/*===========================================================================*/
/*   (Ast/venv.scm)                                                          */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/venv.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_isfunz00_bgl
	{
		struct BgL_nodez00_bgl *BgL_originalzd2bodyzd2;
		obj_t BgL_recursivezd2callszd2;
	}               *BgL_isfunz00_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl__restorezd2valuezd2types3526z00zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_EXPORTED_DECL obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl__restorezd2valuezd2typesz123264z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	BGL_EXPORTED_DECL obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t, obj_t);
	static obj_t BGl__bindzd2globalz123529zc0zzast_envz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zzast_envz00();
	static obj_t BGl__addzd2genvz12zc0zzast_envz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl__alreadyzd2restoredzf3z21zzast_envz00(obj_t, obj_t);
	static obj_t
		BGl__additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2getzd2zz__hashz00(obj_t, obj_t);
	static obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_hrtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_userzd2warningzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_envz00();
	static obj_t BGl_za2Genvza2z00zzast_envz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	BGL_IMPORT int BGl_bigloozd2warningzd2zz__paramz00();
	extern BgL_typez00_bglt BGl_findzd2typezd2zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t,
		obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_bindzd2globalz12zc0zzast_envz00(obj_t, obj_t, BgL_valuez00_bglt, obj_t,
		obj_t);
	static obj_t BGl__restorezd2globalz12zc0zzast_envz00(obj_t, obj_t);
	static obj_t BGl__unbindzd2globalz123530zc0zzast_envz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33276ze3z83zzast_envz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_warningzd2rebindzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00;
	BGL_EXPORTED_DECL obj_t BGl_getzd2genvzd2zzast_envz00();
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_methodzd2initzd2zzast_envz00();
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	static obj_t BGl__getzd2genvzd2zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl__globalzd2bucketzd2posit3532z00zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_envz00 = BUNSPEC;
	static obj_t BGl__forzd2eachzd2globalz123531z12zzast_envz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_genericzd2initzd2zzast_envz00();
	extern obj_t BGl_funz00zzast_varz00;
	extern obj_t BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_nodez00_bglt);
	extern obj_t BGl_globalz00zzast_varz00;
	extern obj_t BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00(obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl__findzd2global3527zd2zzast_envz00(obj_t, obj_t, obj_t);
	static obj_t BGl__getzd2globalzf2modulez20zzast_envz00(obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_envz00();
	static obj_t BGl__initializa7ezd2Genvz12z67zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	extern obj_t BGl_userzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BUNSPEC;
	static obj_t BGl__findzd2globalzf2module3528z20zzast_envz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123267z12zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123270z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123272z12zzast_envz00(obj_t, obj_t);
	static obj_t BGl_restorezd2valuezd2typesz123274z12zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	static obj_t BGl__setzd2genvz12zc0zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern BgL_globalz00_bglt BGl_makezd2globalzd2zzast_varz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, obj_t,
		obj_t, bool_t, obj_t, bool_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_EXPORTED_DECL obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_za2restoredza2z00zzast_envz00 = BUNSPEC;
	static obj_t BGl_zc3anonymousza33414ze3z83zzast_envz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	BGL_EXPORTED_DECL obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_isfunz00zzinline_inlinez00;
	static obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00();
	static obj_t __cnst[7];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_restorezd2valuezd2typesz123264zd2envzc0zzast_envz00,
		BgL_bgl__restoreza7d2value3553za7,
		BGl__restorezd2valuezd2typesz123264z12zzast_envz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_forzd2eachzd2globalz12zd2envzc0zzast_envz00,
		BgL_bgl__forza7d2eachza7d2gl3554z00, va_generic_entry,
		BGl__forzd2eachzd2globalz123531z12zzast_envz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzd2envz00zzast_envz00,
		BgL_bgl__findza7d2global353555za7, va_generic_entry,
		BGl__findzd2global3527zd2zzast_envz00, BUNSPEC, -2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_initializa7ezd2Genvz12zd2envzb5zzast_envz00,
		BgL_bgl__initializa7a7eza7d23556z00,
		BGl__initializa7ezd2Genvz12z67zzast_envz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzd2bucketzd2positionzd2envzd2zzast_envz00,
		BgL_bgl__globalza7d2bucket3557za7,
		BGl__globalzd2bucketzd2posit3532z00zzast_envz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_alreadyzd2restoredzf3zd2envzf3zzast_envz00,
		BgL_bgl__alreadyza7d2resto3558za7,
		BGl__alreadyzd2restoredzf3z21zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2genvzd2envz00zzast_envz00,
		BgL_bgl__getza7d2genvza7d2za7za73559z00, BGl__getzd2genvzd2zzast_envz00, 0L,
		BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_unbindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl__unbindza7d2global3560za7,
		BGl__unbindzd2globalz123530zc0zzast_envz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl__getza7d2globalza7f23561z00,
		BGl__getzd2globalzf2modulez20zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_addzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl__addza7d2genvza712za7c3562za7, BGl__addzd2genvz12zc0zzast_envz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_restorezd2globalz12zd2envz12zzast_envz00,
		BgL_bgl__restoreza7d2globa3563za7, BGl__restorezd2globalz12zc0zzast_envz00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_setzd2genvz12zd2envz12zzast_envz00,
		BgL_bgl__setza7d2genvza712za7c3564za7, BGl__setzd2genvz12zc0zzast_envz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_additionalzd2heapzd2restorezd2globalsz12zd2envz12zzast_envz00,
		BgL_bgl__additionalza7d2he3565za7,
		BGl__additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00, 0L, BUNSPEC,
		0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2globalzf2modulezd2envzf2zzast_envz00,
		BgL_bgl__findza7d2globalza7f3566z00,
		BGl__findzd2globalzf2module3528z20zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3533z00zzast_envz00,
		BgL_bgl_za7c3anonymousza7a333567z00,
		BGl_zc3anonymousza33276ze3z83zzast_envz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3541z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73568z00,
		BGl_restorezd2valuezd2typesz123267z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3542z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73569z00,
		BGl_restorezd2valuezd2typesz123270z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3543z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73570z00,
		BGl_restorezd2valuezd2typesz123272z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3544z00zzast_envz00,
		BgL_bgl_restoreza7d2valueza73571z00,
		BGl_restorezd2valuezd2typesz123274z12zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3534z00zzast_envz00,
		BgL_bgl_string3534za700za7za7a3572za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string3535z00zzast_envz00,
		BgL_bgl_string3535za700za7za7a3573za7, "Cannot find global variable", 27);
	      DEFINE_STRING(BGl_string3536z00zzast_envz00,
		BgL_bgl_string3536za700za7za7a3574za7, "Variable overridden by", 22);
	      DEFINE_STRING(BGl_string3537z00zzast_envz00,
		BgL_bgl_string3537za700za7za7a3575za7, "Duplicate definition", 20);
	      DEFINE_STRING(BGl_string3538z00zzast_envz00,
		BgL_bgl_string3538za700za7za7a3576za7, "eval", 4);
	      DEFINE_STRING(BGl_string3540z00zzast_envz00,
		BgL_bgl_string3540za700za7za7a3577za7, "Can't find global", 17);
	      DEFINE_STRING(BGl_string3539z00zzast_envz00,
		BgL_bgl_string3539za700za7za7a3578za7, "unbind-global!", 14);
	      DEFINE_STRING(BGl_string3545z00zzast_envz00,
		BgL_bgl_string3545za700za7za7a3579za7, "restore-value-types(sfun)", 25);
	      DEFINE_STRING(BGl_string3546z00zzast_envz00,
		BgL_bgl_string3546za700za7za7a3580za7, "Illegal argument", 16);
	      DEFINE_STRING(BGl_string3547z00zzast_envz00,
		BgL_bgl_string3547za700za7za7a3581za7, "restore-value-types", 19);
	      DEFINE_STRING(BGl_string3548z00zzast_envz00,
		BgL_bgl_string3548za700za7za7a3582za7, "Illegal non pair argument", 25);
	      DEFINE_STRING(BGl_string3550z00zzast_envz00,
		BgL_bgl_string3550za700za7za7a3583za7,
		"eval now read @ get-global/module foreign the-global-environment ", 65);
	      DEFINE_STRING(BGl_string3549z00zzast_envz00,
		BgL_bgl_string3549za700za7za7a3584za7, "ast_env", 7);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
		BgL_bgl__restoreza7d2value3585za7,
		BGl__restorezd2valuezd2types3526z00zzast_envz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_bindzd2globalz12zd2envz12zzast_envz00,
		BgL_bgl__bindza7d2globalza713586z00,
		BGl__bindzd2globalz123529zc0zzast_envz00, 0L, BUNSPEC, 5);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long
		BgL_checksumz00_1878, char *BgL_fromz00_1879)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_envz00))
				{
					BGl_requirezd2initializa7ationz75zzast_envz00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_envz00();
					BGl_cnstzd2initzd2zzast_envz00();
					BGl_importedzd2moduleszd2initz00zzast_envz00();
					BGl_genericzd2initzd2zzast_envz00();
					BGl_methodzd2initzd2zzast_envz00();
					BGl_toplevelzd2initzd2zzast_envz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 0), "ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_env");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_env");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			{	/* Ast/venv.scm 14 */
				obj_t BgL_cportz00_1869;

				BgL_cportz00_1869 =
					bgl_open_input_string(BGl_string3550z00zzast_envz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1870;

					BgL_iz00_1870 = ((long) 6);
				BgL_loopz00_1871:
					if ((BgL_iz00_1870 == ((long) -1)))
						{	/* Ast/venv.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/venv.scm 14 */
							{	/* Ast/venv.scm 14 */
								obj_t BgL_arg3552z00_1873;

								{	/* Ast/venv.scm 14 */

									{	/* Ast/venv.scm 14 */
										obj_t BgL_locationz00_1875;

										BgL_locationz00_1875 = BBOOL(((bool_t) 0));
										{	/* Ast/venv.scm 14 */

											BgL_arg3552z00_1873 =
												BGl_readz00zz__readerz00(BgL_cportz00_1869,
												BgL_locationz00_1875);
										}
									}
								}
								{	/* Ast/venv.scm 14 */
									int BgL_auxz00_1902;

									BgL_auxz00_1902 = (int) (BgL_iz00_1870);
									CNST_TABLE_SET(BgL_auxz00_1902, BgL_arg3552z00_1873);
							}}
							{	/* Ast/venv.scm 14 */
								int BgL_auxz00_1876;

								BgL_auxz00_1876 = (int) ((BgL_iz00_1870 - ((long) 1)));
								{
									long BgL_iz00_1907;

									BgL_iz00_1907 = (long) (BgL_auxz00_1876);
									BgL_iz00_1870 = BgL_iz00_1907;
									goto BgL_loopz00_1871;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_za2Genvza2z00zzast_envz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 = BNIL;
			BGl_za2restoredza2z00zzast_envz00 = BNIL;
			return BUNSPEC;
		}
	}



/* set-genv! */
	BGL_EXPORTED_DEF obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_1)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 54 */
			return (BGl_za2Genvza2z00zzast_envz00 = BgL_genvz00_1, BUNSPEC);
		}
	}



/* _set-genv! */
	obj_t BGl__setzd2genvz12zc0zzast_envz00(obj_t BgL_envz00_1809,
		obj_t BgL_genvz00_1810)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 54 */
			return BGl_setzd2genvz12zc0zzast_envz00(BgL_genvz00_1810);
		}
	}



/* add-genv! */
	BGL_EXPORTED_DEF obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t BgL_genvz00_2)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 63 */
			BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_2,
				BGl_proc3533z00zzast_envz00);
			return (BGl_za2restoredza2z00zzast_envz00 = BNIL, BUNSPEC);
		}
	}



/* _add-genv! */
	obj_t BGl__addzd2genvz12zc0zzast_envz00(obj_t BgL_envz00_1812,
		obj_t BgL_genvz00_1813)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 63 */
			return BGl_addzd2genvz12zc0zzast_envz00(BgL_genvz00_1813);
		}
	}



/* <anonymous:3276> */
	obj_t BGl_zc3anonymousza33276ze3z83zzast_envz00(obj_t BgL_envz00_1814,
		obj_t BgL_kz00_1815, obj_t BgL_bucketz00_1816)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 66 */
			{
				obj_t BgL_kz00_859;

				obj_t BgL_bucketz00_860;

				{	/* Ast/venv.scm 67 */
					bool_t BgL_auxz00_1913;

					BgL_kz00_859 = BgL_kz00_1815;
					BgL_bucketz00_860 = BgL_bucketz00_1816;
					{	/* Ast/venv.scm 67 */
						obj_t BgL_g3258z00_862;

						BgL_g3258z00_862 = CDR(BgL_bucketz00_860);
						{
							obj_t BgL_l3256z00_863;

							BgL_l3256z00_863 = BgL_g3258z00_862;
						BgL_forzd2each3257zd2_864:
							if (PAIRP(BgL_l3256z00_863))
								{	/* Ast/venv.scm 87 */
									{	/* Ast/venv.scm 86 */
										obj_t BgL_newz00_866;

										BgL_newz00_866 = CAR(BgL_l3256z00_863);
										BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00 =
											MAKE_PAIR(BgL_newz00_866,
											BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00);
										{	/* Ast/venv.scm 69 */
											obj_t BgL_modulez00_867;

											{
												BgL_globalz00_bglt BgL_auxz00_1919;

												BgL_auxz00_1919 = (BgL_globalz00_bglt) (BgL_newz00_866);
												BgL_modulez00_867 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1919))->
													BgL_modulez00);
											}
											{	/* Ast/venv.scm 69 */
												obj_t BgL_idz00_868;

												{
													BgL_variablez00_bglt BgL_auxz00_1922;

													BgL_auxz00_1922 =
														(BgL_variablez00_bglt) (BgL_newz00_866);
													BgL_idz00_868 =
														(((BgL_variablez00_bglt) CREF(BgL_auxz00_1922))->
														BgL_idz00);
												}
												{	/* Ast/venv.scm 70 */
													obj_t BgL_bucketz00_869;

													BgL_bucketz00_869 =
														BGl_hashtablezd2getzd2zz__hashz00
														(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_868);
													{	/* Ast/venv.scm 71 */

														if (PAIRP(BgL_bucketz00_869))
															{	/* Ast/venv.scm 75 */
																bool_t BgL_testz00_1928;

																if (
																	(BgL_modulez00_867 ==
																		BGl_za2moduleza2z00zzmodule_modulez00))
																	{	/* Ast/venv.scm 75 */
																		BgL_testz00_1928 = ((bool_t) 1);
																	}
																else
																	{	/* Ast/venv.scm 76 */
																		bool_t BgL_testz00_1931;

																		{	/* Ast/venv.scm 77 */
																			obj_t BgL_arg3286z00_879;

																			{	/* Ast/venv.scm 77 */
																				BgL_globalz00_bglt BgL_obj1491z00_1525;

																				{	/* Ast/venv.scm 77 */
																					obj_t BgL_pairz00_1521;

																					BgL_pairz00_1521 = BgL_bucketz00_869;
																					{	/* Ast/venv.scm 77 */
																						obj_t BgL_pairz00_1524;

																						BgL_pairz00_1524 =
																							CDR(BgL_pairz00_1521);
																						BgL_obj1491z00_1525 =
																							(BgL_globalz00_bglt) (CAR
																							(BgL_pairz00_1524));
																					}
																				}
																				BgL_arg3286z00_879 =
																					(((BgL_globalz00_bglt)
																						CREF(BgL_obj1491z00_1525))->
																					BgL_modulez00);
																			}
																			BgL_testz00_1931 =
																				(BGl_za2moduleza2z00zzmodule_modulez00
																				== BgL_arg3286z00_879);
																		}
																		if (BgL_testz00_1931)
																			{	/* Ast/venv.scm 76 */
																				BgL_testz00_1928 = ((bool_t) 0);
																			}
																		else
																			{	/* Ast/venv.scm 76 */
																				BgL_testz00_1928 = ((bool_t) 1);
																			}
																	}
																if (BgL_testz00_1928)
																	{	/* Ast/venv.scm 83 */
																		obj_t BgL_newzd2bucketzd2_872;

																		BgL_newzd2bucketzd2_872 =
																			MAKE_PAIR(BgL_newz00_866,
																			CDR(BgL_bucketz00_869));
																		SET_CDR(BgL_bucketz00_869,
																			BgL_newzd2bucketzd2_872);
																	}
																else
																	{	/* Ast/venv.scm 86 */
																		obj_t BgL_arg3281z00_874;

																		obj_t BgL_arg3282z00_875;

																		BgL_arg3281z00_874 = CDR(BgL_bucketz00_869);
																		{	/* Ast/venv.scm 86 */
																			obj_t BgL_arg3283z00_876;

																			{	/* Ast/venv.scm 86 */
																				obj_t BgL_pairz00_1530;

																				BgL_pairz00_1530 = BgL_bucketz00_869;
																				BgL_arg3283z00_876 =
																					CDR(CDR(BgL_pairz00_1530));
																			}
																			BgL_arg3282z00_875 =
																				MAKE_PAIR(BgL_newz00_866,
																				BgL_arg3283z00_876);
																		}
																		SET_CDR(BgL_arg3281z00_874,
																			BgL_arg3282z00_875);
																	}
															}
														else
															{	/* Ast/venv.scm 74 */
																obj_t BgL_arg3288z00_881;

																{	/* Ast/venv.scm 74 */
																	obj_t BgL_list3289z00_882;

																	{	/* Ast/venv.scm 74 */
																		obj_t BgL_arg3290z00_883;

																		BgL_arg3290z00_883 =
																			MAKE_PAIR(BgL_newz00_866, BNIL);
																		BgL_list3289z00_882 =
																			MAKE_PAIR(BgL_idz00_868,
																			BgL_arg3290z00_883);
																	}
																	BgL_arg3288z00_881 = BgL_list3289z00_882;
																}
																BGl_hashtablezd2putz12zc0zz__hashz00
																	(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_868,
																	BgL_arg3288z00_881);
															}
													}
												}
											}
										}
									}
									{
										obj_t BgL_l3256z00_1948;

										BgL_l3256z00_1948 = CDR(BgL_l3256z00_863);
										BgL_l3256z00_863 = BgL_l3256z00_1948;
										goto BgL_forzd2each3257zd2_864;
									}
								}
							else
								{	/* Ast/venv.scm 87 */
									BgL_auxz00_1913 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1913);
				}
			}
		}
	}



/* additional-heap-restore-globals! */
	BGL_EXPORTED_DEF obj_t
		BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 104 */
			{
				obj_t BgL_l3259z00_886;

				BgL_l3259z00_886 = BGl_za2delayedzd2restoredzd2globalza2z00zzast_envz00;
			BgL_forzd2each3260zd2_887:
				if (PAIRP(BgL_l3259z00_886))
					{	/* Ast/venv.scm 105 */
						BGl_restorezd2globalz12zc0zzast_envz00(CAR(BgL_l3259z00_886));
						{
							obj_t BgL_l3259z00_1955;

							BgL_l3259z00_1955 = CDR(BgL_l3259z00_886);
							BgL_l3259z00_886 = BgL_l3259z00_1955;
							goto BgL_forzd2each3260zd2_887;
						}
					}
				else
					{	/* Ast/venv.scm 105 */
						((bool_t) 1);
					}
			}
			return BTRUE;
		}
	}



/* _additional-heap-restore-globals! */
	obj_t BGl__additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00(obj_t
		BgL_envz00_1817)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 104 */
			return BGl_additionalzd2heapzd2restorezd2globalsz12zc0zzast_envz00();
		}
	}



/* restore-global! */
	BGL_EXPORTED_DEF obj_t BGl_restorezd2globalz12zc0zzast_envz00(obj_t
		BgL_newz00_4)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 111 */
			BGl_za2restoredza2z00zzast_envz00 =
				MAKE_PAIR(BgL_newz00_4, BGl_za2restoredza2z00zzast_envz00);
			{	/* Ast/venv.scm 114 */
				BgL_typez00_bglt BgL_typez00_892;

				{
					BgL_variablez00_bglt BgL_auxz00_1959;

					BgL_auxz00_1959 = (BgL_variablez00_bglt) (BgL_newz00_4);
					BgL_typez00_892 =
						(((BgL_variablez00_bglt) CREF(BgL_auxz00_1959))->BgL_typez00);
				}
				{	/* Ast/venv.scm 115 */
					BgL_valuez00_bglt BgL_valuez00_893;

					{
						BgL_variablez00_bglt BgL_auxz00_1962;

						BgL_auxz00_1962 = (BgL_variablez00_bglt) (BgL_newz00_4);
						BgL_valuez00_893 =
							(((BgL_variablez00_bglt) CREF(BgL_auxz00_1962))->BgL_valuez00);
					}
					{	/* Ast/venv.scm 116 */
						obj_t BgL_typezd2idzd2_894;

						BgL_typezd2idzd2_894 =
							(((BgL_typez00_bglt) CREF(BgL_typez00_892))->BgL_idz00);
						{	/* Ast/venv.scm 117 */

							{
								BgL_typez00_bglt BgL_auxz00_1968;

								BgL_variablez00_bglt BgL_auxz00_1966;

								BgL_auxz00_1968 =
									BGl_findzd2typezd2zztype_envz00(BgL_typezd2idzd2_894);
								BgL_auxz00_1966 = (BgL_variablez00_bglt) (BgL_newz00_4);
								((((BgL_variablez00_bglt) CREF(BgL_auxz00_1966))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_1968), BUNSPEC);
							}
							{	/* Ast/venv.scm 121 */
								obj_t BgL_method3265z00_1550;

								{	/* Ast/venv.scm 121 */
									BgL_objectz00_bglt BgL_objz00_1551;

									BgL_objz00_1551 = (BgL_objectz00_bglt) (BgL_valuez00_893);
									{	/* Ast/venv.scm 121 */
										long BgL_objzd2classzd2numz00_1552;

										BgL_objzd2classzd2numz00_1552 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1551);
										{	/* Ast/venv.scm 121 */
											obj_t BgL_arg2334z00_1553;

											BgL_arg2334z00_1553 =
												PROCEDURE_REF
												(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
												(int) (((long) 1)));
											{	/* Ast/venv.scm 121 */
												obj_t BgL_arrayz00_1555;

												int BgL_offsetz00_1556;

												BgL_arrayz00_1555 = BgL_arg2334z00_1553;
												BgL_offsetz00_1556 =
													(int) (BgL_objzd2classzd2numz00_1552);
												{	/* Ast/venv.scm 121 */
													long BgL_offsetz00_1557;

													BgL_offsetz00_1557 =
														((long) (BgL_offsetz00_1556) - OBJECT_TYPE);
													{	/* Ast/venv.scm 121 */
														long BgL_modz00_1558;

														{	/* Ast/venv.scm 121 */
															int BgL_arg2336z00_1559;

															BgL_arg2336z00_1559 = (int) (((long) 8));
															{	/* Ast/venv.scm 121 */
																long BgL_auxz00_1979;

																BgL_auxz00_1979 = (long) (BgL_arg2336z00_1559);
																BgL_modz00_1558 =
																	(BgL_offsetz00_1557 / BgL_auxz00_1979);
														}}
														{	/* Ast/venv.scm 121 */
															long BgL_restz00_1560;

															{	/* Ast/venv.scm 121 */
																int BgL_arg2335z00_1561;

																BgL_arg2335z00_1561 = (int) (((long) 8));
																{	/* Ast/venv.scm 121 */
																	long BgL_auxz00_1983;

																	BgL_auxz00_1983 =
																		(long) (BgL_arg2335z00_1561);
																	BgL_restz00_1560 =
																		(BgL_offsetz00_1557 % BgL_auxz00_1983);
															}}
															{	/* Ast/venv.scm 121 */

																BgL_method3265z00_1550 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1555,
																		(int) (BgL_modz00_1558)),
																	(int) (BgL_restz00_1560));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3265z00_1550) (BgL_method3265z00_1550,
									(obj_t) (BgL_valuez00_893), BEOA);
							}
							{	/* Ast/venv.scm 123 */
								bool_t BgL_testz00_1993;

								{	/* Ast/venv.scm 123 */
									bool_t BgL_testz00_1994;

									{	/* Ast/venv.scm 123 */
										obj_t BgL_arg3305z00_905;

										BgL_arg3305z00_905 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										{
											BgL_backendz00_bglt BgL_auxz00_1996;

											BgL_auxz00_1996 =
												(BgL_backendz00_bglt) (BgL_arg3305z00_905);
											BgL_testz00_1994 =
												(((BgL_backendz00_bglt) CREF(BgL_auxz00_1996))->
												BgL_qualifiedzd2typeszd2);
									}}
									if (BgL_testz00_1994)
										{	/* Ast/venv.scm 124 */
											bool_t BgL_testz00_1999;

											{	/* Ast/venv.scm 124 */
												obj_t BgL_auxz00_2000;

												{
													BgL_globalz00_bglt BgL_auxz00_2001;

													BgL_auxz00_2001 = (BgL_globalz00_bglt) (BgL_newz00_4);
													BgL_auxz00_2000 =
														(((BgL_globalz00_bglt) CREF(BgL_auxz00_2001))->
														BgL_modulez00);
												}
												BgL_testz00_1999 =
													(BgL_auxz00_2000 == CNST_TABLE_REF(((long) 1)));
											}
											if (BgL_testz00_1999)
												{	/* Ast/venv.scm 124 */
													BgL_testz00_1993 = ((bool_t) 0);
												}
											else
												{	/* Ast/venv.scm 124 */
													BgL_testz00_1993 = ((bool_t) 1);
												}
										}
									else
										{	/* Ast/venv.scm 123 */
											BgL_testz00_1993 = ((bool_t) 0);
										}
								}
								if (BgL_testz00_1993)
									{	/* Ast/venv.scm 125 */
										obj_t BgL_arg3297z00_897;

										obj_t BgL_arg3298z00_898;

										obj_t BgL_arg3299z00_899;

										{
											BgL_globalz00_bglt BgL_auxz00_2006;

											BgL_auxz00_2006 = (BgL_globalz00_bglt) (BgL_newz00_4);
											BgL_arg3297z00_897 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_2006))->
												BgL_modulez00);
										}
										{
											BgL_globalz00_bglt BgL_auxz00_2009;

											BgL_auxz00_2009 = (BgL_globalz00_bglt) (BgL_newz00_4);
											BgL_arg3298z00_898 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_2009))->
												BgL_jvmzd2typezd2namez00);
										}
										BgL_arg3299z00_899 =
											BGl_shapez00zztools_shapez00(BgL_newz00_4);
										{	/* Ast/venv.scm 125 */
											obj_t BgL_list3300z00_900;

											BgL_list3300z00_900 = MAKE_PAIR(BgL_arg3299z00_899, BNIL);
											return
												BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00
												(BgL_arg3297z00_897, BgL_arg3298z00_898,
												BgL_list3300z00_900);
										}
									}
								else
									{	/* Ast/venv.scm 123 */
										return BFALSE;
									}
							}
						}
					}
				}
			}
		}
	}



/* _restore-global! */
	obj_t BGl__restorezd2globalz12zc0zzast_envz00(obj_t BgL_envz00_1818,
		obj_t BgL_newz00_1819)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 111 */
			return BGl_restorezd2globalz12zc0zzast_envz00(BgL_newz00_1819);
		}
	}



/* already-restored? */
	BGL_EXPORTED_DEF obj_t BGl_alreadyzd2restoredzf3z21zzast_envz00(obj_t
		BgL_funz00_6)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 146 */
			return
				BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_funz00_6,
				BGl_za2restoredza2z00zzast_envz00);
		}
	}



/* _already-restored? */
	obj_t BGl__alreadyzd2restoredzf3z21zzast_envz00(obj_t BgL_envz00_1822,
		obj_t BgL_funz00_1823)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 146 */
			return BGl_alreadyzd2restoredzf3z21zzast_envz00(BgL_funz00_1823);
		}
	}



/* get-genv */
	BGL_EXPORTED_DEF obj_t BGl_getzd2genvzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 220 */
			return BGl_za2Genvza2z00zzast_envz00;
		}
	}



/* _get-genv */
	obj_t BGl__getzd2genvzd2zzast_envz00(obj_t BgL_envz00_1824)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 220 */
			return BGl_za2Genvza2z00zzast_envz00;
		}
	}



/* initialize-Genv! */
	BGL_EXPORTED_DEF obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 226 */
			return (BGl_za2Genvza2z00zzast_envz00 =
				BGl_makezd2hashtablezd2zz__hashz00(BNIL), BUNSPEC);
		}
	}



/* _initialize-Genv! */
	obj_t BGl__initializa7ezd2Genvz12z67zzast_envz00(obj_t BgL_envz00_1825)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 226 */
			return BGl_initializa7ezd2Genvz12z67zzast_envz00();
		}
	}



/* find-global */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzd2zzast_envz00(obj_t BgL_idz00_13,
		obj_t BgL_modulez00_14)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 232 */
			{	/* Ast/venv.scm 234 */
				obj_t BgL_bucketz00_907;

				obj_t BgL_modulez00_908;

				BgL_bucketz00_907 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_13);
				if (NULLP(BgL_modulez00_14))
					{	/* Ast/venv.scm 235 */
						BgL_modulez00_908 = BNIL;
					}
				else
					{	/* Ast/venv.scm 235 */
						BgL_modulez00_908 = CAR(BgL_modulez00_14);
					}
				if (PAIRP(BgL_bucketz00_907))
					{	/* Ast/venv.scm 237 */
						if (NULLP(CDR(BgL_bucketz00_907)))
							{	/* Ast/venv.scm 239 */
								return BFALSE;
							}
						else
							{	/* Ast/venv.scm 239 */
								if (NULLP(BgL_modulez00_908))
									{	/* Ast/venv.scm 242 */
										obj_t BgL_pairz00_1585;

										BgL_pairz00_1585 = BgL_bucketz00_907;
										return CAR(CDR(BgL_pairz00_1585));
									}
								else
									{
										obj_t BgL_globalsz00_913;

										BgL_globalsz00_913 = CDR(BgL_bucketz00_907);
									BgL_loopz00_914:
										if (NULLP(BgL_globalsz00_913))
											{	/* Ast/venv.scm 246 */
												return BFALSE;
											}
										else
											{	/* Ast/venv.scm 248 */
												bool_t BgL_testz00_2035;

												{	/* Ast/venv.scm 248 */
													obj_t BgL_auxz00_2036;

													{	/* Ast/venv.scm 248 */
														BgL_globalz00_bglt BgL_obj1491z00_1592;

														{	/* Ast/venv.scm 248 */
															obj_t BgL_pairz00_1591;

															BgL_pairz00_1591 = BgL_globalsz00_913;
															BgL_obj1491z00_1592 =
																(BgL_globalz00_bglt) (CAR(BgL_pairz00_1591));
														}
														BgL_auxz00_2036 =
															(((BgL_globalz00_bglt)
																CREF(BgL_obj1491z00_1592))->BgL_modulez00);
													}
													BgL_testz00_2035 =
														(BgL_auxz00_2036 == BgL_modulez00_908);
												}
												if (BgL_testz00_2035)
													{	/* Ast/venv.scm 248 */
														return CAR(BgL_globalsz00_913);
													}
												else
													{
														obj_t BgL_globalsz00_2042;

														BgL_globalsz00_2042 = CDR(BgL_globalsz00_913);
														BgL_globalsz00_913 = BgL_globalsz00_2042;
														goto BgL_loopz00_914;
													}
											}
									}
							}
					}
				else
					{	/* Ast/venv.scm 237 */
						return BFALSE;
					}
			}
		}
	}



/* _find-global3527 */
	obj_t BGl__findzd2global3527zd2zzast_envz00(obj_t BgL_envz00_1826,
		obj_t BgL_idz00_1827, obj_t BgL_modulez00_1828)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 232 */
			return
				BGl_findzd2globalzd2zzast_envz00(BgL_idz00_1827, BgL_modulez00_1828);
		}
	}



/* find-global/module */
	BGL_EXPORTED_DEF obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_15, obj_t BgL_modulez00_16)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 256 */
			{	/* Ast/venv.scm 257 */
				obj_t BgL_bucketz00_922;

				BgL_bucketz00_922 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_15);
				if (PAIRP(BgL_bucketz00_922))
					{	/* Ast/venv.scm 259 */
						if (NULLP(CDR(BgL_bucketz00_922)))
							{	/* Ast/venv.scm 261 */
								return BFALSE;
							}
						else
							{
								obj_t BgL_globalsz00_927;

								BgL_globalsz00_927 = CDR(BgL_bucketz00_922);
							BgL_loopz00_928:
								if (NULLP(BgL_globalsz00_927))
									{	/* Ast/venv.scm 268 */
										return BFALSE;
									}
								else
									{	/* Ast/venv.scm 270 */
										bool_t BgL_testz00_2054;

										{	/* Ast/venv.scm 270 */
											obj_t BgL_auxz00_2055;

											{	/* Ast/venv.scm 270 */
												BgL_globalz00_bglt BgL_obj1491z00_1606;

												{	/* Ast/venv.scm 270 */
													obj_t BgL_pairz00_1605;

													BgL_pairz00_1605 = BgL_globalsz00_927;
													BgL_obj1491z00_1606 =
														(BgL_globalz00_bglt) (CAR(BgL_pairz00_1605));
												}
												BgL_auxz00_2055 =
													(((BgL_globalz00_bglt) CREF(BgL_obj1491z00_1606))->
													BgL_modulez00);
											}
											BgL_testz00_2054 = (BgL_auxz00_2055 == BgL_modulez00_16);
										}
										if (BgL_testz00_2054)
											{	/* Ast/venv.scm 270 */
												return CAR(BgL_globalsz00_927);
											}
										else
											{
												obj_t BgL_globalsz00_2061;

												BgL_globalsz00_2061 = CDR(BgL_globalsz00_927);
												BgL_globalsz00_927 = BgL_globalsz00_2061;
												goto BgL_loopz00_928;
											}
									}
							}
					}
				else
					{	/* Ast/venv.scm 259 */
						return BFALSE;
					}
			}
		}
	}



/* _find-global/module3528 */
	obj_t BGl__findzd2globalzf2module3528z20zzast_envz00(obj_t BgL_envz00_1829,
		obj_t BgL_idz00_1830, obj_t BgL_modulez00_1831)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 256 */
			return
				BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_1830,
				BgL_modulez00_1831);
		}
	}



/* get-global/module */
	BGL_EXPORTED_DEF obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t
		BgL_idz00_17, obj_t BgL_modulez00_18)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 278 */
			{	/* Ast/venv.scm 279 */
				obj_t BgL_globalz00_935;

				BgL_globalz00_935 =
					BGl_findzd2globalzf2modulez20zzast_envz00(BgL_idz00_17,
					BgL_modulez00_18);
				{	/* Ast/venv.scm 280 */
					bool_t BgL_testz00_2066;

					if (BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_935,
							BGl_globalz00zzast_varz00))
						{	/* Ast/venv.scm 280 */
							BgL_testz00_2066 = ((bool_t) 0);
						}
					else
						{	/* Ast/venv.scm 280 */
							if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
								{	/* Ast/venv.scm 280 */
									BgL_testz00_2066 = ((bool_t) 0);
								}
							else
								{	/* Ast/venv.scm 280 */
									BgL_testz00_2066 = ((bool_t) 1);
								}
						}
					if (BgL_testz00_2066)
						{	/* Ast/venv.scm 281 */
							obj_t BgL_arg3327z00_937;

							obj_t BgL_arg3329z00_939;

							BgL_arg3327z00_937 = CNST_TABLE_REF(((long) 2));
							{	/* Ast/venv.scm 283 */
								obj_t BgL_list3330z00_940;

								{	/* Ast/venv.scm 283 */
									obj_t BgL_arg3331z00_941;

									BgL_arg3331z00_941 = MAKE_PAIR(BgL_modulez00_18, BNIL);
									BgL_list3330z00_940 =
										MAKE_PAIR(BgL_idz00_17, BgL_arg3331z00_941);
								}
								BgL_arg3329z00_939 =
									BGl_formatz00zz__r4_output_6_10_3z00
									(BGl_string3534z00zzast_envz00, BgL_list3330z00_940);
							}
							BGl_internalzd2errorzd2zztools_errorz00(BgL_arg3327z00_937,
								BGl_string3535z00zzast_envz00, BgL_arg3329z00_939);
						}
					else
						{	/* Ast/venv.scm 280 */
							BFALSE;
						}
				}
				return BgL_globalz00_935;
			}
		}
	}



/* _get-global/module */
	obj_t BGl__getzd2globalzf2modulez20zzast_envz00(obj_t BgL_envz00_1832,
		obj_t BgL_idz00_1833, obj_t BgL_modulez00_1834)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 278 */
			return
				BGl_getzd2globalzf2modulez20zzast_envz00(BgL_idz00_1833,
				BgL_modulez00_1834);
		}
	}



/* warning-override-global! */
	obj_t BGl_warningzd2overridezd2globalz12z12zzast_envz00(obj_t BgL_nz00_19,
		obj_t BgL_oz00_20, obj_t BgL_msgz00_21)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 289 */
			{	/* Ast/venv.scm 290 */
				bool_t BgL_testz00_2077;

				{	/* Ast/venv.scm 290 */
					bool_t BgL_testz00_2078;

					{	/* Ast/venv.scm 290 */
						int BgL_arg3351z00_966;

						BgL_arg3351z00_966 = BGl_bigloozd2warningzd2zz__paramz00();
						BgL_testz00_2078 = ((long) (BgL_arg3351z00_966) > ((long) 0));
					}
					if (BgL_testz00_2078)
						{	/* Ast/venv.scm 290 */
							BgL_testz00_2077 =
								CBOOL
								(BGl_za2warningzd2overridenzd2variablesza2z00zzengine_paramz00);
						}
					else
						{	/* Ast/venv.scm 290 */
							BgL_testz00_2077 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2077)
					{	/* Ast/venv.scm 292 */
						obj_t BgL_locz00_945;

						obj_t BgL_oldz00_946;

						obj_t BgL_newz00_947;

						obj_t BgL_msgz00_948;

						{	/* Ast/venv.scm 292 */
							obj_t BgL_arg3334z00_949;

							{
								BgL_globalz00_bglt BgL_auxz00_2083;

								BgL_auxz00_2083 = (BgL_globalz00_bglt) (BgL_oz00_20);
								BgL_arg3334z00_949 =
									(((BgL_globalz00_bglt) CREF(BgL_auxz00_2083))->BgL_srcz00);
							}
							BgL_locz00_945 =
								BGl_findzd2locationzd2zztools_locationz00(BgL_arg3334z00_949);
						}
						{	/* Ast/venv.scm 293 */
							obj_t BgL_arg3335z00_950;

							obj_t BgL_arg3336z00_951;

							BgL_arg3335z00_950 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/venv.scm 293 */
								obj_t BgL_arg3337z00_952;

								obj_t BgL_arg3338z00_953;

								{
									BgL_variablez00_bglt BgL_auxz00_2088;

									BgL_auxz00_2088 = (BgL_variablez00_bglt) (BgL_oz00_20);
									BgL_arg3337z00_952 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2088))->BgL_idz00);
								}
								{
									BgL_globalz00_bglt BgL_auxz00_2091;

									BgL_auxz00_2091 = (BgL_globalz00_bglt) (BgL_oz00_20);
									BgL_arg3338z00_953 =
										(((BgL_globalz00_bglt) CREF(BgL_auxz00_2091))->
										BgL_modulez00);
								}
								{	/* Ast/venv.scm 293 */
									obj_t BgL_list3340z00_955;

									{	/* Ast/venv.scm 293 */
										obj_t BgL_arg3341z00_956;

										BgL_arg3341z00_956 = MAKE_PAIR(BNIL, BNIL);
										BgL_list3340z00_955 =
											MAKE_PAIR(BgL_arg3338z00_953, BgL_arg3341z00_956);
									}
									BgL_arg3336z00_951 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg3337z00_952, BgL_list3340z00_955);
							}}
							BgL_oldz00_946 =
								MAKE_PAIR(BgL_arg3335z00_950, BgL_arg3336z00_951);
						}
						{	/* Ast/venv.scm 294 */
							obj_t BgL_arg3342z00_957;

							obj_t BgL_arg3343z00_958;

							BgL_arg3342z00_957 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/venv.scm 294 */
								obj_t BgL_arg3344z00_959;

								obj_t BgL_arg3345z00_960;

								{
									BgL_variablez00_bglt BgL_auxz00_2099;

									BgL_auxz00_2099 = (BgL_variablez00_bglt) (BgL_nz00_19);
									BgL_arg3344z00_959 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2099))->BgL_idz00);
								}
								{
									BgL_globalz00_bglt BgL_auxz00_2102;

									BgL_auxz00_2102 = (BgL_globalz00_bglt) (BgL_nz00_19);
									BgL_arg3345z00_960 =
										(((BgL_globalz00_bglt) CREF(BgL_auxz00_2102))->
										BgL_modulez00);
								}
								{	/* Ast/venv.scm 294 */
									obj_t BgL_list3347z00_962;

									{	/* Ast/venv.scm 294 */
										obj_t BgL_arg3348z00_963;

										BgL_arg3348z00_963 = MAKE_PAIR(BNIL, BNIL);
										BgL_list3347z00_962 =
											MAKE_PAIR(BgL_arg3345z00_960, BgL_arg3348z00_963);
									}
									BgL_arg3343z00_958 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg3344z00_959, BgL_list3347z00_962);
							}}
							BgL_newz00_947 =
								MAKE_PAIR(BgL_arg3342z00_957, BgL_arg3343z00_958);
						}
						if (PAIRP(BgL_msgz00_21))
							{	/* Ast/venv.scm 295 */
								BgL_msgz00_948 = CAR(BgL_msgz00_21);
							}
						else
							{	/* Ast/venv.scm 295 */
								BgL_msgz00_948 = BGl_string3536z00zzast_envz00;
							}
						if (CBOOL(BgL_locz00_945))
							{	/* Ast/venv.scm 296 */
								return
									BGl_userzd2warningzf2locationz20zztools_errorz00
									(BgL_locz00_945, BgL_oldz00_946, BgL_msgz00_948,
									BgL_newz00_947);
							}
						else
							{	/* Ast/venv.scm 296 */
								return
									BGl_userzd2warningzd2zztools_errorz00(BgL_oldz00_946,
									BgL_msgz00_948, BgL_newz00_947);
							}
					}
				else
					{	/* Ast/venv.scm 290 */
						return BFALSE;
					}
			}
		}
	}



/* error-rebind-global! */
	obj_t BGl_errorzd2rebindzd2globalz12z12zzast_envz00(obj_t BgL_oz00_22,
		obj_t BgL_srcz00_23)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 303 */
			{	/* Ast/venv.scm 305 */
				obj_t BgL_locz00_969;

				BgL_locz00_969 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_23);
				if (CBOOL(BgL_locz00_969))
					{	/* Ast/venv.scm 308 */
						obj_t BgL_arg3353z00_971;

						obj_t BgL_arg3354z00_972;

						{
							BgL_globalz00_bglt BgL_auxz00_2119;

							BgL_auxz00_2119 = (BgL_globalz00_bglt) (BgL_oz00_22);
							BgL_arg3353z00_971 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2119))->BgL_modulez00);
						}
						BgL_arg3354z00_972 = BGl_shapez00zztools_shapez00(BgL_oz00_22);
						return
							BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_969,
							BgL_arg3353z00_971, BGl_string3537z00zzast_envz00,
							BgL_arg3354z00_972, BNIL);
					}
				else
					{	/* Ast/venv.scm 309 */
						obj_t BgL_arg3356z00_974;

						obj_t BgL_arg3357z00_975;

						{
							BgL_globalz00_bglt BgL_auxz00_2124;

							BgL_auxz00_2124 = (BgL_globalz00_bglt) (BgL_oz00_22);
							BgL_arg3356z00_974 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2124))->BgL_modulez00);
						}
						BgL_arg3357z00_975 = BGl_shapez00zztools_shapez00(BgL_oz00_22);
						return
							BGl_userzd2errorzd2zztools_errorz00(BgL_arg3356z00_974,
							BGl_string3537z00zzast_envz00, BgL_arg3357z00_975, BNIL);
					}
			}
		}
	}



/* warning-rebind-global! */
	obj_t BGl_warningzd2rebindzd2globalz12z12zzast_envz00(obj_t BgL_oz00_24,
		obj_t BgL_srcz00_25)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 314 */
			{	/* Ast/venv.scm 316 */
				obj_t BgL_locz00_978;

				BgL_locz00_978 =
					BGl_findzd2locationzd2zztools_locationz00(BgL_srcz00_25);
				if (CBOOL(BgL_locz00_978))
					{	/* Ast/venv.scm 319 */
						obj_t BgL_arg3359z00_980;

						obj_t BgL_arg3360z00_981;

						{
							BgL_globalz00_bglt BgL_auxz00_2132;

							BgL_auxz00_2132 = (BgL_globalz00_bglt) (BgL_oz00_24);
							BgL_arg3359z00_980 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2132))->BgL_modulez00);
						}
						BgL_arg3360z00_981 = BGl_shapez00zztools_shapez00(BgL_oz00_24);
						return
							BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_978,
							BgL_arg3359z00_980, BGl_string3537z00zzast_envz00,
							BgL_arg3360z00_981);
					}
				else
					{	/* Ast/venv.scm 320 */
						obj_t BgL_arg3361z00_982;

						obj_t BgL_arg3362z00_983;

						{
							BgL_globalz00_bglt BgL_auxz00_2137;

							BgL_auxz00_2137 = (BgL_globalz00_bglt) (BgL_oz00_24);
							BgL_arg3361z00_982 =
								(((BgL_globalz00_bglt) CREF(BgL_auxz00_2137))->BgL_modulez00);
						}
						BgL_arg3362z00_983 = BGl_shapez00zztools_shapez00(BgL_oz00_24);
						return
							BGl_userzd2warningzd2zztools_errorz00(BgL_arg3361z00_982,
							BGl_string3537z00zzast_envz00, BgL_arg3362z00_983);
					}
			}
		}
	}



/* bind-global! */
	BGL_EXPORTED_DEF BgL_globalz00_bglt BGl_bindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_26, obj_t BgL_modulez00_27, BgL_valuez00_bglt BgL_valuez00_28,
		obj_t BgL_importz00_29, obj_t BgL_srcz00_30)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 337 */
			{	/* Ast/venv.scm 340 */
				obj_t BgL_oldz00_984;

				{	/* Ast/venv.scm 340 */
					obj_t BgL_list3395z00_1021;

					BgL_list3395z00_1021 = MAKE_PAIR(BgL_modulez00_27, BNIL);
					BgL_oldz00_984 =
						BGl_findzd2globalzd2zzast_envz00(BgL_idz00_26,
						BgL_list3395z00_1021);
				}
				if (BGl_iszd2azf3z21zz__objectz00(BgL_oldz00_984,
						BGl_globalz00zzast_varz00))
					{	/* Ast/venv.scm 341 */
						if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
							{	/* Ast/venv.scm 343 */
								return (BgL_globalz00_bglt) (BgL_oldz00_984);
							}
						else
							{	/* Ast/venv.scm 345 */
								bool_t BgL_testz00_2149;

								{	/* Ast/venv.scm 345 */
									obj_t BgL_auxz00_2150;

									{
										BgL_globalz00_bglt BgL_auxz00_2151;

										BgL_auxz00_2151 = (BgL_globalz00_bglt) (BgL_oldz00_984);
										BgL_auxz00_2150 =
											(((BgL_globalz00_bglt) CREF(BgL_auxz00_2151))->
											BgL_modulez00);
									}
									BgL_testz00_2149 = (BgL_modulez00_27 == BgL_auxz00_2150);
								}
								if (BgL_testz00_2149)
									{	/* Ast/venv.scm 345 */
										BGl_warningzd2rebindzd2globalz12z12zzast_envz00
											(BgL_oldz00_984, BgL_srcz00_30);
										return (BgL_globalz00_bglt) (BgL_oldz00_984);
									}
								else
									{	/* Ast/venv.scm 345 */
										return
											(BgL_globalz00_bglt)
											(BGl_errorzd2rebindzd2globalz12z12zzast_envz00
											(BgL_oldz00_984, BgL_srcz00_30));
									}
							}
					}
				else
					{	/* Ast/venv.scm 350 */
						obj_t BgL_bucketz00_988;

						BgL_globalz00_bglt BgL_newz00_989;

						BgL_bucketz00_988 =
							BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
							BgL_idz00_26);
						{	/* Ast/var.scm 32 */
							obj_t BgL_arg3388z00_1015;

							obj_t BgL_arg3389z00_1016;

							obj_t BgL_arg3393z00_1019;

							BgL_arg3388z00_1015 = CNST_TABLE_REF(((long) 4));
							BgL_arg3389z00_1016 = CNST_TABLE_REF(((long) 5));
							if ((BgL_importz00_29 == CNST_TABLE_REF(((long) 6))))
								{	/* Ast/venv.scm 353 */
									BgL_arg3393z00_1019 = BGl_string3538z00zzast_envz00;
								}
							else
								{	/* Ast/venv.scm 353 */
									BgL_arg3393z00_1019 =
										BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
										(BgL_modulez00_27);
								}
							BgL_newz00_989 =
								BGl_makezd2globalzd2zzast_varz00(BgL_idz00_26, BFALSE,
								(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00),
								BgL_valuez00_28, BgL_arg3388z00_1015, BUNSPEC,
								BgL_arg3389z00_1016, ((long) 0), BgL_modulez00_27,
								BgL_importz00_29, ((bool_t) 1), BFALSE, ((bool_t) 1), BNIL,
								BgL_srcz00_30, BgL_arg3393z00_1019);
						}
						{	/* Ast/venv.scm 361 */
							bool_t BgL_testz00_2168;

							if (PAIRP(BgL_bucketz00_988))
								{	/* Ast/venv.scm 361 */
									BgL_testz00_2168 = NULLP(CDR(BgL_bucketz00_988));
								}
							else
								{	/* Ast/venv.scm 361 */
									BgL_testz00_2168 = ((bool_t) 1);
								}
							if (BgL_testz00_2168)
								{	/* Ast/venv.scm 361 */
									{	/* Ast/venv.scm 363 */
										obj_t BgL_arg3367z00_991;

										{	/* Ast/venv.scm 363 */
											obj_t BgL_list3368z00_992;

											{	/* Ast/venv.scm 363 */
												obj_t BgL_arg3369z00_993;

												BgL_arg3369z00_993 =
													MAKE_PAIR((obj_t) (BgL_newz00_989), BNIL);
												BgL_list3368z00_992 =
													MAKE_PAIR(BgL_idz00_26, BgL_arg3369z00_993);
											}
											BgL_arg3367z00_991 = BgL_list3368z00_992;
										}
										BGl_hashtablezd2putz12zc0zz__hashz00
											(BGl_za2Genvza2z00zzast_envz00, BgL_idz00_26,
											BgL_arg3367z00_991);
									}
									return BgL_newz00_989;
								}
							else
								{	/* Ast/venv.scm 366 */
									obj_t BgL_oldza2za2_994;

									BgL_oldza2za2_994 = CDR(BgL_bucketz00_988);
									{	/* Ast/venv.scm 366 */
										obj_t BgL_midz00_995;

										{	/* Ast/venv.scm 368 */
											obj_t BgL_arg3384z00_1011;

											{	/* Ast/venv.scm 368 */
												BgL_globalz00_bglt BgL_obj1491z00_1632;

												{	/* Ast/venv.scm 368 */
													obj_t BgL_pairz00_1631;

													BgL_pairz00_1631 = BgL_oldza2za2_994;
													BgL_obj1491z00_1632 =
														(BgL_globalz00_bglt) (CAR(BgL_pairz00_1631));
												}
												BgL_arg3384z00_1011 =
													(((BgL_globalz00_bglt) CREF(BgL_obj1491z00_1632))->
													BgL_modulez00);
											}
											BgL_midz00_995 =
												BGl_modulezd2initializa7ationzd2idza7zzmodule_modulez00
												(BgL_arg3384z00_1011);
										}
										{	/* Ast/venv.scm 367 */

											{	/* Ast/venv.scm 370 */
												bool_t BgL_testz00_2182;

												{	/* Ast/venv.scm 370 */
													obj_t BgL_arg3382z00_1009;

													{	/* Ast/venv.scm 370 */
														BgL_globalz00_bglt BgL_obj1491z00_1634;

														{	/* Ast/venv.scm 370 */
															obj_t BgL_pairz00_1633;

															BgL_pairz00_1633 = BgL_oldza2za2_994;
															BgL_obj1491z00_1634 =
																(BgL_globalz00_bglt) (CAR(BgL_pairz00_1633));
														}
														BgL_arg3382z00_1009 =
															(((BgL_globalz00_bglt)
																CREF(BgL_obj1491z00_1634))->BgL_modulez00);
													}
													BgL_testz00_2182 =
														(BgL_arg3382z00_1009 ==
														BGl_za2moduleza2z00zzmodule_modulez00);
												}
												if (BgL_testz00_2182)
													{	/* Ast/venv.scm 370 */
														{	/* Ast/venv.scm 372 */
															bool_t BgL_testz00_2187;

															if ((BgL_idz00_26 == BgL_midz00_995))
																{	/* Ast/venv.scm 372 */
																	BgL_testz00_2187 = ((bool_t) 0);
																}
															else
																{	/* Ast/venv.scm 372 */
																	if (CBOOL
																		(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																		{	/* Ast/venv.scm 372 */
																			BgL_testz00_2187 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 372 */
																			BgL_testz00_2187 = ((bool_t) 1);
																		}
																}
															if (BgL_testz00_2187)
																{	/* Ast/venv.scm 372 */
																	BGl_warningzd2overridezd2globalz12z12zzast_envz00
																		(CAR(BgL_oldza2za2_994),
																		(obj_t) (BgL_newz00_989), BNIL);
																}
															else
																{	/* Ast/venv.scm 372 */
																	BFALSE;
																}
														}
														{	/* Ast/venv.scm 374 */
															obj_t BgL_arg3375z00_1001;

															obj_t BgL_arg3376z00_1002;

															BgL_arg3375z00_1001 = CDR(BgL_bucketz00_988);
															{	/* Ast/venv.scm 374 */
																obj_t BgL_arg3377z00_1003;

																{	/* Ast/venv.scm 374 */
																	obj_t BgL_pairz00_1637;

																	BgL_pairz00_1637 = BgL_bucketz00_988;
																	BgL_arg3377z00_1003 =
																		CDR(CDR(BgL_pairz00_1637));
																}
																BgL_arg3376z00_1002 =
																	MAKE_PAIR(
																	(obj_t) (BgL_newz00_989),
																	BgL_arg3377z00_1003);
															}
															SET_CDR(BgL_arg3375z00_1001, BgL_arg3376z00_1002);
														}
														return BgL_newz00_989;
													}
												else
													{	/* Ast/venv.scm 377 */
														obj_t BgL_newza2za2_1004;

														BgL_newza2za2_1004 =
															MAKE_PAIR(
															(obj_t) (BgL_newz00_989), BgL_oldza2za2_994);
														{	/* Ast/venv.scm 378 */
															bool_t BgL_testz00_2203;

															if ((BgL_idz00_26 == BgL_midz00_995))
																{	/* Ast/venv.scm 378 */
																	BgL_testz00_2203 = ((bool_t) 0);
																}
															else
																{	/* Ast/venv.scm 378 */
																	if (CBOOL
																		(BGl_za2libzd2modeza2zd2zzengine_paramz00))
																		{	/* Ast/venv.scm 378 */
																			BgL_testz00_2203 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/venv.scm 378 */
																			BgL_testz00_2203 = ((bool_t) 1);
																		}
																}
															if (BgL_testz00_2203)
																{	/* Ast/venv.scm 378 */
																	BGl_warningzd2overridezd2globalz12z12zzast_envz00
																		((obj_t) (BgL_newz00_989),
																		CAR(BgL_oldza2za2_994), BNIL);
																}
															else
																{	/* Ast/venv.scm 378 */
																	BFALSE;
																}
														}
														SET_CDR(BgL_bucketz00_988, BgL_newza2za2_1004);
														return BgL_newz00_989;
													}
											}
										}
									}
								}
						}
					}
			}
		}
	}



/* _bind-global!3529 */
	obj_t BGl__bindzd2globalz123529zc0zzast_envz00(obj_t BgL_envz00_1835,
		obj_t BgL_idz00_1836, obj_t BgL_modulez00_1837, obj_t BgL_valuez00_1838,
		obj_t BgL_importz00_1839, obj_t BgL_srcz00_1840)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 337 */
			return
				(obj_t) (BGl_bindzd2globalz12zc0zzast_envz00(BgL_idz00_1836,
					BgL_modulez00_1837, (BgL_valuez00_bglt) (BgL_valuez00_1838),
					BgL_importz00_1839, BgL_srcz00_1840));
		}
	}



/* unbind-global! */
	BGL_EXPORTED_DEF obj_t BGl_unbindzd2globalz12zc0zzast_envz00(obj_t
		BgL_idz00_31, obj_t BgL_modulez00_32)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 386 */
			{	/* Ast/venv.scm 387 */
				obj_t BgL_globalz00_1022;

				{	/* Ast/venv.scm 387 */
					obj_t BgL_list3410z00_1042;

					BgL_list3410z00_1042 = MAKE_PAIR(BgL_modulez00_32, BNIL);
					BgL_globalz00_1022 =
						BGl_findzd2globalzd2zzast_envz00(BgL_idz00_31,
						BgL_list3410z00_1042);
				}
				if (BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1022,
						BGl_globalz00zzast_varz00))
					{	/* Ast/venv.scm 390 */
						obj_t BgL_bucketz00_1024;

						BgL_bucketz00_1024 =
							BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
							BgL_idz00_31);
						{	/* Ast/venv.scm 391 */
							obj_t BgL_g3254z00_1025;

							BgL_g3254z00_1025 = CDR(BgL_bucketz00_1024);
							{
								obj_t BgL_curz00_1026;

								obj_t BgL_prevz00_1027;

								BgL_curz00_1026 = BgL_g3254z00_1025;
								BgL_prevz00_1027 = BgL_bucketz00_1024;
							BgL_loopz00_1028:
								if ((CAR(BgL_curz00_1026) == BgL_globalz00_1022))
									{	/* Ast/venv.scm 394 */
										obj_t BgL_auxz00_2224;

										BgL_auxz00_2224 = CDR(BgL_curz00_1026);
										return SET_CDR(BgL_prevz00_1027, BgL_auxz00_2224);
									}
								else
									{
										obj_t BgL_prevz00_2229;

										obj_t BgL_curz00_2227;

										BgL_curz00_2227 = CDR(BgL_curz00_1026);
										BgL_prevz00_2229 = CDR(BgL_prevz00_1027);
										BgL_prevz00_1027 = BgL_prevz00_2229;
										BgL_curz00_1026 = BgL_curz00_2227;
										goto BgL_loopz00_1028;
									}
							}
						}
					}
				else
					{	/* Ast/venv.scm 389 */
						obj_t BgL_arg3404z00_1036;

						{	/* Ast/venv.scm 389 */
							obj_t BgL_arg3406z00_1038;

							obj_t BgL_arg3407z00_1039;

							BgL_arg3406z00_1038 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/venv.scm 389 */
								obj_t BgL_list3408z00_1040;

								{	/* Ast/venv.scm 389 */
									obj_t BgL_arg3409z00_1041;

									BgL_arg3409z00_1041 = MAKE_PAIR(BNIL, BNIL);
									BgL_list3408z00_1040 =
										MAKE_PAIR(BgL_modulez00_32, BgL_arg3409z00_1041);
								}
								BgL_arg3407z00_1039 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_idz00_31,
									BgL_list3408z00_1040);
							}
							BgL_arg3404z00_1036 =
								MAKE_PAIR(BgL_arg3406z00_1038, BgL_arg3407z00_1039);
						}
						return
							BGl_userzd2errorzd2zztools_errorz00(BGl_string3539z00zzast_envz00,
							BGl_string3540z00zzast_envz00, BgL_arg3404z00_1036, BNIL);
					}
			}
		}
	}



/* _unbind-global!3530 */
	obj_t BGl__unbindzd2globalz123530zc0zzast_envz00(obj_t BgL_envz00_1841,
		obj_t BgL_idz00_1842, obj_t BgL_modulez00_1843)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 386 */
			return
				BGl_unbindzd2globalz12zc0zzast_envz00(BgL_idz00_1842,
				BgL_modulez00_1843);
		}
	}



/* for-each-global! */
	BGL_EXPORTED_DEF obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t
		BgL_procz00_33, obj_t BgL_envz00_34)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 400 */
			{	/* Ast/venv.scm 401 */
				obj_t BgL_arg3411z00_1043;

				if (NULLP(BgL_envz00_34))
					{	/* Ast/venv.scm 401 */
						BgL_arg3411z00_1043 = BGl_za2Genvza2z00zzast_envz00;
					}
				else
					{	/* Ast/venv.scm 401 */
						BgL_arg3411z00_1043 = CAR(BgL_envz00_34);
					}
				{	/* Ast/venv.scm 402 */
					obj_t BgL_zc3anonymousza33414ze3z83_1844;

					BgL_zc3anonymousza33414ze3z83_1844 =
						make_fx_procedure(BGl_zc3anonymousza33414ze3z83zzast_envz00,
						(int) (((long) 2)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3anonymousza33414ze3z83_1844,
						(int) (((long) 0)), BgL_procz00_33);
					return
						BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_arg3411z00_1043,
						BgL_zc3anonymousza33414ze3z83_1844);
				}
			}
		}
	}



/* _for-each-global!3531 */
	obj_t BGl__forzd2eachzd2globalz123531z12zzast_envz00(obj_t BgL_envz00_1845,
		obj_t BgL_procz00_1846, obj_t BgL_envz00_1847)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 400 */
			return
				BGl_forzd2eachzd2globalz12z12zzast_envz00(BgL_procz00_1846,
				BgL_envz00_1847);
		}
	}



/* <anonymous:3414> */
	obj_t BGl_zc3anonymousza33414ze3z83zzast_envz00(obj_t BgL_envz00_1848,
		obj_t BgL_kz00_1850, obj_t BgL_bucketz00_1851)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 402 */
			{	/* Ast/venv.scm 402 */
				obj_t BgL_procz00_1849;

				BgL_procz00_1849 = PROCEDURE_REF(BgL_envz00_1848, (int) (((long) 0)));
				{
					obj_t BgL_kz00_1046;

					obj_t BgL_bucketz00_1047;

					{	/* Ast/venv.scm 402 */
						bool_t BgL_auxz00_2250;

						BgL_kz00_1046 = BgL_kz00_1850;
						BgL_bucketz00_1047 = BgL_bucketz00_1851;
						{	/* Ast/venv.scm 402 */
							obj_t BgL_g3263z00_1049;

							BgL_g3263z00_1049 = CDR(BgL_bucketz00_1047);
							{
								obj_t BgL_l3261z00_1050;

								BgL_l3261z00_1050 = BgL_g3263z00_1049;
							BgL_forzd2each3262zd2_1051:
								if (PAIRP(BgL_l3261z00_1050))
									{	/* Ast/venv.scm 402 */
										{	/* Ast/venv.scm 402 */
											obj_t BgL_arg3416z00_1053;

											BgL_arg3416z00_1053 = CAR(BgL_l3261z00_1050);
											PROCEDURE_ENTRY(BgL_procz00_1849) (BgL_procz00_1849,
												BgL_arg3416z00_1053, BEOA);
										}
										{
											obj_t BgL_l3261z00_2257;

											BgL_l3261z00_2257 = CDR(BgL_l3261z00_1050);
											BgL_l3261z00_1050 = BgL_l3261z00_2257;
											goto BgL_forzd2each3262zd2_1051;
										}
									}
								else
									{	/* Ast/venv.scm 402 */
										BgL_auxz00_2250 = ((bool_t) 1);
									}
							}
						}
						return BBOOL(BgL_auxz00_2250);
					}
				}
			}
		}
	}



/* global-bucket-position */
	BGL_EXPORTED_DEF obj_t BGl_globalzd2bucketzd2positionz00zzast_envz00(obj_t
		BgL_idz00_35, obj_t BgL_modulez00_36)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 407 */
			{	/* Ast/venv.scm 408 */
				obj_t BgL_bucketz00_1056;

				BgL_bucketz00_1056 =
					BGl_hashtablezd2getzd2zz__hashz00(BGl_za2Genvza2z00zzast_envz00,
					BgL_idz00_35);
				if (PAIRP(BgL_bucketz00_1056))
					{
						obj_t BgL_globalsz00_1059;

						long BgL_posz00_1060;

						{	/* Ast/venv.scm 411 */
							long BgL_auxz00_2263;

							BgL_globalsz00_1059 = CDR(BgL_bucketz00_1056);
							BgL_posz00_1060 = ((long) 0);
						BgL_loopz00_1061:
							if (NULLP(BgL_globalsz00_1059))
								{	/* Ast/venv.scm 414 */
									BgL_auxz00_2263 = ((long) -1);
								}
							else
								{	/* Ast/venv.scm 416 */
									bool_t BgL_testz00_2266;

									{	/* Ast/venv.scm 416 */
										obj_t BgL_auxz00_2267;

										{	/* Ast/venv.scm 416 */
											BgL_globalz00_bglt BgL_obj1491z00_1664;

											{	/* Ast/venv.scm 416 */
												obj_t BgL_pairz00_1663;

												BgL_pairz00_1663 = BgL_globalsz00_1059;
												BgL_obj1491z00_1664 =
													(BgL_globalz00_bglt) (CAR(BgL_pairz00_1663));
											}
											BgL_auxz00_2267 =
												(((BgL_globalz00_bglt) CREF(BgL_obj1491z00_1664))->
												BgL_modulez00);
										}
										BgL_testz00_2266 = (BgL_auxz00_2267 == BgL_modulez00_36);
									}
									if (BgL_testz00_2266)
										{	/* Ast/venv.scm 416 */
											BgL_auxz00_2263 = BgL_posz00_1060;
										}
									else
										{
											long BgL_posz00_2274;

											obj_t BgL_globalsz00_2272;

											BgL_globalsz00_2272 = CDR(BgL_globalsz00_1059);
											BgL_posz00_2274 = (BgL_posz00_1060 + ((long) 1));
											BgL_posz00_1060 = BgL_posz00_2274;
											BgL_globalsz00_1059 = BgL_globalsz00_2272;
											goto BgL_loopz00_1061;
										}
								}
							return BINT(BgL_auxz00_2263);
						}
					}
				else
					{	/* Ast/venv.scm 409 */
						return BINT(((long) -1));
		}}}
	}



/* _global-bucket-posit3532 */
	obj_t BGl__globalzd2bucketzd2posit3532z00zzast_envz00(obj_t BgL_envz00_1852,
		obj_t BgL_idz00_1853, obj_t BgL_modulez00_1854)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 407 */
			return
				BGl_globalzd2bucketzd2positionz00zzast_envz00(BgL_idz00_1853,
				BgL_modulez00_1854);
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_restorezd2valuezd2typesz123264zd2envzc0zzast_envz00);
		}
	}



/* restore-value-types! */
	obj_t BGl_restorezd2valuezd2typesz12z12zzast_envz00(BgL_valuez00_bglt
		BgL_valuez00_7)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 152 */
			{	/* Ast/venv.scm 152 */
				obj_t BgL_method3265z00_1668;

				{	/* Ast/venv.scm 152 */
					BgL_objectz00_bglt BgL_objz00_1669;

					BgL_objz00_1669 = (BgL_objectz00_bglt) (BgL_valuez00_7);
					{	/* Ast/venv.scm 152 */
						long BgL_objzd2classzd2numz00_1670;

						BgL_objzd2classzd2numz00_1670 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1669);
						{	/* Ast/venv.scm 152 */
							obj_t BgL_arg2334z00_1671;

							BgL_arg2334z00_1671 =
								PROCEDURE_REF
								(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								(int) (((long) 1)));
							{	/* Ast/venv.scm 152 */
								obj_t BgL_arrayz00_1673;

								int BgL_offsetz00_1674;

								BgL_arrayz00_1673 = BgL_arg2334z00_1671;
								BgL_offsetz00_1674 = (int) (BgL_objzd2classzd2numz00_1670);
								{	/* Ast/venv.scm 152 */
									long BgL_offsetz00_1675;

									BgL_offsetz00_1675 =
										((long) (BgL_offsetz00_1674) - OBJECT_TYPE);
									{	/* Ast/venv.scm 152 */
										long BgL_modz00_1676;

										{	/* Ast/venv.scm 152 */
											int BgL_arg2336z00_1677;

											BgL_arg2336z00_1677 = (int) (((long) 8));
											{	/* Ast/venv.scm 152 */
												long BgL_auxz00_2289;

												BgL_auxz00_2289 = (long) (BgL_arg2336z00_1677);
												BgL_modz00_1676 =
													(BgL_offsetz00_1675 / BgL_auxz00_2289);
										}}
										{	/* Ast/venv.scm 152 */
											long BgL_restz00_1678;

											{	/* Ast/venv.scm 152 */
												int BgL_arg2335z00_1679;

												BgL_arg2335z00_1679 = (int) (((long) 8));
												{	/* Ast/venv.scm 152 */
													long BgL_auxz00_2293;

													BgL_auxz00_2293 = (long) (BgL_arg2335z00_1679);
													BgL_restz00_1678 =
														(BgL_offsetz00_1675 % BgL_auxz00_2293);
											}}
											{	/* Ast/venv.scm 152 */

												BgL_method3265z00_1668 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1673,
														(int) (BgL_modz00_1676)), (int) (BgL_restz00_1678));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3265z00_1668) (BgL_method3265z00_1668,
					(obj_t) (BgL_valuez00_7), BEOA);
			}
		}
	}



/* _restore-value-types3526 */
	obj_t BGl__restorezd2valuezd2types3526z00zzast_envz00(obj_t BgL_envz00_1820,
		obj_t BgL_valuez00_1821)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 152 */
			return
				BGl_restorezd2valuezd2typesz12z12zzast_envz00(
				(BgL_valuez00_bglt) (BgL_valuez00_1821));
		}
	}



/* _restore-value-types!3264 */
	obj_t BGl__restorezd2valuezd2typesz123264z12zzast_envz00(obj_t
		BgL_envz00_1855, obj_t BgL_valuez00_1856)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_funz00zzast_varz00, BGl_proc3541z00zzast_envz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_sfunz00zzast_varz00, BGl_proc3542z00zzast_envz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc3543z00zzast_envz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
				BGl_cfunz00zzast_varz00, BGl_proc3544z00zzast_envz00);
		}
	}



/* restore-value-types!3274 */
	obj_t BGl_restorezd2valuezd2typesz123274z12zzast_envz00(obj_t BgL_envz00_1861,
		obj_t BgL_valuez00_1862)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 208 */
			{
				BgL_cfunz00_bglt BgL_valuez00_1500;

				{	/* Ast/venv.scm 208 */
					bool_t BgL_auxz00_2309;

					BgL_valuez00_1500 = (BgL_cfunz00_bglt) (BgL_valuez00_1862);
					{

						{	/* Ast/venv.scm 208 */
							obj_t BgL_nextzd2method3273zd2_1512;

							BgL_nextzd2method3273zd2_1512 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_valuez00_1500),
								BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
								BGl_cfunz00zzast_varz00);
							if (PROCEDUREP(BgL_nextzd2method3273zd2_1512))
								{	/* Ast/venv.scm 208 */
									PROCEDURE_ENTRY(BgL_nextzd2method3273zd2_1512)
										(BgL_nextzd2method3273zd2_1512, (obj_t) (BgL_valuez00_1500),
										BEOA);
								}
							else
								{	/* Ast/venv.scm 208 */
									{	/* Ast/venv.scm 208 */
										BgL_valuez00_bglt BgL_valuez00_1783;

										BgL_valuez00_1783 = (BgL_valuez00_bglt) (BgL_valuez00_1500);
										{	/* Ast/venv.scm 208 */
											obj_t BgL_method3265z00_1784;

											{	/* Ast/venv.scm 208 */
												BgL_objectz00_bglt BgL_objz00_1785;

												BgL_objz00_1785 =
													(BgL_objectz00_bglt) (BgL_valuez00_1783);
												{	/* Ast/venv.scm 208 */
													long BgL_objzd2classzd2numz00_1786;

													BgL_objzd2classzd2numz00_1786 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_1785);
													{	/* Ast/venv.scm 208 */
														obj_t BgL_arg2334z00_1787;

														BgL_arg2334z00_1787 =
															PROCEDURE_REF
															(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
															(int) (((long) 1)));
														{	/* Ast/venv.scm 208 */
															obj_t BgL_arrayz00_1789;

															int BgL_offsetz00_1790;

															BgL_arrayz00_1789 = BgL_arg2334z00_1787;
															BgL_offsetz00_1790 =
																(int) (BgL_objzd2classzd2numz00_1786);
															{	/* Ast/venv.scm 208 */
																long BgL_offsetz00_1791;

																BgL_offsetz00_1791 =
																	((long) (BgL_offsetz00_1790) - OBJECT_TYPE);
																{	/* Ast/venv.scm 208 */
																	long BgL_modz00_1792;

																	{	/* Ast/venv.scm 208 */
																		int BgL_arg2336z00_1793;

																		BgL_arg2336z00_1793 = (int) (((long) 8));
																		{	/* Ast/venv.scm 208 */
																			long BgL_auxz00_2326;

																			BgL_auxz00_2326 =
																				(long) (BgL_arg2336z00_1793);
																			BgL_modz00_1792 =
																				(BgL_offsetz00_1791 / BgL_auxz00_2326);
																	}}
																	{	/* Ast/venv.scm 208 */
																		long BgL_restz00_1794;

																		{	/* Ast/venv.scm 208 */
																			int BgL_arg2335z00_1795;

																			BgL_arg2335z00_1795 = (int) (((long) 8));
																			{	/* Ast/venv.scm 208 */
																				long BgL_auxz00_2330;

																				BgL_auxz00_2330 =
																					(long) (BgL_arg2335z00_1795);
																				BgL_restz00_1794 =
																					(BgL_offsetz00_1791 %
																					BgL_auxz00_2330);
																		}}
																		{	/* Ast/venv.scm 208 */

																			BgL_method3265z00_1784 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_1789,
																					(int) (BgL_modz00_1792)),
																				(int) (BgL_restz00_1794));
											}}}}}}}}
											PROCEDURE_ENTRY(BgL_method3265z00_1784)
												(BgL_method3265z00_1784, (obj_t) (BgL_valuez00_1783),
												BEOA);
						}}}}
						{
							obj_t BgL_argsz00_1504;

							{	/* Ast/venv.scm 211 */
								obj_t BgL_arg3507z00_1506;

								BgL_arg3507z00_1506 =
									(((BgL_cfunz00_bglt) CREF(BgL_valuez00_1500))->
									BgL_argszd2typezd2);
								BgL_argsz00_1504 = BgL_arg3507z00_1506;
							BgL_loopz00_1505:
								if (PAIRP(BgL_argsz00_1504))
									{	/* Ast/venv.scm 212 */
										{	/* Ast/venv.scm 214 */
											BgL_typez00_bglt BgL_arg3509z00_1508;

											{	/* Ast/venv.scm 214 */
												obj_t BgL_arg3510z00_1509;

												{	/* Ast/venv.scm 214 */
													BgL_typez00_bglt BgL_obj1319z00_1778;

													{	/* Ast/venv.scm 214 */
														obj_t BgL_pairz00_1777;

														BgL_pairz00_1777 = BgL_argsz00_1504;
														BgL_obj1319z00_1778 =
															(BgL_typez00_bglt) (CAR(BgL_pairz00_1777));
													}
													BgL_arg3510z00_1509 =
														(((BgL_typez00_bglt) CREF(BgL_obj1319z00_1778))->
														BgL_idz00);
												}
												BgL_arg3509z00_1508 =
													BGl_findzd2typezd2zztype_envz00(BgL_arg3510z00_1509);
											}
											{	/* Ast/venv.scm 214 */
												obj_t BgL_auxz00_2347;

												BgL_auxz00_2347 = (obj_t) (BgL_arg3509z00_1508);
												SET_CAR(BgL_argsz00_1504, BgL_auxz00_2347);
											}
										}
										{
											obj_t BgL_argsz00_2350;

											BgL_argsz00_2350 = CDR(BgL_argsz00_1504);
											BgL_argsz00_1504 = BgL_argsz00_2350;
											goto BgL_loopz00_1505;
										}
									}
								else
									{	/* Ast/venv.scm 212 */
										BgL_auxz00_2309 = ((bool_t) 0);
									}
							}
						}
					}
					return BBOOL(BgL_auxz00_2309);
				}
			}
		}
	}



/* restore-value-types!3272 */
	obj_t BGl_restorezd2valuezd2typesz123272z12zzast_envz00(obj_t BgL_envz00_1863,
		obj_t BgL_valuez00_1864)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 201 */
			{
				BgL_isfunz00_bglt BgL_valuez00_1494;

				BgL_valuez00_1494 = (BgL_isfunz00_bglt) (BgL_valuez00_1864);
				{

					{	/* Ast/venv.scm 201 */
						obj_t BgL_nextzd2method3271zd2_1498;

						BgL_nextzd2method3271zd2_1498 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_valuez00_1494),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_isfunz00zzinline_inlinez00);
						if (PROCEDUREP(BgL_nextzd2method3271zd2_1498))
							{	/* Ast/venv.scm 201 */
								PROCEDURE_ENTRY(BgL_nextzd2method3271zd2_1498)
									(BgL_nextzd2method3271zd2_1498, (obj_t) (BgL_valuez00_1494),
									BEOA);
							}
						else
							{	/* Ast/venv.scm 201 */
								{	/* Ast/venv.scm 201 */
									BgL_valuez00_bglt BgL_valuez00_1749;

									BgL_valuez00_1749 = (BgL_valuez00_bglt) (BgL_valuez00_1494);
									{	/* Ast/venv.scm 201 */
										obj_t BgL_method3265z00_1750;

										{	/* Ast/venv.scm 201 */
											BgL_objectz00_bglt BgL_objz00_1751;

											BgL_objz00_1751 =
												(BgL_objectz00_bglt) (BgL_valuez00_1749);
											{	/* Ast/venv.scm 201 */
												long BgL_objzd2classzd2numz00_1752;

												BgL_objzd2classzd2numz00_1752 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1751);
												{	/* Ast/venv.scm 201 */
													obj_t BgL_arg2334z00_1753;

													BgL_arg2334z00_1753 =
														PROCEDURE_REF
														(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
														(int) (((long) 1)));
													{	/* Ast/venv.scm 201 */
														obj_t BgL_arrayz00_1755;

														int BgL_offsetz00_1756;

														BgL_arrayz00_1755 = BgL_arg2334z00_1753;
														BgL_offsetz00_1756 =
															(int) (BgL_objzd2classzd2numz00_1752);
														{	/* Ast/venv.scm 201 */
															long BgL_offsetz00_1757;

															BgL_offsetz00_1757 =
																((long) (BgL_offsetz00_1756) - OBJECT_TYPE);
															{	/* Ast/venv.scm 201 */
																long BgL_modz00_1758;

																{	/* Ast/venv.scm 201 */
																	int BgL_arg2336z00_1759;

																	BgL_arg2336z00_1759 = (int) (((long) 8));
																	{	/* Ast/venv.scm 201 */
																		long BgL_auxz00_2370;

																		BgL_auxz00_2370 =
																			(long) (BgL_arg2336z00_1759);
																		BgL_modz00_1758 =
																			(BgL_offsetz00_1757 / BgL_auxz00_2370);
																}}
																{	/* Ast/venv.scm 201 */
																	long BgL_restz00_1760;

																	{	/* Ast/venv.scm 201 */
																		int BgL_arg2335z00_1761;

																		BgL_arg2335z00_1761 = (int) (((long) 8));
																		{	/* Ast/venv.scm 201 */
																			long BgL_auxz00_2374;

																			BgL_auxz00_2374 =
																				(long) (BgL_arg2335z00_1761);
																			BgL_restz00_1760 =
																				(BgL_offsetz00_1757 % BgL_auxz00_2374);
																	}}
																	{	/* Ast/venv.scm 201 */

																		BgL_method3265z00_1750 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1755,
																				(int) (BgL_modz00_1758)),
																			(int) (BgL_restz00_1760));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method3265z00_1750)
											(BgL_method3265z00_1750, (obj_t) (BgL_valuez00_1749),
											BEOA);
					}}}}
					{	/* Ast/venv.scm 203 */
						BgL_nodez00_bglt BgL_arg3505z00_1497;

						{
							obj_t BgL_auxz00_2384;

							{	/* Ast/venv.scm 203 */
								BgL_objectz00_bglt BgL_auxz00_2385;

								BgL_auxz00_2385 = (BgL_objectz00_bglt) (BgL_valuez00_1494);
								BgL_auxz00_2384 = BGL_OBJECT_WIDENING(BgL_auxz00_2385);
							}
							BgL_arg3505z00_1497 =
								(((BgL_isfunz00_bglt) CREF(BgL_auxz00_2384))->
								BgL_originalzd2bodyzd2);
						}
						return BGl_hrtypezd2nodez12zc0zzast_hrtypez00(BgL_arg3505z00_1497);
					}
				}
			}
		}
	}



/* restore-value-types!3270 */
	obj_t BGl_restorezd2valuezd2typesz123270z12zzast_envz00(obj_t BgL_envz00_1865,
		obj_t BgL_valuez00_1866)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 166 */
			{
				BgL_sfunz00_bglt BgL_valuez00_1462;

				BgL_valuez00_1462 = (BgL_sfunz00_bglt) (BgL_valuez00_1866);
				{

					{	/* Ast/venv.scm 166 */
						obj_t BgL_nextzd2method3268zd2_1492;

						BgL_nextzd2method3268zd2_1492 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_valuez00_1462),
							BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
							BGl_sfunz00zzast_varz00);
						if (PROCEDUREP(BgL_nextzd2method3268zd2_1492))
							{	/* Ast/venv.scm 166 */
								PROCEDURE_ENTRY(BgL_nextzd2method3268zd2_1492)
									(BgL_nextzd2method3268zd2_1492, (obj_t) (BgL_valuez00_1462),
									BEOA);
							}
						else
							{	/* Ast/venv.scm 166 */
								{	/* Ast/venv.scm 166 */
									BgL_valuez00_bglt BgL_valuez00_1721;

									BgL_valuez00_1721 = (BgL_valuez00_bglt) (BgL_valuez00_1462);
									{	/* Ast/venv.scm 166 */
										obj_t BgL_method3265z00_1722;

										{	/* Ast/venv.scm 166 */
											BgL_objectz00_bglt BgL_objz00_1723;

											BgL_objz00_1723 =
												(BgL_objectz00_bglt) (BgL_valuez00_1721);
											{	/* Ast/venv.scm 166 */
												long BgL_objzd2classzd2numz00_1724;

												BgL_objzd2classzd2numz00_1724 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1723);
												{	/* Ast/venv.scm 166 */
													obj_t BgL_arg2334z00_1725;

													BgL_arg2334z00_1725 =
														PROCEDURE_REF
														(BGl_restorezd2valuezd2typesz12zd2envzc0zzast_envz00,
														(int) (((long) 1)));
													{	/* Ast/venv.scm 166 */
														obj_t BgL_arrayz00_1727;

														int BgL_offsetz00_1728;

														BgL_arrayz00_1727 = BgL_arg2334z00_1725;
														BgL_offsetz00_1728 =
															(int) (BgL_objzd2classzd2numz00_1724);
														{	/* Ast/venv.scm 166 */
															long BgL_offsetz00_1729;

															BgL_offsetz00_1729 =
																((long) (BgL_offsetz00_1728) - OBJECT_TYPE);
															{	/* Ast/venv.scm 166 */
																long BgL_modz00_1730;

																{	/* Ast/venv.scm 166 */
																	int BgL_arg2336z00_1731;

																	BgL_arg2336z00_1731 = (int) (((long) 8));
																	{	/* Ast/venv.scm 166 */
																		long BgL_auxz00_2407;

																		BgL_auxz00_2407 =
																			(long) (BgL_arg2336z00_1731);
																		BgL_modz00_1730 =
																			(BgL_offsetz00_1729 / BgL_auxz00_2407);
																}}
																{	/* Ast/venv.scm 166 */
																	long BgL_restz00_1732;

																	{	/* Ast/venv.scm 166 */
																		int BgL_arg2335z00_1733;

																		BgL_arg2335z00_1733 = (int) (((long) 8));
																		{	/* Ast/venv.scm 166 */
																			long BgL_auxz00_2411;

																			BgL_auxz00_2411 =
																				(long) (BgL_arg2335z00_1733);
																			BgL_restz00_1732 =
																				(BgL_offsetz00_1729 % BgL_auxz00_2411);
																	}}
																	{	/* Ast/venv.scm 166 */

																		BgL_method3265z00_1722 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1727,
																				(int) (BgL_modz00_1730)),
																			(int) (BgL_restz00_1732));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method3265z00_1722)
											(BgL_method3265z00_1722, (obj_t) (BgL_valuez00_1721),
											BEOA);
					}}}}
					{
						obj_t BgL_argsz00_1466;

						{	/* Ast/venv.scm 169 */
							obj_t BgL_arg3481z00_1468;

							BgL_arg3481z00_1468 =
								(((BgL_sfunz00_bglt) CREF(BgL_valuez00_1462))->BgL_argsz00);
							BgL_argsz00_1466 = BgL_arg3481z00_1468;
						BgL_loopz00_1467:
							if (PAIRP(BgL_argsz00_1466))
								{	/* Ast/venv.scm 172 */
									obj_t BgL_argz00_1470;

									BgL_argz00_1470 = CAR(BgL_argsz00_1466);
									if (BGl_iszd2azf3z21zz__objectz00(BgL_argz00_1470,
											BGl_typez00zztype_typez00))
										{	/* Ast/venv.scm 175 */
											BgL_typez00_bglt BgL_arg3484z00_1472;

											{	/* Ast/venv.scm 175 */
												obj_t BgL_arg3485z00_1473;

												{
													BgL_typez00_bglt BgL_auxz00_2427;

													BgL_auxz00_2427 =
														(BgL_typez00_bglt) (BgL_argz00_1470);
													BgL_arg3485z00_1473 =
														(((BgL_typez00_bglt) CREF(BgL_auxz00_2427))->
														BgL_idz00);
												}
												BgL_arg3484z00_1472 =
													BGl_findzd2typezd2zztype_envz00(BgL_arg3485z00_1473);
											}
											{	/* Ast/venv.scm 175 */
												obj_t BgL_auxz00_2431;

												BgL_auxz00_2431 = (obj_t) (BgL_arg3484z00_1472);
												SET_CAR(BgL_argsz00_1466, BgL_auxz00_2431);
											}
										}
									else
										{	/* Ast/venv.scm 174 */
											if (BGl_iszd2azf3z21zz__objectz00(BgL_argz00_1470,
													BGl_localz00zzast_varz00))
												{	/* Ast/venv.scm 177 */
													BgL_typez00_bglt BgL_newzd2typezd2_1475;

													{	/* Ast/venv.scm 177 */
														obj_t BgL_arg3488z00_1476;

														{	/* Ast/venv.scm 177 */
															BgL_typez00_bglt BgL_obj1319z00_1708;

															{
																BgL_variablez00_bglt BgL_auxz00_2436;

																BgL_auxz00_2436 =
																	(BgL_variablez00_bglt) (BgL_argz00_1470);
																BgL_obj1319z00_1708 =
																	(((BgL_variablez00_bglt)
																		CREF(BgL_auxz00_2436))->BgL_typez00);
															}
															BgL_arg3488z00_1476 =
																(((BgL_typez00_bglt)
																	CREF(BgL_obj1319z00_1708))->BgL_idz00);
														}
														BgL_newzd2typezd2_1475 =
															BGl_findzd2typezd2zztype_envz00
															(BgL_arg3488z00_1476);
													}
													{
														BgL_variablez00_bglt BgL_auxz00_2441;

														BgL_auxz00_2441 =
															(BgL_variablez00_bglt) (BgL_argz00_1470);
														((((BgL_variablez00_bglt) CREF(BgL_auxz00_2441))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_newzd2typezd2_1475),
															BUNSPEC);
													}
												}
											else
												{	/* Ast/venv.scm 176 */
													BGl_errorz00zz__errorz00
														(BGl_string3545z00zzast_envz00,
														BGl_string3546z00zzast_envz00,
														BGl_shapez00zztools_shapez00(BgL_argz00_1470));
												}
										}
									{
										obj_t BgL_argsz00_2446;

										BgL_argsz00_2446 = CDR(BgL_argsz00_1466);
										BgL_argsz00_1466 = BgL_argsz00_2446;
										goto BgL_loopz00_1467;
									}
								}
							else
								{	/* Ast/venv.scm 171 */
									if (NULLP(BgL_argsz00_1466))
										{	/* Ast/venv.scm 185 */
											obj_t BgL_bodyz00_1483;

											BgL_bodyz00_1483 =
												(((BgL_sfunz00_bglt) CREF(BgL_valuez00_1462))->
												BgL_bodyz00);
											if (BGl_iszd2azf3z21zz__objectz00(BgL_bodyz00_1483,
													BGl_nodez00zzast_nodez00))
												{	/* Ast/venv.scm 188 */
													BgL_typez00_bglt BgL_tresz00_1485;

													{
														BgL_nodez00_bglt BgL_auxz00_2453;

														BgL_auxz00_2453 =
															(BgL_nodez00_bglt) (BgL_bodyz00_1483);
														BgL_tresz00_1485 =
															(((BgL_nodez00_bglt) CREF(BgL_auxz00_2453))->
															BgL_typez00);
													}
													BGl_hrtypezd2nodez12zc0zzast_hrtypez00(
														(BgL_nodez00_bglt) (BgL_bodyz00_1483));
													{	/* Ast/venv.scm 190 */
														bool_t BgL_testz00_2458;

														{	/* Ast/venv.scm 190 */
															obj_t BgL_obj1414z00_1716;

															BgL_obj1414z00_1716 = (obj_t) (BgL_tresz00_1485);
															BgL_testz00_2458 =
																BGl_iszd2azf3z21zz__objectz00
																(BgL_obj1414z00_1716,
																BGl_typez00zztype_typez00);
														}
														if (BgL_testz00_2458)
															{	/* Ast/venv.scm 192 */
																BgL_typez00_bglt BgL_arg3499z00_1487;

																{	/* Ast/venv.scm 192 */
																	obj_t BgL_arg3500z00_1488;

																	BgL_arg3500z00_1488 =
																		(((BgL_typez00_bglt)
																			CREF(BgL_tresz00_1485))->BgL_idz00);
																	BgL_arg3499z00_1487 =
																		BGl_findzd2typezd2zztype_envz00
																		(BgL_arg3500z00_1488);
																}
																{
																	BgL_nodez00_bglt BgL_auxz00_2463;

																	BgL_auxz00_2463 =
																		(BgL_nodez00_bglt) (BgL_bodyz00_1483);
																	return
																		((((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_2463))->BgL_typez00) =
																		((BgL_typez00_bglt) BgL_arg3499z00_1487),
																		BUNSPEC);
																}
															}
														else
															{	/* Ast/venv.scm 190 */
																return BFALSE;
															}
													}
												}
											else
												{	/* Ast/venv.scm 187 */
													return BFALSE;
												}
										}
									else
										{	/* Ast/venv.scm 184 */
											return
												BGl_errorz00zz__errorz00(BGl_string3547z00zzast_envz00,
												BGl_string3548z00zzast_envz00,
												BGl_shapez00zztools_shapez00(BgL_argsz00_1466));
										}
								}
						}
					}
				}
			}
		}
	}



/* restore-value-types!3267 */
	obj_t BGl_restorezd2valuezd2typesz123267z12zzast_envz00(obj_t BgL_envz00_1867,
		obj_t BgL_valuez00_1868)
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 158 */
			{
				BgL_funz00_bglt BgL_valuez00_1451;

				BgL_valuez00_1451 = (BgL_funz00_bglt) (BgL_valuez00_1868);
				{	/* Ast/venv.scm 160 */
					bool_t BgL_testz00_2469;

					{	/* Ast/venv.scm 160 */
						obj_t BgL_arg3479z00_1459;

						BgL_arg3479z00_1459 =
							(((BgL_funz00_bglt) CREF(BgL_valuez00_1451))->
							BgL_predicatezd2ofzd2);
						BgL_testz00_2469 =
							BGl_iszd2azf3z21zz__objectz00(BgL_arg3479z00_1459,
							BGl_typez00zztype_typez00);
					}
					if (BgL_testz00_2469)
						{	/* Ast/venv.scm 161 */
							BgL_typez00_bglt BgL_arg3476z00_1456;

							{	/* Ast/venv.scm 161 */
								obj_t BgL_arg3477z00_1457;

								{	/* Ast/venv.scm 161 */
									BgL_typez00_bglt BgL_obj1319z00_1696;

									BgL_obj1319z00_1696 =
										(BgL_typez00_bglt) (
										(((BgL_funz00_bglt) CREF(BgL_valuez00_1451))->
											BgL_predicatezd2ofzd2));
									BgL_arg3477z00_1457 =
										(((BgL_typez00_bglt) CREF(BgL_obj1319z00_1696))->BgL_idz00);
								}
								BgL_arg3476z00_1456 =
									BGl_findzd2typezd2zztype_envz00(BgL_arg3477z00_1457);
							}
							{
								obj_t BgL_auxz00_2476;

								BgL_auxz00_2476 = (obj_t) (BgL_arg3476z00_1456);
								return
									((((BgL_funz00_bglt) CREF(BgL_valuez00_1451))->
										BgL_predicatezd2ofzd2) =
									((obj_t) BgL_auxz00_2476), BUNSPEC);
							}
						}
					else
						{	/* Ast/venv.scm 160 */
							return BFALSE;
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_envz00()
	{
		AN_OBJECT;
		{	/* Ast/venv.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzast_hrtypez00(((long) 346346738),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 143212498),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
			return
				BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long) 326457085),
				BSTRING_TO_STRING(BGl_string3549z00zzast_envz00));
		}
	}

#ifdef __cplusplus
}
#endif
