/*===========================================================================*/
/*   (Cfa/arithmetic.scm)                                                    */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/arithmetic.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_prezd2arithmeticzd2appz00_bgl
	{
		obj_t BgL_speczd2typeszd2;
	}                                *BgL_prezd2arithmeticzd2appz00_bglt;

	typedef struct BgL_arithmeticzd2appzd2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		obj_t BgL_speczd2typeszd2;
	}                          *BgL_arithmeticzd2appzd2_bglt;


	extern BgL_approxz00_bglt BGl_loosez12z12zzcfa_loosez00(BgL_approxz00_bglt,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_approxzd2setzd2typez12z12zzcfa_approxz00(BgL_approxz00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_approxz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setupz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_cfaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_iteratez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_loosez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_continuezd2cfaz12zc0zzcfa_iteratez00();
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern BgL_approxz00_bglt BGl_makezd2emptyzd2approxz00zzcfa_approxz00();
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 = BUNSPEC;
	static obj_t BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00();
	static obj_t BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BUNSPEC;
	extern obj_t BGl_typez00zztype_typez00;
	extern obj_t BGl_nodezd2setupza2z12z62zzcfa_setupz00(obj_t);
	static obj_t
		BGl__cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
	extern obj_t BGl_prezd2arithmeticzd2appz00zzcfa_info2z00;
	extern BgL_approxz00_bglt
		BGl_makezd2typezd2approxz00zzcfa_approxz00(BgL_typez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00();
	static obj_t BGl_nodezd2setupz12zd2prezd2arit4547zc0zzcfa_arithmeticz00(obj_t,
		obj_t);
	extern BgL_approxz00_bglt BGl_cfaz12z12zzcfa_cfaz00(BgL_nodez00_bglt);
	static obj_t BGl_cfaz12zd2arithmeticzd2app4549z12zzcfa_arithmeticz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	extern obj_t
		BGl_wideningzd2arithmeticzd2appz00zzcfa_info2z00(BgL_approxz00_bglt, obj_t);
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_arithmeticzd2appzd2zzcfa_info2z00;
	static obj_t BGl_cleanupzd2typezd2zzcfa_arithmeticz00(obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
	static obj_t __cnst[1];


	extern obj_t BGl_cfaz12zd2envzc0zzcfa_cfaz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4752z00zzcfa_arithmeticz00,
		BgL_bgl_nodeza7d2setupza712za74760za7,
		BGl_nodezd2setupz12zd2prezd2arit4547zc0zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc4753z00zzcfa_arithmeticz00,
		BgL_bgl_cfaza712za7d2arithme4761z00,
		BGl_cfaz12zd2arithmeticzd2app4549z12zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string4754z00zzcfa_arithmeticz00,
		BgL_bgl_string4754za700za7za7c4762za7, "node-setup!", 11);
	      DEFINE_STRING(BGl_string4755z00zzcfa_arithmeticz00,
		BgL_bgl_string4755za700za7za7c4763za7, "Illegal arithmetic node", 23);
	      DEFINE_STRING(BGl_string4756z00zzcfa_arithmeticz00,
		BgL_bgl_string4756za700za7za7c4764za7, "cfa_arithmetic", 14);
	      DEFINE_STRING(BGl_string4757z00zzcfa_arithmeticz00,
		BgL_bgl_string4757za700za7za7c4765za7, "all ", 4);
	extern obj_t BGl_nodezd2setupz12zd2envz12zzcfa_setupz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_cleanupzd2arithmeticzd2nodesz12zd2envzc0zzcfa_arithmeticz00,
		BgL_bgl__cleanupza7d2arith4766za7,
		BGl__cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00, 0L, BUNSPEC, 0);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long
		BgL_checksumz00_1863, char *BgL_fromz00_1864)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_cnstzd2initzd2zzcfa_arithmeticz00();
					BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_methodzd2initzd2zzcfa_arithmeticz00();
					BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"cfa_arithmetic");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			{	/* Cfa/arithmetic.scm 28 */
				obj_t BgL_cportz00_1855;

				BgL_cportz00_1855 =
					bgl_open_input_string(BGl_string4757z00zzcfa_arithmeticz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1856;

					BgL_iz00_1856 = ((long) 0);
				BgL_loopz00_1857:
					if ((BgL_iz00_1856 == ((long) -1)))
						{	/* Cfa/arithmetic.scm 28 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/arithmetic.scm 28 */
							{	/* Cfa/arithmetic.scm 28 */
								obj_t BgL_arg4759z00_1859;

								{	/* Cfa/arithmetic.scm 28 */

									{	/* Cfa/arithmetic.scm 28 */
										obj_t BgL_locationz00_1861;

										BgL_locationz00_1861 = BBOOL(((bool_t) 0));
										{	/* Cfa/arithmetic.scm 28 */

											BgL_arg4759z00_1859 =
												BGl_readz00zz__readerz00(BgL_cportz00_1855,
												BgL_locationz00_1861);
										}
									}
								}
								{	/* Cfa/arithmetic.scm 28 */
									int BgL_auxz00_1883;

									BgL_auxz00_1883 = (int) (BgL_iz00_1856);
									CNST_TABLE_SET(BgL_auxz00_1883, BgL_arg4759z00_1859);
							}}
							{	/* Cfa/arithmetic.scm 28 */
								int BgL_auxz00_1862;

								BgL_auxz00_1862 = (int) ((BgL_iz00_1856 - ((long) 1)));
								{
									long BgL_iz00_1888;

									BgL_iz00_1888 = (long) (BgL_auxz00_1862);
									BgL_iz00_1856 = BgL_iz00_1888;
									goto BgL_loopz00_1857;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BNIL;
			return BUNSPEC;
		}
	}



/* cleanup-arithmetic-nodes! */
	BGL_EXPORTED_DEF obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 52 */
			{
				obj_t BgL_l4529z00_995;

				{	/* Cfa/arithmetic.scm 67 */
					bool_t BgL_auxz00_1890;

					BgL_l4529z00_995 = BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00;
				BgL_forzd2each4530zd2_996:
					if (PAIRP(BgL_l4529z00_995))
						{	/* Cfa/arithmetic.scm 67 */
							{	/* Cfa/arithmetic.scm 68 */
								obj_t BgL_nodez00_998;

								BgL_nodez00_998 = CAR(BgL_l4529z00_995);
								{	/* Cfa/arithmetic.scm 69 */
									BgL_variablez00_bglt BgL_fz00_1000;

									{	/* Cfa/arithmetic.scm 69 */
										BgL_varz00_bglt BgL_obj1972z00_1714;

										{
											BgL_appz00_bglt BgL_auxz00_1894;

											BgL_auxz00_1894 = (BgL_appz00_bglt) (BgL_nodez00_998);
											BgL_obj1972z00_1714 =
												(((BgL_appz00_bglt) CREF(BgL_auxz00_1894))->BgL_funz00);
										}
										BgL_fz00_1000 =
											(((BgL_varz00_bglt) CREF(BgL_obj1972z00_1714))->
											BgL_variablez00);
									}
									{	/* Cfa/arithmetic.scm 69 */
										BgL_valuez00_bglt BgL_valz00_1001;

										BgL_valz00_1001 =
											(((BgL_variablez00_bglt) CREF(BgL_fz00_1000))->
											BgL_valuez00);
										{	/* Cfa/arithmetic.scm 70 */

											{	/* Cfa/arithmetic.scm 72 */
												bool_t BgL_testz00_1899;

												{	/* Cfa/arithmetic.scm 72 */
													BgL_typez00_bglt BgL_arg4552z00_1003;

													BgL_arg4552z00_1003 =
														(((BgL_variablez00_bglt) CREF(BgL_fz00_1000))->
														BgL_typez00);
													BgL_testz00_1899 =
														((obj_t) (BgL_arg4552z00_1003) ==
														BGl_za2_za2z00zztype_cachez00);
												}
												if (BgL_testz00_1899)
													{
														BgL_typez00_bglt BgL_auxz00_1903;

														BgL_auxz00_1903 =
															(BgL_typez00_bglt)
															(BGl_za2objza2z00zztype_cachez00);
														((((BgL_variablez00_bglt) CREF(BgL_fz00_1000))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_auxz00_1903), BUNSPEC);
													}
												else
													{	/* Cfa/arithmetic.scm 72 */
														BFALSE;
													}
											}
											{	/* Cfa/arithmetic.scm 74 */
												bool_t BgL_testz00_1906;

												{	/* Cfa/arithmetic.scm 74 */
													BgL_typez00_bglt BgL_arg4554z00_1005;

													{
														BgL_nodez00_bglt BgL_auxz00_1907;

														BgL_auxz00_1907 =
															(BgL_nodez00_bglt) (BgL_nodez00_998);
														BgL_arg4554z00_1005 =
															(((BgL_nodez00_bglt) CREF(BgL_auxz00_1907))->
															BgL_typez00);
													}
													BgL_testz00_1906 =
														(
														(obj_t) (BgL_arg4554z00_1005) ==
														BGl_za2_za2z00zztype_cachez00);
												}
												if (BgL_testz00_1906)
													{
														BgL_typez00_bglt BgL_auxz00_1914;

														BgL_nodez00_bglt BgL_auxz00_1912;

														BgL_auxz00_1914 =
															(BgL_typez00_bglt)
															(BGl_za2objza2z00zztype_cachez00);
														BgL_auxz00_1912 =
															(BgL_nodez00_bglt) (BgL_nodez00_998);
														((((BgL_nodez00_bglt) CREF(BgL_auxz00_1912))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_auxz00_1914), BUNSPEC);
													}
												else
													{	/* Cfa/arithmetic.scm 74 */
														BFALSE;
													}
											}
											{	/* Cfa/arithmetic.scm 77 */
												bool_t BgL_testz00_1917;

												{	/* Cfa/arithmetic.scm 77 */
													obj_t BgL_obj1772z00_1722;

													BgL_obj1772z00_1722 = (obj_t) (BgL_valz00_1001);
													BgL_testz00_1917 =
														BGl_iszd2azf3z21zz__objectz00(BgL_obj1772z00_1722,
														BGl_sfunz00zzast_varz00);
												}
												if (BgL_testz00_1917)
													{	/* Cfa/arithmetic.scm 79 */
														obj_t BgL_arg4556z00_1007;

														{	/* Cfa/arithmetic.scm 79 */
															obj_t BgL_l4522z00_1008;

															{
																BgL_sfunz00_bglt BgL_auxz00_1920;

																BgL_auxz00_1920 =
																	(BgL_sfunz00_bglt) (BgL_valz00_1001);
																BgL_l4522z00_1008 =
																	(((BgL_sfunz00_bglt) CREF(BgL_auxz00_1920))->
																	BgL_argsz00);
															}
															if (NULLP(BgL_l4522z00_1008))
																{	/* Cfa/arithmetic.scm 79 */
																	BgL_arg4556z00_1007 = BNIL;
																}
															else
																{	/* Cfa/arithmetic.scm 79 */
																	obj_t BgL_head4525z00_1010;

																	BgL_head4525z00_1010 =
																		MAKE_PAIR
																		(BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																		(CAR(BgL_l4522z00_1008)), BNIL);
																	{	/* Cfa/arithmetic.scm 79 */
																		obj_t BgL_g4528z00_1011;

																		BgL_g4528z00_1011 = CDR(BgL_l4522z00_1008);
																		{
																			obj_t BgL_l4522z00_1012;

																			obj_t BgL_tail4526z00_1013;

																			BgL_l4522z00_1012 = BgL_g4528z00_1011;
																			BgL_tail4526z00_1013 =
																				BgL_head4525z00_1010;
																		BgL_map4524z00_1014:
																			if (NULLP(BgL_l4522z00_1012))
																				{	/* Cfa/arithmetic.scm 79 */
																					BgL_arg4556z00_1007 =
																						BgL_head4525z00_1010;
																				}
																			else
																				{	/* Cfa/arithmetic.scm 79 */
																					obj_t BgL_newtail4527z00_1016;

																					BgL_newtail4527z00_1016 =
																						MAKE_PAIR
																						(BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																						(CAR(BgL_l4522z00_1012)), BNIL);
																					SET_CDR(BgL_tail4526z00_1013,
																						BgL_newtail4527z00_1016);
																					{
																						obj_t BgL_tail4526z00_1937;

																						obj_t BgL_l4522z00_1935;

																						BgL_l4522z00_1935 =
																							CDR(BgL_l4522z00_1012);
																						BgL_tail4526z00_1937 =
																							BgL_newtail4527z00_1016;
																						BgL_tail4526z00_1013 =
																							BgL_tail4526z00_1937;
																						BgL_l4522z00_1012 =
																							BgL_l4522z00_1935;
																						goto BgL_map4524z00_1014;
																					}
																				}
																		}
																	}
																}
														}
														{
															BgL_sfunz00_bglt BgL_auxz00_1938;

															BgL_auxz00_1938 =
																(BgL_sfunz00_bglt) (BgL_valz00_1001);
															((((BgL_sfunz00_bglt) CREF(BgL_auxz00_1938))->
																	BgL_argsz00) =
																((obj_t) BgL_arg4556z00_1007), BUNSPEC);
														}
													}
												else
													{	/* Cfa/arithmetic.scm 80 */
														bool_t BgL_testz00_1941;

														{	/* Cfa/arithmetic.scm 80 */
															obj_t BgL_obj1836z00_1738;

															BgL_obj1836z00_1738 = (obj_t) (BgL_valz00_1001);
															BgL_testz00_1941 =
																BGl_iszd2azf3z21zz__objectz00
																(BgL_obj1836z00_1738, BGl_cfunz00zzast_varz00);
														}
														if (BgL_testz00_1941)
															{	/* Cfa/arithmetic.scm 81 */
																obj_t BgL_g4512z00_1025;

																{
																	BgL_cfunz00_bglt BgL_auxz00_1944;

																	BgL_auxz00_1944 =
																		(BgL_cfunz00_bglt) (BgL_valz00_1001);
																	BgL_g4512z00_1025 =
																		(((BgL_cfunz00_bglt)
																			CREF(BgL_auxz00_1944))->
																		BgL_argszd2typezd2);
																}
																{
																	obj_t BgL_lz00_1026;

																	{	/* Cfa/arithmetic.scm 81 */
																		bool_t BgL_auxz00_1947;

																		BgL_lz00_1026 = BgL_g4512z00_1025;
																	BgL_loopz00_1027:
																		if (PAIRP(BgL_lz00_1026))
																			{	/* Cfa/arithmetic.scm 82 */
																				{	/* Cfa/arithmetic.scm 84 */
																					obj_t BgL_auxz00_1950;

																					BgL_auxz00_1950 =
																						BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																						(CAR(BgL_lz00_1026));
																					SET_CAR(BgL_lz00_1026,
																						BgL_auxz00_1950);
																				}
																				{
																					obj_t BgL_lz00_1954;

																					BgL_lz00_1954 = CDR(BgL_lz00_1026);
																					BgL_lz00_1026 = BgL_lz00_1954;
																					goto BgL_loopz00_1027;
																				}
																			}
																		else
																			{	/* Cfa/arithmetic.scm 82 */
																				BgL_auxz00_1947 = ((bool_t) 0);
																			}
																		BBOOL(BgL_auxz00_1947);
																	}
																}
															}
														else
															{	/* Cfa/arithmetic.scm 80 */
																BFALSE;
															}
													}
											}
										}
									}
								}
							}
							{
								obj_t BgL_l4529z00_1957;

								BgL_l4529z00_1957 = CDR(BgL_l4529z00_995);
								BgL_l4529z00_995 = BgL_l4529z00_1957;
								goto BgL_forzd2each4530zd2_996;
							}
						}
					else
						{	/* Cfa/arithmetic.scm 67 */
							BgL_auxz00_1890 = ((bool_t) 1);
						}
					return BBOOL(BgL_auxz00_1890);
				}
			}
		}
	}



/* cleanup-type */
	obj_t BGl_cleanupzd2typezd2zzcfa_arithmeticz00(obj_t BgL_tz00_1034)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 66 */
			if (BGl_iszd2azf3z21zz__objectz00(BgL_tz00_1034,
					BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 55 */
					if ((BgL_tz00_1034 == BGl_za2_za2z00zztype_cachez00))
						{	/* Cfa/arithmetic.scm 56 */
							return BGl_za2objza2z00zztype_cachez00;
						}
					else
						{	/* Cfa/arithmetic.scm 56 */
							return BgL_tz00_1034;
						}
				}
			else
				{	/* Cfa/arithmetic.scm 55 */
					if (BGl_iszd2azf3z21zz__objectz00(BgL_tz00_1034,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 59 */
							{	/* Cfa/arithmetic.scm 60 */
								bool_t BgL_testz00_1966;

								{	/* Cfa/arithmetic.scm 60 */
									BgL_typez00_bglt BgL_arg4579z00_1040;

									{
										BgL_variablez00_bglt BgL_auxz00_1967;

										BgL_auxz00_1967 = (BgL_variablez00_bglt) (BgL_tz00_1034);
										BgL_arg4579z00_1040 =
											(((BgL_variablez00_bglt) CREF(BgL_auxz00_1967))->
											BgL_typez00);
									}
									BgL_testz00_1966 =
										(
										(obj_t) (BgL_arg4579z00_1040) ==
										BGl_za2_za2z00zztype_cachez00);
								}
								if (BgL_testz00_1966)
									{
										BgL_typez00_bglt BgL_auxz00_1974;

										BgL_variablez00_bglt BgL_auxz00_1972;

										BgL_auxz00_1974 =
											(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
										BgL_auxz00_1972 = (BgL_variablez00_bglt) (BgL_tz00_1034);
										((((BgL_variablez00_bglt) CREF(BgL_auxz00_1972))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_auxz00_1974), BUNSPEC);
									}
								else
									{	/* Cfa/arithmetic.scm 60 */
										BFALSE;
									}
							}
							return BgL_tz00_1034;
						}
					else
						{	/* Cfa/arithmetic.scm 59 */
							return BgL_tz00_1034;
						}
				}
		}
	}



/* _cleanup-arithmetic-nodes! */
	obj_t BGl__cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t
		BgL_envz00_1844)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 52 */
			return BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00();
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_nodezd2setupz12zd2envz12zzcfa_setupz00,
				BGl_prezd2arithmeticzd2appz00zzcfa_info2z00,
				BGl_proc4752z00zzcfa_arithmeticz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00(BGl_cfaz12zd2envzc0zzcfa_cfaz00,
				BGl_arithmeticzd2appzd2zzcfa_info2z00,
				BGl_proc4753z00zzcfa_arithmeticz00);
		}
	}



/* cfa!-arithmetic-app4549 */
	obj_t BGl_cfaz12zd2arithmeticzd2app4549z12zzcfa_arithmeticz00(obj_t
		BgL_envz00_1847, obj_t BgL_nodez00_1848)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 141 */
			{
				BgL_arithmeticzd2appzd2_bglt BgL_nodez00_1626;

				{	/* Cfa/arithmetic.scm 170 */
					BgL_approxz00_bglt BgL_auxz00_1980;

					BgL_nodez00_1626 = (BgL_arithmeticzd2appzd2_bglt) (BgL_nodez00_1848);
					{
						obj_t BgL_argszd2approxzd2_1666;

						obj_t BgL_speczd2typeszd2_1667;

						obj_t BgL_argszd2approxzd2_1677;

						obj_t BgL_typez00_1678;

						obj_t BgL_speczd2typeszd2_1679;

						obj_t BgL_argszd2approxzd2_1692;

						{	/* Cfa/arithmetic.scm 182 */
							obj_t BgL_argszd2approxzd2_1634;

							{	/* Cfa/arithmetic.scm 182 */
								obj_t BgL_l4537z00_1650;

								{
									BgL_appz00_bglt BgL_auxz00_1981;

									BgL_auxz00_1981 = (BgL_appz00_bglt) (BgL_nodez00_1626);
									BgL_l4537z00_1650 =
										(((BgL_appz00_bglt) CREF(BgL_auxz00_1981))->BgL_argsz00);
								}
								if (NULLP(BgL_l4537z00_1650))
									{	/* Cfa/arithmetic.scm 182 */
										BgL_argszd2approxzd2_1634 = BNIL;
									}
								else
									{	/* Cfa/arithmetic.scm 182 */
										obj_t BgL_head4539z00_1652;

										{	/* Cfa/arithmetic.scm 182 */
											BgL_approxz00_bglt BgL_arg4722z00_1663;

											{	/* Cfa/arithmetic.scm 182 */
												obj_t BgL_arg4725z00_1665;

												BgL_arg4725z00_1665 = CAR(BgL_l4537z00_1650);
												BgL_arg4722z00_1663 =
													BGl_cfaz12z12zzcfa_cfaz00(
													(BgL_nodez00_bglt) (BgL_arg4725z00_1665));
											}
											BgL_head4539z00_1652 =
												MAKE_PAIR((obj_t) (BgL_arg4722z00_1663), BNIL);
										}
										{	/* Cfa/arithmetic.scm 182 */
											obj_t BgL_g4542z00_1653;

											BgL_g4542z00_1653 = CDR(BgL_l4537z00_1650);
											{
												obj_t BgL_l4537z00_1654;

												obj_t BgL_tail4540z00_1655;

												BgL_l4537z00_1654 = BgL_g4542z00_1653;
												BgL_tail4540z00_1655 = BgL_head4539z00_1652;
											BgL_map4538z00_1656:
												if (NULLP(BgL_l4537z00_1654))
													{	/* Cfa/arithmetic.scm 182 */
														BgL_argszd2approxzd2_1634 = BgL_head4539z00_1652;
													}
												else
													{	/* Cfa/arithmetic.scm 182 */
														obj_t BgL_newtail4541z00_1658;

														{	/* Cfa/arithmetic.scm 182 */
															BgL_approxz00_bglt BgL_arg4719z00_1660;

															{	/* Cfa/arithmetic.scm 182 */
																obj_t BgL_arg4721z00_1662;

																BgL_arg4721z00_1662 = CAR(BgL_l4537z00_1654);
																BgL_arg4719z00_1660 =
																	BGl_cfaz12z12zzcfa_cfaz00(
																	(BgL_nodez00_bglt) (BgL_arg4721z00_1662));
															}
															BgL_newtail4541z00_1658 =
																MAKE_PAIR((obj_t) (BgL_arg4719z00_1660), BNIL);
														}
														SET_CDR(BgL_tail4540z00_1655,
															BgL_newtail4541z00_1658);
														{
															obj_t BgL_tail4540z00_2002;

															obj_t BgL_l4537z00_2000;

															BgL_l4537z00_2000 = CDR(BgL_l4537z00_1654);
															BgL_tail4540z00_2002 = BgL_newtail4541z00_1658;
															BgL_tail4540z00_1655 = BgL_tail4540z00_2002;
															BgL_l4537z00_1654 = BgL_l4537z00_2000;
															goto BgL_map4538z00_1656;
														}
													}
											}
										}
									}
							}
							{	/* Cfa/arithmetic.scm 184 */
								obj_t BgL_tyz00_1635;

								BgL_argszd2approxzd2_1692 = BgL_argszd2approxzd2_1634;
								{
									obj_t BgL_argsz00_1694;

									BgL_argsz00_1694 = BgL_argszd2approxzd2_1692;
								BgL_loopz00_1695:
									if (NULLP(BgL_argsz00_1694))
										{	/* Cfa/arithmetic.scm 150 */
											BgL_tyz00_1635 = BFALSE;
										}
									else
										{	/* Cfa/arithmetic.scm 152 */
											obj_t BgL_tz00_1697;

											{	/* Cfa/arithmetic.scm 152 */
												BgL_typez00_bglt BgL_arg4744z00_1700;

												{	/* Cfa/arithmetic.scm 152 */
													BgL_approxz00_bglt BgL_obj3060z00_1839;

													{	/* Cfa/arithmetic.scm 152 */
														obj_t BgL_pairz00_1838;

														BgL_pairz00_1838 = BgL_argsz00_1694;
														BgL_obj3060z00_1839 =
															(BgL_approxz00_bglt) (CAR(BgL_pairz00_1838));
													}
													BgL_arg4744z00_1700 =
														(((BgL_approxz00_bglt) CREF(BgL_obj3060z00_1839))->
														BgL_typez00);
												}
												if (
													((obj_t) (BgL_arg4744z00_1700) ==
														BGl_za2intza2z00zztype_cachez00))
													{	/* Cfa/arithmetic.scm 152 */
														BgL_tz00_1697 = BGl_za2longza2z00zztype_cachez00;
													}
												else
													{	/* Cfa/arithmetic.scm 152 */
														BgL_tz00_1697 = (obj_t) (BgL_arg4744z00_1700);
													}
											}
											if ((BgL_tz00_1697 == BGl_za2_za2z00zztype_cachez00))
												{
													obj_t BgL_argsz00_2014;

													BgL_argsz00_2014 = CDR(BgL_argsz00_1694);
													BgL_argsz00_1694 = BgL_argsz00_2014;
													goto BgL_loopz00_1695;
												}
											else
												{	/* Cfa/arithmetic.scm 153 */
													BgL_tyz00_1635 = BgL_tz00_1697;
												}
										}
								}
								{	/* Cfa/arithmetic.scm 185 */
									bool_t BgL_testz00_2016;

									BgL_argszd2approxzd2_1677 = BgL_argszd2approxzd2_1634;
									BgL_typez00_1678 = BgL_tyz00_1635;
									{
										obj_t BgL_auxz00_2038;

										{	/* Cfa/arithmetic.scm 185 */
											BgL_objectz00_bglt BgL_auxz00_2039;

											BgL_auxz00_2039 = (BgL_objectz00_bglt) (BgL_nodez00_1626);
											BgL_auxz00_2038 = BGL_OBJECT_WIDENING(BgL_auxz00_2039);
										}
										BgL_speczd2typeszd2_1679 =
											(((BgL_arithmeticzd2appzd2_bglt) CREF(BgL_auxz00_2038))->
											BgL_speczd2typeszd2);
									}
									{	/* Cfa/arithmetic.scm 159 */
										bool_t BgL__ortest_4518z00_1681;

										if (CBOOL(BgL_typez00_1678))
											{	/* Cfa/arithmetic.scm 159 */
												BgL__ortest_4518z00_1681 = ((bool_t) 0);
											}
										else
											{	/* Cfa/arithmetic.scm 159 */
												BgL__ortest_4518z00_1681 = ((bool_t) 1);
											}
										if (BgL__ortest_4518z00_1681)
											{	/* Cfa/arithmetic.scm 159 */
												BgL_testz00_2016 = BgL__ortest_4518z00_1681;
											}
										else
											{	/* Cfa/arithmetic.scm 159 */
												if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
														(BgL_typez00_1678, BgL_speczd2typeszd2_1679)))
													{
														obj_t BgL_argsz00_1683;

														BgL_argsz00_1683 = BgL_argszd2approxzd2_1677;
													BgL_loopz00_1684:
														if (NULLP(BgL_argsz00_1683))
															{	/* Cfa/arithmetic.scm 162 */
																BgL_testz00_2016 = ((bool_t) 1);
															}
														else
															{	/* Cfa/arithmetic.scm 164 */
																obj_t BgL_tz00_1686;

																{	/* Cfa/arithmetic.scm 164 */
																	BgL_typez00_bglt BgL_arg4738z00_1690;

																	{	/* Cfa/arithmetic.scm 164 */
																		BgL_approxz00_bglt BgL_obj3060z00_1833;

																		{	/* Cfa/arithmetic.scm 164 */
																			obj_t BgL_pairz00_1832;

																			BgL_pairz00_1832 = BgL_argsz00_1683;
																			BgL_obj3060z00_1833 =
																				(BgL_approxz00_bglt) (CAR
																				(BgL_pairz00_1832));
																		}
																		BgL_arg4738z00_1690 =
																			(((BgL_approxz00_bglt)
																				CREF(BgL_obj3060z00_1833))->
																			BgL_typez00);
																	}
																	if (
																		((obj_t) (BgL_arg4738z00_1690) ==
																			BGl_za2intza2z00zztype_cachez00))
																		{	/* Cfa/arithmetic.scm 164 */
																			BgL_tz00_1686 =
																				BGl_za2longza2z00zztype_cachez00;
																		}
																	else
																		{	/* Cfa/arithmetic.scm 164 */
																			BgL_tz00_1686 =
																				(obj_t) (BgL_arg4738z00_1690);
																		}
																}
																{	/* Cfa/arithmetic.scm 165 */
																	bool_t BgL_testz00_2032;

																	if ((BgL_tz00_1686 == BgL_typez00_1678))
																		{	/* Cfa/arithmetic.scm 165 */
																			BgL_testz00_2032 = ((bool_t) 1);
																		}
																	else
																		{	/* Cfa/arithmetic.scm 165 */
																			BgL_testz00_2032 =
																				(BgL_tz00_1686 ==
																				BGl_za2_za2z00zztype_cachez00);
																		}
																	if (BgL_testz00_2032)
																		{
																			obj_t BgL_argsz00_2036;

																			BgL_argsz00_2036 = CDR(BgL_argsz00_1683);
																			BgL_argsz00_1683 = BgL_argsz00_2036;
																			goto BgL_loopz00_1684;
																		}
																	else
																		{	/* Cfa/arithmetic.scm 165 */
																			BgL_testz00_2016 = ((bool_t) 0);
																		}
																}
															}
													}
												else
													{	/* Cfa/arithmetic.scm 160 */
														BgL_testz00_2016 = ((bool_t) 0);
													}
											}
									}
									if (BgL_testz00_2016)
										{	/* Cfa/arithmetic.scm 187 */
											bool_t BgL_testz00_2043;

											BgL_argszd2approxzd2_1666 = BgL_argszd2approxzd2_1634;
											{
												obj_t BgL_auxz00_2058;

												{	/* Cfa/arithmetic.scm 187 */
													BgL_objectz00_bglt BgL_auxz00_2059;

													BgL_auxz00_2059 =
														(BgL_objectz00_bglt) (BgL_nodez00_1626);
													BgL_auxz00_2058 =
														BGL_OBJECT_WIDENING(BgL_auxz00_2059);
												}
												BgL_speczd2typeszd2_1667 =
													(((BgL_arithmeticzd2appzd2_bglt)
														CREF(BgL_auxz00_2058))->BgL_speczd2typeszd2);
											}
											{
												obj_t BgL_argsz00_1669;

												BgL_argsz00_1669 = BgL_argszd2approxzd2_1666;
											BgL_loopz00_1670:
												if (NULLP(BgL_argsz00_1669))
													{	/* Cfa/arithmetic.scm 172 */
														BgL_testz00_2043 = ((bool_t) 1);
													}
												else
													{	/* Cfa/arithmetic.scm 174 */
														bool_t BgL_testz00_2046;

														{	/* Cfa/arithmetic.scm 174 */
															obj_t BgL_arg4730z00_1674;

															{	/* Cfa/arithmetic.scm 174 */
																BgL_typez00_bglt BgL_arg4731z00_1675;

																{	/* Cfa/arithmetic.scm 174 */
																	BgL_approxz00_bglt BgL_obj3060z00_1827;

																	{	/* Cfa/arithmetic.scm 174 */
																		obj_t BgL_pairz00_1826;

																		BgL_pairz00_1826 = BgL_argsz00_1669;
																		BgL_obj3060z00_1827 =
																			(BgL_approxz00_bglt) (CAR
																			(BgL_pairz00_1826));
																	}
																	BgL_arg4731z00_1675 =
																		(((BgL_approxz00_bglt)
																			CREF(BgL_obj3060z00_1827))->BgL_typez00);
																}
																if (
																	((obj_t) (BgL_arg4731z00_1675) ==
																		BGl_za2intza2z00zztype_cachez00))
																	{	/* Cfa/arithmetic.scm 174 */
																		BgL_arg4730z00_1674 =
																			BGl_za2longza2z00zztype_cachez00;
																	}
																else
																	{	/* Cfa/arithmetic.scm 174 */
																		BgL_arg4730z00_1674 =
																			(obj_t) (BgL_arg4731z00_1675);
																	}
															}
															BgL_testz00_2046 =
																CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
																(BgL_arg4730z00_1674,
																	BgL_speczd2typeszd2_1667));
														}
														if (BgL_testz00_2046)
															{
																obj_t BgL_argsz00_2056;

																BgL_argsz00_2056 = CDR(BgL_argsz00_1669);
																BgL_argsz00_1669 = BgL_argsz00_2056;
																goto BgL_loopz00_1670;
															}
														else
															{	/* Cfa/arithmetic.scm 174 */
																BgL_testz00_2043 = ((bool_t) 0);
															}
													}
											}
											if (BgL_testz00_2043)
												{	/* Cfa/arithmetic.scm 190 */
													bool_t BgL_testz00_2063;

													{	/* Cfa/arithmetic.scm 190 */
														BgL_typez00_bglt BgL_arg4709z00_1640;

														{	/* Cfa/arithmetic.scm 190 */
															BgL_approxz00_bglt BgL_obj3060z00_1818;

															{
																obj_t BgL_auxz00_2064;

																{	/* Cfa/arithmetic.scm 190 */
																	BgL_objectz00_bglt BgL_auxz00_2065;

																	BgL_auxz00_2065 =
																		(BgL_objectz00_bglt) (BgL_nodez00_1626);
																	BgL_auxz00_2064 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_2065);
																}
																BgL_obj3060z00_1818 =
																	(((BgL_arithmeticzd2appzd2_bglt)
																		CREF(BgL_auxz00_2064))->BgL_approxz00);
															}
															BgL_arg4709z00_1640 =
																(((BgL_approxz00_bglt)
																	CREF(BgL_obj3060z00_1818))->BgL_typez00);
														}
														BgL_testz00_2063 =
															(
															(obj_t) (BgL_arg4709z00_1640) ==
															BGl_za2_za2z00zztype_cachez00);
													}
													if (BgL_testz00_2063)
														{	/* Cfa/arithmetic.scm 190 */
															{	/* Cfa/arithmetic.scm 193 */
																BgL_approxz00_bglt BgL_arg4708z00_1639;

																{
																	obj_t BgL_auxz00_2072;

																	{	/* Cfa/arithmetic.scm 193 */
																		BgL_objectz00_bglt BgL_auxz00_2073;

																		BgL_auxz00_2073 =
																			(BgL_objectz00_bglt) (BgL_nodez00_1626);
																		BgL_auxz00_2072 =
																			BGL_OBJECT_WIDENING(BgL_auxz00_2073);
																	}
																	BgL_arg4708z00_1639 =
																		(((BgL_arithmeticzd2appzd2_bglt)
																			CREF(BgL_auxz00_2072))->BgL_approxz00);
																}
																BGl_approxzd2setzd2typez12z12zzcfa_approxz00
																	(BgL_arg4708z00_1639,
																	(BgL_typez00_bglt) (BgL_tyz00_1635));
															}
															BGl_continuezd2cfaz12zc0zzcfa_iteratez00();
														}
													else
														{	/* Cfa/arithmetic.scm 190 */
															BFALSE;
														}
												}
											else
												{	/* Cfa/arithmetic.scm 187 */
													BFALSE;
												}
										}
									else
										{	/* Cfa/arithmetic.scm 185 */
											{
												obj_t BgL_l4543z00_1643;

												BgL_l4543z00_1643 = BgL_argszd2approxzd2_1634;
											BgL_forzd2each4545zd2_1644:
												if (PAIRP(BgL_l4543z00_1643))
													{	/* Cfa/arithmetic.scm 197 */
														{	/* Cfa/arithmetic.scm 197 */
															obj_t BgL_az00_1646;

															BgL_az00_1646 = CAR(BgL_l4543z00_1643);
															BGl_loosez12z12zzcfa_loosez00(
																(BgL_approxz00_bglt) (BgL_az00_1646),
																CNST_TABLE_REF(((long) 0)));
														}
														{
															obj_t BgL_l4543z00_2086;

															BgL_l4543z00_2086 = CDR(BgL_l4543z00_1643);
															BgL_l4543z00_1643 = BgL_l4543z00_2086;
															goto BgL_forzd2each4545zd2_1644;
														}
													}
												else
													{	/* Cfa/arithmetic.scm 197 */
														((bool_t) 1);
													}
											}
											{	/* Cfa/arithmetic.scm 198 */
												BgL_approxz00_bglt BgL_arg4714z00_1648;

												{
													obj_t BgL_auxz00_2088;

													{	/* Cfa/arithmetic.scm 198 */
														BgL_objectz00_bglt BgL_auxz00_2089;

														BgL_auxz00_2089 =
															(BgL_objectz00_bglt) (BgL_nodez00_1626);
														BgL_auxz00_2088 =
															BGL_OBJECT_WIDENING(BgL_auxz00_2089);
													}
													BgL_arg4714z00_1648 =
														(((BgL_arithmeticzd2appzd2_bglt)
															CREF(BgL_auxz00_2088))->BgL_approxz00);
												}
												BGl_approxzd2setzd2typez12z12zzcfa_approxz00
													(BgL_arg4714z00_1648,
													(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00));
											}
										}
								}
							}
						}
						{
							obj_t BgL_auxz00_2095;

							{	/* Cfa/arithmetic.scm 200 */
								BgL_objectz00_bglt BgL_auxz00_2096;

								BgL_auxz00_2096 = (BgL_objectz00_bglt) (BgL_nodez00_1626);
								BgL_auxz00_2095 = BGL_OBJECT_WIDENING(BgL_auxz00_2096);
							}
							BgL_auxz00_1980 =
								(((BgL_arithmeticzd2appzd2_bglt) CREF(BgL_auxz00_2095))->
								BgL_approxz00);
						}
					}
					return (obj_t) (BgL_auxz00_1980);
				}
			}
		}
	}



/* node-setup!-pre-arit4547 */
	obj_t BGl_nodezd2setupz12zd2prezd2arit4547zc0zzcfa_arithmeticz00(obj_t
		BgL_envz00_1849, obj_t BgL_nodez00_1850)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 96 */
			{
				BgL_prezd2arithmeticzd2appz00_bglt BgL_nodez00_1569;

				{	/* Cfa/arithmetic.scm 99 */
					BgL_appz00_bglt BgL_auxz00_2102;

					BgL_nodez00_1569 =
						(BgL_prezd2arithmeticzd2appz00_bglt) (BgL_nodez00_1850);
					{	/* Cfa/arithmetic.scm 107 */
						BgL_variablez00_bglt BgL_fz00_1574;

						{	/* Cfa/arithmetic.scm 107 */
							BgL_varz00_bglt BgL_obj1972z00_1752;

							{
								BgL_appz00_bglt BgL_auxz00_2103;

								BgL_auxz00_2103 = (BgL_appz00_bglt) (BgL_nodez00_1569);
								BgL_obj1972z00_1752 =
									(((BgL_appz00_bglt) CREF(BgL_auxz00_2103))->BgL_funz00);
							}
							BgL_fz00_1574 =
								(((BgL_varz00_bglt) CREF(BgL_obj1972z00_1752))->
								BgL_variablez00);
						}
						{	/* Cfa/arithmetic.scm 107 */
							BgL_valuez00_bglt BgL_valz00_1575;

							BgL_valz00_1575 =
								(((BgL_variablez00_bglt) CREF(BgL_fz00_1574))->BgL_valuez00);
							{	/* Cfa/arithmetic.scm 108 */

								{	/* Cfa/arithmetic.scm 110 */
									bool_t BgL_testz00_2108;

									{	/* Cfa/arithmetic.scm 110 */
										BgL_typez00_bglt BgL_arg4673z00_1577;

										BgL_arg4673z00_1577 =
											(((BgL_variablez00_bglt) CREF(BgL_fz00_1574))->
											BgL_typez00);
										BgL_testz00_2108 =
											((obj_t) (BgL_arg4673z00_1577) ==
											BGl_za2objza2z00zztype_cachez00);
									}
									if (BgL_testz00_2108)
										{	/* Cfa/arithmetic.scm 110 */
											{
												BgL_typez00_bglt BgL_auxz00_2112;

												BgL_auxz00_2112 =
													(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00);
												((((BgL_variablez00_bglt) CREF(BgL_fz00_1574))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_auxz00_2112), BUNSPEC);
											}
											{
												BgL_typez00_bglt BgL_auxz00_2117;

												BgL_nodez00_bglt BgL_auxz00_2115;

												BgL_auxz00_2117 =
													(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00);
												BgL_auxz00_2115 = (BgL_nodez00_bglt) (BgL_nodez00_1569);
												((((BgL_nodez00_bglt) CREF(BgL_auxz00_2115))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_auxz00_2117), BUNSPEC);
											}
										}
									else
										{	/* Cfa/arithmetic.scm 110 */
											BFALSE;
										}
								}
								{	/* Cfa/arithmetic.scm 117 */
									bool_t BgL_testz00_2120;

									{	/* Cfa/arithmetic.scm 117 */
										obj_t BgL_obj1772z00_1759;

										BgL_obj1772z00_1759 = (obj_t) (BgL_valz00_1575);
										BgL_testz00_2120 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj1772z00_1759,
											BGl_sfunz00zzast_varz00);
									}
									if (BgL_testz00_2120)
										{	/* Cfa/arithmetic.scm 119 */
											obj_t BgL_arg4675z00_1579;

											{	/* Cfa/arithmetic.scm 119 */
												obj_t BgL_l4531z00_1580;

												{
													BgL_sfunz00_bglt BgL_auxz00_2123;

													BgL_auxz00_2123 =
														(BgL_sfunz00_bglt) (BgL_valz00_1575);
													BgL_l4531z00_1580 =
														(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2123))->
														BgL_argsz00);
												}
												if (NULLP(BgL_l4531z00_1580))
													{	/* Cfa/arithmetic.scm 119 */
														BgL_arg4675z00_1579 = BNIL;
													}
												else
													{	/* Cfa/arithmetic.scm 119 */
														obj_t BgL_head4533z00_1582;

														BgL_head4533z00_1582 =
															MAKE_PAIR
															(BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(CAR
																(BgL_l4531z00_1580)), BNIL);
														{	/* Cfa/arithmetic.scm 119 */
															obj_t BgL_g4536z00_1583;

															BgL_g4536z00_1583 = CDR(BgL_l4531z00_1580);
															{
																obj_t BgL_l4531z00_1584;

																obj_t BgL_tail4534z00_1585;

																BgL_l4531z00_1584 = BgL_g4536z00_1583;
																BgL_tail4534z00_1585 = BgL_head4533z00_1582;
															BgL_map4532z00_1586:
																if (NULLP(BgL_l4531z00_1584))
																	{	/* Cfa/arithmetic.scm 119 */
																		BgL_arg4675z00_1579 = BgL_head4533z00_1582;
																	}
																else
																	{	/* Cfa/arithmetic.scm 119 */
																		obj_t BgL_newtail4535z00_1588;

																		BgL_newtail4535z00_1588 =
																			MAKE_PAIR
																			(BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00
																			(CAR(BgL_l4531z00_1584)), BNIL);
																		SET_CDR(BgL_tail4534z00_1585,
																			BgL_newtail4535z00_1588);
																		{
																			obj_t BgL_tail4534z00_2140;

																			obj_t BgL_l4531z00_2138;

																			BgL_l4531z00_2138 =
																				CDR(BgL_l4531z00_1584);
																			BgL_tail4534z00_2140 =
																				BgL_newtail4535z00_1588;
																			BgL_tail4534z00_1585 =
																				BgL_tail4534z00_2140;
																			BgL_l4531z00_1584 = BgL_l4531z00_2138;
																			goto BgL_map4532z00_1586;
																		}
																	}
															}
														}
													}
											}
											{
												BgL_sfunz00_bglt BgL_auxz00_2141;

												BgL_auxz00_2141 = (BgL_sfunz00_bglt) (BgL_valz00_1575);
												((((BgL_sfunz00_bglt) CREF(BgL_auxz00_2141))->
														BgL_argsz00) =
													((obj_t) BgL_arg4675z00_1579), BUNSPEC);
											}
										}
									else
										{	/* Cfa/arithmetic.scm 120 */
											bool_t BgL_testz00_2144;

											{	/* Cfa/arithmetic.scm 120 */
												obj_t BgL_obj1836z00_1775;

												BgL_obj1836z00_1775 = (obj_t) (BgL_valz00_1575);
												BgL_testz00_2144 =
													BGl_iszd2azf3z21zz__objectz00(BgL_obj1836z00_1775,
													BGl_cfunz00zzast_varz00);
											}
											if (BgL_testz00_2144)
												{	/* Cfa/arithmetic.scm 121 */
													obj_t BgL_g4515z00_1597;

													{
														BgL_cfunz00_bglt BgL_auxz00_2147;

														BgL_auxz00_2147 =
															(BgL_cfunz00_bglt) (BgL_valz00_1575);
														BgL_g4515z00_1597 =
															(((BgL_cfunz00_bglt) CREF(BgL_auxz00_2147))->
															BgL_argszd2typezd2);
													}
													{
														obj_t BgL_lz00_1598;

														BgL_lz00_1598 = BgL_g4515z00_1597;
													BgL_loopz00_1599:
														if (PAIRP(BgL_lz00_1598))
															{	/* Cfa/arithmetic.scm 123 */
																obj_t BgL_auxz00_2152;

																BgL_auxz00_2152 =
																	BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00
																	(CAR(BgL_lz00_1598));
																SET_CAR(BgL_lz00_1598, BgL_auxz00_2152);
															}
														else
															{
																obj_t BgL_lz00_2156;

																BgL_lz00_2156 = CDR(BgL_lz00_1598);
																BgL_lz00_1598 = BgL_lz00_2156;
																goto BgL_loopz00_1599;
															}
													}
												}
											else
												{	/* Cfa/arithmetic.scm 120 */
													BGl_errorz00zz__errorz00
														(BGl_string4754z00zzcfa_arithmeticz00,
														BGl_string4755z00zzcfa_arithmeticz00,
														(obj_t) (BgL_nodez00_1569));
												}
										}
								}
								BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 =
									MAKE_PAIR(
									(obj_t) (BgL_nodez00_1569),
									BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00);
								{	/* Cfa/arithmetic.scm 129 */
									obj_t BgL_arg4690z00_1604;

									{
										BgL_appz00_bglt BgL_auxz00_2162;

										BgL_auxz00_2162 = (BgL_appz00_bglt) (BgL_nodez00_1569);
										BgL_arg4690z00_1604 =
											(((BgL_appz00_bglt) CREF(BgL_auxz00_2162))->BgL_argsz00);
									}
									BGl_nodezd2setupza2z12z62zzcfa_setupz00(BgL_arg4690z00_1604);
								}
								{	/* Cfa/arithmetic.scm 130 */
									obj_t BgL_speczd2typeszd2_1605;

									{
										obj_t BgL_auxz00_2166;

										{	/* Cfa/arithmetic.scm 130 */
											BgL_objectz00_bglt BgL_auxz00_2167;

											BgL_auxz00_2167 = (BgL_objectz00_bglt) (BgL_nodez00_1569);
											BgL_auxz00_2166 = BGL_OBJECT_WIDENING(BgL_auxz00_2167);
										}
										BgL_speczd2typeszd2_1605 =
											(((BgL_prezd2arithmeticzd2appz00_bglt)
												CREF(BgL_auxz00_2166))->BgL_speczd2typeszd2);
									}
									{	/* Cfa/arithmetic.scm 130 */
										BgL_prezd2arithmeticzd2appz00_bglt BgL_nodez00_1606;

										{	/* Cfa/arithmetic.scm 131 */
											long BgL_arg4697z00_1615;

											{	/* Cfa/arithmetic.scm 131 */
												obj_t BgL_arg4698z00_1616;

												{	/* Cfa/arithmetic.scm 131 */
													obj_t BgL_arg4699z00_1617;

													{	/* Cfa/arithmetic.scm 131 */
														BgL_objectz00_bglt BgL_objectz00_1784;

														BgL_objectz00_1784 =
															(BgL_objectz00_bglt) (BgL_nodez00_1569);
														{	/* Cfa/arithmetic.scm 131 */
															long BgL_arg2337z00_1785;

															{	/* Cfa/arithmetic.scm 131 */
																long BgL_arg2338z00_1786;

																BgL_arg2338z00_1786 =
																	BGL_OBJECT_CLASS_NUM(BgL_objectz00_1784);
																BgL_arg2337z00_1785 =
																	(BgL_arg2338z00_1786 - OBJECT_TYPE);
															}
															BgL_arg4699z00_1617 =
																VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
																(int) (BgL_arg2337z00_1785));
													}}
													BgL_arg4698z00_1616 =
														BGl_classzd2superzd2zz__objectz00
														(BgL_arg4699z00_1617);
												}
												BgL_arg4697z00_1615 =
													BGl_classzd2numzd2zz__objectz00(BgL_arg4698z00_1616);
											}
											BGL_OBJECT_CLASS_NUM_SET(
												(BgL_objectz00_bglt) (BgL_nodez00_1569),
												BgL_arg4697z00_1615);
										}
										{	/* Cfa/arithmetic.scm 131 */
											BgL_objectz00_bglt BgL_auxz00_2180;

											BgL_auxz00_2180 = (BgL_objectz00_bglt) (BgL_nodez00_1569);
											BGL_OBJECT_WIDENING_SET(BgL_auxz00_2180, BFALSE);
										}
										BgL_nodez00_1606 = BgL_nodez00_1569;
										{	/* Cfa/arithmetic.scm 131 */

											{	/* Cfa/arithmetic.scm 132 */
												BgL_appz00_bglt BgL_obj4517z00_1607;

												BgL_obj4517z00_1607 =
													((BgL_appz00_bglt)
													(BgL_appz00_bglt) (BgL_nodez00_1606));
												{	/* Cfa/arithmetic.scm 134 */
													obj_t BgL_arg4691z00_1608;

													{	/* Cfa/arithmetic.scm 134 */
														BgL_approxz00_bglt BgL_arg4692z00_1609;

														{	/* Cfa/arithmetic.scm 134 */
															bool_t BgL_testz00_2185;

															{	/* Cfa/arithmetic.scm 134 */
																BgL_typez00_bglt BgL_arg4695z00_1612;

																BgL_arg4695z00_1612 =
																	(((BgL_variablez00_bglt)
																		CREF(BgL_fz00_1574))->BgL_typez00);
																BgL_testz00_2185 =
																	((obj_t) (BgL_arg4695z00_1612) ==
																	BGl_za2_za2z00zztype_cachez00);
															}
															if (BgL_testz00_2185)
																{	/* Cfa/arithmetic.scm 134 */
																	BgL_arg4692z00_1609 =
																		BGl_makezd2emptyzd2approxz00zzcfa_approxz00
																		();
																}
															else
																{	/* Cfa/arithmetic.scm 136 */
																	BgL_typez00_bglt BgL_arg4694z00_1611;

																	BgL_arg4694z00_1611 =
																		(((BgL_variablez00_bglt)
																			CREF(BgL_fz00_1574))->BgL_typez00);
																	BgL_arg4692z00_1609 =
																		BGl_makezd2typezd2approxz00zzcfa_approxz00
																		(BgL_arg4694z00_1611);
																}
														}
														BgL_arg4691z00_1608 =
															BGl_wideningzd2arithmeticzd2appz00zzcfa_info2z00
															(BgL_arg4692z00_1609, BgL_speczd2typeszd2_1605);
													}
													{	/* Cfa/arithmetic.scm 132 */
														BgL_objectz00_bglt BgL_auxz00_2193;

														BgL_auxz00_2193 =
															(BgL_objectz00_bglt) (BgL_obj4517z00_1607);
														BGL_OBJECT_WIDENING_SET(BgL_auxz00_2193,
															BgL_arg4691z00_1608);
													}
												}
												BGL_OBJECT_CLASS_NUM_SET(
													(BgL_objectz00_bglt) (BgL_obj4517z00_1607),
													BGl_classzd2numzd2zz__objectz00
													(BGl_arithmeticzd2appzd2zzcfa_info2z00));
												BgL_auxz00_2102 = BgL_obj4517z00_1607;
											}
										}
									}
								}
							}
						}
					}
					return (obj_t) (BgL_auxz00_2102);
				}
			}
		}
	}



/* unspecified-type */
	obj_t BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(obj_t BgL_lz00_1619)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 105 */
			if (BGl_iszd2azf3z21zz__objectz00(BgL_lz00_1619,
					BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 99 */
					return BGl_za2_za2z00zztype_cachez00;
				}
			else
				{	/* Cfa/arithmetic.scm 99 */
					if (BGl_iszd2azf3z21zz__objectz00(BgL_lz00_1619,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 101 */
							{
								BgL_typez00_bglt BgL_auxz00_2207;

								BgL_variablez00_bglt BgL_auxz00_2205;

								BgL_auxz00_2207 =
									(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00);
								BgL_auxz00_2205 = (BgL_variablez00_bglt) (BgL_lz00_1619);
								((((BgL_variablez00_bglt) CREF(BgL_auxz00_2205))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_2207), BUNSPEC);
							}
							return BgL_lz00_1619;
						}
					else
						{	/* Cfa/arithmetic.scm 101 */
							return BgL_lz00_1619;
						}
				}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 243010053),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_loosez00(((long) 235614963),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_iteratez00(((long) 326518176),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_cfaz00(((long) 42139303),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_setupz00(((long) 212645849),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_approxz00(((long) 535144917),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
			return
				BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long) 249450490),
				BSTRING_TO_STRING(BGl_string4756z00zzcfa_arithmeticz00));
		}
	}

#ifdef __cplusplus
}
#endif
