/*===========================================================================*/
/*   (Coerce/convert.scm)                                                    */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/convert.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;


	extern obj_t BGl_nodez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt,
		BgL_typez00_bglt, obj_t, BgL_nodez00_bglt);
	static BgL_nodez00_bglt
		BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt);
	static obj_t BGl_cnstzd2initzd2zzcoerce_convertz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt, BgL_typez00_bglt,
		BgL_typez00_bglt, bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_spreadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_lvtypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_coercionz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00();
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_dozd2convertzd2zzcoerce_convertz00(obj_t, obj_t,
		BgL_typez00_bglt);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl__convertz12z12zzcoerce_convertz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern bool_t BGl_subzd2typezf3z21zztype_envz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_nodez00_bglt);
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	extern obj_t BGl_userzd2warningzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcoerce_convertz00();
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	extern bool_t
		BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00(BgL_nodez00_bglt);
	extern BgL_castz00_bglt BGl_makezd2castzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_convertz00 = BUNSPEC;
	extern obj_t BGl_tclassz00zzobject_classz00;
	static obj_t BGl_genericzd2initzd2zzcoerce_convertz00();
	extern BgL_typez00_bglt
		BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_typez00_bglt);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	static obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t,
		BgL_typez00_bglt, BgL_typez00_bglt, obj_t, obj_t, obj_t, bool_t);
	extern obj_t BGl_findzd2coercerzd2zztype_coercionz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
	static BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t,
		BgL_typez00_bglt, BgL_typez00_bglt, obj_t, obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt,
		obj_t, BgL_typez00_bglt, bool_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	static obj_t BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(obj_t,
		BgL_typez00_bglt, BgL_typez00_bglt, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t string_to_symbol(char *);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_IMPORT obj_t BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t __cnst[15];


	   
		 
		DEFINE_STRING(BGl_string3748z00zzcoerce_convertz00,
		BgL_bgl_string3748za700za7za7c3757za7, "Type error", 10);
	      DEFINE_STRING(BGl_string3750z00zzcoerce_convertz00,
		BgL_bgl_string3750za700za7za7c3758za7, "Illegal conversion", 18);
	      DEFINE_STRING(BGl_string3749z00zzcoerce_convertz00,
		BgL_bgl_string3749za700za7za7c3759za7, "", 0);
	      DEFINE_STRING(BGl_string3751z00zzcoerce_convertz00,
		BgL_bgl_string3751za700za7za7c3760za7, "do-convert", 10);
	      DEFINE_STRING(BGl_string3752z00zzcoerce_convertz00,
		BgL_bgl_string3752za700za7za7c3761za7, "Illegal converter", 17);
	      DEFINE_STRING(BGl_string3753z00zzcoerce_convertz00,
		BgL_bgl_string3753za700za7za7c3762za7, "coerce_convert", 14);
	      DEFINE_STRING(BGl_string3754z00zzcoerce_convertz00,
		BgL_bgl_string3754za700za7za7c3763za7,
		"aux2 if coercer bigloo-type-error failure quote bigloo-type-error/location __error @ begin location bdb ::obj let aux ",
		118);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_convertz12zd2envzc0zzcoerce_convertz00,
		BgL_bgl__convertza712za712za7za73764z00,
		BGl__convertz12z12zzcoerce_convertz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_runtimezd2typezd2errorzd2envzd2zzcoerce_convertz00,
		BgL_bgl__runtimeza7d2typeza73765z00,
		BGl__runtimezd2typezd2errorz00zzcoerce_convertz00, 0L, BUNSPEC, 3);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long
		BgL_checksumz00_1815, char *BgL_fromz00_1816)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_convertz00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_convertz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00();
					BGl_cnstzd2initzd2zzcoerce_convertz00();
					BGl_importedzd2moduleszd2initz00zzcoerce_convertz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"coerce_convert");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"coerce_convert");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			{	/* Coerce/convert.scm 16 */
				obj_t BgL_cportz00_1807;

				BgL_cportz00_1807 =
					bgl_open_input_string(BGl_string3754z00zzcoerce_convertz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1808;

					BgL_iz00_1808 = ((long) 14);
				BgL_loopz00_1809:
					if ((BgL_iz00_1808 == ((long) -1)))
						{	/* Coerce/convert.scm 16 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/convert.scm 16 */
							{	/* Coerce/convert.scm 16 */
								obj_t BgL_arg3756z00_1811;

								{	/* Coerce/convert.scm 16 */

									{	/* Coerce/convert.scm 16 */
										obj_t BgL_locationz00_1813;

										BgL_locationz00_1813 = BBOOL(((bool_t) 0));
										{	/* Coerce/convert.scm 16 */

											BgL_arg3756z00_1811 =
												BGl_readz00zz__readerz00(BgL_cportz00_1807,
												BgL_locationz00_1813);
										}
									}
								}
								{	/* Coerce/convert.scm 16 */
									int BgL_auxz00_1835;

									BgL_auxz00_1835 = (int) (BgL_iz00_1808);
									CNST_TABLE_SET(BgL_auxz00_1835, BgL_arg3756z00_1811);
							}}
							{	/* Coerce/convert.scm 16 */
								int BgL_auxz00_1814;

								BgL_auxz00_1814 = (int) ((BgL_iz00_1808 - ((long) 1)));
								{
									long BgL_iz00_1840;

									BgL_iz00_1840 = (long) (BgL_auxz00_1814);
									BgL_iz00_1808 = BgL_iz00_1840;
									goto BgL_loopz00_1809;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}
	}



/* runtime-type-error */
	BGL_EXPORTED_DEF obj_t BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t
		BgL_locz00_41, obj_t BgL_tiz00_42, obj_t BgL_valuez00_43)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 69 */
			{

				if (BGl_iszd2azf3z21zz__objectz00(BgL_valuez00_43,
						BGl_nodez00zzast_nodez00))
					{	/* Coerce/convert.scm 104 */
						BgL_nodez00_bglt BgL_auxz00_1844;

						{	/* Coerce/convert.scm 95 */
							obj_t BgL_auxz00_963;

							BgL_auxz00_963 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 0)));
							{	/* Coerce/convert.scm 95 */
								BgL_nodez00_bglt BgL_resz00_964;

								{	/* Coerce/convert.scm 97 */
									obj_t BgL_arg3446z00_967;

									{	/* Coerce/convert.scm 97 */
										obj_t BgL_arg3447z00_968;

										obj_t BgL_arg3448z00_969;

										BgL_arg3447z00_968 = CNST_TABLE_REF(((long) 1));
										{	/* Coerce/convert.scm 97 */
											obj_t BgL_arg3449z00_970;

											obj_t BgL_arg3450z00_971;

											{	/* Coerce/convert.scm 97 */
												obj_t BgL_arg3454z00_975;

												{	/* Coerce/convert.scm 97 */
													obj_t BgL_arg3456z00_977;

													obj_t BgL_arg3457z00_978;

													{	/* Coerce/convert.scm 97 */
														obj_t BgL_arg3458z00_979;

														{	/* Coerce/convert.scm 97 */
															obj_t BgL_arg3459z00_980;

															{	/* Coerce/convert.scm 97 */
																obj_t BgL_arg3460z00_981;

																obj_t BgL_arg3461z00_982;

																BgL_arg3460z00_981 =
																	SYMBOL_TO_STRING(BgL_auxz00_963);
																{	/* Coerce/convert.scm 97 */
																	obj_t BgL_symbolz00_1658;

																	BgL_symbolz00_1658 =
																		CNST_TABLE_REF(((long) 2));
																	BgL_arg3461z00_982 =
																		SYMBOL_TO_STRING(BgL_symbolz00_1658);
																}
																{	/* Coerce/convert.scm 97 */
																	obj_t BgL_list3462z00_983;

																	{	/* Coerce/convert.scm 97 */
																		obj_t BgL_arg3463z00_984;

																		BgL_arg3463z00_984 =
																			MAKE_PAIR(BgL_arg3461z00_982, BNIL);
																		BgL_list3462z00_983 =
																			MAKE_PAIR(BgL_arg3460z00_981,
																			BgL_arg3463z00_984);
																	}
																	BgL_arg3459z00_980 =
																		BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																		(BgL_list3462z00_983);
															}}
															BgL_arg3458z00_979 =
																string_to_symbol(BSTRING_TO_STRING
																(BgL_arg3459z00_980));
														}
														BgL_arg3456z00_977 =
															BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
															(BgL_arg3458z00_979);
													}
													{	/* Coerce/convert.scm 97 */
														obj_t BgL_list3464z00_985;

														BgL_list3464z00_985 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3457z00_978 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BUNSPEC, BgL_list3464z00_985);
													}
													BgL_arg3454z00_975 =
														MAKE_PAIR(BgL_arg3456z00_977, BgL_arg3457z00_978);
												}
												BgL_arg3449z00_970 =
													MAKE_PAIR(BgL_arg3454z00_975, BNIL);
											}
											BgL_arg3450z00_971 =
												BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
												(BgL_tiz00_42, BgL_locz00_41, BgL_auxz00_963);
											{	/* Coerce/convert.scm 97 */
												obj_t BgL_list3452z00_973;

												{	/* Coerce/convert.scm 97 */
													obj_t BgL_arg3453z00_974;

													BgL_arg3453z00_974 = MAKE_PAIR(BNIL, BNIL);
													BgL_list3452z00_973 =
														MAKE_PAIR(BgL_arg3450z00_971, BgL_arg3453z00_974);
												}
												BgL_arg3448z00_969 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3449z00_970, BgL_list3452z00_973);
										}}
										BgL_arg3446z00_967 =
											MAKE_PAIR(BgL_arg3447z00_968, BgL_arg3448z00_969);
									}
									BgL_resz00_964 =
										BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
										(BgL_arg3446z00_967, BgL_locz00_41);
								}
								{	/* Coerce/convert.scm 96 */

									{	/* Coerce/convert.scm 101 */
										obj_t BgL_arg3444z00_965;

										{	/* Coerce/convert.scm 101 */
											obj_t BgL_pairz00_1661;

											{
												BgL_letzd2varzd2_bglt BgL_auxz00_1867;

												BgL_auxz00_1867 =
													(BgL_letzd2varzd2_bglt) (BgL_resz00_964);
												BgL_pairz00_1661 =
													(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_1867))->
													BgL_bindingsz00);
											}
											BgL_arg3444z00_965 = CAR(BgL_pairz00_1661);
										}
										SET_CDR(BgL_arg3444z00_965, BgL_valuez00_43);
									}
									BgL_auxz00_1844 = BgL_resz00_964;
						}}}
						return (obj_t) (BgL_auxz00_1844);
					}
				else
					{	/* Coerce/convert.scm 103 */
						return
							BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00
							(BgL_tiz00_42, BgL_locz00_41, BgL_valuez00_43);
					}
			}
		}
	}



/* runtime-type-error/id */
	obj_t BGl_runtimezd2typezd2errorzf2idzf2zzcoerce_convertz00(obj_t
		BgL_tiz00_1804, obj_t BgL_locz00_1803, obj_t BgL_idz00_986)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 73 */
			{	/* Coerce/convert.scm 74 */
				bool_t BgL_testz00_1874;

				{	/* Coerce/convert.scm 74 */
					bool_t BgL_testz00_1875;

					{	/* Coerce/convert.scm 74 */
						bool_t BgL_testz00_1876;

						if (
							((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >
								((long) 0)))
							{	/* Coerce/convert.scm 75 */
								obj_t BgL_arg3538z00_1056;

								obj_t BgL_arg3539z00_1057;

								BgL_arg3538z00_1056 = CNST_TABLE_REF(((long) 3));
								{	/* Coerce/convert.scm 75 */
									obj_t BgL_arg3540z00_1058;

									BgL_arg3540z00_1058 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									{
										BgL_backendz00_bglt BgL_auxz00_1882;

										BgL_auxz00_1882 =
											(BgL_backendz00_bglt) (BgL_arg3540z00_1058);
										BgL_arg3539z00_1057 =
											(((BgL_backendz00_bglt) CREF(BgL_auxz00_1882))->
											BgL_debugzd2supportzd2);
								}}
								BgL_testz00_1876 =
									CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
									(BgL_arg3538z00_1056, BgL_arg3539z00_1057));
							}
						else
							{	/* Coerce/convert.scm 74 */
								BgL_testz00_1876 = ((bool_t) 0);
							}
						if (BgL_testz00_1876)
							{	/* Coerce/convert.scm 74 */
								BgL_testz00_1875 = ((bool_t) 1);
							}
						else
							{	/* Coerce/convert.scm 74 */
								BgL_testz00_1875 =
									(
									(long) CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >
									((long) 0));
					}}
					if (BgL_testz00_1875)
						{	/* Coerce/convert.scm 74 */
							if (STRUCTP(BgL_locz00_1803))
								{	/* Coerce/convert.scm 77 */
									BgL_testz00_1874 =
										(STRUCT_KEY(BgL_locz00_1803) == CNST_TABLE_REF(((long) 4)));
								}
							else
								{	/* Coerce/convert.scm 77 */
									BgL_testz00_1874 = ((bool_t) 0);
								}
						}
					else
						{	/* Coerce/convert.scm 74 */
							BgL_testz00_1874 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_1874)
					{	/* Coerce/convert.scm 78 */
						obj_t BgL_arg3467z00_989;

						obj_t BgL_arg3468z00_990;

						BgL_arg3467z00_989 = CNST_TABLE_REF(((long) 5));
						{	/* Coerce/convert.scm 79 */
							obj_t BgL_arg3469z00_991;

							obj_t BgL_arg3470z00_992;

							{	/* Coerce/convert.scm 79 */
								obj_t BgL_arg3474z00_996;

								obj_t BgL_arg3475z00_997;

								{	/* Coerce/convert.scm 79 */
									obj_t BgL_arg3476z00_998;

									obj_t BgL_arg3477z00_999;

									BgL_arg3476z00_998 = CNST_TABLE_REF(((long) 6));
									{	/* Coerce/convert.scm 79 */
										obj_t BgL_list3478z00_1000;

										{	/* Coerce/convert.scm 79 */
											obj_t BgL_arg3479z00_1001;

											obj_t BgL_arg3480z00_1002;

											BgL_arg3479z00_1001 = CNST_TABLE_REF(((long) 7));
											BgL_arg3480z00_1002 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3478z00_1000 =
												MAKE_PAIR(BgL_arg3479z00_1001, BgL_arg3480z00_1002);
										}
										BgL_arg3477z00_999 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(CNST_TABLE_REF
											(((long) 8)), BgL_list3478z00_1000);
									}
									BgL_arg3474z00_996 =
										MAKE_PAIR(BgL_arg3476z00_998, BgL_arg3477z00_999);
								}
								{	/* Coerce/convert.scm 79 */
									obj_t BgL_arg3481z00_1003;

									obj_t BgL_arg3482z00_1004;

									obj_t BgL_arg3483z00_1005;

									obj_t BgL_arg3484z00_1006;

									{	/* Coerce/convert.scm 79 */
										obj_t BgL_arg3492z00_1013;

										obj_t BgL_arg3493z00_1014;

										BgL_arg3492z00_1013 = CNST_TABLE_REF(((long) 9));
										{	/* Coerce/convert.scm 79 */
											obj_t BgL_arg3494z00_1015;

											BgL_arg3494z00_1015 =
												BGl_currentzd2functionzd2zztools_errorz00();
											{	/* Coerce/convert.scm 79 */
												obj_t BgL_list3496z00_1017;

												BgL_list3496z00_1017 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3493z00_1014 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3494z00_1015, BgL_list3496z00_1017);
										}}
										BgL_arg3481z00_1003 =
											MAKE_PAIR(BgL_arg3492z00_1013, BgL_arg3493z00_1014);
									}
									BgL_arg3482z00_1004 = SYMBOL_TO_STRING(BgL_tiz00_1804);
									BgL_arg3483z00_1005 =
										BGl_locationzd2fullzd2fnamez00zztools_locationz00
										(BgL_locz00_1803);
									BgL_arg3484z00_1006 =
										STRUCT_REF(BgL_locz00_1803, (int) (((long) 1)));
									{	/* Coerce/convert.scm 79 */
										obj_t BgL_list3486z00_1008;

										{	/* Coerce/convert.scm 79 */
											obj_t BgL_arg3488z00_1009;

											{	/* Coerce/convert.scm 79 */
												obj_t BgL_arg3489z00_1010;

												{	/* Coerce/convert.scm 79 */
													obj_t BgL_arg3490z00_1011;

													{	/* Coerce/convert.scm 79 */
														obj_t BgL_arg3491z00_1012;

														BgL_arg3491z00_1012 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3490z00_1011 =
															MAKE_PAIR(BgL_arg3484z00_1006,
															BgL_arg3491z00_1012);
													}
													BgL_arg3489z00_1010 =
														MAKE_PAIR(BgL_arg3483z00_1005, BgL_arg3490z00_1011);
												}
												BgL_arg3488z00_1009 =
													MAKE_PAIR(BgL_idz00_986, BgL_arg3489z00_1010);
											}
											BgL_list3486z00_1008 =
												MAKE_PAIR(BgL_arg3482z00_1004, BgL_arg3488z00_1009);
										}
										BgL_arg3475z00_997 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3481z00_1003, BgL_list3486z00_1008);
								}}
								BgL_arg3469z00_991 =
									MAKE_PAIR(BgL_arg3474z00_996, BgL_arg3475z00_997);
							}
							{	/* Coerce/convert.scm 87 */
								obj_t BgL_arg3499z00_1018;

								obj_t BgL_arg3500z00_1019;

								BgL_arg3499z00_1018 = CNST_TABLE_REF(((long) 10));
								{	/* Coerce/convert.scm 87 */
									obj_t BgL_list3501z00_1020;

									{	/* Coerce/convert.scm 87 */
										obj_t BgL_arg3502z00_1021;

										{	/* Coerce/convert.scm 87 */
											obj_t BgL_arg3503z00_1022;

											BgL_arg3503z00_1022 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg3502z00_1021 =
												MAKE_PAIR(BFALSE, BgL_arg3503z00_1022);
										}
										BgL_list3501z00_1020 =
											MAKE_PAIR(BFALSE, BgL_arg3502z00_1021);
									}
									BgL_arg3500z00_1019 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BFALSE,
										BgL_list3501z00_1020);
								}
								BgL_arg3470z00_992 =
									MAKE_PAIR(BgL_arg3499z00_1018, BgL_arg3500z00_1019);
							}
							{	/* Coerce/convert.scm 78 */
								obj_t BgL_list3472z00_994;

								{	/* Coerce/convert.scm 78 */
									obj_t BgL_arg3473z00_995;

									BgL_arg3473z00_995 = MAKE_PAIR(BNIL, BNIL);
									BgL_list3472z00_994 =
										MAKE_PAIR(BgL_arg3470z00_992, BgL_arg3473z00_995);
								}
								BgL_arg3468z00_990 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
									(BgL_arg3469z00_991, BgL_list3472z00_994);
						}}
						return MAKE_PAIR(BgL_arg3467z00_989, BgL_arg3468z00_990);
					}
				else
					{	/* Coerce/convert.scm 88 */
						obj_t BgL_arg3504z00_1023;

						obj_t BgL_arg3505z00_1024;

						BgL_arg3504z00_1023 = CNST_TABLE_REF(((long) 5));
						{	/* Coerce/convert.scm 89 */
							obj_t BgL_arg3506z00_1025;

							obj_t BgL_arg3507z00_1026;

							{	/* Coerce/convert.scm 89 */
								obj_t BgL_arg3512z00_1030;

								obj_t BgL_arg3513z00_1031;

								{	/* Coerce/convert.scm 89 */
									obj_t BgL_arg3514z00_1032;

									obj_t BgL_arg3515z00_1033;

									BgL_arg3514z00_1032 = CNST_TABLE_REF(((long) 6));
									{	/* Coerce/convert.scm 89 */
										obj_t BgL_list3516z00_1034;

										{	/* Coerce/convert.scm 89 */
											obj_t BgL_arg3517z00_1035;

											obj_t BgL_arg3518z00_1036;

											BgL_arg3517z00_1035 = CNST_TABLE_REF(((long) 7));
											BgL_arg3518z00_1036 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3516z00_1034 =
												MAKE_PAIR(BgL_arg3517z00_1035, BgL_arg3518z00_1036);
										}
										BgL_arg3515z00_1033 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(CNST_TABLE_REF
											(((long) 11)), BgL_list3516z00_1034);
									}
									BgL_arg3512z00_1030 =
										MAKE_PAIR(BgL_arg3514z00_1032, BgL_arg3515z00_1033);
								}
								{	/* Coerce/convert.scm 89 */
									obj_t BgL_arg3519z00_1037;

									obj_t BgL_arg3520z00_1038;

									{	/* Coerce/convert.scm 89 */
										obj_t BgL_arg3525z00_1043;

										obj_t BgL_arg3526z00_1044;

										BgL_arg3525z00_1043 = CNST_TABLE_REF(((long) 9));
										{	/* Coerce/convert.scm 89 */
											obj_t BgL_arg3527z00_1045;

											BgL_arg3527z00_1045 =
												BGl_currentzd2functionzd2zztools_errorz00();
											{	/* Coerce/convert.scm 89 */
												obj_t BgL_list3529z00_1047;

												BgL_list3529z00_1047 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3526z00_1044 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3527z00_1045, BgL_list3529z00_1047);
										}}
										BgL_arg3519z00_1037 =
											MAKE_PAIR(BgL_arg3525z00_1043, BgL_arg3526z00_1044);
									}
									BgL_arg3520z00_1038 = SYMBOL_TO_STRING(BgL_tiz00_1804);
									{	/* Coerce/convert.scm 89 */
										obj_t BgL_list3522z00_1040;

										{	/* Coerce/convert.scm 89 */
											obj_t BgL_arg3523z00_1041;

											{	/* Coerce/convert.scm 89 */
												obj_t BgL_arg3524z00_1042;

												BgL_arg3524z00_1042 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3523z00_1041 =
													MAKE_PAIR(BgL_idz00_986, BgL_arg3524z00_1042);
											}
											BgL_list3522z00_1040 =
												MAKE_PAIR(BgL_arg3520z00_1038, BgL_arg3523z00_1041);
										}
										BgL_arg3513z00_1031 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3519z00_1037, BgL_list3522z00_1040);
								}}
								BgL_arg3506z00_1025 =
									MAKE_PAIR(BgL_arg3512z00_1030, BgL_arg3513z00_1031);
							}
							{	/* Coerce/convert.scm 92 */
								obj_t BgL_arg3530z00_1048;

								obj_t BgL_arg3531z00_1049;

								BgL_arg3530z00_1048 = CNST_TABLE_REF(((long) 10));
								{	/* Coerce/convert.scm 92 */
									obj_t BgL_list3532z00_1050;

									{	/* Coerce/convert.scm 92 */
										obj_t BgL_arg3533z00_1051;

										{	/* Coerce/convert.scm 92 */
											obj_t BgL_arg3534z00_1052;

											BgL_arg3534z00_1052 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg3533z00_1051 =
												MAKE_PAIR(BFALSE, BgL_arg3534z00_1052);
										}
										BgL_list3532z00_1050 =
											MAKE_PAIR(BFALSE, BgL_arg3533z00_1051);
									}
									BgL_arg3531z00_1049 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BFALSE,
										BgL_list3532z00_1050);
								}
								BgL_arg3507z00_1026 =
									MAKE_PAIR(BgL_arg3530z00_1048, BgL_arg3531z00_1049);
							}
							{	/* Coerce/convert.scm 88 */
								obj_t BgL_list3510z00_1028;

								{	/* Coerce/convert.scm 88 */
									obj_t BgL_arg3511z00_1029;

									BgL_arg3511z00_1029 = MAKE_PAIR(BNIL, BNIL);
									BgL_list3510z00_1028 =
										MAKE_PAIR(BgL_arg3507z00_1026, BgL_arg3511z00_1029);
								}
								BgL_arg3505z00_1024 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
									(BgL_arg3506z00_1025, BgL_list3510z00_1028);
						}}
						return MAKE_PAIR(BgL_arg3504z00_1023, BgL_arg3505z00_1024);
					}
			}
		}
	}



/* _runtime-type-error */
	obj_t BGl__runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t BgL_envz00_1794,
		obj_t BgL_locz00_1795, obj_t BgL_tiz00_1796, obj_t BgL_valuez00_1797)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 69 */
			return
				BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(BgL_locz00_1795,
				BgL_tiz00_1796, BgL_valuez00_1797);
		}
	}



/* convert-error */
	obj_t BGl_convertzd2errorzd2zzcoerce_convertz00(BgL_typez00_bglt
		BgL_fromz00_44, BgL_typez00_bglt BgL_toz00_45, obj_t BgL_locz00_46,
		BgL_nodez00_bglt BgL_nodez00_47)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 114 */
			{	/* Coerce/convert.scm 117 */
				bool_t BgL_testz00_1958;

				if (((obj_t) (BgL_toz00_45) == BGl_za2objza2z00zztype_cachez00))
					{	/* Coerce/convert.scm 117 */
						BgL_testz00_1958 = ((bool_t) 0);
					}
				else
					{	/* Coerce/convert.scm 117 */
						BgL_testz00_1958 =
							BGl_subzd2typezf3z21zztype_envz00(BgL_toz00_45,
							(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00));
					}
				if (BgL_testz00_1958)
					{	/* Coerce/convert.scm 117 */
						{	/* Coerce/convert.scm 119 */
							obj_t BgL_arg3542z00_1062;

							BgL_arg3542z00_1062 = BGl_currentzd2functionzd2zztools_errorz00();
							BGl_userzd2warningzf2locationz20zztools_errorz00(BgL_locz00_46,
								BgL_arg3542z00_1062, BGl_string3748z00zzcoerce_convertz00,
								BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
								(BGl_string3749z00zzcoerce_convertz00,
									BGl_shapez00zztools_shapez00((obj_t) (BgL_toz00_45)),
									BGl_shapez00zztools_shapez00((obj_t) (BgL_fromz00_44))));
						}
						{	/* Coerce/convert.scm 120 */
							obj_t BgL_arg3543z00_1063;

							{	/* Coerce/convert.scm 120 */
								obj_t BgL_arg3544z00_1064;

								BgL_arg3544z00_1064 =
									(((BgL_typez00_bglt) CREF(BgL_toz00_45))->BgL_idz00);
								BgL_arg3543z00_1063 =
									BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
									(BgL_locz00_46, BgL_arg3544z00_1064,
									(obj_t) (BgL_nodez00_47));
							}
							return
								(obj_t) (BGl_coercez12z12zzcoerce_coercez00(
									(BgL_nodez00_bglt) (BgL_arg3543z00_1063), BUNSPEC,
									BgL_fromz00_44, ((bool_t) 0)));
						}
					}
				else
					{	/* Coerce/convert.scm 124 */
						obj_t BgL_arg3545z00_1065;

						BgL_arg3545z00_1065 = BGl_currentzd2functionzd2zztools_errorz00();
						return
							BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_46,
							BgL_arg3545z00_1065, BGl_string3748z00zzcoerce_convertz00,
							BGl_bigloozd2typezd2errorzd2msgzd2zz__errorz00
							(BGl_string3749z00zzcoerce_convertz00,
								BGl_shapez00zztools_shapez00((obj_t) (BgL_toz00_45)),
								BGl_shapez00zztools_shapez00((obj_t) (BgL_fromz00_44))), BNIL);
					}
			}
		}
	}



/* convert! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt BgL_nodez00_48,
		BgL_typez00_bglt BgL_fromz00_49, BgL_typez00_bglt BgL_toz00_50,
		bool_t BgL_safez00_51)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 132 */
			{	/* Coerce/convert.scm 136 */
				BgL_typez00_bglt BgL_toz00_1067;

				BgL_typez00_bglt BgL_fromz00_1068;

				BgL_toz00_1067 =
					BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_toz00_50);
				BgL_fromz00_1068 =
					BGl_getzd2aliasedzd2typez00zztype_typez00(BgL_fromz00_49);
				{	/* Coerce/convert.scm 138 */
					bool_t BgL_testz00_1986;

					if (((obj_t) (BgL_fromz00_1068) == (obj_t) (BgL_toz00_1067)))
						{	/* Coerce/convert.scm 138 */
							BgL_testz00_1986 = ((bool_t) 1);
						}
					else
						{	/* Coerce/convert.scm 138 */
							BgL_testz00_1986 =
								(((BgL_typez00_bglt) CREF(BgL_fromz00_1068))->BgL_magiczf3zf3);
						}
					if (BgL_testz00_1986)
						{	/* Coerce/convert.scm 138 */
							return BgL_nodez00_48;
						}
					else
						{	/* Coerce/convert.scm 140 */
							obj_t BgL_coercerz00_1070;

							obj_t BgL_locz00_1071;

							BgL_coercerz00_1070 =
								BGl_findzd2coercerzd2zztype_coercionz00(BgL_fromz00_1068,
								BgL_toz00_1067);
							BgL_locz00_1071 =
								(((BgL_nodez00_bglt) CREF(BgL_nodez00_48))->BgL_locz00);
							{	/* Coerce/convert.scm 142 */
								bool_t BgL_testz00_1994;

								if (STRUCTP(BgL_coercerz00_1070))
									{	/* Coerce/convert.scm 142 */
										BgL_testz00_1994 =
											(STRUCT_KEY(BgL_coercerz00_1070) ==
											CNST_TABLE_REF(((long) 12)));
									}
								else
									{	/* Coerce/convert.scm 142 */
										BgL_testz00_1994 = ((bool_t) 0);
									}
								if (BgL_testz00_1994)
									{	/* Coerce/convert.scm 146 */
										obj_t BgL_checksz00_1073;

										obj_t BgL_coercesz00_1074;

										BgL_checksz00_1073 =
											STRUCT_REF(BgL_coercerz00_1070, (int) (((long) 2)));
										BgL_coercesz00_1074 =
											STRUCT_REF(BgL_coercerz00_1070, (int) (((long) 3)));
										{
											obj_t BgL_checksz00_1075;

											obj_t BgL_coercesz00_1076;

											obj_t BgL_nodez00_1077;

											{	/* Coerce/convert.scm 151 */
												obj_t BgL_auxz00_2004;

												BgL_checksz00_1075 = BgL_checksz00_1073;
												BgL_coercesz00_1076 = BgL_coercesz00_1074;
												BgL_nodez00_1077 = (obj_t) (BgL_nodez00_48);
											BgL_loopz00_1078:
												if (NULLP(BgL_checksz00_1075))
													{	/* Coerce/convert.scm 155 */
														if (NULLP(BgL_coercesz00_1076))
															{	/* Coerce/convert.scm 156 */
																BgL_auxz00_2004 = BgL_nodez00_1077;
															}
														else
															{	/* Coerce/convert.scm 156 */
																BgL_auxz00_2004 =
																	BGl_internalzd2errorzd2zztools_errorz00
																	(BGl_string3750z00zzcoerce_convertz00,
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_fromz00_1068)),
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_toz00_1067)));
															}
													}
												else
													{	/* Coerce/convert.scm 155 */
														if (NULLP(BgL_coercesz00_1076))
															{	/* Coerce/convert.scm 161 */
																BgL_auxz00_2004 =
																	BGl_internalzd2errorzd2zztools_errorz00
																	(BGl_string3750z00zzcoerce_convertz00,
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_fromz00_1068)),
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_toz00_1067)));
															}
														else
															{
																obj_t BgL_nodez00_2025;

																obj_t BgL_coercesz00_2023;

																obj_t BgL_checksz00_2021;

																BgL_checksz00_2021 = CDR(BgL_checksz00_1075);
																BgL_coercesz00_2023 = CDR(BgL_coercesz00_1076);
																BgL_nodez00_2025 =
																	BGl_makezd2onezd2conversionz00zzcoerce_convertz00
																	(CAR(BgL_checksz00_1075), BgL_fromz00_1068,
																	BgL_toz00_1067, CAR(BgL_checksz00_1075),
																	CAR(BgL_coercesz00_1076), BgL_nodez00_1077,
																	BgL_safez00_51);
																BgL_nodez00_1077 = BgL_nodez00_2025;
																BgL_coercesz00_1076 = BgL_coercesz00_2023;
																BgL_checksz00_1075 = BgL_checksz00_2021;
																goto BgL_loopz00_1078;
															}
													}
												return (BgL_nodez00_bglt) (BgL_auxz00_2004);
											}
										}
									}
								else
									{	/* Coerce/convert.scm 142 */
										return
											(BgL_nodez00_bglt)
											(BGl_convertzd2errorzd2zzcoerce_convertz00
											(BgL_fromz00_1068, BgL_toz00_1067, BgL_locz00_1071,
												BgL_nodez00_48));
									}
							}
						}
				}
			}
		}
	}



/* _convert! */
	obj_t BGl__convertz12z12zzcoerce_convertz00(obj_t BgL_envz00_1798,
		obj_t BgL_nodez00_1799, obj_t BgL_fromz00_1800, obj_t BgL_toz00_1801,
		obj_t BgL_safez00_1802)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 132 */
			return
				(obj_t) (BGl_convertz12z12zzcoerce_convertz00(
					(BgL_nodez00_bglt) (BgL_nodez00_1799),
					(BgL_typez00_bglt) (BgL_fromz00_1800),
					(BgL_typez00_bglt) (BgL_toz00_1801), CBOOL(BgL_safez00_1802)));
		}
	}



/* make-one-conversion */
	obj_t BGl_makezd2onezd2conversionz00zzcoerce_convertz00(obj_t
		BgL_idzd2fromzd2_52, BgL_typez00_bglt BgL_fromz00_53,
		BgL_typez00_bglt BgL_toz00_54, obj_t BgL_checkopz00_55,
		obj_t BgL_coerceopz00_56, obj_t BgL_nodez00_57, bool_t BgL_safez00_58)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 185 */
			{	/* Coerce/convert.scm 186 */
				bool_t BgL_testz00_2040;

				if (NULLP(BgL_checkopz00_55))
					{	/* Coerce/convert.scm 186 */
						BgL_testz00_2040 = ((bool_t) 1);
					}
				else
					{	/* Coerce/convert.scm 186 */
						if (BgL_safez00_58)
							{	/* Coerce/convert.scm 186 */
								BgL_testz00_2040 = ((bool_t) 0);
							}
						else
							{	/* Coerce/convert.scm 186 */
								BgL_testz00_2040 = ((bool_t) 1);
							}
					}
				if (BgL_testz00_2040)
					{	/* Coerce/convert.scm 186 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coerceopz00_56,
							BgL_nodez00_57, BgL_fromz00_53);
					}
				else
					{	/* Coerce/convert.scm 188 */
						bool_t BgL_testz00_2045;

						{	/* Coerce/convert.scm 188 */
							obj_t BgL_obj3189z00_1725;

							BgL_obj3189z00_1725 = (obj_t) (BgL_fromz00_53);
							BgL_testz00_2045 =
								BGl_iszd2azf3z21zz__objectz00(BgL_obj3189z00_1725,
								BGl_tclassz00zzobject_classz00);
						}
						if (BgL_testz00_2045)
							{	/* Coerce/convert.scm 188 */
								return
									BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00
									(BgL_idzd2fromzd2_52, BgL_fromz00_53, BgL_toz00_54,
									BgL_checkopz00_55, BgL_coerceopz00_56, BgL_nodez00_57);
							}
						else
							{	/* Coerce/convert.scm 188 */
								return
									(obj_t)
									(BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00
									(BgL_idzd2fromzd2_52, BgL_fromz00_53, BgL_toz00_54,
										BgL_checkopz00_55, BgL_coerceopz00_56, BgL_nodez00_57));
							}
					}
			}
		}
	}



/* skip-let-var */
	BgL_nodez00_bglt BGl_skipzd2letzd2varz00zzcoerce_convertz00(BgL_nodez00_bglt
		BgL_nodez00_59)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 195 */
		BGl_skipzd2letzd2varz00zzcoerce_convertz00:
			{	/* Coerce/convert.scm 196 */
				bool_t BgL_testz00_2051;

				{	/* Coerce/convert.scm 196 */
					obj_t BgL_obj2996z00_1726;

					BgL_obj2996z00_1726 = (obj_t) (BgL_nodez00_59);
					BgL_testz00_2051 =
						BGl_iszd2azf3z21zz__objectz00(BgL_obj2996z00_1726,
						BGl_letzd2varzd2zzast_nodez00);
				}
				if (BgL_testz00_2051)
					{
						BgL_nodez00_bglt BgL_nodez00_2054;

						{
							BgL_letzd2varzd2_bglt BgL_auxz00_2055;

							BgL_auxz00_2055 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_59);
							BgL_nodez00_2054 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2055))->BgL_bodyz00);
						}
						BgL_nodez00_59 = BgL_nodez00_2054;
						goto BGl_skipzd2letzd2varz00zzcoerce_convertz00;
					}
				else
					{	/* Coerce/convert.scm 196 */
						return BgL_nodez00_59;
					}
			}
		}
	}



/* make-one-type-conversion */
	BgL_nodez00_bglt
		BGl_makezd2onezd2typezd2conversionzd2zzcoerce_convertz00(obj_t
		BgL_idzd2fromzd2_60, BgL_typez00_bglt BgL_fromz00_61,
		BgL_typez00_bglt BgL_toz00_62, obj_t BgL_checkzd2opzd2_63,
		obj_t BgL_coercezd2opzd2_64, obj_t BgL_nodez00_65)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 203 */
			{	/* Coerce/convert.scm 204 */
				obj_t BgL_auxz00_1100;

				BgL_auxz00_1100 =
					BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
					(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 0))));
				{	/* Coerce/convert.scm 204 */
					obj_t BgL_locz00_1101;

					{
						BgL_nodez00_bglt BgL_auxz00_2061;

						BgL_auxz00_2061 = (BgL_nodez00_bglt) (BgL_nodez00_65);
						BgL_locz00_1101 =
							(((BgL_nodez00_bglt) CREF(BgL_auxz00_2061))->BgL_locz00);
					}
					{	/* Coerce/convert.scm 205 */
						BgL_nodez00_bglt BgL_lnodez00_1102;

						{	/* Coerce/convert.scm 212 */
							obj_t BgL_arg3579z00_1113;

							{	/* Coerce/convert.scm 212 */
								obj_t BgL_arg3580z00_1114;

								obj_t BgL_arg3581z00_1115;

								BgL_arg3580z00_1114 = CNST_TABLE_REF(((long) 1));
								{	/* Coerce/convert.scm 213 */
									obj_t BgL_arg3582z00_1116;

									obj_t BgL_arg3583z00_1117;

									{	/* Coerce/convert.scm 213 */
										obj_t BgL_arg3587z00_1121;

										{	/* Coerce/convert.scm 213 */
											obj_t BgL_arg3589z00_1123;

											obj_t BgL_arg3590z00_1124;

											{	/* Coerce/convert.scm 213 */
												obj_t BgL_arg3591z00_1125;

												{	/* Coerce/convert.scm 213 */
													obj_t BgL_arg3592z00_1126;

													BgL_arg3592z00_1126 =
														(((BgL_typez00_bglt) CREF(BgL_fromz00_61))->
														BgL_idz00);
													BgL_arg3591z00_1125 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_auxz00_1100, BgL_arg3592z00_1126);
												}
												BgL_arg3589z00_1123 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BgL_arg3591z00_1125);
											}
											{	/* Coerce/convert.scm 212 */
												obj_t BgL_list3593z00_1127;

												BgL_list3593z00_1127 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3590z00_1124 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BUNSPEC,
													BgL_list3593z00_1127);
											}
											BgL_arg3587z00_1121 =
												MAKE_PAIR(BgL_arg3589z00_1123, BgL_arg3590z00_1124);
										}
										BgL_arg3582z00_1116 = MAKE_PAIR(BgL_arg3587z00_1121, BNIL);
									}
									{	/* Coerce/convert.scm 215 */
										obj_t BgL_arg3594z00_1128;

										obj_t BgL_arg3595z00_1129;

										BgL_arg3594z00_1128 = CNST_TABLE_REF(((long) 13));
										{	/* Coerce/convert.scm 215 */
											obj_t BgL_arg3596z00_1130;

											obj_t BgL_arg3597z00_1131;

											{	/* Coerce/convert.scm 215 */
												obj_t BgL_arg3602z00_1136;

												{	/* Coerce/convert.scm 215 */
													obj_t BgL_list3603z00_1137;

													BgL_list3603z00_1137 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3602z00_1136 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_auxz00_1100, BgL_list3603z00_1137);
												}
												BgL_arg3596z00_1130 =
													MAKE_PAIR(BgL_checkzd2opzd2_63, BgL_arg3602z00_1136);
											}
											{	/* Coerce/convert.scm 217 */
												obj_t BgL_arg3604z00_1138;

												BgL_arg3604z00_1138 =
													(((BgL_typez00_bglt) CREF(BgL_toz00_62))->BgL_idz00);
												BgL_arg3597z00_1131 =
													BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
													(BgL_locz00_1101, BgL_arg3604z00_1138,
													BgL_auxz00_1100);
											}
											{	/* Coerce/convert.scm 215 */
												obj_t BgL_list3599z00_1133;

												{	/* Coerce/convert.scm 215 */
													obj_t BgL_arg3600z00_1134;

													{	/* Coerce/convert.scm 215 */
														obj_t BgL_arg3601z00_1135;

														BgL_arg3601z00_1135 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3600z00_1134 =
															MAKE_PAIR(BgL_arg3597z00_1131,
															BgL_arg3601z00_1135);
													}
													BgL_list3599z00_1133 =
														MAKE_PAIR(BgL_auxz00_1100, BgL_arg3600z00_1134);
												}
												BgL_arg3595z00_1129 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3596z00_1130, BgL_list3599z00_1133);
										}}
										BgL_arg3583z00_1117 =
											MAKE_PAIR(BgL_arg3594z00_1128, BgL_arg3595z00_1129);
									}
									{	/* Coerce/convert.scm 212 */
										obj_t BgL_list3585z00_1119;

										{	/* Coerce/convert.scm 212 */
											obj_t BgL_arg3586z00_1120;

											BgL_arg3586z00_1120 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3585z00_1119 =
												MAKE_PAIR(BgL_arg3583z00_1117, BgL_arg3586z00_1120);
										}
										BgL_arg3581z00_1115 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3582z00_1116, BgL_list3585z00_1119);
								}}
								BgL_arg3579z00_1113 =
									MAKE_PAIR(BgL_arg3580z00_1114, BgL_arg3581z00_1115);
							}
							BgL_lnodez00_1102 =
								BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
								(BgL_arg3579z00_1113, BgL_locz00_1101);
						}
						{	/* Coerce/convert.scm 206 */

							BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_lnodez00_1102);
							BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
								(BgL_lnodez00_1102);
							{	/* Coerce/convert.scm 221 */
								obj_t BgL_varz00_1103;

								{	/* Coerce/convert.scm 221 */
									obj_t BgL_pairz00_1733;

									{	/* Coerce/convert.scm 221 */
										obj_t BgL_pairz00_1732;

										{
											BgL_letzd2varzd2_bglt BgL_auxz00_2090;

											BgL_auxz00_2090 =
												(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1102);
											BgL_pairz00_1732 =
												(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2090))->
												BgL_bindingsz00);
										}
										BgL_pairz00_1733 = CAR(BgL_pairz00_1732);
									}
									BgL_varz00_1103 = CAR(BgL_pairz00_1733);
								}
								{	/* Coerce/convert.scm 221 */
									obj_t BgL_coercezd2appzd2_1104;

									{	/* Coerce/convert.scm 223 */
										BgL_varz00_bglt BgL_arg3575z00_1110;

										BgL_arg3575z00_1110 =
											BGl_makezd2varzd2zzast_nodez00(BgL_locz00_1101,
											BgL_fromz00_61, (BgL_variablez00_bglt) (BgL_varz00_1103));
										BgL_coercezd2appzd2_1104 =
											BGl_dozd2convertzd2zzcoerce_convertz00
											(BgL_coercezd2opzd2_64, (obj_t) (BgL_arg3575z00_1110),
											BgL_fromz00_61);
									}
									{	/* Coerce/convert.scm 222 */
										BgL_nodez00_bglt BgL_condnz00_1105;

										BgL_condnz00_1105 =
											BGl_skipzd2letzd2varz00zzcoerce_convertz00
											(BgL_lnodez00_1102);
										{	/* Coerce/convert.scm 228 */

											{
												BgL_variablez00_bglt BgL_auxz00_2100;

												BgL_auxz00_2100 =
													(BgL_variablez00_bglt) (BgL_varz00_1103);
												((((BgL_variablez00_bglt) CREF(BgL_auxz00_2100))->
														BgL_typez00) =
													((BgL_typez00_bglt) BgL_fromz00_61), BUNSPEC);
											}
											{	/* Coerce/convert.scm 232 */
												obj_t BgL_arg3571z00_1106;

												{	/* Coerce/convert.scm 232 */
													obj_t BgL_pairz00_1737;

													{
														BgL_letzd2varzd2_bglt BgL_auxz00_2103;

														BgL_auxz00_2103 =
															(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1102);
														BgL_pairz00_1737 =
															(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2103))->
															BgL_bindingsz00);
													}
													BgL_arg3571z00_1106 = CAR(BgL_pairz00_1737);
												}
												SET_CDR(BgL_arg3571z00_1106, BgL_nodez00_65);
											}
											{
												BgL_nodez00_bglt BgL_auxz00_2110;

												BgL_conditionalz00_bglt BgL_auxz00_2108;

												BgL_auxz00_2110 =
													(BgL_nodez00_bglt) (BgL_coercezd2appzd2_1104);
												BgL_auxz00_2108 =
													(BgL_conditionalz00_bglt) (BgL_condnz00_1105);
												((((BgL_conditionalz00_bglt) CREF(BgL_auxz00_2108))->
														BgL_truez00) =
													((BgL_nodez00_bglt) BgL_auxz00_2110), BUNSPEC);
											}
											{	/* Coerce/convert.scm 235 */
												BgL_nodez00_bglt BgL_arg3573z00_1108;

												{	/* Coerce/convert.scm 235 */
													BgL_nodez00_bglt BgL_arg3574z00_1109;

													{
														BgL_conditionalz00_bglt BgL_auxz00_2113;

														BgL_auxz00_2113 =
															(BgL_conditionalz00_bglt) (BgL_condnz00_1105);
														BgL_arg3574z00_1109 =
															(((BgL_conditionalz00_bglt)
																CREF(BgL_auxz00_2113))->BgL_falsez00);
													}
													BgL_arg3573z00_1108 =
														BGl_coercez12z12zzcoerce_coercez00
														(BgL_arg3574z00_1109, BUNSPEC, BgL_fromz00_61,
														((bool_t) 0));
												}
												{
													BgL_conditionalz00_bglt BgL_auxz00_2117;

													BgL_auxz00_2117 =
														(BgL_conditionalz00_bglt) (BgL_condnz00_1105);
													((((BgL_conditionalz00_bglt) CREF(BgL_auxz00_2117))->
															BgL_falsez00) =
														((BgL_nodez00_bglt) BgL_arg3573z00_1108), BUNSPEC);
											}}
											return BgL_lnodez00_1102;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* make-one-class-conversion */
	obj_t BGl_makezd2onezd2classzd2conversionzd2zzcoerce_convertz00(obj_t
		BgL_idzd2fromzd2_66, BgL_typez00_bglt BgL_fromz00_67,
		BgL_typez00_bglt BgL_toz00_68, obj_t BgL_checkzd2opzd2_69,
		obj_t BgL_coercezd2opzd2_70, obj_t BgL_nodez00_71)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 244 */
			{	/* Coerce/convert.scm 245 */
				bool_t BgL_testz00_2120;

				{	/* Coerce/convert.scm 245 */
					bool_t BgL_testz00_2121;

					{	/* Coerce/convert.scm 245 */
						obj_t BgL_obj3189z00_1745;

						BgL_obj3189z00_1745 = (obj_t) (BgL_toz00_68);
						BgL_testz00_2121 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj3189z00_1745,
							BGl_tclassz00zzobject_classz00);
					}
					if (BgL_testz00_2121)
						{	/* Coerce/convert.scm 245 */
							BgL_testz00_2120 =
								BGl_typezd2subclasszf3z21zzobject_classz00(BgL_fromz00_67,
								BgL_toz00_68);
						}
					else
						{	/* Coerce/convert.scm 245 */
							BgL_testz00_2120 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2120)
					{	/* Coerce/convert.scm 245 */
						return
							BGl_dozd2convertzd2zzcoerce_convertz00(BgL_coercezd2opzd2_70,
							BgL_nodez00_71, BgL_fromz00_67);
					}
				else
					{	/* Coerce/convert.scm 247 */
						obj_t BgL_auxz00_1141;

						BgL_auxz00_1141 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 0)));
						{	/* Coerce/convert.scm 247 */
							obj_t BgL_aux2z00_1142;

							BgL_aux2z00_1142 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 14)));
							{	/* Coerce/convert.scm 248 */
								obj_t BgL_locz00_1143;

								{
									BgL_nodez00_bglt BgL_auxz00_2130;

									BgL_auxz00_2130 = (BgL_nodez00_bglt) (BgL_nodez00_71);
									BgL_locz00_1143 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_2130))->BgL_locz00);
								}
								{	/* Coerce/convert.scm 249 */
									BgL_nodez00_bglt BgL_lnodez00_1144;

									{	/* Coerce/convert.scm 251 */
										obj_t BgL_arg3618z00_1160;

										{	/* Coerce/convert.scm 251 */
											obj_t BgL_arg3619z00_1161;

											obj_t BgL_arg3620z00_1162;

											BgL_arg3619z00_1161 = CNST_TABLE_REF(((long) 1));
											{	/* Coerce/convert.scm 252 */
												obj_t BgL_arg3621z00_1163;

												obj_t BgL_arg3622z00_1164;

												{	/* Coerce/convert.scm 252 */
													obj_t BgL_arg3626z00_1168;

													{	/* Coerce/convert.scm 252 */
														obj_t BgL_arg3628z00_1170;

														obj_t BgL_arg3629z00_1171;

														{	/* Coerce/convert.scm 252 */
															obj_t BgL_arg3630z00_1172;

															{	/* Coerce/convert.scm 252 */
																obj_t BgL_arg3631z00_1173;

																{	/* Coerce/convert.scm 252 */
																	obj_t BgL_arg3632z00_1174;

																	obj_t BgL_arg3634z00_1175;

																	BgL_arg3632z00_1174 =
																		SYMBOL_TO_STRING(BgL_auxz00_1141);
																	{	/* Coerce/convert.scm 252 */
																		obj_t BgL_symbolz00_1748;

																		BgL_symbolz00_1748 =
																			CNST_TABLE_REF(((long) 2));
																		BgL_arg3634z00_1175 =
																			SYMBOL_TO_STRING(BgL_symbolz00_1748);
																	}
																	{	/* Coerce/convert.scm 252 */
																		obj_t BgL_list3635z00_1176;

																		{	/* Coerce/convert.scm 252 */
																			obj_t BgL_arg3636z00_1177;

																			BgL_arg3636z00_1177 =
																				MAKE_PAIR(BgL_arg3634z00_1175, BNIL);
																			BgL_list3635z00_1176 =
																				MAKE_PAIR(BgL_arg3632z00_1174,
																				BgL_arg3636z00_1177);
																		}
																		BgL_arg3631z00_1173 =
																			BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																			(BgL_list3635z00_1176);
																}}
																BgL_arg3630z00_1172 =
																	string_to_symbol(BSTRING_TO_STRING
																	(BgL_arg3631z00_1173));
															}
															BgL_arg3628z00_1170 =
																BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																(BgL_arg3630z00_1172);
														}
														{	/* Coerce/convert.scm 251 */
															obj_t BgL_list3637z00_1178;

															BgL_list3637z00_1178 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg3629z00_1171 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BUNSPEC, BgL_list3637z00_1178);
														}
														BgL_arg3626z00_1168 =
															MAKE_PAIR(BgL_arg3628z00_1170,
															BgL_arg3629z00_1171);
													}
													BgL_arg3621z00_1163 =
														MAKE_PAIR(BgL_arg3626z00_1168, BNIL);
												}
												{	/* Coerce/convert.scm 253 */
													obj_t BgL_arg3638z00_1179;

													obj_t BgL_arg3639z00_1180;

													BgL_arg3638z00_1179 = CNST_TABLE_REF(((long) 1));
													{	/* Coerce/convert.scm 254 */
														obj_t BgL_arg3640z00_1181;

														obj_t BgL_arg3641z00_1182;

														{	/* Coerce/convert.scm 254 */
															obj_t BgL_arg3645z00_1186;

															{	/* Coerce/convert.scm 254 */
																obj_t BgL_arg3647z00_1188;

																obj_t BgL_arg3648z00_1189;

																{	/* Coerce/convert.scm 254 */
																	obj_t BgL_arg3649z00_1190;

																	{	/* Coerce/convert.scm 254 */
																		obj_t BgL_arg3650z00_1191;

																		{	/* Coerce/convert.scm 254 */
																			obj_t BgL_arg3651z00_1192;

																			obj_t BgL_arg3652z00_1193;

																			BgL_arg3651z00_1192 =
																				SYMBOL_TO_STRING(BgL_aux2z00_1142);
																			{	/* Coerce/convert.scm 254 */
																				obj_t BgL_symbolz00_1751;

																				BgL_symbolz00_1751 =
																					CNST_TABLE_REF(((long) 2));
																				BgL_arg3652z00_1193 =
																					SYMBOL_TO_STRING(BgL_symbolz00_1751);
																			}
																			{	/* Coerce/convert.scm 254 */
																				obj_t BgL_list3653z00_1194;

																				{	/* Coerce/convert.scm 254 */
																					obj_t BgL_arg3654z00_1195;

																					BgL_arg3654z00_1195 =
																						MAKE_PAIR(BgL_arg3652z00_1193,
																						BNIL);
																					BgL_list3653z00_1194 =
																						MAKE_PAIR(BgL_arg3651z00_1192,
																						BgL_arg3654z00_1195);
																				}
																				BgL_arg3650z00_1191 =
																					BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																					(BgL_list3653z00_1194);
																		}}
																		BgL_arg3649z00_1190 =
																			string_to_symbol(BSTRING_TO_STRING
																			(BgL_arg3650z00_1191));
																	}
																	BgL_arg3647z00_1188 =
																		BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																		(BgL_arg3649z00_1190);
																}
																{	/* Coerce/convert.scm 253 */
																	obj_t BgL_list3655z00_1196;

																	BgL_list3655z00_1196 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg3648z00_1189 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BUNSPEC, BgL_list3655z00_1196);
																}
																BgL_arg3645z00_1186 =
																	MAKE_PAIR(BgL_arg3647z00_1188,
																	BgL_arg3648z00_1189);
															}
															BgL_arg3640z00_1181 =
																MAKE_PAIR(BgL_arg3645z00_1186, BNIL);
														}
														{	/* Coerce/convert.scm 255 */
															obj_t BgL_arg3656z00_1197;

															obj_t BgL_arg3657z00_1198;

															BgL_arg3656z00_1197 = CNST_TABLE_REF(((long) 13));
															{	/* Coerce/convert.scm 255 */
																obj_t BgL_arg3658z00_1199;

																obj_t BgL_arg3659z00_1200;

																{	/* Coerce/convert.scm 255 */
																	obj_t BgL_arg3664z00_1205;

																	{	/* Coerce/convert.scm 255 */
																		obj_t BgL_list3665z00_1206;

																		BgL_list3665z00_1206 =
																			MAKE_PAIR(BNIL, BNIL);
																		BgL_arg3664z00_1205 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_aux2z00_1142, BgL_list3665z00_1206);
																	}
																	BgL_arg3658z00_1199 =
																		MAKE_PAIR(BgL_checkzd2opzd2_69,
																		BgL_arg3664z00_1205);
																}
																{	/* Coerce/convert.scm 257 */
																	obj_t BgL_arg3666z00_1207;

																	BgL_arg3666z00_1207 =
																		(((BgL_typez00_bglt) CREF(BgL_toz00_68))->
																		BgL_idz00);
																	BgL_arg3659z00_1200 =
																		BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
																		(BgL_locz00_1143, BgL_arg3666z00_1207,
																		BgL_auxz00_1141);
																}
																{	/* Coerce/convert.scm 255 */
																	obj_t BgL_list3661z00_1202;

																	{	/* Coerce/convert.scm 255 */
																		obj_t BgL_arg3662z00_1203;

																		{	/* Coerce/convert.scm 255 */
																			obj_t BgL_arg3663z00_1204;

																			BgL_arg3663z00_1204 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3662z00_1203 =
																				MAKE_PAIR(BgL_arg3659z00_1200,
																				BgL_arg3663z00_1204);
																		}
																		BgL_list3661z00_1202 =
																			MAKE_PAIR(BgL_auxz00_1141,
																			BgL_arg3662z00_1203);
																	}
																	BgL_arg3657z00_1198 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg3658z00_1199, BgL_list3661z00_1202);
															}}
															BgL_arg3641z00_1182 =
																MAKE_PAIR(BgL_arg3656z00_1197,
																BgL_arg3657z00_1198);
														}
														{	/* Coerce/convert.scm 253 */
															obj_t BgL_list3643z00_1184;

															{	/* Coerce/convert.scm 253 */
																obj_t BgL_arg3644z00_1185;

																BgL_arg3644z00_1185 = MAKE_PAIR(BNIL, BNIL);
																BgL_list3643z00_1184 =
																	MAKE_PAIR(BgL_arg3641z00_1182,
																	BgL_arg3644z00_1185);
															}
															BgL_arg3639z00_1180 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg3640z00_1181, BgL_list3643z00_1184);
													}}
													BgL_arg3622z00_1164 =
														MAKE_PAIR(BgL_arg3638z00_1179, BgL_arg3639z00_1180);
												}
												{	/* Coerce/convert.scm 251 */
													obj_t BgL_list3624z00_1166;

													{	/* Coerce/convert.scm 251 */
														obj_t BgL_arg3625z00_1167;

														BgL_arg3625z00_1167 = MAKE_PAIR(BNIL, BNIL);
														BgL_list3624z00_1166 =
															MAKE_PAIR(BgL_arg3622z00_1164,
															BgL_arg3625z00_1167);
													}
													BgL_arg3620z00_1162 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg3621z00_1163, BgL_list3624z00_1166);
											}}
											BgL_arg3618z00_1160 =
												MAKE_PAIR(BgL_arg3619z00_1161, BgL_arg3620z00_1162);
										}
										BgL_lnodez00_1144 =
											BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
											(BgL_arg3618z00_1160, BgL_locz00_1143);
									}
									{	/* Coerce/convert.scm 250 */

										BGl_lvtypezd2nodez12zc0zzast_lvtypez00(BgL_lnodez00_1144);
										BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
											(BgL_lnodez00_1144);
										{	/* Coerce/convert.scm 261 */
											obj_t BgL_varz00_1145;

											{	/* Coerce/convert.scm 261 */
												obj_t BgL_pairz00_1756;

												{	/* Coerce/convert.scm 261 */
													obj_t BgL_pairz00_1755;

													{
														BgL_letzd2varzd2_bglt BgL_auxz00_2183;

														BgL_auxz00_2183 =
															(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1144);
														BgL_pairz00_1755 =
															(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2183))->
															BgL_bindingsz00);
													}
													BgL_pairz00_1756 = CAR(BgL_pairz00_1755);
												}
												BgL_varz00_1145 = CAR(BgL_pairz00_1756);
											}
											{	/* Coerce/convert.scm 261 */
												obj_t BgL_coercezd2appzd2_1146;

												{	/* Coerce/convert.scm 263 */
													BgL_varz00_bglt BgL_arg3615z00_1157;

													BgL_arg3615z00_1157 =
														BGl_makezd2varzd2zzast_nodez00(BgL_locz00_1143,
														BgL_fromz00_67,
														(BgL_variablez00_bglt) (BgL_varz00_1145));
													BgL_coercezd2appzd2_1146 =
														BGl_dozd2convertzd2zzcoerce_convertz00
														(BgL_coercezd2opzd2_70,
														(obj_t) (BgL_arg3615z00_1157), BgL_fromz00_67);
												}
												{	/* Coerce/convert.scm 262 */
													BgL_nodez00_bglt BgL_condnz00_1147;

													BgL_condnz00_1147 =
														BGl_skipzd2letzd2varz00zzcoerce_convertz00
														(BgL_lnodez00_1144);
													{	/* Coerce/convert.scm 268 */

														{
															BgL_variablez00_bglt BgL_auxz00_2193;

															BgL_auxz00_2193 =
																(BgL_variablez00_bglt) (BgL_varz00_1145);
															((((BgL_variablez00_bglt) CREF(BgL_auxz00_2193))->
																	BgL_typez00) =
																((BgL_typez00_bglt) BgL_fromz00_67), BUNSPEC);
														}
														{	/* Coerce/convert.scm 272 */
															obj_t BgL_arg3607z00_1148;

															{	/* Coerce/convert.scm 272 */
																obj_t BgL_pairz00_1760;

																{
																	BgL_letzd2varzd2_bglt BgL_auxz00_2196;

																	BgL_auxz00_2196 =
																		(BgL_letzd2varzd2_bglt) (BgL_lnodez00_1144);
																	BgL_pairz00_1760 =
																		(((BgL_letzd2varzd2_bglt)
																			CREF(BgL_auxz00_2196))->BgL_bindingsz00);
																}
																BgL_arg3607z00_1148 = CAR(BgL_pairz00_1760);
															}
															SET_CDR(BgL_arg3607z00_1148, BgL_nodez00_71);
														}
														{	/* Coerce/convert.scm 273 */
															obj_t BgL_binding2z00_1150;

															{	/* Coerce/convert.scm 273 */
																obj_t BgL_pairz00_1765;

																{	/* Coerce/convert.scm 273 */
																	BgL_letzd2varzd2_bglt BgL_obj2963z00_1764;

																	{	/* Coerce/convert.scm 273 */
																		BgL_letzd2varzd2_bglt BgL_obj2966z00_1763;

																		BgL_obj2966z00_1763 =
																			(BgL_letzd2varzd2_bglt)
																			(BgL_lnodez00_1144);
																		BgL_obj2963z00_1764 =
																			(BgL_letzd2varzd2_bglt) (((
																					(BgL_letzd2varzd2_bglt)
																					CREF(BgL_obj2966z00_1763))->
																				BgL_bodyz00));
																	}
																	BgL_pairz00_1765 =
																		(((BgL_letzd2varzd2_bglt)
																			CREF(BgL_obj2963z00_1764))->
																		BgL_bindingsz00);
																}
																BgL_binding2z00_1150 = CAR(BgL_pairz00_1765);
															}
															{	/* Coerce/convert.scm 277 */
																BgL_castz00_bglt BgL_arg3609z00_1151;

																{	/* Coerce/convert.scm 277 */
																	BgL_varz00_bglt BgL_arg3610z00_1152;

																	BgL_arg3610z00_1152 =
																		BGl_makezd2varzd2zzast_nodez00
																		(BgL_locz00_1143, BgL_fromz00_67,
																		(BgL_variablez00_bglt) (BgL_varz00_1145));
																	BgL_arg3609z00_1151 =
																		BGl_makezd2castzd2zzast_nodez00
																		(BgL_locz00_1143,
																		(BgL_typez00_bglt)
																		(BGl_za2objza2z00zztype_cachez00),
																		(BgL_nodez00_bglt) (BgL_arg3610z00_1152));
																}
																{	/* Coerce/convert.scm 274 */
																	obj_t BgL_auxz00_2211;

																	BgL_auxz00_2211 =
																		(obj_t) (BgL_arg3609z00_1151);
																	SET_CDR(BgL_binding2z00_1150,
																		BgL_auxz00_2211);
														}}}
														{
															BgL_nodez00_bglt BgL_auxz00_2216;

															BgL_conditionalz00_bglt BgL_auxz00_2214;

															BgL_auxz00_2216 =
																(BgL_nodez00_bglt) (BgL_coercezd2appzd2_1146);
															BgL_auxz00_2214 =
																(BgL_conditionalz00_bglt) (BgL_condnz00_1147);
															((((BgL_conditionalz00_bglt)
																		CREF(BgL_auxz00_2214))->BgL_truez00) =
																((BgL_nodez00_bglt) BgL_auxz00_2216), BUNSPEC);
														}
														{	/* Coerce/convert.scm 283 */
															BgL_nodez00_bglt BgL_arg3613z00_1155;

															{	/* Coerce/convert.scm 283 */
																BgL_nodez00_bglt BgL_arg3614z00_1156;

																{
																	BgL_conditionalz00_bglt BgL_auxz00_2219;

																	BgL_auxz00_2219 =
																		(BgL_conditionalz00_bglt)
																		(BgL_condnz00_1147);
																	BgL_arg3614z00_1156 =
																		(((BgL_conditionalz00_bglt)
																			CREF(BgL_auxz00_2219))->BgL_falsez00);
																}
																BgL_arg3613z00_1155 =
																	BGl_coercez12z12zzcoerce_coercez00
																	(BgL_arg3614z00_1156, BUNSPEC, BgL_fromz00_67,
																	((bool_t) 0));
															}
															{
																BgL_conditionalz00_bglt BgL_auxz00_2223;

																BgL_auxz00_2223 =
																	(BgL_conditionalz00_bglt) (BgL_condnz00_1147);
																((((BgL_conditionalz00_bglt)
																			CREF(BgL_auxz00_2223))->BgL_falsez00) =
																	((BgL_nodez00_bglt) BgL_arg3613z00_1155),
																	BUNSPEC);
														}}
														return (obj_t) (BgL_lnodez00_1144);
													}
												}
											}
										}
									}
								}
							}
						}
					}
			}
		}
	}



/* do-convert */
	obj_t BGl_dozd2convertzd2zzcoerce_convertz00(obj_t BgL_coercezd2opzd2_72,
		obj_t BgL_nodez00_73, BgL_typez00_bglt BgL_fromz00_74)
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 292 */
			if (NULLP(BgL_coercezd2opzd2_72))
				{	/* Coerce/convert.scm 295 */
					return BgL_nodez00_73;
				}
			else
				{	/* Coerce/convert.scm 297 */
					BgL_nodez00_bglt BgL_nnodez00_1210;

					{	/* Coerce/convert.scm 297 */
						obj_t BgL_arg3686z00_1229;

						obj_t BgL_arg3687z00_1230;

						{	/* Coerce/convert.scm 297 */
							obj_t BgL_arg3688z00_1231;

							{	/* Coerce/convert.scm 297 */
								obj_t BgL_list3689z00_1232;

								BgL_list3689z00_1232 = MAKE_PAIR(BNIL, BNIL);
								BgL_arg3688z00_1231 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BUNSPEC,
									BgL_list3689z00_1232);
							}
							BgL_arg3686z00_1229 =
								MAKE_PAIR(BgL_coercezd2opzd2_72, BgL_arg3688z00_1231);
						}
						{
							BgL_nodez00_bglt BgL_auxz00_2232;

							BgL_auxz00_2232 = (BgL_nodez00_bglt) (BgL_nodez00_73);
							BgL_arg3687z00_1230 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_2232))->BgL_locz00);
						}
						BgL_nnodez00_1210 =
							BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
							(BgL_arg3686z00_1229, BgL_arg3687z00_1230);
					}
					{	/* Coerce/convert.scm 297 */

						{
							BgL_nodez00_bglt BgL_auxz00_2236;

							BgL_auxz00_2236 = (BgL_nodez00_bglt) (BgL_nodez00_73);
							((((BgL_nodez00_bglt) CREF(BgL_auxz00_2236))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_fromz00_74), BUNSPEC);
						}
						BGl_spreadzd2sidezd2effectz12z12zzeffect_spreadz00
							(BgL_nnodez00_1210);
						{	/* Coerce/convert.scm 311 */
							bool_t BgL_testz00_2240;

							{	/* Coerce/convert.scm 311 */
								obj_t BgL_obj2174z00_1777;

								BgL_obj2174z00_1777 = (obj_t) (BgL_nnodez00_1210);
								BgL_testz00_2240 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj2174z00_1777,
									BGl_appz00zzast_nodez00);
							}
							if (BgL_testz00_2240)
								{	/* Coerce/convert.scm 311 */
									{	/* Coerce/convert.scm 312 */
										obj_t BgL_arg3670z00_1212;

										{	/* Coerce/convert.scm 312 */
											obj_t BgL_list3671z00_1213;

											BgL_list3671z00_1213 = MAKE_PAIR(BgL_nodez00_73, BNIL);
											BgL_arg3670z00_1212 = BgL_list3671z00_1213;
										}
										{
											BgL_appz00_bglt BgL_auxz00_2244;

											BgL_auxz00_2244 = (BgL_appz00_bglt) (BgL_nnodez00_1210);
											((((BgL_appz00_bglt) CREF(BgL_auxz00_2244))->
													BgL_argsz00) =
												((obj_t) BgL_arg3670z00_1212), BUNSPEC);
										}
									}
									return (obj_t) (BgL_nnodez00_1210);
								}
							else
								{	/* Coerce/convert.scm 314 */
									bool_t BgL_testz00_2248;

									{	/* Coerce/convert.scm 314 */
										obj_t BgL_obj2996z00_1782;

										BgL_obj2996z00_1782 = (obj_t) (BgL_nnodez00_1210);
										BgL_testz00_2248 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj2996z00_1782,
											BGl_letzd2varzd2zzast_nodez00);
									}
									if (BgL_testz00_2248)
										{	/* Coerce/convert.scm 315 */
											obj_t BgL_bdgsz00_1215;

											{
												BgL_letzd2varzd2_bglt BgL_auxz00_2251;

												BgL_auxz00_2251 =
													(BgL_letzd2varzd2_bglt) (BgL_nnodez00_1210);
												BgL_bdgsz00_1215 =
													(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_2251))->
													BgL_bindingsz00);
											}
											{	/* Coerce/convert.scm 316 */
												bool_t BgL_testz00_2254;

												if (NULLP(BgL_bdgsz00_1215))
													{	/* Coerce/convert.scm 316 */
														BgL_testz00_2254 = ((bool_t) 1);
													}
												else
													{	/* Coerce/convert.scm 316 */
														if (NULLP(CDR(BgL_bdgsz00_1215)))
															{	/* Coerce/convert.scm 316 */
																BgL_testz00_2254 = ((bool_t) 0);
															}
														else
															{	/* Coerce/convert.scm 316 */
																BgL_testz00_2254 = ((bool_t) 1);
															}
													}
												if (BgL_testz00_2254)
													{	/* Coerce/convert.scm 316 */
														return
															BGl_internalzd2errorzd2zztools_errorz00
															(BGl_string3751z00zzcoerce_convertz00,
															BGl_string3752z00zzcoerce_convertz00,
															BGl_shapez00zztools_shapez00
															(BgL_coercezd2opzd2_72));
													}
												else
													{	/* Coerce/convert.scm 316 */
														{	/* Coerce/convert.scm 321 */
															obj_t BgL_arg3677z00_1220;

															BgL_arg3677z00_1220 = CAR(CAR(BgL_bdgsz00_1215));
															{
																BgL_variablez00_bglt BgL_auxz00_2264;

																BgL_auxz00_2264 =
																	(BgL_variablez00_bglt) (BgL_arg3677z00_1220);
																((((BgL_variablez00_bglt)
																			CREF(BgL_auxz00_2264))->BgL_typez00) =
																	((BgL_typez00_bglt) BgL_fromz00_74), BUNSPEC);
															}
														}
														{	/* Coerce/convert.scm 322 */
															obj_t BgL_auxz00_2267;

															BgL_auxz00_2267 = CAR(BgL_bdgsz00_1215);
															SET_CDR(BgL_auxz00_2267, BgL_nodez00_73);
														}
														return (obj_t) (BgL_nnodez00_1210);
													}
											}
										}
									else
										{	/* Coerce/convert.scm 314 */
											return
												BGl_internalzd2errorzd2zztools_errorz00
												(BGl_string3751z00zzcoerce_convertz00,
												BGl_string3752z00zzcoerce_convertz00,
												BGl_shapez00zztools_shapez00(BgL_coercezd2opzd2_72));
										}
								}
						}
					}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_convertz00()
	{
		AN_OBJECT;
		{	/* Coerce/convert.scm 16 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_coercionz00(((long) 451733024),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 77938009),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzast_lvtypez00(((long) 498901618),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			BGl_modulezd2initializa7ationz75zzcoerce_coercez00(((long) 387636515),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_spreadz00(((long) 476444243),
				BSTRING_TO_STRING(BGl_string3753z00zzcoerce_convertz00));
		}
	}

#ifdef __cplusplus
}
#endif
