/*===========================================================================*/
/*   (Coerce/funcall.scm)                                                    */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/funcall.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;


	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	static obj_t BGl_cnstzd2initzd2zzcoerce_funcallz00();
	extern BgL_nodez00_bglt BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, BgL_typez00_bglt, bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_localz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcoerce_funcallz00();
	BGL_IMPORT long bgl_list_length(obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzcoerce_funcallz00();
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_funcallz00 = BUNSPEC;
	extern obj_t BGl_za2unsafezd2arityza2zd2zzengine_paramz00;
	extern BgL_atomz00_bglt BGl_makezd2atomzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t);
	static BgL_nodez00_bglt
		BGl_makezd2arityzd2errorzd2nodezd2zzcoerce_funcallz00(BgL_localz00_bglt,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzcoerce_funcallz00();
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t
		BGl_coercezd2funcallzd2argsz12z12zzcoerce_funcallz00(BgL_funcallz00_bglt,
		obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_funcallz00();
	extern BgL_nodez00_bglt BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt,
		obj_t, BgL_typez00_bglt, bool_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	BGL_IMPORT obj_t string_to_symbol(char *);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern BgL_localz00_bglt BGl_makezd2localzd2svarz00zzast_localz00(obj_t,
		BgL_typez00_bglt);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	extern BgL_letzd2varzd2_bglt BGl_makezd2letzd2varz00zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, obj_t, BgL_nodez00_bglt, bool_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_funcallz00();
	static obj_t BGl_coercez12zd2funcall3152zc0zzcoerce_funcallz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t __cnst[18];


	extern obj_t BGl_coercez12zd2envzc0zzcoerce_coercez00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3352z00zzcoerce_funcallz00,
		BgL_bgl_coerceza712za7d2func3357z00,
		BGl_coercez12zd2funcall3152zc0zzcoerce_funcallz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3351z00zzcoerce_funcallz00,
		BgL_bgl_string3351za700za7za7c3358za7, ":Wrong number of arguments", 26);
	      DEFINE_STRING(BGl_string3353z00zzcoerce_funcallz00,
		BgL_bgl_string3353za700za7za7c3359za7, "coerce_funcall", 14);
	      DEFINE_STRING(BGl_string3354z00zzcoerce_funcallz00,
		BgL_bgl_string3354za700za7za7c3360za7,
		"correct-arity? if let ::int len fun (light elight) dummy __eoa__ _ quote failure error/location __error @ begin location bdb ",
		125);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(long
		BgL_checksumz00_1443, char *BgL_fromz00_1444)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_funcallz00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_funcallz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcoerce_funcallz00();
					BGl_cnstzd2initzd2zzcoerce_funcallz00();
					BGl_importedzd2moduleszd2initz00zzcoerce_funcallz00();
					BGl_methodzd2initzd2zzcoerce_funcallz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_funcall");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"coerce_funcall");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"coerce_funcall");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"coerce_funcall");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_funcall");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			{	/* Coerce/funcall.scm 15 */
				obj_t BgL_cportz00_1435;

				BgL_cportz00_1435 =
					bgl_open_input_string(BGl_string3354z00zzcoerce_funcallz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1436;

					BgL_iz00_1436 = ((long) 17);
				BgL_loopz00_1437:
					if ((BgL_iz00_1436 == ((long) -1)))
						{	/* Coerce/funcall.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/funcall.scm 15 */
							{	/* Coerce/funcall.scm 15 */
								obj_t BgL_arg3356z00_1439;

								{	/* Coerce/funcall.scm 15 */

									{	/* Coerce/funcall.scm 15 */
										obj_t BgL_locationz00_1441;

										BgL_locationz00_1441 = BBOOL(((bool_t) 0));
										{	/* Coerce/funcall.scm 15 */

											BgL_arg3356z00_1439 =
												BGl_readz00zz__readerz00(BgL_cportz00_1435,
												BgL_locationz00_1441);
										}
									}
								}
								{	/* Coerce/funcall.scm 15 */
									int BgL_auxz00_1463;

									BgL_auxz00_1463 = (int) (BgL_iz00_1436);
									CNST_TABLE_SET(BgL_auxz00_1463, BgL_arg3356z00_1439);
							}}
							{	/* Coerce/funcall.scm 15 */
								int BgL_auxz00_1442;

								BgL_auxz00_1442 = (int) ((BgL_iz00_1436 - ((long) 1)));
								{
									long BgL_iz00_1468;

									BgL_iz00_1468 = (long) (BgL_auxz00_1442);
									BgL_iz00_1436 = BgL_iz00_1468;
									goto BgL_loopz00_1437;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			return BUNSPEC;
		}
	}



/* make-arity-error-node */
	BgL_nodez00_bglt
		BGl_makezd2arityzd2errorzd2nodezd2zzcoerce_funcallz00(BgL_localz00_bglt
		BgL_funz00_19, obj_t BgL_errorzd2msgzd2_20, obj_t BgL_locz00_21,
		obj_t BgL_callerz00_22, obj_t BgL_toz00_23)
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 85 */
			{	/* Coerce/funcall.scm 86 */
				BgL_nodez00_bglt BgL_nodez00_841;

				{	/* Coerce/funcall.scm 87 */
					obj_t BgL_arg3162z00_842;

					{	/* Coerce/funcall.scm 87 */
						bool_t BgL_testz00_1470;

						{	/* Coerce/funcall.scm 87 */
							bool_t BgL_testz00_1471;

							if (
								((long) CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >
									((long) 0)))
								{	/* Coerce/funcall.scm 87 */
									BgL_testz00_1471 = ((bool_t) 1);
								}
							else
								{	/* Coerce/funcall.scm 87 */
									if (
										((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >
											((long) 0)))
										{	/* Coerce/funcall.scm 89 */
											obj_t BgL_arg3224z00_901;

											obj_t BgL_arg3225z00_902;

											BgL_arg3224z00_901 = CNST_TABLE_REF(((long) 0));
											{	/* Coerce/funcall.scm 91 */
												obj_t BgL_arg3226z00_903;

												BgL_arg3226z00_903 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												{
													BgL_backendz00_bglt BgL_auxz00_1480;

													BgL_auxz00_1480 =
														(BgL_backendz00_bglt) (BgL_arg3226z00_903);
													BgL_arg3225z00_902 =
														(((BgL_backendz00_bglt) CREF(BgL_auxz00_1480))->
														BgL_debugzd2supportzd2);
											}}
											BgL_testz00_1471 =
												CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(BgL_arg3224z00_901, BgL_arg3225z00_902));
										}
									else
										{	/* Coerce/funcall.scm 88 */
											BgL_testz00_1471 = ((bool_t) 0);
										}
								}
							if (BgL_testz00_1471)
								{	/* Coerce/funcall.scm 87 */
									if (STRUCTP(BgL_locz00_21))
										{	/* Coerce/funcall.scm 92 */
											BgL_testz00_1470 =
												(STRUCT_KEY(BgL_locz00_21) ==
												CNST_TABLE_REF(((long) 1)));
										}
									else
										{	/* Coerce/funcall.scm 92 */
											BgL_testz00_1470 = ((bool_t) 0);
										}
								}
							else
								{	/* Coerce/funcall.scm 87 */
									BgL_testz00_1470 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_1470)
							{	/* Coerce/funcall.scm 93 */
								obj_t BgL_arg3164z00_844;

								obj_t BgL_arg3165z00_845;

								BgL_arg3164z00_844 = CNST_TABLE_REF(((long) 2));
								{	/* Coerce/funcall.scm 94 */
									obj_t BgL_arg3166z00_846;

									obj_t BgL_arg3167z00_847;

									{	/* Coerce/funcall.scm 94 */
										obj_t BgL_arg3172z00_851;

										obj_t BgL_arg3173z00_852;

										{	/* Coerce/funcall.scm 94 */
											obj_t BgL_arg3174z00_853;

											obj_t BgL_arg3175z00_854;

											BgL_arg3174z00_853 = CNST_TABLE_REF(((long) 3));
											{	/* Coerce/funcall.scm 94 */
												obj_t BgL_list3176z00_855;

												{	/* Coerce/funcall.scm 94 */
													obj_t BgL_arg3177z00_856;

													obj_t BgL_arg3178z00_857;

													BgL_arg3177z00_856 = CNST_TABLE_REF(((long) 4));
													BgL_arg3178z00_857 = MAKE_PAIR(BNIL, BNIL);
													BgL_list3176z00_855 =
														MAKE_PAIR(BgL_arg3177z00_856, BgL_arg3178z00_857);
												}
												BgL_arg3175z00_854 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(CNST_TABLE_REF(((long) 5)), BgL_list3176z00_855);
											}
											BgL_arg3172z00_851 =
												MAKE_PAIR(BgL_arg3174z00_853, BgL_arg3175z00_854);
										}
										{	/* Coerce/funcall.scm 96 */
											obj_t BgL_arg3179z00_858;

											obj_t BgL_arg3180z00_859;

											obj_t BgL_arg3181z00_860;

											{	/* Coerce/funcall.scm 96 */
												obj_t BgL_arg3188z00_867;

												BgL_arg3188z00_867 =
													SYMBOL_TO_STRING
													(BGl_currentzd2functionzd2zztools_errorz00());
												BgL_arg3179z00_858 =
													string_append(BgL_arg3188z00_867,
													BGl_string3351z00zzcoerce_funcallz00);
											}
											BgL_arg3180z00_859 =
												BGl_locationzd2fullzd2fnamez00zztools_locationz00
												(BgL_locz00_21);
											BgL_arg3181z00_860 =
												STRUCT_REF(BgL_locz00_21, (int) (((long) 1)));
											{	/* Coerce/funcall.scm 94 */
												obj_t BgL_list3183z00_862;

												{	/* Coerce/funcall.scm 94 */
													obj_t BgL_arg3184z00_863;

													{	/* Coerce/funcall.scm 94 */
														obj_t BgL_arg3185z00_864;

														{	/* Coerce/funcall.scm 94 */
															obj_t BgL_arg3186z00_865;

															{	/* Coerce/funcall.scm 94 */
																obj_t BgL_arg3187z00_866;

																BgL_arg3187z00_866 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg3186z00_865 =
																	MAKE_PAIR(BgL_arg3181z00_860,
																	BgL_arg3187z00_866);
															}
															BgL_arg3185z00_864 =
																MAKE_PAIR(BgL_arg3180z00_859,
																BgL_arg3186z00_865);
														}
														BgL_arg3184z00_863 =
															MAKE_PAIR(
															(obj_t) (BgL_funz00_19), BgL_arg3185z00_864);
													}
													BgL_list3183z00_862 =
														MAKE_PAIR(BgL_errorzd2msgzd2_20,
														BgL_arg3184z00_863);
												}
												BgL_arg3173z00_852 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3179z00_858, BgL_list3183z00_862);
										}}
										BgL_arg3166z00_846 =
											MAKE_PAIR(BgL_arg3172z00_851, BgL_arg3173z00_852);
									}
									{	/* Coerce/funcall.scm 102 */
										obj_t BgL_arg3191z00_870;

										obj_t BgL_arg3192z00_871;

										BgL_arg3191z00_870 = CNST_TABLE_REF(((long) 6));
										{	/* Coerce/funcall.scm 102 */
											obj_t BgL_arg3193z00_872;

											obj_t BgL_arg3194z00_873;

											obj_t BgL_arg3195z00_874;

											{	/* Coerce/funcall.scm 102 */
												obj_t BgL_arg3200z00_879;

												obj_t BgL_arg3201z00_880;

												BgL_arg3200z00_879 = CNST_TABLE_REF(((long) 7));
												{	/* Coerce/funcall.scm 102 */
													obj_t BgL_list3202z00_881;

													BgL_list3202z00_881 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3201z00_880 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 8)), BgL_list3202z00_881);
												}
												BgL_arg3193z00_872 =
													MAKE_PAIR(BgL_arg3200z00_879, BgL_arg3201z00_880);
											}
											{	/* Coerce/funcall.scm 102 */
												obj_t BgL_arg3203z00_882;

												obj_t BgL_arg3204z00_883;

												BgL_arg3203z00_882 = CNST_TABLE_REF(((long) 7));
												{	/* Coerce/funcall.scm 102 */
													obj_t BgL_list3205z00_884;

													BgL_list3205z00_884 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3204z00_883 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 8)), BgL_list3205z00_884);
												}
												BgL_arg3194z00_873 =
													MAKE_PAIR(BgL_arg3203z00_882, BgL_arg3204z00_883);
											}
											{	/* Coerce/funcall.scm 102 */
												obj_t BgL_arg3207z00_885;

												obj_t BgL_arg3208z00_886;

												BgL_arg3207z00_885 = CNST_TABLE_REF(((long) 7));
												{	/* Coerce/funcall.scm 102 */
													obj_t BgL_list3209z00_887;

													BgL_list3209z00_887 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3208z00_886 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 8)), BgL_list3209z00_887);
												}
												BgL_arg3195z00_874 =
													MAKE_PAIR(BgL_arg3207z00_885, BgL_arg3208z00_886);
											}
											{	/* Coerce/funcall.scm 102 */
												obj_t BgL_list3197z00_876;

												{	/* Coerce/funcall.scm 102 */
													obj_t BgL_arg3198z00_877;

													{	/* Coerce/funcall.scm 102 */
														obj_t BgL_arg3199z00_878;

														BgL_arg3199z00_878 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3198z00_877 =
															MAKE_PAIR(BgL_arg3195z00_874, BgL_arg3199z00_878);
													}
													BgL_list3197z00_876 =
														MAKE_PAIR(BgL_arg3194z00_873, BgL_arg3198z00_877);
												}
												BgL_arg3192z00_871 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3193z00_872, BgL_list3197z00_876);
										}}
										BgL_arg3167z00_847 =
											MAKE_PAIR(BgL_arg3191z00_870, BgL_arg3192z00_871);
									}
									{	/* Coerce/funcall.scm 93 */
										obj_t BgL_list3169z00_849;

										{	/* Coerce/funcall.scm 93 */
											obj_t BgL_arg3170z00_850;

											BgL_arg3170z00_850 = MAKE_PAIR(BNIL, BNIL);
											BgL_list3169z00_849 =
												MAKE_PAIR(BgL_arg3167z00_847, BgL_arg3170z00_850);
										}
										BgL_arg3165z00_845 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3166z00_846, BgL_list3169z00_849);
								}}
								BgL_arg3162z00_842 =
									MAKE_PAIR(BgL_arg3164z00_844, BgL_arg3165z00_845);
							}
						else
							{	/* Coerce/funcall.scm 103 */
								obj_t BgL_arg3212z00_888;

								obj_t BgL_arg3213z00_889;

								BgL_arg3212z00_888 = CNST_TABLE_REF(((long) 6));
								{	/* Coerce/funcall.scm 104 */
									obj_t BgL_arg3214z00_890;

									{	/* Coerce/funcall.scm 104 */
										obj_t BgL_arg3219z00_895;

										BgL_arg3219z00_895 =
											SYMBOL_TO_STRING(BGl_currentzd2functionzd2zztools_errorz00
											());
										BgL_arg3214z00_890 =
											string_append(BgL_arg3219z00_895,
											BGl_string3351z00zzcoerce_funcallz00);
									}
									{	/* Coerce/funcall.scm 103 */
										obj_t BgL_list3216z00_892;

										{	/* Coerce/funcall.scm 103 */
											obj_t BgL_arg3217z00_893;

											{	/* Coerce/funcall.scm 103 */
												obj_t BgL_arg3218z00_894;

												BgL_arg3218z00_894 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3217z00_893 =
													MAKE_PAIR(
													(obj_t) (BgL_funz00_19), BgL_arg3218z00_894);
											}
											BgL_list3216z00_892 =
												MAKE_PAIR(BgL_errorzd2msgzd2_20, BgL_arg3217z00_893);
										}
										BgL_arg3213z00_889 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg3214z00_890, BgL_list3216z00_892);
								}}
								BgL_arg3162z00_842 =
									MAKE_PAIR(BgL_arg3212z00_888, BgL_arg3213z00_889);
					}}
					BgL_nodez00_841 =
						BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3162z00_842,
						BgL_locz00_21);
				}
				return
					BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_841, BgL_callerz00_22,
					(BgL_typez00_bglt) (BgL_toz00_23), ((bool_t) 0));
			}
		}
	}



/* coerce-funcall-args! */
	obj_t BGl_coercezd2funcallzd2argsz12z12zzcoerce_funcallz00(BgL_funcallz00_bglt
		BgL_nodez00_24, obj_t BgL_callerz00_25, obj_t BgL_toz00_26,
		obj_t BgL_safez00_27)
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 114 */
			if (NULLP((((BgL_funcallz00_bglt) CREF(BgL_nodez00_24))->BgL_argsz00)))
				{	/* Coerce/funcall.scm 117 */
					obj_t BgL_arg3229z00_905;

					{	/* Coerce/funcall.scm 117 */
						BgL_nodez00_bglt BgL_arg3230z00_906;

						{	/* Coerce/funcall.scm 117 */
							obj_t BgL_arg3232z00_908;

							obj_t BgL_arg3233z00_909;

							BgL_arg3232z00_908 = CNST_TABLE_REF(((long) 9));
							{
								BgL_nodez00_bglt BgL_auxz00_1554;

								BgL_auxz00_1554 = (BgL_nodez00_bglt) (BgL_nodez00_24);
								BgL_arg3233z00_909 =
									(((BgL_nodez00_bglt) CREF(BgL_auxz00_1554))->BgL_locz00);
							}
							BgL_arg3230z00_906 =
								BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
								(BgL_arg3232z00_908, BgL_arg3233z00_909);
						}
						{	/* Coerce/funcall.scm 116 */
							obj_t BgL_list3231z00_907;

							BgL_list3231z00_907 =
								MAKE_PAIR((obj_t) (BgL_arg3230z00_906), BNIL);
							BgL_arg3229z00_905 = BgL_list3231z00_907;
					}}
					return
						((((BgL_funcallz00_bglt) CREF(BgL_nodez00_24))->BgL_argsz00) =
						((obj_t) BgL_arg3229z00_905), BUNSPEC);
				}
			else
				{	/* Coerce/funcall.scm 119 */
					obj_t BgL_g3149z00_910;

					obj_t BgL_g3150z00_911;

					BgL_g3149z00_910 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_24))->BgL_argsz00);
					BgL_g3150z00_911 = CNST_TABLE_REF(((long) 10));
					{
						obj_t BgL_actualsz00_912;

						obj_t BgL_prevz00_913;

						BgL_actualsz00_912 = BgL_g3149z00_910;
						BgL_prevz00_913 = BgL_g3150z00_911;
					BgL_loopz00_914:
						if (NULLP(BgL_actualsz00_912))
							{	/* Coerce/funcall.scm 123 */
								obj_t BgL_arg3235z00_916;

								{	/* Coerce/funcall.scm 123 */
									BgL_nodez00_bglt BgL_arg3236z00_917;

									{	/* Coerce/funcall.scm 123 */
										obj_t BgL_arg3238z00_919;

										obj_t BgL_arg3239z00_920;

										BgL_arg3238z00_919 = CNST_TABLE_REF(((long) 9));
										{
											BgL_nodez00_bglt BgL_auxz00_1566;

											BgL_auxz00_1566 = (BgL_nodez00_bglt) (BgL_nodez00_24);
											BgL_arg3239z00_920 =
												(((BgL_nodez00_bglt) CREF(BgL_auxz00_1566))->
												BgL_locz00);
										}
										BgL_arg3236z00_917 =
											BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
											(BgL_arg3238z00_919, BgL_arg3239z00_920);
									}
									{	/* Coerce/funcall.scm 122 */
										obj_t BgL_list3237z00_918;

										BgL_list3237z00_918 =
											MAKE_PAIR((obj_t) (BgL_arg3236z00_917), BNIL);
										BgL_arg3235z00_916 = BgL_list3237z00_918;
								}}
								return SET_CDR(BgL_prevz00_913, BgL_arg3235z00_916);
							}
						else
							{	/* Coerce/funcall.scm 121 */
								{	/* Coerce/funcall.scm 126 */
									BgL_nodez00_bglt BgL_arg3240z00_921;

									{	/* Coerce/funcall.scm 126 */
										obj_t BgL_arg3241z00_922;

										BgL_arg3241z00_922 = CAR(BgL_actualsz00_912);
										BgL_arg3240z00_921 =
											BGl_coercez12z12zzcoerce_coercez00(
											(BgL_nodez00_bglt) (BgL_arg3241z00_922), BgL_callerz00_25,
											(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
											CBOOL(BgL_safez00_27));
									}
									{	/* Coerce/funcall.scm 126 */
										obj_t BgL_auxz00_1578;

										BgL_auxz00_1578 = (obj_t) (BgL_arg3240z00_921);
										SET_CAR(BgL_actualsz00_912, BgL_auxz00_1578);
									}
								}
								{
									obj_t BgL_prevz00_1583;

									obj_t BgL_actualsz00_1581;

									BgL_actualsz00_1581 = CDR(BgL_actualsz00_912);
									BgL_prevz00_1583 = BgL_actualsz00_912;
									BgL_prevz00_913 = BgL_prevz00_1583;
									BgL_actualsz00_912 = BgL_actualsz00_1581;
									goto BgL_loopz00_914;
								}
							}
					}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_funcallz00zzast_nodez00,
				BGl_proc3352z00zzcoerce_funcallz00);
		}
	}



/* coerce!-funcall3152 */
	obj_t BGl_coercez12zd2funcall3152zc0zzcoerce_funcallz00(obj_t BgL_envz00_1424,
		obj_t BgL_nodez00_1425, obj_t BgL_callerz00_1426, obj_t BgL_toz00_1427,
		obj_t BgL_safez00_1428)
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 36 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1297;

				obj_t BgL_callerz00_1298;

				obj_t BgL_toz00_1299;

				obj_t BgL_safez00_1300;

				BgL_nodez00_1297 = (BgL_funcallz00_bglt) (BgL_nodez00_1425);
				BgL_callerz00_1298 = BgL_callerz00_1426;
				BgL_toz00_1299 = BgL_toz00_1427;
				BgL_safez00_1300 = BgL_safez00_1428;
				{	/* Coerce/funcall.scm 38 */
					obj_t BgL_errorzd2msgzd2_1303;

					obj_t BgL_strengthz00_1304;

					{	/* Coerce/funcall.scm 38 */
						obj_t BgL_arg3334z00_1356;

						obj_t BgL_arg3335z00_1357;

						BgL_arg3334z00_1356 = CNST_TABLE_REF(((long) 7));
						BgL_arg3335z00_1357 =
							BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1297));
						{	/* Coerce/funcall.scm 38 */
							obj_t BgL_list3336z00_1358;

							{	/* Coerce/funcall.scm 38 */
								obj_t BgL_arg3337z00_1359;

								BgL_arg3337z00_1359 = MAKE_PAIR(BgL_arg3335z00_1357, BNIL);
								BgL_list3336z00_1358 =
									MAKE_PAIR(BgL_arg3334z00_1356, BgL_arg3337z00_1359);
							}
							BgL_errorzd2msgzd2_1303 = BgL_list3336z00_1358;
					}}
					BgL_strengthz00_1304 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1297))->BgL_strengthz00);
					BGl_coercezd2funcallzd2argsz12z12zzcoerce_funcallz00(BgL_nodez00_1297,
						BgL_callerz00_1298, BgL_toz00_1299, BgL_safez00_1300);
					if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
							(BgL_strengthz00_1304, CNST_TABLE_REF(((long) 11)))))
						{	/* Coerce/funcall.scm 42 */
							return
								(obj_t) (BGl_convertz12z12zzcoerce_convertz00(
									(BgL_nodez00_bglt) (BgL_nodez00_1297),
									(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
									(BgL_typez00_bglt) (BgL_toz00_1299),
									CBOOL(BgL_safez00_1300)));
						}
					else
						{	/* Coerce/funcall.scm 45 */
							BgL_nodez00_bglt BgL_czd2funzd2_1306;

							{	/* Coerce/funcall.scm 45 */
								BgL_nodez00_bglt BgL_arg3333z00_1355;

								BgL_arg3333z00_1355 =
									(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1297))->BgL_funz00);
								BgL_czd2funzd2_1306 =
									BGl_coercez12z12zzcoerce_coercez00(BgL_arg3333z00_1355,
									BgL_callerz00_1298,
									(BgL_typez00_bglt) (BGl_za2procedureza2z00zztype_cachez00),
									CBOOL(BgL_safez00_1300));
							}
							if (CBOOL(BGl_za2unsafezd2arityza2zd2zzengine_paramz00))
								{	/* Coerce/funcall.scm 47 */
									((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1297))->
											BgL_funz00) =
										((BgL_nodez00_bglt) BgL_czd2funzd2_1306), BUNSPEC);
									return (obj_t) (BGl_convertz12z12zzcoerce_convertz00(
											(BgL_nodez00_bglt) (BgL_nodez00_1297),
											(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
											(BgL_typez00_bglt) (BgL_toz00_1299),
											CBOOL(BgL_safez00_1300)));
								}
							else
								{	/* Coerce/funcall.scm 51 */
									BgL_localz00_bglt BgL_funz00_1307;

									BgL_funz00_1307 =
										BGl_makezd2localzd2svarz00zzast_localz00(CNST_TABLE_REF((
												(long) 12)),
										(BgL_typez00_bglt) (BGl_za2procedureza2z00zztype_cachez00));
									{	/* Coerce/funcall.scm 51 */
										obj_t BgL_locz00_1308;

										{
											BgL_nodez00_bglt BgL_auxz00_1618;

											BgL_auxz00_1618 = (BgL_nodez00_bglt) (BgL_nodez00_1297);
											BgL_locz00_1308 =
												(((BgL_nodez00_bglt) CREF(BgL_auxz00_1618))->
												BgL_locz00);
										}
										{	/* Coerce/funcall.scm 52 */
											BgL_atomz00_bglt BgL_lenz00_1309;

											{	/* Coerce/funcall.scm 56 */
												long BgL_arg3329z00_1351;

												BgL_arg3329z00_1351 =
													(bgl_list_length(
														(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1297))->
															BgL_argsz00)) - ((long) 2));
												BgL_lenz00_1309 =
													BGl_makezd2atomzd2zzast_nodez00(BgL_locz00_1308,
													(BgL_typez00_bglt) (BGl_za2intza2z00zztype_cachez00),
													BINT(BgL_arg3329z00_1351));
											}
											{	/* Coerce/funcall.scm 53 */
												obj_t BgL_azd2lenzd2_1310;

												BgL_azd2lenzd2_1310 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
																(long) 13))));
												{	/* Coerce/funcall.scm 58 */
													obj_t BgL_azd2tlenzd2_1311;

													{	/* Coerce/funcall.scm 60 */
														obj_t BgL_arg3322z00_1344;

														{	/* Coerce/funcall.scm 60 */
															obj_t BgL_arg3323z00_1345;

															{	/* Coerce/funcall.scm 60 */
																obj_t BgL_arg3324z00_1346;

																obj_t BgL_arg3325z00_1347;

																BgL_arg3324z00_1346 =
																	SYMBOL_TO_STRING(BgL_azd2lenzd2_1310);
																{	/* Coerce/funcall.scm 60 */
																	obj_t BgL_symbolz00_1417;

																	BgL_symbolz00_1417 =
																		CNST_TABLE_REF(((long) 14));
																	BgL_arg3325z00_1347 =
																		SYMBOL_TO_STRING(BgL_symbolz00_1417);
																}
																{	/* Coerce/funcall.scm 60 */
																	obj_t BgL_list3326z00_1348;

																	{	/* Coerce/funcall.scm 60 */
																		obj_t BgL_arg3327z00_1349;

																		BgL_arg3327z00_1349 =
																			MAKE_PAIR(BgL_arg3325z00_1347, BNIL);
																		BgL_list3326z00_1348 =
																			MAKE_PAIR(BgL_arg3324z00_1346,
																			BgL_arg3327z00_1349);
																	}
																	BgL_arg3323z00_1345 =
																		BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																		(BgL_list3326z00_1348);
															}}
															BgL_arg3322z00_1344 =
																string_to_symbol(BSTRING_TO_STRING
																(BgL_arg3323z00_1345));
														}
														BgL_azd2tlenzd2_1311 =
															BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
															(BgL_arg3322z00_1344);
													}
													{	/* Coerce/funcall.scm 59 */
														BgL_letzd2varzd2_bglt BgL_lnodez00_1312;

														{	/* Coerce/funcall.scm 61 */
															obj_t BgL_arg3293z00_1315;

															BgL_nodez00_bglt BgL_arg3294z00_1316;

															{	/* Coerce/funcall.scm 64 */
																obj_t BgL_arg3295z00_1317;

																BgL_arg3295z00_1317 =
																	MAKE_PAIR(
																	(obj_t) (BgL_funz00_1307),
																	(obj_t) (BgL_czd2funzd2_1306));
																{	/* Coerce/funcall.scm 64 */
																	obj_t BgL_list3296z00_1318;

																	BgL_list3296z00_1318 =
																		MAKE_PAIR(BgL_arg3295z00_1317, BNIL);
																	BgL_arg3293z00_1315 = BgL_list3296z00_1318;
															}}
															{	/* Coerce/funcall.scm 66 */
																obj_t BgL_arg3297z00_1319;

																{	/* Coerce/funcall.scm 66 */
																	obj_t BgL_arg3298z00_1320;

																	obj_t BgL_arg3299z00_1321;

																	BgL_arg3298z00_1320 =
																		CNST_TABLE_REF(((long) 15));
																	{	/* Coerce/funcall.scm 66 */
																		obj_t BgL_arg3300z00_1322;

																		obj_t BgL_arg3301z00_1323;

																		{	/* Coerce/funcall.scm 66 */
																			obj_t BgL_arg3305z00_1327;

																			{	/* Coerce/funcall.scm 66 */
																				obj_t BgL_arg3307z00_1329;

																				{	/* Coerce/funcall.scm 66 */
																					obj_t BgL_list3308z00_1330;

																					BgL_list3308z00_1330 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3307z00_1329 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						((obj_t) (BgL_lenz00_1309),
																						BgL_list3308z00_1330);
																				}
																				BgL_arg3305z00_1327 =
																					MAKE_PAIR(BgL_azd2tlenzd2_1311,
																					BgL_arg3307z00_1329);
																			}
																			BgL_arg3300z00_1322 =
																				MAKE_PAIR(BgL_arg3305z00_1327, BNIL);
																		}
																		{	/* Coerce/funcall.scm 67 */
																			obj_t BgL_arg3309z00_1331;

																			obj_t BgL_arg3310z00_1332;

																			BgL_arg3309z00_1331 =
																				CNST_TABLE_REF(((long) 16));
																			{	/* Coerce/funcall.scm 67 */
																				obj_t BgL_arg3311z00_1333;

																				BgL_nodez00_bglt BgL_arg3312z00_1334;

																				BgL_nodez00_bglt BgL_arg3313z00_1335;

																				{	/* Coerce/funcall.scm 67 */
																					obj_t BgL_arg3318z00_1340;

																					obj_t BgL_arg3319z00_1341;

																					BgL_arg3318z00_1340 =
																						CNST_TABLE_REF(((long) 17));
																					{	/* Coerce/funcall.scm 67 */
																						obj_t BgL_list3320z00_1342;

																						{	/* Coerce/funcall.scm 67 */
																							obj_t BgL_arg3321z00_1343;

																							BgL_arg3321z00_1343 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list3320z00_1342 =
																								MAKE_PAIR(BgL_azd2lenzd2_1310,
																								BgL_arg3321z00_1343);
																						}
																						BgL_arg3319z00_1341 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							((obj_t) (BgL_funz00_1307),
																							BgL_list3320z00_1342);
																					}
																					BgL_arg3311z00_1333 =
																						MAKE_PAIR(BgL_arg3318z00_1340,
																						BgL_arg3319z00_1341);
																				}
																				BgL_arg3312z00_1334 =
																					BGl_convertz12z12zzcoerce_convertz00(
																					(BgL_nodez00_bglt) (BgL_nodez00_1297),
																					(BgL_typez00_bglt)
																					(BGl_za2objza2z00zztype_cachez00),
																					(BgL_typez00_bglt) (BgL_toz00_1299),
																					CBOOL(BgL_safez00_1300));
																				BgL_arg3313z00_1335 =
																					BGl_makezd2arityzd2errorzd2nodezd2zzcoerce_funcallz00
																					(BgL_funz00_1307,
																					BgL_errorzd2msgzd2_1303,
																					BgL_locz00_1308, BgL_callerz00_1298,
																					BgL_toz00_1299);
																				{	/* Coerce/funcall.scm 67 */
																					obj_t BgL_list3315z00_1337;

																					{	/* Coerce/funcall.scm 67 */
																						obj_t BgL_arg3316z00_1338;

																						{	/* Coerce/funcall.scm 67 */
																							obj_t BgL_arg3317z00_1339;

																							BgL_arg3317z00_1339 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg3316z00_1338 =
																								MAKE_PAIR(
																								(obj_t) (BgL_arg3313z00_1335),
																								BgL_arg3317z00_1339);
																						}
																						BgL_list3315z00_1337 =
																							MAKE_PAIR(
																							(obj_t) (BgL_arg3312z00_1334),
																							BgL_arg3316z00_1338);
																					}
																					BgL_arg3310z00_1332 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3311z00_1333,
																						BgL_list3315z00_1337);
																			}}
																			BgL_arg3301z00_1323 =
																				MAKE_PAIR(BgL_arg3309z00_1331,
																				BgL_arg3310z00_1332);
																		}
																		{	/* Coerce/funcall.scm 66 */
																			obj_t BgL_list3303z00_1325;

																			{	/* Coerce/funcall.scm 66 */
																				obj_t BgL_arg3304z00_1326;

																				BgL_arg3304z00_1326 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list3303z00_1325 =
																					MAKE_PAIR(BgL_arg3301z00_1323,
																					BgL_arg3304z00_1326);
																			}
																			BgL_arg3299z00_1321 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg3300z00_1322,
																				BgL_list3303z00_1325);
																	}}
																	BgL_arg3297z00_1319 =
																		MAKE_PAIR(BgL_arg3298z00_1320,
																		BgL_arg3299z00_1321);
																}
																BgL_arg3294z00_1316 =
																	BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_arg3297z00_1319, BgL_locz00_1308);
															}
															BgL_lnodez00_1312 =
																BGl_makezd2letzd2varz00zzast_nodez00
																(BgL_locz00_1308,
																(BgL_typez00_bglt)
																(BGl_za2objza2z00zztype_cachez00), BUNSPEC,
																BINT(((long) -1)), BgL_arg3293z00_1315,
																BgL_arg3294z00_1316, ((bool_t) 1));
														}
														{	/* Coerce/funcall.scm 61 */

															{	/* Coerce/funcall.scm 76 */
																BgL_varz00_bglt BgL_arg3291z00_1313;

																BgL_arg3291z00_1313 =
																	BGl_makezd2varzd2zzast_nodez00
																	(BgL_locz00_1308,
																	(BgL_typez00_bglt)
																	(BGl_za2objza2z00zztype_cachez00),
																	(BgL_variablez00_bglt) (BgL_funz00_1307));
																{
																	BgL_nodez00_bglt BgL_auxz00_1680;

																	BgL_auxz00_1680 =
																		(BgL_nodez00_bglt) (BgL_arg3291z00_1313);
																	((((BgL_funcallz00_bglt)
																				CREF(BgL_nodez00_1297))->BgL_funz00) =
																		((BgL_nodez00_bglt) BgL_auxz00_1680),
																		BUNSPEC);
															}}
															return (obj_t) (BgL_lnodez00_1312);
														}
													}
												}
											}
										}
									}
								}
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_funcallz00()
	{
		AN_OBJECT;
		{	/* Coerce/funcall.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 77938009),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_localz00(((long) 499216671),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			BGl_modulezd2initializa7ationz75zzcoerce_coercez00(((long) 387636515),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
			return
				BGl_modulezd2initializa7ationz75zzcoerce_convertz00(((long) 65499856),
				BSTRING_TO_STRING(BGl_string3353z00zzcoerce_funcallz00));
		}
	}

#ifdef __cplusplus
}
#endif
