/*===========================================================================*/
/*   (Engine/heap.scm)                                                       */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Engine/heap.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
	}                *BgL_tclassz00_bglt;


	static obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t);
	static obj_t BGl_zc3anonymousza32371ze3z83zzengine_heapz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_setzd2genvz12zc0zzast_envz00(obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzengine_heapz00 = BUNSPEC;
	static obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t);
	extern obj_t BGl_tclassz00zzobject_classz00;
	static obj_t BGl_genericzd2initzd2zzengine_heapz00();
	BGL_EXPORTED_DECL obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t);
	extern obj_t BGl_initializa7ezd2Tenvz12z67zztype_envz00();
	static obj_t BGl_cnstzd2initzd2zzengine_heapz00();
	extern obj_t BGl_setzd2backendz12zc0zzbackend_backendz00(obj_t);
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00();
	extern obj_t BGl_setzd2tenvz12zc0zztype_envz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2libzd2dirza2zd2zzengine_paramz00;
	BGL_IMPORT obj_t BGl_hashtablezd2forzd2eachz00zz__hashz00(obj_t, obj_t);
	BGL_IMPORT obj_t bgl_display_string(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32443ze3z83zzengine_heapz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzheap_restorez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzread_jvmz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__binaryz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t close_binary_port(obj_t);
	BGL_IMPORT obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00(obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	static obj_t BGl_zc3exitza32320ze3z83zzengine_heapz00(obj_t, obj_t);
	static obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t);
	static obj_t BGl_zc3anonymousza32341ze3z83zzengine_heapz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_za2targetzd2languageza2zd2zzengine_paramz00;
	extern obj_t BGl_addzd2genvz12zc0zzast_envz00(obj_t);
	extern obj_t BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00(obj_t);
	BGL_IMPORT obj_t input_obj(obj_t);
	static obj_t BGl_zc3anonymousza32348ze3z83zzengine_heapz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza32355ze3z83zzengine_heapz00(obj_t);
	extern obj_t BGl_heapzd2modulezd2listz00zzheap_restorez00(obj_t);
	static obj_t BGl__dumpzd2heapszd2zzengine_heapz00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
	extern obj_t BGl_initializa7ezd2Genvz12z67zzast_envz00();
	static obj_t BGl_methodzd2initzd2zzengine_heapz00();
	extern obj_t BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(obj_t, obj_t,
		obj_t);
	static obj_t __cnst[14];


	   
		 
		DEFINE_STRING(BGl_string2515z00zzengine_heapz00,
		BgL_bgl_string2515za700za7za7e2536za7, "Cannot open heap file ~s", 24);
	      DEFINE_STRING(BGl_string2516z00zzengine_heapz00,
		BgL_bgl_string2516za700za7za7e2537za7, "Corrupted heap", 14);
	      DEFINE_STRING(BGl_string2520z00zzengine_heapz00,
		BgL_bgl_string2520za700za7za7e2538za7, "\"", 1);
	      DEFINE_STRING(BGl_string2519z00zzengine_heapz00,
		BgL_bgl_string2519za700za7za7e2539za7, "(heap \"", 7);
	      DEFINE_STRING(BGl_string2521z00zzengine_heapz00,
		BgL_bgl_string2521za700za7za7e2540za7, " (variables", 11);
	      DEFINE_STRING(BGl_string2522z00zzengine_heapz00,
		BgL_bgl_string2522za700za7za7e2541za7, " )\n", 3);
	      DEFINE_STRING(BGl_string2523z00zzengine_heapz00,
		BgL_bgl_string2523za700za7za7e2542za7, " (types", 7);
	      DEFINE_STRING(BGl_string2524z00zzengine_heapz00,
		BgL_bgl_string2524za700za7za7e2543za7, " )", 2);
	      DEFINE_STRING(BGl_string2525z00zzengine_heapz00,
		BgL_bgl_string2525za700za7za7e2544za7, " (includes", 10);
	      DEFINE_STRING(BGl_string2526z00zzengine_heapz00,
		BgL_bgl_string2526za700za7za7e2545za7, ")\n", 2);
	      DEFINE_STRING(BGl_string2528z00zzengine_heapz00,
		BgL_bgl_string2528za700za7za7e2546za7, "   ", 3);
	      DEFINE_STRING(BGl_string2530z00zzengine_heapz00,
		BgL_bgl_string2530za700za7za7e2547za7, "", 0);
	      DEFINE_STRING(BGl_string2529z00zzengine_heapz00,
		BgL_bgl_string2529za700za7za7e2548za7, "\n    ", 5);
	      DEFINE_STRING(BGl_string2532z00zzengine_heapz00,
		BgL_bgl_string2532za700za7za7e2549za7, "engine_heap", 11);
	      DEFINE_STRING(BGl_string2533z00zzengine_heapz00,
		BgL_bgl_string2533za700za7za7e2550za7,
		"type super class jvm-type-name inline sifun qualified-type name module id variable native function dump-heap ",
		109);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_dumpzd2heapszd2envz00zzengine_heapz00,
		BgL_bgl__dumpza7d2heapsza7d22551z00, BGl__dumpzd2heapszd2zzengine_heapz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2517z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322552z00,
		BGl_zc3anonymousza32341ze3z83zzengine_heapz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2518z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322553z00,
		BGl_zc3anonymousza32348ze3z83zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2527z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322554z00,
		BGl_zc3anonymousza32371ze3z83zzengine_heapz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2531z00zzengine_heapz00,
		BgL_bgl_za7c3anonymousza7a322555z00,
		BGl_zc3anonymousza32443ze3z83zzengine_heapz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzengine_heapz00(long
		BgL_checksumz00_1008, char *BgL_fromz00_1009)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzengine_heapz00))
				{
					BGl_requirezd2initializa7ationz75zzengine_heapz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzengine_heapz00();
					BGl_cnstzd2initzd2zzengine_heapz00();
					BGl_importedzd2moduleszd2initz00zzengine_heapz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"engine_heap");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__hashz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__binaryz00(((long) 0), "engine_heap");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"engine_heap");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			{	/* Engine/heap.scm 15 */
				obj_t BgL_cportz00_1000;

				BgL_cportz00_1000 =
					bgl_open_input_string(BGl_string2533z00zzengine_heapz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1001;

					BgL_iz00_1001 = ((long) 13);
				BgL_loopz00_1002:
					if ((BgL_iz00_1001 == ((long) -1)))
						{	/* Engine/heap.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Engine/heap.scm 15 */
							{	/* Engine/heap.scm 15 */
								obj_t BgL_arg2535z00_1004;

								{	/* Engine/heap.scm 15 */

									{	/* Engine/heap.scm 15 */
										obj_t BgL_locationz00_1006;

										BgL_locationz00_1006 = BBOOL(((bool_t) 0));
										{	/* Engine/heap.scm 15 */

											BgL_arg2535z00_1004 =
												BGl_readz00zz__readerz00(BgL_cportz00_1000,
												BgL_locationz00_1006);
										}
									}
								}
								{	/* Engine/heap.scm 15 */
									int BgL_auxz00_1032;

									BgL_auxz00_1032 = (int) (BgL_iz00_1001);
									CNST_TABLE_SET(BgL_auxz00_1032, BgL_arg2535z00_1004);
							}}
							{	/* Engine/heap.scm 15 */
								int BgL_auxz00_1007;

								BgL_auxz00_1007 = (int) ((BgL_iz00_1001 - ((long) 1)));
								{
									long BgL_iz00_1037;

									BgL_iz00_1037 = (long) (BgL_auxz00_1007);
									BgL_iz00_1001 = BgL_iz00_1037;
									goto BgL_loopz00_1002;
								}
							}
						}
				}
			}
		}
	}



/* dump-heaps */
	BGL_EXPORTED_DEF obj_t BGl_dumpzd2heapszd2zzengine_heapz00(obj_t
		BgL_namesz00_1)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 33 */
			BGl_setzd2backendz12zc0zzbackend_backendz00
				(BGl_za2targetzd2languageza2zd2zzengine_paramz00);
			BGl_initializa7ezd2Genvz12z67zzast_envz00();
			BGl_initializa7ezd2Tenvz12z67zztype_envz00();
			{
				obj_t BgL_l2272z00_471;

				{	/* Engine/heap.scm 40 */
					bool_t BgL_auxz00_1042;

					BgL_l2272z00_471 = BgL_namesz00_1;
				BgL_forzd2each2273zd2_472:
					if (PAIRP(BgL_l2272z00_471))
						{	/* Engine/heap.scm 40 */
							BGl_dumpzd2heapzd2zzengine_heapz00(CAR(BgL_l2272z00_471));
							{
								obj_t BgL_l2272z00_1047;

								BgL_l2272z00_1047 = CDR(BgL_l2272z00_471);
								BgL_l2272z00_471 = BgL_l2272z00_1047;
								goto BgL_forzd2each2273zd2_472;
							}
						}
					else
						{	/* Engine/heap.scm 40 */
							BgL_auxz00_1042 = ((bool_t) 1);
						}
					return BBOOL(BgL_auxz00_1042);
				}
			}
		}
	}



/* _dump-heaps */
	obj_t BGl__dumpzd2heapszd2zzengine_heapz00(obj_t BgL_envz00_974,
		obj_t BgL_namesz00_975)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 33 */
			return BGl_dumpzd2heapszd2zzengine_heapz00(BgL_namesz00_975);
		}
	}



/* dump-heap */
	obj_t BGl_dumpzd2heapzd2zzengine_heapz00(obj_t BgL_heapz00_2)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 45 */
			{	/* Engine/heap.scm 46 */
				obj_t BgL_fnamez00_476;

				BgL_fnamez00_476 =
					BGl_findzd2filezf2pathz20zz__osz00(BgL_heapz00_2,
					BGl_za2libzd2dirza2zd2zzengine_paramz00);
				if (STRINGP(BgL_fnamez00_476))
					{	/* Engine/heap.scm 48 */
						obj_t BgL_portz00_478;

						BgL_portz00_478 =
							BGl_openzd2inputzd2binaryzd2filezd2zz__binaryz00
							(BgL_fnamez00_476);
						if (BINARY_PORTP(BgL_portz00_478))
							{	/* Engine/heap.scm 53 */
								obj_t BgL_val2266z00_480;

								BgL_val2266z00_480 =
									BGl_zc3exitza32320ze3z83zzengine_heapz00(BgL_heapz00_2,
									BgL_portz00_478);
								close_binary_port(BgL_portz00_478);
								if (CBOOL(BGl_valzd2fromzd2exitzf3zf3zz__bexitz00
										(BgL_val2266z00_480)))
									{	/* Engine/heap.scm 113 */
										return
											BGl_unwindzd2untilz12zc0zz__bexitz00(CAR
											(BgL_val2266z00_480), CDR(BgL_val2266z00_480));
									}
								else
									{	/* Engine/heap.scm 113 */
										return BgL_val2266z00_480;
									}
							}
						else
							{	/* Engine/heap.scm 50 */
								obj_t BgL_arg2366z00_547;

								obj_t BgL_arg2367z00_548;

								BgL_arg2366z00_547 = CNST_TABLE_REF(((long) 0));
								{	/* Engine/heap.scm 51 */
									obj_t BgL_list2368z00_549;

									BgL_list2368z00_549 = MAKE_PAIR(BgL_fnamez00_476, BNIL);
									BgL_arg2367z00_548 =
										BGl_formatz00zz__r4_output_6_10_3z00
										(BGl_string2515z00zzengine_heapz00, BgL_list2368z00_549);
								}
								return
									BGl_errorz00zz__errorz00(BgL_arg2366z00_547,
									BgL_arg2367z00_548, BGl_za2libzd2dirza2zd2zzengine_paramz00);
							}
					}
				else
					{	/* Engine/heap.scm 114 */
						obj_t BgL_mz00_550;

						{	/* Engine/heap.scm 114 */
							obj_t BgL_list2369z00_551;

							BgL_list2369z00_551 = MAKE_PAIR(BgL_heapz00_2, BNIL);
							BgL_mz00_550 =
								BGl_formatz00zz__r4_output_6_10_3z00
								(BGl_string2515z00zzengine_heapz00, BgL_list2369z00_551);
						}
						BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)), BgL_mz00_550,
							BGl_za2libzd2dirza2zd2zzengine_paramz00);
						return BFALSE;
					}
			}
		}
	}



/* <exit:2320> */
	obj_t BGl_zc3exitza32320ze3z83zzengine_heapz00(obj_t BgL_heapz00_998,
		obj_t BgL_portz00_997)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 113 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit2267z00_485;

			{
				BGL_STORE_TRACE();
				if (SET_EXIT(BgL_an_exit2267z00_485))
					{
						BGL_RESTORE_TRACE();
						return _exit_value_;
					}
				else
					{
						BgL_an_exit2267z00_485 = (void *) jmpbuf;
						{	/* Engine/heap.scm 113 */

							PUSH_EXIT(BgL_an_exit2267z00_485, ((long) 0));
							{	/* Engine/heap.scm 54 */
								obj_t BgL_val2268z00_486;

								{	/* Engine/heap.scm 54 */
									obj_t BgL_envsz00_487;

									BgL_envsz00_487 = input_obj(BgL_portz00_997);
									{	/* Engine/heap.scm 54 */
										obj_t BgL__z00_488;

										{	/* Engine/heap.scm 55 */
											bool_t BgL_testz00_1077;

											{	/* Engine/heap.scm 55 */
												bool_t BgL_testz00_1078;

												{	/* Engine/heap.scm 55 */
													obj_t BgL_v2274z00_546;

													BgL_v2274z00_546 = create_vector((int) (((long) 1)));
													VECTOR_SET(BgL_v2274z00_546,
														(int) (((long) 0)), BgL_envsz00_487);
													BgL_testz00_1078 = ((bool_t) 1);
												}
												if (BgL_testz00_1078)
													{	/* Engine/heap.scm 56 */
														bool_t BgL__ortest_2269z00_541;

														{	/* Engine/heap.scm 56 */
															int BgL_arg2364z00_544;

															BgL_arg2364z00_544 =
																VECTOR_LENGTH(BgL_envsz00_487);
															BgL__ortest_2269z00_541 =
																((long) (BgL_arg2364z00_544) == ((long) 5));
														}
														if (BgL__ortest_2269z00_541)
															{	/* Engine/heap.scm 56 */
																BgL_testz00_1077 = BgL__ortest_2269z00_541;
															}
														else
															{	/* Engine/heap.scm 57 */
																int BgL_arg2362z00_542;

																BgL_arg2362z00_542 =
																	VECTOR_LENGTH(BgL_envsz00_487);
																BgL_testz00_1077 =
																	((long) (BgL_arg2362z00_542) == ((long) 6));
													}}
												else
													{	/* Engine/heap.scm 55 */
														BgL_testz00_1077 = ((bool_t) 0);
													}
											}
											if (BgL_testz00_1077)
												{	/* Engine/heap.scm 55 */
													BgL__z00_488 = BFALSE;
												}
											else
												{	/* Engine/heap.scm 55 */
													BgL__z00_488 =
														BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
														BGl_string2516z00zzengine_heapz00, BgL_heapz00_998);
										}}
										{	/* Engine/heap.scm 55 */
											obj_t BgL_targetz00_489;

											BgL_targetz00_489 =
												VECTOR_REF(BgL_envsz00_487, (int) (((long) 0)));
											{	/* Engine/heap.scm 59 */
												obj_t BgL_versionz00_490;

												BgL_versionz00_490 =
													VECTOR_REF(BgL_envsz00_487, (int) (((long) 1)));
												{	/* Engine/heap.scm 60 */
													obj_t BgL_specificz00_491;

													BgL_specificz00_491 =
														VECTOR_REF(BgL_envsz00_487, (int) (((long) 2)));
													{	/* Engine/heap.scm 61 */
														obj_t BgL_genvz00_492;

														BgL_genvz00_492 =
															VECTOR_REF(BgL_envsz00_487, (int) (((long) 3)));
														{	/* Engine/heap.scm 62 */
															obj_t BgL_tenvz00_493;

															BgL_tenvz00_493 =
																VECTOR_REF(BgL_envsz00_487, (int) (((long) 4)));
															{	/* Engine/heap.scm 63 */
																obj_t BgL_includesz00_494;

																{	/* Engine/heap.scm 64 */
																	bool_t BgL_testz00_1102;

																	{	/* Engine/heap.scm 64 */
																		int BgL_arg2358z00_537;

																		BgL_arg2358z00_537 =
																			VECTOR_LENGTH(BgL_envsz00_487);
																		BgL_testz00_1102 =
																			(
																			(long) (BgL_arg2358z00_537) ==
																			((long) 6));
																	}
																	if (BgL_testz00_1102)
																		{	/* Engine/heap.scm 64 */
																			BgL_includesz00_494 =
																				VECTOR_REF(BgL_envsz00_487,
																				(int) (((long) 5)));
																		}
																	else
																		{	/* Engine/heap.scm 64 */
																			BgL_includesz00_494 = BNIL;
																		}
																}
																{	/* Engine/heap.scm 64 */

																	{	/* Engine/heap.scm 76 */
																		bool_t BgL_testz00_1108;

																		{	/* Engine/heap.scm 76 */
																			int BgL_arg2327z00_496;

																			BgL_arg2327z00_496 =
																				VECTOR_LENGTH(BgL_envsz00_487);
																			BgL_testz00_1108 =
																				(
																				(long) (BgL_arg2327z00_496) ==
																				((long) 6));
																		}
																		if (BgL_testz00_1108)
																			{	/* Engine/heap.scm 76 */
																				BGl_addzd2genvz12zc0zzast_envz00
																					(BgL_genvz00_492);
																			}
																		else
																			{	/* Engine/heap.scm 76 */
																				BGl_setzd2tenvz12zc0zztype_envz00
																					(BgL_tenvz00_493);
																				BGl_setzd2genvz12zc0zzast_envz00
																					(BgL_genvz00_492);
																			}
																	}
																	{	/* Engine/heap.scm 85 */
																		bool_t BgL_testz00_1115;

																		{	/* Engine/heap.scm 85 */
																			obj_t BgL_arg2346z00_508;

																			BgL_arg2346z00_508 =
																				BGl_thezd2backendzd2zzbackend_backendz00
																				();
																			{
																				BgL_backendz00_bglt BgL_auxz00_1117;

																				BgL_auxz00_1117 =
																					(BgL_backendz00_bglt)
																					(BgL_arg2346z00_508);
																				BgL_testz00_1115 =
																					(((BgL_backendz00_bglt)
																						CREF(BgL_auxz00_1117))->
																					BgL_qualifiedzd2typeszd2);
																			}
																		}
																		if (BgL_testz00_1115)
																			{	/* Engine/heap.scm 85 */
																				BGl_forzd2eachzd2globalz12z12zzast_envz00
																					(BGl_proc2517z00zzengine_heapz00,
																					BNIL);
																			}
																		else
																			{	/* Engine/heap.scm 85 */
																				BFALSE;
																			}
																	}
																	BGl_hashtablezd2forzd2eachz00zz__hashz00
																		(BgL_genvz00_492,
																		BGl_proc2518z00zzengine_heapz00);
																	{	/* Engine/heap.scm 99 */
																		obj_t BgL_arg2353z00_522;

																		{	/* Engine/heap.scm 99 */
																			obj_t BgL_res2502z00_876;

																			{	/* Engine/heap.scm 99 */
																				obj_t BgL_auxz00_1122;

																				BgL_auxz00_1122 =
																					BGL_CURRENT_DYNAMIC_ENV();
																				BgL_res2502z00_876 =
																					BGL_ENV_CURRENT_ERROR_PORT
																					(BgL_auxz00_1122);
																			}
																			BgL_arg2353z00_522 = BgL_res2502z00_876;
																		}
																		{	/* Engine/heap.scm 101 */
																			obj_t BgL_zc3anonymousza32355ze3z83_976;

																			BgL_zc3anonymousza32355ze3z83_976 =
																				make_fx_procedure
																				(BGl_zc3anonymousza32355ze3z83zzengine_heapz00,
																				(int) (((long) 0)), (int) (((long) 4)));
																			PROCEDURE_SET
																				(BgL_zc3anonymousza32355ze3z83_976,
																				(int) (((long) 0)), BgL_heapz00_998);
																			PROCEDURE_SET
																				(BgL_zc3anonymousza32355ze3z83_976,
																				(int) (((long) 1)), BgL_genvz00_492);
																			PROCEDURE_SET
																				(BgL_zc3anonymousza32355ze3z83_976,
																				(int) (((long) 2)), BgL_tenvz00_493);
																			PROCEDURE_SET
																				(BgL_zc3anonymousza32355ze3z83_976,
																				(int) (((long) 3)),
																				BgL_includesz00_494);
																			BgL_val2268z00_486 =
																				BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00
																				(BgL_arg2353z00_522,
																				BgL_zc3anonymousza32355ze3z83_976);
								}}}}}}}}}}}
								POP_EXIT();
								return BgL_val2268z00_486;
							}
						}
					}
			}
		}
	}



/* <anonymous:2355> */
	obj_t BGl_zc3anonymousza32355ze3z83zzengine_heapz00(obj_t BgL_envz00_979)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 100 */
			{	/* Engine/heap.scm 101 */
				obj_t BgL_heapz00_980;

				obj_t BgL_genvz00_981;

				obj_t BgL_tenvz00_982;

				obj_t BgL_includesz00_983;

				BgL_heapz00_980 = PROCEDURE_REF(BgL_envz00_979, (int) (((long) 0)));
				BgL_genvz00_981 = PROCEDURE_REF(BgL_envz00_979, (int) (((long) 1)));
				BgL_tenvz00_982 = PROCEDURE_REF(BgL_envz00_979, (int) (((long) 2)));
				BgL_includesz00_983 = PROCEDURE_REF(BgL_envz00_979, (int) (((long) 3)));
				{

					{	/* Engine/heap.scm 101 */
						obj_t BgL_port2278z00_525;

						{	/* Engine/heap.scm 101 */
							obj_t BgL_res2503z00_878;

							{	/* Engine/heap.scm 101 */
								obj_t BgL_auxz00_1146;

								BgL_auxz00_1146 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2503z00_878 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1146);
							}
							BgL_port2278z00_525 = BgL_res2503z00_878;
						}
						bgl_display_string(BGl_string2519z00zzengine_heapz00,
							BgL_port2278z00_525);
						bgl_display_obj(BgL_heapz00_980, BgL_port2278z00_525);
						bgl_display_string(BGl_string2520z00zzengine_heapz00,
							BgL_port2278z00_525);
						bgl_display_char(((unsigned char) '\n'), BgL_port2278z00_525);
					}
					{	/* Engine/heap.scm 102 */
						obj_t BgL_port2279z00_526;

						{	/* Engine/heap.scm 102 */
							obj_t BgL_res2504z00_885;

							{	/* Engine/heap.scm 102 */
								obj_t BgL_auxz00_1153;

								BgL_auxz00_1153 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2504z00_885 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1153);
							}
							BgL_port2279z00_526 = BgL_res2504z00_885;
						}
						bgl_display_string(BGl_string2521z00zzengine_heapz00,
							BgL_port2279z00_526);
						bgl_display_char(((unsigned char) '\n'), BgL_port2279z00_526);
					}
					BGl_dumpzd2Genvzd2zzengine_heapz00(BgL_genvz00_981);
					{	/* Engine/heap.scm 104 */
						obj_t BgL_port2280z00_527;

						{	/* Engine/heap.scm 104 */
							obj_t BgL_res2505z00_890;

							{	/* Engine/heap.scm 104 */
								obj_t BgL_auxz00_1159;

								BgL_auxz00_1159 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2505z00_890 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1159);
							}
							BgL_port2280z00_527 = BgL_res2505z00_890;
						}
						bgl_display_string(BGl_string2522z00zzengine_heapz00,
							BgL_port2280z00_527);
						bgl_display_char(((unsigned char) '\n'), BgL_port2280z00_527);
					}
					{	/* Engine/heap.scm 105 */
						obj_t BgL_port2281z00_528;

						{	/* Engine/heap.scm 105 */
							obj_t BgL_res2506z00_895;

							{	/* Engine/heap.scm 105 */
								obj_t BgL_auxz00_1164;

								BgL_auxz00_1164 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2506z00_895 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1164);
							}
							BgL_port2281z00_528 = BgL_res2506z00_895;
						}
						bgl_display_string(BGl_string2523z00zzengine_heapz00,
							BgL_port2281z00_528);
						bgl_display_char(((unsigned char) '\n'), BgL_port2281z00_528);
					}
					BGl_dumpzd2Tenvzd2zzengine_heapz00(BgL_tenvz00_982);
					{	/* Engine/heap.scm 107 */
						obj_t BgL_port2282z00_529;

						{	/* Engine/heap.scm 107 */
							obj_t BgL_res2507z00_900;

							{	/* Engine/heap.scm 107 */
								obj_t BgL_auxz00_1170;

								BgL_auxz00_1170 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2507z00_900 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1170);
							}
							BgL_port2282z00_529 = BgL_res2507z00_900;
						}
						bgl_display_string(BGl_string2524z00zzengine_heapz00,
							BgL_port2282z00_529);
						bgl_display_char(((unsigned char) '\n'), BgL_port2282z00_529);
					}
					if (PAIRP(BgL_includesz00_983))
						{	/* Engine/heap.scm 108 */
							{	/* Engine/heap.scm 109 */
								obj_t BgL_port2283z00_531;

								{	/* Engine/heap.scm 109 */
									obj_t BgL_res2508z00_906;

									{	/* Engine/heap.scm 109 */
										obj_t BgL_auxz00_1177;

										BgL_auxz00_1177 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2508z00_906 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1177);
									}
									BgL_port2283z00_531 = BgL_res2508z00_906;
								}
								bgl_display_string(BGl_string2525z00zzengine_heapz00,
									BgL_port2283z00_531);
								bgl_display_char(((unsigned char) '\n'), BgL_port2283z00_531);
							}
							{	/* Engine/heap.scm 110 */
								obj_t BgL_port2284z00_532;

								{	/* Engine/heap.scm 110 */
									obj_t BgL_res2509z00_911;

									{	/* Engine/heap.scm 110 */
										obj_t BgL_auxz00_1182;

										BgL_auxz00_1182 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2509z00_911 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1182);
									}
									BgL_port2284z00_532 = BgL_res2509z00_911;
								}
								bgl_display_obj(BgL_includesz00_983, BgL_port2284z00_532);
								bgl_display_char(((unsigned char) '\n'), BgL_port2284z00_532);
							}
							{	/* Engine/heap.scm 111 */
								obj_t BgL_port2285z00_533;

								{	/* Engine/heap.scm 111 */
									obj_t BgL_res2510z00_914;

									{	/* Engine/heap.scm 111 */
										obj_t BgL_auxz00_1187;

										BgL_auxz00_1187 = BGL_CURRENT_DYNAMIC_ENV();
										BgL_res2510z00_914 =
											BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1187);
									}
									BgL_port2285z00_533 = BgL_res2510z00_914;
								}
								bgl_display_string(BGl_string2524z00zzengine_heapz00,
									BgL_port2285z00_533);
								bgl_display_char(((unsigned char) '\n'), BgL_port2285z00_533);
						}}
					else
						{	/* Engine/heap.scm 108 */
							BFALSE;
						}
					{	/* Engine/heap.scm 112 */
						obj_t BgL_port2286z00_534;

						{	/* Engine/heap.scm 112 */
							obj_t BgL_res2511z00_919;

							{	/* Engine/heap.scm 112 */
								obj_t BgL_auxz00_1192;

								BgL_auxz00_1192 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res2511z00_919 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1192);
							}
							BgL_port2286z00_534 = BgL_res2511z00_919;
						}
						bgl_display_string(BGl_string2526z00zzengine_heapz00,
							BgL_port2286z00_534);
						return bgl_display_char(((unsigned char) '\n'),
							BgL_port2286z00_534);
		}}}}
	}



/* <anonymous:2348> */
	obj_t BGl_zc3anonymousza32348ze3z83zzengine_heapz00(obj_t BgL_envz00_984,
		obj_t BgL_kz00_985, obj_t BgL_bucketz00_986)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 95 */
			{
				obj_t BgL_kz00_510;

				obj_t BgL_bucketz00_511;

				{	/* Engine/heap.scm 96 */
					bool_t BgL_auxz00_1197;

					BgL_kz00_510 = BgL_kz00_985;
					BgL_bucketz00_511 = BgL_bucketz00_986;
					{	/* Engine/heap.scm 96 */
						obj_t BgL_g2277z00_513;

						BgL_g2277z00_513 = CDR(BgL_bucketz00_511);
						{
							obj_t BgL_l2275z00_514;

							BgL_l2275z00_514 = BgL_g2277z00_513;
						BgL_forzd2each2276zd2_515:
							if (PAIRP(BgL_l2275z00_514))
								{	/* Engine/heap.scm 98 */
									{	/* Engine/heap.scm 97 */
										obj_t BgL_newz00_517;

										BgL_newz00_517 = CAR(BgL_l2275z00_514);
										{	/* Engine/heap.scm 97 */
											obj_t BgL_arg2350z00_518;

											{
												BgL_globalz00_bglt BgL_auxz00_1202;

												BgL_auxz00_1202 = (BgL_globalz00_bglt) (BgL_newz00_517);
												BgL_arg2350z00_518 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1202))->
													BgL_modulez00);
											}
											{	/* Engine/heap.scm 97 */
												obj_t BgL_list2351z00_519;

												BgL_list2351z00_519 =
													MAKE_PAIR(BgL_arg2350z00_518, BNIL);
												BGl_heapzd2modulezd2listz00zzheap_restorez00
													(BgL_list2351z00_519);
											}
										}
									}
									{
										obj_t BgL_l2275z00_1207;

										BgL_l2275z00_1207 = CDR(BgL_l2275z00_514);
										BgL_l2275z00_514 = BgL_l2275z00_1207;
										goto BgL_forzd2each2276zd2_515;
									}
								}
							else
								{	/* Engine/heap.scm 98 */
									BgL_auxz00_1197 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_1197);
				}
			}
		}
	}



/* <anonymous:2341> */
	obj_t BGl_zc3anonymousza32341ze3z83zzengine_heapz00(obj_t BgL_envz00_987,
		obj_t BgL_newz00_988)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 87 */
			{
				obj_t BgL_newz00_501;

				BgL_newz00_501 = BgL_newz00_988;
				{	/* Engine/heap.scm 89 */
					obj_t BgL_arg2342z00_503;

					obj_t BgL_arg2343z00_504;

					obj_t BgL_arg2344z00_505;

					{
						BgL_globalz00_bglt BgL_auxz00_1210;

						BgL_auxz00_1210 = (BgL_globalz00_bglt) (BgL_newz00_501);
						BgL_arg2342z00_503 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1210))->BgL_modulez00);
					}
					{
						BgL_globalz00_bglt BgL_auxz00_1213;

						BgL_auxz00_1213 = (BgL_globalz00_bglt) (BgL_newz00_501);
						BgL_arg2343z00_504 =
							(((BgL_globalz00_bglt) CREF(BgL_auxz00_1213))->
							BgL_jvmzd2typezd2namez00);
					}
					BgL_arg2344z00_505 = BGl_shapez00zztools_shapez00(BgL_newz00_501);
					{	/* Engine/heap.scm 88 */
						obj_t BgL_list2345z00_506;

						BgL_list2345z00_506 = MAKE_PAIR(BgL_arg2344z00_505, BNIL);
						return
							BGl_addzd2qualifiedzd2typez12z12zzread_jvmz00(BgL_arg2342z00_503,
							BgL_arg2343z00_504, BgL_list2345z00_506);
					}
				}
			}
		}
	}



/* dump-Genv */
	obj_t BGl_dumpzd2Genvzd2zzengine_heapz00(obj_t BgL_genvz00_3)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 121 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_genvz00_3,
				BGl_proc2527z00zzengine_heapz00);
		}
	}



/* <anonymous:2371> */
	obj_t BGl_zc3anonymousza32371ze3z83zzengine_heapz00(obj_t BgL_envz00_990,
		obj_t BgL_kz00_991, obj_t BgL_bucketz00_992)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 152 */
			{
				obj_t BgL_kz00_554;

				obj_t BgL_bucketz00_555;

				{	/* Engine/heap.scm 152 */
					bool_t BgL_auxz00_1220;

					BgL_kz00_554 = BgL_kz00_991;
					BgL_bucketz00_555 = BgL_bucketz00_992;
					{
						obj_t BgL_newz00_564;

						{	/* Engine/heap.scm 152 */
							obj_t BgL_g2290z00_557;

							BgL_g2290z00_557 = CDR(BgL_bucketz00_555);
							{
								obj_t BgL_l2288z00_558;

								BgL_l2288z00_558 = BgL_g2290z00_557;
							BgL_forzd2each2289zd2_559:
								if (PAIRP(BgL_l2288z00_558))
									{	/* Engine/heap.scm 152 */
										BgL_newz00_564 = CAR(BgL_l2288z00_558);
										{	/* Engine/heap.scm 123 */
											obj_t BgL_modulez00_566;

											{
												BgL_globalz00_bglt BgL_auxz00_1224;

												BgL_auxz00_1224 = (BgL_globalz00_bglt) (BgL_newz00_564);
												BgL_modulez00_566 =
													(((BgL_globalz00_bglt) CREF(BgL_auxz00_1224))->
													BgL_modulez00);
											}
											{	/* Engine/heap.scm 123 */
												obj_t BgL_idz00_567;

												{
													BgL_variablez00_bglt BgL_auxz00_1227;

													BgL_auxz00_1227 =
														(BgL_variablez00_bglt) (BgL_newz00_564);
													BgL_idz00_567 =
														(((BgL_variablez00_bglt) CREF(BgL_auxz00_1227))->
														BgL_idz00);
												}
												{	/* Engine/heap.scm 124 */
													obj_t BgL_qtz00_568;

													BgL_qtz00_568 =
														BGl_modulezd2ze3qualifiedzd2typeze3zzread_jvmz00
														(BgL_modulez00_566);
													{	/* Engine/heap.scm 125 */
														obj_t BgL_jtz00_569;

														{
															BgL_globalz00_bglt BgL_auxz00_1231;

															BgL_auxz00_1231 =
																(BgL_globalz00_bglt) (BgL_newz00_564);
															BgL_jtz00_569 =
																(((BgL_globalz00_bglt) CREF(BgL_auxz00_1231))->
																BgL_jvmzd2typezd2namez00);
														}
														{	/* Engine/heap.scm 126 */
															BgL_valuez00_bglt BgL_valz00_570;

															{
																BgL_variablez00_bglt BgL_auxz00_1234;

																BgL_auxz00_1234 =
																	(BgL_variablez00_bglt) (BgL_newz00_564);
																BgL_valz00_570 =
																	(((BgL_variablez00_bglt)
																		CREF(BgL_auxz00_1234))->BgL_valuez00);
															}
															{	/* Engine/heap.scm 127 */
																obj_t BgL_kindz00_571;

																{	/* Engine/heap.scm 129 */
																	bool_t BgL_testz00_1237;

																	{	/* Engine/heap.scm 129 */
																		obj_t BgL_obj1760z00_934;

																		BgL_obj1760z00_934 =
																			(obj_t) (BgL_valz00_570);
																		BgL_testz00_1237 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj1760z00_934,
																			BGl_sfunz00zzast_varz00);
																	}
																	if (BgL_testz00_1237)
																		{	/* Engine/heap.scm 129 */
																			BgL_kindz00_571 =
																				CNST_TABLE_REF(((long) 1));
																		}
																	else
																		{	/* Engine/heap.scm 130 */
																			bool_t BgL_testz00_1241;

																			{	/* Engine/heap.scm 130 */
																				obj_t BgL_obj1824z00_935;

																				BgL_obj1824z00_935 =
																					(obj_t) (BgL_valz00_570);
																				BgL_testz00_1241 =
																					BGl_iszd2azf3z21zz__objectz00
																					(BgL_obj1824z00_935,
																					BGl_cfunz00zzast_varz00);
																			}
																			if (BgL_testz00_1241)
																				{	/* Engine/heap.scm 130 */
																					BgL_kindz00_571 =
																						CNST_TABLE_REF(((long) 2));
																				}
																			else
																				{	/* Engine/heap.scm 130 */
																					BgL_kindz00_571 =
																						CNST_TABLE_REF(((long) 3));
																}}}
																{	/* Engine/heap.scm 128 */

																	{	/* Engine/heap.scm 132 */
																		obj_t BgL_port2287z00_572;

																		{	/* Engine/heap.scm 132 */
																			obj_t BgL_res2512z00_937;

																			{	/* Engine/heap.scm 132 */
																				obj_t BgL_auxz00_1246;

																				BgL_auxz00_1246 =
																					BGL_CURRENT_DYNAMIC_ENV();
																				BgL_res2512z00_937 =
																					BGL_ENV_CURRENT_OUTPUT_PORT
																					(BgL_auxz00_1246);
																			}
																			BgL_port2287z00_572 = BgL_res2512z00_937;
																		}
																		bgl_display_string
																			(BGl_string2528z00zzengine_heapz00,
																			BgL_port2287z00_572);
																		{	/* Engine/heap.scm 133 */
																			obj_t BgL_arg2376z00_573;

																			{	/* Engine/heap.scm 133 */
																				obj_t BgL_arg2377z00_574;

																				{	/* Engine/heap.scm 133 */
																					obj_t BgL_arg2378z00_575;

																					obj_t BgL_arg2380z00_577;

																					obj_t BgL_arg2382z00_579;

																					obj_t BgL_arg2384z00_581;

																					obj_t BgL_arg2386z00_583;

																					obj_t BgL_arg2387z00_584;

																					obj_t BgL_arg2388z00_585;

																					obj_t BgL_arg2390z00_587;

																					BgL_arg2378z00_575 =
																						BGl_shapez00zztools_shapez00
																						(BgL_newz00_564);
																					{	/* Engine/heap.scm 135 */
																						obj_t BgL_arg2407z00_602;

																						obj_t BgL_arg2408z00_603;

																						BgL_arg2407z00_602 =
																							CNST_TABLE_REF(((long) 4));
																						{	/* Engine/heap.scm 135 */
																							obj_t BgL_list2409z00_604;

																							BgL_list2409z00_604 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2408z00_603 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_idz00_567,
																								BgL_list2409z00_604);
																						}
																						BgL_arg2380z00_577 =
																							MAKE_PAIR(BgL_arg2407z00_602,
																							BgL_arg2408z00_603);
																					}
																					{	/* Engine/heap.scm 137 */
																						obj_t BgL_arg2410z00_605;

																						obj_t BgL_arg2411z00_606;

																						BgL_arg2410z00_605 =
																							CNST_TABLE_REF(((long) 5));
																						{	/* Engine/heap.scm 137 */
																							obj_t BgL_list2412z00_607;

																							BgL_list2412z00_607 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2411z00_606 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_modulez00_566,
																								BgL_list2412z00_607);
																						}
																						BgL_arg2382z00_579 =
																							MAKE_PAIR(BgL_arg2410z00_605,
																							BgL_arg2411z00_606);
																					}
																					{	/* Engine/heap.scm 139 */
																						obj_t BgL_arg2413z00_608;

																						obj_t BgL_arg2414z00_609;

																						BgL_arg2413z00_608 =
																							CNST_TABLE_REF(((long) 6));
																						{	/* Engine/heap.scm 139 */
																							obj_t BgL_arg2415z00_610;

																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_1260;
																								BgL_auxz00_1260 =
																									(BgL_variablez00_bglt)
																									(BgL_newz00_564);
																								BgL_arg2415z00_610 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_1260))->
																									BgL_namez00);
																							}
																							{	/* Engine/heap.scm 139 */
																								obj_t BgL_list2417z00_612;

																								BgL_list2417z00_612 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2414z00_609 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg2415z00_610,
																									BgL_list2417z00_612);
																						}}
																						BgL_arg2384z00_581 =
																							MAKE_PAIR(BgL_arg2413z00_608,
																							BgL_arg2414z00_609);
																					}
																					{	/* Engine/heap.scm 141 */
																						obj_t BgL_arg2418z00_613;

																						obj_t BgL_arg2420z00_614;

																						BgL_arg2418z00_613 =
																							CNST_TABLE_REF(((long) 7));
																						{	/* Engine/heap.scm 141 */
																							obj_t BgL_list2421z00_615;

																							BgL_list2421z00_615 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2420z00_614 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_qtz00_568,
																								BgL_list2421z00_615);
																						}
																						BgL_arg2386z00_583 =
																							MAKE_PAIR(BgL_arg2418z00_613,
																							BgL_arg2420z00_614);
																					}
																					{	/* Engine/heap.scm 142 */
																						bool_t BgL_testz00_1270;

																						{	/* Engine/heap.scm 142 */
																							bool_t BgL_testz00_1271;

																							{	/* Engine/heap.scm 142 */
																								obj_t BgL_obj1760z00_941;

																								BgL_obj1760z00_941 =
																									(obj_t) (BgL_valz00_570);
																								BgL_testz00_1271 =
																									BGl_iszd2azf3z21zz__objectz00
																									(BgL_obj1760z00_941,
																									BGl_sfunz00zzast_varz00);
																							}
																							if (BgL_testz00_1271)
																								{	/* Engine/heap.scm 142 */
																									obj_t BgL_auxz00_1274;

																									{
																										BgL_sfunz00_bglt
																											BgL_auxz00_1275;
																										BgL_auxz00_1275 =
																											(BgL_sfunz00_bglt)
																											(BgL_valz00_570);
																										BgL_auxz00_1274 =
																											(((BgL_sfunz00_bglt)
																												CREF(BgL_auxz00_1275))->
																											BgL_classz00);
																									}
																									BgL_testz00_1270 =
																										(BgL_auxz00_1274 ==
																										CNST_TABLE_REF(((long) 8)));
																								}
																							else
																								{	/* Engine/heap.scm 142 */
																									BgL_testz00_1270 =
																										((bool_t) 0);
																								}
																						}
																						if (BgL_testz00_1270)
																							{	/* Engine/heap.scm 142 */
																								BgL_arg2387z00_584 =
																									BGl_string2529z00zzengine_heapz00;
																							}
																						else
																							{	/* Engine/heap.scm 142 */
																								BgL_arg2387z00_584 =
																									BGl_string2530z00zzengine_heapz00;
																							}
																					}
																					{	/* Engine/heap.scm 145 */
																						bool_t BgL_testz00_1280;

																						{	/* Engine/heap.scm 145 */
																							bool_t BgL_testz00_1281;

																							{	/* Engine/heap.scm 145 */
																								obj_t BgL_obj1760z00_943;

																								BgL_obj1760z00_943 =
																									(obj_t) (BgL_valz00_570);
																								BgL_testz00_1281 =
																									BGl_iszd2azf3z21zz__objectz00
																									(BgL_obj1760z00_943,
																									BGl_sfunz00zzast_varz00);
																							}
																							if (BgL_testz00_1281)
																								{	/* Engine/heap.scm 145 */
																									obj_t BgL_auxz00_1284;

																									{
																										BgL_sfunz00_bglt
																											BgL_auxz00_1285;
																										BgL_auxz00_1285 =
																											(BgL_sfunz00_bglt)
																											(BgL_valz00_570);
																										BgL_auxz00_1284 =
																											(((BgL_sfunz00_bglt)
																												CREF(BgL_auxz00_1285))->
																											BgL_classz00);
																									}
																									BgL_testz00_1280 =
																										(BgL_auxz00_1284 ==
																										CNST_TABLE_REF(((long) 8)));
																								}
																							else
																								{	/* Engine/heap.scm 145 */
																									BgL_testz00_1280 =
																										((bool_t) 0);
																								}
																						}
																						if (BgL_testz00_1280)
																							{	/* Engine/heap.scm 146 */
																								obj_t BgL_arg2427z00_621;

																								obj_t BgL_arg2428z00_622;

																								BgL_arg2427z00_621 =
																									CNST_TABLE_REF(((long) 9));
																								{	/* Engine/heap.scm 146 */
																									obj_t BgL_arg2429z00_623;

																									{	/* Engine/heap.scm 146 */
																										obj_t BgL_arg2432z00_626;

																										{
																											BgL_sfunz00_bglt
																												BgL_auxz00_1291;
																											BgL_auxz00_1291 =
																												(BgL_sfunz00_bglt)
																												(BgL_valz00_570);
																											BgL_arg2432z00_626 =
																												(((BgL_sfunz00_bglt)
																													CREF
																													(BgL_auxz00_1291))->
																												BgL_bodyz00);
																										}
																										BgL_arg2429z00_623 =
																											BGl_shapez00zztools_shapez00
																											(BgL_arg2432z00_626);
																									}
																									{	/* Engine/heap.scm 146 */
																										obj_t BgL_list2431z00_625;

																										BgL_list2431z00_625 =
																											MAKE_PAIR(BNIL, BNIL);
																										BgL_arg2428z00_622 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2429z00_623,
																											BgL_list2431z00_625);
																								}}
																								BgL_arg2388z00_585 =
																									MAKE_PAIR(BgL_arg2427z00_621,
																									BgL_arg2428z00_622);
																							}
																						else
																							{	/* Engine/heap.scm 145 */
																								BgL_arg2388z00_585 =
																									BGl_string2530z00zzengine_heapz00;
																							}
																					}
																					{	/* Engine/heap.scm 149 */
																						obj_t BgL_arg2437z00_630;

																						obj_t BgL_arg2438z00_631;

																						BgL_arg2437z00_630 =
																							CNST_TABLE_REF(((long) 10));
																						{	/* Engine/heap.scm 149 */
																							obj_t BgL_list2439z00_632;

																							BgL_list2439z00_632 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2438z00_631 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_jtz00_569,
																								BgL_list2439z00_632);
																						}
																						BgL_arg2390z00_587 =
																							MAKE_PAIR(BgL_arg2437z00_630,
																							BgL_arg2438z00_631);
																					}
																					{	/* Engine/heap.scm 132 */
																						obj_t BgL_list2392z00_589;

																						{	/* Engine/heap.scm 132 */
																							obj_t BgL_arg2393z00_590;

																							{	/* Engine/heap.scm 132 */
																								obj_t BgL_arg2394z00_591;

																								{	/* Engine/heap.scm 132 */
																									obj_t BgL_arg2395z00_592;

																									{	/* Engine/heap.scm 132 */
																										obj_t BgL_arg2396z00_593;

																										{	/* Engine/heap.scm 132 */
																											obj_t BgL_arg2397z00_594;

																											{	/* Engine/heap.scm 132 */
																												obj_t
																													BgL_arg2399z00_595;
																												{	/* Engine/heap.scm 132 */
																													obj_t
																														BgL_arg2400z00_596;
																													{	/* Engine/heap.scm 132 */
																														obj_t
																															BgL_arg2401z00_597;
																														{	/* Engine/heap.scm 132 */
																															obj_t
																																BgL_arg2402z00_598;
																															{	/* Engine/heap.scm 132 */
																																obj_t
																																	BgL_arg2403z00_599;
																																{	/* Engine/heap.scm 132 */
																																	obj_t
																																		BgL_arg2405z00_600;
																																	{	/* Engine/heap.scm 132 */
																																		obj_t
																																			BgL_arg2406z00_601;
																																		BgL_arg2406z00_601
																																			=
																																			MAKE_PAIR
																																			(BNIL,
																																			BNIL);
																																		BgL_arg2405z00_600
																																			=
																																			MAKE_PAIR
																																			(BgL_arg2390z00_587,
																																			BgL_arg2406z00_601);
																																	}
																																	BgL_arg2403z00_599
																																		=
																																		MAKE_PAIR
																																		(BGl_string2529z00zzengine_heapz00,
																																		BgL_arg2405z00_600);
																																}
																																BgL_arg2402z00_598
																																	=
																																	MAKE_PAIR
																																	(BgL_arg2388z00_585,
																																	BgL_arg2403z00_599);
																															}
																															BgL_arg2401z00_597
																																=
																																MAKE_PAIR
																																(BgL_arg2387z00_584,
																																BgL_arg2402z00_598);
																														}
																														BgL_arg2400z00_596 =
																															MAKE_PAIR
																															(BgL_arg2386z00_583,
																															BgL_arg2401z00_597);
																													}
																													BgL_arg2399z00_595 =
																														MAKE_PAIR
																														(BGl_string2529z00zzengine_heapz00,
																														BgL_arg2400z00_596);
																												}
																												BgL_arg2397z00_594 =
																													MAKE_PAIR
																													(BgL_arg2384z00_581,
																													BgL_arg2399z00_595);
																											}
																											BgL_arg2396z00_593 =
																												MAKE_PAIR
																												(BGl_string2529z00zzengine_heapz00,
																												BgL_arg2397z00_594);
																										}
																										BgL_arg2395z00_592 =
																											MAKE_PAIR
																											(BgL_arg2382z00_579,
																											BgL_arg2396z00_593);
																									}
																									BgL_arg2394z00_591 =
																										MAKE_PAIR
																										(BGl_string2529z00zzengine_heapz00,
																										BgL_arg2395z00_592);
																								}
																								BgL_arg2393z00_590 =
																									MAKE_PAIR(BgL_arg2380z00_577,
																									BgL_arg2394z00_591);
																							}
																							BgL_list2392z00_589 =
																								MAKE_PAIR
																								(BGl_string2529z00zzengine_heapz00,
																								BgL_arg2393z00_590);
																						}
																						BgL_arg2377z00_574 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2378z00_575,
																							BgL_list2392z00_589);
																				}}
																				BgL_arg2376z00_573 =
																					MAKE_PAIR(BgL_kindz00_571,
																					BgL_arg2377z00_574);
																			}
																			bgl_display_obj(BgL_arg2376z00_573,
																				BgL_port2287z00_572);
																		}
																		bgl_display_char(((unsigned char) '\n'),
																			BgL_port2287z00_572);
										}}}}}}}}
										{
											obj_t BgL_l2288z00_1320;

											BgL_l2288z00_1320 = CDR(BgL_l2288z00_558);
											BgL_l2288z00_558 = BgL_l2288z00_1320;
											goto BgL_forzd2each2289zd2_559;
										}
									}
								else
									{	/* Engine/heap.scm 152 */
										BgL_auxz00_1220 = ((bool_t) 1);
									}
							}
						}
					}
					return BBOOL(BgL_auxz00_1220);
				}
			}
		}
	}



/* dump-Tenv */
	obj_t BGl_dumpzd2Tenvzd2zzengine_heapz00(obj_t BgL_tenvz00_4)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 157 */
			return
				BGl_hashtablezd2forzd2eachz00zz__hashz00(BgL_tenvz00_4,
				BGl_proc2531z00zzengine_heapz00);
		}
	}



/* <anonymous:2443> */
	obj_t BGl_zc3anonymousza32443ze3z83zzengine_heapz00(obj_t BgL_envz00_994,
		obj_t BgL_kz00_995, obj_t BgL_newz00_996)
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 159 */
			{
				obj_t BgL_kz00_637;

				obj_t BgL_newz00_638;

				BgL_kz00_637 = BgL_kz00_995;
				BgL_newz00_638 = BgL_newz00_996;
				{	/* Engine/heap.scm 160 */
					obj_t BgL_idz00_640;

					{
						BgL_typez00_bglt BgL_auxz00_1324;

						BgL_auxz00_1324 = (BgL_typez00_bglt) (BgL_newz00_638);
						BgL_idz00_640 =
							(((BgL_typez00_bglt) CREF(BgL_auxz00_1324))->BgL_idz00);
					}
					{	/* Engine/heap.scm 160 */
						obj_t BgL_namez00_641;

						{
							BgL_typez00_bglt BgL_auxz00_1327;

							BgL_auxz00_1327 = (BgL_typez00_bglt) (BgL_newz00_638);
							BgL_namez00_641 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_1327))->BgL_namez00);
						}
						{	/* Engine/heap.scm 161 */

							if (BGl_iszd2azf3z21zz__objectz00(BgL_newz00_638,
									BGl_tclassz00zzobject_classz00))
								{	/* Engine/heap.scm 164 */
									obj_t BgL_port2297z00_644;

									{	/* Engine/heap.scm 164 */
										obj_t BgL_res2513z00_951;

										{	/* Engine/heap.scm 164 */
											obj_t BgL_auxz00_1332;

											BgL_auxz00_1332 = BGL_CURRENT_DYNAMIC_ENV();
											BgL_res2513z00_951 =
												BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1332);
										}
										BgL_port2297z00_644 = BgL_res2513z00_951;
									}
									bgl_display_string(BGl_string2528z00zzengine_heapz00,
										BgL_port2297z00_644);
									{	/* Engine/heap.scm 165 */
										obj_t BgL_arg2445z00_645;

										{	/* Engine/heap.scm 165 */
											obj_t BgL_arg2446z00_646;

											obj_t BgL_arg2447z00_647;

											BgL_arg2446z00_646 = CNST_TABLE_REF(((long) 11));
											{	/* Engine/heap.scm 165 */
												obj_t BgL_arg2449z00_648;

												obj_t BgL_arg2450z00_649;

												obj_t BgL_arg2451z00_650;

												BgL_arg2449z00_648 =
													BGl_shapez00zztools_shapez00(BgL_newz00_638);
												{	/* Engine/heap.scm 166 */
													obj_t BgL_arg2454z00_653;

													obj_t BgL_arg2455z00_654;

													BgL_arg2454z00_653 = CNST_TABLE_REF(((long) 12));
													{	/* Engine/heap.scm 166 */
														obj_t BgL_arg2456z00_655;

														{	/* Engine/heap.scm 166 */
															obj_t BgL_arg2459z00_658;

															{	/* Engine/heap.scm 166 */
																BgL_tclassz00_bglt BgL_obj2036z00_954;

																BgL_obj2036z00_954 =
																	(BgL_tclassz00_bglt) (BgL_newz00_638);
																{
																	obj_t BgL_auxz00_1340;

																	{	/* Engine/heap.scm 166 */
																		BgL_objectz00_bglt BgL_auxz00_1341;

																		BgL_auxz00_1341 =
																			(BgL_objectz00_bglt) (BgL_obj2036z00_954);
																		BgL_auxz00_1340 =
																			BGL_OBJECT_WIDENING(BgL_auxz00_1341);
																	}
																	BgL_arg2459z00_658 =
																		(((BgL_tclassz00_bglt)
																			CREF(BgL_auxz00_1340))->
																		BgL_itszd2superzd2);
															}}
															BgL_arg2456z00_655 =
																BGl_shapez00zztools_shapez00
																(BgL_arg2459z00_658);
														}
														{	/* Engine/heap.scm 166 */
															obj_t BgL_list2458z00_657;

															BgL_list2458z00_657 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg2455z00_654 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2456z00_655, BgL_list2458z00_657);
													}}
													BgL_arg2450z00_649 =
														MAKE_PAIR(BgL_arg2454z00_653, BgL_arg2455z00_654);
												}
												{	/* Engine/heap.scm 167 */
													obj_t BgL_arg2461z00_659;

													{	/* Engine/heap.scm 167 */
														obj_t BgL_l2291z00_661;

														{	/* Engine/heap.scm 167 */
															BgL_tclassz00_bglt BgL_obj2039z00_955;

															BgL_obj2039z00_955 =
																(BgL_tclassz00_bglt) (BgL_newz00_638);
															{
																obj_t BgL_auxz00_1350;

																{	/* Engine/heap.scm 167 */
																	BgL_objectz00_bglt BgL_auxz00_1351;

																	BgL_auxz00_1351 =
																		(BgL_objectz00_bglt) (BgL_obj2039z00_955);
																	BgL_auxz00_1350 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_1351);
																}
																BgL_l2291z00_661 =
																	(((BgL_tclassz00_bglt)
																		CREF(BgL_auxz00_1350))->BgL_slotsz00);
														}}
														if (NULLP(BgL_l2291z00_661))
															{	/* Engine/heap.scm 167 */
																BgL_arg2461z00_659 = BNIL;
															}
														else
															{	/* Engine/heap.scm 167 */
																obj_t BgL_head2293z00_663;

																BgL_head2293z00_663 =
																	MAKE_PAIR(BGl_shapez00zztools_shapez00(CAR
																		(BgL_l2291z00_661)), BNIL);
																{	/* Engine/heap.scm 167 */
																	obj_t BgL_g2296z00_664;

																	BgL_g2296z00_664 = CDR(BgL_l2291z00_661);
																	{
																		obj_t BgL_l2291z00_665;

																		obj_t BgL_tail2294z00_666;

																		BgL_l2291z00_665 = BgL_g2296z00_664;
																		BgL_tail2294z00_666 = BgL_head2293z00_663;
																	BgL_map2292z00_667:
																		if (NULLP(BgL_l2291z00_665))
																			{	/* Engine/heap.scm 167 */
																				BgL_arg2461z00_659 =
																					BgL_head2293z00_663;
																			}
																		else
																			{	/* Engine/heap.scm 167 */
																				obj_t BgL_newtail2295z00_669;

																				BgL_newtail2295z00_669 =
																					MAKE_PAIR(BGl_shapez00zztools_shapez00
																					(CAR(BgL_l2291z00_665)), BNIL);
																				SET_CDR(BgL_tail2294z00_666,
																					BgL_newtail2295z00_669);
																				{
																					obj_t BgL_tail2294z00_1369;

																					obj_t BgL_l2291z00_1367;

																					BgL_l2291z00_1367 =
																						CDR(BgL_l2291z00_665);
																					BgL_tail2294z00_1369 =
																						BgL_newtail2295z00_669;
																					BgL_tail2294z00_666 =
																						BgL_tail2294z00_1369;
																					BgL_l2291z00_665 = BgL_l2291z00_1367;
																					goto BgL_map2292z00_667;
																				}
																			}
																	}
																}
															}
													}
													BgL_arg2451z00_650 =
														BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2461z00_659, BNIL);
												}
												{	/* Engine/heap.scm 165 */
													obj_t BgL_list2452z00_651;

													{	/* Engine/heap.scm 165 */
														obj_t BgL_arg2453z00_652;

														BgL_arg2453z00_652 =
															MAKE_PAIR(BgL_arg2451z00_650, BNIL);
														BgL_list2452z00_651 =
															MAKE_PAIR(BgL_arg2450z00_649, BgL_arg2453z00_652);
													}
													BgL_arg2447z00_647 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2449z00_648, BgL_list2452z00_651);
												}
											}
											BgL_arg2445z00_645 =
												MAKE_PAIR(BgL_arg2446z00_646, BgL_arg2447z00_647);
										}
										bgl_display_obj(BgL_arg2445z00_645, BgL_port2297z00_644);
									}
									return
										bgl_display_char(((unsigned char) '\n'),
										BgL_port2297z00_644);
								}
							else
								{	/* Engine/heap.scm 168 */
									obj_t BgL_port2298z00_677;

									{	/* Engine/heap.scm 168 */
										obj_t BgL_res2514z00_970;

										{	/* Engine/heap.scm 168 */
											obj_t BgL_auxz00_1377;

											BgL_auxz00_1377 = BGL_CURRENT_DYNAMIC_ENV();
											BgL_res2514z00_970 =
												BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_1377);
										}
										BgL_port2298z00_677 = BgL_res2514z00_970;
									}
									bgl_display_string(BGl_string2528z00zzengine_heapz00,
										BgL_port2298z00_677);
									{	/* Engine/heap.scm 168 */
										obj_t BgL_arg2473z00_678;

										{	/* Engine/heap.scm 168 */
											obj_t BgL_arg2474z00_679;

											obj_t BgL_arg2475z00_680;

											BgL_arg2474z00_679 = CNST_TABLE_REF(((long) 13));
											{	/* Engine/heap.scm 168 */
												obj_t BgL_arg2476z00_681;

												{	/* Engine/heap.scm 168 */
													obj_t BgL_arg2481z00_685;

													obj_t BgL_arg2482z00_686;

													BgL_arg2481z00_685 = CNST_TABLE_REF(((long) 6));
													{	/* Engine/heap.scm 168 */
														obj_t BgL_list2483z00_687;

														BgL_list2483z00_687 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg2482z00_686 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BgL_namez00_641, BgL_list2483z00_687);
													}
													BgL_arg2476z00_681 =
														MAKE_PAIR(BgL_arg2481z00_685, BgL_arg2482z00_686);
												}
												{	/* Engine/heap.scm 168 */
													obj_t BgL_list2479z00_683;

													{	/* Engine/heap.scm 168 */
														obj_t BgL_arg2480z00_684;

														BgL_arg2480z00_684 = MAKE_PAIR(BNIL, BNIL);
														BgL_list2479z00_683 =
															MAKE_PAIR(BgL_arg2476z00_681, BgL_arg2480z00_684);
													}
													BgL_arg2475z00_680 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_idz00_640, BgL_list2479z00_683);
											}}
											BgL_arg2473z00_678 =
												MAKE_PAIR(BgL_arg2474z00_679, BgL_arg2475z00_680);
										}
										bgl_display_obj(BgL_arg2473z00_678, BgL_port2298z00_677);
									}
									return
										bgl_display_char(((unsigned char) '\n'),
										BgL_port2298z00_677);
		}}}}}}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzengine_heapz00()
	{
		AN_OBJECT;
		{	/* Engine/heap.scm 15 */
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzread_jvmz00(((long) 143212498),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzheap_restorez00(((long) 307873065),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
			return
				BGl_modulezd2initializa7ationz75zzmodule_pragmaz00(((long) 284127067),
				BSTRING_TO_STRING(BGl_string2532z00zzengine_heapz00));
		}
	}

#ifdef __cplusplus
}
#endif
