/*===========================================================================*/
/*   (Object/struct.scm)                                                     */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Object/struct.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
	}                *BgL_tclassz00_bglt;

	typedef struct BgL_slotz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_srcz00;
		obj_t BgL_classzd2ownerzd2;
		obj_t BgL_typez00;
		bool_t BgL_readzd2onlyzf3z21;
		obj_t BgL_defaultzd2valuezd2;
		obj_t BgL_virtualzd2numzd2;
		obj_t BgL_getterz00;
		obj_t BgL_setterz00;
		obj_t BgL_indexedz00;
		obj_t BgL_userzd2infozd2;
	}              *BgL_slotz00_bglt;


	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	static obj_t BGl_savezd2slotzd2zzobject_structz00(obj_t, obj_t, obj_t, long,
		obj_t);
	extern obj_t
		BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00(BgL_typez00_bglt,
		BgL_slotz00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzobject_structz00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzobject_structz00();
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	static obj_t BGl_genzd2plainzd2classzd2ze3structz31zzobject_structz00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_cnstzd2initzd2zzobject_structz00();
	static obj_t BGl_genzd2widezd2classzd2ze3structz31zzobject_structz00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzobject_structz00();
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt,
		obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	static obj_t
		BGl__genzd2widezd2classzc3zd2ze3st2992zf2zzobject_structz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzobject_structz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	BGL_IMPORT obj_t string_to_symbol(char *);
	static obj_t BGl_genzd2structzd2ze3plainzd2classz31zzobject_structz00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern bool_t BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_slotz00_bglt);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t
		BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00
		(BgL_typez00_bglt, BgL_slotz00_bglt, obj_t, obj_t);
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	static obj_t BGl_restorezd2slotzd2zzobject_structz00(obj_t, obj_t, obj_t,
		BgL_typez00_bglt, long, obj_t);
	static long BGl_slotszd2lengthzd2zzobject_structz00(obj_t);
	static obj_t BGl_genzd2structzd2ze3widezd2classz31zzobject_structz00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t);
	extern obj_t BGl_makezd2privatezd2sexpz00zzast_privatez00(obj_t, obj_t,
		obj_t);
	extern obj_t
		BGl_makezd2pragmazd2indexedzd2setz12zc0zzobject_toolsz00(BgL_typez00_bglt,
		BgL_slotz00_bglt, obj_t, obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzobject_structz00();
	static obj_t BGl_methodzd2initzd2zzobject_structz00();
	static obj_t
		BGl__genzd2plainzd2classzc3zd2ze3s2991zf2zzobject_structz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00
		(BgL_typez00_bglt, obj_t);
	static obj_t __cnst[47];


	   
		 
		DEFINE_STRING(BGl_string2993z00zzobject_structz00,
		BgL_bgl_string2993za700za7za7o2999za7, "((", 2);
	      DEFINE_STRING(BGl_string2994z00zzobject_structz00,
		BgL_bgl_string2994za700za7za7o3000za7, ")($1))", 6);
	      DEFINE_STRING(BGl_string2995z00zzobject_structz00,
		BgL_bgl_string2995za700za7za7o3001za7, "object_struct", 13);
	      DEFINE_STRING(BGl_string2996z00zzobject_structz00,
		BgL_bgl_string2996za700za7za7o3002za7,
		"@ class-num object-class-num-set! cast pragma new old object-widening-set! s::struct struct+object->object::object vector-ref-ur done o vector-length s struct-ref f ::long v i struct-key struct-key-set! call-next-method aux ::struct quote make-struct object->struct::struct define-method res obj +fx -ref vector-set-ur! begin struct-set! =fx if labels make-vector -len - let len loop j vec ",
		390);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2widezd2classzc3zd2ze3structzd2envz20zzobject_structz00,
		BgL_bgl__genza7d2wideza7d2cl3003z00,
		BGl__genzd2widezd2classzc3zd2ze3st2992zf2zzobject_structz00, 0L, BUNSPEC,
		2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2plainzd2classzc3zd2ze3structzd2envz20zzobject_structz00,
		BgL_bgl__genza7d2plainza7d2c3004z00,
		BGl__genzd2plainzd2classzc3zd2ze3s2991zf2zzobject_structz00, 0L, BUNSPEC,
		2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzobject_structz00(long
		BgL_checksumz00_1445, char *BgL_fromz00_1446)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzobject_structz00))
				{
					BGl_requirezd2initializa7ationz75zzobject_structz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzobject_structz00();
					BGl_cnstzd2initzd2zzobject_structz00();
					BGl_importedzd2moduleszd2initz00zzobject_structz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"object_struct");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"object_struct");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"object_struct");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"object_struct");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			{	/* Object/struct.scm 15 */
				obj_t BgL_cportz00_1437;

				BgL_cportz00_1437 =
					bgl_open_input_string(BGl_string2996z00zzobject_structz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_1438;

					BgL_iz00_1438 = ((long) 46);
				BgL_loopz00_1439:
					if ((BgL_iz00_1438 == ((long) -1)))
						{	/* Object/struct.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Object/struct.scm 15 */
							{	/* Object/struct.scm 15 */
								obj_t BgL_arg2998z00_1441;

								{	/* Object/struct.scm 15 */

									{	/* Object/struct.scm 15 */
										obj_t BgL_locationz00_1443;

										BgL_locationz00_1443 = BBOOL(((bool_t) 0));
										{	/* Object/struct.scm 15 */

											BgL_arg2998z00_1441 =
												BGl_readz00zz__readerz00(BgL_cportz00_1437,
												BgL_locationz00_1443);
										}
									}
								}
								{	/* Object/struct.scm 15 */
									int BgL_auxz00_1463;

									BgL_auxz00_1463 = (int) (BgL_iz00_1438);
									CNST_TABLE_SET(BgL_auxz00_1463, BgL_arg2998z00_1441);
							}}
							{	/* Object/struct.scm 15 */
								int BgL_auxz00_1444;

								BgL_auxz00_1444 = (int) ((BgL_iz00_1438 - ((long) 1)));
								{
									long BgL_iz00_1468;

									BgL_iz00_1468 = (long) (BgL_auxz00_1444);
									BgL_iz00_1438 = BgL_iz00_1468;
									goto BgL_loopz00_1439;
								}
							}
						}
				}
			}
		}
	}



/* gen-plain-class<->struct */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt
		BgL_classz00_1, obj_t BgL_srczd2defzd2_2)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 38 */
			{	/* Object/struct.scm 40 */
				bool_t BgL_testz00_1470;

				{	/* Object/struct.scm 40 */
					BgL_tclassz00_bglt BgL_obj2052z00_1342;

					BgL_obj2052z00_1342 = (BgL_tclassz00_bglt) (BgL_classz00_1);
					{
						obj_t BgL_auxz00_1472;

						{	/* Object/struct.scm 40 */
							BgL_objectz00_bglt BgL_auxz00_1473;

							BgL_auxz00_1473 = (BgL_objectz00_bglt) (BgL_obj2052z00_1342);
							BgL_auxz00_1472 = BGL_OBJECT_WIDENING(BgL_auxz00_1473);
						}
						BgL_testz00_1470 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1472))->
							BgL_abstractzf3zf3);
					}
				}
				if (BgL_testz00_1470)
					{	/* Object/struct.scm 40 */
						return BNIL;
					}
				else
					{	/* Object/struct.scm 42 */
						obj_t BgL_arg2318z00_523;

						obj_t BgL_arg2319z00_524;

						{	/* Object/struct.scm 42 */
							obj_t BgL_arg2333z00_527;

							obj_t BgL_arg2339z00_528;

							BgL_arg2333z00_527 =
								(((BgL_typez00_bglt) CREF(BgL_classz00_1))->BgL_idz00);
							{	/* Object/struct.scm 42 */
								BgL_tclassz00_bglt BgL_obj2039z00_1344;

								BgL_obj2039z00_1344 = (BgL_tclassz00_bglt) (BgL_classz00_1);
								{
									obj_t BgL_auxz00_1479;

									{	/* Object/struct.scm 42 */
										BgL_objectz00_bglt BgL_auxz00_1480;

										BgL_auxz00_1480 =
											(BgL_objectz00_bglt) (BgL_obj2039z00_1344);
										BgL_auxz00_1479 = BGL_OBJECT_WIDENING(BgL_auxz00_1480);
									}
									BgL_arg2339z00_528 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1479))->
										BgL_slotsz00);
								}
							}
							BgL_arg2318z00_523 =
								BGl_genzd2plainzd2classzd2ze3structz31zzobject_structz00
								(BgL_arg2333z00_527, BgL_classz00_1, BgL_arg2339z00_528,
								BgL_srczd2defzd2_2);
						}
						{	/* Object/struct.scm 43 */
							obj_t BgL_arg2340z00_529;

							obj_t BgL_arg2341z00_530;

							BgL_arg2340z00_529 =
								(((BgL_typez00_bglt) CREF(BgL_classz00_1))->BgL_idz00);
							{	/* Object/struct.scm 43 */
								BgL_tclassz00_bglt BgL_obj2039z00_1346;

								BgL_obj2039z00_1346 = (BgL_tclassz00_bglt) (BgL_classz00_1);
								{
									obj_t BgL_auxz00_1487;

									{	/* Object/struct.scm 43 */
										BgL_objectz00_bglt BgL_auxz00_1488;

										BgL_auxz00_1488 =
											(BgL_objectz00_bglt) (BgL_obj2039z00_1346);
										BgL_auxz00_1487 = BGL_OBJECT_WIDENING(BgL_auxz00_1488);
									}
									BgL_arg2341z00_530 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1487))->
										BgL_slotsz00);
								}
							}
							BgL_arg2319z00_524 =
								BGl_genzd2structzd2ze3plainzd2classz31zzobject_structz00
								(BgL_arg2340z00_529, BgL_classz00_1, BgL_arg2341z00_530,
								BgL_srczd2defzd2_2);
						}
						{	/* Object/struct.scm 42 */
							obj_t BgL_list2320z00_525;

							{	/* Object/struct.scm 42 */
								obj_t BgL_arg2327z00_526;

								BgL_arg2327z00_526 = MAKE_PAIR(BgL_arg2319z00_524, BNIL);
								BgL_list2320z00_525 =
									MAKE_PAIR(BgL_arg2318z00_523, BgL_arg2327z00_526);
							}
							return BgL_list2320z00_525;
						}
					}
			}
		}
	}



/* _gen-plain-class<->s2991 */
	obj_t BGl__genzd2plainzd2classzc3zd2ze3s2991zf2zzobject_structz00(obj_t
		BgL_envz00_1431, obj_t BgL_classz00_1432, obj_t BgL_srczd2defzd2_1433)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 38 */
			return
				BGl_genzd2plainzd2classzc3zd2ze3structzf2zzobject_structz00(
				(BgL_typez00_bglt) (BgL_classz00_1432), BgL_srczd2defzd2_1433);
		}
	}



/* gen-wide-class<->struct */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(BgL_typez00_bglt
		BgL_classz00_3, obj_t BgL_srczd2defzd2_4)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 48 */
			{	/* Object/struct.scm 50 */
				obj_t BgL_arg2342z00_532;

				obj_t BgL_arg2343z00_533;

				{	/* Object/struct.scm 50 */
					obj_t BgL_arg2346z00_536;

					obj_t BgL_arg2347z00_537;

					BgL_arg2346z00_536 =
						(((BgL_typez00_bglt) CREF(BgL_classz00_3))->BgL_idz00);
					{	/* Object/struct.scm 50 */
						BgL_tclassz00_bglt BgL_obj2039z00_1350;

						BgL_obj2039z00_1350 = (BgL_tclassz00_bglt) (BgL_classz00_3);
						{
							obj_t BgL_auxz00_1499;

							{	/* Object/struct.scm 50 */
								BgL_objectz00_bglt BgL_auxz00_1500;

								BgL_auxz00_1500 = (BgL_objectz00_bglt) (BgL_obj2039z00_1350);
								BgL_auxz00_1499 = BGL_OBJECT_WIDENING(BgL_auxz00_1500);
							}
							BgL_arg2347z00_537 =
								(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1499))->BgL_slotsz00);
						}
					}
					BgL_arg2342z00_532 =
						BGl_genzd2widezd2classzd2ze3structz31zzobject_structz00
						(BgL_arg2346z00_536, BgL_classz00_3, BgL_arg2347z00_537,
						BgL_srczd2defzd2_4);
				}
				{	/* Object/struct.scm 51 */
					obj_t BgL_arg2348z00_538;

					obj_t BgL_arg2349z00_539;

					BgL_arg2348z00_538 =
						(((BgL_typez00_bglt) CREF(BgL_classz00_3))->BgL_idz00);
					{	/* Object/struct.scm 51 */
						BgL_tclassz00_bglt BgL_obj2039z00_1352;

						BgL_obj2039z00_1352 = (BgL_tclassz00_bglt) (BgL_classz00_3);
						{
							obj_t BgL_auxz00_1507;

							{	/* Object/struct.scm 51 */
								BgL_objectz00_bglt BgL_auxz00_1508;

								BgL_auxz00_1508 = (BgL_objectz00_bglt) (BgL_obj2039z00_1352);
								BgL_auxz00_1507 = BGL_OBJECT_WIDENING(BgL_auxz00_1508);
							}
							BgL_arg2349z00_539 =
								(((BgL_tclassz00_bglt) CREF(BgL_auxz00_1507))->BgL_slotsz00);
						}
					}
					BgL_arg2343z00_533 =
						BGl_genzd2structzd2ze3widezd2classz31zzobject_structz00
						(BgL_arg2348z00_538, BgL_classz00_3, BgL_arg2349z00_539,
						BgL_srczd2defzd2_4);
				}
				{	/* Object/struct.scm 50 */
					obj_t BgL_list2344z00_534;

					{	/* Object/struct.scm 50 */
						obj_t BgL_arg2345z00_535;

						BgL_arg2345z00_535 = MAKE_PAIR(BgL_arg2343z00_533, BNIL);
						BgL_list2344z00_534 =
							MAKE_PAIR(BgL_arg2342z00_532, BgL_arg2345z00_535);
					}
					return BgL_list2344z00_534;
				}
			}
		}
	}



/* _gen-wide-class<->st2992 */
	obj_t BGl__genzd2widezd2classzc3zd2ze3st2992zf2zzobject_structz00(obj_t
		BgL_envz00_1434, obj_t BgL_classz00_1435, obj_t BgL_srczd2defzd2_1436)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 48 */
			return
				BGl_genzd2widezd2classzc3zd2ze3structzf2zzobject_structz00(
				(BgL_typez00_bglt) (BgL_classz00_1435), BgL_srczd2defzd2_1436);
		}
	}



/* save-slot */
	obj_t BGl_savezd2slotzd2zzobject_structz00(obj_t BgL_onamez00_5,
		obj_t BgL_snamez00_6, obj_t BgL_cnamez00_7, long BgL_iz00_8,
		obj_t BgL_slotz00_9)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 56 */
			{

				if (BGl_slotzd2virtualzf3z21zzobject_slotsz00(
						(BgL_slotz00_bglt) (BgL_slotz00_9)))
					{	/* Object/struct.scm 84 */
						return BUNSPEC;
					}
				else
					{	/* Object/struct.scm 86 */
						bool_t BgL_testz00_1520;

						{	/* Object/struct.scm 86 */
							BgL_slotz00_bglt BgL_obj2262z00_1355;

							BgL_obj2262z00_1355 = (BgL_slotz00_bglt) (BgL_slotz00_9);
							BgL_testz00_1520 =
								CBOOL(
								(((BgL_slotz00_bglt) CREF(BgL_obj2262z00_1355))->
									BgL_indexedz00));
						}
						if (BgL_testz00_1520)
							{	/* Object/struct.scm 86 */
								{	/* Object/struct.scm 63 */
									obj_t BgL_vecz00_545;

									obj_t BgL_jz00_546;

									obj_t BgL_loopz00_547;

									obj_t BgL_lenz00_548;

									BgL_vecz00_545 =
										BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												0)));
									BgL_jz00_546 =
										BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												1)));
									BgL_loopz00_547 =
										BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												2)));
									BgL_lenz00_548 =
										BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												3)));
									{	/* Object/struct.scm 67 */
										obj_t BgL_arg2353z00_549;

										obj_t BgL_arg2354z00_550;

										BgL_arg2353z00_549 = CNST_TABLE_REF(((long) 4));
										{	/* Object/struct.scm 67 */
											obj_t BgL_arg2355z00_551;

											obj_t BgL_arg2356z00_552;

											{	/* Object/struct.scm 67 */
												obj_t BgL_arg2360z00_556;

												{	/* Object/struct.scm 67 */
													obj_t BgL_arg2362z00_558;

													{	/* Object/struct.scm 67 */
														obj_t BgL_arg2363z00_559;

														{	/* Object/struct.scm 67 */
															obj_t BgL_arg2366z00_562;

															obj_t BgL_arg2367z00_563;

															{	/* Object/struct.scm 67 */
																obj_t BgL_arg2368z00_564;

																obj_t BgL_arg2369z00_565;

																obj_t BgL_arg2370z00_566;

																BgL_arg2368z00_564 = CNST_TABLE_REF(((long) 5));
																{
																	BgL_slotz00_bglt BgL_auxz00_1534;

																	BgL_auxz00_1534 =
																		(BgL_slotz00_bglt) (BgL_slotz00_9);
																	BgL_arg2369z00_565 =
																		(((BgL_slotz00_bglt)
																			CREF(BgL_auxz00_1534))->BgL_idz00);
																}
																BgL_arg2370z00_566 = CNST_TABLE_REF(((long) 6));
																{	/* Object/struct.scm 67 */
																	obj_t BgL_list2371z00_567;

																	{	/* Object/struct.scm 67 */
																		obj_t BgL_arg2372z00_568;

																		{	/* Object/struct.scm 67 */
																			obj_t BgL_arg2373z00_569;

																			{	/* Object/struct.scm 67 */
																				obj_t BgL_arg2374z00_570;

																				BgL_arg2374z00_570 =
																					MAKE_PAIR(BgL_arg2370z00_566, BNIL);
																				BgL_arg2373z00_569 =
																					MAKE_PAIR(BgL_arg2369z00_565,
																					BgL_arg2374z00_570);
																			}
																			BgL_arg2372z00_568 =
																				MAKE_PAIR(BgL_arg2368z00_564,
																				BgL_arg2373z00_569);
																		}
																		BgL_list2371z00_567 =
																			MAKE_PAIR(BgL_cnamez00_7,
																			BgL_arg2372z00_568);
																	}
																	BgL_arg2366z00_562 =
																		BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																		(BgL_list2371z00_567);
															}}
															{	/* Object/struct.scm 67 */
																obj_t BgL_list2375z00_571;

																BgL_list2375z00_571 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg2367z00_563 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_onamez00_5, BgL_list2375z00_571);
															}
															BgL_arg2363z00_559 =
																MAKE_PAIR(BgL_arg2366z00_562,
																BgL_arg2367z00_563);
														}
														{	/* Object/struct.scm 67 */
															obj_t BgL_list2365z00_561;

															BgL_list2365z00_561 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg2362z00_558 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2363z00_559, BgL_list2365z00_561);
													}}
													BgL_arg2360z00_556 =
														MAKE_PAIR(BgL_lenz00_548, BgL_arg2362z00_558);
												}
												BgL_arg2355z00_551 =
													MAKE_PAIR(BgL_arg2360z00_556, BNIL);
											}
											{	/* Object/struct.scm 68 */
												obj_t BgL_arg2376z00_572;

												obj_t BgL_arg2377z00_573;

												BgL_arg2376z00_572 = CNST_TABLE_REF(((long) 4));
												{	/* Object/struct.scm 68 */
													obj_t BgL_arg2378z00_574;

													obj_t BgL_arg2379z00_575;

													{	/* Object/struct.scm 68 */
														obj_t BgL_arg2383z00_579;

														{	/* Object/struct.scm 68 */
															obj_t BgL_arg2385z00_581;

															{	/* Object/struct.scm 68 */
																obj_t BgL_arg2386z00_582;

																{	/* Object/struct.scm 68 */
																	obj_t BgL_arg2389z00_585;

																	obj_t BgL_arg2390z00_586;

																	BgL_arg2389z00_585 =
																		CNST_TABLE_REF(((long) 7));
																	{	/* Object/struct.scm 68 */
																		obj_t BgL_list2391z00_587;

																		BgL_list2391z00_587 = MAKE_PAIR(BNIL, BNIL);
																		BgL_arg2390z00_586 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_lenz00_548, BgL_list2391z00_587);
																	}
																	BgL_arg2386z00_582 =
																		MAKE_PAIR(BgL_arg2389z00_585,
																		BgL_arg2390z00_586);
																}
																{	/* Object/struct.scm 68 */
																	obj_t BgL_list2388z00_584;

																	BgL_list2388z00_584 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg2385z00_581 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg2386z00_582, BgL_list2388z00_584);
															}}
															BgL_arg2383z00_579 =
																MAKE_PAIR(BgL_vecz00_545, BgL_arg2385z00_581);
														}
														BgL_arg2378z00_574 =
															MAKE_PAIR(BgL_arg2383z00_579, BNIL);
													}
													{	/* Object/struct.scm 69 */
														obj_t BgL_arg2392z00_588;

														obj_t BgL_arg2393z00_589;

														BgL_arg2392z00_588 = CNST_TABLE_REF(((long) 8));
														{	/* Object/struct.scm 69 */
															obj_t BgL_arg2394z00_590;

															obj_t BgL_arg2395z00_591;

															{	/* Object/struct.scm 69 */
																obj_t BgL_arg2400z00_595;

																{	/* Object/struct.scm 69 */
																	obj_t BgL_arg2402z00_597;

																	{	/* Object/struct.scm 69 */
																		obj_t BgL_arg2403z00_598;

																		obj_t BgL_arg2405z00_599;

																		BgL_arg2403z00_598 =
																			MAKE_PAIR(BgL_jz00_546, BNIL);
																		{	/* Object/struct.scm 69 */
																			obj_t BgL_arg2409z00_603;

																			obj_t BgL_arg2410z00_604;

																			BgL_arg2409z00_603 =
																				CNST_TABLE_REF(((long) 9));
																			{	/* Object/struct.scm 69 */
																				obj_t BgL_arg2411z00_605;

																				obj_t BgL_arg2412z00_606;

																				obj_t BgL_arg2413z00_607;

																				{	/* Object/struct.scm 69 */
																					obj_t BgL_arg2418z00_612;

																					obj_t BgL_arg2420z00_613;

																					BgL_arg2418z00_612 =
																						CNST_TABLE_REF(((long) 10));
																					{	/* Object/struct.scm 69 */
																						obj_t BgL_list2421z00_614;

																						{	/* Object/struct.scm 69 */
																							obj_t BgL_arg2422z00_615;

																							BgL_arg2422z00_615 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2421z00_614 =
																								MAKE_PAIR(BgL_lenz00_548,
																								BgL_arg2422z00_615);
																						}
																						BgL_arg2420z00_613 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_jz00_546,
																							BgL_list2421z00_614);
																					}
																					BgL_arg2411z00_605 =
																						MAKE_PAIR(BgL_arg2418z00_612,
																						BgL_arg2420z00_613);
																				}
																				{	/* Object/struct.scm 70 */
																					obj_t BgL_arg2423z00_616;

																					obj_t BgL_arg2424z00_617;

																					BgL_arg2423z00_616 =
																						CNST_TABLE_REF(((long) 11));
																					{	/* Object/struct.scm 70 */
																						obj_t BgL_list2425z00_618;

																						{	/* Object/struct.scm 70 */
																							obj_t BgL_arg2426z00_619;

																							{	/* Object/struct.scm 70 */
																								obj_t BgL_arg2427z00_620;

																								BgL_arg2427z00_620 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2426z00_619 =
																									MAKE_PAIR(BgL_vecz00_545,
																									BgL_arg2427z00_620);
																							}
																							BgL_list2425z00_618 =
																								MAKE_PAIR(BINT(BgL_iz00_8),
																								BgL_arg2426z00_619);
																						}
																						BgL_arg2424z00_617 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_snamez00_6,
																							BgL_list2425z00_618);
																					}
																					BgL_arg2412z00_606 =
																						MAKE_PAIR(BgL_arg2423z00_616,
																						BgL_arg2424z00_617);
																				}
																				{	/* Object/struct.scm 71 */
																					obj_t BgL_arg2428z00_621;

																					obj_t BgL_arg2429z00_622;

																					BgL_arg2428z00_621 =
																						CNST_TABLE_REF(((long) 12));
																					{	/* Object/struct.scm 72 */
																						obj_t BgL_arg2430z00_623;

																						obj_t BgL_arg2431z00_624;

																						{	/* Object/struct.scm 72 */
																							obj_t BgL_arg2436z00_628;

																							obj_t BgL_arg2437z00_629;

																							BgL_arg2436z00_628 =
																								CNST_TABLE_REF(((long) 13));
																							{	/* Object/struct.scm 76 */
																								obj_t BgL_arg2438z00_630;

																								{	/* Object/struct.scm 76 */
																									obj_t BgL_arg2444z00_635;

																									obj_t BgL_arg2445z00_636;

																									{	/* Object/struct.scm 76 */
																										obj_t BgL_arg2446z00_637;

																										obj_t BgL_arg2447z00_638;

																										obj_t BgL_arg2449z00_639;

																										BgL_arg2446z00_637 =
																											CNST_TABLE_REF(((long)
																												5));
																										{
																											BgL_slotz00_bglt
																												BgL_auxz00_1577;
																											BgL_auxz00_1577 =
																												(BgL_slotz00_bglt)
																												(BgL_slotz00_9);
																											BgL_arg2447z00_638 =
																												(((BgL_slotz00_bglt)
																													CREF
																													(BgL_auxz00_1577))->
																												BgL_idz00);
																										}
																										BgL_arg2449z00_639 =
																											CNST_TABLE_REF(((long)
																												14));
																										{	/* Object/struct.scm 75 */
																											obj_t BgL_list2450z00_640;

																											{	/* Object/struct.scm 75 */
																												obj_t
																													BgL_arg2451z00_641;
																												{	/* Object/struct.scm 75 */
																													obj_t
																														BgL_arg2452z00_642;
																													{	/* Object/struct.scm 75 */
																														obj_t
																															BgL_arg2453z00_643;
																														BgL_arg2453z00_643 =
																															MAKE_PAIR
																															(BgL_arg2449z00_639,
																															BNIL);
																														BgL_arg2452z00_642 =
																															MAKE_PAIR
																															(BgL_arg2447z00_638,
																															BgL_arg2453z00_643);
																													}
																													BgL_arg2451z00_641 =
																														MAKE_PAIR
																														(BgL_arg2446z00_637,
																														BgL_arg2452z00_642);
																												}
																												BgL_list2450z00_640 =
																													MAKE_PAIR
																													(BgL_cnamez00_7,
																													BgL_arg2451z00_641);
																											}
																											BgL_arg2444z00_635 =
																												BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																												(BgL_list2450z00_640);
																									}}
																									{	/* Object/struct.scm 75 */
																										obj_t BgL_list2454z00_644;

																										{	/* Object/struct.scm 75 */
																											obj_t BgL_arg2455z00_645;

																											BgL_arg2455z00_645 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_list2454z00_644 =
																												MAKE_PAIR(BgL_jz00_546,
																												BgL_arg2455z00_645);
																										}
																										BgL_arg2445z00_636 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_onamez00_5,
																											BgL_list2454z00_644);
																									}
																									BgL_arg2438z00_630 =
																										MAKE_PAIR
																										(BgL_arg2444z00_635,
																										BgL_arg2445z00_636);
																								}
																								{	/* Object/struct.scm 72 */
																									obj_t BgL_list2440z00_632;

																									{	/* Object/struct.scm 72 */
																										obj_t BgL_arg2441z00_633;

																										{	/* Object/struct.scm 72 */
																											obj_t BgL_arg2442z00_634;

																											BgL_arg2442z00_634 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_arg2441z00_633 =
																												MAKE_PAIR
																												(BgL_arg2438z00_630,
																												BgL_arg2442z00_634);
																										}
																										BgL_list2440z00_632 =
																											MAKE_PAIR(BgL_jz00_546,
																											BgL_arg2441z00_633);
																									}
																									BgL_arg2437z00_629 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_vecz00_545,
																										BgL_list2440z00_632);
																							}}
																							BgL_arg2430z00_623 =
																								MAKE_PAIR(BgL_arg2436z00_628,
																								BgL_arg2437z00_629);
																						}
																						{	/* Object/struct.scm 81 */
																							obj_t BgL_arg2456z00_646;

																							{	/* Object/struct.scm 81 */
																								obj_t BgL_arg2457z00_647;

																								{	/* Object/struct.scm 81 */
																									obj_t BgL_arg2461z00_650;

																									obj_t BgL_arg2462z00_651;

																									BgL_arg2461z00_650 =
																										CNST_TABLE_REF(((long) 15));
																									{	/* Object/struct.scm 81 */
																										obj_t BgL_list2463z00_652;

																										{	/* Object/struct.scm 81 */
																											obj_t BgL_arg2465z00_654;

																											BgL_arg2465z00_654 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_list2463z00_652 =
																												MAKE_PAIR(BINT(((long)
																														1)),
																												BgL_arg2465z00_654);
																										}
																										BgL_arg2462z00_651 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_jz00_546,
																											BgL_list2463z00_652);
																									}
																									BgL_arg2457z00_647 =
																										MAKE_PAIR
																										(BgL_arg2461z00_650,
																										BgL_arg2462z00_651);
																								}
																								{	/* Object/struct.scm 81 */
																									obj_t BgL_list2459z00_649;

																									BgL_list2459z00_649 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_arg2456z00_646 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg2457z00_647,
																										BgL_list2459z00_649);
																							}}
																							BgL_arg2431z00_624 =
																								MAKE_PAIR(BgL_loopz00_547,
																								BgL_arg2456z00_646);
																						}
																						{	/* Object/struct.scm 71 */
																							obj_t BgL_list2433z00_626;

																							{	/* Object/struct.scm 71 */
																								obj_t BgL_arg2435z00_627;

																								BgL_arg2435z00_627 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_list2433z00_626 =
																									MAKE_PAIR(BgL_arg2431z00_624,
																									BgL_arg2435z00_627);
																							}
																							BgL_arg2429z00_622 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_arg2430z00_623,
																								BgL_list2433z00_626);
																					}}
																					BgL_arg2413z00_607 =
																						MAKE_PAIR(BgL_arg2428z00_621,
																						BgL_arg2429z00_622);
																				}
																				{	/* Object/struct.scm 69 */
																					obj_t BgL_list2415z00_609;

																					{	/* Object/struct.scm 69 */
																						obj_t BgL_arg2416z00_610;

																						{	/* Object/struct.scm 69 */
																							obj_t BgL_arg2417z00_611;

																							BgL_arg2417z00_611 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2416z00_610 =
																								MAKE_PAIR(BgL_arg2413z00_607,
																								BgL_arg2417z00_611);
																						}
																						BgL_list2415z00_609 =
																							MAKE_PAIR(BgL_arg2412z00_606,
																							BgL_arg2416z00_610);
																					}
																					BgL_arg2410z00_604 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg2411z00_605,
																						BgL_list2415z00_609);
																			}}
																			BgL_arg2405z00_599 =
																				MAKE_PAIR(BgL_arg2409z00_603,
																				BgL_arg2410z00_604);
																		}
																		{	/* Object/struct.scm 69 */
																			obj_t BgL_list2407z00_601;

																			{	/* Object/struct.scm 69 */
																				obj_t BgL_arg2408z00_602;

																				BgL_arg2408z00_602 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list2407z00_601 =
																					MAKE_PAIR(BgL_arg2405z00_599,
																					BgL_arg2408z00_602);
																			}
																			BgL_arg2402z00_597 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2403z00_598,
																				BgL_list2407z00_601);
																	}}
																	BgL_arg2400z00_595 =
																		MAKE_PAIR(BgL_loopz00_547,
																		BgL_arg2402z00_597);
																}
																BgL_arg2394z00_590 =
																	MAKE_PAIR(BgL_arg2400z00_595, BNIL);
															}
															{	/* Object/struct.scm 82 */
																obj_t BgL_arg2466z00_655;

																{	/* Object/struct.scm 82 */
																	obj_t BgL_list2467z00_656;

																	BgL_list2467z00_656 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg2466z00_655 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BINT(((long) 0)), BgL_list2467z00_656);
																}
																BgL_arg2395z00_591 =
																	MAKE_PAIR(BgL_loopz00_547,
																	BgL_arg2466z00_655);
															}
															{	/* Object/struct.scm 69 */
																obj_t BgL_list2397z00_593;

																{	/* Object/struct.scm 69 */
																	obj_t BgL_arg2399z00_594;

																	BgL_arg2399z00_594 = MAKE_PAIR(BNIL, BNIL);
																	BgL_list2397z00_593 =
																		MAKE_PAIR(BgL_arg2395z00_591,
																		BgL_arg2399z00_594);
																}
																BgL_arg2393z00_589 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg2394z00_590, BgL_list2397z00_593);
														}}
														BgL_arg2379z00_575 =
															MAKE_PAIR(BgL_arg2392z00_588, BgL_arg2393z00_589);
													}
													{	/* Object/struct.scm 68 */
														obj_t BgL_list2381z00_577;

														{	/* Object/struct.scm 68 */
															obj_t BgL_arg2382z00_578;

															BgL_arg2382z00_578 = MAKE_PAIR(BNIL, BNIL);
															BgL_list2381z00_577 =
																MAKE_PAIR(BgL_arg2379z00_575,
																BgL_arg2382z00_578);
														}
														BgL_arg2377z00_573 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BgL_arg2378z00_574, BgL_list2381z00_577);
												}}
												BgL_arg2356z00_552 =
													MAKE_PAIR(BgL_arg2376z00_572, BgL_arg2377z00_573);
											}
											{	/* Object/struct.scm 67 */
												obj_t BgL_list2358z00_554;

												{	/* Object/struct.scm 67 */
													obj_t BgL_arg2359z00_555;

													BgL_arg2359z00_555 = MAKE_PAIR(BNIL, BNIL);
													BgL_list2358z00_554 =
														MAKE_PAIR(BgL_arg2356z00_552, BgL_arg2359z00_555);
												}
												BgL_arg2354z00_550 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg2355z00_551, BgL_list2358z00_554);
										}}
										return MAKE_PAIR(BgL_arg2353z00_549, BgL_arg2354z00_550);
									}
								}
							}
						else
							{	/* Object/struct.scm 86 */
								{	/* Object/struct.scm 58 */
									obj_t BgL_arg2469z00_658;

									obj_t BgL_arg2470z00_659;

									BgL_arg2469z00_658 = CNST_TABLE_REF(((long) 11));
									{	/* Object/struct.scm 60 */
										obj_t BgL_arg2472z00_660;

										{	/* Object/struct.scm 60 */
											obj_t BgL_arg2478z00_665;

											obj_t BgL_arg2479z00_666;

											{	/* Object/struct.scm 60 */
												obj_t BgL_arg2480z00_667;

												obj_t BgL_arg2481z00_668;

												BgL_arg2480z00_667 = CNST_TABLE_REF(((long) 5));
												{
													BgL_slotz00_bglt BgL_auxz00_1636;

													BgL_auxz00_1636 = (BgL_slotz00_bglt) (BgL_slotz00_9);
													BgL_arg2481z00_668 =
														(((BgL_slotz00_bglt) CREF(BgL_auxz00_1636))->
														BgL_idz00);
												}
												{	/* Object/struct.scm 60 */
													obj_t BgL_list2482z00_669;

													{	/* Object/struct.scm 60 */
														obj_t BgL_arg2483z00_670;

														{	/* Object/struct.scm 60 */
															obj_t BgL_arg2484z00_671;

															BgL_arg2484z00_671 =
																MAKE_PAIR(BgL_arg2481z00_668, BNIL);
															BgL_arg2483z00_670 =
																MAKE_PAIR(BgL_arg2480z00_667,
																BgL_arg2484z00_671);
														}
														BgL_list2482z00_669 =
															MAKE_PAIR(BgL_cnamez00_7, BgL_arg2483z00_670);
													}
													BgL_arg2478z00_665 =
														BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
														(BgL_list2482z00_669);
											}}
											{	/* Object/struct.scm 60 */
												obj_t BgL_list2485z00_672;

												BgL_list2485z00_672 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg2479z00_666 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_onamez00_5, BgL_list2485z00_672);
											}
											BgL_arg2472z00_660 =
												MAKE_PAIR(BgL_arg2478z00_665, BgL_arg2479z00_666);
										}
										{	/* Object/struct.scm 58 */
											obj_t BgL_list2474z00_662;

											{	/* Object/struct.scm 58 */
												obj_t BgL_arg2475z00_663;

												{	/* Object/struct.scm 58 */
													obj_t BgL_arg2476z00_664;

													BgL_arg2476z00_664 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg2475z00_663 =
														MAKE_PAIR(BgL_arg2472z00_660, BgL_arg2476z00_664);
												}
												BgL_list2474z00_662 =
													MAKE_PAIR(BINT(BgL_iz00_8), BgL_arg2475z00_663);
											}
											BgL_arg2470z00_659 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BgL_snamez00_6, BgL_list2474z00_662);
									}}
									return MAKE_PAIR(BgL_arg2469z00_658, BgL_arg2470z00_659);
								}
							}
					}
			}
		}
	}



/* slots-length */
	long BGl_slotszd2lengthzd2zzobject_structz00(obj_t BgL_slotsz00_10)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 94 */
			{
				obj_t BgL_slotsz00_675;

				long BgL_lenz00_676;

				BgL_slotsz00_675 = BgL_slotsz00_10;
				BgL_lenz00_676 = ((long) 0);
			BgL_loopz00_677:
				if (NULLP(BgL_slotsz00_675))
					{	/* Object/struct.scm 98 */
						return BgL_lenz00_676;
					}
				else
					{	/* Object/struct.scm 100 */
						bool_t BgL_testz00_1654;

						{	/* Object/struct.scm 100 */
							obj_t BgL_arg2492z00_683;

							BgL_arg2492z00_683 = CAR(BgL_slotsz00_675);
							BgL_testz00_1654 =
								BGl_slotzd2virtualzf3z21zzobject_slotsz00(
								(BgL_slotz00_bglt) (BgL_arg2492z00_683));
						}
						if (BgL_testz00_1654)
							{
								obj_t BgL_slotsz00_1658;

								BgL_slotsz00_1658 = CDR(BgL_slotsz00_675);
								BgL_slotsz00_675 = BgL_slotsz00_1658;
								goto BgL_loopz00_677;
							}
						else
							{
								long BgL_lenz00_1662;

								obj_t BgL_slotsz00_1660;

								BgL_slotsz00_1660 = CDR(BgL_slotsz00_675);
								BgL_lenz00_1662 = (((long) 1) + BgL_lenz00_676);
								BgL_lenz00_676 = BgL_lenz00_1662;
								BgL_slotsz00_675 = BgL_slotsz00_1660;
								goto BgL_loopz00_677;
							}
					}
			}
		}
	}



/* gen-plain-class->struct */
	obj_t BGl_genzd2plainzd2classzd2ze3structz31zzobject_structz00(obj_t
		BgL_cnamez00_11, BgL_typez00_bglt BgL_typez00_12, obj_t BgL_slotsz00_13,
		obj_t BgL_srczd2defzd2_14)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 108 */
			{	/* Object/struct.scm 109 */
				long BgL_lenz00_684;

				obj_t BgL_onamez00_685;

				obj_t BgL_snamez00_686;

				BgL_lenz00_684 =
					(((long) 1) +
					BGl_slotszd2lengthzd2zzobject_structz00(BgL_slotsz00_13));
				BgL_onamez00_685 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 16)));
				BgL_snamez00_686 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 17)));
				{	/* Object/struct.scm 113 */
					obj_t BgL_arg2493z00_687;

					{	/* Object/struct.scm 113 */
						obj_t BgL_arg2494z00_688;

						obj_t BgL_arg2495z00_689;

						BgL_arg2494z00_688 = CNST_TABLE_REF(((long) 18));
						{	/* Object/struct.scm 113 */
							obj_t BgL_arg2496z00_690;

							obj_t BgL_arg2497z00_691;

							{	/* Object/struct.scm 113 */
								obj_t BgL_arg2501z00_695;

								obj_t BgL_arg2502z00_696;

								BgL_arg2501z00_695 = CNST_TABLE_REF(((long) 19));
								{	/* Object/struct.scm 113 */
									obj_t BgL_arg2503z00_697;

									BgL_arg2503z00_697 =
										BGl_makezd2typedzd2identz00zzast_identz00(BgL_onamez00_685,
										BgL_cnamez00_11);
									{	/* Object/struct.scm 113 */
										obj_t BgL_list2505z00_699;

										BgL_list2505z00_699 = MAKE_PAIR(BNIL, BNIL);
										BgL_arg2502z00_696 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg2503z00_697, BgL_list2505z00_699);
								}}
								BgL_arg2496z00_690 =
									MAKE_PAIR(BgL_arg2501z00_695, BgL_arg2502z00_696);
							}
							{	/* Object/struct.scm 114 */
								obj_t BgL_arg2506z00_700;

								obj_t BgL_arg2507z00_701;

								BgL_arg2506z00_700 = CNST_TABLE_REF(((long) 4));
								{	/* Object/struct.scm 114 */
									obj_t BgL_arg2508z00_702;

									obj_t BgL_arg2509z00_703;

									{	/* Object/struct.scm 114 */
										obj_t BgL_arg2513z00_707;

										{	/* Object/struct.scm 114 */
											obj_t BgL_arg2515z00_709;

											{	/* Object/struct.scm 114 */
												obj_t BgL_arg2516z00_710;

												{	/* Object/struct.scm 114 */
													obj_t BgL_arg2519z00_713;

													obj_t BgL_arg2520z00_714;

													BgL_arg2519z00_713 = CNST_TABLE_REF(((long) 20));
													{	/* Object/struct.scm 114 */
														obj_t BgL_arg2521z00_715;

														{	/* Object/struct.scm 114 */
															obj_t BgL_arg2526z00_720;

															obj_t BgL_arg2527z00_721;

															BgL_arg2526z00_720 = CNST_TABLE_REF(((long) 21));
															{	/* Object/struct.scm 114 */
																obj_t BgL_list2528z00_722;

																BgL_list2528z00_722 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg2527z00_721 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_cnamez00_11, BgL_list2528z00_722);
															}
															BgL_arg2521z00_715 =
																MAKE_PAIR(BgL_arg2526z00_720,
																BgL_arg2527z00_721);
														}
														{	/* Object/struct.scm 114 */
															obj_t BgL_list2523z00_717;

															{	/* Object/struct.scm 114 */
																obj_t BgL_arg2524z00_718;

																{	/* Object/struct.scm 114 */
																	obj_t BgL_arg2525z00_719;

																	BgL_arg2525z00_719 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg2524z00_718 =
																		MAKE_PAIR(BUNSPEC, BgL_arg2525z00_719);
																}
																BgL_list2523z00_717 =
																	MAKE_PAIR(BINT(BgL_lenz00_684),
																	BgL_arg2524z00_718);
															}
															BgL_arg2520z00_714 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2521z00_715, BgL_list2523z00_717);
													}}
													BgL_arg2516z00_710 =
														MAKE_PAIR(BgL_arg2519z00_713, BgL_arg2520z00_714);
												}
												{	/* Object/struct.scm 114 */
													obj_t BgL_list2518z00_712;

													BgL_list2518z00_712 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg2515z00_709 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2516z00_710, BgL_list2518z00_712);
											}}
											BgL_arg2513z00_707 =
												MAKE_PAIR(BgL_snamez00_686, BgL_arg2515z00_709);
										}
										BgL_arg2508z00_702 = MAKE_PAIR(BgL_arg2513z00_707, BNIL);
									}
									{	/* Object/struct.scm 115 */
										obj_t BgL_arg2529z00_723;

										obj_t BgL_arg2530z00_724;

										BgL_arg2529z00_723 = CNST_TABLE_REF(((long) 12));
										{	/* Object/struct.scm 116 */
											obj_t BgL_arg2531z00_725;

											obj_t BgL_arg2533z00_726;

											{	/* Object/struct.scm 116 */
												obj_t BgL_arg2535z00_728;

												obj_t BgL_arg2537z00_729;

												BgL_arg2535z00_728 = CNST_TABLE_REF(((long) 11));
												{	/* Object/struct.scm 116 */
													obj_t BgL_list2538z00_730;

													{	/* Object/struct.scm 116 */
														obj_t BgL_arg2540z00_732;

														{	/* Object/struct.scm 116 */
															obj_t BgL_arg2541z00_733;

															BgL_arg2541z00_733 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg2540z00_732 =
																MAKE_PAIR(BFALSE, BgL_arg2541z00_733);
														}
														BgL_list2538z00_730 =
															MAKE_PAIR(BINT(((long) 0)), BgL_arg2540z00_732);
													}
													BgL_arg2537z00_729 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_snamez00_686, BgL_list2538z00_730);
												}
												BgL_arg2531z00_725 =
													MAKE_PAIR(BgL_arg2535z00_728, BgL_arg2537z00_729);
											}
											{	/* Object/struct.scm 117 */
												obj_t BgL_arg2542z00_734;

												obj_t BgL_arg2543z00_735;

												{
													long BgL_iz00_737;

													obj_t BgL_slotsz00_738;

													obj_t BgL_resz00_739;

													BgL_iz00_737 = ((long) 1);
													BgL_slotsz00_738 = BgL_slotsz00_13;
													BgL_resz00_739 = BNIL;
												BgL_loopz00_740:
													if ((BgL_iz00_737 == BgL_lenz00_684))
														{	/* Object/struct.scm 121 */
															BgL_arg2542z00_734 =
																bgl_reverse_bang(BgL_resz00_739);
														}
													else
														{	/* Object/struct.scm 123 */
															bool_t BgL_testz00_1703;

															{	/* Object/struct.scm 123 */
																obj_t BgL_arg2553z00_750;

																BgL_arg2553z00_750 = CAR(BgL_slotsz00_738);
																BgL_testz00_1703 =
																	BGl_slotzd2virtualzf3z21zzobject_slotsz00(
																	(BgL_slotz00_bglt) (BgL_arg2553z00_750));
															}
															if (BgL_testz00_1703)
																{
																	obj_t BgL_slotsz00_1709;

																	long BgL_iz00_1707;

																	BgL_iz00_1707 = (BgL_iz00_737 + ((long) 1));
																	BgL_slotsz00_1709 = CDR(BgL_slotsz00_738);
																	BgL_slotsz00_738 = BgL_slotsz00_1709;
																	BgL_iz00_737 = BgL_iz00_1707;
																	goto BgL_loopz00_740;
																}
															else
																{	/* Object/struct.scm 128 */
																	long BgL_arg2548z00_745;

																	obj_t BgL_arg2549z00_746;

																	obj_t BgL_arg2550z00_747;

																	BgL_arg2548z00_745 =
																		(BgL_iz00_737 + ((long) 1));
																	BgL_arg2549z00_746 = CDR(BgL_slotsz00_738);
																	BgL_arg2550z00_747 =
																		MAKE_PAIR
																		(BGl_savezd2slotzd2zzobject_structz00
																		(BgL_onamez00_685, BgL_snamez00_686,
																			BgL_cnamez00_11, BgL_iz00_737,
																			CAR(BgL_slotsz00_738)), BgL_resz00_739);
																	{
																		obj_t BgL_resz00_1718;

																		obj_t BgL_slotsz00_1717;

																		long BgL_iz00_1716;

																		BgL_iz00_1716 = BgL_arg2548z00_745;
																		BgL_slotsz00_1717 = BgL_arg2549z00_746;
																		BgL_resz00_1718 = BgL_arg2550z00_747;
																		BgL_resz00_739 = BgL_resz00_1718;
																		BgL_slotsz00_738 = BgL_slotsz00_1717;
																		BgL_iz00_737 = BgL_iz00_1716;
																		goto BgL_loopz00_740;
																	}
																}
														}
												}
												BgL_arg2543z00_735 = MAKE_PAIR(BgL_snamez00_686, BNIL);
												BgL_arg2533z00_726 =
													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg2542z00_734, BgL_arg2543z00_735);
											}
											{	/* Object/struct.scm 115 */
												obj_t BgL_list2534z00_727;

												BgL_list2534z00_727 =
													MAKE_PAIR(BgL_arg2533z00_726, BNIL);
												BgL_arg2530z00_724 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg2531z00_725, BgL_list2534z00_727);
											}
										}
										BgL_arg2509z00_703 =
											MAKE_PAIR(BgL_arg2529z00_723, BgL_arg2530z00_724);
									}
									{	/* Object/struct.scm 114 */
										obj_t BgL_list2511z00_705;

										{	/* Object/struct.scm 114 */
											obj_t BgL_arg2512z00_706;

											BgL_arg2512z00_706 = MAKE_PAIR(BNIL, BNIL);
											BgL_list2511z00_705 =
												MAKE_PAIR(BgL_arg2509z00_703, BgL_arg2512z00_706);
										}
										BgL_arg2507z00_701 =
											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
											(BgL_arg2508z00_702, BgL_list2511z00_705);
									}
								}
								BgL_arg2497z00_691 =
									MAKE_PAIR(BgL_arg2506z00_700, BgL_arg2507z00_701);
							}
							{	/* Object/struct.scm 113 */
								obj_t BgL_list2499z00_693;

								{	/* Object/struct.scm 113 */
									obj_t BgL_arg2500z00_694;

									BgL_arg2500z00_694 = MAKE_PAIR(BNIL, BNIL);
									BgL_list2499z00_693 =
										MAKE_PAIR(BgL_arg2497z00_691, BgL_arg2500z00_694);
								}
								BgL_arg2495z00_689 =
									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
									(BgL_arg2496z00_690, BgL_list2499z00_693);
							}
						}
						BgL_arg2493z00_687 =
							MAKE_PAIR(BgL_arg2494z00_688, BgL_arg2495z00_689);
					}
					return
						BGl_epairifyz00zztools_miscz00(BgL_arg2493z00_687,
						BgL_srczd2defzd2_14);
				}
			}
		}
	}



/* gen-wide-class->struct */
	obj_t BGl_genzd2widezd2classzd2ze3structz31zzobject_structz00(obj_t
		BgL_cnamez00_15, BgL_typez00_bglt BgL_typez00_16, obj_t BgL_slotsz00_17,
		obj_t BgL_srczd2defzd2_18)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 142 */
			{	/* Object/struct.scm 143 */
				long BgL_lenz00_753;

				BgL_lenz00_753 =
					BGl_slotszd2lengthzd2zzobject_structz00(BgL_slotsz00_17);
				{	/* Object/struct.scm 143 */
					obj_t BgL_onamez00_754;

					BgL_onamez00_754 =
						BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 16)));
					{	/* Object/struct.scm 144 */
						obj_t BgL_resz00_755;

						BgL_resz00_755 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 17)));
						{	/* Object/struct.scm 145 */
							obj_t BgL_tresz00_756;

							{	/* Object/struct.scm 146 */
								obj_t BgL_arg2653z00_854;

								{	/* Object/struct.scm 146 */
									obj_t BgL_arg2654z00_855;

									obj_t BgL_arg2655z00_856;

									BgL_arg2654z00_855 = SYMBOL_TO_STRING(BgL_resz00_755);
									{	/* Object/struct.scm 146 */
										obj_t BgL_symbolz00_1378;

										BgL_symbolz00_1378 = CNST_TABLE_REF(((long) 22));
										BgL_arg2655z00_856 = SYMBOL_TO_STRING(BgL_symbolz00_1378);
									}
									{	/* Object/struct.scm 146 */
										obj_t BgL_list2656z00_857;

										{	/* Object/struct.scm 146 */
											obj_t BgL_arg2657z00_858;

											BgL_arg2657z00_858 = MAKE_PAIR(BgL_arg2655z00_856, BNIL);
											BgL_list2656z00_857 =
												MAKE_PAIR(BgL_arg2654z00_855, BgL_arg2657z00_858);
										}
										BgL_arg2653z00_854 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list2656z00_857);
								}}
								BgL_tresz00_756 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg2653z00_854));
							}
							{	/* Object/struct.scm 146 */
								obj_t BgL_auxz00_757;

								BgL_auxz00_757 =
									BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											23)));
								{	/* Object/struct.scm 147 */

									{	/* Object/struct.scm 149 */
										obj_t BgL_arg2556z00_758;

										{	/* Object/struct.scm 149 */
											obj_t BgL_arg2558z00_759;

											obj_t BgL_arg2559z00_760;

											BgL_arg2558z00_759 = CNST_TABLE_REF(((long) 18));
											{	/* Object/struct.scm 149 */
												obj_t BgL_arg2560z00_761;

												obj_t BgL_arg2561z00_762;

												{	/* Object/struct.scm 149 */
													obj_t BgL_arg2565z00_766;

													obj_t BgL_arg2566z00_767;

													BgL_arg2565z00_766 = CNST_TABLE_REF(((long) 19));
													{	/* Object/struct.scm 149 */
														obj_t BgL_arg2567z00_768;

														BgL_arg2567z00_768 =
															BGl_makezd2typedzd2identz00zzast_identz00
															(BgL_onamez00_754, BgL_cnamez00_15);
														{	/* Object/struct.scm 149 */
															obj_t BgL_list2569z00_770;

															BgL_list2569z00_770 = MAKE_PAIR(BNIL, BNIL);
															BgL_arg2566z00_767 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2567z00_768, BgL_list2569z00_770);
													}}
													BgL_arg2560z00_761 =
														MAKE_PAIR(BgL_arg2565z00_766, BgL_arg2566z00_767);
												}
												{	/* Object/struct.scm 150 */
													obj_t BgL_arg2570z00_771;

													obj_t BgL_arg2571z00_772;

													BgL_arg2570z00_771 = CNST_TABLE_REF(((long) 4));
													{	/* Object/struct.scm 150 */
														obj_t BgL_arg2572z00_773;

														obj_t BgL_arg2573z00_774;

														{	/* Object/struct.scm 150 */
															obj_t BgL_arg2577z00_778;

															{	/* Object/struct.scm 150 */
																obj_t BgL_arg2579z00_780;

																{	/* Object/struct.scm 150 */
																	obj_t BgL_arg2580z00_781;

																	BgL_arg2580z00_781 =
																		MAKE_PAIR(CNST_TABLE_REF(((long) 24)),
																		BNIL);
																	{	/* Object/struct.scm 150 */
																		obj_t BgL_list2582z00_783;

																		BgL_list2582z00_783 = MAKE_PAIR(BNIL, BNIL);
																		BgL_arg2579z00_780 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg2580z00_781, BgL_list2582z00_783);
																}}
																BgL_arg2577z00_778 =
																	MAKE_PAIR(BgL_tresz00_756,
																	BgL_arg2579z00_780);
															}
															BgL_arg2572z00_773 =
																MAKE_PAIR(BgL_arg2577z00_778, BNIL);
														}
														{	/* Object/struct.scm 151 */
															obj_t BgL_arg2583z00_784;

															obj_t BgL_arg2584z00_785;

															BgL_arg2583z00_784 = CNST_TABLE_REF(((long) 4));
															{	/* Object/struct.scm 151 */
																obj_t BgL_arg2585z00_786;

																obj_t BgL_arg2586z00_787;

																{	/* Object/struct.scm 151 */
																	obj_t BgL_arg2588z00_789;

																	{	/* Object/struct.scm 151 */
																		obj_t BgL_arg2590z00_791;

																		{	/* Object/struct.scm 151 */
																			obj_t BgL_arg2591z00_792;

																			{	/* Object/struct.scm 151 */
																				obj_t BgL_arg2594z00_795;

																				obj_t BgL_arg2595z00_796;

																				BgL_arg2594z00_795 =
																					CNST_TABLE_REF(((long) 20));
																				{	/* Object/struct.scm 151 */
																					obj_t BgL_arg2596z00_797;

																					{	/* Object/struct.scm 151 */
																						obj_t BgL_arg2602z00_802;

																						obj_t BgL_arg2603z00_803;

																						BgL_arg2602z00_802 =
																							CNST_TABLE_REF(((long) 21));
																						{	/* Object/struct.scm 151 */
																							obj_t BgL_list2604z00_804;

																							BgL_list2604z00_804 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2603z00_803 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_cnamez00_15,
																								BgL_list2604z00_804);
																						}
																						BgL_arg2596z00_797 =
																							MAKE_PAIR(BgL_arg2602z00_802,
																							BgL_arg2603z00_803);
																					}
																					{	/* Object/struct.scm 151 */
																						obj_t BgL_list2598z00_799;

																						{	/* Object/struct.scm 151 */
																							obj_t BgL_arg2600z00_800;

																							{	/* Object/struct.scm 151 */
																								obj_t BgL_arg2601z00_801;

																								BgL_arg2601z00_801 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2600z00_800 =
																									MAKE_PAIR(BUNSPEC,
																									BgL_arg2601z00_801);
																							}
																							BgL_list2598z00_799 =
																								MAKE_PAIR(BINT(BgL_lenz00_753),
																								BgL_arg2600z00_800);
																						}
																						BgL_arg2595z00_796 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2596z00_797,
																							BgL_list2598z00_799);
																				}}
																				BgL_arg2591z00_792 =
																					MAKE_PAIR(BgL_arg2594z00_795,
																					BgL_arg2595z00_796);
																			}
																			{	/* Object/struct.scm 151 */
																				obj_t BgL_list2593z00_794;

																				BgL_list2593z00_794 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_arg2590z00_791 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2591z00_792,
																					BgL_list2593z00_794);
																		}}
																		BgL_arg2588z00_789 =
																			MAKE_PAIR(BgL_auxz00_757,
																			BgL_arg2590z00_791);
																	}
																	BgL_arg2585z00_786 =
																		MAKE_PAIR(BgL_arg2588z00_789, BNIL);
																}
																{	/* Object/struct.scm 152 */
																	obj_t BgL_arg2605z00_805;

																	obj_t BgL_arg2606z00_806;

																	{
																		long BgL_iz00_808;

																		obj_t BgL_slotsz00_809;

																		obj_t BgL_resz00_810;

																		BgL_iz00_808 = ((long) 0);
																		BgL_slotsz00_809 = BgL_slotsz00_17;
																		BgL_resz00_810 = BNIL;
																	BgL_loopz00_811:
																		if ((BgL_iz00_808 == BgL_lenz00_753))
																			{	/* Object/struct.scm 156 */
																				BgL_arg2605z00_805 =
																					bgl_reverse_bang(BgL_resz00_810);
																			}
																		else
																			{	/* Object/struct.scm 158 */
																				bool_t BgL_testz00_1780;

																				{	/* Object/struct.scm 158 */
																					obj_t BgL_arg2617z00_821;

																					BgL_arg2617z00_821 =
																						CAR(BgL_slotsz00_809);
																					BgL_testz00_1780 =
																						BGl_slotzd2virtualzf3z21zzobject_slotsz00
																						((BgL_slotz00_bglt)
																						(BgL_arg2617z00_821));
																				}
																				if (BgL_testz00_1780)
																					{
																						obj_t BgL_slotsz00_1786;

																						long BgL_iz00_1784;

																						BgL_iz00_1784 =
																							(BgL_iz00_808 + ((long) 1));
																						BgL_slotsz00_1786 =
																							CDR(BgL_slotsz00_809);
																						BgL_slotsz00_809 =
																							BgL_slotsz00_1786;
																						BgL_iz00_808 = BgL_iz00_1784;
																						goto BgL_loopz00_811;
																					}
																				else
																					{	/* Object/struct.scm 163 */
																						long BgL_arg2611z00_816;

																						obj_t BgL_arg2612z00_817;

																						obj_t BgL_arg2614z00_818;

																						BgL_arg2611z00_816 =
																							(BgL_iz00_808 + ((long) 1));
																						BgL_arg2612z00_817 =
																							CDR(BgL_slotsz00_809);
																						BgL_arg2614z00_818 =
																							MAKE_PAIR
																							(BGl_savezd2slotzd2zzobject_structz00
																							(BgL_onamez00_754, BgL_auxz00_757,
																								BgL_cnamez00_15, BgL_iz00_808,
																								CAR(BgL_slotsz00_809)),
																							BgL_resz00_810);
																						{
																							obj_t BgL_resz00_1795;

																							obj_t BgL_slotsz00_1794;

																							long BgL_iz00_1793;

																							BgL_iz00_1793 =
																								BgL_arg2611z00_816;
																							BgL_slotsz00_1794 =
																								BgL_arg2612z00_817;
																							BgL_resz00_1795 =
																								BgL_arg2614z00_818;
																							BgL_resz00_810 = BgL_resz00_1795;
																							BgL_slotsz00_809 =
																								BgL_slotsz00_1794;
																							BgL_iz00_808 = BgL_iz00_1793;
																							goto BgL_loopz00_811;
																						}
																					}
																			}
																	}
																	{	/* Object/struct.scm 167 */
																		obj_t BgL_arg2618z00_822;

																		obj_t BgL_arg2619z00_823;

																		{	/* Object/struct.scm 167 */
																			obj_t BgL_arg2620z00_824;

																			obj_t BgL_arg2621z00_825;

																			BgL_arg2620z00_824 =
																				CNST_TABLE_REF(((long) 11));
																			{	/* Object/struct.scm 167 */
																				obj_t BgL_list2622z00_826;

																				{	/* Object/struct.scm 167 */
																					obj_t BgL_arg2624z00_828;

																					{	/* Object/struct.scm 167 */
																						obj_t BgL_arg2625z00_829;

																						BgL_arg2625z00_829 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg2624z00_828 =
																							MAKE_PAIR(BgL_auxz00_757,
																							BgL_arg2625z00_829);
																					}
																					BgL_list2622z00_826 =
																						MAKE_PAIR(BINT(((long) 0)),
																						BgL_arg2624z00_828);
																				}
																				BgL_arg2621z00_825 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_resz00_755, BgL_list2622z00_826);
																			}
																			BgL_arg2618z00_822 =
																				MAKE_PAIR(BgL_arg2620z00_824,
																				BgL_arg2621z00_825);
																		}
																		{	/* Object/struct.scm 169 */
																			obj_t BgL_arg2627z00_830;

																			obj_t BgL_arg2629z00_831;

																			{	/* Object/struct.scm 169 */
																				obj_t BgL_arg2635z00_836;

																				obj_t BgL_arg2636z00_837;

																				BgL_arg2635z00_836 =
																					CNST_TABLE_REF(((long) 25));
																				{	/* Object/struct.scm 169 */
																					obj_t BgL_arg2637z00_838;

																					{	/* Object/struct.scm 169 */
																						obj_t BgL_arg2641z00_842;

																						obj_t BgL_arg2642z00_843;

																						BgL_arg2641z00_842 =
																							CNST_TABLE_REF(((long) 26));
																						{	/* Object/struct.scm 169 */
																							obj_t BgL_list2643z00_844;

																							BgL_list2643z00_844 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2642z00_843 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_resz00_755,
																								BgL_list2643z00_844);
																						}
																						BgL_arg2637z00_838 =
																							MAKE_PAIR(BgL_arg2641z00_842,
																							BgL_arg2642z00_843);
																					}
																					{	/* Object/struct.scm 169 */
																						obj_t BgL_list2639z00_840;

																						{	/* Object/struct.scm 169 */
																							obj_t BgL_arg2640z00_841;

																							BgL_arg2640z00_841 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2639z00_840 =
																								MAKE_PAIR(BgL_arg2637z00_838,
																								BgL_arg2640z00_841);
																						}
																						BgL_arg2636z00_837 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_auxz00_757,
																							BgL_list2639z00_840);
																				}}
																				BgL_arg2627z00_830 =
																					MAKE_PAIR(BgL_arg2635z00_836,
																					BgL_arg2636z00_837);
																			}
																			{	/* Object/struct.scm 170 */
																				obj_t BgL_arg2644z00_845;

																				obj_t BgL_arg2645z00_846;

																				BgL_arg2644z00_845 =
																					CNST_TABLE_REF(((long) 25));
																				{	/* Object/struct.scm 170 */
																					obj_t BgL_arg2646z00_847;

																					{	/* Object/struct.scm 170 */
																						obj_t BgL_arg2650z00_851;

																						obj_t BgL_arg2651z00_852;

																						BgL_arg2650z00_851 =
																							CNST_TABLE_REF(((long) 21));
																						{	/* Object/struct.scm 170 */
																							obj_t BgL_list2652z00_853;

																							BgL_list2652z00_853 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2651z00_852 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_cnamez00_15,
																								BgL_list2652z00_853);
																						}
																						BgL_arg2646z00_847 =
																							MAKE_PAIR(BgL_arg2650z00_851,
																							BgL_arg2651z00_852);
																					}
																					{	/* Object/struct.scm 170 */
																						obj_t BgL_list2648z00_849;

																						{	/* Object/struct.scm 170 */
																							obj_t BgL_arg2649z00_850;

																							BgL_arg2649z00_850 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2648z00_849 =
																								MAKE_PAIR(BgL_arg2646z00_847,
																								BgL_arg2649z00_850);
																						}
																						BgL_arg2645z00_846 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_resz00_755,
																							BgL_list2648z00_849);
																				}}
																				BgL_arg2629z00_831 =
																					MAKE_PAIR(BgL_arg2644z00_845,
																					BgL_arg2645z00_846);
																			}
																			{	/* Object/struct.scm 151 */
																				obj_t BgL_list2631z00_833;

																				{	/* Object/struct.scm 151 */
																					obj_t BgL_arg2632z00_834;

																					{	/* Object/struct.scm 151 */
																						obj_t BgL_arg2633z00_835;

																						BgL_arg2633z00_835 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg2632z00_834 =
																							MAKE_PAIR(BgL_resz00_755,
																							BgL_arg2633z00_835);
																					}
																					BgL_list2631z00_833 =
																						MAKE_PAIR(BgL_arg2629z00_831,
																						BgL_arg2632z00_834);
																				}
																				BgL_arg2619z00_823 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2627z00_830,
																					BgL_list2631z00_833);
																		}}
																		BgL_arg2606z00_806 =
																			MAKE_PAIR(BgL_arg2618z00_822,
																			BgL_arg2619z00_823);
																	}
																	BgL_arg2586z00_787 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg2605z00_805, BgL_arg2606z00_806);
																}
																{	/* Object/struct.scm 151 */
																	obj_t BgL_list2587z00_788;

																	BgL_list2587z00_788 =
																		MAKE_PAIR(BgL_arg2586z00_787, BNIL);
																	BgL_arg2584z00_785 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg2585z00_786, BgL_list2587z00_788);
															}}
															BgL_arg2573z00_774 =
																MAKE_PAIR(BgL_arg2583z00_784,
																BgL_arg2584z00_785);
														}
														{	/* Object/struct.scm 150 */
															obj_t BgL_list2575z00_776;

															{	/* Object/struct.scm 150 */
																obj_t BgL_arg2576z00_777;

																BgL_arg2576z00_777 = MAKE_PAIR(BNIL, BNIL);
																BgL_list2575z00_776 =
																	MAKE_PAIR(BgL_arg2573z00_774,
																	BgL_arg2576z00_777);
															}
															BgL_arg2571z00_772 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2572z00_773, BgL_list2575z00_776);
													}}
													BgL_arg2561z00_762 =
														MAKE_PAIR(BgL_arg2570z00_771, BgL_arg2571z00_772);
												}
												{	/* Object/struct.scm 149 */
													obj_t BgL_list2563z00_764;

													{	/* Object/struct.scm 149 */
														obj_t BgL_arg2564z00_765;

														BgL_arg2564z00_765 = MAKE_PAIR(BNIL, BNIL);
														BgL_list2563z00_764 =
															MAKE_PAIR(BgL_arg2561z00_762, BgL_arg2564z00_765);
													}
													BgL_arg2559z00_760 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg2560z00_761, BgL_list2563z00_764);
											}}
											BgL_arg2556z00_758 =
												MAKE_PAIR(BgL_arg2558z00_759, BgL_arg2559z00_760);
										}
										return
											BGl_epairifyz00zztools_miscz00(BgL_arg2556z00_758,
											BgL_srczd2defzd2_18);
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* restore-slot */
	obj_t BGl_restorezd2slotzd2zzobject_structz00(obj_t BgL_onamez00_19,
		obj_t BgL_snamez00_20, obj_t BgL_cnamez00_21,
		BgL_typez00_bglt BgL_typez00_22, long BgL_iz00_23, obj_t BgL_slotz00_24)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 178 */
			{	/* Object/struct.scm 179 */
				obj_t BgL_loopz00_859;

				BgL_loopz00_859 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 2)));
				{	/* Object/struct.scm 179 */
					obj_t BgL_runnerz00_860;

					BgL_runnerz00_860 =
						BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 27)));
					{	/* Object/struct.scm 180 */
						obj_t BgL_vz00_861;

						BgL_vz00_861 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 28)));
						{	/* Object/struct.scm 181 */
							obj_t BgL_lenz00_862;

							BgL_lenz00_862 =
								BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 3)));
							{	/* Object/struct.scm 182 */
								obj_t BgL_runnerzd2typedzd2_863;

								{	/* Object/struct.scm 183 */
									obj_t BgL_arg2791z00_992;

									{	/* Object/struct.scm 183 */
										obj_t BgL_arg2792z00_993;

										obj_t BgL_arg2793z00_994;

										BgL_arg2792z00_993 = SYMBOL_TO_STRING(BgL_runnerz00_860);
										{	/* Object/struct.scm 183 */
											obj_t BgL_symbolz00_1391;

											BgL_symbolz00_1391 = CNST_TABLE_REF(((long) 29));
											BgL_arg2793z00_994 = SYMBOL_TO_STRING(BgL_symbolz00_1391);
										}
										{	/* Object/struct.scm 183 */
											obj_t BgL_list2794z00_995;

											{	/* Object/struct.scm 183 */
												obj_t BgL_arg2795z00_996;

												BgL_arg2795z00_996 =
													MAKE_PAIR(BgL_arg2793z00_994, BNIL);
												BgL_list2794z00_995 =
													MAKE_PAIR(BgL_arg2792z00_993, BgL_arg2795z00_996);
											}
											BgL_arg2791z00_992 =
												BGl_stringzd2appendzd2zz__r4_strings_6_7z00
												(BgL_list2794z00_995);
									}}
									BgL_runnerzd2typedzd2_863 =
										string_to_symbol(BSTRING_TO_STRING(BgL_arg2791z00_992));
								}
								{	/* Object/struct.scm 183 */

									if (BGl_slotzd2virtualzf3z21zzobject_slotsz00(
											(BgL_slotz00_bglt) (BgL_slotz00_24)))
										{	/* Object/struct.scm 185 */
											return BUNSPEC;
										}
									else
										{	/* Object/struct.scm 187 */
											bool_t BgL_testz00_1858;

											{	/* Object/struct.scm 187 */
												BgL_slotz00_bglt BgL_obj2262z00_1393;

												BgL_obj2262z00_1393 =
													(BgL_slotz00_bglt) (BgL_slotz00_24);
												BgL_testz00_1858 =
													CBOOL(
													(((BgL_slotz00_bglt) CREF(BgL_obj2262z00_1393))->
														BgL_indexedz00));
											}
											if (BgL_testz00_1858)
												{	/* Object/struct.scm 195 */
													obj_t BgL_fz00_866;

													BgL_fz00_866 =
														BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
																(long) 30)));
													{	/* Object/struct.scm 195 */
														obj_t BgL_tfz00_867;

														{	/* Object/struct.scm 196 */
															obj_t BgL_arg2769z00_970;

															{	/* Object/struct.scm 196 */
																BgL_typez00_bglt BgL_obj1319z00_1395;

																{	/* Object/struct.scm 196 */
																	BgL_slotz00_bglt BgL_obj2250z00_1394;

																	BgL_obj2250z00_1394 =
																		(BgL_slotz00_bglt) (BgL_slotz00_24);
																	BgL_obj1319z00_1395 =
																		(BgL_typez00_bglt) (
																		(((BgL_slotz00_bglt)
																				CREF(BgL_obj2250z00_1394))->
																			BgL_typez00));
																}
																BgL_arg2769z00_970 =
																	(((BgL_typez00_bglt)
																		CREF(BgL_obj1319z00_1395))->BgL_idz00);
															}
															BgL_tfz00_867 =
																BGl_makezd2typedzd2identz00zzast_identz00
																(BgL_fz00_866, BgL_arg2769z00_970);
														}
														{	/* Object/struct.scm 196 */

															{	/* Object/struct.scm 197 */
																obj_t BgL_arg2660z00_868;

																obj_t BgL_arg2661z00_869;

																BgL_arg2660z00_868 = CNST_TABLE_REF(((long) 4));
																{	/* Object/struct.scm 197 */
																	obj_t BgL_arg2662z00_870;

																	obj_t BgL_arg2663z00_871;

																	{	/* Object/struct.scm 197 */
																		obj_t BgL_arg2668z00_875;

																		{	/* Object/struct.scm 197 */
																			obj_t BgL_arg2670z00_877;

																			{	/* Object/struct.scm 197 */
																				obj_t BgL_arg2671z00_878;

																				{	/* Object/struct.scm 197 */
																					obj_t BgL_arg2674z00_881;

																					obj_t BgL_arg2675z00_882;

																					BgL_arg2674z00_881 =
																						CNST_TABLE_REF(((long) 31));
																					{	/* Object/struct.scm 197 */
																						obj_t BgL_list2676z00_883;

																						{	/* Object/struct.scm 197 */
																							obj_t BgL_arg2677z00_884;

																							BgL_arg2677z00_884 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2676z00_883 =
																								MAKE_PAIR(BINT(BgL_iz00_23),
																								BgL_arg2677z00_884);
																						}
																						BgL_arg2675z00_882 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(CNST_TABLE_REF(((long) 32)),
																							BgL_list2676z00_883);
																					}
																					BgL_arg2671z00_878 =
																						MAKE_PAIR(BgL_arg2674z00_881,
																						BgL_arg2675z00_882);
																				}
																				{	/* Object/struct.scm 197 */
																					obj_t BgL_list2673z00_880;

																					BgL_list2673z00_880 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg2670z00_877 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg2671z00_878,
																						BgL_list2673z00_880);
																			}}
																			BgL_arg2668z00_875 =
																				MAKE_PAIR(BgL_vz00_861,
																				BgL_arg2670z00_877);
																		}
																		BgL_arg2662z00_870 =
																			MAKE_PAIR(BgL_arg2668z00_875, BNIL);
																	}
																	{	/* Object/struct.scm 198 */
																		obj_t BgL_arg2678z00_885;

																		obj_t BgL_arg2679z00_886;

																		BgL_arg2678z00_885 =
																			CNST_TABLE_REF(((long) 4));
																		{	/* Object/struct.scm 198 */
																			obj_t BgL_arg2680z00_887;

																			obj_t BgL_arg2681z00_888;

																			obj_t BgL_arg2682z00_889;

																			{	/* Object/struct.scm 198 */
																				obj_t BgL_arg2687z00_894;

																				{	/* Object/struct.scm 198 */
																					obj_t BgL_arg2689z00_896;

																					obj_t BgL_arg2690z00_897;

																					{	/* Object/struct.scm 198 */
																						obj_t BgL_arg2691z00_898;

																						{	/* Object/struct.scm 198 */
																							obj_t BgL_arg2692z00_899;

																							obj_t BgL_arg2693z00_900;

																							BgL_arg2692z00_899 =
																								SYMBOL_TO_STRING
																								(BgL_lenz00_862);
																							{	/* Object/struct.scm 198 */
																								obj_t BgL_symbolz00_1397;

																								BgL_symbolz00_1397 =
																									CNST_TABLE_REF(((long) 29));
																								BgL_arg2693z00_900 =
																									SYMBOL_TO_STRING
																									(BgL_symbolz00_1397);
																							}
																							{	/* Object/struct.scm 198 */
																								obj_t BgL_list2694z00_901;

																								{	/* Object/struct.scm 198 */
																									obj_t BgL_arg2695z00_902;

																									BgL_arg2695z00_902 =
																										MAKE_PAIR
																										(BgL_arg2693z00_900, BNIL);
																									BgL_list2694z00_901 =
																										MAKE_PAIR
																										(BgL_arg2692z00_899,
																										BgL_arg2695z00_902);
																								}
																								BgL_arg2691z00_898 =
																									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																									(BgL_list2694z00_901);
																						}}
																						BgL_arg2689z00_896 =
																							string_to_symbol(BSTRING_TO_STRING
																							(BgL_arg2691z00_898));
																					}
																					{	/* Object/struct.scm 198 */
																						obj_t BgL_arg2696z00_903;

																						{	/* Object/struct.scm 198 */
																							obj_t BgL_arg2699z00_906;

																							obj_t BgL_arg2700z00_907;

																							BgL_arg2699z00_906 =
																								CNST_TABLE_REF(((long) 33));
																							{	/* Object/struct.scm 198 */
																								obj_t BgL_list2701z00_908;

																								BgL_list2701z00_908 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2700z00_907 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_vz00_861,
																									BgL_list2701z00_908);
																							}
																							BgL_arg2696z00_903 =
																								MAKE_PAIR(BgL_arg2699z00_906,
																								BgL_arg2700z00_907);
																						}
																						{	/* Object/struct.scm 198 */
																							obj_t BgL_list2698z00_905;

																							BgL_list2698z00_905 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2690z00_897 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_arg2696z00_903,
																								BgL_list2698z00_905);
																					}}
																					BgL_arg2687z00_894 =
																						MAKE_PAIR(BgL_arg2689z00_896,
																						BgL_arg2690z00_897);
																				}
																				BgL_arg2680z00_887 =
																					MAKE_PAIR(BgL_arg2687z00_894, BNIL);
																			}
																			BgL_arg2681z00_888 =
																				BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00
																				(BgL_typez00_22,
																				(BgL_slotz00_bglt) (BgL_slotz00_24),
																				CNST_TABLE_REF(((long) 34)),
																				BgL_lenz00_862);
																			{	/* Object/struct.scm 201 */
																				obj_t BgL_arg2702z00_909;

																				obj_t BgL_arg2703z00_910;

																				BgL_arg2702z00_909 =
																					CNST_TABLE_REF(((long) 8));
																				{	/* Object/struct.scm 201 */
																					obj_t BgL_arg2705z00_911;

																					obj_t BgL_arg2706z00_912;

																					{	/* Object/struct.scm 201 */
																						obj_t BgL_arg2712z00_916;

																						{	/* Object/struct.scm 201 */
																							obj_t BgL_arg2714z00_918;

																							{	/* Object/struct.scm 201 */
																								obj_t BgL_arg2715z00_919;

																								obj_t BgL_arg2716z00_920;

																								BgL_arg2715z00_919 =
																									MAKE_PAIR
																									(BgL_runnerzd2typedzd2_863,
																									BNIL);
																								{	/* Object/struct.scm 202 */
																									obj_t BgL_arg2720z00_924;

																									obj_t BgL_arg2721z00_925;

																									BgL_arg2720z00_924 =
																										CNST_TABLE_REF(((long) 9));
																									{	/* Object/struct.scm 202 */
																										obj_t BgL_arg2722z00_926;

																										obj_t BgL_arg2723z00_927;

																										obj_t BgL_arg2725z00_928;

																										{	/* Object/struct.scm 202 */
																											obj_t BgL_arg2731z00_933;

																											obj_t BgL_arg2732z00_934;

																											BgL_arg2731z00_933 =
																												CNST_TABLE_REF(((long)
																													10));
																											{	/* Object/struct.scm 202 */
																												obj_t
																													BgL_list2733z00_935;
																												{	/* Object/struct.scm 202 */
																													obj_t
																														BgL_arg2734z00_936;
																													BgL_arg2734z00_936 =
																														MAKE_PAIR(BNIL,
																														BNIL);
																													BgL_list2733z00_935 =
																														MAKE_PAIR
																														(BgL_lenz00_862,
																														BgL_arg2734z00_936);
																												}
																												BgL_arg2732z00_934 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_runnerz00_860,
																													BgL_list2733z00_935);
																											}
																											BgL_arg2722z00_926 =
																												MAKE_PAIR
																												(BgL_arg2731z00_933,
																												BgL_arg2732z00_934);
																										}
																										{	/* Object/struct.scm 203 */
																											obj_t BgL_arg2735z00_937;

																											obj_t BgL_arg2736z00_938;

																											BgL_arg2735z00_937 =
																												CNST_TABLE_REF(((long)
																													21));
																											{	/* Object/struct.scm 203 */
																												obj_t
																													BgL_list2737z00_939;
																												BgL_list2737z00_939 =
																													MAKE_PAIR(BNIL, BNIL);
																												BgL_arg2736z00_938 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(CNST_TABLE_REF((
																															(long) 35)),
																													BgL_list2737z00_939);
																											}
																											BgL_arg2723z00_927 =
																												MAKE_PAIR
																												(BgL_arg2735z00_937,
																												BgL_arg2736z00_938);
																										}
																										{	/* Object/struct.scm 204 */
																											obj_t BgL_arg2738z00_940;

																											obj_t BgL_arg2739z00_941;

																											BgL_arg2738z00_940 =
																												CNST_TABLE_REF(((long)
																													4));
																											{	/* Object/struct.scm 204 */
																												obj_t
																													BgL_arg2740z00_942;
																												obj_t
																													BgL_arg2741z00_943;
																												obj_t
																													BgL_arg2742z00_944;
																												{	/* Object/struct.scm 204 */
																													obj_t
																														BgL_arg2747z00_949;
																													{	/* Object/struct.scm 204 */
																														obj_t
																															BgL_arg2749z00_951;
																														{	/* Object/struct.scm 204 */
																															obj_t
																																BgL_arg2750z00_952;
																															{	/* Object/struct.scm 204 */
																																obj_t
																																	BgL_arg2754z00_955;
																																obj_t
																																	BgL_arg2755z00_956;
																																BgL_arg2754z00_955
																																	=
																																	CNST_TABLE_REF
																																	(((long) 36));
																																{	/* Object/struct.scm 204 */
																																	obj_t
																																		BgL_list2756z00_957;
																																	{	/* Object/struct.scm 204 */
																																		obj_t
																																			BgL_arg2757z00_958;
																																		BgL_arg2757z00_958
																																			=
																																			MAKE_PAIR
																																			(BNIL,
																																			BNIL);
																																		BgL_list2756z00_957
																																			=
																																			MAKE_PAIR
																																			(BgL_runnerz00_860,
																																			BgL_arg2757z00_958);
																																	}
																																	BgL_arg2755z00_956
																																		=
																																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																		(BgL_vz00_861,
																																		BgL_list2756z00_957);
																																}
																																BgL_arg2750z00_952
																																	=
																																	MAKE_PAIR
																																	(BgL_arg2754z00_955,
																																	BgL_arg2755z00_956);
																															}
																															{	/* Object/struct.scm 204 */
																																obj_t
																																	BgL_list2753z00_954;
																																BgL_list2753z00_954
																																	=
																																	MAKE_PAIR
																																	(BNIL, BNIL);
																																BgL_arg2749z00_951
																																	=
																																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																	(BgL_arg2750z00_952,
																																	BgL_list2753z00_954);
																														}}
																														BgL_arg2747z00_949 =
																															MAKE_PAIR
																															(BgL_tfz00_867,
																															BgL_arg2749z00_951);
																													}
																													BgL_arg2740z00_942 =
																														MAKE_PAIR
																														(BgL_arg2747z00_949,
																														BNIL);
																												}
																												BgL_arg2741z00_943 =
																													BGl_makezd2pragmazd2indexedzd2setz12zc0zzobject_toolsz00
																													(BgL_typez00_22,
																													(BgL_slotz00_bglt)
																													(BgL_slotz00_24),
																													CNST_TABLE_REF(((long)
																															34)),
																													BgL_fz00_866,
																													BgL_runnerz00_860);
																												{	/* Object/struct.scm 211 */
																													obj_t
																														BgL_arg2758z00_959;
																													{	/* Object/struct.scm 211 */
																														obj_t
																															BgL_arg2759z00_960;
																														{	/* Object/struct.scm 211 */
																															obj_t
																																BgL_arg2762z00_963;
																															obj_t
																																BgL_arg2763z00_964;
																															BgL_arg2762z00_963
																																=
																																CNST_TABLE_REF((
																																	(long) 15));
																															{	/* Object/struct.scm 211 */
																																obj_t
																																	BgL_list2764z00_965;
																																{	/* Object/struct.scm 211 */
																																	obj_t
																																		BgL_arg2766z00_967;
																																	BgL_arg2766z00_967
																																		=
																																		MAKE_PAIR
																																		(BNIL,
																																		BNIL);
																																	BgL_list2764z00_965
																																		=
																																		MAKE_PAIR
																																		(BINT((
																																				(long)
																																				1)),
																																		BgL_arg2766z00_967);
																																}
																																BgL_arg2763z00_964
																																	=
																																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																	(BgL_runnerz00_860,
																																	BgL_list2764z00_965);
																															}
																															BgL_arg2759z00_960
																																=
																																MAKE_PAIR
																																(BgL_arg2762z00_963,
																																BgL_arg2763z00_964);
																														}
																														{	/* Object/struct.scm 211 */
																															obj_t
																																BgL_list2761z00_962;
																															BgL_list2761z00_962
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															BgL_arg2758z00_959
																																=
																																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																(BgL_arg2759z00_960,
																																BgL_list2761z00_962);
																													}}
																													BgL_arg2742z00_944 =
																														MAKE_PAIR
																														(BgL_loopz00_859,
																														BgL_arg2758z00_959);
																												}
																												{	/* Object/struct.scm 204 */
																													obj_t
																														BgL_list2744z00_946;
																													{	/* Object/struct.scm 204 */
																														obj_t
																															BgL_arg2745z00_947;
																														{	/* Object/struct.scm 204 */
																															obj_t
																																BgL_arg2746z00_948;
																															BgL_arg2746z00_948
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															BgL_arg2745z00_947
																																=
																																MAKE_PAIR
																																(BgL_arg2742z00_944,
																																BgL_arg2746z00_948);
																														}
																														BgL_list2744z00_946
																															=
																															MAKE_PAIR
																															(BgL_arg2741z00_943,
																															BgL_arg2745z00_947);
																													}
																													BgL_arg2739z00_941 =
																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																														(BgL_arg2740z00_942,
																														BgL_list2744z00_946);
																											}}
																											BgL_arg2725z00_928 =
																												MAKE_PAIR
																												(BgL_arg2738z00_940,
																												BgL_arg2739z00_941);
																										}
																										{	/* Object/struct.scm 202 */
																											obj_t BgL_list2728z00_930;

																											{	/* Object/struct.scm 202 */
																												obj_t
																													BgL_arg2729z00_931;
																												{	/* Object/struct.scm 202 */
																													obj_t
																														BgL_arg2730z00_932;
																													BgL_arg2730z00_932 =
																														MAKE_PAIR(BNIL,
																														BNIL);
																													BgL_arg2729z00_931 =
																														MAKE_PAIR
																														(BgL_arg2725z00_928,
																														BgL_arg2730z00_932);
																												}
																												BgL_list2728z00_930 =
																													MAKE_PAIR
																													(BgL_arg2723z00_927,
																													BgL_arg2729z00_931);
																											}
																											BgL_arg2721z00_925 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg2722z00_926,
																												BgL_list2728z00_930);
																									}}
																									BgL_arg2716z00_920 =
																										MAKE_PAIR
																										(BgL_arg2720z00_924,
																										BgL_arg2721z00_925);
																								}
																								{	/* Object/struct.scm 201 */
																									obj_t BgL_list2718z00_922;

																									{	/* Object/struct.scm 201 */
																										obj_t BgL_arg2719z00_923;

																										BgL_arg2719z00_923 =
																											MAKE_PAIR(BNIL, BNIL);
																										BgL_list2718z00_922 =
																											MAKE_PAIR
																											(BgL_arg2716z00_920,
																											BgL_arg2719z00_923);
																									}
																									BgL_arg2714z00_918 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg2715z00_919,
																										BgL_list2718z00_922);
																							}}
																							BgL_arg2712z00_916 =
																								MAKE_PAIR(BgL_loopz00_859,
																								BgL_arg2714z00_918);
																						}
																						BgL_arg2705z00_911 =
																							MAKE_PAIR(BgL_arg2712z00_916,
																							BNIL);
																					}
																					{	/* Object/struct.scm 212 */
																						obj_t BgL_arg2767z00_968;

																						{	/* Object/struct.scm 212 */
																							obj_t BgL_list2768z00_969;

																							BgL_list2768z00_969 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2767z00_968 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BINT(((long) 0)),
																								BgL_list2768z00_969);
																						}
																						BgL_arg2706z00_912 =
																							MAKE_PAIR(BgL_loopz00_859,
																							BgL_arg2767z00_968);
																					}
																					{	/* Object/struct.scm 201 */
																						obj_t BgL_list2709z00_914;

																						{	/* Object/struct.scm 201 */
																							obj_t BgL_arg2711z00_915;

																							BgL_arg2711z00_915 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list2709z00_914 =
																								MAKE_PAIR(BgL_arg2706z00_912,
																								BgL_arg2711z00_915);
																						}
																						BgL_arg2703z00_910 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2705z00_911,
																							BgL_list2709z00_914);
																				}}
																				BgL_arg2682z00_889 =
																					MAKE_PAIR(BgL_arg2702z00_909,
																					BgL_arg2703z00_910);
																			}
																			{	/* Object/struct.scm 198 */
																				obj_t BgL_list2684z00_891;

																				{	/* Object/struct.scm 198 */
																					obj_t BgL_arg2685z00_892;

																					{	/* Object/struct.scm 198 */
																						obj_t BgL_arg2686z00_893;

																						BgL_arg2686z00_893 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg2685z00_892 =
																							MAKE_PAIR(BgL_arg2682z00_889,
																							BgL_arg2686z00_893);
																					}
																					BgL_list2684z00_891 =
																						MAKE_PAIR(BgL_arg2681z00_888,
																						BgL_arg2685z00_892);
																				}
																				BgL_arg2679z00_886 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2680z00_887,
																					BgL_list2684z00_891);
																		}}
																		BgL_arg2663z00_871 =
																			MAKE_PAIR(BgL_arg2678z00_885,
																			BgL_arg2679z00_886);
																	}
																	{	/* Object/struct.scm 197 */
																		obj_t BgL_list2665z00_873;

																		{	/* Object/struct.scm 197 */
																			obj_t BgL_arg2666z00_874;

																			BgL_arg2666z00_874 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_list2665z00_873 =
																				MAKE_PAIR(BgL_arg2663z00_871,
																				BgL_arg2666z00_874);
																		}
																		BgL_arg2661z00_869 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg2662z00_870, BgL_list2665z00_873);
																}}
																return
																	MAKE_PAIR(BgL_arg2660z00_868,
																	BgL_arg2661z00_869);
															}
														}
													}
												}
											else
												{	/* Object/struct.scm 214 */
													obj_t BgL_arg2771z00_972;

													obj_t BgL_arg2772z00_973;

													BgL_arg2771z00_972 = CNST_TABLE_REF(((long) 4));
													{	/* Object/struct.scm 214 */
														obj_t BgL_arg2773z00_974;

														obj_t BgL_arg2774z00_975;

														{	/* Object/struct.scm 214 */
															obj_t BgL_arg2778z00_979;

															{	/* Object/struct.scm 214 */
																obj_t BgL_arg2780z00_981;

																obj_t BgL_arg2781z00_982;

																{	/* Object/struct.scm 214 */
																	obj_t BgL_arg2782z00_983;

																	{	/* Object/struct.scm 214 */
																		BgL_typez00_bglt BgL_obj1319z00_1400;

																		{	/* Object/struct.scm 214 */
																			BgL_slotz00_bglt BgL_obj2250z00_1399;

																			BgL_obj2250z00_1399 =
																				(BgL_slotz00_bglt) (BgL_slotz00_24);
																			BgL_obj1319z00_1400 =
																				(BgL_typez00_bglt) (
																				(((BgL_slotz00_bglt)
																						CREF(BgL_obj2250z00_1399))->
																					BgL_typez00));
																		}
																		BgL_arg2782z00_983 =
																			(((BgL_typez00_bglt)
																				CREF(BgL_obj1319z00_1400))->BgL_idz00);
																	}
																	BgL_arg2780z00_981 =
																		BGl_makezd2typedzd2identz00zzast_identz00
																		(BgL_vz00_861, BgL_arg2782z00_983);
																}
																{	/* Object/struct.scm 215 */
																	obj_t BgL_arg2784z00_985;

																	{	/* Object/struct.scm 215 */
																		obj_t BgL_arg2787z00_988;

																		obj_t BgL_arg2788z00_989;

																		BgL_arg2787z00_988 =
																			CNST_TABLE_REF(((long) 31));
																		{	/* Object/struct.scm 215 */
																			obj_t BgL_list2789z00_990;

																			{	/* Object/struct.scm 215 */
																				obj_t BgL_arg2790z00_991;

																				BgL_arg2790z00_991 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list2789z00_990 =
																					MAKE_PAIR(BINT(BgL_iz00_23),
																					BgL_arg2790z00_991);
																			}
																			BgL_arg2788z00_989 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(CNST_TABLE_REF(((long) 32)),
																				BgL_list2789z00_990);
																		}
																		BgL_arg2784z00_985 =
																			MAKE_PAIR(BgL_arg2787z00_988,
																			BgL_arg2788z00_989);
																	}
																	{	/* Object/struct.scm 214 */
																		obj_t BgL_list2786z00_987;

																		BgL_list2786z00_987 = MAKE_PAIR(BNIL, BNIL);
																		BgL_arg2781z00_982 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg2784z00_985, BgL_list2786z00_987);
																}}
																BgL_arg2778z00_979 =
																	MAKE_PAIR(BgL_arg2780z00_981,
																	BgL_arg2781z00_982);
															}
															BgL_arg2773z00_974 =
																MAKE_PAIR(BgL_arg2778z00_979, BNIL);
														}
														BgL_arg2774z00_975 =
															BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00
															(BgL_typez00_22,
															(BgL_slotz00_bglt) (BgL_slotz00_24),
															CNST_TABLE_REF(((long) 34)), BgL_vz00_861);
														{	/* Object/struct.scm 214 */
															obj_t BgL_list2776z00_977;

															{	/* Object/struct.scm 214 */
																obj_t BgL_arg2777z00_978;

																BgL_arg2777z00_978 = MAKE_PAIR(BNIL, BNIL);
																BgL_list2776z00_977 =
																	MAKE_PAIR(BgL_arg2774z00_975,
																	BgL_arg2777z00_978);
															}
															BgL_arg2772z00_973 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BgL_arg2773z00_974, BgL_list2776z00_977);
													}}
													return
														MAKE_PAIR(BgL_arg2771z00_972, BgL_arg2772z00_973);
												}
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* gen-struct->plain-class */
	obj_t BGl_genzd2structzd2ze3plainzd2classz31zzobject_structz00(obj_t
		BgL_cnamez00_25, BgL_typez00_bglt BgL_typez00_26, obj_t BgL_slotsz00_27,
		obj_t BgL_srczd2defzd2_28)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 227 */
			{	/* Object/struct.scm 229 */
				obj_t BgL_arg2796z00_997;

				{	/* Object/struct.scm 229 */
					obj_t BgL_arg2797z00_998;

					obj_t BgL_arg2798z00_999;

					BgL_arg2797z00_998 = CNST_TABLE_REF(((long) 18));
					{	/* Object/struct.scm 229 */
						obj_t BgL_arg2799z00_1000;

						obj_t BgL_arg2800z00_1001;

						{	/* Object/struct.scm 229 */
							obj_t BgL_arg2804z00_1005;

							obj_t BgL_arg2805z00_1006;

							BgL_arg2804z00_1005 = CNST_TABLE_REF(((long) 37));
							{	/* Object/struct.scm 229 */
								obj_t BgL_arg2806z00_1007;

								obj_t BgL_arg2807z00_1008;

								BgL_arg2806z00_1007 =
									BGl_makezd2typedzd2identz00zzast_identz00(CNST_TABLE_REF((
											(long) 34)), BgL_cnamez00_25);
								BgL_arg2807z00_1008 = CNST_TABLE_REF(((long) 38));
								{	/* Object/struct.scm 229 */
									obj_t BgL_list2809z00_1010;

									{	/* Object/struct.scm 229 */
										obj_t BgL_arg2810z00_1011;

										BgL_arg2810z00_1011 = MAKE_PAIR(BNIL, BNIL);
										BgL_list2809z00_1010 =
											MAKE_PAIR(BgL_arg2807z00_1008, BgL_arg2810z00_1011);
									}
									BgL_arg2805z00_1006 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg2806z00_1007, BgL_list2809z00_1010);
							}}
							BgL_arg2799z00_1000 =
								MAKE_PAIR(BgL_arg2804z00_1005, BgL_arg2805z00_1006);
						}
						{	/* Object/struct.scm 231 */
							obj_t BgL_arg2811z00_1012;

							obj_t BgL_arg2812z00_1013;

							BgL_arg2811z00_1012 = CNST_TABLE_REF(((long) 12));
							{	/* Object/struct.scm 232 */
								obj_t BgL_arg2813z00_1014;

								obj_t BgL_arg2814z00_1015;

								{	/* Object/struct.scm 232 */
									obj_t BgL_arg2817z00_1017;

									obj_t BgL_arg2818z00_1018;

									BgL_arg2817z00_1017 = CNST_TABLE_REF(((long) 39));
									{	/* Object/struct.scm 232 */
										obj_t BgL_arg2819z00_1019;

										obj_t BgL_arg2820z00_1020;

										BgL_arg2819z00_1019 = CNST_TABLE_REF(((long) 34));
										{	/* Object/struct.scm 232 */
											obj_t BgL_arg2824z00_1024;

											obj_t BgL_arg2825z00_1025;

											BgL_arg2824z00_1024 = CNST_TABLE_REF(((long) 31));
											{	/* Object/struct.scm 232 */
												obj_t BgL_list2826z00_1026;

												{	/* Object/struct.scm 232 */
													obj_t BgL_arg2828z00_1028;

													BgL_arg2828z00_1028 = MAKE_PAIR(BNIL, BNIL);
													BgL_list2826z00_1026 =
														MAKE_PAIR(BINT(((long) 0)), BgL_arg2828z00_1028);
												}
												BgL_arg2825z00_1025 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(CNST_TABLE_REF(((long) 32)), BgL_list2826z00_1026);
											}
											BgL_arg2820z00_1020 =
												MAKE_PAIR(BgL_arg2824z00_1024, BgL_arg2825z00_1025);
										}
										{	/* Object/struct.scm 232 */
											obj_t BgL_list2822z00_1022;

											{	/* Object/struct.scm 232 */
												obj_t BgL_arg2823z00_1023;

												BgL_arg2823z00_1023 = MAKE_PAIR(BNIL, BNIL);
												BgL_list2822z00_1022 =
													MAKE_PAIR(BgL_arg2820z00_1020, BgL_arg2823z00_1023);
											}
											BgL_arg2818z00_1018 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BgL_arg2819z00_1019, BgL_list2822z00_1022);
									}}
									BgL_arg2813z00_1014 =
										MAKE_PAIR(BgL_arg2817z00_1017, BgL_arg2818z00_1018);
								}
								{	/* Object/struct.scm 233 */
									obj_t BgL_arg2829z00_1029;

									obj_t BgL_arg2830z00_1030;

									{
										long BgL_iz00_1032;

										obj_t BgL_slotsz00_1033;

										obj_t BgL_resz00_1034;

										BgL_iz00_1032 = ((long) 1);
										BgL_slotsz00_1033 = BgL_slotsz00_27;
										BgL_resz00_1034 = BNIL;
									BgL_loopz00_1035:
										if (NULLP(BgL_slotsz00_1033))
											{	/* Object/struct.scm 237 */
												BgL_arg2829z00_1029 = bgl_reverse_bang(BgL_resz00_1034);
											}
										else
											{	/* Object/struct.scm 239 */
												bool_t BgL_testz00_2018;

												{	/* Object/struct.scm 239 */
													obj_t BgL_arg2842z00_1047;

													BgL_arg2842z00_1047 = CAR(BgL_slotsz00_1033);
													BgL_testz00_2018 =
														BGl_slotzd2virtualzf3z21zzobject_slotsz00(
														(BgL_slotz00_bglt) (BgL_arg2842z00_1047));
												}
												if (BgL_testz00_2018)
													{
														obj_t BgL_slotsz00_2024;

														long BgL_iz00_2022;

														BgL_iz00_2022 = (BgL_iz00_1032 + ((long) 1));
														BgL_slotsz00_2024 = CDR(BgL_slotsz00_1033);
														BgL_slotsz00_1033 = BgL_slotsz00_2024;
														BgL_iz00_1032 = BgL_iz00_2022;
														goto BgL_loopz00_1035;
													}
												else
													{	/* Object/struct.scm 244 */
														obj_t BgL_newz00_1040;

														{	/* Object/struct.scm 244 */
															obj_t BgL_arg2839z00_1044;

															obj_t BgL_arg2840z00_1045;

															obj_t BgL_arg2841z00_1046;

															BgL_arg2839z00_1044 = CNST_TABLE_REF(((long) 34));
															BgL_arg2840z00_1045 = CNST_TABLE_REF(((long) 32));
															BgL_arg2841z00_1046 = CAR(BgL_slotsz00_1033);
															BgL_newz00_1040 =
																BGl_restorezd2slotzd2zzobject_structz00
																(BgL_arg2839z00_1044, BgL_arg2840z00_1045,
																BgL_cnamez00_25, BgL_typez00_26, BgL_iz00_1032,
																BgL_arg2841z00_1046);
														}
														{	/* Object/struct.scm 245 */
															long BgL_arg2835z00_1041;

															obj_t BgL_arg2836z00_1042;

															obj_t BgL_arg2838z00_1043;

															BgL_arg2835z00_1041 =
																(BgL_iz00_1032 + ((long) 1));
															BgL_arg2836z00_1042 = CDR(BgL_slotsz00_1033);
															BgL_arg2838z00_1043 =
																MAKE_PAIR(BgL_newz00_1040, BgL_resz00_1034);
															{
																obj_t BgL_resz00_2035;

																obj_t BgL_slotsz00_2034;

																long BgL_iz00_2033;

																BgL_iz00_2033 = BgL_arg2835z00_1041;
																BgL_slotsz00_2034 = BgL_arg2836z00_1042;
																BgL_resz00_2035 = BgL_arg2838z00_1043;
																BgL_resz00_1034 = BgL_resz00_2035;
																BgL_slotsz00_1033 = BgL_slotsz00_2034;
																BgL_iz00_1032 = BgL_iz00_2033;
																goto BgL_loopz00_1035;
															}
														}
													}
											}
									}
									BgL_arg2830z00_1030 =
										MAKE_PAIR(CNST_TABLE_REF(((long) 34)), BNIL);
									BgL_arg2814z00_1015 =
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg2829z00_1029, BgL_arg2830z00_1030);
								}
								{	/* Object/struct.scm 231 */
									obj_t BgL_list2815z00_1016;

									BgL_list2815z00_1016 = MAKE_PAIR(BgL_arg2814z00_1015, BNIL);
									BgL_arg2812z00_1013 =
										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
										(BgL_arg2813z00_1014, BgL_list2815z00_1016);
							}}
							BgL_arg2800z00_1001 =
								MAKE_PAIR(BgL_arg2811z00_1012, BgL_arg2812z00_1013);
						}
						{	/* Object/struct.scm 229 */
							obj_t BgL_list2802z00_1003;

							{	/* Object/struct.scm 229 */
								obj_t BgL_arg2803z00_1004;

								BgL_arg2803z00_1004 = MAKE_PAIR(BNIL, BNIL);
								BgL_list2802z00_1003 =
									MAKE_PAIR(BgL_arg2800z00_1001, BgL_arg2803z00_1004);
							}
							BgL_arg2798z00_999 =
								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_arg2799z00_1000,
								BgL_list2802z00_1003);
					}}
					BgL_arg2796z00_997 =
						MAKE_PAIR(BgL_arg2797z00_998, BgL_arg2798z00_999);
				}
				return
					BGl_epairifyz00zztools_miscz00(BgL_arg2796z00_997,
					BgL_srczd2defzd2_28);
			}
		}
	}



/* gen-struct->wide-class */
	obj_t BGl_genzd2structzd2ze3widezd2classz31zzobject_structz00(obj_t
		BgL_cnamez00_29, BgL_typez00_bglt BgL_typez00_30, obj_t BgL_slotsz00_31,
		obj_t BgL_srczd2defzd2_32)
	{
		AN_OBJECT;
		{	/* Object/struct.scm 254 */
			{	/* Object/struct.scm 255 */
				obj_t BgL_oldz00_1048;

				BgL_oldz00_1048 =
					BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 40)));
				{	/* Object/struct.scm 255 */
					long BgL_lenz00_1049;

					BgL_lenz00_1049 =
						BGl_slotszd2lengthzd2zzobject_structz00(BgL_slotsz00_31);
					{	/* Object/struct.scm 256 */
						obj_t BgL_auxz00_1050;

						BgL_auxz00_1050 =
							BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 23)));
						{	/* Object/struct.scm 257 */
							obj_t BgL_tauxz00_1051;

							{	/* Object/struct.scm 258 */
								obj_t BgL_arg2967z00_1184;

								{	/* Object/struct.scm 258 */
									obj_t BgL_arg2968z00_1185;

									obj_t BgL_arg2969z00_1186;

									BgL_arg2968z00_1185 = SYMBOL_TO_STRING(BgL_auxz00_1050);
									{	/* Object/struct.scm 258 */
										obj_t BgL_symbolz00_1411;

										BgL_symbolz00_1411 = CNST_TABLE_REF(((long) 22));
										BgL_arg2969z00_1186 = SYMBOL_TO_STRING(BgL_symbolz00_1411);
									}
									{	/* Object/struct.scm 258 */
										obj_t BgL_list2970z00_1187;

										{	/* Object/struct.scm 258 */
											obj_t BgL_arg2971z00_1188;

											BgL_arg2971z00_1188 =
												MAKE_PAIR(BgL_arg2969z00_1186, BNIL);
											BgL_list2970z00_1187 =
												MAKE_PAIR(BgL_arg2968z00_1185, BgL_arg2971z00_1188);
										}
										BgL_arg2967z00_1184 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list2970z00_1187);
								}}
								BgL_tauxz00_1051 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg2967z00_1184));
							}
							{	/* Object/struct.scm 258 */
								obj_t BgL_newz00_1052;

								BgL_newz00_1052 =
									BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											41)));
								{	/* Object/struct.scm 259 */
									obj_t BgL_tidz00_1053;

									BgL_tidz00_1053 =
										(((BgL_typez00_bglt) CREF(BgL_typez00_30))->BgL_idz00);
									{	/* Object/struct.scm 260 */
										BgL_globalz00_bglt BgL_holderz00_1054;

										{	/* Object/struct.scm 261 */
											BgL_tclassz00_bglt BgL_obj2042z00_1414;

											BgL_obj2042z00_1414 =
												(BgL_tclassz00_bglt) (BgL_typez00_30);
											{
												obj_t BgL_auxz00_2064;

												{	/* Object/struct.scm 261 */
													BgL_objectz00_bglt BgL_auxz00_2065;

													BgL_auxz00_2065 =
														(BgL_objectz00_bglt) (BgL_obj2042z00_1414);
													BgL_auxz00_2064 =
														BGL_OBJECT_WIDENING(BgL_auxz00_2065);
												}
												BgL_holderz00_1054 =
													(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2064))->
													BgL_holderz00);
										}}
										{	/* Object/struct.scm 261 */
											obj_t BgL_wideningz00_1055;

											{	/* Object/struct.scm 262 */
												obj_t BgL_arg2962z00_1179;

												obj_t BgL_arg2963z00_1180;

												{	/* Object/struct.scm 262 */
													BgL_tclassz00_bglt BgL_obj2043z00_1415;

													BgL_obj2043z00_1415 =
														(BgL_tclassz00_bglt) (BgL_typez00_30);
													{
														obj_t BgL_auxz00_2070;

														{	/* Object/struct.scm 262 */
															BgL_objectz00_bglt BgL_auxz00_2071;

															BgL_auxz00_2071 =
																(BgL_objectz00_bglt) (BgL_obj2043z00_1415);
															BgL_auxz00_2070 =
																BGL_OBJECT_WIDENING(BgL_auxz00_2071);
														}
														BgL_arg2962z00_1179 =
															(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2070))->
															BgL_wideningz00);
												}}
												BgL_arg2963z00_1180 = CNST_TABLE_REF(((long) 5));
												{	/* Object/struct.scm 262 */
													obj_t BgL_list2964z00_1181;

													{	/* Object/struct.scm 262 */
														obj_t BgL_arg2965z00_1182;

														{	/* Object/struct.scm 262 */
															obj_t BgL_arg2966z00_1183;

															BgL_arg2966z00_1183 =
																MAKE_PAIR(BgL_tidz00_1053, BNIL);
															BgL_arg2965z00_1182 =
																MAKE_PAIR(BgL_arg2963z00_1180,
																BgL_arg2966z00_1183);
														}
														BgL_list2964z00_1181 =
															MAKE_PAIR(BgL_arg2962z00_1179,
															BgL_arg2965z00_1182);
													}
													BgL_wideningz00_1055 =
														BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
														(BgL_list2964z00_1181);
											}}
											{	/* Object/struct.scm 262 */

												{
													BgL_typez00_bglt BgL_typez00_1159;

													obj_t BgL_exprz00_1160;

													{	/* Object/struct.scm 270 */
														obj_t BgL_arg2843z00_1057;

														{	/* Object/struct.scm 270 */
															obj_t BgL_arg2844z00_1058;

															obj_t BgL_arg2845z00_1059;

															BgL_arg2844z00_1058 = CNST_TABLE_REF(((long) 18));
															{	/* Object/struct.scm 270 */
																obj_t BgL_arg2846z00_1060;

																obj_t BgL_arg2847z00_1061;

																{	/* Object/struct.scm 270 */
																	obj_t BgL_arg2851z00_1065;

																	obj_t BgL_arg2852z00_1066;

																	BgL_arg2851z00_1065 =
																		CNST_TABLE_REF(((long) 37));
																	{	/* Object/struct.scm 271 */
																		obj_t BgL_arg2853z00_1067;

																		obj_t BgL_arg2854z00_1068;

																		BgL_arg2853z00_1067 =
																			BGl_makezd2typedzd2identz00zzast_identz00
																			(CNST_TABLE_REF(((long) 34)),
																			BgL_cnamez00_29);
																		BgL_arg2854z00_1068 =
																			CNST_TABLE_REF(((long) 38));
																		{	/* Object/struct.scm 270 */
																			obj_t BgL_list2856z00_1070;

																			{	/* Object/struct.scm 270 */
																				obj_t BgL_arg2857z00_1071;

																				BgL_arg2857z00_1071 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list2856z00_1070 =
																					MAKE_PAIR(BgL_arg2854z00_1068,
																					BgL_arg2857z00_1071);
																			}
																			BgL_arg2852z00_1066 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2853z00_1067,
																				BgL_list2856z00_1070);
																	}}
																	BgL_arg2846z00_1060 =
																		MAKE_PAIR(BgL_arg2851z00_1065,
																		BgL_arg2852z00_1066);
																}
																{	/* Object/struct.scm 273 */
																	obj_t BgL_arg2858z00_1072;

																	obj_t BgL_arg2859z00_1073;

																	BgL_arg2858z00_1072 =
																		CNST_TABLE_REF(((long) 4));
																	{	/* Object/struct.scm 273 */
																		obj_t BgL_arg2860z00_1074;

																		obj_t BgL_arg2861z00_1075;

																		{	/* Object/struct.scm 273 */
																			obj_t BgL_arg2865z00_1079;

																			obj_t BgL_arg2866z00_1080;

																			{	/* Object/struct.scm 273 */
																				obj_t BgL_arg2867z00_1081;

																				{	/* Object/struct.scm 273 */
																					obj_t BgL_arg2868z00_1082;

																					BgL_arg2868z00_1082 =
																						MAKE_PAIR(CNST_TABLE_REF(((long)
																								24)), BNIL);
																					{	/* Object/struct.scm 273 */
																						obj_t BgL_list2870z00_1084;

																						BgL_list2870z00_1084 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg2867z00_1081 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2868z00_1082,
																							BgL_list2870z00_1084);
																				}}
																				BgL_arg2865z00_1079 =
																					MAKE_PAIR(BgL_oldz00_1048,
																					BgL_arg2867z00_1081);
																			}
																			{	/* Object/struct.scm 274 */
																				obj_t BgL_arg2871z00_1085;

																				{	/* Object/struct.scm 274 */
																					obj_t BgL_arg2874z00_1088;

																					{	/* Object/struct.scm 274 */
																						obj_t BgL_arg2875z00_1089;

																						{	/* Object/struct.scm 274 */
																							obj_t BgL_arg2878z00_1092;

																							obj_t BgL_arg2880z00_1093;

																							BgL_arg2878z00_1092 =
																								CNST_TABLE_REF(((long) 31));
																							{	/* Object/struct.scm 274 */
																								obj_t BgL_list2881z00_1094;

																								{	/* Object/struct.scm 274 */
																									obj_t BgL_arg2883z00_1096;

																									BgL_arg2883z00_1096 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list2881z00_1094 =
																										MAKE_PAIR(BINT(((long) 0)),
																										BgL_arg2883z00_1096);
																								}
																								BgL_arg2880z00_1093 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(CNST_TABLE_REF(((long) 32)),
																									BgL_list2881z00_1094);
																							}
																							BgL_arg2875z00_1089 =
																								MAKE_PAIR(BgL_arg2878z00_1092,
																								BgL_arg2880z00_1093);
																						}
																						{	/* Object/struct.scm 274 */
																							obj_t BgL_list2877z00_1091;

																							BgL_list2877z00_1091 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_arg2874z00_1088 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_arg2875z00_1089,
																								BgL_list2877z00_1091);
																					}}
																					BgL_arg2871z00_1085 =
																						MAKE_PAIR(BgL_tauxz00_1051,
																						BgL_arg2874z00_1088);
																				}
																				{	/* Object/struct.scm 273 */
																					obj_t BgL_list2873z00_1087;

																					BgL_list2873z00_1087 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg2866z00_1080 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg2871z00_1085,
																						BgL_list2873z00_1087);
																			}}
																			BgL_arg2860z00_1074 =
																				MAKE_PAIR(BgL_arg2865z00_1079,
																				BgL_arg2866z00_1080);
																		}
																		{	/* Object/struct.scm 275 */
																			obj_t BgL_arg2884z00_1097;

																			obj_t BgL_arg2885z00_1098;

																			BgL_arg2884z00_1097 =
																				CNST_TABLE_REF(((long) 4));
																			{	/* Object/struct.scm 275 */
																				obj_t BgL_arg2886z00_1099;

																				obj_t BgL_arg2887z00_1100;

																				obj_t BgL_arg2888z00_1101;

																				{	/* Object/struct.scm 275 */
																					obj_t BgL_arg2894z00_1107;

																					{	/* Object/struct.scm 275 */
																						obj_t BgL_arg2896z00_1109;

																						obj_t BgL_arg2897z00_1110;

																						BgL_arg2896z00_1109 =
																							BGl_makezd2typedzd2identz00zzast_identz00
																							(BgL_newz00_1052,
																							BgL_tidz00_1053);
																						{	/* Object/struct.scm 276 */
																							obj_t BgL_arg2898z00_1111;

																							BgL_typez00_1159 = BgL_typez00_30;
																							BgL_exprz00_1160 =
																								BgL_oldz00_1048;
																							{	/* Object/struct.scm 264 */
																								bool_t BgL_testz00_2110;

																								{	/* Object/struct.scm 264 */
																									obj_t BgL_arg2961z00_1177;

																									BgL_arg2961z00_1177 =
																										BGl_thezd2backendzd2zzbackend_backendz00
																										();
																									{
																										BgL_backendz00_bglt
																											BgL_auxz00_2112;
																										BgL_auxz00_2112 =
																											(BgL_backendz00_bglt)
																											(BgL_arg2961z00_1177);
																										BgL_testz00_2110 =
																											(((BgL_backendz00_bglt)
																												CREF(BgL_auxz00_2112))->
																											BgL_pragmazd2supportzd2);
																								}}
																								if (BgL_testz00_2110)
																									{	/* Object/struct.scm 265 */
																										obj_t BgL_arg2946z00_1163;

																										obj_t BgL_arg2947z00_1164;

																										{	/* Object/struct.scm 265 */
																											obj_t BgL_arg2949z00_1165;

																											obj_t BgL_arg2950z00_1166;

																											BgL_arg2949z00_1165 =
																												CNST_TABLE_REF(((long)
																													42));
																											BgL_arg2950z00_1166 =
																												(((BgL_typez00_bglt)
																													CREF
																													(BgL_typez00_1159))->
																												BgL_idz00);
																											BgL_arg2946z00_1163 =
																												BGl_makezd2typedzd2identz00zzast_identz00
																												(BgL_arg2949z00_1165,
																												BgL_arg2950z00_1166);
																										}
																										{	/* Object/struct.scm 266 */
																											obj_t BgL_arg2951z00_1167;

																											{	/* Object/struct.scm 266 */
																												obj_t
																													BgL_arg2956z00_1172;
																												BgL_arg2956z00_1172 =
																													(((BgL_typez00_bglt)
																														CREF
																														(BgL_typez00_1159))->
																													BgL_namez00);
																												BgL_arg2951z00_1167 =
																													string_append_3
																													(BGl_string2993z00zzobject_structz00,
																													BgL_arg2956z00_1172,
																													BGl_string2994z00zzobject_structz00);
																											}
																											{	/* Object/struct.scm 265 */
																												obj_t
																													BgL_list2953z00_1169;
																												{	/* Object/struct.scm 265 */
																													obj_t
																														BgL_arg2954z00_1170;
																													BgL_arg2954z00_1170 =
																														MAKE_PAIR(BNIL,
																														BNIL);
																													BgL_list2953z00_1169 =
																														MAKE_PAIR
																														(BgL_exprz00_1160,
																														BgL_arg2954z00_1170);
																												}
																												BgL_arg2947z00_1164 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_arg2951z00_1167,
																													BgL_list2953z00_1169);
																										}}
																										BgL_arg2898z00_1111 =
																											MAKE_PAIR
																											(BgL_arg2946z00_1163,
																											BgL_arg2947z00_1164);
																									}
																								else
																									{	/* Object/struct.scm 268 */
																										obj_t BgL_arg2958z00_1174;

																										obj_t BgL_arg2959z00_1175;

																										BgL_arg2958z00_1174 =
																											CNST_TABLE_REF(((long)
																												43));
																										BgL_arg2959z00_1175 =
																											(((BgL_typez00_bglt)
																												CREF
																												(BgL_typez00_1159))->
																											BgL_idz00);
																										{	/* Object/struct.scm 268 */
																											obj_t
																												BgL_list2960z00_1176;
																											BgL_list2960z00_1176 =
																												MAKE_PAIR
																												(BgL_exprz00_1160,
																												BNIL);
																											BgL_arg2898z00_1111 =
																												BGl_makezd2privatezd2sexpz00zzast_privatez00
																												(BgL_arg2958z00_1174,
																												BgL_arg2959z00_1175,
																												BgL_list2960z00_1176);
																							}}}
																							{	/* Object/struct.scm 275 */
																								obj_t BgL_list2900z00_1113;

																								BgL_list2900z00_1113 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2897z00_1110 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg2898z00_1111,
																									BgL_list2900z00_1113);
																						}}
																						BgL_arg2894z00_1107 =
																							MAKE_PAIR(BgL_arg2896z00_1109,
																							BgL_arg2897z00_1110);
																					}
																					BgL_arg2886z00_1099 =
																						MAKE_PAIR(BgL_arg2894z00_1107,
																						BNIL);
																				}
																				{	/* Object/struct.scm 277 */
																					obj_t BgL_arg2903z00_1114;

																					obj_t BgL_arg2905z00_1115;

																					BgL_arg2903z00_1114 =
																						CNST_TABLE_REF(((long) 44));
																					{	/* Object/struct.scm 278 */
																						obj_t BgL_arg2906z00_1116;

																						{	/* Object/struct.scm 278 */
																							obj_t BgL_arg2910z00_1120;

																							obj_t BgL_arg2911z00_1121;

																							BgL_arg2910z00_1120 =
																								CNST_TABLE_REF(((long) 45));
																							{	/* Object/struct.scm 279 */
																								obj_t BgL_arg2912z00_1122;

																								{	/* Object/struct.scm 279 */
																									obj_t BgL_arg2915z00_1125;

																									obj_t BgL_arg2916z00_1126;

																									BgL_arg2915z00_1125 =
																										CNST_TABLE_REF(((long) 46));
																									{	/* Object/struct.scm 279 */
																										obj_t BgL_arg2917z00_1127;

																										obj_t BgL_arg2918z00_1128;

																										{
																											BgL_variablez00_bglt
																												BgL_auxz00_2135;
																											BgL_auxz00_2135 =
																												(BgL_variablez00_bglt)
																												(BgL_holderz00_1054);
																											BgL_arg2917z00_1127 =
																												(((BgL_variablez00_bglt)
																													CREF
																													(BgL_auxz00_2135))->
																												BgL_idz00);
																										}
																										BgL_arg2918z00_1128 =
																											(((BgL_globalz00_bglt)
																												CREF
																												(BgL_holderz00_1054))->
																											BgL_modulez00);
																										{	/* Object/struct.scm 279 */
																											obj_t
																												BgL_list2920z00_1130;
																											{	/* Object/struct.scm 279 */
																												obj_t
																													BgL_arg2921z00_1131;
																												BgL_arg2921z00_1131 =
																													MAKE_PAIR(BNIL, BNIL);
																												BgL_list2920z00_1130 =
																													MAKE_PAIR
																													(BgL_arg2918z00_1128,
																													BgL_arg2921z00_1131);
																											}
																											BgL_arg2916z00_1126 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg2917z00_1127,
																												BgL_list2920z00_1130);
																									}}
																									BgL_arg2912z00_1122 =
																										MAKE_PAIR
																										(BgL_arg2915z00_1125,
																										BgL_arg2916z00_1126);
																								}
																								{	/* Object/struct.scm 278 */
																									obj_t BgL_list2914z00_1124;

																									BgL_list2914z00_1124 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_arg2911z00_1121 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg2912z00_1122,
																										BgL_list2914z00_1124);
																							}}
																							BgL_arg2906z00_1116 =
																								MAKE_PAIR(BgL_arg2910z00_1120,
																								BgL_arg2911z00_1121);
																						}
																						{	/* Object/struct.scm 277 */
																							obj_t BgL_list2908z00_1118;

																							{	/* Object/struct.scm 277 */
																								obj_t BgL_arg2909z00_1119;

																								BgL_arg2909z00_1119 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_list2908z00_1118 =
																									MAKE_PAIR(BgL_arg2906z00_1116,
																									BgL_arg2909z00_1119);
																							}
																							BgL_arg2905z00_1115 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_newz00_1052,
																								BgL_list2908z00_1118);
																					}}
																					BgL_arg2887z00_1100 =
																						MAKE_PAIR(BgL_arg2903z00_1114,
																						BgL_arg2905z00_1115);
																				}
																				{	/* Object/struct.scm 281 */
																					obj_t BgL_arg2922z00_1132;

																					obj_t BgL_arg2923z00_1133;

																					BgL_arg2922z00_1132 =
																						CNST_TABLE_REF(((long) 39));
																					{	/* Object/struct.scm 283 */
																						obj_t BgL_arg2924z00_1134;

																						{	/* Object/struct.scm 283 */
																							obj_t BgL_arg2928z00_1138;

																							{	/* Object/struct.scm 283 */
																								obj_t BgL_arg2929z00_1139;

																								{
																									long BgL_iz00_1142;

																									obj_t BgL_slotsz00_1143;

																									obj_t BgL_refza2za2_1144;

																									BgL_iz00_1142 = ((long) 0);
																									BgL_slotsz00_1143 =
																										BgL_slotsz00_31;
																									BgL_refza2za2_1144 = BNIL;
																								BgL_loopz00_1145:
																									if (
																										(BgL_iz00_1142 ==
																											BgL_lenz00_1049))
																										{	/* Object/struct.scm 287 */
																											BgL_arg2929z00_1139 =
																												bgl_reverse_bang
																												(BgL_refza2za2_1144);
																										}
																									else
																										{	/* Object/struct.scm 289 */
																											bool_t BgL_testz00_2154;

																											{	/* Object/struct.scm 289 */
																												obj_t
																													BgL_arg2943z00_1158;
																												BgL_arg2943z00_1158 =
																													CAR
																													(BgL_slotsz00_1143);
																												BgL_testz00_2154 =
																													BGl_slotzd2virtualzf3z21zzobject_slotsz00
																													((BgL_slotz00_bglt)
																													(BgL_arg2943z00_1158));
																											}
																											if (BgL_testz00_2154)
																												{
																													obj_t
																														BgL_slotsz00_2160;
																													long BgL_iz00_2158;

																													BgL_iz00_2158 =
																														(BgL_iz00_1142 +
																														((long) 1));
																													BgL_slotsz00_2160 =
																														CDR
																														(BgL_slotsz00_1143);
																													BgL_slotsz00_1143 =
																														BgL_slotsz00_2160;
																													BgL_iz00_1142 =
																														BgL_iz00_2158;
																													goto BgL_loopz00_1145;
																												}
																											else
																												{	/* Object/struct.scm 294 */
																													long
																														BgL_arg2935z00_1150;
																													obj_t
																														BgL_arg2936z00_1151;
																													obj_t
																														BgL_arg2937z00_1152;
																													BgL_arg2935z00_1150 =
																														(BgL_iz00_1142 +
																														((long) 1));
																													BgL_arg2936z00_1151 =
																														CDR
																														(BgL_slotsz00_1143);
																													{	/* Object/struct.scm 296 */
																														obj_t
																															BgL_arg2938z00_1153;
																														{	/* Object/struct.scm 296 */
																															obj_t
																																BgL_arg2939z00_1154;
																															obj_t
																																BgL_arg2940z00_1155;
																															BgL_arg2939z00_1154
																																=
																																CNST_TABLE_REF((
																																	(long) 31));
																															{	/* Object/struct.scm 296 */
																																obj_t
																																	BgL_list2941z00_1156;
																																{	/* Object/struct.scm 296 */
																																	obj_t
																																		BgL_arg2942z00_1157;
																																	BgL_arg2942z00_1157
																																		=
																																		MAKE_PAIR
																																		(BNIL,
																																		BNIL);
																																	BgL_list2941z00_1156
																																		=
																																		MAKE_PAIR
																																		(BINT
																																		(BgL_iz00_1142),
																																		BgL_arg2942z00_1157);
																																}
																																BgL_arg2940z00_1155
																																	=
																																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																	(BgL_auxz00_1050,
																																	BgL_list2941z00_1156);
																															}
																															BgL_arg2938z00_1153
																																=
																																MAKE_PAIR
																																(BgL_arg2939z00_1154,
																																BgL_arg2940z00_1155);
																														}
																														BgL_arg2937z00_1152
																															=
																															MAKE_PAIR
																															(BgL_arg2938z00_1153,
																															BgL_refza2za2_1144);
																													}
																													{
																														obj_t
																															BgL_refza2za2_2173;
																														obj_t
																															BgL_slotsz00_2172;
																														long BgL_iz00_2171;

																														BgL_iz00_2171 =
																															BgL_arg2935z00_1150;
																														BgL_slotsz00_2172 =
																															BgL_arg2936z00_1151;
																														BgL_refza2za2_2173 =
																															BgL_arg2937z00_1152;
																														BgL_refza2za2_1144 =
																															BgL_refza2za2_2173;
																														BgL_slotsz00_1143 =
																															BgL_slotsz00_2172;
																														BgL_iz00_1142 =
																															BgL_iz00_2171;
																														goto
																															BgL_loopz00_1145;
																													}
																												}
																										}
																								}
																								BgL_arg2928z00_1138 =
																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg2929z00_1139, BNIL);
																							}
																							BgL_arg2924z00_1134 =
																								MAKE_PAIR(BgL_wideningz00_1055,
																								BgL_arg2928z00_1138);
																						}
																						{	/* Object/struct.scm 281 */
																							obj_t BgL_list2926z00_1136;

																							{	/* Object/struct.scm 281 */
																								obj_t BgL_arg2927z00_1137;

																								BgL_arg2927z00_1137 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_list2926z00_1136 =
																									MAKE_PAIR(BgL_arg2924z00_1134,
																									BgL_arg2927z00_1137);
																							}
																							BgL_arg2923z00_1133 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_newz00_1052,
																								BgL_list2926z00_1136);
																						}
																					}
																					BgL_arg2888z00_1101 =
																						MAKE_PAIR(BgL_arg2922z00_1132,
																						BgL_arg2923z00_1133);
																				}
																				{	/* Object/struct.scm 275 */
																					obj_t BgL_list2890z00_1103;

																					{	/* Object/struct.scm 275 */
																						obj_t BgL_arg2891z00_1104;

																						{	/* Object/struct.scm 275 */
																							obj_t BgL_arg2892z00_1105;

																							{	/* Object/struct.scm 275 */
																								obj_t BgL_arg2893z00_1106;

																								BgL_arg2893z00_1106 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg2892z00_1105 =
																									MAKE_PAIR(BgL_newz00_1052,
																									BgL_arg2893z00_1106);
																							}
																							BgL_arg2891z00_1104 =
																								MAKE_PAIR(BgL_arg2888z00_1101,
																								BgL_arg2892z00_1105);
																						}
																						BgL_list2890z00_1103 =
																							MAKE_PAIR(BgL_arg2887z00_1100,
																							BgL_arg2891z00_1104);
																					}
																					BgL_arg2885z00_1098 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg2886z00_1099,
																						BgL_list2890z00_1103);
																				}
																			}
																			BgL_arg2861z00_1075 =
																				MAKE_PAIR(BgL_arg2884z00_1097,
																				BgL_arg2885z00_1098);
																		}
																		{	/* Object/struct.scm 273 */
																			obj_t BgL_list2863z00_1077;

																			{	/* Object/struct.scm 273 */
																				obj_t BgL_arg2864z00_1078;

																				BgL_arg2864z00_1078 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list2863z00_1077 =
																					MAKE_PAIR(BgL_arg2861z00_1075,
																					BgL_arg2864z00_1078);
																			}
																			BgL_arg2859z00_1073 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2860z00_1074,
																				BgL_list2863z00_1077);
																		}
																	}
																	BgL_arg2847z00_1061 =
																		MAKE_PAIR(BgL_arg2858z00_1072,
																		BgL_arg2859z00_1073);
																}
																{	/* Object/struct.scm 270 */
																	obj_t BgL_list2849z00_1063;

																	{	/* Object/struct.scm 270 */
																		obj_t BgL_arg2850z00_1064;

																		BgL_arg2850z00_1064 = MAKE_PAIR(BNIL, BNIL);
																		BgL_list2849z00_1063 =
																			MAKE_PAIR(BgL_arg2847z00_1061,
																			BgL_arg2850z00_1064);
																	}
																	BgL_arg2845z00_1059 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg2846z00_1060, BgL_list2849z00_1063);
																}
															}
															BgL_arg2843z00_1057 =
																MAKE_PAIR(BgL_arg2844z00_1058,
																BgL_arg2845z00_1059);
														}
														return
															BGl_epairifyz00zztools_miscz00
															(BgL_arg2843z00_1057, BgL_srczd2defzd2_32);
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzobject_structz00()
	{
		AN_OBJECT;
		{	/* Object/struct.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zztype_toolsz00(((long) 195902195),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzobject_toolsz00(((long) 405988581),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long) 17869975),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
			return
				BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 453255680),
				BSTRING_TO_STRING(BGl_string2995z00zzobject_structz00));
		}
	}

#ifdef __cplusplus
}
#endif
