/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/sexp.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_feffectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_readz00;
		obj_t BgL_writez00;
	}                 *BgL_feffectz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;


	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza33179ze3z83zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33180ze3z83zzast_sexpz00(obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_zc3exitza33176ze3z83zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t,
		obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_liipz00zzast_sexpz00(obj_t);
	static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_appz00_bglt BGl_makezd2appzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		obj_t, obj_t, BgL_varz00_bglt, obj_t);
	static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
	extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
	extern BgL_kwotez00_bglt BGl_makezd2kwotezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t);
	BGL_IMPORT bool_t bigloo_strncmp(obj_t, obj_t, long);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	static obj_t BGl__definezd2primopzd2ze3node3871ze3zzast_sexpz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern BgL_sequencez00_bglt BGl_makezd2sequencezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
	extern BgL_jumpzd2exzd2itz00_bglt
		BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	extern BgL_closurez00_bglt BGl_makezd2closurezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_variablez00_bglt);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl__definezd2primopzd2refzd2ze33870z31zzast_sexpz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t c_substring(obj_t, long, long);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT obj_t string_to_bstring(char *);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t,
		obj_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
	static obj_t BGl_loopz00zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33563ze3z83zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	extern BgL_setqz00_bglt BGl_makezd2setqzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_varz00_bglt, BgL_nodez00_bglt);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl__sexpza2zd2ze3node3867z93zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_selectz00_bglt BGl_makezd2selectzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, BgL_nodez00_bglt, obj_t, BgL_typez00_bglt);
	BGL_EXPORTED_DECL BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	static obj_t BGl_methodzd2initzd2zzast_sexpz00();
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static obj_t BGl__locationzd2ze3node3872z31zzast_sexpz00(obj_t, obj_t);
	extern bool_t BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(obj_t);
	extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, obj_t, obj_t);
	extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
	extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
	extern BgL_atomz00_bglt BGl_makezd2atomzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t);
	extern BgL_failz00_bglt BGl_makezd2failzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_nodez00_bglt, BgL_nodez00_bglt, BgL_nodez00_bglt);
	BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
	static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzast_sexpz00();
	static obj_t BGl__makezd2anonymouszd2namez00zzast_sexpz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__errorz00(obj_t);
	extern BgL_conditionalz00_bglt BGl_makezd2conditionalzd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, obj_t, obj_t, BgL_nodez00_bglt, BgL_nodez00_bglt,
		BgL_nodez00_bglt);
	extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	extern obj_t BGl_privatezd2ze3nodez31zzast_privatez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	BGL_EXPORTED_DECL obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
	extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
	BGL_IMPORT obj_t string_to_symbol(char *);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt,
		BgL_nodez00_bglt);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_lookupz00zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl__errorzd2sexpzd2ze3node3869ze3zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern BgL_feffectz00_bglt BGl_parsezd2effectzd2zzeffect_feffectz00(obj_t);
	static obj_t BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__usezd2variablez123868zc0zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	static obj_t BGl__sexpzd2ze3node3866z31zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT char *BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern BgL_typez00_bglt BGl_typeofzd2atomzd2zztype_typeofz00(obj_t);
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
	static obj_t __cnst[39];


	   
		 
		DEFINE_STRING(BGl_string3873z00zzast_sexpz00,
		BgL_bgl_string3873za700za7za7a3906za7, "Illegal `pragma/effect' form", 28);
	      DEFINE_STRING(BGl_string3874z00zzast_sexpz00,
		BgL_bgl_string3874za700za7za7a3907za7, "Illegal `free-pragma/effect' form",
		33);
	      DEFINE_STRING(BGl_string3875z00zzast_sexpz00,
		BgL_bgl_string3875za700za7za7a3908za7, "Illegal `lambda' form", 21);
	      DEFINE_STRING(BGl_string3876z00zzast_sexpz00,
		BgL_bgl_string3876za700za7za7a3909za7, "Illegal `application' form", 26);
	      DEFINE_STRING(BGl_string3877z00zzast_sexpz00,
		BgL_bgl_string3877za700za7za7a3910za7, "Illegal `case' form", 19);
	      DEFINE_STRING(BGl_string3878z00zzast_sexpz00,
		BgL_bgl_string3878za700za7za7a3911za7, "Illegal `failure' form", 22);
	      DEFINE_STRING(BGl_string3880z00zzast_sexpz00,
		BgL_bgl_string3880za700za7za7a3912za7, "illegal `define' expression", 27);
	      DEFINE_STRING(BGl_string3879z00zzast_sexpz00,
		BgL_bgl_string3879za700za7za7a3913za7, "Illegal `define' form", 21);
	      DEFINE_STRING(BGl_string3881z00zzast_sexpz00,
		BgL_bgl_string3881za700za7za7a3914za7, "Illegal `set!' form", 19);
	      DEFINE_STRING(BGl_string3882z00zzast_sexpz00,
		BgL_bgl_string3882za700za7za7a3915za7, "Read-only variable", 18);
	      DEFINE_STRING(BGl_string3883z00zzast_sexpz00,
		BgL_bgl_string3883za700za7za7a3916za7, "illegal `set!' expression", 25);
	      DEFINE_STRING(BGl_string3884z00zzast_sexpz00,
		BgL_bgl_string3884za700za7za7a3917za7, "Illegal `if' form", 17);
	      DEFINE_STRING(BGl_string3885z00zzast_sexpz00,
		BgL_bgl_string3885za700za7za7a3918za7, "Illegal `quote' expression", 26);
	      DEFINE_STRING(BGl_string3886z00zzast_sexpz00,
		BgL_bgl_string3886za700za7za7a3919za7, "Illegal `@' expression", 22);
	      DEFINE_STRING(BGl_string3887z00zzast_sexpz00,
		BgL_bgl_string3887za700za7za7a3920za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string3888z00zzast_sexpz00,
		BgL_bgl_string3888za700za7za7a3921za7,
		"This backend (~a) does not support external first class value functions",
		71);
	      DEFINE_STRING(BGl_string3900z00zzast_sexpz00,
		BgL_bgl_string3900za700za7za7a3922za7, ">", 1);
	      DEFINE_STRING(BGl_string3890z00zzast_sexpz00,
		BgL_bgl_string3890za700za7za7a3923za7, "Illegal `()' expression", 23);
	      DEFINE_STRING(BGl_string3889z00zzast_sexpz00,
		BgL_bgl_string3889za700za7za7a3924za7, "Illegal atom", 12);
	      DEFINE_STRING(BGl_string3901z00zzast_sexpz00,
		BgL_bgl_string3901za700za7za7a3925za7, "-", 1);
	      DEFINE_STRING(BGl_string3891z00zzast_sexpz00,
		BgL_bgl_string3891za700za7za7a3926za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string3902z00zzast_sexpz00,
		BgL_bgl_string3902za700za7za7a3927za7, "ast_sexp", 8);
	      DEFINE_STRING(BGl_string3892z00zzast_sexpz00,
		BgL_bgl_string3892za700za7za7a3928za7, "Illegal formal argument", 23);
	      DEFINE_STRING(BGl_string3903z00zzast_sexpz00,
		BgL_bgl_string3903za700za7za7a3929za7,
		"> bdb pragma::obj (@ __evmeaning_address foreign) (@ define-primop! __evenv) (@ define-primop-ref! __evenv) write cons (quote ()) jump-exit set-exit case failure letrec define begin apply quote @ app eval not if ::bool test location set! let else labels lambda free-pragma/effect free-pragma exp car pragma/effect pragma value (value apply app set!) ",
		350);
	      DEFINE_STRING(BGl_string3893z00zzast_sexpz00,
		BgL_bgl_string3893za700za7za7a3930za7, "Illegal empty sequence", 22);
	      DEFINE_STRING(BGl_string3894z00zzast_sexpz00,
		BgL_bgl_string3894za700za7za7a3931za7, "Illegal mutation", 16);
	      DEFINE_STRING(BGl_string3895z00zzast_sexpz00,
		BgL_bgl_string3895za700za7za7a3932za7, "($1)", 4);
	      DEFINE_STRING(BGl_string3896z00zzast_sexpz00,
		BgL_bgl_string3896za700za7za7a3933za7, "anonymous", 9);
	      DEFINE_STRING(BGl_string3897z00zzast_sexpz00,
		BgL_bgl_string3897za700za7za7a3934za7, "<", 1);
	      DEFINE_STRING(BGl_string3898z00zzast_sexpz00,
		BgL_bgl_string3898za700za7za7a3935za7, ":", 1);
	      DEFINE_STRING(BGl_string3899z00zzast_sexpz00,
		BgL_bgl_string3899za700za7za7a3936za7, "./", 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl__errorza7d2sexpza7d23937z00,
		BGl__errorzd2sexpzd2ze3node3869ze3zzast_sexpz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl__defineza7d2primop3938za7,
		BGl__definezd2primopzd2ze3node3871ze3zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__sexpza7d2za7e3node33939z00,
		BGl__sexpzd2ze3node3866z31zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_locationzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__locationza7d2za7e3n3940z00,
		BGl__locationzd2ze3node3872z31zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_usezd2variablez12zd2envz12zzast_sexpz00,
		BgL_bgl__useza7d2variableza73941z00,
		BGl__usezd2variablez123868zc0zzast_sexpz00, 0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00,
		BgL_bgl__sexpza7a2za7d2za7e3no3942za7,
		BGl__sexpza2zd2ze3node3867z93zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2anonymouszd2namezd2envzd2zzast_sexpz00,
		BgL_bgl__makeza7d2anonymou3943za7, va_generic_entry,
		BGl__makezd2anonymouszd2namez00zzast_sexpz00, BUNSPEC, -2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__topza7d2levelza7d2s3944z00,
		BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl__defineza7d2primop3945za7,
		BGl__definezd2primopzd2refzd2ze33870z31zzast_sexpz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long
		BgL_checksumz00_2603, char *BgL_fromz00_2604)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
				{
					BGl_requirezd2initializa7ationz75zzast_sexpz00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
					BGl_cnstzd2initzd2zzast_sexpz00();
					BGl_importedzd2moduleszd2initz00zzast_sexpz00();
					BGl_toplevelzd2initzd2zzast_sexpz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_sexp");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			{	/* Ast/sexp.scm 14 */
				obj_t BgL_cportz00_2595;

				BgL_cportz00_2595 =
					bgl_open_input_string(BGl_string3903z00zzast_sexpz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2596;

					BgL_iz00_2596 = ((long) 38);
				BgL_loopz00_2597:
					if ((BgL_iz00_2596 == ((long) -1)))
						{	/* Ast/sexp.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/sexp.scm 14 */
							{	/* Ast/sexp.scm 14 */
								obj_t BgL_arg3905z00_2599;

								{	/* Ast/sexp.scm 14 */

									{	/* Ast/sexp.scm 14 */
										obj_t BgL_locationz00_2601;

										BgL_locationz00_2601 = BBOOL(((bool_t) 0));
										{	/* Ast/sexp.scm 14 */

											BgL_arg3905z00_2599 =
												BGl_readz00zz__readerz00(BgL_cportz00_2595,
												BgL_locationz00_2601);
										}
									}
								}
								{	/* Ast/sexp.scm 14 */
									int BgL_auxz00_2629;

									BgL_auxz00_2629 = (int) (BgL_iz00_2596);
									CNST_TABLE_SET(BgL_auxz00_2629, BgL_arg3905z00_2599);
							}}
							{	/* Ast/sexp.scm 14 */
								int BgL_auxz00_2602;

								BgL_auxz00_2602 = (int) ((BgL_iz00_2596 - ((long) 1)));
								{
									long BgL_iz00_2634;

									BgL_iz00_2634 = (long) (BgL_auxz00_2602);
									BgL_iz00_2596 = BgL_iz00_2634;
									goto BgL_loopz00_2597;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_za2sitesza2z00zzast_sexpz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE;
			BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE;
			return (BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC);
		}
	}



/* top-level-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_15,
		obj_t BgL_locz00_16)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 58 */
			return
				(BgL_nodez00_bglt) (BGl_zc3exitza33176ze3z83zzast_sexpz00(BgL_locz00_16,
					BgL_expz00_15));
		}
	}



/* <exit:3176> */
	obj_t BGl_zc3exitza33176ze3z83zzast_sexpz00(obj_t BgL_locz00_2593,
		obj_t BgL_expz00_2592)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 59 */
			jmp_buf_t jmpbuf;

			void *BgL_an_exit3138z00_853;

			{
				BGL_STORE_TRACE();
				if (SET_EXIT(BgL_an_exit3138z00_853))
					{
						BGL_RESTORE_TRACE();
						return _exit_value_;
					}
				else
					{
						BgL_an_exit3138z00_853 = (void *) jmpbuf;
						{	/* Ast/sexp.scm 59 */

							PUSH_EXIT(BgL_an_exit3138z00_853, ((long) 1));
							{	/* Ast/sexp.scm 59 */
								obj_t BgL_an_exitd3139z00_854;

								BgL_an_exitd3139z00_854 = BGL_EXITD_TOP();
								{	/* Ast/sexp.scm 62 */
									obj_t BgL_res3141z00_857;

									{	/* Ast/sexp.scm 62 */
										obj_t BgL_zc3anonymousza33180ze3z83_2545;

										obj_t BgL_zc3anonymousza33179ze3z83_2546;

										BgL_zc3anonymousza33180ze3z83_2545 =
											make_fx_procedure
											(BGl_zc3anonymousza33180ze3z83zzast_sexpz00,
											(int) (((long) 0)), (int) (((long) 2)));
										BgL_zc3anonymousza33179ze3z83_2546 =
											make_fx_procedure
											(BGl_zc3anonymousza33179ze3z83zzast_sexpz00,
											(int) (((long) 1)), (int) (((long) 1)));
										PROCEDURE_SET(BgL_zc3anonymousza33180ze3z83_2545,
											(int) (((long) 0)), BgL_expz00_2592);
										PROCEDURE_SET(BgL_zc3anonymousza33180ze3z83_2545,
											(int) (((long) 1)), BgL_locz00_2593);
										PROCEDURE_SET(BgL_zc3anonymousza33179ze3z83_2546,
											(int) (((long) 0)), BgL_an_exitd3139z00_854);
										BgL_res3141z00_857 =
											BGl_withzd2exceptionzd2handlerz00zz__errorz00
											(BgL_zc3anonymousza33179ze3z83_2546,
											BgL_zc3anonymousza33180ze3z83_2545);
									}
									POP_EXIT();
									return BgL_res3141z00_857;
								}
							}
						}
					}
			}
		}
	}



/* _top-level-sexp->node */
	obj_t BGl__topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_envz00_2547,
		obj_t BgL_expz00_2548, obj_t BgL_locz00_2549)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 58 */
			return
				(obj_t) (BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00
				(BgL_expz00_2548, BgL_locz00_2549));
		}
	}



/* <anonymous:3180> */
	obj_t BGl_zc3anonymousza33180ze3z83zzast_sexpz00(obj_t BgL_envz00_2550)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 64 */
			{	/* Ast/sexp.scm 65 */
				obj_t BgL_expz00_2551;

				obj_t BgL_locz00_2552;

				BgL_expz00_2551 = PROCEDURE_REF(BgL_envz00_2550, (int) (((long) 0)));
				BgL_locz00_2552 = PROCEDURE_REF(BgL_envz00_2550, (int) (((long) 1)));
				{

					{	/* Ast/sexp.scm 65 */
						BgL_nodez00_bglt BgL_auxz00_2663;

						BgL_auxz00_2663 =
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_2551, BNIL,
							BgL_locz00_2552, CNST_TABLE_REF(((long) 1)));
						return (obj_t) (BgL_auxz00_2663);
					}
				}
			}
		}
	}



/* <anonymous:3179> */
	obj_t BGl_zc3anonymousza33179ze3z83zzast_sexpz00(obj_t BgL_envz00_2553,
		obj_t BgL_ez00_2555)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 61 */
			{	/* Ast/sexp.scm 62 */
				obj_t BgL_an_exitd3139z00_2554;

				BgL_an_exitd3139z00_2554 =
					PROCEDURE_REF(BgL_envz00_2553, (int) (((long) 0)));
				{
					obj_t BgL_ez00_860;

					BgL_ez00_860 = BgL_ez00_2555;
					BGl_exceptionzd2notifyzd2zz__errorz00(BgL_ez00_860);
					return
						BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd3139z00_2554,
						BUNSPEC);
				}
			}
		}
	}



/* sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_expz00_17, obj_t BgL_stackz00_18, obj_t BgL_locz00_19,
		obj_t BgL_sitez00_20)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 80 */
		BGl_sexpzd2ze3nodez31zzast_sexpz00:
			{
				obj_t BgL_atomz00_867;

				obj_t BgL_bodyz00_871;

				obj_t BgL_bodyz00_876;

				obj_t BgL_argsz00_877;

				obj_t BgL_varsz00_881;

				obj_t BgL_bodyz00_882;

				obj_t BgL_argsz00_883;

				obj_t BgL_effectz00_887;

				obj_t BgL_restz00_888;

				obj_t BgL_effectz00_891;

				obj_t BgL_restz00_892;

				if (NULLP(BgL_expz00_17))
					{	/* Ast/sexp.scm 85 */
						return
							BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
							(BGl_string3890z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_19);
					}
				else
					{	/* Ast/sexp.scm 85 */
						if (BGl_iszd2azf3z21zz__objectz00(BgL_expz00_17,
								BGl_nodez00zzast_nodez00))
							{	/* Ast/sexp.scm 85 */
								return (BgL_nodez00_bglt) (BgL_expz00_17);
							}
						else
							{	/* Ast/sexp.scm 85 */
								if (PAIRP(BgL_expz00_17))
									{	/* Ast/sexp.scm 85 */
										if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 20))))
											{	/* Ast/sexp.scm 85 */
												obj_t BgL_auxz00_2683;

												{	/* Ast/sexp.scm 157 */
													obj_t BgL_locz00_1084;

													BgL_locz00_1084 =
														BGl_findzd2locationzf2locz20zztools_locationz00
														(BgL_expz00_17, BgL_locz00_19);
													{
														obj_t BgL_namez00_1085;

														obj_t BgL_modulez00_1086;

														if (PAIRP(BgL_expz00_17))
															{	/* Ast/sexp.scm 158 */
																obj_t BgL_cdrzd21861zd2_1091;

																BgL_cdrzd21861zd2_1091 = CDR(BgL_expz00_17);
																if (
																	(CAR(BgL_expz00_17) ==
																		CNST_TABLE_REF(((long) 20))))
																	{	/* Ast/sexp.scm 158 */
																		if (PAIRP(BgL_cdrzd21861zd2_1091))
																			{	/* Ast/sexp.scm 158 */
																				obj_t BgL_carzd21864zd2_1094;

																				obj_t BgL_cdrzd21865zd2_1095;

																				BgL_carzd21864zd2_1094 =
																					CAR(BgL_cdrzd21861zd2_1091);
																				BgL_cdrzd21865zd2_1095 =
																					CDR(BgL_cdrzd21861zd2_1091);
																				if (SYMBOLP(BgL_carzd21864zd2_1094))
																					{	/* Ast/sexp.scm 158 */
																						if (PAIRP(BgL_cdrzd21865zd2_1095))
																							{	/* Ast/sexp.scm 158 */
																								obj_t BgL_carzd21870zd2_1098;

																								BgL_carzd21870zd2_1098 =
																									CAR(BgL_cdrzd21865zd2_1095);
																								if (SYMBOLP
																									(BgL_carzd21870zd2_1098))
																									{	/* Ast/sexp.scm 158 */
																										if (NULLP(CDR
																												(BgL_cdrzd21865zd2_1095)))
																											{	/* Ast/sexp.scm 158 */
																												BgL_namez00_1085 =
																													BgL_carzd21864zd2_1094;
																												BgL_modulez00_1086 =
																													BgL_carzd21870zd2_1098;
																												{	/* Ast/sexp.scm 160 */
																													obj_t
																														BgL_globalz00_1104;
																													BgL_globalz00_1104 =
																														BGl_findzd2globalzf2modulez20zzast_envz00
																														(BgL_namez00_1085,
																														BgL_modulez00_1086);
																													if (BGl_iszd2azf3z21zz__objectz00(BgL_globalz00_1104, BGl_globalz00zzast_varz00))
																														{	/* Ast/sexp.scm 164 */
																															bool_t
																																BgL_testz00_2709;
																															{	/* Ast/sexp.scm 164 */
																																obj_t
																																	BgL_auxz00_2710;
																																{
																																	BgL_globalz00_bglt
																																		BgL_auxz00_2711;
																																	BgL_auxz00_2711
																																		=
																																		(BgL_globalz00_bglt)
																																		(BgL_globalz00_1104);
																																	BgL_auxz00_2710
																																		=
																																		(((BgL_globalz00_bglt) CREF(BgL_auxz00_2711))->BgL_importz00);
																																}
																																BgL_testz00_2709
																																	=
																																	(BgL_auxz00_2710
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			18)));
																															}
																															if (BgL_testz00_2709)
																																{	/* Ast/sexp.scm 165 */
																																	obj_t
																																		BgL_arg3356z00_1107;
																																	{	/* Ast/sexp.scm 165 */
																																		obj_t
																																			BgL_arg3357z00_1108;
																																		obj_t
																																			BgL_arg3358z00_1109;
																																		BgL_arg3357z00_1108
																																			=
																																			CNST_TABLE_REF
																																			(((long)
																																				18));
																																		{	/* Ast/sexp.scm 165 */
																																			obj_t
																																				BgL_list3359z00_1110;
																																			BgL_list3359z00_1110
																																				=
																																				MAKE_PAIR
																																				(BNIL,
																																				BNIL);
																																			BgL_arg3358z00_1109
																																				=
																																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																				(BGl_atomz00zzast_nodez00,
																																				BgL_list3359z00_1110);
																																		}
																																		BgL_arg3356z00_1107
																																			=
																																			MAKE_PAIR
																																			(BgL_arg3357z00_1108,
																																			BgL_arg3358z00_1109);
																																	}
																																	BgL_auxz00_2683
																																		=
																																		(obj_t)
																																		(BGl_sexpzd2ze3nodez31zzast_sexpz00
																																		(BgL_arg3356z00_1107,
																																			BgL_stackz00_18,
																																			BgL_locz00_1084,
																																			BgL_sitez00_20));
																																}
																															else
																																{	/* Ast/sexp.scm 164 */
																																	BGl_usezd2variablez12zc0zzast_sexpz00
																																		(
																																		(BgL_variablez00_bglt)
																																		(BgL_globalz00_1104),
																																		BgL_locz00_1084,
																																		BgL_sitez00_20);
																																	{	/* Ast/sexp.scm 168 */
																																		bool_t
																																			BgL_testz00_2724;
																																		if (
																																			(BgL_sitez00_20
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						19))))
																																			{	/* Ast/sexp.scm 168 */
																																				BgL_testz00_2724
																																					=
																																					(
																																					(bool_t)
																																					0);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 169 */
																																				BgL_valuez00_bglt
																																					BgL_arg3364z00_1115;
																																				{
																																					BgL_variablez00_bglt
																																						BgL_auxz00_2728;
																																					BgL_auxz00_2728
																																						=
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1104);
																																					BgL_arg3364z00_1115
																																						=
																																						(((BgL_variablez00_bglt) CREF(BgL_auxz00_2728))->BgL_valuez00);
																																				}
																																				{	/* Ast/sexp.scm 169 */
																																					obj_t
																																						BgL_obj1751z00_2208;
																																					BgL_obj1751z00_2208
																																						=
																																						(obj_t)
																																						(BgL_arg3364z00_1115);
																																					BgL_testz00_2724
																																						=
																																						BGl_iszd2azf3z21zz__objectz00
																																						(BgL_obj1751z00_2208,
																																						BGl_funz00zzast_varz00);
																																				}
																																			}
																																		if (BgL_testz00_2724)
																																			{	/* Ast/sexp.scm 171 */
																																				BgL_typez00_bglt
																																					BgL_arg3361z00_1112;
																																				{
																																					BgL_variablez00_bglt
																																						BgL_auxz00_2733;
																																					BgL_auxz00_2733
																																						=
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1104);
																																					BgL_arg3361z00_1112
																																						=
																																						(((BgL_variablez00_bglt) CREF(BgL_auxz00_2733))->BgL_typez00);
																																				}
																																				BgL_auxz00_2683
																																					=
																																					(obj_t)
																																					(BGl_makezd2closurezd2zzast_nodez00
																																					(BgL_locz00_1084,
																																						BgL_arg3361z00_1112,
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1104)));
																																			}
																																		else
																																			{	/* Ast/sexp.scm 174 */
																																				BgL_typez00_bglt
																																					BgL_arg3362z00_1113;
																																				{
																																					BgL_variablez00_bglt
																																						BgL_auxz00_2739;
																																					BgL_auxz00_2739
																																						=
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1104);
																																					BgL_arg3362z00_1113
																																						=
																																						(((BgL_variablez00_bglt) CREF(BgL_auxz00_2739))->BgL_typez00);
																																				}
																																				BgL_auxz00_2683
																																					=
																																					(obj_t)
																																					(BGl_makezd2varzd2zzast_nodez00
																																					(BgL_locz00_1084,
																																						BgL_arg3362z00_1113,
																																						(BgL_variablez00_bglt)
																																						(BgL_globalz00_1104)));
																																			}
																																	}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 162 */
																															BgL_auxz00_2683 =
																																(obj_t)
																																(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																(BGl_string3887z00zzast_sexpz00,
																																	BgL_expz00_17,
																																	BgL_locz00_1084));
																														}
																												}
																											}
																										else
																											{	/* Ast/sexp.scm 158 */
																												BgL_nodez00_bglt
																													BgL_auxz00_2747;
																											BgL_tagzd21854zd2_1088:
																												BgL_auxz00_2747 =
																													BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																													(BGl_string3886z00zzast_sexpz00,
																													BgL_expz00_17,
																													BgL_locz00_1084);
																												BgL_auxz00_2683 =
																													(obj_t)
																													(BgL_auxz00_2747);
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 158 */
																										BgL_nodez00_bglt
																											BgL_auxz00_2750;
																										goto BgL_tagzd21854zd2_1088;
																										BgL_auxz00_2683 =
																											(obj_t) (BgL_auxz00_2750);
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 158 */
																								BgL_nodez00_bglt
																									BgL_auxz00_2752;
																								goto BgL_tagzd21854zd2_1088;
																								BgL_auxz00_2683 =
																									(obj_t) (BgL_auxz00_2752);
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 158 */
																						BgL_nodez00_bglt BgL_auxz00_2754;

																						goto BgL_tagzd21854zd2_1088;
																						BgL_auxz00_2683 =
																							(obj_t) (BgL_auxz00_2754);
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 158 */
																				BgL_nodez00_bglt BgL_auxz00_2756;

																				goto BgL_tagzd21854zd2_1088;
																				BgL_auxz00_2683 =
																					(obj_t) (BgL_auxz00_2756);
																			}
																	}
																else
																	{	/* Ast/sexp.scm 158 */
																		BgL_nodez00_bglt BgL_auxz00_2758;

																		goto BgL_tagzd21854zd2_1088;
																		BgL_auxz00_2683 = (obj_t) (BgL_auxz00_2758);
																	}
															}
														else
															{	/* Ast/sexp.scm 158 */
																BgL_nodez00_bglt BgL_auxz00_2760;

																goto BgL_tagzd21854zd2_1088;
																BgL_auxz00_2683 = (obj_t) (BgL_auxz00_2760);
															}
													}
												}
												return (BgL_nodez00_bglt) (BgL_auxz00_2683);
											}
										else
											{	/* Ast/sexp.scm 85 */
												if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 21))))
													{	/* Ast/sexp.scm 85 */
														obj_t BgL_auxz00_2767;

														{
															obj_t BgL_valuez00_1118;

															if (PAIRP(BgL_expz00_17))
																{	/* Ast/sexp.scm 85 */
																	obj_t BgL_cdrzd21881zd2_1123;

																	BgL_cdrzd21881zd2_1123 = CDR(BgL_expz00_17);
																	if (PAIRP(BgL_cdrzd21881zd2_1123))
																		{	/* Ast/sexp.scm 85 */
																			if (NULLP(CDR(BgL_cdrzd21881zd2_1123)))
																				{	/* Ast/sexp.scm 85 */
																					BgL_valuez00_1118 =
																						CAR(BgL_cdrzd21881zd2_1123);
																					{	/* Ast/sexp.scm 182 */
																						obj_t BgL_locz00_1128;

																						BgL_locz00_1128 =
																							BGl_findzd2locationzf2locz20zztools_locationz00
																							(BgL_expz00_17, BgL_locz00_19);
																						if (NULLP(BgL_valuez00_1118))
																							{	/* Ast/sexp.scm 184 */
																								BgL_auxz00_2767 =
																									(obj_t)
																									(BGl_makezd2atomzd2zzast_nodez00
																									(BgL_locz00_1128,
																										(BgL_typez00_bglt)
																										(BGl_za2bnilza2z00zztype_cachez00),
																										BNIL));
																							}
																						else
																							{	/* Ast/sexp.scm 188 */
																								bool_t BgL_testz00_2782;

																								if (PAIRP(BgL_valuez00_1118))
																									{	/* Ast/sexp.scm 188 */
																										BgL_testz00_2782 =
																											((bool_t) 1);
																									}
																								else
																									{	/* Ast/sexp.scm 188 */
																										if (VECTORP
																											(BgL_valuez00_1118))
																											{	/* Ast/sexp.scm 189 */
																												BgL_testz00_2782 =
																													((bool_t) 1);
																											}
																										else
																											{	/* Ast/sexp.scm 189 */
																												if (BGL_HVECTORP
																													(BgL_valuez00_1118))
																													{	/* Ast/sexp.scm 190 */
																														BgL_testz00_2782 =
																															((bool_t) 1);
																													}
																												else
																													{	/* Ast/sexp.scm 190 */
																														if (STRUCTP
																															(BgL_valuez00_1118))
																															{	/* Ast/sexp.scm 191 */
																																BgL_testz00_2782
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Ast/sexp.scm 191 */
																																if (SYMBOLP
																																	(BgL_valuez00_1118))
																																	{	/* Ast/sexp.scm 192 */
																																		BgL_testz00_2782
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 192 */
																																		BgL_testz00_2782
																																			=
																																			KEYWORDP
																																			(BgL_valuez00_1118);
																																	}
																															}
																													}
																											}
																									}
																								if (BgL_testz00_2782)
																									{	/* Ast/sexp.scm 188 */
																										BgL_auxz00_2767 =
																											(obj_t)
																											(BGl_makezd2kwotezd2zzast_nodez00
																											(BgL_locz00_1128,
																												(BgL_typez00_bglt)
																												(BGl_za2_za2z00zztype_cachez00),
																												BgL_valuez00_1118));
																									}
																								else
																									{	/* Ast/sexp.scm 197 */
																										bool_t BgL_testz00_2797;

																										{	/* Ast/sexp.scm 197 */
																											bool_t BgL_testz00_2798;

																											if (INTEGERP
																												(BgL_valuez00_1118))
																												{	/* Ast/sexp.scm 197 */
																													BgL_testz00_2798 =
																														((bool_t) 1);
																												}
																											else
																												{	/* Ast/sexp.scm 197 */
																													if (REALP
																														(BgL_valuez00_1118))
																														{	/* Ast/sexp.scm 197 */
																															BgL_testz00_2798 =
																																((bool_t) 1);
																														}
																													else
																														{	/* Ast/sexp.scm 197 */
																															if (ELONGP
																																(BgL_valuez00_1118))
																																{	/* Ast/sexp.scm 197 */
																																	BgL_testz00_2798
																																		=
																																		((bool_t)
																																		1);
																																}
																															else
																																{	/* Ast/sexp.scm 197 */
																																	if (LLONGP
																																		(BgL_valuez00_1118))
																																		{	/* Ast/sexp.scm 197 */
																																			BgL_testz00_2798
																																				=
																																				(
																																				(bool_t)
																																				1);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 197 */
																																			BgL_testz00_2798
																																				=
																																				BIGNUMP
																																				(BgL_valuez00_1118);
																																		}
																																}
																														}
																												}
																											if (BgL_testz00_2798)
																												{	/* Ast/sexp.scm 197 */
																													BgL_testz00_2797 =
																														((bool_t) 1);
																												}
																											else
																												{	/* Ast/sexp.scm 197 */
																													if (STRINGP
																														(BgL_valuez00_1118))
																														{	/* Ast/sexp.scm 198 */
																															BgL_testz00_2797 =
																																((bool_t) 1);
																														}
																													else
																														{	/* Ast/sexp.scm 198 */
																															if (CNSTP
																																(BgL_valuez00_1118))
																																{	/* Ast/sexp.scm 199 */
																																	BgL_testz00_2797
																																		=
																																		((bool_t)
																																		1);
																																}
																															else
																																{	/* Ast/sexp.scm 199 */
																																	if (CHARP
																																		(BgL_valuez00_1118))
																																		{	/* Ast/sexp.scm 203 */
																																			BgL_testz00_2797
																																				=
																																				(
																																				(bool_t)
																																				1);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 203 */
																																			BgL_testz00_2797
																																				=
																																				BOOLEANP
																																				(BgL_valuez00_1118);
																																		}
																																}
																														}
																												}
																										}
																										if (BgL_testz00_2797)
																											{	/* Ast/sexp.scm 197 */
																												BgL_auxz00_2767 =
																													(obj_t)
																													(BGl_sexpzd2ze3nodez31zzast_sexpz00
																													(BgL_valuez00_1118,
																														BgL_stackz00_18,
																														BgL_locz00_1128,
																														BgL_sitez00_20));
																											}
																										else
																											{	/* Ast/sexp.scm 197 */
																												BgL_auxz00_2767 =
																													(obj_t)
																													(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																													(BGl_string3885z00zzast_sexpz00,
																														BgL_expz00_17,
																														BgL_locz00_1128));
																											}
																									}
																							}
																					}
																				}
																			else
																				{	/* Ast/sexp.scm 85 */
																					BgL_nodez00_bglt BgL_auxz00_2820;

																				BgL_tagzd21876zd2_1120:
																					BgL_auxz00_2820 =
																						BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																						(BGl_string3885z00zzast_sexpz00,
																						BgL_expz00_17, BgL_locz00_19);
																					BgL_auxz00_2767 =
																						(obj_t) (BgL_auxz00_2820);
																				}
																		}
																	else
																		{	/* Ast/sexp.scm 85 */
																			BgL_nodez00_bglt BgL_auxz00_2823;

																			goto BgL_tagzd21876zd2_1120;
																			BgL_auxz00_2767 =
																				(obj_t) (BgL_auxz00_2823);
																		}
																}
															else
																{	/* Ast/sexp.scm 85 */
																	BgL_nodez00_bglt BgL_auxz00_2825;

																	goto BgL_tagzd21876zd2_1120;
																	BgL_auxz00_2767 = (obj_t) (BgL_auxz00_2825);
																}
														}
														return (BgL_nodez00_bglt) (BgL_auxz00_2767);
													}
												else
													{	/* Ast/sexp.scm 85 */
														if (
															(CAR(BgL_expz00_17) ==
																CNST_TABLE_REF(((long) 23))))
															{	/* Ast/sexp.scm 85 */
																obj_t BgL_arg3187z00_909;

																BgL_arg3187z00_909 = CDR(BgL_expz00_17);
																{	/* Ast/sexp.scm 85 */
																	BgL_sequencez00_bglt BgL_auxz00_2833;

																	BgL_bodyz00_871 = BgL_arg3187z00_909;
																	{	/* Ast/sexp.scm 212 */
																		obj_t BgL_bodyz00_1141;

																		if (NULLP(BgL_bodyz00_871))
																			{	/* Ast/sexp.scm 213 */
																				obj_t BgL_list3385z00_1145;

																				BgL_list3385z00_1145 =
																					MAKE_PAIR(BUNSPEC, BNIL);
																				BgL_bodyz00_1141 = BgL_list3385z00_1145;
																			}
																		else
																			{	/* Ast/sexp.scm 212 */
																				BgL_bodyz00_1141 = BgL_bodyz00_871;
																			}
																		{	/* Ast/sexp.scm 215 */
																			obj_t BgL_locz00_1142;

																			BgL_locz00_1142 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_expz00_17, BgL_locz00_19);
																			{	/* Ast/sexp.scm 215 */
																				obj_t BgL_nodesz00_1143;

																				BgL_nodesz00_1143 =
																					BGl_sexpza2zd2ze3nodez93zzast_sexpz00
																					(BgL_bodyz00_1141, BgL_stackz00_18,
																					BgL_locz00_1142, BgL_sitez00_20);
																				{	/* Ast/sexp.scm 216 */

																					BgL_auxz00_2833 =
																						BGl_makezd2sequencezd2zzast_nodez00
																						(BgL_locz00_1142,
																						(BgL_typez00_bglt)
																						(BGl_za2_za2z00zztype_cachez00),
																						BUNSPEC, BINT(((long) -1)),
																						BgL_nodesz00_1143);
																	}}}}
																	return (BgL_nodez00_bglt) (BgL_auxz00_2833);
																}
															}
														else
															{	/* Ast/sexp.scm 85 */
																if (
																	(CAR(BgL_expz00_17) ==
																		CNST_TABLE_REF(((long) 16))))
																	{	/* Ast/sexp.scm 85 */
																		obj_t BgL_auxz00_2847;

																		{
																			obj_t BgL_siz00_1146;

																			obj_t BgL_alorsz00_1147;

																			obj_t BgL_sinonz00_1148;

																			obj_t BgL_siz00_1150;

																			obj_t BgL_alorsz00_1151;

																			if (PAIRP(BgL_expz00_17))
																				{	/* Ast/sexp.scm 85 */
																					obj_t BgL_cdrzd21897zd2_1156;

																					BgL_cdrzd21897zd2_1156 =
																						CDR(BgL_expz00_17);
																					if (PAIRP(BgL_cdrzd21897zd2_1156))
																						{	/* Ast/sexp.scm 85 */
																							obj_t BgL_cdrzd21902zd2_1158;

																							BgL_cdrzd21902zd2_1158 =
																								CDR(BgL_cdrzd21897zd2_1156);
																							if (PAIRP(BgL_cdrzd21902zd2_1158))
																								{	/* Ast/sexp.scm 85 */
																									obj_t BgL_cdrzd21907zd2_1160;

																									BgL_cdrzd21907zd2_1160 =
																										CDR(BgL_cdrzd21902zd2_1158);
																									if (PAIRP
																										(BgL_cdrzd21907zd2_1160))
																										{	/* Ast/sexp.scm 85 */
																											if (NULLP(CDR
																													(BgL_cdrzd21907zd2_1160)))
																												{	/* Ast/sexp.scm 85 */
																													BgL_siz00_1146 =
																														CAR
																														(BgL_cdrzd21897zd2_1156);
																													BgL_alorsz00_1147 =
																														CAR
																														(BgL_cdrzd21902zd2_1158);
																													BgL_sinonz00_1148 =
																														CAR
																														(BgL_cdrzd21907zd2_1160);
																													{
																														obj_t
																															BgL_siz00_1173;
																														if (PAIRP
																															(BgL_siz00_1146))
																															{	/* Ast/sexp.scm 85 */
																																obj_t
																																	BgL_cdrzd21962zd2_1178;
																																BgL_cdrzd21962zd2_1178
																																	=
																																	CDR
																																	(BgL_siz00_1146);
																																if ((CAR
																																		(BgL_siz00_1146)
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				16))))
																																	{	/* Ast/sexp.scm 85 */
																																		if (PAIRP
																																			(BgL_cdrzd21962zd2_1178))
																																			{	/* Ast/sexp.scm 85 */
																																				obj_t
																																					BgL_cdrzd21965zd2_1181;
																																				BgL_cdrzd21965zd2_1181
																																					=
																																					CDR
																																					(BgL_cdrzd21962zd2_1178);
																																				if (PAIRP(BgL_cdrzd21965zd2_1181))
																																					{	/* Ast/sexp.scm 85 */
																																						obj_t
																																							BgL_cdrzd21968zd2_1183;
																																						BgL_cdrzd21968zd2_1183
																																							=
																																							CDR
																																							(BgL_cdrzd21965zd2_1181);
																																						if (
																																							(CAR
																																								(BgL_cdrzd21965zd2_1181)
																																								==
																																								BFALSE))
																																							{	/* Ast/sexp.scm 85 */
																																								if (PAIRP(BgL_cdrzd21968zd2_1183))
																																									{	/* Ast/sexp.scm 85 */
																																										if ((CAR(BgL_cdrzd21968zd2_1183) == BTRUE))
																																											{	/* Ast/sexp.scm 85 */
																																												if (NULLP(CDR(BgL_cdrzd21968zd2_1183)))
																																													{	/* Ast/sexp.scm 85 */
																																														obj_t
																																															BgL_arg3408z00_1188;
																																														BgL_arg3408z00_1188
																																															=
																																															CAR
																																															(BgL_cdrzd21962zd2_1178);
																																														{	/* Ast/sexp.scm 85 */
																																															BgL_nodez00_bglt
																																																BgL_auxz00_2887;
																																															BgL_siz00_1173
																																																=
																																																BgL_arg3408z00_1188;
																																														BgL_tagzd21954zd2_1174:
																																															{	/* Ast/sexp.scm 226 */
																																																obj_t
																																																	BgL_auxz00_2888;
																																																BgL_auxz00_2888
																																																	=
																																																	CDR
																																																	(BgL_expz00_17);
																																																SET_CAR
																																																	(BgL_auxz00_2888,
																																																	BgL_siz00_1173);
																																															}
																																															{	/* Ast/sexp.scm 227 */
																																																obj_t
																																																	BgL_arg3425z00_1205;
																																																{	/* Ast/sexp.scm 227 */
																																																	obj_t
																																																		BgL_pairz00_2282;
																																																	BgL_pairz00_2282
																																																		=
																																																		BgL_expz00_17;
																																																	BgL_arg3425z00_1205
																																																		=
																																																		CDR
																																																		(CDR
																																																		(BgL_pairz00_2282));
																																																}
																																																SET_CAR
																																																	(BgL_arg3425z00_1205,
																																																	BgL_sinonz00_1148);
																																															}
																																															{	/* Ast/sexp.scm 228 */
																																																obj_t
																																																	BgL_arg3426z00_1206;
																																																{	/* Ast/sexp.scm 228 */
																																																	obj_t
																																																		BgL_pairz00_2288;
																																																	BgL_pairz00_2288
																																																		=
																																																		BgL_expz00_17;
																																																	BgL_arg3426z00_1206
																																																		=
																																																		CDR
																																																		(CDR
																																																		(CDR
																																																			(BgL_pairz00_2288)));
																																																}
																																																SET_CAR
																																																	(BgL_arg3426z00_1206,
																																																	BgL_alorsz00_1147);
																																															}
																																															BgL_auxz00_2887
																																																=
																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																(BgL_expz00_17,
																																																BgL_stackz00_18,
																																																BgL_locz00_19,
																																																BgL_sitez00_20);
																																															BgL_auxz00_2847
																																																=
																																																(obj_t)
																																																(BgL_auxz00_2887);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 85 */
																																													BgL_tagzd21955zd2_1175:
																																														{	/* Ast/sexp.scm 231 */
																																															bool_t
																																																BgL_testz00_2900;
																																															if (SYMBOLP(BgL_siz00_1146))
																																																{	/* Ast/sexp.scm 231 */
																																																	BgL_testz00_2900
																																																		=
																																																		(
																																																		(bool_t)
																																																		1);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 231 */
																																																	BgL_testz00_2900
																																																		=
																																																		BGl_iszd2azf3z21zz__objectz00
																																																		(BgL_siz00_1146,
																																																		BGl_atomz00zzast_nodez00);
																																																}
																																															if (BgL_testz00_2900)
																																																{	/* Ast/sexp.scm 232 */
																																																	obj_t
																																																		BgL_olocz00_1208;
																																																	BgL_olocz00_1208
																																																		=
																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																		(BgL_expz00_17,
																																																		BgL_locz00_19);
																																																	{	/* Ast/sexp.scm 232 */
																																																		obj_t
																																																			BgL_cdlocz00_1209;
																																																		BgL_cdlocz00_1209
																																																			=
																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																			(CDR
																																																			(BgL_expz00_17),
																																																			BgL_locz00_19);
																																																		{	/* Ast/sexp.scm 233 */
																																																			obj_t
																																																				BgL_cddlocz00_1210;
																																																			{	/* Ast/sexp.scm 234 */
																																																				obj_t
																																																					BgL_arg3431z00_1223;
																																																				{	/* Ast/sexp.scm 234 */
																																																					obj_t
																																																						BgL_pairz00_2299;
																																																					BgL_pairz00_2299
																																																						=
																																																						BgL_expz00_17;
																																																					BgL_arg3431z00_1223
																																																						=
																																																						CDR
																																																						(CDR
																																																						(BgL_pairz00_2299));
																																																				}
																																																				BgL_cddlocz00_1210
																																																					=
																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																					(BgL_arg3431z00_1223,
																																																					BgL_locz00_19);
																																																			}
																																																			{	/* Ast/sexp.scm 234 */
																																																				obj_t
																																																					BgL_cdddlocz00_1211;
																																																				{	/* Ast/sexp.scm 235 */
																																																					obj_t
																																																						BgL_arg3430z00_1222;
																																																					{	/* Ast/sexp.scm 235 */
																																																						obj_t
																																																							BgL_pairz00_2303;
																																																						BgL_pairz00_2303
																																																							=
																																																							BgL_expz00_17;
																																																						BgL_arg3430z00_1222
																																																							=
																																																							CDR
																																																							(CDR
																																																							(CDR
																																																								(BgL_pairz00_2303)));
																																																					}
																																																					BgL_cdddlocz00_1211
																																																						=
																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																						(BgL_arg3430z00_1222,
																																																						BgL_locz00_19);
																																																				}
																																																				{	/* Ast/sexp.scm 235 */
																																																					obj_t
																																																						BgL_lzd2sizd2_1212;
																																																					BgL_lzd2sizd2_1212
																																																						=
																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																						(BgL_siz00_1146,
																																																						BgL_cdlocz00_1209);
																																																					{	/* Ast/sexp.scm 236 */
																																																						obj_t
																																																							BgL_lzd2alorszd2_1213;
																																																						BgL_lzd2alorszd2_1213
																																																							=
																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																							(BgL_alorsz00_1147,
																																																							BgL_cddlocz00_1210);
																																																						{	/* Ast/sexp.scm 237 */
																																																							obj_t
																																																								BgL_lzd2sinonzd2_1214;
																																																							BgL_lzd2sinonzd2_1214
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_sinonz00_1148,
																																																								BgL_cdddlocz00_1211);
																																																							{	/* Ast/sexp.scm 238 */
																																																								BgL_nodez00_bglt
																																																									BgL_siz00_1215;
																																																								BgL_siz00_1215
																																																									=
																																																									BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																									(BgL_siz00_1146,
																																																									BgL_stackz00_18,
																																																									BgL_lzd2sizd2_1212,
																																																									CNST_TABLE_REF
																																																									(((long) 1)));
																																																								{	/* Ast/sexp.scm 239 */
																																																									BgL_nodez00_bglt
																																																										BgL_alorsz00_1216;
																																																									BgL_alorsz00_1216
																																																										=
																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																										(BgL_alorsz00_1147,
																																																										BgL_stackz00_18,
																																																										BgL_lzd2alorszd2_1213,
																																																										CNST_TABLE_REF
																																																										(((long) 1)));
																																																									{	/* Ast/sexp.scm 240 */
																																																										BgL_nodez00_bglt
																																																											BgL_sinonz00_1217;
																																																										BgL_sinonz00_1217
																																																											=
																																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																											(BgL_sinonz00_1148,
																																																											BgL_stackz00_18,
																																																											BgL_lzd2sinonzd2_1214,
																																																											CNST_TABLE_REF
																																																											(((long) 1)));
																																																										{	/* Ast/sexp.scm 241 */
																																																											obj_t
																																																												BgL_locz00_1218;
																																																											{	/* Ast/sexp.scm 242 */
																																																												obj_t
																																																													BgL_locz00_1219;
																																																												{	/* Ast/sexp.scm 244 */
																																																													obj_t
																																																														BgL_arg3429z00_1221;
																																																													BgL_arg3429z00_1221
																																																														=
																																																														(
																																																														((BgL_nodez00_bglt) CREF(BgL_siz00_1215))->BgL_locz00);
																																																													BgL_locz00_1219
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_expz00_17,
																																																														BgL_arg3429z00_1221);
																																																												}
																																																												{	/* Ast/sexp.scm 245 */
																																																													bool_t
																																																														BgL_testz00_2925;
																																																													if (STRUCTP(BgL_locz00_1219))
																																																														{	/* Ast/sexp.scm 245 */
																																																															BgL_testz00_2925
																																																																=
																																																																(STRUCT_KEY
																																																																(BgL_locz00_1219)
																																																																==
																																																																CNST_TABLE_REF
																																																																(((long) 13)));
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 245 */
																																																															BgL_testz00_2925
																																																																=
																																																																(
																																																																(bool_t)
																																																																0);
																																																														}
																																																													if (BgL_testz00_2925)
																																																														{	/* Ast/sexp.scm 245 */
																																																															BgL_locz00_1218
																																																																=
																																																																BgL_locz00_1219;
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 245 */
																																																															BgL_locz00_1218
																																																																=
																																																																BgL_olocz00_1208;
																																																														}
																																																												}
																																																											}
																																																											{	/* Ast/sexp.scm 242 */

																																																												BgL_auxz00_2847
																																																													=
																																																													(obj_t)
																																																													(BGl_makezd2conditionalzd2zzast_nodez00
																																																													(BgL_locz00_1218,
																																																														(BgL_typez00_bglt)
																																																														(BGl_za2_za2z00zztype_cachez00),
																																																														BUNSPEC,
																																																														BINT
																																																														(((long) -1)), BgL_siz00_1215, BgL_alorsz00_1216, BgL_sinonz00_1217));
																																																}}}}}}}}}}}}
																																															else
																																																{	/* Ast/sexp.scm 253 */
																																																	obj_t
																																																		BgL_testz00_1225;
																																																	BgL_testz00_1225
																																																		=
																																																		BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																		(BGl_gensymz00zz__r4_symbols_6_4z00
																																																		(CNST_TABLE_REF
																																																			(((long) 14))));
																																																	{	/* Ast/sexp.scm 255 */
																																																		obj_t
																																																			BgL_arg3434z00_1226;
																																																		{	/* Ast/sexp.scm 255 */
																																																			obj_t
																																																				BgL_arg3435z00_1227;
																																																			obj_t
																																																				BgL_arg3436z00_1228;
																																																			BgL_arg3435z00_1227
																																																				=
																																																				CNST_TABLE_REF
																																																				(
																																																				((long) 11));
																																																			{	/* Ast/sexp.scm 255 */
																																																				obj_t
																																																					BgL_arg3437z00_1229;
																																																				obj_t
																																																					BgL_arg3438z00_1230;
																																																				{	/* Ast/sexp.scm 255 */
																																																					obj_t
																																																						BgL_arg3442z00_1234;
																																																					{	/* Ast/sexp.scm 255 */
																																																						obj_t
																																																							BgL_arg3444z00_1236;
																																																						obj_t
																																																							BgL_arg3445z00_1237;
																																																						{	/* Ast/sexp.scm 255 */
																																																							obj_t
																																																								BgL_arg3446z00_1238;
																																																							{	/* Ast/sexp.scm 255 */
																																																								obj_t
																																																									BgL_arg3447z00_1239;
																																																								obj_t
																																																									BgL_arg3448z00_1240;
																																																								BgL_arg3447z00_1239
																																																									=
																																																									SYMBOL_TO_STRING
																																																									(BgL_testz00_1225);
																																																								{	/* Ast/sexp.scm 255 */
																																																									obj_t
																																																										BgL_symbolz00_2318;
																																																									BgL_symbolz00_2318
																																																										=
																																																										CNST_TABLE_REF
																																																										(
																																																										((long) 15));
																																																									BgL_arg3448z00_1240
																																																										=
																																																										SYMBOL_TO_STRING
																																																										(BgL_symbolz00_2318);
																																																								}
																																																								{	/* Ast/sexp.scm 255 */
																																																									obj_t
																																																										BgL_list3449z00_1241;
																																																									{	/* Ast/sexp.scm 255 */
																																																										obj_t
																																																											BgL_arg3450z00_1242;
																																																										BgL_arg3450z00_1242
																																																											=
																																																											MAKE_PAIR
																																																											(BgL_arg3448z00_1240,
																																																											BNIL);
																																																										BgL_list3449z00_1241
																																																											=
																																																											MAKE_PAIR
																																																											(BgL_arg3447z00_1239,
																																																											BgL_arg3450z00_1242);
																																																									}
																																																									BgL_arg3446z00_1238
																																																										=
																																																										BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																																																										(BgL_list3449z00_1241);
																																																							}}
																																																							BgL_arg3444z00_1236
																																																								=
																																																								string_to_symbol
																																																								(BSTRING_TO_STRING
																																																								(BgL_arg3446z00_1238));
																																																						}
																																																						{	/* Ast/sexp.scm 255 */
																																																							obj_t
																																																								BgL_list3451z00_1243;
																																																							BgL_list3451z00_1243
																																																								=
																																																								MAKE_PAIR
																																																								(BNIL,
																																																								BNIL);
																																																							BgL_arg3445z00_1237
																																																								=
																																																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																								(BgL_siz00_1146,
																																																								BgL_list3451z00_1243);
																																																						}
																																																						BgL_arg3442z00_1234
																																																							=
																																																							MAKE_PAIR
																																																							(BgL_arg3444z00_1236,
																																																							BgL_arg3445z00_1237);
																																																					}
																																																					BgL_arg3437z00_1229
																																																						=
																																																						MAKE_PAIR
																																																						(BgL_arg3442z00_1234,
																																																						BNIL);
																																																				}
																																																				{	/* Ast/sexp.scm 256 */
																																																					obj_t
																																																						BgL_arg3452z00_1244;
																																																					{	/* Ast/sexp.scm 256 */
																																																						obj_t
																																																							BgL_arg3453z00_1245;
																																																						obj_t
																																																							BgL_arg3454z00_1246;
																																																						BgL_arg3453z00_1245
																																																							=
																																																							CNST_TABLE_REF
																																																							(
																																																							((long) 16));
																																																						{	/* Ast/sexp.scm 256 */
																																																							obj_t
																																																								BgL_list3455z00_1247;
																																																							{	/* Ast/sexp.scm 256 */
																																																								obj_t
																																																									BgL_arg3456z00_1248;
																																																								{	/* Ast/sexp.scm 256 */
																																																									obj_t
																																																										BgL_arg3457z00_1249;
																																																									BgL_arg3457z00_1249
																																																										=
																																																										MAKE_PAIR
																																																										(BNIL,
																																																										BNIL);
																																																									BgL_arg3456z00_1248
																																																										=
																																																										MAKE_PAIR
																																																										(BgL_sinonz00_1148,
																																																										BgL_arg3457z00_1249);
																																																								}
																																																								BgL_list3455z00_1247
																																																									=
																																																									MAKE_PAIR
																																																									(BgL_alorsz00_1147,
																																																									BgL_arg3456z00_1248);
																																																							}
																																																							BgL_arg3454z00_1246
																																																								=
																																																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																								(BgL_testz00_1225,
																																																								BgL_list3455z00_1247);
																																																						}
																																																						BgL_arg3452z00_1244
																																																							=
																																																							MAKE_PAIR
																																																							(BgL_arg3453z00_1245,
																																																							BgL_arg3454z00_1246);
																																																					}
																																																					BgL_arg3438z00_1230
																																																						=
																																																						BGl_epairifyzd2reczd2zztools_miscz00
																																																						(BgL_arg3452z00_1244,
																																																						BgL_expz00_17);
																																																				}
																																																				{	/* Ast/sexp.scm 255 */
																																																					obj_t
																																																						BgL_list3440z00_1232;
																																																					{	/* Ast/sexp.scm 255 */
																																																						obj_t
																																																							BgL_arg3441z00_1233;
																																																						BgL_arg3441z00_1233
																																																							=
																																																							MAKE_PAIR
																																																							(BNIL,
																																																							BNIL);
																																																						BgL_list3440z00_1232
																																																							=
																																																							MAKE_PAIR
																																																							(BgL_arg3438z00_1230,
																																																							BgL_arg3441z00_1233);
																																																					}
																																																					BgL_arg3436z00_1228
																																																						=
																																																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																						(BgL_arg3437z00_1229,
																																																						BgL_list3440z00_1232);
																																																			}}
																																																			BgL_arg3434z00_1226
																																																				=
																																																				MAKE_PAIR
																																																				(BgL_arg3435z00_1227,
																																																				BgL_arg3436z00_1228);
																																																		}
																																																		BGl_replacez12z12zztools_miscz00
																																																			(BgL_expz00_17,
																																																			BgL_arg3434z00_1226);
																																																	}
																																																	BgL_auxz00_2847
																																																		=
																																																		(obj_t)
																																																		(BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																		(BgL_expz00_17,
																																																			BgL_stackz00_18,
																																																			BgL_locz00_19,
																																																			BgL_sitez00_20));
																																											}}}}
																																										else
																																											{	/* Ast/sexp.scm 85 */
																																												goto
																																													BgL_tagzd21955zd2_1175;
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 85 */
																																										goto
																																											BgL_tagzd21955zd2_1175;
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 85 */
																																								goto
																																									BgL_tagzd21955zd2_1175;
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						goto
																																							BgL_tagzd21955zd2_1175;
																																					}
																																			}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				goto
																																					BgL_tagzd21955zd2_1175;
																																			}
																																	}
																																else
																																	{	/* Ast/sexp.scm 85 */
																																		if (
																																			(CAR
																																				(BgL_siz00_1146)
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						17))))
																																			{	/* Ast/sexp.scm 85 */
																																				if (PAIRP(BgL_cdrzd21962zd2_1178))
																																					{	/* Ast/sexp.scm 85 */
																																						if (NULLP(CDR(BgL_cdrzd21962zd2_1178)))
																																							{	/* Ast/sexp.scm 85 */
																																								obj_t
																																									BgL_arg3417z00_1198;
																																								BgL_arg3417z00_1198
																																									=
																																									CAR
																																									(BgL_cdrzd21962zd2_1178);
																																								{	/* Ast/sexp.scm 85 */
																																									BgL_nodez00_bglt
																																										BgL_auxz00_2975;
																																									{
																																										obj_t
																																											BgL_siz00_2976;
																																										BgL_siz00_2976
																																											=
																																											BgL_arg3417z00_1198;
																																										BgL_siz00_1173
																																											=
																																											BgL_siz00_2976;
																																										goto
																																											BgL_tagzd21954zd2_1174;
																																									}
																																									BgL_auxz00_2847
																																										=
																																										(obj_t)
																																										(BgL_auxz00_2975);
																																								}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 85 */
																																								goto
																																									BgL_tagzd21955zd2_1175;
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						goto
																																							BgL_tagzd21955zd2_1175;
																																					}
																																			}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				goto
																																					BgL_tagzd21955zd2_1175;
																																			}
																																	}
																															}
																														else
																															{	/* Ast/sexp.scm 85 */
																																goto
																																	BgL_tagzd21955zd2_1175;
																															}
																													}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													BgL_nodez00_bglt
																														BgL_auxz00_2981;
																												BgL_tagzd21888zd2_1153:
																													BgL_auxz00_2981 =
																														BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																														(BGl_string3884z00zzast_sexpz00,
																														BgL_expz00_17,
																														BgL_locz00_19);
																													BgL_auxz00_2847 =
																														(obj_t)
																														(BgL_auxz00_2981);
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 85 */
																											obj_t
																												BgL_cdrzd21932zd2_1168;
																											BgL_cdrzd21932zd2_1168 =
																												CDR
																												(BgL_cdrzd21897zd2_1156);
																											if (NULLP(CDR
																													(BgL_cdrzd21932zd2_1168)))
																												{	/* Ast/sexp.scm 85 */
																													obj_t
																														BgL_arg3397z00_1170;
																													obj_t
																														BgL_arg3398z00_1171;
																													BgL_arg3397z00_1170 =
																														CAR
																														(BgL_cdrzd21897zd2_1156);
																													BgL_arg3398z00_1171 =
																														CAR
																														(BgL_cdrzd21932zd2_1168);
																													{	/* Ast/sexp.scm 85 */
																														BgL_nodez00_bglt
																															BgL_auxz00_2990;
																														BgL_siz00_1150 =
																															BgL_arg3397z00_1170;
																														BgL_alorsz00_1151 =
																															BgL_arg3398z00_1171;
																														{	/* Ast/sexp.scm 260 */
																															obj_t
																																BgL_arg3460z00_1252;
																															obj_t
																																BgL_arg3461z00_1253;
																															{	/* Ast/sexp.scm 260 */
																																obj_t
																																	BgL_pairz00_2320;
																																BgL_pairz00_2320
																																	=
																																	BgL_expz00_17;
																																BgL_arg3460z00_1252
																																	=
																																	CDR(CDR
																																	(BgL_pairz00_2320));
																															}
																															{	/* Ast/sexp.scm 260 */
																																obj_t
																																	BgL_list3462z00_1254;
																																BgL_list3462z00_1254
																																	=
																																	MAKE_PAIR
																																	(BUNSPEC,
																																	BNIL);
																																BgL_arg3461z00_1253
																																	=
																																	BgL_list3462z00_1254;
																															}
																															SET_CDR
																																(BgL_arg3460z00_1252,
																																BgL_arg3461z00_1253);
																														}
																														BgL_auxz00_2990 =
																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																															(BgL_expz00_17,
																															BgL_stackz00_18,
																															BgL_locz00_19,
																															BgL_sitez00_20);
																														BgL_auxz00_2847 =
																															(obj_t)
																															(BgL_auxz00_2990);
																													}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													BgL_nodez00_bglt
																														BgL_auxz00_2997;
																													goto
																														BgL_tagzd21888zd2_1153;
																													BgL_auxz00_2847 =
																														(obj_t)
																														(BgL_auxz00_2997);
																												}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 85 */
																									BgL_nodez00_bglt
																										BgL_auxz00_2999;
																									goto BgL_tagzd21888zd2_1153;
																									BgL_auxz00_2847 =
																										(obj_t) (BgL_auxz00_2999);
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 85 */
																							BgL_nodez00_bglt BgL_auxz00_3001;

																							goto BgL_tagzd21888zd2_1153;
																							BgL_auxz00_2847 =
																								(obj_t) (BgL_auxz00_3001);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 85 */
																					BgL_nodez00_bglt BgL_auxz00_3003;

																					goto BgL_tagzd21888zd2_1153;
																					BgL_auxz00_2847 =
																						(obj_t) (BgL_auxz00_3003);
																				}
																		}
																		return (BgL_nodez00_bglt) (BgL_auxz00_2847);
																	}
																else
																	{	/* Ast/sexp.scm 85 */
																		if (
																			(CAR(BgL_expz00_17) ==
																				CNST_TABLE_REF(((long) 12))))
																			{	/* Ast/sexp.scm 85 */
																				obj_t BgL_auxz00_3010;

																				{
																					obj_t BgL_varz00_1255;

																					obj_t BgL_valz00_1256;

																					if (PAIRP(BgL_expz00_17))
																						{	/* Ast/sexp.scm 85 */
																							obj_t BgL_cdrzd21993zd2_1261;

																							BgL_cdrzd21993zd2_1261 =
																								CDR(BgL_expz00_17);
																							if (PAIRP(BgL_cdrzd21993zd2_1261))
																								{	/* Ast/sexp.scm 85 */
																									obj_t BgL_cdrzd21997zd2_1263;

																									BgL_cdrzd21997zd2_1263 =
																										CDR(BgL_cdrzd21993zd2_1261);
																									if (PAIRP
																										(BgL_cdrzd21997zd2_1263))
																										{	/* Ast/sexp.scm 85 */
																											if (NULLP(CDR
																													(BgL_cdrzd21997zd2_1263)))
																												{	/* Ast/sexp.scm 85 */
																													BgL_varz00_1255 =
																														CAR
																														(BgL_cdrzd21993zd2_1261);
																													BgL_valz00_1256 =
																														CAR
																														(BgL_cdrzd21997zd2_1263);
																													{	/* Ast/sexp.scm 268 */
																														obj_t
																															BgL_locz00_1269;
																														BgL_locz00_1269 =
																															BGl_findzd2locationzf2locz20zztools_locationz00
																															(BgL_expz00_17,
																															BgL_locz00_19);
																														{	/* Ast/sexp.scm 268 */
																															obj_t
																																BgL_cdlocz00_1270;
																															BgL_cdlocz00_1270
																																=
																																BGl_findzd2locationzf2locz20zztools_locationz00
																																(CDR
																																(BgL_expz00_17),
																																BgL_locz00_1269);
																															{	/* Ast/sexp.scm 269 */
																																obj_t
																																	BgL_cddlocz00_1271;
																																{	/* Ast/sexp.scm 270 */
																																	obj_t
																																		BgL_arg3475z00_1281;
																																	{	/* Ast/sexp.scm 270 */
																																		obj_t
																																			BgL_pairz00_2338;
																																		BgL_pairz00_2338
																																			=
																																			BgL_expz00_17;
																																		BgL_arg3475z00_1281
																																			=
																																			CDR(CDR
																																			(BgL_pairz00_2338));
																																	}
																																	BgL_cddlocz00_1271
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(BgL_arg3475z00_1281,
																																		BgL_locz00_1269);
																																}
																																{	/* Ast/sexp.scm 270 */
																																	obj_t
																																		BgL_valzd2loczd2_1272;
																																	BgL_valzd2loczd2_1272
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(BgL_valz00_1256,
																																		BgL_cddlocz00_1271);
																																	{	/* Ast/sexp.scm 271 */
																																		BgL_nodez00_bglt
																																			BgL_valz00_1273;
																																		BgL_valz00_1273
																																			=
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																			(BgL_valz00_1256,
																																			BgL_stackz00_18,
																																			BgL_valzd2loczd2_1272,
																																			CNST_TABLE_REF
																																			(((long)
																																					1)));
																																		{	/* Ast/sexp.scm 272 */

																																			{	/* Ast/sexp.scm 273 */
																																				BgL_nodez00_bglt
																																					BgL_astz00_1274;
																																				BgL_astz00_1274
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(BgL_varz00_1255,
																																					BgL_stackz00_18,
																																					BgL_cdlocz00_1270,
																																					CNST_TABLE_REF
																																					(((long) 12)));
																																				{	/* Ast/sexp.scm 274 */
																																					bool_t
																																						BgL_testz00_3033;
																																					{	/* Ast/sexp.scm 274 */
																																						obj_t
																																							BgL_obj2064z00_2342;
																																						BgL_obj2064z00_2342
																																							=
																																							(obj_t)
																																							(BgL_astz00_1274);
																																						BgL_testz00_3033
																																							=
																																							BGl_iszd2azf3z21zz__objectz00
																																							(BgL_obj2064z00_2342,
																																							BGl_varz00zzast_nodez00);
																																					}
																																					if (BgL_testz00_3033)
																																						{	/* Ast/sexp.scm 276 */
																																							bool_t
																																								BgL_testz00_3036;
																																							{	/* Ast/sexp.scm 276 */
																																								bool_t
																																									BgL_testz00_3037;
																																								{	/* Ast/sexp.scm 276 */
																																									BgL_variablez00_bglt
																																										BgL_arg3474z00_1280;
																																									{
																																										BgL_varz00_bglt
																																											BgL_auxz00_3038;
																																										BgL_auxz00_3038
																																											=
																																											(BgL_varz00_bglt)
																																											(BgL_astz00_1274);
																																										BgL_arg3474z00_1280
																																											=
																																											(
																																											((BgL_varz00_bglt) CREF(BgL_auxz00_3038))->BgL_variablez00);
																																									}
																																									{	/* Ast/sexp.scm 276 */
																																										obj_t
																																											BgL_obj1647z00_2344;
																																										BgL_obj1647z00_2344
																																											=
																																											(obj_t)
																																											(BgL_arg3474z00_1280);
																																										BgL_testz00_3037
																																											=
																																											BGl_iszd2azf3z21zz__objectz00
																																											(BgL_obj1647z00_2344,
																																											BGl_globalz00zzast_varz00);
																																									}
																																								}
																																								if (BgL_testz00_3037)
																																									{	/* Ast/sexp.scm 277 */
																																										BgL_variablez00_bglt
																																											BgL_arg3473z00_1279;
																																										{
																																											BgL_varz00_bglt
																																												BgL_auxz00_3043;
																																											BgL_auxz00_3043
																																												=
																																												(BgL_varz00_bglt)
																																												(BgL_astz00_1274);
																																											BgL_arg3473z00_1279
																																												=
																																												(
																																												((BgL_varz00_bglt) CREF(BgL_auxz00_3043))->BgL_variablez00);
																																										}
																																										BgL_testz00_3036
																																											=
																																											BGl_globalzd2readzd2onlyzf3zf3zzast_varz00
																																											(
																																											(BgL_globalz00_bglt)
																																											(BgL_arg3473z00_1279));
																																									}
																																								else
																																									{	/* Ast/sexp.scm 276 */
																																										BgL_testz00_3036
																																											=
																																											(
																																											(bool_t)
																																											0);
																																									}
																																							}
																																							if (BgL_testz00_3036)
																																								{	/* Ast/sexp.scm 276 */
																																									BgL_auxz00_3010
																																										=
																																										(obj_t)
																																										(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																										(BGl_string3882z00zzast_sexpz00,
																																											BgL_expz00_17,
																																											BgL_cdlocz00_1270));
																																								}
																																							else
																																								{	/* Ast/sexp.scm 276 */
																																									BgL_auxz00_3010
																																										=
																																										(obj_t)
																																										(BGl_makezd2setqzd2zzast_nodez00
																																										(BgL_locz00_1269,
																																											(BgL_typez00_bglt)
																																											(BGl_za2unspecza2z00zztype_cachez00),
																																											(BgL_varz00_bglt)
																																											(BgL_astz00_1274),
																																											BgL_valz00_1273));
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 274 */
																																							BgL_auxz00_3010
																																								=
																																								(obj_t)
																																								(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																								(BGl_string3883z00zzast_sexpz00,
																																									BgL_expz00_17,
																																									BgL_locz00_1269));
																																						}
																																				}
																																			}
																																		}
																																	}
																																}
																															}
																														}
																													}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													BgL_nodez00_bglt
																														BgL_auxz00_3058;
																												BgL_tagzd21986zd2_1258:
																													BgL_auxz00_3058 =
																														BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																														(BGl_string3881z00zzast_sexpz00,
																														BgL_expz00_17,
																														BGl_findzd2locationzf2locz20zztools_locationz00
																														(BgL_expz00_17,
																															BgL_locz00_19));
																													BgL_auxz00_3010 =
																														(obj_t)
																														(BgL_auxz00_3058);
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 85 */
																											BgL_nodez00_bglt
																												BgL_auxz00_3062;
																											goto
																												BgL_tagzd21986zd2_1258;
																											BgL_auxz00_3010 =
																												(obj_t)
																												(BgL_auxz00_3062);
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 85 */
																									BgL_nodez00_bglt
																										BgL_auxz00_3064;
																									goto BgL_tagzd21986zd2_1258;
																									BgL_auxz00_3010 =
																										(obj_t) (BgL_auxz00_3064);
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 85 */
																							BgL_nodez00_bglt BgL_auxz00_3066;

																							goto BgL_tagzd21986zd2_1258;
																							BgL_auxz00_3010 =
																								(obj_t) (BgL_auxz00_3066);
																						}
																				}
																				return
																					(BgL_nodez00_bglt) (BgL_auxz00_3010);
																			}
																		else
																			{	/* Ast/sexp.scm 85 */
																				if (
																					(CAR(BgL_expz00_17) ==
																						CNST_TABLE_REF(((long) 24))))
																					{	/* Ast/sexp.scm 85 */
																						obj_t BgL_auxz00_3073;

																						{
																							obj_t BgL_varz00_1285;

																							obj_t BgL_valz00_1286;

																							if (PAIRP(BgL_expz00_17))
																								{	/* Ast/sexp.scm 85 */
																									obj_t BgL_cdrzd22011zd2_1291;

																									BgL_cdrzd22011zd2_1291 =
																										CDR(BgL_expz00_17);
																									if (PAIRP
																										(BgL_cdrzd22011zd2_1291))
																										{	/* Ast/sexp.scm 85 */
																											obj_t
																												BgL_cdrzd22015zd2_1293;
																											BgL_cdrzd22015zd2_1293 =
																												CDR
																												(BgL_cdrzd22011zd2_1291);
																											if (PAIRP
																												(BgL_cdrzd22015zd2_1293))
																												{	/* Ast/sexp.scm 85 */
																													if (NULLP(CDR
																															(BgL_cdrzd22015zd2_1293)))
																														{	/* Ast/sexp.scm 85 */
																															BgL_varz00_1285 =
																																CAR
																																(BgL_cdrzd22011zd2_1291);
																															BgL_valz00_1286 =
																																CAR
																																(BgL_cdrzd22015zd2_1293);
																															{	/* Ast/sexp.scm 299 */
																																obj_t
																																	BgL_locz00_1299;
																																BgL_locz00_1299
																																	=
																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																	(BgL_expz00_17,
																																	BgL_locz00_19);
																																{	/* Ast/sexp.scm 299 */
																																	obj_t
																																		BgL_cdlocz00_1300;
																																	BgL_cdlocz00_1300
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(CDR
																																		(BgL_expz00_17),
																																		BgL_locz00_1299);
																																	{	/* Ast/sexp.scm 300 */
																																		obj_t
																																			BgL_cddlocz00_1301;
																																		{	/* Ast/sexp.scm 301 */
																																			obj_t
																																				BgL_arg3491z00_1309;
																																			{	/* Ast/sexp.scm 301 */
																																				obj_t
																																					BgL_pairz00_2356;
																																				BgL_pairz00_2356
																																					=
																																					BgL_expz00_17;
																																				BgL_arg3491z00_1309
																																					=
																																					CDR
																																					(CDR
																																					(BgL_pairz00_2356));
																																			}
																																			BgL_cddlocz00_1301
																																				=
																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																				(BgL_arg3491z00_1309,
																																				BgL_locz00_1299);
																																		}
																																		{	/* Ast/sexp.scm 301 */
																																			obj_t
																																				BgL_valzd2loczd2_1302;
																																			BgL_valzd2loczd2_1302
																																				=
																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																				(BgL_valz00_1286,
																																				BgL_cddlocz00_1301);
																																			{	/* Ast/sexp.scm 302 */
																																				BgL_nodez00_bglt
																																					BgL_valz00_1303;
																																				BgL_valz00_1303
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(BgL_valz00_1286,
																																					BgL_stackz00_18,
																																					BgL_valzd2loczd2_1302,
																																					CNST_TABLE_REF
																																					(((long) 1)));
																																				{	/* Ast/sexp.scm 303 */

																																					{	/* Ast/sexp.scm 304 */
																																						BgL_nodez00_bglt
																																							BgL_astz00_1304;
																																						BgL_astz00_1304
																																							=
																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																							(BgL_varz00_1285,
																																							BgL_stackz00_18,
																																							BgL_cdlocz00_1300,
																																							CNST_TABLE_REF
																																							(((long) 1)));
																																						{	/* Ast/sexp.scm 305 */
																																							bool_t
																																								BgL_testz00_3096;
																																							{	/* Ast/sexp.scm 305 */
																																								bool_t
																																									BgL_testz00_3097;
																																								{	/* Ast/sexp.scm 305 */
																																									obj_t
																																										BgL_obj2064z00_2360;
																																									BgL_obj2064z00_2360
																																										=
																																										(obj_t)
																																										(BgL_astz00_1304);
																																									BgL_testz00_3097
																																										=
																																										BGl_iszd2azf3z21zz__objectz00
																																										(BgL_obj2064z00_2360,
																																										BGl_varz00zzast_nodez00);
																																								}
																																								if (BgL_testz00_3097)
																																									{	/* Ast/sexp.scm 305 */
																																										BgL_variablez00_bglt
																																											BgL_arg3490z00_1308;
																																										{
																																											BgL_varz00_bglt
																																												BgL_auxz00_3100;
																																											BgL_auxz00_3100
																																												=
																																												(BgL_varz00_bglt)
																																												(BgL_astz00_1304);
																																											BgL_arg3490z00_1308
																																												=
																																												(
																																												((BgL_varz00_bglt) CREF(BgL_auxz00_3100))->BgL_variablez00);
																																										}
																																										{	/* Ast/sexp.scm 305 */
																																											obj_t
																																												BgL_obj1647z00_2362;
																																											BgL_obj1647z00_2362
																																												=
																																												(obj_t)
																																												(BgL_arg3490z00_1308);
																																											BgL_testz00_3096
																																												=
																																												BGl_iszd2azf3z21zz__objectz00
																																												(BgL_obj1647z00_2362,
																																												BGl_globalz00zzast_varz00);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 305 */
																																										BgL_testz00_3096
																																											=
																																											(
																																											(bool_t)
																																											0);
																																									}
																																							}
																																							if (BgL_testz00_3096)
																																								{	/* Ast/sexp.scm 305 */
																																									{	/* Ast/sexp.scm 307 */
																																										BgL_variablez00_bglt
																																											BgL_arg3488z00_1306;
																																										{
																																											BgL_varz00_bglt
																																												BgL_auxz00_3105;
																																											BgL_auxz00_3105
																																												=
																																												(BgL_varz00_bglt)
																																												(BgL_astz00_1304);
																																											BgL_arg3488z00_1306
																																												=
																																												(
																																												((BgL_varz00_bglt) CREF(BgL_auxz00_3105))->BgL_variablez00);
																																										}
																																										{
																																											obj_t
																																												BgL_auxz00_3110;
																																											BgL_globalz00_bglt
																																												BgL_auxz00_3108;
																																											BgL_auxz00_3110
																																												=
																																												(obj_t)
																																												(BgL_valz00_1303);
																																											BgL_auxz00_3108
																																												=
																																												(BgL_globalz00_bglt)
																																												(BgL_arg3488z00_1306);
																																											((((BgL_globalz00_bglt) CREF(BgL_auxz00_3108))->BgL_srcz00) = ((obj_t) BgL_auxz00_3110), BUNSPEC);
																																										}
																																									}
																																									BgL_auxz00_3073
																																										=
																																										(obj_t)
																																										(BGl_makezd2setqzd2zzast_nodez00
																																										(BgL_locz00_1299,
																																											(BgL_typez00_bglt)
																																											(BGl_za2unspecza2z00zztype_cachez00),
																																											(BgL_varz00_bglt)
																																											(BgL_astz00_1304),
																																											BgL_valz00_1303));
																																								}
																																							else
																																								{	/* Ast/sexp.scm 305 */
																																									BgL_auxz00_3073
																																										=
																																										(obj_t)
																																										(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																										(BGl_string3880z00zzast_sexpz00,
																																											BgL_expz00_17,
																																											BgL_locz00_1299));
																																								}
																																						}
																																					}
																																				}
																																			}
																																		}
																																	}
																																}
																															}
																														}
																													else
																														{	/* Ast/sexp.scm 85 */
																															BgL_nodez00_bglt
																																BgL_auxz00_3121;
																														BgL_tagzd22004zd2_1288:
																															BgL_auxz00_3121 =
																																BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																(BGl_string3879z00zzast_sexpz00,
																																BgL_expz00_17,
																																BGl_findzd2locationzf2locz20zztools_locationz00
																																(BgL_expz00_17,
																																	BgL_locz00_19));
																															BgL_auxz00_3073 =
																																(obj_t)
																																(BgL_auxz00_3121);
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													BgL_nodez00_bglt
																														BgL_auxz00_3125;
																													goto
																														BgL_tagzd22004zd2_1288;
																													BgL_auxz00_3073 =
																														(obj_t)
																														(BgL_auxz00_3125);
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 85 */
																											BgL_nodez00_bglt
																												BgL_auxz00_3127;
																											goto
																												BgL_tagzd22004zd2_1288;
																											BgL_auxz00_3073 =
																												(obj_t)
																												(BgL_auxz00_3127);
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 85 */
																									BgL_nodez00_bglt
																										BgL_auxz00_3129;
																									goto BgL_tagzd22004zd2_1288;
																									BgL_auxz00_3073 =
																										(obj_t) (BgL_auxz00_3129);
																								}
																						}
																						return
																							(BgL_nodez00_bglt)
																							(BgL_auxz00_3073);
																					}
																				else
																					{	/* Ast/sexp.scm 85 */
																						obj_t BgL_carzd21563zd2_913;

																						BgL_carzd21563zd2_913 =
																							CAR(BgL_expz00_17);
																						if (PAIRP(BgL_carzd21563zd2_913))
																							{	/* Ast/sexp.scm 85 */
																								obj_t BgL_carzd21566zd2_915;

																								obj_t BgL_cdrzd21567zd2_916;

																								BgL_carzd21566zd2_915 =
																									CAR(BgL_carzd21563zd2_913);
																								BgL_cdrzd21567zd2_916 =
																									CDR(BgL_carzd21563zd2_913);
																								{

																									if (
																										(BgL_carzd21566zd2_915 ==
																											CNST_TABLE_REF(((long)
																													11))))
																										{	/* Ast/sexp.scm 85 */
																											obj_t BgL_auxz00_3140;

																										BgL_kapzd21568zd2_917:
																											if (PAIRP
																												(BgL_cdrzd21567zd2_916))
																												{	/* Ast/sexp.scm 85 */
																													obj_t
																														BgL_cdrzd21571zd2_934;
																													BgL_cdrzd21571zd2_934
																														=
																														CDR
																														(BgL_cdrzd21567zd2_916);
																													if (PAIRP
																														(BgL_cdrzd21571zd2_934))
																														{	/* Ast/sexp.scm 85 */
																															if (NULLP(CDR
																																	(BgL_cdrzd21571zd2_934)))
																																{	/* Ast/sexp.scm 85 */
																																	obj_t
																																		BgL_arg3207z00_937;
																																	obj_t
																																		BgL_arg3208z00_938;
																																	BgL_arg3207z00_937
																																		=
																																		CAR
																																		(BgL_cdrzd21571zd2_934);
																																	BgL_arg3208z00_938
																																		=
																																		CDR
																																		(BgL_expz00_17);
																																	{	/* Ast/sexp.scm 85 */
																																		BgL_nodez00_bglt
																																			BgL_auxz00_3151;
																																		BgL_bodyz00_876
																																			=
																																			BgL_arg3207z00_937;
																																		BgL_argsz00_877
																																			=
																																			BgL_arg3208z00_938;
																																		{	/* Ast/sexp.scm 322 */
																																			obj_t
																																				BgL_letzd2partzd2_1313;
																																			BgL_letzd2partzd2_1313
																																				=
																																				CAR
																																				(BgL_expz00_17);
																																			{	/* Ast/sexp.scm 322 */
																																				obj_t
																																					BgL_nexpz00_1314;
																																				{	/* Ast/sexp.scm 323 */
																																					obj_t
																																						BgL_arg3495z00_1315;
																																					obj_t
																																						BgL_arg3499z00_1316;
																																					BgL_arg3495z00_1315
																																						=
																																						CAR
																																						(BgL_letzd2partzd2_1313);
																																					{	/* Ast/sexp.scm 323 */
																																						obj_t
																																							BgL_arg3500z00_1317;
																																						obj_t
																																							BgL_arg3501z00_1318;
																																						{	/* Ast/sexp.scm 323 */
																																							obj_t
																																								BgL_pairz00_2368;
																																							BgL_pairz00_2368
																																								=
																																								BgL_letzd2partzd2_1313;
																																							BgL_arg3500z00_1317
																																								=
																																								CAR
																																								(CDR
																																								(BgL_pairz00_2368));
																																						}
																																						BgL_arg3501z00_1318
																																							=
																																							MAKE_PAIR
																																							(BgL_bodyz00_876,
																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																							(BgL_argsz00_877,
																																								BNIL));
																																						{	/* Ast/sexp.scm 323 */
																																							obj_t
																																								BgL_list3503z00_1320;
																																							{	/* Ast/sexp.scm 323 */
																																								obj_t
																																									BgL_arg3504z00_1321;
																																								BgL_arg3504z00_1321
																																									=
																																									MAKE_PAIR
																																									(BNIL,
																																									BNIL);
																																								BgL_list3503z00_1320
																																									=
																																									MAKE_PAIR
																																									(BgL_arg3501z00_1318,
																																									BgL_arg3504z00_1321);
																																							}
																																							BgL_arg3499z00_1316
																																								=
																																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																								(BgL_arg3500z00_1317,
																																								BgL_list3503z00_1320);
																																						}
																																					}
																																					BgL_nexpz00_1314
																																						=
																																						MAKE_PAIR
																																						(BgL_arg3495z00_1315,
																																						BgL_arg3499z00_1316);
																																				}
																																				{	/* Ast/sexp.scm 323 */

																																					BgL_auxz00_3151
																																						=
																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																						(BgL_nexpz00_1314,
																																						BgL_stackz00_18,
																																						BgL_locz00_19,
																																						BgL_sitez00_20);
																																				}
																																			}
																																		}
																																		BgL_auxz00_3140
																																			=
																																			(obj_t)
																																			(BgL_auxz00_3151);
																																	}
																																}
																															else
																																{	/* Ast/sexp.scm 85 */
																																	obj_t
																																		BgL_carzd21598zd2_939;
																																	BgL_carzd21598zd2_939
																																		=
																																		CAR
																																		(BgL_expz00_17);
																																	{	/* Ast/sexp.scm 85 */
																																		obj_t
																																			BgL_cdrzd21603zd2_940;
																																		BgL_cdrzd21603zd2_940
																																			=
																																			CDR
																																			(BgL_carzd21598zd2_939);
																																		if ((CAR
																																				(BgL_carzd21598zd2_939)
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						8))))
																																			{	/* Ast/sexp.scm 85 */
																																				obj_t
																																					BgL_arg3212z00_942;
																																				obj_t
																																					BgL_arg3213z00_943;
																																				obj_t
																																					BgL_arg3214z00_944;
																																				BgL_arg3212z00_942
																																					=
																																					CAR
																																					(BgL_cdrzd21603zd2_940);
																																				BgL_arg3213z00_943
																																					=
																																					CDR
																																					(BgL_cdrzd21603zd2_940);
																																				BgL_arg3214z00_944
																																					=
																																					CDR
																																					(BgL_expz00_17);
																																				{	/* Ast/sexp.scm 85 */
																																					BgL_nodez00_bglt
																																						BgL_auxz00_3173;
																																					BgL_varsz00_881
																																						=
																																						BgL_arg3212z00_942;
																																					BgL_bodyz00_882
																																						=
																																						BgL_arg3213z00_943;
																																					BgL_argsz00_883
																																						=
																																						BgL_arg3214z00_944;
																																				BgL_tagzd21475zd2_884:
																																					{	/* Ast/sexp.scm 333 */
																																						obj_t
																																							BgL_locz00_1323;
																																						BgL_locz00_1323
																																							=
																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																							(BgL_expz00_17,
																																							BgL_locz00_19);
																																						{	/* Ast/sexp.scm 334 */
																																							obj_t
																																								BgL_arg3506z00_1324;
																																							{	/* Ast/sexp.scm 334 */
																																								obj_t
																																									BgL_arg3507z00_1325;
																																								obj_t
																																									BgL_arg3509z00_1326;
																																								BgL_arg3507z00_1325
																																									=
																																									CNST_TABLE_REF
																																									(
																																									((long) 11));
																																								{	/* Ast/sexp.scm 334 */
																																									obj_t
																																										BgL_arg3510z00_1327;
																																									obj_t
																																										BgL_arg3511z00_1328;
																																									BgL_arg3510z00_1327
																																										=
																																										BGl_loopz00zzast_sexpz00
																																										(BgL_expz00_17,
																																										BgL_locz00_1323,
																																										BgL_varsz00_881,
																																										BgL_argsz00_883);
																																									{	/* Ast/sexp.scm 376 */
																																										obj_t
																																											BgL_arg3559z00_1381;
																																										obj_t
																																											BgL_arg3560z00_1382;
																																										BgL_arg3559z00_1381
																																											=
																																											BGl_shapez00zztools_shapez00
																																											(BGl_currentzd2functionzd2zztools_errorz00
																																											());
																																										BgL_arg3560z00_1382
																																											=
																																											BGl_normaliza7ezd2prognz75zztools_prognz00
																																											(BgL_bodyz00_882);
																																										{	/* Ast/sexp.scm 380 */
																																											obj_t
																																												BgL_zc3anonymousza33563ze3z83_2556;
																																											BgL_zc3anonymousza33563ze3z83_2556
																																												=
																																												make_fx_procedure
																																												(BGl_zc3anonymousza33563ze3z83zzast_sexpz00,
																																												(int)
																																												(((long) 3)), (int) (((long) 1)));
																																											PROCEDURE_SET
																																												(BgL_zc3anonymousza33563ze3z83_2556,
																																												(int)
																																												(((long) 0)), BgL_locz00_1323);
																																											BgL_arg3511z00_1328
																																												=
																																												BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
																																												(BgL_arg3559z00_1381,
																																												BgL_varsz00_881,
																																												BgL_arg3560z00_1382,
																																												BgL_zc3anonymousza33563ze3z83_2556);
																																									}}
																																									{	/* Ast/sexp.scm 334 */
																																										obj_t
																																											BgL_list3513z00_1330;
																																										{	/* Ast/sexp.scm 334 */
																																											obj_t
																																												BgL_arg3514z00_1331;
																																											BgL_arg3514z00_1331
																																												=
																																												MAKE_PAIR
																																												(BNIL,
																																												BNIL);
																																											BgL_list3513z00_1330
																																												=
																																												MAKE_PAIR
																																												(BgL_arg3511z00_1328,
																																												BgL_arg3514z00_1331);
																																										}
																																										BgL_arg3509z00_1326
																																											=
																																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																											(BgL_arg3510z00_1327,
																																											BgL_list3513z00_1330);
																																								}}
																																								BgL_arg3506z00_1324
																																									=
																																									MAKE_PAIR
																																									(BgL_arg3507z00_1325,
																																									BgL_arg3509z00_1326);
																																							}
																																							BgL_auxz00_3173
																																								=
																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																								(BgL_arg3506z00_1324,
																																								BgL_stackz00_18,
																																								BgL_locz00_1323,
																																								BgL_sitez00_20);
																																					}}
																																					BgL_auxz00_3140
																																						=
																																						(obj_t)
																																						(BgL_auxz00_3173);
																																			}}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																					{	/* Ast/sexp.scm 85 */
																																					BgL_tagzd21487zd2_900:
																																						BgL_auxz00_3140 = BGl_privatezd2ze3nodez31zzast_privatez00(BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						BgL_nodez00_bglt
																																							BgL_auxz00_3195;
																																					BgL_tagzd21488zd2_901:
																																						{	/* Ast/sexp.scm 505 */
																																							obj_t
																																								BgL_callerz00_1513;
																																							obj_t
																																								BgL_locz00_1514;
																																							BgL_callerz00_1513
																																								=
																																								CAR
																																								(BgL_expz00_17);
																																							BgL_locz00_1514
																																								=
																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																								(BgL_expz00_17,
																																								BgL_locz00_19);
																																							if (SYMBOLP(BgL_callerz00_1513))
																																								{	/* Ast/sexp.scm 509 */
																																									obj_t
																																										BgL_pidz00_1516;
																																									BgL_pidz00_1516
																																										=
																																										BGl_parsezd2idzd2zzast_identz00
																																										(BgL_callerz00_1513,
																																										BgL_locz00_1514);
																																									{	/* Ast/sexp.scm 509 */
																																										obj_t
																																											BgL_idz00_1517;
																																										BgL_idz00_1517
																																											=
																																											CAR
																																											(BgL_pidz00_1516);
																																										{	/* Ast/sexp.scm 510 */
																																											obj_t
																																												BgL_typez00_1518;
																																											BgL_typez00_1518
																																												=
																																												CDR
																																												(BgL_pidz00_1516);
																																											{	/* Ast/sexp.scm 511 */

																																												if ((BgL_idz00_1517 == CNST_TABLE_REF(((long) 2))))
																																													{	/* Ast/sexp.scm 512 */
																																														BgL_auxz00_3195
																																															=
																																															BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																															(
																																															((bool_t) 0), BFALSE, (BgL_typez00_bglt) (BgL_typez00_1518), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_1514, BgL_sitez00_20);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 512 */
																																														if ((BgL_idz00_1517 == CNST_TABLE_REF(((long) 3))))
																																															{	/* Ast/sexp.scm 516 */
																																																bool_t
																																																	BgL_testz00_3211;
																																																{	/* Ast/sexp.scm 516 */
																																																	obj_t
																																																		BgL_auxz00_3212;
																																																	BgL_auxz00_3212
																																																		=
																																																		CDR
																																																		(BgL_expz00_17);
																																																	BgL_testz00_3211
																																																		=
																																																		PAIRP
																																																		(BgL_auxz00_3212);
																																																}
																																																if (BgL_testz00_3211)
																																																	{	/* Ast/sexp.scm 520 */
																																																		BgL_feffectz00_bglt
																																																			BgL_arg3649z00_1523;
																																																		obj_t
																																																			BgL_arg3650z00_1524;
																																																		{	/* Ast/sexp.scm 520 */
																																																			obj_t
																																																				BgL_arg3651z00_1525;
																																																			{	/* Ast/sexp.scm 520 */
																																																				obj_t
																																																					BgL_pairz00_2450;
																																																				BgL_pairz00_2450
																																																					=
																																																					BgL_expz00_17;
																																																				BgL_arg3651z00_1525
																																																					=
																																																					CAR
																																																					(CDR
																																																					(BgL_pairz00_2450));
																																																			}
																																																			BgL_arg3649z00_1523
																																																				=
																																																				BGl_parsezd2effectzd2zzeffect_feffectz00
																																																				(BgL_arg3651z00_1525);
																																																		}
																																																		{	/* Ast/sexp.scm 521 */
																																																			obj_t
																																																				BgL_arg3652z00_1526;
																																																			obj_t
																																																				BgL_arg3653z00_1527;
																																																			{	/* Ast/sexp.scm 521 */
																																																				obj_t
																																																					BgL_arg3654z00_1528;
																																																				obj_t
																																																					BgL_arg3655z00_1529;
																																																				BgL_arg3654z00_1528
																																																					=
																																																					CNST_TABLE_REF
																																																					(
																																																					((long) 4));
																																																				{	/* Ast/sexp.scm 521 */
																																																					obj_t
																																																						BgL_list3656z00_1530;
																																																					BgL_list3656z00_1530
																																																						=
																																																						MAKE_PAIR
																																																						(BNIL,
																																																						BNIL);
																																																					BgL_arg3655z00_1529
																																																						=
																																																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																						(CNST_TABLE_REF
																																																						(((long) 5)), BgL_list3656z00_1530);
																																																				}
																																																				BgL_arg3652z00_1526
																																																					=
																																																					MAKE_PAIR
																																																					(BgL_arg3654z00_1528,
																																																					BgL_arg3655z00_1529);
																																																			}
																																																			{	/* Ast/sexp.scm 521 */
																																																				obj_t
																																																					BgL_auxz00_3223;
																																																				{	/* Ast/sexp.scm 521 */
																																																					obj_t
																																																						BgL_pairz00_2454;
																																																					BgL_pairz00_2454
																																																						=
																																																						BgL_expz00_17;
																																																					BgL_auxz00_3223
																																																						=
																																																						CDR
																																																						(CDR
																																																						(BgL_pairz00_2454));
																																																				}
																																																				BgL_arg3653z00_1527
																																																					=
																																																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																					(BgL_auxz00_3223,
																																																					BNIL);
																																																			}
																																																			BgL_arg3650z00_1524
																																																				=
																																																				MAKE_PAIR
																																																				(BgL_arg3652z00_1526,
																																																				BgL_arg3653z00_1527);
																																																		}
																																																		BgL_auxz00_3195
																																																			=
																																																			BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																			(
																																																			((bool_t) 0), (obj_t) (BgL_arg3649z00_1523), (BgL_typez00_bglt) (BgL_typez00_1518), BgL_arg3650z00_1524, BgL_stackz00_18, BgL_locz00_1514, BgL_sitez00_20);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 516 */
																																																		BgL_auxz00_3195
																																																			=
																																																			BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																			(BGl_string3873z00zzast_sexpz00,
																																																			BgL_expz00_17,
																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																			(BgL_expz00_17,
																																																				BgL_locz00_1514));
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 512 */
																																																if ((BgL_idz00_1517 == CNST_TABLE_REF(((long) 6))))
																																																	{	/* Ast/sexp.scm 512 */
																																																		BgL_auxz00_3195
																																																			=
																																																			BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																			(
																																																			((bool_t) 1), BFALSE, (BgL_typez00_bglt) (BgL_typez00_1518), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_1514, BgL_sitez00_20);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 512 */
																																																		if ((BgL_idz00_1517 == CNST_TABLE_REF(((long) 7))))
																																																			{	/* Ast/sexp.scm 526 */
																																																				bool_t
																																																					BgL_testz00_3241;
																																																				{	/* Ast/sexp.scm 526 */
																																																					obj_t
																																																						BgL_auxz00_3242;
																																																					BgL_auxz00_3242
																																																						=
																																																						CDR
																																																						(BgL_expz00_17);
																																																					BgL_testz00_3241
																																																						=
																																																						PAIRP
																																																						(BgL_auxz00_3242);
																																																				}
																																																				if (BgL_testz00_3241)
																																																					{	/* Ast/sexp.scm 530 */
																																																						BgL_feffectz00_bglt
																																																							BgL_arg3665z00_1539;
																																																						obj_t
																																																							BgL_arg3666z00_1540;
																																																						{	/* Ast/sexp.scm 530 */
																																																							obj_t
																																																								BgL_arg3667z00_1541;
																																																							{	/* Ast/sexp.scm 530 */
																																																								obj_t
																																																									BgL_pairz00_2464;
																																																								BgL_pairz00_2464
																																																									=
																																																									BgL_expz00_17;
																																																								BgL_arg3667z00_1541
																																																									=
																																																									CAR
																																																									(CDR
																																																									(BgL_pairz00_2464));
																																																							}
																																																							BgL_arg3665z00_1539
																																																								=
																																																								BGl_parsezd2effectzd2zzeffect_feffectz00
																																																								(BgL_arg3667z00_1541);
																																																						}
																																																						{	/* Ast/sexp.scm 531 */
																																																							obj_t
																																																								BgL_arg3668z00_1542;
																																																							obj_t
																																																								BgL_arg3669z00_1543;
																																																							{	/* Ast/sexp.scm 531 */
																																																								obj_t
																																																									BgL_arg3670z00_1544;
																																																								obj_t
																																																									BgL_arg3671z00_1545;
																																																								BgL_arg3670z00_1544
																																																									=
																																																									CNST_TABLE_REF
																																																									(
																																																									((long) 4));
																																																								{	/* Ast/sexp.scm 531 */
																																																									obj_t
																																																										BgL_list3672z00_1546;
																																																									BgL_list3672z00_1546
																																																										=
																																																										MAKE_PAIR
																																																										(BNIL,
																																																										BNIL);
																																																									BgL_arg3671z00_1545
																																																										=
																																																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																										(CNST_TABLE_REF
																																																										(((long) 5)), BgL_list3672z00_1546);
																																																								}
																																																								BgL_arg3668z00_1542
																																																									=
																																																									MAKE_PAIR
																																																									(BgL_arg3670z00_1544,
																																																									BgL_arg3671z00_1545);
																																																							}
																																																							{	/* Ast/sexp.scm 531 */
																																																								obj_t
																																																									BgL_auxz00_3253;
																																																								{	/* Ast/sexp.scm 531 */
																																																									obj_t
																																																										BgL_pairz00_2468;
																																																									BgL_pairz00_2468
																																																										=
																																																										BgL_expz00_17;
																																																									BgL_auxz00_3253
																																																										=
																																																										CDR
																																																										(CDR
																																																										(BgL_pairz00_2468));
																																																								}
																																																								BgL_arg3669z00_1543
																																																									=
																																																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																									(BgL_auxz00_3253,
																																																									BNIL);
																																																							}
																																																							BgL_arg3666z00_1540
																																																								=
																																																								MAKE_PAIR
																																																								(BgL_arg3668z00_1542,
																																																								BgL_arg3669z00_1543);
																																																						}
																																																						BgL_auxz00_3195
																																																							=
																																																							BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																							(
																																																							((bool_t) 1), (obj_t) (BgL_arg3665z00_1539), (BgL_typez00_bglt) (BgL_typez00_1518), BgL_arg3666z00_1540, BgL_stackz00_18, BgL_locz00_1514, BgL_sitez00_20);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 526 */
																																																						BgL_auxz00_3195
																																																							=
																																																							BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																							(BGl_string3874z00zzast_sexpz00,
																																																							BgL_expz00_17,
																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																							(BgL_expz00_17,
																																																								BgL_locz00_1514));
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 512 */
																																																				if ((BgL_idz00_1517 == CNST_TABLE_REF(((long) 8))))
																																																					{
																																																						obj_t
																																																							BgL_argsz00_1553;
																																																						obj_t
																																																							BgL_bodyz00_1554;
																																																						if (PAIRP(BgL_expz00_17))
																																																							{	/* Ast/sexp.scm 534 */
																																																								obj_t
																																																									BgL_cdrzd22085zd2_1559;
																																																								BgL_cdrzd22085zd2_1559
																																																									=
																																																									CDR
																																																									(BgL_expz00_17);
																																																								if (PAIRP(BgL_cdrzd22085zd2_1559))
																																																									{	/* Ast/sexp.scm 534 */
																																																										BgL_argsz00_1553
																																																											=
																																																											CAR
																																																											(BgL_cdrzd22085zd2_1559);
																																																										BgL_bodyz00_1554
																																																											=
																																																											CDR
																																																											(BgL_cdrzd22085zd2_1559);
																																																										{	/* Ast/sexp.scm 536 */
																																																											obj_t
																																																												BgL_locz00_1563;
																																																											BgL_locz00_1563
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_expz00_17,
																																																												BgL_locz00_1514);
																																																											{	/* Ast/sexp.scm 536 */
																																																												obj_t
																																																													BgL_funz00_1564;
																																																												BgL_funz00_1564
																																																													=
																																																													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																													(BGl_gensymz00zz__r4_symbols_6_4z00
																																																													(CNST_TABLE_REF
																																																														(((long) 8))));
																																																												{	/* Ast/sexp.scm 537 */
																																																													obj_t
																																																														BgL_tfunz00_1565;
																																																													{	/* Ast/sexp.scm 538 */
																																																														obj_t
																																																															BgL_arg3697z00_1580;
																																																														{
																																																															BgL_typez00_bglt
																																																																BgL_auxz00_3275;
																																																															BgL_auxz00_3275
																																																																=
																																																																(BgL_typez00_bglt)
																																																																(BgL_typez00_1518);
																																																															BgL_arg3697z00_1580
																																																																=
																																																																(
																																																																((BgL_typez00_bglt) CREF(BgL_auxz00_3275))->BgL_idz00);
																																																														}
																																																														BgL_tfunz00_1565
																																																															=
																																																															BGl_makezd2typedzd2identz00zzast_identz00
																																																															(BgL_funz00_1564,
																																																															BgL_arg3697z00_1580);
																																																													}
																																																													{	/* Ast/sexp.scm 538 */

																																																														{	/* Ast/sexp.scm 540 */
																																																															obj_t
																																																																BgL_arg3683z00_1566;
																																																															{	/* Ast/sexp.scm 540 */
																																																																obj_t
																																																																	BgL_arg3684z00_1567;
																																																																obj_t
																																																																	BgL_arg3685z00_1568;
																																																																BgL_arg3684z00_1567
																																																																	=
																																																																	CNST_TABLE_REF
																																																																	(
																																																																	((long) 9));
																																																																{	/* Ast/sexp.scm 540 */
																																																																	obj_t
																																																																		BgL_arg3686z00_1569;
																																																																	{	/* Ast/sexp.scm 540 */
																																																																		obj_t
																																																																			BgL_arg3690z00_1573;
																																																																		{	/* Ast/sexp.scm 540 */
																																																																			obj_t
																																																																				BgL_arg3692z00_1575;
																																																																			{	/* Ast/sexp.scm 540 */
																																																																				obj_t
																																																																					BgL_arg3693z00_1576;
																																																																				BgL_arg3693z00_1576
																																																																					=
																																																																					BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																					(BgL_bodyz00_1554);
																																																																				{	/* Ast/sexp.scm 540 */
																																																																					obj_t
																																																																						BgL_list3695z00_1578;
																																																																					{	/* Ast/sexp.scm 540 */
																																																																						obj_t
																																																																							BgL_arg3696z00_1579;
																																																																						BgL_arg3696z00_1579
																																																																							=
																																																																							MAKE_PAIR
																																																																							(BNIL,
																																																																							BNIL);
																																																																						BgL_list3695z00_1578
																																																																							=
																																																																							MAKE_PAIR
																																																																							(BgL_arg3693z00_1576,
																																																																							BgL_arg3696z00_1579);
																																																																					}
																																																																					BgL_arg3692z00_1575
																																																																						=
																																																																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																																						(BgL_argsz00_1553,
																																																																						BgL_list3695z00_1578);
																																																																			}}
																																																																			BgL_arg3690z00_1573
																																																																				=
																																																																				MAKE_PAIR
																																																																				(BgL_tfunz00_1565,
																																																																				BgL_arg3692z00_1575);
																																																																		}
																																																																		BgL_arg3686z00_1569
																																																																			=
																																																																			MAKE_PAIR
																																																																			(BgL_arg3690z00_1573,
																																																																			BNIL);
																																																																	}
																																																																	{	/* Ast/sexp.scm 540 */
																																																																		obj_t
																																																																			BgL_list3688z00_1571;
																																																																		{	/* Ast/sexp.scm 540 */
																																																																			obj_t
																																																																				BgL_arg3689z00_1572;
																																																																			BgL_arg3689z00_1572
																																																																				=
																																																																				MAKE_PAIR
																																																																				(BNIL,
																																																																				BNIL);
																																																																			BgL_list3688z00_1571
																																																																				=
																																																																				MAKE_PAIR
																																																																				(BgL_funz00_1564,
																																																																				BgL_arg3689z00_1572);
																																																																		}
																																																																		BgL_arg3685z00_1568
																																																																			=
																																																																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																																																			(BgL_arg3686z00_1569,
																																																																			BgL_list3688z00_1571);
																																																																}}
																																																																BgL_arg3683z00_1566
																																																																	=
																																																																	MAKE_PAIR
																																																																	(BgL_arg3684z00_1567,
																																																																	BgL_arg3685z00_1568);
																																																															}
																																																															BgL_auxz00_3195
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_arg3683z00_1566,
																																																																BgL_stackz00_18,
																																																																BgL_locz00_1563,
																																																																BgL_sitez00_20);
																																																									}}}}}}
																																																								else
																																																									{	/* Ast/sexp.scm 534 */
																																																									BgL_tagzd22078zd2_1556:
																																																										BgL_auxz00_3195 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string3875z00zzast_sexpz00, BgL_expz00_17, BgL_locz00_1514);
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 534 */
																																																								goto
																																																									BgL_tagzd22078zd2_1556;
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 512 */
																																																						BgL_auxz00_3195
																																																							=
																																																							BGl_applicationzd2ze3nodez31zzast_appz00
																																																							(BgL_expz00_17,
																																																							BgL_stackz00_18,
																																																							BgL_locz00_1514,
																																																							BgL_sitez00_20);
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 507 */
																																									BgL_auxz00_3195
																																										=
																																										BGl_applicationzd2ze3nodez31zzast_appz00
																																										(BgL_expz00_17,
																																										BgL_stackz00_18,
																																										BgL_locz00_1514,
																																										BgL_sitez00_20);
																																								}
																																						}
																																						BgL_auxz00_3140
																																							=
																																							(obj_t)
																																							(BgL_auxz00_3195);
																																					}
																																			}
																																	}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 85 */
																															obj_t
																																BgL_carzd21646zd2_949;
																															BgL_carzd21646zd2_949
																																=
																																CAR
																																(BgL_expz00_17);
																															{	/* Ast/sexp.scm 85 */
																																obj_t
																																	BgL_cdrzd21651zd2_950;
																																BgL_cdrzd21651zd2_950
																																	=
																																	CDR
																																	(BgL_carzd21646zd2_949);
																																if ((CAR
																																		(BgL_carzd21646zd2_949)
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				8))))
																																	{	/* Ast/sexp.scm 85 */
																																		obj_t
																																			BgL_arg3220z00_952;
																																		obj_t
																																			BgL_arg3221z00_953;
																																		obj_t
																																			BgL_arg3222z00_954;
																																		BgL_arg3220z00_952
																																			=
																																			CAR
																																			(BgL_cdrzd21651zd2_950);
																																		BgL_arg3221z00_953
																																			=
																																			CDR
																																			(BgL_cdrzd21651zd2_950);
																																		BgL_arg3222z00_954
																																			=
																																			CDR
																																			(BgL_expz00_17);
																																		{	/* Ast/sexp.scm 85 */
																																			BgL_nodez00_bglt
																																				BgL_auxz00_3306;
																																			{
																																				obj_t
																																					BgL_argsz00_3309;
																																				obj_t
																																					BgL_bodyz00_3308;
																																				obj_t
																																					BgL_varsz00_3307;
																																				BgL_varsz00_3307
																																					=
																																					BgL_arg3220z00_952;
																																				BgL_bodyz00_3308
																																					=
																																					BgL_arg3221z00_953;
																																				BgL_argsz00_3309
																																					=
																																					BgL_arg3222z00_954;
																																				BgL_argsz00_883
																																					=
																																					BgL_argsz00_3309;
																																				BgL_bodyz00_882
																																					=
																																					BgL_bodyz00_3308;
																																				BgL_varsz00_881
																																					=
																																					BgL_varsz00_3307;
																																				goto
																																					BgL_tagzd21475zd2_884;
																																			}
																																			BgL_auxz00_3140
																																				=
																																				(obj_t)
																																				(BgL_auxz00_3306);
																																		}
																																	}
																																else
																																	{	/* Ast/sexp.scm 85 */
																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																			{	/* Ast/sexp.scm 85 */
																																				goto
																																					BgL_tagzd21487zd2_900;
																																			}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				BgL_nodez00_bglt
																																					BgL_auxz00_3313;
																																				goto
																																					BgL_tagzd21488zd2_901;
																																				BgL_auxz00_3140
																																					=
																																					(obj_t)
																																					(BgL_auxz00_3313);
																																			}
																																	}
																															}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																														{	/* Ast/sexp.scm 85 */
																															goto
																																BgL_tagzd21487zd2_900;
																														}
																													else
																														{	/* Ast/sexp.scm 85 */
																															BgL_nodez00_bglt
																																BgL_auxz00_3317;
																															goto
																																BgL_tagzd21488zd2_901;
																															BgL_auxz00_3140 =
																																(obj_t)
																																(BgL_auxz00_3317);
																														}
																												}
																											return
																												(BgL_nodez00_bglt)
																												(BgL_auxz00_3140);
																										}
																									else
																										{	/* Ast/sexp.scm 85 */
																											if (
																												(BgL_carzd21566zd2_915
																													==
																													CNST_TABLE_REF(((long)
																															25))))
																												{	/* Ast/sexp.scm 85 */
																													obj_t BgL_auxz00_3323;

																													goto
																														BgL_kapzd21568zd2_917;
																													return
																														(BgL_nodez00_bglt)
																														(BgL_auxz00_3323);
																												}
																											else
																												{	/* Ast/sexp.scm 85 */
																													if (
																														(BgL_carzd21566zd2_915
																															==
																															CNST_TABLE_REF((
																																	(long) 9))))
																														{	/* Ast/sexp.scm 85 */
																															obj_t
																																BgL_auxz00_3328;
																															goto
																																BgL_kapzd21568zd2_917;
																															return
																																(BgL_nodez00_bglt)
																																(BgL_auxz00_3328);
																														}
																													else
																														{	/* Ast/sexp.scm 85 */
																															obj_t
																																BgL_cdrzd21735zd2_923;
																															BgL_cdrzd21735zd2_923
																																=
																																CDR
																																(BgL_carzd21563zd2_913);
																															if ((CAR
																																	(BgL_carzd21563zd2_913)
																																	==
																																	CNST_TABLE_REF
																																	(((long) 8))))
																																{	/* Ast/sexp.scm 85 */
																																	if (PAIRP
																																		(BgL_cdrzd21735zd2_923))
																																		{
																																			obj_t
																																				BgL_argsz00_3341;
																																			obj_t
																																				BgL_bodyz00_3339;
																																			obj_t
																																				BgL_varsz00_3337;
																																			BgL_varsz00_3337
																																				=
																																				CAR
																																				(BgL_cdrzd21735zd2_923);
																																			BgL_bodyz00_3339
																																				=
																																				CDR
																																				(BgL_cdrzd21735zd2_923);
																																			BgL_argsz00_3341
																																				=
																																				CDR
																																				(BgL_expz00_17);
																																			BgL_argsz00_883
																																				=
																																				BgL_argsz00_3341;
																																			BgL_bodyz00_882
																																				=
																																				BgL_bodyz00_3339;
																																			BgL_varsz00_881
																																				=
																																				BgL_varsz00_3337;
																																			goto
																																				BgL_tagzd21475zd2_884;
																																		}
																																	else
																																		{	/* Ast/sexp.scm 85 */
																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																				{	/* Ast/sexp.scm 85 */
																																					obj_t
																																						BgL_auxz00_3345;
																																					goto
																																						BgL_tagzd21487zd2_900;
																																					return
																																						(BgL_nodez00_bglt)
																																						(BgL_auxz00_3345);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 85 */
																																					goto
																																						BgL_tagzd21488zd2_901;
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 85 */
																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																		{	/* Ast/sexp.scm 85 */
																																			obj_t
																																				BgL_auxz00_3349;
																																			goto
																																				BgL_tagzd21487zd2_900;
																																			return
																																				(BgL_nodez00_bglt)
																																				(BgL_auxz00_3349);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 85 */
																																			goto
																																				BgL_tagzd21488zd2_901;
																																		}
																																}
																														}
																												}
																										}
																								}
																							}
																						else
																							{	/* Ast/sexp.scm 85 */
																								if (
																									(BgL_carzd21563zd2_913 ==
																										CNST_TABLE_REF(((long)
																												11))))
																									{	/* Ast/sexp.scm 85 */
																									BgL_tagzd21473zd2_879:
																										return
																											BGl_letzd2ze3nodez31zzast_letz00
																											(BgL_expz00_17,
																											BgL_stackz00_18,
																											BgL_locz00_19,
																											CNST_TABLE_REF(((long)
																													1)));
																									}
																								else
																									{	/* Ast/sexp.scm 85 */
																										if (
																											(BgL_carzd21563zd2_913 ==
																												CNST_TABLE_REF(((long)
																														25))))
																											{	/* Ast/sexp.scm 85 */
																												goto
																													BgL_tagzd21473zd2_879;
																											}
																										else
																											{	/* Ast/sexp.scm 85 */
																												if (
																													(CAR(BgL_expz00_17) ==
																														CNST_TABLE_REF((
																																(long) 9))))
																													{	/* Ast/sexp.scm 85 */
																														BgL_letzd2funzd2_bglt
																															BgL_auxz00_3363;
																														BgL_auxz00_3363 =
																															BGl_labelszd2ze3nodez31zzast_labelsz00
																															(BgL_expz00_17,
																															BgL_stackz00_18,
																															BgL_locz00_19,
																															CNST_TABLE_REF((
																																	(long) 1)));
																														return
																															(BgL_nodez00_bglt)
																															(BgL_auxz00_3363);
																													}
																												else
																													{	/* Ast/sexp.scm 85 */
																														if (
																															(CAR
																																(BgL_expz00_17)
																																==
																																CNST_TABLE_REF((
																																		(long) 8))))
																															{	/* Ast/sexp.scm 85 */
																																{
																																	obj_t
																																		BgL_argsz00_1391;
																																	obj_t
																																		BgL_bodyz00_1392;
																																	if (PAIRP
																																		(BgL_expz00_17))
																																		{	/* Ast/sexp.scm 85 */
																																			obj_t
																																				BgL_cdrzd22029zd2_1397;
																																			BgL_cdrzd22029zd2_1397
																																				=
																																				CDR
																																				(BgL_expz00_17);
																																			if (PAIRP
																																				(BgL_cdrzd22029zd2_1397))
																																				{	/* Ast/sexp.scm 85 */
																																					BgL_argsz00_1391
																																						=
																																						CAR
																																						(BgL_cdrzd22029zd2_1397);
																																					BgL_bodyz00_1392
																																						=
																																						CDR
																																						(BgL_cdrzd22029zd2_1397);
																																					{	/* Ast/sexp.scm 388 */
																																						obj_t
																																							BgL_locz00_1401;
																																						obj_t
																																							BgL_funz00_1402;
																																						BgL_locz00_1401
																																							=
																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																							(BgL_expz00_17,
																																							BgL_locz00_19);
																																						BgL_funz00_1402
																																							=
																																							BGl_makezd2anonymouszd2namez00zzast_sexpz00
																																							(BgL_locz00_19,
																																							BNIL);
																																						{	/* Ast/sexp.scm 390 */
																																							obj_t
																																								BgL_arg3569z00_1403;
																																							{	/* Ast/sexp.scm 390 */
																																								obj_t
																																									BgL_arg3570z00_1404;
																																								obj_t
																																									BgL_arg3571z00_1405;
																																								BgL_arg3570z00_1404
																																									=
																																									CNST_TABLE_REF
																																									(
																																									((long) 9));
																																								{	/* Ast/sexp.scm 390 */
																																									obj_t
																																										BgL_arg3572z00_1406;
																																									{	/* Ast/sexp.scm 390 */
																																										obj_t
																																											BgL_arg3577z00_1410;
																																										{	/* Ast/sexp.scm 390 */
																																											obj_t
																																												BgL_arg3579z00_1412;
																																											{	/* Ast/sexp.scm 390 */
																																												obj_t
																																													BgL_arg3580z00_1413;
																																												BgL_arg3580z00_1413
																																													=
																																													BGl_normaliza7ezd2prognz75zztools_prognz00
																																													(BgL_bodyz00_1392);
																																												{	/* Ast/sexp.scm 390 */
																																													obj_t
																																														BgL_list3582z00_1415;
																																													{	/* Ast/sexp.scm 390 */
																																														obj_t
																																															BgL_arg3583z00_1416;
																																														BgL_arg3583z00_1416
																																															=
																																															MAKE_PAIR
																																															(BNIL,
																																															BNIL);
																																														BgL_list3582z00_1415
																																															=
																																															MAKE_PAIR
																																															(BgL_arg3580z00_1413,
																																															BgL_arg3583z00_1416);
																																													}
																																													BgL_arg3579z00_1412
																																														=
																																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																														(BgL_argsz00_1391,
																																														BgL_list3582z00_1415);
																																											}}
																																											BgL_arg3577z00_1410
																																												=
																																												MAKE_PAIR
																																												(BgL_funz00_1402,
																																												BgL_arg3579z00_1412);
																																										}
																																										BgL_arg3572z00_1406
																																											=
																																											MAKE_PAIR
																																											(BgL_arg3577z00_1410,
																																											BNIL);
																																									}
																																									{	/* Ast/sexp.scm 390 */
																																										obj_t
																																											BgL_list3574z00_1408;
																																										{	/* Ast/sexp.scm 390 */
																																											obj_t
																																												BgL_arg3575z00_1409;
																																											BgL_arg3575z00_1409
																																												=
																																												MAKE_PAIR
																																												(BNIL,
																																												BNIL);
																																											BgL_list3574z00_1408
																																												=
																																												MAKE_PAIR
																																												(BgL_funz00_1402,
																																												BgL_arg3575z00_1409);
																																										}
																																										BgL_arg3571z00_1405
																																											=
																																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																											(BgL_arg3572z00_1406,
																																											BgL_list3574z00_1408);
																																								}}
																																								BgL_arg3569z00_1403
																																									=
																																									MAKE_PAIR
																																									(BgL_arg3570z00_1404,
																																									BgL_arg3571z00_1405);
																																							}
																																							{
																																								obj_t
																																									BgL_locz00_3390;
																																								obj_t
																																									BgL_expz00_3389;
																																								BgL_expz00_3389
																																									=
																																									BgL_arg3569z00_1403;
																																								BgL_locz00_3390
																																									=
																																									BgL_locz00_1401;
																																								BgL_locz00_19
																																									=
																																									BgL_locz00_3390;
																																								BgL_expz00_17
																																									=
																																									BgL_expz00_3389;
																																								goto
																																									BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																							}
																																						}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 85 */
																																				BgL_tagzd22022zd2_1394:
																																					return
																																						BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																						(BGl_string3875z00zzast_sexpz00,
																																						BgL_expz00_17,
																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																						(BgL_expz00_17,
																																							BgL_locz00_19));
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 85 */
																																			goto
																																				BgL_tagzd22022zd2_1394;
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 85 */
																																if (
																																	(CAR
																																		(BgL_expz00_17)
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				2))))
																																	{	/* Ast/sexp.scm 85 */
																																		return
																																			BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																			(((bool_t)
																																				0),
																																			BFALSE,
																																			(BgL_typez00_bglt)
																																			(BGl_za2unspecza2z00zztype_cachez00),
																																			BgL_expz00_17,
																																			BgL_stackz00_18,
																																			BgL_locz00_19,
																																			BgL_sitez00_20);
																																	}
																																else
																																	{	/* Ast/sexp.scm 85 */
																																		obj_t
																																			BgL_cdrzd21807zd2_965;
																																		BgL_cdrzd21807zd2_965
																																			=
																																			CDR
																																			(BgL_expz00_17);
																																		if ((CAR
																																				(BgL_expz00_17)
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						3))))
																																			{	/* Ast/sexp.scm 85 */
																																				if (PAIRP(BgL_cdrzd21807zd2_965))
																																					{	/* Ast/sexp.scm 85 */
																																						BgL_effectz00_887
																																							=
																																							CAR
																																							(BgL_cdrzd21807zd2_965);
																																						BgL_restz00_888
																																							=
																																							CDR
																																							(BgL_cdrzd21807zd2_965);
																																						{	/* Ast/sexp.scm 404 */
																																							BgL_feffectz00_bglt
																																								BgL_arg3587z00_1420;
																																							obj_t
																																								BgL_arg3588z00_1421;
																																							BgL_arg3587z00_1420
																																								=
																																								BGl_parsezd2effectzd2zzeffect_feffectz00
																																								(BgL_effectz00_887);
																																							{	/* Ast/sexp.scm 405 */
																																								obj_t
																																									BgL_arg3589z00_1422;
																																								obj_t
																																									BgL_arg3590z00_1423;
																																								BgL_arg3589z00_1422
																																									=
																																									CNST_TABLE_REF
																																									(
																																									((long) 2));
																																								BgL_arg3590z00_1423
																																									=
																																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																									(BgL_restz00_888,
																																									BNIL);
																																								BgL_arg3588z00_1421
																																									=
																																									MAKE_PAIR
																																									(BgL_arg3589z00_1422,
																																									BgL_arg3590z00_1423);
																																							}
																																							return
																																								BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																								(
																																								((bool_t) 0), (obj_t) (BgL_arg3587z00_1420), (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_arg3588z00_1421, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);
																																						}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																							{	/* Ast/sexp.scm 85 */
																																								obj_t
																																									BgL_auxz00_3419;
																																								goto
																																									BgL_tagzd21487zd2_900;
																																								return
																																									(BgL_nodez00_bglt)
																																									(BgL_auxz00_3419);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 85 */
																																								goto
																																									BgL_tagzd21488zd2_901;
																																							}
																																					}
																																			}
																																		else
																																			{	/* Ast/sexp.scm 85 */
																																				if (
																																					(CAR
																																						(BgL_expz00_17)
																																						==
																																						CNST_TABLE_REF
																																						(((long) 6))))
																																					{	/* Ast/sexp.scm 85 */
																																						return
																																							BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																							(((bool_t) 1), BFALSE, (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_17, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 85 */
																																						if (
																																							(CAR
																																								(BgL_expz00_17)
																																								==
																																								CNST_TABLE_REF
																																								(((long) 7))))
																																							{	/* Ast/sexp.scm 85 */
																																								if (PAIRP(BgL_cdrzd21807zd2_965))
																																									{	/* Ast/sexp.scm 85 */
																																										BgL_effectz00_891
																																											=
																																											CAR
																																											(BgL_cdrzd21807zd2_965);
																																										BgL_restz00_892
																																											=
																																											CDR
																																											(BgL_cdrzd21807zd2_965);
																																										{	/* Ast/sexp.scm 412 */
																																											BgL_feffectz00_bglt
																																												BgL_arg3591z00_1424;
																																											obj_t
																																												BgL_arg3592z00_1425;
																																											BgL_arg3591z00_1424
																																												=
																																												BGl_parsezd2effectzd2zzeffect_feffectz00
																																												(BgL_effectz00_891);
																																											{	/* Ast/sexp.scm 413 */
																																												obj_t
																																													BgL_arg3593z00_1426;
																																												obj_t
																																													BgL_arg3594z00_1427;
																																												BgL_arg3593z00_1426
																																													=
																																													CNST_TABLE_REF
																																													(
																																													((long) 2));
																																												BgL_arg3594z00_1427
																																													=
																																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																													(BgL_restz00_892,
																																													BNIL);
																																												BgL_arg3592z00_1425
																																													=
																																													MAKE_PAIR
																																													(BgL_arg3593z00_1426,
																																													BgL_arg3594z00_1427);
																																											}
																																											return
																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																												(
																																												((bool_t) 1), (obj_t) (BgL_arg3591z00_1424), (BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00), BgL_arg3592z00_1425, BgL_stackz00_18, BgL_locz00_19, BgL_sitez00_20);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 85 */
																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																											{	/* Ast/sexp.scm 85 */
																																												obj_t
																																													BgL_auxz00_3444;
																																												goto
																																													BgL_tagzd21487zd2_900;
																																												return
																																													(BgL_nodez00_bglt)
																																													(BgL_auxz00_3444);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 85 */
																																												goto
																																													BgL_tagzd21488zd2_901;
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 85 */
																																								if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 26))))
																																									{	/* Ast/sexp.scm 85 */
																																										obj_t
																																											BgL_auxz00_3450;
																																										{
																																											obj_t
																																												BgL_procz00_1428;
																																											obj_t
																																												BgL_msgz00_1429;
																																											obj_t
																																												BgL_objz00_1430;
																																											if (PAIRP(BgL_expz00_17))
																																												{	/* Ast/sexp.scm 85 */
																																													obj_t
																																														BgL_cdrzd22046zd2_1435;
																																													BgL_cdrzd22046zd2_1435
																																														=
																																														CDR
																																														(BgL_expz00_17);
																																													if (PAIRP(BgL_cdrzd22046zd2_1435))
																																														{	/* Ast/sexp.scm 85 */
																																															obj_t
																																																BgL_cdrzd22051zd2_1437;
																																															BgL_cdrzd22051zd2_1437
																																																=
																																																CDR
																																																(BgL_cdrzd22046zd2_1435);
																																															if (PAIRP(BgL_cdrzd22051zd2_1437))
																																																{	/* Ast/sexp.scm 85 */
																																																	obj_t
																																																		BgL_cdrzd22056zd2_1439;
																																																	BgL_cdrzd22056zd2_1439
																																																		=
																																																		CDR
																																																		(BgL_cdrzd22051zd2_1437);
																																																	if (PAIRP(BgL_cdrzd22056zd2_1439))
																																																		{	/* Ast/sexp.scm 85 */
																																																			if (NULLP(CDR(BgL_cdrzd22056zd2_1439)))
																																																				{	/* Ast/sexp.scm 85 */
																																																					obj_t
																																																						BgL_arg3600z00_1442;
																																																					obj_t
																																																						BgL_arg3601z00_1443;
																																																					obj_t
																																																						BgL_arg3602z00_1444;
																																																					BgL_arg3600z00_1442
																																																						=
																																																						CAR
																																																						(BgL_cdrzd22046zd2_1435);
																																																					BgL_arg3601z00_1443
																																																						=
																																																						CAR
																																																						(BgL_cdrzd22051zd2_1437);
																																																					BgL_arg3602z00_1444
																																																						=
																																																						CAR
																																																						(BgL_cdrzd22056zd2_1439);
																																																					{	/* Ast/sexp.scm 85 */
																																																						BgL_failz00_bglt
																																																							BgL_auxz00_3468;
																																																						BgL_procz00_1428
																																																							=
																																																							BgL_arg3600z00_1442;
																																																						BgL_msgz00_1429
																																																							=
																																																							BgL_arg3601z00_1443;
																																																						BgL_objz00_1430
																																																							=
																																																							BgL_arg3602z00_1444;
																																																						{	/* Ast/sexp.scm 418 */
																																																							obj_t
																																																								BgL_locz00_1446;
																																																							BgL_locz00_1446
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_17,
																																																								BgL_locz00_19);
																																																							{	/* Ast/sexp.scm 418 */
																																																								obj_t
																																																									BgL_cdlocz00_1447;
																																																								BgL_cdlocz00_1447
																																																									=
																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																									(CDR
																																																									(BgL_expz00_17),
																																																									BgL_locz00_1446);
																																																								{	/* Ast/sexp.scm 419 */
																																																									obj_t
																																																										BgL_cddlocz00_1448;
																																																									{	/* Ast/sexp.scm 420 */
																																																										obj_t
																																																											BgL_arg3605z00_1457;
																																																										{	/* Ast/sexp.scm 420 */
																																																											obj_t
																																																												BgL_pairz00_2412;
																																																											BgL_pairz00_2412
																																																												=
																																																												BgL_expz00_17;
																																																											BgL_arg3605z00_1457
																																																												=
																																																												CDR
																																																												(CDR
																																																												(BgL_pairz00_2412));
																																																										}
																																																										BgL_cddlocz00_1448
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg3605z00_1457,
																																																											BgL_locz00_1446);
																																																									}
																																																									{	/* Ast/sexp.scm 420 */
																																																										obj_t
																																																											BgL_cdddlocz00_1449;
																																																										{	/* Ast/sexp.scm 421 */
																																																											obj_t
																																																												BgL_arg3604z00_1456;
																																																											{	/* Ast/sexp.scm 421 */
																																																												obj_t
																																																													BgL_pairz00_2416;
																																																												BgL_pairz00_2416
																																																													=
																																																													BgL_expz00_17;
																																																												BgL_arg3604z00_1456
																																																													=
																																																													CDR
																																																													(CDR
																																																													(CDR
																																																														(BgL_pairz00_2416)));
																																																											}
																																																											BgL_cdddlocz00_1449
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg3604z00_1456,
																																																												BgL_locz00_1446);
																																																										}
																																																										{	/* Ast/sexp.scm 421 */
																																																											obj_t
																																																												BgL_loczd2proczd2_1450;
																																																											BgL_loczd2proczd2_1450
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_procz00_1428,
																																																												BgL_cdlocz00_1447);
																																																											{	/* Ast/sexp.scm 422 */
																																																												obj_t
																																																													BgL_loczd2msgzd2_1451;
																																																												BgL_loczd2msgzd2_1451
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_msgz00_1429,
																																																													BgL_cddlocz00_1448);
																																																												{	/* Ast/sexp.scm 423 */
																																																													obj_t
																																																														BgL_loczd2objzd2_1452;
																																																													BgL_loczd2objzd2_1452
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_objz00_1430,
																																																														BgL_cdddlocz00_1449);
																																																													{	/* Ast/sexp.scm 424 */
																																																														BgL_nodez00_bglt
																																																															BgL_procz00_1453;
																																																														BgL_procz00_1453
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_procz00_1428,
																																																															BgL_stackz00_18,
																																																															BgL_loczd2proczd2_1450,
																																																															CNST_TABLE_REF
																																																															(((long) 1)));
																																																														{	/* Ast/sexp.scm 425 */
																																																															BgL_nodez00_bglt
																																																																BgL_msgz00_1454;
																																																															BgL_msgz00_1454
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_msgz00_1429,
																																																																BgL_stackz00_18,
																																																																BgL_loczd2msgzd2_1451,
																																																																CNST_TABLE_REF
																																																																(((long) 1)));
																																																															{	/* Ast/sexp.scm 426 */
																																																																BgL_nodez00_bglt
																																																																	BgL_objz00_1455;
																																																																BgL_objz00_1455
																																																																	=
																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																	(BgL_objz00_1430,
																																																																	BgL_stackz00_18,
																																																																	BgL_loczd2objzd2_1452,
																																																																	CNST_TABLE_REF
																																																																	(((long) 1)));
																																																																{	/* Ast/sexp.scm 427 */

																																																																	BgL_auxz00_3468
																																																																		=
																																																																		BGl_makezd2failzd2zzast_nodez00
																																																																		(BgL_locz00_1446,
																																																																		(BgL_typez00_bglt)
																																																																		(BGl_za2magicza2z00zztype_cachez00),
																																																																		BgL_procz00_1453,
																																																																		BgL_msgz00_1454,
																																																																		BgL_objz00_1455);
																																																						}}}}}}}}}}}
																																																						BgL_auxz00_3450
																																																							=
																																																							(obj_t)
																																																							(BgL_auxz00_3468);
																																																				}}
																																																			else
																																																				{	/* Ast/sexp.scm 85 */
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_3491;
																																																				BgL_tagzd22037zd2_1432:
																																																					BgL_auxz00_3491 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string3878z00zzast_sexpz00, BgL_expz00_17, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19));
																																																					BgL_auxz00_3450
																																																						=
																																																						(obj_t)
																																																						(BgL_auxz00_3491);
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 85 */
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_3495;
																																																			goto
																																																				BgL_tagzd22037zd2_1432;
																																																			BgL_auxz00_3450
																																																				=
																																																				(obj_t)
																																																				(BgL_auxz00_3495);
																																																		}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 85 */
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_3497;
																																																	goto
																																																		BgL_tagzd22037zd2_1432;
																																																	BgL_auxz00_3450
																																																		=
																																																		(obj_t)
																																																		(BgL_auxz00_3497);
																																																}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 85 */
																																															BgL_nodez00_bglt
																																																BgL_auxz00_3499;
																																															goto
																																																BgL_tagzd22037zd2_1432;
																																															BgL_auxz00_3450
																																																=
																																																(obj_t)
																																																(BgL_auxz00_3499);
																																														}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 85 */
																																													BgL_nodez00_bglt
																																														BgL_auxz00_3501;
																																													goto
																																														BgL_tagzd22037zd2_1432;
																																													BgL_auxz00_3450
																																														=
																																														(obj_t)
																																														(BgL_auxz00_3501);
																																												}
																																										}
																																										return
																																											(BgL_nodez00_bglt)
																																											(BgL_auxz00_3450);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 85 */
																																										if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 27))))
																																											{	/* Ast/sexp.scm 85 */
																																												obj_t
																																													BgL_auxz00_3508;
																																												{
																																													obj_t
																																														BgL_testz00_1461;
																																													obj_t
																																														BgL_clausesz00_1462;
																																													if (PAIRP(BgL_expz00_17))
																																														{	/* Ast/sexp.scm 85 */
																																															obj_t
																																																BgL_cdrzd22070zd2_1467;
																																															BgL_cdrzd22070zd2_1467
																																																=
																																																CDR
																																																(BgL_expz00_17);
																																															if (PAIRP(BgL_cdrzd22070zd2_1467))
																																																{	/* Ast/sexp.scm 85 */
																																																	BgL_testz00_1461
																																																		=
																																																		CAR
																																																		(BgL_cdrzd22070zd2_1467);
																																																	BgL_clausesz00_1462
																																																		=
																																																		CDR
																																																		(BgL_cdrzd22070zd2_1467);
																																																	{	/* Ast/sexp.scm 447 */
																																																		obj_t
																																																			BgL_locz00_1471;
																																																		BgL_locz00_1471
																																																			=
																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																			(BgL_expz00_17,
																																																			BgL_locz00_19);
																																																		{	/* Ast/sexp.scm 447 */
																																																			obj_t
																																																				BgL_cdlocz00_1472;
																																																			BgL_cdlocz00_1472
																																																				=
																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																				(CDR
																																																				(BgL_expz00_17),
																																																				BgL_locz00_1471);
																																																			{	/* Ast/sexp.scm 448 */
																																																				obj_t
																																																					BgL_cddlocz00_1473;
																																																				BgL_cddlocz00_1473
																																																					=
																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																					(CDR
																																																					(BgL_expz00_17),
																																																					BgL_locz00_1471);
																																																				{	/* Ast/sexp.scm 449 */
																																																					BgL_nodez00_bglt
																																																						BgL_testz00_1474;
																																																					{	/* Ast/sexp.scm 452 */
																																																						obj_t
																																																							BgL_arg3637z00_1505;
																																																						obj_t
																																																							BgL_arg3638z00_1506;
																																																						BgL_arg3637z00_1505
																																																							=
																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																							(BgL_testz00_1461,
																																																							BgL_cdlocz00_1472);
																																																						BgL_arg3638z00_1506
																																																							=
																																																							CNST_TABLE_REF
																																																							(
																																																							((long) 1));
																																																						BgL_testz00_1474
																																																							=
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																							(BgL_testz00_1461,
																																																							BgL_stackz00_18,
																																																							BgL_arg3637z00_1505,
																																																							BgL_arg3638z00_1506);
																																																					}
																																																					{	/* Ast/sexp.scm 450 */

																																																						{
																																																							obj_t
																																																								BgL_clsz00_1476;
																																																							obj_t
																																																								BgL_nclausesz00_1477;
																																																							BgL_clsz00_1476
																																																								=
																																																								BgL_clausesz00_1462;
																																																							BgL_nclausesz00_1477
																																																								=
																																																								BNIL;
																																																						BgL_loopz00_1478:
																																																							if (NULLP(BgL_clsz00_1476))
																																																								{	/* Ast/sexp.scm 457 */
																																																									obj_t
																																																										BgL_arg3615z00_1481;
																																																									BgL_typez00_bglt
																																																										BgL_arg3616z00_1482;
																																																									BgL_arg3615z00_1481
																																																										=
																																																										bgl_reverse_bang
																																																										(BgL_nclausesz00_1477);
																																																									BgL_arg3616z00_1482
																																																										=
																																																										BGl_typeofzd2atomzd2zztype_typeofz00
																																																										(CAR
																																																										(CAR
																																																											(CAR
																																																												(BgL_clausesz00_1462))));
																																																									BgL_auxz00_3508
																																																										=
																																																										(obj_t)
																																																										(BGl_makezd2selectzd2zzast_nodez00
																																																										(BgL_locz00_1471,
																																																											(BgL_typez00_bglt)
																																																											(BGl_za2_za2z00zztype_cachez00),
																																																											BUNSPEC,
																																																											BINT
																																																											(((long) -1)), BgL_testz00_1474, BgL_arg3615z00_1481, BgL_arg3616z00_1482));
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 463 */
																																																									obj_t
																																																										BgL_clausez00_1486;
																																																									BgL_clausez00_1486
																																																										=
																																																										CAR
																																																										(BgL_clsz00_1476);
																																																									{	/* Ast/sexp.scm 463 */
																																																										BgL_nodez00_bglt
																																																											BgL_bodyz00_1487;
																																																										{	/* Ast/sexp.scm 464 */
																																																											obj_t
																																																												BgL_arg3632z00_1501;
																																																											obj_t
																																																												BgL_arg3634z00_1502;
																																																											obj_t
																																																												BgL_arg3635z00_1503;
																																																											BgL_arg3632z00_1501
																																																												=
																																																												BGl_normaliza7ezd2prognz75zztools_prognz00
																																																												(CDR
																																																												(BgL_clausez00_1486));
																																																											BgL_arg3634z00_1502
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_clausez00_1486,
																																																												BgL_cddlocz00_1473);
																																																											BgL_arg3635z00_1503
																																																												=
																																																												CNST_TABLE_REF
																																																												(
																																																												((long) 1));
																																																											BgL_bodyz00_1487
																																																												=
																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																												(BgL_arg3632z00_1501,
																																																												BgL_stackz00_18,
																																																												BgL_arg3634z00_1502,
																																																												BgL_arg3635z00_1503);
																																																										}
																																																										{	/* Ast/sexp.scm 464 */
																																																											obj_t
																																																												BgL_nclausez00_1488;
																																																											BgL_nclausez00_1488
																																																												=
																																																												MAKE_PAIR
																																																												(CAR
																																																												(BgL_clausez00_1486),
																																																												(obj_t)
																																																												(BgL_bodyz00_1487));
																																																											{	/* Ast/sexp.scm 468 */

																																																												{	/* Ast/sexp.scm 470 */
																																																													bool_t
																																																														BgL_testz00_3542;
																																																													if ((CAR(BgL_clausez00_1486) == CNST_TABLE_REF(((long) 10))))
																																																														{	/* Ast/sexp.scm 470 */
																																																															if (NULLP(CDR(BgL_clsz00_1476)))
																																																																{	/* Ast/sexp.scm 471 */
																																																																	BgL_testz00_3542
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		0);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 471 */
																																																																	BgL_testz00_3542
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		1);
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 470 */
																																																															BgL_testz00_3542
																																																																=
																																																																(
																																																																(bool_t)
																																																																0);
																																																														}
																																																													if (BgL_testz00_3542)
																																																														{	/* Ast/sexp.scm 472 */
																																																															obj_t
																																																																BgL_arg3622z00_1491;
																																																															BgL_arg3622z00_1491
																																																																=
																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																(BgL_expz00_17,
																																																																BgL_locz00_1471);
																																																															BgL_auxz00_3508
																																																																=
																																																																(obj_t)
																																																																(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																																(BGl_string3877z00zzast_sexpz00,
																																																																	BgL_expz00_17,
																																																																	BgL_arg3622z00_1491));
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 475 */
																																																															obj_t
																																																																BgL_arg3623z00_1492;
																																																															obj_t
																																																																BgL_arg3624z00_1493;
																																																															BgL_arg3623z00_1492
																																																																=
																																																																CDR
																																																																(BgL_clsz00_1476);
																																																															BgL_arg3624z00_1493
																																																																=
																																																																MAKE_PAIR
																																																																(BGl_epairifyz00zztools_miscz00
																																																																(BgL_nclausez00_1488,
																																																																	BgL_clausez00_1486),
																																																																BgL_nclausesz00_1477);
																																																															{
																																																																obj_t
																																																																	BgL_nclausesz00_3557;
																																																																obj_t
																																																																	BgL_clsz00_3556;
																																																																BgL_clsz00_3556
																																																																	=
																																																																	BgL_arg3623z00_1492;
																																																																BgL_nclausesz00_3557
																																																																	=
																																																																	BgL_arg3624z00_1493;
																																																																BgL_nclausesz00_1477
																																																																	=
																																																																	BgL_nclausesz00_3557;
																																																																BgL_clsz00_1476
																																																																	=
																																																																	BgL_clsz00_3556;
																																																																goto
																																																																	BgL_loopz00_1478;
																																																															}
																																																														}
																																																												}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				}
																																																			}
																																																		}
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 85 */
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_3560;
																																																BgL_tagzd22063zd2_1464:
																																																	BgL_auxz00_3560 = BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BGl_string3877z00zzast_sexpz00, BgL_expz00_17, BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_17, BgL_locz00_19));
																																																	BgL_auxz00_3508
																																																		=
																																																		(obj_t)
																																																		(BgL_auxz00_3560);
																																																}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 85 */
																																															BgL_nodez00_bglt
																																																BgL_auxz00_3564;
																																															goto
																																																BgL_tagzd22063zd2_1464;
																																															BgL_auxz00_3508
																																																=
																																																(obj_t)
																																																(BgL_auxz00_3564);
																																														}
																																												}
																																												return
																																													(BgL_nodez00_bglt)
																																													(BgL_auxz00_3508);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 85 */
																																												if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 28))))
																																													{	/* Ast/sexp.scm 85 */
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_3571;
																																														BgL_auxz00_3571
																																															=
																																															BGl_setzd2exitzd2ze3nodeze3zzast_exitz00
																																															(BgL_expz00_17,
																																															BgL_stackz00_18,
																																															BgL_locz00_19,
																																															BgL_sitez00_20);
																																														return
																																															(BgL_nodez00_bglt)
																																															(BgL_auxz00_3571);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 85 */
																																														if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 29))))
																																															{	/* Ast/sexp.scm 85 */
																																																BgL_jumpzd2exzd2itz00_bglt
																																																	BgL_auxz00_3578;
																																																BgL_auxz00_3578
																																																	=
																																																	BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00
																																																	(BgL_expz00_17,
																																																	BgL_stackz00_18,
																																																	BgL_locz00_19,
																																																	BgL_sitez00_20);
																																																return
																																																	(BgL_nodez00_bglt)
																																																	(BgL_auxz00_3578);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 85 */
																																																obj_t
																																																	BgL_cdrzd21845zd2_982;
																																																BgL_cdrzd21845zd2_982
																																																	=
																																																	CDR
																																																	(BgL_expz00_17);
																																																if ((CAR(BgL_expz00_17) == CNST_TABLE_REF(((long) 22))))
																																																	{	/* Ast/sexp.scm 85 */
																																																		if (PAIRP(BgL_cdrzd21845zd2_982))
																																																			{	/* Ast/sexp.scm 85 */
																																																				obj_t
																																																					BgL_cdrzd21847zd2_985;
																																																				BgL_cdrzd21847zd2_985
																																																					=
																																																					CDR
																																																					(BgL_cdrzd21845zd2_982);
																																																				if (PAIRP(BgL_cdrzd21847zd2_985))
																																																					{	/* Ast/sexp.scm 85 */
																																																						if (NULLP(CDR(BgL_cdrzd21847zd2_985)))
																																																							{	/* Ast/sexp.scm 85 */
																																																								return
																																																									BGl_applycationzd2ze3nodez31zzast_applyz00
																																																									(BgL_expz00_17,
																																																									BgL_stackz00_18,
																																																									BgL_locz00_19,
																																																									BgL_sitez00_20);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 85 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																									{	/* Ast/sexp.scm 85 */
																																																										obj_t
																																																											BgL_auxz00_3597;
																																																										goto
																																																											BgL_tagzd21487zd2_900;
																																																										return
																																																											(BgL_nodez00_bglt)
																																																											(BgL_auxz00_3597);
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 85 */
																																																										goto
																																																											BgL_tagzd21488zd2_901;
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 85 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																							{	/* Ast/sexp.scm 85 */
																																																								obj_t
																																																									BgL_auxz00_3601;
																																																								goto
																																																									BgL_tagzd21487zd2_900;
																																																								return
																																																									(BgL_nodez00_bglt)
																																																									(BgL_auxz00_3601);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 85 */
																																																								goto
																																																									BgL_tagzd21488zd2_901;
																																																							}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 85 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																					{	/* Ast/sexp.scm 85 */
																																																						obj_t
																																																							BgL_auxz00_3605;
																																																						goto
																																																							BgL_tagzd21487zd2_900;
																																																						return
																																																							(BgL_nodez00_bglt)
																																																							(BgL_auxz00_3605);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 85 */
																																																						goto
																																																							BgL_tagzd21488zd2_901;
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 85 */
																																																		if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_17), BUNSPEC))
																																																			{	/* Ast/sexp.scm 85 */
																																																				if (NULLP(BgL_cdrzd21845zd2_982))
																																																					{	/* Ast/sexp.scm 85 */
																																																						return
																																																							BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																																																							(BGl_string3876z00zzast_sexpz00,
																																																							BgL_expz00_17,
																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																							(BgL_expz00_17,
																																																								BgL_locz00_19));
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 85 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																							{	/* Ast/sexp.scm 85 */
																																																								obj_t
																																																									BgL_auxz00_3616;
																																																								goto
																																																									BgL_tagzd21487zd2_900;
																																																								return
																																																									(BgL_nodez00_bglt)
																																																									(BgL_auxz00_3616);
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 85 */
																																																								goto
																																																									BgL_tagzd21488zd2_901;
																																																							}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 85 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_17))
																																																					{	/* Ast/sexp.scm 85 */
																																																						obj_t
																																																							BgL_auxz00_3620;
																																																						goto
																																																							BgL_tagzd21487zd2_900;
																																																						return
																																																							(BgL_nodez00_bglt)
																																																							(BgL_auxz00_3620);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 85 */
																																																						goto
																																																							BgL_tagzd21488zd2_901;
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
								else
									{	/* Ast/sexp.scm 85 */
										obj_t BgL_auxz00_3622;

										BgL_atomz00_867 = BgL_expz00_17;
										if (SYMBOLP(BgL_atomz00_867))
											{	/* Ast/sexp.scm 95 */
												if (CBOOL(BGl_lookupz00zzast_sexpz00(BgL_atomz00_867,
															BgL_stackz00_18)))
													{	/* Ast/sexp.scm 118 */
														obj_t BgL_localz00_1035;

														BgL_localz00_1035 =
															BGl_lookupz00zzast_sexpz00(BgL_atomz00_867,
															BgL_stackz00_18);
														{	/* Ast/sexp.scm 118 */
															obj_t BgL_varz00_1036;

															{	/* Ast/sexp.scm 119 */
																bool_t BgL_testz00_3629;

																if (
																	(BgL_sitez00_20 ==
																		CNST_TABLE_REF(((long) 19))))
																	{	/* Ast/sexp.scm 119 */
																		BgL_testz00_3629 = ((bool_t) 0);
																	}
																else
																	{	/* Ast/sexp.scm 120 */
																		BgL_valuez00_bglt BgL_arg3302z00_1041;

																		{
																			BgL_variablez00_bglt BgL_auxz00_3633;

																			BgL_auxz00_3633 =
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1035);
																			BgL_arg3302z00_1041 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_auxz00_3633))->BgL_valuez00);
																		}
																		{	/* Ast/sexp.scm 120 */
																			obj_t BgL_obj1751z00_2171;

																			BgL_obj1751z00_2171 =
																				(obj_t) (BgL_arg3302z00_1041);
																			BgL_testz00_3629 =
																				BGl_iszd2azf3z21zz__objectz00
																				(BgL_obj1751z00_2171,
																				BGl_funz00zzast_varz00);
																		}
																	}
																if (BgL_testz00_3629)
																	{	/* Ast/sexp.scm 123 */
																		BgL_typez00_bglt BgL_arg3299z00_1038;

																		{
																			BgL_variablez00_bglt BgL_auxz00_3638;

																			BgL_auxz00_3638 =
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1035);
																			BgL_arg3299z00_1038 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_auxz00_3638))->BgL_typez00);
																		}
																		BgL_varz00_1036 =
																			(obj_t)
																			(BGl_makezd2closurezd2zzast_nodez00
																			(BgL_locz00_19, BgL_arg3299z00_1038,
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1035)));
																	}
																else
																	{	/* Ast/sexp.scm 127 */
																		BgL_typez00_bglt BgL_arg3300z00_1039;

																		{
																			BgL_variablez00_bglt BgL_auxz00_3644;

																			BgL_auxz00_3644 =
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1035);
																			BgL_arg3300z00_1039 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_auxz00_3644))->BgL_typez00);
																		}
																		BgL_varz00_1036 =
																			(obj_t) (BGl_makezd2varzd2zzast_nodez00
																			(BgL_locz00_19, BgL_arg3300z00_1039,
																				(BgL_variablez00_bglt)
																				(BgL_localz00_1035)));
																	}
															}
															{	/* Ast/sexp.scm 119 */

																BGl_usezd2variablez12zc0zzast_sexpz00(
																	(BgL_variablez00_bglt) (BgL_localz00_1035),
																	BgL_locz00_19, BgL_sitez00_20);
																BgL_auxz00_3622 = BgL_varz00_1036;
															}
														}
													}
												else
													{	/* Ast/sexp.scm 132 */
														obj_t BgL_globalz00_1042;

														BgL_globalz00_1042 =
															BGl_findzd2globalzd2zzast_envz00(BgL_atomz00_867,
															BNIL);
														if (BGl_iszd2azf3z21zz__objectz00
															(BgL_globalz00_1042, BGl_globalz00zzast_varz00))
															{	/* Ast/sexp.scm 136 */
																bool_t BgL_testz00_3655;

																{	/* Ast/sexp.scm 136 */
																	obj_t BgL_auxz00_3656;

																	{
																		BgL_globalz00_bglt BgL_auxz00_3657;

																		BgL_auxz00_3657 =
																			(BgL_globalz00_bglt) (BgL_globalz00_1042);
																		BgL_auxz00_3656 =
																			(((BgL_globalz00_bglt)
																				CREF(BgL_auxz00_3657))->BgL_importz00);
																	}
																	BgL_testz00_3655 =
																		(BgL_auxz00_3656 ==
																		CNST_TABLE_REF(((long) 18)));
																}
																if (BgL_testz00_3655)
																	{	/* Ast/sexp.scm 137 */
																		obj_t BgL_arg3305z00_1045;

																		{	/* Ast/sexp.scm 137 */
																			obj_t BgL_arg3306z00_1046;

																			obj_t BgL_arg3307z00_1047;

																			BgL_arg3306z00_1046 =
																				CNST_TABLE_REF(((long) 18));
																			{	/* Ast/sexp.scm 137 */
																				obj_t BgL_arg3308z00_1048;

																				{	/* Ast/sexp.scm 137 */
																					obj_t BgL_arg3311z00_1051;

																					obj_t BgL_arg3312z00_1052;

																					BgL_arg3311z00_1051 =
																						CNST_TABLE_REF(((long) 21));
																					{	/* Ast/sexp.scm 137 */
																						obj_t BgL_list3313z00_1053;

																						BgL_list3313z00_1053 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg3312z00_1052 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_atomz00_867,
																							BgL_list3313z00_1053);
																					}
																					BgL_arg3308z00_1048 =
																						MAKE_PAIR(BgL_arg3311z00_1051,
																						BgL_arg3312z00_1052);
																				}
																				{	/* Ast/sexp.scm 137 */
																					obj_t BgL_list3310z00_1050;

																					BgL_list3310z00_1050 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3307z00_1047 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3308z00_1048,
																						BgL_list3310z00_1050);
																			}}
																			BgL_arg3305z00_1045 =
																				MAKE_PAIR(BgL_arg3306z00_1046,
																				BgL_arg3307z00_1047);
																		}
																		BgL_auxz00_3622 =
																			(obj_t)
																			(BGl_sexpzd2ze3nodez31zzast_sexpz00
																			(BgL_arg3305z00_1045, BgL_stackz00_18,
																				BgL_locz00_19, BgL_sitez00_20));
																	}
																else
																	{	/* Ast/sexp.scm 136 */
																		BGl_usezd2variablez12zc0zzast_sexpz00(
																			(BgL_variablez00_bglt)
																			(BgL_globalz00_1042), BgL_locz00_19,
																			BgL_sitez00_20);
																		{	/* Ast/sexp.scm 140 */
																			bool_t BgL_testz00_3674;

																			if (
																				(BgL_sitez00_20 ==
																					CNST_TABLE_REF(((long) 19))))
																				{	/* Ast/sexp.scm 140 */
																					BgL_testz00_3674 = ((bool_t) 0);
																				}
																			else
																				{	/* Ast/sexp.scm 140 */
																					BgL_valuez00_bglt BgL_arg3329z00_1069;

																					{
																						BgL_variablez00_bglt
																							BgL_auxz00_3678;
																						BgL_auxz00_3678 =
																							(BgL_variablez00_bglt)
																							(BgL_globalz00_1042);
																						BgL_arg3329z00_1069 =
																							(((BgL_variablez00_bglt)
																								CREF(BgL_auxz00_3678))->
																							BgL_valuez00);
																					}
																					{	/* Ast/sexp.scm 140 */
																						obj_t BgL_obj1751z00_2177;

																						BgL_obj1751z00_2177 =
																							(obj_t) (BgL_arg3329z00_1069);
																						BgL_testz00_3674 =
																							BGl_iszd2azf3z21zz__objectz00
																							(BgL_obj1751z00_2177,
																							BGl_funz00zzast_varz00);
																					}
																				}
																			if (BgL_testz00_3674)
																				{	/* Ast/sexp.scm 141 */
																					bool_t BgL_testz00_3683;

																					{	/* Ast/sexp.scm 141 */
																						bool_t BgL_testz00_3684;

																						{	/* Ast/sexp.scm 141 */
																							BgL_valuez00_bglt
																								BgL_arg3326z00_1066;
																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_3685;
																								BgL_auxz00_3685 =
																									(BgL_variablez00_bglt)
																									(BgL_globalz00_1042);
																								BgL_arg3326z00_1066 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_3685))->
																									BgL_valuez00);
																							}
																							{	/* Ast/sexp.scm 141 */
																								obj_t BgL_obj1913z00_2179;

																								BgL_obj1913z00_2179 =
																									(obj_t) (BgL_arg3326z00_1066);
																								BgL_testz00_3684 =
																									BGl_iszd2azf3z21zz__objectz00
																									(BgL_obj1913z00_2179,
																									BGl_cfunz00zzast_varz00);
																							}
																						}
																						if (BgL_testz00_3684)
																							{	/* Ast/sexp.scm 142 */
																								bool_t BgL_testz00_3690;

																								{	/* Ast/sexp.scm 142 */
																									obj_t BgL_arg3325z00_1065;

																									BgL_arg3325z00_1065 =
																										BGl_thezd2backendzd2zzbackend_backendz00
																										();
																									{
																										BgL_backendz00_bglt
																											BgL_auxz00_3692;
																										BgL_auxz00_3692 =
																											(BgL_backendz00_bglt)
																											(BgL_arg3325z00_1065);
																										BgL_testz00_3690 =
																											(((BgL_backendz00_bglt)
																												CREF(BgL_auxz00_3692))->
																											BgL_foreignzd2closurezd2);
																									}
																								}
																								if (BgL_testz00_3690)
																									{	/* Ast/sexp.scm 142 */
																										BgL_testz00_3683 =
																											((bool_t) 0);
																									}
																								else
																									{	/* Ast/sexp.scm 142 */
																										if (
																											(BgL_sitez00_20 ==
																												CNST_TABLE_REF(((long)
																														22))))
																											{	/* Ast/sexp.scm 143 */
																												BgL_testz00_3683 =
																													((bool_t) 0);
																											}
																										else
																											{	/* Ast/sexp.scm 143 */
																												BgL_testz00_3683 =
																													((bool_t) 1);
																											}
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 141 */
																								BgL_testz00_3683 = ((bool_t) 0);
																							}
																					}
																					if (BgL_testz00_3683)
																						{	/* Ast/sexp.scm 145 */
																							obj_t BgL_arg3316z00_1056;

																							{	/* Ast/sexp.scm 145 */
																								obj_t BgL_arg3318z00_1058;

																								{	/* Ast/sexp.scm 145 */
																									obj_t BgL_arg3320z00_1060;

																									BgL_arg3320z00_1060 =
																										BGl_thezd2backendzd2zzbackend_backendz00
																										();
																									{
																										BgL_backendz00_bglt
																											BgL_auxz00_3699;
																										BgL_auxz00_3699 =
																											(BgL_backendz00_bglt)
																											(BgL_arg3320z00_1060);
																										BgL_arg3318z00_1058 =
																											(((BgL_backendz00_bglt)
																												CREF(BgL_auxz00_3699))->
																											BgL_namez00);
																									}
																								}
																								{	/* Ast/sexp.scm 145 */
																									obj_t BgL_list3319z00_1059;

																									BgL_list3319z00_1059 =
																										MAKE_PAIR
																										(BgL_arg3318z00_1058, BNIL);
																									BgL_arg3316z00_1056 =
																										BGl_formatz00zz__r4_output_6_10_3z00
																										(BGl_string3888z00zzast_sexpz00,
																										BgL_list3319z00_1059);
																								}
																							}
																							BgL_auxz00_3622 =
																								(obj_t)
																								(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																								(BgL_arg3316z00_1056,
																									BgL_expz00_17,
																									BgL_locz00_19));
																						}
																					else
																						{	/* Ast/sexp.scm 149 */
																							BgL_typez00_bglt
																								BgL_arg3321z00_1061;
																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_3706;
																								BgL_auxz00_3706 =
																									(BgL_variablez00_bglt)
																									(BgL_globalz00_1042);
																								BgL_arg3321z00_1061 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_3706))->
																									BgL_typez00);
																							}
																							BgL_auxz00_3622 =
																								(obj_t)
																								(BGl_makezd2closurezd2zzast_nodez00
																								(BgL_locz00_19,
																									BgL_arg3321z00_1061,
																									(BgL_variablez00_bglt)
																									(BgL_globalz00_1042)));
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 153 */
																					BgL_typez00_bglt BgL_arg3327z00_1067;

																					{
																						BgL_variablez00_bglt
																							BgL_auxz00_3712;
																						BgL_auxz00_3712 =
																							(BgL_variablez00_bglt)
																							(BgL_globalz00_1042);
																						BgL_arg3327z00_1067 =
																							(((BgL_variablez00_bglt)
																								CREF(BgL_auxz00_3712))->
																							BgL_typez00);
																					}
																					BgL_auxz00_3622 =
																						(obj_t)
																						(BGl_makezd2varzd2zzast_nodez00
																						(BgL_locz00_19, BgL_arg3327z00_1067,
																							(BgL_variablez00_bglt)
																							(BgL_globalz00_1042)));
																				}
																		}
																	}
															}
														else
															{	/* Ast/sexp.scm 134 */
																BgL_auxz00_3622 =
																	(obj_t)
																	(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																	(BGl_string3887z00zzast_sexpz00,
																		BgL_expz00_17, BgL_locz00_19));
															}
													}
											}
										else
											{	/* Ast/sexp.scm 97 */
												bool_t BgL_testz00_3720;

												if (BGl_iszd2azf3z21zz__objectz00(BgL_atomz00_867,
														BGl_localz00zzast_varz00))
													{	/* Ast/sexp.scm 97 */
														BgL_testz00_3720 = ((bool_t) 1);
													}
												else
													{	/* Ast/sexp.scm 97 */
														BgL_testz00_3720 =
															BGl_iszd2azf3z21zz__objectz00(BgL_atomz00_867,
															BGl_globalz00zzast_varz00);
													}
												if (BgL_testz00_3720)
													{	/* Ast/sexp.scm 97 */
														BGl_usezd2variablez12zc0zzast_sexpz00(
															(BgL_variablez00_bglt) (BgL_atomz00_867),
															BgL_locz00_19, BgL_sitez00_20);
														{	/* Ast/sexp.scm 99 */
															bool_t BgL_testz00_3726;

															if (
																(BgL_sitez00_20 == CNST_TABLE_REF(((long) 19))))
																{	/* Ast/sexp.scm 99 */
																	BgL_testz00_3726 = ((bool_t) 0);
																}
															else
																{	/* Ast/sexp.scm 99 */
																	BgL_valuez00_bglt BgL_arg3338z00_1078;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3730;

																		BgL_auxz00_3730 =
																			(BgL_variablez00_bglt) (BgL_atomz00_867);
																		BgL_arg3338z00_1078 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3730))->BgL_valuez00);
																	}
																	{	/* Ast/sexp.scm 99 */
																		obj_t BgL_obj1751z00_2187;

																		BgL_obj1751z00_2187 =
																			(obj_t) (BgL_arg3338z00_1078);
																		BgL_testz00_3726 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj1751z00_2187,
																			BGl_funz00zzast_varz00);
																	}
																}
															if (BgL_testz00_3726)
																{	/* Ast/sexp.scm 102 */
																	BgL_typez00_bglt BgL_arg3335z00_1075;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3735;

																		BgL_auxz00_3735 =
																			(BgL_variablez00_bglt) (BgL_atomz00_867);
																		BgL_arg3335z00_1075 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3735))->BgL_typez00);
																	}
																	BgL_auxz00_3622 =
																		(obj_t) (BGl_makezd2closurezd2zzast_nodez00
																		(BgL_locz00_19, BgL_arg3335z00_1075,
																			(BgL_variablez00_bglt)
																			(BgL_atomz00_867)));
																}
															else
																{	/* Ast/sexp.scm 106 */
																	BgL_typez00_bglt BgL_arg3336z00_1076;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3741;

																		BgL_auxz00_3741 =
																			(BgL_variablez00_bglt) (BgL_atomz00_867);
																		BgL_arg3336z00_1076 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3741))->BgL_typez00);
																	}
																	BgL_auxz00_3622 =
																		(obj_t) (BGl_makezd2varzd2zzast_nodez00
																		(BgL_locz00_19, BgL_arg3336z00_1076,
																			(BgL_variablez00_bglt)
																			(BgL_atomz00_867)));
																}
														}
													}
												else
													{	/* Ast/sexp.scm 108 */
														bool_t BgL_testz00_3747;

														if (STRUCTP(BgL_atomz00_867))
															{	/* Ast/sexp.scm 108 */
																BgL_testz00_3747 = ((bool_t) 1);
															}
														else
															{	/* Ast/sexp.scm 108 */
																if (VECTORP(BgL_atomz00_867))
																	{	/* Ast/sexp.scm 109 */
																		BgL_testz00_3747 = ((bool_t) 1);
																	}
																else
																	{	/* Ast/sexp.scm 109 */
																		BgL_testz00_3747 =
																			BGL_OBJECTP(BgL_atomz00_867);
																	}
															}
														if (BgL_testz00_3747)
															{	/* Ast/sexp.scm 108 */
																BgL_auxz00_3622 =
																	(obj_t)
																	(BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
																	(BGl_string3889z00zzast_sexpz00,
																		BgL_expz00_17, BgL_locz00_19));
															}
														else
															{	/* Ast/sexp.scm 115 */
																BgL_typez00_bglt BgL_arg3340z00_1080;

																BgL_arg3340z00_1080 =
																	BGl_typeofzd2atomzd2zztype_typeofz00
																	(BgL_atomz00_867);
																BgL_auxz00_3622 =
																	(obj_t) (BGl_makezd2atomzd2zzast_nodez00
																	(BgL_locz00_19, BgL_arg3340z00_1080,
																		BgL_atomz00_867));
															}
													}
											}
										return (BgL_nodez00_bglt) (BgL_auxz00_3622);
									}
							}
					}
			}
		}
	}



/* liip */
	obj_t BGl_liipz00zzast_sexpz00(obj_t BgL_argsz00_1370)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 349 */
			if (NULLP(BgL_argsz00_1370))
				{	/* Ast/sexp.scm 350 */
					return CNST_TABLE_REF(((long) 30));
				}
			else
				{	/* Ast/sexp.scm 352 */
					obj_t BgL_arg3550z00_1373;

					obj_t BgL_arg3552z00_1374;

					BgL_arg3550z00_1373 = CNST_TABLE_REF(((long) 31));
					{	/* Ast/sexp.scm 352 */
						obj_t BgL_arg3553z00_1375;

						obj_t BgL_arg3554z00_1376;

						BgL_arg3553z00_1375 = CAR(BgL_argsz00_1370);
						BgL_arg3554z00_1376 =
							BGl_liipz00zzast_sexpz00(CDR(BgL_argsz00_1370));
						{	/* Ast/sexp.scm 352 */
							obj_t BgL_list3556z00_1378;

							{	/* Ast/sexp.scm 352 */
								obj_t BgL_arg3557z00_1379;

								BgL_arg3557z00_1379 = MAKE_PAIR(BNIL, BNIL);
								BgL_list3556z00_1378 =
									MAKE_PAIR(BgL_arg3554z00_1376, BgL_arg3557z00_1379);
							}
							BgL_arg3552z00_1374 =
								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_arg3553z00_1375,
								BgL_list3556z00_1378);
					}}
					return MAKE_PAIR(BgL_arg3550z00_1373, BgL_arg3552z00_1374);
				}
		}
	}



/* loop */
	obj_t BGl_loopz00zzast_sexpz00(obj_t BgL_expz00_2591, obj_t BgL_locz00_2590,
		obj_t BgL_varsz00_1332, obj_t BgL_argsz00_1333)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 334 */
		BGl_loopz00zzast_sexpz00:
			if (NULLP(BgL_varsz00_1332))
				{	/* Ast/sexp.scm 337 */
					if (NULLP(BgL_argsz00_1333))
						{	/* Ast/sexp.scm 338 */
							return BNIL;
						}
					else
						{	/* Ast/sexp.scm 338 */
							return
								BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_2590,
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00()),
								BGl_string3891z00zzast_sexpz00, BgL_expz00_2591, BNIL);
						}
				}
			else
				{	/* Ast/sexp.scm 337 */
					if (PAIRP(BgL_varsz00_1332))
						{	/* Ast/sexp.scm 345 */
							if (BGl_dssslzd2namedzd2constantzf3zf3zztools_dssslz00(CAR
									(BgL_varsz00_1332)))
								{	/* Ast/sexp.scm 355 */
									obj_t BgL_argz00_1343;

									BgL_argz00_1343 =
										BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(CDR
										(BgL_varsz00_1332));
									if (CBOOL(BgL_argz00_1343))
										{
											obj_t BgL_varsz00_3786;

											BgL_varsz00_3786 = BgL_argz00_1343;
											BgL_varsz00_1332 = BgL_varsz00_3786;
											goto BGl_loopz00zzast_sexpz00;
										}
									else
										{
											obj_t BgL_varsz00_3787;

											BgL_varsz00_3787 = BNIL;
											BgL_varsz00_1332 = BgL_varsz00_3787;
											goto BGl_loopz00zzast_sexpz00;
										}
								}
							else
								{	/* Ast/sexp.scm 360 */
									bool_t BgL_testz00_3788;

									{	/* Ast/sexp.scm 360 */
										obj_t BgL_auxz00_3789;

										BgL_auxz00_3789 = CAR(BgL_varsz00_1332);
										BgL_testz00_3788 = SYMBOLP(BgL_auxz00_3789);
									}
									if (BgL_testz00_3788)
										{	/* Ast/sexp.scm 360 */
											if (NULLP(BgL_argsz00_1333))
												{	/* Ast/sexp.scm 366 */
													return
														BGl_userzd2errorzf2locationz20zztools_errorz00
														(BgL_locz00_2590,
														BGl_shapez00zztools_shapez00
														(BGl_currentzd2functionzd2zztools_errorz00()),
														BGl_string3891z00zzast_sexpz00, BgL_expz00_2591,
														BNIL);
												}
											else
												{	/* Ast/sexp.scm 373 */
													obj_t BgL_arg3530z00_1351;

													obj_t BgL_arg3531z00_1352;

													{	/* Ast/sexp.scm 373 */
														obj_t BgL_arg3532z00_1353;

														obj_t BgL_arg3533z00_1354;

														BgL_arg3532z00_1353 = CAR(BgL_varsz00_1332);
														BgL_arg3533z00_1354 = CAR(BgL_argsz00_1333);
														{	/* Ast/sexp.scm 373 */
															obj_t BgL_list3534z00_1355;

															{	/* Ast/sexp.scm 373 */
																obj_t BgL_arg3535z00_1356;

																BgL_arg3535z00_1356 =
																	MAKE_PAIR(BgL_arg3533z00_1354, BNIL);
																BgL_list3534z00_1355 =
																	MAKE_PAIR(BgL_arg3532z00_1353,
																	BgL_arg3535z00_1356);
															}
															BgL_arg3530z00_1351 = BgL_list3534z00_1355;
														}
													}
													BgL_arg3531z00_1352 =
														BGl_loopz00zzast_sexpz00(BgL_expz00_2591,
														BgL_locz00_2590, CDR(BgL_varsz00_1332),
														CDR(BgL_argsz00_1333));
													return MAKE_PAIR(BgL_arg3530z00_1351,
														BgL_arg3531z00_1352);
												}
										}
									else
										{	/* Ast/sexp.scm 360 */
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_2590,
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00()),
												BGl_string3892z00zzast_sexpz00, BgL_expz00_2591, BNIL);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 349 */
							obj_t BgL_arg3544z00_1365;

							{	/* Ast/sexp.scm 349 */
								obj_t BgL_arg3546z00_1367;

								BgL_arg3546z00_1367 =
									BGl_liipz00zzast_sexpz00(BgL_argsz00_1333);
								{	/* Ast/sexp.scm 347 */
									obj_t BgL_list3547z00_1368;

									{	/* Ast/sexp.scm 347 */
										obj_t BgL_arg3548z00_1369;

										BgL_arg3548z00_1369 = MAKE_PAIR(BgL_arg3546z00_1367, BNIL);
										BgL_list3547z00_1368 =
											MAKE_PAIR(BgL_varsz00_1332, BgL_arg3548z00_1369);
									}
									BgL_arg3544z00_1365 = BgL_list3547z00_1368;
								}
							}
							{	/* Ast/sexp.scm 346 */
								obj_t BgL_list3545z00_1366;

								BgL_list3545z00_1366 = MAKE_PAIR(BgL_arg3544z00_1365, BNIL);
								return BgL_list3545z00_1366;
							}
						}
				}
		}
	}



/* _sexp->node3866 */
	obj_t BGl__sexpzd2ze3node3866z31zzast_sexpz00(obj_t BgL_envz00_2557,
		obj_t BgL_expz00_2558, obj_t BgL_stackz00_2559, obj_t BgL_locz00_2560,
		obj_t BgL_sitez00_2561)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 80 */
			return
				(obj_t) (BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_2558,
					BgL_stackz00_2559, BgL_locz00_2560, BgL_sitez00_2561));
		}
	}



/* <anonymous:3563> */
	obj_t BGl_zc3anonymousza33563ze3z83zzast_sexpz00(obj_t BgL_envz00_2562,
		obj_t BgL_objz00_2564, obj_t BgL_procz00_2565, obj_t BgL_msgz00_2566)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 379 */
			{	/* Ast/sexp.scm 380 */
				obj_t BgL_locz00_2563;

				BgL_locz00_2563 = PROCEDURE_REF(BgL_envz00_2562, (int) (((long) 0)));
				{
					obj_t BgL_objz00_1385;

					obj_t BgL_procz00_1386;

					obj_t BgL_msgz00_1387;

					BgL_objz00_1385 = BgL_objz00_2564;
					BgL_procz00_1386 = BgL_procz00_2565;
					BgL_msgz00_1387 = BgL_msgz00_2566;
					return
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_2563,
						BgL_objz00_1385, BgL_procz00_1386, BgL_msgz00_1387, BNIL);
				}
			}
		}
	}



/* sexp*->node */
	BGL_EXPORTED_DEF obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t
		BgL_expza2za2_21, obj_t BgL_stackz00_22, obj_t BgL_locz00_23,
		obj_t BgL_sitez00_24)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 556 */
			{
				obj_t BgL_expsz00_1583;

				obj_t BgL_resz00_1584;

				obj_t BgL_locz00_1585;

				BgL_expsz00_1583 = BgL_expza2za2_21;
				BgL_resz00_1584 = BNIL;
				BgL_locz00_1585 = BgL_locz00_23;
			BgL_loopz00_1586:
				if (NULLP(BgL_expsz00_1583))
					{	/* Ast/sexp.scm 561 */
						return
							(obj_t) (BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
							(BGl_string3893z00zzast_sexpz00, BgL_expsz00_1583,
								BgL_locz00_1585));
					}
				else
					{	/* Ast/sexp.scm 561 */
						if (NULLP(CDR(BgL_expsz00_1583)))
							{	/* Ast/sexp.scm 564 */
								obj_t BgL_locz00_1589;

								obj_t BgL_nsitez00_1590;

								BgL_locz00_1589 =
									BGl_findzd2locationzf2locz20zztools_locationz00(CAR
									(BgL_expsz00_1583),
									BGl_findzd2locationzf2locz20zztools_locationz00
									(BgL_expsz00_1583, BgL_locz00_1585));
								if ((BgL_sitez00_24 == CNST_TABLE_REF(((long) 19))))
									{	/* Ast/sexp.scm 566 */
										BgL_nsitez00_1590 = CNST_TABLE_REF(((long) 1));
									}
								else
									{	/* Ast/sexp.scm 566 */
										BgL_nsitez00_1590 = BgL_sitez00_24;
									}
								{	/* Ast/sexp.scm 567 */
									obj_t BgL_arg3701z00_1591;

									{	/* Ast/sexp.scm 567 */
										BgL_nodez00_bglt BgL_arg3702z00_1592;

										BgL_arg3702z00_1592 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(CAR(BgL_expsz00_1583),
											BgL_stackz00_22, BgL_locz00_1589, BgL_nsitez00_1590);
										BgL_arg3701z00_1591 =
											MAKE_PAIR((obj_t) (BgL_arg3702z00_1592), BgL_resz00_1584);
									}
									return bgl_reverse_bang(BgL_arg3701z00_1591);
								}
							}
						else
							{	/* Ast/sexp.scm 569 */
								obj_t BgL_locz00_1597;

								BgL_locz00_1597 =
									BGl_findzd2locationzf2locz20zztools_locationz00(CAR
									(BgL_expsz00_1583),
									BGl_findzd2locationzf2locz20zztools_locationz00
									(BgL_expsz00_1583, BgL_locz00_1585));
								{	/* Ast/sexp.scm 571 */
									obj_t BgL_arg3707z00_1598;

									obj_t BgL_arg3708z00_1599;

									BgL_arg3707z00_1598 = CDR(BgL_expsz00_1583);
									{	/* Ast/sexp.scm 572 */
										BgL_nodez00_bglt BgL_arg3709z00_1600;

										{	/* Ast/sexp.scm 572 */
											obj_t BgL_arg3711z00_1601;

											obj_t BgL_arg3712z00_1602;

											BgL_arg3711z00_1601 = CAR(BgL_expsz00_1583);
											BgL_arg3712z00_1602 = CNST_TABLE_REF(((long) 1));
											BgL_arg3709z00_1600 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3711z00_1601,
												BgL_stackz00_22, BgL_locz00_1597, BgL_arg3712z00_1602);
										}
										BgL_arg3708z00_1599 =
											MAKE_PAIR((obj_t) (BgL_arg3709z00_1600), BgL_resz00_1584);
									}
									{
										obj_t BgL_locz00_3847;

										obj_t BgL_resz00_3846;

										obj_t BgL_expsz00_3845;

										BgL_expsz00_3845 = BgL_arg3707z00_1598;
										BgL_resz00_3846 = BgL_arg3708z00_1599;
										BgL_locz00_3847 = BgL_locz00_1597;
										BgL_locz00_1585 = BgL_locz00_3847;
										BgL_resz00_1584 = BgL_resz00_3846;
										BgL_expsz00_1583 = BgL_expsz00_3845;
										goto BgL_loopz00_1586;
									}
								}
							}
					}
			}
		}
	}



/* _sexp*->node3867 */
	obj_t BGl__sexpza2zd2ze3node3867z93zzast_sexpz00(obj_t BgL_envz00_2567,
		obj_t BgL_expza2za2_2568, obj_t BgL_stackz00_2569, obj_t BgL_locz00_2570,
		obj_t BgL_sitez00_2571)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 556 */
			return
				BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_2568,
				BgL_stackz00_2569, BgL_locz00_2570, BgL_sitez00_2571);
		}
	}



/* lookup */
	obj_t BGl_lookupz00zzast_sexpz00(obj_t BgL_namez00_25, obj_t BgL_stackz00_26)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 585 */
			{	/* Ast/sexp.scm 586 */
				bool_t BgL_testz00_3849;

				if ((BgL_namez00_25 == BGl_za2cachezd2nameza2zd2zzast_sexpz00))
					{	/* Ast/sexp.scm 586 */
						BgL_testz00_3849 =
							(BgL_stackz00_26 == BGl_za2cachezd2stackza2zd2zzast_sexpz00);
					}
				else
					{	/* Ast/sexp.scm 586 */
						BgL_testz00_3849 = ((bool_t) 0);
					}
				if (BgL_testz00_3849)
					{	/* Ast/sexp.scm 586 */
						return BGl_za2cachezd2resza2zd2zzast_sexpz00;
					}
				else
					{	/* Ast/sexp.scm 586 */
						BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_25;
						BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_26;
						{
							obj_t BgL_stackz00_1607;

							BgL_stackz00_1607 = BgL_stackz00_26;
						BgL_loopz00_1608:
							if (NULLP(BgL_stackz00_1607))
								{	/* Ast/sexp.scm 594 */
									BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE;
									return BFALSE;
								}
							else
								{	/* Ast/sexp.scm 597 */
									bool_t BgL_testz00_3855;

									{	/* Ast/sexp.scm 597 */
										obj_t BgL_auxz00_3856;

										{	/* Ast/sexp.scm 597 */
											BgL_variablez00_bglt BgL_obj1498z00_2490;

											{	/* Ast/sexp.scm 597 */
												obj_t BgL_pairz00_2489;

												BgL_pairz00_2489 = BgL_stackz00_1607;
												BgL_obj1498z00_2490 =
													(BgL_variablez00_bglt) (CAR(BgL_pairz00_2489));
											}
											BgL_auxz00_3856 =
												(((BgL_variablez00_bglt) CREF(BgL_obj1498z00_2490))->
												BgL_idz00);
										}
										BgL_testz00_3855 = (BgL_auxz00_3856 == BgL_namez00_25);
									}
									if (BgL_testz00_3855)
										{	/* Ast/sexp.scm 597 */
											BGl_za2cachezd2resza2zd2zzast_sexpz00 =
												CAR(BgL_stackz00_1607);
											return CAR(BgL_stackz00_1607);
										}
									else
										{
											obj_t BgL_stackz00_3863;

											BgL_stackz00_3863 = CDR(BgL_stackz00_1607);
											BgL_stackz00_1607 = BgL_stackz00_3863;
											goto BgL_loopz00_1608;
										}
								}
						}
					}
			}
		}
	}



/* use-variable! */
	BGL_EXPORTED_DEF obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_27,
		obj_t BgL_locz00_28, obj_t BgL_sitez00_29)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 606 */
			if ((BgL_sitez00_29 == CNST_TABLE_REF(((long) 12))))
				{	/* Ast/sexp.scm 609 */
					BgL_variablez00_bglt BgL_obj1511z00_2494;

					obj_t BgL_val1510z00_2495;

					BgL_obj1511z00_2494 = BgL_varz00_27;
					BgL_val1510z00_2495 = CNST_TABLE_REF(((long) 32));
					((((BgL_variablez00_bglt) CREF(BgL_obj1511z00_2494))->BgL_accessz00) =
						((obj_t) BgL_val1510z00_2495), BUNSPEC);
				}
			else
				{	/* Ast/sexp.scm 608 */
					BFALSE;
				}
			{	/* Ast/sexp.scm 610 */
				BgL_valuez00_bglt BgL_valz00_1616;

				BgL_valz00_1616 =
					(((BgL_variablez00_bglt) CREF(BgL_varz00_27))->BgL_valuez00);
				{	/* Ast/sexp.scm 611 */
					bool_t BgL_testz00_3871;

					if ((BgL_sitez00_29 == CNST_TABLE_REF(((long) 12))))
						{	/* Ast/sexp.scm 611 */
							obj_t BgL_obj1751z00_2497;

							BgL_obj1751z00_2497 = (obj_t) (BgL_valz00_1616);
							BgL_testz00_3871 =
								BGl_iszd2azf3z21zz__objectz00(BgL_obj1751z00_2497,
								BGl_funz00zzast_varz00);
						}
					else
						{	/* Ast/sexp.scm 611 */
							BgL_testz00_3871 = ((bool_t) 0);
						}
					if (BgL_testz00_3871)
						{	/* Ast/sexp.scm 612 */
							obj_t BgL_arg3726z00_1619;

							BgL_arg3726z00_1619 =
								BGl_shapez00zztools_shapez00((obj_t) (BgL_varz00_27));
							return
								(obj_t) (BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
								(BGl_string3894z00zzast_sexpz00, BgL_arg3726z00_1619,
									BgL_locz00_28));
						}
					else
						{	/* Ast/sexp.scm 611 */
							return BFALSE;
						}
				}
			}
		}
	}



/* _use-variable!3868 */
	obj_t BGl__usezd2variablez123868zc0zzast_sexpz00(obj_t BgL_envz00_2572,
		obj_t BgL_varz00_2573, obj_t BgL_locz00_2574, obj_t BgL_sitez00_2575)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 606 */
			return
				BGl_usezd2variablez12zc0zzast_sexpz00(
				(BgL_variablez00_bglt) (BgL_varz00_2573), BgL_locz00_2574,
				BgL_sitez00_2575);
		}
	}



/* error-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_30,
		obj_t BgL_expz00_31, obj_t BgL_locz00_32)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 617 */
			{	/* Ast/sexp.scm 619 */
				obj_t BgL_arg3728z00_1621;

				BgL_nodez00_bglt BgL_arg3729z00_1622;

				BgL_arg3728z00_1621 =
					BGl_shapez00zztools_shapez00(BGl_currentzd2functionzd2zztools_errorz00
					());
				BgL_arg3729z00_1622 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 30)), BNIL,
					BgL_locz00_32, CNST_TABLE_REF(((long) 1)));
				{	/* Ast/sexp.scm 618 */
					obj_t BgL_list3730z00_1623;

					BgL_list3730z00_1623 = MAKE_PAIR((obj_t) (BgL_arg3729z00_1622), BNIL);
					return
						(BgL_nodez00_bglt) (BGl_userzd2errorzf2locationz20zztools_errorz00
						(BgL_locz00_32, BgL_arg3728z00_1621, BgL_msgz00_30, BgL_expz00_31,
							BgL_list3730z00_1623));
				}
			}
		}
	}



/* _error-sexp->node3869 */
	obj_t BGl__errorzd2sexpzd2ze3node3869ze3zzast_sexpz00(obj_t BgL_envz00_2576,
		obj_t BgL_msgz00_2577, obj_t BgL_expz00_2578, obj_t BgL_locz00_2579)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 617 */
			return
				(obj_t) (BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_2577,
					BgL_expz00_2578, BgL_locz00_2579));
		}
	}



/* define-primop-ref->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_33, BgL_nodez00_bglt BgL_refz00_34)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 627 */
			{	/* Ast/sexp.scm 628 */
				BgL_nodez00_bglt BgL_funz00_1625;

				BgL_funz00_1625 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 33)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 19)));
				{	/* Ast/sexp.scm 629 */
					bool_t BgL_testz00_3897;

					{	/* Ast/sexp.scm 629 */
						obj_t BgL_obj2064z00_2498;

						BgL_obj2064z00_2498 = (obj_t) (BgL_funz00_1625);
						BgL_testz00_3897 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj2064z00_2498,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_3897)
						{	/* Ast/sexp.scm 630 */
							obj_t BgL_arg3734z00_1628;

							{	/* Ast/sexp.scm 632 */
								BgL_nodez00_bglt BgL_arg3735z00_1629;

								{	/* Ast/sexp.scm 632 */
									obj_t BgL_arg3738z00_1632;

									obj_t BgL_arg3740z00_1634;

									{	/* Ast/sexp.scm 632 */
										obj_t BgL_arg3741z00_1635;

										obj_t BgL_arg3742z00_1636;

										BgL_arg3741z00_1635 = CNST_TABLE_REF(((long) 21));
										{	/* Ast/sexp.scm 632 */
											obj_t BgL_arg3743z00_1637;

											{
												BgL_variablez00_bglt BgL_auxz00_3901;

												BgL_auxz00_3901 =
													(BgL_variablez00_bglt) (BgL_globalz00_33);
												BgL_arg3743z00_1637 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_3901))->
													BgL_idz00);
											}
											{	/* Ast/sexp.scm 632 */
												obj_t BgL_list3745z00_1639;

												BgL_list3745z00_1639 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3742z00_1636 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3743z00_1637, BgL_list3745z00_1639);
										}}
										BgL_arg3738z00_1632 =
											MAKE_PAIR(BgL_arg3741z00_1635, BgL_arg3742z00_1636);
									}
									BgL_arg3740z00_1634 = CNST_TABLE_REF(((long) 1));
									BgL_arg3735z00_1629 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3738z00_1632,
										BNIL, BFALSE, BgL_arg3740z00_1634);
								}
								{	/* Ast/sexp.scm 632 */
									obj_t BgL_list3736z00_1630;

									{	/* Ast/sexp.scm 632 */
										obj_t BgL_arg3737z00_1631;

										BgL_arg3737z00_1631 =
											MAKE_PAIR((obj_t) (BgL_refz00_34), BNIL);
										BgL_list3736z00_1630 =
											MAKE_PAIR(
											(obj_t) (BgL_arg3735z00_1629), BgL_arg3737z00_1631);
									}
									BgL_arg3734z00_1628 = BgL_list3736z00_1630;
							}}
							return
								(BgL_nodez00_bglt) (BGl_makezd2appzd2zzast_nodez00(BFALSE,
									(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00), BUNSPEC,
									BINT(((long) -1)),
									(BgL_varz00_bglt) (BgL_funz00_1625), BgL_arg3734z00_1628));
						}
					else
						{	/* Ast/sexp.scm 629 */
							return BgL_funz00_1625;
						}
				}
			}
		}
	}



/* _define-primop-ref->3870 */
	obj_t BGl__definezd2primopzd2refzd2ze33870z31zzast_sexpz00(obj_t
		BgL_envz00_2580, obj_t BgL_globalz00_2581, obj_t BgL_refz00_2582)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 627 */
			return
				(obj_t) (BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
					(BgL_globalz00_bglt) (BgL_globalz00_2581),
					(BgL_nodez00_bglt) (BgL_refz00_2582)));
		}
	}



/* define-primop->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_35)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 642 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				(BgL_variablez00_bglt) (BgL_globalz00_35), BFALSE,
				CNST_TABLE_REF(((long) 1)));
			{	/* Ast/sexp.scm 644 */
				BgL_nodez00_bglt BgL_funz00_1640;

				BgL_funz00_1640 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 34)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 19)));
				{	/* Ast/sexp.scm 645 */
					bool_t BgL_testz00_3928;

					{	/* Ast/sexp.scm 645 */
						obj_t BgL_obj2064z00_2502;

						BgL_obj2064z00_2502 = (obj_t) (BgL_funz00_1640);
						BgL_testz00_3928 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj2064z00_2502,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_3928)
						{	/* Ast/sexp.scm 646 */
							obj_t BgL_arg3748z00_1643;

							{	/* Ast/sexp.scm 648 */
								BgL_nodez00_bglt BgL_arg3749z00_1644;

								BgL_nodez00_bglt BgL_arg3750z00_1645;

								{	/* Ast/sexp.scm 648 */
									obj_t BgL_arg3753z00_1648;

									obj_t BgL_arg3755z00_1650;

									{	/* Ast/sexp.scm 648 */
										obj_t BgL_arg3756z00_1651;

										obj_t BgL_arg3757z00_1652;

										BgL_arg3756z00_1651 = CNST_TABLE_REF(((long) 21));
										{	/* Ast/sexp.scm 648 */
											obj_t BgL_arg3758z00_1653;

											{
												BgL_variablez00_bglt BgL_auxz00_3932;

												BgL_auxz00_3932 =
													(BgL_variablez00_bglt) (BgL_globalz00_35);
												BgL_arg3758z00_1653 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_3932))->
													BgL_idz00);
											}
											{	/* Ast/sexp.scm 648 */
												obj_t BgL_list3760z00_1655;

												BgL_list3760z00_1655 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg3757z00_1652 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg3758z00_1653, BgL_list3760z00_1655);
										}}
										BgL_arg3753z00_1648 =
											MAKE_PAIR(BgL_arg3756z00_1651, BgL_arg3757z00_1652);
									}
									BgL_arg3755z00_1650 = CNST_TABLE_REF(((long) 1));
									BgL_arg3749z00_1644 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg3753z00_1648,
										BNIL, BFALSE, BgL_arg3755z00_1650);
								}
								BgL_arg3750z00_1645 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(
									(obj_t) (BgL_globalz00_35), BNIL, BFALSE,
									CNST_TABLE_REF(((long) 1)));
								{	/* Ast/sexp.scm 648 */
									obj_t BgL_list3751z00_1646;

									{	/* Ast/sexp.scm 648 */
										obj_t BgL_arg3752z00_1647;

										BgL_arg3752z00_1647 =
											MAKE_PAIR((obj_t) (BgL_arg3750z00_1645), BNIL);
										BgL_list3751z00_1646 =
											MAKE_PAIR(
											(obj_t) (BgL_arg3749z00_1644), BgL_arg3752z00_1647);
									}
									BgL_arg3748z00_1643 = BgL_list3751z00_1646;
							}}
							return
								(BgL_nodez00_bglt) (BGl_makezd2appzd2zzast_nodez00(BFALSE,
									(BgL_typez00_bglt) (BGl_za2_za2z00zztype_cachez00), BUNSPEC,
									BINT(((long) -1)),
									(BgL_varz00_bglt) (BgL_funz00_1640), BgL_arg3748z00_1643));
						}
					else
						{	/* Ast/sexp.scm 645 */
							return BgL_funz00_1640;
						}
				}
			}
		}
	}



/* _define-primop->node3871 */
	obj_t BGl__definezd2primopzd2ze3node3871ze3zzast_sexpz00(obj_t
		BgL_envz00_2583, obj_t BgL_globalz00_2584)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 642 */
			return
				(obj_t) (BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
					(BgL_globalz00_bglt) (BgL_globalz00_2584)));
		}
	}



/* location->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_36)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 661 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				(BgL_variablez00_bglt) (BgL_globalz00_36), BFALSE,
				CNST_TABLE_REF(((long) 1)));
			{	/* Ast/sexp.scm 663 */
				BgL_nodez00_bglt BgL_funz00_1656;

				BgL_funz00_1656 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 35)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 19)));
				{	/* Ast/sexp.scm 664 */
					bool_t BgL_testz00_3961;

					{	/* Ast/sexp.scm 664 */
						obj_t BgL_obj2064z00_2506;

						BgL_obj2064z00_2506 = (obj_t) (BgL_funz00_1656);
						BgL_testz00_3961 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj2064z00_2506,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_3961)
						{	/* Ast/sexp.scm 665 */
							obj_t BgL_exprz00_1658;

							{	/* Ast/sexp.scm 665 */
								bool_t BgL_testz00_3964;

								{	/* Ast/sexp.scm 665 */
									obj_t BgL_arg3771z00_1668;

									BgL_arg3771z00_1668 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									{
										BgL_backendz00_bglt BgL_auxz00_3966;

										BgL_auxz00_3966 =
											(BgL_backendz00_bglt) (BgL_arg3771z00_1668);
										BgL_testz00_3964 =
											(((BgL_backendz00_bglt) CREF(BgL_auxz00_3966))->
											BgL_pragmazd2supportzd2);
									}
								}
								if (BgL_testz00_3964)
									{	/* Ast/sexp.scm 666 */
										obj_t BgL_arg3767z00_1664;

										obj_t BgL_arg3768z00_1665;

										BgL_arg3767z00_1664 = CNST_TABLE_REF(((long) 36));
										{	/* Ast/sexp.scm 666 */
											obj_t BgL_list3769z00_1666;

											{	/* Ast/sexp.scm 666 */
												obj_t BgL_arg3770z00_1667;

												BgL_arg3770z00_1667 = MAKE_PAIR(BNIL, BNIL);
												BgL_list3769z00_1666 =
													MAKE_PAIR(
													(obj_t) (BgL_globalz00_36), BgL_arg3770z00_1667);
											}
											BgL_arg3768z00_1665 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BGl_string3895z00zzast_sexpz00, BgL_list3769z00_1666);
										}
										BgL_exprz00_1658 =
											MAKE_PAIR(BgL_arg3767z00_1664, BgL_arg3768z00_1665);
									}
								else
									{	/* Ast/sexp.scm 665 */
										BgL_exprz00_1658 = (obj_t) (BgL_globalz00_36);
									}
							}
							{	/* Ast/sexp.scm 668 */
								obj_t BgL_arg3763z00_1660;

								{	/* Ast/sexp.scm 670 */
									BgL_nodez00_bglt BgL_arg3764z00_1661;

									BgL_arg3764z00_1661 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_exprz00_1658, BNIL,
										BFALSE, CNST_TABLE_REF(((long) 1)));
									{	/* Ast/sexp.scm 670 */
										obj_t BgL_list3765z00_1662;

										BgL_list3765z00_1662 =
											MAKE_PAIR((obj_t) (BgL_arg3764z00_1661), BNIL);
										BgL_arg3763z00_1660 = BgL_list3765z00_1662;
								}}
								return
									(BgL_nodez00_bglt) (BGl_makezd2appzd2zzast_nodez00(BFALSE,
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
										BUNSPEC, BINT(((long) -1)),
										(BgL_varz00_bglt) (BgL_funz00_1656), BgL_arg3763z00_1660));
						}}
					else
						{	/* Ast/sexp.scm 664 */
							return BgL_funz00_1656;
						}
				}
			}
		}
	}



/* _location->node3872 */
	obj_t BGl__locationzd2ze3node3872z31zzast_sexpz00(obj_t BgL_envz00_2585,
		obj_t BgL_globalz00_2586)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 661 */
			return
				(obj_t) (BGl_locationzd2ze3nodez31zzast_sexpz00(
					(BgL_globalz00_bglt) (BgL_globalz00_2586)));
		}
	}



/* make-anonymous-name */
	BGL_EXPORTED_DEF obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t
		BgL_locz00_37, obj_t BgL_prefz00_38)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 676 */
			{	/* Ast/sexp.scm 677 */
				obj_t BgL_prefz00_1669;

				{	/* Ast/sexp.scm 677 */
					bool_t BgL_testz00_3988;

					if (PAIRP(BgL_prefz00_38))
						{	/* Ast/sexp.scm 677 */
							obj_t BgL_auxz00_3991;

							BgL_auxz00_3991 = CAR(BgL_prefz00_38);
							BgL_testz00_3988 = STRINGP(BgL_auxz00_3991);
						}
					else
						{	/* Ast/sexp.scm 677 */
							BgL_testz00_3988 = ((bool_t) 0);
						}
					if (BgL_testz00_3988)
						{	/* Ast/sexp.scm 677 */
							BgL_prefz00_1669 = CAR(BgL_prefz00_38);
						}
					else
						{	/* Ast/sexp.scm 677 */
							BgL_prefz00_1669 = BGl_string3896z00zzast_sexpz00;
						}
				}
				{	/* Ast/sexp.scm 680 */
					bool_t BgL_testz00_3995;

					if (STRUCTP(BgL_locz00_37))
						{	/* Ast/sexp.scm 680 */
							BgL_testz00_3995 =
								(STRUCT_KEY(BgL_locz00_37) == CNST_TABLE_REF(((long) 13)));
						}
					else
						{	/* Ast/sexp.scm 680 */
							BgL_testz00_3995 = ((bool_t) 0);
						}
					if (BgL_testz00_3995)
						{	/* Ast/sexp.scm 681 */
							obj_t BgL_filez00_1671;

							obj_t BgL_linez00_1672;

							obj_t BgL_basez00_1673;

							BgL_filez00_1671 = STRUCT_REF(BgL_locz00_37, (int) (((long) 0)));
							BgL_linez00_1672 = STRUCT_REF(BgL_locz00_37, (int) (((long) 2)));
							BgL_basez00_1673 =
								SYMBOL_TO_STRING(BGl_gensymz00zz__r4_symbols_6_4z00
								(string_append_3(BGl_string3897z00zzast_sexpz00,
										BgL_prefz00_1669, BGl_string3898z00zzast_sexpz00)));
							{	/* Ast/sexp.scm 685 */
								bool_t BgL_testz00_4008;

								{	/* Ast/sexp.scm 685 */
									bool_t BgL_testz00_4009;

									if (
										((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00) >=
											((long) 1)))
										{	/* Ast/sexp.scm 686 */
											obj_t BgL_arg3792z00_1695;

											obj_t BgL_arg3793z00_1696;

											BgL_arg3792z00_1695 = CNST_TABLE_REF(((long) 37));
											{	/* Ast/sexp.scm 686 */
												obj_t BgL_arg3794z00_1697;

												BgL_arg3794z00_1697 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												{
													BgL_backendz00_bglt BgL_auxz00_4015;

													BgL_auxz00_4015 =
														(BgL_backendz00_bglt) (BgL_arg3794z00_1697);
													BgL_arg3793z00_1696 =
														(((BgL_backendz00_bglt) CREF(BgL_auxz00_4015))->
														BgL_debugzd2supportzd2);
											}}
											BgL_testz00_4009 =
												CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(BgL_arg3792z00_1695, BgL_arg3793z00_1696));
										}
									else
										{	/* Ast/sexp.scm 685 */
											BgL_testz00_4009 = ((bool_t) 0);
										}
									if (BgL_testz00_4009)
										{	/* Ast/sexp.scm 685 */
											BgL_testz00_4008 = ((bool_t) 1);
										}
									else
										{	/* Ast/sexp.scm 685 */
											BgL_testz00_4008 =
												(
												(long)
												CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00) >=
												((long) 1));
								}}
								if (BgL_testz00_4008)
									{	/* Ast/sexp.scm 688 */
										obj_t BgL_filez00_1675;

										if (bigloo_strncmp(BgL_filez00_1671,
												BGl_string3899z00zzast_sexpz00, ((long) 2)))
											{	/* Ast/sexp.scm 688 */
												BgL_filez00_1675 =
													c_substring(BgL_filez00_1671, ((long) 2),
													STRING_LENGTH(BgL_filez00_1671));
											}
										else
											{	/* Ast/sexp.scm 688 */
												BgL_filez00_1675 = BgL_filez00_1671;
											}
										{	/* Ast/sexp.scm 692 */
											obj_t BgL_arg3775z00_1676;

											{	/* Ast/sexp.scm 692 */
												char *BgL_arg3778z00_1679;

												{	/* Ast/sexp.scm 693 */

													BgL_arg3778z00_1679 =
														BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00
														(BgL_linez00_1672, BINT(((long) 10)));
												}
												{	/* Ast/sexp.scm 692 */
													obj_t BgL_list3780z00_1681;

													{	/* Ast/sexp.scm 692 */
														obj_t BgL_arg3781z00_1682;

														{	/* Ast/sexp.scm 692 */
															obj_t BgL_arg3782z00_1683;

															{	/* Ast/sexp.scm 692 */
																obj_t BgL_arg3783z00_1684;

																{	/* Ast/sexp.scm 692 */
																	obj_t BgL_arg3784z00_1685;

																	{	/* Ast/sexp.scm 692 */
																		obj_t BgL_arg3785z00_1686;

																		BgL_arg3785z00_1686 =
																			MAKE_PAIR(BGl_string3900z00zzast_sexpz00,
																			BNIL);
																		BgL_arg3784z00_1685 =
																			MAKE_PAIR(string_to_bstring
																			(BgL_arg3778z00_1679),
																			BgL_arg3785z00_1686);
																	}
																	BgL_arg3783z00_1684 =
																		MAKE_PAIR(BGl_string3898z00zzast_sexpz00,
																		BgL_arg3784z00_1685);
																}
																BgL_arg3782z00_1683 =
																	MAKE_PAIR(BgL_filez00_1675,
																	BgL_arg3783z00_1684);
															}
															BgL_arg3781z00_1682 =
																MAKE_PAIR(BGl_string3898z00zzast_sexpz00,
																BgL_arg3782z00_1683);
														}
														BgL_list3780z00_1681 =
															MAKE_PAIR(BgL_basez00_1673, BgL_arg3781z00_1682);
													}
													BgL_arg3775z00_1676 =
														BGl_stringzd2appendzd2zz__r4_strings_6_7z00
														(BgL_list3780z00_1681);
											}}
											return
												string_to_symbol(BSTRING_TO_STRING
												(BgL_arg3775z00_1676));
										}
									}
								else
									{	/* Ast/sexp.scm 696 */
										obj_t BgL_arg3789z00_1692;

										BgL_arg3789z00_1692 =
											string_append(BgL_basez00_1673,
											BGl_string3900z00zzast_sexpz00);
										return
											string_to_symbol(BSTRING_TO_STRING(BgL_arg3789z00_1692));
									}
							}
						}
					else
						{	/* Ast/sexp.scm 697 */
							obj_t BgL_arg3797z00_1700;

							{	/* Ast/sexp.scm 697 */
								obj_t BgL_arg3798z00_1701;

								obj_t BgL_arg3799z00_1702;

								BgL_arg3798z00_1701 =
									SYMBOL_TO_STRING(BGl_gensymz00zz__r4_symbols_6_4z00
									(string_append_3(BGl_string3897z00zzast_sexpz00,
											BgL_prefz00_1669, BGl_string3901z00zzast_sexpz00)));
								{	/* Ast/sexp.scm 697 */
									obj_t BgL_symbolz00_2543;

									BgL_symbolz00_2543 = CNST_TABLE_REF(((long) 38));
									BgL_arg3799z00_1702 = SYMBOL_TO_STRING(BgL_symbolz00_2543);
								}
								{	/* Ast/sexp.scm 697 */
									obj_t BgL_list3800z00_1703;

									{	/* Ast/sexp.scm 697 */
										obj_t BgL_arg3801z00_1704;

										BgL_arg3801z00_1704 = MAKE_PAIR(BgL_arg3799z00_1702, BNIL);
										BgL_list3800z00_1703 =
											MAKE_PAIR(BgL_arg3798z00_1701, BgL_arg3801z00_1704);
									}
									BgL_arg3797z00_1700 =
										BGl_stringzd2appendzd2zz__r4_strings_6_7z00
										(BgL_list3800z00_1703);
							}}
							return string_to_symbol(BSTRING_TO_STRING(BgL_arg3797z00_1700));
						}
				}
			}
		}
	}



/* _make-anonymous-name */
	obj_t BGl__makezd2anonymouszd2namez00zzast_sexpz00(obj_t BgL_envz00_2587,
		obj_t BgL_locz00_2588, obj_t BgL_prefz00_2589)
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 676 */
			return
				BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_2588,
				BgL_prefz00_2589);
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
	{
		AN_OBJECT;
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_prognz00(((long) 139728077),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 315458190),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_buildz00(((long) 46924743),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long) 292906466),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_labelsz00(((long) 473735386),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 387357065),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_exitz00(((long) 341189244),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 271227279),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 121557513),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 453255680),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 53594424),
				BSTRING_TO_STRING(BGl_string3902z00zzast_sexpz00));
		}
	}

#ifdef __cplusplus
}
#endif
