/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/shrinkify.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;


	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t
		BGl_shrinkzd2nodez12zd2default3101z12zzast_shrinkifyz00(BgL_nodez00_bglt);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2cast3120z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_shrinkzd2nodez12zd2funcall3116z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl__shrinkzd2variablez12zd2def3098z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2setq3122z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_shrinkzd2nodez12zd2conditi3124z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t);
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2extern3118z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2appzd2ly3114zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2boxzd2ref3132zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl__shrinkzd2nodez12zd2default3101z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2fail3126z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt);
	static obj_t BGl_shrinkzd2nodez12zd2app3112z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_setqz00zzast_nodez00;
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt);
	static obj_t
		BGl_shrinkzd2nodez12zd2setzd2exzd23140z12zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = BUNSPEC;
	static obj_t BGl_shrinkzd2nodez12zd2kwote3108z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_genericzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_shrinkzd2nodez12zd2select3128z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2letzd2fun3136zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl__shrinkzd2variablez12zc0zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t BGl_shrinkzd2nodez12zd2letzd2var3138zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2jumpzd2ex3142zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2var3106z12zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2boxzd2set3134zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zd2sequenc3110z12zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_shrinkzd2nodez12zd2atom3104z12zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	static obj_t BGl_shrinkzd2nodez12zd2makezd2bo3130zc0zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_shrinkzd2variablez12zd2def3098z12zzast_shrinkifyz00
		(BgL_variablez00_bglt);
	static bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t BGl__shrinkzd2nodez12zc0zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t __cnst[1];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_shrinkzd2variablez12zd2def3098zd2envzc0zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2variab3433za7,
		BGl__shrinkzd2variablez12zd2def3098z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2variab3434za7,
		BGl__shrinkzd2variablez12zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_shrinkzd2nodez12zd2default3101zd2envzc0zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2nodeza713435z00,
		BGl__shrinkzd2nodez12zd2default3101z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3410z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123436z00,
		BGl_shrinkzd2nodez12zd2var3106z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3409z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123437z00,
		BGl_shrinkzd2nodez12zd2atom3104z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3411z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123438z00,
		BGl_shrinkzd2nodez12zd2kwote3108z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3412z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123439z00,
		BGl_shrinkzd2nodez12zd2sequenc3110z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3413z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123440z00,
		BGl_shrinkzd2nodez12zd2app3112z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3414z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123441z00,
		BGl_shrinkzd2nodez12zd2appzd2ly3114zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3415z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123442z00,
		BGl_shrinkzd2nodez12zd2funcall3116z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3416z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123443z00,
		BGl_shrinkzd2nodez12zd2extern3118z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3417z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123444z00,
		BGl_shrinkzd2nodez12zd2cast3120z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3418z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123445z00,
		BGl_shrinkzd2nodez12zd2setq3122z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3420z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123446z00,
		BGl_shrinkzd2nodez12zd2fail3126z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3419z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123447z00,
		BGl_shrinkzd2nodez12zd2conditi3124z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3421z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123448z00,
		BGl_shrinkzd2nodez12zd2select3128z12zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3422z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123449z00,
		BGl_shrinkzd2nodez12zd2makezd2bo3130zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3423z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123450z00,
		BGl_shrinkzd2nodez12zd2boxzd2ref3132zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3424z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123451z00,
		BGl_shrinkzd2nodez12zd2boxzd2set3134zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3425z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123452z00,
		BGl_shrinkzd2nodez12zd2letzd2fun3136zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3426z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123453z00,
		BGl_shrinkzd2nodez12zd2letzd2var3138zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3427z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123454z00,
		BGl_shrinkzd2nodez12zd2setzd2exzd23140z12zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3428z00zzast_shrinkifyz00,
		BgL_bgl_shrinkza7d2nodeza7123455z00,
		BGl_shrinkzd2nodez12zd2jumpzd2ex3142zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_shrinkifyz12zd2envzc0zzast_shrinkifyz00,
		BgL_bgl__shrinkifyza712za7123456z00, BGl__shrinkifyz12z12zzast_shrinkifyz00,
		0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3408z00zzast_shrinkifyz00,
		BgL_bgl_string3408za700za7za7a3457za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3430z00zzast_shrinkifyz00,
		BgL_bgl_string3430za700za7za7a3458za7, "shrink-node!-default3101 ", 25);
	      DEFINE_STRING(BGl_string3429z00zzast_shrinkifyz00,
		BgL_bgl_string3429za700za7za7a3459za7, "ast_shrinkify", 13);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl__shrinkza7d2nodeza713460z00,
		BGl__shrinkzd2nodez12zc0zzast_shrinkifyz00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long
		BgL_checksumz00_2554, char *BgL_fromz00_2555)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_shrinkifyz00))
				{
					BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_cnstzd2initzd2zzast_shrinkifyz00();
					BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_genericzd2initzd2zzast_shrinkifyz00();
					BGl_methodzd2initzd2zzast_shrinkifyz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"ast_shrinkify");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 15 */
				obj_t BgL_cportz00_2543;

				BgL_cportz00_2543 =
					bgl_open_input_string(BGl_string3430z00zzast_shrinkifyz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2544;

					BgL_iz00_2544 = ((long) 0);
				BgL_loopz00_2545:
					if ((BgL_iz00_2544 == ((long) -1)))
						{	/* Ast/shrinkify.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Ast/shrinkify.scm 15 */
							{	/* Ast/shrinkify.scm 15 */
								obj_t BgL_arg3432z00_2547;

								{	/* Ast/shrinkify.scm 15 */

									{	/* Ast/shrinkify.scm 15 */
										obj_t BgL_locationz00_2549;

										BgL_locationz00_2549 = BBOOL(((bool_t) 0));
										{	/* Ast/shrinkify.scm 15 */

											BgL_arg3432z00_2547 =
												BGl_readz00zz__readerz00(BgL_cportz00_2543,
												BgL_locationz00_2549);
										}
									}
								}
								{	/* Ast/shrinkify.scm 15 */
									int BgL_auxz00_2573;

									BgL_auxz00_2573 = (int) (BgL_iz00_2544);
									CNST_TABLE_SET(BgL_auxz00_2573, BgL_arg3432z00_2547);
							}}
							{	/* Ast/shrinkify.scm 15 */
								int BgL_auxz00_2550;

								BgL_auxz00_2550 = (int) ((BgL_iz00_2544 - ((long) 1)));
								{
									long BgL_iz00_2578;

									BgL_iz00_2578 = (long) (BgL_auxz00_2550);
									BgL_iz00_2544 = BgL_iz00_2578;
									goto BgL_loopz00_2545;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return BUNSPEC;
		}
	}



/* shrinkify! */
	BGL_EXPORTED_DEF obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t
		BgL_globalsz00_1)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 25 */
			BGl_forzd2eachzd2globalz12z12zzast_envz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BNIL);
			{
				obj_t BgL_l3078z00_752;

				BgL_l3078z00_752 = BgL_globalsz00_1;
			BgL_forzd2each3080zd2_753:
				if (PAIRP(BgL_l3078z00_752))
					{	/* Ast/shrinkify.scm 27 */
						{	/* Ast/shrinkify.scm 28 */
							obj_t BgL_globalz00_755;

							BgL_globalz00_755 = CAR(BgL_l3078z00_752);
							{	/* Ast/shrinkify.scm 28 */
								BgL_valuez00_bglt BgL_sfunz00_756;

								{
									BgL_variablez00_bglt BgL_auxz00_2584;

									BgL_auxz00_2584 = (BgL_variablez00_bglt) (BgL_globalz00_755);
									BgL_sfunz00_756 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_2584))->
										BgL_valuez00);
								}
								{	/* Ast/shrinkify.scm 29 */
									obj_t BgL_g3077z00_757;

									{
										BgL_sfunz00_bglt BgL_auxz00_2587;

										BgL_auxz00_2587 = (BgL_sfunz00_bglt) (BgL_sfunz00_756);
										BgL_g3077z00_757 =
											(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2587))->BgL_argsz00);
									}
									{
										obj_t BgL_l3075z00_758;

										BgL_l3075z00_758 = BgL_g3077z00_757;
									BgL_forzd2each3076zd2_759:
										if (PAIRP(BgL_l3075z00_758))
											{	/* Ast/shrinkify.scm 29 */
												{	/* Ast/shrinkify.scm 29 */
													obj_t BgL_arg3146z00_761;

													BgL_arg3146z00_761 = CAR(BgL_l3075z00_758);
													{	/* Ast/shrinkify.scm 29 */
														BgL_variablez00_bglt BgL_variablez00_1356;

														BgL_variablez00_1356 =
															(BgL_variablez00_bglt) (BgL_arg3146z00_761);
														{	/* Ast/shrinkify.scm 29 */
															obj_t BgL_method3100z00_1357;

															{	/* Ast/shrinkify.scm 29 */
																BgL_objectz00_bglt BgL_objz00_1358;

																BgL_objz00_1358 =
																	(BgL_objectz00_bglt) (BgL_variablez00_1356);
																{	/* Ast/shrinkify.scm 29 */
																	long BgL_objzd2classzd2numz00_1359;

																	BgL_objzd2classzd2numz00_1359 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_1358);
																	{	/* Ast/shrinkify.scm 29 */
																		obj_t BgL_arg2334z00_1360;

																		BgL_arg2334z00_1360 =
																			PROCEDURE_REF
																			(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																			(int) (((long) 1)));
																		{	/* Ast/shrinkify.scm 29 */
																			obj_t BgL_arrayz00_1362;

																			int BgL_offsetz00_1363;

																			BgL_arrayz00_1362 = BgL_arg2334z00_1360;
																			BgL_offsetz00_1363 =
																				(int) (BgL_objzd2classzd2numz00_1359);
																			{	/* Ast/shrinkify.scm 29 */
																				long BgL_offsetz00_1364;

																				BgL_offsetz00_1364 =
																					(
																					(long) (BgL_offsetz00_1363) -
																					OBJECT_TYPE);
																				{	/* Ast/shrinkify.scm 29 */
																					long BgL_modz00_1365;

																					{	/* Ast/shrinkify.scm 29 */
																						int BgL_arg2336z00_1366;

																						BgL_arg2336z00_1366 =
																							(int) (((long) 8));
																						{	/* Ast/shrinkify.scm 29 */
																							long BgL_auxz00_2602;

																							BgL_auxz00_2602 =
																								(long) (BgL_arg2336z00_1366);
																							BgL_modz00_1365 =
																								(BgL_offsetz00_1364 /
																								BgL_auxz00_2602);
																					}}
																					{	/* Ast/shrinkify.scm 29 */
																						long BgL_restz00_1367;

																						{	/* Ast/shrinkify.scm 29 */
																							int BgL_arg2335z00_1368;

																							BgL_arg2335z00_1368 =
																								(int) (((long) 8));
																							{	/* Ast/shrinkify.scm 29 */
																								long BgL_auxz00_2606;

																								BgL_auxz00_2606 =
																									(long) (BgL_arg2335z00_1368);
																								BgL_restz00_1367 =
																									(BgL_offsetz00_1364 %
																									BgL_auxz00_2606);
																						}}
																						{	/* Ast/shrinkify.scm 29 */

																							BgL_method3100z00_1357 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_1362,
																									(int) (BgL_modz00_1365)),
																								(int) (BgL_restz00_1367));
															}}}}}}}}
															PROCEDURE_ENTRY(BgL_method3100z00_1357)
																(BgL_method3100z00_1357,
																(obj_t) (BgL_variablez00_1356), BEOA);
												}}}
												{
													obj_t BgL_l3075z00_2616;

													BgL_l3075z00_2616 = CDR(BgL_l3075z00_758);
													BgL_l3075z00_758 = BgL_l3075z00_2616;
													goto BgL_forzd2each3076zd2_759;
												}
											}
										else
											{	/* Ast/shrinkify.scm 29 */
												((bool_t) 1);
											}
									}
								}
								{	/* Ast/shrinkify.scm 30 */
									obj_t BgL_arg3148z00_763;

									{	/* Ast/shrinkify.scm 30 */
										BgL_sfunz00_bglt BgL_obj1700z00_1384;

										{	/* Ast/shrinkify.scm 30 */
											BgL_variablez00_bglt BgL_obj1426z00_1383;

											BgL_obj1426z00_1383 =
												(BgL_variablez00_bglt) (BgL_globalz00_755);
											BgL_obj1700z00_1384 =
												(BgL_sfunz00_bglt) (
												(((BgL_variablez00_bglt) CREF(BgL_obj1426z00_1383))->
													BgL_valuez00));
										}
										BgL_arg3148z00_763 =
											(((BgL_sfunz00_bglt) CREF(BgL_obj1700z00_1384))->
											BgL_bodyz00);
									}
									{	/* Ast/shrinkify.scm 30 */
										obj_t BgL_res3307z00_1411;

										{	/* Ast/shrinkify.scm 30 */
											BgL_nodez00_bglt BgL_nodez00_1385;

											BgL_nodez00_1385 =
												(BgL_nodez00_bglt) (BgL_arg3148z00_763);
											{	/* Ast/shrinkify.scm 30 */
												obj_t BgL_method3102z00_1386;

												{	/* Ast/shrinkify.scm 30 */
													BgL_objectz00_bglt BgL_objz00_1387;

													BgL_objz00_1387 =
														(BgL_objectz00_bglt) (BgL_nodez00_1385);
													{	/* Ast/shrinkify.scm 30 */
														long BgL_objzd2classzd2numz00_1388;

														BgL_objzd2classzd2numz00_1388 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1387);
														{	/* Ast/shrinkify.scm 30 */
															obj_t BgL_arg2334z00_1389;

															BgL_arg2334z00_1389 =
																PROCEDURE_REF
																(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																(int) (((long) 1)));
															{	/* Ast/shrinkify.scm 30 */
																obj_t BgL_arrayz00_1391;

																int BgL_offsetz00_1392;

																BgL_arrayz00_1391 = BgL_arg2334z00_1389;
																BgL_offsetz00_1392 =
																	(int) (BgL_objzd2classzd2numz00_1388);
																{	/* Ast/shrinkify.scm 30 */
																	long BgL_offsetz00_1393;

																	BgL_offsetz00_1393 =
																		((long) (BgL_offsetz00_1392) - OBJECT_TYPE);
																	{	/* Ast/shrinkify.scm 30 */
																		long BgL_modz00_1394;

																		{	/* Ast/shrinkify.scm 30 */
																			int BgL_arg2336z00_1395;

																			BgL_arg2336z00_1395 = (int) (((long) 8));
																			{	/* Ast/shrinkify.scm 30 */
																				long BgL_auxz00_2631;

																				BgL_auxz00_2631 =
																					(long) (BgL_arg2336z00_1395);
																				BgL_modz00_1394 =
																					(BgL_offsetz00_1393 /
																					BgL_auxz00_2631);
																		}}
																		{	/* Ast/shrinkify.scm 30 */
																			long BgL_restz00_1396;

																			{	/* Ast/shrinkify.scm 30 */
																				int BgL_arg2335z00_1397;

																				BgL_arg2335z00_1397 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 30 */
																					long BgL_auxz00_2635;

																					BgL_auxz00_2635 =
																						(long) (BgL_arg2335z00_1397);
																					BgL_restz00_1396 =
																						(BgL_offsetz00_1393 %
																						BgL_auxz00_2635);
																			}}
																			{	/* Ast/shrinkify.scm 30 */

																				BgL_method3102z00_1386 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1391,
																						(int) (BgL_modz00_1394)),
																					(int) (BgL_restz00_1396));
												}}}}}}}}
												{	/* Ast/shrinkify.scm 30 */
													obj_t BgL_xz00_2513;

													BgL_xz00_2513 =
														PROCEDURE_ENTRY(BgL_method3102z00_1386)
														(BgL_method3102z00_1386, (obj_t) (BgL_nodez00_1385),
														BEOA);
													BgL_res3307z00_1411 = BUNSPEC;
										}}} BgL_res3307z00_1411;
						}}}}
						{
							obj_t BgL_l3078z00_2645;

							BgL_l3078z00_2645 = CDR(BgL_l3078z00_752);
							BgL_l3078z00_752 = BgL_l3078z00_2645;
							goto BgL_forzd2each3080zd2_753;
						}
					}
				else
					{	/* Ast/shrinkify.scm 27 */
						((bool_t) 1);
					}
			}
			return BgL_globalsz00_1;
		}
	}



/* _shrinkify! */
	obj_t BGl__shrinkifyz12z12zzast_shrinkifyz00(obj_t BgL_envz00_2443,
		obj_t BgL_globalsz00_2444)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 25 */
			return BGl_shrinkifyz12z12zzast_shrinkifyz00(BgL_globalsz00_2444);
		}
	}



/* shrink-node*! */
	bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t BgL_nodeza2za2_26)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 221 */
			{
				obj_t BgL_l3094z00_766;

				BgL_l3094z00_766 = BgL_nodeza2za2_26;
			BgL_forzd2each3097zd2_767:
				if (PAIRP(BgL_l3094z00_766))
					{	/* Ast/shrinkify.scm 222 */
						{	/* Ast/shrinkify.scm 222 */
							obj_t BgL_arg3152z00_769;

							BgL_arg3152z00_769 = CAR(BgL_l3094z00_766);
							{	/* Ast/shrinkify.scm 222 */
								obj_t BgL_res3310z00_1441;

								{	/* Ast/shrinkify.scm 222 */
									BgL_nodez00_bglt BgL_nodez00_1415;

									BgL_nodez00_1415 = (BgL_nodez00_bglt) (BgL_arg3152z00_769);
									{	/* Ast/shrinkify.scm 222 */
										obj_t BgL_method3102z00_1416;

										{	/* Ast/shrinkify.scm 222 */
											BgL_objectz00_bglt BgL_objz00_1417;

											BgL_objz00_1417 = (BgL_objectz00_bglt) (BgL_nodez00_1415);
											{	/* Ast/shrinkify.scm 222 */
												long BgL_objzd2classzd2numz00_1418;

												BgL_objzd2classzd2numz00_1418 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1417);
												{	/* Ast/shrinkify.scm 222 */
													obj_t BgL_arg2334z00_1419;

													BgL_arg2334z00_1419 =
														PROCEDURE_REF
														(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
														(int) (((long) 1)));
													{	/* Ast/shrinkify.scm 222 */
														obj_t BgL_arrayz00_1421;

														int BgL_offsetz00_1422;

														BgL_arrayz00_1421 = BgL_arg2334z00_1419;
														BgL_offsetz00_1422 =
															(int) (BgL_objzd2classzd2numz00_1418);
														{	/* Ast/shrinkify.scm 222 */
															long BgL_offsetz00_1423;

															BgL_offsetz00_1423 =
																((long) (BgL_offsetz00_1422) - OBJECT_TYPE);
															{	/* Ast/shrinkify.scm 222 */
																long BgL_modz00_1424;

																{	/* Ast/shrinkify.scm 222 */
																	int BgL_arg2336z00_1425;

																	BgL_arg2336z00_1425 = (int) (((long) 8));
																	{	/* Ast/shrinkify.scm 222 */
																		long BgL_auxz00_2660;

																		BgL_auxz00_2660 =
																			(long) (BgL_arg2336z00_1425);
																		BgL_modz00_1424 =
																			(BgL_offsetz00_1423 / BgL_auxz00_2660);
																}}
																{	/* Ast/shrinkify.scm 222 */
																	long BgL_restz00_1426;

																	{	/* Ast/shrinkify.scm 222 */
																		int BgL_arg2335z00_1427;

																		BgL_arg2335z00_1427 = (int) (((long) 8));
																		{	/* Ast/shrinkify.scm 222 */
																			long BgL_auxz00_2664;

																			BgL_auxz00_2664 =
																				(long) (BgL_arg2335z00_1427);
																			BgL_restz00_1426 =
																				(BgL_offsetz00_1423 % BgL_auxz00_2664);
																	}}
																	{	/* Ast/shrinkify.scm 222 */

																		BgL_method3102z00_1416 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1421,
																				(int) (BgL_modz00_1424)),
																			(int) (BgL_restz00_1426));
										}}}}}}}}
										{	/* Ast/shrinkify.scm 222 */
											obj_t BgL_xz00_2514;

											BgL_xz00_2514 =
												PROCEDURE_ENTRY(BgL_method3102z00_1416)
												(BgL_method3102z00_1416, (obj_t) (BgL_nodez00_1415),
												BEOA);
											BgL_res3310z00_1441 = BUNSPEC;
								}}} BgL_res3310z00_1441;
						}}
						{
							obj_t BgL_l3094z00_2674;

							BgL_l3094z00_2674 = CDR(BgL_l3094z00_766);
							BgL_l3094z00_766 = BgL_l3094z00_2674;
							goto BgL_forzd2each3097zd2_767;
						}
					}
				else
					{	/* Ast/shrinkify.scm 222 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
				BGl_shrinkzd2variablez12zd2def3098zd2envzc0zzast_shrinkifyz00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_shrinkzd2nodez12zd2default3101zd2envzc0zzast_shrinkifyz00);
		}
	}



/* shrink-variable! */
	obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt
		BgL_variablez00_2)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 37 */
			{	/* Ast/shrinkify.scm 37 */
				obj_t BgL_method3100z00_1443;

				{	/* Ast/shrinkify.scm 37 */
					BgL_objectz00_bglt BgL_objz00_1444;

					BgL_objz00_1444 = (BgL_objectz00_bglt) (BgL_variablez00_2);
					{	/* Ast/shrinkify.scm 37 */
						long BgL_objzd2classzd2numz00_1445;

						BgL_objzd2classzd2numz00_1445 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1444);
						{	/* Ast/shrinkify.scm 37 */
							obj_t BgL_arg2334z00_1446;

							BgL_arg2334z00_1446 =
								PROCEDURE_REF
								(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 37 */
								obj_t BgL_arrayz00_1448;

								int BgL_offsetz00_1449;

								BgL_arrayz00_1448 = BgL_arg2334z00_1446;
								BgL_offsetz00_1449 = (int) (BgL_objzd2classzd2numz00_1445);
								{	/* Ast/shrinkify.scm 37 */
									long BgL_offsetz00_1450;

									BgL_offsetz00_1450 =
										((long) (BgL_offsetz00_1449) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 37 */
										long BgL_modz00_1451;

										{	/* Ast/shrinkify.scm 37 */
											int BgL_arg2336z00_1452;

											BgL_arg2336z00_1452 = (int) (((long) 8));
											{	/* Ast/shrinkify.scm 37 */
												long BgL_auxz00_2686;

												BgL_auxz00_2686 = (long) (BgL_arg2336z00_1452);
												BgL_modz00_1451 =
													(BgL_offsetz00_1450 / BgL_auxz00_2686);
										}}
										{	/* Ast/shrinkify.scm 37 */
											long BgL_restz00_1453;

											{	/* Ast/shrinkify.scm 37 */
												int BgL_arg2335z00_1454;

												BgL_arg2335z00_1454 = (int) (((long) 8));
												{	/* Ast/shrinkify.scm 37 */
													long BgL_auxz00_2690;

													BgL_auxz00_2690 = (long) (BgL_arg2335z00_1454);
													BgL_restz00_1453 =
														(BgL_offsetz00_1450 % BgL_auxz00_2690);
											}}
											{	/* Ast/shrinkify.scm 37 */

												BgL_method3100z00_1443 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1448,
														(int) (BgL_modz00_1451)), (int) (BgL_restz00_1453));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3100z00_1443) (BgL_method3100z00_1443,
					(obj_t) (BgL_variablez00_2), BEOA);
			}
		}
	}



/* _shrink-variable! */
	obj_t BGl__shrinkzd2variablez12zc0zzast_shrinkifyz00(obj_t BgL_envz00_2445,
		obj_t BgL_variablez00_2446)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 37 */
			return
				BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
				(BgL_variablez00_bglt) (BgL_variablez00_2446));
		}
	}



/* shrink-variable!-def3098 */
	obj_t
		BGl_shrinkzd2variablez12zd2def3098z12zzast_shrinkifyz00(BgL_variablez00_bglt
		BgL_variablez00_3)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 38 */
				bool_t BgL_testz00_2702;

				{	/* Ast/shrinkify.scm 38 */
					bool_t BgL_testz00_2703;

					{	/* Ast/shrinkify.scm 38 */
						obj_t BgL_auxz00_2704;

						{	/* Ast/shrinkify.scm 38 */
							BgL_objectz00_bglt BgL_auxz00_2705;

							BgL_auxz00_2705 = (BgL_objectz00_bglt) (BgL_variablez00_3);
							BgL_auxz00_2704 = BGL_OBJECT_WIDENING(BgL_auxz00_2705);
						}
						BgL_testz00_2703 = CBOOL(BgL_auxz00_2704);
					}
					if (BgL_testz00_2703)
						{	/* Ast/shrinkify.scm 38 */
							BgL_testz00_2702 = ((bool_t) 1);
						}
					else
						{	/* Ast/shrinkify.scm 38 */
							BgL_testz00_2702 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2702)
					{	/* Ast/shrinkify.scm 38 */
						{	/* Ast/shrinkify.scm 39 */
							long BgL_arg3202z00_1146;

							{	/* Ast/shrinkify.scm 39 */
								obj_t BgL_arg3203z00_1147;

								{	/* Ast/shrinkify.scm 39 */
									obj_t BgL_arg3204z00_1148;

									{	/* Ast/shrinkify.scm 39 */
										BgL_objectz00_bglt BgL_objectz00_1471;

										BgL_objectz00_1471 =
											(BgL_objectz00_bglt) (BgL_variablez00_3);
										{	/* Ast/shrinkify.scm 39 */
											long BgL_arg2337z00_1472;

											{	/* Ast/shrinkify.scm 39 */
												long BgL_arg2338z00_1473;

												BgL_arg2338z00_1473 =
													BGL_OBJECT_CLASS_NUM(BgL_objectz00_1471);
												BgL_arg2337z00_1472 =
													(BgL_arg2338z00_1473 - OBJECT_TYPE);
											}
											BgL_arg3204z00_1148 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg2337z00_1472));
									}}
									BgL_arg3203z00_1147 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg3204z00_1148);
								}
								BgL_arg3202z00_1146 =
									BGl_classzd2numzd2zz__objectz00(BgL_arg3203z00_1147);
							}
							BGL_OBJECT_CLASS_NUM_SET(
								(BgL_objectz00_bglt) (BgL_variablez00_3), BgL_arg3202z00_1146);
						}
						{	/* Ast/shrinkify.scm 39 */
							BgL_objectz00_bglt BgL_auxz00_2718;

							BgL_auxz00_2718 = (BgL_objectz00_bglt) (BgL_variablez00_3);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2718, BFALSE);
						}
						(obj_t) (BgL_variablez00_3);
					}
				else
					{	/* Ast/shrinkify.scm 38 */
						BFALSE;
					}
			}
			{	/* Ast/shrinkify.scm 40 */
				bool_t BgL_testz00_2722;

				{	/* Ast/shrinkify.scm 40 */
					bool_t BgL_testz00_2723;

					{	/* Ast/shrinkify.scm 40 */
						obj_t BgL_auxz00_2724;

						{	/* Ast/shrinkify.scm 40 */
							BgL_objectz00_bglt BgL_auxz00_2725;

							BgL_auxz00_2725 =
								(BgL_objectz00_bglt) (
								(((BgL_variablez00_bglt) CREF(BgL_variablez00_3))->
									BgL_valuez00));
							BgL_auxz00_2724 = BGL_OBJECT_WIDENING(BgL_auxz00_2725);
						}
						BgL_testz00_2723 = CBOOL(BgL_auxz00_2724);
					}
					if (BgL_testz00_2723)
						{	/* Ast/shrinkify.scm 40 */
							BgL_testz00_2722 = ((bool_t) 1);
						}
					else
						{	/* Ast/shrinkify.scm 40 */
							BgL_testz00_2722 = ((bool_t) 0);
						}
				}
				if (BgL_testz00_2722)
					{	/* Ast/shrinkify.scm 41 */
						BgL_valuez00_bglt BgL_o3061z00_1150;

						BgL_o3061z00_1150 =
							(((BgL_variablez00_bglt) CREF(BgL_variablez00_3))->BgL_valuez00);
						{	/* Ast/shrinkify.scm 41 */
							long BgL_arg3207z00_1151;

							{	/* Ast/shrinkify.scm 41 */
								obj_t BgL_arg3208z00_1152;

								{	/* Ast/shrinkify.scm 41 */
									obj_t BgL_arg3209z00_1153;

									{	/* Ast/shrinkify.scm 41 */
										BgL_objectz00_bglt BgL_objectz00_1486;

										BgL_objectz00_1486 =
											(BgL_objectz00_bglt) (BgL_o3061z00_1150);
										{	/* Ast/shrinkify.scm 41 */
											long BgL_arg2337z00_1487;

											{	/* Ast/shrinkify.scm 41 */
												long BgL_arg2338z00_1488;

												BgL_arg2338z00_1488 =
													BGL_OBJECT_CLASS_NUM(BgL_objectz00_1486);
												BgL_arg2337z00_1487 =
													(BgL_arg2338z00_1488 - OBJECT_TYPE);
											}
											BgL_arg3209z00_1153 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg2337z00_1487));
									}}
									BgL_arg3208z00_1152 =
										BGl_classzd2superzd2zz__objectz00(BgL_arg3209z00_1153);
								}
								BgL_arg3207z00_1151 =
									BGl_classzd2numzd2zz__objectz00(BgL_arg3208z00_1152);
							}
							BGL_OBJECT_CLASS_NUM_SET(
								(BgL_objectz00_bglt) (BgL_o3061z00_1150), BgL_arg3207z00_1151);
						}
						{	/* Ast/shrinkify.scm 41 */
							BgL_objectz00_bglt BgL_auxz00_2740;

							BgL_auxz00_2740 = (BgL_objectz00_bglt) (BgL_o3061z00_1150);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2740, BFALSE);
						}
						return (obj_t) (BgL_o3061z00_1150);
					}
				else
					{	/* Ast/shrinkify.scm 40 */
						return BFALSE;
					}
			}
		}
	}



/* _shrink-variable!-def3098 */
	obj_t BGl__shrinkzd2variablez12zd2def3098z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2449, obj_t BgL_variablez00_2450)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return
				BGl_shrinkzd2variablez12zd2def3098z12zzast_shrinkifyz00(
				(BgL_variablez00_bglt) (BgL_variablez00_2450));
		}
	}



/* shrink-node! */
	obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt
		BgL_nodez00_4)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 46 */
			{	/* Ast/shrinkify.scm 46 */
				obj_t BgL_method3102z00_1496;

				{	/* Ast/shrinkify.scm 46 */
					BgL_objectz00_bglt BgL_objz00_1497;

					BgL_objz00_1497 = (BgL_objectz00_bglt) (BgL_nodez00_4);
					{	/* Ast/shrinkify.scm 46 */
						long BgL_objzd2classzd2numz00_1498;

						BgL_objzd2classzd2numz00_1498 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1497);
						{	/* Ast/shrinkify.scm 46 */
							obj_t BgL_arg2334z00_1499;

							BgL_arg2334z00_1499 =
								PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 46 */
								obj_t BgL_arrayz00_1501;

								int BgL_offsetz00_1502;

								BgL_arrayz00_1501 = BgL_arg2334z00_1499;
								BgL_offsetz00_1502 = (int) (BgL_objzd2classzd2numz00_1498);
								{	/* Ast/shrinkify.scm 46 */
									long BgL_offsetz00_1503;

									BgL_offsetz00_1503 =
										((long) (BgL_offsetz00_1502) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 46 */
										long BgL_modz00_1504;

										{	/* Ast/shrinkify.scm 46 */
											int BgL_arg2336z00_1505;

											BgL_arg2336z00_1505 = (int) (((long) 8));
											{	/* Ast/shrinkify.scm 46 */
												long BgL_auxz00_2754;

												BgL_auxz00_2754 = (long) (BgL_arg2336z00_1505);
												BgL_modz00_1504 =
													(BgL_offsetz00_1503 / BgL_auxz00_2754);
										}}
										{	/* Ast/shrinkify.scm 46 */
											long BgL_restz00_1506;

											{	/* Ast/shrinkify.scm 46 */
												int BgL_arg2335z00_1507;

												BgL_arg2335z00_1507 = (int) (((long) 8));
												{	/* Ast/shrinkify.scm 46 */
													long BgL_auxz00_2758;

													BgL_auxz00_2758 = (long) (BgL_arg2335z00_1507);
													BgL_restz00_1506 =
														(BgL_offsetz00_1503 % BgL_auxz00_2758);
											}}
											{	/* Ast/shrinkify.scm 46 */

												BgL_method3102z00_1496 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1501,
														(int) (BgL_modz00_1504)), (int) (BgL_restz00_1506));
				}}}}}}}}
				{	/* Ast/shrinkify.scm 46 */
					obj_t BgL_xz00_2515;

					BgL_xz00_2515 =
						PROCEDURE_ENTRY(BgL_method3102z00_1496) (BgL_method3102z00_1496,
						(obj_t) (BgL_nodez00_4), BEOA);
					return BUNSPEC;
				}
			}
		}
	}



/* _shrink-node! */
	obj_t BGl__shrinkzd2nodez12zc0zzast_shrinkifyz00(obj_t BgL_envz00_2447,
		obj_t BgL_nodez00_2448)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 46 */
			return
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				(BgL_nodez00_bglt) (BgL_nodez00_2448));
		}
	}



/* shrink-node!-default3101 */
	obj_t BGl_shrinkzd2nodez12zd2default3101z12zzast_shrinkifyz00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 15 */
				obj_t BgL_xz00_2516;

				BgL_xz00_2516 =
					BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
					BGl_string3408z00zzast_shrinkifyz00, (obj_t) (BgL_nodez00_5));
				return BUNSPEC;
			}
		}
	}



/* _shrink-node!-default3101 */
	obj_t BGl__shrinkzd2nodez12zd2default3101z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2451, obj_t BgL_nodez00_2452)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return
				BGl_shrinkzd2nodez12zd2default3101z12zzast_shrinkifyz00(
				(BgL_nodez00_bglt) (BgL_nodez00_2452));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_atomz00zzast_nodez00, BGl_proc3409z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_varz00zzast_nodez00, BGl_proc3410z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_kwotez00zzast_nodez00, BGl_proc3411z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3412z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appz00zzast_nodez00, BGl_proc3413z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3414z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_funcallz00zzast_nodez00, BGl_proc3415z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_externz00zzast_nodez00, BGl_proc3416z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_castz00zzast_nodez00, BGl_proc3417z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setqz00zzast_nodez00, BGl_proc3418z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3419z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_failz00zzast_nodez00, BGl_proc3420z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_selectz00zzast_nodez00, BGl_proc3421z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3422z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3423z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3424z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3425z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3426z00zzast_shrinkifyz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3427z00zzast_shrinkifyz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3428z00zzast_shrinkifyz00);
		}
	}



/* shrink-node!-jump-ex3142 */
	obj_t BGl_shrinkzd2nodez12zd2jumpzd2ex3142zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2473, obj_t BgL_nodez00_2474)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 213 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1343;

				BgL_nodez00_1343 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2474);
				{	/* Ast/shrinkify.scm 214 */
					BgL_nodez00_bglt BgL_arg3300z00_1346;

					BgL_arg3300z00_1346 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1343))->
						BgL_exitz00);
					{	/* Ast/shrinkify.scm 214 */
						obj_t BgL_res3404z00_2414;

						{	/* Ast/shrinkify.scm 214 */
							obj_t BgL_method3102z00_2389;

							{	/* Ast/shrinkify.scm 214 */
								BgL_objectz00_bglt BgL_objz00_2390;

								BgL_objz00_2390 = (BgL_objectz00_bglt) (BgL_arg3300z00_1346);
								{	/* Ast/shrinkify.scm 214 */
									long BgL_objzd2classzd2numz00_2391;

									BgL_objzd2classzd2numz00_2391 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2390);
									{	/* Ast/shrinkify.scm 214 */
										obj_t BgL_arg2334z00_2392;

										BgL_arg2334z00_2392 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 214 */
											obj_t BgL_arrayz00_2394;

											int BgL_offsetz00_2395;

											BgL_arrayz00_2394 = BgL_arg2334z00_2392;
											BgL_offsetz00_2395 =
												(int) (BgL_objzd2classzd2numz00_2391);
											{	/* Ast/shrinkify.scm 214 */
												long BgL_offsetz00_2396;

												BgL_offsetz00_2396 =
													((long) (BgL_offsetz00_2395) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 214 */
													long BgL_modz00_2397;

													{	/* Ast/shrinkify.scm 214 */
														int BgL_arg2336z00_2398;

														BgL_arg2336z00_2398 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 214 */
															long BgL_auxz00_2804;

															BgL_auxz00_2804 = (long) (BgL_arg2336z00_2398);
															BgL_modz00_2397 =
																(BgL_offsetz00_2396 / BgL_auxz00_2804);
													}}
													{	/* Ast/shrinkify.scm 214 */
														long BgL_restz00_2399;

														{	/* Ast/shrinkify.scm 214 */
															int BgL_arg2335z00_2400;

															BgL_arg2335z00_2400 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 214 */
																long BgL_auxz00_2808;

																BgL_auxz00_2808 = (long) (BgL_arg2335z00_2400);
																BgL_restz00_2399 =
																	(BgL_offsetz00_2396 % BgL_auxz00_2808);
														}}
														{	/* Ast/shrinkify.scm 214 */

															BgL_method3102z00_2389 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2394,
																	(int) (BgL_modz00_2397)),
																(int) (BgL_restz00_2399));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 214 */
								obj_t BgL_xz00_2517;

								BgL_xz00_2517 =
									PROCEDURE_ENTRY(BgL_method3102z00_2389)
									(BgL_method3102z00_2389, (obj_t) (BgL_arg3300z00_1346), BEOA);
								BgL_res3404z00_2414 = BUNSPEC;
						}} BgL_res3404z00_2414;
				}}
				{	/* Ast/shrinkify.scm 215 */
					BgL_nodez00_bglt BgL_arg3301z00_1347;

					BgL_arg3301z00_1347 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1343))->
						BgL_valuez00);
					{	/* Ast/shrinkify.scm 215 */
						obj_t BgL_res3407z00_2442;

						{	/* Ast/shrinkify.scm 215 */
							obj_t BgL_method3102z00_2417;

							{	/* Ast/shrinkify.scm 215 */
								BgL_objectz00_bglt BgL_objz00_2418;

								BgL_objz00_2418 = (BgL_objectz00_bglt) (BgL_arg3301z00_1347);
								{	/* Ast/shrinkify.scm 215 */
									long BgL_objzd2classzd2numz00_2419;

									BgL_objzd2classzd2numz00_2419 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2418);
									{	/* Ast/shrinkify.scm 215 */
										obj_t BgL_arg2334z00_2420;

										BgL_arg2334z00_2420 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 215 */
											obj_t BgL_arrayz00_2422;

											int BgL_offsetz00_2423;

											BgL_arrayz00_2422 = BgL_arg2334z00_2420;
											BgL_offsetz00_2423 =
												(int) (BgL_objzd2classzd2numz00_2419);
											{	/* Ast/shrinkify.scm 215 */
												long BgL_offsetz00_2424;

												BgL_offsetz00_2424 =
													((long) (BgL_offsetz00_2423) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 215 */
													long BgL_modz00_2425;

													{	/* Ast/shrinkify.scm 215 */
														int BgL_arg2336z00_2426;

														BgL_arg2336z00_2426 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 215 */
															long BgL_auxz00_2827;

															BgL_auxz00_2827 = (long) (BgL_arg2336z00_2426);
															BgL_modz00_2425 =
																(BgL_offsetz00_2424 / BgL_auxz00_2827);
													}}
													{	/* Ast/shrinkify.scm 215 */
														long BgL_restz00_2427;

														{	/* Ast/shrinkify.scm 215 */
															int BgL_arg2335z00_2428;

															BgL_arg2335z00_2428 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 215 */
																long BgL_auxz00_2831;

																BgL_auxz00_2831 = (long) (BgL_arg2335z00_2428);
																BgL_restz00_2427 =
																	(BgL_offsetz00_2424 % BgL_auxz00_2831);
														}}
														{	/* Ast/shrinkify.scm 215 */

															BgL_method3102z00_2417 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2422,
																	(int) (BgL_modz00_2425)),
																(int) (BgL_restz00_2427));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 215 */
								obj_t BgL_xz00_2518;

								BgL_xz00_2518 =
									PROCEDURE_ENTRY(BgL_method3102z00_2417)
									(BgL_method3102z00_2417, (obj_t) (BgL_arg3301z00_1347), BEOA);
								BgL_res3407z00_2442 = BUNSPEC;
						}} BgL_res3407z00_2442;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-set-ex-3140 */
	obj_t BGl_shrinkzd2nodez12zd2setzd2exzd23140z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2475, obj_t BgL_nodez00_2476)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 204 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1335;

				BgL_nodez00_1335 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2476);
				{	/* Ast/shrinkify.scm 206 */
					BgL_varz00_bglt BgL_arg3297z00_1339;

					BgL_arg3297z00_1339 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1335))->BgL_varz00);
					{	/* Ast/shrinkify.scm 206 */
						obj_t BgL_res3398z00_2358;

						{	/* Ast/shrinkify.scm 206 */
							BgL_nodez00_bglt BgL_nodez00_2332;

							BgL_nodez00_2332 = (BgL_nodez00_bglt) (BgL_arg3297z00_1339);
							{	/* Ast/shrinkify.scm 206 */
								obj_t BgL_method3102z00_2333;

								{	/* Ast/shrinkify.scm 206 */
									BgL_objectz00_bglt BgL_objz00_2334;

									BgL_objz00_2334 = (BgL_objectz00_bglt) (BgL_nodez00_2332);
									{	/* Ast/shrinkify.scm 206 */
										long BgL_objzd2classzd2numz00_2335;

										BgL_objzd2classzd2numz00_2335 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2334);
										{	/* Ast/shrinkify.scm 206 */
											obj_t BgL_arg2334z00_2336;

											BgL_arg2334z00_2336 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 206 */
												obj_t BgL_arrayz00_2338;

												int BgL_offsetz00_2339;

												BgL_arrayz00_2338 = BgL_arg2334z00_2336;
												BgL_offsetz00_2339 =
													(int) (BgL_objzd2classzd2numz00_2335);
												{	/* Ast/shrinkify.scm 206 */
													long BgL_offsetz00_2340;

													BgL_offsetz00_2340 =
														((long) (BgL_offsetz00_2339) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 206 */
														long BgL_modz00_2341;

														{	/* Ast/shrinkify.scm 206 */
															int BgL_arg2336z00_2342;

															BgL_arg2336z00_2342 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 206 */
																long BgL_auxz00_2852;

																BgL_auxz00_2852 = (long) (BgL_arg2336z00_2342);
																BgL_modz00_2341 =
																	(BgL_offsetz00_2340 / BgL_auxz00_2852);
														}}
														{	/* Ast/shrinkify.scm 206 */
															long BgL_restz00_2343;

															{	/* Ast/shrinkify.scm 206 */
																int BgL_arg2335z00_2344;

																BgL_arg2335z00_2344 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 206 */
																	long BgL_auxz00_2856;

																	BgL_auxz00_2856 =
																		(long) (BgL_arg2335z00_2344);
																	BgL_restz00_2343 =
																		(BgL_offsetz00_2340 % BgL_auxz00_2856);
															}}
															{	/* Ast/shrinkify.scm 206 */

																BgL_method3102z00_2333 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2338,
																		(int) (BgL_modz00_2341)),
																	(int) (BgL_restz00_2343));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 206 */
									obj_t BgL_xz00_2519;

									BgL_xz00_2519 =
										PROCEDURE_ENTRY(BgL_method3102z00_2333)
										(BgL_method3102z00_2333, (obj_t) (BgL_nodez00_2332), BEOA);
									BgL_res3398z00_2358 = BUNSPEC;
						}}} BgL_res3398z00_2358;
				}}
				{	/* Ast/shrinkify.scm 207 */
					BgL_nodez00_bglt BgL_arg3298z00_1340;

					BgL_arg3298z00_1340 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1335))->BgL_bodyz00);
					{	/* Ast/shrinkify.scm 207 */
						obj_t BgL_res3401z00_2386;

						{	/* Ast/shrinkify.scm 207 */
							obj_t BgL_method3102z00_2361;

							{	/* Ast/shrinkify.scm 207 */
								BgL_objectz00_bglt BgL_objz00_2362;

								BgL_objz00_2362 = (BgL_objectz00_bglt) (BgL_arg3298z00_1340);
								{	/* Ast/shrinkify.scm 207 */
									long BgL_objzd2classzd2numz00_2363;

									BgL_objzd2classzd2numz00_2363 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2362);
									{	/* Ast/shrinkify.scm 207 */
										obj_t BgL_arg2334z00_2364;

										BgL_arg2334z00_2364 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 207 */
											obj_t BgL_arrayz00_2366;

											int BgL_offsetz00_2367;

											BgL_arrayz00_2366 = BgL_arg2334z00_2364;
											BgL_offsetz00_2367 =
												(int) (BgL_objzd2classzd2numz00_2363);
											{	/* Ast/shrinkify.scm 207 */
												long BgL_offsetz00_2368;

												BgL_offsetz00_2368 =
													((long) (BgL_offsetz00_2367) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 207 */
													long BgL_modz00_2369;

													{	/* Ast/shrinkify.scm 207 */
														int BgL_arg2336z00_2370;

														BgL_arg2336z00_2370 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 207 */
															long BgL_auxz00_2875;

															BgL_auxz00_2875 = (long) (BgL_arg2336z00_2370);
															BgL_modz00_2369 =
																(BgL_offsetz00_2368 / BgL_auxz00_2875);
													}}
													{	/* Ast/shrinkify.scm 207 */
														long BgL_restz00_2371;

														{	/* Ast/shrinkify.scm 207 */
															int BgL_arg2335z00_2372;

															BgL_arg2335z00_2372 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 207 */
																long BgL_auxz00_2879;

																BgL_auxz00_2879 = (long) (BgL_arg2335z00_2372);
																BgL_restz00_2371 =
																	(BgL_offsetz00_2368 % BgL_auxz00_2879);
														}}
														{	/* Ast/shrinkify.scm 207 */

															BgL_method3102z00_2361 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2366,
																	(int) (BgL_modz00_2369)),
																(int) (BgL_restz00_2371));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 207 */
								obj_t BgL_xz00_2520;

								BgL_xz00_2520 =
									PROCEDURE_ENTRY(BgL_method3102z00_2361)
									(BgL_method3102z00_2361, (obj_t) (BgL_arg3298z00_1340), BEOA);
								BgL_res3401z00_2386 = BUNSPEC;
						}} BgL_res3401z00_2386;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-let-var3138 */
	obj_t BGl_shrinkzd2nodez12zd2letzd2var3138zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2477, obj_t BgL_nodez00_2478)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 192 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1320;

				BgL_nodez00_1320 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2478);
				{	/* Ast/shrinkify.scm 194 */
					BgL_nodez00_bglt BgL_arg3291z00_1324;

					BgL_arg3291z00_1324 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1320))->BgL_bodyz00);
					{	/* Ast/shrinkify.scm 194 */
						obj_t BgL_res3390z00_2271;

						{	/* Ast/shrinkify.scm 194 */
							obj_t BgL_method3102z00_2246;

							{	/* Ast/shrinkify.scm 194 */
								BgL_objectz00_bglt BgL_objz00_2247;

								BgL_objz00_2247 = (BgL_objectz00_bglt) (BgL_arg3291z00_1324);
								{	/* Ast/shrinkify.scm 194 */
									long BgL_objzd2classzd2numz00_2248;

									BgL_objzd2classzd2numz00_2248 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2247);
									{	/* Ast/shrinkify.scm 194 */
										obj_t BgL_arg2334z00_2249;

										BgL_arg2334z00_2249 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 194 */
											obj_t BgL_arrayz00_2251;

											int BgL_offsetz00_2252;

											BgL_arrayz00_2251 = BgL_arg2334z00_2249;
											BgL_offsetz00_2252 =
												(int) (BgL_objzd2classzd2numz00_2248);
											{	/* Ast/shrinkify.scm 194 */
												long BgL_offsetz00_2253;

												BgL_offsetz00_2253 =
													((long) (BgL_offsetz00_2252) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 194 */
													long BgL_modz00_2254;

													{	/* Ast/shrinkify.scm 194 */
														int BgL_arg2336z00_2255;

														BgL_arg2336z00_2255 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 194 */
															long BgL_auxz00_2899;

															BgL_auxz00_2899 = (long) (BgL_arg2336z00_2255);
															BgL_modz00_2254 =
																(BgL_offsetz00_2253 / BgL_auxz00_2899);
													}}
													{	/* Ast/shrinkify.scm 194 */
														long BgL_restz00_2256;

														{	/* Ast/shrinkify.scm 194 */
															int BgL_arg2335z00_2257;

															BgL_arg2335z00_2257 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 194 */
																long BgL_auxz00_2903;

																BgL_auxz00_2903 = (long) (BgL_arg2335z00_2257);
																BgL_restz00_2256 =
																	(BgL_offsetz00_2253 % BgL_auxz00_2903);
														}}
														{	/* Ast/shrinkify.scm 194 */

															BgL_method3102z00_2246 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2251,
																	(int) (BgL_modz00_2254)),
																(int) (BgL_restz00_2256));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 194 */
								obj_t BgL_xz00_2521;

								BgL_xz00_2521 =
									PROCEDURE_ENTRY(BgL_method3102z00_2246)
									(BgL_method3102z00_2246, (obj_t) (BgL_arg3291z00_1324), BEOA);
								BgL_res3390z00_2271 = BUNSPEC;
						}} BgL_res3390z00_2271;
				}}
				{	/* Ast/shrinkify.scm 195 */
					obj_t BgL_g3093z00_1325;

					BgL_g3093z00_1325 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1320))->BgL_bindingsz00);
					{
						obj_t BgL_l3090z00_1326;

						BgL_l3090z00_1326 = BgL_g3093z00_1325;
					BgL_forzd2each3092zd2_1327:
						if (PAIRP(BgL_l3090z00_1326))
							{	/* Ast/shrinkify.scm 195 */
								{	/* Ast/shrinkify.scm 197 */
									obj_t BgL_bindingz00_1329;

									BgL_bindingz00_1329 = CAR(BgL_l3090z00_1326);
									{	/* Ast/shrinkify.scm 196 */
										obj_t BgL_arg3293z00_1330;

										BgL_arg3293z00_1330 = CAR(BgL_bindingz00_1329);
										{	/* Ast/shrinkify.scm 196 */
											BgL_variablez00_bglt BgL_variablez00_2276;

											BgL_variablez00_2276 =
												(BgL_variablez00_bglt) (BgL_arg3293z00_1330);
											{	/* Ast/shrinkify.scm 196 */
												obj_t BgL_method3100z00_2277;

												{	/* Ast/shrinkify.scm 196 */
													BgL_objectz00_bglt BgL_objz00_2278;

													BgL_objz00_2278 =
														(BgL_objectz00_bglt) (BgL_variablez00_2276);
													{	/* Ast/shrinkify.scm 196 */
														long BgL_objzd2classzd2numz00_2279;

														BgL_objzd2classzd2numz00_2279 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2278);
														{	/* Ast/shrinkify.scm 196 */
															obj_t BgL_arg2334z00_2280;

															BgL_arg2334z00_2280 =
																PROCEDURE_REF
																(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																(int) (((long) 1)));
															{	/* Ast/shrinkify.scm 196 */
																obj_t BgL_arrayz00_2282;

																int BgL_offsetz00_2283;

																BgL_arrayz00_2282 = BgL_arg2334z00_2280;
																BgL_offsetz00_2283 =
																	(int) (BgL_objzd2classzd2numz00_2279);
																{	/* Ast/shrinkify.scm 196 */
																	long BgL_offsetz00_2284;

																	BgL_offsetz00_2284 =
																		((long) (BgL_offsetz00_2283) - OBJECT_TYPE);
																	{	/* Ast/shrinkify.scm 196 */
																		long BgL_modz00_2285;

																		{	/* Ast/shrinkify.scm 196 */
																			int BgL_arg2336z00_2286;

																			BgL_arg2336z00_2286 = (int) (((long) 8));
																			{	/* Ast/shrinkify.scm 196 */
																				long BgL_auxz00_2927;

																				BgL_auxz00_2927 =
																					(long) (BgL_arg2336z00_2286);
																				BgL_modz00_2285 =
																					(BgL_offsetz00_2284 /
																					BgL_auxz00_2927);
																		}}
																		{	/* Ast/shrinkify.scm 196 */
																			long BgL_restz00_2287;

																			{	/* Ast/shrinkify.scm 196 */
																				int BgL_arg2335z00_2288;

																				BgL_arg2335z00_2288 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 196 */
																					long BgL_auxz00_2931;

																					BgL_auxz00_2931 =
																						(long) (BgL_arg2335z00_2288);
																					BgL_restz00_2287 =
																						(BgL_offsetz00_2284 %
																						BgL_auxz00_2931);
																			}}
																			{	/* Ast/shrinkify.scm 196 */

																				BgL_method3100z00_2277 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2282,
																						(int) (BgL_modz00_2285)),
																					(int) (BgL_restz00_2287));
												}}}}}}}}
												PROCEDURE_ENTRY(BgL_method3100z00_2277)
													(BgL_method3100z00_2277,
													(obj_t) (BgL_variablez00_2276), BEOA);
									}}}
									{	/* Ast/shrinkify.scm 197 */
										obj_t BgL_arg3294z00_1331;

										BgL_arg3294z00_1331 = CDR(BgL_bindingz00_1329);
										{	/* Ast/shrinkify.scm 197 */
											obj_t BgL_res3395z00_2329;

											{	/* Ast/shrinkify.scm 197 */
												BgL_nodez00_bglt BgL_nodez00_2303;

												BgL_nodez00_2303 =
													(BgL_nodez00_bglt) (BgL_arg3294z00_1331);
												{	/* Ast/shrinkify.scm 197 */
													obj_t BgL_method3102z00_2304;

													{	/* Ast/shrinkify.scm 197 */
														BgL_objectz00_bglt BgL_objz00_2305;

														BgL_objz00_2305 =
															(BgL_objectz00_bglt) (BgL_nodez00_2303);
														{	/* Ast/shrinkify.scm 197 */
															long BgL_objzd2classzd2numz00_2306;

															BgL_objzd2classzd2numz00_2306 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2305);
															{	/* Ast/shrinkify.scm 197 */
																obj_t BgL_arg2334z00_2307;

																BgL_arg2334z00_2307 =
																	PROCEDURE_REF
																	(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																	(int) (((long) 1)));
																{	/* Ast/shrinkify.scm 197 */
																	obj_t BgL_arrayz00_2309;

																	int BgL_offsetz00_2310;

																	BgL_arrayz00_2309 = BgL_arg2334z00_2307;
																	BgL_offsetz00_2310 =
																		(int) (BgL_objzd2classzd2numz00_2306);
																	{	/* Ast/shrinkify.scm 197 */
																		long BgL_offsetz00_2311;

																		BgL_offsetz00_2311 =
																			(
																			(long) (BgL_offsetz00_2310) -
																			OBJECT_TYPE);
																		{	/* Ast/shrinkify.scm 197 */
																			long BgL_modz00_2312;

																			{	/* Ast/shrinkify.scm 197 */
																				int BgL_arg2336z00_2313;

																				BgL_arg2336z00_2313 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 197 */
																					long BgL_auxz00_2951;

																					BgL_auxz00_2951 =
																						(long) (BgL_arg2336z00_2313);
																					BgL_modz00_2312 =
																						(BgL_offsetz00_2311 /
																						BgL_auxz00_2951);
																			}}
																			{	/* Ast/shrinkify.scm 197 */
																				long BgL_restz00_2314;

																				{	/* Ast/shrinkify.scm 197 */
																					int BgL_arg2335z00_2315;

																					BgL_arg2335z00_2315 =
																						(int) (((long) 8));
																					{	/* Ast/shrinkify.scm 197 */
																						long BgL_auxz00_2955;

																						BgL_auxz00_2955 =
																							(long) (BgL_arg2335z00_2315);
																						BgL_restz00_2314 =
																							(BgL_offsetz00_2311 %
																							BgL_auxz00_2955);
																				}}
																				{	/* Ast/shrinkify.scm 197 */

																					BgL_method3102z00_2304 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2309,
																							(int) (BgL_modz00_2312)),
																						(int) (BgL_restz00_2314));
													}}}}}}}}
													{	/* Ast/shrinkify.scm 197 */
														obj_t BgL_xz00_2522;

														BgL_xz00_2522 =
															PROCEDURE_ENTRY(BgL_method3102z00_2304)
															(BgL_method3102z00_2304,
															(obj_t) (BgL_nodez00_2303), BEOA);
														BgL_res3395z00_2329 = BUNSPEC;
											}}} BgL_res3395z00_2329;
								}}}
								{
									obj_t BgL_l3090z00_2965;

									BgL_l3090z00_2965 = CDR(BgL_l3090z00_1326);
									BgL_l3090z00_1326 = BgL_l3090z00_2965;
									goto BgL_forzd2each3092zd2_1327;
								}
							}
						else
							{	/* Ast/shrinkify.scm 195 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-let-fun3136 */
	obj_t BGl_shrinkzd2nodez12zd2letzd2fun3136zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2479, obj_t BgL_nodez00_2480)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 178 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1299;

				BgL_nodez00_1299 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2480);
				{	/* Ast/shrinkify.scm 180 */
					BgL_nodez00_bglt BgL_arg3283z00_1303;

					BgL_arg3283z00_1303 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1299))->BgL_bodyz00);
					{	/* Ast/shrinkify.scm 180 */
						obj_t BgL_res3380z00_2154;

						{	/* Ast/shrinkify.scm 180 */
							obj_t BgL_method3102z00_2129;

							{	/* Ast/shrinkify.scm 180 */
								BgL_objectz00_bglt BgL_objz00_2130;

								BgL_objz00_2130 = (BgL_objectz00_bglt) (BgL_arg3283z00_1303);
								{	/* Ast/shrinkify.scm 180 */
									long BgL_objzd2classzd2numz00_2131;

									BgL_objzd2classzd2numz00_2131 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2130);
									{	/* Ast/shrinkify.scm 180 */
										obj_t BgL_arg2334z00_2132;

										BgL_arg2334z00_2132 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 180 */
											obj_t BgL_arrayz00_2134;

											int BgL_offsetz00_2135;

											BgL_arrayz00_2134 = BgL_arg2334z00_2132;
											BgL_offsetz00_2135 =
												(int) (BgL_objzd2classzd2numz00_2131);
											{	/* Ast/shrinkify.scm 180 */
												long BgL_offsetz00_2136;

												BgL_offsetz00_2136 =
													((long) (BgL_offsetz00_2135) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 180 */
													long BgL_modz00_2137;

													{	/* Ast/shrinkify.scm 180 */
														int BgL_arg2336z00_2138;

														BgL_arg2336z00_2138 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 180 */
															long BgL_auxz00_2977;

															BgL_auxz00_2977 = (long) (BgL_arg2336z00_2138);
															BgL_modz00_2137 =
																(BgL_offsetz00_2136 / BgL_auxz00_2977);
													}}
													{	/* Ast/shrinkify.scm 180 */
														long BgL_restz00_2139;

														{	/* Ast/shrinkify.scm 180 */
															int BgL_arg2335z00_2140;

															BgL_arg2335z00_2140 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 180 */
																long BgL_auxz00_2981;

																BgL_auxz00_2981 = (long) (BgL_arg2335z00_2140);
																BgL_restz00_2139 =
																	(BgL_offsetz00_2136 % BgL_auxz00_2981);
														}}
														{	/* Ast/shrinkify.scm 180 */

															BgL_method3102z00_2129 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2134,
																	(int) (BgL_modz00_2137)),
																(int) (BgL_restz00_2139));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 180 */
								obj_t BgL_xz00_2523;

								BgL_xz00_2523 =
									PROCEDURE_ENTRY(BgL_method3102z00_2129)
									(BgL_method3102z00_2129, (obj_t) (BgL_arg3283z00_1303), BEOA);
								BgL_res3380z00_2154 = BUNSPEC;
						}} BgL_res3380z00_2154;
				}}
				{	/* Ast/shrinkify.scm 181 */
					obj_t BgL_g3089z00_1304;

					BgL_g3089z00_1304 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1299))->BgL_localsz00);
					{
						obj_t BgL_l3087z00_1305;

						BgL_l3087z00_1305 = BgL_g3089z00_1304;
					BgL_forzd2each3088zd2_1306:
						if (PAIRP(BgL_l3087z00_1305))
							{	/* Ast/shrinkify.scm 181 */
								{	/* Ast/shrinkify.scm 182 */
									obj_t BgL_localz00_1308;

									BgL_localz00_1308 = CAR(BgL_l3087z00_1305);
									{	/* Ast/shrinkify.scm 182 */
										BgL_valuez00_bglt BgL_sfunz00_1309;

										{
											BgL_variablez00_bglt BgL_auxz00_2995;

											BgL_auxz00_2995 =
												(BgL_variablez00_bglt) (BgL_localz00_1308);
											BgL_sfunz00_1309 =
												(((BgL_variablez00_bglt) CREF(BgL_auxz00_2995))->
												BgL_valuez00);
										}
										{	/* Ast/shrinkify.scm 183 */
											BgL_variablez00_bglt BgL_variablez00_2159;

											BgL_variablez00_2159 =
												(BgL_variablez00_bglt) (BgL_localz00_1308);
											{	/* Ast/shrinkify.scm 183 */
												obj_t BgL_method3100z00_2160;

												{	/* Ast/shrinkify.scm 183 */
													BgL_objectz00_bglt BgL_objz00_2161;

													BgL_objz00_2161 =
														(BgL_objectz00_bglt) (BgL_variablez00_2159);
													{	/* Ast/shrinkify.scm 183 */
														long BgL_objzd2classzd2numz00_2162;

														BgL_objzd2classzd2numz00_2162 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2161);
														{	/* Ast/shrinkify.scm 183 */
															obj_t BgL_arg2334z00_2163;

															BgL_arg2334z00_2163 =
																PROCEDURE_REF
																(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																(int) (((long) 1)));
															{	/* Ast/shrinkify.scm 183 */
																obj_t BgL_arrayz00_2165;

																int BgL_offsetz00_2166;

																BgL_arrayz00_2165 = BgL_arg2334z00_2163;
																BgL_offsetz00_2166 =
																	(int) (BgL_objzd2classzd2numz00_2162);
																{	/* Ast/shrinkify.scm 183 */
																	long BgL_offsetz00_2167;

																	BgL_offsetz00_2167 =
																		((long) (BgL_offsetz00_2166) - OBJECT_TYPE);
																	{	/* Ast/shrinkify.scm 183 */
																		long BgL_modz00_2168;

																		{	/* Ast/shrinkify.scm 183 */
																			int BgL_arg2336z00_2169;

																			BgL_arg2336z00_2169 = (int) (((long) 8));
																			{	/* Ast/shrinkify.scm 183 */
																				long BgL_auxz00_3007;

																				BgL_auxz00_3007 =
																					(long) (BgL_arg2336z00_2169);
																				BgL_modz00_2168 =
																					(BgL_offsetz00_2167 /
																					BgL_auxz00_3007);
																		}}
																		{	/* Ast/shrinkify.scm 183 */
																			long BgL_restz00_2170;

																			{	/* Ast/shrinkify.scm 183 */
																				int BgL_arg2335z00_2171;

																				BgL_arg2335z00_2171 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 183 */
																					long BgL_auxz00_3011;

																					BgL_auxz00_3011 =
																						(long) (BgL_arg2335z00_2171);
																					BgL_restz00_2170 =
																						(BgL_offsetz00_2167 %
																						BgL_auxz00_3011);
																			}}
																			{	/* Ast/shrinkify.scm 183 */

																				BgL_method3100z00_2160 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2165,
																						(int) (BgL_modz00_2168)),
																					(int) (BgL_restz00_2170));
												}}}}}}}}
												PROCEDURE_ENTRY(BgL_method3100z00_2160)
													(BgL_method3100z00_2160,
													(obj_t) (BgL_variablez00_2159), BEOA);
										}}
										{	/* Ast/shrinkify.scm 184 */
											obj_t BgL_g3086z00_1310;

											{
												BgL_sfunz00_bglt BgL_auxz00_3021;

												BgL_auxz00_3021 = (BgL_sfunz00_bglt) (BgL_sfunz00_1309);
												BgL_g3086z00_1310 =
													(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3021))->
													BgL_argsz00);
											}
											{
												obj_t BgL_l3084z00_1311;

												BgL_l3084z00_1311 = BgL_g3086z00_1310;
											BgL_forzd2each3085zd2_1312:
												if (PAIRP(BgL_l3084z00_1311))
													{	/* Ast/shrinkify.scm 184 */
														{	/* Ast/shrinkify.scm 184 */
															obj_t BgL_arg3286z00_1314;

															BgL_arg3286z00_1314 = CAR(BgL_l3084z00_1311);
															{	/* Ast/shrinkify.scm 184 */
																BgL_variablez00_bglt BgL_variablez00_2188;

																BgL_variablez00_2188 =
																	(BgL_variablez00_bglt) (BgL_arg3286z00_1314);
																{	/* Ast/shrinkify.scm 184 */
																	obj_t BgL_method3100z00_2189;

																	{	/* Ast/shrinkify.scm 184 */
																		BgL_objectz00_bglt BgL_objz00_2190;

																		BgL_objz00_2190 =
																			(BgL_objectz00_bglt)
																			(BgL_variablez00_2188);
																		{	/* Ast/shrinkify.scm 184 */
																			long BgL_objzd2classzd2numz00_2191;

																			BgL_objzd2classzd2numz00_2191 =
																				BGL_OBJECT_CLASS_NUM(BgL_objz00_2190);
																			{	/* Ast/shrinkify.scm 184 */
																				obj_t BgL_arg2334z00_2192;

																				BgL_arg2334z00_2192 =
																					PROCEDURE_REF
																					(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
																					(int) (((long) 1)));
																				{	/* Ast/shrinkify.scm 184 */
																					obj_t BgL_arrayz00_2194;

																					int BgL_offsetz00_2195;

																					BgL_arrayz00_2194 =
																						BgL_arg2334z00_2192;
																					BgL_offsetz00_2195 =
																						(int)
																						(BgL_objzd2classzd2numz00_2191);
																					{	/* Ast/shrinkify.scm 184 */
																						long BgL_offsetz00_2196;

																						BgL_offsetz00_2196 =
																							(
																							(long) (BgL_offsetz00_2195) -
																							OBJECT_TYPE);
																						{	/* Ast/shrinkify.scm 184 */
																							long BgL_modz00_2197;

																							{	/* Ast/shrinkify.scm 184 */
																								int BgL_arg2336z00_2198;

																								BgL_arg2336z00_2198 =
																									(int) (((long) 8));
																								{	/* Ast/shrinkify.scm 184 */
																									long BgL_auxz00_3036;

																									BgL_auxz00_3036 =
																										(long)
																										(BgL_arg2336z00_2198);
																									BgL_modz00_2197 =
																										(BgL_offsetz00_2196 /
																										BgL_auxz00_3036);
																							}}
																							{	/* Ast/shrinkify.scm 184 */
																								long BgL_restz00_2199;

																								{	/* Ast/shrinkify.scm 184 */
																									int BgL_arg2335z00_2200;

																									BgL_arg2335z00_2200 =
																										(int) (((long) 8));
																									{	/* Ast/shrinkify.scm 184 */
																										long BgL_auxz00_3040;

																										BgL_auxz00_3040 =
																											(long)
																											(BgL_arg2335z00_2200);
																										BgL_restz00_2199 =
																											(BgL_offsetz00_2196 %
																											BgL_auxz00_3040);
																								}}
																								{	/* Ast/shrinkify.scm 184 */

																									BgL_method3100z00_2189 =
																										VECTOR_REF(VECTOR_REF
																										(BgL_arrayz00_2194,
																											(int) (BgL_modz00_2197)),
																										(int) (BgL_restz00_2199));
																	}}}}}}}}
																	PROCEDURE_ENTRY(BgL_method3100z00_2189)
																		(BgL_method3100z00_2189,
																		(obj_t) (BgL_variablez00_2188), BEOA);
														}}}
														{
															obj_t BgL_l3084z00_3050;

															BgL_l3084z00_3050 = CDR(BgL_l3084z00_1311);
															BgL_l3084z00_1311 = BgL_l3084z00_3050;
															goto BgL_forzd2each3085zd2_1312;
														}
													}
												else
													{	/* Ast/shrinkify.scm 184 */
														((bool_t) 1);
													}
											}
										}
										{	/* Ast/shrinkify.scm 185 */
											obj_t BgL_arg3288z00_1316;

											{
												BgL_sfunz00_bglt BgL_auxz00_3052;

												BgL_auxz00_3052 = (BgL_sfunz00_bglt) (BgL_sfunz00_1309);
												BgL_arg3288z00_1316 =
													(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3052))->
													BgL_bodyz00);
											}
											{	/* Ast/shrinkify.scm 185 */
												obj_t BgL_res3387z00_2242;

												{	/* Ast/shrinkify.scm 185 */
													BgL_nodez00_bglt BgL_nodez00_2216;

													BgL_nodez00_2216 =
														(BgL_nodez00_bglt) (BgL_arg3288z00_1316);
													{	/* Ast/shrinkify.scm 185 */
														obj_t BgL_method3102z00_2217;

														{	/* Ast/shrinkify.scm 185 */
															BgL_objectz00_bglt BgL_objz00_2218;

															BgL_objz00_2218 =
																(BgL_objectz00_bglt) (BgL_nodez00_2216);
															{	/* Ast/shrinkify.scm 185 */
																long BgL_objzd2classzd2numz00_2219;

																BgL_objzd2classzd2numz00_2219 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_2218);
																{	/* Ast/shrinkify.scm 185 */
																	obj_t BgL_arg2334z00_2220;

																	BgL_arg2334z00_2220 =
																		PROCEDURE_REF
																		(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																		(int) (((long) 1)));
																	{	/* Ast/shrinkify.scm 185 */
																		obj_t BgL_arrayz00_2222;

																		int BgL_offsetz00_2223;

																		BgL_arrayz00_2222 = BgL_arg2334z00_2220;
																		BgL_offsetz00_2223 =
																			(int) (BgL_objzd2classzd2numz00_2219);
																		{	/* Ast/shrinkify.scm 185 */
																			long BgL_offsetz00_2224;

																			BgL_offsetz00_2224 =
																				(
																				(long) (BgL_offsetz00_2223) -
																				OBJECT_TYPE);
																			{	/* Ast/shrinkify.scm 185 */
																				long BgL_modz00_2225;

																				{	/* Ast/shrinkify.scm 185 */
																					int BgL_arg2336z00_2226;

																					BgL_arg2336z00_2226 =
																						(int) (((long) 8));
																					{	/* Ast/shrinkify.scm 185 */
																						long BgL_auxz00_3064;

																						BgL_auxz00_3064 =
																							(long) (BgL_arg2336z00_2226);
																						BgL_modz00_2225 =
																							(BgL_offsetz00_2224 /
																							BgL_auxz00_3064);
																				}}
																				{	/* Ast/shrinkify.scm 185 */
																					long BgL_restz00_2227;

																					{	/* Ast/shrinkify.scm 185 */
																						int BgL_arg2335z00_2228;

																						BgL_arg2335z00_2228 =
																							(int) (((long) 8));
																						{	/* Ast/shrinkify.scm 185 */
																							long BgL_auxz00_3068;

																							BgL_auxz00_3068 =
																								(long) (BgL_arg2335z00_2228);
																							BgL_restz00_2227 =
																								(BgL_offsetz00_2224 %
																								BgL_auxz00_3068);
																					}}
																					{	/* Ast/shrinkify.scm 185 */

																						BgL_method3102z00_2217 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_2222,
																								(int) (BgL_modz00_2225)),
																							(int) (BgL_restz00_2227));
														}}}}}}}}
														{	/* Ast/shrinkify.scm 185 */
															obj_t BgL_xz00_2524;

															BgL_xz00_2524 =
																PROCEDURE_ENTRY(BgL_method3102z00_2217)
																(BgL_method3102z00_2217,
																(obj_t) (BgL_nodez00_2216), BEOA);
															BgL_res3387z00_2242 = BUNSPEC;
												}}} BgL_res3387z00_2242;
								}}}}
								{
									obj_t BgL_l3087z00_3078;

									BgL_l3087z00_3078 = CDR(BgL_l3087z00_1305);
									BgL_l3087z00_1305 = BgL_l3087z00_3078;
									goto BgL_forzd2each3088zd2_1306;
								}
							}
						else
							{	/* Ast/shrinkify.scm 181 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-box-set3134 */
	obj_t BGl_shrinkzd2nodez12zd2boxzd2set3134zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2481, obj_t BgL_nodez00_2482)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 169 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1287;

				BgL_nodez00_1287 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2482);
				{	/* Ast/shrinkify.scm 170 */
					bool_t BgL_testz00_3081;

					{	/* Ast/shrinkify.scm 170 */
						bool_t BgL_testz00_3082;

						{	/* Ast/shrinkify.scm 170 */
							obj_t BgL_auxz00_3083;

							{	/* Ast/shrinkify.scm 170 */
								BgL_objectz00_bglt BgL_auxz00_3084;

								BgL_auxz00_3084 = (BgL_objectz00_bglt) (BgL_nodez00_1287);
								BgL_auxz00_3083 = BGL_OBJECT_WIDENING(BgL_auxz00_3084);
							}
							BgL_testz00_3082 = CBOOL(BgL_auxz00_3083);
						}
						if (BgL_testz00_3082)
							{	/* Ast/shrinkify.scm 170 */
								BgL_testz00_3081 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 170 */
								BgL_testz00_3081 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3081)
						{	/* Ast/shrinkify.scm 170 */
							{	/* Ast/shrinkify.scm 170 */
								long BgL_arg3277z00_1292;

								{	/* Ast/shrinkify.scm 170 */
									obj_t BgL_arg3278z00_1293;

									{	/* Ast/shrinkify.scm 170 */
										obj_t BgL_arg3279z00_1294;

										{	/* Ast/shrinkify.scm 170 */
											BgL_objectz00_bglt BgL_objectz00_2061;

											BgL_objectz00_2061 =
												(BgL_objectz00_bglt) (BgL_nodez00_1287);
											{	/* Ast/shrinkify.scm 170 */
												long BgL_arg2337z00_2062;

												{	/* Ast/shrinkify.scm 170 */
													long BgL_arg2338z00_2063;

													BgL_arg2338z00_2063 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_2061);
													BgL_arg2337z00_2062 =
														(BgL_arg2338z00_2063 - OBJECT_TYPE);
												}
												BgL_arg3279z00_1294 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2337z00_2062));
										}}
										BgL_arg3278z00_1293 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3279z00_1294);
									}
									BgL_arg3277z00_1292 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3278z00_1293);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1287), BgL_arg3277z00_1292);
							}
							{	/* Ast/shrinkify.scm 170 */
								BgL_objectz00_bglt BgL_auxz00_3097;

								BgL_auxz00_3097 = (BgL_objectz00_bglt) (BgL_nodez00_1287);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3097, BFALSE);
							}
							(obj_t) (BgL_nodez00_1287);
						}
					else
						{	/* Ast/shrinkify.scm 170 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 171 */
					BgL_varz00_bglt BgL_arg3280z00_1295;

					BgL_arg3280z00_1295 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1287))->BgL_varz00);
					{	/* Ast/shrinkify.scm 171 */
						obj_t BgL_res3374z00_2098;

						{	/* Ast/shrinkify.scm 171 */
							BgL_nodez00_bglt BgL_nodez00_2072;

							BgL_nodez00_2072 = (BgL_nodez00_bglt) (BgL_arg3280z00_1295);
							{	/* Ast/shrinkify.scm 171 */
								obj_t BgL_method3102z00_2073;

								{	/* Ast/shrinkify.scm 171 */
									BgL_objectz00_bglt BgL_objz00_2074;

									BgL_objz00_2074 = (BgL_objectz00_bglt) (BgL_nodez00_2072);
									{	/* Ast/shrinkify.scm 171 */
										long BgL_objzd2classzd2numz00_2075;

										BgL_objzd2classzd2numz00_2075 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2074);
										{	/* Ast/shrinkify.scm 171 */
											obj_t BgL_arg2334z00_2076;

											BgL_arg2334z00_2076 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 171 */
												obj_t BgL_arrayz00_2078;

												int BgL_offsetz00_2079;

												BgL_arrayz00_2078 = BgL_arg2334z00_2076;
												BgL_offsetz00_2079 =
													(int) (BgL_objzd2classzd2numz00_2075);
												{	/* Ast/shrinkify.scm 171 */
													long BgL_offsetz00_2080;

													BgL_offsetz00_2080 =
														((long) (BgL_offsetz00_2079) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 171 */
														long BgL_modz00_2081;

														{	/* Ast/shrinkify.scm 171 */
															int BgL_arg2336z00_2082;

															BgL_arg2336z00_2082 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 171 */
																long BgL_auxz00_3111;

																BgL_auxz00_3111 = (long) (BgL_arg2336z00_2082);
																BgL_modz00_2081 =
																	(BgL_offsetz00_2080 / BgL_auxz00_3111);
														}}
														{	/* Ast/shrinkify.scm 171 */
															long BgL_restz00_2083;

															{	/* Ast/shrinkify.scm 171 */
																int BgL_arg2335z00_2084;

																BgL_arg2335z00_2084 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 171 */
																	long BgL_auxz00_3115;

																	BgL_auxz00_3115 =
																		(long) (BgL_arg2335z00_2084);
																	BgL_restz00_2083 =
																		(BgL_offsetz00_2080 % BgL_auxz00_3115);
															}}
															{	/* Ast/shrinkify.scm 171 */

																BgL_method3102z00_2073 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2078,
																		(int) (BgL_modz00_2081)),
																	(int) (BgL_restz00_2083));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 171 */
									obj_t BgL_xz00_2525;

									BgL_xz00_2525 =
										PROCEDURE_ENTRY(BgL_method3102z00_2073)
										(BgL_method3102z00_2073, (obj_t) (BgL_nodez00_2072), BEOA);
									BgL_res3374z00_2098 = BUNSPEC;
						}}} BgL_res3374z00_2098;
				}}
				{	/* Ast/shrinkify.scm 172 */
					BgL_nodez00_bglt BgL_arg3281z00_1296;

					BgL_arg3281z00_1296 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1287))->BgL_valuez00);
					{	/* Ast/shrinkify.scm 172 */
						obj_t BgL_res3377z00_2126;

						{	/* Ast/shrinkify.scm 172 */
							obj_t BgL_method3102z00_2101;

							{	/* Ast/shrinkify.scm 172 */
								BgL_objectz00_bglt BgL_objz00_2102;

								BgL_objz00_2102 = (BgL_objectz00_bglt) (BgL_arg3281z00_1296);
								{	/* Ast/shrinkify.scm 172 */
									long BgL_objzd2classzd2numz00_2103;

									BgL_objzd2classzd2numz00_2103 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2102);
									{	/* Ast/shrinkify.scm 172 */
										obj_t BgL_arg2334z00_2104;

										BgL_arg2334z00_2104 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 172 */
											obj_t BgL_arrayz00_2106;

											int BgL_offsetz00_2107;

											BgL_arrayz00_2106 = BgL_arg2334z00_2104;
											BgL_offsetz00_2107 =
												(int) (BgL_objzd2classzd2numz00_2103);
											{	/* Ast/shrinkify.scm 172 */
												long BgL_offsetz00_2108;

												BgL_offsetz00_2108 =
													((long) (BgL_offsetz00_2107) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 172 */
													long BgL_modz00_2109;

													{	/* Ast/shrinkify.scm 172 */
														int BgL_arg2336z00_2110;

														BgL_arg2336z00_2110 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 172 */
															long BgL_auxz00_3134;

															BgL_auxz00_3134 = (long) (BgL_arg2336z00_2110);
															BgL_modz00_2109 =
																(BgL_offsetz00_2108 / BgL_auxz00_3134);
													}}
													{	/* Ast/shrinkify.scm 172 */
														long BgL_restz00_2111;

														{	/* Ast/shrinkify.scm 172 */
															int BgL_arg2335z00_2112;

															BgL_arg2335z00_2112 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 172 */
																long BgL_auxz00_3138;

																BgL_auxz00_3138 = (long) (BgL_arg2335z00_2112);
																BgL_restz00_2111 =
																	(BgL_offsetz00_2108 % BgL_auxz00_3138);
														}}
														{	/* Ast/shrinkify.scm 172 */

															BgL_method3102z00_2101 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2106,
																	(int) (BgL_modz00_2109)),
																(int) (BgL_restz00_2111));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 172 */
								obj_t BgL_xz00_2526;

								BgL_xz00_2526 =
									PROCEDURE_ENTRY(BgL_method3102z00_2101)
									(BgL_method3102z00_2101, (obj_t) (BgL_arg3281z00_1296), BEOA);
								BgL_res3377z00_2126 = BUNSPEC;
						}} BgL_res3377z00_2126;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-box-ref3132 */
	obj_t BGl_shrinkzd2nodez12zd2boxzd2ref3132zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2483, obj_t BgL_nodez00_2484)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 161 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1276;

				BgL_nodez00_1276 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2484);
				{	/* Ast/shrinkify.scm 162 */
					bool_t BgL_testz00_3149;

					{	/* Ast/shrinkify.scm 162 */
						bool_t BgL_testz00_3150;

						{	/* Ast/shrinkify.scm 162 */
							obj_t BgL_auxz00_3151;

							{	/* Ast/shrinkify.scm 162 */
								BgL_objectz00_bglt BgL_auxz00_3152;

								BgL_auxz00_3152 = (BgL_objectz00_bglt) (BgL_nodez00_1276);
								BgL_auxz00_3151 = BGL_OBJECT_WIDENING(BgL_auxz00_3152);
							}
							BgL_testz00_3150 = CBOOL(BgL_auxz00_3151);
						}
						if (BgL_testz00_3150)
							{	/* Ast/shrinkify.scm 162 */
								BgL_testz00_3149 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 162 */
								BgL_testz00_3149 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3149)
						{	/* Ast/shrinkify.scm 162 */
							{	/* Ast/shrinkify.scm 162 */
								long BgL_arg3271z00_1281;

								{	/* Ast/shrinkify.scm 162 */
									obj_t BgL_arg3272z00_1282;

									{	/* Ast/shrinkify.scm 162 */
										obj_t BgL_arg3273z00_1283;

										{	/* Ast/shrinkify.scm 162 */
											BgL_objectz00_bglt BgL_objectz00_2020;

											BgL_objectz00_2020 =
												(BgL_objectz00_bglt) (BgL_nodez00_1276);
											{	/* Ast/shrinkify.scm 162 */
												long BgL_arg2337z00_2021;

												{	/* Ast/shrinkify.scm 162 */
													long BgL_arg2338z00_2022;

													BgL_arg2338z00_2022 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_2020);
													BgL_arg2337z00_2021 =
														(BgL_arg2338z00_2022 - OBJECT_TYPE);
												}
												BgL_arg3273z00_1283 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2337z00_2021));
										}}
										BgL_arg3272z00_1282 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3273z00_1283);
									}
									BgL_arg3271z00_1281 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3272z00_1282);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1276), BgL_arg3271z00_1281);
							}
							{	/* Ast/shrinkify.scm 162 */
								BgL_objectz00_bglt BgL_auxz00_3165;

								BgL_auxz00_3165 = (BgL_objectz00_bglt) (BgL_nodez00_1276);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3165, BFALSE);
							}
							(obj_t) (BgL_nodez00_1276);
						}
					else
						{	/* Ast/shrinkify.scm 162 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 163 */
					BgL_varz00_bglt BgL_arg3274z00_1284;

					BgL_arg3274z00_1284 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1276))->BgL_varz00);
					{	/* Ast/shrinkify.scm 163 */
						obj_t BgL_res3370z00_2057;

						{	/* Ast/shrinkify.scm 163 */
							BgL_nodez00_bglt BgL_nodez00_2031;

							BgL_nodez00_2031 = (BgL_nodez00_bglt) (BgL_arg3274z00_1284);
							{	/* Ast/shrinkify.scm 163 */
								obj_t BgL_method3102z00_2032;

								{	/* Ast/shrinkify.scm 163 */
									BgL_objectz00_bglt BgL_objz00_2033;

									BgL_objz00_2033 = (BgL_objectz00_bglt) (BgL_nodez00_2031);
									{	/* Ast/shrinkify.scm 163 */
										long BgL_objzd2classzd2numz00_2034;

										BgL_objzd2classzd2numz00_2034 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2033);
										{	/* Ast/shrinkify.scm 163 */
											obj_t BgL_arg2334z00_2035;

											BgL_arg2334z00_2035 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 163 */
												obj_t BgL_arrayz00_2037;

												int BgL_offsetz00_2038;

												BgL_arrayz00_2037 = BgL_arg2334z00_2035;
												BgL_offsetz00_2038 =
													(int) (BgL_objzd2classzd2numz00_2034);
												{	/* Ast/shrinkify.scm 163 */
													long BgL_offsetz00_2039;

													BgL_offsetz00_2039 =
														((long) (BgL_offsetz00_2038) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 163 */
														long BgL_modz00_2040;

														{	/* Ast/shrinkify.scm 163 */
															int BgL_arg2336z00_2041;

															BgL_arg2336z00_2041 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 163 */
																long BgL_auxz00_3179;

																BgL_auxz00_3179 = (long) (BgL_arg2336z00_2041);
																BgL_modz00_2040 =
																	(BgL_offsetz00_2039 / BgL_auxz00_3179);
														}}
														{	/* Ast/shrinkify.scm 163 */
															long BgL_restz00_2042;

															{	/* Ast/shrinkify.scm 163 */
																int BgL_arg2335z00_2043;

																BgL_arg2335z00_2043 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 163 */
																	long BgL_auxz00_3183;

																	BgL_auxz00_3183 =
																		(long) (BgL_arg2335z00_2043);
																	BgL_restz00_2042 =
																		(BgL_offsetz00_2039 % BgL_auxz00_3183);
															}}
															{	/* Ast/shrinkify.scm 163 */

																BgL_method3102z00_2032 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2037,
																		(int) (BgL_modz00_2040)),
																	(int) (BgL_restz00_2042));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 163 */
									obj_t BgL_xz00_2527;

									BgL_xz00_2527 =
										PROCEDURE_ENTRY(BgL_method3102z00_2032)
										(BgL_method3102z00_2032, (obj_t) (BgL_nodez00_2031), BEOA);
									BgL_res3370z00_2057 = BUNSPEC;
						}}} BgL_res3370z00_2057;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-make-bo3130 */
	obj_t BGl_shrinkzd2nodez12zd2makezd2bo3130zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2485, obj_t BgL_nodez00_2486)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 153 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1265;

				BgL_nodez00_1265 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2486);
				{	/* Ast/shrinkify.scm 154 */
					bool_t BgL_testz00_3194;

					{	/* Ast/shrinkify.scm 154 */
						bool_t BgL_testz00_3195;

						{	/* Ast/shrinkify.scm 154 */
							obj_t BgL_auxz00_3196;

							{	/* Ast/shrinkify.scm 154 */
								BgL_objectz00_bglt BgL_auxz00_3197;

								BgL_auxz00_3197 = (BgL_objectz00_bglt) (BgL_nodez00_1265);
								BgL_auxz00_3196 = BGL_OBJECT_WIDENING(BgL_auxz00_3197);
							}
							BgL_testz00_3195 = CBOOL(BgL_auxz00_3196);
						}
						if (BgL_testz00_3195)
							{	/* Ast/shrinkify.scm 154 */
								BgL_testz00_3194 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 154 */
								BgL_testz00_3194 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3194)
						{	/* Ast/shrinkify.scm 154 */
							{	/* Ast/shrinkify.scm 154 */
								long BgL_arg3265z00_1270;

								{	/* Ast/shrinkify.scm 154 */
									obj_t BgL_arg3266z00_1271;

									{	/* Ast/shrinkify.scm 154 */
										obj_t BgL_arg3267z00_1272;

										{	/* Ast/shrinkify.scm 154 */
											BgL_objectz00_bglt BgL_objectz00_1979;

											BgL_objectz00_1979 =
												(BgL_objectz00_bglt) (BgL_nodez00_1265);
											{	/* Ast/shrinkify.scm 154 */
												long BgL_arg2337z00_1980;

												{	/* Ast/shrinkify.scm 154 */
													long BgL_arg2338z00_1981;

													BgL_arg2338z00_1981 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1979);
													BgL_arg2337z00_1980 =
														(BgL_arg2338z00_1981 - OBJECT_TYPE);
												}
												BgL_arg3267z00_1272 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2337z00_1980));
										}}
										BgL_arg3266z00_1271 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3267z00_1272);
									}
									BgL_arg3265z00_1270 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3266z00_1271);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1265), BgL_arg3265z00_1270);
							}
							{	/* Ast/shrinkify.scm 154 */
								BgL_objectz00_bglt BgL_auxz00_3210;

								BgL_auxz00_3210 = (BgL_objectz00_bglt) (BgL_nodez00_1265);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3210, BFALSE);
							}
							(obj_t) (BgL_nodez00_1265);
						}
					else
						{	/* Ast/shrinkify.scm 154 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 155 */
					BgL_nodez00_bglt BgL_arg3268z00_1273;

					BgL_arg3268z00_1273 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1265))->BgL_valuez00);
					{	/* Ast/shrinkify.scm 155 */
						obj_t BgL_res3366z00_2016;

						{	/* Ast/shrinkify.scm 155 */
							obj_t BgL_method3102z00_1991;

							{	/* Ast/shrinkify.scm 155 */
								BgL_objectz00_bglt BgL_objz00_1992;

								BgL_objz00_1992 = (BgL_objectz00_bglt) (BgL_arg3268z00_1273);
								{	/* Ast/shrinkify.scm 155 */
									long BgL_objzd2classzd2numz00_1993;

									BgL_objzd2classzd2numz00_1993 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1992);
									{	/* Ast/shrinkify.scm 155 */
										obj_t BgL_arg2334z00_1994;

										BgL_arg2334z00_1994 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 155 */
											obj_t BgL_arrayz00_1996;

											int BgL_offsetz00_1997;

											BgL_arrayz00_1996 = BgL_arg2334z00_1994;
											BgL_offsetz00_1997 =
												(int) (BgL_objzd2classzd2numz00_1993);
											{	/* Ast/shrinkify.scm 155 */
												long BgL_offsetz00_1998;

												BgL_offsetz00_1998 =
													((long) (BgL_offsetz00_1997) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 155 */
													long BgL_modz00_1999;

													{	/* Ast/shrinkify.scm 155 */
														int BgL_arg2336z00_2000;

														BgL_arg2336z00_2000 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 155 */
															long BgL_auxz00_3223;

															BgL_auxz00_3223 = (long) (BgL_arg2336z00_2000);
															BgL_modz00_1999 =
																(BgL_offsetz00_1998 / BgL_auxz00_3223);
													}}
													{	/* Ast/shrinkify.scm 155 */
														long BgL_restz00_2001;

														{	/* Ast/shrinkify.scm 155 */
															int BgL_arg2335z00_2002;

															BgL_arg2335z00_2002 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 155 */
																long BgL_auxz00_3227;

																BgL_auxz00_3227 = (long) (BgL_arg2335z00_2002);
																BgL_restz00_2001 =
																	(BgL_offsetz00_1998 % BgL_auxz00_3227);
														}}
														{	/* Ast/shrinkify.scm 155 */

															BgL_method3102z00_1991 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1996,
																	(int) (BgL_modz00_1999)),
																(int) (BgL_restz00_2001));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 155 */
								obj_t BgL_xz00_2528;

								BgL_xz00_2528 =
									PROCEDURE_ENTRY(BgL_method3102z00_1991)
									(BgL_method3102z00_1991, (obj_t) (BgL_arg3268z00_1273), BEOA);
								BgL_res3366z00_2016 = BUNSPEC;
						}} BgL_res3366z00_2016;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-select3128 */
	obj_t BGl_shrinkzd2nodez12zd2select3128z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2487, obj_t BgL_nodez00_2488)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 143 */
			{
				BgL_selectz00_bglt BgL_nodez00_1252;

				BgL_nodez00_1252 = (BgL_selectz00_bglt) (BgL_nodez00_2488);
				{	/* Ast/shrinkify.scm 144 */
					BgL_nodez00_bglt BgL_arg3259z00_1255;

					BgL_arg3259z00_1255 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1252))->BgL_testz00);
					{	/* Ast/shrinkify.scm 144 */
						obj_t BgL_res3359z00_1943;

						{	/* Ast/shrinkify.scm 144 */
							obj_t BgL_method3102z00_1918;

							{	/* Ast/shrinkify.scm 144 */
								BgL_objectz00_bglt BgL_objz00_1919;

								BgL_objz00_1919 = (BgL_objectz00_bglt) (BgL_arg3259z00_1255);
								{	/* Ast/shrinkify.scm 144 */
									long BgL_objzd2classzd2numz00_1920;

									BgL_objzd2classzd2numz00_1920 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1919);
									{	/* Ast/shrinkify.scm 144 */
										obj_t BgL_arg2334z00_1921;

										BgL_arg2334z00_1921 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 144 */
											obj_t BgL_arrayz00_1923;

											int BgL_offsetz00_1924;

											BgL_arrayz00_1923 = BgL_arg2334z00_1921;
											BgL_offsetz00_1924 =
												(int) (BgL_objzd2classzd2numz00_1920);
											{	/* Ast/shrinkify.scm 144 */
												long BgL_offsetz00_1925;

												BgL_offsetz00_1925 =
													((long) (BgL_offsetz00_1924) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 144 */
													long BgL_modz00_1926;

													{	/* Ast/shrinkify.scm 144 */
														int BgL_arg2336z00_1927;

														BgL_arg2336z00_1927 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 144 */
															long BgL_auxz00_3247;

															BgL_auxz00_3247 = (long) (BgL_arg2336z00_1927);
															BgL_modz00_1926 =
																(BgL_offsetz00_1925 / BgL_auxz00_3247);
													}}
													{	/* Ast/shrinkify.scm 144 */
														long BgL_restz00_1928;

														{	/* Ast/shrinkify.scm 144 */
															int BgL_arg2335z00_1929;

															BgL_arg2335z00_1929 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 144 */
																long BgL_auxz00_3251;

																BgL_auxz00_3251 = (long) (BgL_arg2335z00_1929);
																BgL_restz00_1928 =
																	(BgL_offsetz00_1925 % BgL_auxz00_3251);
														}}
														{	/* Ast/shrinkify.scm 144 */

															BgL_method3102z00_1918 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1923,
																	(int) (BgL_modz00_1926)),
																(int) (BgL_restz00_1928));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 144 */
								obj_t BgL_xz00_2529;

								BgL_xz00_2529 =
									PROCEDURE_ENTRY(BgL_method3102z00_1918)
									(BgL_method3102z00_1918, (obj_t) (BgL_arg3259z00_1255), BEOA);
								BgL_res3359z00_1943 = BUNSPEC;
						}} BgL_res3359z00_1943;
				}}
				{	/* Ast/shrinkify.scm 145 */
					obj_t BgL_g3083z00_1256;

					BgL_g3083z00_1256 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1252))->BgL_clausesz00);
					{
						obj_t BgL_l3081z00_1257;

						BgL_l3081z00_1257 = BgL_g3083z00_1256;
					BgL_forzd2each3082zd2_1258:
						if (PAIRP(BgL_l3081z00_1257))
							{	/* Ast/shrinkify.scm 147 */
								{	/* Ast/shrinkify.scm 146 */
									obj_t BgL_clausez00_1260;

									BgL_clausez00_1260 = CAR(BgL_l3081z00_1257);
									{	/* Ast/shrinkify.scm 146 */
										obj_t BgL_arg3261z00_1261;

										BgL_arg3261z00_1261 = CDR(BgL_clausez00_1260);
										{	/* Ast/shrinkify.scm 146 */
											obj_t BgL_res3362z00_1974;

											{	/* Ast/shrinkify.scm 146 */
												BgL_nodez00_bglt BgL_nodez00_1948;

												BgL_nodez00_1948 =
													(BgL_nodez00_bglt) (BgL_arg3261z00_1261);
												{	/* Ast/shrinkify.scm 146 */
													obj_t BgL_method3102z00_1949;

													{	/* Ast/shrinkify.scm 146 */
														BgL_objectz00_bglt BgL_objz00_1950;

														BgL_objz00_1950 =
															(BgL_objectz00_bglt) (BgL_nodez00_1948);
														{	/* Ast/shrinkify.scm 146 */
															long BgL_objzd2classzd2numz00_1951;

															BgL_objzd2classzd2numz00_1951 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_1950);
															{	/* Ast/shrinkify.scm 146 */
																obj_t BgL_arg2334z00_1952;

																BgL_arg2334z00_1952 =
																	PROCEDURE_REF
																	(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
																	(int) (((long) 1)));
																{	/* Ast/shrinkify.scm 146 */
																	obj_t BgL_arrayz00_1954;

																	int BgL_offsetz00_1955;

																	BgL_arrayz00_1954 = BgL_arg2334z00_1952;
																	BgL_offsetz00_1955 =
																		(int) (BgL_objzd2classzd2numz00_1951);
																	{	/* Ast/shrinkify.scm 146 */
																		long BgL_offsetz00_1956;

																		BgL_offsetz00_1956 =
																			(
																			(long) (BgL_offsetz00_1955) -
																			OBJECT_TYPE);
																		{	/* Ast/shrinkify.scm 146 */
																			long BgL_modz00_1957;

																			{	/* Ast/shrinkify.scm 146 */
																				int BgL_arg2336z00_1958;

																				BgL_arg2336z00_1958 =
																					(int) (((long) 8));
																				{	/* Ast/shrinkify.scm 146 */
																					long BgL_auxz00_3275;

																					BgL_auxz00_3275 =
																						(long) (BgL_arg2336z00_1958);
																					BgL_modz00_1957 =
																						(BgL_offsetz00_1956 /
																						BgL_auxz00_3275);
																			}}
																			{	/* Ast/shrinkify.scm 146 */
																				long BgL_restz00_1959;

																				{	/* Ast/shrinkify.scm 146 */
																					int BgL_arg2335z00_1960;

																					BgL_arg2335z00_1960 =
																						(int) (((long) 8));
																					{	/* Ast/shrinkify.scm 146 */
																						long BgL_auxz00_3279;

																						BgL_auxz00_3279 =
																							(long) (BgL_arg2335z00_1960);
																						BgL_restz00_1959 =
																							(BgL_offsetz00_1956 %
																							BgL_auxz00_3279);
																				}}
																				{	/* Ast/shrinkify.scm 146 */

																					BgL_method3102z00_1949 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_1954,
																							(int) (BgL_modz00_1957)),
																						(int) (BgL_restz00_1959));
													}}}}}}}}
													{	/* Ast/shrinkify.scm 146 */
														obj_t BgL_xz00_2530;

														BgL_xz00_2530 =
															PROCEDURE_ENTRY(BgL_method3102z00_1949)
															(BgL_method3102z00_1949,
															(obj_t) (BgL_nodez00_1948), BEOA);
														BgL_res3362z00_1974 = BUNSPEC;
											}}} BgL_res3362z00_1974;
								}}}
								{
									obj_t BgL_l3081z00_3289;

									BgL_l3081z00_3289 = CDR(BgL_l3081z00_1257);
									BgL_l3081z00_1257 = BgL_l3081z00_3289;
									goto BgL_forzd2each3082zd2_1258;
								}
							}
						else
							{	/* Ast/shrinkify.scm 147 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-fail3126 */
	obj_t BGl_shrinkzd2nodez12zd2fail3126z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2489, obj_t BgL_nodez00_2490)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 134 */
			{
				BgL_failz00_bglt BgL_nodez00_1244;

				BgL_nodez00_1244 = (BgL_failz00_bglt) (BgL_nodez00_2490);
				{	/* Ast/shrinkify.scm 135 */
					BgL_nodez00_bglt BgL_arg3255z00_1247;

					BgL_arg3255z00_1247 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1244))->BgL_procz00);
					{	/* Ast/shrinkify.scm 135 */
						obj_t BgL_res3350z00_1859;

						{	/* Ast/shrinkify.scm 135 */
							obj_t BgL_method3102z00_1834;

							{	/* Ast/shrinkify.scm 135 */
								BgL_objectz00_bglt BgL_objz00_1835;

								BgL_objz00_1835 = (BgL_objectz00_bglt) (BgL_arg3255z00_1247);
								{	/* Ast/shrinkify.scm 135 */
									long BgL_objzd2classzd2numz00_1836;

									BgL_objzd2classzd2numz00_1836 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1835);
									{	/* Ast/shrinkify.scm 135 */
										obj_t BgL_arg2334z00_1837;

										BgL_arg2334z00_1837 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 135 */
											obj_t BgL_arrayz00_1839;

											int BgL_offsetz00_1840;

											BgL_arrayz00_1839 = BgL_arg2334z00_1837;
											BgL_offsetz00_1840 =
												(int) (BgL_objzd2classzd2numz00_1836);
											{	/* Ast/shrinkify.scm 135 */
												long BgL_offsetz00_1841;

												BgL_offsetz00_1841 =
													((long) (BgL_offsetz00_1840) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 135 */
													long BgL_modz00_1842;

													{	/* Ast/shrinkify.scm 135 */
														int BgL_arg2336z00_1843;

														BgL_arg2336z00_1843 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 135 */
															long BgL_auxz00_3301;

															BgL_auxz00_3301 = (long) (BgL_arg2336z00_1843);
															BgL_modz00_1842 =
																(BgL_offsetz00_1841 / BgL_auxz00_3301);
													}}
													{	/* Ast/shrinkify.scm 135 */
														long BgL_restz00_1844;

														{	/* Ast/shrinkify.scm 135 */
															int BgL_arg2335z00_1845;

															BgL_arg2335z00_1845 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 135 */
																long BgL_auxz00_3305;

																BgL_auxz00_3305 = (long) (BgL_arg2335z00_1845);
																BgL_restz00_1844 =
																	(BgL_offsetz00_1841 % BgL_auxz00_3305);
														}}
														{	/* Ast/shrinkify.scm 135 */

															BgL_method3102z00_1834 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1839,
																	(int) (BgL_modz00_1842)),
																(int) (BgL_restz00_1844));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 135 */
								obj_t BgL_xz00_2531;

								BgL_xz00_2531 =
									PROCEDURE_ENTRY(BgL_method3102z00_1834)
									(BgL_method3102z00_1834, (obj_t) (BgL_arg3255z00_1247), BEOA);
								BgL_res3350z00_1859 = BUNSPEC;
						}} BgL_res3350z00_1859;
				}}
				{	/* Ast/shrinkify.scm 136 */
					BgL_nodez00_bglt BgL_arg3256z00_1248;

					BgL_arg3256z00_1248 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1244))->BgL_msgz00);
					{	/* Ast/shrinkify.scm 136 */
						obj_t BgL_res3353z00_1887;

						{	/* Ast/shrinkify.scm 136 */
							obj_t BgL_method3102z00_1862;

							{	/* Ast/shrinkify.scm 136 */
								BgL_objectz00_bglt BgL_objz00_1863;

								BgL_objz00_1863 = (BgL_objectz00_bglt) (BgL_arg3256z00_1248);
								{	/* Ast/shrinkify.scm 136 */
									long BgL_objzd2classzd2numz00_1864;

									BgL_objzd2classzd2numz00_1864 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1863);
									{	/* Ast/shrinkify.scm 136 */
										obj_t BgL_arg2334z00_1865;

										BgL_arg2334z00_1865 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 136 */
											obj_t BgL_arrayz00_1867;

											int BgL_offsetz00_1868;

											BgL_arrayz00_1867 = BgL_arg2334z00_1865;
											BgL_offsetz00_1868 =
												(int) (BgL_objzd2classzd2numz00_1864);
											{	/* Ast/shrinkify.scm 136 */
												long BgL_offsetz00_1869;

												BgL_offsetz00_1869 =
													((long) (BgL_offsetz00_1868) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 136 */
													long BgL_modz00_1870;

													{	/* Ast/shrinkify.scm 136 */
														int BgL_arg2336z00_1871;

														BgL_arg2336z00_1871 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 136 */
															long BgL_auxz00_3324;

															BgL_auxz00_3324 = (long) (BgL_arg2336z00_1871);
															BgL_modz00_1870 =
																(BgL_offsetz00_1869 / BgL_auxz00_3324);
													}}
													{	/* Ast/shrinkify.scm 136 */
														long BgL_restz00_1872;

														{	/* Ast/shrinkify.scm 136 */
															int BgL_arg2335z00_1873;

															BgL_arg2335z00_1873 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 136 */
																long BgL_auxz00_3328;

																BgL_auxz00_3328 = (long) (BgL_arg2335z00_1873);
																BgL_restz00_1872 =
																	(BgL_offsetz00_1869 % BgL_auxz00_3328);
														}}
														{	/* Ast/shrinkify.scm 136 */

															BgL_method3102z00_1862 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1867,
																	(int) (BgL_modz00_1870)),
																(int) (BgL_restz00_1872));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 136 */
								obj_t BgL_xz00_2532;

								BgL_xz00_2532 =
									PROCEDURE_ENTRY(BgL_method3102z00_1862)
									(BgL_method3102z00_1862, (obj_t) (BgL_arg3256z00_1248), BEOA);
								BgL_res3353z00_1887 = BUNSPEC;
						}} BgL_res3353z00_1887;
				}}
				{	/* Ast/shrinkify.scm 137 */
					BgL_nodez00_bglt BgL_arg3257z00_1249;

					BgL_arg3257z00_1249 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1244))->BgL_objz00);
					{	/* Ast/shrinkify.scm 137 */
						obj_t BgL_res3356z00_1915;

						{	/* Ast/shrinkify.scm 137 */
							obj_t BgL_method3102z00_1890;

							{	/* Ast/shrinkify.scm 137 */
								BgL_objectz00_bglt BgL_objz00_1891;

								BgL_objz00_1891 = (BgL_objectz00_bglt) (BgL_arg3257z00_1249);
								{	/* Ast/shrinkify.scm 137 */
									long BgL_objzd2classzd2numz00_1892;

									BgL_objzd2classzd2numz00_1892 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1891);
									{	/* Ast/shrinkify.scm 137 */
										obj_t BgL_arg2334z00_1893;

										BgL_arg2334z00_1893 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 137 */
											obj_t BgL_arrayz00_1895;

											int BgL_offsetz00_1896;

											BgL_arrayz00_1895 = BgL_arg2334z00_1893;
											BgL_offsetz00_1896 =
												(int) (BgL_objzd2classzd2numz00_1892);
											{	/* Ast/shrinkify.scm 137 */
												long BgL_offsetz00_1897;

												BgL_offsetz00_1897 =
													((long) (BgL_offsetz00_1896) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 137 */
													long BgL_modz00_1898;

													{	/* Ast/shrinkify.scm 137 */
														int BgL_arg2336z00_1899;

														BgL_arg2336z00_1899 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 137 */
															long BgL_auxz00_3347;

															BgL_auxz00_3347 = (long) (BgL_arg2336z00_1899);
															BgL_modz00_1898 =
																(BgL_offsetz00_1897 / BgL_auxz00_3347);
													}}
													{	/* Ast/shrinkify.scm 137 */
														long BgL_restz00_1900;

														{	/* Ast/shrinkify.scm 137 */
															int BgL_arg2335z00_1901;

															BgL_arg2335z00_1901 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 137 */
																long BgL_auxz00_3351;

																BgL_auxz00_3351 = (long) (BgL_arg2335z00_1901);
																BgL_restz00_1900 =
																	(BgL_offsetz00_1897 % BgL_auxz00_3351);
														}}
														{	/* Ast/shrinkify.scm 137 */

															BgL_method3102z00_1890 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1895,
																	(int) (BgL_modz00_1898)),
																(int) (BgL_restz00_1900));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 137 */
								obj_t BgL_xz00_2533;

								BgL_xz00_2533 =
									PROCEDURE_ENTRY(BgL_method3102z00_1890)
									(BgL_method3102z00_1890, (obj_t) (BgL_arg3257z00_1249), BEOA);
								BgL_res3356z00_1915 = BUNSPEC;
						}} BgL_res3356z00_1915;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-conditi3124 */
	obj_t BGl_shrinkzd2nodez12zd2conditi3124z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2491, obj_t BgL_nodez00_2492)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 125 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1236;

				BgL_nodez00_1236 = (BgL_conditionalz00_bglt) (BgL_nodez00_2492);
				{	/* Ast/shrinkify.scm 126 */
					BgL_nodez00_bglt BgL_arg3251z00_1239;

					BgL_arg3251z00_1239 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1236))->BgL_testz00);
					{	/* Ast/shrinkify.scm 126 */
						obj_t BgL_res3341z00_1775;

						{	/* Ast/shrinkify.scm 126 */
							obj_t BgL_method3102z00_1750;

							{	/* Ast/shrinkify.scm 126 */
								BgL_objectz00_bglt BgL_objz00_1751;

								BgL_objz00_1751 = (BgL_objectz00_bglt) (BgL_arg3251z00_1239);
								{	/* Ast/shrinkify.scm 126 */
									long BgL_objzd2classzd2numz00_1752;

									BgL_objzd2classzd2numz00_1752 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1751);
									{	/* Ast/shrinkify.scm 126 */
										obj_t BgL_arg2334z00_1753;

										BgL_arg2334z00_1753 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 126 */
											obj_t BgL_arrayz00_1755;

											int BgL_offsetz00_1756;

											BgL_arrayz00_1755 = BgL_arg2334z00_1753;
											BgL_offsetz00_1756 =
												(int) (BgL_objzd2classzd2numz00_1752);
											{	/* Ast/shrinkify.scm 126 */
												long BgL_offsetz00_1757;

												BgL_offsetz00_1757 =
													((long) (BgL_offsetz00_1756) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 126 */
													long BgL_modz00_1758;

													{	/* Ast/shrinkify.scm 126 */
														int BgL_arg2336z00_1759;

														BgL_arg2336z00_1759 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 126 */
															long BgL_auxz00_3371;

															BgL_auxz00_3371 = (long) (BgL_arg2336z00_1759);
															BgL_modz00_1758 =
																(BgL_offsetz00_1757 / BgL_auxz00_3371);
													}}
													{	/* Ast/shrinkify.scm 126 */
														long BgL_restz00_1760;

														{	/* Ast/shrinkify.scm 126 */
															int BgL_arg2335z00_1761;

															BgL_arg2335z00_1761 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 126 */
																long BgL_auxz00_3375;

																BgL_auxz00_3375 = (long) (BgL_arg2335z00_1761);
																BgL_restz00_1760 =
																	(BgL_offsetz00_1757 % BgL_auxz00_3375);
														}}
														{	/* Ast/shrinkify.scm 126 */

															BgL_method3102z00_1750 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1755,
																	(int) (BgL_modz00_1758)),
																(int) (BgL_restz00_1760));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 126 */
								obj_t BgL_xz00_2534;

								BgL_xz00_2534 =
									PROCEDURE_ENTRY(BgL_method3102z00_1750)
									(BgL_method3102z00_1750, (obj_t) (BgL_arg3251z00_1239), BEOA);
								BgL_res3341z00_1775 = BUNSPEC;
						}} BgL_res3341z00_1775;
				}}
				{	/* Ast/shrinkify.scm 127 */
					BgL_nodez00_bglt BgL_arg3252z00_1240;

					BgL_arg3252z00_1240 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1236))->BgL_truez00);
					{	/* Ast/shrinkify.scm 127 */
						obj_t BgL_res3344z00_1803;

						{	/* Ast/shrinkify.scm 127 */
							obj_t BgL_method3102z00_1778;

							{	/* Ast/shrinkify.scm 127 */
								BgL_objectz00_bglt BgL_objz00_1779;

								BgL_objz00_1779 = (BgL_objectz00_bglt) (BgL_arg3252z00_1240);
								{	/* Ast/shrinkify.scm 127 */
									long BgL_objzd2classzd2numz00_1780;

									BgL_objzd2classzd2numz00_1780 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1779);
									{	/* Ast/shrinkify.scm 127 */
										obj_t BgL_arg2334z00_1781;

										BgL_arg2334z00_1781 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 127 */
											obj_t BgL_arrayz00_1783;

											int BgL_offsetz00_1784;

											BgL_arrayz00_1783 = BgL_arg2334z00_1781;
											BgL_offsetz00_1784 =
												(int) (BgL_objzd2classzd2numz00_1780);
											{	/* Ast/shrinkify.scm 127 */
												long BgL_offsetz00_1785;

												BgL_offsetz00_1785 =
													((long) (BgL_offsetz00_1784) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 127 */
													long BgL_modz00_1786;

													{	/* Ast/shrinkify.scm 127 */
														int BgL_arg2336z00_1787;

														BgL_arg2336z00_1787 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 127 */
															long BgL_auxz00_3394;

															BgL_auxz00_3394 = (long) (BgL_arg2336z00_1787);
															BgL_modz00_1786 =
																(BgL_offsetz00_1785 / BgL_auxz00_3394);
													}}
													{	/* Ast/shrinkify.scm 127 */
														long BgL_restz00_1788;

														{	/* Ast/shrinkify.scm 127 */
															int BgL_arg2335z00_1789;

															BgL_arg2335z00_1789 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 127 */
																long BgL_auxz00_3398;

																BgL_auxz00_3398 = (long) (BgL_arg2335z00_1789);
																BgL_restz00_1788 =
																	(BgL_offsetz00_1785 % BgL_auxz00_3398);
														}}
														{	/* Ast/shrinkify.scm 127 */

															BgL_method3102z00_1778 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1783,
																	(int) (BgL_modz00_1786)),
																(int) (BgL_restz00_1788));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 127 */
								obj_t BgL_xz00_2535;

								BgL_xz00_2535 =
									PROCEDURE_ENTRY(BgL_method3102z00_1778)
									(BgL_method3102z00_1778, (obj_t) (BgL_arg3252z00_1240), BEOA);
								BgL_res3344z00_1803 = BUNSPEC;
						}} BgL_res3344z00_1803;
				}}
				{	/* Ast/shrinkify.scm 128 */
					BgL_nodez00_bglt BgL_arg3253z00_1241;

					BgL_arg3253z00_1241 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1236))->BgL_falsez00);
					{	/* Ast/shrinkify.scm 128 */
						obj_t BgL_res3347z00_1831;

						{	/* Ast/shrinkify.scm 128 */
							obj_t BgL_method3102z00_1806;

							{	/* Ast/shrinkify.scm 128 */
								BgL_objectz00_bglt BgL_objz00_1807;

								BgL_objz00_1807 = (BgL_objectz00_bglt) (BgL_arg3253z00_1241);
								{	/* Ast/shrinkify.scm 128 */
									long BgL_objzd2classzd2numz00_1808;

									BgL_objzd2classzd2numz00_1808 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1807);
									{	/* Ast/shrinkify.scm 128 */
										obj_t BgL_arg2334z00_1809;

										BgL_arg2334z00_1809 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 128 */
											obj_t BgL_arrayz00_1811;

											int BgL_offsetz00_1812;

											BgL_arrayz00_1811 = BgL_arg2334z00_1809;
											BgL_offsetz00_1812 =
												(int) (BgL_objzd2classzd2numz00_1808);
											{	/* Ast/shrinkify.scm 128 */
												long BgL_offsetz00_1813;

												BgL_offsetz00_1813 =
													((long) (BgL_offsetz00_1812) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 128 */
													long BgL_modz00_1814;

													{	/* Ast/shrinkify.scm 128 */
														int BgL_arg2336z00_1815;

														BgL_arg2336z00_1815 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 128 */
															long BgL_auxz00_3417;

															BgL_auxz00_3417 = (long) (BgL_arg2336z00_1815);
															BgL_modz00_1814 =
																(BgL_offsetz00_1813 / BgL_auxz00_3417);
													}}
													{	/* Ast/shrinkify.scm 128 */
														long BgL_restz00_1816;

														{	/* Ast/shrinkify.scm 128 */
															int BgL_arg2335z00_1817;

															BgL_arg2335z00_1817 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 128 */
																long BgL_auxz00_3421;

																BgL_auxz00_3421 = (long) (BgL_arg2335z00_1817);
																BgL_restz00_1816 =
																	(BgL_offsetz00_1813 % BgL_auxz00_3421);
														}}
														{	/* Ast/shrinkify.scm 128 */

															BgL_method3102z00_1806 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1811,
																	(int) (BgL_modz00_1814)),
																(int) (BgL_restz00_1816));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 128 */
								obj_t BgL_xz00_2536;

								BgL_xz00_2536 =
									PROCEDURE_ENTRY(BgL_method3102z00_1806)
									(BgL_method3102z00_1806, (obj_t) (BgL_arg3253z00_1241), BEOA);
								BgL_res3347z00_1831 = BUNSPEC;
						}} BgL_res3347z00_1831;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-setq3122 */
	obj_t BGl_shrinkzd2nodez12zd2setq3122z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2493, obj_t BgL_nodez00_2494)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 118 */
			{
				BgL_setqz00_bglt BgL_nodez00_1230;

				BgL_nodez00_1230 = (BgL_setqz00_bglt) (BgL_nodez00_2494);
				{	/* Ast/shrinkify.scm 119 */
					BgL_nodez00_bglt BgL_arg3249z00_1719;

					BgL_arg3249z00_1719 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1230))->BgL_valuez00);
					{	/* Ast/shrinkify.scm 119 */
						obj_t BgL_res3338z00_1747;

						{	/* Ast/shrinkify.scm 119 */
							obj_t BgL_method3102z00_1722;

							{	/* Ast/shrinkify.scm 119 */
								BgL_objectz00_bglt BgL_objz00_1723;

								BgL_objz00_1723 = (BgL_objectz00_bglt) (BgL_arg3249z00_1719);
								{	/* Ast/shrinkify.scm 119 */
									long BgL_objzd2classzd2numz00_1724;

									BgL_objzd2classzd2numz00_1724 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1723);
									{	/* Ast/shrinkify.scm 119 */
										obj_t BgL_arg2334z00_1725;

										BgL_arg2334z00_1725 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 119 */
											obj_t BgL_arrayz00_1727;

											int BgL_offsetz00_1728;

											BgL_arrayz00_1727 = BgL_arg2334z00_1725;
											BgL_offsetz00_1728 =
												(int) (BgL_objzd2classzd2numz00_1724);
											{	/* Ast/shrinkify.scm 119 */
												long BgL_offsetz00_1729;

												BgL_offsetz00_1729 =
													((long) (BgL_offsetz00_1728) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 119 */
													long BgL_modz00_1730;

													{	/* Ast/shrinkify.scm 119 */
														int BgL_arg2336z00_1731;

														BgL_arg2336z00_1731 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 119 */
															long BgL_auxz00_3441;

															BgL_auxz00_3441 = (long) (BgL_arg2336z00_1731);
															BgL_modz00_1730 =
																(BgL_offsetz00_1729 / BgL_auxz00_3441);
													}}
													{	/* Ast/shrinkify.scm 119 */
														long BgL_restz00_1732;

														{	/* Ast/shrinkify.scm 119 */
															int BgL_arg2335z00_1733;

															BgL_arg2335z00_1733 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 119 */
																long BgL_auxz00_3445;

																BgL_auxz00_3445 = (long) (BgL_arg2335z00_1733);
																BgL_restz00_1732 =
																	(BgL_offsetz00_1729 % BgL_auxz00_3445);
														}}
														{	/* Ast/shrinkify.scm 119 */

															BgL_method3102z00_1722 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1727,
																	(int) (BgL_modz00_1730)),
																(int) (BgL_restz00_1732));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 119 */
								obj_t BgL_xz00_2537;

								BgL_xz00_2537 =
									PROCEDURE_ENTRY(BgL_method3102z00_1722)
									(BgL_method3102z00_1722, (obj_t) (BgL_arg3249z00_1719), BEOA);
								BgL_res3338z00_1747 = BUNSPEC;
						}} BgL_res3338z00_1747;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-cast3120 */
	obj_t BGl_shrinkzd2nodez12zd2cast3120z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2495, obj_t BgL_nodez00_2496)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 111 */
			{
				BgL_castz00_bglt BgL_nodez00_1224;

				{	/* Ast/shrinkify.scm 112 */
					BgL_castz00_bglt BgL_auxz00_3456;

					BgL_nodez00_1224 = (BgL_castz00_bglt) (BgL_nodez00_2496);
					{	/* Ast/shrinkify.scm 112 */
						BgL_nodez00_bglt BgL_arg3247z00_1690;

						BgL_arg3247z00_1690 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1224))->BgL_argz00);
						{	/* Ast/shrinkify.scm 112 */
							obj_t BgL_res3335z00_1718;

							{	/* Ast/shrinkify.scm 112 */
								obj_t BgL_method3102z00_1693;

								{	/* Ast/shrinkify.scm 112 */
									BgL_objectz00_bglt BgL_objz00_1694;

									BgL_objz00_1694 = (BgL_objectz00_bglt) (BgL_arg3247z00_1690);
									{	/* Ast/shrinkify.scm 112 */
										long BgL_objzd2classzd2numz00_1695;

										BgL_objzd2classzd2numz00_1695 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1694);
										{	/* Ast/shrinkify.scm 112 */
											obj_t BgL_arg2334z00_1696;

											BgL_arg2334z00_1696 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 112 */
												obj_t BgL_arrayz00_1698;

												int BgL_offsetz00_1699;

												BgL_arrayz00_1698 = BgL_arg2334z00_1696;
												BgL_offsetz00_1699 =
													(int) (BgL_objzd2classzd2numz00_1695);
												{	/* Ast/shrinkify.scm 112 */
													long BgL_offsetz00_1700;

													BgL_offsetz00_1700 =
														((long) (BgL_offsetz00_1699) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 112 */
														long BgL_modz00_1701;

														{	/* Ast/shrinkify.scm 112 */
															int BgL_arg2336z00_1702;

															BgL_arg2336z00_1702 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 112 */
																long BgL_auxz00_3466;

																BgL_auxz00_3466 = (long) (BgL_arg2336z00_1702);
																BgL_modz00_1701 =
																	(BgL_offsetz00_1700 / BgL_auxz00_3466);
														}}
														{	/* Ast/shrinkify.scm 112 */
															long BgL_restz00_1703;

															{	/* Ast/shrinkify.scm 112 */
																int BgL_arg2335z00_1704;

																BgL_arg2335z00_1704 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 112 */
																	long BgL_auxz00_3470;

																	BgL_auxz00_3470 =
																		(long) (BgL_arg2335z00_1704);
																	BgL_restz00_1703 =
																		(BgL_offsetz00_1700 % BgL_auxz00_3470);
															}}
															{	/* Ast/shrinkify.scm 112 */

																BgL_method3102z00_1693 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1698,
																		(int) (BgL_modz00_1701)),
																	(int) (BgL_restz00_1703));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 112 */
									obj_t BgL_xz00_2538;

									BgL_xz00_2538 =
										PROCEDURE_ENTRY(BgL_method3102z00_1693)
										(BgL_method3102z00_1693, (obj_t) (BgL_arg3247z00_1690),
										BEOA);
									BgL_res3335z00_1718 = BUNSPEC;
							}} BgL_res3335z00_1718;
					}}
					BgL_auxz00_3456 = BgL_nodez00_1224;
					return (obj_t) (BgL_auxz00_3456);
				}
			}
		}
	}



/* shrink-node!-extern3118 */
	obj_t BGl_shrinkzd2nodez12zd2extern3118z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2497, obj_t BgL_nodez00_2498)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 103 */
			{
				BgL_externz00_bglt BgL_nodez00_1213;

				{	/* Ast/shrinkify.scm 104 */
					BgL_externz00_bglt BgL_auxz00_3482;

					BgL_nodez00_1213 = (BgL_externz00_bglt) (BgL_nodez00_2498);
					{	/* Ast/shrinkify.scm 104 */
						bool_t BgL_testz00_3483;

						{	/* Ast/shrinkify.scm 104 */
							bool_t BgL_testz00_3484;

							{	/* Ast/shrinkify.scm 104 */
								obj_t BgL_auxz00_3485;

								{	/* Ast/shrinkify.scm 104 */
									BgL_objectz00_bglt BgL_auxz00_3486;

									BgL_auxz00_3486 = (BgL_objectz00_bglt) (BgL_nodez00_1213);
									BgL_auxz00_3485 = BGL_OBJECT_WIDENING(BgL_auxz00_3486);
								}
								BgL_testz00_3484 = CBOOL(BgL_auxz00_3485);
							}
							if (BgL_testz00_3484)
								{	/* Ast/shrinkify.scm 104 */
									BgL_testz00_3483 = ((bool_t) 1);
								}
							else
								{	/* Ast/shrinkify.scm 104 */
									BgL_testz00_3483 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_3483)
							{	/* Ast/shrinkify.scm 104 */
								{	/* Ast/shrinkify.scm 104 */
									long BgL_arg3242z00_1218;

									{	/* Ast/shrinkify.scm 104 */
										obj_t BgL_arg3243z00_1219;

										{	/* Ast/shrinkify.scm 104 */
											obj_t BgL_arg3244z00_1220;

											{	/* Ast/shrinkify.scm 104 */
												BgL_objectz00_bglt BgL_objectz00_1679;

												BgL_objectz00_1679 =
													(BgL_objectz00_bglt) (BgL_nodez00_1213);
												{	/* Ast/shrinkify.scm 104 */
													long BgL_arg2337z00_1680;

													{	/* Ast/shrinkify.scm 104 */
														long BgL_arg2338z00_1681;

														BgL_arg2338z00_1681 =
															BGL_OBJECT_CLASS_NUM(BgL_objectz00_1679);
														BgL_arg2337z00_1680 =
															(BgL_arg2338z00_1681 - OBJECT_TYPE);
													}
													BgL_arg3244z00_1220 =
														VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
														(int) (BgL_arg2337z00_1680));
											}}
											BgL_arg3243z00_1219 =
												BGl_classzd2superzd2zz__objectz00(BgL_arg3244z00_1220);
										}
										BgL_arg3242z00_1218 =
											BGl_classzd2numzd2zz__objectz00(BgL_arg3243z00_1219);
									}
									BGL_OBJECT_CLASS_NUM_SET(
										(BgL_objectz00_bglt) (BgL_nodez00_1213),
										BgL_arg3242z00_1218);
								}
								{	/* Ast/shrinkify.scm 104 */
									BgL_objectz00_bglt BgL_auxz00_3499;

									BgL_auxz00_3499 = (BgL_objectz00_bglt) (BgL_nodez00_1213);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_3499, BFALSE);
								}
								(obj_t) (BgL_nodez00_1213);
							}
						else
							{	/* Ast/shrinkify.scm 104 */
								BFALSE;
							}
					}
					{	/* Ast/shrinkify.scm 105 */
						obj_t BgL_arg3245z00_1221;

						BgL_arg3245z00_1221 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1213))->BgL_exprza2za2);
						BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3245z00_1221);
					}
					BgL_auxz00_3482 = BgL_nodez00_1213;
					return (obj_t) (BgL_auxz00_3482);
				}
			}
		}
	}



/* shrink-node!-funcall3116 */
	obj_t BGl_shrinkzd2nodez12zd2funcall3116z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2499, obj_t BgL_nodez00_2500)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 94 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1201;

				BgL_nodez00_1201 = (BgL_funcallz00_bglt) (BgL_nodez00_2500);
				{	/* Ast/shrinkify.scm 95 */
					bool_t BgL_testz00_3507;

					{	/* Ast/shrinkify.scm 95 */
						bool_t BgL_testz00_3508;

						{	/* Ast/shrinkify.scm 95 */
							obj_t BgL_auxz00_3509;

							{	/* Ast/shrinkify.scm 95 */
								BgL_objectz00_bglt BgL_auxz00_3510;

								BgL_auxz00_3510 = (BgL_objectz00_bglt) (BgL_nodez00_1201);
								BgL_auxz00_3509 = BGL_OBJECT_WIDENING(BgL_auxz00_3510);
							}
							BgL_testz00_3508 = CBOOL(BgL_auxz00_3509);
						}
						if (BgL_testz00_3508)
							{	/* Ast/shrinkify.scm 95 */
								BgL_testz00_3507 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 95 */
								BgL_testz00_3507 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3507)
						{	/* Ast/shrinkify.scm 95 */
							{	/* Ast/shrinkify.scm 95 */
								long BgL_arg3235z00_1206;

								{	/* Ast/shrinkify.scm 95 */
									obj_t BgL_arg3236z00_1207;

									{	/* Ast/shrinkify.scm 95 */
										obj_t BgL_arg3237z00_1208;

										{	/* Ast/shrinkify.scm 95 */
											BgL_objectz00_bglt BgL_objectz00_1637;

											BgL_objectz00_1637 =
												(BgL_objectz00_bglt) (BgL_nodez00_1201);
											{	/* Ast/shrinkify.scm 95 */
												long BgL_arg2337z00_1638;

												{	/* Ast/shrinkify.scm 95 */
													long BgL_arg2338z00_1639;

													BgL_arg2338z00_1639 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1637);
													BgL_arg2337z00_1638 =
														(BgL_arg2338z00_1639 - OBJECT_TYPE);
												}
												BgL_arg3237z00_1208 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2337z00_1638));
										}}
										BgL_arg3236z00_1207 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3237z00_1208);
									}
									BgL_arg3235z00_1206 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3236z00_1207);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1201), BgL_arg3235z00_1206);
							}
							{	/* Ast/shrinkify.scm 95 */
								BgL_objectz00_bglt BgL_auxz00_3523;

								BgL_auxz00_3523 = (BgL_objectz00_bglt) (BgL_nodez00_1201);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3523, BFALSE);
							}
							(obj_t) (BgL_nodez00_1201);
						}
					else
						{	/* Ast/shrinkify.scm 95 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 96 */
					BgL_nodez00_bglt BgL_arg3238z00_1209;

					BgL_arg3238z00_1209 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1201))->BgL_funz00);
					{	/* Ast/shrinkify.scm 96 */
						obj_t BgL_res3331z00_1674;

						{	/* Ast/shrinkify.scm 96 */
							obj_t BgL_method3102z00_1649;

							{	/* Ast/shrinkify.scm 96 */
								BgL_objectz00_bglt BgL_objz00_1650;

								BgL_objz00_1650 = (BgL_objectz00_bglt) (BgL_arg3238z00_1209);
								{	/* Ast/shrinkify.scm 96 */
									long BgL_objzd2classzd2numz00_1651;

									BgL_objzd2classzd2numz00_1651 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1650);
									{	/* Ast/shrinkify.scm 96 */
										obj_t BgL_arg2334z00_1652;

										BgL_arg2334z00_1652 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 96 */
											obj_t BgL_arrayz00_1654;

											int BgL_offsetz00_1655;

											BgL_arrayz00_1654 = BgL_arg2334z00_1652;
											BgL_offsetz00_1655 =
												(int) (BgL_objzd2classzd2numz00_1651);
											{	/* Ast/shrinkify.scm 96 */
												long BgL_offsetz00_1656;

												BgL_offsetz00_1656 =
													((long) (BgL_offsetz00_1655) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 96 */
													long BgL_modz00_1657;

													{	/* Ast/shrinkify.scm 96 */
														int BgL_arg2336z00_1658;

														BgL_arg2336z00_1658 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 96 */
															long BgL_auxz00_3536;

															BgL_auxz00_3536 = (long) (BgL_arg2336z00_1658);
															BgL_modz00_1657 =
																(BgL_offsetz00_1656 / BgL_auxz00_3536);
													}}
													{	/* Ast/shrinkify.scm 96 */
														long BgL_restz00_1659;

														{	/* Ast/shrinkify.scm 96 */
															int BgL_arg2335z00_1660;

															BgL_arg2335z00_1660 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 96 */
																long BgL_auxz00_3540;

																BgL_auxz00_3540 = (long) (BgL_arg2335z00_1660);
																BgL_restz00_1659 =
																	(BgL_offsetz00_1656 % BgL_auxz00_3540);
														}}
														{	/* Ast/shrinkify.scm 96 */

															BgL_method3102z00_1649 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1654,
																	(int) (BgL_modz00_1657)),
																(int) (BgL_restz00_1659));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 96 */
								obj_t BgL_xz00_2539;

								BgL_xz00_2539 =
									PROCEDURE_ENTRY(BgL_method3102z00_1649)
									(BgL_method3102z00_1649, (obj_t) (BgL_arg3238z00_1209), BEOA);
								BgL_res3331z00_1674 = BUNSPEC;
						}} BgL_res3331z00_1674;
				}}
				{	/* Ast/shrinkify.scm 97 */
					obj_t BgL_arg3239z00_1210;

					BgL_arg3239z00_1210 =
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1201))->BgL_argsz00);
					BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3239z00_1210);
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-app-ly3114 */
	obj_t BGl_shrinkzd2nodez12zd2appzd2ly3114zc0zzast_shrinkifyz00(obj_t
		BgL_envz00_2501, obj_t BgL_nodez00_2502)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 85 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1189;

				BgL_nodez00_1189 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2502);
				{	/* Ast/shrinkify.scm 86 */
					bool_t BgL_testz00_3553;

					{	/* Ast/shrinkify.scm 86 */
						bool_t BgL_testz00_3554;

						{	/* Ast/shrinkify.scm 86 */
							obj_t BgL_auxz00_3555;

							{	/* Ast/shrinkify.scm 86 */
								BgL_objectz00_bglt BgL_auxz00_3556;

								BgL_auxz00_3556 = (BgL_objectz00_bglt) (BgL_nodez00_1189);
								BgL_auxz00_3555 = BGL_OBJECT_WIDENING(BgL_auxz00_3556);
							}
							BgL_testz00_3554 = CBOOL(BgL_auxz00_3555);
						}
						if (BgL_testz00_3554)
							{	/* Ast/shrinkify.scm 86 */
								BgL_testz00_3553 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 86 */
								BgL_testz00_3553 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3553)
						{	/* Ast/shrinkify.scm 86 */
							{	/* Ast/shrinkify.scm 86 */
								long BgL_arg3226z00_1194;

								{	/* Ast/shrinkify.scm 86 */
									obj_t BgL_arg3227z00_1195;

									{	/* Ast/shrinkify.scm 86 */
										obj_t BgL_arg3229z00_1196;

										{	/* Ast/shrinkify.scm 86 */
											BgL_objectz00_bglt BgL_objectz00_1568;

											BgL_objectz00_1568 =
												(BgL_objectz00_bglt) (BgL_nodez00_1189);
											{	/* Ast/shrinkify.scm 86 */
												long BgL_arg2337z00_1569;

												{	/* Ast/shrinkify.scm 86 */
													long BgL_arg2338z00_1570;

													BgL_arg2338z00_1570 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1568);
													BgL_arg2337z00_1569 =
														(BgL_arg2338z00_1570 - OBJECT_TYPE);
												}
												BgL_arg3229z00_1196 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2337z00_1569));
										}}
										BgL_arg3227z00_1195 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3229z00_1196);
									}
									BgL_arg3226z00_1194 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3227z00_1195);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1189), BgL_arg3226z00_1194);
							}
							{	/* Ast/shrinkify.scm 86 */
								BgL_objectz00_bglt BgL_auxz00_3569;

								BgL_auxz00_3569 = (BgL_objectz00_bglt) (BgL_nodez00_1189);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3569, BFALSE);
							}
							(obj_t) (BgL_nodez00_1189);
						}
					else
						{	/* Ast/shrinkify.scm 86 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 87 */
					BgL_nodez00_bglt BgL_arg3230z00_1197;

					BgL_arg3230z00_1197 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1189))->BgL_funz00);
					{	/* Ast/shrinkify.scm 87 */
						obj_t BgL_res3324z00_1605;

						{	/* Ast/shrinkify.scm 87 */
							obj_t BgL_method3102z00_1580;

							{	/* Ast/shrinkify.scm 87 */
								BgL_objectz00_bglt BgL_objz00_1581;

								BgL_objz00_1581 = (BgL_objectz00_bglt) (BgL_arg3230z00_1197);
								{	/* Ast/shrinkify.scm 87 */
									long BgL_objzd2classzd2numz00_1582;

									BgL_objzd2classzd2numz00_1582 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1581);
									{	/* Ast/shrinkify.scm 87 */
										obj_t BgL_arg2334z00_1583;

										BgL_arg2334z00_1583 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 87 */
											obj_t BgL_arrayz00_1585;

											int BgL_offsetz00_1586;

											BgL_arrayz00_1585 = BgL_arg2334z00_1583;
											BgL_offsetz00_1586 =
												(int) (BgL_objzd2classzd2numz00_1582);
											{	/* Ast/shrinkify.scm 87 */
												long BgL_offsetz00_1587;

												BgL_offsetz00_1587 =
													((long) (BgL_offsetz00_1586) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 87 */
													long BgL_modz00_1588;

													{	/* Ast/shrinkify.scm 87 */
														int BgL_arg2336z00_1589;

														BgL_arg2336z00_1589 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 87 */
															long BgL_auxz00_3582;

															BgL_auxz00_3582 = (long) (BgL_arg2336z00_1589);
															BgL_modz00_1588 =
																(BgL_offsetz00_1587 / BgL_auxz00_3582);
													}}
													{	/* Ast/shrinkify.scm 87 */
														long BgL_restz00_1590;

														{	/* Ast/shrinkify.scm 87 */
															int BgL_arg2335z00_1591;

															BgL_arg2335z00_1591 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 87 */
																long BgL_auxz00_3586;

																BgL_auxz00_3586 = (long) (BgL_arg2335z00_1591);
																BgL_restz00_1590 =
																	(BgL_offsetz00_1587 % BgL_auxz00_3586);
														}}
														{	/* Ast/shrinkify.scm 87 */

															BgL_method3102z00_1580 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1585,
																	(int) (BgL_modz00_1588)),
																(int) (BgL_restz00_1590));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 87 */
								obj_t BgL_xz00_2540;

								BgL_xz00_2540 =
									PROCEDURE_ENTRY(BgL_method3102z00_1580)
									(BgL_method3102z00_1580, (obj_t) (BgL_arg3230z00_1197), BEOA);
								BgL_res3324z00_1605 = BUNSPEC;
						}} BgL_res3324z00_1605;
				}}
				{	/* Ast/shrinkify.scm 88 */
					BgL_nodez00_bglt BgL_arg3232z00_1198;

					BgL_arg3232z00_1198 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1189))->BgL_argz00);
					{	/* Ast/shrinkify.scm 88 */
						obj_t BgL_res3327z00_1633;

						{	/* Ast/shrinkify.scm 88 */
							obj_t BgL_method3102z00_1608;

							{	/* Ast/shrinkify.scm 88 */
								BgL_objectz00_bglt BgL_objz00_1609;

								BgL_objz00_1609 = (BgL_objectz00_bglt) (BgL_arg3232z00_1198);
								{	/* Ast/shrinkify.scm 88 */
									long BgL_objzd2classzd2numz00_1610;

									BgL_objzd2classzd2numz00_1610 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1609);
									{	/* Ast/shrinkify.scm 88 */
										obj_t BgL_arg2334z00_1611;

										BgL_arg2334z00_1611 =
											PROCEDURE_REF
											(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
											(int) (((long) 1)));
										{	/* Ast/shrinkify.scm 88 */
											obj_t BgL_arrayz00_1613;

											int BgL_offsetz00_1614;

											BgL_arrayz00_1613 = BgL_arg2334z00_1611;
											BgL_offsetz00_1614 =
												(int) (BgL_objzd2classzd2numz00_1610);
											{	/* Ast/shrinkify.scm 88 */
												long BgL_offsetz00_1615;

												BgL_offsetz00_1615 =
													((long) (BgL_offsetz00_1614) - OBJECT_TYPE);
												{	/* Ast/shrinkify.scm 88 */
													long BgL_modz00_1616;

													{	/* Ast/shrinkify.scm 88 */
														int BgL_arg2336z00_1617;

														BgL_arg2336z00_1617 = (int) (((long) 8));
														{	/* Ast/shrinkify.scm 88 */
															long BgL_auxz00_3605;

															BgL_auxz00_3605 = (long) (BgL_arg2336z00_1617);
															BgL_modz00_1616 =
																(BgL_offsetz00_1615 / BgL_auxz00_3605);
													}}
													{	/* Ast/shrinkify.scm 88 */
														long BgL_restz00_1618;

														{	/* Ast/shrinkify.scm 88 */
															int BgL_arg2335z00_1619;

															BgL_arg2335z00_1619 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 88 */
																long BgL_auxz00_3609;

																BgL_auxz00_3609 = (long) (BgL_arg2335z00_1619);
																BgL_restz00_1618 =
																	(BgL_offsetz00_1615 % BgL_auxz00_3609);
														}}
														{	/* Ast/shrinkify.scm 88 */

															BgL_method3102z00_1608 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1613,
																	(int) (BgL_modz00_1616)),
																(int) (BgL_restz00_1618));
							}}}}}}}}
							{	/* Ast/shrinkify.scm 88 */
								obj_t BgL_xz00_2541;

								BgL_xz00_2541 =
									PROCEDURE_ENTRY(BgL_method3102z00_1608)
									(BgL_method3102z00_1608, (obj_t) (BgL_arg3232z00_1198), BEOA);
								BgL_res3327z00_1633 = BUNSPEC;
						}} BgL_res3327z00_1633;
				}}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-app3112 */
	obj_t BGl_shrinkzd2nodez12zd2app3112z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2503, obj_t BgL_nodez00_2504)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 76 */
			{
				BgL_appz00_bglt BgL_nodez00_1177;

				BgL_nodez00_1177 = (BgL_appz00_bglt) (BgL_nodez00_2504);
				{	/* Ast/shrinkify.scm 77 */
					bool_t BgL_testz00_3620;

					{	/* Ast/shrinkify.scm 77 */
						bool_t BgL_testz00_3621;

						{	/* Ast/shrinkify.scm 77 */
							obj_t BgL_auxz00_3622;

							{	/* Ast/shrinkify.scm 77 */
								BgL_objectz00_bglt BgL_auxz00_3623;

								BgL_auxz00_3623 = (BgL_objectz00_bglt) (BgL_nodez00_1177);
								BgL_auxz00_3622 = BGL_OBJECT_WIDENING(BgL_auxz00_3623);
							}
							BgL_testz00_3621 = CBOOL(BgL_auxz00_3622);
						}
						if (BgL_testz00_3621)
							{	/* Ast/shrinkify.scm 77 */
								BgL_testz00_3620 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 77 */
								BgL_testz00_3620 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3620)
						{	/* Ast/shrinkify.scm 77 */
							{	/* Ast/shrinkify.scm 77 */
								long BgL_arg3219z00_1182;

								{	/* Ast/shrinkify.scm 77 */
									obj_t BgL_arg3220z00_1183;

									{	/* Ast/shrinkify.scm 77 */
										obj_t BgL_arg3221z00_1184;

										{	/* Ast/shrinkify.scm 77 */
											BgL_objectz00_bglt BgL_objectz00_1526;

											BgL_objectz00_1526 =
												(BgL_objectz00_bglt) (BgL_nodez00_1177);
											{	/* Ast/shrinkify.scm 77 */
												long BgL_arg2337z00_1527;

												{	/* Ast/shrinkify.scm 77 */
													long BgL_arg2338z00_1528;

													BgL_arg2338z00_1528 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1526);
													BgL_arg2337z00_1527 =
														(BgL_arg2338z00_1528 - OBJECT_TYPE);
												}
												BgL_arg3221z00_1184 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2337z00_1527));
										}}
										BgL_arg3220z00_1183 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3221z00_1184);
									}
									BgL_arg3219z00_1182 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3220z00_1183);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_nodez00_1177), BgL_arg3219z00_1182);
							}
							{	/* Ast/shrinkify.scm 77 */
								BgL_objectz00_bglt BgL_auxz00_3636;

								BgL_auxz00_3636 = (BgL_objectz00_bglt) (BgL_nodez00_1177);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3636, BFALSE);
							}
							(obj_t) (BgL_nodez00_1177);
						}
					else
						{	/* Ast/shrinkify.scm 77 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 78 */
					BgL_varz00_bglt BgL_arg3222z00_1185;

					BgL_arg3222z00_1185 =
						(((BgL_appz00_bglt) CREF(BgL_nodez00_1177))->BgL_funz00);
					{	/* Ast/shrinkify.scm 78 */
						obj_t BgL_res3320z00_1563;

						{	/* Ast/shrinkify.scm 78 */
							BgL_nodez00_bglt BgL_nodez00_1537;

							BgL_nodez00_1537 = (BgL_nodez00_bglt) (BgL_arg3222z00_1185);
							{	/* Ast/shrinkify.scm 78 */
								obj_t BgL_method3102z00_1538;

								{	/* Ast/shrinkify.scm 78 */
									BgL_objectz00_bglt BgL_objz00_1539;

									BgL_objz00_1539 = (BgL_objectz00_bglt) (BgL_nodez00_1537);
									{	/* Ast/shrinkify.scm 78 */
										long BgL_objzd2classzd2numz00_1540;

										BgL_objzd2classzd2numz00_1540 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1539);
										{	/* Ast/shrinkify.scm 78 */
											obj_t BgL_arg2334z00_1541;

											BgL_arg2334z00_1541 =
												PROCEDURE_REF
												(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
												(int) (((long) 1)));
											{	/* Ast/shrinkify.scm 78 */
												obj_t BgL_arrayz00_1543;

												int BgL_offsetz00_1544;

												BgL_arrayz00_1543 = BgL_arg2334z00_1541;
												BgL_offsetz00_1544 =
													(int) (BgL_objzd2classzd2numz00_1540);
												{	/* Ast/shrinkify.scm 78 */
													long BgL_offsetz00_1545;

													BgL_offsetz00_1545 =
														((long) (BgL_offsetz00_1544) - OBJECT_TYPE);
													{	/* Ast/shrinkify.scm 78 */
														long BgL_modz00_1546;

														{	/* Ast/shrinkify.scm 78 */
															int BgL_arg2336z00_1547;

															BgL_arg2336z00_1547 = (int) (((long) 8));
															{	/* Ast/shrinkify.scm 78 */
																long BgL_auxz00_3650;

																BgL_auxz00_3650 = (long) (BgL_arg2336z00_1547);
																BgL_modz00_1546 =
																	(BgL_offsetz00_1545 / BgL_auxz00_3650);
														}}
														{	/* Ast/shrinkify.scm 78 */
															long BgL_restz00_1548;

															{	/* Ast/shrinkify.scm 78 */
																int BgL_arg2335z00_1549;

																BgL_arg2335z00_1549 = (int) (((long) 8));
																{	/* Ast/shrinkify.scm 78 */
																	long BgL_auxz00_3654;

																	BgL_auxz00_3654 =
																		(long) (BgL_arg2335z00_1549);
																	BgL_restz00_1548 =
																		(BgL_offsetz00_1545 % BgL_auxz00_3654);
															}}
															{	/* Ast/shrinkify.scm 78 */

																BgL_method3102z00_1538 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1543,
																		(int) (BgL_modz00_1546)),
																	(int) (BgL_restz00_1548));
								}}}}}}}}
								{	/* Ast/shrinkify.scm 78 */
									obj_t BgL_xz00_2542;

									BgL_xz00_2542 =
										PROCEDURE_ENTRY(BgL_method3102z00_1538)
										(BgL_method3102z00_1538, (obj_t) (BgL_nodez00_1537), BEOA);
									BgL_res3320z00_1563 = BUNSPEC;
						}}} BgL_res3320z00_1563;
				}}
				{	/* Ast/shrinkify.scm 79 */
					obj_t BgL_arg3223z00_1186;

					BgL_arg3223z00_1186 =
						(((BgL_appz00_bglt) CREF(BgL_nodez00_1177))->BgL_argsz00);
					BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3223z00_1186);
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-sequenc3110 */
	obj_t BGl_shrinkzd2nodez12zd2sequenc3110z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2505, obj_t BgL_nodez00_2506)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 69 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1171;

				BgL_nodez00_1171 = (BgL_sequencez00_bglt) (BgL_nodez00_2506);
				{	/* Ast/shrinkify.scm 70 */
					obj_t BgL_arg3216z00_1521;

					BgL_arg3216z00_1521 =
						(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1171))->BgL_nodesz00);
					BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(BgL_arg3216z00_1521);
				}
				return BUNSPEC;
			}
		}
	}



/* shrink-node!-kwote3108 */
	obj_t BGl_shrinkzd2nodez12zd2kwote3108z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2507, obj_t BgL_nodez00_2508)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 63 */
			return BUNSPEC;
		}
	}



/* shrink-node!-var3106 */
	obj_t BGl_shrinkzd2nodez12zd2var3106z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2509, obj_t BgL_nodez00_2510)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 57 */
			return BUNSPEC;
		}
	}



/* shrink-node!-atom3104 */
	obj_t BGl_shrinkzd2nodez12zd2atom3104z12zzast_shrinkifyz00(obj_t
		BgL_envz00_2511, obj_t BgL_nodez00_2512)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 51 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3429z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3429z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3429z00zzast_shrinkifyz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3429z00zzast_shrinkifyz00));
		}
	}

#ifdef __cplusplus
}
#endif
