/*===========================================================================*/
/*   (Ast/substitute.scm)                                                    */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/substitute.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;


	static obj_t BGl_dozd2substitutez12zd2setq3128z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_dozd2substitutez12zd2jumpzd23142zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	static obj_t BGl_dozd2substitutez12zd2boxzd2s3149zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substituteza2z12z62zzast_substitutez00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_substitutez00();
	static obj_t BGl_dozd2substitutez12zd2exter3124z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	static obj_t BGl_dozd2substitutez12zd2fail3132z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2letzd2f3136zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_substitutez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzast_substitutez00();
	static obj_t BGl_dozd2substitutez12zd2appzd2l3120zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern BgL_closurez00_bglt BGl_makezd2closurezd2zzast_nodez00(obj_t,
		BgL_typez00_bglt, BgL_variablez00_bglt);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_dozd2substitutez12zd2app3118z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_dozd2substitutez12zc0zzast_substitutez00(BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_dozd2substitutez12zd2setzd2e3140zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	extern bool_t BGl_globalzd2optionalzf3z21zzast_varz00(obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_dozd2substitutez12zd2defau3105z12zzast_substitutez00(BgL_nodez00_bglt,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2letzd2v3138zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_substitutez00();
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_substitutez00 = BUNSPEC;
	extern obj_t BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt,
		obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2kwote3114z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_knownzd2appzd2lyzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, BgL_nodez00_bglt, BgL_nodez00_bglt, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_substitutez00();
	static obj_t BGl_dozd2substitutez12zd2var3112z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	static obj_t BGl_dozd2substitutez12zd2atom3110z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_makezd2appzd2nodez00zzast_appz00(obj_t, obj_t,
		obj_t, BgL_varz00_bglt, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_dozd2substitutez12zd2selec3134z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern bool_t
		BGl_correctzd2arityzd2appzf3zf3zzast_appz00(BgL_variablez00_bglt, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_substitutez00();
	static obj_t BGl_dozd2substitutez12zd2funca3122z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_substitutez12z12zzast_substitutez00(obj_t, obj_t, BgL_nodez00_bglt,
		obj_t);
	static obj_t BGl__dozd2substitutez12zd2defau3105z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl__dozd2substitutez12zc0zzast_substitutez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_dozd2substitutez12zd2seque3116z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2condi3130z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dozd2substitutez12zd2cast3126z12zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__substitutez12z12zzast_substitutez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_varz00_bglt BGl_makezd2varzd2zzast_nodez00(obj_t, BgL_typez00_bglt,
		BgL_variablez00_bglt);
	static obj_t BGl_dozd2substitutez12zd2boxzd2r3147zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_globalzd2keyzf3z21zzast_varz00(obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_substitutez00();
	static obj_t BGl_dozd2substitutez12zd2makezd23144zc0zzast_substitutez00(obj_t,
		obj_t, obj_t);
	static obj_t __cnst[7];


	   
		 
		DEFINE_STATIC_BGL_GENERIC
		(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
		BgL_bgl__doza7d2substitute3482za7,
		BGl__dozd2substitutez12zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_substitutez12zd2envzc0zzast_substitutez00,
		BgL_bgl__substituteza712za713483z00,
		BGl__substitutez12z12zzast_substitutez00, 0L, BUNSPEC, 4);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_dozd2substitutez12zd2defau3105zd2envzc0zzast_substitutez00,
		BgL_bgl__doza7d2substitute3484za7,
		BGl__dozd2substitutez12zd2defau3105z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3454z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73485z00,
		BGl_dozd2substitutez12zd2atom3110z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3455z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73486z00,
		BGl_dozd2substitutez12zd2var3112z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3456z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73487z00,
		BGl_dozd2substitutez12zd2kwote3114z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3457z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73488z00,
		BGl_dozd2substitutez12zd2seque3116z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3458z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73489z00,
		BGl_dozd2substitutez12zd2app3118z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3460z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73490z00,
		BGl_dozd2substitutez12zd2funca3122z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3459z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73491z00,
		BGl_dozd2substitutez12zd2appzd2l3120zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3461z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73492z00,
		BGl_dozd2substitutez12zd2exter3124z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3462z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73493z00,
		BGl_dozd2substitutez12zd2cast3126z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3463z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73494z00,
		BGl_dozd2substitutez12zd2setq3128z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3464z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73495z00,
		BGl_dozd2substitutez12zd2condi3130z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3465z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73496z00,
		BGl_dozd2substitutez12zd2fail3132z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3466z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73497z00,
		BGl_dozd2substitutez12zd2selec3134z12zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3467z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73498z00,
		BGl_dozd2substitutez12zd2letzd2f3136zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3468z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73499z00,
		BGl_dozd2substitutez12zd2letzd2v3138zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3470z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73500z00,
		BGl_dozd2substitutez12zd2jumpzd23142zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3469z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73501z00,
		BGl_dozd2substitutez12zd2setzd2e3140zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3471z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73502z00,
		BGl_dozd2substitutez12zd2makezd23144zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3472z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73503z00,
		BGl_dozd2substitutez12zd2boxzd2r3147zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3473z00zzast_substitutez00,
		BgL_bgl_doza7d2substituteza73504z00,
		BGl_dozd2substitutez12zd2boxzd2s3149zc0zzast_substitutez00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3453z00zzast_substitutez00,
		BgL_bgl_string3453za700za7za7a3505za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3474z00zzast_substitutez00,
		BgL_bgl_string3474za700za7za7a3506za7, "Illegal application", 19);
	      DEFINE_STRING(BGl_string3475z00zzast_substitutez00,
		BgL_bgl_string3475za700za7za7a3507za7, "wrong number of argument(s)", 27);
	      DEFINE_STRING(BGl_string3476z00zzast_substitutez00,
		BgL_bgl_string3476za700za7za7a3508za7, "duplicate", 9);
	      DEFINE_STRING(BGl_string3477z00zzast_substitutez00,
		BgL_bgl_string3477za700za7za7a3509za7, "Illegal substitution", 20);
	      DEFINE_STRING(BGl_string3478z00zzast_substitutez00,
		BgL_bgl_string3478za700za7za7a3510za7, "ast_substitute", 14);
	      DEFINE_STRING(BGl_string3479z00zzast_substitutez00,
		BgL_bgl_string3479za700za7za7a3511za7,
		"apply funcall set! app do-substitute!-defau3105 value done ", 59);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzast_substitutez00(long
		BgL_checksumz00_2590, char *BgL_fromz00_2591)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_substitutez00))
				{
					BGl_requirezd2initializa7ationz75zzast_substitutez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_substitutez00();
					BGl_cnstzd2initzd2zzast_substitutez00();
					BGl_importedzd2moduleszd2initz00zzast_substitutez00();
					BGl_genericzd2initzd2zzast_substitutez00();
					BGl_methodzd2initzd2zzast_substitutez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"ast_substitute");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"ast_substitute");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"ast_substitute");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			{	/* Ast/substitute.scm 14 */
				obj_t BgL_cportz00_2578;

				BgL_cportz00_2578 =
					bgl_open_input_string(BGl_string3479z00zzast_substitutez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2579;

					BgL_iz00_2579 = ((long) 6);
				BgL_loopz00_2580:
					if ((BgL_iz00_2579 == ((long) -1)))
						{	/* Ast/substitute.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/substitute.scm 14 */
							{	/* Ast/substitute.scm 14 */
								obj_t BgL_arg3481z00_2582;

								{	/* Ast/substitute.scm 14 */

									{	/* Ast/substitute.scm 14 */
										obj_t BgL_locationz00_2584;

										BgL_locationz00_2584 = BBOOL(((bool_t) 0));
										{	/* Ast/substitute.scm 14 */

											BgL_arg3481z00_2582 =
												BGl_readz00zz__readerz00(BgL_cportz00_2578,
												BgL_locationz00_2584);
										}
									}
								}
								{	/* Ast/substitute.scm 14 */
									int BgL_auxz00_2609;

									BgL_auxz00_2609 = (int) (BgL_iz00_2579);
									CNST_TABLE_SET(BgL_auxz00_2609, BgL_arg3481z00_2582);
							}}
							{	/* Ast/substitute.scm 14 */
								int BgL_auxz00_2585;

								BgL_auxz00_2585 = (int) ((BgL_iz00_2579 - ((long) 1)));
								{
									long BgL_iz00_2614;

									BgL_iz00_2614 = (long) (BgL_auxz00_2585);
									BgL_iz00_2579 = BgL_iz00_2614;
									goto BgL_loopz00_2580;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			return BUNSPEC;
		}
	}



/* substitute! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_substitutez12z12zzast_substitutez00(obj_t BgL_whatza2za2_1,
		obj_t BgL_byza2za2_2, BgL_nodez00_bglt BgL_nodez00_3, obj_t BgL_sitez00_4)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 34 */
			{
				obj_t BgL_ll3079z00_775;

				obj_t BgL_ll3080z00_776;

				BgL_ll3079z00_775 = BgL_whatza2za2_1;
				BgL_ll3080z00_776 = BgL_byza2za2_2;
			BgL_forzd2each3082zd2_777:
				if (NULLP(BgL_ll3079z00_775))
					{	/* Ast/substitute.scm 37 */
						((bool_t) 1);
					}
				else
					{	/* Ast/substitute.scm 37 */
						{	/* Ast/substitute.scm 39 */
							obj_t BgL_whatz00_779;

							obj_t BgL_byz00_780;

							BgL_whatz00_779 = CAR(BgL_ll3079z00_775);
							BgL_byz00_780 = CAR(BgL_ll3080z00_776);
							{
								BgL_variablez00_bglt BgL_auxz00_2620;

								BgL_auxz00_2620 = (BgL_variablez00_bglt) (BgL_whatz00_779);
								((((BgL_variablez00_bglt) CREF(BgL_auxz00_2620))->
										BgL_fastzd2alphazd2) = ((obj_t) BgL_byz00_780), BUNSPEC);
							}
						}
						{
							obj_t BgL_ll3080z00_2625;

							obj_t BgL_ll3079z00_2623;

							BgL_ll3079z00_2623 = CDR(BgL_ll3079z00_775);
							BgL_ll3080z00_2625 = CDR(BgL_ll3080z00_776);
							BgL_ll3080z00_776 = BgL_ll3080z00_2625;
							BgL_ll3079z00_775 = BgL_ll3079z00_2623;
							goto BgL_forzd2each3082zd2_777;
						}
					}
			}
			{	/* Ast/substitute.scm 42 */
				BgL_nodez00_bglt BgL_resz00_783;

				{	/* Ast/substitute.scm 42 */
					BgL_nodez00_bglt BgL_res3363z00_1487;

					{	/* Ast/substitute.scm 42 */
						obj_t BgL_method3108z00_1462;

						{	/* Ast/substitute.scm 42 */
							BgL_objectz00_bglt BgL_objz00_1463;

							BgL_objz00_1463 = (BgL_objectz00_bglt) (BgL_nodez00_3);
							{	/* Ast/substitute.scm 42 */
								long BgL_objzd2classzd2numz00_1464;

								BgL_objzd2classzd2numz00_1464 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_1463);
								{	/* Ast/substitute.scm 42 */
									obj_t BgL_arg2334z00_1465;

									BgL_arg2334z00_1465 =
										PROCEDURE_REF
										(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
										(int) (((long) 1)));
									{	/* Ast/substitute.scm 42 */
										obj_t BgL_arrayz00_1467;

										int BgL_offsetz00_1468;

										BgL_arrayz00_1467 = BgL_arg2334z00_1465;
										BgL_offsetz00_1468 = (int) (BgL_objzd2classzd2numz00_1464);
										{	/* Ast/substitute.scm 42 */
											long BgL_offsetz00_1469;

											BgL_offsetz00_1469 =
												((long) (BgL_offsetz00_1468) - OBJECT_TYPE);
											{	/* Ast/substitute.scm 42 */
												long BgL_modz00_1470;

												{	/* Ast/substitute.scm 42 */
													int BgL_arg2336z00_1471;

													BgL_arg2336z00_1471 = (int) (((long) 8));
													{	/* Ast/substitute.scm 42 */
														long BgL_auxz00_2635;

														BgL_auxz00_2635 = (long) (BgL_arg2336z00_1471);
														BgL_modz00_1470 =
															(BgL_offsetz00_1469 / BgL_auxz00_2635);
												}}
												{	/* Ast/substitute.scm 42 */
													long BgL_restz00_1472;

													{	/* Ast/substitute.scm 42 */
														int BgL_arg2335z00_1473;

														BgL_arg2335z00_1473 = (int) (((long) 8));
														{	/* Ast/substitute.scm 42 */
															long BgL_auxz00_2639;

															BgL_auxz00_2639 = (long) (BgL_arg2335z00_1473);
															BgL_restz00_1472 =
																(BgL_offsetz00_1469 % BgL_auxz00_2639);
													}}
													{	/* Ast/substitute.scm 42 */

														BgL_method3108z00_1462 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_1467,
																(int) (BgL_modz00_1470)),
															(int) (BgL_restz00_1472));
						}}}}}}}}
						BgL_res3363z00_1487 =
							(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1462)
							(BgL_method3108z00_1462, (obj_t) (BgL_nodez00_3), BgL_sitez00_4,
								BEOA));
					}
					BgL_resz00_783 = BgL_res3363z00_1487;
				}
				{
					obj_t BgL_l3083z00_784;

					BgL_l3083z00_784 = BgL_whatza2za2_1;
				BgL_forzd2each3085zd2_785:
					if (PAIRP(BgL_l3083z00_784))
						{	/* Ast/substitute.scm 44 */
							{	/* Ast/substitute.scm 45 */
								obj_t BgL_whatz00_787;

								BgL_whatz00_787 = CAR(BgL_l3083z00_784);
								{
									BgL_variablez00_bglt BgL_auxz00_2653;

									BgL_auxz00_2653 = (BgL_variablez00_bglt) (BgL_whatz00_787);
									((((BgL_variablez00_bglt) CREF(BgL_auxz00_2653))->
											BgL_fastzd2alphazd2) = ((obj_t) BUNSPEC), BUNSPEC);
								}
							}
							{
								obj_t BgL_l3083z00_2656;

								BgL_l3083z00_2656 = CDR(BgL_l3083z00_784);
								BgL_l3083z00_784 = BgL_l3083z00_2656;
								goto BgL_forzd2each3085zd2_785;
							}
						}
					else
						{	/* Ast/substitute.scm 44 */
							((bool_t) 1);
						}
				}
				return BgL_resz00_783;
			}
		}
	}



/* _substitute! */
	obj_t BGl__substitutez12z12zzast_substitutez00(obj_t BgL_envz00_2487,
		obj_t BgL_whatza2za2_2488, obj_t BgL_byza2za2_2489, obj_t BgL_nodez00_2490,
		obj_t BgL_sitez00_2491)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 34 */
			return
				(obj_t) (BGl_substitutez12z12zzast_substitutez00(BgL_whatza2za2_2488,
					BgL_byza2za2_2489, (BgL_nodez00_bglt) (BgL_nodez00_2490),
					BgL_sitez00_2491));
		}
	}



/* do-substitute*! */
	obj_t BGl_dozd2substituteza2z12z62zzast_substitutez00(obj_t BgL_nodeza2za2_49,
		obj_t BgL_sitez00_50)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 271 */
		BGl_dozd2substituteza2z12z62zzast_substitutez00:
			if (NULLP(BgL_nodeza2za2_49))
				{	/* Ast/substitute.scm 273 */
					return CNST_TABLE_REF(((long) 0));
				}
			else
				{	/* Ast/substitute.scm 273 */
					if (NULLP(CDR(BgL_nodeza2za2_49)))
						{	/* Ast/substitute.scm 275 */
							{	/* Ast/substitute.scm 276 */
								BgL_nodez00_bglt BgL_arg3157z00_791;

								{	/* Ast/substitute.scm 276 */
									obj_t BgL_arg3158z00_792;

									BgL_arg3158z00_792 = CAR(BgL_nodeza2za2_49);
									{	/* Ast/substitute.scm 276 */
										BgL_nodez00_bglt BgL_res3366z00_1524;

										{	/* Ast/substitute.scm 276 */
											BgL_nodez00_bglt BgL_nodez00_1497;

											BgL_nodez00_1497 =
												(BgL_nodez00_bglt) (BgL_arg3158z00_792);
											{	/* Ast/substitute.scm 276 */
												obj_t BgL_method3108z00_1499;

												{	/* Ast/substitute.scm 276 */
													BgL_objectz00_bglt BgL_objz00_1500;

													BgL_objz00_1500 =
														(BgL_objectz00_bglt) (BgL_nodez00_1497);
													{	/* Ast/substitute.scm 276 */
														long BgL_objzd2classzd2numz00_1501;

														BgL_objzd2classzd2numz00_1501 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1500);
														{	/* Ast/substitute.scm 276 */
															obj_t BgL_arg2334z00_1502;

															BgL_arg2334z00_1502 =
																PROCEDURE_REF
																(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																(int) (((long) 1)));
															{	/* Ast/substitute.scm 276 */
																obj_t BgL_arrayz00_1504;

																int BgL_offsetz00_1505;

																BgL_arrayz00_1504 = BgL_arg2334z00_1502;
																BgL_offsetz00_1505 =
																	(int) (BgL_objzd2classzd2numz00_1501);
																{	/* Ast/substitute.scm 276 */
																	long BgL_offsetz00_1506;

																	BgL_offsetz00_1506 =
																		((long) (BgL_offsetz00_1505) - OBJECT_TYPE);
																	{	/* Ast/substitute.scm 276 */
																		long BgL_modz00_1507;

																		{	/* Ast/substitute.scm 276 */
																			int BgL_arg2336z00_1508;

																			BgL_arg2336z00_1508 = (int) (((long) 8));
																			{	/* Ast/substitute.scm 276 */
																				long BgL_auxz00_2677;

																				BgL_auxz00_2677 =
																					(long) (BgL_arg2336z00_1508);
																				BgL_modz00_1507 =
																					(BgL_offsetz00_1506 /
																					BgL_auxz00_2677);
																		}}
																		{	/* Ast/substitute.scm 276 */
																			long BgL_restz00_1509;

																			{	/* Ast/substitute.scm 276 */
																				int BgL_arg2335z00_1510;

																				BgL_arg2335z00_1510 =
																					(int) (((long) 8));
																				{	/* Ast/substitute.scm 276 */
																					long BgL_auxz00_2681;

																					BgL_auxz00_2681 =
																						(long) (BgL_arg2335z00_1510);
																					BgL_restz00_1509 =
																						(BgL_offsetz00_1506 %
																						BgL_auxz00_2681);
																			}}
																			{	/* Ast/substitute.scm 276 */

																				BgL_method3108z00_1499 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1504,
																						(int) (BgL_modz00_1507)),
																					(int) (BgL_restz00_1509));
												}}}}}}}}
												BgL_res3366z00_1524 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3108z00_1499) (BgL_method3108z00_1499,
														(obj_t) (BgL_nodez00_1497), BgL_sitez00_50, BEOA));
										}}
										BgL_arg3157z00_791 = BgL_res3366z00_1524;
								}}
								{	/* Ast/substitute.scm 276 */
									obj_t BgL_auxz00_2692;

									BgL_auxz00_2692 = (obj_t) (BgL_arg3157z00_791);
									SET_CAR(BgL_nodeza2za2_49, BgL_auxz00_2692);
							}}
							return CNST_TABLE_REF(((long) 0));
						}
					else
						{	/* Ast/substitute.scm 275 */
							{	/* Ast/substitute.scm 279 */
								BgL_nodez00_bglt BgL_arg3159z00_793;

								{	/* Ast/substitute.scm 279 */
									obj_t BgL_arg3160z00_794;

									obj_t BgL_arg3161z00_795;

									BgL_arg3160z00_794 = CAR(BgL_nodeza2za2_49);
									BgL_arg3161z00_795 = CNST_TABLE_REF(((long) 1));
									{	/* Ast/substitute.scm 279 */
										BgL_nodez00_bglt BgL_res3369z00_1555;

										{	/* Ast/substitute.scm 279 */
											BgL_nodez00_bglt BgL_nodez00_1528;

											BgL_nodez00_1528 =
												(BgL_nodez00_bglt) (BgL_arg3160z00_794);
											{	/* Ast/substitute.scm 279 */
												obj_t BgL_method3108z00_1530;

												{	/* Ast/substitute.scm 279 */
													BgL_objectz00_bglt BgL_objz00_1531;

													BgL_objz00_1531 =
														(BgL_objectz00_bglt) (BgL_nodez00_1528);
													{	/* Ast/substitute.scm 279 */
														long BgL_objzd2classzd2numz00_1532;

														BgL_objzd2classzd2numz00_1532 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1531);
														{	/* Ast/substitute.scm 279 */
															obj_t BgL_arg2334z00_1533;

															BgL_arg2334z00_1533 =
																PROCEDURE_REF
																(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																(int) (((long) 1)));
															{	/* Ast/substitute.scm 279 */
																obj_t BgL_arrayz00_1535;

																int BgL_offsetz00_1536;

																BgL_arrayz00_1535 = BgL_arg2334z00_1533;
																BgL_offsetz00_1536 =
																	(int) (BgL_objzd2classzd2numz00_1532);
																{	/* Ast/substitute.scm 279 */
																	long BgL_offsetz00_1537;

																	BgL_offsetz00_1537 =
																		((long) (BgL_offsetz00_1536) - OBJECT_TYPE);
																	{	/* Ast/substitute.scm 279 */
																		long BgL_modz00_1538;

																		{	/* Ast/substitute.scm 279 */
																			int BgL_arg2336z00_1539;

																			BgL_arg2336z00_1539 = (int) (((long) 8));
																			{	/* Ast/substitute.scm 279 */
																				long BgL_auxz00_2707;

																				BgL_auxz00_2707 =
																					(long) (BgL_arg2336z00_1539);
																				BgL_modz00_1538 =
																					(BgL_offsetz00_1537 /
																					BgL_auxz00_2707);
																		}}
																		{	/* Ast/substitute.scm 279 */
																			long BgL_restz00_1540;

																			{	/* Ast/substitute.scm 279 */
																				int BgL_arg2335z00_1541;

																				BgL_arg2335z00_1541 =
																					(int) (((long) 8));
																				{	/* Ast/substitute.scm 279 */
																					long BgL_auxz00_2711;

																					BgL_auxz00_2711 =
																						(long) (BgL_arg2335z00_1541);
																					BgL_restz00_1540 =
																						(BgL_offsetz00_1537 %
																						BgL_auxz00_2711);
																			}}
																			{	/* Ast/substitute.scm 279 */

																				BgL_method3108z00_1530 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1535,
																						(int) (BgL_modz00_1538)),
																					(int) (BgL_restz00_1540));
												}}}}}}}}
												BgL_res3369z00_1555 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3108z00_1530) (BgL_method3108z00_1530,
														(obj_t) (BgL_nodez00_1528), BgL_arg3161z00_795,
														BEOA));
										}}
										BgL_arg3159z00_793 = BgL_res3369z00_1555;
								}}
								{	/* Ast/substitute.scm 279 */
									obj_t BgL_auxz00_2722;

									BgL_auxz00_2722 = (obj_t) (BgL_arg3159z00_793);
									SET_CAR(BgL_nodeza2za2_49, BgL_auxz00_2722);
							}}
							{
								obj_t BgL_nodeza2za2_2725;

								BgL_nodeza2za2_2725 = CDR(BgL_nodeza2za2_49);
								BgL_nodeza2za2_49 = BgL_nodeza2za2_2725;
								goto BGl_dozd2substituteza2z12z62zzast_substitutez00;
							}
						}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_dozd2substitutez12zd2defau3105zd2envzc0zzast_substitutez00);
		}
	}



/* do-substitute! */
	BgL_nodez00_bglt BGl_dozd2substitutez12zc0zzast_substitutez00(BgL_nodez00_bglt
		BgL_nodez00_5, obj_t BgL_sitez00_6)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 52 */
			{	/* Ast/substitute.scm 52 */
				obj_t BgL_method3108z00_1559;

				{	/* Ast/substitute.scm 52 */
					BgL_objectz00_bglt BgL_objz00_1560;

					BgL_objz00_1560 = (BgL_objectz00_bglt) (BgL_nodez00_5);
					{	/* Ast/substitute.scm 52 */
						long BgL_objzd2classzd2numz00_1561;

						BgL_objzd2classzd2numz00_1561 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1560);
						{	/* Ast/substitute.scm 52 */
							obj_t BgL_arg2334z00_1562;

							BgL_arg2334z00_1562 =
								PROCEDURE_REF
								(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
								(int) (((long) 1)));
							{	/* Ast/substitute.scm 52 */
								obj_t BgL_arrayz00_1564;

								int BgL_offsetz00_1565;

								BgL_arrayz00_1564 = BgL_arg2334z00_1562;
								BgL_offsetz00_1565 = (int) (BgL_objzd2classzd2numz00_1561);
								{	/* Ast/substitute.scm 52 */
									long BgL_offsetz00_1566;

									BgL_offsetz00_1566 =
										((long) (BgL_offsetz00_1565) - OBJECT_TYPE);
									{	/* Ast/substitute.scm 52 */
										long BgL_modz00_1567;

										{	/* Ast/substitute.scm 52 */
											int BgL_arg2336z00_1568;

											BgL_arg2336z00_1568 = (int) (((long) 8));
											{	/* Ast/substitute.scm 52 */
												long BgL_auxz00_2736;

												BgL_auxz00_2736 = (long) (BgL_arg2336z00_1568);
												BgL_modz00_1567 =
													(BgL_offsetz00_1566 / BgL_auxz00_2736);
										}}
										{	/* Ast/substitute.scm 52 */
											long BgL_restz00_1569;

											{	/* Ast/substitute.scm 52 */
												int BgL_arg2335z00_1570;

												BgL_arg2335z00_1570 = (int) (((long) 8));
												{	/* Ast/substitute.scm 52 */
													long BgL_auxz00_2740;

													BgL_auxz00_2740 = (long) (BgL_arg2335z00_1570);
													BgL_restz00_1569 =
														(BgL_offsetz00_1566 % BgL_auxz00_2740);
											}}
											{	/* Ast/substitute.scm 52 */

												BgL_method3108z00_1559 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1564,
														(int) (BgL_modz00_1567)), (int) (BgL_restz00_1569));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1559)
					(BgL_method3108z00_1559, (obj_t) (BgL_nodez00_5), BgL_sitez00_6,
						BEOA));
			}
		}
	}



/* _do-substitute! */
	obj_t BGl__dozd2substitutez12zc0zzast_substitutez00(obj_t BgL_envz00_2492,
		obj_t BgL_nodez00_2493, obj_t BgL_sitez00_2494)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 52 */
			return
				(obj_t) (BGl_dozd2substitutez12zc0zzast_substitutez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2493), BgL_sitez00_2494));
		}
	}



/* do-substitute!-defau3105 */
	BgL_nodez00_bglt
		BGl_dozd2substitutez12zd2defau3105z12zzast_substitutez00(BgL_nodez00_bglt
		BgL_nodez00_7, obj_t BgL_sitez00_8)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			return
				(BgL_nodez00_bglt) (BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
					BGl_string3453z00zzast_substitutez00, (obj_t) (BgL_nodez00_7)));
		}
	}



/* _do-substitute!-defau3105 */
	obj_t BGl__dozd2substitutez12zd2defau3105z12zzast_substitutez00(obj_t
		BgL_envz00_2495, obj_t BgL_nodez00_2496, obj_t BgL_sitez00_2497)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			return
				(obj_t) (BGl_dozd2substitutez12zd2defau3105z12zzast_substitutez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2496), BgL_sitez00_2497));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_atomz00zzast_nodez00, BGl_proc3454z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_varz00zzast_nodez00, BGl_proc3455z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_kwotez00zzast_nodez00, BGl_proc3456z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_sequencez00zzast_nodez00, BGl_proc3457z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_appz00zzast_nodez00, BGl_proc3458z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3459z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_funcallz00zzast_nodez00, BGl_proc3460z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_externz00zzast_nodez00, BGl_proc3461z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_castz00zzast_nodez00, BGl_proc3462z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_setqz00zzast_nodez00, BGl_proc3463z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3464z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_failz00zzast_nodez00, BGl_proc3465z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_selectz00zzast_nodez00, BGl_proc3466z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3467z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3468z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3469z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3470z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3471z00zzast_substitutez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3472z00zzast_substitutez00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3473z00zzast_substitutez00);
		}
	}



/* do-substitute!-box-s3149 */
	obj_t BGl_dozd2substitutez12zd2boxzd2s3149zc0zzast_substitutez00(obj_t
		BgL_envz00_2518, obj_t BgL_nodez00_2519, obj_t BgL_sitez00_2520)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 263 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1441;

				obj_t BgL_sitez00_1442;

				{	/* Ast/substitute.scm 264 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_2781;

					BgL_nodez00_1441 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2519);
					BgL_sitez00_1442 = BgL_sitez00_2520;
					{	/* Ast/substitute.scm 264 */
						BgL_nodez00_bglt BgL_arg3354z00_1445;

						{	/* Ast/substitute.scm 264 */
							BgL_varz00_bglt BgL_arg3355z00_1446;

							obj_t BgL_arg3356z00_1447;

							BgL_arg3355z00_1446 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1441))->
								BgL_varz00);
							BgL_arg3356z00_1447 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 264 */
								BgL_nodez00_bglt BgL_res3449z00_2453;

								{	/* Ast/substitute.scm 264 */
									BgL_nodez00_bglt BgL_nodez00_2426;

									BgL_nodez00_2426 = (BgL_nodez00_bglt) (BgL_arg3355z00_1446);
									{	/* Ast/substitute.scm 264 */
										obj_t BgL_method3108z00_2428;

										{	/* Ast/substitute.scm 264 */
											BgL_objectz00_bglt BgL_objz00_2429;

											BgL_objz00_2429 = (BgL_objectz00_bglt) (BgL_nodez00_2426);
											{	/* Ast/substitute.scm 264 */
												long BgL_objzd2classzd2numz00_2430;

												BgL_objzd2classzd2numz00_2430 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2429);
												{	/* Ast/substitute.scm 264 */
													obj_t BgL_arg2334z00_2431;

													BgL_arg2334z00_2431 =
														PROCEDURE_REF
														(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
														(int) (((long) 1)));
													{	/* Ast/substitute.scm 264 */
														obj_t BgL_arrayz00_2433;

														int BgL_offsetz00_2434;

														BgL_arrayz00_2433 = BgL_arg2334z00_2431;
														BgL_offsetz00_2434 =
															(int) (BgL_objzd2classzd2numz00_2430);
														{	/* Ast/substitute.scm 264 */
															long BgL_offsetz00_2435;

															BgL_offsetz00_2435 =
																((long) (BgL_offsetz00_2434) - OBJECT_TYPE);
															{	/* Ast/substitute.scm 264 */
																long BgL_modz00_2436;

																{	/* Ast/substitute.scm 264 */
																	int BgL_arg2336z00_2437;

																	BgL_arg2336z00_2437 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 264 */
																		long BgL_auxz00_2793;

																		BgL_auxz00_2793 =
																			(long) (BgL_arg2336z00_2437);
																		BgL_modz00_2436 =
																			(BgL_offsetz00_2435 / BgL_auxz00_2793);
																}}
																{	/* Ast/substitute.scm 264 */
																	long BgL_restz00_2438;

																	{	/* Ast/substitute.scm 264 */
																		int BgL_arg2335z00_2439;

																		BgL_arg2335z00_2439 = (int) (((long) 8));
																		{	/* Ast/substitute.scm 264 */
																			long BgL_auxz00_2797;

																			BgL_auxz00_2797 =
																				(long) (BgL_arg2335z00_2439);
																			BgL_restz00_2438 =
																				(BgL_offsetz00_2435 % BgL_auxz00_2797);
																	}}
																	{	/* Ast/substitute.scm 264 */

																		BgL_method3108z00_2428 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2433,
																				(int) (BgL_modz00_2436)),
																			(int) (BgL_restz00_2438));
										}}}}}}}}
										BgL_res3449z00_2453 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3108z00_2428) (BgL_method3108z00_2428,
												(obj_t) (BgL_nodez00_2426), BgL_arg3356z00_1447, BEOA));
								}}
								BgL_arg3354z00_1445 = BgL_res3449z00_2453;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_2808;

							BgL_auxz00_2808 = (BgL_varz00_bglt) (BgL_arg3354z00_1445);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1441))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_2808), BUNSPEC);
					}}
					{	/* Ast/substitute.scm 265 */
						BgL_nodez00_bglt BgL_arg3357z00_1448;

						{	/* Ast/substitute.scm 265 */
							BgL_nodez00_bglt BgL_arg3358z00_1449;

							obj_t BgL_arg3359z00_1450;

							BgL_arg3358z00_1449 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1441))->
								BgL_valuez00);
							BgL_arg3359z00_1450 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 265 */
								BgL_nodez00_bglt BgL_res3452z00_2484;

								{	/* Ast/substitute.scm 265 */
									obj_t BgL_method3108z00_2459;

									{	/* Ast/substitute.scm 265 */
										BgL_objectz00_bglt BgL_objz00_2460;

										BgL_objz00_2460 =
											(BgL_objectz00_bglt) (BgL_arg3358z00_1449);
										{	/* Ast/substitute.scm 265 */
											long BgL_objzd2classzd2numz00_2461;

											BgL_objzd2classzd2numz00_2461 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2460);
											{	/* Ast/substitute.scm 265 */
												obj_t BgL_arg2334z00_2462;

												BgL_arg2334z00_2462 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 265 */
													obj_t BgL_arrayz00_2464;

													int BgL_offsetz00_2465;

													BgL_arrayz00_2464 = BgL_arg2334z00_2462;
													BgL_offsetz00_2465 =
														(int) (BgL_objzd2classzd2numz00_2461);
													{	/* Ast/substitute.scm 265 */
														long BgL_offsetz00_2466;

														BgL_offsetz00_2466 =
															((long) (BgL_offsetz00_2465) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 265 */
															long BgL_modz00_2467;

															{	/* Ast/substitute.scm 265 */
																int BgL_arg2336z00_2468;

																BgL_arg2336z00_2468 = (int) (((long) 8));
																{	/* Ast/substitute.scm 265 */
																	long BgL_auxz00_2821;

																	BgL_auxz00_2821 =
																		(long) (BgL_arg2336z00_2468);
																	BgL_modz00_2467 =
																		(BgL_offsetz00_2466 / BgL_auxz00_2821);
															}}
															{	/* Ast/substitute.scm 265 */
																long BgL_restz00_2469;

																{	/* Ast/substitute.scm 265 */
																	int BgL_arg2335z00_2470;

																	BgL_arg2335z00_2470 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 265 */
																		long BgL_auxz00_2825;

																		BgL_auxz00_2825 =
																			(long) (BgL_arg2335z00_2470);
																		BgL_restz00_2469 =
																			(BgL_offsetz00_2466 % BgL_auxz00_2825);
																}}
																{	/* Ast/substitute.scm 265 */

																	BgL_method3108z00_2459 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2464,
																			(int) (BgL_modz00_2467)),
																		(int) (BgL_restz00_2469));
									}}}}}}}}
									BgL_res3452z00_2484 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2459)
										(BgL_method3108z00_2459, (obj_t) (BgL_arg3358z00_1449),
											BgL_arg3359z00_1450, BEOA));
								}
								BgL_arg3357z00_1448 = BgL_res3452z00_2484;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1441))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3357z00_1448), BUNSPEC);
					}
					BgL_auxz00_2781 = BgL_nodez00_1441;
					return (obj_t) (BgL_auxz00_2781);
				}
			}
		}
	}



/* do-substitute!-box-r3147 */
	obj_t BGl_dozd2substitutez12zd2boxzd2r3147zc0zzast_substitutez00(obj_t
		BgL_envz00_2521, obj_t BgL_nodez00_2522, obj_t BgL_sitez00_2523)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 256 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1432;

				obj_t BgL_sitez00_1433;

				{	/* Ast/substitute.scm 257 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_2839;

					BgL_nodez00_1432 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2522);
					BgL_sitez00_1433 = BgL_sitez00_2523;
					{	/* Ast/substitute.scm 257 */
						BgL_nodez00_bglt BgL_arg3350z00_2391;

						{	/* Ast/substitute.scm 257 */
							BgL_varz00_bglt BgL_arg3351z00_2392;

							obj_t BgL_arg3352z00_2393;

							BgL_arg3351z00_2392 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1432))->BgL_varz00);
							BgL_arg3352z00_2393 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 257 */
								BgL_nodez00_bglt BgL_res3446z00_2422;

								{	/* Ast/substitute.scm 257 */
									BgL_nodez00_bglt BgL_nodez00_2395;

									BgL_nodez00_2395 = (BgL_nodez00_bglt) (BgL_arg3351z00_2392);
									{	/* Ast/substitute.scm 257 */
										obj_t BgL_method3108z00_2397;

										{	/* Ast/substitute.scm 257 */
											BgL_objectz00_bglt BgL_objz00_2398;

											BgL_objz00_2398 = (BgL_objectz00_bglt) (BgL_nodez00_2395);
											{	/* Ast/substitute.scm 257 */
												long BgL_objzd2classzd2numz00_2399;

												BgL_objzd2classzd2numz00_2399 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2398);
												{	/* Ast/substitute.scm 257 */
													obj_t BgL_arg2334z00_2400;

													BgL_arg2334z00_2400 =
														PROCEDURE_REF
														(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
														(int) (((long) 1)));
													{	/* Ast/substitute.scm 257 */
														obj_t BgL_arrayz00_2402;

														int BgL_offsetz00_2403;

														BgL_arrayz00_2402 = BgL_arg2334z00_2400;
														BgL_offsetz00_2403 =
															(int) (BgL_objzd2classzd2numz00_2399);
														{	/* Ast/substitute.scm 257 */
															long BgL_offsetz00_2404;

															BgL_offsetz00_2404 =
																((long) (BgL_offsetz00_2403) - OBJECT_TYPE);
															{	/* Ast/substitute.scm 257 */
																long BgL_modz00_2405;

																{	/* Ast/substitute.scm 257 */
																	int BgL_arg2336z00_2406;

																	BgL_arg2336z00_2406 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 257 */
																		long BgL_auxz00_2851;

																		BgL_auxz00_2851 =
																			(long) (BgL_arg2336z00_2406);
																		BgL_modz00_2405 =
																			(BgL_offsetz00_2404 / BgL_auxz00_2851);
																}}
																{	/* Ast/substitute.scm 257 */
																	long BgL_restz00_2407;

																	{	/* Ast/substitute.scm 257 */
																		int BgL_arg2335z00_2408;

																		BgL_arg2335z00_2408 = (int) (((long) 8));
																		{	/* Ast/substitute.scm 257 */
																			long BgL_auxz00_2855;

																			BgL_auxz00_2855 =
																				(long) (BgL_arg2335z00_2408);
																			BgL_restz00_2407 =
																				(BgL_offsetz00_2404 % BgL_auxz00_2855);
																	}}
																	{	/* Ast/substitute.scm 257 */

																		BgL_method3108z00_2397 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2402,
																				(int) (BgL_modz00_2405)),
																			(int) (BgL_restz00_2407));
										}}}}}}}}
										BgL_res3446z00_2422 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3108z00_2397) (BgL_method3108z00_2397,
												(obj_t) (BgL_nodez00_2395), BgL_arg3352z00_2393, BEOA));
								}}
								BgL_arg3350z00_2391 = BgL_res3446z00_2422;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_2866;

							BgL_auxz00_2866 = (BgL_varz00_bglt) (BgL_arg3350z00_2391);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1432))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_2866), BUNSPEC);
					}}
					BgL_auxz00_2839 = BgL_nodez00_1432;
					return (obj_t) (BgL_auxz00_2839);
				}
			}
		}
	}



/* do-substitute!-make-3144 */
	obj_t BGl_dozd2substitutez12zd2makezd23144zc0zzast_substitutez00(obj_t
		BgL_envz00_2524, obj_t BgL_nodez00_2525, obj_t BgL_sitez00_2526)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 249 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1423;

				obj_t BgL_sitez00_1424;

				{	/* Ast/substitute.scm 250 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_2871;

					BgL_nodez00_1423 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2525);
					BgL_sitez00_1424 = BgL_sitez00_2526;
					{	/* Ast/substitute.scm 250 */
						BgL_nodez00_bglt BgL_arg3346z00_2357;

						{	/* Ast/substitute.scm 250 */
							BgL_nodez00_bglt BgL_arg3347z00_2358;

							obj_t BgL_arg3348z00_2359;

							BgL_arg3347z00_2358 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1423))->
								BgL_valuez00);
							BgL_arg3348z00_2359 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 250 */
								BgL_nodez00_bglt BgL_res3443z00_2388;

								{	/* Ast/substitute.scm 250 */
									obj_t BgL_method3108z00_2363;

									{	/* Ast/substitute.scm 250 */
										BgL_objectz00_bglt BgL_objz00_2364;

										BgL_objz00_2364 =
											(BgL_objectz00_bglt) (BgL_arg3347z00_2358);
										{	/* Ast/substitute.scm 250 */
											long BgL_objzd2classzd2numz00_2365;

											BgL_objzd2classzd2numz00_2365 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2364);
											{	/* Ast/substitute.scm 250 */
												obj_t BgL_arg2334z00_2366;

												BgL_arg2334z00_2366 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 250 */
													obj_t BgL_arrayz00_2368;

													int BgL_offsetz00_2369;

													BgL_arrayz00_2368 = BgL_arg2334z00_2366;
													BgL_offsetz00_2369 =
														(int) (BgL_objzd2classzd2numz00_2365);
													{	/* Ast/substitute.scm 250 */
														long BgL_offsetz00_2370;

														BgL_offsetz00_2370 =
															((long) (BgL_offsetz00_2369) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 250 */
															long BgL_modz00_2371;

															{	/* Ast/substitute.scm 250 */
																int BgL_arg2336z00_2372;

																BgL_arg2336z00_2372 = (int) (((long) 8));
																{	/* Ast/substitute.scm 250 */
																	long BgL_auxz00_2882;

																	BgL_auxz00_2882 =
																		(long) (BgL_arg2336z00_2372);
																	BgL_modz00_2371 =
																		(BgL_offsetz00_2370 / BgL_auxz00_2882);
															}}
															{	/* Ast/substitute.scm 250 */
																long BgL_restz00_2373;

																{	/* Ast/substitute.scm 250 */
																	int BgL_arg2335z00_2374;

																	BgL_arg2335z00_2374 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 250 */
																		long BgL_auxz00_2886;

																		BgL_auxz00_2886 =
																			(long) (BgL_arg2335z00_2374);
																		BgL_restz00_2373 =
																			(BgL_offsetz00_2370 % BgL_auxz00_2886);
																}}
																{	/* Ast/substitute.scm 250 */

																	BgL_method3108z00_2363 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2368,
																			(int) (BgL_modz00_2371)),
																		(int) (BgL_restz00_2373));
									}}}}}}}}
									BgL_res3443z00_2388 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2363)
										(BgL_method3108z00_2363, (obj_t) (BgL_arg3347z00_2358),
											BgL_arg3348z00_2359, BEOA));
								}
								BgL_arg3346z00_2357 = BgL_res3443z00_2388;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1423))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3346z00_2357), BUNSPEC);
					}
					BgL_auxz00_2871 = BgL_nodez00_1423;
					return (obj_t) (BgL_auxz00_2871);
				}
			}
		}
	}



/* do-substitute!-jump-3142 */
	obj_t BGl_dozd2substitutez12zd2jumpzd23142zc0zzast_substitutez00(obj_t
		BgL_envz00_2527, obj_t BgL_nodez00_2528, obj_t BgL_sitez00_2529)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 241 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1411;

				obj_t BgL_sitez00_1412;

				{	/* Ast/substitute.scm 242 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_2900;

					BgL_nodez00_1411 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2528);
					BgL_sitez00_1412 = BgL_sitez00_2529;
					{	/* Ast/substitute.scm 242 */
						BgL_nodez00_bglt BgL_arg3339z00_1415;

						{	/* Ast/substitute.scm 242 */
							BgL_nodez00_bglt BgL_arg3340z00_1416;

							obj_t BgL_arg3341z00_1417;

							BgL_arg3340z00_1416 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1411))->
								BgL_exitz00);
							BgL_arg3341z00_1417 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/substitute.scm 242 */
								BgL_nodez00_bglt BgL_res3437z00_2323;

								{	/* Ast/substitute.scm 242 */
									obj_t BgL_method3108z00_2298;

									{	/* Ast/substitute.scm 242 */
										BgL_objectz00_bglt BgL_objz00_2299;

										BgL_objz00_2299 =
											(BgL_objectz00_bglt) (BgL_arg3340z00_1416);
										{	/* Ast/substitute.scm 242 */
											long BgL_objzd2classzd2numz00_2300;

											BgL_objzd2classzd2numz00_2300 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2299);
											{	/* Ast/substitute.scm 242 */
												obj_t BgL_arg2334z00_2301;

												BgL_arg2334z00_2301 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 242 */
													obj_t BgL_arrayz00_2303;

													int BgL_offsetz00_2304;

													BgL_arrayz00_2303 = BgL_arg2334z00_2301;
													BgL_offsetz00_2304 =
														(int) (BgL_objzd2classzd2numz00_2300);
													{	/* Ast/substitute.scm 242 */
														long BgL_offsetz00_2305;

														BgL_offsetz00_2305 =
															((long) (BgL_offsetz00_2304) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 242 */
															long BgL_modz00_2306;

															{	/* Ast/substitute.scm 242 */
																int BgL_arg2336z00_2307;

																BgL_arg2336z00_2307 = (int) (((long) 8));
																{	/* Ast/substitute.scm 242 */
																	long BgL_auxz00_2911;

																	BgL_auxz00_2911 =
																		(long) (BgL_arg2336z00_2307);
																	BgL_modz00_2306 =
																		(BgL_offsetz00_2305 / BgL_auxz00_2911);
															}}
															{	/* Ast/substitute.scm 242 */
																long BgL_restz00_2308;

																{	/* Ast/substitute.scm 242 */
																	int BgL_arg2335z00_2309;

																	BgL_arg2335z00_2309 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 242 */
																		long BgL_auxz00_2915;

																		BgL_auxz00_2915 =
																			(long) (BgL_arg2335z00_2309);
																		BgL_restz00_2308 =
																			(BgL_offsetz00_2305 % BgL_auxz00_2915);
																}}
																{	/* Ast/substitute.scm 242 */

																	BgL_method3108z00_2298 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2303,
																			(int) (BgL_modz00_2306)),
																		(int) (BgL_restz00_2308));
									}}}}}}}}
									BgL_res3437z00_2323 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2298)
										(BgL_method3108z00_2298, (obj_t) (BgL_arg3340z00_1416),
											BgL_arg3341z00_1417, BEOA));
								}
								BgL_arg3339z00_1415 = BgL_res3437z00_2323;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1411))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3339z00_1415), BUNSPEC);
					}
					{	/* Ast/substitute.scm 243 */
						BgL_nodez00_bglt BgL_arg3342z00_1418;

						{	/* Ast/substitute.scm 243 */
							BgL_nodez00_bglt BgL_arg3343z00_1419;

							obj_t BgL_arg3344z00_1420;

							BgL_arg3343z00_1419 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1411))->
								BgL_valuez00);
							BgL_arg3344z00_1420 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 243 */
								BgL_nodez00_bglt BgL_res3440z00_2354;

								{	/* Ast/substitute.scm 243 */
									obj_t BgL_method3108z00_2329;

									{	/* Ast/substitute.scm 243 */
										BgL_objectz00_bglt BgL_objz00_2330;

										BgL_objz00_2330 =
											(BgL_objectz00_bglt) (BgL_arg3343z00_1419);
										{	/* Ast/substitute.scm 243 */
											long BgL_objzd2classzd2numz00_2331;

											BgL_objzd2classzd2numz00_2331 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2330);
											{	/* Ast/substitute.scm 243 */
												obj_t BgL_arg2334z00_2332;

												BgL_arg2334z00_2332 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 243 */
													obj_t BgL_arrayz00_2334;

													int BgL_offsetz00_2335;

													BgL_arrayz00_2334 = BgL_arg2334z00_2332;
													BgL_offsetz00_2335 =
														(int) (BgL_objzd2classzd2numz00_2331);
													{	/* Ast/substitute.scm 243 */
														long BgL_offsetz00_2336;

														BgL_offsetz00_2336 =
															((long) (BgL_offsetz00_2335) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 243 */
															long BgL_modz00_2337;

															{	/* Ast/substitute.scm 243 */
																int BgL_arg2336z00_2338;

																BgL_arg2336z00_2338 = (int) (((long) 8));
																{	/* Ast/substitute.scm 243 */
																	long BgL_auxz00_2937;

																	BgL_auxz00_2937 =
																		(long) (BgL_arg2336z00_2338);
																	BgL_modz00_2337 =
																		(BgL_offsetz00_2336 / BgL_auxz00_2937);
															}}
															{	/* Ast/substitute.scm 243 */
																long BgL_restz00_2339;

																{	/* Ast/substitute.scm 243 */
																	int BgL_arg2335z00_2340;

																	BgL_arg2335z00_2340 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 243 */
																		long BgL_auxz00_2941;

																		BgL_auxz00_2941 =
																			(long) (BgL_arg2335z00_2340);
																		BgL_restz00_2339 =
																			(BgL_offsetz00_2336 % BgL_auxz00_2941);
																}}
																{	/* Ast/substitute.scm 243 */

																	BgL_method3108z00_2329 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2334,
																			(int) (BgL_modz00_2337)),
																		(int) (BgL_restz00_2339));
									}}}}}}}}
									BgL_res3440z00_2354 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2329)
										(BgL_method3108z00_2329, (obj_t) (BgL_arg3343z00_1419),
											BgL_arg3344z00_1420, BEOA));
								}
								BgL_arg3342z00_1418 = BgL_res3440z00_2354;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1411))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3342z00_1418), BUNSPEC);
					}
					BgL_auxz00_2900 = BgL_nodez00_1411;
					return (obj_t) (BgL_auxz00_2900);
				}
			}
		}
	}



/* do-substitute!-set-e3140 */
	obj_t BGl_dozd2substitutez12zd2setzd2e3140zc0zzast_substitutez00(obj_t
		BgL_envz00_2530, obj_t BgL_nodez00_2531, obj_t BgL_sitez00_2532)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 234 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1403;

				obj_t BgL_sitez00_1404;

				{	/* Ast/substitute.scm 235 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_2955;

					BgL_nodez00_1403 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2531);
					BgL_sitez00_1404 = BgL_sitez00_2532;
					{	/* Ast/substitute.scm 235 */
						BgL_nodez00_bglt BgL_arg3336z00_2262;

						{	/* Ast/substitute.scm 235 */
							BgL_nodez00_bglt BgL_arg3337z00_2263;

							BgL_arg3337z00_2263 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1403))->
								BgL_bodyz00);
							{	/* Ast/substitute.scm 235 */
								BgL_nodez00_bglt BgL_res3434z00_2292;

								{	/* Ast/substitute.scm 235 */
									obj_t BgL_method3108z00_2267;

									{	/* Ast/substitute.scm 235 */
										BgL_objectz00_bglt BgL_objz00_2268;

										BgL_objz00_2268 =
											(BgL_objectz00_bglt) (BgL_arg3337z00_2263);
										{	/* Ast/substitute.scm 235 */
											long BgL_objzd2classzd2numz00_2269;

											BgL_objzd2classzd2numz00_2269 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2268);
											{	/* Ast/substitute.scm 235 */
												obj_t BgL_arg2334z00_2270;

												BgL_arg2334z00_2270 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 235 */
													obj_t BgL_arrayz00_2272;

													int BgL_offsetz00_2273;

													BgL_arrayz00_2272 = BgL_arg2334z00_2270;
													BgL_offsetz00_2273 =
														(int) (BgL_objzd2classzd2numz00_2269);
													{	/* Ast/substitute.scm 235 */
														long BgL_offsetz00_2274;

														BgL_offsetz00_2274 =
															((long) (BgL_offsetz00_2273) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 235 */
															long BgL_modz00_2275;

															{	/* Ast/substitute.scm 235 */
																int BgL_arg2336z00_2276;

																BgL_arg2336z00_2276 = (int) (((long) 8));
																{	/* Ast/substitute.scm 235 */
																	long BgL_auxz00_2965;

																	BgL_auxz00_2965 =
																		(long) (BgL_arg2336z00_2276);
																	BgL_modz00_2275 =
																		(BgL_offsetz00_2274 / BgL_auxz00_2965);
															}}
															{	/* Ast/substitute.scm 235 */
																long BgL_restz00_2277;

																{	/* Ast/substitute.scm 235 */
																	int BgL_arg2335z00_2278;

																	BgL_arg2335z00_2278 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 235 */
																		long BgL_auxz00_2969;

																		BgL_auxz00_2969 =
																			(long) (BgL_arg2335z00_2278);
																		BgL_restz00_2277 =
																			(BgL_offsetz00_2274 % BgL_auxz00_2969);
																}}
																{	/* Ast/substitute.scm 235 */

																	BgL_method3108z00_2267 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2272,
																			(int) (BgL_modz00_2275)),
																		(int) (BgL_restz00_2277));
									}}}}}}}}
									BgL_res3434z00_2292 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2267)
										(BgL_method3108z00_2267, (obj_t) (BgL_arg3337z00_2263),
											BgL_sitez00_1404, BEOA));
								}
								BgL_arg3336z00_2262 = BgL_res3434z00_2292;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1403))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3336z00_2262), BUNSPEC);
					}
					BgL_auxz00_2955 = BgL_nodez00_1403;
					return (obj_t) (BgL_auxz00_2955);
				}
			}
		}
	}



/* do-substitute!-let-v3138 */
	obj_t BGl_dozd2substitutez12zd2letzd2v3138zc0zzast_substitutez00(obj_t
		BgL_envz00_2533, obj_t BgL_nodez00_2534, obj_t BgL_sitez00_2535)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 224 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1386;

				obj_t BgL_sitez00_1387;

				{	/* Ast/substitute.scm 225 */
					BgL_letzd2varzd2_bglt BgL_auxz00_2983;

					BgL_nodez00_1386 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2534);
					BgL_sitez00_1387 = BgL_sitez00_2535;
					{	/* Ast/substitute.scm 225 */
						obj_t BgL_g3104z00_1390;

						BgL_g3104z00_1390 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1386))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3102z00_1391;

							BgL_l3102z00_1391 = BgL_g3104z00_1390;
						BgL_forzd2each3103zd2_1392:
							if (PAIRP(BgL_l3102z00_1391))
								{	/* Ast/substitute.scm 227 */
									{	/* Ast/substitute.scm 226 */
										obj_t BgL_bindingz00_1394;

										BgL_bindingz00_1394 = CAR(BgL_l3102z00_1391);
										{	/* Ast/substitute.scm 226 */
											BgL_nodez00_bglt BgL_arg3329z00_1395;

											{	/* Ast/substitute.scm 226 */
												obj_t BgL_arg3330z00_1396;

												obj_t BgL_arg3331z00_1397;

												BgL_arg3330z00_1396 = CDR(BgL_bindingz00_1394);
												BgL_arg3331z00_1397 = CNST_TABLE_REF(((long) 1));
												{	/* Ast/substitute.scm 226 */
													BgL_nodez00_bglt BgL_res3428z00_2227;

													{	/* Ast/substitute.scm 226 */
														BgL_nodez00_bglt BgL_nodez00_2200;

														BgL_nodez00_2200 =
															(BgL_nodez00_bglt) (BgL_arg3330z00_1396);
														{	/* Ast/substitute.scm 226 */
															obj_t BgL_method3108z00_2202;

															{	/* Ast/substitute.scm 226 */
																BgL_objectz00_bglt BgL_objz00_2203;

																BgL_objz00_2203 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2200);
																{	/* Ast/substitute.scm 226 */
																	long BgL_objzd2classzd2numz00_2204;

																	BgL_objzd2classzd2numz00_2204 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2203);
																	{	/* Ast/substitute.scm 226 */
																		obj_t BgL_arg2334z00_2205;

																		BgL_arg2334z00_2205 =
																			PROCEDURE_REF
																			(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																			(int) (((long) 1)));
																		{	/* Ast/substitute.scm 226 */
																			obj_t BgL_arrayz00_2207;

																			int BgL_offsetz00_2208;

																			BgL_arrayz00_2207 = BgL_arg2334z00_2205;
																			BgL_offsetz00_2208 =
																				(int) (BgL_objzd2classzd2numz00_2204);
																			{	/* Ast/substitute.scm 226 */
																				long BgL_offsetz00_2209;

																				BgL_offsetz00_2209 =
																					(
																					(long) (BgL_offsetz00_2208) -
																					OBJECT_TYPE);
																				{	/* Ast/substitute.scm 226 */
																					long BgL_modz00_2210;

																					{	/* Ast/substitute.scm 226 */
																						int BgL_arg2336z00_2211;

																						BgL_arg2336z00_2211 =
																							(int) (((long) 8));
																						{	/* Ast/substitute.scm 226 */
																							long BgL_auxz00_2999;

																							BgL_auxz00_2999 =
																								(long) (BgL_arg2336z00_2211);
																							BgL_modz00_2210 =
																								(BgL_offsetz00_2209 /
																								BgL_auxz00_2999);
																					}}
																					{	/* Ast/substitute.scm 226 */
																						long BgL_restz00_2212;

																						{	/* Ast/substitute.scm 226 */
																							int BgL_arg2335z00_2213;

																							BgL_arg2335z00_2213 =
																								(int) (((long) 8));
																							{	/* Ast/substitute.scm 226 */
																								long BgL_auxz00_3003;

																								BgL_auxz00_3003 =
																									(long) (BgL_arg2335z00_2213);
																								BgL_restz00_2212 =
																									(BgL_offsetz00_2209 %
																									BgL_auxz00_3003);
																						}}
																						{	/* Ast/substitute.scm 226 */

																							BgL_method3108z00_2202 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2207,
																									(int) (BgL_modz00_2210)),
																								(int) (BgL_restz00_2212));
															}}}}}}}}
															BgL_res3428z00_2227 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3108z00_2202)
																(BgL_method3108z00_2202,
																	(obj_t) (BgL_nodez00_2200),
																	BgL_arg3331z00_1397, BEOA));
													}}
													BgL_arg3329z00_1395 = BgL_res3428z00_2227;
											}}
											{	/* Ast/substitute.scm 226 */
												obj_t BgL_auxz00_3014;

												BgL_auxz00_3014 = (obj_t) (BgL_arg3329z00_1395);
												SET_CDR(BgL_bindingz00_1394, BgL_auxz00_3014);
									}}}
									{
										obj_t BgL_l3102z00_3017;

										BgL_l3102z00_3017 = CDR(BgL_l3102z00_1391);
										BgL_l3102z00_1391 = BgL_l3102z00_3017;
										goto BgL_forzd2each3103zd2_1392;
									}
								}
							else
								{	/* Ast/substitute.scm 227 */
									((bool_t) 1);
								}
						}
					}
					{	/* Ast/substitute.scm 228 */
						BgL_nodez00_bglt BgL_arg3333z00_1399;

						{	/* Ast/substitute.scm 228 */
							BgL_nodez00_bglt BgL_arg3334z00_1400;

							BgL_arg3334z00_1400 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1386))->BgL_bodyz00);
							{	/* Ast/substitute.scm 228 */
								BgL_nodez00_bglt BgL_res3431z00_2259;

								{	/* Ast/substitute.scm 228 */
									obj_t BgL_method3108z00_2234;

									{	/* Ast/substitute.scm 228 */
										BgL_objectz00_bglt BgL_objz00_2235;

										BgL_objz00_2235 =
											(BgL_objectz00_bglt) (BgL_arg3334z00_1400);
										{	/* Ast/substitute.scm 228 */
											long BgL_objzd2classzd2numz00_2236;

											BgL_objzd2classzd2numz00_2236 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2235);
											{	/* Ast/substitute.scm 228 */
												obj_t BgL_arg2334z00_2237;

												BgL_arg2334z00_2237 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 228 */
													obj_t BgL_arrayz00_2239;

													int BgL_offsetz00_2240;

													BgL_arrayz00_2239 = BgL_arg2334z00_2237;
													BgL_offsetz00_2240 =
														(int) (BgL_objzd2classzd2numz00_2236);
													{	/* Ast/substitute.scm 228 */
														long BgL_offsetz00_2241;

														BgL_offsetz00_2241 =
															((long) (BgL_offsetz00_2240) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 228 */
															long BgL_modz00_2242;

															{	/* Ast/substitute.scm 228 */
																int BgL_arg2336z00_2243;

																BgL_arg2336z00_2243 = (int) (((long) 8));
																{	/* Ast/substitute.scm 228 */
																	long BgL_auxz00_3028;

																	BgL_auxz00_3028 =
																		(long) (BgL_arg2336z00_2243);
																	BgL_modz00_2242 =
																		(BgL_offsetz00_2241 / BgL_auxz00_3028);
															}}
															{	/* Ast/substitute.scm 228 */
																long BgL_restz00_2244;

																{	/* Ast/substitute.scm 228 */
																	int BgL_arg2335z00_2245;

																	BgL_arg2335z00_2245 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 228 */
																		long BgL_auxz00_3032;

																		BgL_auxz00_3032 =
																			(long) (BgL_arg2335z00_2245);
																		BgL_restz00_2244 =
																			(BgL_offsetz00_2241 % BgL_auxz00_3032);
																}}
																{	/* Ast/substitute.scm 228 */

																	BgL_method3108z00_2234 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2239,
																			(int) (BgL_modz00_2242)),
																		(int) (BgL_restz00_2244));
									}}}}}}}}
									BgL_res3431z00_2259 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2234)
										(BgL_method3108z00_2234, (obj_t) (BgL_arg3334z00_1400),
											BgL_sitez00_1387, BEOA));
								}
								BgL_arg3333z00_1399 = BgL_res3431z00_2259;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1386))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3333z00_1399), BUNSPEC);
					}
					BgL_auxz00_2983 = BgL_nodez00_1386;
					return (obj_t) (BgL_auxz00_2983);
				}
			}
		}
	}



/* do-substitute!-let-f3136 */
	obj_t BGl_dozd2substitutez12zd2letzd2f3136zc0zzast_substitutez00(obj_t
		BgL_envz00_2536, obj_t BgL_nodez00_2537, obj_t BgL_sitez00_2538)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 212 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1368;

				obj_t BgL_sitez00_1369;

				{	/* Ast/substitute.scm 213 */
					BgL_letzd2funzd2_bglt BgL_auxz00_3046;

					BgL_nodez00_1368 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2537);
					BgL_sitez00_1369 = BgL_sitez00_2538;
					{	/* Ast/substitute.scm 213 */
						obj_t BgL_g3101z00_1372;

						BgL_g3101z00_1372 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1368))->BgL_localsz00);
						{
							obj_t BgL_l3099z00_1373;

							BgL_l3099z00_1373 = BgL_g3101z00_1372;
						BgL_forzd2each3100zd2_1374:
							if (PAIRP(BgL_l3099z00_1373))
								{	/* Ast/substitute.scm 217 */
									{	/* Ast/substitute.scm 214 */
										obj_t BgL_localz00_1376;

										BgL_localz00_1376 = CAR(BgL_l3099z00_1373);
										{	/* Ast/substitute.scm 214 */
											BgL_valuez00_bglt BgL_funz00_1377;

											{
												BgL_variablez00_bglt BgL_auxz00_3051;

												BgL_auxz00_3051 =
													(BgL_variablez00_bglt) (BgL_localz00_1376);
												BgL_funz00_1377 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_3051))->
													BgL_valuez00);
											}
											{	/* Ast/substitute.scm 215 */
												BgL_nodez00_bglt BgL_arg3321z00_1378;

												{	/* Ast/substitute.scm 215 */
													obj_t BgL_arg3322z00_1379;

													obj_t BgL_arg3323z00_1380;

													{
														BgL_sfunz00_bglt BgL_auxz00_3054;

														BgL_auxz00_3054 =
															(BgL_sfunz00_bglt) (BgL_funz00_1377);
														BgL_arg3322z00_1379 =
															(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3054))->
															BgL_bodyz00);
													}
													BgL_arg3323z00_1380 = CNST_TABLE_REF(((long) 1));
													{	/* Ast/substitute.scm 215 */
														BgL_nodez00_bglt BgL_res3422z00_2161;

														{	/* Ast/substitute.scm 215 */
															BgL_nodez00_bglt BgL_nodez00_2134;

															BgL_nodez00_2134 =
																(BgL_nodez00_bglt) (BgL_arg3322z00_1379);
															{	/* Ast/substitute.scm 215 */
																obj_t BgL_method3108z00_2136;

																{	/* Ast/substitute.scm 215 */
																	BgL_objectz00_bglt BgL_objz00_2137;

																	BgL_objz00_2137 =
																		(BgL_objectz00_bglt) (BgL_nodez00_2134);
																	{	/* Ast/substitute.scm 215 */
																		long BgL_objzd2classzd2numz00_2138;

																		BgL_objzd2classzd2numz00_2138 =
																			BGL_OBJECT_CLASS_NUM(BgL_objz00_2137);
																		{	/* Ast/substitute.scm 215 */
																			obj_t BgL_arg2334z00_2139;

																			BgL_arg2334z00_2139 =
																				PROCEDURE_REF
																				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																				(int) (((long) 1)));
																			{	/* Ast/substitute.scm 215 */
																				obj_t BgL_arrayz00_2141;

																				int BgL_offsetz00_2142;

																				BgL_arrayz00_2141 = BgL_arg2334z00_2139;
																				BgL_offsetz00_2142 =
																					(int) (BgL_objzd2classzd2numz00_2138);
																				{	/* Ast/substitute.scm 215 */
																					long BgL_offsetz00_2143;

																					BgL_offsetz00_2143 =
																						(
																						(long) (BgL_offsetz00_2142) -
																						OBJECT_TYPE);
																					{	/* Ast/substitute.scm 215 */
																						long BgL_modz00_2144;

																						{	/* Ast/substitute.scm 215 */
																							int BgL_arg2336z00_2145;

																							BgL_arg2336z00_2145 =
																								(int) (((long) 8));
																							{	/* Ast/substitute.scm 215 */
																								long BgL_auxz00_3067;

																								BgL_auxz00_3067 =
																									(long) (BgL_arg2336z00_2145);
																								BgL_modz00_2144 =
																									(BgL_offsetz00_2143 /
																									BgL_auxz00_3067);
																						}}
																						{	/* Ast/substitute.scm 215 */
																							long BgL_restz00_2146;

																							{	/* Ast/substitute.scm 215 */
																								int BgL_arg2335z00_2147;

																								BgL_arg2335z00_2147 =
																									(int) (((long) 8));
																								{	/* Ast/substitute.scm 215 */
																									long BgL_auxz00_3071;

																									BgL_auxz00_3071 =
																										(long)
																										(BgL_arg2335z00_2147);
																									BgL_restz00_2146 =
																										(BgL_offsetz00_2143 %
																										BgL_auxz00_3071);
																							}}
																							{	/* Ast/substitute.scm 215 */

																								BgL_method3108z00_2136 =
																									VECTOR_REF(VECTOR_REF
																									(BgL_arrayz00_2141,
																										(int) (BgL_modz00_2144)),
																									(int) (BgL_restz00_2146));
																}}}}}}}}
																BgL_res3422z00_2161 =
																	(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																	(BgL_method3108z00_2136)
																	(BgL_method3108z00_2136,
																		(obj_t) (BgL_nodez00_2134),
																		BgL_arg3323z00_1380, BEOA));
														}}
														BgL_arg3321z00_1378 = BgL_res3422z00_2161;
												}}
												{
													obj_t BgL_auxz00_3084;

													BgL_sfunz00_bglt BgL_auxz00_3082;

													BgL_auxz00_3084 = (obj_t) (BgL_arg3321z00_1378);
													BgL_auxz00_3082 =
														(BgL_sfunz00_bglt) (BgL_funz00_1377);
													((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3082))->
															BgL_bodyz00) =
														((obj_t) BgL_auxz00_3084), BUNSPEC);
									}}}}
									{
										obj_t BgL_l3099z00_3087;

										BgL_l3099z00_3087 = CDR(BgL_l3099z00_1373);
										BgL_l3099z00_1373 = BgL_l3099z00_3087;
										goto BgL_forzd2each3100zd2_1374;
									}
								}
							else
								{	/* Ast/substitute.scm 217 */
									((bool_t) 1);
								}
						}
					}
					{	/* Ast/substitute.scm 218 */
						BgL_nodez00_bglt BgL_arg3325z00_1382;

						{	/* Ast/substitute.scm 218 */
							BgL_nodez00_bglt BgL_arg3326z00_1383;

							BgL_arg3326z00_1383 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1368))->BgL_bodyz00);
							{	/* Ast/substitute.scm 218 */
								BgL_nodez00_bglt BgL_res3425z00_2193;

								{	/* Ast/substitute.scm 218 */
									obj_t BgL_method3108z00_2168;

									{	/* Ast/substitute.scm 218 */
										BgL_objectz00_bglt BgL_objz00_2169;

										BgL_objz00_2169 =
											(BgL_objectz00_bglt) (BgL_arg3326z00_1383);
										{	/* Ast/substitute.scm 218 */
											long BgL_objzd2classzd2numz00_2170;

											BgL_objzd2classzd2numz00_2170 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2169);
											{	/* Ast/substitute.scm 218 */
												obj_t BgL_arg2334z00_2171;

												BgL_arg2334z00_2171 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 218 */
													obj_t BgL_arrayz00_2173;

													int BgL_offsetz00_2174;

													BgL_arrayz00_2173 = BgL_arg2334z00_2171;
													BgL_offsetz00_2174 =
														(int) (BgL_objzd2classzd2numz00_2170);
													{	/* Ast/substitute.scm 218 */
														long BgL_offsetz00_2175;

														BgL_offsetz00_2175 =
															((long) (BgL_offsetz00_2174) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 218 */
															long BgL_modz00_2176;

															{	/* Ast/substitute.scm 218 */
																int BgL_arg2336z00_2177;

																BgL_arg2336z00_2177 = (int) (((long) 8));
																{	/* Ast/substitute.scm 218 */
																	long BgL_auxz00_3098;

																	BgL_auxz00_3098 =
																		(long) (BgL_arg2336z00_2177);
																	BgL_modz00_2176 =
																		(BgL_offsetz00_2175 / BgL_auxz00_3098);
															}}
															{	/* Ast/substitute.scm 218 */
																long BgL_restz00_2178;

																{	/* Ast/substitute.scm 218 */
																	int BgL_arg2335z00_2179;

																	BgL_arg2335z00_2179 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 218 */
																		long BgL_auxz00_3102;

																		BgL_auxz00_3102 =
																			(long) (BgL_arg2335z00_2179);
																		BgL_restz00_2178 =
																			(BgL_offsetz00_2175 % BgL_auxz00_3102);
																}}
																{	/* Ast/substitute.scm 218 */

																	BgL_method3108z00_2168 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2173,
																			(int) (BgL_modz00_2176)),
																		(int) (BgL_restz00_2178));
									}}}}}}}}
									BgL_res3425z00_2193 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2168)
										(BgL_method3108z00_2168, (obj_t) (BgL_arg3326z00_1383),
											BgL_sitez00_1369, BEOA));
								}
								BgL_arg3325z00_1382 = BgL_res3425z00_2193;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1368))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3325z00_1382), BUNSPEC);
					}
					BgL_auxz00_3046 = BgL_nodez00_1368;
					return (obj_t) (BgL_auxz00_3046);
				}
			}
		}
	}



/* do-substitute!-selec3134 */
	obj_t BGl_dozd2substitutez12zd2selec3134z12zzast_substitutez00(obj_t
		BgL_envz00_2539, obj_t BgL_nodez00_2540, obj_t BgL_sitez00_2541)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 202 */
			{
				BgL_selectz00_bglt BgL_nodez00_1351;

				obj_t BgL_sitez00_1352;

				{	/* Ast/substitute.scm 203 */
					BgL_selectz00_bglt BgL_auxz00_3116;

					BgL_nodez00_1351 = (BgL_selectz00_bglt) (BgL_nodez00_2540);
					BgL_sitez00_1352 = BgL_sitez00_2541;
					{	/* Ast/substitute.scm 203 */
						BgL_nodez00_bglt BgL_arg3312z00_1355;

						{	/* Ast/substitute.scm 203 */
							BgL_nodez00_bglt BgL_arg3313z00_1356;

							obj_t BgL_arg3314z00_1357;

							BgL_arg3313z00_1356 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1351))->BgL_testz00);
							BgL_arg3314z00_1357 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 203 */
								BgL_nodez00_bglt BgL_res3416z00_2091;

								{	/* Ast/substitute.scm 203 */
									obj_t BgL_method3108z00_2066;

									{	/* Ast/substitute.scm 203 */
										BgL_objectz00_bglt BgL_objz00_2067;

										BgL_objz00_2067 =
											(BgL_objectz00_bglt) (BgL_arg3313z00_1356);
										{	/* Ast/substitute.scm 203 */
											long BgL_objzd2classzd2numz00_2068;

											BgL_objzd2classzd2numz00_2068 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2067);
											{	/* Ast/substitute.scm 203 */
												obj_t BgL_arg2334z00_2069;

												BgL_arg2334z00_2069 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 203 */
													obj_t BgL_arrayz00_2071;

													int BgL_offsetz00_2072;

													BgL_arrayz00_2071 = BgL_arg2334z00_2069;
													BgL_offsetz00_2072 =
														(int) (BgL_objzd2classzd2numz00_2068);
													{	/* Ast/substitute.scm 203 */
														long BgL_offsetz00_2073;

														BgL_offsetz00_2073 =
															((long) (BgL_offsetz00_2072) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 203 */
															long BgL_modz00_2074;

															{	/* Ast/substitute.scm 203 */
																int BgL_arg2336z00_2075;

																BgL_arg2336z00_2075 = (int) (((long) 8));
																{	/* Ast/substitute.scm 203 */
																	long BgL_auxz00_3127;

																	BgL_auxz00_3127 =
																		(long) (BgL_arg2336z00_2075);
																	BgL_modz00_2074 =
																		(BgL_offsetz00_2073 / BgL_auxz00_3127);
															}}
															{	/* Ast/substitute.scm 203 */
																long BgL_restz00_2076;

																{	/* Ast/substitute.scm 203 */
																	int BgL_arg2335z00_2077;

																	BgL_arg2335z00_2077 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 203 */
																		long BgL_auxz00_3131;

																		BgL_auxz00_3131 =
																			(long) (BgL_arg2335z00_2077);
																		BgL_restz00_2076 =
																			(BgL_offsetz00_2073 % BgL_auxz00_3131);
																}}
																{	/* Ast/substitute.scm 203 */

																	BgL_method3108z00_2066 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2071,
																			(int) (BgL_modz00_2074)),
																		(int) (BgL_restz00_2076));
									}}}}}}}}
									BgL_res3416z00_2091 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2066)
										(BgL_method3108z00_2066, (obj_t) (BgL_arg3313z00_1356),
											BgL_arg3314z00_1357, BEOA));
								}
								BgL_arg3312z00_1355 = BgL_res3416z00_2091;
						}}
						((((BgL_selectz00_bglt) CREF(BgL_nodez00_1351))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3312z00_1355), BUNSPEC);
					}
					{	/* Ast/substitute.scm 204 */
						obj_t BgL_g3098z00_1358;

						BgL_g3098z00_1358 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1351))->BgL_clausesz00);
						{
							obj_t BgL_l3092z00_1359;

							BgL_l3092z00_1359 = BgL_g3098z00_1358;
						BgL_forzd2each3097zd2_1360:
							if (PAIRP(BgL_l3092z00_1359))
								{	/* Ast/substitute.scm 206 */
									{	/* Ast/substitute.scm 205 */
										obj_t BgL_clausez00_1362;

										BgL_clausez00_1362 = CAR(BgL_l3092z00_1359);
										{	/* Ast/substitute.scm 205 */
											BgL_nodez00_bglt BgL_arg3316z00_1363;

											{	/* Ast/substitute.scm 205 */
												obj_t BgL_arg3317z00_1364;

												BgL_arg3317z00_1364 = CDR(BgL_clausez00_1362);
												{	/* Ast/substitute.scm 205 */
													BgL_nodez00_bglt BgL_res3419z00_2125;

													{	/* Ast/substitute.scm 205 */
														BgL_nodez00_bglt BgL_nodez00_2098;

														BgL_nodez00_2098 =
															(BgL_nodez00_bglt) (BgL_arg3317z00_1364);
														{	/* Ast/substitute.scm 205 */
															obj_t BgL_method3108z00_2100;

															{	/* Ast/substitute.scm 205 */
																BgL_objectz00_bglt BgL_objz00_2101;

																BgL_objz00_2101 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2098);
																{	/* Ast/substitute.scm 205 */
																	long BgL_objzd2classzd2numz00_2102;

																	BgL_objzd2classzd2numz00_2102 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2101);
																	{	/* Ast/substitute.scm 205 */
																		obj_t BgL_arg2334z00_2103;

																		BgL_arg2334z00_2103 =
																			PROCEDURE_REF
																			(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																			(int) (((long) 1)));
																		{	/* Ast/substitute.scm 205 */
																			obj_t BgL_arrayz00_2105;

																			int BgL_offsetz00_2106;

																			BgL_arrayz00_2105 = BgL_arg2334z00_2103;
																			BgL_offsetz00_2106 =
																				(int) (BgL_objzd2classzd2numz00_2102);
																			{	/* Ast/substitute.scm 205 */
																				long BgL_offsetz00_2107;

																				BgL_offsetz00_2107 =
																					(
																					(long) (BgL_offsetz00_2106) -
																					OBJECT_TYPE);
																				{	/* Ast/substitute.scm 205 */
																					long BgL_modz00_2108;

																					{	/* Ast/substitute.scm 205 */
																						int BgL_arg2336z00_2109;

																						BgL_arg2336z00_2109 =
																							(int) (((long) 8));
																						{	/* Ast/substitute.scm 205 */
																							long BgL_auxz00_3157;

																							BgL_auxz00_3157 =
																								(long) (BgL_arg2336z00_2109);
																							BgL_modz00_2108 =
																								(BgL_offsetz00_2107 /
																								BgL_auxz00_3157);
																					}}
																					{	/* Ast/substitute.scm 205 */
																						long BgL_restz00_2110;

																						{	/* Ast/substitute.scm 205 */
																							int BgL_arg2335z00_2111;

																							BgL_arg2335z00_2111 =
																								(int) (((long) 8));
																							{	/* Ast/substitute.scm 205 */
																								long BgL_auxz00_3161;

																								BgL_auxz00_3161 =
																									(long) (BgL_arg2335z00_2111);
																								BgL_restz00_2110 =
																									(BgL_offsetz00_2107 %
																									BgL_auxz00_3161);
																						}}
																						{	/* Ast/substitute.scm 205 */

																							BgL_method3108z00_2100 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2105,
																									(int) (BgL_modz00_2108)),
																								(int) (BgL_restz00_2110));
															}}}}}}}}
															BgL_res3419z00_2125 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3108z00_2100)
																(BgL_method3108z00_2100,
																	(obj_t) (BgL_nodez00_2098), BgL_sitez00_1352,
																	BEOA));
													}}
													BgL_arg3316z00_1363 = BgL_res3419z00_2125;
											}}
											{	/* Ast/substitute.scm 205 */
												obj_t BgL_auxz00_3172;

												BgL_auxz00_3172 = (obj_t) (BgL_arg3316z00_1363);
												SET_CDR(BgL_clausez00_1362, BgL_auxz00_3172);
									}}}
									{
										obj_t BgL_l3092z00_3175;

										BgL_l3092z00_3175 = CDR(BgL_l3092z00_1359);
										BgL_l3092z00_1359 = BgL_l3092z00_3175;
										goto BgL_forzd2each3097zd2_1360;
									}
								}
							else
								{	/* Ast/substitute.scm 206 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3116 = BgL_nodez00_1351;
					return (obj_t) (BgL_auxz00_3116);
				}
			}
		}
	}



/* do-substitute!-fail3132 */
	obj_t BGl_dozd2substitutez12zd2fail3132z12zzast_substitutez00(obj_t
		BgL_envz00_2542, obj_t BgL_nodez00_2543, obj_t BgL_sitez00_2544)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 192 */
			{
				BgL_failz00_bglt BgL_nodez00_1335;

				obj_t BgL_sitez00_1336;

				{	/* Ast/substitute.scm 193 */
					BgL_failz00_bglt BgL_auxz00_3179;

					BgL_nodez00_1335 = (BgL_failz00_bglt) (BgL_nodez00_2543);
					BgL_sitez00_1336 = BgL_sitez00_2544;
					{	/* Ast/substitute.scm 194 */
						BgL_nodez00_bglt BgL_arg3302z00_1340;

						{	/* Ast/substitute.scm 194 */
							BgL_nodez00_bglt BgL_arg3303z00_1341;

							obj_t BgL_arg3304z00_1342;

							BgL_arg3303z00_1341 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1335))->BgL_procz00);
							BgL_arg3304z00_1342 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 194 */
								BgL_nodez00_bglt BgL_res3407z00_1998;

								{	/* Ast/substitute.scm 194 */
									obj_t BgL_method3108z00_1973;

									{	/* Ast/substitute.scm 194 */
										BgL_objectz00_bglt BgL_objz00_1974;

										BgL_objz00_1974 =
											(BgL_objectz00_bglt) (BgL_arg3303z00_1341);
										{	/* Ast/substitute.scm 194 */
											long BgL_objzd2classzd2numz00_1975;

											BgL_objzd2classzd2numz00_1975 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1974);
											{	/* Ast/substitute.scm 194 */
												obj_t BgL_arg2334z00_1976;

												BgL_arg2334z00_1976 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 194 */
													obj_t BgL_arrayz00_1978;

													int BgL_offsetz00_1979;

													BgL_arrayz00_1978 = BgL_arg2334z00_1976;
													BgL_offsetz00_1979 =
														(int) (BgL_objzd2classzd2numz00_1975);
													{	/* Ast/substitute.scm 194 */
														long BgL_offsetz00_1980;

														BgL_offsetz00_1980 =
															((long) (BgL_offsetz00_1979) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 194 */
															long BgL_modz00_1981;

															{	/* Ast/substitute.scm 194 */
																int BgL_arg2336z00_1982;

																BgL_arg2336z00_1982 = (int) (((long) 8));
																{	/* Ast/substitute.scm 194 */
																	long BgL_auxz00_3190;

																	BgL_auxz00_3190 =
																		(long) (BgL_arg2336z00_1982);
																	BgL_modz00_1981 =
																		(BgL_offsetz00_1980 / BgL_auxz00_3190);
															}}
															{	/* Ast/substitute.scm 194 */
																long BgL_restz00_1983;

																{	/* Ast/substitute.scm 194 */
																	int BgL_arg2335z00_1984;

																	BgL_arg2335z00_1984 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 194 */
																		long BgL_auxz00_3194;

																		BgL_auxz00_3194 =
																			(long) (BgL_arg2335z00_1984);
																		BgL_restz00_1983 =
																			(BgL_offsetz00_1980 % BgL_auxz00_3194);
																}}
																{	/* Ast/substitute.scm 194 */

																	BgL_method3108z00_1973 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1978,
																			(int) (BgL_modz00_1981)),
																		(int) (BgL_restz00_1983));
									}}}}}}}}
									BgL_res3407z00_1998 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1973)
										(BgL_method3108z00_1973, (obj_t) (BgL_arg3303z00_1341),
											BgL_arg3304z00_1342, BEOA));
								}
								BgL_arg3302z00_1340 = BgL_res3407z00_1998;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1335))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3302z00_1340), BUNSPEC);
					}
					{	/* Ast/substitute.scm 195 */
						BgL_nodez00_bglt BgL_arg3305z00_1343;

						{	/* Ast/substitute.scm 195 */
							BgL_nodez00_bglt BgL_arg3306z00_1344;

							obj_t BgL_arg3307z00_1345;

							BgL_arg3306z00_1344 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1335))->BgL_msgz00);
							BgL_arg3307z00_1345 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 195 */
								BgL_nodez00_bglt BgL_res3410z00_2029;

								{	/* Ast/substitute.scm 195 */
									obj_t BgL_method3108z00_2004;

									{	/* Ast/substitute.scm 195 */
										BgL_objectz00_bglt BgL_objz00_2005;

										BgL_objz00_2005 =
											(BgL_objectz00_bglt) (BgL_arg3306z00_1344);
										{	/* Ast/substitute.scm 195 */
											long BgL_objzd2classzd2numz00_2006;

											BgL_objzd2classzd2numz00_2006 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2005);
											{	/* Ast/substitute.scm 195 */
												obj_t BgL_arg2334z00_2007;

												BgL_arg2334z00_2007 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 195 */
													obj_t BgL_arrayz00_2009;

													int BgL_offsetz00_2010;

													BgL_arrayz00_2009 = BgL_arg2334z00_2007;
													BgL_offsetz00_2010 =
														(int) (BgL_objzd2classzd2numz00_2006);
													{	/* Ast/substitute.scm 195 */
														long BgL_offsetz00_2011;

														BgL_offsetz00_2011 =
															((long) (BgL_offsetz00_2010) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 195 */
															long BgL_modz00_2012;

															{	/* Ast/substitute.scm 195 */
																int BgL_arg2336z00_2013;

																BgL_arg2336z00_2013 = (int) (((long) 8));
																{	/* Ast/substitute.scm 195 */
																	long BgL_auxz00_3216;

																	BgL_auxz00_3216 =
																		(long) (BgL_arg2336z00_2013);
																	BgL_modz00_2012 =
																		(BgL_offsetz00_2011 / BgL_auxz00_3216);
															}}
															{	/* Ast/substitute.scm 195 */
																long BgL_restz00_2014;

																{	/* Ast/substitute.scm 195 */
																	int BgL_arg2335z00_2015;

																	BgL_arg2335z00_2015 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 195 */
																		long BgL_auxz00_3220;

																		BgL_auxz00_3220 =
																			(long) (BgL_arg2335z00_2015);
																		BgL_restz00_2014 =
																			(BgL_offsetz00_2011 % BgL_auxz00_3220);
																}}
																{	/* Ast/substitute.scm 195 */

																	BgL_method3108z00_2004 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2009,
																			(int) (BgL_modz00_2012)),
																		(int) (BgL_restz00_2014));
									}}}}}}}}
									BgL_res3410z00_2029 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2004)
										(BgL_method3108z00_2004, (obj_t) (BgL_arg3306z00_1344),
											BgL_arg3307z00_1345, BEOA));
								}
								BgL_arg3305z00_1343 = BgL_res3410z00_2029;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1335))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3305z00_1343), BUNSPEC);
					}
					{	/* Ast/substitute.scm 196 */
						BgL_nodez00_bglt BgL_arg3308z00_1346;

						{	/* Ast/substitute.scm 196 */
							BgL_nodez00_bglt BgL_arg3309z00_1347;

							obj_t BgL_arg3310z00_1348;

							BgL_arg3309z00_1347 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1335))->BgL_objz00);
							BgL_arg3310z00_1348 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 196 */
								BgL_nodez00_bglt BgL_res3413z00_2060;

								{	/* Ast/substitute.scm 196 */
									obj_t BgL_method3108z00_2035;

									{	/* Ast/substitute.scm 196 */
										BgL_objectz00_bglt BgL_objz00_2036;

										BgL_objz00_2036 =
											(BgL_objectz00_bglt) (BgL_arg3309z00_1347);
										{	/* Ast/substitute.scm 196 */
											long BgL_objzd2classzd2numz00_2037;

											BgL_objzd2classzd2numz00_2037 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2036);
											{	/* Ast/substitute.scm 196 */
												obj_t BgL_arg2334z00_2038;

												BgL_arg2334z00_2038 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 196 */
													obj_t BgL_arrayz00_2040;

													int BgL_offsetz00_2041;

													BgL_arrayz00_2040 = BgL_arg2334z00_2038;
													BgL_offsetz00_2041 =
														(int) (BgL_objzd2classzd2numz00_2037);
													{	/* Ast/substitute.scm 196 */
														long BgL_offsetz00_2042;

														BgL_offsetz00_2042 =
															((long) (BgL_offsetz00_2041) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 196 */
															long BgL_modz00_2043;

															{	/* Ast/substitute.scm 196 */
																int BgL_arg2336z00_2044;

																BgL_arg2336z00_2044 = (int) (((long) 8));
																{	/* Ast/substitute.scm 196 */
																	long BgL_auxz00_3242;

																	BgL_auxz00_3242 =
																		(long) (BgL_arg2336z00_2044);
																	BgL_modz00_2043 =
																		(BgL_offsetz00_2042 / BgL_auxz00_3242);
															}}
															{	/* Ast/substitute.scm 196 */
																long BgL_restz00_2045;

																{	/* Ast/substitute.scm 196 */
																	int BgL_arg2335z00_2046;

																	BgL_arg2335z00_2046 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 196 */
																		long BgL_auxz00_3246;

																		BgL_auxz00_3246 =
																			(long) (BgL_arg2335z00_2046);
																		BgL_restz00_2045 =
																			(BgL_offsetz00_2042 % BgL_auxz00_3246);
																}}
																{	/* Ast/substitute.scm 196 */

																	BgL_method3108z00_2035 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2040,
																			(int) (BgL_modz00_2043)),
																		(int) (BgL_restz00_2045));
									}}}}}}}}
									BgL_res3413z00_2060 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_2035)
										(BgL_method3108z00_2035, (obj_t) (BgL_arg3309z00_1347),
											BgL_arg3310z00_1348, BEOA));
								}
								BgL_arg3308z00_1346 = BgL_res3413z00_2060;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1335))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3308z00_1346), BUNSPEC);
					}
					BgL_auxz00_3179 = BgL_nodez00_1335;
					return (obj_t) (BgL_auxz00_3179);
				}
			}
		}
	}



/* do-substitute!-condi3130 */
	obj_t BGl_dozd2substitutez12zd2condi3130z12zzast_substitutez00(obj_t
		BgL_envz00_2545, obj_t BgL_nodez00_2546, obj_t BgL_sitez00_2547)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 182 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1321;

				obj_t BgL_sitez00_1322;

				{	/* Ast/substitute.scm 183 */
					BgL_conditionalz00_bglt BgL_auxz00_3260;

					BgL_nodez00_1321 = (BgL_conditionalz00_bglt) (BgL_nodez00_2546);
					BgL_sitez00_1322 = BgL_sitez00_2547;
					{	/* Ast/substitute.scm 184 */
						BgL_nodez00_bglt BgL_arg3294z00_1326;

						{	/* Ast/substitute.scm 184 */
							BgL_nodez00_bglt BgL_arg3295z00_1327;

							obj_t BgL_arg3296z00_1328;

							BgL_arg3295z00_1327 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1321))->
								BgL_testz00);
							BgL_arg3296z00_1328 = CNST_TABLE_REF(((long) 1));
							{	/* Ast/substitute.scm 184 */
								BgL_nodez00_bglt BgL_res3398z00_1905;

								{	/* Ast/substitute.scm 184 */
									obj_t BgL_method3108z00_1880;

									{	/* Ast/substitute.scm 184 */
										BgL_objectz00_bglt BgL_objz00_1881;

										BgL_objz00_1881 =
											(BgL_objectz00_bglt) (BgL_arg3295z00_1327);
										{	/* Ast/substitute.scm 184 */
											long BgL_objzd2classzd2numz00_1882;

											BgL_objzd2classzd2numz00_1882 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1881);
											{	/* Ast/substitute.scm 184 */
												obj_t BgL_arg2334z00_1883;

												BgL_arg2334z00_1883 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 184 */
													obj_t BgL_arrayz00_1885;

													int BgL_offsetz00_1886;

													BgL_arrayz00_1885 = BgL_arg2334z00_1883;
													BgL_offsetz00_1886 =
														(int) (BgL_objzd2classzd2numz00_1882);
													{	/* Ast/substitute.scm 184 */
														long BgL_offsetz00_1887;

														BgL_offsetz00_1887 =
															((long) (BgL_offsetz00_1886) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 184 */
															long BgL_modz00_1888;

															{	/* Ast/substitute.scm 184 */
																int BgL_arg2336z00_1889;

																BgL_arg2336z00_1889 = (int) (((long) 8));
																{	/* Ast/substitute.scm 184 */
																	long BgL_auxz00_3271;

																	BgL_auxz00_3271 =
																		(long) (BgL_arg2336z00_1889);
																	BgL_modz00_1888 =
																		(BgL_offsetz00_1887 / BgL_auxz00_3271);
															}}
															{	/* Ast/substitute.scm 184 */
																long BgL_restz00_1890;

																{	/* Ast/substitute.scm 184 */
																	int BgL_arg2335z00_1891;

																	BgL_arg2335z00_1891 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 184 */
																		long BgL_auxz00_3275;

																		BgL_auxz00_3275 =
																			(long) (BgL_arg2335z00_1891);
																		BgL_restz00_1890 =
																			(BgL_offsetz00_1887 % BgL_auxz00_3275);
																}}
																{	/* Ast/substitute.scm 184 */

																	BgL_method3108z00_1880 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1885,
																			(int) (BgL_modz00_1888)),
																		(int) (BgL_restz00_1890));
									}}}}}}}}
									BgL_res3398z00_1905 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1880)
										(BgL_method3108z00_1880, (obj_t) (BgL_arg3295z00_1327),
											BgL_arg3296z00_1328, BEOA));
								}
								BgL_arg3294z00_1326 = BgL_res3398z00_1905;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1321))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3294z00_1326), BUNSPEC);
					}
					{	/* Ast/substitute.scm 185 */
						BgL_nodez00_bglt BgL_arg3297z00_1329;

						{	/* Ast/substitute.scm 185 */
							BgL_nodez00_bglt BgL_arg3298z00_1330;

							BgL_arg3298z00_1330 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1321))->
								BgL_truez00);
							{	/* Ast/substitute.scm 185 */
								BgL_nodez00_bglt BgL_res3401z00_1936;

								{	/* Ast/substitute.scm 185 */
									obj_t BgL_method3108z00_1911;

									{	/* Ast/substitute.scm 185 */
										BgL_objectz00_bglt BgL_objz00_1912;

										BgL_objz00_1912 =
											(BgL_objectz00_bglt) (BgL_arg3298z00_1330);
										{	/* Ast/substitute.scm 185 */
											long BgL_objzd2classzd2numz00_1913;

											BgL_objzd2classzd2numz00_1913 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1912);
											{	/* Ast/substitute.scm 185 */
												obj_t BgL_arg2334z00_1914;

												BgL_arg2334z00_1914 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 185 */
													obj_t BgL_arrayz00_1916;

													int BgL_offsetz00_1917;

													BgL_arrayz00_1916 = BgL_arg2334z00_1914;
													BgL_offsetz00_1917 =
														(int) (BgL_objzd2classzd2numz00_1913);
													{	/* Ast/substitute.scm 185 */
														long BgL_offsetz00_1918;

														BgL_offsetz00_1918 =
															((long) (BgL_offsetz00_1917) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 185 */
															long BgL_modz00_1919;

															{	/* Ast/substitute.scm 185 */
																int BgL_arg2336z00_1920;

																BgL_arg2336z00_1920 = (int) (((long) 8));
																{	/* Ast/substitute.scm 185 */
																	long BgL_auxz00_3296;

																	BgL_auxz00_3296 =
																		(long) (BgL_arg2336z00_1920);
																	BgL_modz00_1919 =
																		(BgL_offsetz00_1918 / BgL_auxz00_3296);
															}}
															{	/* Ast/substitute.scm 185 */
																long BgL_restz00_1921;

																{	/* Ast/substitute.scm 185 */
																	int BgL_arg2335z00_1922;

																	BgL_arg2335z00_1922 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 185 */
																		long BgL_auxz00_3300;

																		BgL_auxz00_3300 =
																			(long) (BgL_arg2335z00_1922);
																		BgL_restz00_1921 =
																			(BgL_offsetz00_1918 % BgL_auxz00_3300);
																}}
																{	/* Ast/substitute.scm 185 */

																	BgL_method3108z00_1911 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1916,
																			(int) (BgL_modz00_1919)),
																		(int) (BgL_restz00_1921));
									}}}}}}}}
									BgL_res3401z00_1936 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1911)
										(BgL_method3108z00_1911, (obj_t) (BgL_arg3298z00_1330),
											BgL_sitez00_1322, BEOA));
								}
								BgL_arg3297z00_1329 = BgL_res3401z00_1936;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1321))->BgL_truez00) =
							((BgL_nodez00_bglt) BgL_arg3297z00_1329), BUNSPEC);
					}
					{	/* Ast/substitute.scm 186 */
						BgL_nodez00_bglt BgL_arg3299z00_1331;

						{	/* Ast/substitute.scm 186 */
							BgL_nodez00_bglt BgL_arg3300z00_1332;

							BgL_arg3300z00_1332 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1321))->
								BgL_falsez00);
							{	/* Ast/substitute.scm 186 */
								BgL_nodez00_bglt BgL_res3404z00_1967;

								{	/* Ast/substitute.scm 186 */
									obj_t BgL_method3108z00_1942;

									{	/* Ast/substitute.scm 186 */
										BgL_objectz00_bglt BgL_objz00_1943;

										BgL_objz00_1943 =
											(BgL_objectz00_bglt) (BgL_arg3300z00_1332);
										{	/* Ast/substitute.scm 186 */
											long BgL_objzd2classzd2numz00_1944;

											BgL_objzd2classzd2numz00_1944 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1943);
											{	/* Ast/substitute.scm 186 */
												obj_t BgL_arg2334z00_1945;

												BgL_arg2334z00_1945 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 186 */
													obj_t BgL_arrayz00_1947;

													int BgL_offsetz00_1948;

													BgL_arrayz00_1947 = BgL_arg2334z00_1945;
													BgL_offsetz00_1948 =
														(int) (BgL_objzd2classzd2numz00_1944);
													{	/* Ast/substitute.scm 186 */
														long BgL_offsetz00_1949;

														BgL_offsetz00_1949 =
															((long) (BgL_offsetz00_1948) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 186 */
															long BgL_modz00_1950;

															{	/* Ast/substitute.scm 186 */
																int BgL_arg2336z00_1951;

																BgL_arg2336z00_1951 = (int) (((long) 8));
																{	/* Ast/substitute.scm 186 */
																	long BgL_auxz00_3321;

																	BgL_auxz00_3321 =
																		(long) (BgL_arg2336z00_1951);
																	BgL_modz00_1950 =
																		(BgL_offsetz00_1949 / BgL_auxz00_3321);
															}}
															{	/* Ast/substitute.scm 186 */
																long BgL_restz00_1952;

																{	/* Ast/substitute.scm 186 */
																	int BgL_arg2335z00_1953;

																	BgL_arg2335z00_1953 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 186 */
																		long BgL_auxz00_3325;

																		BgL_auxz00_3325 =
																			(long) (BgL_arg2335z00_1953);
																		BgL_restz00_1952 =
																			(BgL_offsetz00_1949 % BgL_auxz00_3325);
																}}
																{	/* Ast/substitute.scm 186 */

																	BgL_method3108z00_1942 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1947,
																			(int) (BgL_modz00_1950)),
																		(int) (BgL_restz00_1952));
									}}}}}}}}
									BgL_res3404z00_1967 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1942)
										(BgL_method3108z00_1942, (obj_t) (BgL_arg3300z00_1332),
											BgL_sitez00_1322, BEOA));
								}
								BgL_arg3299z00_1331 = BgL_res3404z00_1967;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1321))->
								BgL_falsez00) =
							((BgL_nodez00_bglt) BgL_arg3299z00_1331), BUNSPEC);
					}
					BgL_auxz00_3260 = BgL_nodez00_1321;
					return (obj_t) (BgL_auxz00_3260);
				}
			}
		}
	}



/* do-substitute!-setq3128 */
	obj_t BGl_dozd2substitutez12zd2setq3128z12zzast_substitutez00(obj_t
		BgL_envz00_2548, obj_t BgL_nodez00_2549, obj_t BgL_sitez00_2550)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 173 */
			{
				BgL_setqz00_bglt BgL_nodez00_1309;

				obj_t BgL_sitez00_1310;

				{	/* Ast/substitute.scm 174 */
					BgL_setqz00_bglt BgL_auxz00_3339;

					BgL_nodez00_1309 = (BgL_setqz00_bglt) (BgL_nodez00_2549);
					BgL_sitez00_1310 = BgL_sitez00_2550;
					{	/* Ast/substitute.scm 175 */
						BgL_nodez00_bglt BgL_arg3288z00_1314;

						{	/* Ast/substitute.scm 175 */
							BgL_varz00_bglt BgL_arg3289z00_1315;

							obj_t BgL_arg3290z00_1316;

							BgL_arg3289z00_1315 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1309))->BgL_varz00);
							BgL_arg3290z00_1316 = CNST_TABLE_REF(((long) 4));
							{	/* Ast/substitute.scm 175 */
								BgL_nodez00_bglt BgL_res3392z00_1843;

								{	/* Ast/substitute.scm 175 */
									BgL_nodez00_bglt BgL_nodez00_1816;

									BgL_nodez00_1816 = (BgL_nodez00_bglt) (BgL_arg3289z00_1315);
									{	/* Ast/substitute.scm 175 */
										obj_t BgL_method3108z00_1818;

										{	/* Ast/substitute.scm 175 */
											BgL_objectz00_bglt BgL_objz00_1819;

											BgL_objz00_1819 = (BgL_objectz00_bglt) (BgL_nodez00_1816);
											{	/* Ast/substitute.scm 175 */
												long BgL_objzd2classzd2numz00_1820;

												BgL_objzd2classzd2numz00_1820 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1819);
												{	/* Ast/substitute.scm 175 */
													obj_t BgL_arg2334z00_1821;

													BgL_arg2334z00_1821 =
														PROCEDURE_REF
														(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
														(int) (((long) 1)));
													{	/* Ast/substitute.scm 175 */
														obj_t BgL_arrayz00_1823;

														int BgL_offsetz00_1824;

														BgL_arrayz00_1823 = BgL_arg2334z00_1821;
														BgL_offsetz00_1824 =
															(int) (BgL_objzd2classzd2numz00_1820);
														{	/* Ast/substitute.scm 175 */
															long BgL_offsetz00_1825;

															BgL_offsetz00_1825 =
																((long) (BgL_offsetz00_1824) - OBJECT_TYPE);
															{	/* Ast/substitute.scm 175 */
																long BgL_modz00_1826;

																{	/* Ast/substitute.scm 175 */
																	int BgL_arg2336z00_1827;

																	BgL_arg2336z00_1827 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 175 */
																		long BgL_auxz00_3351;

																		BgL_auxz00_3351 =
																			(long) (BgL_arg2336z00_1827);
																		BgL_modz00_1826 =
																			(BgL_offsetz00_1825 / BgL_auxz00_3351);
																}}
																{	/* Ast/substitute.scm 175 */
																	long BgL_restz00_1828;

																	{	/* Ast/substitute.scm 175 */
																		int BgL_arg2335z00_1829;

																		BgL_arg2335z00_1829 = (int) (((long) 8));
																		{	/* Ast/substitute.scm 175 */
																			long BgL_auxz00_3355;

																			BgL_auxz00_3355 =
																				(long) (BgL_arg2335z00_1829);
																			BgL_restz00_1828 =
																				(BgL_offsetz00_1825 % BgL_auxz00_3355);
																	}}
																	{	/* Ast/substitute.scm 175 */

																		BgL_method3108z00_1818 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1823,
																				(int) (BgL_modz00_1826)),
																			(int) (BgL_restz00_1828));
										}}}}}}}}
										BgL_res3392z00_1843 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3108z00_1818) (BgL_method3108z00_1818,
												(obj_t) (BgL_nodez00_1816), BgL_arg3290z00_1316, BEOA));
								}}
								BgL_arg3288z00_1314 = BgL_res3392z00_1843;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3366;

							BgL_auxz00_3366 = (BgL_varz00_bglt) (BgL_arg3288z00_1314);
							((((BgL_setqz00_bglt) CREF(BgL_nodez00_1309))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_3366), BUNSPEC);
					}}
					{	/* Ast/substitute.scm 176 */
						BgL_nodez00_bglt BgL_arg3291z00_1317;

						{	/* Ast/substitute.scm 176 */
							BgL_nodez00_bglt BgL_arg3292z00_1318;

							BgL_arg3292z00_1318 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1309))->BgL_valuez00);
							{	/* Ast/substitute.scm 176 */
								BgL_nodez00_bglt BgL_res3395z00_1874;

								{	/* Ast/substitute.scm 176 */
									obj_t BgL_method3108z00_1849;

									{	/* Ast/substitute.scm 176 */
										BgL_objectz00_bglt BgL_objz00_1850;

										BgL_objz00_1850 =
											(BgL_objectz00_bglt) (BgL_arg3292z00_1318);
										{	/* Ast/substitute.scm 176 */
											long BgL_objzd2classzd2numz00_1851;

											BgL_objzd2classzd2numz00_1851 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1850);
											{	/* Ast/substitute.scm 176 */
												obj_t BgL_arg2334z00_1852;

												BgL_arg2334z00_1852 =
													PROCEDURE_REF
													(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
													(int) (((long) 1)));
												{	/* Ast/substitute.scm 176 */
													obj_t BgL_arrayz00_1854;

													int BgL_offsetz00_1855;

													BgL_arrayz00_1854 = BgL_arg2334z00_1852;
													BgL_offsetz00_1855 =
														(int) (BgL_objzd2classzd2numz00_1851);
													{	/* Ast/substitute.scm 176 */
														long BgL_offsetz00_1856;

														BgL_offsetz00_1856 =
															((long) (BgL_offsetz00_1855) - OBJECT_TYPE);
														{	/* Ast/substitute.scm 176 */
															long BgL_modz00_1857;

															{	/* Ast/substitute.scm 176 */
																int BgL_arg2336z00_1858;

																BgL_arg2336z00_1858 = (int) (((long) 8));
																{	/* Ast/substitute.scm 176 */
																	long BgL_auxz00_3378;

																	BgL_auxz00_3378 =
																		(long) (BgL_arg2336z00_1858);
																	BgL_modz00_1857 =
																		(BgL_offsetz00_1856 / BgL_auxz00_3378);
															}}
															{	/* Ast/substitute.scm 176 */
																long BgL_restz00_1859;

																{	/* Ast/substitute.scm 176 */
																	int BgL_arg2335z00_1860;

																	BgL_arg2335z00_1860 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 176 */
																		long BgL_auxz00_3382;

																		BgL_auxz00_3382 =
																			(long) (BgL_arg2335z00_1860);
																		BgL_restz00_1859 =
																			(BgL_offsetz00_1856 % BgL_auxz00_3382);
																}}
																{	/* Ast/substitute.scm 176 */

																	BgL_method3108z00_1849 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1854,
																			(int) (BgL_modz00_1857)),
																		(int) (BgL_restz00_1859));
									}}}}}}}}
									BgL_res3395z00_1874 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1849)
										(BgL_method3108z00_1849, (obj_t) (BgL_arg3292z00_1318),
											BgL_sitez00_1310, BEOA));
								}
								BgL_arg3291z00_1317 = BgL_res3395z00_1874;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1309))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3291z00_1317), BUNSPEC);
					}
					BgL_auxz00_3339 = BgL_nodez00_1309;
					return (obj_t) (BgL_auxz00_3339);
				}
			}
		}
	}



/* do-substitute!-cast3126 */
	obj_t BGl_dozd2substitutez12zd2cast3126z12zzast_substitutez00(obj_t
		BgL_envz00_2551, obj_t BgL_nodez00_2552, obj_t BgL_sitez00_2553)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 166 */
			{
				BgL_castz00_bglt BgL_nodez00_1302;

				obj_t BgL_sitez00_1303;

				{	/* Ast/substitute.scm 167 */
					BgL_castz00_bglt BgL_auxz00_3396;

					BgL_nodez00_1302 = (BgL_castz00_bglt) (BgL_nodez00_2552);
					BgL_sitez00_1303 = BgL_sitez00_2553;
					{	/* Ast/substitute.scm 167 */
						BgL_nodez00_bglt BgL_arg3286z00_1785;

						BgL_arg3286z00_1785 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1302))->BgL_argz00);
						{	/* Ast/substitute.scm 167 */
							BgL_nodez00_bglt BgL_res3389z00_1814;

							{	/* Ast/substitute.scm 167 */
								obj_t BgL_method3108z00_1789;

								{	/* Ast/substitute.scm 167 */
									BgL_objectz00_bglt BgL_objz00_1790;

									BgL_objz00_1790 = (BgL_objectz00_bglt) (BgL_arg3286z00_1785);
									{	/* Ast/substitute.scm 167 */
										long BgL_objzd2classzd2numz00_1791;

										BgL_objzd2classzd2numz00_1791 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1790);
										{	/* Ast/substitute.scm 167 */
											obj_t BgL_arg2334z00_1792;

											BgL_arg2334z00_1792 =
												PROCEDURE_REF
												(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
												(int) (((long) 1)));
											{	/* Ast/substitute.scm 167 */
												obj_t BgL_arrayz00_1794;

												int BgL_offsetz00_1795;

												BgL_arrayz00_1794 = BgL_arg2334z00_1792;
												BgL_offsetz00_1795 =
													(int) (BgL_objzd2classzd2numz00_1791);
												{	/* Ast/substitute.scm 167 */
													long BgL_offsetz00_1796;

													BgL_offsetz00_1796 =
														((long) (BgL_offsetz00_1795) - OBJECT_TYPE);
													{	/* Ast/substitute.scm 167 */
														long BgL_modz00_1797;

														{	/* Ast/substitute.scm 167 */
															int BgL_arg2336z00_1798;

															BgL_arg2336z00_1798 = (int) (((long) 8));
															{	/* Ast/substitute.scm 167 */
																long BgL_auxz00_3406;

																BgL_auxz00_3406 = (long) (BgL_arg2336z00_1798);
																BgL_modz00_1797 =
																	(BgL_offsetz00_1796 / BgL_auxz00_3406);
														}}
														{	/* Ast/substitute.scm 167 */
															long BgL_restz00_1799;

															{	/* Ast/substitute.scm 167 */
																int BgL_arg2335z00_1800;

																BgL_arg2335z00_1800 = (int) (((long) 8));
																{	/* Ast/substitute.scm 167 */
																	long BgL_auxz00_3410;

																	BgL_auxz00_3410 =
																		(long) (BgL_arg2335z00_1800);
																	BgL_restz00_1799 =
																		(BgL_offsetz00_1796 % BgL_auxz00_3410);
															}}
															{	/* Ast/substitute.scm 167 */

																BgL_method3108z00_1789 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1794,
																		(int) (BgL_modz00_1797)),
																	(int) (BgL_restz00_1799));
								}}}}}}}}
								BgL_res3389z00_1814 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1789)
									(BgL_method3108z00_1789, (obj_t) (BgL_arg3286z00_1785),
										BgL_sitez00_1303, BEOA));
							} BgL_res3389z00_1814;
					}}
					BgL_auxz00_3396 = BgL_nodez00_1302;
					return (obj_t) (BgL_auxz00_3396);
				}
			}
		}
	}



/* do-substitute!-exter3124 */
	obj_t BGl_dozd2substitutez12zd2exter3124z12zzast_substitutez00(obj_t
		BgL_envz00_2554, obj_t BgL_nodez00_2555, obj_t BgL_sitez00_2556)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 159 */
			{
				BgL_externz00_bglt BgL_nodez00_1295;

				obj_t BgL_sitez00_1296;

				{	/* Ast/substitute.scm 160 */
					BgL_externz00_bglt BgL_auxz00_3423;

					BgL_nodez00_1295 = (BgL_externz00_bglt) (BgL_nodez00_2555);
					BgL_sitez00_1296 = BgL_sitez00_2556;
					{	/* Ast/substitute.scm 160 */
						obj_t BgL_arg3284z00_1783;

						BgL_arg3284z00_1783 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1295))->BgL_exprza2za2);
						BGl_dozd2substituteza2z12z62zzast_substitutez00(BgL_arg3284z00_1783,
							BgL_sitez00_1296);
					}
					BgL_auxz00_3423 = BgL_nodez00_1295;
					return (obj_t) (BgL_auxz00_3423);
				}
			}
		}
	}



/* do-substitute!-funca3122 */
	obj_t BGl_dozd2substitutez12zd2funca3122z12zzast_substitutez00(obj_t
		BgL_envz00_2557, obj_t BgL_nodez00_2558, obj_t BgL_sitez00_2559)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 133 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1255;

				obj_t BgL_sitez00_1256;

				BgL_nodez00_1255 = (BgL_funcallz00_bglt) (BgL_nodez00_2558);
				BgL_sitez00_1256 = BgL_sitez00_2559;
				{	/* Ast/substitute.scm 135 */
					BgL_nodez00_bglt BgL_nfunz00_1260;

					obj_t BgL_nargsz00_1261;

					{	/* Ast/substitute.scm 135 */
						BgL_nodez00_bglt BgL_arg3276z00_1279;

						obj_t BgL_arg3277z00_1280;

						BgL_arg3276z00_1279 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1255))->BgL_funz00);
						BgL_arg3277z00_1280 = CNST_TABLE_REF(((long) 1));
						{	/* Ast/substitute.scm 135 */
							BgL_nodez00_bglt BgL_res3383z00_1728;

							{	/* Ast/substitute.scm 135 */
								obj_t BgL_method3108z00_1703;

								{	/* Ast/substitute.scm 135 */
									BgL_objectz00_bglt BgL_objz00_1704;

									BgL_objz00_1704 = (BgL_objectz00_bglt) (BgL_arg3276z00_1279);
									{	/* Ast/substitute.scm 135 */
										long BgL_objzd2classzd2numz00_1705;

										BgL_objzd2classzd2numz00_1705 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1704);
										{	/* Ast/substitute.scm 135 */
											obj_t BgL_arg2334z00_1706;

											BgL_arg2334z00_1706 =
												PROCEDURE_REF
												(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
												(int) (((long) 1)));
											{	/* Ast/substitute.scm 135 */
												obj_t BgL_arrayz00_1708;

												int BgL_offsetz00_1709;

												BgL_arrayz00_1708 = BgL_arg2334z00_1706;
												BgL_offsetz00_1709 =
													(int) (BgL_objzd2classzd2numz00_1705);
												{	/* Ast/substitute.scm 135 */
													long BgL_offsetz00_1710;

													BgL_offsetz00_1710 =
														((long) (BgL_offsetz00_1709) - OBJECT_TYPE);
													{	/* Ast/substitute.scm 135 */
														long BgL_modz00_1711;

														{	/* Ast/substitute.scm 135 */
															int BgL_arg2336z00_1712;

															BgL_arg2336z00_1712 = (int) (((long) 8));
															{	/* Ast/substitute.scm 135 */
																long BgL_auxz00_3438;

																BgL_auxz00_3438 = (long) (BgL_arg2336z00_1712);
																BgL_modz00_1711 =
																	(BgL_offsetz00_1710 / BgL_auxz00_3438);
														}}
														{	/* Ast/substitute.scm 135 */
															long BgL_restz00_1713;

															{	/* Ast/substitute.scm 135 */
																int BgL_arg2335z00_1714;

																BgL_arg2335z00_1714 = (int) (((long) 8));
																{	/* Ast/substitute.scm 135 */
																	long BgL_auxz00_3442;

																	BgL_auxz00_3442 =
																		(long) (BgL_arg2335z00_1714);
																	BgL_restz00_1713 =
																		(BgL_offsetz00_1710 % BgL_auxz00_3442);
															}}
															{	/* Ast/substitute.scm 135 */

																BgL_method3108z00_1703 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1708,
																		(int) (BgL_modz00_1711)),
																	(int) (BgL_restz00_1713));
								}}}}}}}}
								BgL_res3383z00_1728 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1703)
									(BgL_method3108z00_1703, (obj_t) (BgL_arg3276z00_1279),
										BgL_arg3277z00_1280, BEOA));
							}
							BgL_nfunz00_1260 = BgL_res3383z00_1728;
					}}
					{	/* Ast/substitute.scm 136 */
						obj_t BgL_l3086z00_1281;

						BgL_l3086z00_1281 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1255))->BgL_argsz00);
						if (NULLP(BgL_l3086z00_1281))
							{	/* Ast/substitute.scm 136 */
								BgL_nargsz00_1261 = BNIL;
							}
						else
							{	/* Ast/substitute.scm 136 */
								obj_t BgL_head3089z00_1283;

								BgL_head3089z00_1283 = MAKE_PAIR(BNIL, BNIL);
								{
									obj_t BgL_l3086z00_1284;

									obj_t BgL_tail3090z00_1285;

									BgL_l3086z00_1284 = BgL_l3086z00_1281;
									BgL_tail3090z00_1285 = BgL_head3089z00_1283;
								BgL_map3088z00_1286:
									if (NULLP(BgL_l3086z00_1284))
										{	/* Ast/substitute.scm 136 */
											BgL_nargsz00_1261 = CDR(BgL_head3089z00_1283);
										}
									else
										{	/* Ast/substitute.scm 136 */
											obj_t BgL_newtail3091z00_1288;

											{	/* Ast/substitute.scm 136 */
												BgL_nodez00_bglt BgL_arg3281z00_1290;

												{	/* Ast/substitute.scm 136 */
													obj_t BgL_az00_1292;

													BgL_az00_1292 = CAR(BgL_l3086z00_1284);
													{	/* Ast/substitute.scm 136 */
														BgL_nodez00_bglt BgL_res3386z00_1763;

														{	/* Ast/substitute.scm 136 */
															BgL_nodez00_bglt BgL_nodez00_1736;

															obj_t BgL_sitez00_1737;

															BgL_nodez00_1736 =
																(BgL_nodez00_bglt) (BgL_az00_1292);
															BgL_sitez00_1737 = CNST_TABLE_REF(((long) 1));
															{	/* Ast/substitute.scm 136 */
																obj_t BgL_method3108z00_1738;

																{	/* Ast/substitute.scm 136 */
																	BgL_objectz00_bglt BgL_objz00_1739;

																	BgL_objz00_1739 =
																		(BgL_objectz00_bglt) (BgL_nodez00_1736);
																	{	/* Ast/substitute.scm 136 */
																		long BgL_objzd2classzd2numz00_1740;

																		BgL_objzd2classzd2numz00_1740 =
																			BGL_OBJECT_CLASS_NUM(BgL_objz00_1739);
																		{	/* Ast/substitute.scm 136 */
																			obj_t BgL_arg2334z00_1741;

																			BgL_arg2334z00_1741 =
																				PROCEDURE_REF
																				(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
																				(int) (((long) 1)));
																			{	/* Ast/substitute.scm 136 */
																				obj_t BgL_arrayz00_1743;

																				int BgL_offsetz00_1744;

																				BgL_arrayz00_1743 = BgL_arg2334z00_1741;
																				BgL_offsetz00_1744 =
																					(int) (BgL_objzd2classzd2numz00_1740);
																				{	/* Ast/substitute.scm 136 */
																					long BgL_offsetz00_1745;

																					BgL_offsetz00_1745 =
																						(
																						(long) (BgL_offsetz00_1744) -
																						OBJECT_TYPE);
																					{	/* Ast/substitute.scm 136 */
																						long BgL_modz00_1746;

																						{	/* Ast/substitute.scm 136 */
																							int BgL_arg2336z00_1747;

																							BgL_arg2336z00_1747 =
																								(int) (((long) 8));
																							{	/* Ast/substitute.scm 136 */
																								long BgL_auxz00_3471;

																								BgL_auxz00_3471 =
																									(long) (BgL_arg2336z00_1747);
																								BgL_modz00_1746 =
																									(BgL_offsetz00_1745 /
																									BgL_auxz00_3471);
																						}}
																						{	/* Ast/substitute.scm 136 */
																							long BgL_restz00_1748;

																							{	/* Ast/substitute.scm 136 */
																								int BgL_arg2335z00_1749;

																								BgL_arg2335z00_1749 =
																									(int) (((long) 8));
																								{	/* Ast/substitute.scm 136 */
																									long BgL_auxz00_3475;

																									BgL_auxz00_3475 =
																										(long)
																										(BgL_arg2335z00_1749);
																									BgL_restz00_1748 =
																										(BgL_offsetz00_1745 %
																										BgL_auxz00_3475);
																							}}
																							{	/* Ast/substitute.scm 136 */

																								BgL_method3108z00_1738 =
																									VECTOR_REF(VECTOR_REF
																									(BgL_arrayz00_1743,
																										(int) (BgL_modz00_1746)),
																									(int) (BgL_restz00_1748));
																}}}}}}}}
																BgL_res3386z00_1763 =
																	(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																	(BgL_method3108z00_1738)
																	(BgL_method3108z00_1738,
																		(obj_t) (BgL_nodez00_1736),
																		BgL_sitez00_1737, BEOA));
														}}
														BgL_arg3281z00_1290 = BgL_res3386z00_1763;
												}}
												BgL_newtail3091z00_1288 =
													MAKE_PAIR((obj_t) (BgL_arg3281z00_1290), BNIL);
											}
											SET_CDR(BgL_tail3090z00_1285, BgL_newtail3091z00_1288);
											{
												obj_t BgL_tail3090z00_3491;

												obj_t BgL_l3086z00_3489;

												BgL_l3086z00_3489 = CDR(BgL_l3086z00_1284);
												BgL_tail3090z00_3491 = BgL_newtail3091z00_1288;
												BgL_tail3090z00_1285 = BgL_tail3090z00_3491;
												BgL_l3086z00_1284 = BgL_l3086z00_3489;
												goto BgL_map3088z00_1286;
											}
										}
								}
							}
					}
					{	/* Ast/substitute.scm 137 */
						bool_t BgL_testz00_3492;

						{	/* Ast/substitute.scm 137 */
							bool_t BgL_testz00_3493;

							{	/* Ast/substitute.scm 137 */
								obj_t BgL_obj2007z00_1769;

								BgL_obj2007z00_1769 = (obj_t) (BgL_nfunz00_1260);
								BgL_testz00_3493 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj2007z00_1769,
									BGl_closurez00zzast_nodez00);
							}
							if (BgL_testz00_3493)
								{	/* Ast/substitute.scm 137 */
									BgL_testz00_3492 = ((bool_t) 1);
								}
							else
								{	/* Ast/substitute.scm 138 */
									bool_t BgL_testz00_3496;

									{	/* Ast/substitute.scm 138 */
										obj_t BgL_obj1987z00_1770;

										BgL_obj1987z00_1770 = (obj_t) (BgL_nfunz00_1260);
										BgL_testz00_3496 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj1987z00_1770,
											BGl_varz00zzast_nodez00);
									}
									if (BgL_testz00_3496)
										{	/* Ast/substitute.scm 139 */
											BgL_valuez00_bglt BgL_arg3274z00_1277;

											{	/* Ast/substitute.scm 139 */
												BgL_variablez00_bglt BgL_obj1426z00_1772;

												{
													BgL_varz00_bglt BgL_auxz00_3499;

													BgL_auxz00_3499 =
														(BgL_varz00_bglt) (BgL_nfunz00_1260);
													BgL_obj1426z00_1772 =
														(((BgL_varz00_bglt) CREF(BgL_auxz00_3499))->
														BgL_variablez00);
												}
												BgL_arg3274z00_1277 =
													(((BgL_variablez00_bglt) CREF(BgL_obj1426z00_1772))->
													BgL_valuez00);
											}
											{	/* Ast/substitute.scm 139 */
												obj_t BgL_obj1673z00_1773;

												BgL_obj1673z00_1773 = (obj_t) (BgL_arg3274z00_1277);
												BgL_testz00_3492 =
													BGl_iszd2azf3z21zz__objectz00(BgL_obj1673z00_1773,
													BGl_funz00zzast_varz00);
											}
										}
									else
										{	/* Ast/substitute.scm 138 */
											BgL_testz00_3492 = ((bool_t) 0);
										}
								}
						}
						if (BgL_testz00_3492)
							{	/* Ast/substitute.scm 140 */
								bool_t BgL_testz00_3505;

								{	/* Ast/substitute.scm 140 */
									BgL_variablez00_bglt BgL_arg3271z00_1273;

									obj_t BgL_arg3272z00_1274;

									{
										BgL_varz00_bglt BgL_auxz00_3506;

										BgL_auxz00_3506 = (BgL_varz00_bglt) (BgL_nfunz00_1260);
										BgL_arg3271z00_1273 =
											(((BgL_varz00_bglt) CREF(BgL_auxz00_3506))->
											BgL_variablez00);
									}
									BgL_arg3272z00_1274 = CDR(BgL_nargsz00_1261);
									BgL_testz00_3505 =
										BGl_correctzd2arityzd2appzf3zf3zzast_appz00
										(BgL_arg3271z00_1273, BgL_arg3272z00_1274);
								}
								if (BgL_testz00_3505)
									{	/* Ast/substitute.scm 142 */
										obj_t BgL_arg3263z00_1265;

										obj_t BgL_arg3264z00_1266;

										obj_t BgL_arg3265z00_1267;

										{
											BgL_nodez00_bglt BgL_auxz00_3511;

											BgL_auxz00_3511 = (BgL_nodez00_bglt) (BgL_nodez00_1255);
											BgL_arg3263z00_1265 =
												(((BgL_nodez00_bglt) CREF(BgL_auxz00_3511))->
												BgL_locz00);
										}
										BgL_arg3264z00_1266 = CNST_TABLE_REF(((long) 5));
										BgL_arg3265z00_1267 = CDR(BgL_nargsz00_1261);
										return
											(obj_t) (BGl_makezd2appzd2nodez00zzast_appz00(BNIL,
												BgL_arg3263z00_1265, BgL_arg3264z00_1266,
												(BgL_varz00_bglt) (BgL_nfunz00_1260),
												BgL_arg3265z00_1267));
									}
								else
									{	/* Ast/substitute.scm 147 */
										obj_t BgL_arg3266z00_1268;

										obj_t BgL_arg3269z00_1271;

										{
											BgL_nodez00_bglt BgL_auxz00_3519;

											BgL_auxz00_3519 = (BgL_nodez00_bglt) (BgL_nodez00_1255);
											BgL_arg3266z00_1268 =
												(((BgL_nodez00_bglt) CREF(BgL_auxz00_3519))->
												BgL_locz00);
										}
										BgL_arg3269z00_1271 =
											BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1255));
										return
											BGl_userzd2errorzf2locationz20zztools_errorz00
											(BgL_arg3266z00_1268,
											BGl_string3474z00zzast_substitutez00,
											BGl_string3475z00zzast_substitutez00, BgL_arg3269z00_1271,
											BNIL);
									}
							}
						else
							{	/* Ast/substitute.scm 137 */
								((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1255))->BgL_funz00) =
									((BgL_nodez00_bglt) BgL_nfunz00_1260), BUNSPEC);
								((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1255))->BgL_argsz00) =
									((obj_t) BgL_nargsz00_1261), BUNSPEC);
								return (obj_t) (BgL_nodez00_1255);
							}
					}
				}
			}
		}
	}



/* do-substitute!-app-l3120 */
	obj_t BGl_dozd2substitutez12zd2appzd2l3120zc0zzast_substitutez00(obj_t
		BgL_envz00_2560, obj_t BgL_nodez00_2561, obj_t BgL_sitez00_2562)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 114 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1228;

				obj_t BgL_sitez00_1229;

				BgL_nodez00_1228 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2561);
				BgL_sitez00_1229 = BgL_sitez00_2562;
				{	/* Ast/substitute.scm 116 */
					BgL_nodez00_bglt BgL_nfunz00_1233;

					BgL_nodez00_bglt BgL_nargz00_1234;

					{	/* Ast/substitute.scm 116 */
						BgL_nodez00_bglt BgL_arg3255z00_1249;

						obj_t BgL_arg3256z00_1250;

						BgL_arg3255z00_1249 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1228))->BgL_funz00);
						BgL_arg3256z00_1250 = CNST_TABLE_REF(((long) 6));
						{	/* Ast/substitute.scm 116 */
							BgL_nodez00_bglt BgL_res3377z00_1659;

							{	/* Ast/substitute.scm 116 */
								obj_t BgL_method3108z00_1634;

								{	/* Ast/substitute.scm 116 */
									BgL_objectz00_bglt BgL_objz00_1635;

									BgL_objz00_1635 = (BgL_objectz00_bglt) (BgL_arg3255z00_1249);
									{	/* Ast/substitute.scm 116 */
										long BgL_objzd2classzd2numz00_1636;

										BgL_objzd2classzd2numz00_1636 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1635);
										{	/* Ast/substitute.scm 116 */
											obj_t BgL_arg2334z00_1637;

											BgL_arg2334z00_1637 =
												PROCEDURE_REF
												(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
												(int) (((long) 1)));
											{	/* Ast/substitute.scm 116 */
												obj_t BgL_arrayz00_1639;

												int BgL_offsetz00_1640;

												BgL_arrayz00_1639 = BgL_arg2334z00_1637;
												BgL_offsetz00_1640 =
													(int) (BgL_objzd2classzd2numz00_1636);
												{	/* Ast/substitute.scm 116 */
													long BgL_offsetz00_1641;

													BgL_offsetz00_1641 =
														((long) (BgL_offsetz00_1640) - OBJECT_TYPE);
													{	/* Ast/substitute.scm 116 */
														long BgL_modz00_1642;

														{	/* Ast/substitute.scm 116 */
															int BgL_arg2336z00_1643;

															BgL_arg2336z00_1643 = (int) (((long) 8));
															{	/* Ast/substitute.scm 116 */
																long BgL_auxz00_3539;

																BgL_auxz00_3539 = (long) (BgL_arg2336z00_1643);
																BgL_modz00_1642 =
																	(BgL_offsetz00_1641 / BgL_auxz00_3539);
														}}
														{	/* Ast/substitute.scm 116 */
															long BgL_restz00_1644;

															{	/* Ast/substitute.scm 116 */
																int BgL_arg2335z00_1645;

																BgL_arg2335z00_1645 = (int) (((long) 8));
																{	/* Ast/substitute.scm 116 */
																	long BgL_auxz00_3543;

																	BgL_auxz00_3543 =
																		(long) (BgL_arg2335z00_1645);
																	BgL_restz00_1644 =
																		(BgL_offsetz00_1641 % BgL_auxz00_3543);
															}}
															{	/* Ast/substitute.scm 116 */

																BgL_method3108z00_1634 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1639,
																		(int) (BgL_modz00_1642)),
																	(int) (BgL_restz00_1644));
								}}}}}}}}
								BgL_res3377z00_1659 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1634)
									(BgL_method3108z00_1634, (obj_t) (BgL_arg3255z00_1249),
										BgL_arg3256z00_1250, BEOA));
							}
							BgL_nfunz00_1233 = BgL_res3377z00_1659;
					}}
					{	/* Ast/substitute.scm 117 */
						BgL_nodez00_bglt BgL_arg3257z00_1251;

						obj_t BgL_arg3258z00_1252;

						BgL_arg3257z00_1251 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1228))->BgL_argz00);
						BgL_arg3258z00_1252 = CNST_TABLE_REF(((long) 1));
						{	/* Ast/substitute.scm 117 */
							BgL_nodez00_bglt BgL_res3380z00_1688;

							{	/* Ast/substitute.scm 117 */
								obj_t BgL_method3108z00_1663;

								{	/* Ast/substitute.scm 117 */
									BgL_objectz00_bglt BgL_objz00_1664;

									BgL_objz00_1664 = (BgL_objectz00_bglt) (BgL_arg3257z00_1251);
									{	/* Ast/substitute.scm 117 */
										long BgL_objzd2classzd2numz00_1665;

										BgL_objzd2classzd2numz00_1665 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1664);
										{	/* Ast/substitute.scm 117 */
											obj_t BgL_arg2334z00_1666;

											BgL_arg2334z00_1666 =
												PROCEDURE_REF
												(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
												(int) (((long) 1)));
											{	/* Ast/substitute.scm 117 */
												obj_t BgL_arrayz00_1668;

												int BgL_offsetz00_1669;

												BgL_arrayz00_1668 = BgL_arg2334z00_1666;
												BgL_offsetz00_1669 =
													(int) (BgL_objzd2classzd2numz00_1665);
												{	/* Ast/substitute.scm 117 */
													long BgL_offsetz00_1670;

													BgL_offsetz00_1670 =
														((long) (BgL_offsetz00_1669) - OBJECT_TYPE);
													{	/* Ast/substitute.scm 117 */
														long BgL_modz00_1671;

														{	/* Ast/substitute.scm 117 */
															int BgL_arg2336z00_1672;

															BgL_arg2336z00_1672 = (int) (((long) 8));
															{	/* Ast/substitute.scm 117 */
																long BgL_auxz00_3564;

																BgL_auxz00_3564 = (long) (BgL_arg2336z00_1672);
																BgL_modz00_1671 =
																	(BgL_offsetz00_1670 / BgL_auxz00_3564);
														}}
														{	/* Ast/substitute.scm 117 */
															long BgL_restz00_1673;

															{	/* Ast/substitute.scm 117 */
																int BgL_arg2335z00_1674;

																BgL_arg2335z00_1674 = (int) (((long) 8));
																{	/* Ast/substitute.scm 117 */
																	long BgL_auxz00_3568;

																	BgL_auxz00_3568 =
																		(long) (BgL_arg2335z00_1674);
																	BgL_restz00_1673 =
																		(BgL_offsetz00_1670 % BgL_auxz00_3568);
															}}
															{	/* Ast/substitute.scm 117 */

																BgL_method3108z00_1663 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1668,
																		(int) (BgL_modz00_1671)),
																	(int) (BgL_restz00_1673));
								}}}}}}}}
								BgL_res3380z00_1688 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3108z00_1663)
									(BgL_method3108z00_1663, (obj_t) (BgL_arg3257z00_1251),
										BgL_arg3258z00_1252, BEOA));
							}
							BgL_nargz00_1234 = BgL_res3380z00_1688;
					}}
					{	/* Ast/substitute.scm 118 */
						bool_t BgL_testz00_3579;

						{	/* Ast/substitute.scm 118 */
							bool_t BgL_testz00_3580;

							{	/* Ast/substitute.scm 118 */
								obj_t BgL_obj2007z00_1689;

								BgL_obj2007z00_1689 = (obj_t) (BgL_nfunz00_1233);
								BgL_testz00_3580 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj2007z00_1689,
									BGl_closurez00zzast_nodez00);
							}
							if (BgL_testz00_3580)
								{	/* Ast/substitute.scm 119 */
									bool_t BgL_testz00_3583;

									{	/* Ast/substitute.scm 119 */
										BgL_variablez00_bglt BgL_arg3254z00_1248;

										{
											BgL_varz00_bglt BgL_auxz00_3584;

											BgL_auxz00_3584 = (BgL_varz00_bglt) (BgL_nfunz00_1233);
											BgL_arg3254z00_1248 =
												(((BgL_varz00_bglt) CREF(BgL_auxz00_3584))->
												BgL_variablez00);
										}
										BgL_testz00_3583 =
											BGl_globalzd2optionalzf3z21zzast_varz00(
											(obj_t) (BgL_arg3254z00_1248));
									}
									if (BgL_testz00_3583)
										{	/* Ast/substitute.scm 119 */
											BgL_testz00_3579 = ((bool_t) 0);
										}
									else
										{	/* Ast/substitute.scm 120 */
											bool_t BgL_testz00_3589;

											{	/* Ast/substitute.scm 120 */
												BgL_variablez00_bglt BgL_arg3253z00_1247;

												{
													BgL_varz00_bglt BgL_auxz00_3590;

													BgL_auxz00_3590 =
														(BgL_varz00_bglt) (BgL_nfunz00_1233);
													BgL_arg3253z00_1247 =
														(((BgL_varz00_bglt) CREF(BgL_auxz00_3590))->
														BgL_variablez00);
												}
												BgL_testz00_3589 =
													BGl_globalzd2keyzf3z21zzast_varz00(
													(obj_t) (BgL_arg3253z00_1247));
											}
											if (BgL_testz00_3589)
												{	/* Ast/substitute.scm 120 */
													BgL_testz00_3579 = ((bool_t) 0);
												}
											else
												{	/* Ast/substitute.scm 120 */
													BgL_testz00_3579 = ((bool_t) 1);
												}
										}
								}
							else
								{	/* Ast/substitute.scm 118 */
									BgL_testz00_3579 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_3579)
							{	/* Ast/substitute.scm 121 */
								obj_t BgL_arg3245z00_1237;

								BgL_varz00_bglt BgL_arg3246z00_1238;

								{
									BgL_nodez00_bglt BgL_auxz00_3595;

									BgL_auxz00_3595 = (BgL_nodez00_bglt) (BgL_nodez00_1228);
									BgL_arg3245z00_1237 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_3595))->BgL_locz00);
								}
								{	/* Ast/substitute.scm 121 */
									BgL_varz00_bglt BgL_duplicated3068z00_1239;

									BgL_duplicated3068z00_1239 =
										(BgL_varz00_bglt) (BgL_nfunz00_1233);
									{	/* Ast/substitute.scm 121 */
										BgL_varz00_bglt BgL_new3069z00_1240;

										{	/* Ast/substitute.scm 121 */
											obj_t BgL_arg3247z00_1241;

											BgL_typez00_bglt BgL_arg3248z00_1242;

											BgL_variablez00_bglt BgL_arg3249z00_1243;

											{
												BgL_nodez00_bglt BgL_auxz00_3599;

												BgL_auxz00_3599 =
													(BgL_nodez00_bglt) (BgL_duplicated3068z00_1239);
												BgL_arg3247z00_1241 =
													(((BgL_nodez00_bglt) CREF(BgL_auxz00_3599))->
													BgL_locz00);
											}
											{
												BgL_nodez00_bglt BgL_auxz00_3602;

												BgL_auxz00_3602 =
													(BgL_nodez00_bglt) (BgL_duplicated3068z00_1239);
												BgL_arg3248z00_1242 =
													(((BgL_nodez00_bglt) CREF(BgL_auxz00_3602))->
													BgL_typez00);
											}
											BgL_arg3249z00_1243 =
												(((BgL_varz00_bglt) CREF(BgL_duplicated3068z00_1239))->
												BgL_variablez00);
											BgL_new3069z00_1240 =
												BGl_makezd2varzd2zzast_nodez00(BgL_arg3247z00_1241,
												BgL_arg3248z00_1242, BgL_arg3249z00_1243);
										}
										{	/* Ast/substitute.scm 121 */

											BgL_arg3246z00_1238 = BgL_new3069z00_1240;
										}
									}
								}
								return
									(obj_t) (BGl_knownzd2appzd2lyzd2ze3nodez31zzast_applyz00(BNIL,
										BgL_arg3245z00_1237,
										(BgL_nodez00_bglt) (BgL_arg3246z00_1238), BgL_nargz00_1234,
										BgL_sitez00_1229));
							}
						else
							{	/* Ast/substitute.scm 118 */
								((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1228))->BgL_funz00) =
									((BgL_nodez00_bglt) BgL_nfunz00_1233), BUNSPEC);
								((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1228))->BgL_argz00) =
									((BgL_nodez00_bglt) BgL_nargz00_1234), BUNSPEC);
								return (obj_t) (BgL_nodez00_1228);
							}
					}
				}
			}
		}
	}



/* do-substitute!-app3118 */
	obj_t BGl_dozd2substitutez12zd2app3118z12zzast_substitutez00(obj_t
		BgL_envz00_2563, obj_t BgL_nodez00_2564, obj_t BgL_sitez00_2565)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 106 */
			{
				BgL_appz00_bglt BgL_nodez00_1217;

				obj_t BgL_sitez00_1218;

				{	/* Ast/substitute.scm 107 */
					BgL_appz00_bglt BgL_auxz00_3614;

					BgL_nodez00_1217 = (BgL_appz00_bglt) (BgL_nodez00_2564);
					BgL_sitez00_1218 = BgL_sitez00_2565;
					{	/* Ast/substitute.scm 107 */
						BgL_nodez00_bglt BgL_arg3237z00_1221;

						{	/* Ast/substitute.scm 107 */
							BgL_varz00_bglt BgL_arg3238z00_1222;

							obj_t BgL_arg3239z00_1223;

							BgL_arg3238z00_1222 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_1217))->BgL_funz00);
							BgL_arg3239z00_1223 = CNST_TABLE_REF(((long) 3));
							{	/* Ast/substitute.scm 107 */
								BgL_nodez00_bglt BgL_res3374z00_1627;

								{	/* Ast/substitute.scm 107 */
									BgL_nodez00_bglt BgL_nodez00_1600;

									BgL_nodez00_1600 = (BgL_nodez00_bglt) (BgL_arg3238z00_1222);
									{	/* Ast/substitute.scm 107 */
										obj_t BgL_method3108z00_1602;

										{	/* Ast/substitute.scm 107 */
											BgL_objectz00_bglt BgL_objz00_1603;

											BgL_objz00_1603 = (BgL_objectz00_bglt) (BgL_nodez00_1600);
											{	/* Ast/substitute.scm 107 */
												long BgL_objzd2classzd2numz00_1604;

												BgL_objzd2classzd2numz00_1604 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1603);
												{	/* Ast/substitute.scm 107 */
													obj_t BgL_arg2334z00_1605;

													BgL_arg2334z00_1605 =
														PROCEDURE_REF
														(BGl_dozd2substitutez12zd2envz12zzast_substitutez00,
														(int) (((long) 1)));
													{	/* Ast/substitute.scm 107 */
														obj_t BgL_arrayz00_1607;

														int BgL_offsetz00_1608;

														BgL_arrayz00_1607 = BgL_arg2334z00_1605;
														BgL_offsetz00_1608 =
															(int) (BgL_objzd2classzd2numz00_1604);
														{	/* Ast/substitute.scm 107 */
															long BgL_offsetz00_1609;

															BgL_offsetz00_1609 =
																((long) (BgL_offsetz00_1608) - OBJECT_TYPE);
															{	/* Ast/substitute.scm 107 */
																long BgL_modz00_1610;

																{	/* Ast/substitute.scm 107 */
																	int BgL_arg2336z00_1611;

																	BgL_arg2336z00_1611 = (int) (((long) 8));
																	{	/* Ast/substitute.scm 107 */
																		long BgL_auxz00_3626;

																		BgL_auxz00_3626 =
																			(long) (BgL_arg2336z00_1611);
																		BgL_modz00_1610 =
																			(BgL_offsetz00_1609 / BgL_auxz00_3626);
																}}
																{	/* Ast/substitute.scm 107 */
																	long BgL_restz00_1612;

																	{	/* Ast/substitute.scm 107 */
																		int BgL_arg2335z00_1613;

																		BgL_arg2335z00_1613 = (int) (((long) 8));
																		{	/* Ast/substitute.scm 107 */
																			long BgL_auxz00_3630;

																			BgL_auxz00_3630 =
																				(long) (BgL_arg2335z00_1613);
																			BgL_restz00_1612 =
																				(BgL_offsetz00_1609 % BgL_auxz00_3630);
																	}}
																	{	/* Ast/substitute.scm 107 */

																		BgL_method3108z00_1602 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1607,
																				(int) (BgL_modz00_1610)),
																			(int) (BgL_restz00_1612));
										}}}}}}}}
										BgL_res3374z00_1627 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3108z00_1602) (BgL_method3108z00_1602,
												(obj_t) (BgL_nodez00_1600), BgL_arg3239z00_1223, BEOA));
								}}
								BgL_arg3237z00_1221 = BgL_res3374z00_1627;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3641;

							BgL_auxz00_3641 = (BgL_varz00_bglt) (BgL_arg3237z00_1221);
							((((BgL_appz00_bglt) CREF(BgL_nodez00_1217))->BgL_funz00) =
								((BgL_varz00_bglt) BgL_auxz00_3641), BUNSPEC);
					}}
					{	/* Ast/substitute.scm 108 */
						obj_t BgL_arg3240z00_1224;

						obj_t BgL_arg3241z00_1225;

						BgL_arg3240z00_1224 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1217))->BgL_argsz00);
						BgL_arg3241z00_1225 = CNST_TABLE_REF(((long) 1));
						BGl_dozd2substituteza2z12z62zzast_substitutez00(BgL_arg3240z00_1224,
							BgL_arg3241z00_1225);
					}
					BgL_auxz00_3614 = BgL_nodez00_1217;
					return (obj_t) (BgL_auxz00_3614);
				}
			}
		}
	}



/* do-substitute!-seque3116 */
	obj_t BGl_dozd2substitutez12zd2seque3116z12zzast_substitutez00(obj_t
		BgL_envz00_2566, obj_t BgL_nodez00_2567, obj_t BgL_sitez00_2568)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 99 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1210;

				obj_t BgL_sitez00_1211;

				{	/* Ast/substitute.scm 100 */
					BgL_sequencez00_bglt BgL_auxz00_3649;

					BgL_nodez00_1210 = (BgL_sequencez00_bglt) (BgL_nodez00_2567);
					BgL_sitez00_1211 = BgL_sitez00_2568;
					{	/* Ast/substitute.scm 100 */
						obj_t BgL_arg3235z00_1597;

						BgL_arg3235z00_1597 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1210))->BgL_nodesz00);
						BGl_dozd2substituteza2z12z62zzast_substitutez00(BgL_arg3235z00_1597,
							BgL_sitez00_1211);
					}
					BgL_auxz00_3649 = BgL_nodez00_1210;
					return (obj_t) (BgL_auxz00_3649);
				}
			}
		}
	}



/* do-substitute!-kwote3114 */
	obj_t BGl_dozd2substitutez12zd2kwote3114z12zzast_substitutez00(obj_t
		BgL_envz00_2569, obj_t BgL_nodez00_2570, obj_t BgL_sitez00_2571)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 93 */
			return (obj_t) ((BgL_kwotez00_bglt) (BgL_nodez00_2570));
		}
	}



/* do-substitute!-var3112 */
	obj_t BGl_dozd2substitutez12zd2var3112z12zzast_substitutez00(obj_t
		BgL_envz00_2572, obj_t BgL_nodez00_2573, obj_t BgL_sitez00_2574)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 63 */
			{
				BgL_varz00_bglt BgL_nodez00_1177;

				obj_t BgL_sitez00_1178;

				BgL_nodez00_1177 = (BgL_varz00_bglt) (BgL_nodez00_2573);
				BgL_sitez00_1178 = BgL_sitez00_2574;
				{	/* Ast/substitute.scm 64 */
					BgL_variablez00_bglt BgL_varz00_1181;

					BgL_varz00_1181 =
						(((BgL_varz00_bglt) CREF(BgL_nodez00_1177))->BgL_variablez00);
					{	/* Ast/substitute.scm 64 */
						obj_t BgL_alphaz00_1182;

						BgL_alphaz00_1182 =
							(((BgL_variablez00_bglt) CREF(BgL_varz00_1181))->
							BgL_fastzd2alphazd2);
						{	/* Ast/substitute.scm 65 */

							{
								obj_t BgL_alphaz00_1183;

								BgL_alphaz00_1183 = BgL_alphaz00_1182;
							BgL_loopz00_1184:
								if ((BgL_alphaz00_1183 == BUNSPEC))
									{	/* Ast/substitute.scm 68 */
										return (obj_t) (BgL_nodez00_1177);
									}
								else
									{	/* Ast/substitute.scm 68 */
										if (BGl_iszd2azf3z21zz__objectz00(BgL_alphaz00_1183,
												BGl_varz00zzast_nodez00))
											{	/* Ast/substitute.scm 71 */
												BgL_variablez00_bglt BgL_arg3217z00_1187;

												{
													BgL_varz00_bglt BgL_auxz00_3663;

													BgL_auxz00_3663 =
														(BgL_varz00_bglt) (BgL_alphaz00_1183);
													BgL_arg3217z00_1187 =
														(((BgL_varz00_bglt) CREF(BgL_auxz00_3663))->
														BgL_variablez00);
												}
												{
													obj_t BgL_alphaz00_3666;

													BgL_alphaz00_3666 = (obj_t) (BgL_arg3217z00_1187);
													BgL_alphaz00_1183 = BgL_alphaz00_3666;
													goto BgL_loopz00_1184;
												}
											}
										else
											{	/* Ast/substitute.scm 70 */
												if (BGl_iszd2azf3z21zz__objectz00(BgL_alphaz00_1183,
														BGl_variablez00zzast_varz00))
													{	/* Ast/substitute.scm 72 */
														{	/* Ast/substitute.scm 73 */
															obj_t BgL_arg3219z00_1189;

															{
																BgL_nodez00_bglt BgL_auxz00_3670;

																BgL_auxz00_3670 =
																	(BgL_nodez00_bglt) (BgL_nodez00_1177);
																BgL_arg3219z00_1189 =
																	(((BgL_nodez00_bglt) CREF(BgL_auxz00_3670))->
																	BgL_locz00);
															}
															BGl_usezd2variablez12zc0zzast_sexpz00(
																(BgL_variablez00_bglt) (BgL_alphaz00_1183),
																BgL_arg3219z00_1189, BgL_sitez00_1178);
														}
														{	/* Ast/substitute.scm 74 */
															bool_t BgL_testz00_3675;

															{	/* Ast/substitute.scm 74 */
																bool_t BgL_testz00_3676;

																{	/* Ast/substitute.scm 74 */
																	BgL_valuez00_bglt BgL_arg3227z00_1197;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3677;

																		BgL_auxz00_3677 =
																			(BgL_variablez00_bglt)
																			(BgL_alphaz00_1183);
																		BgL_arg3227z00_1197 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3677))->BgL_valuez00);
																	}
																	{	/* Ast/substitute.scm 74 */
																		obj_t BgL_obj1673z00_1591;

																		BgL_obj1673z00_1591 =
																			(obj_t) (BgL_arg3227z00_1197);
																		BgL_testz00_3676 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj1673z00_1591,
																			BGl_funz00zzast_varz00);
																	}
																}
																if (BgL_testz00_3676)
																	{	/* Ast/substitute.scm 74 */
																		if (
																			(BgL_sitez00_1178 ==
																				CNST_TABLE_REF(((long) 3))))
																			{	/* Ast/substitute.scm 74 */
																				BgL_testz00_3675 = ((bool_t) 0);
																			}
																		else
																			{	/* Ast/substitute.scm 74 */
																				BgL_testz00_3675 = ((bool_t) 1);
																			}
																	}
																else
																	{	/* Ast/substitute.scm 74 */
																		BgL_testz00_3675 = ((bool_t) 0);
																	}
															}
															if (BgL_testz00_3675)
																{	/* Ast/substitute.scm 76 */
																	obj_t BgL_arg3221z00_1191;

																	BgL_typez00_bglt BgL_arg3222z00_1192;

																	{
																		BgL_nodez00_bglt BgL_auxz00_3685;

																		BgL_auxz00_3685 =
																			(BgL_nodez00_bglt) (BgL_nodez00_1177);
																		BgL_arg3221z00_1191 =
																			(((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_3685))->BgL_locz00);
																	}
																	{
																		BgL_nodez00_bglt BgL_auxz00_3688;

																		BgL_auxz00_3688 =
																			(BgL_nodez00_bglt) (BgL_nodez00_1177);
																		BgL_arg3222z00_1192 =
																			(((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_3688))->BgL_typez00);
																	}
																	return
																		(obj_t) (BGl_makezd2closurezd2zzast_nodez00
																		(BgL_arg3221z00_1191, BgL_arg3222z00_1192,
																			(BgL_variablez00_bglt)
																			(BgL_alphaz00_1183)));
																}
															else
																{	/* Ast/substitute.scm 80 */
																	obj_t BgL_arg3223z00_1193;

																	BgL_typez00_bglt BgL_arg3224z00_1194;

																	{
																		BgL_nodez00_bglt BgL_auxz00_3694;

																		BgL_auxz00_3694 =
																			(BgL_nodez00_bglt) (BgL_nodez00_1177);
																		BgL_arg3223z00_1193 =
																			(((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_3694))->BgL_locz00);
																	}
																	{
																		BgL_nodez00_bglt BgL_auxz00_3697;

																		BgL_auxz00_3697 =
																			(BgL_nodez00_bglt) (BgL_nodez00_1177);
																		BgL_arg3224z00_1194 =
																			(((BgL_nodez00_bglt)
																				CREF(BgL_auxz00_3697))->BgL_typez00);
																	}
																	return
																		(obj_t) (BGl_makezd2varzd2zzast_nodez00
																		(BgL_arg3223z00_1193, BgL_arg3224z00_1194,
																			(BgL_variablez00_bglt)
																			(BgL_alphaz00_1183)));
																}
														}
													}
												else
													{	/* Ast/substitute.scm 72 */
														if (BGl_iszd2azf3z21zz__objectz00(BgL_alphaz00_1183,
																BGl_atomz00zzast_nodez00))
															{	/* Ast/substitute.scm 83 */
																return BgL_alphaz00_1183;
															}
														else
															{	/* Ast/substitute.scm 83 */
																return
																	BGl_internalzd2errorzd2zztools_errorz00
																	(BGl_string3476z00zzast_substitutez00,
																	BGl_string3477z00zzast_substitutez00,
																	BGl_shapez00zztools_shapez00((obj_t)
																		(BgL_nodez00_1177)));
															}
													}
											}
									}
							}
						}
					}
				}
			}
		}
	}



/* do-substitute!-atom3110 */
	obj_t BGl_dozd2substitutez12zd2atom3110z12zzast_substitutez00(obj_t
		BgL_envz00_2575, obj_t BgL_nodez00_2576, obj_t BgL_sitez00_2577)
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 57 */
			return (obj_t) ((BgL_atomz00_bglt) (BgL_nodez00_2576));
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_substitutez00()
	{
		AN_OBJECT;
		{	/* Ast/substitute.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 121557513),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 271227279),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
			return
				BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 77938009),
				BSTRING_TO_STRING(BGl_string3478z00zzast_substitutez00));
		}
	}

#ifdef __cplusplus
}
#endif
