/*===========================================================================*/
/*   (Cfa/specialize.scm)                                                    */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/specialize.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_specializa7edzd2globalz75_bgl
	{
		obj_t BgL_fixz00;
	}                                *BgL_specializa7edzd2globalz75_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	static bool_t BGl_patchzd2treez12zc0zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_patchz12zd2kwote3377zc0zzcfa_specializa7eza7(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_patchz12zd2select3400zc0zzcfa_specializa7eza7(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_objectzd2ze3structz31zz__objectz00(BgL_objectz00_bglt);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(BgL_globalz00_bglt);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	static obj_t BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
	static obj_t BGl_patchza2z12zb0zzcfa_specializa7eza7(obj_t);
	static obj_t BGl__specializa7ez12zb5zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7 =
		BUNSPEC;
	extern obj_t BGl_za2libzd2modeza2zd2zzengine_paramz00;
	static obj_t BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7 = BUNSPEC;
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static BgL_appz00_bglt
		BGl_specializa7ezd2appz12z67zzcfa_specializa7eza7(BgL_appz00_bglt);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcfa_specializa7eza7();
	static obj_t BGl_patchz12zd2boxzd2ref3414z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern BgL_valuez00_bglt BGl_valuezd2nilzd2zzast_varz00();
	extern obj_t BGl_za2bintza2z00zztype_cachez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl__specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static BgL_specializa7edzd2globalz75_bglt
		BGl_specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7();
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcfa_specializa7eza7(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_patchzd2funz12zc0zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_toplevelzd2initzd2zzcfa_specializa7eza7();
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_patchz12zd2atom3375zc0zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_patchz12zd2jumpzd2exzd2it3408zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	static bool_t BGl_specializa7ezd2optimiza7ationzf3z21zzcfa_specializa7eza7();
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 =
		BUNSPEC;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t
		BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_patchz12zd2app3416zc0zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(BgL_globalz00_bglt);
	static obj_t BGl_patchz12zd2letzd2fun3402z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl__arithmeticzd2speczd2typ3840z00zzcfa_specializa7eza7(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
	static obj_t BGl_patchz12zd2closure3381zc0zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_patchz12zd2setzd2exzd2it3406zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_za2realza2z00zztype_cachez00;
	static obj_t BGl_patchz12zd2letzd2var3404z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_za2specializa7eza2za7zzcfa_specializa7eza7 = BUNSPEC;
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static obj_t BGl__patchz12z12zzcfa_specializa7eza7(obj_t, obj_t);
	static BgL_appz00_bglt
		BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7(BgL_appz00_bglt);
	static obj_t BGl_methodzd2initzd2zzcfa_specializa7eza7();
	extern obj_t BGl_setqz00zzast_nodez00;
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7 = BUNSPEC;
	static obj_t BGl_genericzd2initzd2zzcfa_specializa7eza7();
	static obj_t BGl_patchz12zd2cast3392zc0zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7
		= BUNSPEC;
	static obj_t BGl_specializa7edzd2globalz75zzcfa_specializa7eza7 = BUNSPEC;
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_typez00_bglt BGl_typeofz00zztype_typeofz00(BgL_nodez00_bglt);
	static obj_t BGl_patchz12zd2sequence3383zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl__arithmeticzd2operator3839zd2zzcfa_specializa7eza7(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_installzd2specializa7ez12z67zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_patchz12zd2var3379zc0zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_typezd2nilzd2zztype_typez00();
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_patchz12zd2boxzd2setz123412z00zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_patchz12z12zzcfa_specializa7eza7(BgL_nodez00_bglt);
	static obj_t BGl_addzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_specializa7eza7();
	BGL_IMPORT obj_t make_struct(obj_t, int, obj_t);
	static obj_t BGl_patchz12zd2setq3394zc0zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_objectzd2ze3structzd2speci3418ze3zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_patchz12zd2extern3390zc0zzcfa_specializa7eza7(obj_t, obj_t);
	extern obj_t BGl_za2brealza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	static obj_t BGl__patchz12zd2default3372zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl__specializa7edzd2globalzf3z86zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_patchz12zd2appzd2ly3385z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	BGL_IMPORT BgL_objectz00_bglt
		BGl_structzb2objectzd2ze3objectz83zz__objectz00(BgL_objectz00_bglt, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_za2bcharza2z00zztype_cachez00;
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_patchz12zd2conditional3396zc0zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t
		BGl_patchz12zd2default3372zc0zzcfa_specializa7eza7(BgL_nodez00_bglt);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	static obj_t BGl_normaliza7ezd2typeofz75zzcfa_specializa7eza7(obj_t);
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t
		BGl_addzd2specializa7edzd2eqzd2typez12z67zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_uninstallzd2specializa7esz12z67zzcfa_specializa7eza7();
	static bool_t BGl_showzd2specializa7ez75zzcfa_specializa7eza7();
	static obj_t BGl_patchz12zd2fail3398zc0zzcfa_specializa7eza7(obj_t, obj_t);
	static obj_t
		BGl__z52allocatezd2specializa7edzd2globalzf5zzcfa_specializa7eza7(obj_t);
	static obj_t BGl_patchz12zd2makezd2box3410z12zzcfa_specializa7eza7(obj_t,
		obj_t);
	static obj_t BGl_objectzd2initzd2zzcfa_specializa7eza7();
	static obj_t BGl_patchz12zd2funcall3387zc0zzcfa_specializa7eza7(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_specializa7ez12zb5zzcfa_specializa7eza7(obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_specializa7eza7();
	static obj_t BGl_structzb2objectzd2ze3objec3421z83zzcfa_specializa7eza7(obj_t,
		obj_t, obj_t);
	static obj_t BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
	static obj_t __cnst[10];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_z52allocatezd2specializa7edzd2globalzd2envz27zzcfa_specializa7eza7,
		BgL_bgl__za752allocateza7d2s3890z00,
		BGl__z52allocatezd2specializa7edzd2globalzf5zzcfa_specializa7eza7, 0L,
		BUNSPEC, 0);
	      DEFINE_STRING(BGl_string3844z00zzcfa_specializa7eza7,
		BgL_bgl_string3844za700za7za7c3891za7, "arithmetic-spec-types", 21);
	      DEFINE_STRING(BGl_string3845z00zzcfa_specializa7eza7,
		BgL_bgl_string3845za700za7za7c3892za7, "Null specification for", 22);
	      DEFINE_STRING(BGl_string3846z00zzcfa_specializa7eza7,
		BgL_bgl_string3846za700za7za7c3893za7, "   . specializing", 17);
	      DEFINE_STRING(BGl_string3847z00zzcfa_specializa7eza7,
		BgL_bgl_string3847za700za7za7c3894za7, ")\n", 2);
	      DEFINE_STRING(BGl_string3848z00zzcfa_specializa7eza7,
		BgL_bgl_string3848za700za7za7c3895za7, ": ", 2);
	      DEFINE_STRING(BGl_string3850z00zzcfa_specializa7eza7,
		BgL_bgl_string3850za700za7za7c3896za7, "        (eq? ", 13);
	      DEFINE_STRING(BGl_string3849z00zzcfa_specializa7eza7,
		BgL_bgl_string3849za700za7za7c3897za7, "        (-> ", 12);
	      DEFINE_STRING(BGl_string3851z00zzcfa_specializa7eza7,
		BgL_bgl_string3851za700za7za7c3898za7, "add-specialized-type!", 21);
	      DEFINE_STRING(BGl_string3852z00zzcfa_specializa7eza7,
		BgL_bgl_string3852za700za7za7c3899za7, "Unspecialized type", 18);
	      DEFINE_STRING(BGl_string3853z00zzcfa_specializa7eza7,
		BgL_bgl_string3853za700za7za7c3900za7, "install-specialize", 18);
	      DEFINE_STRING(BGl_string3854z00zzcfa_specializa7eza7,
		BgL_bgl_string3854za700za7za7c3901za7, "Illegal argument", 16);
	      DEFINE_STRING(BGl_string3855z00zzcfa_specializa7eza7,
		BgL_bgl_string3855za700za7za7c3902za7, " -- ", 4);
	      DEFINE_STRING(BGl_string3856z00zzcfa_specializa7eza7,
		BgL_bgl_string3856za700za7za7c3903za7, "Can't find global", 17);
	      DEFINE_STRING(BGl_string3857z00zzcfa_specializa7eza7,
		BgL_bgl_string3857za700za7za7c3904za7, "install-specialize!", 19);
	      DEFINE_STRING(BGl_string3858z00zzcfa_specializa7eza7,
		BgL_bgl_string3858za700za7za7c3905za7, "", 0);
	      DEFINE_STRING(BGl_string3859z00zzcfa_specializa7eza7,
		BgL_bgl_string3859za700za7za7c3906za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3883z00zzcfa_specializa7eza7,
		BgL_bgl_string3883za700za7za7c3907za7, "patch!", 6);
	      DEFINE_STRING(BGl_string3884z00zzcfa_specializa7eza7,
		BgL_bgl_string3884za700za7za7c3908za7, "Unexpected closure", 18);
	      DEFINE_STRING(BGl_string3885z00zzcfa_specializa7eza7,
		BgL_bgl_string3885za700za7za7c3909za7, "cfa_specialize", 14);
	      DEFINE_STRING(BGl_string3886z00zzcfa_specializa7eza7,
		BgL_bgl_string3886za700za7za7c3910za7,
		"patch!-default3372 _ specialized-global done c-eq? c-boxed-eq? foreign __r4_numbers_6_5_flonum __r4_numbers_6_5_fixnum ((c-eq? (c-eq? foreign) (=fx __r4_numbers_6_5_fixnum) (=fl __r4_numbers_6_5_flonum)) (2= (2= __r4_numbers_6_5) (=fx __r4_numbers_6_5_fixnum) (=fl __r4_numbers_6_5_flonum)) (2< (2< __r4_numbers_6_5) (<fx __r4_numbers_6_5_fixnum) (<fl __r4_numbers_6_5_flonum)) (2> (2> __r4_numbers_6_5) (>fx __r4_numbers_6_5_fixnum) (>fl __r4_numbers_6_5_flonum)) (2<= (2<= __r4_numbers_6_5) (<=fx __r4_numbers_6_5_fixnum) (<=fl __r4_numbers_6_5_flonum)) (2>= (2>= __r4_numbers_6_5) (>=fx __r4_numbers_6_5_fixnum) (>=fl __r4_numbers_6_5_flonum)) (zero? (zero? __r4_numbers_6_5) (zerofx? __r4_numbers_6_5_fixnum) (zerofl? __r4_numbers_6_5_flonum)) (positive? (positive? __r4_numbers_6_5) (positivefx? __r4_numbers_6_5_fixnum) (positivefl? __r4_numbers_6_5_flonum)) (negative? (negative? __r4_numbers_6_5) (negativefx? __r4_numbers_6_5_fixnum) (negativefl? __r4_numbers_6_5_flonum)) (2+ (2+ __r4_numbers_6_5) (+fx __r4_number"
		"s_6_5_fixnum) (+fl __r4_numbers_6_5_flonum)) (2- (2- __r4_numbers_6_5) (-fx __r4_numbers_6_5_fixnum) (-fl __r4_numbers_6_5_flonum)) (2* (2* __r4_numbers_6_5) (*fx __r4_numbers_6_5_fixnum) (*fl __r4_numbers_6_5_flonum)) (2/ (2/ __r4_numbers_6_5) (/fl __r4_numbers_6_5_flonum)) (abs (abs __r4_numbers_6_5) (absfx __r4_numbers_6_5_fixnum) (absfl __r4_numbers_6_5_flonum)) (log (log __r4_numbers_6_5) (logfl __r4_numbers_6_5_flonum)) (exp (exp __r4_numbers_6_5) (expfl __r4_numbers_6_5_flonum)) (sin (sin __r4_numbers_6_5) (sinfl __r4_numbers_6_5_flonum)) (cos (cos __r4_numbers_6_5) (cosfl __r4_numbers_6_5_flonum)) (tan (tan __r4_numbers_6_5) (tanfl __r4_numbers_6_5_flonum)) (atan (atan __r4_numbers_6_5) (atanfl __r4_numbers_6_5_flonum)) (asin (asin __r4_numbers_6_5) (asinfl __r4_numbers_6_5_flonum)) (acos (acos __r4_numbers_6_5) (acosfl __r4_numbers_6_5_flonum)) (sqrt (sqrt __r4_numbers_6_5) (sqrtfl __r4_numbers_6_5_flonum))) ",
		1955);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_arithmeticzd2operatorzf3zd2envzf3zzcfa_specializa7eza7,
		BgL_bgl__arithmeticza7d2op3911za7,
		BGl__arithmeticzd2operator3839zd2zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_patchz12zd2default3372zd2envz12zzcfa_specializa7eza7,
		BgL_bgl__patchza712za7d2defa3912z00,
		BGl__patchz12zd2default3372zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_specializa7edzd2globalzd2nilzd2envz75zzcfa_specializa7eza7,
		BgL_bgl__specializa7a7edza7d3913z00,
		BGl__specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7, 0L, BUNSPEC, 0);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_specializa7edzd2globalzf3zd2envz54zzcfa_specializa7eza7,
		BgL_bgl__specializa7a7edza7d3914z00,
		BGl__specializa7edzd2globalzf3z86zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_arithmeticzd2speczd2typeszd2envzd2zzcfa_specializa7eza7,
		BgL_bgl__arithmeticza7d2sp3915za7,
		BGl__arithmeticzd2speczd2typ3840z00zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	BGL_IMPORT obj_t BGl_objectzd2ze3structzd2envze3zz__objectz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_specializa7ez12zd2envz67zzcfa_specializa7eza7,
		BgL_bgl__specializa7a7eza7123916z00,
		BGl__specializa7ez12zb5zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
		BgL_bgl__patchza712za712za7za7cf3917z00,
		BGl__patchz12z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	BGL_IMPORT obj_t BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3860z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2atom33918z00,
		BGl_patchz12zd2atom3375zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3861z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2kwote3919z00,
		BGl_patchz12zd2kwote3377zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3862z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2var333920z00,
		BGl_patchz12zd2var3379zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3863z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2closu3921z00,
		BGl_patchz12zd2closure3381zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3864z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2seque3922z00,
		BGl_patchz12zd2sequence3383zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3865z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2appza7d3923za7,
		BGl_patchz12zd2appzd2ly3385z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3866z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2funca3924z00,
		BGl_patchz12zd2funcall3387zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3867z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2exter3925z00,
		BGl_patchz12zd2extern3390zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3868z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2cast33926z00,
		BGl_patchz12zd2cast3392zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3870z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2condi3927z00,
		BGl_patchz12zd2conditional3396zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3869z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2setq33928z00,
		BGl_patchz12zd2setq3394zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3871z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2fail33929z00,
		BGl_patchz12zd2fail3398zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3872z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2selec3930z00,
		BGl_patchz12zd2select3400zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3873z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2letza7d3931za7,
		BGl_patchz12zd2letzd2fun3402z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3874z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2letza7d3932za7,
		BGl_patchz12zd2letzd2var3404z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3875z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2setza7d3933za7,
		BGl_patchz12zd2setzd2exzd2it3406zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3876z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2jumpza73934za7,
		BGl_patchz12zd2jumpzd2exzd2it3408zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3877z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2makeza73935za7,
		BGl_patchz12zd2makezd2box3410z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3878z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2boxza7d3936za7,
		BGl_patchz12zd2boxzd2setz123412z00zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3880z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2app343937z00,
		BGl_patchz12zd2app3416zc0zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3879z00zzcfa_specializa7eza7,
		BgL_bgl_patchza712za7d2boxza7d3938za7,
		BGl_patchz12zd2boxzd2ref3414z12zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3881z00zzcfa_specializa7eza7,
		BgL_bgl_objectza7d2za7e3stru3939z00,
		BGl_objectzd2ze3structzd2speci3418ze3zzcfa_specializa7eza7, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3882z00zzcfa_specializa7eza7,
		BgL_bgl_structza7b2objectza73940z00,
		BGl_structzb2objectzd2ze3objec3421z83zzcfa_specializa7eza7, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcfa_specializa7eza7(long
		BgL_checksumz00_2978, char *BgL_fromz00_2979)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7))
				{
					BGl_requirezd2initializa7ationz75zzcfa_specializa7eza7 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcfa_specializa7eza7();
					BGl_cnstzd2initzd2zzcfa_specializa7eza7();
					BGl_importedzd2moduleszd2initz00zzcfa_specializa7eza7();
					BGl_objectzd2initzd2zzcfa_specializa7eza7();
					BGl_genericzd2initzd2zzcfa_specializa7eza7();
					BGl_methodzd2initzd2zzcfa_specializa7eza7();
					BGl_toplevelzd2initzd2zzcfa_specializa7eza7();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"cfa_specialize");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_specialize");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			{	/* Cfa/specialize.scm 19 */
				obj_t BgL_cportz00_2961;

				BgL_cportz00_2961 =
					bgl_open_input_string(BGl_string3886z00zzcfa_specializa7eza7,
					(int) (((long) 0)));
				{
					long BgL_iz00_2962;

					BgL_iz00_2962 = ((long) 9);
				BgL_loopz00_2963:
					if ((BgL_iz00_2962 == ((long) -1)))
						{	/* Cfa/specialize.scm 19 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/specialize.scm 19 */
							{	/* Cfa/specialize.scm 19 */
								obj_t BgL_arg3888z00_2965;

								{	/* Cfa/specialize.scm 19 */

									{	/* Cfa/specialize.scm 19 */
										obj_t BgL_locationz00_2967;

										BgL_locationz00_2967 = BBOOL(((bool_t) 0));
										{	/* Cfa/specialize.scm 19 */

											BgL_arg3888z00_2965 =
												BGl_readz00zz__readerz00(BgL_cportz00_2961,
												BgL_locationz00_2967);
										}
									}
								}
								{	/* Cfa/specialize.scm 19 */
									int BgL_auxz00_3000;

									BgL_auxz00_3000 = (int) (BgL_iz00_2962);
									CNST_TABLE_SET(BgL_auxz00_3000, BgL_arg3888z00_2965);
							}}
							{	/* Cfa/specialize.scm 19 */
								int BgL_auxz00_2968;

								BgL_auxz00_2968 = (int) ((BgL_iz00_2962 - ((long) 1)));
								{
									long BgL_iz00_3005;

									BgL_iz00_3005 = (long) (BgL_auxz00_2968);
									BgL_iz00_2962 = BgL_iz00_3005;
									goto BgL_loopz00_2963;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7 =
				CNST_TABLE_REF(((long) 0));
			BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
			BGl_za2specializa7eza2za7zzcfa_specializa7eza7 = BNIL;
			BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 = BNIL;
			BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7 = BNIL;
			BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7 = BUNSPEC;
			return BUNSPEC;
		}
	}



/* specialize! */
	BGL_EXPORTED_DEF obj_t BGl_specializa7ez12zb5zzcfa_specializa7eza7(obj_t
		BgL_globalsz00_1)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 43 */
			if (BGl_specializa7ezd2optimiza7ationzf3z21zzcfa_specializa7eza7())
				{	/* Cfa/specialize.scm 45 */
					{
						obj_t BgL_l3348z00_874;

						BgL_l3348z00_874 =
							BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7;
					BgL_forzd2each3351zd2_875:
						if (PAIRP(BgL_l3348z00_874))
							{	/* Cfa/specialize.scm 47 */
								{	/* Cfa/specialize.scm 48 */
									obj_t BgL_specz00_877;

									BgL_specz00_877 = CAR(BgL_l3348z00_874);
									{	/* Cfa/specialize.scm 48 */
										obj_t BgL_runner3425z00_879;

										BgL_runner3425z00_879 = CDR(BgL_specz00_877);
										{	/* Cfa/specialize.scm 48 */
											obj_t BgL_aux3424z00_878;

											BgL_aux3424z00_878 = CAR(BgL_runner3425z00_879);
											BgL_runner3425z00_879 = CDR(BgL_runner3425z00_879);
											BGl_installzd2specializa7ez12z67zzcfa_specializa7eza7
												(BgL_aux3424z00_878, BgL_runner3425z00_879);
										}
									}
								}
								{
									obj_t BgL_l3348z00_3017;

									BgL_l3348z00_3017 = CDR(BgL_l3348z00_874);
									BgL_l3348z00_874 = BgL_l3348z00_3017;
									goto BgL_forzd2each3351zd2_875;
								}
							}
						else
							{	/* Cfa/specialize.scm 47 */
								((bool_t) 1);
							}
					}
					BGl_patchzd2treez12zc0zzcfa_specializa7eza7(BgL_globalsz00_1);
					BGl_showzd2specializa7ez75zzcfa_specializa7eza7();
					BGl_uninstallzd2specializa7esz12z67zzcfa_specializa7eza7();
				}
			else
				{	/* Cfa/specialize.scm 45 */
					BFALSE;
				}
			return BgL_globalsz00_1;
		}
	}



/* _specialize! */
	obj_t BGl__specializa7ez12zb5zzcfa_specializa7eza7(obj_t BgL_envz00_2872,
		obj_t BgL_globalsz00_2873)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 43 */
			return BGl_specializa7ez12zb5zzcfa_specializa7eza7(BgL_globalsz00_2873);
		}
	}



/* arithmetic-operator? */
	BGL_EXPORTED_DEF obj_t
		BGl_arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(BgL_globalz00_bglt
		BgL_globalz00_2)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 58 */
			{	/* Cfa/specialize.scm 60 */
				obj_t BgL_cellz00_882;

				{	/* Cfa/specialize.scm 60 */
					obj_t BgL_arg3430z00_887;

					{
						BgL_variablez00_bglt BgL_auxz00_3023;

						BgL_auxz00_3023 = (BgL_variablez00_bglt) (BgL_globalz00_2);
						BgL_arg3430z00_887 =
							(((BgL_variablez00_bglt) CREF(BgL_auxz00_3023))->BgL_idz00);
					}
					BgL_cellz00_882 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg3430z00_887,
						BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7);
				}
				if (PAIRP(BgL_cellz00_882))
					{	/* Cfa/specialize.scm 62 */
						bool_t BgL_auxz00_3029;

						{	/* Cfa/specialize.scm 62 */
							obj_t BgL_auxz00_3030;

							{	/* Cfa/specialize.scm 62 */
								obj_t BgL_pairz00_1755;

								{	/* Cfa/specialize.scm 62 */
									obj_t BgL_pairz00_1751;

									BgL_pairz00_1751 = BgL_cellz00_882;
									BgL_pairz00_1755 = CAR(CDR(BgL_pairz00_1751));
								}
								BgL_auxz00_3030 = CAR(CDR(BgL_pairz00_1755));
							}
							BgL_auxz00_3029 =
								(BgL_auxz00_3030 ==
								(((BgL_globalz00_bglt) CREF(BgL_globalz00_2))->BgL_modulez00));
						}
						return BBOOL(BgL_auxz00_3029);
					}
				else
					{	/* Cfa/specialize.scm 61 */
						return BFALSE;
					}
			}
		}
	}



/* _arithmetic-operator3839 */
	obj_t BGl__arithmeticzd2operator3839zd2zzcfa_specializa7eza7(obj_t
		BgL_envz00_2874, obj_t BgL_globalz00_2875)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 58 */
			return
				BGl_arithmeticzd2operatorzf3z21zzcfa_specializa7eza7(
				(BgL_globalz00_bglt) (BgL_globalz00_2875));
		}
	}



/* arithmetic-spec-types */
	BGL_EXPORTED_DEF obj_t
		BGl_arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(BgL_globalz00_bglt
		BgL_globalz00_3)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 71 */
			{	/* Cfa/specialize.scm 73 */
				obj_t BgL_cellz00_889;

				{	/* Cfa/specialize.scm 73 */
					obj_t BgL_arg3450z00_914;

					{
						BgL_variablez00_bglt BgL_auxz00_3040;

						BgL_auxz00_3040 = (BgL_variablez00_bglt) (BgL_globalz00_3);
						BgL_arg3450z00_914 =
							(((BgL_variablez00_bglt) CREF(BgL_auxz00_3040))->BgL_idz00);
					}
					BgL_cellz00_889 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg3450z00_914,
						BGl_za2specializa7ationsza2za7zzcfa_specializa7eza7);
				}
				if (PAIRP(BgL_cellz00_889))
					{	/* Cfa/specialize.scm 76 */
						obj_t BgL_g3303z00_891;

						{	/* Cfa/specialize.scm 76 */
							obj_t BgL_pairz00_1762;

							BgL_pairz00_1762 = BgL_cellz00_889;
							BgL_g3303z00_891 = CDR(CDR(BgL_pairz00_1762));
						}
						{
							obj_t BgL_specz00_893;

							obj_t BgL_typesz00_894;

							BgL_specz00_893 = BgL_g3303z00_891;
							BgL_typesz00_894 = BNIL;
						BgL_loopz00_895:
							if (NULLP(BgL_specz00_893))
								{	/* Cfa/specialize.scm 79 */
									if (NULLP(BgL_typesz00_894))
										{	/* Cfa/specialize.scm 80 */
											return
												BGl_internalzd2errorzd2zztools_errorz00
												(BGl_string3844z00zzcfa_specializa7eza7,
												BGl_string3845z00zzcfa_specializa7eza7,
												BGl_shapez00zztools_shapez00((obj_t)
													(BgL_globalz00_3)));
										}
									else
										{	/* Cfa/specialize.scm 80 */
											return BgL_typesz00_894;
										}
								}
							else
								{	/* Cfa/specialize.scm 85 */
									bool_t BgL_testz00_3055;

									{	/* Cfa/specialize.scm 85 */
										obj_t BgL_auxz00_3056;

										{	/* Cfa/specialize.scm 85 */
											obj_t BgL_pairz00_1769;

											BgL_pairz00_1769 = CAR(BgL_specz00_893);
											BgL_auxz00_3056 = CAR(CDR(BgL_pairz00_1769));
										}
										BgL_testz00_3055 =
											(BgL_auxz00_3056 == CNST_TABLE_REF(((long) 1)));
									}
									if (BgL_testz00_3055)
										{	/* Cfa/specialize.scm 86 */
											obj_t BgL_arg3438z00_902;

											obj_t BgL_arg3439z00_903;

											BgL_arg3438z00_902 = CDR(BgL_specz00_893);
											BgL_arg3439z00_903 =
												MAKE_PAIR(BGl_za2longza2z00zztype_cachez00,
												BgL_typesz00_894);
											{
												obj_t BgL_typesz00_3065;

												obj_t BgL_specz00_3064;

												BgL_specz00_3064 = BgL_arg3438z00_902;
												BgL_typesz00_3065 = BgL_arg3439z00_903;
												BgL_typesz00_894 = BgL_typesz00_3065;
												BgL_specz00_893 = BgL_specz00_3064;
												goto BgL_loopz00_895;
											}
										}
									else
										{	/* Cfa/specialize.scm 87 */
											bool_t BgL_testz00_3066;

											{	/* Cfa/specialize.scm 87 */
												obj_t BgL_auxz00_3067;

												{	/* Cfa/specialize.scm 87 */
													obj_t BgL_pairz00_1775;

													BgL_pairz00_1775 = CAR(BgL_specz00_893);
													BgL_auxz00_3067 = CAR(CDR(BgL_pairz00_1775));
												}
												BgL_testz00_3066 =
													(BgL_auxz00_3067 == CNST_TABLE_REF(((long) 2)));
											}
											if (BgL_testz00_3066)
												{	/* Cfa/specialize.scm 88 */
													obj_t BgL_arg3441z00_905;

													obj_t BgL_arg3442z00_906;

													BgL_arg3441z00_905 = CDR(BgL_specz00_893);
													BgL_arg3442z00_906 =
														MAKE_PAIR(BGl_za2realza2z00zztype_cachez00,
														BgL_typesz00_894);
													{
														obj_t BgL_typesz00_3076;

														obj_t BgL_specz00_3075;

														BgL_specz00_3075 = BgL_arg3441z00_905;
														BgL_typesz00_3076 = BgL_arg3442z00_906;
														BgL_typesz00_894 = BgL_typesz00_3076;
														BgL_specz00_893 = BgL_specz00_3075;
														goto BgL_loopz00_895;
													}
												}
											else
												{
													obj_t BgL_specz00_3077;

													BgL_specz00_3077 = CDR(BgL_specz00_893);
													BgL_specz00_893 = BgL_specz00_3077;
													goto BgL_loopz00_895;
												}
										}
								}
						}
					}
				else
					{	/* Cfa/specialize.scm 74 */
						return BNIL;
					}
			}
		}
	}



/* _arithmetic-spec-typ3840 */
	obj_t BGl__arithmeticzd2speczd2typ3840z00zzcfa_specializa7eza7(obj_t
		BgL_envz00_2876, obj_t BgL_globalz00_2877)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 71 */
			return
				BGl_arithmeticzd2speczd2typesz00zzcfa_specializa7eza7(
				(BgL_globalz00_bglt) (BgL_globalz00_2877));
		}
	}



/* specialize-optimization? */
	bool_t BGl_specializa7ezd2optimiza7ationzf3z21zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 161 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 1)))
				{	/* Cfa/specialize.scm 162 */
					if (CBOOL(BGl_za2libzd2modeza2zd2zzengine_paramz00))
						{	/* Cfa/specialize.scm 162 */
							return ((bool_t) 0);
						}
					else
						{	/* Cfa/specialize.scm 162 */
							return ((bool_t) 1);
						}
				}
			else
				{	/* Cfa/specialize.scm 162 */
					return ((bool_t) 0);
				}
		}
	}



/* show-specialize */
	bool_t BGl_showzd2specializa7ez75zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 167 */
			{	/* Cfa/specialize.scm 168 */
				obj_t BgL_list3451z00_916;

				{	/* Cfa/specialize.scm 168 */
					obj_t BgL_arg3453z00_918;

					BgL_arg3453z00_918 = MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
					BgL_list3451z00_916 =
						MAKE_PAIR(BGl_string3846z00zzcfa_specializa7eza7,
						BgL_arg3453z00_918);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list3451z00_916);
			}
			{
				obj_t BgL_l3352z00_919;

				BgL_l3352z00_919 =
					BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7;
			BgL_forzd2each3354zd2_920:
				if (PAIRP(BgL_l3352z00_919))
					{	/* Cfa/specialize.scm 169 */
						{	/* Cfa/specialize.scm 170 */
							obj_t BgL_typeze2numze2_922;

							BgL_typeze2numze2_922 = CAR(BgL_l3352z00_919);
							{	/* Cfa/specialize.scm 170 */
								bool_t BgL_testz00_3094;

								{	/* Cfa/specialize.scm 170 */
									long BgL_auxz00_3095;

									{	/* Cfa/specialize.scm 170 */
										obj_t BgL_pairz00_1785;

										BgL_pairz00_1785 = BgL_typeze2numze2_922;
										BgL_auxz00_3095 = (long) CINT(CDR(BgL_pairz00_1785));
									}
									BgL_testz00_3094 = (BgL_auxz00_3095 > ((long) 0));
								}
								if (BgL_testz00_3094)
									{	/* Cfa/specialize.scm 171 */
										obj_t BgL_arg3458z00_926;

										obj_t BgL_arg3460z00_928;

										BgL_arg3458z00_926 =
											BGl_shapez00zztools_shapez00(CAR(BgL_typeze2numze2_922));
										BgL_arg3460z00_928 = CDR(BgL_typeze2numze2_922);
										{	/* Cfa/specialize.scm 171 */
											obj_t BgL_list3462z00_930;

											{	/* Cfa/specialize.scm 171 */
												obj_t BgL_arg3463z00_931;

												{	/* Cfa/specialize.scm 171 */
													obj_t BgL_arg3464z00_932;

													{	/* Cfa/specialize.scm 171 */
														obj_t BgL_arg3465z00_933;

														{	/* Cfa/specialize.scm 171 */
															obj_t BgL_arg3466z00_934;

															BgL_arg3466z00_934 =
																MAKE_PAIR
																(BGl_string3847z00zzcfa_specializa7eza7, BNIL);
															BgL_arg3465z00_933 =
																MAKE_PAIR(BgL_arg3460z00_928,
																BgL_arg3466z00_934);
														}
														BgL_arg3464z00_932 =
															MAKE_PAIR(BGl_string3848z00zzcfa_specializa7eza7,
															BgL_arg3465z00_933);
													}
													BgL_arg3463z00_931 =
														MAKE_PAIR(BgL_arg3458z00_926, BgL_arg3464z00_932);
												}
												BgL_list3462z00_930 =
													MAKE_PAIR(BGl_string3849z00zzcfa_specializa7eza7,
													BgL_arg3463z00_931);
											}
											BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
												BgL_list3462z00_930);
									}}
								else
									{	/* Cfa/specialize.scm 170 */
										BFALSE;
									}
							}
						}
						{
							obj_t BgL_l3352z00_3109;

							BgL_l3352z00_3109 = CDR(BgL_l3352z00_919);
							BgL_l3352z00_919 = BgL_l3352z00_3109;
							goto BgL_forzd2each3354zd2_920;
						}
					}
				else
					{	/* Cfa/specialize.scm 169 */
						((bool_t) 1);
					}
			}
			{
				obj_t BgL_l3355z00_939;

				BgL_l3355z00_939 =
					BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7;
			BgL_forzd2each3356zd2_940:
				if (PAIRP(BgL_l3355z00_939))
					{	/* Cfa/specialize.scm 174 */
						{	/* Cfa/specialize.scm 175 */
							obj_t BgL_typeze2numze2_942;

							BgL_typeze2numze2_942 = CAR(BgL_l3355z00_939);
							{	/* Cfa/specialize.scm 175 */
								bool_t BgL_testz00_3114;

								{	/* Cfa/specialize.scm 175 */
									long BgL_auxz00_3115;

									{	/* Cfa/specialize.scm 175 */
										obj_t BgL_pairz00_1793;

										BgL_pairz00_1793 = BgL_typeze2numze2_942;
										BgL_auxz00_3115 = (long) CINT(CDR(BgL_pairz00_1793));
									}
									BgL_testz00_3114 = (BgL_auxz00_3115 > ((long) 0));
								}
								if (BgL_testz00_3114)
									{	/* Cfa/specialize.scm 176 */
										obj_t BgL_arg3475z00_946;

										obj_t BgL_arg3477z00_948;

										BgL_arg3475z00_946 =
											BGl_shapez00zztools_shapez00(CAR(BgL_typeze2numze2_942));
										BgL_arg3477z00_948 = CDR(BgL_typeze2numze2_942);
										{	/* Cfa/specialize.scm 176 */
											obj_t BgL_list3479z00_950;

											{	/* Cfa/specialize.scm 176 */
												obj_t BgL_arg3480z00_951;

												{	/* Cfa/specialize.scm 176 */
													obj_t BgL_arg3481z00_952;

													{	/* Cfa/specialize.scm 176 */
														obj_t BgL_arg3482z00_953;

														{	/* Cfa/specialize.scm 176 */
															obj_t BgL_arg3483z00_954;

															BgL_arg3483z00_954 =
																MAKE_PAIR
																(BGl_string3847z00zzcfa_specializa7eza7, BNIL);
															BgL_arg3482z00_953 =
																MAKE_PAIR(BgL_arg3477z00_948,
																BgL_arg3483z00_954);
														}
														BgL_arg3481z00_952 =
															MAKE_PAIR(BGl_string3848z00zzcfa_specializa7eza7,
															BgL_arg3482z00_953);
													}
													BgL_arg3480z00_951 =
														MAKE_PAIR(BgL_arg3475z00_946, BgL_arg3481z00_952);
												}
												BgL_list3479z00_950 =
													MAKE_PAIR(BGl_string3850z00zzcfa_specializa7eza7,
													BgL_arg3480z00_951);
											}
											BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
												BgL_list3479z00_950);
									}}
								else
									{	/* Cfa/specialize.scm 175 */
										BFALSE;
									}
							}
						}
						{
							obj_t BgL_l3355z00_3129;

							BgL_l3355z00_3129 = CDR(BgL_l3355z00_939);
							BgL_l3355z00_939 = BgL_l3355z00_3129;
							goto BgL_forzd2each3356zd2_940;
						}
					}
				else
					{	/* Cfa/specialize.scm 174 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* install-specialized-type! */
	obj_t BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t
		BgL_typez00_4)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 191 */
			{	/* Cfa/specialize.scm 192 */
				bool_t BgL_testz00_3131;

				{	/* Cfa/specialize.scm 192 */
					obj_t BgL_auxz00_3132;

					BgL_auxz00_3132 =
						BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_4,
						BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7);
					BgL_testz00_3131 = PAIRP(BgL_auxz00_3132);
				}
				if (BgL_testz00_3131)
					{	/* Cfa/specialize.scm 192 */
						return BFALSE;
					}
				else
					{	/* Cfa/specialize.scm 192 */
						{	/* Cfa/specialize.scm 194 */
							obj_t BgL_arg3490z00_960;

							BgL_arg3490z00_960 = MAKE_PAIR(BgL_typez00_4, BINT(((long) 0)));
							BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 =
								MAKE_PAIR(BgL_arg3490z00_960,
								BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7);
						}
						{	/* Cfa/specialize.scm 195 */
							obj_t BgL_list3491z00_961;

							BgL_list3491z00_961 = MAKE_PAIR(CNST_TABLE_REF(((long) 3)), BNIL);
							BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 4)),
								BgL_list3491z00_961);
						}
						{	/* Cfa/specialize.scm 196 */
							obj_t BgL_list3492z00_962;

							BgL_list3492z00_962 = MAKE_PAIR(CNST_TABLE_REF(((long) 3)), BNIL);
							return (BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7 =
								BGl_findzd2globalzd2zzast_envz00(CNST_TABLE_REF(((long) 5)),
									BgL_list3492z00_962), BUNSPEC);
		}}}}
	}



/* add-specialized-type! */
	obj_t BGl_addzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7(obj_t
		BgL_typez00_5)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 201 */
			{	/* Cfa/specialize.scm 202 */
				obj_t BgL_cellz00_964;

				BgL_cellz00_964 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_5,
					BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7);
				if (PAIRP(BgL_cellz00_964))
					{	/* Cfa/specialize.scm 207 */
						long BgL_arg3495z00_966;

						{	/* Cfa/specialize.scm 207 */
							long BgL_auxz00_3149;

							{	/* Cfa/specialize.scm 207 */
								obj_t BgL_pairz00_1801;

								BgL_pairz00_1801 = BgL_cellz00_964;
								BgL_auxz00_3149 = (long) CINT(CDR(BgL_pairz00_1801));
							}
							BgL_arg3495z00_966 = (((long) 1) + BgL_auxz00_3149);
						}
						{	/* Cfa/specialize.scm 207 */
							obj_t BgL_auxz00_3153;

							BgL_auxz00_3153 = BINT(BgL_arg3495z00_966);
							return SET_CDR(BgL_cellz00_964, BgL_auxz00_3153);
						}
					}
				else
					{	/* Cfa/specialize.scm 203 */
						return
							BGl_internalzd2errorzd2zztools_errorz00
							(BGl_string3851z00zzcfa_specializa7eza7,
							BGl_string3852z00zzcfa_specializa7eza7,
							BGl_shapez00zztools_shapez00(BgL_typez00_5));
					}
			}
		}
	}



/* add-specialized-eq-type! */
	obj_t BGl_addzd2specializa7edzd2eqzd2typez12z67zzcfa_specializa7eza7(obj_t
		BgL_typez00_6)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 212 */
			{	/* Cfa/specialize.scm 213 */
				obj_t BgL_cellz00_972;

				BgL_cellz00_972 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_6,
					BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7);
				if (PAIRP(BgL_cellz00_972))
					{	/* Cfa/specialize.scm 217 */
						long BgL_arg3505z00_974;

						{	/* Cfa/specialize.scm 217 */
							long BgL_auxz00_3161;

							{	/* Cfa/specialize.scm 217 */
								obj_t BgL_pairz00_1807;

								BgL_pairz00_1807 = BgL_cellz00_972;
								BgL_auxz00_3161 = (long) CINT(CDR(BgL_pairz00_1807));
							}
							BgL_arg3505z00_974 = (((long) 1) + BgL_auxz00_3161);
						}
						{	/* Cfa/specialize.scm 217 */
							obj_t BgL_auxz00_3165;

							BgL_auxz00_3165 = BINT(BgL_arg3505z00_974);
							return SET_CDR(BgL_cellz00_972, BgL_auxz00_3165);
						}
					}
				else
					{	/* Cfa/specialize.scm 215 */
						obj_t BgL_arg3509z00_977;

						BgL_arg3509z00_977 = MAKE_PAIR(BgL_typez00_6, BINT(((long) 1)));
						return (BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7
							=
							MAKE_PAIR(BgL_arg3509z00_977,
								BGl_za2specializa7edzd2eqzd2typesza2za7zzcfa_specializa7eza7),
							BUNSPEC);
					}
			}
		}
	}



/* install-specialize! */
	obj_t BGl_installzd2specializa7ez12z67zzcfa_specializa7eza7(obj_t
		BgL_genz00_7, obj_t BgL_fixesz00_8)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 222 */
			{	/* Cfa/specialize.scm 223 */
				obj_t BgL_genzd2idzd2_978;

				BgL_genzd2idzd2_978 = CAR(BgL_genz00_7);
				{	/* Cfa/specialize.scm 223 */
					obj_t BgL_genzd2modzd2_979;

					{	/* Cfa/specialize.scm 224 */
						obj_t BgL_pairz00_1813;

						BgL_pairz00_1813 = BgL_genz00_7;
						BgL_genzd2modzd2_979 = CAR(CDR(BgL_pairz00_1813));
					}
					{	/* Cfa/specialize.scm 224 */
						obj_t BgL_genericz00_980;

						BgL_genericz00_980 =
							BGl_findzd2globalzf2modulez20zzast_envz00(BgL_genzd2idzd2_978,
							BgL_genzd2modzd2_979);
						{	/* Cfa/specialize.scm 225 */

							if (BGl_iszd2azf3z21zz__objectz00(BgL_genericz00_980,
									BGl_globalz00zzast_varz00))
								{
									obj_t BgL_fixesz00_983;

									obj_t BgL_resz00_984;

									BgL_fixesz00_983 = BgL_fixesz00_8;
									BgL_resz00_984 = BNIL;
								BgL_loopz00_985:
									if (NULLP(BgL_fixesz00_983))
										{	/* Cfa/specialize.scm 229 */
											{	/* Cfa/specialize.scm 231 */
												BgL_globalz00_bglt BgL_obj3307z00_987;

												BgL_obj3307z00_987 =
													((BgL_globalz00_bglt)
													(BgL_globalz00_bglt) (BgL_genericz00_980));
												{	/* Cfa/specialize.scm 231 */
													BgL_specializa7edzd2globalz75_bglt BgL_arg3512z00_988;

													{	/* Cfa/specialize.scm 231 */
														BgL_specializa7edzd2globalz75_bglt
															BgL_res3772z00_1825;
														{	/* Cfa/specialize.scm 231 */
															BgL_specializa7edzd2globalz75_bglt
																BgL_new3212z00_1820;
															BgL_new3212z00_1820 =
																((BgL_specializa7edzd2globalz75_bglt)
																BREF(GC_MALLOC(sizeof(struct
																			BgL_specializa7edzd2globalz75_bgl))));
															{	/* Cfa/specialize.scm 231 */
																BgL_specializa7edzd2globalz75_bglt
																	BgL_res3771z00_1824;
																{	/* Cfa/specialize.scm 231 */
																	BgL_specializa7edzd2globalz75_bglt
																		BgL_new3234z00_1821;
																	BgL_new3234z00_1821 = BgL_new3212z00_1820;
																	{	/* Cfa/specialize.scm 231 */
																		obj_t BgL_fix3233z00_1823;

																		BgL_fix3233z00_1823 = BgL_resz00_984;
																		((((BgL_specializa7edzd2globalz75_bglt)
																					CREF(BgL_new3234z00_1821))->
																				BgL_fixz00) =
																			((obj_t) BgL_fix3233z00_1823), BUNSPEC);
																		BgL_res3771z00_1824 = BgL_new3234z00_1821;
																}} BgL_res3771z00_1824;
															}
															BgL_res3772z00_1825 = BgL_new3212z00_1820;
														}
														BgL_arg3512z00_988 = BgL_res3772z00_1825;
													}
													{	/* Cfa/specialize.scm 231 */
														obj_t BgL_auxz00_3185;

														BgL_objectz00_bglt BgL_auxz00_3183;

														BgL_auxz00_3185 = (obj_t) (BgL_arg3512z00_988);
														BgL_auxz00_3183 =
															(BgL_objectz00_bglt) (BgL_obj3307z00_987);
														BGL_OBJECT_WIDENING_SET(BgL_auxz00_3183,
															BgL_auxz00_3185);
												}}
												BGL_OBJECT_CLASS_NUM_SET(
													(BgL_objectz00_bglt) (BgL_obj3307z00_987),
													BGl_classzd2numzd2zz__objectz00
													(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7));
												BgL_obj3307z00_987;
											}
											return (BGl_za2specializa7eza2za7zzcfa_specializa7eza7 =
												MAKE_PAIR(BgL_genericz00_980,
													BGl_za2specializa7eza2za7zzcfa_specializa7eza7),
												BUNSPEC);
										}
									else
										{	/* Cfa/specialize.scm 234 */
											obj_t BgL_fixz00_990;

											BgL_fixz00_990 = CAR(BgL_fixesz00_983);
											{	/* Cfa/specialize.scm 234 */
												obj_t BgL_idz00_991;

												BgL_idz00_991 = CAR(BgL_fixz00_990);
												{	/* Cfa/specialize.scm 235 */
													obj_t BgL_modz00_992;

													{	/* Cfa/specialize.scm 236 */
														obj_t BgL_pairz00_1830;

														BgL_pairz00_1830 = BgL_fixz00_990;
														BgL_modz00_992 = CAR(CDR(BgL_pairz00_1830));
													}
													{	/* Cfa/specialize.scm 236 */
														obj_t BgL_globalz00_993;

														BgL_globalz00_993 =
															BGl_findzd2globalzf2modulez20zzast_envz00
															(BgL_idz00_991, BgL_modz00_992);
														{	/* Cfa/specialize.scm 237 */

															if (BGl_iszd2azf3z21zz__objectz00
																(BgL_globalz00_993, BGl_globalz00zzast_varz00))
																{	/* Cfa/specialize.scm 239 */
																	BgL_valuez00_bglt BgL_valz00_995;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3199;

																		BgL_auxz00_3199 =
																			(BgL_variablez00_bglt)
																			(BgL_globalz00_993);
																		BgL_valz00_995 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3199))->BgL_valuez00);
																	}
																	{	/* Cfa/specialize.scm 241 */
																		bool_t BgL_testz00_3202;

																		{	/* Cfa/specialize.scm 241 */
																			bool_t BgL_testz00_3203;

																			{	/* Cfa/specialize.scm 241 */
																				obj_t BgL_obj1849z00_1836;

																				BgL_obj1849z00_1836 =
																					(obj_t) (BgL_valz00_995);
																				BgL_testz00_3203 =
																					BGl_iszd2azf3z21zz__objectz00
																					(BgL_obj1849z00_1836,
																					BGl_sfunz00zzast_varz00);
																			}
																			if (BgL_testz00_3203)
																				{	/* Cfa/specialize.scm 241 */
																					obj_t BgL_auxz00_3206;

																					{
																						BgL_sfunz00_bglt BgL_auxz00_3207;

																						BgL_auxz00_3207 =
																							(BgL_sfunz00_bglt)
																							(BgL_valz00_995);
																						BgL_auxz00_3206 =
																							(((BgL_sfunz00_bglt)
																								CREF(BgL_auxz00_3207))->
																							BgL_argsz00);
																					}
																					BgL_testz00_3202 =
																						PAIRP(BgL_auxz00_3206);
																				}
																			else
																				{	/* Cfa/specialize.scm 241 */
																					BgL_testz00_3202 = ((bool_t) 0);
																				}
																		}
																		if (BgL_testz00_3202)
																			{	/* Cfa/specialize.scm 242 */
																				obj_t BgL_typez00_997;

																				{	/* Cfa/specialize.scm 242 */
																					obj_t BgL_vz00_1001;

																					{	/* Cfa/specialize.scm 242 */
																						obj_t BgL_pairz00_1840;

																						{
																							BgL_sfunz00_bglt BgL_auxz00_3211;

																							BgL_auxz00_3211 =
																								(BgL_sfunz00_bglt)
																								(BgL_valz00_995);
																							BgL_pairz00_1840 =
																								(((BgL_sfunz00_bglt)
																									CREF(BgL_auxz00_3211))->
																								BgL_argsz00);
																						}
																						BgL_vz00_1001 =
																							CAR(BgL_pairz00_1840);
																					}
																					if (BGl_iszd2azf3z21zz__objectz00
																						(BgL_vz00_1001,
																							BGl_typez00zztype_typez00))
																						{	/* Cfa/specialize.scm 246 */
																							BgL_typez00_997 = BgL_vz00_1001;
																						}
																					else
																						{	/* Cfa/specialize.scm 246 */
																							if (BGl_iszd2azf3z21zz__objectz00
																								(BgL_vz00_1001,
																									BGl_localz00zzast_varz00))
																								{	/* Cfa/specialize.scm 249 */
																									BgL_variablez00_bglt
																										BgL_obj1503z00_1843;
																									BgL_obj1503z00_1843 =
																										(BgL_variablez00_bglt)
																										(BgL_vz00_1001);
																									BgL_typez00_997 =
																										(obj_t) (((
																												(BgL_variablez00_bglt)
																												CREF
																												(BgL_obj1503z00_1843))->
																											BgL_typez00));
																								}
																							else
																								{	/* Cfa/specialize.scm 251 */
																									obj_t BgL_arg3523z00_1006;

																									{
																										BgL_variablez00_bglt
																											BgL_auxz00_3222;
																										BgL_auxz00_3222 =
																											(BgL_variablez00_bglt)
																											(BgL_globalz00_993);
																										BgL_arg3523z00_1006 =
																											(((BgL_variablez00_bglt)
																												CREF(BgL_auxz00_3222))->
																											BgL_idz00);
																									}
																									BgL_typez00_997 =
																										BGl_internalzd2errorzd2zztools_errorz00
																										(BGl_string3853z00zzcfa_specializa7eza7,
																										BGl_string3854z00zzcfa_specializa7eza7,
																										BgL_arg3523z00_1006);
																								}
																						}
																				}
																				BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7
																					(BgL_typez00_997);
																				{	/* Cfa/specialize.scm 256 */
																					obj_t BgL_arg3516z00_998;

																					obj_t BgL_arg3517z00_999;

																					BgL_arg3516z00_998 =
																						CDR(BgL_fixesz00_983);
																					{	/* Cfa/specialize.scm 257 */
																						obj_t BgL_arg3518z00_1000;

																						BgL_arg3518z00_1000 =
																							MAKE_PAIR(BgL_typez00_997,
																							BgL_globalz00_993);
																						BgL_arg3517z00_999 =
																							MAKE_PAIR(BgL_arg3518z00_1000,
																							BgL_resz00_984);
																					}
																					{
																						obj_t BgL_resz00_3231;

																						obj_t BgL_fixesz00_3230;

																						BgL_fixesz00_3230 =
																							BgL_arg3516z00_998;
																						BgL_resz00_3231 =
																							BgL_arg3517z00_999;
																						BgL_resz00_984 = BgL_resz00_3231;
																						BgL_fixesz00_983 =
																							BgL_fixesz00_3230;
																						goto BgL_loopz00_985;
																					}
																				}
																			}
																		else
																			{	/* Cfa/specialize.scm 258 */
																				bool_t BgL_testz00_3232;

																				{	/* Cfa/specialize.scm 258 */
																					bool_t BgL_testz00_3233;

																					{	/* Cfa/specialize.scm 258 */
																						obj_t BgL_obj1913z00_1846;

																						BgL_obj1913z00_1846 =
																							(obj_t) (BgL_valz00_995);
																						BgL_testz00_3233 =
																							BGl_iszd2azf3z21zz__objectz00
																							(BgL_obj1913z00_1846,
																							BGl_cfunz00zzast_varz00);
																					}
																					if (BgL_testz00_3233)
																						{	/* Cfa/specialize.scm 258 */
																							obj_t BgL_auxz00_3236;

																							{
																								BgL_cfunz00_bglt
																									BgL_auxz00_3237;
																								BgL_auxz00_3237 =
																									(BgL_cfunz00_bglt)
																									(BgL_valz00_995);
																								BgL_auxz00_3236 =
																									(((BgL_cfunz00_bglt)
																										CREF(BgL_auxz00_3237))->
																									BgL_argszd2typezd2);
																							}
																							BgL_testz00_3232 =
																								PAIRP(BgL_auxz00_3236);
																						}
																					else
																						{	/* Cfa/specialize.scm 258 */
																							BgL_testz00_3232 = ((bool_t) 0);
																						}
																				}
																				if (BgL_testz00_3232)
																					{	/* Cfa/specialize.scm 259 */
																						obj_t BgL_typez00_1009;

																						{	/* Cfa/specialize.scm 259 */
																							obj_t BgL_pairz00_1850;

																							{
																								BgL_cfunz00_bglt
																									BgL_auxz00_3241;
																								BgL_auxz00_3241 =
																									(BgL_cfunz00_bglt)
																									(BgL_valz00_995);
																								BgL_pairz00_1850 =
																									(((BgL_cfunz00_bglt)
																										CREF(BgL_auxz00_3241))->
																									BgL_argszd2typezd2);
																							}
																							BgL_typez00_1009 =
																								CAR(BgL_pairz00_1850);
																						}
																						BGl_installzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7
																							(BgL_typez00_1009);
																						{	/* Cfa/specialize.scm 261 */
																							obj_t BgL_arg3526z00_1010;

																							obj_t BgL_arg3527z00_1011;

																							BgL_arg3526z00_1010 =
																								CDR(BgL_fixesz00_983);
																							{	/* Cfa/specialize.scm 262 */
																								obj_t BgL_arg3528z00_1012;

																								BgL_arg3528z00_1012 =
																									MAKE_PAIR(BgL_typez00_1009,
																									BgL_globalz00_993);
																								BgL_arg3527z00_1011 =
																									MAKE_PAIR(BgL_arg3528z00_1012,
																									BgL_resz00_984);
																							}
																							{
																								obj_t BgL_resz00_3250;

																								obj_t BgL_fixesz00_3249;

																								BgL_fixesz00_3249 =
																									BgL_arg3526z00_1010;
																								BgL_resz00_3250 =
																									BgL_arg3527z00_1011;
																								BgL_resz00_984 =
																									BgL_resz00_3250;
																								BgL_fixesz00_983 =
																									BgL_fixesz00_3249;
																								goto BgL_loopz00_985;
																							}
																						}
																					}
																				else
																					{	/* Cfa/specialize.scm 258 */
																						return BFALSE;
																					}
																			}
																	}
																}
															else
																{	/* Cfa/specialize.scm 238 */
																	{	/* Cfa/specialize.scm 264 */
																		obj_t BgL_arg3537z00_1021;

																		BgL_arg3537z00_1021 =
																			MAKE_PAIR(BgL_idz00_991, BgL_modz00_992);
																		{	/* Cfa/specialize.scm 264 */
																			obj_t BgL_list3538z00_1022;

																			{	/* Cfa/specialize.scm 264 */
																				obj_t BgL_arg3539z00_1023;

																				{	/* Cfa/specialize.scm 264 */
																					obj_t BgL_arg3540z00_1024;

																					{	/* Cfa/specialize.scm 264 */
																						obj_t BgL_arg3541z00_1025;

																						BgL_arg3541z00_1025 =
																							MAKE_PAIR(BgL_arg3537z00_1021,
																							BNIL);
																						BgL_arg3540z00_1024 =
																							MAKE_PAIR
																							(BGl_string3855z00zzcfa_specializa7eza7,
																							BgL_arg3541z00_1025);
																					}
																					BgL_arg3539z00_1023 =
																						MAKE_PAIR
																						(BGl_string3856z00zzcfa_specializa7eza7,
																						BgL_arg3540z00_1024);
																				}
																				BgL_list3538z00_1022 =
																					MAKE_PAIR
																					(BGl_string3857z00zzcfa_specializa7eza7,
																					BgL_arg3539z00_1023);
																			}
																			BGl_warningz00zz__errorz00
																				(BgL_list3538z00_1022);
																		}
																	}
																	{
																		obj_t BgL_fixesz00_3257;

																		BgL_fixesz00_3257 = CDR(BgL_fixesz00_983);
																		BgL_fixesz00_983 = BgL_fixesz00_3257;
																		goto BgL_loopz00_985;
																	}
																}
														}
													}
												}
											}
										}
								}
							else
								{	/* Cfa/specialize.scm 269 */
									obj_t BgL_arg3546z00_1030;

									BgL_arg3546z00_1030 =
										MAKE_PAIR(BgL_genzd2idzd2_978, BgL_genzd2modzd2_979);
									{	/* Cfa/specialize.scm 269 */
										obj_t BgL_list3547z00_1031;

										{	/* Cfa/specialize.scm 269 */
											obj_t BgL_arg3548z00_1032;

											{	/* Cfa/specialize.scm 269 */
												obj_t BgL_arg3549z00_1033;

												{	/* Cfa/specialize.scm 269 */
													obj_t BgL_arg3550z00_1034;

													BgL_arg3550z00_1034 =
														MAKE_PAIR(BgL_arg3546z00_1030, BNIL);
													BgL_arg3549z00_1033 =
														MAKE_PAIR(BGl_string3855z00zzcfa_specializa7eza7,
														BgL_arg3550z00_1034);
												}
												BgL_arg3548z00_1032 =
													MAKE_PAIR(BGl_string3856z00zzcfa_specializa7eza7,
													BgL_arg3549z00_1033);
											}
											BgL_list3547z00_1031 =
												MAKE_PAIR(BGl_string3857z00zzcfa_specializa7eza7,
												BgL_arg3548z00_1032);
										}
										return BGl_warningz00zz__errorz00(BgL_list3547z00_1031);
									}
								}
						}
					}
				}
			}
		}
	}



/* uninstall-specializes! */
	obj_t BGl_uninstallzd2specializa7esz12z67zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 277 */
			BGl_za2specializa7edzd2typesza2z75zzcfa_specializa7eza7 = BNIL;
			{
				obj_t BgL_l3357z00_1035;

				BgL_l3357z00_1035 = BGl_za2specializa7eza2za7zzcfa_specializa7eza7;
			BgL_forzd2each3358zd2_1036:
				if (PAIRP(BgL_l3357z00_1035))
					{	/* Cfa/specialize.scm 279 */
						{	/* Cfa/specialize.scm 279 */
							obj_t BgL_oz00_1038;

							BgL_oz00_1038 = CAR(BgL_l3357z00_1035);
							{	/* Cfa/specialize.scm 279 */
								long BgL_arg3552z00_1040;

								{	/* Cfa/specialize.scm 279 */
									obj_t BgL_arg3553z00_1041;

									{	/* Cfa/specialize.scm 279 */
										obj_t BgL_arg3554z00_1042;

										{	/* Cfa/specialize.scm 279 */
											BgL_objectz00_bglt BgL_objectz00_1855;

											BgL_objectz00_1855 = (BgL_objectz00_bglt) (BgL_oz00_1038);
											{	/* Cfa/specialize.scm 279 */
												long BgL_arg2337z00_1856;

												{	/* Cfa/specialize.scm 279 */
													long BgL_arg2338z00_1857;

													BgL_arg2338z00_1857 =
														BGL_OBJECT_CLASS_NUM(BgL_objectz00_1855);
													BgL_arg2337z00_1856 =
														(BgL_arg2338z00_1857 - OBJECT_TYPE);
												}
												BgL_arg3554z00_1042 =
													VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
													(int) (BgL_arg2337z00_1856));
										}}
										BgL_arg3553z00_1041 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg3554z00_1042);
									}
									BgL_arg3552z00_1040 =
										BGl_classzd2numzd2zz__objectz00(BgL_arg3553z00_1041);
								}
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_oz00_1038), BgL_arg3552z00_1040);
							}
							{	/* Cfa/specialize.scm 279 */
								BgL_objectz00_bglt BgL_auxz00_3277;

								BgL_auxz00_3277 = (BgL_objectz00_bglt) (BgL_oz00_1038);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3277, BFALSE);
							} BgL_oz00_1038;
						}
						{
							obj_t BgL_l3357z00_3280;

							BgL_l3357z00_3280 = CDR(BgL_l3357z00_1035);
							BgL_l3357z00_1035 = BgL_l3357z00_3280;
							goto BgL_forzd2each3358zd2_1036;
						}
					}
				else
					{	/* Cfa/specialize.scm 279 */
						((bool_t) 1);
					}
			}
			return (BGl_za2specializa7eza2za7zzcfa_specializa7eza7 = BNIL, BUNSPEC);
		}
	}



/* patch-tree! */
	bool_t BGl_patchzd2treez12zc0zzcfa_specializa7eza7(obj_t BgL_globalsz00_9)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 285 */
			{
				obj_t BgL_l3359z00_1044;

				BgL_l3359z00_1044 = BgL_globalsz00_9;
			BgL_forzd2each3360zd2_1045:
				if (PAIRP(BgL_l3359z00_1044))
					{	/* Cfa/specialize.scm 286 */
						BGl_patchzd2funz12zc0zzcfa_specializa7eza7(CAR(BgL_l3359z00_1044));
						{
							obj_t BgL_l3359z00_3286;

							BgL_l3359z00_3286 = CDR(BgL_l3359z00_1044);
							BgL_l3359z00_1044 = BgL_l3359z00_3286;
							goto BgL_forzd2each3360zd2_1045;
						}
					}
				else
					{	/* Cfa/specialize.scm 286 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* patch-fun! */
	obj_t BGl_patchzd2funz12zc0zzcfa_specializa7eza7(obj_t BgL_variablez00_10)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 291 */
			{	/* Cfa/specialize.scm 292 */
				BgL_valuez00_bglt BgL_funz00_1049;

				{
					BgL_variablez00_bglt BgL_auxz00_3288;

					BgL_auxz00_3288 = (BgL_variablez00_bglt) (BgL_variablez00_10);
					BgL_funz00_1049 =
						(((BgL_variablez00_bglt) CREF(BgL_auxz00_3288))->BgL_valuez00);
				}
				{	/* Cfa/specialize.scm 293 */
					obj_t BgL_arg3559z00_1050;

					{	/* Cfa/specialize.scm 293 */
						obj_t BgL_arg3560z00_1051;

						{
							BgL_sfunz00_bglt BgL_auxz00_3291;

							BgL_auxz00_3291 = (BgL_sfunz00_bglt) (BgL_funz00_1049);
							BgL_arg3560z00_1051 =
								(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3291))->BgL_bodyz00);
						}
						{	/* Cfa/specialize.scm 293 */
							BgL_nodez00_bglt BgL_nodez00_1871;

							BgL_nodez00_1871 = (BgL_nodez00_bglt) (BgL_arg3560z00_1051);
							{	/* Cfa/specialize.scm 293 */
								obj_t BgL_method3373z00_1872;

								{	/* Cfa/specialize.scm 293 */
									BgL_objectz00_bglt BgL_objz00_1873;

									BgL_objz00_1873 = (BgL_objectz00_bglt) (BgL_nodez00_1871);
									{	/* Cfa/specialize.scm 293 */
										long BgL_objzd2classzd2numz00_1874;

										BgL_objzd2classzd2numz00_1874 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1873);
										{	/* Cfa/specialize.scm 293 */
											obj_t BgL_arg2334z00_1875;

											BgL_arg2334z00_1875 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 293 */
												obj_t BgL_arrayz00_1877;

												int BgL_offsetz00_1878;

												BgL_arrayz00_1877 = BgL_arg2334z00_1875;
												BgL_offsetz00_1878 =
													(int) (BgL_objzd2classzd2numz00_1874);
												{	/* Cfa/specialize.scm 293 */
													long BgL_offsetz00_1879;

													BgL_offsetz00_1879 =
														((long) (BgL_offsetz00_1878) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 293 */
														long BgL_modz00_1880;

														{	/* Cfa/specialize.scm 293 */
															int BgL_arg2336z00_1881;

															BgL_arg2336z00_1881 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 293 */
																long BgL_auxz00_3303;

																BgL_auxz00_3303 = (long) (BgL_arg2336z00_1881);
																BgL_modz00_1880 =
																	(BgL_offsetz00_1879 / BgL_auxz00_3303);
														}}
														{	/* Cfa/specialize.scm 293 */
															long BgL_restz00_1882;

															{	/* Cfa/specialize.scm 293 */
																int BgL_arg2335z00_1883;

																BgL_arg2335z00_1883 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 293 */
																	long BgL_auxz00_3307;

																	BgL_auxz00_3307 =
																		(long) (BgL_arg2335z00_1883);
																	BgL_restz00_1882 =
																		(BgL_offsetz00_1879 % BgL_auxz00_3307);
															}}
															{	/* Cfa/specialize.scm 293 */

																BgL_method3373z00_1872 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1877,
																		(int) (BgL_modz00_1880)),
																	(int) (BgL_restz00_1882));
								}}}}}}}}
								BgL_arg3559z00_1050 =
									PROCEDURE_ENTRY(BgL_method3373z00_1872)
									(BgL_method3373z00_1872, (obj_t) (BgL_nodez00_1871), BEOA);
					}}}
					{
						BgL_sfunz00_bglt BgL_auxz00_3317;

						BgL_auxz00_3317 = (BgL_sfunz00_bglt) (BgL_funz00_1049);
						return
							((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3317))->BgL_bodyz00) =
							((obj_t) BgL_arg3559z00_1050), BUNSPEC);
					}
				}
			}
		}
	}



/* patch*! */
	obj_t BGl_patchza2z12zb0zzcfa_specializa7eza7(obj_t BgL_nodeza2za2_33)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 473 */
			{
				obj_t BgL_nodeza2za2_1052;

				BgL_nodeza2za2_1052 = BgL_nodeza2za2_33;
			BgL_loopz00_1053:
				if (NULLP(BgL_nodeza2za2_1052))
					{	/* Cfa/specialize.scm 475 */
						return CNST_TABLE_REF(((long) 6));
					}
				else
					{	/* Cfa/specialize.scm 475 */
						{	/* Cfa/specialize.scm 478 */
							obj_t BgL_arg3562z00_1055;

							{	/* Cfa/specialize.scm 478 */
								obj_t BgL_arg3563z00_1056;

								BgL_arg3563z00_1056 = CAR(BgL_nodeza2za2_1052);
								{	/* Cfa/specialize.scm 478 */
									BgL_nodez00_bglt BgL_nodez00_1901;

									BgL_nodez00_1901 = (BgL_nodez00_bglt) (BgL_arg3563z00_1056);
									{	/* Cfa/specialize.scm 478 */
										obj_t BgL_method3373z00_1902;

										{	/* Cfa/specialize.scm 478 */
											BgL_objectz00_bglt BgL_objz00_1903;

											BgL_objz00_1903 = (BgL_objectz00_bglt) (BgL_nodez00_1901);
											{	/* Cfa/specialize.scm 478 */
												long BgL_objzd2classzd2numz00_1904;

												BgL_objzd2classzd2numz00_1904 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1903);
												{	/* Cfa/specialize.scm 478 */
													obj_t BgL_arg2334z00_1905;

													BgL_arg2334z00_1905 =
														PROCEDURE_REF
														(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
														(int) (((long) 1)));
													{	/* Cfa/specialize.scm 478 */
														obj_t BgL_arrayz00_1907;

														int BgL_offsetz00_1908;

														BgL_arrayz00_1907 = BgL_arg2334z00_1905;
														BgL_offsetz00_1908 =
															(int) (BgL_objzd2classzd2numz00_1904);
														{	/* Cfa/specialize.scm 478 */
															long BgL_offsetz00_1909;

															BgL_offsetz00_1909 =
																((long) (BgL_offsetz00_1908) - OBJECT_TYPE);
															{	/* Cfa/specialize.scm 478 */
																long BgL_modz00_1910;

																{	/* Cfa/specialize.scm 478 */
																	int BgL_arg2336z00_1911;

																	BgL_arg2336z00_1911 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 478 */
																		long BgL_auxz00_3333;

																		BgL_auxz00_3333 =
																			(long) (BgL_arg2336z00_1911);
																		BgL_modz00_1910 =
																			(BgL_offsetz00_1909 / BgL_auxz00_3333);
																}}
																{	/* Cfa/specialize.scm 478 */
																	long BgL_restz00_1912;

																	{	/* Cfa/specialize.scm 478 */
																		int BgL_arg2335z00_1913;

																		BgL_arg2335z00_1913 = (int) (((long) 8));
																		{	/* Cfa/specialize.scm 478 */
																			long BgL_auxz00_3337;

																			BgL_auxz00_3337 =
																				(long) (BgL_arg2335z00_1913);
																			BgL_restz00_1912 =
																				(BgL_offsetz00_1909 % BgL_auxz00_3337);
																	}}
																	{	/* Cfa/specialize.scm 478 */

																		BgL_method3373z00_1902 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1907,
																				(int) (BgL_modz00_1910)),
																			(int) (BgL_restz00_1912));
										}}}}}}}}
										BgL_arg3562z00_1055 =
											PROCEDURE_ENTRY(BgL_method3373z00_1902)
											(BgL_method3373z00_1902, (obj_t) (BgL_nodez00_1901),
											BEOA);
							}}}
							SET_CAR(BgL_nodeza2za2_1052, BgL_arg3562z00_1055);
						}
						{
							obj_t BgL_nodeza2za2_3348;

							BgL_nodeza2za2_3348 = CDR(BgL_nodeza2za2_1052);
							BgL_nodeza2za2_1052 = BgL_nodeza2za2_3348;
							goto BgL_loopz00_1053;
						}
					}
			}
		}
	}



/* specialize-app! */
	BgL_appz00_bglt
		BGl_specializa7ezd2appz12z67zzcfa_specializa7eza7(BgL_appz00_bglt
		BgL_nodez00_35)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 498 */
			if (NULLP((((BgL_appz00_bglt) CREF(BgL_nodez00_35))->BgL_argsz00)))
				{	/* Cfa/specialize.scm 505 */
					return BgL_nodez00_35;
				}
			else
				{	/* Cfa/specialize.scm 509 */
					obj_t BgL_typez00_1061;

					{	/* Cfa/specialize.scm 509 */
						obj_t BgL_arg3578z00_1078;

						{	/* Cfa/specialize.scm 509 */
							obj_t BgL_pairz00_1933;

							BgL_pairz00_1933 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_35))->BgL_argsz00);
							BgL_arg3578z00_1078 = CAR(BgL_pairz00_1933);
						}
						BgL_typez00_1061 =
							BGl_normaliza7ezd2typeofz75zzcfa_specializa7eza7
							(BgL_arg3578z00_1078);
					}
					{	/* Cfa/specialize.scm 509 */
						BgL_variablez00_bglt BgL_gloz00_1062;

						{	/* Cfa/specialize.scm 510 */
							BgL_varz00_bglt BgL_obj2049z00_1935;

							BgL_obj2049z00_1935 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_35))->BgL_funz00);
							BgL_gloz00_1062 =
								(((BgL_varz00_bglt) CREF(BgL_obj2049z00_1935))->
								BgL_variablez00);
						}
						{	/* Cfa/specialize.scm 510 */
							obj_t BgL_specz00_1063;

							{	/* Cfa/specialize.scm 511 */
								obj_t BgL_auxz00_3358;

								{	/* Cfa/specialize.scm 511 */
									BgL_specializa7edzd2globalz75_bglt BgL_obj3245z00_1936;

									BgL_obj3245z00_1936 =
										(BgL_specializa7edzd2globalz75_bglt) (BgL_gloz00_1062);
									{
										obj_t BgL_auxz00_3360;

										{	/* Cfa/specialize.scm 511 */
											BgL_objectz00_bglt BgL_auxz00_3361;

											BgL_auxz00_3361 =
												(BgL_objectz00_bglt) (BgL_obj3245z00_1936);
											BgL_auxz00_3360 = BGL_OBJECT_WIDENING(BgL_auxz00_3361);
										}
										BgL_auxz00_3358 =
											(((BgL_specializa7edzd2globalz75_bglt)
												CREF(BgL_auxz00_3360))->BgL_fixz00);
									}
								}
								BgL_specz00_1063 =
									BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_typez00_1061,
									BgL_auxz00_3358);
							}
							{	/* Cfa/specialize.scm 511 */

								if (PAIRP(BgL_specz00_1063))
									{	/* Cfa/specialize.scm 513 */
										obj_t BgL_g3345z00_1065;

										{	/* Cfa/specialize.scm 513 */
											obj_t BgL_pairz00_1939;

											BgL_pairz00_1939 =
												(((BgL_appz00_bglt) CREF(BgL_nodez00_35))->BgL_argsz00);
											BgL_g3345z00_1065 = CDR(BgL_pairz00_1939);
										}
										{
											obj_t BgL_argsz00_1066;

											BgL_argsz00_1066 = BgL_g3345z00_1065;
										BgL_loopz00_1067:
											if (NULLP(BgL_argsz00_1066))
												{	/* Cfa/specialize.scm 515 */
													BGl_addzd2specializa7edzd2typez12zb5zzcfa_specializa7eza7
														(BgL_typez00_1061);
													{	/* Cfa/specialize.scm 517 */
														BgL_varz00_bglt BgL_arg3568z00_1069;

														obj_t BgL_arg3569z00_1070;

														BgL_arg3568z00_1069 =
															(((BgL_appz00_bglt) CREF(BgL_nodez00_35))->
															BgL_funz00);
														BgL_arg3569z00_1070 = CDR(BgL_specz00_1063);
														{
															BgL_variablez00_bglt BgL_auxz00_3375;

															BgL_auxz00_3375 =
																(BgL_variablez00_bglt) (BgL_arg3569z00_1070);
															((((BgL_varz00_bglt) CREF(BgL_arg3568z00_1069))->
																	BgL_variablez00) =
																((BgL_variablez00_bglt) BgL_auxz00_3375),
																BUNSPEC);
														}
													}
													{
														BgL_typez00_bglt BgL_auxz00_3380;

														BgL_nodez00_bglt BgL_auxz00_3378;

														BgL_auxz00_3380 =
															(BgL_typez00_bglt) (BgL_typez00_1061);
														BgL_auxz00_3378 =
															(BgL_nodez00_bglt) (BgL_nodez00_35);
														((((BgL_nodez00_bglt) CREF(BgL_auxz00_3378))->
																BgL_typez00) =
															((BgL_typez00_bglt) BgL_auxz00_3380), BUNSPEC);
													}
													return BgL_nodez00_35;
												}
											else
												{	/* Cfa/specialize.scm 515 */
													if (
														(BGl_normaliza7ezd2typeofz75zzcfa_specializa7eza7
															(CAR(BgL_argsz00_1066)) == BgL_typez00_1061))
														{
															obj_t BgL_argsz00_3387;

															BgL_argsz00_3387 = CDR(BgL_argsz00_1066);
															BgL_argsz00_1066 = BgL_argsz00_3387;
															goto BgL_loopz00_1067;
														}
													else
														{	/* Cfa/specialize.scm 520 */
															return
																BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7
																(BgL_nodez00_35);
														}
												}
										}
									}
								else
									{	/* Cfa/specialize.scm 512 */
										return
											BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7
											(BgL_nodez00_35);
									}
							}
						}
					}
				}
		}
	}



/* normalize-typeof */
	obj_t BGl_normaliza7ezd2typeofz75zzcfa_specializa7eza7(obj_t BgL_valz00_1081)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 503 */
			{	/* Cfa/specialize.scm 500 */
				BgL_typez00_bglt BgL_tyz00_1083;

				BgL_tyz00_1083 =
					BGl_typeofz00zztype_typeofz00((BgL_nodez00_bglt) (BgL_valz00_1081));
				if (((obj_t) (BgL_tyz00_1083) == BGl_za2intza2z00zztype_cachez00))
					{	/* Cfa/specialize.scm 501 */
						return BGl_za2longza2z00zztype_cachez00;
					}
				else
					{	/* Cfa/specialize.scm 501 */
						return (obj_t) (BgL_tyz00_1083);
					}
			}
		}
	}



/* specialize-eq? */
	BgL_appz00_bglt
		BGl_specializa7ezd2eqzf3z86zzcfa_specializa7eza7(BgL_appz00_bglt
		BgL_nodez00_36)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 534 */
			{
				BgL_appz00_bglt BgL_nodez00_1115;

				obj_t BgL_typez00_1116;

				{	/* Cfa/specialize.scm 541 */
					bool_t BgL_testz00_3397;

					{	/* Cfa/specialize.scm 541 */
						bool_t BgL_testz00_3398;

						{	/* Cfa/specialize.scm 541 */
							BgL_variablez00_bglt BgL_arg3606z00_1113;

							{	/* Cfa/specialize.scm 541 */
								BgL_varz00_bglt BgL_obj2049z00_1950;

								BgL_obj2049z00_1950 =
									(((BgL_appz00_bglt) CREF(BgL_nodez00_36))->BgL_funz00);
								BgL_arg3606z00_1113 =
									(((BgL_varz00_bglt) CREF(BgL_obj2049z00_1950))->
									BgL_variablez00);
							}
							BgL_testz00_3398 =
								(
								(obj_t) (BgL_arg3606z00_1113) ==
								BGl_za2czd2eqzf3za2z21zzcfa_specializa7eza7);
						}
						if (BgL_testz00_3398)
							{	/* Cfa/specialize.scm 542 */
								obj_t BgL_arg3605z00_1112;

								BgL_arg3605z00_1112 =
									BGl_thezd2backendzd2zzbackend_backendz00();
								{
									BgL_backendz00_bglt BgL_auxz00_3404;

									BgL_auxz00_3404 = (BgL_backendz00_bglt) (BgL_arg3605z00_1112);
									BgL_testz00_3397 =
										(((BgL_backendz00_bglt) CREF(BgL_auxz00_3404))->
										BgL_typedzd2eqzd2);
								}
							}
						else
							{	/* Cfa/specialize.scm 541 */
								BgL_testz00_3397 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3397)
						{	/* Cfa/specialize.scm 544 */
							BgL_typez00_bglt BgL_t1z00_1089;

							BgL_typez00_bglt BgL_t2z00_1090;

							{	/* Cfa/specialize.scm 544 */
								obj_t BgL_arg3600z00_1107;

								{	/* Cfa/specialize.scm 544 */
									obj_t BgL_pairz00_1953;

									BgL_pairz00_1953 =
										(((BgL_appz00_bglt) CREF(BgL_nodez00_36))->BgL_argsz00);
									BgL_arg3600z00_1107 = CAR(BgL_pairz00_1953);
								}
								BgL_t1z00_1089 =
									BGl_typeofz00zztype_typeofz00(
									(BgL_nodez00_bglt) (BgL_arg3600z00_1107));
							}
							{	/* Cfa/specialize.scm 545 */
								obj_t BgL_arg3602z00_1109;

								{	/* Cfa/specialize.scm 545 */
									obj_t BgL_pairz00_1955;

									BgL_pairz00_1955 =
										(((BgL_appz00_bglt) CREF(BgL_nodez00_36))->BgL_argsz00);
									BgL_arg3602z00_1109 = CAR(CDR(BgL_pairz00_1955));
								}
								BgL_t2z00_1090 =
									BGl_typeofz00zztype_typeofz00(
									(BgL_nodez00_bglt) (BgL_arg3602z00_1109));
							}
							{	/* Cfa/specialize.scm 547 */
								bool_t BgL_testz00_3416;

								if (
									((obj_t) (BgL_t1z00_1089) == BGl_za2objza2z00zztype_cachez00))
									{	/* Cfa/specialize.scm 547 */
										BgL_testz00_3416 =
											(
											(obj_t) (BgL_t2z00_1090) ==
											BGl_za2objza2z00zztype_cachez00);
									}
								else
									{	/* Cfa/specialize.scm 547 */
										BgL_testz00_3416 = ((bool_t) 0);
									}
								if (BgL_testz00_3416)
									{	/* Cfa/specialize.scm 547 */
										BUNSPEC;
									}
								else
									{	/* Cfa/specialize.scm 547 */
										if (
											((obj_t) (BgL_t1z00_1089) ==
												BGl_za2bintza2z00zztype_cachez00))
											{	/* Cfa/specialize.scm 549 */
												if (
													((obj_t) (BgL_t2z00_1090) ==
														BGl_za2bintza2z00zztype_cachez00))
													{	/* Cfa/specialize.scm 550 */
														BgL_nodez00_1115 = BgL_nodez00_36;
														BgL_typez00_1116 = BGl_za2bintza2z00zztype_cachez00;
													BgL_zc3anonymousza33608ze3z83_1117:
														{	/* Cfa/specialize.scm 537 */
															bool_t BgL_testz00_3428;

															{	/* Cfa/specialize.scm 537 */
																obj_t BgL_obj1647z00_1959;

																BgL_obj1647z00_1959 =
																	BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7;
																BgL_testz00_3428 =
																	BGl_iszd2azf3z21zz__objectz00
																	(BgL_obj1647z00_1959,
																	BGl_globalz00zzast_varz00);
															}
															if (BgL_testz00_3428)
																{	/* Cfa/specialize.scm 537 */
																	{	/* Cfa/specialize.scm 539 */
																		BgL_varz00_bglt BgL_arg3610z00_1119;

																		BgL_arg3610z00_1119 =
																			(((BgL_appz00_bglt)
																				CREF(BgL_nodez00_36))->BgL_funz00);
																		{
																			BgL_variablez00_bglt BgL_auxz00_3431;

																			BgL_auxz00_3431 =
																				(BgL_variablez00_bglt)
																				(BGl_za2boxedzd2eqzf3za2z21zzcfa_specializa7eza7);
																			((((BgL_varz00_bglt)
																						CREF(BgL_arg3610z00_1119))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt)
																					BgL_auxz00_3431), BUNSPEC);
																		}
																	}
																	BGl_addzd2specializa7edzd2eqzd2typez12z67zzcfa_specializa7eza7
																		(BgL_typez00_1116);
																}
															else
																{	/* Cfa/specialize.scm 537 */
																	BFALSE;
																}
														}
													}
												else
													{	/* Cfa/specialize.scm 550 */
														BFALSE;
													}
											}
										else
											{	/* Cfa/specialize.scm 549 */
												if (
													((obj_t) (BgL_t2z00_1090) ==
														BGl_za2bintza2z00zztype_cachez00))
													{	/* Cfa/specialize.scm 553 */
														BUNSPEC;
													}
												else
													{	/* Cfa/specialize.scm 553 */
														if (
															((obj_t) (BgL_t1z00_1089) ==
																BGl_za2brealza2z00zztype_cachez00))
															{	/* Cfa/specialize.scm 555 */
																if (
																	((obj_t) (BgL_t2z00_1090) ==
																		BGl_za2brealza2z00zztype_cachez00))
																	{
																		obj_t BgL_typez00_3445;

																		BgL_appz00_bglt BgL_nodez00_3444;

																		BgL_nodez00_3444 = BgL_nodez00_36;
																		BgL_typez00_3445 =
																			BGl_za2brealza2z00zztype_cachez00;
																		BgL_typez00_1116 = BgL_typez00_3445;
																		BgL_nodez00_1115 = BgL_nodez00_3444;
																		goto BgL_zc3anonymousza33608ze3z83_1117;
																	}
																else
																	{	/* Cfa/specialize.scm 556 */
																		BFALSE;
																	}
															}
														else
															{	/* Cfa/specialize.scm 555 */
																if (
																	((obj_t) (BgL_t2z00_1090) ==
																		BGl_za2brealza2z00zztype_cachez00))
																	{	/* Cfa/specialize.scm 559 */
																		BUNSPEC;
																	}
																else
																	{	/* Cfa/specialize.scm 559 */
																		if (
																			((obj_t) (BgL_t2z00_1090) ==
																				BGl_za2bintza2z00zztype_cachez00))
																			{	/* Cfa/specialize.scm 561 */
																				BUNSPEC;
																			}
																		else
																			{	/* Cfa/specialize.scm 561 */
																				if (
																					((obj_t) (BgL_t1z00_1089) ==
																						BGl_za2bcharza2z00zztype_cachez00))
																					{	/* Cfa/specialize.scm 563 */
																						if (
																							((obj_t) (BgL_t2z00_1090) ==
																								BGl_za2bcharza2z00zztype_cachez00))
																							{
																								obj_t BgL_typez00_3459;

																								BgL_appz00_bglt
																									BgL_nodez00_3458;
																								BgL_nodez00_3458 =
																									BgL_nodez00_36;
																								BgL_typez00_3459 =
																									BGl_za2bcharza2z00zztype_cachez00;
																								BgL_typez00_1116 =
																									BgL_typez00_3459;
																								BgL_nodez00_1115 =
																									BgL_nodez00_3458;
																								goto
																									BgL_zc3anonymousza33608ze3z83_1117;
																							}
																						else
																							{	/* Cfa/specialize.scm 564 */
																								BFALSE;
																							}
																					}
																				else
																					{	/* Cfa/specialize.scm 563 */
																						if (
																							((obj_t) (BgL_t2z00_1090) ==
																								BGl_za2bcharza2z00zztype_cachez00))
																							{	/* Cfa/specialize.scm 567 */
																								BUNSPEC;
																							}
																						else
																							{	/* Cfa/specialize.scm 569 */
																								bool_t BgL_testz00_3463;

																								if (BGl_bigloozd2typezf3z21zztype_typez00(BgL_t1z00_1089))
																									{	/* Cfa/specialize.scm 569 */
																										BgL_testz00_3463 =
																											BGl_bigloozd2typezf3z21zztype_typez00
																											(BgL_t2z00_1090);
																									}
																								else
																									{	/* Cfa/specialize.scm 569 */
																										BgL_testz00_3463 =
																											((bool_t) 0);
																									}
																								if (BgL_testz00_3463)
																									{	/* Cfa/specialize.scm 571 */
																										BgL_typez00_bglt
																											BgL_arg3596z00_1103;
																										if (((obj_t)
																												(BgL_t1z00_1089) ==
																												BGl_za2objza2z00zztype_cachez00))
																											{	/* Cfa/specialize.scm 571 */
																												BgL_arg3596z00_1103 =
																													BgL_t2z00_1090;
																											}
																										else
																											{	/* Cfa/specialize.scm 571 */
																												BgL_arg3596z00_1103 =
																													BgL_t1z00_1089;
																											}
																										{
																											obj_t BgL_typez00_3471;

																											BgL_appz00_bglt
																												BgL_nodez00_3470;
																											BgL_nodez00_3470 =
																												BgL_nodez00_36;
																											BgL_typez00_3471 =
																												(obj_t)
																												(BgL_arg3596z00_1103);
																											BgL_typez00_1116 =
																												BgL_typez00_3471;
																											BgL_nodez00_1115 =
																												BgL_nodez00_3470;
																											goto
																												BgL_zc3anonymousza33608ze3z83_1117;
																										}
																									}
																								else
																									{	/* Cfa/specialize.scm 569 */
																										BUNSPEC;
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
							}
							return BgL_nodez00_36;
						}
					else
						{	/* Cfa/specialize.scm 541 */
							return BgL_nodez00_36;
						}
				}
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			{	/* Cfa/specialize.scm 34 */
				obj_t BgL_arg3611z00_1121;

				obj_t BgL_arg3612z00_1122;

				obj_t BgL_arg3615z00_1125;

				BgL_arg3611z00_1121 = CNST_TABLE_REF(((long) 7));
				BgL_arg3612z00_1122 = BGl_globalz00zzast_varz00;
				{	/* Cfa/specialize.scm 34 */
					obj_t BgL_v3371z00_1126;

					BgL_v3371z00_1126 = create_vector((int) (((long) 0)));
					BgL_arg3615z00_1125 = BgL_v3371z00_1126;
				}
				BGl_specializa7edzd2globalz75zzcfa_specializa7eza7 =
					BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3611z00_1121,
					BgL_arg3612z00_1122, ((bool_t) 0), BFALSE,
					BGl_z52allocatezd2specializa7edzd2globalzd2envz27zzcfa_specializa7eza7,
					BGl_specializa7edzd2globalzd2nilzd2envz75zzcfa_specializa7eza7,
					BGl_specializa7edzd2globalzf3zd2envz54zzcfa_specializa7eza7,
					((long) 420446428), BFALSE, BFALSE, BgL_arg3615z00_1125);
			}
			return (BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7
				= BUNSPEC, BUNSPEC);
		}
	}



/* _specialized-global? */
	obj_t BGl__specializa7edzd2globalzf3z86zzcfa_specializa7eza7(obj_t
		BgL_envz00_2882, obj_t BgL_obj3244z00_2883)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj3244z00_2883,
					BGl_specializa7edzd2globalz75zzcfa_specializa7eza7));
		}
	}



/* _%allocate-specialized-global */
	obj_t BGl__z52allocatezd2specializa7edzd2globalzf5zzcfa_specializa7eza7(obj_t
		BgL_envz00_2880)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			{	/* Cfa/specialize.scm 34 */
				BgL_globalz00_bglt BgL_auxz00_3479;

				{	/* Cfa/specialize.scm 34 */
					BgL_globalz00_bglt BgL_res3889z00_2974;

					{	/* Cfa/specialize.scm 34 */
						BgL_globalz00_bglt BgL_new3237z00_2972;

						BgL_new3237z00_2972 =
							((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_globalz00_bgl))));
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3237z00_2972),
							BGl_classzd2numzd2zz__objectz00
							(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7));
						{	/* Cfa/specialize.scm 34 */
							BgL_objectz00_bglt BgL_auxz00_3484;

							BgL_auxz00_3484 = (BgL_objectz00_bglt) (BgL_new3237z00_2972);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3484, BFALSE);
						}
						BgL_res3889z00_2974 = BgL_new3237z00_2972;
					}
					BgL_auxz00_3479 = BgL_res3889z00_2974;
				}
				return (obj_t) (BgL_auxz00_3479);
			}
		}
	}



/* specialized-global-nil */
	BgL_specializa7edzd2globalz75_bglt
		BGl_specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			if (
				(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7 ==
					BUNSPEC))
				{	/* Cfa/specialize.scm 34 */
					{	/* Cfa/specialize.scm 34 */
						BgL_globalz00_bglt BgL_res3778z00_1977;

						{	/* Cfa/specialize.scm 34 */
							BgL_globalz00_bglt BgL_new1646z00_1973;

							BgL_new1646z00_1973 =
								((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_globalz00_bgl))));
							BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
								(BgL_new1646z00_1973),
								BGl_classzd2numzd2zz__objectz00(BGl_globalz00zzast_varz00));
							{	/* Cfa/specialize.scm 34 */
								BgL_objectz00_bglt BgL_auxz00_3494;

								BgL_auxz00_3494 = (BgL_objectz00_bglt) (BgL_new1646z00_1973);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3494, BFALSE);
							}
							BgL_res3778z00_1977 = BgL_new1646z00_1973;
						}
						BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7 =
							(obj_t) (BgL_res3778z00_1977);
					}
					{	/* Cfa/specialize.scm 34 */
						obj_t BgL_arg3620z00_1136;

						BgL_typez00_bglt BgL_arg3621z00_1137;

						BgL_valuez00_bglt BgL_arg3622z00_1138;

						obj_t BgL_arg3624z00_1140;

						BgL_arg3620z00_1136 = CNST_TABLE_REF(((long) 8));
						BgL_arg3621z00_1137 = BGl_typezd2nilzd2zztype_typez00();
						BgL_arg3622z00_1138 = BGl_valuezd2nilzd2zzast_varz00();
						BgL_arg3624z00_1140 = CNST_TABLE_REF(((long) 8));
						{	/* Cfa/specialize.scm 34 */
							BgL_globalz00_bglt BgL_res3779z00_2011;

							{	/* Cfa/specialize.scm 34 */
								BgL_globalz00_bglt BgL_new1628z00_1978;

								BgL_new1628z00_1978 =
									(BgL_globalz00_bglt)
									(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7);
								{	/* Cfa/specialize.scm 34 */
									obj_t BgL_id1612z00_1995;

									obj_t BgL_name1613z00_1996;

									BgL_typez00_bglt BgL_type1614z00_1997;

									BgL_valuez00_bglt BgL_value1615z00_1998;

									obj_t BgL_access1616z00_1999;

									obj_t BgL_fastzd2alpha1617zd2_2000;

									obj_t BgL_removable1618z00_2001;

									long BgL_occurrence1619z00_2002;

									obj_t BgL_module1620z00_2003;

									obj_t BgL_import1621z00_2004;

									bool_t BgL_evaluablezf31622zf3_2005;

									obj_t BgL_library1623z00_2006;

									bool_t BgL_userzf31624zf3_2007;

									obj_t BgL_pragma1625z00_2008;

									obj_t BgL_src1626z00_2009;

									obj_t BgL_jvmzd2typezd2name1627z00_2010;

									BgL_id1612z00_1995 = BgL_arg3620z00_1136;
									BgL_name1613z00_1996 = BUNSPEC;
									BgL_type1614z00_1997 = BgL_arg3621z00_1137;
									BgL_value1615z00_1998 = BgL_arg3622z00_1138;
									BgL_access1616z00_1999 = BUNSPEC;
									BgL_fastzd2alpha1617zd2_2000 = BUNSPEC;
									BgL_removable1618z00_2001 = BUNSPEC;
									BgL_occurrence1619z00_2002 = ((long) 0);
									BgL_module1620z00_2003 = BgL_arg3624z00_1140;
									BgL_import1621z00_2004 = BUNSPEC;
									BgL_evaluablezf31622zf3_2005 = ((bool_t) 0);
									BgL_library1623z00_2006 = BUNSPEC;
									BgL_userzf31624zf3_2007 = ((bool_t) 0);
									BgL_pragma1625z00_2008 = BUNSPEC;
									BgL_src1626z00_2009 = BUNSPEC;
									BgL_jvmzd2typezd2name1627z00_2010 =
										BGl_string3858z00zzcfa_specializa7eza7;
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_idz00) = ((obj_t) BgL_id1612z00_1995), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_namez00) = ((obj_t) BgL_name1613z00_1996), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_type1614z00_1997), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_valuez00) =
										((BgL_valuez00_bglt) BgL_value1615z00_1998), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_accessz00) =
										((obj_t) BgL_access1616z00_1999), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_fastzd2alphazd2) =
										((obj_t) BgL_fastzd2alpha1617zd2_2000), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_removablez00) =
										((obj_t) BgL_removable1618z00_2001), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_occurrencez00) =
										((long) BgL_occurrence1619z00_2002), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_modulez00) =
										((obj_t) BgL_module1620z00_2003), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_importz00) =
										((obj_t) BgL_import1621z00_2004), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_evaluablezf3zf3) =
										((bool_t) BgL_evaluablezf31622zf3_2005), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_libraryz00) =
										((obj_t) BgL_library1623z00_2006), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_userzf3zf3) =
										((bool_t) BgL_userzf31624zf3_2007), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_pragmaz00) =
										((obj_t) BgL_pragma1625z00_2008), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_srcz00) = ((obj_t) BgL_src1626z00_2009), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1628z00_1978))->
											BgL_jvmzd2typezd2namez00) =
										((obj_t) BgL_jvmzd2typezd2name1627z00_2010), BUNSPEC);
									BgL_res3779z00_2011 = BgL_new1628z00_1978;
							}} BgL_res3779z00_2011;
					}}
					{	/* Cfa/specialize.scm 34 */
						long BgL_arg3626z00_1142;

						BgL_arg3626z00_1142 =
							BGl_classzd2numzd2zz__objectz00
							(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
							(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7),
							BgL_arg3626z00_1142);
					}
					{	/* Cfa/specialize.scm 34 */
						BgL_specializa7edzd2globalz75_bglt BgL_arg3627z00_1143;

						{	/* Cfa/specialize.scm 34 */
							BgL_specializa7edzd2globalz75_bglt BgL_res3781z00_2020;

							{	/* Cfa/specialize.scm 34 */
								BgL_specializa7edzd2globalz75_bglt BgL_new3212z00_2015;

								BgL_new3212z00_2015 =
									((BgL_specializa7edzd2globalz75_bglt)
									BREF(GC_MALLOC(sizeof(struct
												BgL_specializa7edzd2globalz75_bgl))));
								{	/* Cfa/specialize.scm 34 */
									BgL_specializa7edzd2globalz75_bglt BgL_res3780z00_2019;

									{	/* Cfa/specialize.scm 34 */
										BgL_specializa7edzd2globalz75_bglt BgL_new3234z00_2016;

										BgL_new3234z00_2016 = BgL_new3212z00_2015;
										{	/* Cfa/specialize.scm 34 */
											obj_t BgL_fix3233z00_2018;

											BgL_fix3233z00_2018 = BUNSPEC;
											((((BgL_specializa7edzd2globalz75_bglt)
														CREF(BgL_new3234z00_2016))->BgL_fixz00) =
												((obj_t) BgL_fix3233z00_2018), BUNSPEC);
											BgL_res3780z00_2019 = BgL_new3234z00_2016;
									}} BgL_res3780z00_2019;
								}
								BgL_res3781z00_2020 = BgL_new3212z00_2015;
							}
							BgL_arg3627z00_1143 = BgL_res3781z00_2020;
						}
						{	/* Cfa/specialize.scm 34 */
							obj_t BgL_auxz00_3526;

							BgL_objectz00_bglt BgL_auxz00_3524;

							BgL_auxz00_3526 = (obj_t) (BgL_arg3627z00_1143);
							BgL_auxz00_3524 =
								(BgL_objectz00_bglt)
								(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3524, BgL_auxz00_3526);
				}}}
			else
				{	/* Cfa/specialize.scm 34 */
					BFALSE;
				}
			return
				(BgL_specializa7edzd2globalz75_bglt)
				(BGl_z52thezd2specializa7edzd2globalzd2nilz27zzcfa_specializa7eza7);
		}
	}



/* _specialized-global-nil */
	obj_t BGl__specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7(obj_t
		BgL_envz00_2881)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			return
				(obj_t) (BGl_specializa7edzd2globalzd2nilza7zzcfa_specializa7eza7());
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_patchz12zd2default3372zd2envz12zzcfa_specializa7eza7);
		}
	}



/* patch! */
	obj_t BGl_patchz12z12zzcfa_specializa7eza7(BgL_nodez00_bglt BgL_nodez00_11)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 298 */
			{	/* Cfa/specialize.scm 298 */
				obj_t BgL_method3373z00_2041;

				{	/* Cfa/specialize.scm 298 */
					BgL_objectz00_bglt BgL_objz00_2042;

					BgL_objz00_2042 = (BgL_objectz00_bglt) (BgL_nodez00_11);
					{	/* Cfa/specialize.scm 298 */
						long BgL_objzd2classzd2numz00_2043;

						BgL_objzd2classzd2numz00_2043 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2042);
						{	/* Cfa/specialize.scm 298 */
							obj_t BgL_arg2334z00_2044;

							BgL_arg2334z00_2044 =
								PROCEDURE_REF(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
								(int) (((long) 1)));
							{	/* Cfa/specialize.scm 298 */
								obj_t BgL_arrayz00_2046;

								int BgL_offsetz00_2047;

								BgL_arrayz00_2046 = BgL_arg2334z00_2044;
								BgL_offsetz00_2047 = (int) (BgL_objzd2classzd2numz00_2043);
								{	/* Cfa/specialize.scm 298 */
									long BgL_offsetz00_2048;

									BgL_offsetz00_2048 =
										((long) (BgL_offsetz00_2047) - OBJECT_TYPE);
									{	/* Cfa/specialize.scm 298 */
										long BgL_modz00_2049;

										{	/* Cfa/specialize.scm 298 */
											int BgL_arg2336z00_2050;

											BgL_arg2336z00_2050 = (int) (((long) 8));
											{	/* Cfa/specialize.scm 298 */
												long BgL_auxz00_3541;

												BgL_auxz00_3541 = (long) (BgL_arg2336z00_2050);
												BgL_modz00_2049 =
													(BgL_offsetz00_2048 / BgL_auxz00_3541);
										}}
										{	/* Cfa/specialize.scm 298 */
											long BgL_restz00_2051;

											{	/* Cfa/specialize.scm 298 */
												int BgL_arg2335z00_2052;

												BgL_arg2335z00_2052 = (int) (((long) 8));
												{	/* Cfa/specialize.scm 298 */
													long BgL_auxz00_3545;

													BgL_auxz00_3545 = (long) (BgL_arg2335z00_2052);
													BgL_restz00_2051 =
														(BgL_offsetz00_2048 % BgL_auxz00_3545);
											}}
											{	/* Cfa/specialize.scm 298 */

												BgL_method3373z00_2041 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2046,
														(int) (BgL_modz00_2049)), (int) (BgL_restz00_2051));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3373z00_2041) (BgL_method3373z00_2041,
					(obj_t) (BgL_nodez00_11), BEOA);
			}
		}
	}



/* _patch! */
	obj_t BGl__patchz12z12zzcfa_specializa7eza7(obj_t BgL_envz00_2878,
		obj_t BgL_nodez00_2879)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 298 */
			return
				BGl_patchz12z12zzcfa_specializa7eza7(
				(BgL_nodez00_bglt) (BgL_nodez00_2879));
		}
	}



/* patch!-default3372 */
	obj_t BGl_patchz12zd2default3372zc0zzcfa_specializa7eza7(BgL_nodez00_bglt
		BgL_nodez00_12)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 9)),
				BGl_string3859z00zzcfa_specializa7eza7, (obj_t) (BgL_nodez00_12));
		}
	}



/* _patch!-default3372 */
	obj_t BGl__patchz12zd2default3372zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2884, obj_t BgL_nodez00_2885)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			return
				BGl_patchz12zd2default3372zc0zzcfa_specializa7eza7(
				(BgL_nodez00_bglt) (BgL_nodez00_2885));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_atomz00zzast_nodez00,
				BGl_proc3860z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_kwotez00zzast_nodez00,
				BGl_proc3861z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_varz00zzast_nodez00,
				BGl_proc3862z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_closurez00zzast_nodez00, BGl_proc3863z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_sequencez00zzast_nodez00, BGl_proc3864z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3865z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_funcallz00zzast_nodez00, BGl_proc3866z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_externz00zzast_nodez00,
				BGl_proc3867z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_castz00zzast_nodez00,
				BGl_proc3868z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_setqz00zzast_nodez00,
				BGl_proc3869z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_conditionalz00zzast_nodez00, BGl_proc3870z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_failz00zzast_nodez00,
				BGl_proc3871z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_selectz00zzast_nodez00,
				BGl_proc3872z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3873z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3874z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3875z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3876z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3877z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3878z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3879z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_patchz12zd2envzc0zzcfa_specializa7eza7, BGl_appz00zzast_nodez00,
				BGl_proc3880z00zzcfa_specializa7eza7);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_objectzd2ze3structzd2envze3zz__objectz00,
				BGl_specializa7edzd2globalz75zzcfa_specializa7eza7,
				BGl_proc3881z00zzcfa_specializa7eza7);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
				BGl_specializa7edzd2globalz75zzcfa_specializa7eza7,
				BGl_proc3882z00zzcfa_specializa7eza7);
		}
	}



/* struct+object->objec3421 */
	obj_t BGl_structzb2objectzd2ze3objec3421z83zzcfa_specializa7eza7(obj_t
		BgL_envz00_2914, obj_t BgL_oz00_2915, obj_t BgL_sz00_2916)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			{
				BgL_specializa7edzd2globalz75_bglt BgL_oz00_1731;

				obj_t BgL_sz00_1732;

				{	/* Cfa/specialize.scm 34 */
					BgL_specializa7edzd2globalz75_bglt BgL_auxz00_3585;

					BgL_oz00_1731 = (BgL_specializa7edzd2globalz75_bglt) (BgL_oz00_2915);
					BgL_sz00_1732 = BgL_sz00_2916;
					{

						{	/* Cfa/specialize.scm 34 */
							obj_t BgL_old3241z00_1735;

							obj_t BgL_aux3242z00_1736;

							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_nextzd2method3420zd2_1741;

								BgL_nextzd2method3420zd2_1741 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									(BgL_objectz00_bglt) (BgL_oz00_1731),
									BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
									BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
								if (PROCEDUREP(BgL_nextzd2method3420zd2_1741))
									{	/* Cfa/specialize.scm 34 */
										BgL_old3241z00_1735 =
											PROCEDURE_ENTRY(BgL_nextzd2method3420zd2_1741)
											(BgL_nextzd2method3420zd2_1741, (obj_t) (BgL_oz00_1731),
											BgL_sz00_1732, BEOA);
									}
								else
									{	/* Cfa/specialize.scm 34 */
										BgL_old3241z00_1735 =
											(obj_t) (BGl_structzb2objectzd2ze3objectz83zz__objectz00(
												(BgL_objectz00_bglt) (BgL_oz00_1731), BgL_sz00_1732));
									}
							}
							BgL_aux3242z00_1736 =
								STRUCT_REF(BgL_sz00_1732, (int) (((long) 0)));
							{	/* Cfa/specialize.scm 34 */
								BgL_specializa7edzd2globalz75_bglt BgL_new3243z00_1737;

								BgL_new3243z00_1737 =
									((BgL_specializa7edzd2globalz75_bglt) (BgL_old3241z00_1735));
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_new3243z00_1737),
									BGl_classzd2numzd2zz__objectz00
									(BGl_specializa7edzd2globalz75zzcfa_specializa7eza7));
								{	/* Cfa/specialize.scm 34 */
									BgL_specializa7edzd2globalz75_bglt BgL_arg3768z00_1739;

									{	/* Cfa/specialize.scm 34 */
										obj_t BgL_arg3769z00_1740;

										BgL_arg3769z00_1740 =
											STRUCT_REF(BgL_aux3242z00_1736, (int) (((long) 0)));
										{	/* Cfa/specialize.scm 34 */
											BgL_specializa7edzd2globalz75_bglt BgL_res3838z00_2870;

											{	/* Cfa/specialize.scm 34 */
												BgL_specializa7edzd2globalz75_bglt BgL_new3212z00_2865;

												BgL_new3212z00_2865 =
													((BgL_specializa7edzd2globalz75_bglt)
													BREF(GC_MALLOC(sizeof(struct
																BgL_specializa7edzd2globalz75_bgl))));
												{	/* Cfa/specialize.scm 34 */
													BgL_specializa7edzd2globalz75_bglt
														BgL_res3837z00_2869;
													{	/* Cfa/specialize.scm 34 */
														BgL_specializa7edzd2globalz75_bglt
															BgL_new3234z00_2866;
														BgL_new3234z00_2866 = BgL_new3212z00_2865;
														{	/* Cfa/specialize.scm 34 */
															obj_t BgL_fix3233z00_2868;

															BgL_fix3233z00_2868 = BgL_arg3769z00_1740;
															((((BgL_specializa7edzd2globalz75_bglt)
																		CREF(BgL_new3234z00_2866))->BgL_fixz00) =
																((obj_t) BgL_fix3233z00_2868), BUNSPEC);
															BgL_res3837z00_2869 = BgL_new3234z00_2866;
													}} BgL_res3837z00_2869;
												}
												BgL_res3838z00_2870 = BgL_new3212z00_2865;
											}
											BgL_arg3768z00_1739 = BgL_res3838z00_2870;
									}}
									{	/* Cfa/specialize.scm 34 */
										obj_t BgL_auxz00_3608;

										BgL_objectz00_bglt BgL_auxz00_3606;

										BgL_auxz00_3608 = (obj_t) (BgL_arg3768z00_1739);
										BgL_auxz00_3606 =
											(BgL_objectz00_bglt) (BgL_new3243z00_1737);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_3606, BgL_auxz00_3608);
								}}
								BgL_auxz00_3585 = BgL_new3243z00_1737;
					}}}
					return (obj_t) (BgL_auxz00_3585);
				}
			}
		}
	}



/* object->struct-speci3418 */
	obj_t BGl_objectzd2ze3structzd2speci3418ze3zzcfa_specializa7eza7(obj_t
		BgL_envz00_2917, obj_t BgL_obj3238z00_2918)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 34 */
			{
				BgL_specializa7edzd2globalz75_bglt BgL_obj3238z00_1721;

				BgL_obj3238z00_1721 =
					(BgL_specializa7edzd2globalz75_bglt) (BgL_obj3238z00_2918);
				{

					{	/* Cfa/specialize.scm 34 */
						obj_t BgL_res3239z00_1724;

						{	/* Cfa/specialize.scm 34 */
							obj_t BgL_nextzd2method3417zd2_1729;

							BgL_nextzd2method3417zd2_1729 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_obj3238z00_1721),
								BGl_objectzd2ze3structzd2envze3zz__objectz00,
								BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
							if (PROCEDUREP(BgL_nextzd2method3417zd2_1729))
								{	/* Cfa/specialize.scm 34 */
									BgL_res3239z00_1724 =
										PROCEDURE_ENTRY(BgL_nextzd2method3417zd2_1729)
										(BgL_nextzd2method3417zd2_1729,
										(obj_t) (BgL_obj3238z00_1721), BEOA);
								}
							else
								{	/* Cfa/specialize.scm 34 */
									BgL_res3239z00_1724 =
										BGl_objectzd2ze3structz31zz__objectz00(
										(BgL_objectz00_bglt) (BgL_obj3238z00_1721));
								}
						}
						{	/* Cfa/specialize.scm 34 */
							obj_t BgL_aux3240z00_1725;

							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_keyz00_2841;

								BgL_keyz00_2841 = CNST_TABLE_REF(((long) 7));
								BgL_aux3240z00_1725 =
									make_struct(BgL_keyz00_2841, (int) (((long) 1)), BUNSPEC);
							}
							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_arg3764z00_1727;

								{
									obj_t BgL_auxz00_3625;

									{	/* Cfa/specialize.scm 34 */
										BgL_objectz00_bglt BgL_auxz00_3626;

										BgL_auxz00_3626 =
											(BgL_objectz00_bglt) (BgL_obj3238z00_1721);
										BgL_auxz00_3625 = BGL_OBJECT_WIDENING(BgL_auxz00_3626);
									}
									BgL_arg3764z00_1727 =
										(((BgL_specializa7edzd2globalz75_bglt)
											CREF(BgL_auxz00_3625))->BgL_fixz00);
								}
								{	/* Cfa/specialize.scm 34 */
									int BgL_auxz00_3630;

									BgL_auxz00_3630 = (int) (((long) 0));
									STRUCT_SET(BgL_aux3240z00_1725, BgL_auxz00_3630,
										BgL_arg3764z00_1727);
							}}
							{	/* Cfa/specialize.scm 34 */
								int BgL_auxz00_3633;

								BgL_auxz00_3633 = (int) (((long) 0));
								STRUCT_SET(BgL_res3239z00_1724, BgL_auxz00_3633,
									BgL_aux3240z00_1725);
							}
							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_auxz00_3636;

								BgL_auxz00_3636 = STRUCT_KEY(BgL_res3239z00_1724);
								STRUCT_KEY_SET(BgL_aux3240z00_1725, BgL_auxz00_3636);
							}
							{	/* Cfa/specialize.scm 34 */
								obj_t BgL_kz00_2856;

								BgL_kz00_2856 = CNST_TABLE_REF(((long) 7));
								STRUCT_KEY_SET(BgL_res3239z00_1724, BgL_kz00_2856);
							}
							return BgL_res3239z00_1724;
						}
					}
				}
			}
		}
	}



/* patch!-app3416 */
	obj_t BGl_patchz12zd2app3416zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2919,
		obj_t BgL_nodez00_2920)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 484 */
			{
				BgL_appz00_bglt BgL_nodez00_1709;

				{	/* Cfa/specialize.scm 485 */
					BgL_appz00_bglt BgL_auxz00_3642;

					BgL_nodez00_1709 = (BgL_appz00_bglt) (BgL_nodez00_2920);
					{	/* Cfa/specialize.scm 486 */
						obj_t BgL_arg3757z00_1713;

						BgL_arg3757z00_1713 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1709))->BgL_argsz00);
						BGl_patchza2z12zb0zzcfa_specializa7eza7(BgL_arg3757z00_1713);
					}
					{	/* Cfa/specialize.scm 487 */
						obj_t BgL_arg3758z00_1714;

						{	/* Cfa/specialize.scm 487 */
							BgL_varz00_bglt BgL_arg3759z00_1715;

							BgL_arg3759z00_1715 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_1709))->BgL_funz00);
							{	/* Cfa/specialize.scm 487 */
								BgL_nodez00_bglt BgL_nodez00_2810;

								BgL_nodez00_2810 = (BgL_nodez00_bglt) (BgL_arg3759z00_1715);
								{	/* Cfa/specialize.scm 487 */
									obj_t BgL_method3373z00_2811;

									{	/* Cfa/specialize.scm 487 */
										BgL_objectz00_bglt BgL_objz00_2812;

										BgL_objz00_2812 = (BgL_objectz00_bglt) (BgL_nodez00_2810);
										{	/* Cfa/specialize.scm 487 */
											long BgL_objzd2classzd2numz00_2813;

											BgL_objzd2classzd2numz00_2813 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2812);
											{	/* Cfa/specialize.scm 487 */
												obj_t BgL_arg2334z00_2814;

												BgL_arg2334z00_2814 =
													PROCEDURE_REF
													(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
													(int) (((long) 1)));
												{	/* Cfa/specialize.scm 487 */
													obj_t BgL_arrayz00_2816;

													int BgL_offsetz00_2817;

													BgL_arrayz00_2816 = BgL_arg2334z00_2814;
													BgL_offsetz00_2817 =
														(int) (BgL_objzd2classzd2numz00_2813);
													{	/* Cfa/specialize.scm 487 */
														long BgL_offsetz00_2818;

														BgL_offsetz00_2818 =
															((long) (BgL_offsetz00_2817) - OBJECT_TYPE);
														{	/* Cfa/specialize.scm 487 */
															long BgL_modz00_2819;

															{	/* Cfa/specialize.scm 487 */
																int BgL_arg2336z00_2820;

																BgL_arg2336z00_2820 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 487 */
																	long BgL_auxz00_3655;

																	BgL_auxz00_3655 =
																		(long) (BgL_arg2336z00_2820);
																	BgL_modz00_2819 =
																		(BgL_offsetz00_2818 / BgL_auxz00_3655);
															}}
															{	/* Cfa/specialize.scm 487 */
																long BgL_restz00_2821;

																{	/* Cfa/specialize.scm 487 */
																	int BgL_arg2335z00_2822;

																	BgL_arg2335z00_2822 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 487 */
																		long BgL_auxz00_3659;

																		BgL_auxz00_3659 =
																			(long) (BgL_arg2335z00_2822);
																		BgL_restz00_2821 =
																			(BgL_offsetz00_2818 % BgL_auxz00_3659);
																}}
																{	/* Cfa/specialize.scm 487 */

																	BgL_method3373z00_2811 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2816,
																			(int) (BgL_modz00_2819)),
																		(int) (BgL_restz00_2821));
									}}}}}}}}
									BgL_arg3758z00_1714 =
										PROCEDURE_ENTRY(BgL_method3373z00_2811)
										(BgL_method3373z00_2811, (obj_t) (BgL_nodez00_2810), BEOA);
						}}}
						{
							BgL_varz00_bglt BgL_auxz00_3669;

							BgL_auxz00_3669 = (BgL_varz00_bglt) (BgL_arg3758z00_1714);
							((((BgL_appz00_bglt) CREF(BgL_nodez00_1709))->BgL_funz00) =
								((BgL_varz00_bglt) BgL_auxz00_3669), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 488 */
						BgL_variablez00_bglt BgL_vz00_1716;

						{	/* Cfa/specialize.scm 488 */
							BgL_varz00_bglt BgL_obj2049z00_2839;

							BgL_obj2049z00_2839 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_1709))->BgL_funz00);
							BgL_vz00_1716 =
								(((BgL_varz00_bglt) CREF(BgL_obj2049z00_2839))->
								BgL_variablez00);
						}
						{	/* Cfa/specialize.scm 490 */
							bool_t BgL_testz00_3674;

							{	/* Cfa/specialize.scm 490 */
								obj_t BgL_obj3244z00_2840;

								BgL_obj3244z00_2840 = (obj_t) (BgL_vz00_1716);
								BgL_testz00_3674 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj3244z00_2840,
									BGl_specializa7edzd2globalz75zzcfa_specializa7eza7);
							}
							if (BgL_testz00_3674)
								{	/* Cfa/specialize.scm 490 */
									BgL_auxz00_3642 =
										BGl_specializa7ezd2appz12z67zzcfa_specializa7eza7
										(BgL_nodez00_1709);
								}
							else
								{	/* Cfa/specialize.scm 490 */
									BgL_auxz00_3642 = BgL_nodez00_1709;
								}
						}
					}
					return (obj_t) (BgL_auxz00_3642);
				}
			}
		}
	}



/* patch!-box-ref3414 */
	obj_t BGl_patchz12zd2boxzd2ref3414z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2921, obj_t BgL_nodez00_2922)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 465 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1701;

				{	/* Cfa/specialize.scm 466 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_3680;

					BgL_nodez00_1701 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2922);
					{	/* Cfa/specialize.scm 467 */
						obj_t BgL_arg3754z00_1705;

						{	/* Cfa/specialize.scm 467 */
							BgL_varz00_bglt BgL_arg3755z00_1706;

							BgL_arg3755z00_1706 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1701))->BgL_varz00);
							{	/* Cfa/specialize.scm 467 */
								BgL_nodez00_bglt BgL_nodez00_2780;

								BgL_nodez00_2780 = (BgL_nodez00_bglt) (BgL_arg3755z00_1706);
								{	/* Cfa/specialize.scm 467 */
									obj_t BgL_method3373z00_2781;

									{	/* Cfa/specialize.scm 467 */
										BgL_objectz00_bglt BgL_objz00_2782;

										BgL_objz00_2782 = (BgL_objectz00_bglt) (BgL_nodez00_2780);
										{	/* Cfa/specialize.scm 467 */
											long BgL_objzd2classzd2numz00_2783;

											BgL_objzd2classzd2numz00_2783 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2782);
											{	/* Cfa/specialize.scm 467 */
												obj_t BgL_arg2334z00_2784;

												BgL_arg2334z00_2784 =
													PROCEDURE_REF
													(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
													(int) (((long) 1)));
												{	/* Cfa/specialize.scm 467 */
													obj_t BgL_arrayz00_2786;

													int BgL_offsetz00_2787;

													BgL_arrayz00_2786 = BgL_arg2334z00_2784;
													BgL_offsetz00_2787 =
														(int) (BgL_objzd2classzd2numz00_2783);
													{	/* Cfa/specialize.scm 467 */
														long BgL_offsetz00_2788;

														BgL_offsetz00_2788 =
															((long) (BgL_offsetz00_2787) - OBJECT_TYPE);
														{	/* Cfa/specialize.scm 467 */
															long BgL_modz00_2789;

															{	/* Cfa/specialize.scm 467 */
																int BgL_arg2336z00_2790;

																BgL_arg2336z00_2790 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 467 */
																	long BgL_auxz00_3691;

																	BgL_auxz00_3691 =
																		(long) (BgL_arg2336z00_2790);
																	BgL_modz00_2789 =
																		(BgL_offsetz00_2788 / BgL_auxz00_3691);
															}}
															{	/* Cfa/specialize.scm 467 */
																long BgL_restz00_2791;

																{	/* Cfa/specialize.scm 467 */
																	int BgL_arg2335z00_2792;

																	BgL_arg2335z00_2792 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 467 */
																		long BgL_auxz00_3695;

																		BgL_auxz00_3695 =
																			(long) (BgL_arg2335z00_2792);
																		BgL_restz00_2791 =
																			(BgL_offsetz00_2788 % BgL_auxz00_3695);
																}}
																{	/* Cfa/specialize.scm 467 */

																	BgL_method3373z00_2781 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2786,
																			(int) (BgL_modz00_2789)),
																		(int) (BgL_restz00_2791));
									}}}}}}}}
									BgL_arg3754z00_1705 =
										PROCEDURE_ENTRY(BgL_method3373z00_2781)
										(BgL_method3373z00_2781, (obj_t) (BgL_nodez00_2780), BEOA);
						}}}
						{
							BgL_varz00_bglt BgL_auxz00_3705;

							BgL_auxz00_3705 = (BgL_varz00_bglt) (BgL_arg3754z00_1705);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1701))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_3705), BUNSPEC);
					}}
					BgL_auxz00_3680 = BgL_nodez00_1701;
					return (obj_t) (BgL_auxz00_3680);
				}
			}
		}
	}



/* patch!-box-set!3412 */
	obj_t BGl_patchz12zd2boxzd2setz123412z00zzcfa_specializa7eza7(obj_t
		BgL_envz00_2923, obj_t BgL_nodez00_2924)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 456 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1691;

				{	/* Cfa/specialize.scm 457 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_3710;

					BgL_nodez00_1691 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2924);
					{	/* Cfa/specialize.scm 458 */
						obj_t BgL_arg3749z00_1695;

						{	/* Cfa/specialize.scm 458 */
							BgL_varz00_bglt BgL_arg3750z00_1696;

							BgL_arg3750z00_1696 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1691))->
								BgL_varz00);
							{	/* Cfa/specialize.scm 458 */
								BgL_nodez00_bglt BgL_nodez00_2722;

								BgL_nodez00_2722 = (BgL_nodez00_bglt) (BgL_arg3750z00_1696);
								{	/* Cfa/specialize.scm 458 */
									obj_t BgL_method3373z00_2723;

									{	/* Cfa/specialize.scm 458 */
										BgL_objectz00_bglt BgL_objz00_2724;

										BgL_objz00_2724 = (BgL_objectz00_bglt) (BgL_nodez00_2722);
										{	/* Cfa/specialize.scm 458 */
											long BgL_objzd2classzd2numz00_2725;

											BgL_objzd2classzd2numz00_2725 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2724);
											{	/* Cfa/specialize.scm 458 */
												obj_t BgL_arg2334z00_2726;

												BgL_arg2334z00_2726 =
													PROCEDURE_REF
													(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
													(int) (((long) 1)));
												{	/* Cfa/specialize.scm 458 */
													obj_t BgL_arrayz00_2728;

													int BgL_offsetz00_2729;

													BgL_arrayz00_2728 = BgL_arg2334z00_2726;
													BgL_offsetz00_2729 =
														(int) (BgL_objzd2classzd2numz00_2725);
													{	/* Cfa/specialize.scm 458 */
														long BgL_offsetz00_2730;

														BgL_offsetz00_2730 =
															((long) (BgL_offsetz00_2729) - OBJECT_TYPE);
														{	/* Cfa/specialize.scm 458 */
															long BgL_modz00_2731;

															{	/* Cfa/specialize.scm 458 */
																int BgL_arg2336z00_2732;

																BgL_arg2336z00_2732 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 458 */
																	long BgL_auxz00_3721;

																	BgL_auxz00_3721 =
																		(long) (BgL_arg2336z00_2732);
																	BgL_modz00_2731 =
																		(BgL_offsetz00_2730 / BgL_auxz00_3721);
															}}
															{	/* Cfa/specialize.scm 458 */
																long BgL_restz00_2733;

																{	/* Cfa/specialize.scm 458 */
																	int BgL_arg2335z00_2734;

																	BgL_arg2335z00_2734 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 458 */
																		long BgL_auxz00_3725;

																		BgL_auxz00_3725 =
																			(long) (BgL_arg2335z00_2734);
																		BgL_restz00_2733 =
																			(BgL_offsetz00_2730 % BgL_auxz00_3725);
																}}
																{	/* Cfa/specialize.scm 458 */

																	BgL_method3373z00_2723 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2728,
																			(int) (BgL_modz00_2731)),
																		(int) (BgL_restz00_2733));
									}}}}}}}}
									BgL_arg3749z00_1695 =
										PROCEDURE_ENTRY(BgL_method3373z00_2723)
										(BgL_method3373z00_2723, (obj_t) (BgL_nodez00_2722), BEOA);
						}}}
						{
							BgL_varz00_bglt BgL_auxz00_3735;

							BgL_auxz00_3735 = (BgL_varz00_bglt) (BgL_arg3749z00_1695);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1691))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_3735), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 459 */
						obj_t BgL_arg3751z00_1697;

						{	/* Cfa/specialize.scm 459 */
							BgL_nodez00_bglt BgL_arg3752z00_1698;

							BgL_arg3752z00_1698 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1691))->
								BgL_valuez00);
							{	/* Cfa/specialize.scm 459 */
								obj_t BgL_method3373z00_2752;

								{	/* Cfa/specialize.scm 459 */
									BgL_objectz00_bglt BgL_objz00_2753;

									BgL_objz00_2753 = (BgL_objectz00_bglt) (BgL_arg3752z00_1698);
									{	/* Cfa/specialize.scm 459 */
										long BgL_objzd2classzd2numz00_2754;

										BgL_objzd2classzd2numz00_2754 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2753);
										{	/* Cfa/specialize.scm 459 */
											obj_t BgL_arg2334z00_2755;

											BgL_arg2334z00_2755 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 459 */
												obj_t BgL_arrayz00_2757;

												int BgL_offsetz00_2758;

												BgL_arrayz00_2757 = BgL_arg2334z00_2755;
												BgL_offsetz00_2758 =
													(int) (BgL_objzd2classzd2numz00_2754);
												{	/* Cfa/specialize.scm 459 */
													long BgL_offsetz00_2759;

													BgL_offsetz00_2759 =
														((long) (BgL_offsetz00_2758) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 459 */
														long BgL_modz00_2760;

														{	/* Cfa/specialize.scm 459 */
															int BgL_arg2336z00_2761;

															BgL_arg2336z00_2761 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 459 */
																long BgL_auxz00_3747;

																BgL_auxz00_3747 = (long) (BgL_arg2336z00_2761);
																BgL_modz00_2760 =
																	(BgL_offsetz00_2759 / BgL_auxz00_3747);
														}}
														{	/* Cfa/specialize.scm 459 */
															long BgL_restz00_2762;

															{	/* Cfa/specialize.scm 459 */
																int BgL_arg2335z00_2763;

																BgL_arg2335z00_2763 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 459 */
																	long BgL_auxz00_3751;

																	BgL_auxz00_3751 =
																		(long) (BgL_arg2335z00_2763);
																	BgL_restz00_2762 =
																		(BgL_offsetz00_2759 % BgL_auxz00_3751);
															}}
															{	/* Cfa/specialize.scm 459 */

																BgL_method3373z00_2752 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2757,
																		(int) (BgL_modz00_2760)),
																	(int) (BgL_restz00_2762));
								}}}}}}}}
								BgL_arg3751z00_1697 =
									PROCEDURE_ENTRY(BgL_method3373z00_2752)
									(BgL_method3373z00_2752, (obj_t) (BgL_arg3752z00_1698), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3761;

							BgL_auxz00_3761 = (BgL_nodez00_bglt) (BgL_arg3751z00_1697);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1691))->
									BgL_valuez00) =
								((BgL_nodez00_bglt) BgL_auxz00_3761), BUNSPEC);
					}}
					BgL_auxz00_3710 = BgL_nodez00_1691;
					return (obj_t) (BgL_auxz00_3710);
				}
			}
		}
	}



/* patch!-make-box3410 */
	obj_t BGl_patchz12zd2makezd2box3410z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2925, obj_t BgL_nodez00_2926)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 448 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1683;

				{	/* Cfa/specialize.scm 449 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_3766;

					BgL_nodez00_1683 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2926);
					{	/* Cfa/specialize.scm 450 */
						obj_t BgL_arg3746z00_1687;

						{	/* Cfa/specialize.scm 450 */
							BgL_nodez00_bglt BgL_arg3747z00_1688;

							BgL_arg3747z00_1688 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1683))->
								BgL_valuez00);
							{	/* Cfa/specialize.scm 450 */
								obj_t BgL_method3373z00_2694;

								{	/* Cfa/specialize.scm 450 */
									BgL_objectz00_bglt BgL_objz00_2695;

									BgL_objz00_2695 = (BgL_objectz00_bglt) (BgL_arg3747z00_1688);
									{	/* Cfa/specialize.scm 450 */
										long BgL_objzd2classzd2numz00_2696;

										BgL_objzd2classzd2numz00_2696 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2695);
										{	/* Cfa/specialize.scm 450 */
											obj_t BgL_arg2334z00_2697;

											BgL_arg2334z00_2697 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 450 */
												obj_t BgL_arrayz00_2699;

												int BgL_offsetz00_2700;

												BgL_arrayz00_2699 = BgL_arg2334z00_2697;
												BgL_offsetz00_2700 =
													(int) (BgL_objzd2classzd2numz00_2696);
												{	/* Cfa/specialize.scm 450 */
													long BgL_offsetz00_2701;

													BgL_offsetz00_2701 =
														((long) (BgL_offsetz00_2700) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 450 */
														long BgL_modz00_2702;

														{	/* Cfa/specialize.scm 450 */
															int BgL_arg2336z00_2703;

															BgL_arg2336z00_2703 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 450 */
																long BgL_auxz00_3776;

																BgL_auxz00_3776 = (long) (BgL_arg2336z00_2703);
																BgL_modz00_2702 =
																	(BgL_offsetz00_2701 / BgL_auxz00_3776);
														}}
														{	/* Cfa/specialize.scm 450 */
															long BgL_restz00_2704;

															{	/* Cfa/specialize.scm 450 */
																int BgL_arg2335z00_2705;

																BgL_arg2335z00_2705 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 450 */
																	long BgL_auxz00_3780;

																	BgL_auxz00_3780 =
																		(long) (BgL_arg2335z00_2705);
																	BgL_restz00_2704 =
																		(BgL_offsetz00_2701 % BgL_auxz00_3780);
															}}
															{	/* Cfa/specialize.scm 450 */

																BgL_method3373z00_2694 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2699,
																		(int) (BgL_modz00_2702)),
																	(int) (BgL_restz00_2704));
								}}}}}}}}
								BgL_arg3746z00_1687 =
									PROCEDURE_ENTRY(BgL_method3373z00_2694)
									(BgL_method3373z00_2694, (obj_t) (BgL_arg3747z00_1688), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3790;

							BgL_auxz00_3790 = (BgL_nodez00_bglt) (BgL_arg3746z00_1687);
							((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1683))->
									BgL_valuez00) =
								((BgL_nodez00_bglt) BgL_auxz00_3790), BUNSPEC);
					}}
					BgL_auxz00_3766 = BgL_nodez00_1683;
					return (obj_t) (BgL_auxz00_3766);
				}
			}
		}
	}



/* patch!-jump-ex-it3408 */
	obj_t BGl_patchz12zd2jumpzd2exzd2it3408zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2927, obj_t BgL_nodez00_2928)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 439 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1673;

				{	/* Cfa/specialize.scm 440 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_3795;

					BgL_nodez00_1673 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2928);
					{	/* Cfa/specialize.scm 441 */
						obj_t BgL_arg3741z00_1677;

						{	/* Cfa/specialize.scm 441 */
							BgL_nodez00_bglt BgL_arg3742z00_1678;

							BgL_arg3742z00_1678 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1673))->
								BgL_exitz00);
							{	/* Cfa/specialize.scm 441 */
								obj_t BgL_method3373z00_2636;

								{	/* Cfa/specialize.scm 441 */
									BgL_objectz00_bglt BgL_objz00_2637;

									BgL_objz00_2637 = (BgL_objectz00_bglt) (BgL_arg3742z00_1678);
									{	/* Cfa/specialize.scm 441 */
										long BgL_objzd2classzd2numz00_2638;

										BgL_objzd2classzd2numz00_2638 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2637);
										{	/* Cfa/specialize.scm 441 */
											obj_t BgL_arg2334z00_2639;

											BgL_arg2334z00_2639 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 441 */
												obj_t BgL_arrayz00_2641;

												int BgL_offsetz00_2642;

												BgL_arrayz00_2641 = BgL_arg2334z00_2639;
												BgL_offsetz00_2642 =
													(int) (BgL_objzd2classzd2numz00_2638);
												{	/* Cfa/specialize.scm 441 */
													long BgL_offsetz00_2643;

													BgL_offsetz00_2643 =
														((long) (BgL_offsetz00_2642) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 441 */
														long BgL_modz00_2644;

														{	/* Cfa/specialize.scm 441 */
															int BgL_arg2336z00_2645;

															BgL_arg2336z00_2645 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 441 */
																long BgL_auxz00_3805;

																BgL_auxz00_3805 = (long) (BgL_arg2336z00_2645);
																BgL_modz00_2644 =
																	(BgL_offsetz00_2643 / BgL_auxz00_3805);
														}}
														{	/* Cfa/specialize.scm 441 */
															long BgL_restz00_2646;

															{	/* Cfa/specialize.scm 441 */
																int BgL_arg2335z00_2647;

																BgL_arg2335z00_2647 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 441 */
																	long BgL_auxz00_3809;

																	BgL_auxz00_3809 =
																		(long) (BgL_arg2335z00_2647);
																	BgL_restz00_2646 =
																		(BgL_offsetz00_2643 % BgL_auxz00_3809);
															}}
															{	/* Cfa/specialize.scm 441 */

																BgL_method3373z00_2636 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2641,
																		(int) (BgL_modz00_2644)),
																	(int) (BgL_restz00_2646));
								}}}}}}}}
								BgL_arg3741z00_1677 =
									PROCEDURE_ENTRY(BgL_method3373z00_2636)
									(BgL_method3373z00_2636, (obj_t) (BgL_arg3742z00_1678), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3819;

							BgL_auxz00_3819 = (BgL_nodez00_bglt) (BgL_arg3741z00_1677);
							((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1673))->
									BgL_exitz00) = ((BgL_nodez00_bglt) BgL_auxz00_3819), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 442 */
						obj_t BgL_arg3743z00_1679;

						{	/* Cfa/specialize.scm 442 */
							BgL_nodez00_bglt BgL_arg3744z00_1680;

							BgL_arg3744z00_1680 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1673))->
								BgL_valuez00);
							{	/* Cfa/specialize.scm 442 */
								obj_t BgL_method3373z00_2665;

								{	/* Cfa/specialize.scm 442 */
									BgL_objectz00_bglt BgL_objz00_2666;

									BgL_objz00_2666 = (BgL_objectz00_bglt) (BgL_arg3744z00_1680);
									{	/* Cfa/specialize.scm 442 */
										long BgL_objzd2classzd2numz00_2667;

										BgL_objzd2classzd2numz00_2667 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2666);
										{	/* Cfa/specialize.scm 442 */
											obj_t BgL_arg2334z00_2668;

											BgL_arg2334z00_2668 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 442 */
												obj_t BgL_arrayz00_2670;

												int BgL_offsetz00_2671;

												BgL_arrayz00_2670 = BgL_arg2334z00_2668;
												BgL_offsetz00_2671 =
													(int) (BgL_objzd2classzd2numz00_2667);
												{	/* Cfa/specialize.scm 442 */
													long BgL_offsetz00_2672;

													BgL_offsetz00_2672 =
														((long) (BgL_offsetz00_2671) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 442 */
														long BgL_modz00_2673;

														{	/* Cfa/specialize.scm 442 */
															int BgL_arg2336z00_2674;

															BgL_arg2336z00_2674 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 442 */
																long BgL_auxz00_3831;

																BgL_auxz00_3831 = (long) (BgL_arg2336z00_2674);
																BgL_modz00_2673 =
																	(BgL_offsetz00_2672 / BgL_auxz00_3831);
														}}
														{	/* Cfa/specialize.scm 442 */
															long BgL_restz00_2675;

															{	/* Cfa/specialize.scm 442 */
																int BgL_arg2335z00_2676;

																BgL_arg2335z00_2676 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 442 */
																	long BgL_auxz00_3835;

																	BgL_auxz00_3835 =
																		(long) (BgL_arg2335z00_2676);
																	BgL_restz00_2675 =
																		(BgL_offsetz00_2672 % BgL_auxz00_3835);
															}}
															{	/* Cfa/specialize.scm 442 */

																BgL_method3373z00_2665 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2670,
																		(int) (BgL_modz00_2673)),
																	(int) (BgL_restz00_2675));
								}}}}}}}}
								BgL_arg3743z00_1679 =
									PROCEDURE_ENTRY(BgL_method3373z00_2665)
									(BgL_method3373z00_2665, (obj_t) (BgL_arg3744z00_1680), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3845;

							BgL_auxz00_3845 = (BgL_nodez00_bglt) (BgL_arg3743z00_1679);
							((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1673))->
									BgL_valuez00) =
								((BgL_nodez00_bglt) BgL_auxz00_3845), BUNSPEC);
					}}
					BgL_auxz00_3795 = BgL_nodez00_1673;
					return (obj_t) (BgL_auxz00_3795);
				}
			}
		}
	}



/* patch!-set-ex-it3406 */
	obj_t BGl_patchz12zd2setzd2exzd2it3406zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2929, obj_t BgL_nodez00_2930)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 430 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1664;

				{	/* Cfa/specialize.scm 431 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_3850;

					BgL_nodez00_1664 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2930);
					{	/* Cfa/specialize.scm 432 */
						obj_t BgL_arg3737z00_1668;

						{	/* Cfa/specialize.scm 432 */
							BgL_nodez00_bglt BgL_arg3738z00_1669;

							BgL_arg3738z00_1669 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1664))->
								BgL_bodyz00);
							{	/* Cfa/specialize.scm 432 */
								obj_t BgL_method3373z00_2580;

								{	/* Cfa/specialize.scm 432 */
									BgL_objectz00_bglt BgL_objz00_2581;

									BgL_objz00_2581 = (BgL_objectz00_bglt) (BgL_arg3738z00_1669);
									{	/* Cfa/specialize.scm 432 */
										long BgL_objzd2classzd2numz00_2582;

										BgL_objzd2classzd2numz00_2582 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2581);
										{	/* Cfa/specialize.scm 432 */
											obj_t BgL_arg2334z00_2583;

											BgL_arg2334z00_2583 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 432 */
												obj_t BgL_arrayz00_2585;

												int BgL_offsetz00_2586;

												BgL_arrayz00_2585 = BgL_arg2334z00_2583;
												BgL_offsetz00_2586 =
													(int) (BgL_objzd2classzd2numz00_2582);
												{	/* Cfa/specialize.scm 432 */
													long BgL_offsetz00_2587;

													BgL_offsetz00_2587 =
														((long) (BgL_offsetz00_2586) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 432 */
														long BgL_modz00_2588;

														{	/* Cfa/specialize.scm 432 */
															int BgL_arg2336z00_2589;

															BgL_arg2336z00_2589 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 432 */
																long BgL_auxz00_3860;

																BgL_auxz00_3860 = (long) (BgL_arg2336z00_2589);
																BgL_modz00_2588 =
																	(BgL_offsetz00_2587 / BgL_auxz00_3860);
														}}
														{	/* Cfa/specialize.scm 432 */
															long BgL_restz00_2590;

															{	/* Cfa/specialize.scm 432 */
																int BgL_arg2335z00_2591;

																BgL_arg2335z00_2591 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 432 */
																	long BgL_auxz00_3864;

																	BgL_auxz00_3864 =
																		(long) (BgL_arg2335z00_2591);
																	BgL_restz00_2590 =
																		(BgL_offsetz00_2587 % BgL_auxz00_3864);
															}}
															{	/* Cfa/specialize.scm 432 */

																BgL_method3373z00_2580 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2585,
																		(int) (BgL_modz00_2588)),
																	(int) (BgL_restz00_2590));
								}}}}}}}}
								BgL_arg3737z00_1668 =
									PROCEDURE_ENTRY(BgL_method3373z00_2580)
									(BgL_method3373z00_2580, (obj_t) (BgL_arg3738z00_1669), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3874;

							BgL_auxz00_3874 = (BgL_nodez00_bglt) (BgL_arg3737z00_1668);
							((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1664))->
									BgL_bodyz00) = ((BgL_nodez00_bglt) BgL_auxz00_3874), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 433 */
						BgL_varz00_bglt BgL_arg3739z00_1670;

						BgL_arg3739z00_1670 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1664))->
							BgL_varz00);
						{	/* Cfa/specialize.scm 433 */
							BgL_nodez00_bglt BgL_nodez00_2608;

							BgL_nodez00_2608 = (BgL_nodez00_bglt) (BgL_arg3739z00_1670);
							{	/* Cfa/specialize.scm 433 */
								obj_t BgL_method3373z00_2609;

								{	/* Cfa/specialize.scm 433 */
									BgL_objectz00_bglt BgL_objz00_2610;

									BgL_objz00_2610 = (BgL_objectz00_bglt) (BgL_nodez00_2608);
									{	/* Cfa/specialize.scm 433 */
										long BgL_objzd2classzd2numz00_2611;

										BgL_objzd2classzd2numz00_2611 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2610);
										{	/* Cfa/specialize.scm 433 */
											obj_t BgL_arg2334z00_2612;

											BgL_arg2334z00_2612 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 433 */
												obj_t BgL_arrayz00_2614;

												int BgL_offsetz00_2615;

												BgL_arrayz00_2614 = BgL_arg2334z00_2612;
												BgL_offsetz00_2615 =
													(int) (BgL_objzd2classzd2numz00_2611);
												{	/* Cfa/specialize.scm 433 */
													long BgL_offsetz00_2616;

													BgL_offsetz00_2616 =
														((long) (BgL_offsetz00_2615) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 433 */
														long BgL_modz00_2617;

														{	/* Cfa/specialize.scm 433 */
															int BgL_arg2336z00_2618;

															BgL_arg2336z00_2618 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 433 */
																long BgL_auxz00_3887;

																BgL_auxz00_3887 = (long) (BgL_arg2336z00_2618);
																BgL_modz00_2617 =
																	(BgL_offsetz00_2616 / BgL_auxz00_3887);
														}}
														{	/* Cfa/specialize.scm 433 */
															long BgL_restz00_2619;

															{	/* Cfa/specialize.scm 433 */
																int BgL_arg2335z00_2620;

																BgL_arg2335z00_2620 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 433 */
																	long BgL_auxz00_3891;

																	BgL_auxz00_3891 =
																		(long) (BgL_arg2335z00_2620);
																	BgL_restz00_2619 =
																		(BgL_offsetz00_2616 % BgL_auxz00_3891);
															}}
															{	/* Cfa/specialize.scm 433 */

																BgL_method3373z00_2609 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2614,
																		(int) (BgL_modz00_2617)),
																	(int) (BgL_restz00_2619));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3373z00_2609) (BgL_method3373z00_2609,
									(obj_t) (BgL_nodez00_2608), BEOA);
					}}}
					BgL_auxz00_3850 = BgL_nodez00_1664;
					return (obj_t) (BgL_auxz00_3850);
				}
			}
		}
	}



/* patch!-let-var3404 */
	obj_t BGl_patchz12zd2letzd2var3404z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2931, obj_t BgL_nodez00_2932)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 418 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1648;

				{	/* Cfa/specialize.scm 419 */
					BgL_letzd2varzd2_bglt BgL_auxz00_3903;

					BgL_nodez00_1648 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2932);
					{	/* Cfa/specialize.scm 420 */
						obj_t BgL_g3370z00_1652;

						BgL_g3370z00_1652 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1648))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3368z00_1653;

							BgL_l3368z00_1653 = BgL_g3370z00_1652;
						BgL_forzd2each3369zd2_1654:
							if (PAIRP(BgL_l3368z00_1653))
								{	/* Cfa/specialize.scm 420 */
									{	/* Cfa/specialize.scm 421 */
										obj_t BgL_bindingz00_1656;

										BgL_bindingz00_1656 = CAR(BgL_l3368z00_1653);
										{	/* Cfa/specialize.scm 421 */
											obj_t BgL_valz00_1657;

											BgL_valz00_1657 = CDR(BgL_bindingz00_1656);
											{	/* Cfa/specialize.scm 422 */
												obj_t BgL_arg3732z00_1658;

												{	/* Cfa/specialize.scm 422 */
													BgL_nodez00_bglt BgL_nodez00_2520;

													BgL_nodez00_2520 =
														(BgL_nodez00_bglt) (BgL_valz00_1657);
													{	/* Cfa/specialize.scm 422 */
														obj_t BgL_method3373z00_2521;

														{	/* Cfa/specialize.scm 422 */
															BgL_objectz00_bglt BgL_objz00_2522;

															BgL_objz00_2522 =
																(BgL_objectz00_bglt) (BgL_nodez00_2520);
															{	/* Cfa/specialize.scm 422 */
																long BgL_objzd2classzd2numz00_2523;

																BgL_objzd2classzd2numz00_2523 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_2522);
																{	/* Cfa/specialize.scm 422 */
																	obj_t BgL_arg2334z00_2524;

																	BgL_arg2334z00_2524 =
																		PROCEDURE_REF
																		(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
																		(int) (((long) 1)));
																	{	/* Cfa/specialize.scm 422 */
																		obj_t BgL_arrayz00_2526;

																		int BgL_offsetz00_2527;

																		BgL_arrayz00_2526 = BgL_arg2334z00_2524;
																		BgL_offsetz00_2527 =
																			(int) (BgL_objzd2classzd2numz00_2523);
																		{	/* Cfa/specialize.scm 422 */
																			long BgL_offsetz00_2528;

																			BgL_offsetz00_2528 =
																				(
																				(long) (BgL_offsetz00_2527) -
																				OBJECT_TYPE);
																			{	/* Cfa/specialize.scm 422 */
																				long BgL_modz00_2529;

																				{	/* Cfa/specialize.scm 422 */
																					int BgL_arg2336z00_2530;

																					BgL_arg2336z00_2530 =
																						(int) (((long) 8));
																					{	/* Cfa/specialize.scm 422 */
																						long BgL_auxz00_3918;

																						BgL_auxz00_3918 =
																							(long) (BgL_arg2336z00_2530);
																						BgL_modz00_2529 =
																							(BgL_offsetz00_2528 /
																							BgL_auxz00_3918);
																				}}
																				{	/* Cfa/specialize.scm 422 */
																					long BgL_restz00_2531;

																					{	/* Cfa/specialize.scm 422 */
																						int BgL_arg2335z00_2532;

																						BgL_arg2335z00_2532 =
																							(int) (((long) 8));
																						{	/* Cfa/specialize.scm 422 */
																							long BgL_auxz00_3922;

																							BgL_auxz00_3922 =
																								(long) (BgL_arg2335z00_2532);
																							BgL_restz00_2531 =
																								(BgL_offsetz00_2528 %
																								BgL_auxz00_3922);
																					}}
																					{	/* Cfa/specialize.scm 422 */

																						BgL_method3373z00_2521 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_2526,
																								(int) (BgL_modz00_2529)),
																							(int) (BgL_restz00_2531));
														}}}}}}}}
														BgL_arg3732z00_1658 =
															PROCEDURE_ENTRY(BgL_method3373z00_2521)
															(BgL_method3373z00_2521,
															(obj_t) (BgL_nodez00_2520), BEOA);
												}}
												SET_CDR(BgL_bindingz00_1656, BgL_arg3732z00_1658);
									}}}
									{
										obj_t BgL_l3368z00_3933;

										BgL_l3368z00_3933 = CDR(BgL_l3368z00_1653);
										BgL_l3368z00_1653 = BgL_l3368z00_3933;
										goto BgL_forzd2each3369zd2_1654;
									}
								}
							else
								{	/* Cfa/specialize.scm 420 */
									((bool_t) 1);
								}
						}
					}
					{	/* Cfa/specialize.scm 424 */
						obj_t BgL_arg3734z00_1660;

						{	/* Cfa/specialize.scm 424 */
							BgL_nodez00_bglt BgL_arg3735z00_1661;

							BgL_arg3735z00_1661 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1648))->BgL_bodyz00);
							{	/* Cfa/specialize.scm 424 */
								obj_t BgL_method3373z00_2551;

								{	/* Cfa/specialize.scm 424 */
									BgL_objectz00_bglt BgL_objz00_2552;

									BgL_objz00_2552 = (BgL_objectz00_bglt) (BgL_arg3735z00_1661);
									{	/* Cfa/specialize.scm 424 */
										long BgL_objzd2classzd2numz00_2553;

										BgL_objzd2classzd2numz00_2553 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2552);
										{	/* Cfa/specialize.scm 424 */
											obj_t BgL_arg2334z00_2554;

											BgL_arg2334z00_2554 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 424 */
												obj_t BgL_arrayz00_2556;

												int BgL_offsetz00_2557;

												BgL_arrayz00_2556 = BgL_arg2334z00_2554;
												BgL_offsetz00_2557 =
													(int) (BgL_objzd2classzd2numz00_2553);
												{	/* Cfa/specialize.scm 424 */
													long BgL_offsetz00_2558;

													BgL_offsetz00_2558 =
														((long) (BgL_offsetz00_2557) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 424 */
														long BgL_modz00_2559;

														{	/* Cfa/specialize.scm 424 */
															int BgL_arg2336z00_2560;

															BgL_arg2336z00_2560 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 424 */
																long BgL_auxz00_3944;

																BgL_auxz00_3944 = (long) (BgL_arg2336z00_2560);
																BgL_modz00_2559 =
																	(BgL_offsetz00_2558 / BgL_auxz00_3944);
														}}
														{	/* Cfa/specialize.scm 424 */
															long BgL_restz00_2561;

															{	/* Cfa/specialize.scm 424 */
																int BgL_arg2335z00_2562;

																BgL_arg2335z00_2562 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 424 */
																	long BgL_auxz00_3948;

																	BgL_auxz00_3948 =
																		(long) (BgL_arg2335z00_2562);
																	BgL_restz00_2561 =
																		(BgL_offsetz00_2558 % BgL_auxz00_3948);
															}}
															{	/* Cfa/specialize.scm 424 */

																BgL_method3373z00_2551 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2556,
																		(int) (BgL_modz00_2559)),
																	(int) (BgL_restz00_2561));
								}}}}}}}}
								BgL_arg3734z00_1660 =
									PROCEDURE_ENTRY(BgL_method3373z00_2551)
									(BgL_method3373z00_2551, (obj_t) (BgL_arg3735z00_1661), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3958;

							BgL_auxz00_3958 = (BgL_nodez00_bglt) (BgL_arg3734z00_1660);
							((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1648))->BgL_bodyz00) =
								((BgL_nodez00_bglt) BgL_auxz00_3958), BUNSPEC);
					}}
					BgL_auxz00_3903 = BgL_nodez00_1648;
					return (obj_t) (BgL_auxz00_3903);
				}
			}
		}
	}



/* patch!-let-fun3402 */
	obj_t BGl_patchz12zd2letzd2fun3402z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2933, obj_t BgL_nodez00_2934)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 409 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1634;

				{	/* Cfa/specialize.scm 410 */
					BgL_letzd2funzd2_bglt BgL_auxz00_3963;

					BgL_nodez00_1634 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2934);
					{	/* Cfa/specialize.scm 411 */
						obj_t BgL_g3367z00_1638;

						BgL_g3367z00_1638 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1634))->BgL_localsz00);
						{
							obj_t BgL_l3364z00_1639;

							BgL_l3364z00_1639 = BgL_g3367z00_1638;
						BgL_forzd2each3366zd2_1640:
							if (PAIRP(BgL_l3364z00_1639))
								{	/* Cfa/specialize.scm 411 */
									BGl_patchzd2funz12zc0zzcfa_specializa7eza7(CAR
										(BgL_l3364z00_1639));
									{
										obj_t BgL_l3364z00_3969;

										BgL_l3364z00_3969 = CDR(BgL_l3364z00_1639);
										BgL_l3364z00_1639 = BgL_l3364z00_3969;
										goto BgL_forzd2each3366zd2_1640;
									}
								}
							else
								{	/* Cfa/specialize.scm 411 */
									((bool_t) 1);
								}
						}
					}
					{	/* Cfa/specialize.scm 412 */
						obj_t BgL_arg3728z00_1644;

						{	/* Cfa/specialize.scm 412 */
							BgL_nodez00_bglt BgL_arg3729z00_1645;

							BgL_arg3729z00_1645 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1634))->BgL_bodyz00);
							{	/* Cfa/specialize.scm 412 */
								obj_t BgL_method3373z00_2489;

								{	/* Cfa/specialize.scm 412 */
									BgL_objectz00_bglt BgL_objz00_2490;

									BgL_objz00_2490 = (BgL_objectz00_bglt) (BgL_arg3729z00_1645);
									{	/* Cfa/specialize.scm 412 */
										long BgL_objzd2classzd2numz00_2491;

										BgL_objzd2classzd2numz00_2491 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2490);
										{	/* Cfa/specialize.scm 412 */
											obj_t BgL_arg2334z00_2492;

											BgL_arg2334z00_2492 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 412 */
												obj_t BgL_arrayz00_2494;

												int BgL_offsetz00_2495;

												BgL_arrayz00_2494 = BgL_arg2334z00_2492;
												BgL_offsetz00_2495 =
													(int) (BgL_objzd2classzd2numz00_2491);
												{	/* Cfa/specialize.scm 412 */
													long BgL_offsetz00_2496;

													BgL_offsetz00_2496 =
														((long) (BgL_offsetz00_2495) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 412 */
														long BgL_modz00_2497;

														{	/* Cfa/specialize.scm 412 */
															int BgL_arg2336z00_2498;

															BgL_arg2336z00_2498 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 412 */
																long BgL_auxz00_3980;

																BgL_auxz00_3980 = (long) (BgL_arg2336z00_2498);
																BgL_modz00_2497 =
																	(BgL_offsetz00_2496 / BgL_auxz00_3980);
														}}
														{	/* Cfa/specialize.scm 412 */
															long BgL_restz00_2499;

															{	/* Cfa/specialize.scm 412 */
																int BgL_arg2335z00_2500;

																BgL_arg2335z00_2500 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 412 */
																	long BgL_auxz00_3984;

																	BgL_auxz00_3984 =
																		(long) (BgL_arg2335z00_2500);
																	BgL_restz00_2499 =
																		(BgL_offsetz00_2496 % BgL_auxz00_3984);
															}}
															{	/* Cfa/specialize.scm 412 */

																BgL_method3373z00_2489 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2494,
																		(int) (BgL_modz00_2497)),
																	(int) (BgL_restz00_2499));
								}}}}}}}}
								BgL_arg3728z00_1644 =
									PROCEDURE_ENTRY(BgL_method3373z00_2489)
									(BgL_method3373z00_2489, (obj_t) (BgL_arg3729z00_1645), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_3994;

							BgL_auxz00_3994 = (BgL_nodez00_bglt) (BgL_arg3728z00_1644);
							((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1634))->BgL_bodyz00) =
								((BgL_nodez00_bglt) BgL_auxz00_3994), BUNSPEC);
					}}
					BgL_auxz00_3963 = BgL_nodez00_1634;
					return (obj_t) (BgL_auxz00_3963);
				}
			}
		}
	}



/* patch!-select3400 */
	obj_t BGl_patchz12zd2select3400zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2935,
		obj_t BgL_nodez00_2936)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 398 */
			{
				BgL_selectz00_bglt BgL_nodez00_1618;

				{	/* Cfa/specialize.scm 399 */
					BgL_selectz00_bglt BgL_auxz00_3999;

					BgL_nodez00_1618 = (BgL_selectz00_bglt) (BgL_nodez00_2936);
					{	/* Cfa/specialize.scm 400 */
						obj_t BgL_arg3718z00_1622;

						{	/* Cfa/specialize.scm 400 */
							BgL_nodez00_bglt BgL_arg3719z00_1623;

							BgL_arg3719z00_1623 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1618))->BgL_testz00);
							{	/* Cfa/specialize.scm 400 */
								obj_t BgL_method3373z00_2423;

								{	/* Cfa/specialize.scm 400 */
									BgL_objectz00_bglt BgL_objz00_2424;

									BgL_objz00_2424 = (BgL_objectz00_bglt) (BgL_arg3719z00_1623);
									{	/* Cfa/specialize.scm 400 */
										long BgL_objzd2classzd2numz00_2425;

										BgL_objzd2classzd2numz00_2425 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2424);
										{	/* Cfa/specialize.scm 400 */
											obj_t BgL_arg2334z00_2426;

											BgL_arg2334z00_2426 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 400 */
												obj_t BgL_arrayz00_2428;

												int BgL_offsetz00_2429;

												BgL_arrayz00_2428 = BgL_arg2334z00_2426;
												BgL_offsetz00_2429 =
													(int) (BgL_objzd2classzd2numz00_2425);
												{	/* Cfa/specialize.scm 400 */
													long BgL_offsetz00_2430;

													BgL_offsetz00_2430 =
														((long) (BgL_offsetz00_2429) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 400 */
														long BgL_modz00_2431;

														{	/* Cfa/specialize.scm 400 */
															int BgL_arg2336z00_2432;

															BgL_arg2336z00_2432 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 400 */
																long BgL_auxz00_4009;

																BgL_auxz00_4009 = (long) (BgL_arg2336z00_2432);
																BgL_modz00_2431 =
																	(BgL_offsetz00_2430 / BgL_auxz00_4009);
														}}
														{	/* Cfa/specialize.scm 400 */
															long BgL_restz00_2433;

															{	/* Cfa/specialize.scm 400 */
																int BgL_arg2335z00_2434;

																BgL_arg2335z00_2434 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 400 */
																	long BgL_auxz00_4013;

																	BgL_auxz00_4013 =
																		(long) (BgL_arg2335z00_2434);
																	BgL_restz00_2433 =
																		(BgL_offsetz00_2430 % BgL_auxz00_4013);
															}}
															{	/* Cfa/specialize.scm 400 */

																BgL_method3373z00_2423 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2428,
																		(int) (BgL_modz00_2431)),
																	(int) (BgL_restz00_2433));
								}}}}}}}}
								BgL_arg3718z00_1622 =
									PROCEDURE_ENTRY(BgL_method3373z00_2423)
									(BgL_method3373z00_2423, (obj_t) (BgL_arg3719z00_1623), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4023;

							BgL_auxz00_4023 = (BgL_nodez00_bglt) (BgL_arg3718z00_1622);
							((((BgL_selectz00_bglt) CREF(BgL_nodez00_1618))->BgL_testz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4023), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 401 */
						obj_t BgL_g3363z00_1624;

						BgL_g3363z00_1624 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1618))->BgL_clausesz00);
						{
							obj_t BgL_l3361z00_1625;

							BgL_l3361z00_1625 = BgL_g3363z00_1624;
						BgL_forzd2each3362zd2_1626:
							if (PAIRP(BgL_l3361z00_1625))
								{	/* Cfa/specialize.scm 401 */
									{	/* Cfa/specialize.scm 402 */
										obj_t BgL_clausez00_1628;

										BgL_clausez00_1628 = CAR(BgL_l3361z00_1625);
										{	/* Cfa/specialize.scm 402 */
											obj_t BgL_arg3721z00_1629;

											{	/* Cfa/specialize.scm 402 */
												obj_t BgL_arg3722z00_1630;

												BgL_arg3722z00_1630 = CDR(BgL_clausez00_1628);
												{	/* Cfa/specialize.scm 402 */
													BgL_nodez00_bglt BgL_nodez00_2454;

													BgL_nodez00_2454 =
														(BgL_nodez00_bglt) (BgL_arg3722z00_1630);
													{	/* Cfa/specialize.scm 402 */
														obj_t BgL_method3373z00_2455;

														{	/* Cfa/specialize.scm 402 */
															BgL_objectz00_bglt BgL_objz00_2456;

															BgL_objz00_2456 =
																(BgL_objectz00_bglt) (BgL_nodez00_2454);
															{	/* Cfa/specialize.scm 402 */
																long BgL_objzd2classzd2numz00_2457;

																BgL_objzd2classzd2numz00_2457 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_2456);
																{	/* Cfa/specialize.scm 402 */
																	obj_t BgL_arg2334z00_2458;

																	BgL_arg2334z00_2458 =
																		PROCEDURE_REF
																		(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
																		(int) (((long) 1)));
																	{	/* Cfa/specialize.scm 402 */
																		obj_t BgL_arrayz00_2460;

																		int BgL_offsetz00_2461;

																		BgL_arrayz00_2460 = BgL_arg2334z00_2458;
																		BgL_offsetz00_2461 =
																			(int) (BgL_objzd2classzd2numz00_2457);
																		{	/* Cfa/specialize.scm 402 */
																			long BgL_offsetz00_2462;

																			BgL_offsetz00_2462 =
																				(
																				(long) (BgL_offsetz00_2461) -
																				OBJECT_TYPE);
																			{	/* Cfa/specialize.scm 402 */
																				long BgL_modz00_2463;

																				{	/* Cfa/specialize.scm 402 */
																					int BgL_arg2336z00_2464;

																					BgL_arg2336z00_2464 =
																						(int) (((long) 8));
																					{	/* Cfa/specialize.scm 402 */
																						long BgL_auxz00_4040;

																						BgL_auxz00_4040 =
																							(long) (BgL_arg2336z00_2464);
																						BgL_modz00_2463 =
																							(BgL_offsetz00_2462 /
																							BgL_auxz00_4040);
																				}}
																				{	/* Cfa/specialize.scm 402 */
																					long BgL_restz00_2465;

																					{	/* Cfa/specialize.scm 402 */
																						int BgL_arg2335z00_2466;

																						BgL_arg2335z00_2466 =
																							(int) (((long) 8));
																						{	/* Cfa/specialize.scm 402 */
																							long BgL_auxz00_4044;

																							BgL_auxz00_4044 =
																								(long) (BgL_arg2335z00_2466);
																							BgL_restz00_2465 =
																								(BgL_offsetz00_2462 %
																								BgL_auxz00_4044);
																					}}
																					{	/* Cfa/specialize.scm 402 */

																						BgL_method3373z00_2455 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_2460,
																								(int) (BgL_modz00_2463)),
																							(int) (BgL_restz00_2465));
														}}}}}}}}
														BgL_arg3721z00_1629 =
															PROCEDURE_ENTRY(BgL_method3373z00_2455)
															(BgL_method3373z00_2455,
															(obj_t) (BgL_nodez00_2454), BEOA);
											}}}
											SET_CDR(BgL_clausez00_1628, BgL_arg3721z00_1629);
									}}
									{
										obj_t BgL_l3361z00_4055;

										BgL_l3361z00_4055 = CDR(BgL_l3361z00_1625);
										BgL_l3361z00_1625 = BgL_l3361z00_4055;
										goto BgL_forzd2each3362zd2_1626;
									}
								}
							else
								{	/* Cfa/specialize.scm 401 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3999 = BgL_nodez00_1618;
					return (obj_t) (BgL_auxz00_3999);
				}
			}
		}
	}



/* patch!-fail3398 */
	obj_t BGl_patchz12zd2fail3398zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2937,
		obj_t BgL_nodez00_2938)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 388 */
			{
				BgL_failz00_bglt BgL_nodez00_1606;

				{	/* Cfa/specialize.scm 389 */
					BgL_failz00_bglt BgL_auxz00_4059;

					BgL_nodez00_1606 = (BgL_failz00_bglt) (BgL_nodez00_2938);
					{	/* Cfa/specialize.scm 390 */
						obj_t BgL_arg3711z00_1610;

						{	/* Cfa/specialize.scm 390 */
							BgL_nodez00_bglt BgL_arg3712z00_1611;

							BgL_arg3712z00_1611 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1606))->BgL_procz00);
							{	/* Cfa/specialize.scm 390 */
								obj_t BgL_method3373z00_2336;

								{	/* Cfa/specialize.scm 390 */
									BgL_objectz00_bglt BgL_objz00_2337;

									BgL_objz00_2337 = (BgL_objectz00_bglt) (BgL_arg3712z00_1611);
									{	/* Cfa/specialize.scm 390 */
										long BgL_objzd2classzd2numz00_2338;

										BgL_objzd2classzd2numz00_2338 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2337);
										{	/* Cfa/specialize.scm 390 */
											obj_t BgL_arg2334z00_2339;

											BgL_arg2334z00_2339 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 390 */
												obj_t BgL_arrayz00_2341;

												int BgL_offsetz00_2342;

												BgL_arrayz00_2341 = BgL_arg2334z00_2339;
												BgL_offsetz00_2342 =
													(int) (BgL_objzd2classzd2numz00_2338);
												{	/* Cfa/specialize.scm 390 */
													long BgL_offsetz00_2343;

													BgL_offsetz00_2343 =
														((long) (BgL_offsetz00_2342) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 390 */
														long BgL_modz00_2344;

														{	/* Cfa/specialize.scm 390 */
															int BgL_arg2336z00_2345;

															BgL_arg2336z00_2345 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 390 */
																long BgL_auxz00_4069;

																BgL_auxz00_4069 = (long) (BgL_arg2336z00_2345);
																BgL_modz00_2344 =
																	(BgL_offsetz00_2343 / BgL_auxz00_4069);
														}}
														{	/* Cfa/specialize.scm 390 */
															long BgL_restz00_2346;

															{	/* Cfa/specialize.scm 390 */
																int BgL_arg2335z00_2347;

																BgL_arg2335z00_2347 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 390 */
																	long BgL_auxz00_4073;

																	BgL_auxz00_4073 =
																		(long) (BgL_arg2335z00_2347);
																	BgL_restz00_2346 =
																		(BgL_offsetz00_2343 % BgL_auxz00_4073);
															}}
															{	/* Cfa/specialize.scm 390 */

																BgL_method3373z00_2336 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2341,
																		(int) (BgL_modz00_2344)),
																	(int) (BgL_restz00_2346));
								}}}}}}}}
								BgL_arg3711z00_1610 =
									PROCEDURE_ENTRY(BgL_method3373z00_2336)
									(BgL_method3373z00_2336, (obj_t) (BgL_arg3712z00_1611), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4083;

							BgL_auxz00_4083 = (BgL_nodez00_bglt) (BgL_arg3711z00_1610);
							((((BgL_failz00_bglt) CREF(BgL_nodez00_1606))->BgL_procz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4083), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 391 */
						obj_t BgL_arg3713z00_1612;

						{	/* Cfa/specialize.scm 391 */
							BgL_nodez00_bglt BgL_arg3714z00_1613;

							BgL_arg3714z00_1613 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1606))->BgL_msgz00);
							{	/* Cfa/specialize.scm 391 */
								obj_t BgL_method3373z00_2365;

								{	/* Cfa/specialize.scm 391 */
									BgL_objectz00_bglt BgL_objz00_2366;

									BgL_objz00_2366 = (BgL_objectz00_bglt) (BgL_arg3714z00_1613);
									{	/* Cfa/specialize.scm 391 */
										long BgL_objzd2classzd2numz00_2367;

										BgL_objzd2classzd2numz00_2367 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2366);
										{	/* Cfa/specialize.scm 391 */
											obj_t BgL_arg2334z00_2368;

											BgL_arg2334z00_2368 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 391 */
												obj_t BgL_arrayz00_2370;

												int BgL_offsetz00_2371;

												BgL_arrayz00_2370 = BgL_arg2334z00_2368;
												BgL_offsetz00_2371 =
													(int) (BgL_objzd2classzd2numz00_2367);
												{	/* Cfa/specialize.scm 391 */
													long BgL_offsetz00_2372;

													BgL_offsetz00_2372 =
														((long) (BgL_offsetz00_2371) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 391 */
														long BgL_modz00_2373;

														{	/* Cfa/specialize.scm 391 */
															int BgL_arg2336z00_2374;

															BgL_arg2336z00_2374 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 391 */
																long BgL_auxz00_4095;

																BgL_auxz00_4095 = (long) (BgL_arg2336z00_2374);
																BgL_modz00_2373 =
																	(BgL_offsetz00_2372 / BgL_auxz00_4095);
														}}
														{	/* Cfa/specialize.scm 391 */
															long BgL_restz00_2375;

															{	/* Cfa/specialize.scm 391 */
																int BgL_arg2335z00_2376;

																BgL_arg2335z00_2376 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 391 */
																	long BgL_auxz00_4099;

																	BgL_auxz00_4099 =
																		(long) (BgL_arg2335z00_2376);
																	BgL_restz00_2375 =
																		(BgL_offsetz00_2372 % BgL_auxz00_4099);
															}}
															{	/* Cfa/specialize.scm 391 */

																BgL_method3373z00_2365 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2370,
																		(int) (BgL_modz00_2373)),
																	(int) (BgL_restz00_2375));
								}}}}}}}}
								BgL_arg3713z00_1612 =
									PROCEDURE_ENTRY(BgL_method3373z00_2365)
									(BgL_method3373z00_2365, (obj_t) (BgL_arg3714z00_1613), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4109;

							BgL_auxz00_4109 = (BgL_nodez00_bglt) (BgL_arg3713z00_1612);
							((((BgL_failz00_bglt) CREF(BgL_nodez00_1606))->BgL_msgz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4109), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 392 */
						obj_t BgL_arg3715z00_1614;

						{	/* Cfa/specialize.scm 392 */
							BgL_nodez00_bglt BgL_arg3716z00_1615;

							BgL_arg3716z00_1615 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1606))->BgL_objz00);
							{	/* Cfa/specialize.scm 392 */
								obj_t BgL_method3373z00_2394;

								{	/* Cfa/specialize.scm 392 */
									BgL_objectz00_bglt BgL_objz00_2395;

									BgL_objz00_2395 = (BgL_objectz00_bglt) (BgL_arg3716z00_1615);
									{	/* Cfa/specialize.scm 392 */
										long BgL_objzd2classzd2numz00_2396;

										BgL_objzd2classzd2numz00_2396 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2395);
										{	/* Cfa/specialize.scm 392 */
											obj_t BgL_arg2334z00_2397;

											BgL_arg2334z00_2397 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 392 */
												obj_t BgL_arrayz00_2399;

												int BgL_offsetz00_2400;

												BgL_arrayz00_2399 = BgL_arg2334z00_2397;
												BgL_offsetz00_2400 =
													(int) (BgL_objzd2classzd2numz00_2396);
												{	/* Cfa/specialize.scm 392 */
													long BgL_offsetz00_2401;

													BgL_offsetz00_2401 =
														((long) (BgL_offsetz00_2400) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 392 */
														long BgL_modz00_2402;

														{	/* Cfa/specialize.scm 392 */
															int BgL_arg2336z00_2403;

															BgL_arg2336z00_2403 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 392 */
																long BgL_auxz00_4121;

																BgL_auxz00_4121 = (long) (BgL_arg2336z00_2403);
																BgL_modz00_2402 =
																	(BgL_offsetz00_2401 / BgL_auxz00_4121);
														}}
														{	/* Cfa/specialize.scm 392 */
															long BgL_restz00_2404;

															{	/* Cfa/specialize.scm 392 */
																int BgL_arg2335z00_2405;

																BgL_arg2335z00_2405 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 392 */
																	long BgL_auxz00_4125;

																	BgL_auxz00_4125 =
																		(long) (BgL_arg2335z00_2405);
																	BgL_restz00_2404 =
																		(BgL_offsetz00_2401 % BgL_auxz00_4125);
															}}
															{	/* Cfa/specialize.scm 392 */

																BgL_method3373z00_2394 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2399,
																		(int) (BgL_modz00_2402)),
																	(int) (BgL_restz00_2404));
								}}}}}}}}
								BgL_arg3715z00_1614 =
									PROCEDURE_ENTRY(BgL_method3373z00_2394)
									(BgL_method3373z00_2394, (obj_t) (BgL_arg3716z00_1615), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4135;

							BgL_auxz00_4135 = (BgL_nodez00_bglt) (BgL_arg3715z00_1614);
							((((BgL_failz00_bglt) CREF(BgL_nodez00_1606))->BgL_objz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4135), BUNSPEC);
					}}
					BgL_auxz00_4059 = BgL_nodez00_1606;
					return (obj_t) (BgL_auxz00_4059);
				}
			}
		}
	}



/* patch!-conditional3396 */
	obj_t BGl_patchz12zd2conditional3396zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2939, obj_t BgL_nodez00_2940)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 378 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1594;

				{	/* Cfa/specialize.scm 379 */
					BgL_conditionalz00_bglt BgL_auxz00_4140;

					BgL_nodez00_1594 = (BgL_conditionalz00_bglt) (BgL_nodez00_2940);
					{	/* Cfa/specialize.scm 380 */
						obj_t BgL_arg3703z00_1598;

						{	/* Cfa/specialize.scm 380 */
							BgL_nodez00_bglt BgL_arg3704z00_1599;

							BgL_arg3704z00_1599 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1594))->
								BgL_testz00);
							{	/* Cfa/specialize.scm 380 */
								obj_t BgL_method3373z00_2249;

								{	/* Cfa/specialize.scm 380 */
									BgL_objectz00_bglt BgL_objz00_2250;

									BgL_objz00_2250 = (BgL_objectz00_bglt) (BgL_arg3704z00_1599);
									{	/* Cfa/specialize.scm 380 */
										long BgL_objzd2classzd2numz00_2251;

										BgL_objzd2classzd2numz00_2251 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2250);
										{	/* Cfa/specialize.scm 380 */
											obj_t BgL_arg2334z00_2252;

											BgL_arg2334z00_2252 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 380 */
												obj_t BgL_arrayz00_2254;

												int BgL_offsetz00_2255;

												BgL_arrayz00_2254 = BgL_arg2334z00_2252;
												BgL_offsetz00_2255 =
													(int) (BgL_objzd2classzd2numz00_2251);
												{	/* Cfa/specialize.scm 380 */
													long BgL_offsetz00_2256;

													BgL_offsetz00_2256 =
														((long) (BgL_offsetz00_2255) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 380 */
														long BgL_modz00_2257;

														{	/* Cfa/specialize.scm 380 */
															int BgL_arg2336z00_2258;

															BgL_arg2336z00_2258 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 380 */
																long BgL_auxz00_4150;

																BgL_auxz00_4150 = (long) (BgL_arg2336z00_2258);
																BgL_modz00_2257 =
																	(BgL_offsetz00_2256 / BgL_auxz00_4150);
														}}
														{	/* Cfa/specialize.scm 380 */
															long BgL_restz00_2259;

															{	/* Cfa/specialize.scm 380 */
																int BgL_arg2335z00_2260;

																BgL_arg2335z00_2260 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 380 */
																	long BgL_auxz00_4154;

																	BgL_auxz00_4154 =
																		(long) (BgL_arg2335z00_2260);
																	BgL_restz00_2259 =
																		(BgL_offsetz00_2256 % BgL_auxz00_4154);
															}}
															{	/* Cfa/specialize.scm 380 */

																BgL_method3373z00_2249 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2254,
																		(int) (BgL_modz00_2257)),
																	(int) (BgL_restz00_2259));
								}}}}}}}}
								BgL_arg3703z00_1598 =
									PROCEDURE_ENTRY(BgL_method3373z00_2249)
									(BgL_method3373z00_2249, (obj_t) (BgL_arg3704z00_1599), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4164;

							BgL_auxz00_4164 = (BgL_nodez00_bglt) (BgL_arg3703z00_1598);
							((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1594))->
									BgL_testz00) = ((BgL_nodez00_bglt) BgL_auxz00_4164), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 381 */
						obj_t BgL_arg3705z00_1600;

						{	/* Cfa/specialize.scm 381 */
							BgL_nodez00_bglt BgL_arg3706z00_1601;

							BgL_arg3706z00_1601 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1594))->
								BgL_truez00);
							{	/* Cfa/specialize.scm 381 */
								obj_t BgL_method3373z00_2278;

								{	/* Cfa/specialize.scm 381 */
									BgL_objectz00_bglt BgL_objz00_2279;

									BgL_objz00_2279 = (BgL_objectz00_bglt) (BgL_arg3706z00_1601);
									{	/* Cfa/specialize.scm 381 */
										long BgL_objzd2classzd2numz00_2280;

										BgL_objzd2classzd2numz00_2280 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2279);
										{	/* Cfa/specialize.scm 381 */
											obj_t BgL_arg2334z00_2281;

											BgL_arg2334z00_2281 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 381 */
												obj_t BgL_arrayz00_2283;

												int BgL_offsetz00_2284;

												BgL_arrayz00_2283 = BgL_arg2334z00_2281;
												BgL_offsetz00_2284 =
													(int) (BgL_objzd2classzd2numz00_2280);
												{	/* Cfa/specialize.scm 381 */
													long BgL_offsetz00_2285;

													BgL_offsetz00_2285 =
														((long) (BgL_offsetz00_2284) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 381 */
														long BgL_modz00_2286;

														{	/* Cfa/specialize.scm 381 */
															int BgL_arg2336z00_2287;

															BgL_arg2336z00_2287 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 381 */
																long BgL_auxz00_4176;

																BgL_auxz00_4176 = (long) (BgL_arg2336z00_2287);
																BgL_modz00_2286 =
																	(BgL_offsetz00_2285 / BgL_auxz00_4176);
														}}
														{	/* Cfa/specialize.scm 381 */
															long BgL_restz00_2288;

															{	/* Cfa/specialize.scm 381 */
																int BgL_arg2335z00_2289;

																BgL_arg2335z00_2289 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 381 */
																	long BgL_auxz00_4180;

																	BgL_auxz00_4180 =
																		(long) (BgL_arg2335z00_2289);
																	BgL_restz00_2288 =
																		(BgL_offsetz00_2285 % BgL_auxz00_4180);
															}}
															{	/* Cfa/specialize.scm 381 */

																BgL_method3373z00_2278 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2283,
																		(int) (BgL_modz00_2286)),
																	(int) (BgL_restz00_2288));
								}}}}}}}}
								BgL_arg3705z00_1600 =
									PROCEDURE_ENTRY(BgL_method3373z00_2278)
									(BgL_method3373z00_2278, (obj_t) (BgL_arg3706z00_1601), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4190;

							BgL_auxz00_4190 = (BgL_nodez00_bglt) (BgL_arg3705z00_1600);
							((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1594))->
									BgL_truez00) = ((BgL_nodez00_bglt) BgL_auxz00_4190), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 382 */
						obj_t BgL_arg3707z00_1602;

						{	/* Cfa/specialize.scm 382 */
							BgL_nodez00_bglt BgL_arg3708z00_1603;

							BgL_arg3708z00_1603 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1594))->
								BgL_falsez00);
							{	/* Cfa/specialize.scm 382 */
								obj_t BgL_method3373z00_2307;

								{	/* Cfa/specialize.scm 382 */
									BgL_objectz00_bglt BgL_objz00_2308;

									BgL_objz00_2308 = (BgL_objectz00_bglt) (BgL_arg3708z00_1603);
									{	/* Cfa/specialize.scm 382 */
										long BgL_objzd2classzd2numz00_2309;

										BgL_objzd2classzd2numz00_2309 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2308);
										{	/* Cfa/specialize.scm 382 */
											obj_t BgL_arg2334z00_2310;

											BgL_arg2334z00_2310 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 382 */
												obj_t BgL_arrayz00_2312;

												int BgL_offsetz00_2313;

												BgL_arrayz00_2312 = BgL_arg2334z00_2310;
												BgL_offsetz00_2313 =
													(int) (BgL_objzd2classzd2numz00_2309);
												{	/* Cfa/specialize.scm 382 */
													long BgL_offsetz00_2314;

													BgL_offsetz00_2314 =
														((long) (BgL_offsetz00_2313) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 382 */
														long BgL_modz00_2315;

														{	/* Cfa/specialize.scm 382 */
															int BgL_arg2336z00_2316;

															BgL_arg2336z00_2316 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 382 */
																long BgL_auxz00_4202;

																BgL_auxz00_4202 = (long) (BgL_arg2336z00_2316);
																BgL_modz00_2315 =
																	(BgL_offsetz00_2314 / BgL_auxz00_4202);
														}}
														{	/* Cfa/specialize.scm 382 */
															long BgL_restz00_2317;

															{	/* Cfa/specialize.scm 382 */
																int BgL_arg2335z00_2318;

																BgL_arg2335z00_2318 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 382 */
																	long BgL_auxz00_4206;

																	BgL_auxz00_4206 =
																		(long) (BgL_arg2335z00_2318);
																	BgL_restz00_2317 =
																		(BgL_offsetz00_2314 % BgL_auxz00_4206);
															}}
															{	/* Cfa/specialize.scm 382 */

																BgL_method3373z00_2307 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2312,
																		(int) (BgL_modz00_2315)),
																	(int) (BgL_restz00_2317));
								}}}}}}}}
								BgL_arg3707z00_1602 =
									PROCEDURE_ENTRY(BgL_method3373z00_2307)
									(BgL_method3373z00_2307, (obj_t) (BgL_arg3708z00_1603), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4216;

							BgL_auxz00_4216 = (BgL_nodez00_bglt) (BgL_arg3707z00_1602);
							((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1594))->
									BgL_falsez00) =
								((BgL_nodez00_bglt) BgL_auxz00_4216), BUNSPEC);
					}}
					BgL_auxz00_4140 = BgL_nodez00_1594;
					return (obj_t) (BgL_auxz00_4140);
				}
			}
		}
	}



/* patch!-setq3394 */
	obj_t BGl_patchz12zd2setq3394zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2941,
		obj_t BgL_nodez00_2942)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 369 */
			{
				BgL_setqz00_bglt BgL_nodez00_1584;

				{	/* Cfa/specialize.scm 370 */
					BgL_setqz00_bglt BgL_auxz00_4221;

					BgL_nodez00_1584 = (BgL_setqz00_bglt) (BgL_nodez00_2942);
					{	/* Cfa/specialize.scm 371 */
						obj_t BgL_arg3698z00_1588;

						{	/* Cfa/specialize.scm 371 */
							BgL_nodez00_bglt BgL_arg3699z00_1589;

							BgL_arg3699z00_1589 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1584))->BgL_valuez00);
							{	/* Cfa/specialize.scm 371 */
								obj_t BgL_method3373z00_2191;

								{	/* Cfa/specialize.scm 371 */
									BgL_objectz00_bglt BgL_objz00_2192;

									BgL_objz00_2192 = (BgL_objectz00_bglt) (BgL_arg3699z00_1589);
									{	/* Cfa/specialize.scm 371 */
										long BgL_objzd2classzd2numz00_2193;

										BgL_objzd2classzd2numz00_2193 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2192);
										{	/* Cfa/specialize.scm 371 */
											obj_t BgL_arg2334z00_2194;

											BgL_arg2334z00_2194 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 371 */
												obj_t BgL_arrayz00_2196;

												int BgL_offsetz00_2197;

												BgL_arrayz00_2196 = BgL_arg2334z00_2194;
												BgL_offsetz00_2197 =
													(int) (BgL_objzd2classzd2numz00_2193);
												{	/* Cfa/specialize.scm 371 */
													long BgL_offsetz00_2198;

													BgL_offsetz00_2198 =
														((long) (BgL_offsetz00_2197) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 371 */
														long BgL_modz00_2199;

														{	/* Cfa/specialize.scm 371 */
															int BgL_arg2336z00_2200;

															BgL_arg2336z00_2200 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 371 */
																long BgL_auxz00_4231;

																BgL_auxz00_4231 = (long) (BgL_arg2336z00_2200);
																BgL_modz00_2199 =
																	(BgL_offsetz00_2198 / BgL_auxz00_4231);
														}}
														{	/* Cfa/specialize.scm 371 */
															long BgL_restz00_2201;

															{	/* Cfa/specialize.scm 371 */
																int BgL_arg2335z00_2202;

																BgL_arg2335z00_2202 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 371 */
																	long BgL_auxz00_4235;

																	BgL_auxz00_4235 =
																		(long) (BgL_arg2335z00_2202);
																	BgL_restz00_2201 =
																		(BgL_offsetz00_2198 % BgL_auxz00_4235);
															}}
															{	/* Cfa/specialize.scm 371 */

																BgL_method3373z00_2191 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2196,
																		(int) (BgL_modz00_2199)),
																	(int) (BgL_restz00_2201));
								}}}}}}}}
								BgL_arg3698z00_1588 =
									PROCEDURE_ENTRY(BgL_method3373z00_2191)
									(BgL_method3373z00_2191, (obj_t) (BgL_arg3699z00_1589), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4245;

							BgL_auxz00_4245 = (BgL_nodez00_bglt) (BgL_arg3698z00_1588);
							((((BgL_setqz00_bglt) CREF(BgL_nodez00_1584))->BgL_valuez00) =
								((BgL_nodez00_bglt) BgL_auxz00_4245), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 372 */
						obj_t BgL_arg3700z00_1590;

						{	/* Cfa/specialize.scm 372 */
							BgL_varz00_bglt BgL_arg3701z00_1591;

							BgL_arg3701z00_1591 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1584))->BgL_varz00);
							{	/* Cfa/specialize.scm 372 */
								BgL_nodez00_bglt BgL_nodez00_2219;

								BgL_nodez00_2219 = (BgL_nodez00_bglt) (BgL_arg3701z00_1591);
								{	/* Cfa/specialize.scm 372 */
									obj_t BgL_method3373z00_2220;

									{	/* Cfa/specialize.scm 372 */
										BgL_objectz00_bglt BgL_objz00_2221;

										BgL_objz00_2221 = (BgL_objectz00_bglt) (BgL_nodez00_2219);
										{	/* Cfa/specialize.scm 372 */
											long BgL_objzd2classzd2numz00_2222;

											BgL_objzd2classzd2numz00_2222 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2221);
											{	/* Cfa/specialize.scm 372 */
												obj_t BgL_arg2334z00_2223;

												BgL_arg2334z00_2223 =
													PROCEDURE_REF
													(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
													(int) (((long) 1)));
												{	/* Cfa/specialize.scm 372 */
													obj_t BgL_arrayz00_2225;

													int BgL_offsetz00_2226;

													BgL_arrayz00_2225 = BgL_arg2334z00_2223;
													BgL_offsetz00_2226 =
														(int) (BgL_objzd2classzd2numz00_2222);
													{	/* Cfa/specialize.scm 372 */
														long BgL_offsetz00_2227;

														BgL_offsetz00_2227 =
															((long) (BgL_offsetz00_2226) - OBJECT_TYPE);
														{	/* Cfa/specialize.scm 372 */
															long BgL_modz00_2228;

															{	/* Cfa/specialize.scm 372 */
																int BgL_arg2336z00_2229;

																BgL_arg2336z00_2229 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 372 */
																	long BgL_auxz00_4258;

																	BgL_auxz00_4258 =
																		(long) (BgL_arg2336z00_2229);
																	BgL_modz00_2228 =
																		(BgL_offsetz00_2227 / BgL_auxz00_4258);
															}}
															{	/* Cfa/specialize.scm 372 */
																long BgL_restz00_2230;

																{	/* Cfa/specialize.scm 372 */
																	int BgL_arg2335z00_2231;

																	BgL_arg2335z00_2231 = (int) (((long) 8));
																	{	/* Cfa/specialize.scm 372 */
																		long BgL_auxz00_4262;

																		BgL_auxz00_4262 =
																			(long) (BgL_arg2335z00_2231);
																		BgL_restz00_2230 =
																			(BgL_offsetz00_2227 % BgL_auxz00_4262);
																}}
																{	/* Cfa/specialize.scm 372 */

																	BgL_method3373z00_2220 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2225,
																			(int) (BgL_modz00_2228)),
																		(int) (BgL_restz00_2230));
									}}}}}}}}
									BgL_arg3700z00_1590 =
										PROCEDURE_ENTRY(BgL_method3373z00_2220)
										(BgL_method3373z00_2220, (obj_t) (BgL_nodez00_2219), BEOA);
						}}}
						{
							BgL_varz00_bglt BgL_auxz00_4272;

							BgL_auxz00_4272 = (BgL_varz00_bglt) (BgL_arg3700z00_1590);
							((((BgL_setqz00_bglt) CREF(BgL_nodez00_1584))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_4272), BUNSPEC);
					}}
					BgL_auxz00_4221 = BgL_nodez00_1584;
					return (obj_t) (BgL_auxz00_4221);
				}
			}
		}
	}



/* patch!-cast3392 */
	obj_t BGl_patchz12zd2cast3392zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2943,
		obj_t BgL_nodez00_2944)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 361 */
			{
				BgL_castz00_bglt BgL_nodez00_1577;

				{	/* Cfa/specialize.scm 362 */
					BgL_castz00_bglt BgL_auxz00_4277;

					BgL_nodez00_1577 = (BgL_castz00_bglt) (BgL_nodez00_2944);
					{	/* Cfa/specialize.scm 362 */
						BgL_nodez00_bglt BgL_arg3696z00_2161;

						BgL_arg3696z00_2161 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1577))->BgL_argz00);
						{	/* Cfa/specialize.scm 362 */
							obj_t BgL_method3373z00_2164;

							{	/* Cfa/specialize.scm 362 */
								BgL_objectz00_bglt BgL_objz00_2165;

								BgL_objz00_2165 = (BgL_objectz00_bglt) (BgL_arg3696z00_2161);
								{	/* Cfa/specialize.scm 362 */
									long BgL_objzd2classzd2numz00_2166;

									BgL_objzd2classzd2numz00_2166 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2165);
									{	/* Cfa/specialize.scm 362 */
										obj_t BgL_arg2334z00_2167;

										BgL_arg2334z00_2167 =
											PROCEDURE_REF(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
											(int) (((long) 1)));
										{	/* Cfa/specialize.scm 362 */
											obj_t BgL_arrayz00_2169;

											int BgL_offsetz00_2170;

											BgL_arrayz00_2169 = BgL_arg2334z00_2167;
											BgL_offsetz00_2170 =
												(int) (BgL_objzd2classzd2numz00_2166);
											{	/* Cfa/specialize.scm 362 */
												long BgL_offsetz00_2171;

												BgL_offsetz00_2171 =
													((long) (BgL_offsetz00_2170) - OBJECT_TYPE);
												{	/* Cfa/specialize.scm 362 */
													long BgL_modz00_2172;

													{	/* Cfa/specialize.scm 362 */
														int BgL_arg2336z00_2173;

														BgL_arg2336z00_2173 = (int) (((long) 8));
														{	/* Cfa/specialize.scm 362 */
															long BgL_auxz00_4287;

															BgL_auxz00_4287 = (long) (BgL_arg2336z00_2173);
															BgL_modz00_2172 =
																(BgL_offsetz00_2171 / BgL_auxz00_4287);
													}}
													{	/* Cfa/specialize.scm 362 */
														long BgL_restz00_2174;

														{	/* Cfa/specialize.scm 362 */
															int BgL_arg2335z00_2175;

															BgL_arg2335z00_2175 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 362 */
																long BgL_auxz00_4291;

																BgL_auxz00_4291 = (long) (BgL_arg2335z00_2175);
																BgL_restz00_2174 =
																	(BgL_offsetz00_2171 % BgL_auxz00_4291);
														}}
														{	/* Cfa/specialize.scm 362 */

															BgL_method3373z00_2164 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2169,
																	(int) (BgL_modz00_2172)),
																(int) (BgL_restz00_2174));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3373z00_2164) (BgL_method3373z00_2164,
								(obj_t) (BgL_arg3696z00_2161), BEOA);
					}}
					BgL_auxz00_4277 = BgL_nodez00_1577;
					return (obj_t) (BgL_auxz00_4277);
				}
			}
		}
	}



/* patch!-extern3390 */
	obj_t BGl_patchz12zd2extern3390zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2945,
		obj_t BgL_nodez00_2946)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 353 */
			{
				BgL_externz00_bglt BgL_nodez00_1570;

				{	/* Cfa/specialize.scm 354 */
					BgL_externz00_bglt BgL_auxz00_4303;

					BgL_nodez00_1570 = (BgL_externz00_bglt) (BgL_nodez00_2946);
					{	/* Cfa/specialize.scm 354 */
						obj_t BgL_arg3694z00_2158;

						BgL_arg3694z00_2158 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1570))->BgL_exprza2za2);
						BGl_patchza2z12zb0zzcfa_specializa7eza7(BgL_arg3694z00_2158);
					}
					BgL_auxz00_4303 = BgL_nodez00_1570;
					return (obj_t) (BgL_auxz00_4303);
				}
			}
		}
	}



/* patch!-funcall3387 */
	obj_t BGl_patchz12zd2funcall3387zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2947, obj_t BgL_nodez00_2948)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 344 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1561;

				{	/* Cfa/specialize.scm 345 */
					BgL_funcallz00_bglt BgL_auxz00_4308;

					BgL_nodez00_1561 = (BgL_funcallz00_bglt) (BgL_nodez00_2948);
					{	/* Cfa/specialize.scm 346 */
						obj_t BgL_arg3690z00_1565;

						{	/* Cfa/specialize.scm 346 */
							BgL_nodez00_bglt BgL_arg3691z00_1566;

							BgL_arg3691z00_1566 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1561))->BgL_funz00);
							{	/* Cfa/specialize.scm 346 */
								obj_t BgL_method3373z00_2129;

								{	/* Cfa/specialize.scm 346 */
									BgL_objectz00_bglt BgL_objz00_2130;

									BgL_objz00_2130 = (BgL_objectz00_bglt) (BgL_arg3691z00_1566);
									{	/* Cfa/specialize.scm 346 */
										long BgL_objzd2classzd2numz00_2131;

										BgL_objzd2classzd2numz00_2131 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2130);
										{	/* Cfa/specialize.scm 346 */
											obj_t BgL_arg2334z00_2132;

											BgL_arg2334z00_2132 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 346 */
												obj_t BgL_arrayz00_2134;

												int BgL_offsetz00_2135;

												BgL_arrayz00_2134 = BgL_arg2334z00_2132;
												BgL_offsetz00_2135 =
													(int) (BgL_objzd2classzd2numz00_2131);
												{	/* Cfa/specialize.scm 346 */
													long BgL_offsetz00_2136;

													BgL_offsetz00_2136 =
														((long) (BgL_offsetz00_2135) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 346 */
														long BgL_modz00_2137;

														{	/* Cfa/specialize.scm 346 */
															int BgL_arg2336z00_2138;

															BgL_arg2336z00_2138 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 346 */
																long BgL_auxz00_4318;

																BgL_auxz00_4318 = (long) (BgL_arg2336z00_2138);
																BgL_modz00_2137 =
																	(BgL_offsetz00_2136 / BgL_auxz00_4318);
														}}
														{	/* Cfa/specialize.scm 346 */
															long BgL_restz00_2139;

															{	/* Cfa/specialize.scm 346 */
																int BgL_arg2335z00_2140;

																BgL_arg2335z00_2140 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 346 */
																	long BgL_auxz00_4322;

																	BgL_auxz00_4322 =
																		(long) (BgL_arg2335z00_2140);
																	BgL_restz00_2139 =
																		(BgL_offsetz00_2136 % BgL_auxz00_4322);
															}}
															{	/* Cfa/specialize.scm 346 */

																BgL_method3373z00_2129 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2134,
																		(int) (BgL_modz00_2137)),
																	(int) (BgL_restz00_2139));
								}}}}}}}}
								BgL_arg3690z00_1565 =
									PROCEDURE_ENTRY(BgL_method3373z00_2129)
									(BgL_method3373z00_2129, (obj_t) (BgL_arg3691z00_1566), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4332;

							BgL_auxz00_4332 = (BgL_nodez00_bglt) (BgL_arg3690z00_1565);
							((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1561))->BgL_funz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4332), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 347 */
						obj_t BgL_arg3692z00_1567;

						BgL_arg3692z00_1567 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1561))->BgL_argsz00);
						BGl_patchza2z12zb0zzcfa_specializa7eza7(BgL_arg3692z00_1567);
					}
					BgL_auxz00_4308 = BgL_nodez00_1561;
					return (obj_t) (BgL_auxz00_4308);
				}
			}
		}
	}



/* patch!-app-ly3385 */
	obj_t BGl_patchz12zd2appzd2ly3385z12zzcfa_specializa7eza7(obj_t
		BgL_envz00_2949, obj_t BgL_nodez00_2950)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 335 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1551;

				{	/* Cfa/specialize.scm 336 */
					BgL_appzd2lyzd2_bglt BgL_auxz00_4339;

					BgL_nodez00_1551 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2950);
					{	/* Cfa/specialize.scm 337 */
						obj_t BgL_arg3685z00_1555;

						{	/* Cfa/specialize.scm 337 */
							BgL_nodez00_bglt BgL_arg3686z00_1556;

							BgL_arg3686z00_1556 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1551))->BgL_funz00);
							{	/* Cfa/specialize.scm 337 */
								obj_t BgL_method3373z00_2071;

								{	/* Cfa/specialize.scm 337 */
									BgL_objectz00_bglt BgL_objz00_2072;

									BgL_objz00_2072 = (BgL_objectz00_bglt) (BgL_arg3686z00_1556);
									{	/* Cfa/specialize.scm 337 */
										long BgL_objzd2classzd2numz00_2073;

										BgL_objzd2classzd2numz00_2073 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2072);
										{	/* Cfa/specialize.scm 337 */
											obj_t BgL_arg2334z00_2074;

											BgL_arg2334z00_2074 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 337 */
												obj_t BgL_arrayz00_2076;

												int BgL_offsetz00_2077;

												BgL_arrayz00_2076 = BgL_arg2334z00_2074;
												BgL_offsetz00_2077 =
													(int) (BgL_objzd2classzd2numz00_2073);
												{	/* Cfa/specialize.scm 337 */
													long BgL_offsetz00_2078;

													BgL_offsetz00_2078 =
														((long) (BgL_offsetz00_2077) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 337 */
														long BgL_modz00_2079;

														{	/* Cfa/specialize.scm 337 */
															int BgL_arg2336z00_2080;

															BgL_arg2336z00_2080 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 337 */
																long BgL_auxz00_4349;

																BgL_auxz00_4349 = (long) (BgL_arg2336z00_2080);
																BgL_modz00_2079 =
																	(BgL_offsetz00_2078 / BgL_auxz00_4349);
														}}
														{	/* Cfa/specialize.scm 337 */
															long BgL_restz00_2081;

															{	/* Cfa/specialize.scm 337 */
																int BgL_arg2335z00_2082;

																BgL_arg2335z00_2082 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 337 */
																	long BgL_auxz00_4353;

																	BgL_auxz00_4353 =
																		(long) (BgL_arg2335z00_2082);
																	BgL_restz00_2081 =
																		(BgL_offsetz00_2078 % BgL_auxz00_4353);
															}}
															{	/* Cfa/specialize.scm 337 */

																BgL_method3373z00_2071 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2076,
																		(int) (BgL_modz00_2079)),
																	(int) (BgL_restz00_2081));
								}}}}}}}}
								BgL_arg3685z00_1555 =
									PROCEDURE_ENTRY(BgL_method3373z00_2071)
									(BgL_method3373z00_2071, (obj_t) (BgL_arg3686z00_1556), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4363;

							BgL_auxz00_4363 = (BgL_nodez00_bglt) (BgL_arg3685z00_1555);
							((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1551))->BgL_funz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4363), BUNSPEC);
					}}
					{	/* Cfa/specialize.scm 338 */
						obj_t BgL_arg3687z00_1557;

						{	/* Cfa/specialize.scm 338 */
							BgL_nodez00_bglt BgL_arg3688z00_1558;

							BgL_arg3688z00_1558 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1551))->BgL_argz00);
							{	/* Cfa/specialize.scm 338 */
								obj_t BgL_method3373z00_2100;

								{	/* Cfa/specialize.scm 338 */
									BgL_objectz00_bglt BgL_objz00_2101;

									BgL_objz00_2101 = (BgL_objectz00_bglt) (BgL_arg3688z00_1558);
									{	/* Cfa/specialize.scm 338 */
										long BgL_objzd2classzd2numz00_2102;

										BgL_objzd2classzd2numz00_2102 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2101);
										{	/* Cfa/specialize.scm 338 */
											obj_t BgL_arg2334z00_2103;

											BgL_arg2334z00_2103 =
												PROCEDURE_REF
												(BGl_patchz12zd2envzc0zzcfa_specializa7eza7,
												(int) (((long) 1)));
											{	/* Cfa/specialize.scm 338 */
												obj_t BgL_arrayz00_2105;

												int BgL_offsetz00_2106;

												BgL_arrayz00_2105 = BgL_arg2334z00_2103;
												BgL_offsetz00_2106 =
													(int) (BgL_objzd2classzd2numz00_2102);
												{	/* Cfa/specialize.scm 338 */
													long BgL_offsetz00_2107;

													BgL_offsetz00_2107 =
														((long) (BgL_offsetz00_2106) - OBJECT_TYPE);
													{	/* Cfa/specialize.scm 338 */
														long BgL_modz00_2108;

														{	/* Cfa/specialize.scm 338 */
															int BgL_arg2336z00_2109;

															BgL_arg2336z00_2109 = (int) (((long) 8));
															{	/* Cfa/specialize.scm 338 */
																long BgL_auxz00_4375;

																BgL_auxz00_4375 = (long) (BgL_arg2336z00_2109);
																BgL_modz00_2108 =
																	(BgL_offsetz00_2107 / BgL_auxz00_4375);
														}}
														{	/* Cfa/specialize.scm 338 */
															long BgL_restz00_2110;

															{	/* Cfa/specialize.scm 338 */
																int BgL_arg2335z00_2111;

																BgL_arg2335z00_2111 = (int) (((long) 8));
																{	/* Cfa/specialize.scm 338 */
																	long BgL_auxz00_4379;

																	BgL_auxz00_4379 =
																		(long) (BgL_arg2335z00_2111);
																	BgL_restz00_2110 =
																		(BgL_offsetz00_2107 % BgL_auxz00_4379);
															}}
															{	/* Cfa/specialize.scm 338 */

																BgL_method3373z00_2100 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2105,
																		(int) (BgL_modz00_2108)),
																	(int) (BgL_restz00_2110));
								}}}}}}}}
								BgL_arg3687z00_1557 =
									PROCEDURE_ENTRY(BgL_method3373z00_2100)
									(BgL_method3373z00_2100, (obj_t) (BgL_arg3688z00_1558), BEOA);
						}}
						{
							BgL_nodez00_bglt BgL_auxz00_4389;

							BgL_auxz00_4389 = (BgL_nodez00_bglt) (BgL_arg3687z00_1557);
							((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1551))->BgL_argz00) =
								((BgL_nodez00_bglt) BgL_auxz00_4389), BUNSPEC);
					}}
					BgL_auxz00_4339 = BgL_nodez00_1551;
					return (obj_t) (BgL_auxz00_4339);
				}
			}
		}
	}



/* patch!-sequence3383 */
	obj_t BGl_patchz12zd2sequence3383zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2951, obj_t BgL_nodez00_2952)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 327 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1544;

				{	/* Cfa/specialize.scm 328 */
					BgL_sequencez00_bglt BgL_auxz00_4394;

					BgL_nodez00_1544 = (BgL_sequencez00_bglt) (BgL_nodez00_2952);
					{	/* Cfa/specialize.scm 328 */
						obj_t BgL_arg3683z00_2067;

						BgL_arg3683z00_2067 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1544))->BgL_nodesz00);
						BGl_patchza2z12zb0zzcfa_specializa7eza7(BgL_arg3683z00_2067);
					}
					BgL_auxz00_4394 = BgL_nodez00_1544;
					return (obj_t) (BgL_auxz00_4394);
				}
			}
		}
	}



/* patch!-closure3381 */
	obj_t BGl_patchz12zd2closure3381zc0zzcfa_specializa7eza7(obj_t
		BgL_envz00_2953, obj_t BgL_nodez00_2954)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 321 */
			{
				BgL_closurez00_bglt BgL_nodez00_1536;

				BgL_nodez00_1536 = (BgL_closurez00_bglt) (BgL_nodez00_2954);
				return
					BGl_internalzd2errorzd2zztools_errorz00
					(BGl_string3883z00zzcfa_specializa7eza7,
					BGl_string3884z00zzcfa_specializa7eza7,
					BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1536)));
			}
		}
	}



/* patch!-var3379 */
	obj_t BGl_patchz12zd2var3379zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2955,
		obj_t BgL_nodez00_2956)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 315 */
			return (obj_t) ((BgL_varz00_bglt) (BgL_nodez00_2956));
		}
	}



/* patch!-kwote3377 */
	obj_t BGl_patchz12zd2kwote3377zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2957,
		obj_t BgL_nodez00_2958)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 309 */
			return (obj_t) ((BgL_kwotez00_bglt) (BgL_nodez00_2958));
		}
	}



/* patch!-atom3375 */
	obj_t BGl_patchz12zd2atom3375zc0zzcfa_specializa7eza7(obj_t BgL_envz00_2959,
		obj_t BgL_nodez00_2960)
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 303 */
			return (obj_t) ((BgL_atomz00_bglt) (BgL_nodez00_2960));
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_specializa7eza7()
	{
		AN_OBJECT;
		{	/* Cfa/specialize.scm 19 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 182148081),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			BGl_modulezd2initializa7ationz75zzinline_inlinez00(((long) 326457085),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
			return
				BGl_modulezd2initializa7ationz75zzinline_walkz00(((long) 175384950),
				BSTRING_TO_STRING(BGl_string3885z00zzcfa_specializa7eza7));
		}
	}

#ifdef __cplusplus
}
#endif
