/*===========================================================================*/
/*   (Cfa/type.scm)                                                          */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/type.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_svarz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
	}              *BgL_svarz00_bglt;

	typedef struct BgL_cvarz00_bgl
	{
		header_t header;
		obj_t widening;
		bool_t BgL_macrozf3zf3;
	}              *BgL_cvarz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_vallocz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2heapzd2formatz00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                *BgL_vallocz00_bglt;

	typedef struct BgL_vrefz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}              *BgL_vrefz00_bglt;

	typedef struct BgL_vsetz12z12_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                 *BgL_vsetz12z12_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_internzd2sfunzf2cinfoz20_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		long BgL_stampz00;
	}                               *BgL_internzd2sfunzf2cinfoz20_bglt;

	typedef struct BgL_svarzf2cinfozf2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		bool_t BgL_clozd2envzf3z21;
	}                      *BgL_svarzf2cinfozf2_bglt;

	typedef struct BgL_cvarzf2cinfozf2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
	}                      *BgL_cvarzf2cinfozf2_bglt;

	typedef struct BgL_makezd2vectorzd2appz00_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		struct BgL_approxz00_bgl *BgL_valuezd2approxzd2;
		long BgL_lostzd2stampzd2;
		struct BgL_variablez00_bgl *BgL_ownerz00;
		obj_t BgL_stackzd2stampzd2;
		bool_t BgL_seenzf3zf3;
	}                             *BgL_makezd2vectorzd2appz00_bglt;

	typedef struct BgL_valloczf2cinfozb2optimz40_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		struct BgL_approxz00_bgl *BgL_valuezd2approxzd2;
		long BgL_lostzd2stampzd2;
		struct BgL_variablez00_bgl *BgL_ownerz00;
		bool_t BgL_stackablezf3zf3;
		obj_t BgL_stackzd2stampzd2;
		bool_t BgL_seenzf3zf3;
	}                                *BgL_valloczf2cinfozb2optimz40_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_vrefz00zzast_nodez00;
	extern obj_t BGl_sexitzf2Cinfozf2zzcfa_infoz00;
	static obj_t BGl_typezd2nodez12zd2atom5128z12zzcfa_typez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl__typezd2variablez12zc0zzcfa_typez00(obj_t, obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2funcall5142z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_valloczf2Cinfozb2optimz40zzcfa_info3z00;
	static obj_t BGl_typezd2nodez12zd2app5138z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2vsetz125149z00zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t
		BGl_setzd2variablezd2typez12z12zzcfa_typez00(BgL_variablez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcfa_typez00();
	extern obj_t BGl_cvarzf2Cinfozf2zzcfa_infoz00;
	static obj_t BGl_typezd2nodez12zd2makezd2box5169zc0zzcfa_typez00(obj_t,
		obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzcfa_typez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztvector_tvectorz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcfa_typez00();
	static obj_t BGl_typezd2nodez12zd2boxzd2ref5173zc0zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2jumpzd2exzd2i5167z12zzcfa_typez00(obj_t,
		obj_t);
	static obj_t BGl_typezd2nodez12zd2cast5151z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_internzd2sfunzf2Cinfoz20zzcfa_infoz00;
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_typezd2variablez12zd2cvarzf25120ze0zzcfa_typez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_typezd2variablez12zd2sexit5122z12zzcfa_typez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_typezd2nodez12zd2var5132z12zzcfa_typez00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_approxz00_bglt);
	extern obj_t BGl_closurez00zzast_nodez00;
	static obj_t BGl_typezd2nodez12zd2vref5147z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2extern5145z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2setq5153z12zzcfa_typez00(obj_t, obj_t);
	static obj_t
		BGl_typezd2variablez12zd2defau5113z12zzcfa_typez00(BgL_valuez00_bglt,
		BgL_variablez00_bglt);
	extern obj_t BGl_tvecz00zztvector_tvectorz00;
	static obj_t BGl_typezd2nodez12zd2appzd2ly5140zc0zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2condition5155z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_vsetz12z12zzast_nodez00;
	static obj_t BGl_methodzd2initzd2zzcfa_typez00();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_typezd2variablez12zd2inter5124z12zzcfa_typez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_setzd2ze3listz31zzcfa_setz00(obj_t);
	static obj_t BGl_typezd2nodez12zc0zzcfa_typez00(BgL_nodez00_bglt);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_typez00 = BUNSPEC;
	static obj_t BGl_typezd2nodez12zd2letzd2fun5161zc0zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2closure5134z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2funz12zc0zzcfa_typez00(BgL_variablez00_bglt);
	static obj_t BGl_genericzd2initzd2zzcfa_typez00();
	BGL_EXPORTED_DECL obj_t BGl_typezd2settingsz12zc0zzcfa_typez00(obj_t);
	extern BgL_typez00_bglt
		BGl_getzd2vectorzd2itemzd2typezd2zzcfa_tvectorz00(BgL_nodez00_bglt);
	extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
	static obj_t BGl_typezd2nodez12zd2letzd2var5163zc0zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_funz00zzast_varz00;
	extern obj_t BGl_globalz00zzast_varz00;
	extern obj_t BGl_typez00zztype_typez00;
	extern obj_t BGl_makezd2vectorzd2appz00zzcfa_info2z00;
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_typezd2nodez12zd2kwote5130z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2fail5157z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_typezd2variablez12zc0zzcfa_typez00(BgL_valuez00_bglt,
		BgL_variablez00_bglt);
	extern BgL_typez00_bglt BGl_getzd2defaultzd2typez00zztype_cachez00();
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_typez00();
	static bool_t BGl_typezd2nodeza2z12z62zzcfa_typez00(obj_t);
	static obj_t BGl_typezd2nodez12zd2setzd2exzd2it5165z12zzcfa_typez00(obj_t,
		obj_t);
	static obj_t BGl_typezd2nodez12zd2select5159z12zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_svarzf2Cinfozf2zzcfa_infoz00;
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl__typezd2variablez12zd2defau5113z12zzcfa_typez00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_tvectorzd2optimiza7ationzf3z86zzcfa_tvectorz00();
	extern obj_t BGl_za2vectorza2z00zztype_cachez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_typezd2nodez12zd2sequence5136z12zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl__typezd2nodez12zc0zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl_typezd2variablez12zd2svarzf25116ze0zzcfa_typez00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_typezd2nodez12zd2boxzd2setz125171zd2zzcfa_typez00(obj_t,
		obj_t);
	static obj_t BGl_typezd2variablez12zd2scnst5118z12zzcfa_typez00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__typezd2nodez12zd2default5125z12zzcfa_typez00(obj_t, obj_t);
	static obj_t
		BGl_typezd2nodez12zd2default5125z12zzcfa_typez00(BgL_nodez00_bglt);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_typez00();
	static obj_t BGl__getzd2approxzd2typez00zzcfa_typez00(obj_t, obj_t);
	static obj_t BGl__typezd2settingsz12zc0zzcfa_typez00(obj_t, obj_t);
	extern obj_t BGl_scnstzf2Cinfozf2zzcfa_infoz00;
	static obj_t __cnst[4];


	   
		 
		DEFINE_STATIC_BGL_GENERIC(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
		BgL_bgl__typeza7d2nodeza712za75508za7, BGl__typezd2nodez12zc0zzcfa_typez00,
		0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_typezd2variablez12zd2defau5113zd2envzc0zzcfa_typez00,
		BgL_bgl__typeza7d2variable5509za7,
		BGl__typezd2variablez12zd2defau5113z12zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_GENERIC(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
		BgL_bgl__typeza7d2variable5510za7, BGl__typezd2variablez12zc0zzcfa_typez00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_typezd2settingsz12zd2envz12zzcfa_typez00,
		BgL_bgl__typeza7d2settings5511za7, BGl__typezd2settingsz12zc0zzcfa_typez00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5471z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75512z00,
		BGl_typezd2variablez12zd2svarzf25116ze0zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5472z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75513z00,
		BGl_typezd2variablez12zd2scnst5118z12zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5473z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75514z00,
		BGl_typezd2variablez12zd2cvarzf25120ze0zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5474z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75515z00,
		BGl_typezd2variablez12zd2sexit5122z12zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5475z00zzcfa_typez00,
		BgL_bgl_typeza7d2variableza75516z00,
		BGl_typezd2variablez12zd2inter5124z12zzcfa_typez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5476z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5517za7,
		BGl_typezd2nodez12zd2atom5128z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5477z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5518za7,
		BGl_typezd2nodez12zd2kwote5130z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5478z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5519za7,
		BGl_typezd2nodez12zd2var5132z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5480z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5520za7,
		BGl_typezd2nodez12zd2sequence5136z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5479z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5521za7,
		BGl_typezd2nodez12zd2closure5134z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5481z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5522za7,
		BGl_typezd2nodez12zd2app5138z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5482z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5523za7,
		BGl_typezd2nodez12zd2appzd2ly5140zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5483z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5524za7,
		BGl_typezd2nodez12zd2funcall5142z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5484z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5525za7,
		BGl_typezd2nodez12zd2extern5145z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5485z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5526za7,
		BGl_typezd2nodez12zd2vref5147z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5486z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5527za7,
		BGl_typezd2nodez12zd2vsetz125149z00zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5487z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5528za7,
		BGl_typezd2nodez12zd2cast5151z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5488z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5529za7,
		BGl_typezd2nodez12zd2setq5153z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5490z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5530za7,
		BGl_typezd2nodez12zd2fail5157z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5489z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5531za7,
		BGl_typezd2nodez12zd2condition5155z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5491z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5532za7,
		BGl_typezd2nodez12zd2select5159z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5492z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5533za7,
		BGl_typezd2nodez12zd2letzd2fun5161zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5493z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5534za7,
		BGl_typezd2nodez12zd2letzd2var5163zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5494z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5535za7,
		BGl_typezd2nodez12zd2setzd2exzd2it5165z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5495z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5536za7,
		BGl_typezd2nodez12zd2jumpzd2exzd2i5167z12zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5496z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5537za7,
		BGl_typezd2nodez12zd2makezd2box5169zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5497z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5538za7,
		BGl_typezd2nodez12zd2boxzd2setz125171zd2zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5498z00zzcfa_typez00,
		BgL_bgl_typeza7d2nodeza712za7d5539za7,
		BGl_typezd2nodez12zd2boxzd2ref5173zc0zzcfa_typez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string5470z00zzcfa_typez00,
		BgL_bgl_string5470za700za7za7c5540za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string5500z00zzcfa_typez00,
		BgL_bgl_string5500za700za7za7c5541za7, "Unexpected closure", 18);
	      DEFINE_STRING(BGl_string5501z00zzcfa_typez00,
		BgL_bgl_string5501za700za7za7c5542za7, "cfa_type", 8);
	      DEFINE_STRING(BGl_string5502z00zzcfa_typez00,
		BgL_bgl_string5502za700za7za7c5543za7,
		"static type-node!-default5125 nothing bigloo ", 45);
	      DEFINE_STRING(BGl_string5499z00zzcfa_typez00,
		BgL_bgl_string5499za700za7za7c5544za7, "type-node!", 10);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2approxzd2typezd2envzd2zzcfa_typez00,
		BgL_bgl__getza7d2approxza7d25545z00,
		BGl__getzd2approxzd2typez00zzcfa_typez00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_typezd2nodez12zd2default5125zd2envzc0zzcfa_typez00,
		BgL_bgl__typeza7d2nodeza712za75546za7,
		BGl__typezd2nodez12zd2default5125z12zzcfa_typez00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzcfa_typez00(long
		BgL_checksumz00_3160, char *BgL_fromz00_3161)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_typez00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_typez00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcfa_typez00();
					BGl_cnstzd2initzd2zzcfa_typez00();
					BGl_importedzd2moduleszd2initz00zzcfa_typez00();
					BGl_genericzd2initzd2zzcfa_typez00();
					BGl_methodzd2initzd2zzcfa_typez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "cfa_type");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "cfa_type");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "cfa_type");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			{	/* Cfa/type.scm 15 */
				obj_t BgL_cportz00_3141;

				BgL_cportz00_3141 =
					bgl_open_input_string(BGl_string5502z00zzcfa_typez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_3142;

					BgL_iz00_3142 = ((long) 3);
				BgL_loopz00_3143:
					if ((BgL_iz00_3142 == ((long) -1)))
						{	/* Cfa/type.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/type.scm 15 */
							{	/* Cfa/type.scm 15 */
								obj_t BgL_arg5504z00_3145;

								{	/* Cfa/type.scm 15 */

									{	/* Cfa/type.scm 15 */
										obj_t BgL_locationz00_3147;

										BgL_locationz00_3147 = BBOOL(((bool_t) 0));
										{	/* Cfa/type.scm 15 */

											BgL_arg5504z00_3145 =
												BGl_readz00zz__readerz00(BgL_cportz00_3141,
												BgL_locationz00_3147);
										}
									}
								}
								{	/* Cfa/type.scm 15 */
									int BgL_auxz00_3179;

									BgL_auxz00_3179 = (int) (BgL_iz00_3142);
									CNST_TABLE_SET(BgL_auxz00_3179, BgL_arg5504z00_3145);
							}}
							{	/* Cfa/type.scm 15 */
								int BgL_auxz00_3148;

								BgL_auxz00_3148 = (int) ((BgL_iz00_3142 - ((long) 1)));
								{
									long BgL_iz00_3184;

									BgL_iz00_3184 = (long) (BgL_auxz00_3148);
									BgL_iz00_3142 = BgL_iz00_3184;
									goto BgL_loopz00_3143;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			return BUNSPEC;
		}
	}



/* type-settings! */
	BGL_EXPORTED_DEF obj_t BGl_typezd2settingsz12zc0zzcfa_typez00(obj_t
		BgL_globalsz00_1)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 38 */
			{
				obj_t BgL_l5095z00_1120;

				{	/* Cfa/type.scm 39 */
					bool_t BgL_auxz00_3186;

					BgL_l5095z00_1120 = BgL_globalsz00_1;
				BgL_forzd2each5096zd2_1121:
					if (PAIRP(BgL_l5095z00_1120))
						{	/* Cfa/type.scm 39 */
							{	/* Cfa/type.scm 39 */
								obj_t BgL_arg5175z00_1123;

								BgL_arg5175z00_1123 = CAR(BgL_l5095z00_1120);
								BGl_typezd2funz12zc0zzcfa_typez00(
									(BgL_variablez00_bglt) (BgL_arg5175z00_1123));
							}
							{
								obj_t BgL_l5095z00_3192;

								BgL_l5095z00_3192 = CDR(BgL_l5095z00_1120);
								BgL_l5095z00_1120 = BgL_l5095z00_3192;
								goto BgL_forzd2each5096zd2_1121;
							}
						}
					else
						{	/* Cfa/type.scm 39 */
							BgL_auxz00_3186 = ((bool_t) 1);
						}
					return BBOOL(BgL_auxz00_3186);
				}
			}
		}
	}



/* _type-settings! */
	obj_t BGl__typezd2settingsz12zc0zzcfa_typez00(obj_t BgL_envz00_3038,
		obj_t BgL_globalsz00_3039)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 38 */
			return BGl_typezd2settingsz12zc0zzcfa_typez00(BgL_globalsz00_3039);
		}
	}



/* type-fun! */
	obj_t BGl_typezd2funz12zc0zzcfa_typez00(BgL_variablez00_bglt BgL_varz00_2)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 44 */
			{	/* Cfa/type.scm 45 */
				BgL_valuez00_bglt BgL_funz00_1125;

				BgL_funz00_1125 =
					(((BgL_variablez00_bglt) CREF(BgL_varz00_2))->BgL_valuez00);
				{	/* Cfa/type.scm 46 */
					bool_t BgL_testz00_3197;

					{	/* Cfa/type.scm 46 */
						obj_t BgL_obj3235z00_2000;

						BgL_obj3235z00_2000 = (obj_t) (BgL_funz00_1125);
						BgL_testz00_3197 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj3235z00_2000,
							BGl_internzd2sfunzf2Cinfoz20zzcfa_infoz00);
					}
					if (BgL_testz00_3197)
						{	/* Cfa/type.scm 46 */
							{	/* Cfa/type.scm 51 */
								obj_t BgL_g5100z00_1128;

								{
									BgL_sfunz00_bglt BgL_auxz00_3200;

									BgL_auxz00_3200 = (BgL_sfunz00_bglt) (BgL_funz00_1125);
									BgL_g5100z00_1128 =
										(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3200))->BgL_argsz00);
								}
								{
									obj_t BgL_l5097z00_1129;

									BgL_l5097z00_1129 = BgL_g5100z00_1128;
								BgL_forzd2each5099zd2_1130:
									if (PAIRP(BgL_l5097z00_1129))
										{	/* Cfa/type.scm 51 */
											{	/* Cfa/type.scm 51 */
												obj_t BgL_varz00_1132;

												BgL_varz00_1132 = CAR(BgL_l5097z00_1129);
												{	/* Cfa/type.scm 51 */
													BgL_valuez00_bglt BgL_arg5179z00_1133;

													{
														BgL_variablez00_bglt BgL_auxz00_3206;

														BgL_auxz00_3206 =
															(BgL_variablez00_bglt) (BgL_varz00_1132);
														BgL_arg5179z00_1133 =
															(((BgL_variablez00_bglt) CREF(BgL_auxz00_3206))->
															BgL_valuez00);
													}
													{	/* Cfa/type.scm 51 */
														BgL_variablez00_bglt BgL_variablez00_2006;

														BgL_variablez00_2006 =
															(BgL_variablez00_bglt) (BgL_varz00_1132);
														{	/* Cfa/type.scm 51 */
															obj_t BgL_method5114z00_2007;

															{	/* Cfa/type.scm 51 */
																BgL_objectz00_bglt BgL_objz00_2008;

																BgL_objz00_2008 =
																	(BgL_objectz00_bglt) (BgL_arg5179z00_1133);
																{	/* Cfa/type.scm 51 */
																	long BgL_objzd2classzd2numz00_2009;

																	BgL_objzd2classzd2numz00_2009 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2008);
																	{	/* Cfa/type.scm 51 */
																		obj_t BgL_arg2334z00_2010;

																		BgL_arg2334z00_2010 =
																			PROCEDURE_REF
																			(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
																			(int) (((long) 1)));
																		{	/* Cfa/type.scm 51 */
																			obj_t BgL_arrayz00_2012;

																			int BgL_offsetz00_2013;

																			BgL_arrayz00_2012 = BgL_arg2334z00_2010;
																			BgL_offsetz00_2013 =
																				(int) (BgL_objzd2classzd2numz00_2009);
																			{	/* Cfa/type.scm 51 */
																				long BgL_offsetz00_2014;

																				BgL_offsetz00_2014 =
																					(
																					(long) (BgL_offsetz00_2013) -
																					OBJECT_TYPE);
																				{	/* Cfa/type.scm 51 */
																					long BgL_modz00_2015;

																					{	/* Cfa/type.scm 51 */
																						int BgL_arg2336z00_2016;

																						BgL_arg2336z00_2016 =
																							(int) (((long) 8));
																						{	/* Cfa/type.scm 51 */
																							long BgL_auxz00_3218;

																							BgL_auxz00_3218 =
																								(long) (BgL_arg2336z00_2016);
																							BgL_modz00_2015 =
																								(BgL_offsetz00_2014 /
																								BgL_auxz00_3218);
																					}}
																					{	/* Cfa/type.scm 51 */
																						long BgL_restz00_2017;

																						{	/* Cfa/type.scm 51 */
																							int BgL_arg2335z00_2018;

																							BgL_arg2335z00_2018 =
																								(int) (((long) 8));
																							{	/* Cfa/type.scm 51 */
																								long BgL_auxz00_3222;

																								BgL_auxz00_3222 =
																									(long) (BgL_arg2335z00_2018);
																								BgL_restz00_2017 =
																									(BgL_offsetz00_2014 %
																									BgL_auxz00_3222);
																						}}
																						{	/* Cfa/type.scm 51 */

																							BgL_method5114z00_2007 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2012,
																									(int) (BgL_modz00_2015)),
																								(int) (BgL_restz00_2017));
															}}}}}}}}
															PROCEDURE_ENTRY(BgL_method5114z00_2007)
																(BgL_method5114z00_2007,
																(obj_t) (BgL_arg5179z00_1133),
																(obj_t) (BgL_variablez00_2006), BEOA);
											}}}}
											{
												obj_t BgL_l5097z00_3233;

												BgL_l5097z00_3233 = CDR(BgL_l5097z00_1129);
												BgL_l5097z00_1129 = BgL_l5097z00_3233;
												goto BgL_forzd2each5099zd2_1130;
											}
										}
									else
										{	/* Cfa/type.scm 51 */
											((bool_t) 1);
										}
								}
							}
							{	/* Cfa/type.scm 54 */
								obj_t BgL_arg5181z00_1135;

								{
									BgL_sfunz00_bglt BgL_auxz00_3235;

									BgL_auxz00_3235 = (BgL_sfunz00_bglt) (BgL_funz00_1125);
									BgL_arg5181z00_1135 =
										(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3235))->BgL_bodyz00);
								}
								{	/* Cfa/type.scm 54 */
									BgL_nodez00_bglt BgL_nodez00_2034;

									BgL_nodez00_2034 = (BgL_nodez00_bglt) (BgL_arg5181z00_1135);
									{	/* Cfa/type.scm 54 */
										obj_t BgL_method5126z00_2035;

										{	/* Cfa/type.scm 54 */
											BgL_objectz00_bglt BgL_objz00_2036;

											BgL_objz00_2036 = (BgL_objectz00_bglt) (BgL_nodez00_2034);
											{	/* Cfa/type.scm 54 */
												long BgL_objzd2classzd2numz00_2037;

												BgL_objzd2classzd2numz00_2037 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2036);
												{	/* Cfa/type.scm 54 */
													obj_t BgL_arg2334z00_2038;

													BgL_arg2334z00_2038 =
														PROCEDURE_REF
														(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
														(int) (((long) 1)));
													{	/* Cfa/type.scm 54 */
														obj_t BgL_arrayz00_2040;

														int BgL_offsetz00_2041;

														BgL_arrayz00_2040 = BgL_arg2334z00_2038;
														BgL_offsetz00_2041 =
															(int) (BgL_objzd2classzd2numz00_2037);
														{	/* Cfa/type.scm 54 */
															long BgL_offsetz00_2042;

															BgL_offsetz00_2042 =
																((long) (BgL_offsetz00_2041) - OBJECT_TYPE);
															{	/* Cfa/type.scm 54 */
																long BgL_modz00_2043;

																{	/* Cfa/type.scm 54 */
																	int BgL_arg2336z00_2044;

																	BgL_arg2336z00_2044 = (int) (((long) 8));
																	{	/* Cfa/type.scm 54 */
																		long BgL_auxz00_3247;

																		BgL_auxz00_3247 =
																			(long) (BgL_arg2336z00_2044);
																		BgL_modz00_2043 =
																			(BgL_offsetz00_2042 / BgL_auxz00_3247);
																}}
																{	/* Cfa/type.scm 54 */
																	long BgL_restz00_2045;

																	{	/* Cfa/type.scm 54 */
																		int BgL_arg2335z00_2046;

																		BgL_arg2335z00_2046 = (int) (((long) 8));
																		{	/* Cfa/type.scm 54 */
																			long BgL_auxz00_3251;

																			BgL_auxz00_3251 =
																				(long) (BgL_arg2335z00_2046);
																			BgL_restz00_2045 =
																				(BgL_offsetz00_2042 % BgL_auxz00_3251);
																	}}
																	{	/* Cfa/type.scm 54 */

																		BgL_method5126z00_2035 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2040,
																				(int) (BgL_modz00_2043)),
																			(int) (BgL_restz00_2045));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method5126z00_2035)
											(BgL_method5126z00_2035, (obj_t) (BgL_nodez00_2034),
											BEOA);
							}}}
							{	/* Cfa/type.scm 56 */
								obj_t BgL_arg5182z00_1136;

								{	/* Cfa/type.scm 56 */
									BgL_approxz00_bglt BgL_arg5183z00_1137;

									{	/* Cfa/type.scm 56 */
										BgL_internzd2sfunzf2cinfoz20_bglt BgL_obj3236z00_2060;

										BgL_obj3236z00_2060 =
											(BgL_internzd2sfunzf2cinfoz20_bglt) (BgL_funz00_1125);
										{
											obj_t BgL_auxz00_3262;

											{	/* Cfa/type.scm 56 */
												BgL_objectz00_bglt BgL_auxz00_3263;

												BgL_auxz00_3263 =
													(BgL_objectz00_bglt) (BgL_obj3236z00_2060);
												BgL_auxz00_3262 = BGL_OBJECT_WIDENING(BgL_auxz00_3263);
											}
											BgL_arg5183z00_1137 =
												(((BgL_internzd2sfunzf2cinfoz20_bglt)
													CREF(BgL_auxz00_3262))->BgL_approxz00);
									}}
									BgL_arg5182z00_1136 =
										BGl_getzd2approxzd2typez00zzcfa_typez00
										(BgL_arg5183z00_1137);
								}
								return
									BGl_setzd2variablezd2typez12z12zzcfa_typez00(BgL_varz00_2,
									(BgL_typez00_bglt) (BgL_arg5182z00_1136));
							}
						}
					else
						{	/* Cfa/type.scm 46 */
							return BFALSE;
						}
				}
			}
		}
	}



/* get-approx-type */
	BGL_EXPORTED_DEF obj_t
		BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_approxz00_bglt BgL_approxz00_3)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 61 */
			{	/* Cfa/type.scm 62 */
				BgL_typez00_bglt BgL_typez00_1138;

				obj_t BgL_alloczd2listzd2_1139;

				BgL_typez00_1138 =
					(((BgL_approxz00_bglt) CREF(BgL_approxz00_3))->BgL_typez00);
				{	/* Cfa/type.scm 63 */
					obj_t BgL_arg5193z00_1158;

					BgL_arg5193z00_1158 =
						(((BgL_approxz00_bglt) CREF(BgL_approxz00_3))->BgL_allocsz00);
					BgL_alloczd2listzd2_1139 =
						BGl_setzd2ze3listz31zzcfa_setz00(BgL_arg5193z00_1158);
				}
				if (PAIRP(BgL_alloczd2listzd2_1139))
					{	/* Cfa/type.scm 65 */
						if (CBOOL(BGl_tvectorzd2optimiza7ationzf3z86zzcfa_tvectorz00()))
							{	/* Cfa/type.scm 69 */
								bool_t BgL_testz00_3278;

								{	/* Cfa/type.scm 69 */
									obj_t BgL_arg5192z00_1157;

									BgL_arg5192z00_1157 = CAR(BgL_alloczd2listzd2_1139);
									BgL_testz00_3278 =
										BGl_iszd2azf3z21zz__objectz00(BgL_arg5192z00_1157,
										BGl_makezd2vectorzd2appz00zzcfa_info2z00);
								}
								if (BgL_testz00_3278)
									{	/* Cfa/type.scm 70 */
										obj_t BgL_appz00_1143;

										BgL_appz00_1143 = CAR(BgL_alloczd2listzd2_1139);
										{	/* Cfa/type.scm 70 */
											BgL_typez00_bglt BgL_tvzd2typezd2_1144;

											BgL_tvzd2typezd2_1144 =
												BGl_getzd2vectorzd2itemzd2typezd2zzcfa_tvectorz00(
												(BgL_nodez00_bglt) (BgL_appz00_1143));
											{	/* Cfa/type.scm 71 */
												BgL_approxz00_bglt BgL_valuezd2approxzd2_1145;

												{	/* Cfa/type.scm 72 */
													BgL_makezd2vectorzd2appz00_bglt BgL_obj4278z00_2067;

													BgL_obj4278z00_2067 =
														(BgL_makezd2vectorzd2appz00_bglt) (BgL_appz00_1143);
													{
														obj_t BgL_auxz00_3285;

														{	/* Cfa/type.scm 72 */
															BgL_objectz00_bglt BgL_auxz00_3286;

															BgL_auxz00_3286 =
																(BgL_objectz00_bglt) (BgL_obj4278z00_2067);
															BgL_auxz00_3285 =
																BGL_OBJECT_WIDENING(BgL_auxz00_3286);
														}
														BgL_valuezd2approxzd2_1145 =
															(((BgL_makezd2vectorzd2appz00_bglt)
																CREF(BgL_auxz00_3285))->BgL_valuezd2approxzd2);
													}
												}
												{	/* Cfa/type.scm 72 */
													BgL_typez00_bglt BgL_itemzd2typezd2_1146;

													BgL_itemzd2typezd2_1146 =
														(((BgL_approxz00_bglt)
															CREF(BgL_valuezd2approxzd2_1145))->BgL_typez00);
													{	/* Cfa/type.scm 73 */
														obj_t BgL_tvz00_1147;

														BgL_tvz00_1147 =
															(((BgL_typez00_bglt)
																CREF(BgL_itemzd2typezd2_1146))->BgL_tvectorz00);
														{	/* Cfa/type.scm 74 */

															if (BGl_iszd2azf3z21zz__objectz00(BgL_tvz00_1147,
																	BGl_typez00zztype_typez00))
																{	/* Cfa/type.scm 75 */
																	return BgL_tvz00_1147;
																}
															else
																{	/* Cfa/type.scm 75 */
																	return (obj_t) (BgL_typez00_1138);
																}
														}
													}
												}
											}
										}
									}
								else
									{	/* Cfa/type.scm 78 */
										bool_t BgL_testz00_3295;

										{	/* Cfa/type.scm 78 */
											obj_t BgL_arg5190z00_1156;

											BgL_arg5190z00_1156 = CAR(BgL_alloczd2listzd2_1139);
											BgL_testz00_3295 =
												BGl_iszd2azf3z21zz__objectz00(BgL_arg5190z00_1156,
												BGl_valloczf2Cinfozb2optimz40zzcfa_info3z00);
										}
										if (BgL_testz00_3295)
											{	/* Cfa/type.scm 79 */
												obj_t BgL_appz00_1150;

												BgL_appz00_1150 = CAR(BgL_alloczd2listzd2_1139);
												{	/* Cfa/type.scm 79 */
													BgL_typez00_bglt BgL_tvzd2typezd2_1151;

													BgL_tvzd2typezd2_1151 =
														BGl_getzd2vectorzd2itemzd2typezd2zzcfa_tvectorz00(
														(BgL_nodez00_bglt) (BgL_appz00_1150));
													{	/* Cfa/type.scm 80 */
														BgL_approxz00_bglt BgL_valuezd2approxzd2_1152;

														{	/* Cfa/type.scm 81 */
															BgL_valloczf2cinfozb2optimz40_bglt
																BgL_obj4950z00_2074;
															BgL_obj4950z00_2074 =
																(BgL_valloczf2cinfozb2optimz40_bglt)
																(BgL_appz00_1150);
															{
																obj_t BgL_auxz00_3302;

																{	/* Cfa/type.scm 81 */
																	BgL_objectz00_bglt BgL_auxz00_3303;

																	BgL_auxz00_3303 =
																		(BgL_objectz00_bglt) (BgL_obj4950z00_2074);
																	BgL_auxz00_3302 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_3303);
																}
																BgL_valuezd2approxzd2_1152 =
																	(((BgL_valloczf2cinfozb2optimz40_bglt)
																		CREF(BgL_auxz00_3302))->
																	BgL_valuezd2approxzd2);
															}
														}
														{	/* Cfa/type.scm 81 */
															BgL_typez00_bglt BgL_itemzd2typezd2_1153;

															BgL_itemzd2typezd2_1153 =
																(((BgL_approxz00_bglt)
																	CREF(BgL_valuezd2approxzd2_1152))->
																BgL_typez00);
															{	/* Cfa/type.scm 82 */
																obj_t BgL_tvz00_1154;

																BgL_tvz00_1154 =
																	(((BgL_typez00_bglt)
																		CREF(BgL_itemzd2typezd2_1153))->
																	BgL_tvectorz00);
																{	/* Cfa/type.scm 83 */

																	if (BGl_iszd2azf3z21zz__objectz00
																		(BgL_tvz00_1154, BGl_typez00zztype_typez00))
																		{	/* Cfa/type.scm 84 */
																			return BgL_tvz00_1154;
																		}
																	else
																		{	/* Cfa/type.scm 84 */
																			return (obj_t) (BgL_typez00_1138);
																		}
																}
															}
														}
													}
												}
											}
										else
											{	/* Cfa/type.scm 78 */
												return (obj_t) (BgL_typez00_1138);
											}
									}
							}
						else
							{	/* Cfa/type.scm 67 */
								return (obj_t) (BgL_typez00_1138);
							}
					}
				else
					{	/* Cfa/type.scm 65 */
						return (obj_t) (BgL_typez00_1138);
					}
			}
		}
	}



/* _get-approx-type */
	obj_t BGl__getzd2approxzd2typez00zzcfa_typez00(obj_t BgL_envz00_3045,
		obj_t BgL_approxz00_3046)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 61 */
			return
				BGl_getzd2approxzd2typez00zzcfa_typez00(
				(BgL_approxz00_bglt) (BgL_approxz00_3046));
		}
	}



/* set-variable-type! */
	obj_t BGl_setzd2variablezd2typez12z12zzcfa_typez00(BgL_variablez00_bglt
		BgL_variablez00_18, BgL_typez00_bglt BgL_typez00_19)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 143 */
			{	/* Cfa/type.scm 144 */
				obj_t BgL_ntypez00_1159;

				BgL_typez00_bglt BgL_otypez00_1160;

				if (((obj_t) (BgL_typez00_19) == BGl_za2_za2z00zztype_cachez00))
					{	/* Cfa/type.scm 144 */
						BgL_ntypez00_1159 = BGl_za2objza2z00zztype_cachez00;
					}
				else
					{	/* Cfa/type.scm 144 */
						BgL_ntypez00_1159 = (obj_t) (BgL_typez00_19);
					}
				BgL_otypez00_1160 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->BgL_typez00);
				if (((obj_t) (BgL_otypez00_1160) == BGl_za2_za2z00zztype_cachez00))
					{	/* Cfa/type.scm 148 */
						bool_t BgL_testz00_3325;

						{	/* Cfa/type.scm 148 */
							bool_t BgL_testz00_3326;

							{	/* Cfa/type.scm 148 */
								obj_t BgL_obj1568z00_2079;

								BgL_obj1568z00_2079 = (obj_t) (BgL_variablez00_18);
								BgL_testz00_3326 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1568z00_2079,
									BGl_globalz00zzast_varz00);
							}
							if (BgL_testz00_3326)
								{	/* Cfa/type.scm 149 */
									bool_t BgL_testz00_3329;

									{	/* Cfa/type.scm 149 */
										BgL_valuez00_bglt BgL_arg5201z00_1168;

										BgL_arg5201z00_1168 =
											(((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->
											BgL_valuez00);
										{	/* Cfa/type.scm 149 */
											obj_t BgL_obj1673z00_2081;

											BgL_obj1673z00_2081 = (obj_t) (BgL_arg5201z00_1168);
											BgL_testz00_3329 =
												BGl_iszd2azf3z21zz__objectz00(BgL_obj1673z00_2081,
												BGl_funz00zzast_varz00);
										}
									}
									if (BgL_testz00_3329)
										{	/* Cfa/type.scm 149 */
											BgL_testz00_3325 = ((bool_t) 0);
										}
									else
										{	/* Cfa/type.scm 149 */
											if (CBOOL(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
												{	/* Cfa/type.scm 150 */
													BgL_testz00_3325 = ((bool_t) 0);
												}
											else
												{	/* Cfa/type.scm 151 */
													bool_t BgL_testz00_3335;

													{	/* Cfa/type.scm 151 */
														obj_t BgL_auxz00_3336;

														{
															BgL_typez00_bglt BgL_auxz00_3337;

															BgL_auxz00_3337 =
																(BgL_typez00_bglt) (BgL_ntypez00_1159);
															BgL_auxz00_3336 =
																(((BgL_typez00_bglt) CREF(BgL_auxz00_3337))->
																BgL_classz00);
														}
														BgL_testz00_3335 =
															(BgL_auxz00_3336 == CNST_TABLE_REF(((long) 0)));
													}
													if (BgL_testz00_3335)
														{	/* Cfa/type.scm 151 */
															BgL_testz00_3325 = ((bool_t) 0);
														}
													else
														{	/* Cfa/type.scm 151 */
															BgL_testz00_3325 = ((bool_t) 1);
														}
												}
										}
								}
							else
								{	/* Cfa/type.scm 148 */
									BgL_testz00_3325 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_3325)
							{
								BgL_typez00_bglt BgL_auxz00_3342;

								BgL_auxz00_3342 =
									(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
								return
									((((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->
										BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_3342), BUNSPEC);
							}
						else
							{
								BgL_typez00_bglt BgL_auxz00_3345;

								BgL_auxz00_3345 = (BgL_typez00_bglt) (BgL_ntypez00_1159);
								return
									((((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->
										BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_3345), BUNSPEC);
							}
					}
				else
					{	/* Cfa/type.scm 158 */
						bool_t BgL_testz00_3348;

						if (
							((obj_t) (BgL_otypez00_1160) ==
								BGl_za2vectorza2z00zztype_cachez00))
							{	/* Cfa/type.scm 158 */
								BgL_testz00_3348 =
									BGl_iszd2azf3z21zz__objectz00(BgL_ntypez00_1159,
									BGl_tvecz00zztvector_tvectorz00);
							}
						else
							{	/* Cfa/type.scm 158 */
								BgL_testz00_3348 = ((bool_t) 0);
							}
						if (BgL_testz00_3348)
							{
								BgL_typez00_bglt BgL_auxz00_3353;

								BgL_auxz00_3353 = (BgL_typez00_bglt) (BgL_ntypez00_1159);
								return
									((((BgL_variablez00_bglt) CREF(BgL_variablez00_18))->
										BgL_typez00) =
									((BgL_typez00_bglt) BgL_auxz00_3353), BUNSPEC);
							}
						else
							{	/* Cfa/type.scm 158 */
								return BFALSE;
							}
					}
			}
		}
	}



/* type-node*! */
	bool_t BGl_typezd2nodeza2z12z62zzcfa_typez00(obj_t BgL_nodeza2za2_45)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 354 */
			{
				obj_t BgL_l5110z00_1172;

				BgL_l5110z00_1172 = BgL_nodeza2za2_45;
			BgL_forzd2each5112zd2_1173:
				if (PAIRP(BgL_l5110z00_1172))
					{	/* Cfa/type.scm 355 */
						{	/* Cfa/type.scm 355 */
							obj_t BgL_arg5206z00_1175;

							BgL_arg5206z00_1175 = CAR(BgL_l5110z00_1172);
							{	/* Cfa/type.scm 355 */
								BgL_nodez00_bglt BgL_nodez00_2092;

								BgL_nodez00_2092 = (BgL_nodez00_bglt) (BgL_arg5206z00_1175);
								{	/* Cfa/type.scm 355 */
									obj_t BgL_method5126z00_2093;

									{	/* Cfa/type.scm 355 */
										BgL_objectz00_bglt BgL_objz00_2094;

										BgL_objz00_2094 = (BgL_objectz00_bglt) (BgL_nodez00_2092);
										{	/* Cfa/type.scm 355 */
											long BgL_objzd2classzd2numz00_2095;

											BgL_objzd2classzd2numz00_2095 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2094);
											{	/* Cfa/type.scm 355 */
												obj_t BgL_arg2334z00_2096;

												BgL_arg2334z00_2096 =
													PROCEDURE_REF
													(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
													(int) (((long) 1)));
												{	/* Cfa/type.scm 355 */
													obj_t BgL_arrayz00_2098;

													int BgL_offsetz00_2099;

													BgL_arrayz00_2098 = BgL_arg2334z00_2096;
													BgL_offsetz00_2099 =
														(int) (BgL_objzd2classzd2numz00_2095);
													{	/* Cfa/type.scm 355 */
														long BgL_offsetz00_2100;

														BgL_offsetz00_2100 =
															((long) (BgL_offsetz00_2099) - OBJECT_TYPE);
														{	/* Cfa/type.scm 355 */
															long BgL_modz00_2101;

															{	/* Cfa/type.scm 355 */
																int BgL_arg2336z00_2102;

																BgL_arg2336z00_2102 = (int) (((long) 8));
																{	/* Cfa/type.scm 355 */
																	long BgL_auxz00_3368;

																	BgL_auxz00_3368 =
																		(long) (BgL_arg2336z00_2102);
																	BgL_modz00_2101 =
																		(BgL_offsetz00_2100 / BgL_auxz00_3368);
															}}
															{	/* Cfa/type.scm 355 */
																long BgL_restz00_2103;

																{	/* Cfa/type.scm 355 */
																	int BgL_arg2335z00_2104;

																	BgL_arg2335z00_2104 = (int) (((long) 8));
																	{	/* Cfa/type.scm 355 */
																		long BgL_auxz00_3372;

																		BgL_auxz00_3372 =
																			(long) (BgL_arg2335z00_2104);
																		BgL_restz00_2103 =
																			(BgL_offsetz00_2100 % BgL_auxz00_3372);
																}}
																{	/* Cfa/type.scm 355 */

																	BgL_method5126z00_2093 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2098,
																			(int) (BgL_modz00_2101)),
																		(int) (BgL_restz00_2103));
									}}}}}}}}
									PROCEDURE_ENTRY(BgL_method5126z00_2093)
										(BgL_method5126z00_2093, (obj_t) (BgL_nodez00_2092), BEOA);
						}}}
						{
							obj_t BgL_l5110z00_3382;

							BgL_l5110z00_3382 = CDR(BgL_l5110z00_1172);
							BgL_l5110z00_1172 = BgL_l5110z00_3382;
							goto BgL_forzd2each5112zd2_1173;
						}
					}
				else
					{	/* Cfa/type.scm 355 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_typezd2variablez12zd2defau5113zd2envzc0zzcfa_typez00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_typezd2nodez12zd2default5125zd2envzc0zzcfa_typez00);
		}
	}



/* type-variable! */
	obj_t BGl_typezd2variablez12zc0zzcfa_typez00(BgL_valuez00_bglt BgL_valuez00_4,
		BgL_variablez00_bglt BgL_variablez00_5)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 93 */
			{	/* Cfa/type.scm 93 */
				obj_t BgL_method5114z00_2119;

				{	/* Cfa/type.scm 93 */
					BgL_objectz00_bglt BgL_objz00_2120;

					BgL_objz00_2120 = (BgL_objectz00_bglt) (BgL_valuez00_4);
					{	/* Cfa/type.scm 93 */
						long BgL_objzd2classzd2numz00_2121;

						BgL_objzd2classzd2numz00_2121 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2120);
						{	/* Cfa/type.scm 93 */
							obj_t BgL_arg2334z00_2122;

							BgL_arg2334z00_2122 =
								PROCEDURE_REF(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
								(int) (((long) 1)));
							{	/* Cfa/type.scm 93 */
								obj_t BgL_arrayz00_2124;

								int BgL_offsetz00_2125;

								BgL_arrayz00_2124 = BgL_arg2334z00_2122;
								BgL_offsetz00_2125 = (int) (BgL_objzd2classzd2numz00_2121);
								{	/* Cfa/type.scm 93 */
									long BgL_offsetz00_2126;

									BgL_offsetz00_2126 =
										((long) (BgL_offsetz00_2125) - OBJECT_TYPE);
									{	/* Cfa/type.scm 93 */
										long BgL_modz00_2127;

										{	/* Cfa/type.scm 93 */
											int BgL_arg2336z00_2128;

											BgL_arg2336z00_2128 = (int) (((long) 8));
											{	/* Cfa/type.scm 93 */
												long BgL_auxz00_3394;

												BgL_auxz00_3394 = (long) (BgL_arg2336z00_2128);
												BgL_modz00_2127 =
													(BgL_offsetz00_2126 / BgL_auxz00_3394);
										}}
										{	/* Cfa/type.scm 93 */
											long BgL_restz00_2129;

											{	/* Cfa/type.scm 93 */
												int BgL_arg2335z00_2130;

												BgL_arg2335z00_2130 = (int) (((long) 8));
												{	/* Cfa/type.scm 93 */
													long BgL_auxz00_3398;

													BgL_auxz00_3398 = (long) (BgL_arg2335z00_2130);
													BgL_restz00_2129 =
														(BgL_offsetz00_2126 % BgL_auxz00_3398);
											}}
											{	/* Cfa/type.scm 93 */

												BgL_method5114z00_2119 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2124,
														(int) (BgL_modz00_2127)), (int) (BgL_restz00_2129));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method5114z00_2119) (BgL_method5114z00_2119,
					(obj_t) (BgL_valuez00_4), (obj_t) (BgL_variablez00_5), BEOA);
			}
		}
	}



/* _type-variable! */
	obj_t BGl__typezd2variablez12zc0zzcfa_typez00(obj_t BgL_envz00_3040,
		obj_t BgL_valuez00_3041, obj_t BgL_variablez00_3042)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 93 */
			return
				BGl_typezd2variablez12zc0zzcfa_typez00(
				(BgL_valuez00_bglt) (BgL_valuez00_3041),
				(BgL_variablez00_bglt) (BgL_variablez00_3042));
		}
	}



/* type-variable!-defau5113 */
	obj_t BGl_typezd2variablez12zd2defau5113z12zzcfa_typez00(BgL_valuez00_bglt
		BgL_valuez00_6, BgL_variablez00_bglt BgL_variablez00_7)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			{	/* Cfa/type.scm 94 */
				BgL_typez00_bglt BgL_typez00_2144;

				BgL_typez00_2144 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_7))->BgL_typez00);
				{	/* Cfa/type.scm 94 */
					bool_t BgL_testz00_3413;

					{	/* Cfa/type.scm 94 */
						obj_t BgL_obj1414z00_2148;

						BgL_obj1414z00_2148 = (obj_t) (BgL_typez00_2144);
						BgL_testz00_3413 =
							BGl_iszd2azf3z21zz__objectz00(BgL_obj1414z00_2148,
							BGl_typez00zztype_typez00);
					}
					if (BgL_testz00_3413)
						{	/* Cfa/type.scm 94 */
							return CNST_TABLE_REF(((long) 1));
						}
					else
						{	/* Cfa/type.scm 94 */
							return
								BGl_setzd2variablezd2typez12z12zzcfa_typez00(BgL_variablez00_7,
								BGl_getzd2defaultzd2typez00zztype_cachez00());
						}
				}
			}
		}
	}



/* _type-variable!-defau5113 */
	obj_t BGl__typezd2variablez12zd2defau5113z12zzcfa_typez00(obj_t
		BgL_envz00_3047, obj_t BgL_valuez00_3048, obj_t BgL_variablez00_3049)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			return
				BGl_typezd2variablez12zd2defau5113z12zzcfa_typez00(
				(BgL_valuez00_bglt) (BgL_valuez00_3048),
				(BgL_variablez00_bglt) (BgL_variablez00_3049));
		}
	}



/* type-node! */
	obj_t BGl_typezd2nodez12zc0zzcfa_typez00(BgL_nodez00_bglt BgL_nodez00_20)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 164 */
			{	/* Cfa/type.scm 164 */
				obj_t BgL_method5126z00_2149;

				{	/* Cfa/type.scm 164 */
					BgL_objectz00_bglt BgL_objz00_2150;

					BgL_objz00_2150 = (BgL_objectz00_bglt) (BgL_nodez00_20);
					{	/* Cfa/type.scm 164 */
						long BgL_objzd2classzd2numz00_2151;

						BgL_objzd2classzd2numz00_2151 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2150);
						{	/* Cfa/type.scm 164 */
							obj_t BgL_arg2334z00_2152;

							BgL_arg2334z00_2152 =
								PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
								(int) (((long) 1)));
							{	/* Cfa/type.scm 164 */
								obj_t BgL_arrayz00_2154;

								int BgL_offsetz00_2155;

								BgL_arrayz00_2154 = BgL_arg2334z00_2152;
								BgL_offsetz00_2155 = (int) (BgL_objzd2classzd2numz00_2151);
								{	/* Cfa/type.scm 164 */
									long BgL_offsetz00_2156;

									BgL_offsetz00_2156 =
										((long) (BgL_offsetz00_2155) - OBJECT_TYPE);
									{	/* Cfa/type.scm 164 */
										long BgL_modz00_2157;

										{	/* Cfa/type.scm 164 */
											int BgL_arg2336z00_2158;

											BgL_arg2336z00_2158 = (int) (((long) 8));
											{	/* Cfa/type.scm 164 */
												long BgL_auxz00_3430;

												BgL_auxz00_3430 = (long) (BgL_arg2336z00_2158);
												BgL_modz00_2157 =
													(BgL_offsetz00_2156 / BgL_auxz00_3430);
										}}
										{	/* Cfa/type.scm 164 */
											long BgL_restz00_2159;

											{	/* Cfa/type.scm 164 */
												int BgL_arg2335z00_2160;

												BgL_arg2335z00_2160 = (int) (((long) 8));
												{	/* Cfa/type.scm 164 */
													long BgL_auxz00_3434;

													BgL_auxz00_3434 = (long) (BgL_arg2335z00_2160);
													BgL_restz00_2159 =
														(BgL_offsetz00_2156 % BgL_auxz00_3434);
											}}
											{	/* Cfa/type.scm 164 */

												BgL_method5126z00_2149 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2154,
														(int) (BgL_modz00_2157)), (int) (BgL_restz00_2159));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method5126z00_2149) (BgL_method5126z00_2149,
					(obj_t) (BgL_nodez00_20), BEOA);
			}
		}
	}



/* _type-node! */
	obj_t BGl__typezd2nodez12zc0zzcfa_typez00(obj_t BgL_envz00_3043,
		obj_t BgL_nodez00_3044)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 164 */
			return
				BGl_typezd2nodez12zc0zzcfa_typez00(
				(BgL_nodez00_bglt) (BgL_nodez00_3044));
		}
	}



/* type-node!-default5125 */
	obj_t BGl_typezd2nodez12zd2default5125z12zzcfa_typez00(BgL_nodez00_bglt
		BgL_nodez00_21)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
				BGl_string5470z00zzcfa_typez00, (obj_t) (BgL_nodez00_21));
		}
	}



/* _type-node!-default5125 */
	obj_t BGl__typezd2nodez12zd2default5125z12zzcfa_typez00(obj_t BgL_envz00_3050,
		obj_t BgL_nodez00_3051)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			return
				BGl_typezd2nodez12zd2default5125z12zzcfa_typez00(
				(BgL_nodez00_bglt) (BgL_nodez00_3051));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_svarzf2Cinfozf2zzcfa_infoz00, BGl_proc5471z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_scnstzf2Cinfozf2zzcfa_infoz00, BGl_proc5472z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_cvarzf2Cinfozf2zzcfa_infoz00, BGl_proc5473z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_sexitzf2Cinfozf2zzcfa_infoz00, BGl_proc5474z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
				BGl_internzd2sfunzf2Cinfoz20zzcfa_infoz00,
				BGl_proc5475z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_atomz00zzast_nodez00,
				BGl_proc5476z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_kwotez00zzast_nodez00,
				BGl_proc5477z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_varz00zzast_nodez00,
				BGl_proc5478z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_closurez00zzast_nodez00,
				BGl_proc5479z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_sequencez00zzast_nodez00,
				BGl_proc5480z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_appz00zzast_nodez00,
				BGl_proc5481z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc5482z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_funcallz00zzast_nodez00,
				BGl_proc5483z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_externz00zzast_nodez00,
				BGl_proc5484z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_vrefz00zzast_nodez00,
				BGl_proc5485z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_vsetz12z12zzast_nodez00,
				BGl_proc5486z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_castz00zzast_nodez00,
				BGl_proc5487z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_setqz00zzast_nodez00,
				BGl_proc5488z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc5489z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_failz00zzast_nodez00,
				BGl_proc5490z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00, BGl_selectz00zzast_nodez00,
				BGl_proc5491z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc5492z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc5493z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc5494z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc5495z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc5496z00zzcfa_typez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc5497z00zzcfa_typez00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc5498z00zzcfa_typez00);
		}
	}



/* type-node!-box-ref5173 */
	obj_t BGl_typezd2nodez12zd2boxzd2ref5173zc0zzcfa_typez00(obj_t
		BgL_envz00_3080, obj_t BgL_nodez00_3081)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 347 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1989;

				BgL_nodez00_1989 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_3081);
				{	/* Cfa/type.scm 348 */
					BgL_varz00_bglt BgL_arg5398z00_3010;

					BgL_arg5398z00_3010 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1989))->BgL_varz00);
					{	/* Cfa/type.scm 348 */
						BgL_nodez00_bglt BgL_nodez00_3012;

						BgL_nodez00_3012 = (BgL_nodez00_bglt) (BgL_arg5398z00_3010);
						{	/* Cfa/type.scm 348 */
							obj_t BgL_method5126z00_3013;

							{	/* Cfa/type.scm 348 */
								BgL_objectz00_bglt BgL_objz00_3014;

								BgL_objz00_3014 = (BgL_objectz00_bglt) (BgL_nodez00_3012);
								{	/* Cfa/type.scm 348 */
									long BgL_objzd2classzd2numz00_3015;

									BgL_objzd2classzd2numz00_3015 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_3014);
									{	/* Cfa/type.scm 348 */
										obj_t BgL_arg2334z00_3016;

										BgL_arg2334z00_3016 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 348 */
											obj_t BgL_arrayz00_3018;

											int BgL_offsetz00_3019;

											BgL_arrayz00_3018 = BgL_arg2334z00_3016;
											BgL_offsetz00_3019 =
												(int) (BgL_objzd2classzd2numz00_3015);
											{	/* Cfa/type.scm 348 */
												long BgL_offsetz00_3020;

												BgL_offsetz00_3020 =
													((long) (BgL_offsetz00_3019) - OBJECT_TYPE);
												{	/* Cfa/type.scm 348 */
													long BgL_modz00_3021;

													{	/* Cfa/type.scm 348 */
														int BgL_arg2336z00_3022;

														BgL_arg2336z00_3022 = (int) (((long) 8));
														{	/* Cfa/type.scm 348 */
															long BgL_auxz00_3489;

															BgL_auxz00_3489 = (long) (BgL_arg2336z00_3022);
															BgL_modz00_3021 =
																(BgL_offsetz00_3020 / BgL_auxz00_3489);
													}}
													{	/* Cfa/type.scm 348 */
														long BgL_restz00_3023;

														{	/* Cfa/type.scm 348 */
															int BgL_arg2335z00_3024;

															BgL_arg2335z00_3024 = (int) (((long) 8));
															{	/* Cfa/type.scm 348 */
																long BgL_auxz00_3493;

																BgL_auxz00_3493 = (long) (BgL_arg2335z00_3024);
																BgL_restz00_3023 =
																	(BgL_offsetz00_3020 % BgL_auxz00_3493);
														}}
														{	/* Cfa/type.scm 348 */

															BgL_method5126z00_3013 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_3018,
																	(int) (BgL_modz00_3021)),
																(int) (BgL_restz00_3023));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method5126z00_3013) (BgL_method5126z00_3013,
								(obj_t) (BgL_nodez00_3012), BEOA);
						}
					}
				}
			}
		}
	}



/* type-node!-box-set!5171 */
	obj_t BGl_typezd2nodez12zd2boxzd2setz125171zd2zzcfa_typez00(obj_t
		BgL_envz00_3082, obj_t BgL_nodez00_3083)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 339 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1981;

				BgL_nodez00_1981 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_3083);
				{	/* Cfa/type.scm 341 */
					BgL_varz00_bglt BgL_arg5395z00_1985;

					BgL_arg5395z00_1985 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1981))->BgL_varz00);
					{	/* Cfa/type.scm 341 */
						BgL_nodez00_bglt BgL_nodez00_2956;

						BgL_nodez00_2956 = (BgL_nodez00_bglt) (BgL_arg5395z00_1985);
						{	/* Cfa/type.scm 341 */
							obj_t BgL_method5126z00_2957;

							{	/* Cfa/type.scm 341 */
								BgL_objectz00_bglt BgL_objz00_2958;

								BgL_objz00_2958 = (BgL_objectz00_bglt) (BgL_nodez00_2956);
								{	/* Cfa/type.scm 341 */
									long BgL_objzd2classzd2numz00_2959;

									BgL_objzd2classzd2numz00_2959 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2958);
									{	/* Cfa/type.scm 341 */
										obj_t BgL_arg2334z00_2960;

										BgL_arg2334z00_2960 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 341 */
											obj_t BgL_arrayz00_2962;

											int BgL_offsetz00_2963;

											BgL_arrayz00_2962 = BgL_arg2334z00_2960;
											BgL_offsetz00_2963 =
												(int) (BgL_objzd2classzd2numz00_2959);
											{	/* Cfa/type.scm 341 */
												long BgL_offsetz00_2964;

												BgL_offsetz00_2964 =
													((long) (BgL_offsetz00_2963) - OBJECT_TYPE);
												{	/* Cfa/type.scm 341 */
													long BgL_modz00_2965;

													{	/* Cfa/type.scm 341 */
														int BgL_arg2336z00_2966;

														BgL_arg2336z00_2966 = (int) (((long) 8));
														{	/* Cfa/type.scm 341 */
															long BgL_auxz00_3514;

															BgL_auxz00_3514 = (long) (BgL_arg2336z00_2966);
															BgL_modz00_2965 =
																(BgL_offsetz00_2964 / BgL_auxz00_3514);
													}}
													{	/* Cfa/type.scm 341 */
														long BgL_restz00_2967;

														{	/* Cfa/type.scm 341 */
															int BgL_arg2335z00_2968;

															BgL_arg2335z00_2968 = (int) (((long) 8));
															{	/* Cfa/type.scm 341 */
																long BgL_auxz00_3518;

																BgL_auxz00_3518 = (long) (BgL_arg2335z00_2968);
																BgL_restz00_2967 =
																	(BgL_offsetz00_2964 % BgL_auxz00_3518);
														}}
														{	/* Cfa/type.scm 341 */

															BgL_method5126z00_2957 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2962,
																	(int) (BgL_modz00_2965)),
																(int) (BgL_restz00_2967));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method5126z00_2957) (BgL_method5126z00_2957,
								(obj_t) (BgL_nodez00_2956), BEOA);
				}}}
				{	/* Cfa/type.scm 342 */
					BgL_nodez00_bglt BgL_arg5396z00_1986;

					BgL_arg5396z00_1986 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1981))->BgL_valuez00);
					{	/* Cfa/type.scm 342 */
						obj_t BgL_method5126z00_2984;

						{	/* Cfa/type.scm 342 */
							BgL_objectz00_bglt BgL_objz00_2985;

							BgL_objz00_2985 = (BgL_objectz00_bglt) (BgL_arg5396z00_1986);
							{	/* Cfa/type.scm 342 */
								long BgL_objzd2classzd2numz00_2986;

								BgL_objzd2classzd2numz00_2986 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2985);
								{	/* Cfa/type.scm 342 */
									obj_t BgL_arg2334z00_2987;

									BgL_arg2334z00_2987 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 342 */
										obj_t BgL_arrayz00_2989;

										int BgL_offsetz00_2990;

										BgL_arrayz00_2989 = BgL_arg2334z00_2987;
										BgL_offsetz00_2990 = (int) (BgL_objzd2classzd2numz00_2986);
										{	/* Cfa/type.scm 342 */
											long BgL_offsetz00_2991;

											BgL_offsetz00_2991 =
												((long) (BgL_offsetz00_2990) - OBJECT_TYPE);
											{	/* Cfa/type.scm 342 */
												long BgL_modz00_2992;

												{	/* Cfa/type.scm 342 */
													int BgL_arg2336z00_2993;

													BgL_arg2336z00_2993 = (int) (((long) 8));
													{	/* Cfa/type.scm 342 */
														long BgL_auxz00_3537;

														BgL_auxz00_3537 = (long) (BgL_arg2336z00_2993);
														BgL_modz00_2992 =
															(BgL_offsetz00_2991 / BgL_auxz00_3537);
												}}
												{	/* Cfa/type.scm 342 */
													long BgL_restz00_2994;

													{	/* Cfa/type.scm 342 */
														int BgL_arg2335z00_2995;

														BgL_arg2335z00_2995 = (int) (((long) 8));
														{	/* Cfa/type.scm 342 */
															long BgL_auxz00_3541;

															BgL_auxz00_3541 = (long) (BgL_arg2335z00_2995);
															BgL_restz00_2994 =
																(BgL_offsetz00_2991 % BgL_auxz00_3541);
													}}
													{	/* Cfa/type.scm 342 */

														BgL_method5126z00_2984 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2989,
																(int) (BgL_modz00_2992)),
															(int) (BgL_restz00_2994));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5126z00_2984) (BgL_method5126z00_2984,
							(obj_t) (BgL_arg5396z00_1986), BEOA);
					}
				}
			}
		}
	}



/* type-node!-make-box5169 */
	obj_t BGl_typezd2nodez12zd2makezd2box5169zc0zzcfa_typez00(obj_t
		BgL_envz00_3084, obj_t BgL_nodez00_3085)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 332 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1974;

				BgL_nodez00_1974 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_3085);
				{	/* Cfa/type.scm 333 */
					BgL_nodez00_bglt BgL_arg5393z00_2927;

					BgL_arg5393z00_2927 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1974))->BgL_valuez00);
					{	/* Cfa/type.scm 333 */
						obj_t BgL_method5126z00_2930;

						{	/* Cfa/type.scm 333 */
							BgL_objectz00_bglt BgL_objz00_2931;

							BgL_objz00_2931 = (BgL_objectz00_bglt) (BgL_arg5393z00_2927);
							{	/* Cfa/type.scm 333 */
								long BgL_objzd2classzd2numz00_2932;

								BgL_objzd2classzd2numz00_2932 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2931);
								{	/* Cfa/type.scm 333 */
									obj_t BgL_arg2334z00_2933;

									BgL_arg2334z00_2933 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 333 */
										obj_t BgL_arrayz00_2935;

										int BgL_offsetz00_2936;

										BgL_arrayz00_2935 = BgL_arg2334z00_2933;
										BgL_offsetz00_2936 = (int) (BgL_objzd2classzd2numz00_2932);
										{	/* Cfa/type.scm 333 */
											long BgL_offsetz00_2937;

											BgL_offsetz00_2937 =
												((long) (BgL_offsetz00_2936) - OBJECT_TYPE);
											{	/* Cfa/type.scm 333 */
												long BgL_modz00_2938;

												{	/* Cfa/type.scm 333 */
													int BgL_arg2336z00_2939;

													BgL_arg2336z00_2939 = (int) (((long) 8));
													{	/* Cfa/type.scm 333 */
														long BgL_auxz00_3561;

														BgL_auxz00_3561 = (long) (BgL_arg2336z00_2939);
														BgL_modz00_2938 =
															(BgL_offsetz00_2937 / BgL_auxz00_3561);
												}}
												{	/* Cfa/type.scm 333 */
													long BgL_restz00_2940;

													{	/* Cfa/type.scm 333 */
														int BgL_arg2335z00_2941;

														BgL_arg2335z00_2941 = (int) (((long) 8));
														{	/* Cfa/type.scm 333 */
															long BgL_auxz00_3565;

															BgL_auxz00_3565 = (long) (BgL_arg2335z00_2941);
															BgL_restz00_2940 =
																(BgL_offsetz00_2937 % BgL_auxz00_3565);
													}}
													{	/* Cfa/type.scm 333 */

														BgL_method5126z00_2930 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2935,
																(int) (BgL_modz00_2938)),
															(int) (BgL_restz00_2940));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5126z00_2930) (BgL_method5126z00_2930,
							(obj_t) (BgL_arg5393z00_2927), BEOA);
					}
				}
			}
		}
	}



/* type-node!-jump-ex-i5167 */
	obj_t BGl_typezd2nodez12zd2jumpzd2exzd2i5167z12zzcfa_typez00(obj_t
		BgL_envz00_3086, obj_t BgL_nodez00_3087)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 324 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1966;

				BgL_nodez00_1966 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3087);
				{	/* Cfa/type.scm 326 */
					BgL_nodez00_bglt BgL_arg5390z00_1970;

					BgL_arg5390z00_1970 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1966))->
						BgL_exitz00);
					{	/* Cfa/type.scm 326 */
						obj_t BgL_method5126z00_2874;

						{	/* Cfa/type.scm 326 */
							BgL_objectz00_bglt BgL_objz00_2875;

							BgL_objz00_2875 = (BgL_objectz00_bglt) (BgL_arg5390z00_1970);
							{	/* Cfa/type.scm 326 */
								long BgL_objzd2classzd2numz00_2876;

								BgL_objzd2classzd2numz00_2876 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2875);
								{	/* Cfa/type.scm 326 */
									obj_t BgL_arg2334z00_2877;

									BgL_arg2334z00_2877 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 326 */
										obj_t BgL_arrayz00_2879;

										int BgL_offsetz00_2880;

										BgL_arrayz00_2879 = BgL_arg2334z00_2877;
										BgL_offsetz00_2880 = (int) (BgL_objzd2classzd2numz00_2876);
										{	/* Cfa/type.scm 326 */
											long BgL_offsetz00_2881;

											BgL_offsetz00_2881 =
												((long) (BgL_offsetz00_2880) - OBJECT_TYPE);
											{	/* Cfa/type.scm 326 */
												long BgL_modz00_2882;

												{	/* Cfa/type.scm 326 */
													int BgL_arg2336z00_2883;

													BgL_arg2336z00_2883 = (int) (((long) 8));
													{	/* Cfa/type.scm 326 */
														long BgL_auxz00_3585;

														BgL_auxz00_3585 = (long) (BgL_arg2336z00_2883);
														BgL_modz00_2882 =
															(BgL_offsetz00_2881 / BgL_auxz00_3585);
												}}
												{	/* Cfa/type.scm 326 */
													long BgL_restz00_2884;

													{	/* Cfa/type.scm 326 */
														int BgL_arg2335z00_2885;

														BgL_arg2335z00_2885 = (int) (((long) 8));
														{	/* Cfa/type.scm 326 */
															long BgL_auxz00_3589;

															BgL_auxz00_3589 = (long) (BgL_arg2335z00_2885);
															BgL_restz00_2884 =
																(BgL_offsetz00_2881 % BgL_auxz00_3589);
													}}
													{	/* Cfa/type.scm 326 */

														BgL_method5126z00_2874 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2879,
																(int) (BgL_modz00_2882)),
															(int) (BgL_restz00_2884));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5126z00_2874) (BgL_method5126z00_2874,
							(obj_t) (BgL_arg5390z00_1970), BEOA);
				}}
				{	/* Cfa/type.scm 327 */
					BgL_nodez00_bglt BgL_arg5391z00_1971;

					BgL_arg5391z00_1971 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1966))->
						BgL_valuez00);
					{	/* Cfa/type.scm 327 */
						obj_t BgL_method5126z00_2901;

						{	/* Cfa/type.scm 327 */
							BgL_objectz00_bglt BgL_objz00_2902;

							BgL_objz00_2902 = (BgL_objectz00_bglt) (BgL_arg5391z00_1971);
							{	/* Cfa/type.scm 327 */
								long BgL_objzd2classzd2numz00_2903;

								BgL_objzd2classzd2numz00_2903 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2902);
								{	/* Cfa/type.scm 327 */
									obj_t BgL_arg2334z00_2904;

									BgL_arg2334z00_2904 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 327 */
										obj_t BgL_arrayz00_2906;

										int BgL_offsetz00_2907;

										BgL_arrayz00_2906 = BgL_arg2334z00_2904;
										BgL_offsetz00_2907 = (int) (BgL_objzd2classzd2numz00_2903);
										{	/* Cfa/type.scm 327 */
											long BgL_offsetz00_2908;

											BgL_offsetz00_2908 =
												((long) (BgL_offsetz00_2907) - OBJECT_TYPE);
											{	/* Cfa/type.scm 327 */
												long BgL_modz00_2909;

												{	/* Cfa/type.scm 327 */
													int BgL_arg2336z00_2910;

													BgL_arg2336z00_2910 = (int) (((long) 8));
													{	/* Cfa/type.scm 327 */
														long BgL_auxz00_3608;

														BgL_auxz00_3608 = (long) (BgL_arg2336z00_2910);
														BgL_modz00_2909 =
															(BgL_offsetz00_2908 / BgL_auxz00_3608);
												}}
												{	/* Cfa/type.scm 327 */
													long BgL_restz00_2911;

													{	/* Cfa/type.scm 327 */
														int BgL_arg2335z00_2912;

														BgL_arg2335z00_2912 = (int) (((long) 8));
														{	/* Cfa/type.scm 327 */
															long BgL_auxz00_3612;

															BgL_auxz00_3612 = (long) (BgL_arg2335z00_2912);
															BgL_restz00_2911 =
																(BgL_offsetz00_2908 % BgL_auxz00_3612);
													}}
													{	/* Cfa/type.scm 327 */

														BgL_method5126z00_2901 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2906,
																(int) (BgL_modz00_2909)),
															(int) (BgL_restz00_2911));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5126z00_2901) (BgL_method5126z00_2901,
							(obj_t) (BgL_arg5391z00_1971), BEOA);
					}
				}
			}
		}
	}



/* type-node!-set-ex-it5165 */
	obj_t BGl_typezd2nodez12zd2setzd2exzd2it5165z12zzcfa_typez00(obj_t
		BgL_envz00_3088, obj_t BgL_nodez00_3089)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 314 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1955;

				BgL_nodez00_1955 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3089);
				{	/* Cfa/type.scm 316 */
					BgL_variablez00_bglt BgL_vz00_1959;

					{	/* Cfa/type.scm 316 */
						BgL_varz00_bglt BgL_obj1972z00_2789;

						BgL_obj1972z00_2789 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1955))->
							BgL_varz00);
						BgL_vz00_1959 =
							(((BgL_varz00_bglt) CREF(BgL_obj1972z00_2789))->BgL_variablez00);
					}
					{	/* Cfa/type.scm 317 */
						BgL_valuez00_bglt BgL_arg5385z00_1960;

						BgL_arg5385z00_1960 =
							(((BgL_variablez00_bglt) CREF(BgL_vz00_1959))->BgL_valuez00);
						{	/* Cfa/type.scm 317 */
							obj_t BgL_method5114z00_2793;

							{	/* Cfa/type.scm 317 */
								BgL_objectz00_bglt BgL_objz00_2794;

								BgL_objz00_2794 = (BgL_objectz00_bglt) (BgL_arg5385z00_1960);
								{	/* Cfa/type.scm 317 */
									long BgL_objzd2classzd2numz00_2795;

									BgL_objzd2classzd2numz00_2795 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2794);
									{	/* Cfa/type.scm 317 */
										obj_t BgL_arg2334z00_2796;

										BgL_arg2334z00_2796 =
											PROCEDURE_REF
											(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 317 */
											obj_t BgL_arrayz00_2798;

											int BgL_offsetz00_2799;

											BgL_arrayz00_2798 = BgL_arg2334z00_2796;
											BgL_offsetz00_2799 =
												(int) (BgL_objzd2classzd2numz00_2795);
											{	/* Cfa/type.scm 317 */
												long BgL_offsetz00_2800;

												BgL_offsetz00_2800 =
													((long) (BgL_offsetz00_2799) - OBJECT_TYPE);
												{	/* Cfa/type.scm 317 */
													long BgL_modz00_2801;

													{	/* Cfa/type.scm 317 */
														int BgL_arg2336z00_2802;

														BgL_arg2336z00_2802 = (int) (((long) 8));
														{	/* Cfa/type.scm 317 */
															long BgL_auxz00_3634;

															BgL_auxz00_3634 = (long) (BgL_arg2336z00_2802);
															BgL_modz00_2801 =
																(BgL_offsetz00_2800 / BgL_auxz00_3634);
													}}
													{	/* Cfa/type.scm 317 */
														long BgL_restz00_2803;

														{	/* Cfa/type.scm 317 */
															int BgL_arg2335z00_2804;

															BgL_arg2335z00_2804 = (int) (((long) 8));
															{	/* Cfa/type.scm 317 */
																long BgL_auxz00_3638;

																BgL_auxz00_3638 = (long) (BgL_arg2335z00_2804);
																BgL_restz00_2803 =
																	(BgL_offsetz00_2800 % BgL_auxz00_3638);
														}}
														{	/* Cfa/type.scm 317 */

															BgL_method5114z00_2793 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2798,
																	(int) (BgL_modz00_2801)),
																(int) (BgL_restz00_2803));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method5114z00_2793) (BgL_method5114z00_2793,
								(obj_t) (BgL_arg5385z00_1960), (obj_t) (BgL_vz00_1959), BEOA);
				}}}
				{	/* Cfa/type.scm 318 */
					BgL_nodez00_bglt BgL_arg5387z00_1962;

					BgL_arg5387z00_1962 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1955))->BgL_bodyz00);
					{	/* Cfa/type.scm 318 */
						obj_t BgL_method5126z00_2820;

						{	/* Cfa/type.scm 318 */
							BgL_objectz00_bglt BgL_objz00_2821;

							BgL_objz00_2821 = (BgL_objectz00_bglt) (BgL_arg5387z00_1962);
							{	/* Cfa/type.scm 318 */
								long BgL_objzd2classzd2numz00_2822;

								BgL_objzd2classzd2numz00_2822 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2821);
								{	/* Cfa/type.scm 318 */
									obj_t BgL_arg2334z00_2823;

									BgL_arg2334z00_2823 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 318 */
										obj_t BgL_arrayz00_2825;

										int BgL_offsetz00_2826;

										BgL_arrayz00_2825 = BgL_arg2334z00_2823;
										BgL_offsetz00_2826 = (int) (BgL_objzd2classzd2numz00_2822);
										{	/* Cfa/type.scm 318 */
											long BgL_offsetz00_2827;

											BgL_offsetz00_2827 =
												((long) (BgL_offsetz00_2826) - OBJECT_TYPE);
											{	/* Cfa/type.scm 318 */
												long BgL_modz00_2828;

												{	/* Cfa/type.scm 318 */
													int BgL_arg2336z00_2829;

													BgL_arg2336z00_2829 = (int) (((long) 8));
													{	/* Cfa/type.scm 318 */
														long BgL_auxz00_3658;

														BgL_auxz00_3658 = (long) (BgL_arg2336z00_2829);
														BgL_modz00_2828 =
															(BgL_offsetz00_2827 / BgL_auxz00_3658);
												}}
												{	/* Cfa/type.scm 318 */
													long BgL_restz00_2830;

													{	/* Cfa/type.scm 318 */
														int BgL_arg2335z00_2831;

														BgL_arg2335z00_2831 = (int) (((long) 8));
														{	/* Cfa/type.scm 318 */
															long BgL_auxz00_3662;

															BgL_auxz00_3662 = (long) (BgL_arg2335z00_2831);
															BgL_restz00_2830 =
																(BgL_offsetz00_2827 % BgL_auxz00_3662);
													}}
													{	/* Cfa/type.scm 318 */

														BgL_method5126z00_2820 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2825,
																(int) (BgL_modz00_2828)),
															(int) (BgL_restz00_2830));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5126z00_2820) (BgL_method5126z00_2820,
							(obj_t) (BgL_arg5387z00_1962), BEOA);
				}}
				{	/* Cfa/type.scm 319 */
					BgL_varz00_bglt BgL_arg5388z00_1963;

					BgL_arg5388z00_1963 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1955))->BgL_varz00);
					{	/* Cfa/type.scm 319 */
						BgL_nodez00_bglt BgL_nodez00_2846;

						BgL_nodez00_2846 = (BgL_nodez00_bglt) (BgL_arg5388z00_1963);
						{	/* Cfa/type.scm 319 */
							obj_t BgL_method5126z00_2847;

							{	/* Cfa/type.scm 319 */
								BgL_objectz00_bglt BgL_objz00_2848;

								BgL_objz00_2848 = (BgL_objectz00_bglt) (BgL_nodez00_2846);
								{	/* Cfa/type.scm 319 */
									long BgL_objzd2classzd2numz00_2849;

									BgL_objzd2classzd2numz00_2849 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2848);
									{	/* Cfa/type.scm 319 */
										obj_t BgL_arg2334z00_2850;

										BgL_arg2334z00_2850 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 319 */
											obj_t BgL_arrayz00_2852;

											int BgL_offsetz00_2853;

											BgL_arrayz00_2852 = BgL_arg2334z00_2850;
											BgL_offsetz00_2853 =
												(int) (BgL_objzd2classzd2numz00_2849);
											{	/* Cfa/type.scm 319 */
												long BgL_offsetz00_2854;

												BgL_offsetz00_2854 =
													((long) (BgL_offsetz00_2853) - OBJECT_TYPE);
												{	/* Cfa/type.scm 319 */
													long BgL_modz00_2855;

													{	/* Cfa/type.scm 319 */
														int BgL_arg2336z00_2856;

														BgL_arg2336z00_2856 = (int) (((long) 8));
														{	/* Cfa/type.scm 319 */
															long BgL_auxz00_3682;

															BgL_auxz00_3682 = (long) (BgL_arg2336z00_2856);
															BgL_modz00_2855 =
																(BgL_offsetz00_2854 / BgL_auxz00_3682);
													}}
													{	/* Cfa/type.scm 319 */
														long BgL_restz00_2857;

														{	/* Cfa/type.scm 319 */
															int BgL_arg2335z00_2858;

															BgL_arg2335z00_2858 = (int) (((long) 8));
															{	/* Cfa/type.scm 319 */
																long BgL_auxz00_3686;

																BgL_auxz00_3686 = (long) (BgL_arg2335z00_2858);
																BgL_restz00_2857 =
																	(BgL_offsetz00_2854 % BgL_auxz00_3686);
														}}
														{	/* Cfa/type.scm 319 */

															BgL_method5126z00_2847 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2852,
																	(int) (BgL_modz00_2855)),
																(int) (BgL_restz00_2857));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method5126z00_2847) (BgL_method5126z00_2847,
								(obj_t) (BgL_nodez00_2846), BEOA);
						}
					}
				}
			}
		}
	}



/* type-node!-let-var5163 */
	obj_t BGl_typezd2nodez12zd2letzd2var5163zc0zzcfa_typez00(obj_t
		BgL_envz00_3090, obj_t BgL_nodez00_3091)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 301 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1939;

				BgL_nodez00_1939 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3091);
				{	/* Cfa/type.scm 303 */
					obj_t BgL_g5109z00_1943;

					BgL_g5109z00_1943 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1939))->BgL_bindingsz00);
					{
						obj_t BgL_l5107z00_1944;

						BgL_l5107z00_1944 = BgL_g5109z00_1943;
					BgL_forzd2each5108zd2_1945:
						if (PAIRP(BgL_l5107z00_1944))
							{	/* Cfa/type.scm 303 */
								{	/* Cfa/type.scm 304 */
									obj_t BgL_bindingz00_1947;

									BgL_bindingz00_1947 = CAR(BgL_l5107z00_1944);
									{	/* Cfa/type.scm 304 */
										obj_t BgL_varz00_1948;

										obj_t BgL_valz00_1949;

										BgL_varz00_1948 = CAR(BgL_bindingz00_1947);
										BgL_valz00_1949 = CDR(BgL_bindingz00_1947);
										{	/* Cfa/type.scm 306 */
											BgL_nodez00_bglt BgL_nodez00_2706;

											BgL_nodez00_2706 = (BgL_nodez00_bglt) (BgL_valz00_1949);
											{	/* Cfa/type.scm 306 */
												obj_t BgL_method5126z00_2707;

												{	/* Cfa/type.scm 306 */
													BgL_objectz00_bglt BgL_objz00_2708;

													BgL_objz00_2708 =
														(BgL_objectz00_bglt) (BgL_nodez00_2706);
													{	/* Cfa/type.scm 306 */
														long BgL_objzd2classzd2numz00_2709;

														BgL_objzd2classzd2numz00_2709 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2708);
														{	/* Cfa/type.scm 306 */
															obj_t BgL_arg2334z00_2710;

															BgL_arg2334z00_2710 =
																PROCEDURE_REF
																(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
																(int) (((long) 1)));
															{	/* Cfa/type.scm 306 */
																obj_t BgL_arrayz00_2712;

																int BgL_offsetz00_2713;

																BgL_arrayz00_2712 = BgL_arg2334z00_2710;
																BgL_offsetz00_2713 =
																	(int) (BgL_objzd2classzd2numz00_2709);
																{	/* Cfa/type.scm 306 */
																	long BgL_offsetz00_2714;

																	BgL_offsetz00_2714 =
																		((long) (BgL_offsetz00_2713) - OBJECT_TYPE);
																	{	/* Cfa/type.scm 306 */
																		long BgL_modz00_2715;

																		{	/* Cfa/type.scm 306 */
																			int BgL_arg2336z00_2716;

																			BgL_arg2336z00_2716 = (int) (((long) 8));
																			{	/* Cfa/type.scm 306 */
																				long BgL_auxz00_3712;

																				BgL_auxz00_3712 =
																					(long) (BgL_arg2336z00_2716);
																				BgL_modz00_2715 =
																					(BgL_offsetz00_2714 /
																					BgL_auxz00_3712);
																		}}
																		{	/* Cfa/type.scm 306 */
																			long BgL_restz00_2717;

																			{	/* Cfa/type.scm 306 */
																				int BgL_arg2335z00_2718;

																				BgL_arg2335z00_2718 =
																					(int) (((long) 8));
																				{	/* Cfa/type.scm 306 */
																					long BgL_auxz00_3716;

																					BgL_auxz00_3716 =
																						(long) (BgL_arg2335z00_2718);
																					BgL_restz00_2717 =
																						(BgL_offsetz00_2714 %
																						BgL_auxz00_3716);
																			}}
																			{	/* Cfa/type.scm 306 */

																				BgL_method5126z00_2707 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2712,
																						(int) (BgL_modz00_2715)),
																					(int) (BgL_restz00_2717));
												}}}}}}}}
												PROCEDURE_ENTRY(BgL_method5126z00_2707)
													(BgL_method5126z00_2707, (obj_t) (BgL_nodez00_2706),
													BEOA);
										}}
										{	/* Cfa/type.scm 307 */
											BgL_valuez00_bglt BgL_arg5381z00_1950;

											{
												BgL_variablez00_bglt BgL_auxz00_3726;

												BgL_auxz00_3726 =
													(BgL_variablez00_bglt) (BgL_varz00_1948);
												BgL_arg5381z00_1950 =
													(((BgL_variablez00_bglt) CREF(BgL_auxz00_3726))->
													BgL_valuez00);
											}
											{	/* Cfa/type.scm 307 */
												BgL_variablez00_bglt BgL_variablez00_2734;

												BgL_variablez00_2734 =
													(BgL_variablez00_bglt) (BgL_varz00_1948);
												{	/* Cfa/type.scm 307 */
													obj_t BgL_method5114z00_2735;

													{	/* Cfa/type.scm 307 */
														BgL_objectz00_bglt BgL_objz00_2736;

														BgL_objz00_2736 =
															(BgL_objectz00_bglt) (BgL_arg5381z00_1950);
														{	/* Cfa/type.scm 307 */
															long BgL_objzd2classzd2numz00_2737;

															BgL_objzd2classzd2numz00_2737 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2736);
															{	/* Cfa/type.scm 307 */
																obj_t BgL_arg2334z00_2738;

																BgL_arg2334z00_2738 =
																	PROCEDURE_REF
																	(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
																	(int) (((long) 1)));
																{	/* Cfa/type.scm 307 */
																	obj_t BgL_arrayz00_2740;

																	int BgL_offsetz00_2741;

																	BgL_arrayz00_2740 = BgL_arg2334z00_2738;
																	BgL_offsetz00_2741 =
																		(int) (BgL_objzd2classzd2numz00_2737);
																	{	/* Cfa/type.scm 307 */
																		long BgL_offsetz00_2742;

																		BgL_offsetz00_2742 =
																			(
																			(long) (BgL_offsetz00_2741) -
																			OBJECT_TYPE);
																		{	/* Cfa/type.scm 307 */
																			long BgL_modz00_2743;

																			{	/* Cfa/type.scm 307 */
																				int BgL_arg2336z00_2744;

																				BgL_arg2336z00_2744 =
																					(int) (((long) 8));
																				{	/* Cfa/type.scm 307 */
																					long BgL_auxz00_3738;

																					BgL_auxz00_3738 =
																						(long) (BgL_arg2336z00_2744);
																					BgL_modz00_2743 =
																						(BgL_offsetz00_2742 /
																						BgL_auxz00_3738);
																			}}
																			{	/* Cfa/type.scm 307 */
																				long BgL_restz00_2745;

																				{	/* Cfa/type.scm 307 */
																					int BgL_arg2335z00_2746;

																					BgL_arg2335z00_2746 =
																						(int) (((long) 8));
																					{	/* Cfa/type.scm 307 */
																						long BgL_auxz00_3742;

																						BgL_auxz00_3742 =
																							(long) (BgL_arg2335z00_2746);
																						BgL_restz00_2745 =
																							(BgL_offsetz00_2742 %
																							BgL_auxz00_3742);
																				}}
																				{	/* Cfa/type.scm 307 */

																					BgL_method5114z00_2735 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2740,
																							(int) (BgL_modz00_2743)),
																						(int) (BgL_restz00_2745));
													}}}}}}}}
													PROCEDURE_ENTRY(BgL_method5114z00_2735)
														(BgL_method5114z00_2735,
														(obj_t) (BgL_arg5381z00_1950),
														(obj_t) (BgL_variablez00_2734), BEOA);
								}}}}}
								{
									obj_t BgL_l5107z00_3753;

									BgL_l5107z00_3753 = CDR(BgL_l5107z00_1944);
									BgL_l5107z00_1944 = BgL_l5107z00_3753;
									goto BgL_forzd2each5108zd2_1945;
								}
							}
						else
							{	/* Cfa/type.scm 303 */
								((bool_t) 1);
							}
					}
				}
				{	/* Cfa/type.scm 309 */
					BgL_nodez00_bglt BgL_arg5383z00_1952;

					BgL_arg5383z00_1952 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1939))->BgL_bodyz00);
					{	/* Cfa/type.scm 309 */
						obj_t BgL_method5126z00_2763;

						{	/* Cfa/type.scm 309 */
							BgL_objectz00_bglt BgL_objz00_2764;

							BgL_objz00_2764 = (BgL_objectz00_bglt) (BgL_arg5383z00_1952);
							{	/* Cfa/type.scm 309 */
								long BgL_objzd2classzd2numz00_2765;

								BgL_objzd2classzd2numz00_2765 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2764);
								{	/* Cfa/type.scm 309 */
									obj_t BgL_arg2334z00_2766;

									BgL_arg2334z00_2766 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 309 */
										obj_t BgL_arrayz00_2768;

										int BgL_offsetz00_2769;

										BgL_arrayz00_2768 = BgL_arg2334z00_2766;
										BgL_offsetz00_2769 = (int) (BgL_objzd2classzd2numz00_2765);
										{	/* Cfa/type.scm 309 */
											long BgL_offsetz00_2770;

											BgL_offsetz00_2770 =
												((long) (BgL_offsetz00_2769) - OBJECT_TYPE);
											{	/* Cfa/type.scm 309 */
												long BgL_modz00_2771;

												{	/* Cfa/type.scm 309 */
													int BgL_arg2336z00_2772;

													BgL_arg2336z00_2772 = (int) (((long) 8));
													{	/* Cfa/type.scm 309 */
														long BgL_auxz00_3764;

														BgL_auxz00_3764 = (long) (BgL_arg2336z00_2772);
														BgL_modz00_2771 =
															(BgL_offsetz00_2770 / BgL_auxz00_3764);
												}}
												{	/* Cfa/type.scm 309 */
													long BgL_restz00_2773;

													{	/* Cfa/type.scm 309 */
														int BgL_arg2335z00_2774;

														BgL_arg2335z00_2774 = (int) (((long) 8));
														{	/* Cfa/type.scm 309 */
															long BgL_auxz00_3768;

															BgL_auxz00_3768 = (long) (BgL_arg2335z00_2774);
															BgL_restz00_2773 =
																(BgL_offsetz00_2770 % BgL_auxz00_3768);
													}}
													{	/* Cfa/type.scm 309 */

														BgL_method5126z00_2763 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2768,
																(int) (BgL_modz00_2771)),
															(int) (BgL_restz00_2773));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5126z00_2763) (BgL_method5126z00_2763,
							(obj_t) (BgL_arg5383z00_1952), BEOA);
					}
				}
			}
		}
	}



/* type-node!-let-fun5161 */
	obj_t BGl_typezd2nodez12zd2letzd2fun5161zc0zzcfa_typez00(obj_t
		BgL_envz00_3092, obj_t BgL_nodez00_3093)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 293 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1926;

				BgL_nodez00_1926 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3093);
				{	/* Cfa/type.scm 295 */
					obj_t BgL_g5106z00_1930;

					BgL_g5106z00_1930 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1926))->BgL_localsz00);
					{
						obj_t BgL_l5104z00_1931;

						BgL_l5104z00_1931 = BgL_g5106z00_1930;
					BgL_forzd2each5105zd2_1932:
						if (PAIRP(BgL_l5104z00_1931))
							{	/* Cfa/type.scm 295 */
								{	/* Cfa/type.scm 295 */
									obj_t BgL_arg5376z00_1934;

									BgL_arg5376z00_1934 = CAR(BgL_l5104z00_1931);
									BGl_typezd2funz12zc0zzcfa_typez00(
										(BgL_variablez00_bglt) (BgL_arg5376z00_1934));
								}
								{
									obj_t BgL_l5104z00_3785;

									BgL_l5104z00_3785 = CDR(BgL_l5104z00_1931);
									BgL_l5104z00_1931 = BgL_l5104z00_3785;
									goto BgL_forzd2each5105zd2_1932;
								}
							}
						else
							{	/* Cfa/type.scm 295 */
								((bool_t) 1);
							}
					}
				}
				{	/* Cfa/type.scm 296 */
					BgL_nodez00_bglt BgL_arg5378z00_1936;

					BgL_arg5378z00_1936 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1926))->BgL_bodyz00);
					{	/* Cfa/type.scm 296 */
						obj_t BgL_method5126z00_2676;

						{	/* Cfa/type.scm 296 */
							BgL_objectz00_bglt BgL_objz00_2677;

							BgL_objz00_2677 = (BgL_objectz00_bglt) (BgL_arg5378z00_1936);
							{	/* Cfa/type.scm 296 */
								long BgL_objzd2classzd2numz00_2678;

								BgL_objzd2classzd2numz00_2678 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2677);
								{	/* Cfa/type.scm 296 */
									obj_t BgL_arg2334z00_2679;

									BgL_arg2334z00_2679 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 296 */
										obj_t BgL_arrayz00_2681;

										int BgL_offsetz00_2682;

										BgL_arrayz00_2681 = BgL_arg2334z00_2679;
										BgL_offsetz00_2682 = (int) (BgL_objzd2classzd2numz00_2678);
										{	/* Cfa/type.scm 296 */
											long BgL_offsetz00_2683;

											BgL_offsetz00_2683 =
												((long) (BgL_offsetz00_2682) - OBJECT_TYPE);
											{	/* Cfa/type.scm 296 */
												long BgL_modz00_2684;

												{	/* Cfa/type.scm 296 */
													int BgL_arg2336z00_2685;

													BgL_arg2336z00_2685 = (int) (((long) 8));
													{	/* Cfa/type.scm 296 */
														long BgL_auxz00_3796;

														BgL_auxz00_3796 = (long) (BgL_arg2336z00_2685);
														BgL_modz00_2684 =
															(BgL_offsetz00_2683 / BgL_auxz00_3796);
												}}
												{	/* Cfa/type.scm 296 */
													long BgL_restz00_2686;

													{	/* Cfa/type.scm 296 */
														int BgL_arg2335z00_2687;

														BgL_arg2335z00_2687 = (int) (((long) 8));
														{	/* Cfa/type.scm 296 */
															long BgL_auxz00_3800;

															BgL_auxz00_3800 = (long) (BgL_arg2335z00_2687);
															BgL_restz00_2686 =
																(BgL_offsetz00_2683 % BgL_auxz00_3800);
													}}
													{	/* Cfa/type.scm 296 */

														BgL_method5126z00_2676 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2681,
																(int) (BgL_modz00_2684)),
															(int) (BgL_restz00_2686));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5126z00_2676) (BgL_method5126z00_2676,
							(obj_t) (BgL_arg5378z00_1936), BEOA);
					}
				}
			}
		}
	}



/* type-node!-select5159 */
	obj_t BGl_typezd2nodez12zd2select5159z12zzcfa_typez00(obj_t BgL_envz00_3094,
		obj_t BgL_nodez00_3095)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 283 */
			{
				BgL_selectz00_bglt BgL_nodez00_1912;

				{	/* Cfa/type.scm 284 */
					bool_t BgL_auxz00_3811;

					BgL_nodez00_1912 = (BgL_selectz00_bglt) (BgL_nodez00_3095);
					{	/* Cfa/type.scm 285 */
						BgL_nodez00_bglt BgL_arg5370z00_1916;

						BgL_arg5370z00_1916 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1912))->BgL_testz00);
						{	/* Cfa/type.scm 285 */
							obj_t BgL_method5126z00_2614;

							{	/* Cfa/type.scm 285 */
								BgL_objectz00_bglt BgL_objz00_2615;

								BgL_objz00_2615 = (BgL_objectz00_bglt) (BgL_arg5370z00_1916);
								{	/* Cfa/type.scm 285 */
									long BgL_objzd2classzd2numz00_2616;

									BgL_objzd2classzd2numz00_2616 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2615);
									{	/* Cfa/type.scm 285 */
										obj_t BgL_arg2334z00_2617;

										BgL_arg2334z00_2617 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 285 */
											obj_t BgL_arrayz00_2619;

											int BgL_offsetz00_2620;

											BgL_arrayz00_2619 = BgL_arg2334z00_2617;
											BgL_offsetz00_2620 =
												(int) (BgL_objzd2classzd2numz00_2616);
											{	/* Cfa/type.scm 285 */
												long BgL_offsetz00_2621;

												BgL_offsetz00_2621 =
													((long) (BgL_offsetz00_2620) - OBJECT_TYPE);
												{	/* Cfa/type.scm 285 */
													long BgL_modz00_2622;

													{	/* Cfa/type.scm 285 */
														int BgL_arg2336z00_2623;

														BgL_arg2336z00_2623 = (int) (((long) 8));
														{	/* Cfa/type.scm 285 */
															long BgL_auxz00_3821;

															BgL_auxz00_3821 = (long) (BgL_arg2336z00_2623);
															BgL_modz00_2622 =
																(BgL_offsetz00_2621 / BgL_auxz00_3821);
													}}
													{	/* Cfa/type.scm 285 */
														long BgL_restz00_2624;

														{	/* Cfa/type.scm 285 */
															int BgL_arg2335z00_2625;

															BgL_arg2335z00_2625 = (int) (((long) 8));
															{	/* Cfa/type.scm 285 */
																long BgL_auxz00_3825;

																BgL_auxz00_3825 = (long) (BgL_arg2335z00_2625);
																BgL_restz00_2624 =
																	(BgL_offsetz00_2621 % BgL_auxz00_3825);
														}}
														{	/* Cfa/type.scm 285 */

															BgL_method5126z00_2614 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2619,
																	(int) (BgL_modz00_2622)),
																(int) (BgL_restz00_2624));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method5126z00_2614) (BgL_method5126z00_2614,
								(obj_t) (BgL_arg5370z00_1916), BEOA);
					}}
					{	/* Cfa/type.scm 286 */
						obj_t BgL_g5103z00_1917;

						BgL_g5103z00_1917 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1912))->BgL_clausesz00);
						{
							obj_t BgL_l5101z00_1918;

							BgL_l5101z00_1918 = BgL_g5103z00_1917;
						BgL_forzd2each5102zd2_1919:
							if (PAIRP(BgL_l5101z00_1918))
								{	/* Cfa/type.scm 286 */
									{	/* Cfa/type.scm 287 */
										obj_t BgL_clausez00_1921;

										BgL_clausez00_1921 = CAR(BgL_l5101z00_1918);
										{	/* Cfa/type.scm 287 */
											obj_t BgL_arg5372z00_1922;

											BgL_arg5372z00_1922 = CDR(BgL_clausez00_1921);
											{	/* Cfa/type.scm 287 */
												BgL_nodez00_bglt BgL_nodez00_2643;

												BgL_nodez00_2643 =
													(BgL_nodez00_bglt) (BgL_arg5372z00_1922);
												{	/* Cfa/type.scm 287 */
													obj_t BgL_method5126z00_2644;

													{	/* Cfa/type.scm 287 */
														BgL_objectz00_bglt BgL_objz00_2645;

														BgL_objz00_2645 =
															(BgL_objectz00_bglt) (BgL_nodez00_2643);
														{	/* Cfa/type.scm 287 */
															long BgL_objzd2classzd2numz00_2646;

															BgL_objzd2classzd2numz00_2646 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2645);
															{	/* Cfa/type.scm 287 */
																obj_t BgL_arg2334z00_2647;

																BgL_arg2334z00_2647 =
																	PROCEDURE_REF
																	(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
																	(int) (((long) 1)));
																{	/* Cfa/type.scm 287 */
																	obj_t BgL_arrayz00_2649;

																	int BgL_offsetz00_2650;

																	BgL_arrayz00_2649 = BgL_arg2334z00_2647;
																	BgL_offsetz00_2650 =
																		(int) (BgL_objzd2classzd2numz00_2646);
																	{	/* Cfa/type.scm 287 */
																		long BgL_offsetz00_2651;

																		BgL_offsetz00_2651 =
																			(
																			(long) (BgL_offsetz00_2650) -
																			OBJECT_TYPE);
																		{	/* Cfa/type.scm 287 */
																			long BgL_modz00_2652;

																			{	/* Cfa/type.scm 287 */
																				int BgL_arg2336z00_2653;

																				BgL_arg2336z00_2653 =
																					(int) (((long) 8));
																				{	/* Cfa/type.scm 287 */
																					long BgL_auxz00_3849;

																					BgL_auxz00_3849 =
																						(long) (BgL_arg2336z00_2653);
																					BgL_modz00_2652 =
																						(BgL_offsetz00_2651 /
																						BgL_auxz00_3849);
																			}}
																			{	/* Cfa/type.scm 287 */
																				long BgL_restz00_2654;

																				{	/* Cfa/type.scm 287 */
																					int BgL_arg2335z00_2655;

																					BgL_arg2335z00_2655 =
																						(int) (((long) 8));
																					{	/* Cfa/type.scm 287 */
																						long BgL_auxz00_3853;

																						BgL_auxz00_3853 =
																							(long) (BgL_arg2335z00_2655);
																						BgL_restz00_2654 =
																							(BgL_offsetz00_2651 %
																							BgL_auxz00_3853);
																				}}
																				{	/* Cfa/type.scm 287 */

																					BgL_method5126z00_2644 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2649,
																							(int) (BgL_modz00_2652)),
																						(int) (BgL_restz00_2654));
													}}}}}}}}
													PROCEDURE_ENTRY(BgL_method5126z00_2644)
														(BgL_method5126z00_2644, (obj_t) (BgL_nodez00_2643),
														BEOA);
									}}}}
									{
										obj_t BgL_l5101z00_3863;

										BgL_l5101z00_3863 = CDR(BgL_l5101z00_1918);
										BgL_l5101z00_1918 = BgL_l5101z00_3863;
										goto BgL_forzd2each5102zd2_1919;
									}
								}
							else
								{	/* Cfa/type.scm 286 */
									BgL_auxz00_3811 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_3811);
				}
			}
		}
	}



/* type-node!-fail5157 */
	obj_t BGl_typezd2nodez12zd2fail5157z12zzcfa_typez00(obj_t BgL_envz00_3096,
		obj_t BgL_nodez00_3097)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 274 */
			{
				BgL_failz00_bglt BgL_nodez00_1903;

				BgL_nodez00_1903 = (BgL_failz00_bglt) (BgL_nodez00_3097);
				{	/* Cfa/type.scm 276 */
					BgL_nodez00_bglt BgL_arg5366z00_1907;

					BgL_arg5366z00_1907 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1903))->BgL_procz00);
					{	/* Cfa/type.scm 276 */
						obj_t BgL_method5126z00_2533;

						{	/* Cfa/type.scm 276 */
							BgL_objectz00_bglt BgL_objz00_2534;

							BgL_objz00_2534 = (BgL_objectz00_bglt) (BgL_arg5366z00_1907);
							{	/* Cfa/type.scm 276 */
								long BgL_objzd2classzd2numz00_2535;

								BgL_objzd2classzd2numz00_2535 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2534);
								{	/* Cfa/type.scm 276 */
									obj_t BgL_arg2334z00_2536;

									BgL_arg2334z00_2536 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 276 */
										obj_t BgL_arrayz00_2538;

										int BgL_offsetz00_2539;

										BgL_arrayz00_2538 = BgL_arg2334z00_2536;
										BgL_offsetz00_2539 = (int) (BgL_objzd2classzd2numz00_2535);
										{	/* Cfa/type.scm 276 */
											long BgL_offsetz00_2540;

											BgL_offsetz00_2540 =
												((long) (BgL_offsetz00_2539) - OBJECT_TYPE);
											{	/* Cfa/type.scm 276 */
												long BgL_modz00_2541;

												{	/* Cfa/type.scm 276 */
													int BgL_arg2336z00_2542;

													BgL_arg2336z00_2542 = (int) (((long) 8));
													{	/* Cfa/type.scm 276 */
														long BgL_auxz00_3876;

														BgL_auxz00_3876 = (long) (BgL_arg2336z00_2542);
														BgL_modz00_2541 =
															(BgL_offsetz00_2540 / BgL_auxz00_3876);
												}}
												{	/* Cfa/type.scm 276 */
													long BgL_restz00_2543;

													{	/* Cfa/type.scm 276 */
														int BgL_arg2335z00_2544;

														BgL_arg2335z00_2544 = (int) (((long) 8));
														{	/* Cfa/type.scm 276 */
															long BgL_auxz00_3880;

															BgL_auxz00_3880 = (long) (BgL_arg2335z00_2544);
															BgL_restz00_2543 =
																(BgL_offsetz00_2540 % BgL_auxz00_3880);
													}}
													{	/* Cfa/type.scm 276 */

														BgL_method5126z00_2533 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2538,
																(int) (BgL_modz00_2541)),
															(int) (BgL_restz00_2543));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5126z00_2533) (BgL_method5126z00_2533,
							(obj_t) (BgL_arg5366z00_1907), BEOA);
				}}
				{	/* Cfa/type.scm 277 */
					BgL_nodez00_bglt BgL_arg5367z00_1908;

					BgL_arg5367z00_1908 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1903))->BgL_msgz00);
					{	/* Cfa/type.scm 277 */
						obj_t BgL_method5126z00_2560;

						{	/* Cfa/type.scm 277 */
							BgL_objectz00_bglt BgL_objz00_2561;

							BgL_objz00_2561 = (BgL_objectz00_bglt) (BgL_arg5367z00_1908);
							{	/* Cfa/type.scm 277 */
								long BgL_objzd2classzd2numz00_2562;

								BgL_objzd2classzd2numz00_2562 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2561);
								{	/* Cfa/type.scm 277 */
									obj_t BgL_arg2334z00_2563;

									BgL_arg2334z00_2563 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 277 */
										obj_t BgL_arrayz00_2565;

										int BgL_offsetz00_2566;

										BgL_arrayz00_2565 = BgL_arg2334z00_2563;
										BgL_offsetz00_2566 = (int) (BgL_objzd2classzd2numz00_2562);
										{	/* Cfa/type.scm 277 */
											long BgL_offsetz00_2567;

											BgL_offsetz00_2567 =
												((long) (BgL_offsetz00_2566) - OBJECT_TYPE);
											{	/* Cfa/type.scm 277 */
												long BgL_modz00_2568;

												{	/* Cfa/type.scm 277 */
													int BgL_arg2336z00_2569;

													BgL_arg2336z00_2569 = (int) (((long) 8));
													{	/* Cfa/type.scm 277 */
														long BgL_auxz00_3899;

														BgL_auxz00_3899 = (long) (BgL_arg2336z00_2569);
														BgL_modz00_2568 =
															(BgL_offsetz00_2567 / BgL_auxz00_3899);
												}}
												{	/* Cfa/type.scm 277 */
													long BgL_restz00_2570;

													{	/* Cfa/type.scm 277 */
														int BgL_arg2335z00_2571;

														BgL_arg2335z00_2571 = (int) (((long) 8));
														{	/* Cfa/type.scm 277 */
															long BgL_auxz00_3903;

															BgL_auxz00_3903 = (long) (BgL_arg2335z00_2571);
															BgL_restz00_2570 =
																(BgL_offsetz00_2567 % BgL_auxz00_3903);
													}}
													{	/* Cfa/type.scm 277 */

														BgL_method5126z00_2560 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2565,
																(int) (BgL_modz00_2568)),
															(int) (BgL_restz00_2570));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5126z00_2560) (BgL_method5126z00_2560,
							(obj_t) (BgL_arg5367z00_1908), BEOA);
				}}
				{	/* Cfa/type.scm 278 */
					BgL_nodez00_bglt BgL_arg5368z00_1909;

					BgL_arg5368z00_1909 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1903))->BgL_objz00);
					{	/* Cfa/type.scm 278 */
						obj_t BgL_method5126z00_2587;

						{	/* Cfa/type.scm 278 */
							BgL_objectz00_bglt BgL_objz00_2588;

							BgL_objz00_2588 = (BgL_objectz00_bglt) (BgL_arg5368z00_1909);
							{	/* Cfa/type.scm 278 */
								long BgL_objzd2classzd2numz00_2589;

								BgL_objzd2classzd2numz00_2589 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2588);
								{	/* Cfa/type.scm 278 */
									obj_t BgL_arg2334z00_2590;

									BgL_arg2334z00_2590 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 278 */
										obj_t BgL_arrayz00_2592;

										int BgL_offsetz00_2593;

										BgL_arrayz00_2592 = BgL_arg2334z00_2590;
										BgL_offsetz00_2593 = (int) (BgL_objzd2classzd2numz00_2589);
										{	/* Cfa/type.scm 278 */
											long BgL_offsetz00_2594;

											BgL_offsetz00_2594 =
												((long) (BgL_offsetz00_2593) - OBJECT_TYPE);
											{	/* Cfa/type.scm 278 */
												long BgL_modz00_2595;

												{	/* Cfa/type.scm 278 */
													int BgL_arg2336z00_2596;

													BgL_arg2336z00_2596 = (int) (((long) 8));
													{	/* Cfa/type.scm 278 */
														long BgL_auxz00_3922;

														BgL_auxz00_3922 = (long) (BgL_arg2336z00_2596);
														BgL_modz00_2595 =
															(BgL_offsetz00_2594 / BgL_auxz00_3922);
												}}
												{	/* Cfa/type.scm 278 */
													long BgL_restz00_2597;

													{	/* Cfa/type.scm 278 */
														int BgL_arg2335z00_2598;

														BgL_arg2335z00_2598 = (int) (((long) 8));
														{	/* Cfa/type.scm 278 */
															long BgL_auxz00_3926;

															BgL_auxz00_3926 = (long) (BgL_arg2335z00_2598);
															BgL_restz00_2597 =
																(BgL_offsetz00_2594 % BgL_auxz00_3926);
													}}
													{	/* Cfa/type.scm 278 */

														BgL_method5126z00_2587 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2592,
																(int) (BgL_modz00_2595)),
															(int) (BgL_restz00_2597));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5126z00_2587) (BgL_method5126z00_2587,
							(obj_t) (BgL_arg5368z00_1909), BEOA);
					}
				}
			}
		}
	}



/* type-node!-condition5155 */
	obj_t BGl_typezd2nodez12zd2condition5155z12zzcfa_typez00(obj_t
		BgL_envz00_3098, obj_t BgL_nodez00_3099)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 265 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1894;

				BgL_nodez00_1894 = (BgL_conditionalz00_bglt) (BgL_nodez00_3099);
				{	/* Cfa/type.scm 267 */
					BgL_nodez00_bglt BgL_arg5362z00_1898;

					BgL_arg5362z00_1898 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1894))->BgL_testz00);
					{	/* Cfa/type.scm 267 */
						obj_t BgL_method5126z00_2452;

						{	/* Cfa/type.scm 267 */
							BgL_objectz00_bglt BgL_objz00_2453;

							BgL_objz00_2453 = (BgL_objectz00_bglt) (BgL_arg5362z00_1898);
							{	/* Cfa/type.scm 267 */
								long BgL_objzd2classzd2numz00_2454;

								BgL_objzd2classzd2numz00_2454 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2453);
								{	/* Cfa/type.scm 267 */
									obj_t BgL_arg2334z00_2455;

									BgL_arg2334z00_2455 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 267 */
										obj_t BgL_arrayz00_2457;

										int BgL_offsetz00_2458;

										BgL_arrayz00_2457 = BgL_arg2334z00_2455;
										BgL_offsetz00_2458 = (int) (BgL_objzd2classzd2numz00_2454);
										{	/* Cfa/type.scm 267 */
											long BgL_offsetz00_2459;

											BgL_offsetz00_2459 =
												((long) (BgL_offsetz00_2458) - OBJECT_TYPE);
											{	/* Cfa/type.scm 267 */
												long BgL_modz00_2460;

												{	/* Cfa/type.scm 267 */
													int BgL_arg2336z00_2461;

													BgL_arg2336z00_2461 = (int) (((long) 8));
													{	/* Cfa/type.scm 267 */
														long BgL_auxz00_3946;

														BgL_auxz00_3946 = (long) (BgL_arg2336z00_2461);
														BgL_modz00_2460 =
															(BgL_offsetz00_2459 / BgL_auxz00_3946);
												}}
												{	/* Cfa/type.scm 267 */
													long BgL_restz00_2462;

													{	/* Cfa/type.scm 267 */
														int BgL_arg2335z00_2463;

														BgL_arg2335z00_2463 = (int) (((long) 8));
														{	/* Cfa/type.scm 267 */
															long BgL_auxz00_3950;

															BgL_auxz00_3950 = (long) (BgL_arg2335z00_2463);
															BgL_restz00_2462 =
																(BgL_offsetz00_2459 % BgL_auxz00_3950);
													}}
													{	/* Cfa/type.scm 267 */

														BgL_method5126z00_2452 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2457,
																(int) (BgL_modz00_2460)),
															(int) (BgL_restz00_2462));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5126z00_2452) (BgL_method5126z00_2452,
							(obj_t) (BgL_arg5362z00_1898), BEOA);
				}}
				{	/* Cfa/type.scm 268 */
					BgL_nodez00_bglt BgL_arg5363z00_1899;

					BgL_arg5363z00_1899 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1894))->BgL_truez00);
					{	/* Cfa/type.scm 268 */
						obj_t BgL_method5126z00_2479;

						{	/* Cfa/type.scm 268 */
							BgL_objectz00_bglt BgL_objz00_2480;

							BgL_objz00_2480 = (BgL_objectz00_bglt) (BgL_arg5363z00_1899);
							{	/* Cfa/type.scm 268 */
								long BgL_objzd2classzd2numz00_2481;

								BgL_objzd2classzd2numz00_2481 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2480);
								{	/* Cfa/type.scm 268 */
									obj_t BgL_arg2334z00_2482;

									BgL_arg2334z00_2482 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 268 */
										obj_t BgL_arrayz00_2484;

										int BgL_offsetz00_2485;

										BgL_arrayz00_2484 = BgL_arg2334z00_2482;
										BgL_offsetz00_2485 = (int) (BgL_objzd2classzd2numz00_2481);
										{	/* Cfa/type.scm 268 */
											long BgL_offsetz00_2486;

											BgL_offsetz00_2486 =
												((long) (BgL_offsetz00_2485) - OBJECT_TYPE);
											{	/* Cfa/type.scm 268 */
												long BgL_modz00_2487;

												{	/* Cfa/type.scm 268 */
													int BgL_arg2336z00_2488;

													BgL_arg2336z00_2488 = (int) (((long) 8));
													{	/* Cfa/type.scm 268 */
														long BgL_auxz00_3969;

														BgL_auxz00_3969 = (long) (BgL_arg2336z00_2488);
														BgL_modz00_2487 =
															(BgL_offsetz00_2486 / BgL_auxz00_3969);
												}}
												{	/* Cfa/type.scm 268 */
													long BgL_restz00_2489;

													{	/* Cfa/type.scm 268 */
														int BgL_arg2335z00_2490;

														BgL_arg2335z00_2490 = (int) (((long) 8));
														{	/* Cfa/type.scm 268 */
															long BgL_auxz00_3973;

															BgL_auxz00_3973 = (long) (BgL_arg2335z00_2490);
															BgL_restz00_2489 =
																(BgL_offsetz00_2486 % BgL_auxz00_3973);
													}}
													{	/* Cfa/type.scm 268 */

														BgL_method5126z00_2479 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2484,
																(int) (BgL_modz00_2487)),
															(int) (BgL_restz00_2489));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5126z00_2479) (BgL_method5126z00_2479,
							(obj_t) (BgL_arg5363z00_1899), BEOA);
				}}
				{	/* Cfa/type.scm 269 */
					BgL_nodez00_bglt BgL_arg5364z00_1900;

					BgL_arg5364z00_1900 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1894))->BgL_falsez00);
					{	/* Cfa/type.scm 269 */
						obj_t BgL_method5126z00_2506;

						{	/* Cfa/type.scm 269 */
							BgL_objectz00_bglt BgL_objz00_2507;

							BgL_objz00_2507 = (BgL_objectz00_bglt) (BgL_arg5364z00_1900);
							{	/* Cfa/type.scm 269 */
								long BgL_objzd2classzd2numz00_2508;

								BgL_objzd2classzd2numz00_2508 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2507);
								{	/* Cfa/type.scm 269 */
									obj_t BgL_arg2334z00_2509;

									BgL_arg2334z00_2509 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 269 */
										obj_t BgL_arrayz00_2511;

										int BgL_offsetz00_2512;

										BgL_arrayz00_2511 = BgL_arg2334z00_2509;
										BgL_offsetz00_2512 = (int) (BgL_objzd2classzd2numz00_2508);
										{	/* Cfa/type.scm 269 */
											long BgL_offsetz00_2513;

											BgL_offsetz00_2513 =
												((long) (BgL_offsetz00_2512) - OBJECT_TYPE);
											{	/* Cfa/type.scm 269 */
												long BgL_modz00_2514;

												{	/* Cfa/type.scm 269 */
													int BgL_arg2336z00_2515;

													BgL_arg2336z00_2515 = (int) (((long) 8));
													{	/* Cfa/type.scm 269 */
														long BgL_auxz00_3992;

														BgL_auxz00_3992 = (long) (BgL_arg2336z00_2515);
														BgL_modz00_2514 =
															(BgL_offsetz00_2513 / BgL_auxz00_3992);
												}}
												{	/* Cfa/type.scm 269 */
													long BgL_restz00_2516;

													{	/* Cfa/type.scm 269 */
														int BgL_arg2335z00_2517;

														BgL_arg2335z00_2517 = (int) (((long) 8));
														{	/* Cfa/type.scm 269 */
															long BgL_auxz00_3996;

															BgL_auxz00_3996 = (long) (BgL_arg2335z00_2517);
															BgL_restz00_2516 =
																(BgL_offsetz00_2513 % BgL_auxz00_3996);
													}}
													{	/* Cfa/type.scm 269 */

														BgL_method5126z00_2506 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2511,
																(int) (BgL_modz00_2514)),
															(int) (BgL_restz00_2516));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5126z00_2506) (BgL_method5126z00_2506,
							(obj_t) (BgL_arg5364z00_1900), BEOA);
					}
				}
			}
		}
	}



/* type-node!-setq5153 */
	obj_t BGl_typezd2nodez12zd2setq5153z12zzcfa_typez00(obj_t BgL_envz00_3100,
		obj_t BgL_nodez00_3101)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 257 */
			{
				BgL_setqz00_bglt BgL_nodez00_1886;

				BgL_nodez00_1886 = (BgL_setqz00_bglt) (BgL_nodez00_3101);
				{	/* Cfa/type.scm 259 */
					BgL_nodez00_bglt BgL_arg5359z00_1890;

					BgL_arg5359z00_1890 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1886))->BgL_valuez00);
					{	/* Cfa/type.scm 259 */
						obj_t BgL_method5126z00_2398;

						{	/* Cfa/type.scm 259 */
							BgL_objectz00_bglt BgL_objz00_2399;

							BgL_objz00_2399 = (BgL_objectz00_bglt) (BgL_arg5359z00_1890);
							{	/* Cfa/type.scm 259 */
								long BgL_objzd2classzd2numz00_2400;

								BgL_objzd2classzd2numz00_2400 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2399);
								{	/* Cfa/type.scm 259 */
									obj_t BgL_arg2334z00_2401;

									BgL_arg2334z00_2401 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 259 */
										obj_t BgL_arrayz00_2403;

										int BgL_offsetz00_2404;

										BgL_arrayz00_2403 = BgL_arg2334z00_2401;
										BgL_offsetz00_2404 = (int) (BgL_objzd2classzd2numz00_2400);
										{	/* Cfa/type.scm 259 */
											long BgL_offsetz00_2405;

											BgL_offsetz00_2405 =
												((long) (BgL_offsetz00_2404) - OBJECT_TYPE);
											{	/* Cfa/type.scm 259 */
												long BgL_modz00_2406;

												{	/* Cfa/type.scm 259 */
													int BgL_arg2336z00_2407;

													BgL_arg2336z00_2407 = (int) (((long) 8));
													{	/* Cfa/type.scm 259 */
														long BgL_auxz00_4016;

														BgL_auxz00_4016 = (long) (BgL_arg2336z00_2407);
														BgL_modz00_2406 =
															(BgL_offsetz00_2405 / BgL_auxz00_4016);
												}}
												{	/* Cfa/type.scm 259 */
													long BgL_restz00_2408;

													{	/* Cfa/type.scm 259 */
														int BgL_arg2335z00_2409;

														BgL_arg2335z00_2409 = (int) (((long) 8));
														{	/* Cfa/type.scm 259 */
															long BgL_auxz00_4020;

															BgL_auxz00_4020 = (long) (BgL_arg2335z00_2409);
															BgL_restz00_2408 =
																(BgL_offsetz00_2405 % BgL_auxz00_4020);
													}}
													{	/* Cfa/type.scm 259 */

														BgL_method5126z00_2398 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2403,
																(int) (BgL_modz00_2406)),
															(int) (BgL_restz00_2408));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5126z00_2398) (BgL_method5126z00_2398,
							(obj_t) (BgL_arg5359z00_1890), BEOA);
				}}
				{	/* Cfa/type.scm 260 */
					BgL_varz00_bglt BgL_arg5360z00_1891;

					BgL_arg5360z00_1891 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1886))->BgL_varz00);
					{	/* Cfa/type.scm 260 */
						BgL_nodez00_bglt BgL_nodez00_2424;

						BgL_nodez00_2424 = (BgL_nodez00_bglt) (BgL_arg5360z00_1891);
						{	/* Cfa/type.scm 260 */
							obj_t BgL_method5126z00_2425;

							{	/* Cfa/type.scm 260 */
								BgL_objectz00_bglt BgL_objz00_2426;

								BgL_objz00_2426 = (BgL_objectz00_bglt) (BgL_nodez00_2424);
								{	/* Cfa/type.scm 260 */
									long BgL_objzd2classzd2numz00_2427;

									BgL_objzd2classzd2numz00_2427 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2426);
									{	/* Cfa/type.scm 260 */
										obj_t BgL_arg2334z00_2428;

										BgL_arg2334z00_2428 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 260 */
											obj_t BgL_arrayz00_2430;

											int BgL_offsetz00_2431;

											BgL_arrayz00_2430 = BgL_arg2334z00_2428;
											BgL_offsetz00_2431 =
												(int) (BgL_objzd2classzd2numz00_2427);
											{	/* Cfa/type.scm 260 */
												long BgL_offsetz00_2432;

												BgL_offsetz00_2432 =
													((long) (BgL_offsetz00_2431) - OBJECT_TYPE);
												{	/* Cfa/type.scm 260 */
													long BgL_modz00_2433;

													{	/* Cfa/type.scm 260 */
														int BgL_arg2336z00_2434;

														BgL_arg2336z00_2434 = (int) (((long) 8));
														{	/* Cfa/type.scm 260 */
															long BgL_auxz00_4040;

															BgL_auxz00_4040 = (long) (BgL_arg2336z00_2434);
															BgL_modz00_2433 =
																(BgL_offsetz00_2432 / BgL_auxz00_4040);
													}}
													{	/* Cfa/type.scm 260 */
														long BgL_restz00_2435;

														{	/* Cfa/type.scm 260 */
															int BgL_arg2335z00_2436;

															BgL_arg2335z00_2436 = (int) (((long) 8));
															{	/* Cfa/type.scm 260 */
																long BgL_auxz00_4044;

																BgL_auxz00_4044 = (long) (BgL_arg2335z00_2436);
																BgL_restz00_2435 =
																	(BgL_offsetz00_2432 % BgL_auxz00_4044);
														}}
														{	/* Cfa/type.scm 260 */

															BgL_method5126z00_2425 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2430,
																	(int) (BgL_modz00_2433)),
																(int) (BgL_restz00_2435));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method5126z00_2425) (BgL_method5126z00_2425,
								(obj_t) (BgL_nodez00_2424), BEOA);
						}
					}
				}
			}
		}
	}



/* type-node!-cast5151 */
	obj_t BGl_typezd2nodez12zd2cast5151z12zzcfa_typez00(obj_t BgL_envz00_3102,
		obj_t BgL_nodez00_3103)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 250 */
			{
				BgL_castz00_bglt BgL_nodez00_1879;

				BgL_nodez00_1879 = (BgL_castz00_bglt) (BgL_nodez00_3103);
				{	/* Cfa/type.scm 251 */
					BgL_nodez00_bglt BgL_arg5357z00_2368;

					BgL_arg5357z00_2368 =
						(((BgL_castz00_bglt) CREF(BgL_nodez00_1879))->BgL_argz00);
					{	/* Cfa/type.scm 251 */
						obj_t BgL_method5126z00_2371;

						{	/* Cfa/type.scm 251 */
							BgL_objectz00_bglt BgL_objz00_2372;

							BgL_objz00_2372 = (BgL_objectz00_bglt) (BgL_arg5357z00_2368);
							{	/* Cfa/type.scm 251 */
								long BgL_objzd2classzd2numz00_2373;

								BgL_objzd2classzd2numz00_2373 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2372);
								{	/* Cfa/type.scm 251 */
									obj_t BgL_arg2334z00_2374;

									BgL_arg2334z00_2374 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 251 */
										obj_t BgL_arrayz00_2376;

										int BgL_offsetz00_2377;

										BgL_arrayz00_2376 = BgL_arg2334z00_2374;
										BgL_offsetz00_2377 = (int) (BgL_objzd2classzd2numz00_2373);
										{	/* Cfa/type.scm 251 */
											long BgL_offsetz00_2378;

											BgL_offsetz00_2378 =
												((long) (BgL_offsetz00_2377) - OBJECT_TYPE);
											{	/* Cfa/type.scm 251 */
												long BgL_modz00_2379;

												{	/* Cfa/type.scm 251 */
													int BgL_arg2336z00_2380;

													BgL_arg2336z00_2380 = (int) (((long) 8));
													{	/* Cfa/type.scm 251 */
														long BgL_auxz00_4064;

														BgL_auxz00_4064 = (long) (BgL_arg2336z00_2380);
														BgL_modz00_2379 =
															(BgL_offsetz00_2378 / BgL_auxz00_4064);
												}}
												{	/* Cfa/type.scm 251 */
													long BgL_restz00_2381;

													{	/* Cfa/type.scm 251 */
														int BgL_arg2335z00_2382;

														BgL_arg2335z00_2382 = (int) (((long) 8));
														{	/* Cfa/type.scm 251 */
															long BgL_auxz00_4068;

															BgL_auxz00_4068 = (long) (BgL_arg2335z00_2382);
															BgL_restz00_2381 =
																(BgL_offsetz00_2378 % BgL_auxz00_4068);
													}}
													{	/* Cfa/type.scm 251 */

														BgL_method5126z00_2371 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2376,
																(int) (BgL_modz00_2379)),
															(int) (BgL_restz00_2381));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5126z00_2371) (BgL_method5126z00_2371,
							(obj_t) (BgL_arg5357z00_2368), BEOA);
					}
				}
			}
		}
	}



/* type-node!-vset!5149 */
	obj_t BGl_typezd2nodez12zd2vsetz125149z00zzcfa_typez00(obj_t BgL_envz00_3104,
		obj_t BgL_nodez00_3105)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 241 */
			{
				BgL_vsetz12z12_bglt BgL_nodez00_1871;

				BgL_nodez00_1871 = (BgL_vsetz12z12_bglt) (BgL_nodez00_3105);
				{

					{	/* Cfa/type.scm 241 */
						obj_t BgL_nextzd2method5148zd2_1877;

						BgL_nextzd2method5148zd2_1877 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_nodez00_1871),
							BGl_typezd2nodez12zd2envz12zzcfa_typez00,
							BGl_vsetz12z12zzast_nodez00);
						if (PROCEDUREP(BgL_nextzd2method5148zd2_1877))
							{	/* Cfa/type.scm 241 */
								PROCEDURE_ENTRY(BgL_nextzd2method5148zd2_1877)
									(BgL_nextzd2method5148zd2_1877, (obj_t) (BgL_nodez00_1871),
									BEOA);
							}
						else
							{	/* Cfa/type.scm 241 */
								{	/* Cfa/type.scm 241 */
									BgL_nodez00_bglt BgL_nodez00_2341;

									BgL_nodez00_2341 = (BgL_nodez00_bglt) (BgL_nodez00_1871);
									{	/* Cfa/type.scm 241 */
										obj_t BgL_method5126z00_2342;

										{	/* Cfa/type.scm 241 */
											BgL_objectz00_bglt BgL_objz00_2343;

											BgL_objz00_2343 = (BgL_objectz00_bglt) (BgL_nodez00_2341);
											{	/* Cfa/type.scm 241 */
												long BgL_objzd2classzd2numz00_2344;

												BgL_objzd2classzd2numz00_2344 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2343);
												{	/* Cfa/type.scm 241 */
													obj_t BgL_arg2334z00_2345;

													BgL_arg2334z00_2345 =
														PROCEDURE_REF
														(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
														(int) (((long) 1)));
													{	/* Cfa/type.scm 241 */
														obj_t BgL_arrayz00_2347;

														int BgL_offsetz00_2348;

														BgL_arrayz00_2347 = BgL_arg2334z00_2345;
														BgL_offsetz00_2348 =
															(int) (BgL_objzd2classzd2numz00_2344);
														{	/* Cfa/type.scm 241 */
															long BgL_offsetz00_2349;

															BgL_offsetz00_2349 =
																((long) (BgL_offsetz00_2348) - OBJECT_TYPE);
															{	/* Cfa/type.scm 241 */
																long BgL_modz00_2350;

																{	/* Cfa/type.scm 241 */
																	int BgL_arg2336z00_2351;

																	BgL_arg2336z00_2351 = (int) (((long) 8));
																	{	/* Cfa/type.scm 241 */
																		long BgL_auxz00_4095;

																		BgL_auxz00_4095 =
																			(long) (BgL_arg2336z00_2351);
																		BgL_modz00_2350 =
																			(BgL_offsetz00_2349 / BgL_auxz00_4095);
																}}
																{	/* Cfa/type.scm 241 */
																	long BgL_restz00_2352;

																	{	/* Cfa/type.scm 241 */
																		int BgL_arg2335z00_2353;

																		BgL_arg2335z00_2353 = (int) (((long) 8));
																		{	/* Cfa/type.scm 241 */
																			long BgL_auxz00_4099;

																			BgL_auxz00_4099 =
																				(long) (BgL_arg2335z00_2353);
																			BgL_restz00_2352 =
																				(BgL_offsetz00_2349 % BgL_auxz00_4099);
																	}}
																	{	/* Cfa/type.scm 241 */

																		BgL_method5126z00_2342 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2347,
																				(int) (BgL_modz00_2350)),
																			(int) (BgL_restz00_2352));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method5126z00_2342)
											(BgL_method5126z00_2342, (obj_t) (BgL_nodez00_2341),
											BEOA);
					}}}}
					{	/* Cfa/type.scm 244 */
						bool_t BgL_testz00_4109;

						{	/* Cfa/type.scm 244 */
							BgL_typez00_bglt BgL_arg5355z00_1876;

							BgL_arg5355z00_1876 =
								(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1871))->BgL_ftypez00);
							BgL_testz00_4109 =
								(
								(obj_t) (BgL_arg5355z00_1876) == BGl_za2_za2z00zztype_cachez00);
						}
						if (BgL_testz00_4109)
							{
								BgL_typez00_bglt BgL_auxz00_4113;

								BgL_auxz00_4113 =
									(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
								return
									((((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1871))->
										BgL_ftypez00) =
									((BgL_typez00_bglt) BgL_auxz00_4113), BUNSPEC);
							}
						else
							{	/* Cfa/type.scm 244 */
								return BFALSE;
							}
					}
				}
			}
		}
	}



/* type-node!-vref5147 */
	obj_t BGl_typezd2nodez12zd2vref5147z12zzcfa_typez00(obj_t BgL_envz00_3106,
		obj_t BgL_nodez00_3107)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 232 */
			{
				BgL_vrefz00_bglt BgL_nodez00_1863;

				BgL_nodez00_1863 = (BgL_vrefz00_bglt) (BgL_nodez00_3107);
				{

					{	/* Cfa/type.scm 232 */
						obj_t BgL_nextzd2method5146zd2_1869;

						BgL_nextzd2method5146zd2_1869 =
							BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
							(BgL_objectz00_bglt) (BgL_nodez00_1863),
							BGl_typezd2nodez12zd2envz12zzcfa_typez00,
							BGl_vrefz00zzast_nodez00);
						if (PROCEDUREP(BgL_nextzd2method5146zd2_1869))
							{	/* Cfa/type.scm 232 */
								PROCEDURE_ENTRY(BgL_nextzd2method5146zd2_1869)
									(BgL_nextzd2method5146zd2_1869, (obj_t) (BgL_nodez00_1863),
									BEOA);
							}
						else
							{	/* Cfa/type.scm 232 */
								{	/* Cfa/type.scm 232 */
									BgL_nodez00_bglt BgL_nodez00_2311;

									BgL_nodez00_2311 = (BgL_nodez00_bglt) (BgL_nodez00_1863);
									{	/* Cfa/type.scm 232 */
										obj_t BgL_method5126z00_2312;

										{	/* Cfa/type.scm 232 */
											BgL_objectz00_bglt BgL_objz00_2313;

											BgL_objz00_2313 = (BgL_objectz00_bglt) (BgL_nodez00_2311);
											{	/* Cfa/type.scm 232 */
												long BgL_objzd2classzd2numz00_2314;

												BgL_objzd2classzd2numz00_2314 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2313);
												{	/* Cfa/type.scm 232 */
													obj_t BgL_arg2334z00_2315;

													BgL_arg2334z00_2315 =
														PROCEDURE_REF
														(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
														(int) (((long) 1)));
													{	/* Cfa/type.scm 232 */
														obj_t BgL_arrayz00_2317;

														int BgL_offsetz00_2318;

														BgL_arrayz00_2317 = BgL_arg2334z00_2315;
														BgL_offsetz00_2318 =
															(int) (BgL_objzd2classzd2numz00_2314);
														{	/* Cfa/type.scm 232 */
															long BgL_offsetz00_2319;

															BgL_offsetz00_2319 =
																((long) (BgL_offsetz00_2318) - OBJECT_TYPE);
															{	/* Cfa/type.scm 232 */
																long BgL_modz00_2320;

																{	/* Cfa/type.scm 232 */
																	int BgL_arg2336z00_2321;

																	BgL_arg2336z00_2321 = (int) (((long) 8));
																	{	/* Cfa/type.scm 232 */
																		long BgL_auxz00_4133;

																		BgL_auxz00_4133 =
																			(long) (BgL_arg2336z00_2321);
																		BgL_modz00_2320 =
																			(BgL_offsetz00_2319 / BgL_auxz00_4133);
																}}
																{	/* Cfa/type.scm 232 */
																	long BgL_restz00_2322;

																	{	/* Cfa/type.scm 232 */
																		int BgL_arg2335z00_2323;

																		BgL_arg2335z00_2323 = (int) (((long) 8));
																		{	/* Cfa/type.scm 232 */
																			long BgL_auxz00_4137;

																			BgL_auxz00_4137 =
																				(long) (BgL_arg2335z00_2323);
																			BgL_restz00_2322 =
																				(BgL_offsetz00_2319 % BgL_auxz00_4137);
																	}}
																	{	/* Cfa/type.scm 232 */

																		BgL_method5126z00_2312 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2317,
																				(int) (BgL_modz00_2320)),
																			(int) (BgL_restz00_2322));
										}}}}}}}}
										PROCEDURE_ENTRY(BgL_method5126z00_2312)
											(BgL_method5126z00_2312, (obj_t) (BgL_nodez00_2311),
											BEOA);
					}}}}
					{	/* Cfa/type.scm 235 */
						bool_t BgL_testz00_4147;

						{	/* Cfa/type.scm 235 */
							BgL_typez00_bglt BgL_arg5352z00_1868;

							BgL_arg5352z00_1868 =
								(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1863))->BgL_ftypez00);
							BgL_testz00_4147 =
								(
								(obj_t) (BgL_arg5352z00_1868) == BGl_za2_za2z00zztype_cachez00);
						}
						if (BgL_testz00_4147)
							{
								BgL_typez00_bglt BgL_auxz00_4151;

								BgL_auxz00_4151 =
									(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
								return
									((((BgL_vrefz00_bglt) CREF(BgL_nodez00_1863))->BgL_ftypez00) =
									((BgL_typez00_bglt) BgL_auxz00_4151), BUNSPEC);
							}
						else
							{	/* Cfa/type.scm 235 */
								return BFALSE;
							}
					}
				}
			}
		}
	}



/* type-node!-extern5145 */
	obj_t BGl_typezd2nodez12zd2extern5145z12zzcfa_typez00(obj_t BgL_envz00_3108,
		obj_t BgL_nodez00_3109)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 225 */
			{
				BgL_externz00_bglt BgL_nodez00_1856;

				{	/* Cfa/type.scm 226 */
					bool_t BgL_auxz00_4155;

					BgL_nodez00_1856 = (BgL_externz00_bglt) (BgL_nodez00_3109);
					{	/* Cfa/type.scm 226 */
						obj_t BgL_arg5349z00_2305;

						BgL_arg5349z00_2305 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1856))->BgL_exprza2za2);
						BgL_auxz00_4155 =
							BGl_typezd2nodeza2z12z62zzcfa_typez00(BgL_arg5349z00_2305);
					}
					return BBOOL(BgL_auxz00_4155);
				}
			}
		}
	}



/* type-node!-funcall5142 */
	obj_t BGl_typezd2nodez12zd2funcall5142z12zzcfa_typez00(obj_t BgL_envz00_3110,
		obj_t BgL_nodez00_3111)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 217 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1848;

				{	/* Cfa/type.scm 218 */
					bool_t BgL_auxz00_4160;

					BgL_nodez00_1848 = (BgL_funcallz00_bglt) (BgL_nodez00_3111);
					{	/* Cfa/type.scm 219 */
						BgL_nodez00_bglt BgL_arg5346z00_1852;

						BgL_arg5346z00_1852 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1848))->BgL_funz00);
						{	/* Cfa/type.scm 219 */
							obj_t BgL_method5126z00_2278;

							{	/* Cfa/type.scm 219 */
								BgL_objectz00_bglt BgL_objz00_2279;

								BgL_objz00_2279 = (BgL_objectz00_bglt) (BgL_arg5346z00_1852);
								{	/* Cfa/type.scm 219 */
									long BgL_objzd2classzd2numz00_2280;

									BgL_objzd2classzd2numz00_2280 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2279);
									{	/* Cfa/type.scm 219 */
										obj_t BgL_arg2334z00_2281;

										BgL_arg2334z00_2281 =
											PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
											(int) (((long) 1)));
										{	/* Cfa/type.scm 219 */
											obj_t BgL_arrayz00_2283;

											int BgL_offsetz00_2284;

											BgL_arrayz00_2283 = BgL_arg2334z00_2281;
											BgL_offsetz00_2284 =
												(int) (BgL_objzd2classzd2numz00_2280);
											{	/* Cfa/type.scm 219 */
												long BgL_offsetz00_2285;

												BgL_offsetz00_2285 =
													((long) (BgL_offsetz00_2284) - OBJECT_TYPE);
												{	/* Cfa/type.scm 219 */
													long BgL_modz00_2286;

													{	/* Cfa/type.scm 219 */
														int BgL_arg2336z00_2287;

														BgL_arg2336z00_2287 = (int) (((long) 8));
														{	/* Cfa/type.scm 219 */
															long BgL_auxz00_4170;

															BgL_auxz00_4170 = (long) (BgL_arg2336z00_2287);
															BgL_modz00_2286 =
																(BgL_offsetz00_2285 / BgL_auxz00_4170);
													}}
													{	/* Cfa/type.scm 219 */
														long BgL_restz00_2288;

														{	/* Cfa/type.scm 219 */
															int BgL_arg2335z00_2289;

															BgL_arg2335z00_2289 = (int) (((long) 8));
															{	/* Cfa/type.scm 219 */
																long BgL_auxz00_4174;

																BgL_auxz00_4174 = (long) (BgL_arg2335z00_2289);
																BgL_restz00_2288 =
																	(BgL_offsetz00_2285 % BgL_auxz00_4174);
														}}
														{	/* Cfa/type.scm 219 */

															BgL_method5126z00_2278 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2283,
																	(int) (BgL_modz00_2286)),
																(int) (BgL_restz00_2288));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method5126z00_2278) (BgL_method5126z00_2278,
								(obj_t) (BgL_arg5346z00_1852), BEOA);
					}}
					{	/* Cfa/type.scm 220 */
						obj_t BgL_arg5347z00_1853;

						BgL_arg5347z00_1853 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1848))->BgL_argsz00);
						BgL_auxz00_4160 =
							BGl_typezd2nodeza2z12z62zzcfa_typez00(BgL_arg5347z00_1853);
					}
					return BBOOL(BgL_auxz00_4160);
				}
			}
		}
	}



/* type-node!-app-ly5140 */
	obj_t BGl_typezd2nodez12zd2appzd2ly5140zc0zzcfa_typez00(obj_t BgL_envz00_3112,
		obj_t BgL_nodez00_3113)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 209 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1840;

				BgL_nodez00_1840 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_3113);
				{	/* Cfa/type.scm 211 */
					BgL_nodez00_bglt BgL_arg5343z00_1844;

					BgL_arg5343z00_1844 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1840))->BgL_funz00);
					{	/* Cfa/type.scm 211 */
						obj_t BgL_method5126z00_2224;

						{	/* Cfa/type.scm 211 */
							BgL_objectz00_bglt BgL_objz00_2225;

							BgL_objz00_2225 = (BgL_objectz00_bglt) (BgL_arg5343z00_1844);
							{	/* Cfa/type.scm 211 */
								long BgL_objzd2classzd2numz00_2226;

								BgL_objzd2classzd2numz00_2226 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2225);
								{	/* Cfa/type.scm 211 */
									obj_t BgL_arg2334z00_2227;

									BgL_arg2334z00_2227 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 211 */
										obj_t BgL_arrayz00_2229;

										int BgL_offsetz00_2230;

										BgL_arrayz00_2229 = BgL_arg2334z00_2227;
										BgL_offsetz00_2230 = (int) (BgL_objzd2classzd2numz00_2226);
										{	/* Cfa/type.scm 211 */
											long BgL_offsetz00_2231;

											BgL_offsetz00_2231 =
												((long) (BgL_offsetz00_2230) - OBJECT_TYPE);
											{	/* Cfa/type.scm 211 */
												long BgL_modz00_2232;

												{	/* Cfa/type.scm 211 */
													int BgL_arg2336z00_2233;

													BgL_arg2336z00_2233 = (int) (((long) 8));
													{	/* Cfa/type.scm 211 */
														long BgL_auxz00_4197;

														BgL_auxz00_4197 = (long) (BgL_arg2336z00_2233);
														BgL_modz00_2232 =
															(BgL_offsetz00_2231 / BgL_auxz00_4197);
												}}
												{	/* Cfa/type.scm 211 */
													long BgL_restz00_2234;

													{	/* Cfa/type.scm 211 */
														int BgL_arg2335z00_2235;

														BgL_arg2335z00_2235 = (int) (((long) 8));
														{	/* Cfa/type.scm 211 */
															long BgL_auxz00_4201;

															BgL_auxz00_4201 = (long) (BgL_arg2335z00_2235);
															BgL_restz00_2234 =
																(BgL_offsetz00_2231 % BgL_auxz00_4201);
													}}
													{	/* Cfa/type.scm 211 */

														BgL_method5126z00_2224 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2229,
																(int) (BgL_modz00_2232)),
															(int) (BgL_restz00_2234));
						}}}}}}}}
						PROCEDURE_ENTRY(BgL_method5126z00_2224) (BgL_method5126z00_2224,
							(obj_t) (BgL_arg5343z00_1844), BEOA);
				}}
				{	/* Cfa/type.scm 212 */
					BgL_nodez00_bglt BgL_arg5344z00_1845;

					BgL_arg5344z00_1845 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1840))->BgL_argz00);
					{	/* Cfa/type.scm 212 */
						obj_t BgL_method5126z00_2251;

						{	/* Cfa/type.scm 212 */
							BgL_objectz00_bglt BgL_objz00_2252;

							BgL_objz00_2252 = (BgL_objectz00_bglt) (BgL_arg5344z00_1845);
							{	/* Cfa/type.scm 212 */
								long BgL_objzd2classzd2numz00_2253;

								BgL_objzd2classzd2numz00_2253 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2252);
								{	/* Cfa/type.scm 212 */
									obj_t BgL_arg2334z00_2254;

									BgL_arg2334z00_2254 =
										PROCEDURE_REF(BGl_typezd2nodez12zd2envz12zzcfa_typez00,
										(int) (((long) 1)));
									{	/* Cfa/type.scm 212 */
										obj_t BgL_arrayz00_2256;

										int BgL_offsetz00_2257;

										BgL_arrayz00_2256 = BgL_arg2334z00_2254;
										BgL_offsetz00_2257 = (int) (BgL_objzd2classzd2numz00_2253);
										{	/* Cfa/type.scm 212 */
											long BgL_offsetz00_2258;

											BgL_offsetz00_2258 =
												((long) (BgL_offsetz00_2257) - OBJECT_TYPE);
											{	/* Cfa/type.scm 212 */
												long BgL_modz00_2259;

												{	/* Cfa/type.scm 212 */
													int BgL_arg2336z00_2260;

													BgL_arg2336z00_2260 = (int) (((long) 8));
													{	/* Cfa/type.scm 212 */
														long BgL_auxz00_4220;

														BgL_auxz00_4220 = (long) (BgL_arg2336z00_2260);
														BgL_modz00_2259 =
															(BgL_offsetz00_2258 / BgL_auxz00_4220);
												}}
												{	/* Cfa/type.scm 212 */
													long BgL_restz00_2261;

													{	/* Cfa/type.scm 212 */
														int BgL_arg2335z00_2262;

														BgL_arg2335z00_2262 = (int) (((long) 8));
														{	/* Cfa/type.scm 212 */
															long BgL_auxz00_4224;

															BgL_auxz00_4224 = (long) (BgL_arg2335z00_2262);
															BgL_restz00_2261 =
																(BgL_offsetz00_2258 % BgL_auxz00_4224);
													}}
													{	/* Cfa/type.scm 212 */

														BgL_method5126z00_2251 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2256,
																(int) (BgL_modz00_2259)),
															(int) (BgL_restz00_2261));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method5126z00_2251) (BgL_method5126z00_2251,
							(obj_t) (BgL_arg5344z00_1845), BEOA);
					}
				}
			}
		}
	}



/* type-node!-app5138 */
	obj_t BGl_typezd2nodez12zd2app5138z12zzcfa_typez00(obj_t BgL_envz00_3114,
		obj_t BgL_nodez00_3115)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 202 */
			{
				BgL_appz00_bglt BgL_nodez00_1833;

				{	/* Cfa/type.scm 203 */
					bool_t BgL_auxz00_4235;

					BgL_nodez00_1833 = (BgL_appz00_bglt) (BgL_nodez00_3115);
					{	/* Cfa/type.scm 203 */
						obj_t BgL_arg5341z00_2220;

						BgL_arg5341z00_2220 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1833))->BgL_argsz00);
						BgL_auxz00_4235 =
							BGl_typezd2nodeza2z12z62zzcfa_typez00(BgL_arg5341z00_2220);
					}
					return BBOOL(BgL_auxz00_4235);
				}
			}
		}
	}



/* type-node!-sequence5136 */
	obj_t BGl_typezd2nodez12zd2sequence5136z12zzcfa_typez00(obj_t BgL_envz00_3116,
		obj_t BgL_nodez00_3117)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 195 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1826;

				{	/* Cfa/type.scm 196 */
					bool_t BgL_auxz00_4240;

					BgL_nodez00_1826 = (BgL_sequencez00_bglt) (BgL_nodez00_3117);
					{	/* Cfa/type.scm 196 */
						obj_t BgL_arg5339z00_2217;

						BgL_arg5339z00_2217 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1826))->BgL_nodesz00);
						BgL_auxz00_4240 =
							BGl_typezd2nodeza2z12z62zzcfa_typez00(BgL_arg5339z00_2217);
					}
					return BBOOL(BgL_auxz00_4240);
				}
			}
		}
	}



/* type-node!-closure5134 */
	obj_t BGl_typezd2nodez12zd2closure5134z12zzcfa_typez00(obj_t BgL_envz00_3118,
		obj_t BgL_nodez00_3119)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 189 */
			{
				BgL_closurez00_bglt BgL_nodez00_1818;

				BgL_nodez00_1818 = (BgL_closurez00_bglt) (BgL_nodez00_3119);
				return
					BGl_internalzd2errorzd2zztools_errorz00
					(BGl_string5499z00zzcfa_typez00, BGl_string5500z00zzcfa_typez00,
					BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1818)));
			}
		}
	}



/* type-node!-var5132 */
	obj_t BGl_typezd2nodez12zd2var5132z12zzcfa_typez00(obj_t BgL_envz00_3120,
		obj_t BgL_nodez00_3121)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 181 */
			{
				BgL_varz00_bglt BgL_nodez00_1803;

				BgL_nodez00_1803 = (BgL_varz00_bglt) (BgL_nodez00_3121);
				{	/* Cfa/type.scm 183 */
					bool_t BgL_testz00_4249;

					{	/* Cfa/type.scm 183 */
						bool_t BgL_testz00_4250;

						{	/* Cfa/type.scm 183 */
							BgL_variablez00_bglt BgL_arg5333z00_1815;

							BgL_arg5333z00_1815 =
								(((BgL_varz00_bglt) CREF(BgL_nodez00_1803))->BgL_variablez00);
							{	/* Cfa/type.scm 183 */
								obj_t BgL_obj1568z00_2183;

								BgL_obj1568z00_2183 = (obj_t) (BgL_arg5333z00_1815);
								BgL_testz00_4250 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1568z00_2183,
									BGl_globalz00zzast_varz00);
							}
						}
						if (BgL_testz00_4250)
							{	/* Cfa/type.scm 183 */
								obj_t BgL_auxz00_4254;

								{	/* Cfa/type.scm 183 */
									BgL_globalz00_bglt BgL_obj1494z00_2185;

									BgL_obj1494z00_2185 =
										(BgL_globalz00_bglt) (
										(((BgL_varz00_bglt) CREF(BgL_nodez00_1803))->
											BgL_variablez00));
									BgL_auxz00_4254 =
										(((BgL_globalz00_bglt) CREF(BgL_obj1494z00_2185))->
										BgL_importz00);
								}
								BgL_testz00_4249 =
									(BgL_auxz00_4254 == CNST_TABLE_REF(((long) 3)));
							}
						else
							{	/* Cfa/type.scm 183 */
								BgL_testz00_4249 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_4249)
						{	/* Cfa/type.scm 184 */
							BgL_valuez00_bglt BgL_arg5326z00_1808;

							BgL_variablez00_bglt BgL_arg5327z00_1809;

							{	/* Cfa/type.scm 184 */
								BgL_variablez00_bglt BgL_obj1426z00_2187;

								BgL_obj1426z00_2187 =
									(((BgL_varz00_bglt) CREF(BgL_nodez00_1803))->BgL_variablez00);
								BgL_arg5326z00_1808 =
									(((BgL_variablez00_bglt) CREF(BgL_obj1426z00_2187))->
									BgL_valuez00);
							}
							BgL_arg5327z00_1809 =
								(((BgL_varz00_bglt) CREF(BgL_nodez00_1803))->BgL_variablez00);
							{	/* Cfa/type.scm 184 */
								obj_t BgL_method5114z00_2191;

								{	/* Cfa/type.scm 184 */
									BgL_objectz00_bglt BgL_objz00_2192;

									BgL_objz00_2192 = (BgL_objectz00_bglt) (BgL_arg5326z00_1808);
									{	/* Cfa/type.scm 184 */
										long BgL_objzd2classzd2numz00_2193;

										BgL_objzd2classzd2numz00_2193 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2192);
										{	/* Cfa/type.scm 184 */
											obj_t BgL_arg2334z00_2194;

											BgL_arg2334z00_2194 =
												PROCEDURE_REF
												(BGl_typezd2variablez12zd2envz12zzcfa_typez00,
												(int) (((long) 1)));
											{	/* Cfa/type.scm 184 */
												obj_t BgL_arrayz00_2196;

												int BgL_offsetz00_2197;

												BgL_arrayz00_2196 = BgL_arg2334z00_2194;
												BgL_offsetz00_2197 =
													(int) (BgL_objzd2classzd2numz00_2193);
												{	/* Cfa/type.scm 184 */
													long BgL_offsetz00_2198;

													BgL_offsetz00_2198 =
														((long) (BgL_offsetz00_2197) - OBJECT_TYPE);
													{	/* Cfa/type.scm 184 */
														long BgL_modz00_2199;

														{	/* Cfa/type.scm 184 */
															int BgL_arg2336z00_2200;

															BgL_arg2336z00_2200 = (int) (((long) 8));
															{	/* Cfa/type.scm 184 */
																long BgL_auxz00_4271;

																BgL_auxz00_4271 = (long) (BgL_arg2336z00_2200);
																BgL_modz00_2199 =
																	(BgL_offsetz00_2198 / BgL_auxz00_4271);
														}}
														{	/* Cfa/type.scm 184 */
															long BgL_restz00_2201;

															{	/* Cfa/type.scm 184 */
																int BgL_arg2335z00_2202;

																BgL_arg2335z00_2202 = (int) (((long) 8));
																{	/* Cfa/type.scm 184 */
																	long BgL_auxz00_4275;

																	BgL_auxz00_4275 =
																		(long) (BgL_arg2335z00_2202);
																	BgL_restz00_2201 =
																		(BgL_offsetz00_2198 % BgL_auxz00_4275);
															}}
															{	/* Cfa/type.scm 184 */

																BgL_method5114z00_2191 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2196,
																		(int) (BgL_modz00_2199)),
																	(int) (BgL_restz00_2201));
								}}}}}}}}
								return
									PROCEDURE_ENTRY(BgL_method5114z00_2191)
									(BgL_method5114z00_2191, (obj_t) (BgL_arg5326z00_1808),
									(obj_t) (BgL_arg5327z00_1809), BEOA);
							}
						}
					else
						{	/* Cfa/type.scm 183 */
							return BFALSE;
						}
				}
			}
		}
	}



/* type-node!-kwote5130 */
	obj_t BGl_typezd2nodez12zd2kwote5130z12zzcfa_typez00(obj_t BgL_envz00_3122,
		obj_t BgL_nodez00_3123)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 175 */
			return BUNSPEC;
		}
	}



/* type-node!-atom5128 */
	obj_t BGl_typezd2nodez12zd2atom5128z12zzcfa_typez00(obj_t BgL_envz00_3124,
		obj_t BgL_nodez00_3125)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 169 */
			return BUNSPEC;
		}
	}



/* type-variable!-inter5124 */
	obj_t BGl_typezd2variablez12zd2inter5124z12zzcfa_typez00(obj_t
		BgL_envz00_3126, obj_t BgL_valuez00_3127, obj_t BgL_variablez00_3128)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 132 */
			{	/* Cfa/type.scm 133 */
				obj_t BgL_res5505z00_3153;

				BgL_res5505z00_3153 = CNST_TABLE_REF(((long) 1));
				return BgL_res5505z00_3153;
			}
		}
	}



/* type-variable!-sexit5122 */
	obj_t BGl_typezd2variablez12zd2sexit5122z12zzcfa_typez00(obj_t
		BgL_envz00_3129, obj_t BgL_valuez00_3130, obj_t BgL_variablez00_3131)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 122 */
			{	/* Cfa/type.scm 123 */
				obj_t BgL_res5506z00_3156;

				BgL_res5506z00_3156 = CNST_TABLE_REF(((long) 1));
				return BgL_res5506z00_3156;
			}
		}
	}



/* type-variable!-cvar/5120 */
	obj_t BGl_typezd2variablez12zd2cvarzf25120ze0zzcfa_typez00(obj_t
		BgL_envz00_3132, obj_t BgL_valuez00_3133, obj_t BgL_variablez00_3134)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 115 */
			{
				BgL_cvarzf2cinfozf2_bglt BgL_valuez00_1772;

				obj_t BgL_variablez00_1773;

				BgL_valuez00_1772 = (BgL_cvarzf2cinfozf2_bglt) (BgL_valuez00_3133);
				BgL_variablez00_1773 = BgL_variablez00_3134;
				{	/* Cfa/type.scm 116 */
					obj_t BgL_arg5318z00_2179;

					{	/* Cfa/type.scm 116 */
						BgL_approxz00_bglt BgL_arg5319z00_2180;

						{
							obj_t BgL_auxz00_4289;

							{	/* Cfa/type.scm 116 */
								BgL_objectz00_bglt BgL_auxz00_4290;

								BgL_auxz00_4290 = (BgL_objectz00_bglt) (BgL_valuez00_1772);
								BgL_auxz00_4289 = BGL_OBJECT_WIDENING(BgL_auxz00_4290);
							}
							BgL_arg5319z00_2180 =
								(((BgL_cvarzf2cinfozf2_bglt) CREF(BgL_auxz00_4289))->
								BgL_approxz00);
						}
						BgL_arg5318z00_2179 =
							BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_arg5319z00_2180);
					}
					return
						BGl_setzd2variablezd2typez12z12zzcfa_typez00(
						(BgL_variablez00_bglt) (BgL_variablez00_1773),
						(BgL_typez00_bglt) (BgL_arg5318z00_2179));
				}
			}
		}
	}



/* type-variable!-scnst5118 */
	obj_t BGl_typezd2variablez12zd2scnst5118z12zzcfa_typez00(obj_t
		BgL_envz00_3135, obj_t BgL_valuez00_3136, obj_t BgL_variablez00_3137)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 109 */
			{	/* Cfa/type.scm 110 */
				obj_t BgL_res5507z00_3159;

				BgL_res5507z00_3159 = CNST_TABLE_REF(((long) 1));
				return BgL_res5507z00_3159;
			}
		}
	}



/* type-variable!-svar/5116 */
	obj_t BGl_typezd2variablez12zd2svarzf25116ze0zzcfa_typez00(obj_t
		BgL_envz00_3138, obj_t BgL_valuez00_3139, obj_t BgL_variablez00_3140)
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 102 */
			{
				BgL_svarzf2cinfozf2_bglt BgL_valuez00_1757;

				obj_t BgL_variablez00_1758;

				BgL_valuez00_1757 = (BgL_svarzf2cinfozf2_bglt) (BgL_valuez00_3139);
				BgL_variablez00_1758 = BgL_variablez00_3140;
				{	/* Cfa/type.scm 103 */
					obj_t BgL_arg5314z00_2175;

					{	/* Cfa/type.scm 103 */
						BgL_approxz00_bglt BgL_arg5315z00_2176;

						{
							obj_t BgL_auxz00_4300;

							{	/* Cfa/type.scm 103 */
								BgL_objectz00_bglt BgL_auxz00_4301;

								BgL_auxz00_4301 = (BgL_objectz00_bglt) (BgL_valuez00_1757);
								BgL_auxz00_4300 = BGL_OBJECT_WIDENING(BgL_auxz00_4301);
							}
							BgL_arg5315z00_2176 =
								(((BgL_svarzf2cinfozf2_bglt) CREF(BgL_auxz00_4300))->
								BgL_approxz00);
						}
						BgL_arg5314z00_2175 =
							BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_arg5315z00_2176);
					}
					return
						BGl_setzd2variablezd2typez12z12zzcfa_typez00(
						(BgL_variablez00_bglt) (BgL_variablez00_1758),
						(BgL_typez00_bglt) (BgL_arg5314z00_2175));
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_typez00()
	{
		AN_OBJECT;
		{	/* Cfa/type.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 243010053),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_info3z00(((long) 0),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_setz00(((long) 474371048),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long) 249450490),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
			return
				BGl_modulezd2initializa7ationz75zztvector_tvectorz00(((long) 2222742),
				BSTRING_TO_STRING(BGl_string5501z00zzcfa_typez00));
		}
	}

#ifdef __cplusplus
}
#endif
