/*===========================================================================*/
/*   (Coerce/coerce.scm)                                                     */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Coerce/coerce.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_getfieldz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_fnamez00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                  *BgL_getfieldz00_bglt;

	typedef struct BgL_setfieldz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_fnamez00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                  *BgL_setfieldz00_bglt;

	typedef struct BgL_newz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_argszd2typezd2;
	}             *BgL_newz00_bglt;

	typedef struct BgL_vallocz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2heapzd2formatz00;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
	}                *BgL_vallocz00_bglt;

	typedef struct BgL_vrefz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}              *BgL_vrefz00_bglt;

	typedef struct BgL_vsetz12z12_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_ftypez00;
		struct BgL_typez00_bgl *BgL_otypez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                 *BgL_vsetz12z12_bglt;

	typedef struct BgL_vlengthz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                 *BgL_vlengthz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;


	extern obj_t BGl_vrefz00zzast_nodez00;
	static obj_t BGl_coercez12zd2new3412zc0zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_coercez12zd2kwote3398zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2cast3423zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_pvariablezd2protozd2zzcoerce_pprotoz00(long,
		BgL_variablez00_bglt);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t BGl_coercez12zd2vref3416zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl__coercezd2functionz123847zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcoerce_coercez00();
	static obj_t BGl_coercez12zd2setq3425zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2jumpzd2exzd2it3439zc0zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2vlength3421zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2makezd2box3441z12zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2getfield3408zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	extern obj_t BGl_vallocz00zzast_nodez00;
	extern bool_t BGl_sidezd2effectzf3z21zzeffect_effectz00(BgL_nodez00_bglt);
	extern BgL_nodez00_bglt BGl_convertz12z12zzcoerce_convertz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, BgL_typez00_bglt, bool_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_effectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_convertz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcoerce_pprotoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_coercionz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzcoerce_coercez00();
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_coercez12zd2boxzd2ref3443z12zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2boolza2z00zztype_cachez00;
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	BGL_EXPORTED_DECL obj_t
		BGl_coercezd2functionz12zc0zzcoerce_coercez00(BgL_variablez00_bglt, bool_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_deczd2ppmargez12zc0zzcoerce_pprotoz00();
	static obj_t BGl_coercez12zd2setfield3410zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2fail3429zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl__coercez123848z12zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_vlengthz00zzast_nodez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_inczd2ppmargez12zc0zzcoerce_pprotoz00();
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	extern obj_t BGl_vsetz12z12zzast_nodez00;
	static obj_t BGl_methodzd2initzd2zzcoerce_coercez00();
	static obj_t BGl_coercez12zd2vsetz123418zd2zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl__coercez12zd2default3390zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcoerce_coercez00 = BUNSPEC;
	static obj_t BGl_coercez12zd2extern3406zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2letzd2fun3433z12zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzcoerce_coercez00();
	static obj_t BGl_coercez12zd2closure3402zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
	static obj_t BGl_coercez12zd2var3400zc0zzcoerce_coercez00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_coercerzd2existszf3z21zztype_coercionz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_thezd2coercedzd2functionz00zzcoerce_coercez00 = BUNSPEC;
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_typez00_bglt BGl_typeofz00zztype_typeofz00(BgL_nodez00_bglt);
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl_coercez12zd2letzd2var3435z12zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern bool_t BGl_typezd2disjointzf3z21zztype_miscz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_coercez12zd2conditional3427zc0zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2valloc3414zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzcoerce_coercez00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt, obj_t,
		BgL_typez00_bglt, bool_t);
	extern obj_t BGl_getfieldz00zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_coercez12zd2atom3395zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	extern obj_t BGl_newz00zzast_nodez00;
	static obj_t BGl_coercez12zd2select3431zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_pfunctionzd2protozd2zzcoerce_pprotoz00(long,
		BgL_variablez00_bglt);
	static obj_t BGl_coercez12zd2sequence3404zc0zzcoerce_coercez00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_coercez12zd2setzd2exzd2it3437zc0zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_za2unsafezd2evalza2zd2zzengine_paramz00;
	extern obj_t BGl_setfieldz00zzast_nodez00;
	extern obj_t BGl_za2exitza2z00zztype_cachez00;
	extern obj_t BGl_runtimezd2typezd2errorz00zzcoerce_convertz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_coercez12zd2boxzd2setz123445z00zzcoerce_coercez00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern bool_t BGl_typezd2lesszd2specificzf3zf3zztype_miscz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_coercez00();
	static BgL_nodez00_bglt
		BGl_coercez12zd2default3390zc0zzcoerce_coercez00(BgL_nodez00_bglt, obj_t,
		BgL_typez00_bglt, bool_t);
	static obj_t __cnst[3];


	   
		 
		DEFINE_STRING(BGl_string3849z00zzcoerce_coercez00,
		BgL_bgl_string3849za700za7za7c3881za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3875z00zzcoerce_coercez00,
		BgL_bgl_string3875za700za7za7c3882za7, "coerce!", 7);
	      DEFINE_STRING(BGl_string3876z00zzcoerce_coercez00,
		BgL_bgl_string3876za700za7za7c3883za7, "Unexepected `closure' node", 26);
	      DEFINE_STRING(BGl_string3877z00zzcoerce_coercez00,
		BgL_bgl_string3877za700za7za7c3884za7, "coerce_coerce", 13);
	      DEFINE_STRING(BGl_string3878z00zzcoerce_coercez00,
		BgL_bgl_string3878za700za7za7c3885za7, "false true coerce!-default3390 ",
		31);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_coercez12zd2envzc0zzcoerce_coercez00,
		BgL_bgl__coerceza7123848za713886z00,
		BGl__coercez123848z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_coercez12zd2default3390zd2envz12zzcoerce_coercez00,
		BgL_bgl__coerceza712za7d2def3887z00,
		BGl__coercez12zd2default3390zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_coercezd2functionz12zd2envz12zzcoerce_coercez00,
		BgL_bgl__coerceza7d2functi3888za7,
		BGl__coercezd2functionz123847zc0zzcoerce_coercez00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3850z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2atom3889z00,
		BGl_coercez12zd2atom3395zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3851z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2kwot3890z00,
		BGl_coercez12zd2kwote3398zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3852z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2var33891z00,
		BGl_coercez12zd2var3400zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3853z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2clos3892z00,
		BGl_coercez12zd2closure3402zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3854z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2sequ3893z00,
		BGl_coercez12zd2sequence3404zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3855z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2exte3894z00,
		BGl_coercez12zd2extern3406zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3856z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2getf3895z00,
		BGl_coercez12zd2getfield3408zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3857z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2setf3896z00,
		BGl_coercez12zd2setfield3410zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3858z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2new33897z00,
		BGl_coercez12zd2new3412zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3860z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2vref3898z00,
		BGl_coercez12zd2vref3416zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3859z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2vall3899z00,
		BGl_coercez12zd2valloc3414zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3861z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2vset3900z00,
		BGl_coercez12zd2vsetz123418zd2zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3862z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2vlen3901z00,
		BGl_coercez12zd2vlength3421zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3863z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2cast3902z00,
		BGl_coercez12zd2cast3423zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3864z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2setq3903z00,
		BGl_coercez12zd2setq3425zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3865z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2cond3904z00,
		BGl_coercez12zd2conditional3427zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3866z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2fail3905z00,
		BGl_coercez12zd2fail3429zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3867z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2sele3906z00,
		BGl_coercez12zd2select3431zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3868z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2letza73907za7,
		BGl_coercez12zd2letzd2fun3433z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3870z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2setza73908za7,
		BGl_coercez12zd2setzd2exzd2it3437zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3869z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2letza73909za7,
		BGl_coercez12zd2letzd2var3435z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3871z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2jump3910z00,
		BGl_coercez12zd2jumpzd2exzd2it3439zc0zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3872z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2make3911z00,
		BGl_coercez12zd2makezd2box3441z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3873z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2boxza73912za7,
		BGl_coercez12zd2boxzd2ref3443z12zzcoerce_coercez00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3874z00zzcoerce_coercez00,
		BgL_bgl_coerceza712za7d2boxza73913za7,
		BGl_coercez12zd2boxzd2setz123445z00zzcoerce_coercez00, 0L, BUNSPEC, 4);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzcoerce_coercez00(long
		BgL_checksumz00_3360, char *BgL_fromz00_3361)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcoerce_coercez00))
				{
					BGl_requirezd2initializa7ationz75zzcoerce_coercez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcoerce_coercez00();
					BGl_cnstzd2initzd2zzcoerce_coercez00();
					BGl_importedzd2moduleszd2initz00zzcoerce_coercez00();
					BGl_genericzd2initzd2zzcoerce_coercez00();
					BGl_methodzd2initzd2zzcoerce_coercez00();
					BGl_toplevelzd2initzd2zzcoerce_coercez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "coerce_coerce");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"coerce_coerce");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			{	/* Coerce/coerce.scm 15 */
				obj_t BgL_cportz00_3352;

				BgL_cportz00_3352 =
					bgl_open_input_string(BGl_string3878z00zzcoerce_coercez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_3353;

					BgL_iz00_3353 = ((long) 2);
				BgL_loopz00_3354:
					if ((BgL_iz00_3353 == ((long) -1)))
						{	/* Coerce/coerce.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Coerce/coerce.scm 15 */
							{	/* Coerce/coerce.scm 15 */
								obj_t BgL_arg3880z00_3356;

								{	/* Coerce/coerce.scm 15 */

									{	/* Coerce/coerce.scm 15 */
										obj_t BgL_locationz00_3358;

										BgL_locationz00_3358 = BBOOL(((bool_t) 0));
										{	/* Coerce/coerce.scm 15 */

											BgL_arg3880z00_3356 =
												BGl_readz00zz__readerz00(BgL_cportz00_3352,
												BgL_locationz00_3358);
										}
									}
								}
								{	/* Coerce/coerce.scm 15 */
									int BgL_auxz00_3380;

									BgL_auxz00_3380 = (int) (BgL_iz00_3353);
									CNST_TABLE_SET(BgL_auxz00_3380, BgL_arg3880z00_3356);
							}}
							{	/* Coerce/coerce.scm 15 */
								int BgL_auxz00_3359;

								BgL_auxz00_3359 = (int) ((BgL_iz00_3353 - ((long) 1)));
								{
									long BgL_iz00_3385;

									BgL_iz00_3385 = (long) (BgL_auxz00_3359);
									BgL_iz00_3353 = BgL_iz00_3385;
									goto BgL_loopz00_3354;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			BGl_thezd2coercedzd2functionz00zzcoerce_coercez00 = BUNSPEC;
			return BUNSPEC;
		}
	}



/* coerce-function! */
	BGL_EXPORTED_DEF obj_t
		BGl_coercezd2functionz12zc0zzcoerce_coercez00(BgL_variablez00_bglt
		BgL_variablez00_1, bool_t BgL_typezd2safezd2_2)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 45 */
			{	/* Coerce/coerce.scm 47 */
				obj_t BgL_arg3446z00_885;

				BgL_arg3446z00_885 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_idz00);
				BGl_enterzd2functionzd2zztools_errorz00(BgL_arg3446z00_885);
			}
			{	/* Coerce/coerce.scm 48 */
				BgL_valuez00_bglt BgL_funz00_886;

				BgL_funz00_886 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_valuez00);
				{	/* Coerce/coerce.scm 48 */
					obj_t BgL_bodyz00_887;

					{
						BgL_sfunz00_bglt BgL_auxz00_3390;

						BgL_auxz00_3390 = (BgL_sfunz00_bglt) (BgL_funz00_886);
						BgL_bodyz00_887 =
							(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3390))->BgL_bodyz00);
					}
					{	/* Coerce/coerce.scm 49 */
						BgL_typez00_bglt BgL_tresz00_888;

						BgL_tresz00_888 =
							(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_typez00);
						{	/* Coerce/coerce.scm 50 */
							bool_t BgL_typezd2safetyzd2enforcedz00_889;

							{	/* Coerce/coerce.scm 51 */
								bool_t BgL_testz00_3394;

								if (CBOOL(BGl_za2unsafezd2evalza2zd2zzengine_paramz00))
									{	/* Coerce/coerce.scm 51 */
										BgL_testz00_3394 = ((bool_t) 0);
									}
								else
									{	/* Coerce/coerce.scm 51 */
										BgL_testz00_3394 = ((bool_t) 1);
									}
								if (BgL_testz00_3394)
									{	/* Coerce/coerce.scm 52 */
										bool_t BgL_testz00_3397;

										{	/* Coerce/coerce.scm 52 */
											obj_t BgL_obj1830z00_1775;

											BgL_obj1830z00_1775 = (obj_t) (BgL_variablez00_1);
											BgL_testz00_3397 =
												BGl_iszd2azf3z21zz__objectz00(BgL_obj1830z00_1775,
												BGl_globalz00zzast_varz00);
										}
										if (BgL_testz00_3397)
											{	/* Coerce/coerce.scm 53 */
												bool_t BgL_testz00_3400;

												{
													BgL_globalz00_bglt BgL_auxz00_3401;

													BgL_auxz00_3401 =
														(BgL_globalz00_bglt) (BgL_variablez00_1);
													BgL_testz00_3400 =
														(((BgL_globalz00_bglt) CREF(BgL_auxz00_3401))->
														BgL_evaluablezf3zf3);
												}
												if (BgL_testz00_3400)
													{	/* Coerce/coerce.scm 54 */
														bool_t BgL_testz00_3404;

														{
															BgL_globalz00_bglt BgL_auxz00_3405;

															BgL_auxz00_3405 =
																(BgL_globalz00_bglt) (BgL_variablez00_1);
															BgL_testz00_3404 =
																(((BgL_globalz00_bglt) CREF(BgL_auxz00_3405))->
																BgL_userzf3zf3);
														}
														if (BgL_testz00_3404)
															{	/* Coerce/coerce.scm 55 */
																obj_t BgL_arg3448z00_897;

																{
																	BgL_sfunz00_bglt BgL_auxz00_3408;

																	BgL_auxz00_3408 =
																		(BgL_sfunz00_bglt) (BgL_funz00_886);
																	BgL_arg3448z00_897 =
																		(((BgL_sfunz00_bglt)
																			CREF(BgL_auxz00_3408))->
																		BgL_thezd2closurezd2globalz00);
																}
																BgL_typezd2safetyzd2enforcedz00_889 =
																	BGl_iszd2azf3z21zz__objectz00
																	(BgL_arg3448z00_897,
																	BGl_globalz00zzast_varz00);
															}
														else
															{	/* Coerce/coerce.scm 54 */
																BgL_typezd2safetyzd2enforcedz00_889 =
																	((bool_t) 0);
															}
													}
												else
													{	/* Coerce/coerce.scm 53 */
														BgL_typezd2safetyzd2enforcedz00_889 = ((bool_t) 0);
													}
											}
										else
											{	/* Coerce/coerce.scm 52 */
												BgL_typezd2safetyzd2enforcedz00_889 = ((bool_t) 0);
											}
									}
								else
									{	/* Coerce/coerce.scm 51 */
										BgL_typezd2safetyzd2enforcedz00_889 = ((bool_t) 0);
									}
							}
							{	/* Coerce/coerce.scm 51 */
								bool_t BgL_typezd2safezd2_890;

								if (BgL_typezd2safezd2_2)
									{	/* Coerce/coerce.scm 56 */
										BgL_typezd2safezd2_890 = BgL_typezd2safezd2_2;
									}
								else
									{	/* Coerce/coerce.scm 56 */
										BgL_typezd2safezd2_890 =
											BgL_typezd2safetyzd2enforcedz00_889;
									}
								{	/* Coerce/coerce.scm 56 */

									BGl_pfunctionzd2protozd2zzcoerce_pprotoz00(((long) 3),
										BgL_variablez00_1);
									BGl_thezd2coercedzd2functionz00zzcoerce_coercez00 =
										(obj_t) (BgL_variablez00_1);
									{	/* Coerce/coerce.scm 59 */
										BgL_nodez00_bglt BgL_arg3447z00_891;

										{	/* Coerce/coerce.scm 59 */
											BgL_nodez00_bglt BgL_res3736z00_1809;

											{	/* Coerce/coerce.scm 59 */
												BgL_nodez00_bglt BgL_nodez00_1780;

												obj_t BgL_callerz00_1781;

												BgL_nodez00_1780 = (BgL_nodez00_bglt) (BgL_bodyz00_887);
												BgL_callerz00_1781 = (obj_t) (BgL_variablez00_1);
												{	/* Coerce/coerce.scm 59 */
													obj_t BgL_method3391z00_1784;

													{	/* Coerce/coerce.scm 59 */
														BgL_objectz00_bglt BgL_objz00_1785;

														BgL_objz00_1785 =
															(BgL_objectz00_bglt) (BgL_nodez00_1780);
														{	/* Coerce/coerce.scm 59 */
															long BgL_objzd2classzd2numz00_1786;

															BgL_objzd2classzd2numz00_1786 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_1785);
															{	/* Coerce/coerce.scm 59 */
																obj_t BgL_arg2334z00_1787;

																BgL_arg2334z00_1787 =
																	PROCEDURE_REF
																	(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																	(int) (((long) 1)));
																{	/* Coerce/coerce.scm 59 */
																	obj_t BgL_arrayz00_1789;

																	int BgL_offsetz00_1790;

																	BgL_arrayz00_1789 = BgL_arg2334z00_1787;
																	BgL_offsetz00_1790 =
																		(int) (BgL_objzd2classzd2numz00_1786);
																	{	/* Coerce/coerce.scm 59 */
																		long BgL_offsetz00_1791;

																		BgL_offsetz00_1791 =
																			(
																			(long) (BgL_offsetz00_1790) -
																			OBJECT_TYPE);
																		{	/* Coerce/coerce.scm 59 */
																			long BgL_modz00_1792;

																			{	/* Coerce/coerce.scm 59 */
																				int BgL_arg2336z00_1793;

																				BgL_arg2336z00_1793 =
																					(int) (((long) 8));
																				{	/* Coerce/coerce.scm 59 */
																					long BgL_auxz00_3425;

																					BgL_auxz00_3425 =
																						(long) (BgL_arg2336z00_1793);
																					BgL_modz00_1792 =
																						(BgL_offsetz00_1791 /
																						BgL_auxz00_3425);
																			}}
																			{	/* Coerce/coerce.scm 59 */
																				long BgL_restz00_1794;

																				{	/* Coerce/coerce.scm 59 */
																					int BgL_arg2335z00_1795;

																					BgL_arg2335z00_1795 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 59 */
																						long BgL_auxz00_3429;

																						BgL_auxz00_3429 =
																							(long) (BgL_arg2335z00_1795);
																						BgL_restz00_1794 =
																							(BgL_offsetz00_1791 %
																							BgL_auxz00_3429);
																				}}
																				{	/* Coerce/coerce.scm 59 */

																					BgL_method3391z00_1784 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_1789,
																							(int) (BgL_modz00_1792)),
																						(int) (BgL_restz00_1794));
													}}}}}}}}
													BgL_res3736z00_1809 =
														(BgL_nodez00_bglt) (PROCEDURE_ENTRY
														(BgL_method3391z00_1784) (BgL_method3391z00_1784,
															(obj_t) (BgL_nodez00_1780), BgL_callerz00_1781,
															(obj_t) (BgL_tresz00_888),
															BBOOL(BgL_typezd2safezd2_890), BEOA));
											}}
											BgL_arg3447z00_891 = BgL_res3736z00_1809;
										}
										{
											obj_t BgL_auxz00_3444;

											BgL_sfunz00_bglt BgL_auxz00_3442;

											BgL_auxz00_3444 = (obj_t) (BgL_arg3447z00_891);
											BgL_auxz00_3442 = (BgL_sfunz00_bglt) (BgL_funz00_886);
											((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3442))->
													BgL_bodyz00) = ((obj_t) BgL_auxz00_3444), BUNSPEC);
									}}
									return BGl_leavezd2functionzd2zztools_errorz00();
								}
							}
						}
					}
				}
			}
		}
	}



/* _coerce-function!3847 */
	obj_t BGl__coercezd2functionz123847zc0zzcoerce_coercez00(obj_t
		BgL_envz00_3189, obj_t BgL_variablez00_3190, obj_t BgL_typezd2safezd2_3191)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 45 */
			return
				BGl_coercezd2functionz12zc0zzcoerce_coercez00(
				(BgL_variablez00_bglt) (BgL_variablez00_3190),
				CBOOL(BgL_typezd2safezd2_3191));
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_coercez12zd2default3390zd2envz12zzcoerce_coercez00);
		}
	}



/* coerce! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_coercez12z12zzcoerce_coercez00(BgL_nodez00_bglt BgL_nodez00_3,
		obj_t BgL_callerz00_4, BgL_typez00_bglt BgL_toz00_5, bool_t BgL_safez00_6)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 65 */
			{	/* Coerce/coerce.scm 65 */
				obj_t BgL_method3391z00_1812;

				{	/* Coerce/coerce.scm 65 */
					BgL_objectz00_bglt BgL_objz00_1813;

					BgL_objz00_1813 = (BgL_objectz00_bglt) (BgL_nodez00_3);
					{	/* Coerce/coerce.scm 65 */
						long BgL_objzd2classzd2numz00_1814;

						BgL_objzd2classzd2numz00_1814 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1813);
						{	/* Coerce/coerce.scm 65 */
							obj_t BgL_arg2334z00_1815;

							BgL_arg2334z00_1815 =
								PROCEDURE_REF(BGl_coercez12zd2envzc0zzcoerce_coercez00,
								(int) (((long) 1)));
							{	/* Coerce/coerce.scm 65 */
								obj_t BgL_arrayz00_1817;

								int BgL_offsetz00_1818;

								BgL_arrayz00_1817 = BgL_arg2334z00_1815;
								BgL_offsetz00_1818 = (int) (BgL_objzd2classzd2numz00_1814);
								{	/* Coerce/coerce.scm 65 */
									long BgL_offsetz00_1819;

									BgL_offsetz00_1819 =
										((long) (BgL_offsetz00_1818) - OBJECT_TYPE);
									{	/* Coerce/coerce.scm 65 */
										long BgL_modz00_1820;

										{	/* Coerce/coerce.scm 65 */
											int BgL_arg2336z00_1821;

											BgL_arg2336z00_1821 = (int) (((long) 8));
											{	/* Coerce/coerce.scm 65 */
												long BgL_auxz00_3460;

												BgL_auxz00_3460 = (long) (BgL_arg2336z00_1821);
												BgL_modz00_1820 =
													(BgL_offsetz00_1819 / BgL_auxz00_3460);
										}}
										{	/* Coerce/coerce.scm 65 */
											long BgL_restz00_1822;

											{	/* Coerce/coerce.scm 65 */
												int BgL_arg2335z00_1823;

												BgL_arg2335z00_1823 = (int) (((long) 8));
												{	/* Coerce/coerce.scm 65 */
													long BgL_auxz00_3464;

													BgL_auxz00_3464 = (long) (BgL_arg2335z00_1823);
													BgL_restz00_1822 =
														(BgL_offsetz00_1819 % BgL_auxz00_3464);
											}}
											{	/* Coerce/coerce.scm 65 */

												BgL_method3391z00_1812 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1817,
														(int) (BgL_modz00_1820)), (int) (BgL_restz00_1822));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3391z00_1812)
					(BgL_method3391z00_1812, (obj_t) (BgL_nodez00_3), BgL_callerz00_4,
						(obj_t) (BgL_toz00_5), BBOOL(BgL_safez00_6), BEOA));
			}
		}
	}



/* _coerce!3848 */
	obj_t BGl__coercez123848z12zzcoerce_coercez00(obj_t BgL_envz00_3192,
		obj_t BgL_nodez00_3193, obj_t BgL_callerz00_3194, obj_t BgL_toz00_3195,
		obj_t BgL_safez00_3196)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 65 */
			return
				(obj_t) (BGl_coercez12z12zzcoerce_coercez00(
					(BgL_nodez00_bglt) (BgL_nodez00_3193), BgL_callerz00_3194,
					(BgL_typez00_bglt) (BgL_toz00_3195), CBOOL(BgL_safez00_3196)));
		}
	}



/* coerce!-default3390 */
	BgL_nodez00_bglt
		BGl_coercez12zd2default3390zc0zzcoerce_coercez00(BgL_nodez00_bglt
		BgL_nodez00_7, obj_t BgL_callerz00_8, BgL_typez00_bglt BgL_toz00_9,
		bool_t BgL_safez00_10)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			return
				(BgL_nodez00_bglt) (BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
					BGl_string3849z00zzcoerce_coercez00, (obj_t) (BgL_nodez00_7)));
		}
	}



/* _coerce!-default3390 */
	obj_t BGl__coercez12zd2default3390zc0zzcoerce_coercez00(obj_t BgL_envz00_3197,
		obj_t BgL_nodez00_3198, obj_t BgL_callerz00_3199, obj_t BgL_toz00_3200,
		obj_t BgL_safez00_3201)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			return
				(obj_t) (BGl_coercez12zd2default3390zc0zzcoerce_coercez00(
					(BgL_nodez00_bglt) (BgL_nodez00_3198), BgL_callerz00_3199,
					(BgL_typez00_bglt) (BgL_toz00_3200), CBOOL(BgL_safez00_3201)));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_atomz00zzast_nodez00,
				BGl_proc3850z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_kwotez00zzast_nodez00,
				BGl_proc3851z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_varz00zzast_nodez00,
				BGl_proc3852z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_closurez00zzast_nodez00,
				BGl_proc3853z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_sequencez00zzast_nodez00,
				BGl_proc3854z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_externz00zzast_nodez00,
				BGl_proc3855z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_getfieldz00zzast_nodez00,
				BGl_proc3856z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_setfieldz00zzast_nodez00,
				BGl_proc3857z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_newz00zzast_nodez00,
				BGl_proc3858z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vallocz00zzast_nodez00,
				BGl_proc3859z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vrefz00zzast_nodez00,
				BGl_proc3860z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vsetz12z12zzast_nodez00,
				BGl_proc3861z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_vlengthz00zzast_nodez00,
				BGl_proc3862z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_castz00zzast_nodez00,
				BGl_proc3863z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_setqz00zzast_nodez00,
				BGl_proc3864z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3865z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_failz00zzast_nodez00,
				BGl_proc3866z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00, BGl_selectz00zzast_nodez00,
				BGl_proc3867z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3868z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3869z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3870z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3871z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3872z00zzcoerce_coercez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3873z00zzcoerce_coercez00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3874z00zzcoerce_coercez00);
		}
	}



/* coerce!-box-set!3445 */
	obj_t BGl_coercez12zd2boxzd2setz123445z00zzcoerce_coercez00(obj_t
		BgL_envz00_3227, obj_t BgL_nodez00_3228, obj_t BgL_callerz00_3229,
		obj_t BgL_toz00_3230, obj_t BgL_safez00_3231)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 431 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1758;

				obj_t BgL_callerz00_1759;

				obj_t BgL_toz00_1760;

				obj_t BgL_safez00_1761;

				{	/* Coerce/coerce.scm 432 */
					BgL_nodez00_bglt BgL_auxz00_3516;

					BgL_nodez00_1758 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_3228);
					BgL_callerz00_1759 = BgL_callerz00_3229;
					BgL_toz00_1760 = BgL_toz00_3230;
					BgL_safez00_1761 = BgL_safez00_3231;
					{	/* Coerce/coerce.scm 433 */
						BgL_variablez00_bglt BgL_arg3729z00_1765;

						{	/* Coerce/coerce.scm 433 */
							BgL_varz00_bglt BgL_obj2232z00_3153;

							BgL_obj2232z00_3153 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1758))->
								BgL_varz00);
							BgL_arg3729z00_1765 =
								(((BgL_varz00_bglt) CREF(BgL_obj2232z00_3153))->
								BgL_variablez00);
						}
						{
							BgL_typez00_bglt BgL_auxz00_3519;

							BgL_auxz00_3519 =
								(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
							((((BgL_variablez00_bglt) CREF(BgL_arg3729z00_1765))->
									BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_3519), BUNSPEC);
						}
					}
					{	/* Coerce/coerce.scm 434 */
						BgL_nodez00_bglt BgL_arg3731z00_1767;

						{	/* Coerce/coerce.scm 434 */
							BgL_nodez00_bglt BgL_arg3732z00_1768;

							BgL_arg3732z00_1768 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1758))->
								BgL_valuez00);
							{	/* Coerce/coerce.scm 434 */
								BgL_nodez00_bglt BgL_res3846z00_3186;

								{	/* Coerce/coerce.scm 434 */
									BgL_typez00_bglt BgL_toz00_3159;

									bool_t BgL_safez00_3160;

									BgL_toz00_3159 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_3160 = CBOOL(BgL_safez00_1761);
									{	/* Coerce/coerce.scm 434 */
										obj_t BgL_method3391z00_3161;

										{	/* Coerce/coerce.scm 434 */
											BgL_objectz00_bglt BgL_objz00_3162;

											BgL_objz00_3162 =
												(BgL_objectz00_bglt) (BgL_arg3732z00_1768);
											{	/* Coerce/coerce.scm 434 */
												long BgL_objzd2classzd2numz00_3163;

												BgL_objzd2classzd2numz00_3163 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3162);
												{	/* Coerce/coerce.scm 434 */
													obj_t BgL_arg2334z00_3164;

													BgL_arg2334z00_3164 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 434 */
														obj_t BgL_arrayz00_3166;

														int BgL_offsetz00_3167;

														BgL_arrayz00_3166 = BgL_arg2334z00_3164;
														BgL_offsetz00_3167 =
															(int) (BgL_objzd2classzd2numz00_3163);
														{	/* Coerce/coerce.scm 434 */
															long BgL_offsetz00_3168;

															BgL_offsetz00_3168 =
																((long) (BgL_offsetz00_3167) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 434 */
																long BgL_modz00_3169;

																{	/* Coerce/coerce.scm 434 */
																	int BgL_arg2336z00_3170;

																	BgL_arg2336z00_3170 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 434 */
																		long BgL_auxz00_3533;

																		BgL_auxz00_3533 =
																			(long) (BgL_arg2336z00_3170);
																		BgL_modz00_3169 =
																			(BgL_offsetz00_3168 / BgL_auxz00_3533);
																}}
																{	/* Coerce/coerce.scm 434 */
																	long BgL_restz00_3171;

																	{	/* Coerce/coerce.scm 434 */
																		int BgL_arg2335z00_3172;

																		BgL_arg2335z00_3172 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 434 */
																			long BgL_auxz00_3537;

																			BgL_auxz00_3537 =
																				(long) (BgL_arg2335z00_3172);
																			BgL_restz00_3171 =
																				(BgL_offsetz00_3168 % BgL_auxz00_3537);
																	}}
																	{	/* Coerce/coerce.scm 434 */

																		BgL_method3391z00_3161 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3166,
																				(int) (BgL_modz00_3169)),
																			(int) (BgL_restz00_3171));
										}}}}}}}}
										BgL_res3846z00_3186 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_3161) (BgL_method3391z00_3161,
												(obj_t) (BgL_arg3732z00_1768), BgL_callerz00_1759,
												(obj_t) (BgL_toz00_3159), BBOOL(BgL_safez00_3160),
												BEOA));
								}}
								BgL_arg3731z00_1767 = BgL_res3846z00_3186;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1758))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3731z00_1767), BUNSPEC);
					}
					BgL_auxz00_3516 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1758),
						(BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1760), CBOOL(BgL_safez00_1761));
					return (obj_t) (BgL_auxz00_3516);
				}
			}
		}
	}



/* coerce!-box-ref3443 */
	obj_t BGl_coercez12zd2boxzd2ref3443z12zzcoerce_coercez00(obj_t
		BgL_envz00_3232, obj_t BgL_nodez00_3233, obj_t BgL_callerz00_3234,
		obj_t BgL_toz00_3235, obj_t BgL_safez00_3236)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 424 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1749;

				obj_t BgL_callerz00_1750;

				obj_t BgL_toz00_1751;

				obj_t BgL_safez00_1752;

				{	/* Coerce/coerce.scm 426 */
					BgL_nodez00_bglt BgL_auxz00_3558;

					BgL_nodez00_1749 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_3233);
					BgL_callerz00_1750 = BgL_callerz00_3234;
					BgL_toz00_1751 = BgL_toz00_3235;
					BgL_safez00_1752 = BgL_safez00_3236;
					BgL_auxz00_3558 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1749),
						(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1751), CBOOL(BgL_safez00_1752));
					return (obj_t) (BgL_auxz00_3558);
				}
			}
		}
	}



/* coerce!-make-box3441 */
	obj_t BGl_coercez12zd2makezd2box3441z12zzcoerce_coercez00(obj_t
		BgL_envz00_3237, obj_t BgL_nodez00_3238, obj_t BgL_callerz00_3239,
		obj_t BgL_toz00_3240, obj_t BgL_safez00_3241)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 416 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1738;

				obj_t BgL_callerz00_1739;

				obj_t BgL_toz00_1740;

				obj_t BgL_safez00_1741;

				{	/* Coerce/coerce.scm 417 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_3566;

					BgL_nodez00_1738 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_3238);
					BgL_callerz00_1739 = BgL_callerz00_3239;
					BgL_toz00_1740 = BgL_toz00_3240;
					BgL_safez00_1741 = BgL_safez00_3241;
					{	/* Coerce/coerce.scm 417 */
						BgL_nodez00_bglt BgL_arg3725z00_3117;

						{	/* Coerce/coerce.scm 417 */
							BgL_nodez00_bglt BgL_arg3726z00_3118;

							BgL_arg3726z00_3118 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1738))->
								BgL_valuez00);
							{	/* Coerce/coerce.scm 417 */
								BgL_nodez00_bglt BgL_res3843z00_3149;

								{	/* Coerce/coerce.scm 417 */
									BgL_typez00_bglt BgL_toz00_3122;

									bool_t BgL_safez00_3123;

									BgL_toz00_3122 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_3123 = CBOOL(BgL_safez00_1741);
									{	/* Coerce/coerce.scm 417 */
										obj_t BgL_method3391z00_3124;

										{	/* Coerce/coerce.scm 417 */
											BgL_objectz00_bglt BgL_objz00_3125;

											BgL_objz00_3125 =
												(BgL_objectz00_bglt) (BgL_arg3726z00_3118);
											{	/* Coerce/coerce.scm 417 */
												long BgL_objzd2classzd2numz00_3126;

												BgL_objzd2classzd2numz00_3126 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3125);
												{	/* Coerce/coerce.scm 417 */
													obj_t BgL_arg2334z00_3127;

													BgL_arg2334z00_3127 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 417 */
														obj_t BgL_arrayz00_3129;

														int BgL_offsetz00_3130;

														BgL_arrayz00_3129 = BgL_arg2334z00_3127;
														BgL_offsetz00_3130 =
															(int) (BgL_objzd2classzd2numz00_3126);
														{	/* Coerce/coerce.scm 417 */
															long BgL_offsetz00_3131;

															BgL_offsetz00_3131 =
																((long) (BgL_offsetz00_3130) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 417 */
																long BgL_modz00_3132;

																{	/* Coerce/coerce.scm 417 */
																	int BgL_arg2336z00_3133;

																	BgL_arg2336z00_3133 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 417 */
																		long BgL_auxz00_3578;

																		BgL_auxz00_3578 =
																			(long) (BgL_arg2336z00_3133);
																		BgL_modz00_3132 =
																			(BgL_offsetz00_3131 / BgL_auxz00_3578);
																}}
																{	/* Coerce/coerce.scm 417 */
																	long BgL_restz00_3134;

																	{	/* Coerce/coerce.scm 417 */
																		int BgL_arg2335z00_3135;

																		BgL_arg2335z00_3135 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 417 */
																			long BgL_auxz00_3582;

																			BgL_auxz00_3582 =
																				(long) (BgL_arg2335z00_3135);
																			BgL_restz00_3134 =
																				(BgL_offsetz00_3131 % BgL_auxz00_3582);
																	}}
																	{	/* Coerce/coerce.scm 417 */

																		BgL_method3391z00_3124 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3129,
																				(int) (BgL_modz00_3132)),
																			(int) (BgL_restz00_3134));
										}}}}}}}}
										BgL_res3843z00_3149 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_3124) (BgL_method3391z00_3124,
												(obj_t) (BgL_arg3726z00_3118), BgL_callerz00_1739,
												(obj_t) (BgL_toz00_3122), BBOOL(BgL_safez00_3123),
												BEOA));
								}}
								BgL_arg3725z00_3117 = BgL_res3843z00_3149;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1738))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3725z00_3117), BUNSPEC);
					}
					BgL_auxz00_3566 = BgL_nodez00_1738;
					return (obj_t) (BgL_auxz00_3566);
				}
			}
		}
	}



/* coerce!-jump-ex-it3439 */
	obj_t BGl_coercez12zd2jumpzd2exzd2it3439zc0zzcoerce_coercez00(obj_t
		BgL_envz00_3242, obj_t BgL_nodez00_3243, obj_t BgL_callerz00_3244,
		obj_t BgL_toz00_3245, obj_t BgL_safez00_3246)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 407 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1725;

				obj_t BgL_callerz00_1726;

				obj_t BgL_toz00_1727;

				obj_t BgL_safez00_1728;

				{	/* Coerce/coerce.scm 408 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_3598;

					BgL_nodez00_1725 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3243);
					BgL_callerz00_1726 = BgL_callerz00_3244;
					BgL_toz00_1727 = BgL_toz00_3245;
					BgL_safez00_1728 = BgL_safez00_3246;
					{	/* Coerce/coerce.scm 409 */
						BgL_nodez00_bglt BgL_arg3719z00_1732;

						{	/* Coerce/coerce.scm 409 */
							BgL_nodez00_bglt BgL_arg3720z00_1733;

							BgL_arg3720z00_1733 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1725))->
								BgL_exitz00);
							{	/* Coerce/coerce.scm 409 */
								BgL_nodez00_bglt BgL_res3837z00_3080;

								{	/* Coerce/coerce.scm 409 */
									BgL_typez00_bglt BgL_toz00_3053;

									bool_t BgL_safez00_3054;

									BgL_toz00_3053 =
										(BgL_typez00_bglt) (BGl_za2exitza2z00zztype_cachez00);
									BgL_safez00_3054 = CBOOL(BgL_safez00_1728);
									{	/* Coerce/coerce.scm 409 */
										obj_t BgL_method3391z00_3055;

										{	/* Coerce/coerce.scm 409 */
											BgL_objectz00_bglt BgL_objz00_3056;

											BgL_objz00_3056 =
												(BgL_objectz00_bglt) (BgL_arg3720z00_1733);
											{	/* Coerce/coerce.scm 409 */
												long BgL_objzd2classzd2numz00_3057;

												BgL_objzd2classzd2numz00_3057 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3056);
												{	/* Coerce/coerce.scm 409 */
													obj_t BgL_arg2334z00_3058;

													BgL_arg2334z00_3058 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 409 */
														obj_t BgL_arrayz00_3060;

														int BgL_offsetz00_3061;

														BgL_arrayz00_3060 = BgL_arg2334z00_3058;
														BgL_offsetz00_3061 =
															(int) (BgL_objzd2classzd2numz00_3057);
														{	/* Coerce/coerce.scm 409 */
															long BgL_offsetz00_3062;

															BgL_offsetz00_3062 =
																((long) (BgL_offsetz00_3061) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 409 */
																long BgL_modz00_3063;

																{	/* Coerce/coerce.scm 409 */
																	int BgL_arg2336z00_3064;

																	BgL_arg2336z00_3064 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 409 */
																		long BgL_auxz00_3610;

																		BgL_auxz00_3610 =
																			(long) (BgL_arg2336z00_3064);
																		BgL_modz00_3063 =
																			(BgL_offsetz00_3062 / BgL_auxz00_3610);
																}}
																{	/* Coerce/coerce.scm 409 */
																	long BgL_restz00_3065;

																	{	/* Coerce/coerce.scm 409 */
																		int BgL_arg2335z00_3066;

																		BgL_arg2335z00_3066 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 409 */
																			long BgL_auxz00_3614;

																			BgL_auxz00_3614 =
																				(long) (BgL_arg2335z00_3066);
																			BgL_restz00_3065 =
																				(BgL_offsetz00_3062 % BgL_auxz00_3614);
																	}}
																	{	/* Coerce/coerce.scm 409 */

																		BgL_method3391z00_3055 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3060,
																				(int) (BgL_modz00_3063)),
																			(int) (BgL_restz00_3065));
										}}}}}}}}
										BgL_res3837z00_3080 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_3055) (BgL_method3391z00_3055,
												(obj_t) (BgL_arg3720z00_1733), BgL_callerz00_1726,
												(obj_t) (BgL_toz00_3053), BBOOL(BgL_safez00_3054),
												BEOA));
								}}
								BgL_arg3719z00_1732 = BgL_res3837z00_3080;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1725))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3719z00_1732), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 410 */
						BgL_nodez00_bglt BgL_arg3721z00_1734;

						{	/* Coerce/coerce.scm 410 */
							BgL_nodez00_bglt BgL_arg3722z00_1735;

							BgL_arg3722z00_1735 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1725))->
								BgL_valuez00);
							{	/* Coerce/coerce.scm 410 */
								BgL_nodez00_bglt BgL_res3840z00_3113;

								{	/* Coerce/coerce.scm 410 */
									BgL_typez00_bglt BgL_toz00_3086;

									bool_t BgL_safez00_3087;

									BgL_toz00_3086 = (BgL_typez00_bglt) (BgL_toz00_1727);
									BgL_safez00_3087 = CBOOL(BgL_safez00_1728);
									{	/* Coerce/coerce.scm 410 */
										obj_t BgL_method3391z00_3088;

										{	/* Coerce/coerce.scm 410 */
											BgL_objectz00_bglt BgL_objz00_3089;

											BgL_objz00_3089 =
												(BgL_objectz00_bglt) (BgL_arg3722z00_1735);
											{	/* Coerce/coerce.scm 410 */
												long BgL_objzd2classzd2numz00_3090;

												BgL_objzd2classzd2numz00_3090 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3089);
												{	/* Coerce/coerce.scm 410 */
													obj_t BgL_arg2334z00_3091;

													BgL_arg2334z00_3091 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 410 */
														obj_t BgL_arrayz00_3093;

														int BgL_offsetz00_3094;

														BgL_arrayz00_3093 = BgL_arg2334z00_3091;
														BgL_offsetz00_3094 =
															(int) (BgL_objzd2classzd2numz00_3090);
														{	/* Coerce/coerce.scm 410 */
															long BgL_offsetz00_3095;

															BgL_offsetz00_3095 =
																((long) (BgL_offsetz00_3094) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 410 */
																long BgL_modz00_3096;

																{	/* Coerce/coerce.scm 410 */
																	int BgL_arg2336z00_3097;

																	BgL_arg2336z00_3097 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 410 */
																		long BgL_auxz00_3639;

																		BgL_auxz00_3639 =
																			(long) (BgL_arg2336z00_3097);
																		BgL_modz00_3096 =
																			(BgL_offsetz00_3095 / BgL_auxz00_3639);
																}}
																{	/* Coerce/coerce.scm 410 */
																	long BgL_restz00_3098;

																	{	/* Coerce/coerce.scm 410 */
																		int BgL_arg2335z00_3099;

																		BgL_arg2335z00_3099 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 410 */
																			long BgL_auxz00_3643;

																			BgL_auxz00_3643 =
																				(long) (BgL_arg2335z00_3099);
																			BgL_restz00_3098 =
																				(BgL_offsetz00_3095 % BgL_auxz00_3643);
																	}}
																	{	/* Coerce/coerce.scm 410 */

																		BgL_method3391z00_3088 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3093,
																				(int) (BgL_modz00_3096)),
																			(int) (BgL_restz00_3098));
										}}}}}}}}
										BgL_res3840z00_3113 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_3088) (BgL_method3391z00_3088,
												(obj_t) (BgL_arg3722z00_1735), BgL_callerz00_1726,
												(obj_t) (BgL_toz00_3086), BBOOL(BgL_safez00_3087),
												BEOA));
								}}
								BgL_arg3721z00_1734 = BgL_res3840z00_3113;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1725))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3721z00_1734), BUNSPEC);
					}
					BgL_auxz00_3598 = BgL_nodez00_1725;
					return (obj_t) (BgL_auxz00_3598);
				}
			}
		}
	}



/* coerce!-set-ex-it3437 */
	obj_t BGl_coercez12zd2setzd2exzd2it3437zc0zzcoerce_coercez00(obj_t
		BgL_envz00_3247, obj_t BgL_nodez00_3248, obj_t BgL_callerz00_3249,
		obj_t BgL_toz00_3250, obj_t BgL_safez00_3251)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 397 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1709;

				obj_t BgL_callerz00_1710;

				obj_t BgL_toz00_1711;

				obj_t BgL_safez00_1712;

				{	/* Coerce/coerce.scm 398 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_3659;

					BgL_nodez00_1709 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3248);
					BgL_callerz00_1710 = BgL_callerz00_3249;
					BgL_toz00_1711 = BgL_toz00_3250;
					BgL_safez00_1712 = BgL_safez00_3251;
					{	/* Coerce/coerce.scm 399 */
						BgL_nodez00_bglt BgL_arg3711z00_1716;

						{	/* Coerce/coerce.scm 399 */
							BgL_varz00_bglt BgL_arg3712z00_1717;

							BgL_arg3712z00_1717 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1709))->
								BgL_varz00);
							{	/* Coerce/coerce.scm 399 */
								BgL_nodez00_bglt BgL_res3831z00_3012;

								{	/* Coerce/coerce.scm 399 */
									BgL_nodez00_bglt BgL_nodez00_2983;

									BgL_typez00_bglt BgL_toz00_2985;

									bool_t BgL_safez00_2986;

									BgL_nodez00_2983 = (BgL_nodez00_bglt) (BgL_arg3712z00_1717);
									BgL_toz00_2985 =
										(BgL_typez00_bglt) (BGl_za2exitza2z00zztype_cachez00);
									BgL_safez00_2986 = CBOOL(BgL_safez00_1712);
									{	/* Coerce/coerce.scm 399 */
										obj_t BgL_method3391z00_2987;

										{	/* Coerce/coerce.scm 399 */
											BgL_objectz00_bglt BgL_objz00_2988;

											BgL_objz00_2988 = (BgL_objectz00_bglt) (BgL_nodez00_2983);
											{	/* Coerce/coerce.scm 399 */
												long BgL_objzd2classzd2numz00_2989;

												BgL_objzd2classzd2numz00_2989 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2988);
												{	/* Coerce/coerce.scm 399 */
													obj_t BgL_arg2334z00_2990;

													BgL_arg2334z00_2990 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 399 */
														obj_t BgL_arrayz00_2992;

														int BgL_offsetz00_2993;

														BgL_arrayz00_2992 = BgL_arg2334z00_2990;
														BgL_offsetz00_2993 =
															(int) (BgL_objzd2classzd2numz00_2989);
														{	/* Coerce/coerce.scm 399 */
															long BgL_offsetz00_2994;

															BgL_offsetz00_2994 =
																((long) (BgL_offsetz00_2993) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 399 */
																long BgL_modz00_2995;

																{	/* Coerce/coerce.scm 399 */
																	int BgL_arg2336z00_2996;

																	BgL_arg2336z00_2996 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 399 */
																		long BgL_auxz00_3672;

																		BgL_auxz00_3672 =
																			(long) (BgL_arg2336z00_2996);
																		BgL_modz00_2995 =
																			(BgL_offsetz00_2994 / BgL_auxz00_3672);
																}}
																{	/* Coerce/coerce.scm 399 */
																	long BgL_restz00_2997;

																	{	/* Coerce/coerce.scm 399 */
																		int BgL_arg2335z00_2998;

																		BgL_arg2335z00_2998 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 399 */
																			long BgL_auxz00_3676;

																			BgL_auxz00_3676 =
																				(long) (BgL_arg2335z00_2998);
																			BgL_restz00_2997 =
																				(BgL_offsetz00_2994 % BgL_auxz00_3676);
																	}}
																	{	/* Coerce/coerce.scm 399 */

																		BgL_method3391z00_2987 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2992,
																				(int) (BgL_modz00_2995)),
																			(int) (BgL_restz00_2997));
										}}}}}}}}
										BgL_res3831z00_3012 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2987) (BgL_method3391z00_2987,
												(obj_t) (BgL_nodez00_2983), BgL_callerz00_1710,
												(obj_t) (BgL_toz00_2985), BBOOL(BgL_safez00_2986),
												BEOA));
								}}
								BgL_arg3711z00_1716 = BgL_res3831z00_3012;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3689;

							BgL_auxz00_3689 = (BgL_varz00_bglt) (BgL_arg3711z00_1716);
							((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1709))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_3689), BUNSPEC);
					}}
					{	/* Coerce/coerce.scm 400 */
						BgL_variablez00_bglt BgL_arg3714z00_1719;

						{	/* Coerce/coerce.scm 400 */
							BgL_varz00_bglt BgL_obj2232z00_3016;

							BgL_obj2232z00_3016 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1709))->
								BgL_varz00);
							BgL_arg3714z00_1719 =
								(((BgL_varz00_bglt) CREF(BgL_obj2232z00_3016))->
								BgL_variablez00);
						}
						BGl_pvariablezd2protozd2zzcoerce_pprotoz00(((long) 3),
							BgL_arg3714z00_1719);
					}
					{	/* Coerce/coerce.scm 401 */
						BgL_nodez00_bglt BgL_arg3716z00_1721;

						{	/* Coerce/coerce.scm 401 */
							BgL_nodez00_bglt BgL_arg3717z00_1722;

							BgL_arg3717z00_1722 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1709))->
								BgL_bodyz00);
							{	/* Coerce/coerce.scm 401 */
								BgL_nodez00_bglt BgL_res3834z00_3047;

								{	/* Coerce/coerce.scm 401 */
									BgL_typez00_bglt BgL_toz00_3020;

									bool_t BgL_safez00_3021;

									BgL_toz00_3020 = (BgL_typez00_bglt) (BgL_toz00_1711);
									BgL_safez00_3021 = CBOOL(BgL_safez00_1712);
									{	/* Coerce/coerce.scm 401 */
										obj_t BgL_method3391z00_3022;

										{	/* Coerce/coerce.scm 401 */
											BgL_objectz00_bglt BgL_objz00_3023;

											BgL_objz00_3023 =
												(BgL_objectz00_bglt) (BgL_arg3717z00_1722);
											{	/* Coerce/coerce.scm 401 */
												long BgL_objzd2classzd2numz00_3024;

												BgL_objzd2classzd2numz00_3024 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3023);
												{	/* Coerce/coerce.scm 401 */
													obj_t BgL_arg2334z00_3025;

													BgL_arg2334z00_3025 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 401 */
														obj_t BgL_arrayz00_3027;

														int BgL_offsetz00_3028;

														BgL_arrayz00_3027 = BgL_arg2334z00_3025;
														BgL_offsetz00_3028 =
															(int) (BgL_objzd2classzd2numz00_3024);
														{	/* Coerce/coerce.scm 401 */
															long BgL_offsetz00_3029;

															BgL_offsetz00_3029 =
																((long) (BgL_offsetz00_3028) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 401 */
																long BgL_modz00_3030;

																{	/* Coerce/coerce.scm 401 */
																	int BgL_arg2336z00_3031;

																	BgL_arg2336z00_3031 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 401 */
																		long BgL_auxz00_3706;

																		BgL_auxz00_3706 =
																			(long) (BgL_arg2336z00_3031);
																		BgL_modz00_3030 =
																			(BgL_offsetz00_3029 / BgL_auxz00_3706);
																}}
																{	/* Coerce/coerce.scm 401 */
																	long BgL_restz00_3032;

																	{	/* Coerce/coerce.scm 401 */
																		int BgL_arg2335z00_3033;

																		BgL_arg2335z00_3033 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 401 */
																			long BgL_auxz00_3710;

																			BgL_auxz00_3710 =
																				(long) (BgL_arg2335z00_3033);
																			BgL_restz00_3032 =
																				(BgL_offsetz00_3029 % BgL_auxz00_3710);
																	}}
																	{	/* Coerce/coerce.scm 401 */

																		BgL_method3391z00_3022 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3027,
																				(int) (BgL_modz00_3030)),
																			(int) (BgL_restz00_3032));
										}}}}}}}}
										BgL_res3834z00_3047 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_3022) (BgL_method3391z00_3022,
												(obj_t) (BgL_arg3717z00_1722), BgL_callerz00_1710,
												(obj_t) (BgL_toz00_3020), BBOOL(BgL_safez00_3021),
												BEOA));
								}}
								BgL_arg3716z00_1721 = BgL_res3834z00_3047;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1709))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3716z00_1721), BUNSPEC);
					}
					BgL_auxz00_3659 = BgL_nodez00_1709;
					return (obj_t) (BgL_auxz00_3659);
				}
			}
		}
	}



/* coerce!-let-var3435 */
	obj_t BGl_coercez12zd2letzd2var3435z12zzcoerce_coercez00(obj_t
		BgL_envz00_3252, obj_t BgL_nodez00_3253, obj_t BgL_callerz00_3254,
		obj_t BgL_toz00_3255, obj_t BgL_safez00_3256)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 378 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1686;

				obj_t BgL_callerz00_1687;

				obj_t BgL_toz00_1688;

				obj_t BgL_safez00_1689;

				{	/* Tools/trace.sch 53 */
					BgL_letzd2varzd2_bglt BgL_auxz00_3726;

					BgL_nodez00_1686 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3253);
					BgL_callerz00_1687 = BgL_callerz00_3254;
					BgL_toz00_1688 = BgL_toz00_3255;
					BgL_safez00_1689 = BgL_safez00_3256;
					BGl_inczd2ppmargez12zc0zzcoerce_pprotoz00();
					{	/* Coerce/coerce.scm 383 */
						obj_t BgL_g3389z00_1693;

						BgL_g3389z00_1693 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1686))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3387z00_1694;

							BgL_l3387z00_1694 = BgL_g3389z00_1693;
						BgL_forzd2each3388zd2_1695:
							if (PAIRP(BgL_l3387z00_1694))
								{	/* Coerce/coerce.scm 383 */
									{	/* Coerce/coerce.scm 388 */
										obj_t BgL_bindingz00_1697;

										BgL_bindingz00_1697 = CAR(BgL_l3387z00_1694);
										{	/* Coerce/coerce.scm 384 */
											obj_t BgL_arg3702z00_1699;

											BgL_arg3702z00_1699 = CAR(BgL_bindingz00_1697);
											BGl_pvariablezd2protozd2zzcoerce_pprotoz00(((long) 3),
												(BgL_variablez00_bglt) (BgL_arg3702z00_1699));
										}
										{	/* Coerce/coerce.scm 385 */
											BgL_nodez00_bglt BgL_arg3703z00_1700;

											{	/* Coerce/coerce.scm 385 */
												obj_t BgL_arg3704z00_1701;

												BgL_typez00_bglt BgL_arg3705z00_1702;

												BgL_arg3704z00_1701 = CDR(BgL_bindingz00_1697);
												{	/* Coerce/coerce.scm 387 */
													BgL_variablez00_bglt BgL_obj1687z00_2915;

													{	/* Coerce/coerce.scm 387 */
														obj_t BgL_pairz00_2914;

														BgL_pairz00_2914 = BgL_bindingz00_1697;
														BgL_obj1687z00_2915 =
															(BgL_variablez00_bglt) (CAR(BgL_pairz00_2914));
													}
													BgL_arg3705z00_1702 =
														(((BgL_variablez00_bglt)
															CREF(BgL_obj1687z00_2915))->BgL_typez00);
												}
												{	/* Coerce/coerce.scm 385 */
													BgL_nodez00_bglt BgL_res3825z00_2945;

													{	/* Coerce/coerce.scm 385 */
														BgL_nodez00_bglt BgL_nodez00_2916;

														bool_t BgL_safez00_2919;

														BgL_nodez00_2916 =
															(BgL_nodez00_bglt) (BgL_arg3704z00_1701);
														BgL_safez00_2919 = CBOOL(BgL_safez00_1689);
														{	/* Coerce/coerce.scm 385 */
															obj_t BgL_method3391z00_2920;

															{	/* Coerce/coerce.scm 385 */
																BgL_objectz00_bglt BgL_objz00_2921;

																BgL_objz00_2921 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2916);
																{	/* Coerce/coerce.scm 385 */
																	long BgL_objzd2classzd2numz00_2922;

																	BgL_objzd2classzd2numz00_2922 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2921);
																	{	/* Coerce/coerce.scm 385 */
																		obj_t BgL_arg2334z00_2923;

																		BgL_arg2334z00_2923 =
																			PROCEDURE_REF
																			(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																			(int) (((long) 1)));
																		{	/* Coerce/coerce.scm 385 */
																			obj_t BgL_arrayz00_2925;

																			int BgL_offsetz00_2926;

																			BgL_arrayz00_2925 = BgL_arg2334z00_2923;
																			BgL_offsetz00_2926 =
																				(int) (BgL_objzd2classzd2numz00_2922);
																			{	/* Coerce/coerce.scm 385 */
																				long BgL_offsetz00_2927;

																				BgL_offsetz00_2927 =
																					(
																					(long) (BgL_offsetz00_2926) -
																					OBJECT_TYPE);
																				{	/* Coerce/coerce.scm 385 */
																					long BgL_modz00_2928;

																					{	/* Coerce/coerce.scm 385 */
																						int BgL_arg2336z00_2929;

																						BgL_arg2336z00_2929 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 385 */
																							long BgL_auxz00_3749;

																							BgL_auxz00_3749 =
																								(long) (BgL_arg2336z00_2929);
																							BgL_modz00_2928 =
																								(BgL_offsetz00_2927 /
																								BgL_auxz00_3749);
																					}}
																					{	/* Coerce/coerce.scm 385 */
																						long BgL_restz00_2930;

																						{	/* Coerce/coerce.scm 385 */
																							int BgL_arg2335z00_2931;

																							BgL_arg2335z00_2931 =
																								(int) (((long) 8));
																							{	/* Coerce/coerce.scm 385 */
																								long BgL_auxz00_3753;

																								BgL_auxz00_3753 =
																									(long) (BgL_arg2335z00_2931);
																								BgL_restz00_2930 =
																									(BgL_offsetz00_2927 %
																									BgL_auxz00_3753);
																						}}
																						{	/* Coerce/coerce.scm 385 */

																							BgL_method3391z00_2920 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2925,
																									(int) (BgL_modz00_2928)),
																								(int) (BgL_restz00_2930));
															}}}}}}}}
															BgL_res3825z00_2945 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3391z00_2920)
																(BgL_method3391z00_2920,
																	(obj_t) (BgL_nodez00_2916),
																	BgL_callerz00_1687,
																	(obj_t) (BgL_arg3705z00_1702),
																	BBOOL(BgL_safez00_2919), BEOA));
													}}
													BgL_arg3703z00_1700 = BgL_res3825z00_2945;
											}}
											{	/* Coerce/coerce.scm 385 */
												obj_t BgL_auxz00_3766;

												BgL_auxz00_3766 = (obj_t) (BgL_arg3703z00_1700);
												SET_CDR(BgL_bindingz00_1697, BgL_auxz00_3766);
									}}}
									{
										obj_t BgL_l3387z00_3769;

										BgL_l3387z00_3769 = CDR(BgL_l3387z00_1694);
										BgL_l3387z00_1694 = BgL_l3387z00_3769;
										goto BgL_forzd2each3388zd2_1695;
									}
								}
							else
								{	/* Coerce/coerce.scm 383 */
									((bool_t) 1);
								}
						}
					}
					{	/* Coerce/coerce.scm 390 */
						BgL_nodez00_bglt BgL_arg3708z00_1705;

						{	/* Coerce/coerce.scm 390 */
							BgL_nodez00_bglt BgL_arg3709z00_1706;

							BgL_arg3709z00_1706 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1686))->BgL_bodyz00);
							{	/* Coerce/coerce.scm 390 */
								BgL_nodez00_bglt BgL_res3828z00_2979;

								{	/* Coerce/coerce.scm 390 */
									BgL_typez00_bglt BgL_toz00_2952;

									bool_t BgL_safez00_2953;

									BgL_toz00_2952 = (BgL_typez00_bglt) (BgL_toz00_1688);
									BgL_safez00_2953 = CBOOL(BgL_safez00_1689);
									{	/* Coerce/coerce.scm 390 */
										obj_t BgL_method3391z00_2954;

										{	/* Coerce/coerce.scm 390 */
											BgL_objectz00_bglt BgL_objz00_2955;

											BgL_objz00_2955 =
												(BgL_objectz00_bglt) (BgL_arg3709z00_1706);
											{	/* Coerce/coerce.scm 390 */
												long BgL_objzd2classzd2numz00_2956;

												BgL_objzd2classzd2numz00_2956 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2955);
												{	/* Coerce/coerce.scm 390 */
													obj_t BgL_arg2334z00_2957;

													BgL_arg2334z00_2957 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 390 */
														obj_t BgL_arrayz00_2959;

														int BgL_offsetz00_2960;

														BgL_arrayz00_2959 = BgL_arg2334z00_2957;
														BgL_offsetz00_2960 =
															(int) (BgL_objzd2classzd2numz00_2956);
														{	/* Coerce/coerce.scm 390 */
															long BgL_offsetz00_2961;

															BgL_offsetz00_2961 =
																((long) (BgL_offsetz00_2960) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 390 */
																long BgL_modz00_2962;

																{	/* Coerce/coerce.scm 390 */
																	int BgL_arg2336z00_2963;

																	BgL_arg2336z00_2963 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 390 */
																		long BgL_auxz00_3782;

																		BgL_auxz00_3782 =
																			(long) (BgL_arg2336z00_2963);
																		BgL_modz00_2962 =
																			(BgL_offsetz00_2961 / BgL_auxz00_3782);
																}}
																{	/* Coerce/coerce.scm 390 */
																	long BgL_restz00_2964;

																	{	/* Coerce/coerce.scm 390 */
																		int BgL_arg2335z00_2965;

																		BgL_arg2335z00_2965 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 390 */
																			long BgL_auxz00_3786;

																			BgL_auxz00_3786 =
																				(long) (BgL_arg2335z00_2965);
																			BgL_restz00_2964 =
																				(BgL_offsetz00_2961 % BgL_auxz00_3786);
																	}}
																	{	/* Coerce/coerce.scm 390 */

																		BgL_method3391z00_2954 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2959,
																				(int) (BgL_modz00_2962)),
																			(int) (BgL_restz00_2964));
										}}}}}}}}
										BgL_res3828z00_2979 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2954) (BgL_method3391z00_2954,
												(obj_t) (BgL_arg3709z00_1706), BgL_callerz00_1687,
												(obj_t) (BgL_toz00_2952), BBOOL(BgL_safez00_2953),
												BEOA));
								}}
								BgL_arg3708z00_1705 = BgL_res3828z00_2979;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1686))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3708z00_1705), BUNSPEC);
					}
					BGl_deczd2ppmargez12zc0zzcoerce_pprotoz00();
					BgL_auxz00_3726 = BgL_nodez00_1686;
					return (obj_t) (BgL_auxz00_3726);
				}
			}
		}
	}



/* coerce!-let-fun3433 */
	obj_t BGl_coercez12zd2letzd2fun3433z12zzcoerce_coercez00(obj_t
		BgL_envz00_3257, obj_t BgL_nodez00_3258, obj_t BgL_callerz00_3259,
		obj_t BgL_toz00_3260, obj_t BgL_safez00_3261)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 367 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1668;

				obj_t BgL_callerz00_1669;

				obj_t BgL_toz00_1670;

				obj_t BgL_safez00_1671;

				{	/* Coerce/coerce.scm 368 */
					BgL_letzd2funzd2_bglt BgL_auxz00_3803;

					BgL_nodez00_1668 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3258);
					BgL_callerz00_1669 = BgL_callerz00_3259;
					BgL_toz00_1670 = BgL_toz00_3260;
					BgL_safez00_1671 = BgL_safez00_3261;
					BGl_inczd2ppmargez12zc0zzcoerce_pprotoz00();
					{	/* Coerce/coerce.scm 370 */
						obj_t BgL_g3386z00_1675;

						BgL_g3386z00_1675 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1668))->BgL_localsz00);
						{
							obj_t BgL_l3384z00_1676;

							BgL_l3384z00_1676 = BgL_g3386z00_1675;
						BgL_forzd2each3385zd2_1677:
							if (PAIRP(BgL_l3384z00_1676))
								{	/* Coerce/coerce.scm 370 */
									{	/* Coerce/coerce.scm 370 */
										obj_t BgL_fz00_1679;

										BgL_fz00_1679 = CAR(BgL_l3384z00_1676);
										{	/* Coerce/coerce.scm 370 */
											bool_t BgL_arg3695z00_1680;

											if (CBOOL(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
												{	/* Coerce/coerce.scm 370 */
													BgL_arg3695z00_1680 = ((bool_t) 0);
												}
											else
												{	/* Coerce/coerce.scm 370 */
													BgL_arg3695z00_1680 = ((bool_t) 1);
												}
											BGl_coercezd2functionz12zc0zzcoerce_coercez00(
												(BgL_variablez00_bglt) (BgL_fz00_1679),
												BgL_arg3695z00_1680);
										}
									}
									{
										obj_t BgL_l3384z00_3813;

										BgL_l3384z00_3813 = CDR(BgL_l3384z00_1676);
										BgL_l3384z00_1676 = BgL_l3384z00_3813;
										goto BgL_forzd2each3385zd2_1677;
									}
								}
							else
								{	/* Coerce/coerce.scm 370 */
									((bool_t) 1);
								}
						}
					}
					{	/* Coerce/coerce.scm 371 */
						BgL_nodez00_bglt BgL_arg3697z00_1682;

						{	/* Coerce/coerce.scm 371 */
							BgL_nodez00_bglt BgL_arg3698z00_1683;

							BgL_arg3698z00_1683 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1668))->BgL_bodyz00);
							{	/* Coerce/coerce.scm 371 */
								BgL_nodez00_bglt BgL_res3822z00_2906;

								{	/* Coerce/coerce.scm 371 */
									BgL_typez00_bglt BgL_toz00_2879;

									bool_t BgL_safez00_2880;

									BgL_toz00_2879 = (BgL_typez00_bglt) (BgL_toz00_1670);
									BgL_safez00_2880 = CBOOL(BgL_safez00_1671);
									{	/* Coerce/coerce.scm 371 */
										obj_t BgL_method3391z00_2881;

										{	/* Coerce/coerce.scm 371 */
											BgL_objectz00_bglt BgL_objz00_2882;

											BgL_objz00_2882 =
												(BgL_objectz00_bglt) (BgL_arg3698z00_1683);
											{	/* Coerce/coerce.scm 371 */
												long BgL_objzd2classzd2numz00_2883;

												BgL_objzd2classzd2numz00_2883 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2882);
												{	/* Coerce/coerce.scm 371 */
													obj_t BgL_arg2334z00_2884;

													BgL_arg2334z00_2884 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 371 */
														obj_t BgL_arrayz00_2886;

														int BgL_offsetz00_2887;

														BgL_arrayz00_2886 = BgL_arg2334z00_2884;
														BgL_offsetz00_2887 =
															(int) (BgL_objzd2classzd2numz00_2883);
														{	/* Coerce/coerce.scm 371 */
															long BgL_offsetz00_2888;

															BgL_offsetz00_2888 =
																((long) (BgL_offsetz00_2887) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 371 */
																long BgL_modz00_2889;

																{	/* Coerce/coerce.scm 371 */
																	int BgL_arg2336z00_2890;

																	BgL_arg2336z00_2890 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 371 */
																		long BgL_auxz00_3826;

																		BgL_auxz00_3826 =
																			(long) (BgL_arg2336z00_2890);
																		BgL_modz00_2889 =
																			(BgL_offsetz00_2888 / BgL_auxz00_3826);
																}}
																{	/* Coerce/coerce.scm 371 */
																	long BgL_restz00_2891;

																	{	/* Coerce/coerce.scm 371 */
																		int BgL_arg2335z00_2892;

																		BgL_arg2335z00_2892 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 371 */
																			long BgL_auxz00_3830;

																			BgL_auxz00_3830 =
																				(long) (BgL_arg2335z00_2892);
																			BgL_restz00_2891 =
																				(BgL_offsetz00_2888 % BgL_auxz00_3830);
																	}}
																	{	/* Coerce/coerce.scm 371 */

																		BgL_method3391z00_2881 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2886,
																				(int) (BgL_modz00_2889)),
																			(int) (BgL_restz00_2891));
										}}}}}}}}
										BgL_res3822z00_2906 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2881) (BgL_method3391z00_2881,
												(obj_t) (BgL_arg3698z00_1683), BgL_callerz00_1669,
												(obj_t) (BgL_toz00_2879), BBOOL(BgL_safez00_2880),
												BEOA));
								}}
								BgL_arg3697z00_1682 = BgL_res3822z00_2906;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1668))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3697z00_1682), BUNSPEC);
					}
					BGl_deczd2ppmargez12zc0zzcoerce_pprotoz00();
					BgL_auxz00_3803 = BgL_nodez00_1668;
					return (obj_t) (BgL_auxz00_3803);
				}
			}
		}
	}



/* coerce!-select3431 */
	obj_t BGl_coercez12zd2select3431zc0zzcoerce_coercez00(obj_t BgL_envz00_3262,
		obj_t BgL_nodez00_3263, obj_t BgL_callerz00_3264, obj_t BgL_toz00_3265,
		obj_t BgL_safez00_3266)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 334 */
			{
				BgL_selectz00_bglt BgL_nodez00_1641;

				obj_t BgL_callerz00_1642;

				obj_t BgL_toz00_1643;

				obj_t BgL_safez00_1644;

				BgL_nodez00_1641 = (BgL_selectz00_bglt) (BgL_nodez00_3263);
				BgL_callerz00_1642 = BgL_callerz00_3264;
				BgL_toz00_1643 = BgL_toz00_3265;
				BgL_safez00_1644 = BgL_safez00_3266;
				{
					BgL_typez00_bglt BgL_auxz00_3849;

					BgL_nodez00_bglt BgL_auxz00_3847;

					BgL_auxz00_3849 = (BgL_typez00_bglt) (BgL_toz00_1643);
					BgL_auxz00_3847 = (BgL_nodez00_bglt) (BgL_nodez00_1641);
					((((BgL_nodez00_bglt) CREF(BgL_auxz00_3847))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_auxz00_3849), BUNSPEC);
				}
				{	/* Coerce/coerce.scm 337 */
					obj_t BgL_clausesz00_1648;

					BgL_typez00_bglt BgL_testzd2typezd2_1649;

					BgL_typez00_bglt BgL_testzd2nodezd2typez00_1650;

					BgL_clausesz00_1648 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1641))->BgL_clausesz00);
					BgL_testzd2typezd2_1649 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1641))->BgL_itemzd2typezd2);
					{	/* Coerce/coerce.scm 339 */
						BgL_nodez00_bglt BgL_arg3692z00_1665;

						BgL_arg3692z00_1665 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1641))->BgL_testz00);
						BgL_testzd2nodezd2typez00_1650 =
							BGl_typeofz00zztype_typeofz00(BgL_arg3692z00_1665);
					}
					if (BGl_coercerzd2existszf3z21zztype_coercionz00
						(BgL_testzd2nodezd2typez00_1650, BgL_testzd2typezd2_1649))
						{	/* Coerce/coerce.scm 347 */
							{	/* Coerce/coerce.scm 355 */
								BgL_nodez00_bglt BgL_arg3682z00_1652;

								{	/* Coerce/coerce.scm 355 */
									BgL_nodez00_bglt BgL_arg3683z00_1653;

									BgL_arg3683z00_1653 =
										(((BgL_selectz00_bglt) CREF(BgL_nodez00_1641))->
										BgL_testz00);
									{	/* Coerce/coerce.scm 355 */
										BgL_nodez00_bglt BgL_res3813z00_2800;

										{	/* Coerce/coerce.scm 355 */
											bool_t BgL_safez00_2774;

											BgL_safez00_2774 = CBOOL(BgL_safez00_1644);
											{	/* Coerce/coerce.scm 355 */
												obj_t BgL_method3391z00_2775;

												{	/* Coerce/coerce.scm 355 */
													BgL_objectz00_bglt BgL_objz00_2776;

													BgL_objz00_2776 =
														(BgL_objectz00_bglt) (BgL_arg3683z00_1653);
													{	/* Coerce/coerce.scm 355 */
														long BgL_objzd2classzd2numz00_2777;

														BgL_objzd2classzd2numz00_2777 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_2776);
														{	/* Coerce/coerce.scm 355 */
															obj_t BgL_arg2334z00_2778;

															BgL_arg2334z00_2778 =
																PROCEDURE_REF
																(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																(int) (((long) 1)));
															{	/* Coerce/coerce.scm 355 */
																obj_t BgL_arrayz00_2780;

																int BgL_offsetz00_2781;

																BgL_arrayz00_2780 = BgL_arg2334z00_2778;
																BgL_offsetz00_2781 =
																	(int) (BgL_objzd2classzd2numz00_2777);
																{	/* Coerce/coerce.scm 355 */
																	long BgL_offsetz00_2782;

																	BgL_offsetz00_2782 =
																		((long) (BgL_offsetz00_2781) - OBJECT_TYPE);
																	{	/* Coerce/coerce.scm 355 */
																		long BgL_modz00_2783;

																		{	/* Coerce/coerce.scm 355 */
																			int BgL_arg2336z00_2784;

																			BgL_arg2336z00_2784 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 355 */
																				long BgL_auxz00_3868;

																				BgL_auxz00_3868 =
																					(long) (BgL_arg2336z00_2784);
																				BgL_modz00_2783 =
																					(BgL_offsetz00_2782 /
																					BgL_auxz00_3868);
																		}}
																		{	/* Coerce/coerce.scm 355 */
																			long BgL_restz00_2785;

																			{	/* Coerce/coerce.scm 355 */
																				int BgL_arg2335z00_2786;

																				BgL_arg2335z00_2786 =
																					(int) (((long) 8));
																				{	/* Coerce/coerce.scm 355 */
																					long BgL_auxz00_3872;

																					BgL_auxz00_3872 =
																						(long) (BgL_arg2335z00_2786);
																					BgL_restz00_2785 =
																						(BgL_offsetz00_2782 %
																						BgL_auxz00_3872);
																			}}
																			{	/* Coerce/coerce.scm 355 */

																				BgL_method3391z00_2775 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_2780,
																						(int) (BgL_modz00_2783)),
																					(int) (BgL_restz00_2785));
												}}}}}}}}
												BgL_res3813z00_2800 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3391z00_2775) (BgL_method3391z00_2775,
														(obj_t) (BgL_arg3683z00_1653), BgL_callerz00_1642,
														(obj_t) (BgL_testzd2typezd2_1649),
														BBOOL(BgL_safez00_2774), BEOA));
										}}
										BgL_arg3682z00_1652 = BgL_res3813z00_2800;
								}}
								((((BgL_selectz00_bglt) CREF(BgL_nodez00_1641))->BgL_testz00) =
									((BgL_nodez00_bglt) BgL_arg3682z00_1652), BUNSPEC);
							}
							{
								obj_t BgL_l3379z00_1654;

								BgL_l3379z00_1654 = BgL_clausesz00_1648;
							BgL_forzd2each3383zd2_1655:
								if (PAIRP(BgL_l3379z00_1654))
									{	/* Coerce/coerce.scm 356 */
										{	/* Coerce/coerce.scm 357 */
											obj_t BgL_clausez00_1657;

											BgL_clausez00_1657 = CAR(BgL_l3379z00_1654);
											{	/* Coerce/coerce.scm 357 */
												BgL_nodez00_bglt BgL_arg3685z00_1658;

												{	/* Coerce/coerce.scm 357 */
													obj_t BgL_arg3686z00_1659;

													BgL_arg3686z00_1659 = CDR(BgL_clausez00_1657);
													{	/* Coerce/coerce.scm 357 */
														BgL_nodez00_bglt BgL_res3816z00_2835;

														{	/* Coerce/coerce.scm 357 */
															BgL_nodez00_bglt BgL_nodez00_2806;

															BgL_typez00_bglt BgL_toz00_2808;

															bool_t BgL_safez00_2809;

															BgL_nodez00_2806 =
																(BgL_nodez00_bglt) (BgL_arg3686z00_1659);
															BgL_toz00_2808 =
																(BgL_typez00_bglt) (BgL_toz00_1643);
															BgL_safez00_2809 = CBOOL(BgL_safez00_1644);
															{	/* Coerce/coerce.scm 357 */
																obj_t BgL_method3391z00_2810;

																{	/* Coerce/coerce.scm 357 */
																	BgL_objectz00_bglt BgL_objz00_2811;

																	BgL_objz00_2811 =
																		(BgL_objectz00_bglt) (BgL_nodez00_2806);
																	{	/* Coerce/coerce.scm 357 */
																		long BgL_objzd2classzd2numz00_2812;

																		BgL_objzd2classzd2numz00_2812 =
																			BGL_OBJECT_CLASS_NUM(BgL_objz00_2811);
																		{	/* Coerce/coerce.scm 357 */
																			obj_t BgL_arg2334z00_2813;

																			BgL_arg2334z00_2813 =
																				PROCEDURE_REF
																				(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																				(int) (((long) 1)));
																			{	/* Coerce/coerce.scm 357 */
																				obj_t BgL_arrayz00_2815;

																				int BgL_offsetz00_2816;

																				BgL_arrayz00_2815 = BgL_arg2334z00_2813;
																				BgL_offsetz00_2816 =
																					(int) (BgL_objzd2classzd2numz00_2812);
																				{	/* Coerce/coerce.scm 357 */
																					long BgL_offsetz00_2817;

																					BgL_offsetz00_2817 =
																						(
																						(long) (BgL_offsetz00_2816) -
																						OBJECT_TYPE);
																					{	/* Coerce/coerce.scm 357 */
																						long BgL_modz00_2818;

																						{	/* Coerce/coerce.scm 357 */
																							int BgL_arg2336z00_2819;

																							BgL_arg2336z00_2819 =
																								(int) (((long) 8));
																							{	/* Coerce/coerce.scm 357 */
																								long BgL_auxz00_3901;

																								BgL_auxz00_3901 =
																									(long) (BgL_arg2336z00_2819);
																								BgL_modz00_2818 =
																									(BgL_offsetz00_2817 /
																									BgL_auxz00_3901);
																						}}
																						{	/* Coerce/coerce.scm 357 */
																							long BgL_restz00_2820;

																							{	/* Coerce/coerce.scm 357 */
																								int BgL_arg2335z00_2821;

																								BgL_arg2335z00_2821 =
																									(int) (((long) 8));
																								{	/* Coerce/coerce.scm 357 */
																									long BgL_auxz00_3905;

																									BgL_auxz00_3905 =
																										(long)
																										(BgL_arg2335z00_2821);
																									BgL_restz00_2820 =
																										(BgL_offsetz00_2817 %
																										BgL_auxz00_3905);
																							}}
																							{	/* Coerce/coerce.scm 357 */

																								BgL_method3391z00_2810 =
																									VECTOR_REF(VECTOR_REF
																									(BgL_arrayz00_2815,
																										(int) (BgL_modz00_2818)),
																									(int) (BgL_restz00_2820));
																}}}}}}}}
																BgL_res3816z00_2835 =
																	(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																	(BgL_method3391z00_2810)
																	(BgL_method3391z00_2810,
																		(obj_t) (BgL_nodez00_2806),
																		BgL_callerz00_1642,
																		(obj_t) (BgL_toz00_2808),
																		BBOOL(BgL_safez00_2809), BEOA));
														}}
														BgL_arg3685z00_1658 = BgL_res3816z00_2835;
												}}
												{	/* Coerce/coerce.scm 357 */
													obj_t BgL_auxz00_3918;

													BgL_auxz00_3918 = (obj_t) (BgL_arg3685z00_1658);
													SET_CDR(BgL_clausez00_1657, BgL_auxz00_3918);
										}}}
										{
											obj_t BgL_l3379z00_3921;

											BgL_l3379z00_3921 = CDR(BgL_l3379z00_1654);
											BgL_l3379z00_1654 = BgL_l3379z00_3921;
											goto BgL_forzd2each3383zd2_1655;
										}
									}
								else
									{	/* Coerce/coerce.scm 356 */
										((bool_t) 1);
									}
							}
							return (obj_t) (BgL_nodez00_1641);
						}
					else
						{	/* Coerce/coerce.scm 348 */
							obj_t BgL_arg3688z00_1661;

							{	/* Coerce/coerce.scm 348 */
								obj_t BgL_arg3689z00_1662;

								obj_t BgL_arg3690z00_1663;

								BgL_nodez00_bglt BgL_arg3691z00_1664;

								{
									BgL_nodez00_bglt BgL_auxz00_3924;

									BgL_auxz00_3924 = (BgL_nodez00_bglt) (BgL_nodez00_1641);
									BgL_arg3689z00_1662 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_3924))->BgL_locz00);
								}
								BgL_arg3690z00_1663 =
									(((BgL_typez00_bglt) CREF(BgL_testzd2typezd2_1649))->
									BgL_idz00);
								BgL_arg3691z00_1664 =
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1641))->BgL_testz00);
								BgL_arg3688z00_1661 =
									BGl_runtimezd2typezd2errorz00zzcoerce_convertz00
									(BgL_arg3689z00_1662, BgL_arg3690z00_1663,
									(obj_t) (BgL_arg3691z00_1664));
							}
							{	/* Coerce/coerce.scm 348 */
								BgL_nodez00_bglt BgL_res3819z00_2871;

								{	/* Coerce/coerce.scm 348 */
									BgL_nodez00_bglt BgL_nodez00_2842;

									BgL_typez00_bglt BgL_toz00_2844;

									bool_t BgL_safez00_2845;

									BgL_nodez00_2842 = (BgL_nodez00_bglt) (BgL_arg3688z00_1661);
									BgL_toz00_2844 = (BgL_typez00_bglt) (BgL_toz00_1643);
									BgL_safez00_2845 = CBOOL(BgL_safez00_1644);
									{	/* Coerce/coerce.scm 348 */
										obj_t BgL_method3391z00_2846;

										{	/* Coerce/coerce.scm 348 */
											BgL_objectz00_bglt BgL_objz00_2847;

											BgL_objz00_2847 = (BgL_objectz00_bglt) (BgL_nodez00_2842);
											{	/* Coerce/coerce.scm 348 */
												long BgL_objzd2classzd2numz00_2848;

												BgL_objzd2classzd2numz00_2848 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2847);
												{	/* Coerce/coerce.scm 348 */
													obj_t BgL_arg2334z00_2849;

													BgL_arg2334z00_2849 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 348 */
														obj_t BgL_arrayz00_2851;

														int BgL_offsetz00_2852;

														BgL_arrayz00_2851 = BgL_arg2334z00_2849;
														BgL_offsetz00_2852 =
															(int) (BgL_objzd2classzd2numz00_2848);
														{	/* Coerce/coerce.scm 348 */
															long BgL_offsetz00_2853;

															BgL_offsetz00_2853 =
																((long) (BgL_offsetz00_2852) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 348 */
																long BgL_modz00_2854;

																{	/* Coerce/coerce.scm 348 */
																	int BgL_arg2336z00_2855;

																	BgL_arg2336z00_2855 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 348 */
																		long BgL_auxz00_3942;

																		BgL_auxz00_3942 =
																			(long) (BgL_arg2336z00_2855);
																		BgL_modz00_2854 =
																			(BgL_offsetz00_2853 / BgL_auxz00_3942);
																}}
																{	/* Coerce/coerce.scm 348 */
																	long BgL_restz00_2856;

																	{	/* Coerce/coerce.scm 348 */
																		int BgL_arg2335z00_2857;

																		BgL_arg2335z00_2857 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 348 */
																			long BgL_auxz00_3946;

																			BgL_auxz00_3946 =
																				(long) (BgL_arg2335z00_2857);
																			BgL_restz00_2856 =
																				(BgL_offsetz00_2853 % BgL_auxz00_3946);
																	}}
																	{	/* Coerce/coerce.scm 348 */

																		BgL_method3391z00_2846 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2851,
																				(int) (BgL_modz00_2854)),
																			(int) (BgL_restz00_2856));
										}}}}}}}}
										BgL_res3819z00_2871 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2846) (BgL_method3391z00_2846,
												(obj_t) (BgL_nodez00_2842), BgL_callerz00_1642,
												(obj_t) (BgL_toz00_2844), BBOOL(BgL_safez00_2845),
												BEOA));
								}}
								return (obj_t) (BgL_res3819z00_2871);
							}
						}
				}
			}
		}
	}



/* coerce!-fail3429 */
	obj_t BGl_coercez12zd2fail3429zc0zzcoerce_coercez00(obj_t BgL_envz00_3267,
		obj_t BgL_nodez00_3268, obj_t BgL_callerz00_3269, obj_t BgL_toz00_3270,
		obj_t BgL_safez00_3271)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 324 */
			{
				BgL_failz00_bglt BgL_nodez00_1626;

				obj_t BgL_callerz00_1627;

				obj_t BgL_toz00_1628;

				obj_t BgL_safez00_1629;

				{	/* Coerce/coerce.scm 325 */
					BgL_nodez00_bglt BgL_auxz00_3961;

					BgL_nodez00_1626 = (BgL_failz00_bglt) (BgL_nodez00_3268);
					BgL_callerz00_1627 = BgL_callerz00_3269;
					BgL_toz00_1628 = BgL_toz00_3270;
					BgL_safez00_1629 = BgL_safez00_3271;
					{	/* Coerce/coerce.scm 326 */
						BgL_nodez00_bglt BgL_arg3674z00_1633;

						{	/* Coerce/coerce.scm 326 */
							BgL_nodez00_bglt BgL_arg3675z00_1634;

							BgL_arg3675z00_1634 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1626))->BgL_procz00);
							{	/* Coerce/coerce.scm 326 */
								BgL_nodez00_bglt BgL_res3804z00_2696;

								{	/* Coerce/coerce.scm 326 */
									BgL_typez00_bglt BgL_toz00_2669;

									bool_t BgL_safez00_2670;

									BgL_toz00_2669 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_2670 = CBOOL(BgL_safez00_1629);
									{	/* Coerce/coerce.scm 326 */
										obj_t BgL_method3391z00_2671;

										{	/* Coerce/coerce.scm 326 */
											BgL_objectz00_bglt BgL_objz00_2672;

											BgL_objz00_2672 =
												(BgL_objectz00_bglt) (BgL_arg3675z00_1634);
											{	/* Coerce/coerce.scm 326 */
												long BgL_objzd2classzd2numz00_2673;

												BgL_objzd2classzd2numz00_2673 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2672);
												{	/* Coerce/coerce.scm 326 */
													obj_t BgL_arg2334z00_2674;

													BgL_arg2334z00_2674 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 326 */
														obj_t BgL_arrayz00_2676;

														int BgL_offsetz00_2677;

														BgL_arrayz00_2676 = BgL_arg2334z00_2674;
														BgL_offsetz00_2677 =
															(int) (BgL_objzd2classzd2numz00_2673);
														{	/* Coerce/coerce.scm 326 */
															long BgL_offsetz00_2678;

															BgL_offsetz00_2678 =
																((long) (BgL_offsetz00_2677) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 326 */
																long BgL_modz00_2679;

																{	/* Coerce/coerce.scm 326 */
																	int BgL_arg2336z00_2680;

																	BgL_arg2336z00_2680 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 326 */
																		long BgL_auxz00_3973;

																		BgL_auxz00_3973 =
																			(long) (BgL_arg2336z00_2680);
																		BgL_modz00_2679 =
																			(BgL_offsetz00_2678 / BgL_auxz00_3973);
																}}
																{	/* Coerce/coerce.scm 326 */
																	long BgL_restz00_2681;

																	{	/* Coerce/coerce.scm 326 */
																		int BgL_arg2335z00_2682;

																		BgL_arg2335z00_2682 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 326 */
																			long BgL_auxz00_3977;

																			BgL_auxz00_3977 =
																				(long) (BgL_arg2335z00_2682);
																			BgL_restz00_2681 =
																				(BgL_offsetz00_2678 % BgL_auxz00_3977);
																	}}
																	{	/* Coerce/coerce.scm 326 */

																		BgL_method3391z00_2671 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2676,
																				(int) (BgL_modz00_2679)),
																			(int) (BgL_restz00_2681));
										}}}}}}}}
										BgL_res3804z00_2696 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2671) (BgL_method3391z00_2671,
												(obj_t) (BgL_arg3675z00_1634), BgL_callerz00_1627,
												(obj_t) (BgL_toz00_2669), BBOOL(BgL_safez00_2670),
												BEOA));
								}}
								BgL_arg3674z00_1633 = BgL_res3804z00_2696;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1626))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3674z00_1633), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 327 */
						BgL_nodez00_bglt BgL_arg3676z00_1635;

						{	/* Coerce/coerce.scm 327 */
							BgL_nodez00_bglt BgL_arg3677z00_1636;

							BgL_arg3677z00_1636 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1626))->BgL_msgz00);
							{	/* Coerce/coerce.scm 327 */
								BgL_nodez00_bglt BgL_res3807z00_2729;

								{	/* Coerce/coerce.scm 327 */
									BgL_typez00_bglt BgL_toz00_2702;

									bool_t BgL_safez00_2703;

									BgL_toz00_2702 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_2703 = CBOOL(BgL_safez00_1629);
									{	/* Coerce/coerce.scm 327 */
										obj_t BgL_method3391z00_2704;

										{	/* Coerce/coerce.scm 327 */
											BgL_objectz00_bglt BgL_objz00_2705;

											BgL_objz00_2705 =
												(BgL_objectz00_bglt) (BgL_arg3677z00_1636);
											{	/* Coerce/coerce.scm 327 */
												long BgL_objzd2classzd2numz00_2706;

												BgL_objzd2classzd2numz00_2706 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2705);
												{	/* Coerce/coerce.scm 327 */
													obj_t BgL_arg2334z00_2707;

													BgL_arg2334z00_2707 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 327 */
														obj_t BgL_arrayz00_2709;

														int BgL_offsetz00_2710;

														BgL_arrayz00_2709 = BgL_arg2334z00_2707;
														BgL_offsetz00_2710 =
															(int) (BgL_objzd2classzd2numz00_2706);
														{	/* Coerce/coerce.scm 327 */
															long BgL_offsetz00_2711;

															BgL_offsetz00_2711 =
																((long) (BgL_offsetz00_2710) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 327 */
																long BgL_modz00_2712;

																{	/* Coerce/coerce.scm 327 */
																	int BgL_arg2336z00_2713;

																	BgL_arg2336z00_2713 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 327 */
																		long BgL_auxz00_4002;

																		BgL_auxz00_4002 =
																			(long) (BgL_arg2336z00_2713);
																		BgL_modz00_2712 =
																			(BgL_offsetz00_2711 / BgL_auxz00_4002);
																}}
																{	/* Coerce/coerce.scm 327 */
																	long BgL_restz00_2714;

																	{	/* Coerce/coerce.scm 327 */
																		int BgL_arg2335z00_2715;

																		BgL_arg2335z00_2715 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 327 */
																			long BgL_auxz00_4006;

																			BgL_auxz00_4006 =
																				(long) (BgL_arg2335z00_2715);
																			BgL_restz00_2714 =
																				(BgL_offsetz00_2711 % BgL_auxz00_4006);
																	}}
																	{	/* Coerce/coerce.scm 327 */

																		BgL_method3391z00_2704 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2709,
																				(int) (BgL_modz00_2712)),
																			(int) (BgL_restz00_2714));
										}}}}}}}}
										BgL_res3807z00_2729 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2704) (BgL_method3391z00_2704,
												(obj_t) (BgL_arg3677z00_1636), BgL_callerz00_1627,
												(obj_t) (BgL_toz00_2702), BBOOL(BgL_safez00_2703),
												BEOA));
								}}
								BgL_arg3676z00_1635 = BgL_res3807z00_2729;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1626))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3676z00_1635), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 328 */
						BgL_nodez00_bglt BgL_arg3678z00_1637;

						{	/* Coerce/coerce.scm 328 */
							BgL_nodez00_bglt BgL_arg3679z00_1638;

							BgL_arg3679z00_1638 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1626))->BgL_objz00);
							{	/* Coerce/coerce.scm 328 */
								BgL_nodez00_bglt BgL_res3810z00_2762;

								{	/* Coerce/coerce.scm 328 */
									BgL_typez00_bglt BgL_toz00_2735;

									bool_t BgL_safez00_2736;

									BgL_toz00_2735 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_2736 = CBOOL(BgL_safez00_1629);
									{	/* Coerce/coerce.scm 328 */
										obj_t BgL_method3391z00_2737;

										{	/* Coerce/coerce.scm 328 */
											BgL_objectz00_bglt BgL_objz00_2738;

											BgL_objz00_2738 =
												(BgL_objectz00_bglt) (BgL_arg3679z00_1638);
											{	/* Coerce/coerce.scm 328 */
												long BgL_objzd2classzd2numz00_2739;

												BgL_objzd2classzd2numz00_2739 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2738);
												{	/* Coerce/coerce.scm 328 */
													obj_t BgL_arg2334z00_2740;

													BgL_arg2334z00_2740 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 328 */
														obj_t BgL_arrayz00_2742;

														int BgL_offsetz00_2743;

														BgL_arrayz00_2742 = BgL_arg2334z00_2740;
														BgL_offsetz00_2743 =
															(int) (BgL_objzd2classzd2numz00_2739);
														{	/* Coerce/coerce.scm 328 */
															long BgL_offsetz00_2744;

															BgL_offsetz00_2744 =
																((long) (BgL_offsetz00_2743) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 328 */
																long BgL_modz00_2745;

																{	/* Coerce/coerce.scm 328 */
																	int BgL_arg2336z00_2746;

																	BgL_arg2336z00_2746 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 328 */
																		long BgL_auxz00_4031;

																		BgL_auxz00_4031 =
																			(long) (BgL_arg2336z00_2746);
																		BgL_modz00_2745 =
																			(BgL_offsetz00_2744 / BgL_auxz00_4031);
																}}
																{	/* Coerce/coerce.scm 328 */
																	long BgL_restz00_2747;

																	{	/* Coerce/coerce.scm 328 */
																		int BgL_arg2335z00_2748;

																		BgL_arg2335z00_2748 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 328 */
																			long BgL_auxz00_4035;

																			BgL_auxz00_4035 =
																				(long) (BgL_arg2335z00_2748);
																			BgL_restz00_2747 =
																				(BgL_offsetz00_2744 % BgL_auxz00_4035);
																	}}
																	{	/* Coerce/coerce.scm 328 */

																		BgL_method3391z00_2737 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2742,
																				(int) (BgL_modz00_2745)),
																			(int) (BgL_restz00_2747));
										}}}}}}}}
										BgL_res3810z00_2762 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2737) (BgL_method3391z00_2737,
												(obj_t) (BgL_arg3679z00_1638), BgL_callerz00_1627,
												(obj_t) (BgL_toz00_2735), BBOOL(BgL_safez00_2736),
												BEOA));
								}}
								BgL_arg3678z00_1637 = BgL_res3810z00_2762;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1626))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3678z00_1637), BUNSPEC);
					}
					BgL_auxz00_3961 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1626),
						(BgL_typez00_bglt) (BGl_za2magicza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1628), CBOOL(BgL_safez00_1629));
					return (obj_t) (BgL_auxz00_3961);
				}
			}
		}
	}



/* coerce!-conditional3427 */
	obj_t BGl_coercez12zd2conditional3427zc0zzcoerce_coercez00(obj_t
		BgL_envz00_3272, obj_t BgL_nodez00_3273, obj_t BgL_callerz00_3274,
		obj_t BgL_toz00_3275, obj_t BgL_safez00_3276)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 244 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1531;

				obj_t BgL_callerz00_1532;

				obj_t BgL_toz00_1533;

				obj_t BgL_safez00_1534;

				BgL_nodez00_1531 = (BgL_conditionalz00_bglt) (BgL_nodez00_3273);
				BgL_callerz00_1532 = BgL_callerz00_3274;
				BgL_toz00_1533 = BgL_toz00_3275;
				BgL_safez00_1534 = BgL_safez00_3276;
				{
					BgL_nodez00_bglt BgL_nodez00_1553;

					BgL_nodez00_bglt BgL_nodez00_1557;

					BgL_nodez00_bglt BgL_nodez00_1598;

					{	/* Coerce/coerce.scm 309 */
						BgL_nodez00_bglt BgL_arg3619z00_1541;

						{	/* Coerce/coerce.scm 309 */
							BgL_nodez00_bglt BgL_arg3620z00_1542;

							BgL_arg3620z00_1542 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1531))->
								BgL_testz00);
							{	/* Coerce/coerce.scm 309 */
								BgL_nodez00_bglt BgL_res3789z00_2480;

								{	/* Coerce/coerce.scm 309 */
									BgL_typez00_bglt BgL_toz00_2453;

									bool_t BgL_safez00_2454;

									BgL_toz00_2453 =
										(BgL_typez00_bglt) (BGl_za2boolza2z00zztype_cachez00);
									BgL_safez00_2454 = CBOOL(BgL_safez00_1534);
									{	/* Coerce/coerce.scm 309 */
										obj_t BgL_method3391z00_2455;

										{	/* Coerce/coerce.scm 309 */
											BgL_objectz00_bglt BgL_objz00_2456;

											BgL_objz00_2456 =
												(BgL_objectz00_bglt) (BgL_arg3620z00_1542);
											{	/* Coerce/coerce.scm 309 */
												long BgL_objzd2classzd2numz00_2457;

												BgL_objzd2classzd2numz00_2457 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2456);
												{	/* Coerce/coerce.scm 309 */
													obj_t BgL_arg2334z00_2458;

													BgL_arg2334z00_2458 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 309 */
														obj_t BgL_arrayz00_2460;

														int BgL_offsetz00_2461;

														BgL_arrayz00_2460 = BgL_arg2334z00_2458;
														BgL_offsetz00_2461 =
															(int) (BgL_objzd2classzd2numz00_2457);
														{	/* Coerce/coerce.scm 309 */
															long BgL_offsetz00_2462;

															BgL_offsetz00_2462 =
																((long) (BgL_offsetz00_2461) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 309 */
																long BgL_modz00_2463;

																{	/* Coerce/coerce.scm 309 */
																	int BgL_arg2336z00_2464;

																	BgL_arg2336z00_2464 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 309 */
																		long BgL_auxz00_4067;

																		BgL_auxz00_4067 =
																			(long) (BgL_arg2336z00_2464);
																		BgL_modz00_2463 =
																			(BgL_offsetz00_2462 / BgL_auxz00_4067);
																}}
																{	/* Coerce/coerce.scm 309 */
																	long BgL_restz00_2465;

																	{	/* Coerce/coerce.scm 309 */
																		int BgL_arg2335z00_2466;

																		BgL_arg2335z00_2466 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 309 */
																			long BgL_auxz00_4071;

																			BgL_auxz00_4071 =
																				(long) (BgL_arg2335z00_2466);
																			BgL_restz00_2465 =
																				(BgL_offsetz00_2462 % BgL_auxz00_4071);
																	}}
																	{	/* Coerce/coerce.scm 309 */

																		BgL_method3391z00_2455 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2460,
																				(int) (BgL_modz00_2463)),
																			(int) (BgL_restz00_2465));
										}}}}}}}}
										BgL_res3789z00_2480 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2455) (BgL_method3391z00_2455,
												(obj_t) (BgL_arg3620z00_1542), BgL_callerz00_1532,
												(obj_t) (BgL_toz00_2453), BBOOL(BgL_safez00_2454),
												BEOA));
								}}
								BgL_arg3619z00_1541 = BgL_res3789z00_2480;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1531))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3619z00_1541), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 310 */
						obj_t BgL_casezd2valuezd2_1543;

						{	/* Coerce/coerce.scm 310 */
							BgL_nodez00_bglt BgL_arg3629z00_1552;

							BgL_arg3629z00_1552 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1531))->
								BgL_testz00);
							BgL_nodez00_1553 = BgL_arg3629z00_1552;
							{	/* Coerce/coerce.scm 302 */
								bool_t BgL_testz00_4086;

								{	/* Coerce/coerce.scm 302 */
									obj_t BgL_obj2353z00_2618;

									BgL_obj2353z00_2618 = (obj_t) (BgL_nodez00_1553);
									BgL_testz00_4086 =
										BGl_iszd2azf3z21zz__objectz00(BgL_obj2353z00_2618,
										BGl_appz00zzast_nodez00);
								}
								if (BgL_testz00_4086)
									{	/* Coerce/coerce.scm 302 */
										BgL_nodez00_1598 = BgL_nodez00_1553;
										{	/* Coerce/coerce.scm 247 */
											bool_t BgL_testz00_4089;

											{	/* Coerce/coerce.scm 247 */
												obj_t BgL_auxz00_4090;

												{
													BgL_appz00_bglt BgL_auxz00_4091;

													BgL_auxz00_4091 =
														(BgL_appz00_bglt) (BgL_nodez00_1598);
													BgL_auxz00_4090 =
														(((BgL_appz00_bglt) CREF(BgL_auxz00_4091))->
														BgL_argsz00);
												}
												BgL_testz00_4089 = PAIRP(BgL_auxz00_4090);
											}
											if (BgL_testz00_4089)
												{	/* Coerce/coerce.scm 248 */
													bool_t BgL_testz00_4095;

													{	/* Coerce/coerce.scm 248 */
														obj_t BgL_auxz00_4096;

														{	/* Coerce/coerce.scm 248 */
															obj_t BgL_pairz00_2655;

															{
																BgL_appz00_bglt BgL_auxz00_4097;

																BgL_auxz00_4097 =
																	(BgL_appz00_bglt) (BgL_nodez00_1598);
																BgL_pairz00_2655 =
																	(((BgL_appz00_bglt) CREF(BgL_auxz00_4097))->
																	BgL_argsz00);
															}
															BgL_auxz00_4096 = CDR(BgL_pairz00_2655);
														}
														BgL_testz00_4095 = NULLP(BgL_auxz00_4096);
													}
													if (BgL_testz00_4095)
														{	/* Coerce/coerce.scm 249 */
															bool_t BgL_testz00_4102;

															{	/* Coerce/coerce.scm 249 */
																bool_t BgL_testz00_4103;

																{	/* Coerce/coerce.scm 249 */
																	obj_t BgL_arg3668z00_1616;

																	{	/* Coerce/coerce.scm 249 */
																		obj_t BgL_pairz00_2658;

																		{
																			BgL_appz00_bglt BgL_auxz00_4104;

																			BgL_auxz00_4104 =
																				(BgL_appz00_bglt) (BgL_nodez00_1598);
																			BgL_pairz00_2658 =
																				(((BgL_appz00_bglt)
																					CREF(BgL_auxz00_4104))->BgL_argsz00);
																		}
																		BgL_arg3668z00_1616 = CAR(BgL_pairz00_2658);
																	}
																	BgL_testz00_4103 =
																		BGl_sidezd2effectzf3z21zzeffect_effectz00(
																		(BgL_nodez00_bglt) (BgL_arg3668z00_1616));
																}
																if (BgL_testz00_4103)
																	{	/* Coerce/coerce.scm 249 */
																		BgL_testz00_4102 = ((bool_t) 0);
																	}
																else
																	{	/* Coerce/coerce.scm 249 */
																		BgL_testz00_4102 = ((bool_t) 1);
																	}
															}
															if (BgL_testz00_4102)
																{	/* Coerce/coerce.scm 250 */
																	BgL_varz00_bglt BgL_funz00_1604;

																	{
																		BgL_appz00_bglt BgL_auxz00_4110;

																		BgL_auxz00_4110 =
																			(BgL_appz00_bglt) (BgL_nodez00_1598);
																		BgL_funz00_1604 =
																			(((BgL_appz00_bglt)
																				CREF(BgL_auxz00_4110))->BgL_funz00);
																	}
																	{	/* Coerce/coerce.scm 250 */
																		BgL_valuez00_bglt BgL_valz00_1605;

																		{	/* Coerce/coerce.scm 251 */
																			BgL_variablez00_bglt BgL_obj1690z00_2661;

																			BgL_obj1690z00_2661 =
																				(((BgL_varz00_bglt)
																					CREF(BgL_funz00_1604))->
																				BgL_variablez00);
																			BgL_valz00_1605 =
																				(((BgL_variablez00_bglt)
																					CREF(BgL_obj1690z00_2661))->
																				BgL_valuez00);
																		}
																		{	/* Coerce/coerce.scm 251 */
																			obj_t BgL_typecz00_1606;

																			{
																				BgL_funz00_bglt BgL_auxz00_4115;

																				BgL_auxz00_4115 =
																					(BgL_funz00_bglt) (BgL_valz00_1605);
																				BgL_typecz00_1606 =
																					(((BgL_funz00_bglt)
																						CREF(BgL_auxz00_4115))->
																					BgL_predicatezd2ofzd2);
																			}
																			{	/* Coerce/coerce.scm 252 */
																				BgL_typez00_bglt BgL_typevz00_1607;

																				{	/* Coerce/coerce.scm 253 */
																					obj_t BgL_arg3664z00_1612;

																					{	/* Coerce/coerce.scm 253 */
																						obj_t BgL_pairz00_2664;

																						{
																							BgL_appz00_bglt BgL_auxz00_4118;

																							BgL_auxz00_4118 =
																								(BgL_appz00_bglt)
																								(BgL_nodez00_1598);
																							BgL_pairz00_2664 =
																								(((BgL_appz00_bglt)
																									CREF(BgL_auxz00_4118))->
																								BgL_argsz00);
																						}
																						BgL_arg3664z00_1612 =
																							CAR(BgL_pairz00_2664);
																					}
																					BgL_typevz00_1607 =
																						BGl_typeofz00zztype_typeofz00(
																						(BgL_nodez00_bglt)
																						(BgL_arg3664z00_1612));
																				}
																				{	/* Coerce/coerce.scm 253 */

																					if (BGl_iszd2azf3z21zz__objectz00
																						(BgL_typecz00_1606,
																							BGl_typez00zztype_typez00))
																						{	/* Coerce/coerce.scm 255 */
																							if (
																								((obj_t) (BgL_typevz00_1607) ==
																									BGl_za2objza2z00zztype_cachez00))
																								{	/* Coerce/coerce.scm 258 */
																									BgL_casezd2valuezd2_1543 =
																										BFALSE;
																								}
																							else
																								{	/* Coerce/coerce.scm 258 */
																									if (BGl_typezd2lesszd2specificzf3zf3zztype_miscz00((BgL_typez00_bglt) (BgL_typecz00_1606), BgL_typevz00_1607))
																										{	/* Coerce/coerce.scm 261 */
																											BgL_casezd2valuezd2_1543 =
																												CNST_TABLE_REF(((long)
																													1));
																										}
																									else
																										{	/* Coerce/coerce.scm 261 */
																											if (BGl_typezd2disjointzf3z21zztype_miscz00((BgL_typez00_bglt) (BgL_typecz00_1606), BgL_typevz00_1607))
																												{	/* Coerce/coerce.scm 263 */
																													BgL_casezd2valuezd2_1543
																														=
																														CNST_TABLE_REF((
																															(long) 2));
																												}
																											else
																												{	/* Coerce/coerce.scm 263 */
																													BgL_casezd2valuezd2_1543
																														= BFALSE;
																												}
																										}
																								}
																						}
																					else
																						{	/* Coerce/coerce.scm 255 */
																							BgL_casezd2valuezd2_1543 = BFALSE;
																						}
																				}
																			}
																		}
																	}
																}
															else
																{	/* Coerce/coerce.scm 249 */
																	BgL_casezd2valuezd2_1543 = BFALSE;
																}
														}
													else
														{	/* Coerce/coerce.scm 248 */
															BgL_casezd2valuezd2_1543 = BFALSE;
														}
												}
											else
												{	/* Coerce/coerce.scm 247 */
													BgL_casezd2valuezd2_1543 = BFALSE;
												}
										}
									}
								else
									{	/* Coerce/coerce.scm 304 */
										bool_t BgL_testz00_4137;

										{	/* Coerce/coerce.scm 304 */
											obj_t BgL_obj3170z00_2619;

											BgL_obj3170z00_2619 = (obj_t) (BgL_nodez00_1553);
											BgL_testz00_4137 =
												BGl_iszd2azf3z21zz__objectz00(BgL_obj3170z00_2619,
												BGl_letzd2varzd2zzast_nodez00);
										}
										if (BgL_testz00_4137)
											{	/* Coerce/coerce.scm 304 */
												BgL_nodez00_1557 = BgL_nodez00_1553;
												{	/* Coerce/coerce.scm 269 */
													bool_t BgL_testz00_4140;

													{	/* Coerce/coerce.scm 269 */
														obj_t BgL_auxz00_4141;

														{
															BgL_letzd2varzd2_bglt BgL_auxz00_4142;

															BgL_auxz00_4142 =
																(BgL_letzd2varzd2_bglt) (BgL_nodez00_1557);
															BgL_auxz00_4141 =
																(((BgL_letzd2varzd2_bglt)
																	CREF(BgL_auxz00_4142))->BgL_bindingsz00);
														}
														BgL_testz00_4140 = PAIRP(BgL_auxz00_4141);
													}
													if (BgL_testz00_4140)
														{	/* Coerce/coerce.scm 270 */
															bool_t BgL_testz00_4146;

															{	/* Coerce/coerce.scm 270 */
																obj_t BgL_auxz00_4147;

																{	/* Coerce/coerce.scm 270 */
																	obj_t BgL_pairz00_2623;

																	{
																		BgL_letzd2varzd2_bglt BgL_auxz00_4148;

																		BgL_auxz00_4148 =
																			(BgL_letzd2varzd2_bglt)
																			(BgL_nodez00_1557);
																		BgL_pairz00_2623 =
																			(((BgL_letzd2varzd2_bglt)
																				CREF(BgL_auxz00_4148))->
																			BgL_bindingsz00);
																	}
																	BgL_auxz00_4147 = CDR(BgL_pairz00_2623);
																}
																BgL_testz00_4146 = NULLP(BgL_auxz00_4147);
															}
															if (BgL_testz00_4146)
																{	/* Coerce/coerce.scm 271 */
																	bool_t BgL_testz00_4153;

																	{	/* Coerce/coerce.scm 271 */
																		BgL_nodez00_bglt BgL_arg3655z00_1594;

																		{
																			BgL_letzd2varzd2_bglt BgL_auxz00_4154;

																			BgL_auxz00_4154 =
																				(BgL_letzd2varzd2_bglt)
																				(BgL_nodez00_1557);
																			BgL_arg3655z00_1594 =
																				(((BgL_letzd2varzd2_bglt)
																					CREF(BgL_auxz00_4154))->BgL_bodyz00);
																		}
																		{	/* Coerce/coerce.scm 271 */
																			obj_t BgL_obj2353z00_2626;

																			BgL_obj2353z00_2626 =
																				(obj_t) (BgL_arg3655z00_1594);
																			BgL_testz00_4153 =
																				BGl_iszd2azf3z21zz__objectz00
																				(BgL_obj2353z00_2626,
																				BGl_appz00zzast_nodez00);
																		}
																	}
																	if (BgL_testz00_4153)
																		{	/* Coerce/coerce.scm 272 */
																			BgL_varz00_bglt BgL_funz00_1563;

																			{	/* Coerce/coerce.scm 272 */
																				BgL_appz00_bglt BgL_obj2326z00_2628;

																				{	/* Coerce/coerce.scm 272 */
																					BgL_letzd2varzd2_bglt
																						BgL_obj3139z00_2627;
																					BgL_obj3139z00_2627 =
																						(BgL_letzd2varzd2_bglt)
																						(BgL_nodez00_1557);
																					BgL_obj2326z00_2628 =
																						(BgL_appz00_bglt) (((
																								(BgL_letzd2varzd2_bglt)
																								CREF(BgL_obj3139z00_2627))->
																							BgL_bodyz00));
																				}
																				BgL_funz00_1563 =
																					(((BgL_appz00_bglt)
																						CREF(BgL_obj2326z00_2628))->
																					BgL_funz00);
																			}
																			{	/* Coerce/coerce.scm 272 */
																				obj_t BgL_varz00_1564;

																				{	/* Coerce/coerce.scm 273 */
																					obj_t BgL_argsz00_1585;

																					{	/* Coerce/coerce.scm 273 */
																						BgL_appz00_bglt BgL_obj2329z00_2630;

																						{	/* Coerce/coerce.scm 273 */
																							BgL_letzd2varzd2_bglt
																								BgL_obj3139z00_2629;
																							BgL_obj3139z00_2629 =
																								(BgL_letzd2varzd2_bglt)
																								(BgL_nodez00_1557);
																							BgL_obj2329z00_2630 =
																								(BgL_appz00_bglt) (((
																										(BgL_letzd2varzd2_bglt)
																										CREF(BgL_obj3139z00_2629))->
																									BgL_bodyz00));
																						}
																						BgL_argsz00_1585 =
																							(((BgL_appz00_bglt)
																								CREF(BgL_obj2329z00_2630))->
																							BgL_argsz00);
																					}
																					if (PAIRP(BgL_argsz00_1585))
																						{	/* Coerce/coerce.scm 274 */
																							if (NULLP(CDR(BgL_argsz00_1585)))
																								{	/* Coerce/coerce.scm 276 */
																									bool_t BgL_testz00_4172;

																									{	/* Coerce/coerce.scm 276 */
																										obj_t BgL_arg3651z00_1590;

																										BgL_arg3651z00_1590 =
																											CAR(BgL_argsz00_1585);
																										BgL_testz00_4172 =
																											BGl_iszd2azf3z21zz__objectz00
																											(BgL_arg3651z00_1590,
																											BGl_varz00zzast_nodez00);
																									}
																									if (BgL_testz00_4172)
																										{	/* Coerce/coerce.scm 277 */
																											BgL_varz00_bglt
																												BgL_obj2232z00_2637;
																											{	/* Coerce/coerce.scm 277 */
																												obj_t BgL_pairz00_2636;

																												BgL_pairz00_2636 =
																													BgL_argsz00_1585;
																												BgL_obj2232z00_2637 =
																													(BgL_varz00_bglt) (CAR
																													(BgL_pairz00_2636));
																											}
																											BgL_varz00_1564 =
																												(obj_t) (
																												(((BgL_varz00_bglt)
																														CREF
																														(BgL_obj2232z00_2637))->
																													BgL_variablez00));
																										}
																									else
																										{	/* Coerce/coerce.scm 276 */
																											BgL_varz00_1564 = BFALSE;
																										}
																								}
																							else
																								{	/* Coerce/coerce.scm 275 */
																									BgL_varz00_1564 = BFALSE;
																								}
																						}
																					else
																						{	/* Coerce/coerce.scm 274 */
																							BgL_varz00_1564 = BFALSE;
																						}
																				}
																				{	/* Coerce/coerce.scm 273 */
																					BgL_valuez00_bglt BgL_valz00_1565;

																					{	/* Coerce/coerce.scm 278 */
																						BgL_variablez00_bglt
																							BgL_obj1690z00_2639;
																						BgL_obj1690z00_2639 =
																							(((BgL_varz00_bglt)
																								CREF(BgL_funz00_1563))->
																							BgL_variablez00);
																						BgL_valz00_1565 =
																							(((BgL_variablez00_bglt)
																								CREF(BgL_obj1690z00_2639))->
																							BgL_valuez00);
																					}
																					{	/* Coerce/coerce.scm 278 */
																						obj_t BgL_typecz00_1566;

																						{
																							BgL_funz00_bglt BgL_auxz00_4181;

																							BgL_auxz00_4181 =
																								(BgL_funz00_bglt)
																								(BgL_valz00_1565);
																							BgL_typecz00_1566 =
																								(((BgL_funz00_bglt)
																									CREF(BgL_auxz00_4181))->
																								BgL_predicatezd2ofzd2);
																						}
																						{	/* Coerce/coerce.scm 279 */
																							BgL_typez00_bglt
																								BgL_typepz00_1567;
																							{	/* Coerce/coerce.scm 280 */
																								BgL_variablez00_bglt
																									BgL_obj1687z00_2644;
																								{	/* Coerce/coerce.scm 280 */
																									obj_t BgL_auxz00_4184;

																									{	/* Coerce/coerce.scm 280 */
																										obj_t BgL_pairz00_2643;

																										{	/* Coerce/coerce.scm 280 */
																											obj_t BgL_pairz00_2642;

																											{
																												BgL_letzd2varzd2_bglt
																													BgL_auxz00_4185;
																												BgL_auxz00_4185 =
																													(BgL_letzd2varzd2_bglt)
																													(BgL_nodez00_1557);
																												BgL_pairz00_2642 =
																													(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_4185))->BgL_bindingsz00);
																											}
																											BgL_pairz00_2643 =
																												CAR(BgL_pairz00_2642);
																										}
																										BgL_auxz00_4184 =
																											CAR(BgL_pairz00_2643);
																									}
																									BgL_obj1687z00_2644 =
																										(BgL_variablez00_bglt)
																										(BgL_auxz00_4184);
																								}
																								BgL_typepz00_1567 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_obj1687z00_2644))->
																									BgL_typez00);
																							}
																							{	/* Coerce/coerce.scm 280 */
																								BgL_typez00_bglt
																									BgL_typevz00_1568;
																								if (((obj_t) (BgL_typepz00_1567)
																										==
																										BGl_za2objza2z00zztype_cachez00))
																									{	/* Coerce/coerce.scm 282 */
																										obj_t BgL_arg3643z00_1578;

																										{	/* Coerce/coerce.scm 282 */
																											obj_t BgL_pairz00_2647;

																											{	/* Coerce/coerce.scm 282 */
																												obj_t BgL_pairz00_2646;

																												{
																													BgL_letzd2varzd2_bglt
																														BgL_auxz00_4195;
																													BgL_auxz00_4195 =
																														(BgL_letzd2varzd2_bglt)
																														(BgL_nodez00_1557);
																													BgL_pairz00_2646 =
																														(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_4195))->BgL_bindingsz00);
																												}
																												BgL_pairz00_2647 =
																													CAR(BgL_pairz00_2646);
																											}
																											BgL_arg3643z00_1578 =
																												CDR(BgL_pairz00_2647);
																										}
																										BgL_typevz00_1568 =
																											BGl_typeofz00zztype_typeofz00
																											((BgL_nodez00_bglt)
																											(BgL_arg3643z00_1578));
																									}
																								else
																									{	/* Coerce/coerce.scm 281 */
																										BgL_typevz00_1568 =
																											BgL_typepz00_1567;
																									}
																								{	/* Coerce/coerce.scm 281 */

																									if (BGl_iszd2azf3z21zz__objectz00(BgL_typecz00_1566, BGl_typez00zztype_typez00))
																										{	/* Coerce/coerce.scm 288 */
																											bool_t BgL_testz00_4204;

																											{	/* Coerce/coerce.scm 288 */
																												obj_t BgL_auxz00_4205;

																												{	/* Coerce/coerce.scm 288 */
																													obj_t
																														BgL_pairz00_2651;
																													{	/* Coerce/coerce.scm 288 */
																														obj_t
																															BgL_pairz00_2650;
																														{
																															BgL_letzd2varzd2_bglt
																																BgL_auxz00_4206;
																															BgL_auxz00_4206 =
																																(BgL_letzd2varzd2_bglt)
																																(BgL_nodez00_1557);
																															BgL_pairz00_2650 =
																																(((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_4206))->BgL_bindingsz00);
																														}
																														BgL_pairz00_2651 =
																															CAR
																															(BgL_pairz00_2650);
																													}
																													BgL_auxz00_4205 =
																														CAR
																														(BgL_pairz00_2651);
																												}
																												BgL_testz00_4204 =
																													(BgL_varz00_1564 ==
																													BgL_auxz00_4205);
																											}
																											if (BgL_testz00_4204)
																												{	/* Coerce/coerce.scm 288 */
																													if (
																														((obj_t)
																															(BgL_typevz00_1568)
																															==
																															BGl_za2objza2z00zztype_cachez00))
																														{	/* Coerce/coerce.scm 291 */
																															BgL_casezd2valuezd2_1543
																																= BFALSE;
																														}
																													else
																														{	/* Coerce/coerce.scm 291 */
																															if (BGl_typezd2lesszd2specificzf3zf3zztype_miscz00((BgL_typez00_bglt) (BgL_typecz00_1566), BgL_typevz00_1568))
																																{	/* Coerce/coerce.scm 294 */
																																	BgL_casezd2valuezd2_1543
																																		=
																																		CNST_TABLE_REF
																																		(((long)
																																			1));
																																}
																															else
																																{	/* Coerce/coerce.scm 294 */
																																	if (BGl_typezd2disjointzf3z21zztype_miscz00((BgL_typez00_bglt) (BgL_typecz00_1566), BgL_typevz00_1568))
																																		{	/* Coerce/coerce.scm 296 */
																																			BgL_casezd2valuezd2_1543
																																				=
																																				CNST_TABLE_REF
																																				(((long)
																																					2));
																																		}
																																	else
																																		{	/* Coerce/coerce.scm 296 */
																																			BgL_casezd2valuezd2_1543
																																				=
																																				BFALSE;
																																		}
																																}
																														}
																												}
																											else
																												{	/* Coerce/coerce.scm 288 */
																													BgL_casezd2valuezd2_1543
																														= BFALSE;
																												}
																										}
																									else
																										{	/* Coerce/coerce.scm 285 */
																											BgL_casezd2valuezd2_1543 =
																												BFALSE;
																										}
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																	else
																		{	/* Coerce/coerce.scm 271 */
																			BgL_casezd2valuezd2_1543 = BFALSE;
																		}
																}
															else
																{	/* Coerce/coerce.scm 270 */
																	BgL_casezd2valuezd2_1543 = BFALSE;
																}
														}
													else
														{	/* Coerce/coerce.scm 269 */
															BgL_casezd2valuezd2_1543 = BFALSE;
														}
												}
											}
										else
											{	/* Coerce/coerce.scm 304 */
												BgL_casezd2valuezd2_1543 = BFALSE;
											}
									}
							}
						}
						if ((BgL_casezd2valuezd2_1543 == CNST_TABLE_REF(((long) 1))))
							{	/* Coerce/coerce.scm 312 */
								BgL_nodez00_bglt BgL_arg3622z00_1545;

								BgL_arg3622z00_1545 =
									(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1531))->
									BgL_truez00);
								{	/* Coerce/coerce.scm 312 */
									BgL_nodez00_bglt BgL_res3792z00_2516;

									{	/* Coerce/coerce.scm 312 */
										BgL_typez00_bglt BgL_toz00_2489;

										bool_t BgL_safez00_2490;

										BgL_toz00_2489 = (BgL_typez00_bglt) (BgL_toz00_1533);
										BgL_safez00_2490 = CBOOL(BgL_safez00_1534);
										{	/* Coerce/coerce.scm 312 */
											obj_t BgL_method3391z00_2491;

											{	/* Coerce/coerce.scm 312 */
												BgL_objectz00_bglt BgL_objz00_2492;

												BgL_objz00_2492 =
													(BgL_objectz00_bglt) (BgL_arg3622z00_1545);
												{	/* Coerce/coerce.scm 312 */
													long BgL_objzd2classzd2numz00_2493;

													BgL_objzd2classzd2numz00_2493 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2492);
													{	/* Coerce/coerce.scm 312 */
														obj_t BgL_arg2334z00_2494;

														BgL_arg2334z00_2494 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 312 */
															obj_t BgL_arrayz00_2496;

															int BgL_offsetz00_2497;

															BgL_arrayz00_2496 = BgL_arg2334z00_2494;
															BgL_offsetz00_2497 =
																(int) (BgL_objzd2classzd2numz00_2493);
															{	/* Coerce/coerce.scm 312 */
																long BgL_offsetz00_2498;

																BgL_offsetz00_2498 =
																	((long) (BgL_offsetz00_2497) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 312 */
																	long BgL_modz00_2499;

																	{	/* Coerce/coerce.scm 312 */
																		int BgL_arg2336z00_2500;

																		BgL_arg2336z00_2500 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 312 */
																			long BgL_auxz00_4237;

																			BgL_auxz00_4237 =
																				(long) (BgL_arg2336z00_2500);
																			BgL_modz00_2499 =
																				(BgL_offsetz00_2498 / BgL_auxz00_4237);
																	}}
																	{	/* Coerce/coerce.scm 312 */
																		long BgL_restz00_2501;

																		{	/* Coerce/coerce.scm 312 */
																			int BgL_arg2335z00_2502;

																			BgL_arg2335z00_2502 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 312 */
																				long BgL_auxz00_4241;

																				BgL_auxz00_4241 =
																					(long) (BgL_arg2335z00_2502);
																				BgL_restz00_2501 =
																					(BgL_offsetz00_2498 %
																					BgL_auxz00_4241);
																		}}
																		{	/* Coerce/coerce.scm 312 */

																			BgL_method3391z00_2491 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2496,
																					(int) (BgL_modz00_2499)),
																				(int) (BgL_restz00_2501));
											}}}}}}}}
											BgL_res3792z00_2516 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3391z00_2491) (BgL_method3391z00_2491,
													(obj_t) (BgL_arg3622z00_1545), BgL_callerz00_1532,
													(obj_t) (BgL_toz00_2489), BBOOL(BgL_safez00_2490),
													BEOA));
									}}
									return (obj_t) (BgL_res3792z00_2516);
								}
							}
						else
							{	/* Coerce/coerce.scm 310 */
								if ((BgL_casezd2valuezd2_1543 == CNST_TABLE_REF(((long) 2))))
									{	/* Coerce/coerce.scm 314 */
										BgL_nodez00_bglt BgL_arg3624z00_1547;

										BgL_arg3624z00_1547 =
											(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1531))->
											BgL_falsez00);
										{	/* Coerce/coerce.scm 314 */
											BgL_nodez00_bglt BgL_res3795z00_2549;

											{	/* Coerce/coerce.scm 314 */
												BgL_typez00_bglt BgL_toz00_2522;

												bool_t BgL_safez00_2523;

												BgL_toz00_2522 = (BgL_typez00_bglt) (BgL_toz00_1533);
												BgL_safez00_2523 = CBOOL(BgL_safez00_1534);
												{	/* Coerce/coerce.scm 314 */
													obj_t BgL_method3391z00_2524;

													{	/* Coerce/coerce.scm 314 */
														BgL_objectz00_bglt BgL_objz00_2525;

														BgL_objz00_2525 =
															(BgL_objectz00_bglt) (BgL_arg3624z00_1547);
														{	/* Coerce/coerce.scm 314 */
															long BgL_objzd2classzd2numz00_2526;

															BgL_objzd2classzd2numz00_2526 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2525);
															{	/* Coerce/coerce.scm 314 */
																obj_t BgL_arg2334z00_2527;

																BgL_arg2334z00_2527 =
																	PROCEDURE_REF
																	(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																	(int) (((long) 1)));
																{	/* Coerce/coerce.scm 314 */
																	obj_t BgL_arrayz00_2529;

																	int BgL_offsetz00_2530;

																	BgL_arrayz00_2529 = BgL_arg2334z00_2527;
																	BgL_offsetz00_2530 =
																		(int) (BgL_objzd2classzd2numz00_2526);
																	{	/* Coerce/coerce.scm 314 */
																		long BgL_offsetz00_2531;

																		BgL_offsetz00_2531 =
																			(
																			(long) (BgL_offsetz00_2530) -
																			OBJECT_TYPE);
																		{	/* Coerce/coerce.scm 314 */
																			long BgL_modz00_2532;

																			{	/* Coerce/coerce.scm 314 */
																				int BgL_arg2336z00_2533;

																				BgL_arg2336z00_2533 =
																					(int) (((long) 8));
																				{	/* Coerce/coerce.scm 314 */
																					long BgL_auxz00_4269;

																					BgL_auxz00_4269 =
																						(long) (BgL_arg2336z00_2533);
																					BgL_modz00_2532 =
																						(BgL_offsetz00_2531 /
																						BgL_auxz00_4269);
																			}}
																			{	/* Coerce/coerce.scm 314 */
																				long BgL_restz00_2534;

																				{	/* Coerce/coerce.scm 314 */
																					int BgL_arg2335z00_2535;

																					BgL_arg2335z00_2535 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 314 */
																						long BgL_auxz00_4273;

																						BgL_auxz00_4273 =
																							(long) (BgL_arg2335z00_2535);
																						BgL_restz00_2534 =
																							(BgL_offsetz00_2531 %
																							BgL_auxz00_4273);
																				}}
																				{	/* Coerce/coerce.scm 314 */

																					BgL_method3391z00_2524 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2529,
																							(int) (BgL_modz00_2532)),
																						(int) (BgL_restz00_2534));
													}}}}}}}}
													BgL_res3795z00_2549 =
														(BgL_nodez00_bglt) (PROCEDURE_ENTRY
														(BgL_method3391z00_2524) (BgL_method3391z00_2524,
															(obj_t) (BgL_arg3624z00_1547), BgL_callerz00_1532,
															(obj_t) (BgL_toz00_2522), BBOOL(BgL_safez00_2523),
															BEOA));
											}}
											return (obj_t) (BgL_res3795z00_2549);
										}
									}
								else
									{	/* Coerce/coerce.scm 310 */
										{	/* Coerce/coerce.scm 316 */
											BgL_nodez00_bglt BgL_arg3625z00_1548;

											{	/* Coerce/coerce.scm 316 */
												BgL_nodez00_bglt BgL_arg3626z00_1549;

												BgL_arg3626z00_1549 =
													(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1531))->
													BgL_truez00);
												{	/* Coerce/coerce.scm 316 */
													BgL_nodez00_bglt BgL_res3798z00_2580;

													{	/* Coerce/coerce.scm 316 */
														BgL_typez00_bglt BgL_toz00_2553;

														bool_t BgL_safez00_2554;

														BgL_toz00_2553 =
															(BgL_typez00_bglt) (BgL_toz00_1533);
														BgL_safez00_2554 = CBOOL(BgL_safez00_1534);
														{	/* Coerce/coerce.scm 316 */
															obj_t BgL_method3391z00_2555;

															{	/* Coerce/coerce.scm 316 */
																BgL_objectz00_bglt BgL_objz00_2556;

																BgL_objz00_2556 =
																	(BgL_objectz00_bglt) (BgL_arg3626z00_1549);
																{	/* Coerce/coerce.scm 316 */
																	long BgL_objzd2classzd2numz00_2557;

																	BgL_objzd2classzd2numz00_2557 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2556);
																	{	/* Coerce/coerce.scm 316 */
																		obj_t BgL_arg2334z00_2558;

																		BgL_arg2334z00_2558 =
																			PROCEDURE_REF
																			(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																			(int) (((long) 1)));
																		{	/* Coerce/coerce.scm 316 */
																			obj_t BgL_arrayz00_2560;

																			int BgL_offsetz00_2561;

																			BgL_arrayz00_2560 = BgL_arg2334z00_2558;
																			BgL_offsetz00_2561 =
																				(int) (BgL_objzd2classzd2numz00_2557);
																			{	/* Coerce/coerce.scm 316 */
																				long BgL_offsetz00_2562;

																				BgL_offsetz00_2562 =
																					(
																					(long) (BgL_offsetz00_2561) -
																					OBJECT_TYPE);
																				{	/* Coerce/coerce.scm 316 */
																					long BgL_modz00_2563;

																					{	/* Coerce/coerce.scm 316 */
																						int BgL_arg2336z00_2564;

																						BgL_arg2336z00_2564 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 316 */
																							long BgL_auxz00_4298;

																							BgL_auxz00_4298 =
																								(long) (BgL_arg2336z00_2564);
																							BgL_modz00_2563 =
																								(BgL_offsetz00_2562 /
																								BgL_auxz00_4298);
																					}}
																					{	/* Coerce/coerce.scm 316 */
																						long BgL_restz00_2565;

																						{	/* Coerce/coerce.scm 316 */
																							int BgL_arg2335z00_2566;

																							BgL_arg2335z00_2566 =
																								(int) (((long) 8));
																							{	/* Coerce/coerce.scm 316 */
																								long BgL_auxz00_4302;

																								BgL_auxz00_4302 =
																									(long) (BgL_arg2335z00_2566);
																								BgL_restz00_2565 =
																									(BgL_offsetz00_2562 %
																									BgL_auxz00_4302);
																						}}
																						{	/* Coerce/coerce.scm 316 */

																							BgL_method3391z00_2555 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2560,
																									(int) (BgL_modz00_2563)),
																								(int) (BgL_restz00_2565));
															}}}}}}}}
															BgL_res3798z00_2580 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3391z00_2555)
																(BgL_method3391z00_2555,
																	(obj_t) (BgL_arg3626z00_1549),
																	BgL_callerz00_1532, (obj_t) (BgL_toz00_2553),
																	BBOOL(BgL_safez00_2554), BEOA));
													}}
													BgL_arg3625z00_1548 = BgL_res3798z00_2580;
											}}
											((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1531))->
													BgL_truez00) =
												((BgL_nodez00_bglt) BgL_arg3625z00_1548), BUNSPEC);
										}
										{	/* Coerce/coerce.scm 317 */
											BgL_nodez00_bglt BgL_arg3627z00_1550;

											{	/* Coerce/coerce.scm 317 */
												BgL_nodez00_bglt BgL_arg3628z00_1551;

												BgL_arg3628z00_1551 =
													(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1531))->
													BgL_falsez00);
												{	/* Coerce/coerce.scm 317 */
													BgL_nodez00_bglt BgL_res3801z00_2613;

													{	/* Coerce/coerce.scm 317 */
														BgL_typez00_bglt BgL_toz00_2586;

														bool_t BgL_safez00_2587;

														BgL_toz00_2586 =
															(BgL_typez00_bglt) (BgL_toz00_1533);
														BgL_safez00_2587 = CBOOL(BgL_safez00_1534);
														{	/* Coerce/coerce.scm 317 */
															obj_t BgL_method3391z00_2588;

															{	/* Coerce/coerce.scm 317 */
																BgL_objectz00_bglt BgL_objz00_2589;

																BgL_objz00_2589 =
																	(BgL_objectz00_bglt) (BgL_arg3628z00_1551);
																{	/* Coerce/coerce.scm 317 */
																	long BgL_objzd2classzd2numz00_2590;

																	BgL_objzd2classzd2numz00_2590 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2589);
																	{	/* Coerce/coerce.scm 317 */
																		obj_t BgL_arg2334z00_2591;

																		BgL_arg2334z00_2591 =
																			PROCEDURE_REF
																			(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																			(int) (((long) 1)));
																		{	/* Coerce/coerce.scm 317 */
																			obj_t BgL_arrayz00_2593;

																			int BgL_offsetz00_2594;

																			BgL_arrayz00_2593 = BgL_arg2334z00_2591;
																			BgL_offsetz00_2594 =
																				(int) (BgL_objzd2classzd2numz00_2590);
																			{	/* Coerce/coerce.scm 317 */
																				long BgL_offsetz00_2595;

																				BgL_offsetz00_2595 =
																					(
																					(long) (BgL_offsetz00_2594) -
																					OBJECT_TYPE);
																				{	/* Coerce/coerce.scm 317 */
																					long BgL_modz00_2596;

																					{	/* Coerce/coerce.scm 317 */
																						int BgL_arg2336z00_2597;

																						BgL_arg2336z00_2597 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 317 */
																							long BgL_auxz00_4327;

																							BgL_auxz00_4327 =
																								(long) (BgL_arg2336z00_2597);
																							BgL_modz00_2596 =
																								(BgL_offsetz00_2595 /
																								BgL_auxz00_4327);
																					}}
																					{	/* Coerce/coerce.scm 317 */
																						long BgL_restz00_2598;

																						{	/* Coerce/coerce.scm 317 */
																							int BgL_arg2335z00_2599;

																							BgL_arg2335z00_2599 =
																								(int) (((long) 8));
																							{	/* Coerce/coerce.scm 317 */
																								long BgL_auxz00_4331;

																								BgL_auxz00_4331 =
																									(long) (BgL_arg2335z00_2599);
																								BgL_restz00_2598 =
																									(BgL_offsetz00_2595 %
																									BgL_auxz00_4331);
																						}}
																						{	/* Coerce/coerce.scm 317 */

																							BgL_method3391z00_2588 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2593,
																									(int) (BgL_modz00_2596)),
																								(int) (BgL_restz00_2598));
															}}}}}}}}
															BgL_res3801z00_2613 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3391z00_2588)
																(BgL_method3391z00_2588,
																	(obj_t) (BgL_arg3628z00_1551),
																	BgL_callerz00_1532, (obj_t) (BgL_toz00_2586),
																	BBOOL(BgL_safez00_2587), BEOA));
													}}
													BgL_arg3627z00_1550 = BgL_res3801z00_2613;
											}}
											((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1531))->
													BgL_falsez00) =
												((BgL_nodez00_bglt) BgL_arg3627z00_1550), BUNSPEC);
										}
										{
											BgL_typez00_bglt BgL_auxz00_4347;

											BgL_nodez00_bglt BgL_auxz00_4345;

											BgL_auxz00_4347 = (BgL_typez00_bglt) (BgL_toz00_1533);
											BgL_auxz00_4345 = (BgL_nodez00_bglt) (BgL_nodez00_1531);
											((((BgL_nodez00_bglt) CREF(BgL_auxz00_4345))->
													BgL_typez00) =
												((BgL_typez00_bglt) BgL_auxz00_4347), BUNSPEC);
										}
										return (obj_t) (BgL_nodez00_1531);
									}
							}
					}
				}
			}
		}
	}



/* coerce!-setq3425 */
	obj_t BGl_coercez12zd2setq3425zc0zzcoerce_coercez00(obj_t BgL_envz00_3277,
		obj_t BgL_nodez00_3278, obj_t BgL_callerz00_3279, obj_t BgL_toz00_3280,
		obj_t BgL_safez00_3281)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 220 */
			{
				BgL_setqz00_bglt BgL_nodez00_1517;

				obj_t BgL_callerz00_1518;

				obj_t BgL_toz00_1519;

				obj_t BgL_safez00_1520;

				{	/* Coerce/coerce.scm 221 */
					BgL_nodez00_bglt BgL_auxz00_4352;

					BgL_nodez00_1517 = (BgL_setqz00_bglt) (BgL_nodez00_3278);
					BgL_callerz00_1518 = BgL_callerz00_3279;
					BgL_toz00_1519 = BgL_toz00_3280;
					BgL_safez00_1520 = BgL_safez00_3281;
					{	/* Coerce/coerce.scm 222 */
						BgL_nodez00_bglt BgL_arg3613z00_1524;

						{	/* Coerce/coerce.scm 222 */
							BgL_nodez00_bglt BgL_arg3614z00_1525;

							BgL_typez00_bglt BgL_arg3615z00_1526;

							BgL_arg3614z00_1525 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1517))->BgL_valuez00);
							{	/* Coerce/coerce.scm 224 */
								BgL_variablez00_bglt BgL_arg3616z00_1527;

								{	/* Coerce/coerce.scm 224 */
									BgL_varz00_bglt BgL_obj2232z00_2416;

									BgL_obj2232z00_2416 =
										(((BgL_setqz00_bglt) CREF(BgL_nodez00_1517))->BgL_varz00);
									BgL_arg3616z00_1527 =
										(((BgL_varz00_bglt) CREF(BgL_obj2232z00_2416))->
										BgL_variablez00);
								}
								BgL_arg3615z00_1526 =
									(((BgL_variablez00_bglt) CREF(BgL_arg3616z00_1527))->
									BgL_typez00);
							}
							{	/* Coerce/coerce.scm 222 */
								BgL_nodez00_bglt BgL_res3786z00_2447;

								{	/* Coerce/coerce.scm 222 */
									bool_t BgL_safez00_2421;

									BgL_safez00_2421 = CBOOL(BgL_safez00_1520);
									{	/* Coerce/coerce.scm 222 */
										obj_t BgL_method3391z00_2422;

										{	/* Coerce/coerce.scm 222 */
											BgL_objectz00_bglt BgL_objz00_2423;

											BgL_objz00_2423 =
												(BgL_objectz00_bglt) (BgL_arg3614z00_1525);
											{	/* Coerce/coerce.scm 222 */
												long BgL_objzd2classzd2numz00_2424;

												BgL_objzd2classzd2numz00_2424 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2423);
												{	/* Coerce/coerce.scm 222 */
													obj_t BgL_arg2334z00_2425;

													BgL_arg2334z00_2425 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 222 */
														obj_t BgL_arrayz00_2427;

														int BgL_offsetz00_2428;

														BgL_arrayz00_2427 = BgL_arg2334z00_2425;
														BgL_offsetz00_2428 =
															(int) (BgL_objzd2classzd2numz00_2424);
														{	/* Coerce/coerce.scm 222 */
															long BgL_offsetz00_2429;

															BgL_offsetz00_2429 =
																((long) (BgL_offsetz00_2428) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 222 */
																long BgL_modz00_2430;

																{	/* Coerce/coerce.scm 222 */
																	int BgL_arg2336z00_2431;

																	BgL_arg2336z00_2431 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 222 */
																		long BgL_auxz00_4366;

																		BgL_auxz00_4366 =
																			(long) (BgL_arg2336z00_2431);
																		BgL_modz00_2430 =
																			(BgL_offsetz00_2429 / BgL_auxz00_4366);
																}}
																{	/* Coerce/coerce.scm 222 */
																	long BgL_restz00_2432;

																	{	/* Coerce/coerce.scm 222 */
																		int BgL_arg2335z00_2433;

																		BgL_arg2335z00_2433 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 222 */
																			long BgL_auxz00_4370;

																			BgL_auxz00_4370 =
																				(long) (BgL_arg2335z00_2433);
																			BgL_restz00_2432 =
																				(BgL_offsetz00_2429 % BgL_auxz00_4370);
																	}}
																	{	/* Coerce/coerce.scm 222 */

																		BgL_method3391z00_2422 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2427,
																				(int) (BgL_modz00_2430)),
																			(int) (BgL_restz00_2432));
										}}}}}}}}
										BgL_res3786z00_2447 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2422) (BgL_method3391z00_2422,
												(obj_t) (BgL_arg3614z00_1525), BgL_callerz00_1518,
												(obj_t) (BgL_arg3615z00_1526), BBOOL(BgL_safez00_2421),
												BEOA));
								}}
								BgL_arg3613z00_1524 = BgL_res3786z00_2447;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1517))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3613z00_1524), BUNSPEC);
					}
					BgL_auxz00_4352 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1517),
						(BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1519), CBOOL(BgL_safez00_1520));
					return (obj_t) (BgL_auxz00_4352);
				}
			}
		}
	}



/* coerce!-cast3423 */
	obj_t BGl_coercez12zd2cast3423zc0zzcoerce_coercez00(obj_t BgL_envz00_3282,
		obj_t BgL_nodez00_3283, obj_t BgL_callerz00_3284, obj_t BgL_toz00_3285,
		obj_t BgL_safez00_3286)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 210 */
			{
				BgL_castz00_bglt BgL_nodez00_1505;

				obj_t BgL_callerz00_1506;

				obj_t BgL_toz00_1507;

				obj_t BgL_safez00_1508;

				{	/* Coerce/coerce.scm 211 */
					BgL_nodez00_bglt BgL_auxz00_4391;

					BgL_nodez00_1505 = (BgL_castz00_bglt) (BgL_nodez00_3283);
					BgL_callerz00_1506 = BgL_callerz00_3284;
					BgL_toz00_1507 = BgL_toz00_3285;
					BgL_safez00_1508 = BgL_safez00_3286;
					{	/* Coerce/coerce.scm 211 */
						BgL_nodez00_bglt BgL_arg3609z00_2377;

						{	/* Coerce/coerce.scm 211 */
							BgL_nodez00_bglt BgL_arg3610z00_2378;

							BgL_arg3610z00_2378 =
								(((BgL_castz00_bglt) CREF(BgL_nodez00_1505))->BgL_argz00);
							{	/* Coerce/coerce.scm 211 */
								BgL_nodez00_bglt BgL_res3783z00_2410;

								{	/* Coerce/coerce.scm 211 */
									BgL_typez00_bglt BgL_toz00_2383;

									bool_t BgL_safez00_2384;

									BgL_toz00_2383 = (BgL_typez00_bglt) (BgL_toz00_1507);
									BgL_safez00_2384 = CBOOL(BgL_safez00_1508);
									{	/* Coerce/coerce.scm 211 */
										obj_t BgL_method3391z00_2385;

										{	/* Coerce/coerce.scm 211 */
											BgL_objectz00_bglt BgL_objz00_2386;

											BgL_objz00_2386 =
												(BgL_objectz00_bglt) (BgL_arg3610z00_2378);
											{	/* Coerce/coerce.scm 211 */
												long BgL_objzd2classzd2numz00_2387;

												BgL_objzd2classzd2numz00_2387 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2386);
												{	/* Coerce/coerce.scm 211 */
													obj_t BgL_arg2334z00_2388;

													BgL_arg2334z00_2388 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 211 */
														obj_t BgL_arrayz00_2390;

														int BgL_offsetz00_2391;

														BgL_arrayz00_2390 = BgL_arg2334z00_2388;
														BgL_offsetz00_2391 =
															(int) (BgL_objzd2classzd2numz00_2387);
														{	/* Coerce/coerce.scm 211 */
															long BgL_offsetz00_2392;

															BgL_offsetz00_2392 =
																((long) (BgL_offsetz00_2391) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 211 */
																long BgL_modz00_2393;

																{	/* Coerce/coerce.scm 211 */
																	int BgL_arg2336z00_2394;

																	BgL_arg2336z00_2394 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 211 */
																		long BgL_auxz00_4403;

																		BgL_auxz00_4403 =
																			(long) (BgL_arg2336z00_2394);
																		BgL_modz00_2393 =
																			(BgL_offsetz00_2392 / BgL_auxz00_4403);
																}}
																{	/* Coerce/coerce.scm 211 */
																	long BgL_restz00_2395;

																	{	/* Coerce/coerce.scm 211 */
																		int BgL_arg2335z00_2396;

																		BgL_arg2335z00_2396 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 211 */
																			long BgL_auxz00_4407;

																			BgL_auxz00_4407 =
																				(long) (BgL_arg2335z00_2396);
																			BgL_restz00_2395 =
																				(BgL_offsetz00_2392 % BgL_auxz00_4407);
																	}}
																	{	/* Coerce/coerce.scm 211 */

																		BgL_method3391z00_2385 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2390,
																				(int) (BgL_modz00_2393)),
																			(int) (BgL_restz00_2395));
										}}}}}}}}
										BgL_res3783z00_2410 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2385) (BgL_method3391z00_2385,
												(obj_t) (BgL_arg3610z00_2378), BgL_callerz00_1506,
												(obj_t) (BgL_toz00_2383), BBOOL(BgL_safez00_2384),
												BEOA));
								}}
								BgL_arg3609z00_2377 = BgL_res3783z00_2410;
						}}
						((((BgL_castz00_bglt) CREF(BgL_nodez00_1505))->BgL_argz00) =
							((BgL_nodez00_bglt) BgL_arg3609z00_2377), BUNSPEC);
					}
					{	/* Coerce/coerce.scm 211 */
						BgL_typez00_bglt BgL_arg3611z00_2379;

						{
							BgL_nodez00_bglt BgL_auxz00_4421;

							BgL_auxz00_4421 = (BgL_nodez00_bglt) (BgL_nodez00_1505);
							BgL_arg3611z00_2379 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_4421))->BgL_typez00);
						}
						BgL_auxz00_4391 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1505), BgL_arg3611z00_2379,
							(BgL_typez00_bglt) (BgL_toz00_1507), CBOOL(BgL_safez00_1508));
					}
					return (obj_t) (BgL_auxz00_4391);
				}
			}
		}
	}



/* coerce!-vlength3421 */
	obj_t BGl_coercez12zd2vlength3421zc0zzcoerce_coercez00(obj_t BgL_envz00_3287,
		obj_t BgL_nodez00_3288, obj_t BgL_callerz00_3289, obj_t BgL_toz00_3290,
		obj_t BgL_safez00_3291)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 202 */
			{
				BgL_vlengthz00_bglt BgL_nodez00_1490;

				obj_t BgL_callerz00_1491;

				obj_t BgL_toz00_1492;

				obj_t BgL_safez00_1493;

				{	/* Coerce/coerce.scm 203 */
					BgL_nodez00_bglt BgL_auxz00_4430;

					BgL_nodez00_1490 = (BgL_vlengthz00_bglt) (BgL_nodez00_3288);
					BgL_callerz00_1491 = BgL_callerz00_3289;
					BgL_toz00_1492 = BgL_toz00_3290;
					BgL_safez00_1493 = BgL_safez00_3291;
					{	/* Coerce/coerce.scm 204 */
						obj_t BgL_arg3602z00_1497;

						BgL_nodez00_bglt BgL_arg3603z00_1498;

						{
							BgL_externz00_bglt BgL_auxz00_4431;

							BgL_auxz00_4431 = (BgL_externz00_bglt) (BgL_nodez00_1490);
							BgL_arg3602z00_1497 =
								(((BgL_externz00_bglt) CREF(BgL_auxz00_4431))->BgL_exprza2za2);
						}
						{	/* Coerce/coerce.scm 204 */
							obj_t BgL_arg3604z00_1499;

							BgL_typez00_bglt BgL_arg3605z00_1500;

							{	/* Coerce/coerce.scm 204 */
								obj_t BgL_pairz00_2341;

								{
									BgL_externz00_bglt BgL_auxz00_4434;

									BgL_auxz00_4434 = (BgL_externz00_bglt) (BgL_nodez00_1490);
									BgL_pairz00_2341 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4434))->
										BgL_exprza2za2);
								}
								BgL_arg3604z00_1499 = CAR(BgL_pairz00_2341);
							}
							BgL_arg3605z00_1500 =
								(((BgL_vlengthz00_bglt) CREF(BgL_nodez00_1490))->BgL_vtypez00);
							{	/* Coerce/coerce.scm 204 */
								BgL_nodez00_bglt BgL_res3780z00_2372;

								{	/* Coerce/coerce.scm 204 */
									BgL_nodez00_bglt BgL_nodez00_2343;

									bool_t BgL_safez00_2346;

									BgL_nodez00_2343 = (BgL_nodez00_bglt) (BgL_arg3604z00_1499);
									BgL_safez00_2346 = CBOOL(BgL_safez00_1493);
									{	/* Coerce/coerce.scm 204 */
										obj_t BgL_method3391z00_2347;

										{	/* Coerce/coerce.scm 204 */
											BgL_objectz00_bglt BgL_objz00_2348;

											BgL_objz00_2348 = (BgL_objectz00_bglt) (BgL_nodez00_2343);
											{	/* Coerce/coerce.scm 204 */
												long BgL_objzd2classzd2numz00_2349;

												BgL_objzd2classzd2numz00_2349 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2348);
												{	/* Coerce/coerce.scm 204 */
													obj_t BgL_arg2334z00_2350;

													BgL_arg2334z00_2350 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 204 */
														obj_t BgL_arrayz00_2352;

														int BgL_offsetz00_2353;

														BgL_arrayz00_2352 = BgL_arg2334z00_2350;
														BgL_offsetz00_2353 =
															(int) (BgL_objzd2classzd2numz00_2349);
														{	/* Coerce/coerce.scm 204 */
															long BgL_offsetz00_2354;

															BgL_offsetz00_2354 =
																((long) (BgL_offsetz00_2353) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 204 */
																long BgL_modz00_2355;

																{	/* Coerce/coerce.scm 204 */
																	int BgL_arg2336z00_2356;

																	BgL_arg2336z00_2356 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 204 */
																		long BgL_auxz00_4449;

																		BgL_auxz00_4449 =
																			(long) (BgL_arg2336z00_2356);
																		BgL_modz00_2355 =
																			(BgL_offsetz00_2354 / BgL_auxz00_4449);
																}}
																{	/* Coerce/coerce.scm 204 */
																	long BgL_restz00_2357;

																	{	/* Coerce/coerce.scm 204 */
																		int BgL_arg2335z00_2358;

																		BgL_arg2335z00_2358 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 204 */
																			long BgL_auxz00_4453;

																			BgL_auxz00_4453 =
																				(long) (BgL_arg2335z00_2358);
																			BgL_restz00_2357 =
																				(BgL_offsetz00_2354 % BgL_auxz00_4453);
																	}}
																	{	/* Coerce/coerce.scm 204 */

																		BgL_method3391z00_2347 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2352,
																				(int) (BgL_modz00_2355)),
																			(int) (BgL_restz00_2357));
										}}}}}}}}
										BgL_res3780z00_2372 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2347) (BgL_method3391z00_2347,
												(obj_t) (BgL_nodez00_2343), BgL_callerz00_1491,
												(obj_t) (BgL_arg3605z00_1500), BBOOL(BgL_safez00_2346),
												BEOA));
								}}
								BgL_arg3603z00_1498 = BgL_res3780z00_2372;
						}}
						{	/* Coerce/coerce.scm 204 */
							obj_t BgL_auxz00_4466;

							BgL_auxz00_4466 = (obj_t) (BgL_arg3603z00_1498);
							SET_CAR(BgL_arg3602z00_1497, BgL_auxz00_4466);
					}}
					{	/* Coerce/coerce.scm 205 */
						BgL_typez00_bglt BgL_arg3607z00_1502;

						{
							BgL_nodez00_bglt BgL_auxz00_4469;

							BgL_auxz00_4469 = (BgL_nodez00_bglt) (BgL_nodez00_1490);
							BgL_arg3607z00_1502 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_4469))->BgL_typez00);
						}
						BgL_auxz00_4430 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1490), BgL_arg3607z00_1502,
							(BgL_typez00_bglt) (BgL_toz00_1492), CBOOL(BgL_safez00_1493));
					}
					return (obj_t) (BgL_auxz00_4430);
				}
			}
		}
	}



/* coerce!-vset!3418 */
	obj_t BGl_coercez12zd2vsetz123418zd2zzcoerce_coercez00(obj_t BgL_envz00_3292,
		obj_t BgL_nodez00_3293, obj_t BgL_callerz00_3294, obj_t BgL_toz00_3295,
		obj_t BgL_safez00_3296)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 190 */
			{
				BgL_vsetz12z12_bglt BgL_nodez00_1461;

				obj_t BgL_callerz00_1462;

				obj_t BgL_toz00_1463;

				obj_t BgL_safez00_1464;

				{	/* Coerce/coerce.scm 191 */
					BgL_nodez00_bglt BgL_auxz00_4478;

					BgL_nodez00_1461 = (BgL_vsetz12z12_bglt) (BgL_nodez00_3293);
					BgL_callerz00_1462 = BgL_callerz00_3294;
					BgL_toz00_1463 = BgL_toz00_3295;
					BgL_safez00_1464 = BgL_safez00_3296;
					{	/* Coerce/coerce.scm 193 */
						obj_t BgL_ftypez00_1468;

						{	/* Coerce/coerce.scm 193 */
							bool_t BgL_testz00_4479;

							{	/* Coerce/coerce.scm 193 */
								BgL_typez00_bglt BgL_arg3600z00_1487;

								BgL_arg3600z00_1487 =
									(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1461))->
									BgL_ftypez00);
								BgL_testz00_4479 =
									((obj_t) (BgL_arg3600z00_1487) ==
									BGl_za2_za2z00zztype_cachez00);
							}
							if (BgL_testz00_4479)
								{	/* Coerce/coerce.scm 193 */
									BgL_ftypez00_1468 = BGl_za2objza2z00zztype_cachez00;
								}
							else
								{	/* Coerce/coerce.scm 193 */
									BgL_ftypez00_1468 =
										(obj_t) (
										(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1461))->
											BgL_ftypez00));
								}
						}
						{	/* Coerce/coerce.scm 194 */
							obj_t BgL_arg3582z00_1469;

							BgL_nodez00_bglt BgL_arg3583z00_1470;

							{
								BgL_externz00_bglt BgL_auxz00_4485;

								BgL_auxz00_4485 = (BgL_externz00_bglt) (BgL_nodez00_1461);
								BgL_arg3582z00_1469 =
									(((BgL_externz00_bglt) CREF(BgL_auxz00_4485))->
									BgL_exprza2za2);
							}
							{	/* Coerce/coerce.scm 194 */
								obj_t BgL_arg3584z00_1471;

								BgL_typez00_bglt BgL_arg3585z00_1472;

								{	/* Coerce/coerce.scm 194 */
									obj_t BgL_pairz00_2220;

									{
										BgL_externz00_bglt BgL_auxz00_4488;

										BgL_auxz00_4488 = (BgL_externz00_bglt) (BgL_nodez00_1461);
										BgL_pairz00_2220 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4488))->
											BgL_exprza2za2);
									}
									BgL_arg3584z00_1471 = CAR(BgL_pairz00_2220);
								}
								BgL_arg3585z00_1472 =
									(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1461))->
									BgL_vtypez00);
								{	/* Coerce/coerce.scm 194 */
									BgL_nodez00_bglt BgL_res3771z00_2251;

									{	/* Coerce/coerce.scm 194 */
										BgL_nodez00_bglt BgL_nodez00_2222;

										bool_t BgL_safez00_2225;

										BgL_nodez00_2222 = (BgL_nodez00_bglt) (BgL_arg3584z00_1471);
										BgL_safez00_2225 = CBOOL(BgL_safez00_1464);
										{	/* Coerce/coerce.scm 194 */
											obj_t BgL_method3391z00_2226;

											{	/* Coerce/coerce.scm 194 */
												BgL_objectz00_bglt BgL_objz00_2227;

												BgL_objz00_2227 =
													(BgL_objectz00_bglt) (BgL_nodez00_2222);
												{	/* Coerce/coerce.scm 194 */
													long BgL_objzd2classzd2numz00_2228;

													BgL_objzd2classzd2numz00_2228 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2227);
													{	/* Coerce/coerce.scm 194 */
														obj_t BgL_arg2334z00_2229;

														BgL_arg2334z00_2229 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 194 */
															obj_t BgL_arrayz00_2231;

															int BgL_offsetz00_2232;

															BgL_arrayz00_2231 = BgL_arg2334z00_2229;
															BgL_offsetz00_2232 =
																(int) (BgL_objzd2classzd2numz00_2228);
															{	/* Coerce/coerce.scm 194 */
																long BgL_offsetz00_2233;

																BgL_offsetz00_2233 =
																	((long) (BgL_offsetz00_2232) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 194 */
																	long BgL_modz00_2234;

																	{	/* Coerce/coerce.scm 194 */
																		int BgL_arg2336z00_2235;

																		BgL_arg2336z00_2235 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 194 */
																			long BgL_auxz00_4503;

																			BgL_auxz00_4503 =
																				(long) (BgL_arg2336z00_2235);
																			BgL_modz00_2234 =
																				(BgL_offsetz00_2233 / BgL_auxz00_4503);
																	}}
																	{	/* Coerce/coerce.scm 194 */
																		long BgL_restz00_2236;

																		{	/* Coerce/coerce.scm 194 */
																			int BgL_arg2335z00_2237;

																			BgL_arg2335z00_2237 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 194 */
																				long BgL_auxz00_4507;

																				BgL_auxz00_4507 =
																					(long) (BgL_arg2335z00_2237);
																				BgL_restz00_2236 =
																					(BgL_offsetz00_2233 %
																					BgL_auxz00_4507);
																		}}
																		{	/* Coerce/coerce.scm 194 */

																			BgL_method3391z00_2226 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2231,
																					(int) (BgL_modz00_2234)),
																				(int) (BgL_restz00_2236));
											}}}}}}}}
											BgL_res3771z00_2251 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3391z00_2226) (BgL_method3391z00_2226,
													(obj_t) (BgL_nodez00_2222), BgL_callerz00_1462,
													(obj_t) (BgL_arg3585z00_1472),
													BBOOL(BgL_safez00_2225), BEOA));
									}}
									BgL_arg3583z00_1470 = BgL_res3771z00_2251;
							}}
							{	/* Coerce/coerce.scm 194 */
								obj_t BgL_auxz00_4520;

								BgL_auxz00_4520 = (obj_t) (BgL_arg3583z00_1470);
								SET_CAR(BgL_arg3582z00_1469, BgL_auxz00_4520);
						}}
						{	/* Coerce/coerce.scm 195 */
							obj_t BgL_arg3587z00_1474;

							BgL_nodez00_bglt BgL_arg3588z00_1475;

							{	/* Coerce/coerce.scm 195 */
								obj_t BgL_pairz00_2255;

								{
									BgL_externz00_bglt BgL_auxz00_4523;

									BgL_auxz00_4523 = (BgL_externz00_bglt) (BgL_nodez00_1461);
									BgL_pairz00_2255 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4523))->
										BgL_exprza2za2);
								}
								BgL_arg3587z00_1474 = CDR(BgL_pairz00_2255);
							}
							{	/* Coerce/coerce.scm 195 */
								obj_t BgL_arg3590z00_1477;

								BgL_typez00_bglt BgL_arg3591z00_1478;

								{	/* Coerce/coerce.scm 195 */
									obj_t BgL_pairz00_2257;

									{
										BgL_externz00_bglt BgL_auxz00_4527;

										BgL_auxz00_4527 = (BgL_externz00_bglt) (BgL_nodez00_1461);
										BgL_pairz00_2257 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4527))->
											BgL_exprza2za2);
									}
									BgL_arg3590z00_1477 = CAR(CDR(BgL_pairz00_2257));
								}
								BgL_arg3591z00_1478 =
									(((BgL_vsetz12z12_bglt) CREF(BgL_nodez00_1461))->
									BgL_otypez00);
								{	/* Coerce/coerce.scm 195 */
									BgL_nodez00_bglt BgL_res3774z00_2291;

									{	/* Coerce/coerce.scm 195 */
										BgL_nodez00_bglt BgL_nodez00_2262;

										bool_t BgL_safez00_2265;

										BgL_nodez00_2262 = (BgL_nodez00_bglt) (BgL_arg3590z00_1477);
										BgL_safez00_2265 = CBOOL(BgL_safez00_1464);
										{	/* Coerce/coerce.scm 195 */
											obj_t BgL_method3391z00_2266;

											{	/* Coerce/coerce.scm 195 */
												BgL_objectz00_bglt BgL_objz00_2267;

												BgL_objz00_2267 =
													(BgL_objectz00_bglt) (BgL_nodez00_2262);
												{	/* Coerce/coerce.scm 195 */
													long BgL_objzd2classzd2numz00_2268;

													BgL_objzd2classzd2numz00_2268 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2267);
													{	/* Coerce/coerce.scm 195 */
														obj_t BgL_arg2334z00_2269;

														BgL_arg2334z00_2269 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 195 */
															obj_t BgL_arrayz00_2271;

															int BgL_offsetz00_2272;

															BgL_arrayz00_2271 = BgL_arg2334z00_2269;
															BgL_offsetz00_2272 =
																(int) (BgL_objzd2classzd2numz00_2268);
															{	/* Coerce/coerce.scm 195 */
																long BgL_offsetz00_2273;

																BgL_offsetz00_2273 =
																	((long) (BgL_offsetz00_2272) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 195 */
																	long BgL_modz00_2274;

																	{	/* Coerce/coerce.scm 195 */
																		int BgL_arg2336z00_2275;

																		BgL_arg2336z00_2275 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 195 */
																			long BgL_auxz00_4543;

																			BgL_auxz00_4543 =
																				(long) (BgL_arg2336z00_2275);
																			BgL_modz00_2274 =
																				(BgL_offsetz00_2273 / BgL_auxz00_4543);
																	}}
																	{	/* Coerce/coerce.scm 195 */
																		long BgL_restz00_2276;

																		{	/* Coerce/coerce.scm 195 */
																			int BgL_arg2335z00_2277;

																			BgL_arg2335z00_2277 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 195 */
																				long BgL_auxz00_4547;

																				BgL_auxz00_4547 =
																					(long) (BgL_arg2335z00_2277);
																				BgL_restz00_2276 =
																					(BgL_offsetz00_2273 %
																					BgL_auxz00_4547);
																		}}
																		{	/* Coerce/coerce.scm 195 */

																			BgL_method3391z00_2266 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2271,
																					(int) (BgL_modz00_2274)),
																				(int) (BgL_restz00_2276));
											}}}}}}}}
											BgL_res3774z00_2291 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3391z00_2266) (BgL_method3391z00_2266,
													(obj_t) (BgL_nodez00_2262), BgL_callerz00_1462,
													(obj_t) (BgL_arg3591z00_1478),
													BBOOL(BgL_safez00_2265), BEOA));
									}}
									BgL_arg3588z00_1475 = BgL_res3774z00_2291;
							}}
							{	/* Coerce/coerce.scm 195 */
								obj_t BgL_auxz00_4560;

								BgL_auxz00_4560 = (obj_t) (BgL_arg3588z00_1475);
								SET_CAR(BgL_arg3587z00_1474, BgL_auxz00_4560);
						}}
						{	/* Coerce/coerce.scm 196 */
							obj_t BgL_arg3593z00_1480;

							BgL_nodez00_bglt BgL_arg3594z00_1481;

							{	/* Coerce/coerce.scm 196 */
								obj_t BgL_pairz00_2295;

								{
									BgL_externz00_bglt BgL_auxz00_4563;

									BgL_auxz00_4563 = (BgL_externz00_bglt) (BgL_nodez00_1461);
									BgL_pairz00_2295 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4563))->
										BgL_exprza2za2);
								}
								BgL_arg3593z00_1480 = CDR(CDR(BgL_pairz00_2295));
							}
							{	/* Coerce/coerce.scm 196 */
								obj_t BgL_arg3596z00_1483;

								{	/* Coerce/coerce.scm 196 */
									obj_t BgL_pairz00_2300;

									{
										BgL_externz00_bglt BgL_auxz00_4568;

										BgL_auxz00_4568 = (BgL_externz00_bglt) (BgL_nodez00_1461);
										BgL_pairz00_2300 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4568))->
											BgL_exprza2za2);
									}
									BgL_arg3596z00_1483 = CAR(CDR(CDR(BgL_pairz00_2300)));
								}
								{	/* Coerce/coerce.scm 196 */
									BgL_nodez00_bglt BgL_res3777z00_2335;

									{	/* Coerce/coerce.scm 196 */
										BgL_nodez00_bglt BgL_nodez00_2306;

										BgL_typez00_bglt BgL_toz00_2308;

										bool_t BgL_safez00_2309;

										BgL_nodez00_2306 = (BgL_nodez00_bglt) (BgL_arg3596z00_1483);
										BgL_toz00_2308 = (BgL_typez00_bglt) (BgL_ftypez00_1468);
										BgL_safez00_2309 = CBOOL(BgL_safez00_1464);
										{	/* Coerce/coerce.scm 196 */
											obj_t BgL_method3391z00_2310;

											{	/* Coerce/coerce.scm 196 */
												BgL_objectz00_bglt BgL_objz00_2311;

												BgL_objz00_2311 =
													(BgL_objectz00_bglt) (BgL_nodez00_2306);
												{	/* Coerce/coerce.scm 196 */
													long BgL_objzd2classzd2numz00_2312;

													BgL_objzd2classzd2numz00_2312 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2311);
													{	/* Coerce/coerce.scm 196 */
														obj_t BgL_arg2334z00_2313;

														BgL_arg2334z00_2313 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 196 */
															obj_t BgL_arrayz00_2315;

															int BgL_offsetz00_2316;

															BgL_arrayz00_2315 = BgL_arg2334z00_2313;
															BgL_offsetz00_2316 =
																(int) (BgL_objzd2classzd2numz00_2312);
															{	/* Coerce/coerce.scm 196 */
																long BgL_offsetz00_2317;

																BgL_offsetz00_2317 =
																	((long) (BgL_offsetz00_2316) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 196 */
																	long BgL_modz00_2318;

																	{	/* Coerce/coerce.scm 196 */
																		int BgL_arg2336z00_2319;

																		BgL_arg2336z00_2319 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 196 */
																			long BgL_auxz00_4585;

																			BgL_auxz00_4585 =
																				(long) (BgL_arg2336z00_2319);
																			BgL_modz00_2318 =
																				(BgL_offsetz00_2317 / BgL_auxz00_4585);
																	}}
																	{	/* Coerce/coerce.scm 196 */
																		long BgL_restz00_2320;

																		{	/* Coerce/coerce.scm 196 */
																			int BgL_arg2335z00_2321;

																			BgL_arg2335z00_2321 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 196 */
																				long BgL_auxz00_4589;

																				BgL_auxz00_4589 =
																					(long) (BgL_arg2335z00_2321);
																				BgL_restz00_2320 =
																					(BgL_offsetz00_2317 %
																					BgL_auxz00_4589);
																		}}
																		{	/* Coerce/coerce.scm 196 */

																			BgL_method3391z00_2310 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2315,
																					(int) (BgL_modz00_2318)),
																				(int) (BgL_restz00_2320));
											}}}}}}}}
											BgL_res3777z00_2335 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3391z00_2310) (BgL_method3391z00_2310,
													(obj_t) (BgL_nodez00_2306), BgL_callerz00_1462,
													(obj_t) (BgL_toz00_2308), BBOOL(BgL_safez00_2309),
													BEOA));
									}}
									BgL_arg3594z00_1481 = BgL_res3777z00_2335;
							}}
							{	/* Coerce/coerce.scm 196 */
								obj_t BgL_auxz00_4602;

								BgL_auxz00_4602 = (obj_t) (BgL_arg3594z00_1481);
								SET_CAR(BgL_arg3593z00_1480, BgL_auxz00_4602);
						}}
						{	/* Coerce/coerce.scm 197 */
							BgL_typez00_bglt BgL_arg3598z00_1485;

							{
								BgL_nodez00_bglt BgL_auxz00_4605;

								BgL_auxz00_4605 = (BgL_nodez00_bglt) (BgL_nodez00_1461);
								BgL_arg3598z00_1485 =
									(((BgL_nodez00_bglt) CREF(BgL_auxz00_4605))->BgL_typez00);
							}
							BgL_auxz00_4478 =
								BGl_convertz12z12zzcoerce_convertz00(
								(BgL_nodez00_bglt) (BgL_nodez00_1461), BgL_arg3598z00_1485,
								(BgL_typez00_bglt) (BgL_toz00_1463), CBOOL(BgL_safez00_1464));
					}}
					return (obj_t) (BgL_auxz00_4478);
				}
			}
		}
	}



/* coerce!-vref3416 */
	obj_t BGl_coercez12zd2vref3416zc0zzcoerce_coercez00(obj_t BgL_envz00_3297,
		obj_t BgL_nodez00_3298, obj_t BgL_callerz00_3299, obj_t BgL_toz00_3300,
		obj_t BgL_safez00_3301)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 174 */
			{
				BgL_vrefz00_bglt BgL_nodez00_1438;

				obj_t BgL_callerz00_1439;

				obj_t BgL_toz00_1440;

				obj_t BgL_safez00_1441;

				{	/* Coerce/coerce.scm 175 */
					BgL_nodez00_bglt BgL_auxz00_4614;

					BgL_nodez00_1438 = (BgL_vrefz00_bglt) (BgL_nodez00_3298);
					BgL_callerz00_1439 = BgL_callerz00_3299;
					BgL_toz00_1440 = BgL_toz00_3300;
					BgL_safez00_1441 = BgL_safez00_3301;
					{	/* Coerce/coerce.scm 182 */
						obj_t BgL_ftypez00_1445;

						{	/* Coerce/coerce.scm 182 */
							bool_t BgL_testz00_4615;

							{	/* Coerce/coerce.scm 182 */
								BgL_typez00_bglt BgL_arg3580z00_1458;

								BgL_arg3580z00_1458 =
									(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1438))->BgL_ftypez00);
								BgL_testz00_4615 =
									(
									(obj_t) (BgL_arg3580z00_1458) ==
									BGl_za2_za2z00zztype_cachez00);
							}
							if (BgL_testz00_4615)
								{	/* Coerce/coerce.scm 182 */
									BgL_ftypez00_1445 = BGl_za2objza2z00zztype_cachez00;
								}
							else
								{	/* Coerce/coerce.scm 182 */
									BgL_ftypez00_1445 =
										(obj_t) (
										(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1438))->
											BgL_ftypez00));
								}
						}
						{	/* Coerce/coerce.scm 183 */
							obj_t BgL_arg3567z00_1446;

							BgL_nodez00_bglt BgL_arg3568z00_1447;

							{
								BgL_externz00_bglt BgL_auxz00_4621;

								BgL_auxz00_4621 = (BgL_externz00_bglt) (BgL_nodez00_1438);
								BgL_arg3567z00_1446 =
									(((BgL_externz00_bglt) CREF(BgL_auxz00_4621))->
									BgL_exprza2za2);
							}
							{	/* Coerce/coerce.scm 183 */
								obj_t BgL_arg3569z00_1448;

								BgL_typez00_bglt BgL_arg3570z00_1449;

								{	/* Coerce/coerce.scm 183 */
									obj_t BgL_pairz00_2142;

									{
										BgL_externz00_bglt BgL_auxz00_4624;

										BgL_auxz00_4624 = (BgL_externz00_bglt) (BgL_nodez00_1438);
										BgL_pairz00_2142 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4624))->
											BgL_exprza2za2);
									}
									BgL_arg3569z00_1448 = CAR(BgL_pairz00_2142);
								}
								BgL_arg3570z00_1449 =
									(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1438))->BgL_vtypez00);
								{	/* Coerce/coerce.scm 183 */
									BgL_nodez00_bglt BgL_res3765z00_2173;

									{	/* Coerce/coerce.scm 183 */
										BgL_nodez00_bglt BgL_nodez00_2144;

										bool_t BgL_safez00_2147;

										BgL_nodez00_2144 = (BgL_nodez00_bglt) (BgL_arg3569z00_1448);
										BgL_safez00_2147 = CBOOL(BgL_safez00_1441);
										{	/* Coerce/coerce.scm 183 */
											obj_t BgL_method3391z00_2148;

											{	/* Coerce/coerce.scm 183 */
												BgL_objectz00_bglt BgL_objz00_2149;

												BgL_objz00_2149 =
													(BgL_objectz00_bglt) (BgL_nodez00_2144);
												{	/* Coerce/coerce.scm 183 */
													long BgL_objzd2classzd2numz00_2150;

													BgL_objzd2classzd2numz00_2150 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2149);
													{	/* Coerce/coerce.scm 183 */
														obj_t BgL_arg2334z00_2151;

														BgL_arg2334z00_2151 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 183 */
															obj_t BgL_arrayz00_2153;

															int BgL_offsetz00_2154;

															BgL_arrayz00_2153 = BgL_arg2334z00_2151;
															BgL_offsetz00_2154 =
																(int) (BgL_objzd2classzd2numz00_2150);
															{	/* Coerce/coerce.scm 183 */
																long BgL_offsetz00_2155;

																BgL_offsetz00_2155 =
																	((long) (BgL_offsetz00_2154) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 183 */
																	long BgL_modz00_2156;

																	{	/* Coerce/coerce.scm 183 */
																		int BgL_arg2336z00_2157;

																		BgL_arg2336z00_2157 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 183 */
																			long BgL_auxz00_4639;

																			BgL_auxz00_4639 =
																				(long) (BgL_arg2336z00_2157);
																			BgL_modz00_2156 =
																				(BgL_offsetz00_2155 / BgL_auxz00_4639);
																	}}
																	{	/* Coerce/coerce.scm 183 */
																		long BgL_restz00_2158;

																		{	/* Coerce/coerce.scm 183 */
																			int BgL_arg2335z00_2159;

																			BgL_arg2335z00_2159 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 183 */
																				long BgL_auxz00_4643;

																				BgL_auxz00_4643 =
																					(long) (BgL_arg2335z00_2159);
																				BgL_restz00_2158 =
																					(BgL_offsetz00_2155 %
																					BgL_auxz00_4643);
																		}}
																		{	/* Coerce/coerce.scm 183 */

																			BgL_method3391z00_2148 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2153,
																					(int) (BgL_modz00_2156)),
																				(int) (BgL_restz00_2158));
											}}}}}}}}
											BgL_res3765z00_2173 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3391z00_2148) (BgL_method3391z00_2148,
													(obj_t) (BgL_nodez00_2144), BgL_callerz00_1439,
													(obj_t) (BgL_arg3570z00_1449),
													BBOOL(BgL_safez00_2147), BEOA));
									}}
									BgL_arg3568z00_1447 = BgL_res3765z00_2173;
							}}
							{	/* Coerce/coerce.scm 183 */
								obj_t BgL_auxz00_4656;

								BgL_auxz00_4656 = (obj_t) (BgL_arg3568z00_1447);
								SET_CAR(BgL_arg3567z00_1446, BgL_auxz00_4656);
						}}
						{	/* Coerce/coerce.scm 184 */
							obj_t BgL_arg3572z00_1451;

							BgL_nodez00_bglt BgL_arg3573z00_1452;

							{	/* Coerce/coerce.scm 184 */
								obj_t BgL_pairz00_2177;

								{
									BgL_externz00_bglt BgL_auxz00_4659;

									BgL_auxz00_4659 = (BgL_externz00_bglt) (BgL_nodez00_1438);
									BgL_pairz00_2177 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4659))->
										BgL_exprza2za2);
								}
								BgL_arg3572z00_1451 = CDR(BgL_pairz00_2177);
							}
							{	/* Coerce/coerce.scm 184 */
								obj_t BgL_arg3575z00_1454;

								BgL_typez00_bglt BgL_arg3577z00_1455;

								{	/* Coerce/coerce.scm 184 */
									obj_t BgL_pairz00_2179;

									{
										BgL_externz00_bglt BgL_auxz00_4663;

										BgL_auxz00_4663 = (BgL_externz00_bglt) (BgL_nodez00_1438);
										BgL_pairz00_2179 =
											(((BgL_externz00_bglt) CREF(BgL_auxz00_4663))->
											BgL_exprza2za2);
									}
									BgL_arg3575z00_1454 = CAR(CDR(BgL_pairz00_2179));
								}
								BgL_arg3577z00_1455 =
									(((BgL_vrefz00_bglt) CREF(BgL_nodez00_1438))->BgL_otypez00);
								{	/* Coerce/coerce.scm 184 */
									BgL_nodez00_bglt BgL_res3768z00_2213;

									{	/* Coerce/coerce.scm 184 */
										BgL_nodez00_bglt BgL_nodez00_2184;

										bool_t BgL_safez00_2187;

										BgL_nodez00_2184 = (BgL_nodez00_bglt) (BgL_arg3575z00_1454);
										BgL_safez00_2187 = CBOOL(BgL_safez00_1441);
										{	/* Coerce/coerce.scm 184 */
											obj_t BgL_method3391z00_2188;

											{	/* Coerce/coerce.scm 184 */
												BgL_objectz00_bglt BgL_objz00_2189;

												BgL_objz00_2189 =
													(BgL_objectz00_bglt) (BgL_nodez00_2184);
												{	/* Coerce/coerce.scm 184 */
													long BgL_objzd2classzd2numz00_2190;

													BgL_objzd2classzd2numz00_2190 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_2189);
													{	/* Coerce/coerce.scm 184 */
														obj_t BgL_arg2334z00_2191;

														BgL_arg2334z00_2191 =
															PROCEDURE_REF
															(BGl_coercez12zd2envzc0zzcoerce_coercez00,
															(int) (((long) 1)));
														{	/* Coerce/coerce.scm 184 */
															obj_t BgL_arrayz00_2193;

															int BgL_offsetz00_2194;

															BgL_arrayz00_2193 = BgL_arg2334z00_2191;
															BgL_offsetz00_2194 =
																(int) (BgL_objzd2classzd2numz00_2190);
															{	/* Coerce/coerce.scm 184 */
																long BgL_offsetz00_2195;

																BgL_offsetz00_2195 =
																	((long) (BgL_offsetz00_2194) - OBJECT_TYPE);
																{	/* Coerce/coerce.scm 184 */
																	long BgL_modz00_2196;

																	{	/* Coerce/coerce.scm 184 */
																		int BgL_arg2336z00_2197;

																		BgL_arg2336z00_2197 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 184 */
																			long BgL_auxz00_4679;

																			BgL_auxz00_4679 =
																				(long) (BgL_arg2336z00_2197);
																			BgL_modz00_2196 =
																				(BgL_offsetz00_2195 / BgL_auxz00_4679);
																	}}
																	{	/* Coerce/coerce.scm 184 */
																		long BgL_restz00_2198;

																		{	/* Coerce/coerce.scm 184 */
																			int BgL_arg2335z00_2199;

																			BgL_arg2335z00_2199 = (int) (((long) 8));
																			{	/* Coerce/coerce.scm 184 */
																				long BgL_auxz00_4683;

																				BgL_auxz00_4683 =
																					(long) (BgL_arg2335z00_2199);
																				BgL_restz00_2198 =
																					(BgL_offsetz00_2195 %
																					BgL_auxz00_4683);
																		}}
																		{	/* Coerce/coerce.scm 184 */

																			BgL_method3391z00_2188 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_2193,
																					(int) (BgL_modz00_2196)),
																				(int) (BgL_restz00_2198));
											}}}}}}}}
											BgL_res3768z00_2213 =
												(BgL_nodez00_bglt) (PROCEDURE_ENTRY
												(BgL_method3391z00_2188) (BgL_method3391z00_2188,
													(obj_t) (BgL_nodez00_2184), BgL_callerz00_1439,
													(obj_t) (BgL_arg3577z00_1455),
													BBOOL(BgL_safez00_2187), BEOA));
									}}
									BgL_arg3573z00_1452 = BgL_res3768z00_2213;
							}}
							{	/* Coerce/coerce.scm 184 */
								obj_t BgL_auxz00_4696;

								BgL_auxz00_4696 = (obj_t) (BgL_arg3573z00_1452);
								SET_CAR(BgL_arg3572z00_1451, BgL_auxz00_4696);
						}}
						BgL_auxz00_4614 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1438),
							(BgL_typez00_bglt) (BgL_ftypez00_1445),
							(BgL_typez00_bglt) (BgL_toz00_1440), CBOOL(BgL_safez00_1441));
					}
					return (obj_t) (BgL_auxz00_4614);
				}
			}
		}
	}



/* coerce!-valloc3414 */
	obj_t BGl_coercez12zd2valloc3414zc0zzcoerce_coercez00(obj_t BgL_envz00_3302,
		obj_t BgL_nodez00_3303, obj_t BgL_callerz00_3304, obj_t BgL_toz00_3305,
		obj_t BgL_safez00_3306)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 166 */
			{
				BgL_vallocz00_bglt BgL_nodez00_1423;

				obj_t BgL_callerz00_1424;

				obj_t BgL_toz00_1425;

				obj_t BgL_safez00_1426;

				{	/* Coerce/coerce.scm 167 */
					BgL_nodez00_bglt BgL_auxz00_4706;

					BgL_nodez00_1423 = (BgL_vallocz00_bglt) (BgL_nodez00_3303);
					BgL_callerz00_1424 = BgL_callerz00_3304;
					BgL_toz00_1425 = BgL_toz00_3305;
					BgL_safez00_1426 = BgL_safez00_3306;
					{	/* Coerce/coerce.scm 168 */
						obj_t BgL_arg3560z00_1430;

						BgL_nodez00_bglt BgL_arg3561z00_1431;

						{
							BgL_externz00_bglt BgL_auxz00_4707;

							BgL_auxz00_4707 = (BgL_externz00_bglt) (BgL_nodez00_1423);
							BgL_arg3560z00_1430 =
								(((BgL_externz00_bglt) CREF(BgL_auxz00_4707))->BgL_exprza2za2);
						}
						{	/* Coerce/coerce.scm 168 */
							obj_t BgL_arg3562z00_1432;

							BgL_typez00_bglt BgL_arg3563z00_1433;

							{	/* Coerce/coerce.scm 168 */
								obj_t BgL_pairz00_2103;

								{
									BgL_externz00_bglt BgL_auxz00_4710;

									BgL_auxz00_4710 = (BgL_externz00_bglt) (BgL_nodez00_1423);
									BgL_pairz00_2103 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4710))->
										BgL_exprza2za2);
								}
								BgL_arg3562z00_1432 = CAR(BgL_pairz00_2103);
							}
							BgL_arg3563z00_1433 =
								(((BgL_vallocz00_bglt) CREF(BgL_nodez00_1423))->BgL_otypez00);
							{	/* Coerce/coerce.scm 168 */
								BgL_nodez00_bglt BgL_res3762z00_2134;

								{	/* Coerce/coerce.scm 168 */
									BgL_nodez00_bglt BgL_nodez00_2105;

									bool_t BgL_safez00_2108;

									BgL_nodez00_2105 = (BgL_nodez00_bglt) (BgL_arg3562z00_1432);
									BgL_safez00_2108 = CBOOL(BgL_safez00_1426);
									{	/* Coerce/coerce.scm 168 */
										obj_t BgL_method3391z00_2109;

										{	/* Coerce/coerce.scm 168 */
											BgL_objectz00_bglt BgL_objz00_2110;

											BgL_objz00_2110 = (BgL_objectz00_bglt) (BgL_nodez00_2105);
											{	/* Coerce/coerce.scm 168 */
												long BgL_objzd2classzd2numz00_2111;

												BgL_objzd2classzd2numz00_2111 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2110);
												{	/* Coerce/coerce.scm 168 */
													obj_t BgL_arg2334z00_2112;

													BgL_arg2334z00_2112 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 168 */
														obj_t BgL_arrayz00_2114;

														int BgL_offsetz00_2115;

														BgL_arrayz00_2114 = BgL_arg2334z00_2112;
														BgL_offsetz00_2115 =
															(int) (BgL_objzd2classzd2numz00_2111);
														{	/* Coerce/coerce.scm 168 */
															long BgL_offsetz00_2116;

															BgL_offsetz00_2116 =
																((long) (BgL_offsetz00_2115) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 168 */
																long BgL_modz00_2117;

																{	/* Coerce/coerce.scm 168 */
																	int BgL_arg2336z00_2118;

																	BgL_arg2336z00_2118 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 168 */
																		long BgL_auxz00_4725;

																		BgL_auxz00_4725 =
																			(long) (BgL_arg2336z00_2118);
																		BgL_modz00_2117 =
																			(BgL_offsetz00_2116 / BgL_auxz00_4725);
																}}
																{	/* Coerce/coerce.scm 168 */
																	long BgL_restz00_2119;

																	{	/* Coerce/coerce.scm 168 */
																		int BgL_arg2335z00_2120;

																		BgL_arg2335z00_2120 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 168 */
																			long BgL_auxz00_4729;

																			BgL_auxz00_4729 =
																				(long) (BgL_arg2335z00_2120);
																			BgL_restz00_2119 =
																				(BgL_offsetz00_2116 % BgL_auxz00_4729);
																	}}
																	{	/* Coerce/coerce.scm 168 */

																		BgL_method3391z00_2109 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2114,
																				(int) (BgL_modz00_2117)),
																			(int) (BgL_restz00_2119));
										}}}}}}}}
										BgL_res3762z00_2134 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2109) (BgL_method3391z00_2109,
												(obj_t) (BgL_nodez00_2105), BgL_callerz00_1424,
												(obj_t) (BgL_arg3563z00_1433), BBOOL(BgL_safez00_2108),
												BEOA));
								}}
								BgL_arg3561z00_1431 = BgL_res3762z00_2134;
						}}
						{	/* Coerce/coerce.scm 168 */
							obj_t BgL_auxz00_4742;

							BgL_auxz00_4742 = (obj_t) (BgL_arg3561z00_1431);
							SET_CAR(BgL_arg3560z00_1430, BgL_auxz00_4742);
					}}
					{	/* Coerce/coerce.scm 169 */
						BgL_typez00_bglt BgL_arg3565z00_1435;

						{
							BgL_nodez00_bglt BgL_auxz00_4745;

							BgL_auxz00_4745 = (BgL_nodez00_bglt) (BgL_nodez00_1423);
							BgL_arg3565z00_1435 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_4745))->BgL_typez00);
						}
						BgL_auxz00_4706 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1423), BgL_arg3565z00_1435,
							(BgL_typez00_bglt) (BgL_toz00_1425), CBOOL(BgL_safez00_1426));
					}
					return (obj_t) (BgL_auxz00_4706);
				}
			}
		}
	}



/* coerce!-new3412 */
	obj_t BGl_coercez12zd2new3412zc0zzcoerce_coercez00(obj_t BgL_envz00_3307,
		obj_t BgL_nodez00_3308, obj_t BgL_callerz00_3309, obj_t BgL_toz00_3310,
		obj_t BgL_safez00_3311)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 150 */
			{
				BgL_newz00_bglt BgL_nodez00_1403;

				obj_t BgL_callerz00_1404;

				obj_t BgL_toz00_1405;

				obj_t BgL_safez00_1406;

				{	/* Coerce/coerce.scm 151 */
					BgL_nodez00_bglt BgL_auxz00_4754;

					BgL_nodez00_1403 = (BgL_newz00_bglt) (BgL_nodez00_3308);
					BgL_callerz00_1404 = BgL_callerz00_3309;
					BgL_toz00_1405 = BgL_toz00_3310;
					BgL_safez00_1406 = BgL_safez00_3311;
					{
						obj_t BgL_lz00_1410;

						{	/* Coerce/coerce.scm 152 */
							obj_t BgL_arg3549z00_1412;

							{
								BgL_externz00_bglt BgL_auxz00_4755;

								BgL_auxz00_4755 = (BgL_externz00_bglt) (BgL_nodez00_1403);
								BgL_arg3549z00_1412 =
									(((BgL_externz00_bglt) CREF(BgL_auxz00_4755))->
									BgL_exprza2za2);
							}
							BgL_lz00_1410 = BgL_arg3549z00_1412;
						BgL_loopz00_1411:
							if (NULLP(BgL_lz00_1410))
								{	/* Coerce/coerce.scm 154 */
									BgL_typez00_bglt BgL_arg3552z00_1414;

									{
										BgL_nodez00_bglt BgL_auxz00_4760;

										BgL_auxz00_4760 = (BgL_nodez00_bglt) (BgL_nodez00_1403);
										BgL_arg3552z00_1414 =
											(((BgL_nodez00_bglt) CREF(BgL_auxz00_4760))->BgL_typez00);
									}
									BGl_convertz12z12zzcoerce_convertz00(
										(BgL_nodez00_bglt) (BgL_nodez00_1403), BgL_arg3552z00_1414,
										(BgL_typez00_bglt) (BgL_toz00_1405),
										CBOOL(BgL_safez00_1406));
								}
							else
								{	/* Coerce/coerce.scm 153 */
									{	/* Coerce/coerce.scm 156 */
										BgL_nodez00_bglt BgL_arg3553z00_1415;

										{	/* Coerce/coerce.scm 156 */
											obj_t BgL_arg3554z00_1416;

											BgL_typez00_bglt BgL_arg3555z00_1417;

											BgL_arg3554z00_1416 = CAR(BgL_lz00_1410);
											{	/* Coerce/coerce.scm 158 */
												obj_t BgL_arg3556z00_1418;

												BgL_arg3556z00_1418 = CAR(BgL_lz00_1410);
												BgL_arg3555z00_1417 =
													BGl_typeofz00zztype_typeofz00(
													(BgL_nodez00_bglt) (BgL_arg3556z00_1418));
											}
											{	/* Coerce/coerce.scm 156 */
												BgL_nodez00_bglt BgL_res3759z00_2096;

												{	/* Coerce/coerce.scm 156 */
													BgL_nodez00_bglt BgL_nodez00_2067;

													bool_t BgL_safez00_2070;

													BgL_nodez00_2067 =
														(BgL_nodez00_bglt) (BgL_arg3554z00_1416);
													BgL_safez00_2070 = CBOOL(BgL_safez00_1406);
													{	/* Coerce/coerce.scm 156 */
														obj_t BgL_method3391z00_2071;

														{	/* Coerce/coerce.scm 156 */
															BgL_objectz00_bglt BgL_objz00_2072;

															BgL_objz00_2072 =
																(BgL_objectz00_bglt) (BgL_nodez00_2067);
															{	/* Coerce/coerce.scm 156 */
																long BgL_objzd2classzd2numz00_2073;

																BgL_objzd2classzd2numz00_2073 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_2072);
																{	/* Coerce/coerce.scm 156 */
																	obj_t BgL_arg2334z00_2074;

																	BgL_arg2334z00_2074 =
																		PROCEDURE_REF
																		(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																		(int) (((long) 1)));
																	{	/* Coerce/coerce.scm 156 */
																		obj_t BgL_arrayz00_2076;

																		int BgL_offsetz00_2077;

																		BgL_arrayz00_2076 = BgL_arg2334z00_2074;
																		BgL_offsetz00_2077 =
																			(int) (BgL_objzd2classzd2numz00_2073);
																		{	/* Coerce/coerce.scm 156 */
																			long BgL_offsetz00_2078;

																			BgL_offsetz00_2078 =
																				(
																				(long) (BgL_offsetz00_2077) -
																				OBJECT_TYPE);
																			{	/* Coerce/coerce.scm 156 */
																				long BgL_modz00_2079;

																				{	/* Coerce/coerce.scm 156 */
																					int BgL_arg2336z00_2080;

																					BgL_arg2336z00_2080 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 156 */
																						long BgL_auxz00_4781;

																						BgL_auxz00_4781 =
																							(long) (BgL_arg2336z00_2080);
																						BgL_modz00_2079 =
																							(BgL_offsetz00_2078 /
																							BgL_auxz00_4781);
																				}}
																				{	/* Coerce/coerce.scm 156 */
																					long BgL_restz00_2081;

																					{	/* Coerce/coerce.scm 156 */
																						int BgL_arg2335z00_2082;

																						BgL_arg2335z00_2082 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 156 */
																							long BgL_auxz00_4785;

																							BgL_auxz00_4785 =
																								(long) (BgL_arg2335z00_2082);
																							BgL_restz00_2081 =
																								(BgL_offsetz00_2078 %
																								BgL_auxz00_4785);
																					}}
																					{	/* Coerce/coerce.scm 156 */

																						BgL_method3391z00_2071 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_2076,
																								(int) (BgL_modz00_2079)),
																							(int) (BgL_restz00_2081));
														}}}}}}}}
														BgL_res3759z00_2096 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3391z00_2071) (BgL_method3391z00_2071,
																(obj_t) (BgL_nodez00_2067), BgL_callerz00_1404,
																(obj_t) (BgL_arg3555z00_1417),
																BBOOL(BgL_safez00_2070), BEOA));
												}}
												BgL_arg3553z00_1415 = BgL_res3759z00_2096;
										}}
										{	/* Coerce/coerce.scm 156 */
											obj_t BgL_auxz00_4798;

											BgL_auxz00_4798 = (obj_t) (BgL_arg3553z00_1415);
											SET_CAR(BgL_lz00_1410, BgL_auxz00_4798);
									}}
									{
										obj_t BgL_lz00_4801;

										BgL_lz00_4801 = CDR(BgL_lz00_1410);
										BgL_lz00_1410 = BgL_lz00_4801;
										goto BgL_loopz00_1411;
									}
								}
						}
					}
					{	/* Coerce/coerce.scm 161 */
						BgL_typez00_bglt BgL_arg3558z00_1420;

						{
							BgL_nodez00_bglt BgL_auxz00_4803;

							BgL_auxz00_4803 = (BgL_nodez00_bglt) (BgL_nodez00_1403);
							BgL_arg3558z00_1420 =
								(((BgL_nodez00_bglt) CREF(BgL_auxz00_4803))->BgL_typez00);
						}
						BgL_auxz00_4754 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1403), BgL_arg3558z00_1420,
							(BgL_typez00_bglt) (BgL_toz00_1405), CBOOL(BgL_safez00_1406));
					}
					return (obj_t) (BgL_auxz00_4754);
				}
			}
		}
	}



/* coerce!-setfield3410 */
	obj_t BGl_coercez12zd2setfield3410zc0zzcoerce_coercez00(obj_t BgL_envz00_3312,
		obj_t BgL_nodez00_3313, obj_t BgL_callerz00_3314, obj_t BgL_toz00_3315,
		obj_t BgL_safez00_3316)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 141 */
			{
				BgL_setfieldz00_bglt BgL_nodez00_1384;

				obj_t BgL_callerz00_1385;

				obj_t BgL_toz00_1386;

				obj_t BgL_safez00_1387;

				{	/* Coerce/coerce.scm 142 */
					BgL_nodez00_bglt BgL_auxz00_4812;

					BgL_nodez00_1384 = (BgL_setfieldz00_bglt) (BgL_nodez00_3313);
					BgL_callerz00_1385 = BgL_callerz00_3314;
					BgL_toz00_1386 = BgL_toz00_3315;
					BgL_safez00_1387 = BgL_safez00_3316;
					{	/* Coerce/coerce.scm 143 */
						obj_t BgL_arg3538z00_1391;

						BgL_nodez00_bglt BgL_arg3539z00_1392;

						{
							BgL_externz00_bglt BgL_auxz00_4813;

							BgL_auxz00_4813 = (BgL_externz00_bglt) (BgL_nodez00_1384);
							BgL_arg3538z00_1391 =
								(((BgL_externz00_bglt) CREF(BgL_auxz00_4813))->BgL_exprza2za2);
						}
						{	/* Coerce/coerce.scm 143 */
							obj_t BgL_arg3540z00_1393;

							{	/* Coerce/coerce.scm 143 */
								obj_t BgL_pairz00_1989;

								{
									BgL_externz00_bglt BgL_auxz00_4816;

									BgL_auxz00_4816 = (BgL_externz00_bglt) (BgL_nodez00_1384);
									BgL_pairz00_1989 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4816))->
										BgL_exprza2za2);
								}
								BgL_arg3540z00_1393 = CAR(BgL_pairz00_1989);
							}
							{	/* Coerce/coerce.scm 143 */
								BgL_nodez00_bglt BgL_res3753z00_2019;

								{	/* Coerce/coerce.scm 143 */
									BgL_nodez00_bglt BgL_nodez00_1990;

									BgL_typez00_bglt BgL_toz00_1992;

									bool_t BgL_safez00_1993;

									BgL_nodez00_1990 = (BgL_nodez00_bglt) (BgL_arg3540z00_1393);
									BgL_toz00_1992 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_1993 = CBOOL(BgL_safez00_1387);
									{	/* Coerce/coerce.scm 143 */
										obj_t BgL_method3391z00_1994;

										{	/* Coerce/coerce.scm 143 */
											BgL_objectz00_bglt BgL_objz00_1995;

											BgL_objz00_1995 = (BgL_objectz00_bglt) (BgL_nodez00_1990);
											{	/* Coerce/coerce.scm 143 */
												long BgL_objzd2classzd2numz00_1996;

												BgL_objzd2classzd2numz00_1996 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1995);
												{	/* Coerce/coerce.scm 143 */
													obj_t BgL_arg2334z00_1997;

													BgL_arg2334z00_1997 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 143 */
														obj_t BgL_arrayz00_1999;

														int BgL_offsetz00_2000;

														BgL_arrayz00_1999 = BgL_arg2334z00_1997;
														BgL_offsetz00_2000 =
															(int) (BgL_objzd2classzd2numz00_1996);
														{	/* Coerce/coerce.scm 143 */
															long BgL_offsetz00_2001;

															BgL_offsetz00_2001 =
																((long) (BgL_offsetz00_2000) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 143 */
																long BgL_modz00_2002;

																{	/* Coerce/coerce.scm 143 */
																	int BgL_arg2336z00_2003;

																	BgL_arg2336z00_2003 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 143 */
																		long BgL_auxz00_4831;

																		BgL_auxz00_4831 =
																			(long) (BgL_arg2336z00_2003);
																		BgL_modz00_2002 =
																			(BgL_offsetz00_2001 / BgL_auxz00_4831);
																}}
																{	/* Coerce/coerce.scm 143 */
																	long BgL_restz00_2004;

																	{	/* Coerce/coerce.scm 143 */
																		int BgL_arg2335z00_2005;

																		BgL_arg2335z00_2005 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 143 */
																			long BgL_auxz00_4835;

																			BgL_auxz00_4835 =
																				(long) (BgL_arg2335z00_2005);
																			BgL_restz00_2004 =
																				(BgL_offsetz00_2001 % BgL_auxz00_4835);
																	}}
																	{	/* Coerce/coerce.scm 143 */

																		BgL_method3391z00_1994 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1999,
																				(int) (BgL_modz00_2002)),
																			(int) (BgL_restz00_2004));
										}}}}}}}}
										BgL_res3753z00_2019 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_1994) (BgL_method3391z00_1994,
												(obj_t) (BgL_nodez00_1990), BgL_callerz00_1385,
												(obj_t) (BgL_toz00_1992), BBOOL(BgL_safez00_1993),
												BEOA));
								}}
								BgL_arg3539z00_1392 = BgL_res3753z00_2019;
						}}
						{	/* Coerce/coerce.scm 143 */
							obj_t BgL_auxz00_4848;

							BgL_auxz00_4848 = (obj_t) (BgL_arg3539z00_1392);
							SET_CAR(BgL_arg3538z00_1391, BgL_auxz00_4848);
					}}
					{	/* Coerce/coerce.scm 144 */
						obj_t BgL_arg3542z00_1395;

						BgL_nodez00_bglt BgL_arg3543z00_1396;

						{	/* Coerce/coerce.scm 144 */
							obj_t BgL_pairz00_2023;

							{
								BgL_externz00_bglt BgL_auxz00_4851;

								BgL_auxz00_4851 = (BgL_externz00_bglt) (BgL_nodez00_1384);
								BgL_pairz00_2023 =
									(((BgL_externz00_bglt) CREF(BgL_auxz00_4851))->
									BgL_exprza2za2);
							}
							BgL_arg3542z00_1395 = CDR(BgL_pairz00_2023);
						}
						{	/* Coerce/coerce.scm 144 */
							obj_t BgL_arg3545z00_1398;

							BgL_typez00_bglt BgL_arg3546z00_1399;

							{	/* Coerce/coerce.scm 144 */
								obj_t BgL_pairz00_2025;

								{
									BgL_externz00_bglt BgL_auxz00_4855;

									BgL_auxz00_4855 = (BgL_externz00_bglt) (BgL_nodez00_1384);
									BgL_pairz00_2025 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4855))->
										BgL_exprza2za2);
								}
								BgL_arg3545z00_1398 = CAR(CDR(BgL_pairz00_2025));
							}
							BgL_arg3546z00_1399 =
								(((BgL_setfieldz00_bglt) CREF(BgL_nodez00_1384))->BgL_ftypez00);
							{	/* Coerce/coerce.scm 144 */
								BgL_nodez00_bglt BgL_res3756z00_2059;

								{	/* Coerce/coerce.scm 144 */
									BgL_nodez00_bglt BgL_nodez00_2030;

									bool_t BgL_safez00_2033;

									BgL_nodez00_2030 = (BgL_nodez00_bglt) (BgL_arg3545z00_1398);
									BgL_safez00_2033 = CBOOL(BgL_safez00_1387);
									{	/* Coerce/coerce.scm 144 */
										obj_t BgL_method3391z00_2034;

										{	/* Coerce/coerce.scm 144 */
											BgL_objectz00_bglt BgL_objz00_2035;

											BgL_objz00_2035 = (BgL_objectz00_bglt) (BgL_nodez00_2030);
											{	/* Coerce/coerce.scm 144 */
												long BgL_objzd2classzd2numz00_2036;

												BgL_objzd2classzd2numz00_2036 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2035);
												{	/* Coerce/coerce.scm 144 */
													obj_t BgL_arg2334z00_2037;

													BgL_arg2334z00_2037 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 144 */
														obj_t BgL_arrayz00_2039;

														int BgL_offsetz00_2040;

														BgL_arrayz00_2039 = BgL_arg2334z00_2037;
														BgL_offsetz00_2040 =
															(int) (BgL_objzd2classzd2numz00_2036);
														{	/* Coerce/coerce.scm 144 */
															long BgL_offsetz00_2041;

															BgL_offsetz00_2041 =
																((long) (BgL_offsetz00_2040) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 144 */
																long BgL_modz00_2042;

																{	/* Coerce/coerce.scm 144 */
																	int BgL_arg2336z00_2043;

																	BgL_arg2336z00_2043 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 144 */
																		long BgL_auxz00_4871;

																		BgL_auxz00_4871 =
																			(long) (BgL_arg2336z00_2043);
																		BgL_modz00_2042 =
																			(BgL_offsetz00_2041 / BgL_auxz00_4871);
																}}
																{	/* Coerce/coerce.scm 144 */
																	long BgL_restz00_2044;

																	{	/* Coerce/coerce.scm 144 */
																		int BgL_arg2335z00_2045;

																		BgL_arg2335z00_2045 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 144 */
																			long BgL_auxz00_4875;

																			BgL_auxz00_4875 =
																				(long) (BgL_arg2335z00_2045);
																			BgL_restz00_2044 =
																				(BgL_offsetz00_2041 % BgL_auxz00_4875);
																	}}
																	{	/* Coerce/coerce.scm 144 */

																		BgL_method3391z00_2034 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2039,
																				(int) (BgL_modz00_2042)),
																			(int) (BgL_restz00_2044));
										}}}}}}}}
										BgL_res3756z00_2059 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_2034) (BgL_method3391z00_2034,
												(obj_t) (BgL_nodez00_2030), BgL_callerz00_1385,
												(obj_t) (BgL_arg3546z00_1399), BBOOL(BgL_safez00_2033),
												BEOA));
								}}
								BgL_arg3543z00_1396 = BgL_res3756z00_2059;
						}}
						{	/* Coerce/coerce.scm 144 */
							obj_t BgL_auxz00_4888;

							BgL_auxz00_4888 = (obj_t) (BgL_arg3543z00_1396);
							SET_CAR(BgL_arg3542z00_1395, BgL_auxz00_4888);
					}}
					BgL_auxz00_4812 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1384),
						(BgL_typez00_bglt) (BGl_za2unspecza2z00zztype_cachez00),
						(BgL_typez00_bglt) (BgL_toz00_1386), CBOOL(BgL_safez00_1387));
					return (obj_t) (BgL_auxz00_4812);
				}
			}
		}
	}



/* coerce!-getfield3408 */
	obj_t BGl_coercez12zd2getfield3408zc0zzcoerce_coercez00(obj_t BgL_envz00_3317,
		obj_t BgL_nodez00_3318, obj_t BgL_callerz00_3319, obj_t BgL_toz00_3320,
		obj_t BgL_safez00_3321)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 130 */
			{
				BgL_getfieldz00_bglt BgL_nodez00_1370;

				obj_t BgL_callerz00_1371;

				obj_t BgL_toz00_1372;

				obj_t BgL_safez00_1373;

				{	/* Coerce/coerce.scm 131 */
					BgL_nodez00_bglt BgL_auxz00_4898;

					BgL_nodez00_1370 = (BgL_getfieldz00_bglt) (BgL_nodez00_3318);
					BgL_callerz00_1371 = BgL_callerz00_3319;
					BgL_toz00_1372 = BgL_toz00_3320;
					BgL_safez00_1373 = BgL_safez00_3321;
					{	/* Coerce/coerce.scm 135 */
						obj_t BgL_arg3532z00_1377;

						BgL_nodez00_bglt BgL_arg3533z00_1378;

						{
							BgL_externz00_bglt BgL_auxz00_4899;

							BgL_auxz00_4899 = (BgL_externz00_bglt) (BgL_nodez00_1370);
							BgL_arg3532z00_1377 =
								(((BgL_externz00_bglt) CREF(BgL_auxz00_4899))->BgL_exprza2za2);
						}
						{	/* Coerce/coerce.scm 135 */
							obj_t BgL_arg3534z00_1379;

							{	/* Coerce/coerce.scm 135 */
								obj_t BgL_pairz00_1953;

								{
									BgL_externz00_bglt BgL_auxz00_4902;

									BgL_auxz00_4902 = (BgL_externz00_bglt) (BgL_nodez00_1370);
									BgL_pairz00_1953 =
										(((BgL_externz00_bglt) CREF(BgL_auxz00_4902))->
										BgL_exprza2za2);
								}
								BgL_arg3534z00_1379 = CAR(BgL_pairz00_1953);
							}
							{	/* Coerce/coerce.scm 135 */
								BgL_nodez00_bglt BgL_res3750z00_1983;

								{	/* Coerce/coerce.scm 135 */
									BgL_nodez00_bglt BgL_nodez00_1954;

									BgL_typez00_bglt BgL_toz00_1956;

									bool_t BgL_safez00_1957;

									BgL_nodez00_1954 = (BgL_nodez00_bglt) (BgL_arg3534z00_1379);
									BgL_toz00_1956 =
										(BgL_typez00_bglt) (BGl_za2objza2z00zztype_cachez00);
									BgL_safez00_1957 = CBOOL(BgL_safez00_1373);
									{	/* Coerce/coerce.scm 135 */
										obj_t BgL_method3391z00_1958;

										{	/* Coerce/coerce.scm 135 */
											BgL_objectz00_bglt BgL_objz00_1959;

											BgL_objz00_1959 = (BgL_objectz00_bglt) (BgL_nodez00_1954);
											{	/* Coerce/coerce.scm 135 */
												long BgL_objzd2classzd2numz00_1960;

												BgL_objzd2classzd2numz00_1960 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1959);
												{	/* Coerce/coerce.scm 135 */
													obj_t BgL_arg2334z00_1961;

													BgL_arg2334z00_1961 =
														PROCEDURE_REF
														(BGl_coercez12zd2envzc0zzcoerce_coercez00,
														(int) (((long) 1)));
													{	/* Coerce/coerce.scm 135 */
														obj_t BgL_arrayz00_1963;

														int BgL_offsetz00_1964;

														BgL_arrayz00_1963 = BgL_arg2334z00_1961;
														BgL_offsetz00_1964 =
															(int) (BgL_objzd2classzd2numz00_1960);
														{	/* Coerce/coerce.scm 135 */
															long BgL_offsetz00_1965;

															BgL_offsetz00_1965 =
																((long) (BgL_offsetz00_1964) - OBJECT_TYPE);
															{	/* Coerce/coerce.scm 135 */
																long BgL_modz00_1966;

																{	/* Coerce/coerce.scm 135 */
																	int BgL_arg2336z00_1967;

																	BgL_arg2336z00_1967 = (int) (((long) 8));
																	{	/* Coerce/coerce.scm 135 */
																		long BgL_auxz00_4917;

																		BgL_auxz00_4917 =
																			(long) (BgL_arg2336z00_1967);
																		BgL_modz00_1966 =
																			(BgL_offsetz00_1965 / BgL_auxz00_4917);
																}}
																{	/* Coerce/coerce.scm 135 */
																	long BgL_restz00_1968;

																	{	/* Coerce/coerce.scm 135 */
																		int BgL_arg2335z00_1969;

																		BgL_arg2335z00_1969 = (int) (((long) 8));
																		{	/* Coerce/coerce.scm 135 */
																			long BgL_auxz00_4921;

																			BgL_auxz00_4921 =
																				(long) (BgL_arg2335z00_1969);
																			BgL_restz00_1968 =
																				(BgL_offsetz00_1965 % BgL_auxz00_4921);
																	}}
																	{	/* Coerce/coerce.scm 135 */

																		BgL_method3391z00_1958 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1963,
																				(int) (BgL_modz00_1966)),
																			(int) (BgL_restz00_1968));
										}}}}}}}}
										BgL_res3750z00_1983 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3391z00_1958) (BgL_method3391z00_1958,
												(obj_t) (BgL_nodez00_1954), BgL_callerz00_1371,
												(obj_t) (BgL_toz00_1956), BBOOL(BgL_safez00_1957),
												BEOA));
								}}
								BgL_arg3533z00_1378 = BgL_res3750z00_1983;
						}}
						{	/* Coerce/coerce.scm 135 */
							obj_t BgL_auxz00_4934;

							BgL_auxz00_4934 = (obj_t) (BgL_arg3533z00_1378);
							SET_CAR(BgL_arg3532z00_1377, BgL_auxz00_4934);
					}}
					{	/* Coerce/coerce.scm 136 */
						BgL_typez00_bglt BgL_arg3536z00_1381;

						BgL_arg3536z00_1381 =
							(((BgL_getfieldz00_bglt) CREF(BgL_nodez00_1370))->BgL_ftypez00);
						BgL_auxz00_4898 =
							BGl_convertz12z12zzcoerce_convertz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1370), BgL_arg3536z00_1381,
							(BgL_typez00_bglt) (BgL_toz00_1372), CBOOL(BgL_safez00_1373));
					}
					return (obj_t) (BgL_auxz00_4898);
				}
			}
		}
	}



/* coerce!-extern3406 */
	obj_t BGl_coercez12zd2extern3406zc0zzcoerce_coercez00(obj_t BgL_envz00_3322,
		obj_t BgL_nodez00_3323, obj_t BgL_callerz00_3324, obj_t BgL_toz00_3325,
		obj_t BgL_safez00_3326)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 115 */
			{
				BgL_externz00_bglt BgL_nodez00_1351;

				obj_t BgL_callerz00_1352;

				obj_t BgL_toz00_1353;

				obj_t BgL_safez00_1354;

				{	/* Coerce/coerce.scm 116 */
					BgL_nodez00_bglt BgL_auxz00_4944;

					BgL_nodez00_1351 = (BgL_externz00_bglt) (BgL_nodez00_3323);
					BgL_callerz00_1352 = BgL_callerz00_3324;
					BgL_toz00_1353 = BgL_toz00_3325;
					BgL_safez00_1354 = BgL_safez00_3326;
					{
						obj_t BgL_valuesz00_1358;

						{	/* Coerce/coerce.scm 117 */
							obj_t BgL_arg3523z00_1360;

							BgL_arg3523z00_1360 =
								(((BgL_externz00_bglt) CREF(BgL_nodez00_1351))->BgL_exprza2za2);
							BgL_valuesz00_1358 = BgL_arg3523z00_1360;
						BgL_loopz00_1359:
							if (NULLP(BgL_valuesz00_1358))
								{	/* Coerce/coerce.scm 118 */
									BgL_auxz00_4944 =
										BGl_convertz12z12zzcoerce_convertz00(
										(BgL_nodez00_bglt) (BgL_nodez00_1351),
										BGl_typeofz00zztype_typeofz00(
											(BgL_nodez00_bglt) (BgL_nodez00_1351)),
										(BgL_typez00_bglt) (BgL_toz00_1353),
										CBOOL(BgL_safez00_1354));
								}
							else
								{	/* Coerce/coerce.scm 118 */
									{	/* Coerce/coerce.scm 121 */
										BgL_nodez00_bglt BgL_arg3526z00_1363;

										{	/* Coerce/coerce.scm 121 */
											obj_t BgL_arg3527z00_1364;

											BgL_typez00_bglt BgL_arg3528z00_1365;

											BgL_arg3527z00_1364 = CAR(BgL_valuesz00_1358);
											{	/* Coerce/coerce.scm 123 */
												obj_t BgL_arg3529z00_1366;

												BgL_arg3529z00_1366 = CAR(BgL_valuesz00_1358);
												BgL_arg3528z00_1365 =
													BGl_typeofz00zztype_typeofz00(
													(BgL_nodez00_bglt) (BgL_arg3529z00_1366));
											}
											{	/* Coerce/coerce.scm 121 */
												BgL_nodez00_bglt BgL_res3747z00_1947;

												{	/* Coerce/coerce.scm 121 */
													BgL_nodez00_bglt BgL_nodez00_1918;

													bool_t BgL_safez00_1921;

													BgL_nodez00_1918 =
														(BgL_nodez00_bglt) (BgL_arg3527z00_1364);
													BgL_safez00_1921 = CBOOL(BgL_safez00_1354);
													{	/* Coerce/coerce.scm 121 */
														obj_t BgL_method3391z00_1922;

														{	/* Coerce/coerce.scm 121 */
															BgL_objectz00_bglt BgL_objz00_1923;

															BgL_objz00_1923 =
																(BgL_objectz00_bglt) (BgL_nodez00_1918);
															{	/* Coerce/coerce.scm 121 */
																long BgL_objzd2classzd2numz00_1924;

																BgL_objzd2classzd2numz00_1924 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_1923);
																{	/* Coerce/coerce.scm 121 */
																	obj_t BgL_arg2334z00_1925;

																	BgL_arg2334z00_1925 =
																		PROCEDURE_REF
																		(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																		(int) (((long) 1)));
																	{	/* Coerce/coerce.scm 121 */
																		obj_t BgL_arrayz00_1927;

																		int BgL_offsetz00_1928;

																		BgL_arrayz00_1927 = BgL_arg2334z00_1925;
																		BgL_offsetz00_1928 =
																			(int) (BgL_objzd2classzd2numz00_1924);
																		{	/* Coerce/coerce.scm 121 */
																			long BgL_offsetz00_1929;

																			BgL_offsetz00_1929 =
																				(
																				(long) (BgL_offsetz00_1928) -
																				OBJECT_TYPE);
																			{	/* Coerce/coerce.scm 121 */
																				long BgL_modz00_1930;

																				{	/* Coerce/coerce.scm 121 */
																					int BgL_arg2336z00_1931;

																					BgL_arg2336z00_1931 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 121 */
																						long BgL_auxz00_4968;

																						BgL_auxz00_4968 =
																							(long) (BgL_arg2336z00_1931);
																						BgL_modz00_1930 =
																							(BgL_offsetz00_1929 /
																							BgL_auxz00_4968);
																				}}
																				{	/* Coerce/coerce.scm 121 */
																					long BgL_restz00_1932;

																					{	/* Coerce/coerce.scm 121 */
																						int BgL_arg2335z00_1933;

																						BgL_arg2335z00_1933 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 121 */
																							long BgL_auxz00_4972;

																							BgL_auxz00_4972 =
																								(long) (BgL_arg2335z00_1933);
																							BgL_restz00_1932 =
																								(BgL_offsetz00_1929 %
																								BgL_auxz00_4972);
																					}}
																					{	/* Coerce/coerce.scm 121 */

																						BgL_method3391z00_1922 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_1927,
																								(int) (BgL_modz00_1930)),
																							(int) (BgL_restz00_1932));
														}}}}}}}}
														BgL_res3747z00_1947 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3391z00_1922) (BgL_method3391z00_1922,
																(obj_t) (BgL_nodez00_1918), BgL_callerz00_1352,
																(obj_t) (BgL_arg3528z00_1365),
																BBOOL(BgL_safez00_1921), BEOA));
												}}
												BgL_arg3526z00_1363 = BgL_res3747z00_1947;
										}}
										{	/* Coerce/coerce.scm 121 */
											obj_t BgL_auxz00_4985;

											BgL_auxz00_4985 = (obj_t) (BgL_arg3526z00_1363);
											SET_CAR(BgL_valuesz00_1358, BgL_auxz00_4985);
									}}
									{
										obj_t BgL_valuesz00_4988;

										BgL_valuesz00_4988 = CDR(BgL_valuesz00_1358);
										BgL_valuesz00_1358 = BgL_valuesz00_4988;
										goto BgL_loopz00_1359;
									}
								}
						}
					}
					return (obj_t) (BgL_auxz00_4944);
				}
			}
		}
	}



/* coerce!-sequence3404 */
	obj_t BGl_coercez12zd2sequence3404zc0zzcoerce_coercez00(obj_t BgL_envz00_3327,
		obj_t BgL_nodez00_3328, obj_t BgL_callerz00_3329, obj_t BgL_toz00_3330,
		obj_t BgL_safez00_3331)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 96 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1330;

				obj_t BgL_callerz00_1331;

				obj_t BgL_toz00_1332;

				obj_t BgL_safez00_1333;

				{	/* Coerce/coerce.scm 97 */
					BgL_sequencez00_bglt BgL_auxz00_4992;

					BgL_nodez00_1330 = (BgL_sequencez00_bglt) (BgL_nodez00_3328);
					BgL_callerz00_1331 = BgL_callerz00_3329;
					BgL_toz00_1332 = BgL_toz00_3330;
					BgL_safez00_1333 = BgL_safez00_3331;
					{
						obj_t BgL_hookz00_1337;

						{	/* Coerce/coerce.scm 98 */
							obj_t BgL_arg3512z00_1339;

							BgL_arg3512z00_1339 =
								(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1330))->BgL_nodesz00);
							BgL_hookz00_1337 = BgL_arg3512z00_1339;
						BgL_loopz00_1338:
							if (NULLP(CDR(BgL_hookz00_1337)))
								{	/* Coerce/coerce.scm 99 */
									{	/* Coerce/coerce.scm 101 */
										BgL_nodez00_bglt BgL_arg3514z00_1341;

										{	/* Coerce/coerce.scm 101 */
											obj_t BgL_arg3515z00_1342;

											BgL_arg3515z00_1342 = CAR(BgL_hookz00_1337);
											{	/* Coerce/coerce.scm 101 */
												BgL_nodez00_bglt BgL_res3741z00_1876;

												{	/* Coerce/coerce.scm 101 */
													BgL_nodez00_bglt BgL_nodez00_1847;

													BgL_typez00_bglt BgL_toz00_1849;

													bool_t BgL_safez00_1850;

													BgL_nodez00_1847 =
														(BgL_nodez00_bglt) (BgL_arg3515z00_1342);
													BgL_toz00_1849 = (BgL_typez00_bglt) (BgL_toz00_1332);
													BgL_safez00_1850 = CBOOL(BgL_safez00_1333);
													{	/* Coerce/coerce.scm 101 */
														obj_t BgL_method3391z00_1851;

														{	/* Coerce/coerce.scm 101 */
															BgL_objectz00_bglt BgL_objz00_1852;

															BgL_objz00_1852 =
																(BgL_objectz00_bglt) (BgL_nodez00_1847);
															{	/* Coerce/coerce.scm 101 */
																long BgL_objzd2classzd2numz00_1853;

																BgL_objzd2classzd2numz00_1853 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_1852);
																{	/* Coerce/coerce.scm 101 */
																	obj_t BgL_arg2334z00_1854;

																	BgL_arg2334z00_1854 =
																		PROCEDURE_REF
																		(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																		(int) (((long) 1)));
																	{	/* Coerce/coerce.scm 101 */
																		obj_t BgL_arrayz00_1856;

																		int BgL_offsetz00_1857;

																		BgL_arrayz00_1856 = BgL_arg2334z00_1854;
																		BgL_offsetz00_1857 =
																			(int) (BgL_objzd2classzd2numz00_1853);
																		{	/* Coerce/coerce.scm 101 */
																			long BgL_offsetz00_1858;

																			BgL_offsetz00_1858 =
																				(
																				(long) (BgL_offsetz00_1857) -
																				OBJECT_TYPE);
																			{	/* Coerce/coerce.scm 101 */
																				long BgL_modz00_1859;

																				{	/* Coerce/coerce.scm 101 */
																					int BgL_arg2336z00_1860;

																					BgL_arg2336z00_1860 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 101 */
																						long BgL_auxz00_5009;

																						BgL_auxz00_5009 =
																							(long) (BgL_arg2336z00_1860);
																						BgL_modz00_1859 =
																							(BgL_offsetz00_1858 /
																							BgL_auxz00_5009);
																				}}
																				{	/* Coerce/coerce.scm 101 */
																					long BgL_restz00_1861;

																					{	/* Coerce/coerce.scm 101 */
																						int BgL_arg2335z00_1862;

																						BgL_arg2335z00_1862 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 101 */
																							long BgL_auxz00_5013;

																							BgL_auxz00_5013 =
																								(long) (BgL_arg2335z00_1862);
																							BgL_restz00_1861 =
																								(BgL_offsetz00_1858 %
																								BgL_auxz00_5013);
																					}}
																					{	/* Coerce/coerce.scm 101 */

																						BgL_method3391z00_1851 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_1856,
																								(int) (BgL_modz00_1859)),
																							(int) (BgL_restz00_1861));
														}}}}}}}}
														BgL_res3741z00_1876 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3391z00_1851) (BgL_method3391z00_1851,
																(obj_t) (BgL_nodez00_1847), BgL_callerz00_1331,
																(obj_t) (BgL_toz00_1849),
																BBOOL(BgL_safez00_1850), BEOA));
												}}
												BgL_arg3514z00_1341 = BgL_res3741z00_1876;
										}}
										{	/* Coerce/coerce.scm 101 */
											obj_t BgL_auxz00_5026;

											BgL_auxz00_5026 = (obj_t) (BgL_arg3514z00_1341);
											SET_CAR(BgL_hookz00_1337, BgL_auxz00_5026);
									}}
									BgL_auxz00_4992 = BgL_nodez00_1330;
								}
							else
								{	/* Coerce/coerce.scm 99 */
									{	/* Coerce/coerce.scm 106 */
										BgL_nodez00_bglt BgL_arg3516z00_1343;

										{	/* Coerce/coerce.scm 106 */
											obj_t BgL_arg3517z00_1344;

											BgL_typez00_bglt BgL_arg3518z00_1345;

											BgL_arg3517z00_1344 = CAR(BgL_hookz00_1337);
											{	/* Coerce/coerce.scm 108 */
												obj_t BgL_arg3519z00_1346;

												BgL_arg3519z00_1346 = CAR(BgL_hookz00_1337);
												BgL_arg3518z00_1345 =
													BGl_typeofz00zztype_typeofz00(
													(BgL_nodez00_bglt) (BgL_arg3519z00_1346));
											}
											{	/* Coerce/coerce.scm 106 */
												BgL_nodez00_bglt BgL_res3744z00_1910;

												{	/* Coerce/coerce.scm 106 */
													BgL_nodez00_bglt BgL_nodez00_1881;

													bool_t BgL_safez00_1884;

													BgL_nodez00_1881 =
														(BgL_nodez00_bglt) (BgL_arg3517z00_1344);
													BgL_safez00_1884 = CBOOL(BgL_safez00_1333);
													{	/* Coerce/coerce.scm 106 */
														obj_t BgL_method3391z00_1885;

														{	/* Coerce/coerce.scm 106 */
															BgL_objectz00_bglt BgL_objz00_1886;

															BgL_objz00_1886 =
																(BgL_objectz00_bglt) (BgL_nodez00_1881);
															{	/* Coerce/coerce.scm 106 */
																long BgL_objzd2classzd2numz00_1887;

																BgL_objzd2classzd2numz00_1887 =
																	BGL_OBJECT_CLASS_NUM(BgL_objz00_1886);
																{	/* Coerce/coerce.scm 106 */
																	obj_t BgL_arg2334z00_1888;

																	BgL_arg2334z00_1888 =
																		PROCEDURE_REF
																		(BGl_coercez12zd2envzc0zzcoerce_coercez00,
																		(int) (((long) 1)));
																	{	/* Coerce/coerce.scm 106 */
																		obj_t BgL_arrayz00_1890;

																		int BgL_offsetz00_1891;

																		BgL_arrayz00_1890 = BgL_arg2334z00_1888;
																		BgL_offsetz00_1891 =
																			(int) (BgL_objzd2classzd2numz00_1887);
																		{	/* Coerce/coerce.scm 106 */
																			long BgL_offsetz00_1892;

																			BgL_offsetz00_1892 =
																				(
																				(long) (BgL_offsetz00_1891) -
																				OBJECT_TYPE);
																			{	/* Coerce/coerce.scm 106 */
																				long BgL_modz00_1893;

																				{	/* Coerce/coerce.scm 106 */
																					int BgL_arg2336z00_1894;

																					BgL_arg2336z00_1894 =
																						(int) (((long) 8));
																					{	/* Coerce/coerce.scm 106 */
																						long BgL_auxz00_5043;

																						BgL_auxz00_5043 =
																							(long) (BgL_arg2336z00_1894);
																						BgL_modz00_1893 =
																							(BgL_offsetz00_1892 /
																							BgL_auxz00_5043);
																				}}
																				{	/* Coerce/coerce.scm 106 */
																					long BgL_restz00_1895;

																					{	/* Coerce/coerce.scm 106 */
																						int BgL_arg2335z00_1896;

																						BgL_arg2335z00_1896 =
																							(int) (((long) 8));
																						{	/* Coerce/coerce.scm 106 */
																							long BgL_auxz00_5047;

																							BgL_auxz00_5047 =
																								(long) (BgL_arg2335z00_1896);
																							BgL_restz00_1895 =
																								(BgL_offsetz00_1892 %
																								BgL_auxz00_5047);
																					}}
																					{	/* Coerce/coerce.scm 106 */

																						BgL_method3391z00_1885 =
																							VECTOR_REF(VECTOR_REF
																							(BgL_arrayz00_1890,
																								(int) (BgL_modz00_1893)),
																							(int) (BgL_restz00_1895));
														}}}}}}}}
														BgL_res3744z00_1910 =
															(BgL_nodez00_bglt) (PROCEDURE_ENTRY
															(BgL_method3391z00_1885) (BgL_method3391z00_1885,
																(obj_t) (BgL_nodez00_1881), BgL_callerz00_1331,
																(obj_t) (BgL_arg3518z00_1345),
																BBOOL(BgL_safez00_1884), BEOA));
												}}
												BgL_arg3516z00_1343 = BgL_res3744z00_1910;
										}}
										{	/* Coerce/coerce.scm 106 */
											obj_t BgL_auxz00_5060;

											BgL_auxz00_5060 = (obj_t) (BgL_arg3516z00_1343);
											SET_CAR(BgL_hookz00_1337, BgL_auxz00_5060);
									}}
									{
										obj_t BgL_hookz00_5063;

										BgL_hookz00_5063 = CDR(BgL_hookz00_1337);
										BgL_hookz00_1337 = BgL_hookz00_5063;
										goto BgL_loopz00_1338;
									}
								}
						}
					}
					return (obj_t) (BgL_auxz00_4992);
				}
			}
		}
	}



/* coerce!-closure3402 */
	obj_t BGl_coercez12zd2closure3402zc0zzcoerce_coercez00(obj_t BgL_envz00_3332,
		obj_t BgL_nodez00_3333, obj_t BgL_callerz00_3334, obj_t BgL_toz00_3335,
		obj_t BgL_safez00_3336)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 90 */
			{
				BgL_closurez00_bglt BgL_nodez00_1319;

				obj_t BgL_callerz00_1320;

				obj_t BgL_toz00_1321;

				obj_t BgL_safez00_1322;

				BgL_nodez00_1319 = (BgL_closurez00_bglt) (BgL_nodez00_3333);
				BgL_callerz00_1320 = BgL_callerz00_3334;
				BgL_toz00_1321 = BgL_toz00_3335;
				BgL_safez00_1322 = BgL_safez00_3336;
				return
					BGl_internalzd2errorzd2zztools_errorz00
					(BGl_string3875z00zzcoerce_coercez00,
					BGl_string3876z00zzcoerce_coercez00,
					BGl_shapez00zztools_shapez00((obj_t) (BgL_nodez00_1319)));
			}
		}
	}



/* coerce!-var3400 */
	obj_t BGl_coercez12zd2var3400zc0zzcoerce_coercez00(obj_t BgL_envz00_3337,
		obj_t BgL_nodez00_3338, obj_t BgL_callerz00_3339, obj_t BgL_toz00_3340,
		obj_t BgL_safez00_3341)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 82 */
			{
				BgL_varz00_bglt BgL_nodez00_1309;

				obj_t BgL_callerz00_1310;

				obj_t BgL_toz00_1311;

				obj_t BgL_safez00_1312;

				{	/* Coerce/coerce.scm 84 */
					BgL_nodez00_bglt BgL_auxz00_5071;

					BgL_nodez00_1309 = (BgL_varz00_bglt) (BgL_nodez00_3338);
					BgL_callerz00_1310 = BgL_callerz00_3339;
					BgL_toz00_1311 = BgL_toz00_3340;
					BgL_safez00_1312 = BgL_safez00_3341;
					BgL_auxz00_5071 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1309),
						BGl_typeofz00zztype_typeofz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1309)),
						(BgL_typez00_bglt) (BgL_toz00_1311), CBOOL(BgL_safez00_1312));
					return (obj_t) (BgL_auxz00_5071);
				}
			}
		}
	}



/* coerce!-kwote3398 */
	obj_t BGl_coercez12zd2kwote3398zc0zzcoerce_coercez00(obj_t BgL_envz00_3342,
		obj_t BgL_nodez00_3343, obj_t BgL_callerz00_3344, obj_t BgL_toz00_3345,
		obj_t BgL_safez00_3346)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 76 */
			{
				BgL_kwotez00_bglt BgL_nodez00_1300;

				obj_t BgL_callerz00_1301;

				obj_t BgL_toz00_1302;

				obj_t BgL_safez00_1303;

				{	/* Coerce/coerce.scm 77 */
					BgL_nodez00_bglt BgL_auxz00_5080;

					BgL_nodez00_1300 = (BgL_kwotez00_bglt) (BgL_nodez00_3343);
					BgL_callerz00_1301 = BgL_callerz00_3344;
					BgL_toz00_1302 = BgL_toz00_3345;
					BgL_safez00_1303 = BgL_safez00_3346;
					BgL_auxz00_5080 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1300),
						BGl_typeofz00zztype_typeofz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1300)),
						(BgL_typez00_bglt) (BgL_toz00_1302), CBOOL(BgL_safez00_1303));
					return (obj_t) (BgL_auxz00_5080);
				}
			}
		}
	}



/* coerce!-atom3395 */
	obj_t BGl_coercez12zd2atom3395zc0zzcoerce_coercez00(obj_t BgL_envz00_3347,
		obj_t BgL_nodez00_3348, obj_t BgL_callerz00_3349, obj_t BgL_toz00_3350,
		obj_t BgL_safez00_3351)
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 70 */
			{
				BgL_atomz00_bglt BgL_nodez00_1291;

				obj_t BgL_callerz00_1292;

				obj_t BgL_toz00_1293;

				obj_t BgL_safez00_1294;

				{	/* Coerce/coerce.scm 71 */
					BgL_nodez00_bglt BgL_auxz00_5089;

					BgL_nodez00_1291 = (BgL_atomz00_bglt) (BgL_nodez00_3348);
					BgL_callerz00_1292 = BgL_callerz00_3349;
					BgL_toz00_1293 = BgL_toz00_3350;
					BgL_safez00_1294 = BgL_safez00_3351;
					BgL_auxz00_5089 =
						BGl_convertz12z12zzcoerce_convertz00(
						(BgL_nodez00_bglt) (BgL_nodez00_1291),
						BGl_typeofz00zztype_typeofz00(
							(BgL_nodez00_bglt) (BgL_nodez00_1291)),
						(BgL_typez00_bglt) (BgL_toz00_1293), CBOOL(BgL_safez00_1294));
					return (obj_t) (BgL_auxz00_5089);
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcoerce_coercez00()
	{
		AN_OBJECT;
		{	/* Coerce/coerce.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_coercionz00(((long) 451733024),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 341705556),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 269647501),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_pprotoz00(((long) 30250399),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_convertz00(((long) 65499856),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_appz00(((long) 130975358),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_applyz00(((long) 414524937),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			BGl_modulezd2initializa7ationz75zzcoerce_funcallz00(((long) 427175850),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_effectz00(((long) 470955713),
				BSTRING_TO_STRING(BGl_string3877z00zzcoerce_coercez00));
		}
	}

#ifdef __cplusplus
}
#endif
