/*===========================================================================*/
/*   (Effect/cgraph.scm)                                                     */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Effect/cgraph.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_localzf2fromzf2_bgl
	{
		obj_t BgL_fromz00;
	}                      *BgL_localzf2fromzf2_bglt;

	typedef struct BgL_globalzf2fromzf2_bgl
	{
		obj_t BgL_fromz00;
	}                       *BgL_globalzf2fromzf2_bglt;


	static obj_t
		BGl_callzd2graphz12zd2setzd2exzd2i3288z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	static obj_t BGl_callzd2graphz12zd2sequence3264z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern BgL_localz00_bglt BGl_makezd2localzd2zzast_varz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, bool_t,
		long);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2varzf2allz20zzeffect_cgraphz00();
	static obj_t BGl__resetzd2effectzd2tablesz12z12zzeffect_cgraphz00(obj_t);
	BGL_IMPORT obj_t BGl_objectzd2ze3structz31zz__objectz00(BgL_objectz00_bglt);
	static obj_t
		BGl_callzd2graphz12zd2boxzd2setz123296zd2zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	BGL_EXPORTED_DEF obj_t BGl_globalzf2fromzf2zzeffect_cgraphz00 = BUNSPEC;
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_nodez00_bglt,
		BgL_variablez00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(BgL_variablez00_bglt);
	static obj_t BGl_callzd2graphz12zd2conditio3278z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_callzd2graphz12zd2extern3272z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 = BUNSPEC;
	static obj_t BGl_callzd2graphz12zd2appzd2ly3268zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl_savezd2callz12zd2local3304z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__funzd2callzd2graphz123595z12zzeffect_cgraphz00(obj_t,
		obj_t);
	extern BgL_valuez00_bglt BGl_valuezd2nilzd2zzast_varz00();
	static obj_t BGl_savezd2callz12zd2global3300z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl__getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00(obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t
		BGl_callzd2graphz12zd2jumpzd2exzd23290z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__getzd2varzf2allz20zzeffect_cgraphz00(obj_t);
	static obj_t BGl__callzd2graphz12zd2default3261z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__globalzf2fromzf3z01zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_localzf2fromzf2_bglt
		BGl_fillzd2localzf2fromz12z32zzeffect_cgraphz00(BgL_localzf2fromzf2_bglt,
		obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t BGl_callzd2graphz12zd2cast3274z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl__z52allocatezd2globalzf2fromz72zzeffect_cgraphz00(obj_t);
	static obj_t BGl__wideningzd2localzf2fromz20zzeffect_cgraphz00(obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_savezd2callz12zc0zzeffect_cgraphz00(BgL_variablez00_bglt,
		BgL_variablez00_bglt);
	BGL_EXPORTED_DECL BgL_localzf2fromzf2_bglt
		BGl_localzf2fromzd2nilz20zzeffect_cgraphz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_callzd2graphz12zd2makezd2box3292zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_callzd2graphz12zd2setq3276z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__wideningzd2globalzf2fromz20zzeffect_cgraphz00(obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_callzd2graphz12zd2select3282z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_callzd2graphz12zd2funcall3270z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_localzf2fromzf3z01zzeffect_cgraphz00(obj_t);
	static obj_t BGl_savezd2callz12zd2globalzf2fr3302ze0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__globalzf2fromzd2nilz20zzeffect_cgraphz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzeffect_cgraphz00();
	BGL_EXPORTED_DECL BgL_globalz00_bglt
		BGl_z52allocatezd2globalzf2fromz72zzeffect_cgraphz00();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl__z52allocatezd2localzf2fromz72zzeffect_cgraphz00(obj_t);
	static obj_t BGl__fillzd2localzf2fromz123600z32zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_savezd2callz12zd2localzf2fro3306ze0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_resetzd2effectzd2tablesz12z12zzeffect_cgraphz00();
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	BGL_EXPORTED_DECL BgL_localzf2fromzf2_bglt
		BGl_makezd2localzf2fromz20zzeffect_cgraphz00(obj_t, obj_t, BgL_typez00_bglt,
		BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, bool_t, long, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzeffect_cgraphz00 = BUNSPEC;
	static obj_t BGl_objectzd2ze3structzd2globa3309ze3zzeffect_cgraphz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_globalzf2fromzf2_bglt
		BGl_makezd2globalzf2fromz20zzeffect_cgraphz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, obj_t,
		obj_t, bool_t, obj_t, bool_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl_callzd2graphz12zd2fail3280z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__localzf2fromzf3z01zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_localzf2fromzf2zzeffect_cgraphz00 = BUNSPEC;
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00 = BUNSPEC;
	static obj_t BGl_callzd2graphz12zd2boxzd2ref3294zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl__makezd2localzf2from3599z20zzeffect_cgraphz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern BgL_typez00_bglt BGl_typezd2nilzd2zztype_typez00();
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl__makezd2globalzf2from3597z20zzeffect_cgraphz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzeffect_cgraphz00();
	BGL_EXPORTED_DECL obj_t BGl_getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00();
	BGL_IMPORT obj_t make_struct(obj_t, int, obj_t);
	static obj_t BGl__savezd2callz123601zc0zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__savezd2callz12zd2default3297z12zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_savezd2callz12zd2default3297z12zzeffect_cgraphz00(BgL_variablez00_bglt,
		BgL_variablez00_bglt);
	static obj_t BGl__localzf2fromzd2nilz20zzeffect_cgraphz00(obj_t);
	static obj_t BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00 = BUNSPEC;
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl__callzd2graphz123596zc0zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t BGl_globalzf2fromzf3z01zzeffect_cgraphz00(obj_t);
	BGL_EXPORTED_DECL BgL_localzf2fromzf2_bglt
		BGl_wideningzd2localzf2fromz20zzeffect_cgraphz00(obj_t);
	BGL_IMPORT BgL_objectz00_bglt
		BGl_structzb2objectzd2ze3objectz83zz__objectz00(BgL_objectz00_bglt, obj_t);
	extern BgL_globalz00_bglt BGl_makezd2globalzd2zzast_varz00(obj_t, obj_t,
		BgL_typez00_bglt, BgL_valuez00_bglt, obj_t, obj_t, obj_t, long, obj_t,
		obj_t, bool_t, obj_t, bool_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t
		BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(BgL_variablez00_bglt);
	extern obj_t BGl_cfunz00zzast_varz00;
	static bool_t BGl_callzd2graphza2z12z62zzeffect_cgraphz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_globalzf2fromzf2_bglt
		BGl_wideningzd2globalzf2fromz20zzeffect_cgraphz00(obj_t);
	static obj_t BGl_za2varzf2allza2zf2zzeffect_cgraphz00 = BUNSPEC;
	static obj_t BGl_callzd2graphz12zd2letzd2fun3284zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__fillzd2globalzf2fromz123598z32zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_objectzd2ze3structzd2local3313ze3zzeffect_cgraphz00(obj_t,
		obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	BGL_EXPORTED_DECL BgL_globalzf2fromzf2_bglt
		BGl_globalzf2fromzd2nilz20zzeffect_cgraphz00();
	static obj_t BGl_callzd2graphz12zd2letzd2var3286zc0zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzeffect_cgraphz00();
	static obj_t BGl_structzb2objectzd2ze3objec3311z83zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_structzb2objectzd2ze3objec3315z83zzeffect_cgraphz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzeffect_cgraphz00();
	static obj_t BGl_callzd2graphz12zd2app3266z12zzeffect_cgraphz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_localz00_bglt
		BGl_z52allocatezd2localzf2fromz72zzeffect_cgraphz00();
	BGL_EXPORTED_DECL BgL_globalzf2fromzf2_bglt
		BGl_fillzd2globalzf2fromz12z32zzeffect_cgraphz00(BgL_globalzf2fromzf2_bglt,
		obj_t);
	static obj_t __cnst[7];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_fillzd2localzf2fromz12zd2envze0zzeffect_cgraphz00,
		BgL_bgl__fillza7d2localza7f23641z00,
		BGl__fillzd2localzf2fromz123600z32zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_savezd2callz12zd2default3297zd2envzc0zzeffect_cgraphz00,
		BgL_bgl__saveza7d2callza712za73642za7,
		BGl__savezd2callz12zd2default3297z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_resetzd2effectzd2tablesz12zd2envzc0zzeffect_cgraphz00,
		BgL_bgl__resetza7d2effectza73643z00,
		BGl__resetzd2effectzd2tablesz12z12zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2varzf2sidezd2effectzd2envz20zzeffect_cgraphz00,
		BgL_bgl__getza7d2varza7f2sid3644z00,
		BGl__getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_fillzd2globalzf2fromz12zd2envze0zzeffect_cgraphz00,
		BgL_bgl__fillza7d2globalza7f3645z00,
		BGl__fillzd2globalzf2fromz123598z32zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2globalzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__makeza7d2globalza7f3646z00,
		BGl__makezd2globalzf2from3597z20zzeffect_cgraphz00, 0L, BUNSPEC, 17);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2localzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__makeza7d2localza7f23647z00,
		BGl__makezd2localzf2from3599z20zzeffect_cgraphz00, 0L, BUNSPEC, 11);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
		BgL_bgl__callza7d2graphza7123648z00,
		BGl__callzd2graphz123596zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_wideningzd2globalzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__wideningza7d2glob3649za7,
		BGl__wideningzd2globalzf2fromz20zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
		BgL_bgl__saveza7d2callza71233650z00,
		BGl__savezd2callz123601zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_localzf2fromzf3zd2envzd3zzeffect_cgraphz00,
		BgL_bgl__localza7f2fromza7f33651z00,
		BGl__localzf2fromzf3z01zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	BGL_IMPORT obj_t BGl_objectzd2ze3structzd2envze3zz__objectz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_callzd2graphz12zd2default3261zd2envzc0zzeffect_cgraphz00,
		BgL_bgl__callza7d2graphza7123652z00,
		BGl__callzd2graphz12zd2default3261z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_globalzf2fromzf3zd2envzd3zzeffect_cgraphz00,
		BgL_bgl__globalza7f2fromza7f3653z00,
		BGl__globalzf2fromzf3z01zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_globalzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__globalza7f2fromza7d3654z00,
		BGl__globalzf2fromzd2nilz20zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_funzd2callzd2graphz12zd2envzc0zzeffect_cgraphz00,
		BgL_bgl__funza7d2callza7d2gr3655z00,
		BGl__funzd2callzd2graphz123595z12zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_z52allocatezd2globalzf2fromzd2envza0zzeffect_cgraphz00,
		BgL_bgl__za752allocateza7d2g3656z00,
		BGl__z52allocatezd2globalzf2fromz72zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_z52allocatezd2localzf2fromzd2envza0zzeffect_cgraphz00,
		BgL_bgl__za752allocateza7d2l3657z00,
		BGl__z52allocatezd2localzf2fromz72zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_wideningzd2localzf2fromzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__wideningza7d2loca3658za7,
		BGl__wideningzd2localzf2fromz20zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3607z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73659za7,
		BGl_callzd2graphz12zd2sequence3264z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3608z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73660za7,
		BGl_callzd2graphz12zd2app3266z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3610z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73661za7,
		BGl_callzd2graphz12zd2funcall3270z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3609z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73662za7,
		BGl_callzd2graphz12zd2appzd2ly3268zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3611z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73663za7,
		BGl_callzd2graphz12zd2extern3272z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3612z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73664za7,
		BGl_callzd2graphz12zd2cast3274z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3613z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73665za7,
		BGl_callzd2graphz12zd2setq3276z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3614z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73666za7,
		BGl_callzd2graphz12zd2conditio3278z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3615z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73667za7,
		BGl_callzd2graphz12zd2fail3280z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3616z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73668za7,
		BGl_callzd2graphz12zd2select3282z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3617z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73669za7,
		BGl_callzd2graphz12zd2letzd2fun3284zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3618z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73670za7,
		BGl_callzd2graphz12zd2letzd2var3286zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3620z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73671za7,
		BGl_callzd2graphz12zd2jumpzd2exzd23290z12zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3619z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73672za7,
		BGl_callzd2graphz12zd2setzd2exzd2i3288z12zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3621z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73673za7,
		BGl_callzd2graphz12zd2makezd2box3292zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3622z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73674za7,
		BGl_callzd2graphz12zd2boxzd2ref3294zc0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3623z00zzeffect_cgraphz00,
		BgL_bgl_callza7d2graphza712za73675za7,
		BGl_callzd2graphz12zd2boxzd2setz123296zd2zzeffect_cgraphz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3624z00zzeffect_cgraphz00,
		BgL_bgl_saveza7d2callza712za7d3676za7,
		BGl_savezd2callz12zd2global3300z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3625z00zzeffect_cgraphz00,
		BgL_bgl_saveza7d2callza712za7d3677za7,
		BGl_savezd2callz12zd2globalzf2fr3302ze0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3626z00zzeffect_cgraphz00,
		BgL_bgl_saveza7d2callza712za7d3678za7,
		BGl_savezd2callz12zd2local3304z12zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3627z00zzeffect_cgraphz00,
		BgL_bgl_saveza7d2callza712za7d3679za7,
		BGl_savezd2callz12zd2localzf2fro3306ze0zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3628z00zzeffect_cgraphz00,
		BgL_bgl_objectza7d2za7e3stru3680z00,
		BGl_objectzd2ze3structzd2globa3309ze3zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3630z00zzeffect_cgraphz00,
		BgL_bgl_objectza7d2za7e3stru3681z00,
		BGl_objectzd2ze3structzd2local3313ze3zzeffect_cgraphz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3629z00zzeffect_cgraphz00,
		BgL_bgl_structza7b2objectza73682z00,
		BGl_structzb2objectzd2ze3objec3311z83zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3631z00zzeffect_cgraphz00,
		BgL_bgl_structza7b2objectza73683z00,
		BGl_structzb2objectzd2ze3objec3315z83zzeffect_cgraphz00, 0L, BUNSPEC, 2);
	BGL_IMPORT obj_t BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00;
	   
		 
		DEFINE_STRING(BGl_string3605z00zzeffect_cgraphz00,
		BgL_bgl_string3605za700za7za7e3684za7, "", 0);
	      DEFINE_STRING(BGl_string3606z00zzeffect_cgraphz00,
		BgL_bgl_string3606za700za7za7e3685za7, "No method for this object", 25);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_getzd2varzf2allzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__getza7d2varza7f2all3686z00,
		BGl__getzd2varzf2allz20zzeffect_cgraphz00, 0L, BUNSPEC, 0);
	      DEFINE_STRING(BGl_string3632z00zzeffect_cgraphz00,
		BgL_bgl_string3632za700za7za7e3687za7, "effect_cgraph", 13);
	      DEFINE_STRING(BGl_string3633z00zzeffect_cgraphz00,
		BgL_bgl_string3633za700za7za7e3688za7,
		"import save-call!-default3297 done _ global/from local/from nothing ", 68);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_localzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
		BgL_bgl__localza7f2fromza7d23689z00,
		BGl__localzf2fromzd2nilz20zzeffect_cgraphz00, 0L, BUNSPEC, 0);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(long
		BgL_checksumz00_2879, char *BgL_fromz00_2880)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzeffect_cgraphz00))
				{
					BGl_requirezd2initializa7ationz75zzeffect_cgraphz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzeffect_cgraphz00();
					BGl_cnstzd2initzd2zzeffect_cgraphz00();
					BGl_importedzd2moduleszd2initz00zzeffect_cgraphz00();
					BGl_objectzd2initzd2zzeffect_cgraphz00();
					BGl_genericzd2initzd2zzeffect_cgraphz00();
					BGl_methodzd2initzd2zzeffect_cgraphz00();
					BGl_toplevelzd2initzd2zzeffect_cgraphz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "effect_cgraph");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"effect_cgraph");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			{	/* Effect/cgraph.scm 15 */
				obj_t BgL_cportz00_2846;

				BgL_cportz00_2846 =
					bgl_open_input_string(BGl_string3633z00zzeffect_cgraphz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2847;

					BgL_iz00_2847 = ((long) 6);
				BgL_loopz00_2848:
					if ((BgL_iz00_2847 == ((long) -1)))
						{	/* Effect/cgraph.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Effect/cgraph.scm 15 */
							{	/* Effect/cgraph.scm 15 */
								obj_t BgL_arg3635z00_2850;

								{	/* Effect/cgraph.scm 15 */

									{	/* Effect/cgraph.scm 15 */
										obj_t BgL_locationz00_2852;

										BgL_locationz00_2852 = BBOOL(((bool_t) 0));
										{	/* Effect/cgraph.scm 15 */

											BgL_arg3635z00_2850 =
												BGl_readz00zz__readerz00(BgL_cportz00_2846,
												BgL_locationz00_2852);
										}
									}
								}
								{	/* Effect/cgraph.scm 15 */
									int BgL_auxz00_2901;

									BgL_auxz00_2901 = (int) (BgL_iz00_2847);
									CNST_TABLE_SET(BgL_auxz00_2901, BgL_arg3635z00_2850);
							}}
							{	/* Effect/cgraph.scm 15 */
								int BgL_auxz00_2853;

								BgL_auxz00_2853 = (int) ((BgL_iz00_2847 - ((long) 1)));
								{
									long BgL_iz00_2906;

									BgL_iz00_2906 = (long) (BgL_auxz00_2853);
									BgL_iz00_2847 = BgL_iz00_2906;
									goto BgL_loopz00_2848;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 = BNIL;
			return (BGl_za2varzf2allza2zf2zzeffect_cgraphz00 = BNIL, BUNSPEC);
		}
	}



/* fun-call-graph! */
	BGL_EXPORTED_DEF obj_t
		BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_variablez00_1)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 30 */
			BGl_za2varzf2allza2zf2zzeffect_cgraphz00 =
				MAKE_PAIR(
				(obj_t) (BgL_variablez00_1), BGl_za2varzf2allza2zf2zzeffect_cgraphz00);
			{	/* Effect/cgraph.scm 32 */
				obj_t BgL_arg3316z00_827;

				{	/* Effect/cgraph.scm 32 */
					BgL_sfunz00_bglt BgL_obj1700z00_1523;

					BgL_obj1700z00_1523 =
						(BgL_sfunz00_bglt) (
						(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_valuez00));
					BgL_arg3316z00_827 =
						(((BgL_sfunz00_bglt) CREF(BgL_obj1700z00_1523))->BgL_bodyz00);
				}
				{	/* Effect/cgraph.scm 32 */
					BgL_nodez00_bglt BgL_nodez00_1524;

					BgL_nodez00_1524 = (BgL_nodez00_bglt) (BgL_arg3316z00_827);
					{	/* Effect/cgraph.scm 32 */
						obj_t BgL_method3262z00_1526;

						{	/* Effect/cgraph.scm 32 */
							BgL_objectz00_bglt BgL_objz00_1527;

							BgL_objz00_1527 = (BgL_objectz00_bglt) (BgL_nodez00_1524);
							{	/* Effect/cgraph.scm 32 */
								long BgL_objzd2classzd2numz00_1528;

								BgL_objzd2classzd2numz00_1528 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_1527);
								{	/* Effect/cgraph.scm 32 */
									obj_t BgL_arg2334z00_1529;

									BgL_arg2334z00_1529 =
										PROCEDURE_REF
										(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
										(int) (((long) 1)));
									{	/* Effect/cgraph.scm 32 */
										obj_t BgL_arrayz00_1531;

										int BgL_offsetz00_1532;

										BgL_arrayz00_1531 = BgL_arg2334z00_1529;
										BgL_offsetz00_1532 = (int) (BgL_objzd2classzd2numz00_1528);
										{	/* Effect/cgraph.scm 32 */
											long BgL_offsetz00_1533;

											BgL_offsetz00_1533 =
												((long) (BgL_offsetz00_1532) - OBJECT_TYPE);
											{	/* Effect/cgraph.scm 32 */
												long BgL_modz00_1534;

												{	/* Effect/cgraph.scm 32 */
													int BgL_arg2336z00_1535;

													BgL_arg2336z00_1535 = (int) (((long) 8));
													{	/* Effect/cgraph.scm 32 */
														long BgL_auxz00_2922;

														BgL_auxz00_2922 = (long) (BgL_arg2336z00_1535);
														BgL_modz00_1534 =
															(BgL_offsetz00_1533 / BgL_auxz00_2922);
												}}
												{	/* Effect/cgraph.scm 32 */
													long BgL_restz00_1536;

													{	/* Effect/cgraph.scm 32 */
														int BgL_arg2335z00_1537;

														BgL_arg2335z00_1537 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 32 */
															long BgL_auxz00_2926;

															BgL_auxz00_2926 = (long) (BgL_arg2335z00_1537);
															BgL_restz00_1536 =
																(BgL_offsetz00_1533 % BgL_auxz00_2926);
													}}
													{	/* Effect/cgraph.scm 32 */

														BgL_method3262z00_1526 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_1531,
																(int) (BgL_modz00_1534)),
															(int) (BgL_restz00_1536));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3262z00_1526) (BgL_method3262z00_1526,
							(obj_t) (BgL_nodez00_1524), (obj_t) (BgL_variablez00_1), BEOA);
					}
				}
			}
		}
	}



/* _fun-call-graph!3595 */
	obj_t BGl__funzd2callzd2graphz123595z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2678, obj_t BgL_variablez00_2679)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 30 */
			return
				BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(
				(BgL_variablez00_bglt) (BgL_variablez00_2679));
		}
	}



/* call-graph*! */
	bool_t BGl_callzd2graphza2z12z62zzeffect_cgraphz00(obj_t BgL_nodeza2za2_40,
		obj_t BgL_ownerz00_41)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 197 */
			{
				obj_t BgL_l3257z00_829;

				BgL_l3257z00_829 = BgL_nodeza2za2_40;
			BgL_forzd2each3258zd2_830:
				if (PAIRP(BgL_l3257z00_829))
					{	/* Effect/cgraph.scm 198 */
						{	/* Effect/cgraph.scm 198 */
							obj_t BgL_nodez00_832;

							BgL_nodez00_832 = CAR(BgL_l3257z00_829);
							{	/* Effect/cgraph.scm 198 */
								BgL_nodez00_bglt BgL_nodez00_1553;

								BgL_variablez00_bglt BgL_ownerz00_1554;

								BgL_nodez00_1553 = (BgL_nodez00_bglt) (BgL_nodez00_832);
								BgL_ownerz00_1554 = (BgL_variablez00_bglt) (BgL_ownerz00_41);
								{	/* Effect/cgraph.scm 198 */
									obj_t BgL_method3262z00_1555;

									{	/* Effect/cgraph.scm 198 */
										BgL_objectz00_bglt BgL_objz00_1556;

										BgL_objz00_1556 = (BgL_objectz00_bglt) (BgL_nodez00_1553);
										{	/* Effect/cgraph.scm 198 */
											long BgL_objzd2classzd2numz00_1557;

											BgL_objzd2classzd2numz00_1557 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1556);
											{	/* Effect/cgraph.scm 198 */
												obj_t BgL_arg2334z00_1558;

												BgL_arg2334z00_1558 =
													PROCEDURE_REF
													(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
													(int) (((long) 1)));
												{	/* Effect/cgraph.scm 198 */
													obj_t BgL_arrayz00_1560;

													int BgL_offsetz00_1561;

													BgL_arrayz00_1560 = BgL_arg2334z00_1558;
													BgL_offsetz00_1561 =
														(int) (BgL_objzd2classzd2numz00_1557);
													{	/* Effect/cgraph.scm 198 */
														long BgL_offsetz00_1562;

														BgL_offsetz00_1562 =
															((long) (BgL_offsetz00_1561) - OBJECT_TYPE);
														{	/* Effect/cgraph.scm 198 */
															long BgL_modz00_1563;

															{	/* Effect/cgraph.scm 198 */
																int BgL_arg2336z00_1564;

																BgL_arg2336z00_1564 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 198 */
																	long BgL_auxz00_2952;

																	BgL_auxz00_2952 =
																		(long) (BgL_arg2336z00_1564);
																	BgL_modz00_1563 =
																		(BgL_offsetz00_1562 / BgL_auxz00_2952);
															}}
															{	/* Effect/cgraph.scm 198 */
																long BgL_restz00_1565;

																{	/* Effect/cgraph.scm 198 */
																	int BgL_arg2335z00_1566;

																	BgL_arg2335z00_1566 = (int) (((long) 8));
																	{	/* Effect/cgraph.scm 198 */
																		long BgL_auxz00_2956;

																		BgL_auxz00_2956 =
																			(long) (BgL_arg2335z00_1566);
																		BgL_restz00_1565 =
																			(BgL_offsetz00_1562 % BgL_auxz00_2956);
																}}
																{	/* Effect/cgraph.scm 198 */

																	BgL_method3262z00_1555 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1560,
																			(int) (BgL_modz00_1563)),
																		(int) (BgL_restz00_1565));
									}}}}}}}}
									PROCEDURE_ENTRY(BgL_method3262z00_1555)
										(BgL_method3262z00_1555, (obj_t) (BgL_nodez00_1553),
										(obj_t) (BgL_ownerz00_1554), BEOA);
						}}}
						{
							obj_t BgL_l3257z00_2967;

							BgL_l3257z00_2967 = CDR(BgL_l3257z00_829);
							BgL_l3257z00_829 = BgL_l3257z00_2967;
							goto BgL_forzd2each3258zd2_830;
						}
					}
				else
					{	/* Effect/cgraph.scm 198 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* get-var/side-effect */
	BGL_EXPORTED_DEF obj_t BGl_getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 242 */
			return BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00;
		}
	}



/* _get-var/side-effect */
	obj_t BGl__getzd2varzf2sidezd2effectzf2zzeffect_cgraphz00(obj_t
		BgL_envz00_2683)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 242 */
			return BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00;
		}
	}



/* get-var/all */
	BGL_EXPORTED_DEF obj_t BGl_getzd2varzf2allz20zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 253 */
			return BGl_za2varzf2allza2zf2zzeffect_cgraphz00;
		}
	}



/* _get-var/all */
	obj_t BGl__getzd2varzf2allz20zzeffect_cgraphz00(obj_t BgL_envz00_2684)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 253 */
			return BGl_za2varzf2allza2zf2zzeffect_cgraphz00;
		}
	}



/* reset-effect-tables! */
	BGL_EXPORTED_DEF obj_t BGl_resetzd2effectzd2tablesz12z12zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 264 */
			BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 = BNIL;
			return (BGl_za2varzf2allza2zf2zzeffect_cgraphz00 = BNIL, BUNSPEC);
		}
	}



/* _reset-effect-tables! */
	obj_t BGl__resetzd2effectzd2tablesz12z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2685)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 264 */
			return BGl_resetzd2effectzd2tablesz12z12zzeffect_cgraphz00();
		}
	}



/* mark-side-effect! */
	obj_t BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_vz00_54)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 271 */
			{	/* Effect/cgraph.scm 273 */
				BgL_valuez00_bglt BgL_funz00_834;

				BgL_funz00_834 =
					(((BgL_variablez00_bglt) CREF(BgL_vz00_54))->BgL_valuez00);
				{	/* Effect/cgraph.scm 275 */
					bool_t BgL_testz00_2971;

					{	/* Effect/cgraph.scm 275 */
						BgL_funz00_bglt BgL_obj1631z00_1582;

						BgL_obj1631z00_1582 = (BgL_funz00_bglt) (BgL_funz00_834);
						BgL_testz00_2971 =
							CBOOL(
							(((BgL_funz00_bglt) CREF(BgL_obj1631z00_1582))->
								BgL_sidezd2effectzf3z21));
					}
					if (BgL_testz00_2971)
						{	/* Effect/cgraph.scm 275 */
							if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
										(obj_t) (BgL_vz00_54),
										BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00)))
								{	/* Effect/cgraph.scm 278 */
									return CNST_TABLE_REF(((long) 0));
								}
							else
								{	/* Effect/cgraph.scm 278 */
									return (BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 =
										MAKE_PAIR(
											(obj_t) (BgL_vz00_54),
											BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00),
										BUNSPEC);
								}
						}
					else
						{	/* Effect/cgraph.scm 275 */
							BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00 =
								MAKE_PAIR(
								(obj_t) (BgL_vz00_54),
								BGl_za2varzf2sidezd2effectza2z20zzeffect_cgraphz00);
							{
								BgL_funz00_bglt BgL_auxz00_2984;

								BgL_auxz00_2984 = (BgL_funz00_bglt) (BgL_funz00_834);
								return
									((((BgL_funz00_bglt) CREF(BgL_auxz00_2984))->
										BgL_sidezd2effectzf3z21) = ((obj_t) BTRUE), BUNSPEC);
							}
						}
				}
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			{	/* Effect/cgraph.scm 20 */
				obj_t BgL_arg3322z00_837;

				obj_t BgL_arg3323z00_838;

				obj_t BgL_arg3326z00_841;

				BgL_arg3322z00_837 = CNST_TABLE_REF(((long) 1));
				BgL_arg3323z00_838 = BGl_localz00zzast_varz00;
				{	/* Effect/cgraph.scm 20 */
					obj_t BgL_v3259z00_842;

					BgL_v3259z00_842 = create_vector((int) (((long) 0)));
					BgL_arg3326z00_841 = BgL_v3259z00_842;
				}
				BGl_localzf2fromzf2zzeffect_cgraphz00 =
					BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3322z00_837,
					BgL_arg3323z00_838, ((bool_t) 0), BFALSE,
					BGl_z52allocatezd2localzf2fromzd2envza0zzeffect_cgraphz00,
					BGl_localzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
					BGl_localzf2fromzf3zd2envzd3zzeffect_cgraphz00, ((long) 443584018),
					BFALSE, BFALSE, BgL_arg3326z00_841);
			}
			{	/* Effect/cgraph.scm 21 */
				obj_t BgL_arg3327z00_843;

				obj_t BgL_arg3328z00_844;

				obj_t BgL_arg3331z00_847;

				BgL_arg3327z00_843 = CNST_TABLE_REF(((long) 2));
				BgL_arg3328z00_844 = BGl_globalz00zzast_varz00;
				{	/* Effect/cgraph.scm 21 */
					obj_t BgL_v3260z00_848;

					BgL_v3260z00_848 = create_vector((int) (((long) 0)));
					BgL_arg3331z00_847 = BgL_v3260z00_848;
				}
				BGl_globalzf2fromzf2zzeffect_cgraphz00 =
					BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3327z00_843,
					BgL_arg3328z00_844, ((bool_t) 0), BFALSE,
					BGl_z52allocatezd2globalzf2fromzd2envza0zzeffect_cgraphz00,
					BGl_globalzf2fromzd2nilzd2envzf2zzeffect_cgraphz00,
					BGl_globalzf2fromzf3zd2envzd3zzeffect_cgraphz00, ((long) 410954352),
					BFALSE, BFALSE, BgL_arg3331z00_847);
			}
			BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00 = BUNSPEC;
			return (BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00 =
				BUNSPEC, BUNSPEC);
		}
	}



/* global/from? */
	BGL_EXPORTED_DEF bool_t BGl_globalzf2fromzf3z01zzeffect_cgraphz00(obj_t
		BgL_obj3153z00_55)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return
				BGl_iszd2azf3z21zz__objectz00(BgL_obj3153z00_55,
				BGl_globalzf2fromzf2zzeffect_cgraphz00);
		}
	}



/* _global/from? */
	obj_t BGl__globalzf2fromzf3z01zzeffect_cgraphz00(obj_t BgL_envz00_2692,
		obj_t BgL_obj3153z00_2693)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj3153z00_2693,
					BGl_globalzf2fromzf2zzeffect_cgraphz00));
		}
	}



/* widening-global/from */
	BGL_EXPORTED_DEF BgL_globalzf2fromzf2_bglt
		BGl_wideningzd2globalzf2fromz20zzeffect_cgraphz00(obj_t BgL_from3119z00_59)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalzf2fromzf2_bglt BgL_new3120z00_1585;

				BgL_new3120z00_1585 =
					((BgL_globalzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_globalzf2fromzf2_bgl))));
				{	/* Effect/cgraph.scm 21 */
					BgL_globalzf2fromzf2_bglt BgL_res3513z00_1589;

					{	/* Effect/cgraph.scm 21 */
						BgL_globalzf2fromzf2_bglt BgL_new3142z00_1586;

						BgL_new3142z00_1586 = BgL_new3120z00_1585;
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_from3141z00_1588;

							BgL_from3141z00_1588 = BgL_from3119z00_59;
							((((BgL_globalzf2fromzf2_bglt) CREF(BgL_new3142z00_1586))->
									BgL_fromz00) = ((obj_t) BgL_from3141z00_1588), BUNSPEC);
							BgL_res3513z00_1589 = BgL_new3142z00_1586;
					}} BgL_res3513z00_1589;
				}
				return BgL_new3120z00_1585;
			}
		}
	}



/* _widening-global/from */
	obj_t BGl__wideningzd2globalzf2fromz20zzeffect_cgraphz00(obj_t
		BgL_envz00_2694, obj_t BgL_from3119z00_2695)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return
				(obj_t) (BGl_wideningzd2globalzf2fromz20zzeffect_cgraphz00
				(BgL_from3119z00_2695));
		}
	}



/* make-global/from */
	BGL_EXPORTED_DEF BgL_globalzf2fromzf2_bglt
		BGl_makezd2globalzf2fromz20zzeffect_cgraphz00(obj_t BgL_id3123z00_60,
		obj_t BgL_name3124z00_61, BgL_typez00_bglt BgL_type3125z00_62,
		BgL_valuez00_bglt BgL_value3126z00_63, obj_t BgL_access3127z00_64,
		obj_t BgL_fastzd2alpha3128zd2_65, obj_t BgL_removable3129z00_66,
		long BgL_occurrence3130z00_67, obj_t BgL_module3131z00_68,
		obj_t BgL_import3132z00_69, bool_t BgL_evaluablezf33133zf3_70,
		obj_t BgL_library3134z00_71, bool_t BgL_userzf33135zf3_72,
		obj_t BgL_pragma3136z00_73, obj_t BgL_src3137z00_74,
		obj_t BgL_jvmzd2typezd2name3138z00_75, obj_t BgL_from3122z00_76)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalz00_bglt BgL_aux3139z00_1590;

				BgL_aux3139z00_1590 =
					BGl_makezd2globalzd2zzast_varz00(BgL_id3123z00_60, BgL_name3124z00_61,
					BgL_type3125z00_62, BgL_value3126z00_63, BgL_access3127z00_64,
					BgL_fastzd2alpha3128zd2_65, BgL_removable3129z00_66,
					BgL_occurrence3130z00_67, BgL_module3131z00_68, BgL_import3132z00_69,
					BgL_evaluablezf33133zf3_70, BgL_library3134z00_71,
					BgL_userzf33135zf3_72, BgL_pragma3136z00_73, BgL_src3137z00_74,
					BgL_jvmzd2typezd2name3138z00_75);
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_aux3139z00_1590),
					BGl_classzd2numzd2zz__objectz00
					(BGl_globalzf2fromzf2zzeffect_cgraphz00));
				{	/* Effect/cgraph.scm 21 */
					BgL_globalzf2fromzf2_bglt BgL_arg3333z00_1592;

					{	/* Effect/cgraph.scm 21 */
						BgL_globalzf2fromzf2_bglt BgL_res3515z00_1602;

						{	/* Effect/cgraph.scm 21 */
							BgL_globalzf2fromzf2_bglt BgL_new3120z00_1597;

							BgL_new3120z00_1597 =
								((BgL_globalzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_globalzf2fromzf2_bgl))));
							{	/* Effect/cgraph.scm 21 */
								BgL_globalzf2fromzf2_bglt BgL_res3514z00_1601;

								{	/* Effect/cgraph.scm 21 */
									BgL_globalzf2fromzf2_bglt BgL_new3142z00_1598;

									BgL_new3142z00_1598 = BgL_new3120z00_1597;
									{	/* Effect/cgraph.scm 21 */
										obj_t BgL_from3141z00_1600;

										BgL_from3141z00_1600 = BgL_from3122z00_76;
										((((BgL_globalzf2fromzf2_bglt) CREF(BgL_new3142z00_1598))->
												BgL_fromz00) = ((obj_t) BgL_from3141z00_1600), BUNSPEC);
										BgL_res3514z00_1601 = BgL_new3142z00_1598;
								}} BgL_res3514z00_1601;
							}
							BgL_res3515z00_1602 = BgL_new3120z00_1597;
						}
						BgL_arg3333z00_1592 = BgL_res3515z00_1602;
					}
					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_auxz00_3010;

						BgL_objectz00_bglt BgL_auxz00_3008;

						BgL_auxz00_3010 = (obj_t) (BgL_arg3333z00_1592);
						BgL_auxz00_3008 = (BgL_objectz00_bglt) (BgL_aux3139z00_1590);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_3008, BgL_auxz00_3010);
				}}
				return
					((BgL_globalzf2fromzf2_bglt)
					(BgL_globalzf2fromzf2_bglt) (BgL_aux3139z00_1590));
			}
		}
	}



/* _make-global/from3597 */
	obj_t BGl__makezd2globalzf2from3597z20zzeffect_cgraphz00(obj_t
		BgL_envz00_2696, obj_t BgL_id3123z00_2697, obj_t BgL_name3124z00_2698,
		obj_t BgL_type3125z00_2699, obj_t BgL_value3126z00_2700,
		obj_t BgL_access3127z00_2701, obj_t BgL_fastzd2alpha3128zd2_2702,
		obj_t BgL_removable3129z00_2703, obj_t BgL_occurrence3130z00_2704,
		obj_t BgL_module3131z00_2705, obj_t BgL_import3132z00_2706,
		obj_t BgL_evaluablezf33133zf3_2707, obj_t BgL_library3134z00_2708,
		obj_t BgL_userzf33135zf3_2709, obj_t BgL_pragma3136z00_2710,
		obj_t BgL_src3137z00_2711, obj_t BgL_jvmzd2typezd2name3138z00_2712,
		obj_t BgL_from3122z00_2713)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return
				(obj_t) (BGl_makezd2globalzf2fromz20zzeffect_cgraphz00
				(BgL_id3123z00_2697, BgL_name3124z00_2698,
					(BgL_typez00_bglt) (BgL_type3125z00_2699),
					(BgL_valuez00_bglt) (BgL_value3126z00_2700), BgL_access3127z00_2701,
					BgL_fastzd2alpha3128zd2_2702, BgL_removable3129z00_2703,
					(long) CINT(BgL_occurrence3130z00_2704), BgL_module3131z00_2705,
					BgL_import3132z00_2706, CBOOL(BgL_evaluablezf33133zf3_2707),
					BgL_library3134z00_2708, CBOOL(BgL_userzf33135zf3_2709),
					BgL_pragma3136z00_2710, BgL_src3137z00_2711,
					BgL_jvmzd2typezd2name3138z00_2712, BgL_from3122z00_2713));
		}
	}



/* fill-global/from! */
	BGL_EXPORTED_DEF BgL_globalzf2fromzf2_bglt
		BGl_fillzd2globalzf2fromz12z32zzeffect_cgraphz00(BgL_globalzf2fromzf2_bglt
		BgL_new3142z00_77, obj_t BgL_from3141z00_78)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				obj_t BgL_from3141z00_2855;

				BgL_from3141z00_2855 = BgL_from3141z00_78;
				((((BgL_globalzf2fromzf2_bglt) CREF(BgL_new3142z00_77))->BgL_fromz00) =
					((obj_t) BgL_from3141z00_2855), BUNSPEC);
				return BgL_new3142z00_77;
			}
		}
	}



/* _fill-global/from!3598 */
	obj_t BGl__fillzd2globalzf2fromz123598z32zzeffect_cgraphz00(obj_t
		BgL_envz00_2714, obj_t BgL_new3142z00_2715, obj_t BgL_from3141z00_2716)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalzf2fromzf2_bglt BgL_auxz00_3023;

				{	/* Effect/cgraph.scm 21 */
					BgL_globalzf2fromzf2_bglt BgL_res3636z00_2859;

					{	/* Effect/cgraph.scm 21 */
						BgL_globalzf2fromzf2_bglt BgL_new3142z00_2856;

						BgL_new3142z00_2856 =
							(BgL_globalzf2fromzf2_bglt) (BgL_new3142z00_2715);
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_from3141z00_2858;

							BgL_from3141z00_2858 = BgL_from3141z00_2716;
							((((BgL_globalzf2fromzf2_bglt) CREF(BgL_new3142z00_2856))->
									BgL_fromz00) = ((obj_t) BgL_from3141z00_2858), BUNSPEC);
							BgL_res3636z00_2859 = BgL_new3142z00_2856;
						}
					}
					BgL_auxz00_3023 = BgL_res3636z00_2859;
				}
				return (obj_t) (BgL_auxz00_3023);
			}
		}
	}



/* %allocate-global/from */
	BGL_EXPORTED_DEF BgL_globalz00_bglt
		BGl_z52allocatezd2globalzf2fromz72zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalz00_bglt BgL_new3145z00_2860;

				BgL_new3145z00_2860 =
					((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_globalz00_bgl))));
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3145z00_2860),
					BGl_classzd2numzd2zz__objectz00
					(BGl_globalzf2fromzf2zzeffect_cgraphz00));
				{	/* Effect/cgraph.scm 21 */
					BgL_objectz00_bglt BgL_auxz00_3031;

					BgL_auxz00_3031 = (BgL_objectz00_bglt) (BgL_new3145z00_2860);
					BGL_OBJECT_WIDENING_SET(BgL_auxz00_3031, BFALSE);
				}
				return BgL_new3145z00_2860;
			}
		}
	}



/* _%allocate-global/from */
	obj_t BGl__z52allocatezd2globalzf2fromz72zzeffect_cgraphz00(obj_t
		BgL_envz00_2690)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{	/* Effect/cgraph.scm 21 */
				BgL_globalz00_bglt BgL_auxz00_3034;

				{	/* Effect/cgraph.scm 21 */
					BgL_globalz00_bglt BgL_res3637z00_2864;

					{	/* Effect/cgraph.scm 21 */
						BgL_globalz00_bglt BgL_new3145z00_2862;

						BgL_new3145z00_2862 =
							((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_globalz00_bgl))));
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3145z00_2862),
							BGl_classzd2numzd2zz__objectz00
							(BGl_globalzf2fromzf2zzeffect_cgraphz00));
						{	/* Effect/cgraph.scm 21 */
							BgL_objectz00_bglt BgL_auxz00_3039;

							BgL_auxz00_3039 = (BgL_objectz00_bglt) (BgL_new3145z00_2862);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3039, BFALSE);
						}
						BgL_res3637z00_2864 = BgL_new3145z00_2862;
					}
					BgL_auxz00_3034 = BgL_res3637z00_2864;
				}
				return (obj_t) (BgL_auxz00_3034);
			}
		}
	}



/* global/from-nil */
	BGL_EXPORTED_DEF BgL_globalzf2fromzf2_bglt
		BGl_globalzf2fromzd2nilz20zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			if ((BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00 == BUNSPEC))
				{	/* Effect/cgraph.scm 21 */
					{	/* Effect/cgraph.scm 21 */
						BgL_globalz00_bglt BgL_res3516z00_1612;

						{	/* Effect/cgraph.scm 21 */
							BgL_globalz00_bglt BgL_new1567z00_1608;

							BgL_new1567z00_1608 =
								((BgL_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_globalz00_bgl))));
							BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
								(BgL_new1567z00_1608),
								BGl_classzd2numzd2zz__objectz00(BGl_globalz00zzast_varz00));
							{	/* Effect/cgraph.scm 21 */
								BgL_objectz00_bglt BgL_auxz00_3049;

								BgL_auxz00_3049 = (BgL_objectz00_bglt) (BgL_new1567z00_1608);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3049, BFALSE);
							}
							BgL_res3516z00_1612 = BgL_new1567z00_1608;
						}
						BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00 =
							(obj_t) (BgL_res3516z00_1612);
					}
					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_arg3336z00_858;

						BgL_typez00_bglt BgL_arg3337z00_859;

						BgL_valuez00_bglt BgL_arg3338z00_860;

						obj_t BgL_arg3340z00_862;

						BgL_arg3336z00_858 = CNST_TABLE_REF(((long) 3));
						BgL_arg3337z00_859 = BGl_typezd2nilzd2zztype_typez00();
						BgL_arg3338z00_860 = BGl_valuezd2nilzd2zzast_varz00();
						BgL_arg3340z00_862 = CNST_TABLE_REF(((long) 3));
						{	/* Effect/cgraph.scm 21 */
							BgL_globalz00_bglt BgL_res3517z00_1646;

							{	/* Effect/cgraph.scm 21 */
								BgL_globalz00_bglt BgL_new1549z00_1613;

								BgL_new1549z00_1613 =
									(BgL_globalz00_bglt)
									(BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00);
								{	/* Effect/cgraph.scm 21 */
									obj_t BgL_id1533z00_1630;

									obj_t BgL_name1534z00_1631;

									BgL_typez00_bglt BgL_type1535z00_1632;

									BgL_valuez00_bglt BgL_value1536z00_1633;

									obj_t BgL_access1537z00_1634;

									obj_t BgL_fastzd2alpha1538zd2_1635;

									obj_t BgL_removable1539z00_1636;

									long BgL_occurrence1540z00_1637;

									obj_t BgL_module1541z00_1638;

									obj_t BgL_import1542z00_1639;

									bool_t BgL_evaluablezf31543zf3_1640;

									obj_t BgL_library1544z00_1641;

									bool_t BgL_userzf31545zf3_1642;

									obj_t BgL_pragma1546z00_1643;

									obj_t BgL_src1547z00_1644;

									obj_t BgL_jvmzd2typezd2name1548z00_1645;

									BgL_id1533z00_1630 = BgL_arg3336z00_858;
									BgL_name1534z00_1631 = BUNSPEC;
									BgL_type1535z00_1632 = BgL_arg3337z00_859;
									BgL_value1536z00_1633 = BgL_arg3338z00_860;
									BgL_access1537z00_1634 = BUNSPEC;
									BgL_fastzd2alpha1538zd2_1635 = BUNSPEC;
									BgL_removable1539z00_1636 = BUNSPEC;
									BgL_occurrence1540z00_1637 = ((long) 0);
									BgL_module1541z00_1638 = BgL_arg3340z00_862;
									BgL_import1542z00_1639 = BUNSPEC;
									BgL_evaluablezf31543zf3_1640 = ((bool_t) 0);
									BgL_library1544z00_1641 = BUNSPEC;
									BgL_userzf31545zf3_1642 = ((bool_t) 0);
									BgL_pragma1546z00_1643 = BUNSPEC;
									BgL_src1547z00_1644 = BUNSPEC;
									BgL_jvmzd2typezd2name1548z00_1645 =
										BGl_string3605z00zzeffect_cgraphz00;
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_idz00) = ((obj_t) BgL_id1533z00_1630), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_namez00) = ((obj_t) BgL_name1534z00_1631), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_type1535z00_1632), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_valuez00) =
										((BgL_valuez00_bglt) BgL_value1536z00_1633), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_accessz00) =
										((obj_t) BgL_access1537z00_1634), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_fastzd2alphazd2) =
										((obj_t) BgL_fastzd2alpha1538zd2_1635), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_removablez00) =
										((obj_t) BgL_removable1539z00_1636), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_occurrencez00) =
										((long) BgL_occurrence1540z00_1637), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_modulez00) =
										((obj_t) BgL_module1541z00_1638), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_importz00) =
										((obj_t) BgL_import1542z00_1639), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_evaluablezf3zf3) =
										((bool_t) BgL_evaluablezf31543zf3_1640), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_libraryz00) =
										((obj_t) BgL_library1544z00_1641), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_userzf3zf3) =
										((bool_t) BgL_userzf31545zf3_1642), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_pragmaz00) =
										((obj_t) BgL_pragma1546z00_1643), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_srcz00) = ((obj_t) BgL_src1547z00_1644), BUNSPEC);
									((((BgL_globalz00_bglt) CREF(BgL_new1549z00_1613))->
											BgL_jvmzd2typezd2namez00) =
										((obj_t) BgL_jvmzd2typezd2name1548z00_1645), BUNSPEC);
									BgL_res3517z00_1646 = BgL_new1549z00_1613;
							}} BgL_res3517z00_1646;
					}}
					{	/* Effect/cgraph.scm 21 */
						long BgL_arg3342z00_864;

						BgL_arg3342z00_864 =
							BGl_classzd2numzd2zz__objectz00
							(BGl_globalzf2fromzf2zzeffect_cgraphz00);
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
							(BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00),
							BgL_arg3342z00_864);
					}
					{	/* Effect/cgraph.scm 21 */
						BgL_globalzf2fromzf2_bglt BgL_arg3343z00_865;

						{	/* Effect/cgraph.scm 21 */
							BgL_globalzf2fromzf2_bglt BgL_res3519z00_1655;

							{	/* Effect/cgraph.scm 21 */
								BgL_globalzf2fromzf2_bglt BgL_new3120z00_1650;

								BgL_new3120z00_1650 =
									((BgL_globalzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_globalzf2fromzf2_bgl))));
								{	/* Effect/cgraph.scm 21 */
									BgL_globalzf2fromzf2_bglt BgL_res3518z00_1654;

									{	/* Effect/cgraph.scm 21 */
										BgL_globalzf2fromzf2_bglt BgL_new3142z00_1651;

										BgL_new3142z00_1651 = BgL_new3120z00_1650;
										{	/* Effect/cgraph.scm 21 */
											obj_t BgL_from3141z00_1653;

											BgL_from3141z00_1653 = BUNSPEC;
											((((BgL_globalzf2fromzf2_bglt)
														CREF(BgL_new3142z00_1651))->BgL_fromz00) =
												((obj_t) BgL_from3141z00_1653), BUNSPEC);
											BgL_res3518z00_1654 = BgL_new3142z00_1651;
									}} BgL_res3518z00_1654;
								}
								BgL_res3519z00_1655 = BgL_new3120z00_1650;
							}
							BgL_arg3343z00_865 = BgL_res3519z00_1655;
						}
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_auxz00_3081;

							BgL_objectz00_bglt BgL_auxz00_3079;

							BgL_auxz00_3081 = (obj_t) (BgL_arg3343z00_865);
							BgL_auxz00_3079 =
								(BgL_objectz00_bglt)
								(BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3079, BgL_auxz00_3081);
				}}}
			else
				{	/* Effect/cgraph.scm 21 */
					BFALSE;
				}
			return
				(BgL_globalzf2fromzf2_bglt)
				(BGl_z52thezd2globalzf2fromzd2nilza0zzeffect_cgraphz00);
		}
	}



/* _global/from-nil */
	obj_t BGl__globalzf2fromzd2nilz20zzeffect_cgraphz00(obj_t BgL_envz00_2691)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			return (obj_t) (BGl_globalzf2fromzd2nilz20zzeffect_cgraphz00());
		}
	}



/* local/from? */
	BGL_EXPORTED_DEF bool_t BGl_localzf2fromzf3z01zzeffect_cgraphz00(obj_t
		BgL_obj3087z00_82)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return
				BGl_iszd2azf3z21zz__objectz00(BgL_obj3087z00_82,
				BGl_localzf2fromzf2zzeffect_cgraphz00);
		}
	}



/* _local/from? */
	obj_t BGl__localzf2fromzf3z01zzeffect_cgraphz00(obj_t BgL_envz00_2688,
		obj_t BgL_obj3087z00_2689)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj3087z00_2689,
					BGl_localzf2fromzf2zzeffect_cgraphz00));
		}
	}



/* widening-local/from */
	BGL_EXPORTED_DEF BgL_localzf2fromzf2_bglt
		BGl_wideningzd2localzf2fromz20zzeffect_cgraphz00(obj_t BgL_from3060z00_86)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localzf2fromzf2_bglt BgL_new3061z00_1656;

				BgL_new3061z00_1656 =
					((BgL_localzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_localzf2fromzf2_bgl))));
				{	/* Effect/cgraph.scm 20 */
					BgL_localzf2fromzf2_bglt BgL_res3520z00_1660;

					{	/* Effect/cgraph.scm 20 */
						BgL_localzf2fromzf2_bglt BgL_new3077z00_1657;

						BgL_new3077z00_1657 = BgL_new3061z00_1656;
						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_from3076z00_1659;

							BgL_from3076z00_1659 = BgL_from3060z00_86;
							((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3077z00_1657))->
									BgL_fromz00) = ((obj_t) BgL_from3076z00_1659), BUNSPEC);
							BgL_res3520z00_1660 = BgL_new3077z00_1657;
					}} BgL_res3520z00_1660;
				}
				return BgL_new3061z00_1656;
			}
		}
	}



/* _widening-local/from */
	obj_t BGl__wideningzd2localzf2fromz20zzeffect_cgraphz00(obj_t BgL_envz00_2717,
		obj_t BgL_from3060z00_2718)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return
				(obj_t) (BGl_wideningzd2localzf2fromz20zzeffect_cgraphz00
				(BgL_from3060z00_2718));
		}
	}



/* make-local/from */
	BGL_EXPORTED_DEF BgL_localzf2fromzf2_bglt
		BGl_makezd2localzf2fromz20zzeffect_cgraphz00(obj_t BgL_id3064z00_87,
		obj_t BgL_name3065z00_88, BgL_typez00_bglt BgL_type3066z00_89,
		BgL_valuez00_bglt BgL_value3067z00_90, obj_t BgL_access3068z00_91,
		obj_t BgL_fastzd2alpha3069zd2_92, obj_t BgL_removable3070z00_93,
		long BgL_occurrence3071z00_94, bool_t BgL_userzf33072zf3_95,
		long BgL_key3073z00_96, obj_t BgL_from3063z00_97)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localz00_bglt BgL_aux3074z00_1661;

				BgL_aux3074z00_1661 =
					BGl_makezd2localzd2zzast_varz00(BgL_id3064z00_87, BgL_name3065z00_88,
					BgL_type3066z00_89, BgL_value3067z00_90, BgL_access3068z00_91,
					BgL_fastzd2alpha3069zd2_92, BgL_removable3070z00_93,
					BgL_occurrence3071z00_94, BgL_userzf33072zf3_95, BgL_key3073z00_96);
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_aux3074z00_1661),
					BGl_classzd2numzd2zz__objectz00
					(BGl_localzf2fromzf2zzeffect_cgraphz00));
				{	/* Effect/cgraph.scm 20 */
					BgL_localzf2fromzf2_bglt BgL_arg3345z00_1663;

					{	/* Effect/cgraph.scm 20 */
						BgL_localzf2fromzf2_bglt BgL_res3522z00_1673;

						{	/* Effect/cgraph.scm 20 */
							BgL_localzf2fromzf2_bglt BgL_new3061z00_1668;

							BgL_new3061z00_1668 =
								((BgL_localzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_localzf2fromzf2_bgl))));
							{	/* Effect/cgraph.scm 20 */
								BgL_localzf2fromzf2_bglt BgL_res3521z00_1672;

								{	/* Effect/cgraph.scm 20 */
									BgL_localzf2fromzf2_bglt BgL_new3077z00_1669;

									BgL_new3077z00_1669 = BgL_new3061z00_1668;
									{	/* Effect/cgraph.scm 20 */
										obj_t BgL_from3076z00_1671;

										BgL_from3076z00_1671 = BgL_from3063z00_97;
										((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3077z00_1669))->
												BgL_fromz00) = ((obj_t) BgL_from3076z00_1671), BUNSPEC);
										BgL_res3521z00_1672 = BgL_new3077z00_1669;
								}} BgL_res3521z00_1672;
							}
							BgL_res3522z00_1673 = BgL_new3061z00_1668;
						}
						BgL_arg3345z00_1663 = BgL_res3522z00_1673;
					}
					{	/* Effect/cgraph.scm 20 */
						obj_t BgL_auxz00_3102;

						BgL_objectz00_bglt BgL_auxz00_3100;

						BgL_auxz00_3102 = (obj_t) (BgL_arg3345z00_1663);
						BgL_auxz00_3100 = (BgL_objectz00_bglt) (BgL_aux3074z00_1661);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_3100, BgL_auxz00_3102);
				}}
				return
					((BgL_localzf2fromzf2_bglt)
					(BgL_localzf2fromzf2_bglt) (BgL_aux3074z00_1661));
			}
		}
	}



/* _make-local/from3599 */
	obj_t BGl__makezd2localzf2from3599z20zzeffect_cgraphz00(obj_t BgL_envz00_2719,
		obj_t BgL_id3064z00_2720, obj_t BgL_name3065z00_2721,
		obj_t BgL_type3066z00_2722, obj_t BgL_value3067z00_2723,
		obj_t BgL_access3068z00_2724, obj_t BgL_fastzd2alpha3069zd2_2725,
		obj_t BgL_removable3070z00_2726, obj_t BgL_occurrence3071z00_2727,
		obj_t BgL_userzf33072zf3_2728, obj_t BgL_key3073z00_2729,
		obj_t BgL_from3063z00_2730)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return
				(obj_t) (BGl_makezd2localzf2fromz20zzeffect_cgraphz00
				(BgL_id3064z00_2720, BgL_name3065z00_2721,
					(BgL_typez00_bglt) (BgL_type3066z00_2722),
					(BgL_valuez00_bglt) (BgL_value3067z00_2723), BgL_access3068z00_2724,
					BgL_fastzd2alpha3069zd2_2725, BgL_removable3070z00_2726,
					(long) CINT(BgL_occurrence3071z00_2727),
					CBOOL(BgL_userzf33072zf3_2728), (long) CINT(BgL_key3073z00_2729),
					BgL_from3063z00_2730));
		}
	}



/* fill-local/from! */
	BGL_EXPORTED_DEF BgL_localzf2fromzf2_bglt
		BGl_fillzd2localzf2fromz12z32zzeffect_cgraphz00(BgL_localzf2fromzf2_bglt
		BgL_new3077z00_98, obj_t BgL_from3076z00_99)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				obj_t BgL_from3076z00_2866;

				BgL_from3076z00_2866 = BgL_from3076z00_99;
				((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3077z00_98))->BgL_fromz00) =
					((obj_t) BgL_from3076z00_2866), BUNSPEC);
				return BgL_new3077z00_98;
			}
		}
	}



/* _fill-local/from!3600 */
	obj_t BGl__fillzd2localzf2fromz123600z32zzeffect_cgraphz00(obj_t
		BgL_envz00_2731, obj_t BgL_new3077z00_2732, obj_t BgL_from3076z00_2733)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localzf2fromzf2_bglt BgL_auxz00_3115;

				{	/* Effect/cgraph.scm 20 */
					BgL_localzf2fromzf2_bglt BgL_res3638z00_2870;

					{	/* Effect/cgraph.scm 20 */
						BgL_localzf2fromzf2_bglt BgL_new3077z00_2867;

						BgL_new3077z00_2867 =
							(BgL_localzf2fromzf2_bglt) (BgL_new3077z00_2732);
						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_from3076z00_2869;

							BgL_from3076z00_2869 = BgL_from3076z00_2733;
							((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3077z00_2867))->
									BgL_fromz00) = ((obj_t) BgL_from3076z00_2869), BUNSPEC);
							BgL_res3638z00_2870 = BgL_new3077z00_2867;
						}
					}
					BgL_auxz00_3115 = BgL_res3638z00_2870;
				}
				return (obj_t) (BgL_auxz00_3115);
			}
		}
	}



/* %allocate-local/from */
	BGL_EXPORTED_DEF BgL_localz00_bglt
		BGl_z52allocatezd2localzf2fromz72zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localz00_bglt BgL_new3080z00_2871;

				BgL_new3080z00_2871 =
					((BgL_localz00_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_localz00_bgl))));
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3080z00_2871),
					BGl_classzd2numzd2zz__objectz00
					(BGl_localzf2fromzf2zzeffect_cgraphz00));
				{	/* Effect/cgraph.scm 20 */
					BgL_objectz00_bglt BgL_auxz00_3123;

					BgL_auxz00_3123 = (BgL_objectz00_bglt) (BgL_new3080z00_2871);
					BGL_OBJECT_WIDENING_SET(BgL_auxz00_3123, BFALSE);
				}
				return BgL_new3080z00_2871;
			}
		}
	}



/* _%allocate-local/from */
	obj_t BGl__z52allocatezd2localzf2fromz72zzeffect_cgraphz00(obj_t
		BgL_envz00_2686)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{	/* Effect/cgraph.scm 20 */
				BgL_localz00_bglt BgL_auxz00_3126;

				{	/* Effect/cgraph.scm 20 */
					BgL_localz00_bglt BgL_res3639z00_2875;

					{	/* Effect/cgraph.scm 20 */
						BgL_localz00_bglt BgL_new3080z00_2873;

						BgL_new3080z00_2873 =
							((BgL_localz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_localz00_bgl))));
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3080z00_2873),
							BGl_classzd2numzd2zz__objectz00
							(BGl_localzf2fromzf2zzeffect_cgraphz00));
						{	/* Effect/cgraph.scm 20 */
							BgL_objectz00_bglt BgL_auxz00_3131;

							BgL_auxz00_3131 = (BgL_objectz00_bglt) (BgL_new3080z00_2873);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3131, BFALSE);
						}
						BgL_res3639z00_2875 = BgL_new3080z00_2873;
					}
					BgL_auxz00_3126 = BgL_res3639z00_2875;
				}
				return (obj_t) (BgL_auxz00_3126);
			}
		}
	}



/* local/from-nil */
	BGL_EXPORTED_DEF BgL_localzf2fromzf2_bglt
		BGl_localzf2fromzd2nilz20zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			if ((BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00 == BUNSPEC))
				{	/* Effect/cgraph.scm 20 */
					{	/* Effect/cgraph.scm 20 */
						BgL_localz00_bglt BgL_res3523z00_1683;

						{	/* Effect/cgraph.scm 20 */
							BgL_localz00_bglt BgL_new1628z00_1679;

							BgL_new1628z00_1679 =
								((BgL_localz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_localz00_bgl))));
							BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
								(BgL_new1628z00_1679),
								BGl_classzd2numzd2zz__objectz00(BGl_localz00zzast_varz00));
							{	/* Effect/cgraph.scm 20 */
								BgL_objectz00_bglt BgL_auxz00_3141;

								BgL_auxz00_3141 = (BgL_objectz00_bglt) (BgL_new1628z00_1679);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3141, BFALSE);
							}
							BgL_res3523z00_1683 = BgL_new1628z00_1679;
						}
						BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00 =
							(obj_t) (BgL_res3523z00_1683);
					}
					{	/* Effect/cgraph.scm 20 */
						obj_t BgL_arg3348z00_875;

						BgL_typez00_bglt BgL_arg3349z00_876;

						BgL_valuez00_bglt BgL_arg3350z00_877;

						BgL_arg3348z00_875 = CNST_TABLE_REF(((long) 3));
						BgL_arg3349z00_876 = BGl_typezd2nilzd2zztype_typez00();
						BgL_arg3350z00_877 = BGl_valuezd2nilzd2zzast_varz00();
						{	/* Effect/cgraph.scm 20 */
							BgL_localz00_bglt BgL_res3524z00_1705;

							{	/* Effect/cgraph.scm 20 */
								BgL_localz00_bglt BgL_new1616z00_1684;

								BgL_new1616z00_1684 =
									(BgL_localz00_bglt)
									(BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00);
								{	/* Effect/cgraph.scm 20 */
									obj_t BgL_id1606z00_1695;

									obj_t BgL_name1607z00_1696;

									BgL_typez00_bglt BgL_type1608z00_1697;

									BgL_valuez00_bglt BgL_value1609z00_1698;

									obj_t BgL_access1610z00_1699;

									obj_t BgL_fastzd2alpha1611zd2_1700;

									obj_t BgL_removable1612z00_1701;

									long BgL_occurrence1613z00_1702;

									bool_t BgL_userzf31614zf3_1703;

									long BgL_key1615z00_1704;

									BgL_id1606z00_1695 = BgL_arg3348z00_875;
									BgL_name1607z00_1696 = BUNSPEC;
									BgL_type1608z00_1697 = BgL_arg3349z00_876;
									BgL_value1609z00_1698 = BgL_arg3350z00_877;
									BgL_access1610z00_1699 = BUNSPEC;
									BgL_fastzd2alpha1611zd2_1700 = BUNSPEC;
									BgL_removable1612z00_1701 = BUNSPEC;
									BgL_occurrence1613z00_1702 = ((long) 0);
									BgL_userzf31614zf3_1703 = ((bool_t) 0);
									BgL_key1615z00_1704 = ((long) 0);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_idz00) = ((obj_t) BgL_id1606z00_1695), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_namez00) = ((obj_t) BgL_name1607z00_1696), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_type1608z00_1697), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_valuez00) =
										((BgL_valuez00_bglt) BgL_value1609z00_1698), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_accessz00) =
										((obj_t) BgL_access1610z00_1699), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_fastzd2alphazd2) =
										((obj_t) BgL_fastzd2alpha1611zd2_1700), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_removablez00) =
										((obj_t) BgL_removable1612z00_1701), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_occurrencez00) =
										((long) BgL_occurrence1613z00_1702), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_userzf3zf3) =
										((bool_t) BgL_userzf31614zf3_1703), BUNSPEC);
									((((BgL_localz00_bglt) CREF(BgL_new1616z00_1684))->
											BgL_keyz00) = ((long) BgL_key1615z00_1704), BUNSPEC);
									BgL_res3524z00_1705 = BgL_new1616z00_1684;
							}} BgL_res3524z00_1705;
					}}
					{	/* Effect/cgraph.scm 20 */
						long BgL_arg3353z00_880;

						BgL_arg3353z00_880 =
							BGl_classzd2numzd2zz__objectz00
							(BGl_localzf2fromzf2zzeffect_cgraphz00);
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
							(BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00),
							BgL_arg3353z00_880);
					}
					{	/* Effect/cgraph.scm 20 */
						BgL_localzf2fromzf2_bglt BgL_arg3354z00_881;

						{	/* Effect/cgraph.scm 20 */
							BgL_localzf2fromzf2_bglt BgL_res3526z00_1714;

							{	/* Effect/cgraph.scm 20 */
								BgL_localzf2fromzf2_bglt BgL_new3061z00_1709;

								BgL_new3061z00_1709 =
									((BgL_localzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_localzf2fromzf2_bgl))));
								{	/* Effect/cgraph.scm 20 */
									BgL_localzf2fromzf2_bglt BgL_res3525z00_1713;

									{	/* Effect/cgraph.scm 20 */
										BgL_localzf2fromzf2_bglt BgL_new3077z00_1710;

										BgL_new3077z00_1710 = BgL_new3061z00_1709;
										{	/* Effect/cgraph.scm 20 */
											obj_t BgL_from3076z00_1712;

											BgL_from3076z00_1712 = BUNSPEC;
											((((BgL_localzf2fromzf2_bglt) CREF(BgL_new3077z00_1710))->
													BgL_fromz00) =
												((obj_t) BgL_from3076z00_1712), BUNSPEC);
											BgL_res3525z00_1713 = BgL_new3077z00_1710;
									}} BgL_res3525z00_1713;
								}
								BgL_res3526z00_1714 = BgL_new3061z00_1709;
							}
							BgL_arg3354z00_881 = BgL_res3526z00_1714;
						}
						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_auxz00_3166;

							BgL_objectz00_bglt BgL_auxz00_3164;

							BgL_auxz00_3166 = (obj_t) (BgL_arg3354z00_881);
							BgL_auxz00_3164 =
								(BgL_objectz00_bglt)
								(BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3164, BgL_auxz00_3166);
				}}}
			else
				{	/* Effect/cgraph.scm 20 */
					BFALSE;
				}
			return
				(BgL_localzf2fromzf2_bglt)
				(BGl_z52thezd2localzf2fromzd2nilza0zzeffect_cgraphz00);
		}
	}



/* _local/from-nil */
	obj_t BGl__localzf2fromzd2nilz20zzeffect_cgraphz00(obj_t BgL_envz00_2687)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			return (obj_t) (BGl_localzf2fromzd2nilz20zzeffect_cgraphz00());
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_callzd2graphz12zd2default3261zd2envzc0zzeffect_cgraphz00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_savezd2callz12zd2default3297zd2envzc0zzeffect_cgraphz00);
		}
	}



/* call-graph! */
	obj_t BGl_callzd2graphz12zc0zzeffect_cgraphz00(BgL_nodez00_bglt BgL_nodez00_2,
		BgL_variablez00_bglt BgL_ownerz00_3)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 37 */
			{	/* Effect/cgraph.scm 37 */
				obj_t BgL_method3262z00_1749;

				{	/* Effect/cgraph.scm 37 */
					BgL_objectz00_bglt BgL_objz00_1750;

					BgL_objz00_1750 = (BgL_objectz00_bglt) (BgL_nodez00_2);
					{	/* Effect/cgraph.scm 37 */
						long BgL_objzd2classzd2numz00_1751;

						BgL_objzd2classzd2numz00_1751 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1750);
						{	/* Effect/cgraph.scm 37 */
							obj_t BgL_arg2334z00_1752;

							BgL_arg2334z00_1752 =
								PROCEDURE_REF(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
								(int) (((long) 1)));
							{	/* Effect/cgraph.scm 37 */
								obj_t BgL_arrayz00_1754;

								int BgL_offsetz00_1755;

								BgL_arrayz00_1754 = BgL_arg2334z00_1752;
								BgL_offsetz00_1755 = (int) (BgL_objzd2classzd2numz00_1751);
								{	/* Effect/cgraph.scm 37 */
									long BgL_offsetz00_1756;

									BgL_offsetz00_1756 =
										((long) (BgL_offsetz00_1755) - OBJECT_TYPE);
									{	/* Effect/cgraph.scm 37 */
										long BgL_modz00_1757;

										{	/* Effect/cgraph.scm 37 */
											int BgL_arg2336z00_1758;

											BgL_arg2336z00_1758 = (int) (((long) 8));
											{	/* Effect/cgraph.scm 37 */
												long BgL_auxz00_3182;

												BgL_auxz00_3182 = (long) (BgL_arg2336z00_1758);
												BgL_modz00_1757 =
													(BgL_offsetz00_1756 / BgL_auxz00_3182);
										}}
										{	/* Effect/cgraph.scm 37 */
											long BgL_restz00_1759;

											{	/* Effect/cgraph.scm 37 */
												int BgL_arg2335z00_1760;

												BgL_arg2335z00_1760 = (int) (((long) 8));
												{	/* Effect/cgraph.scm 37 */
													long BgL_auxz00_3186;

													BgL_auxz00_3186 = (long) (BgL_arg2335z00_1760);
													BgL_restz00_1759 =
														(BgL_offsetz00_1756 % BgL_auxz00_3186);
											}}
											{	/* Effect/cgraph.scm 37 */

												BgL_method3262z00_1749 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1754,
														(int) (BgL_modz00_1757)), (int) (BgL_restz00_1759));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3262z00_1749) (BgL_method3262z00_1749,
					(obj_t) (BgL_nodez00_2), (obj_t) (BgL_ownerz00_3), BEOA);
			}
		}
	}



/* _call-graph!3596 */
	obj_t BGl__callzd2graphz123596zc0zzeffect_cgraphz00(obj_t BgL_envz00_2680,
		obj_t BgL_nodez00_2681, obj_t BgL_ownerz00_2682)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 37 */
			return
				BGl_callzd2graphz12zc0zzeffect_cgraphz00(
				(BgL_nodez00_bglt) (BgL_nodez00_2681),
				(BgL_variablez00_bglt) (BgL_ownerz00_2682));
		}
	}



/* _call-graph!-default3261 */
	obj_t BGl__callzd2graphz12zd2default3261z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2734, obj_t BgL_nodez00_2735, obj_t BgL_ownerz00_2736)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			{	/* Effect/cgraph.scm 38 */
				obj_t BgL_res3640z00_2878;

				BgL_res3640z00_2878 = CNST_TABLE_REF(((long) 4));
				return BgL_res3640z00_2878;
			}
		}
	}



/* save-call! */
	obj_t BGl_savezd2callz12zc0zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_calleez00_42, BgL_variablez00_bglt BgL_ownerz00_43)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 203 */
			{	/* Effect/cgraph.scm 203 */
				obj_t BgL_method3298z00_1774;

				{	/* Effect/cgraph.scm 203 */
					BgL_objectz00_bglt BgL_objz00_1775;

					BgL_objz00_1775 = (BgL_objectz00_bglt) (BgL_calleez00_42);
					{	/* Effect/cgraph.scm 203 */
						long BgL_objzd2classzd2numz00_1776;

						BgL_objzd2classzd2numz00_1776 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1775);
						{	/* Effect/cgraph.scm 203 */
							obj_t BgL_arg2334z00_1777;

							BgL_arg2334z00_1777 =
								PROCEDURE_REF(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
								(int) (((long) 1)));
							{	/* Effect/cgraph.scm 203 */
								obj_t BgL_arrayz00_1779;

								int BgL_offsetz00_1780;

								BgL_arrayz00_1779 = BgL_arg2334z00_1777;
								BgL_offsetz00_1780 = (int) (BgL_objzd2classzd2numz00_1776);
								{	/* Effect/cgraph.scm 203 */
									long BgL_offsetz00_1781;

									BgL_offsetz00_1781 =
										((long) (BgL_offsetz00_1780) - OBJECT_TYPE);
									{	/* Effect/cgraph.scm 203 */
										long BgL_modz00_1782;

										{	/* Effect/cgraph.scm 203 */
											int BgL_arg2336z00_1783;

											BgL_arg2336z00_1783 = (int) (((long) 8));
											{	/* Effect/cgraph.scm 203 */
												long BgL_auxz00_3209;

												BgL_auxz00_3209 = (long) (BgL_arg2336z00_1783);
												BgL_modz00_1782 =
													(BgL_offsetz00_1781 / BgL_auxz00_3209);
										}}
										{	/* Effect/cgraph.scm 203 */
											long BgL_restz00_1784;

											{	/* Effect/cgraph.scm 203 */
												int BgL_arg2335z00_1785;

												BgL_arg2335z00_1785 = (int) (((long) 8));
												{	/* Effect/cgraph.scm 203 */
													long BgL_auxz00_3213;

													BgL_auxz00_3213 = (long) (BgL_arg2335z00_1785);
													BgL_restz00_1784 =
														(BgL_offsetz00_1781 % BgL_auxz00_3213);
											}}
											{	/* Effect/cgraph.scm 203 */

												BgL_method3298z00_1774 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1779,
														(int) (BgL_modz00_1782)), (int) (BgL_restz00_1784));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3298z00_1774) (BgL_method3298z00_1774,
					(obj_t) (BgL_calleez00_42), (obj_t) (BgL_ownerz00_43), BEOA);
			}
		}
	}



/* _save-call!3601 */
	obj_t BGl__savezd2callz123601zc0zzeffect_cgraphz00(obj_t BgL_envz00_2737,
		obj_t BgL_calleez00_2738, obj_t BgL_ownerz00_2739)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 203 */
			return
				BGl_savezd2callz12zc0zzeffect_cgraphz00(
				(BgL_variablez00_bglt) (BgL_calleez00_2738),
				(BgL_variablez00_bglt) (BgL_ownerz00_2739));
		}
	}



/* save-call!-default3297 */
	obj_t
		BGl_savezd2callz12zd2default3297z12zzeffect_cgraphz00(BgL_variablez00_bglt
		BgL_calleez00_44, BgL_variablez00_bglt BgL_ownerz00_45)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			return
				BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 5)),
				BGl_string3606z00zzeffect_cgraphz00, (obj_t) (BgL_calleez00_44));
		}
	}



/* _save-call!-default3297 */
	obj_t BGl__savezd2callz12zd2default3297z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2740, obj_t BgL_calleez00_2741, obj_t BgL_ownerz00_2742)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			return
				BGl_savezd2callz12zd2default3297z12zzeffect_cgraphz00(
				(BgL_variablez00_bglt) (BgL_calleez00_2741),
				(BgL_variablez00_bglt) (BgL_ownerz00_2742));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3607z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_appz00zzast_nodez00, BGl_proc3608z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3609z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_funcallz00zzast_nodez00, BGl_proc3610z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_externz00zzast_nodez00, BGl_proc3611z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_castz00zzast_nodez00, BGl_proc3612z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_setqz00zzast_nodez00, BGl_proc3613z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3614z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_failz00zzast_nodez00, BGl_proc3615z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_selectz00zzast_nodez00, BGl_proc3616z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3617z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3618z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3619z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3620z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3621z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3622z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3623z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_globalz00zzast_varz00, BGl_proc3624z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_globalzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3625z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_localz00zzast_varz00, BGl_proc3626z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
				BGl_localzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3627z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_objectzd2ze3structzd2envze3zz__objectz00,
				BGl_globalzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3628z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
				BGl_globalzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3629z00zzeffect_cgraphz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_objectzd2ze3structzd2envze3zz__objectz00,
				BGl_localzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3630z00zzeffect_cgraphz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
				BGl_localzf2fromzf2zzeffect_cgraphz00,
				BGl_proc3631z00zzeffect_cgraphz00);
		}
	}



/* struct+object->objec3315 */
	obj_t BGl_structzb2objectzd2ze3objec3315z83zzeffect_cgraphz00(obj_t
		BgL_envz00_2773, obj_t BgL_oz00_2774, obj_t BgL_sz00_2775)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{
				BgL_localzf2fromzf2_bglt BgL_oz00_1510;

				obj_t BgL_sz00_1511;

				{	/* Effect/cgraph.scm 20 */
					BgL_localzf2fromzf2_bglt BgL_auxz00_3258;

					BgL_oz00_1510 = (BgL_localzf2fromzf2_bglt) (BgL_oz00_2774);
					BgL_sz00_1511 = BgL_sz00_2775;
					{

						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_old3084z00_1514;

							obj_t BgL_aux3085z00_1515;

							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_nextzd2method3314zd2_1520;

								BgL_nextzd2method3314zd2_1520 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									(BgL_objectz00_bglt) (BgL_oz00_1510),
									BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
									BGl_localzf2fromzf2zzeffect_cgraphz00);
								if (PROCEDUREP(BgL_nextzd2method3314zd2_1520))
									{	/* Effect/cgraph.scm 20 */
										BgL_old3084z00_1514 =
											PROCEDURE_ENTRY(BgL_nextzd2method3314zd2_1520)
											(BgL_nextzd2method3314zd2_1520, (obj_t) (BgL_oz00_1510),
											BgL_sz00_1511, BEOA);
									}
								else
									{	/* Effect/cgraph.scm 20 */
										BgL_old3084z00_1514 =
											(obj_t) (BGl_structzb2objectzd2ze3objectz83zz__objectz00(
												(BgL_objectz00_bglt) (BgL_oz00_1510), BgL_sz00_1511));
									}
							}
							BgL_aux3085z00_1515 =
								STRUCT_REF(BgL_sz00_1511, (int) (((long) 0)));
							{	/* Effect/cgraph.scm 20 */
								BgL_localzf2fromzf2_bglt BgL_new3086z00_1516;

								BgL_new3086z00_1516 =
									((BgL_localzf2fromzf2_bglt) (BgL_old3084z00_1514));
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_new3086z00_1516),
									BGl_classzd2numzd2zz__objectz00
									(BGl_localzf2fromzf2zzeffect_cgraphz00));
								{	/* Effect/cgraph.scm 20 */
									BgL_localzf2fromzf2_bglt BgL_arg3506z00_1518;

									{	/* Effect/cgraph.scm 20 */
										obj_t BgL_arg3507z00_1519;

										BgL_arg3507z00_1519 =
											STRUCT_REF(BgL_aux3085z00_1515, (int) (((long) 0)));
										{	/* Effect/cgraph.scm 20 */
											BgL_localzf2fromzf2_bglt BgL_res3594z00_2676;

											{	/* Effect/cgraph.scm 20 */
												BgL_localzf2fromzf2_bglt BgL_new3061z00_2671;

												BgL_new3061z00_2671 =
													((BgL_localzf2fromzf2_bglt)
													BREF(GC_MALLOC(sizeof(struct
																BgL_localzf2fromzf2_bgl))));
												{	/* Effect/cgraph.scm 20 */
													BgL_localzf2fromzf2_bglt BgL_res3593z00_2675;

													{	/* Effect/cgraph.scm 20 */
														BgL_localzf2fromzf2_bglt BgL_new3077z00_2672;

														BgL_new3077z00_2672 = BgL_new3061z00_2671;
														{	/* Effect/cgraph.scm 20 */
															obj_t BgL_from3076z00_2674;

															BgL_from3076z00_2674 = BgL_arg3507z00_1519;
															((((BgL_localzf2fromzf2_bglt)
																		CREF(BgL_new3077z00_2672))->BgL_fromz00) =
																((obj_t) BgL_from3076z00_2674), BUNSPEC);
															BgL_res3593z00_2675 = BgL_new3077z00_2672;
													}} BgL_res3593z00_2675;
												}
												BgL_res3594z00_2676 = BgL_new3061z00_2671;
											}
											BgL_arg3506z00_1518 = BgL_res3594z00_2676;
									}}
									{	/* Effect/cgraph.scm 20 */
										obj_t BgL_auxz00_3281;

										BgL_objectz00_bglt BgL_auxz00_3279;

										BgL_auxz00_3281 = (obj_t) (BgL_arg3506z00_1518);
										BgL_auxz00_3279 =
											(BgL_objectz00_bglt) (BgL_new3086z00_1516);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_3279, BgL_auxz00_3281);
								}}
								BgL_auxz00_3258 = BgL_new3086z00_1516;
					}}}
					return (obj_t) (BgL_auxz00_3258);
				}
			}
		}
	}



/* object->struct-local3313 */
	obj_t BGl_objectzd2ze3structzd2local3313ze3zzeffect_cgraphz00(obj_t
		BgL_envz00_2776, obj_t BgL_obj3081z00_2777)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 20 */
			{
				BgL_localzf2fromzf2_bglt BgL_obj3081z00_1500;

				BgL_obj3081z00_1500 = (BgL_localzf2fromzf2_bglt) (BgL_obj3081z00_2777);
				{

					{	/* Effect/cgraph.scm 20 */
						obj_t BgL_res3082z00_1503;

						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_nextzd2method3312zd2_1508;

							BgL_nextzd2method3312zd2_1508 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_obj3081z00_1500),
								BGl_objectzd2ze3structzd2envze3zz__objectz00,
								BGl_localzf2fromzf2zzeffect_cgraphz00);
							if (PROCEDUREP(BgL_nextzd2method3312zd2_1508))
								{	/* Effect/cgraph.scm 20 */
									BgL_res3082z00_1503 =
										PROCEDURE_ENTRY(BgL_nextzd2method3312zd2_1508)
										(BgL_nextzd2method3312zd2_1508,
										(obj_t) (BgL_obj3081z00_1500), BEOA);
								}
							else
								{	/* Effect/cgraph.scm 20 */
									BgL_res3082z00_1503 =
										BGl_objectzd2ze3structz31zz__objectz00(
										(BgL_objectz00_bglt) (BgL_obj3081z00_1500));
								}
						}
						{	/* Effect/cgraph.scm 20 */
							obj_t BgL_aux3083z00_1504;

							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_keyz00_2647;

								BgL_keyz00_2647 = CNST_TABLE_REF(((long) 1));
								BgL_aux3083z00_1504 =
									make_struct(BgL_keyz00_2647, (int) (((long) 1)), BUNSPEC);
							}
							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_arg3502z00_1506;

								{
									obj_t BgL_auxz00_3298;

									{	/* Effect/cgraph.scm 20 */
										BgL_objectz00_bglt BgL_auxz00_3299;

										BgL_auxz00_3299 =
											(BgL_objectz00_bglt) (BgL_obj3081z00_1500);
										BgL_auxz00_3298 = BGL_OBJECT_WIDENING(BgL_auxz00_3299);
									}
									BgL_arg3502z00_1506 =
										(((BgL_localzf2fromzf2_bglt) CREF(BgL_auxz00_3298))->
										BgL_fromz00);
								}
								{	/* Effect/cgraph.scm 20 */
									int BgL_auxz00_3303;

									BgL_auxz00_3303 = (int) (((long) 0));
									STRUCT_SET(BgL_aux3083z00_1504, BgL_auxz00_3303,
										BgL_arg3502z00_1506);
							}}
							{	/* Effect/cgraph.scm 20 */
								int BgL_auxz00_3306;

								BgL_auxz00_3306 = (int) (((long) 0));
								STRUCT_SET(BgL_res3082z00_1503, BgL_auxz00_3306,
									BgL_aux3083z00_1504);
							}
							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_auxz00_3309;

								BgL_auxz00_3309 = STRUCT_KEY(BgL_res3082z00_1503);
								STRUCT_KEY_SET(BgL_aux3083z00_1504, BgL_auxz00_3309);
							}
							{	/* Effect/cgraph.scm 20 */
								obj_t BgL_kz00_2662;

								BgL_kz00_2662 = CNST_TABLE_REF(((long) 1));
								STRUCT_KEY_SET(BgL_res3082z00_1503, BgL_kz00_2662);
							}
							return BgL_res3082z00_1503;
						}
					}
				}
			}
		}
	}



/* struct+object->objec3311 */
	obj_t BGl_structzb2objectzd2ze3objec3311z83zzeffect_cgraphz00(obj_t
		BgL_envz00_2778, obj_t BgL_oz00_2779, obj_t BgL_sz00_2780)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{
				BgL_globalzf2fromzf2_bglt BgL_oz00_1488;

				obj_t BgL_sz00_1489;

				{	/* Effect/cgraph.scm 21 */
					BgL_globalzf2fromzf2_bglt BgL_auxz00_3315;

					BgL_oz00_1488 = (BgL_globalzf2fromzf2_bglt) (BgL_oz00_2779);
					BgL_sz00_1489 = BgL_sz00_2780;
					{

						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_old3149z00_1492;

							obj_t BgL_aux3150z00_1493;

							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_nextzd2method3310zd2_1498;

								BgL_nextzd2method3310zd2_1498 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									(BgL_objectz00_bglt) (BgL_oz00_1488),
									BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
									BGl_globalzf2fromzf2zzeffect_cgraphz00);
								if (PROCEDUREP(BgL_nextzd2method3310zd2_1498))
									{	/* Effect/cgraph.scm 21 */
										BgL_old3149z00_1492 =
											PROCEDURE_ENTRY(BgL_nextzd2method3310zd2_1498)
											(BgL_nextzd2method3310zd2_1498, (obj_t) (BgL_oz00_1488),
											BgL_sz00_1489, BEOA);
									}
								else
									{	/* Effect/cgraph.scm 21 */
										BgL_old3149z00_1492 =
											(obj_t) (BGl_structzb2objectzd2ze3objectz83zz__objectz00(
												(BgL_objectz00_bglt) (BgL_oz00_1488), BgL_sz00_1489));
									}
							}
							BgL_aux3150z00_1493 =
								STRUCT_REF(BgL_sz00_1489, (int) (((long) 0)));
							{	/* Effect/cgraph.scm 21 */
								BgL_globalzf2fromzf2_bglt BgL_new3151z00_1494;

								BgL_new3151z00_1494 =
									((BgL_globalzf2fromzf2_bglt) (BgL_old3149z00_1492));
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_new3151z00_1494),
									BGl_classzd2numzd2zz__objectz00
									(BGl_globalzf2fromzf2zzeffect_cgraphz00));
								{	/* Effect/cgraph.scm 21 */
									BgL_globalzf2fromzf2_bglt BgL_arg3495z00_1496;

									{	/* Effect/cgraph.scm 21 */
										obj_t BgL_arg3499z00_1497;

										BgL_arg3499z00_1497 =
											STRUCT_REF(BgL_aux3150z00_1493, (int) (((long) 0)));
										{	/* Effect/cgraph.scm 21 */
											BgL_globalzf2fromzf2_bglt BgL_res3591z00_2645;

											{	/* Effect/cgraph.scm 21 */
												BgL_globalzf2fromzf2_bglt BgL_new3120z00_2640;

												BgL_new3120z00_2640 =
													((BgL_globalzf2fromzf2_bglt)
													BREF(GC_MALLOC(sizeof(struct
																BgL_globalzf2fromzf2_bgl))));
												{	/* Effect/cgraph.scm 21 */
													BgL_globalzf2fromzf2_bglt BgL_res3590z00_2644;

													{	/* Effect/cgraph.scm 21 */
														BgL_globalzf2fromzf2_bglt BgL_new3142z00_2641;

														BgL_new3142z00_2641 = BgL_new3120z00_2640;
														{	/* Effect/cgraph.scm 21 */
															obj_t BgL_from3141z00_2643;

															BgL_from3141z00_2643 = BgL_arg3499z00_1497;
															((((BgL_globalzf2fromzf2_bglt)
																		CREF(BgL_new3142z00_2641))->BgL_fromz00) =
																((obj_t) BgL_from3141z00_2643), BUNSPEC);
															BgL_res3590z00_2644 = BgL_new3142z00_2641;
													}} BgL_res3590z00_2644;
												}
												BgL_res3591z00_2645 = BgL_new3120z00_2640;
											}
											BgL_arg3495z00_1496 = BgL_res3591z00_2645;
									}}
									{	/* Effect/cgraph.scm 21 */
										obj_t BgL_auxz00_3338;

										BgL_objectz00_bglt BgL_auxz00_3336;

										BgL_auxz00_3338 = (obj_t) (BgL_arg3495z00_1496);
										BgL_auxz00_3336 =
											(BgL_objectz00_bglt) (BgL_new3151z00_1494);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_3336, BgL_auxz00_3338);
								}}
								BgL_auxz00_3315 = BgL_new3151z00_1494;
					}}}
					return (obj_t) (BgL_auxz00_3315);
				}
			}
		}
	}



/* object->struct-globa3309 */
	obj_t BGl_objectzd2ze3structzd2globa3309ze3zzeffect_cgraphz00(obj_t
		BgL_envz00_2781, obj_t BgL_obj3146z00_2782)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 21 */
			{
				BgL_globalzf2fromzf2_bglt BgL_obj3146z00_1478;

				BgL_obj3146z00_1478 = (BgL_globalzf2fromzf2_bglt) (BgL_obj3146z00_2782);
				{

					{	/* Effect/cgraph.scm 21 */
						obj_t BgL_res3147z00_1481;

						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_nextzd2method3308zd2_1486;

							BgL_nextzd2method3308zd2_1486 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_obj3146z00_1478),
								BGl_objectzd2ze3structzd2envze3zz__objectz00,
								BGl_globalzf2fromzf2zzeffect_cgraphz00);
							if (PROCEDUREP(BgL_nextzd2method3308zd2_1486))
								{	/* Effect/cgraph.scm 21 */
									BgL_res3147z00_1481 =
										PROCEDURE_ENTRY(BgL_nextzd2method3308zd2_1486)
										(BgL_nextzd2method3308zd2_1486,
										(obj_t) (BgL_obj3146z00_1478), BEOA);
								}
							else
								{	/* Effect/cgraph.scm 21 */
									BgL_res3147z00_1481 =
										BGl_objectzd2ze3structz31zz__objectz00(
										(BgL_objectz00_bglt) (BgL_obj3146z00_1478));
								}
						}
						{	/* Effect/cgraph.scm 21 */
							obj_t BgL_aux3148z00_1482;

							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_keyz00_2616;

								BgL_keyz00_2616 = CNST_TABLE_REF(((long) 2));
								BgL_aux3148z00_1482 =
									make_struct(BgL_keyz00_2616, (int) (((long) 1)), BUNSPEC);
							}
							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_arg3491z00_1484;

								{
									obj_t BgL_auxz00_3355;

									{	/* Effect/cgraph.scm 21 */
										BgL_objectz00_bglt BgL_auxz00_3356;

										BgL_auxz00_3356 =
											(BgL_objectz00_bglt) (BgL_obj3146z00_1478);
										BgL_auxz00_3355 = BGL_OBJECT_WIDENING(BgL_auxz00_3356);
									}
									BgL_arg3491z00_1484 =
										(((BgL_globalzf2fromzf2_bglt) CREF(BgL_auxz00_3355))->
										BgL_fromz00);
								}
								{	/* Effect/cgraph.scm 21 */
									int BgL_auxz00_3360;

									BgL_auxz00_3360 = (int) (((long) 0));
									STRUCT_SET(BgL_aux3148z00_1482, BgL_auxz00_3360,
										BgL_arg3491z00_1484);
							}}
							{	/* Effect/cgraph.scm 21 */
								int BgL_auxz00_3363;

								BgL_auxz00_3363 = (int) (((long) 0));
								STRUCT_SET(BgL_res3147z00_1481, BgL_auxz00_3363,
									BgL_aux3148z00_1482);
							}
							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_auxz00_3366;

								BgL_auxz00_3366 = STRUCT_KEY(BgL_res3147z00_1481);
								STRUCT_KEY_SET(BgL_aux3148z00_1482, BgL_auxz00_3366);
							}
							{	/* Effect/cgraph.scm 21 */
								obj_t BgL_kz00_2631;

								BgL_kz00_2631 = CNST_TABLE_REF(((long) 2));
								STRUCT_KEY_SET(BgL_res3147z00_1481, BgL_kz00_2631);
							}
							return BgL_res3147z00_1481;
						}
					}
				}
			}
		}
	}



/* save-call!-local/fro3306 */
	obj_t BGl_savezd2callz12zd2localzf2fro3306ze0zzeffect_cgraphz00(obj_t
		BgL_envz00_2783, obj_t BgL_calleez00_2784, obj_t BgL_ownerz00_2785)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 234 */
			{
				BgL_localzf2fromzf2_bglt BgL_calleez00_1467;

				obj_t BgL_ownerz00_1468;

				BgL_calleez00_1467 = (BgL_localzf2fromzf2_bglt) (BgL_calleez00_2784);
				BgL_ownerz00_1468 = BgL_ownerz00_2785;
				{	/* Effect/cgraph.scm 236 */
					bool_t BgL_testz00_3372;

					{	/* Effect/cgraph.scm 236 */
						obj_t BgL_auxz00_3373;

						{	/* Effect/cgraph.scm 236 */
							obj_t BgL_auxz00_3374;

							{
								obj_t BgL_auxz00_3375;

								{	/* Effect/cgraph.scm 236 */
									BgL_objectz00_bglt BgL_auxz00_3376;

									BgL_auxz00_3376 = (BgL_objectz00_bglt) (BgL_calleez00_1467);
									BgL_auxz00_3375 = BGL_OBJECT_WIDENING(BgL_auxz00_3376);
								}
								BgL_auxz00_3374 =
									(((BgL_localzf2fromzf2_bglt) CREF(BgL_auxz00_3375))->
									BgL_fromz00);
							}
							BgL_auxz00_3373 =
								BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_ownerz00_1468,
								BgL_auxz00_3374);
						}
						BgL_testz00_3372 = CBOOL(BgL_auxz00_3373);
					}
					if (BgL_testz00_3372)
						{	/* Effect/cgraph.scm 236 */
							return BFALSE;
						}
					else
						{	/* Effect/cgraph.scm 237 */
							obj_t BgL_arg3485z00_1473;

							{	/* Effect/cgraph.scm 237 */
								obj_t BgL_arg3486z00_1474;

								{
									obj_t BgL_auxz00_3382;

									{	/* Effect/cgraph.scm 237 */
										BgL_objectz00_bglt BgL_auxz00_3383;

										BgL_auxz00_3383 = (BgL_objectz00_bglt) (BgL_calleez00_1467);
										BgL_auxz00_3382 = BGL_OBJECT_WIDENING(BgL_auxz00_3383);
									}
									BgL_arg3486z00_1474 =
										(((BgL_localzf2fromzf2_bglt) CREF(BgL_auxz00_3382))->
										BgL_fromz00);
								}
								BgL_arg3485z00_1473 =
									MAKE_PAIR(BgL_ownerz00_1468, BgL_arg3486z00_1474);
							}
							{
								obj_t BgL_auxz00_3388;

								{	/* Effect/cgraph.scm 237 */
									BgL_objectz00_bglt BgL_auxz00_3389;

									BgL_auxz00_3389 = (BgL_objectz00_bglt) (BgL_calleez00_1467);
									BgL_auxz00_3388 = BGL_OBJECT_WIDENING(BgL_auxz00_3389);
								}
								return
									((((BgL_localzf2fromzf2_bglt) CREF(BgL_auxz00_3388))->
										BgL_fromz00) = ((obj_t) BgL_arg3485z00_1473), BUNSPEC);
							}
						}
				}
			}
		}
	}



/* save-call!-local3304 */
	obj_t BGl_savezd2callz12zd2local3304z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2786, obj_t BgL_calleez00_2787, obj_t BgL_ownerz00_2788)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 228 */
			{
				BgL_localz00_bglt BgL_calleez00_1457;

				obj_t BgL_ownerz00_1458;

				BgL_calleez00_1457 = (BgL_localz00_bglt) (BgL_calleez00_2787);
				BgL_ownerz00_1458 = BgL_ownerz00_2788;
				{	/* Effect/cgraph.scm 229 */
					BgL_localz00_bglt BgL_arg3480z00_1461;

					{	/* Effect/cgraph.scm 229 */
						BgL_localz00_bglt BgL_obj3243z00_1462;

						BgL_obj3243z00_1462 = ((BgL_localz00_bglt) BgL_calleez00_1457);
						{	/* Effect/cgraph.scm 229 */
							BgL_localzf2fromzf2_bglt BgL_arg3481z00_1463;

							{	/* Effect/cgraph.scm 229 */
								BgL_localzf2fromzf2_bglt BgL_res3586z00_2582;

								{	/* Effect/cgraph.scm 229 */
									BgL_localzf2fromzf2_bglt BgL_new3061z00_2577;

									BgL_new3061z00_2577 =
										((BgL_localzf2fromzf2_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_localzf2fromzf2_bgl))));
									{	/* Effect/cgraph.scm 229 */
										BgL_localzf2fromzf2_bglt BgL_res3585z00_2581;

										{	/* Effect/cgraph.scm 229 */
											BgL_localzf2fromzf2_bglt BgL_new3077z00_2578;

											BgL_new3077z00_2578 = BgL_new3061z00_2577;
											{	/* Effect/cgraph.scm 229 */
												obj_t BgL_from3076z00_2580;

												BgL_from3076z00_2580 = BNIL;
												((((BgL_localzf2fromzf2_bglt)
															CREF(BgL_new3077z00_2578))->BgL_fromz00) =
													((obj_t) BgL_from3076z00_2580), BUNSPEC);
												BgL_res3585z00_2581 = BgL_new3077z00_2578;
										}} BgL_res3585z00_2581;
									}
									BgL_res3586z00_2582 = BgL_new3061z00_2577;
								}
								BgL_arg3481z00_1463 = BgL_res3586z00_2582;
							}
							{	/* Effect/cgraph.scm 229 */
								obj_t BgL_auxz00_3399;

								BgL_objectz00_bglt BgL_auxz00_3397;

								BgL_auxz00_3399 = (obj_t) (BgL_arg3481z00_1463);
								BgL_auxz00_3397 = (BgL_objectz00_bglt) (BgL_obj3243z00_1462);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_3397, BgL_auxz00_3399);
						}}
						BGL_OBJECT_CLASS_NUM_SET(
							(BgL_objectz00_bglt) (BgL_obj3243z00_1462),
							BGl_classzd2numzd2zz__objectz00
							(BGl_localzf2fromzf2zzeffect_cgraphz00));
						BgL_arg3480z00_1461 = BgL_obj3243z00_1462;
					}
					{	/* Effect/cgraph.scm 229 */
						BgL_variablez00_bglt BgL_calleez00_2585;

						BgL_variablez00_bglt BgL_ownerz00_2586;

						BgL_calleez00_2585 = (BgL_variablez00_bglt) (BgL_arg3480z00_1461);
						BgL_ownerz00_2586 = (BgL_variablez00_bglt) (BgL_ownerz00_1458);
						{	/* Effect/cgraph.scm 229 */
							obj_t BgL_method3298z00_2587;

							{	/* Effect/cgraph.scm 229 */
								BgL_objectz00_bglt BgL_objz00_2588;

								BgL_objz00_2588 = (BgL_objectz00_bglt) (BgL_calleez00_2585);
								{	/* Effect/cgraph.scm 229 */
									long BgL_objzd2classzd2numz00_2589;

									BgL_objzd2classzd2numz00_2589 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2588);
									{	/* Effect/cgraph.scm 229 */
										obj_t BgL_arg2334z00_2590;

										BgL_arg2334z00_2590 =
											PROCEDURE_REF
											(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 229 */
											obj_t BgL_arrayz00_2592;

											int BgL_offsetz00_2593;

											BgL_arrayz00_2592 = BgL_arg2334z00_2590;
											BgL_offsetz00_2593 =
												(int) (BgL_objzd2classzd2numz00_2589);
											{	/* Effect/cgraph.scm 229 */
												long BgL_offsetz00_2594;

												BgL_offsetz00_2594 =
													((long) (BgL_offsetz00_2593) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 229 */
													long BgL_modz00_2595;

													{	/* Effect/cgraph.scm 229 */
														int BgL_arg2336z00_2596;

														BgL_arg2336z00_2596 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 229 */
															long BgL_auxz00_3415;

															BgL_auxz00_3415 = (long) (BgL_arg2336z00_2596);
															BgL_modz00_2595 =
																(BgL_offsetz00_2594 / BgL_auxz00_3415);
													}}
													{	/* Effect/cgraph.scm 229 */
														long BgL_restz00_2597;

														{	/* Effect/cgraph.scm 229 */
															int BgL_arg2335z00_2598;

															BgL_arg2335z00_2598 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 229 */
																long BgL_auxz00_3419;

																BgL_auxz00_3419 = (long) (BgL_arg2335z00_2598);
																BgL_restz00_2597 =
																	(BgL_offsetz00_2594 % BgL_auxz00_3419);
														}}
														{	/* Effect/cgraph.scm 229 */

															BgL_method3298z00_2587 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2592,
																	(int) (BgL_modz00_2595)),
																(int) (BgL_restz00_2597));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3298z00_2587) (BgL_method3298z00_2587,
								(obj_t) (BgL_calleez00_2585),
								(obj_t) (BgL_ownerz00_2586), BEOA);
						}
					}
				}
			}
		}
	}



/* save-call!-global/fr3302 */
	obj_t BGl_savezd2callz12zd2globalzf2fr3302ze0zzeffect_cgraphz00(obj_t
		BgL_envz00_2789, obj_t BgL_calleez00_2790, obj_t BgL_ownerz00_2791)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 220 */
			{
				BgL_globalzf2fromzf2_bglt BgL_calleez00_1446;

				obj_t BgL_ownerz00_1447;

				BgL_calleez00_1446 = (BgL_globalzf2fromzf2_bglt) (BgL_calleez00_2790);
				BgL_ownerz00_1447 = BgL_ownerz00_2791;
				{	/* Effect/cgraph.scm 222 */
					bool_t BgL_testz00_3431;

					{	/* Effect/cgraph.scm 222 */
						obj_t BgL_auxz00_3432;

						{	/* Effect/cgraph.scm 222 */
							obj_t BgL_auxz00_3433;

							{
								obj_t BgL_auxz00_3434;

								{	/* Effect/cgraph.scm 222 */
									BgL_objectz00_bglt BgL_auxz00_3435;

									BgL_auxz00_3435 = (BgL_objectz00_bglt) (BgL_calleez00_1446);
									BgL_auxz00_3434 = BGL_OBJECT_WIDENING(BgL_auxz00_3435);
								}
								BgL_auxz00_3433 =
									(((BgL_globalzf2fromzf2_bglt) CREF(BgL_auxz00_3434))->
									BgL_fromz00);
							}
							BgL_auxz00_3432 =
								BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_ownerz00_1447,
								BgL_auxz00_3433);
						}
						BgL_testz00_3431 = CBOOL(BgL_auxz00_3432);
					}
					if (BgL_testz00_3431)
						{	/* Effect/cgraph.scm 222 */
							return BFALSE;
						}
					else
						{	/* Effect/cgraph.scm 223 */
							obj_t BgL_arg3476z00_1452;

							{	/* Effect/cgraph.scm 223 */
								obj_t BgL_arg3477z00_1453;

								{
									obj_t BgL_auxz00_3441;

									{	/* Effect/cgraph.scm 223 */
										BgL_objectz00_bglt BgL_auxz00_3442;

										BgL_auxz00_3442 = (BgL_objectz00_bglt) (BgL_calleez00_1446);
										BgL_auxz00_3441 = BGL_OBJECT_WIDENING(BgL_auxz00_3442);
									}
									BgL_arg3477z00_1453 =
										(((BgL_globalzf2fromzf2_bglt) CREF(BgL_auxz00_3441))->
										BgL_fromz00);
								}
								BgL_arg3476z00_1452 =
									MAKE_PAIR(BgL_ownerz00_1447, BgL_arg3477z00_1453);
							}
							{
								obj_t BgL_auxz00_3447;

								{	/* Effect/cgraph.scm 223 */
									BgL_objectz00_bglt BgL_auxz00_3448;

									BgL_auxz00_3448 = (BgL_objectz00_bglt) (BgL_calleez00_1446);
									BgL_auxz00_3447 = BGL_OBJECT_WIDENING(BgL_auxz00_3448);
								}
								return
									((((BgL_globalzf2fromzf2_bglt) CREF(BgL_auxz00_3447))->
										BgL_fromz00) = ((obj_t) BgL_arg3476z00_1452), BUNSPEC);
							}
						}
				}
			}
		}
	}



/* save-call!-global3300 */
	obj_t BGl_savezd2callz12zd2global3300z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2792, obj_t BgL_calleez00_2793, obj_t BgL_ownerz00_2794)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 208 */
			{
				BgL_globalz00_bglt BgL_calleez00_1429;

				obj_t BgL_ownerz00_1430;

				BgL_calleez00_1429 = (BgL_globalz00_bglt) (BgL_calleez00_2793);
				BgL_ownerz00_1430 = BgL_ownerz00_2794;
				{	/* Effect/cgraph.scm 209 */
					BgL_valuez00_bglt BgL_funz00_1433;

					{
						BgL_variablez00_bglt BgL_auxz00_3453;

						BgL_auxz00_3453 = (BgL_variablez00_bglt) (BgL_calleez00_1429);
						BgL_funz00_1433 =
							(((BgL_variablez00_bglt) CREF(BgL_auxz00_3453))->BgL_valuez00);
					}
					{	/* Effect/cgraph.scm 210 */
						bool_t BgL_testz00_3456;

						{	/* Effect/cgraph.scm 210 */
							bool_t BgL_testz00_3457;

							{	/* Effect/cgraph.scm 210 */
								obj_t BgL_obj1836z00_2532;

								BgL_obj1836z00_2532 = (obj_t) (BgL_funz00_1433);
								BgL_testz00_3457 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1836z00_2532,
									BGl_cfunz00zzast_varz00);
							}
							if (BgL_testz00_3457)
								{	/* Effect/cgraph.scm 210 */
									BgL_testz00_3456 = ((bool_t) 1);
								}
							else
								{	/* Effect/cgraph.scm 211 */
									bool_t BgL_testz00_3460;

									{	/* Effect/cgraph.scm 211 */
										obj_t BgL_obj1772z00_2533;

										BgL_obj1772z00_2533 = (obj_t) (BgL_funz00_1433);
										BgL_testz00_3460 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj1772z00_2533,
											BGl_sfunz00zzast_varz00);
									}
									if (BgL_testz00_3460)
										{	/* Effect/cgraph.scm 211 */
											BgL_testz00_3456 =
												(
												(((BgL_globalz00_bglt) CREF(BgL_calleez00_1429))->
													BgL_importz00) == CNST_TABLE_REF(((long) 6)));
										}
									else
										{	/* Effect/cgraph.scm 211 */
											BgL_testz00_3456 = ((bool_t) 0);
										}
								}
						}
						if (BgL_testz00_3456)
							{	/* Effect/cgraph.scm 213 */
								bool_t BgL_testz00_3466;

								{	/* Effect/cgraph.scm 213 */
									BgL_funz00_bglt BgL_obj1631z00_2535;

									BgL_obj1631z00_2535 = (BgL_funz00_bglt) (BgL_funz00_1433);
									BgL_testz00_3466 =
										CBOOL(
										(((BgL_funz00_bglt) CREF(BgL_obj1631z00_2535))->
											BgL_sidezd2effectzf3z21));
								}
								if (BgL_testz00_3466)
									{	/* Effect/cgraph.scm 213 */
										return
											BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
											(BgL_variablez00_bglt) (BgL_ownerz00_1430));
									}
								else
									{	/* Effect/cgraph.scm 213 */
										return BFALSE;
									}
							}
						else
							{	/* Effect/cgraph.scm 215 */
								BgL_globalz00_bglt BgL_arg3468z00_1436;

								{	/* Effect/cgraph.scm 215 */
									BgL_globalz00_bglt BgL_obj3239z00_1437;

									BgL_obj3239z00_1437 =
										((BgL_globalz00_bglt) BgL_calleez00_1429);
									{	/* Effect/cgraph.scm 215 */
										BgL_globalzf2fromzf2_bglt BgL_arg3469z00_1438;

										{	/* Effect/cgraph.scm 215 */
											BgL_globalzf2fromzf2_bglt BgL_res3582z00_2542;

											{	/* Effect/cgraph.scm 215 */
												BgL_globalzf2fromzf2_bglt BgL_new3120z00_2537;

												BgL_new3120z00_2537 =
													((BgL_globalzf2fromzf2_bglt)
													BREF(GC_MALLOC(sizeof(struct
																BgL_globalzf2fromzf2_bgl))));
												{	/* Effect/cgraph.scm 215 */
													BgL_globalzf2fromzf2_bglt BgL_res3581z00_2541;

													{	/* Effect/cgraph.scm 215 */
														BgL_globalzf2fromzf2_bglt BgL_new3142z00_2538;

														BgL_new3142z00_2538 = BgL_new3120z00_2537;
														{	/* Effect/cgraph.scm 215 */
															obj_t BgL_from3141z00_2540;

															BgL_from3141z00_2540 = BNIL;
															((((BgL_globalzf2fromzf2_bglt)
																		CREF(BgL_new3142z00_2538))->BgL_fromz00) =
																((obj_t) BgL_from3141z00_2540), BUNSPEC);
															BgL_res3581z00_2541 = BgL_new3142z00_2538;
													}} BgL_res3581z00_2541;
												}
												BgL_res3582z00_2542 = BgL_new3120z00_2537;
											}
											BgL_arg3469z00_1438 = BgL_res3582z00_2542;
										}
										{	/* Effect/cgraph.scm 215 */
											obj_t BgL_auxz00_3477;

											BgL_objectz00_bglt BgL_auxz00_3475;

											BgL_auxz00_3477 = (obj_t) (BgL_arg3469z00_1438);
											BgL_auxz00_3475 =
												(BgL_objectz00_bglt) (BgL_obj3239z00_1437);
											BGL_OBJECT_WIDENING_SET(BgL_auxz00_3475, BgL_auxz00_3477);
									}}
									BGL_OBJECT_CLASS_NUM_SET(
										(BgL_objectz00_bglt) (BgL_obj3239z00_1437),
										BGl_classzd2numzd2zz__objectz00
										(BGl_globalzf2fromzf2zzeffect_cgraphz00));
									BgL_arg3468z00_1436 = BgL_obj3239z00_1437;
								}
								{	/* Effect/cgraph.scm 215 */
									BgL_variablez00_bglt BgL_calleez00_2545;

									BgL_variablez00_bglt BgL_ownerz00_2546;

									BgL_calleez00_2545 =
										(BgL_variablez00_bglt) (BgL_arg3468z00_1436);
									BgL_ownerz00_2546 =
										(BgL_variablez00_bglt) (BgL_ownerz00_1430);
									{	/* Effect/cgraph.scm 215 */
										obj_t BgL_method3298z00_2547;

										{	/* Effect/cgraph.scm 215 */
											BgL_objectz00_bglt BgL_objz00_2548;

											BgL_objz00_2548 =
												(BgL_objectz00_bglt) (BgL_calleez00_2545);
											{	/* Effect/cgraph.scm 215 */
												long BgL_objzd2classzd2numz00_2549;

												BgL_objzd2classzd2numz00_2549 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2548);
												{	/* Effect/cgraph.scm 215 */
													obj_t BgL_arg2334z00_2550;

													BgL_arg2334z00_2550 =
														PROCEDURE_REF
														(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
														(int) (((long) 1)));
													{	/* Effect/cgraph.scm 215 */
														obj_t BgL_arrayz00_2552;

														int BgL_offsetz00_2553;

														BgL_arrayz00_2552 = BgL_arg2334z00_2550;
														BgL_offsetz00_2553 =
															(int) (BgL_objzd2classzd2numz00_2549);
														{	/* Effect/cgraph.scm 215 */
															long BgL_offsetz00_2554;

															BgL_offsetz00_2554 =
																((long) (BgL_offsetz00_2553) - OBJECT_TYPE);
															{	/* Effect/cgraph.scm 215 */
																long BgL_modz00_2555;

																{	/* Effect/cgraph.scm 215 */
																	int BgL_arg2336z00_2556;

																	BgL_arg2336z00_2556 = (int) (((long) 8));
																	{	/* Effect/cgraph.scm 215 */
																		long BgL_auxz00_3493;

																		BgL_auxz00_3493 =
																			(long) (BgL_arg2336z00_2556);
																		BgL_modz00_2555 =
																			(BgL_offsetz00_2554 / BgL_auxz00_3493);
																}}
																{	/* Effect/cgraph.scm 215 */
																	long BgL_restz00_2557;

																	{	/* Effect/cgraph.scm 215 */
																		int BgL_arg2335z00_2558;

																		BgL_arg2335z00_2558 = (int) (((long) 8));
																		{	/* Effect/cgraph.scm 215 */
																			long BgL_auxz00_3497;

																			BgL_auxz00_3497 =
																				(long) (BgL_arg2335z00_2558);
																			BgL_restz00_2557 =
																				(BgL_offsetz00_2554 % BgL_auxz00_3497);
																	}}
																	{	/* Effect/cgraph.scm 215 */

																		BgL_method3298z00_2547 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2552,
																				(int) (BgL_modz00_2555)),
																			(int) (BgL_restz00_2557));
										}}}}}}}}
										return
											PROCEDURE_ENTRY(BgL_method3298z00_2547)
											(BgL_method3298z00_2547, (obj_t) (BgL_calleez00_2545),
											(obj_t) (BgL_ownerz00_2546), BEOA);
									}
								}
							}
					}
				}
			}
		}
	}



/* call-graph!-box-set!3296 */
	obj_t BGl_callzd2graphz12zd2boxzd2setz123296zd2zzeffect_cgraphz00(obj_t
		BgL_envz00_2795, obj_t BgL_nodez00_2796, obj_t BgL_ownerz00_2797)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 187 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1416;

				obj_t BgL_ownerz00_1417;

				BgL_nodez00_1416 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2796);
				BgL_ownerz00_1417 = BgL_ownerz00_2797;
				{	/* Effect/cgraph.scm 189 */
					bool_t BgL_testz00_3509;

					if (BGl_iszd2azf3z21zz__objectz00(BgL_ownerz00_1417,
							BGl_localz00zzast_varz00))
						{	/* Effect/cgraph.scm 189 */
							BgL_testz00_3509 = ((bool_t) 1);
						}
					else
						{	/* Effect/cgraph.scm 189 */
							BgL_variablez00_bglt BgL_arg3461z00_1423;

							{	/* Effect/cgraph.scm 189 */
								BgL_varz00_bglt BgL_obj1972z00_2473;

								BgL_obj1972z00_2473 =
									(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1416))->
									BgL_varz00);
								BgL_arg3461z00_1423 =
									(((BgL_varz00_bglt) CREF(BgL_obj1972z00_2473))->
									BgL_variablez00);
							}
							{	/* Effect/cgraph.scm 189 */
								obj_t BgL_obj1568z00_2474;

								BgL_obj1568z00_2474 = (obj_t) (BgL_arg3461z00_1423);
								BgL_testz00_3509 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1568z00_2474,
									BGl_globalz00zzast_varz00);
							}
						}
					if (BgL_testz00_3509)
						{	/* Effect/cgraph.scm 189 */
							BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
								(BgL_variablez00_bglt) (BgL_ownerz00_1417));
						}
					else
						{	/* Effect/cgraph.scm 189 */
							BFALSE;
						}
				}
				{	/* Effect/cgraph.scm 191 */
					BgL_varz00_bglt BgL_arg3463z00_1425;

					BgL_arg3463z00_1425 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1416))->BgL_varz00);
					{	/* Effect/cgraph.scm 191 */
						BgL_nodez00_bglt BgL_nodez00_2476;

						BgL_variablez00_bglt BgL_ownerz00_2477;

						BgL_nodez00_2476 = (BgL_nodez00_bglt) (BgL_arg3463z00_1425);
						BgL_ownerz00_2477 = (BgL_variablez00_bglt) (BgL_ownerz00_1417);
						{	/* Effect/cgraph.scm 191 */
							obj_t BgL_method3262z00_2478;

							{	/* Effect/cgraph.scm 191 */
								BgL_objectz00_bglt BgL_objz00_2479;

								BgL_objz00_2479 = (BgL_objectz00_bglt) (BgL_nodez00_2476);
								{	/* Effect/cgraph.scm 191 */
									long BgL_objzd2classzd2numz00_2480;

									BgL_objzd2classzd2numz00_2480 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2479);
									{	/* Effect/cgraph.scm 191 */
										obj_t BgL_arg2334z00_2481;

										BgL_arg2334z00_2481 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 191 */
											obj_t BgL_arrayz00_2483;

											int BgL_offsetz00_2484;

											BgL_arrayz00_2483 = BgL_arg2334z00_2481;
											BgL_offsetz00_2484 =
												(int) (BgL_objzd2classzd2numz00_2480);
											{	/* Effect/cgraph.scm 191 */
												long BgL_offsetz00_2485;

												BgL_offsetz00_2485 =
													((long) (BgL_offsetz00_2484) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 191 */
													long BgL_modz00_2486;

													{	/* Effect/cgraph.scm 191 */
														int BgL_arg2336z00_2487;

														BgL_arg2336z00_2487 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 191 */
															long BgL_auxz00_3529;

															BgL_auxz00_3529 = (long) (BgL_arg2336z00_2487);
															BgL_modz00_2486 =
																(BgL_offsetz00_2485 / BgL_auxz00_3529);
													}}
													{	/* Effect/cgraph.scm 191 */
														long BgL_restz00_2488;

														{	/* Effect/cgraph.scm 191 */
															int BgL_arg2335z00_2489;

															BgL_arg2335z00_2489 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 191 */
																long BgL_auxz00_3533;

																BgL_auxz00_3533 = (long) (BgL_arg2335z00_2489);
																BgL_restz00_2488 =
																	(BgL_offsetz00_2485 % BgL_auxz00_3533);
														}}
														{	/* Effect/cgraph.scm 191 */

															BgL_method3262z00_2478 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2483,
																	(int) (BgL_modz00_2486)),
																(int) (BgL_restz00_2488));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3262z00_2478) (BgL_method3262z00_2478,
								(obj_t) (BgL_nodez00_2476), (obj_t) (BgL_ownerz00_2477), BEOA);
				}}}
				{	/* Effect/cgraph.scm 192 */
					BgL_nodez00_bglt BgL_arg3464z00_1426;

					BgL_arg3464z00_1426 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1416))->BgL_valuez00);
					{	/* Effect/cgraph.scm 192 */
						BgL_variablez00_bglt BgL_ownerz00_2505;

						BgL_ownerz00_2505 = (BgL_variablez00_bglt) (BgL_ownerz00_1417);
						{	/* Effect/cgraph.scm 192 */
							obj_t BgL_method3262z00_2506;

							{	/* Effect/cgraph.scm 192 */
								BgL_objectz00_bglt BgL_objz00_2507;

								BgL_objz00_2507 = (BgL_objectz00_bglt) (BgL_arg3464z00_1426);
								{	/* Effect/cgraph.scm 192 */
									long BgL_objzd2classzd2numz00_2508;

									BgL_objzd2classzd2numz00_2508 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2507);
									{	/* Effect/cgraph.scm 192 */
										obj_t BgL_arg2334z00_2509;

										BgL_arg2334z00_2509 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 192 */
											obj_t BgL_arrayz00_2511;

											int BgL_offsetz00_2512;

											BgL_arrayz00_2511 = BgL_arg2334z00_2509;
											BgL_offsetz00_2512 =
												(int) (BgL_objzd2classzd2numz00_2508);
											{	/* Effect/cgraph.scm 192 */
												long BgL_offsetz00_2513;

												BgL_offsetz00_2513 =
													((long) (BgL_offsetz00_2512) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 192 */
													long BgL_modz00_2514;

													{	/* Effect/cgraph.scm 192 */
														int BgL_arg2336z00_2515;

														BgL_arg2336z00_2515 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 192 */
															long BgL_auxz00_3554;

															BgL_auxz00_3554 = (long) (BgL_arg2336z00_2515);
															BgL_modz00_2514 =
																(BgL_offsetz00_2513 / BgL_auxz00_3554);
													}}
													{	/* Effect/cgraph.scm 192 */
														long BgL_restz00_2516;

														{	/* Effect/cgraph.scm 192 */
															int BgL_arg2335z00_2517;

															BgL_arg2335z00_2517 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 192 */
																long BgL_auxz00_3558;

																BgL_auxz00_3558 = (long) (BgL_arg2335z00_2517);
																BgL_restz00_2516 =
																	(BgL_offsetz00_2513 % BgL_auxz00_3558);
														}}
														{	/* Effect/cgraph.scm 192 */

															BgL_method3262z00_2506 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2511,
																	(int) (BgL_modz00_2514)),
																(int) (BgL_restz00_2516));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_2506) (BgL_method3262z00_2506,
								(obj_t) (BgL_arg3464z00_1426),
								(obj_t) (BgL_ownerz00_2505), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-box-ref3294 */
	obj_t BGl_callzd2graphz12zd2boxzd2ref3294zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2798, obj_t BgL_nodez00_2799, obj_t BgL_ownerz00_2800)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 179 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1409;

				obj_t BgL_ownerz00_1410;

				BgL_nodez00_1409 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2799);
				BgL_ownerz00_1410 = BgL_ownerz00_2800;
				{	/* Effect/cgraph.scm 180 */
					BgL_varz00_bglt BgL_arg3457z00_2442;

					BgL_arg3457z00_2442 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1409))->BgL_varz00);
					{	/* Effect/cgraph.scm 180 */
						BgL_nodez00_bglt BgL_nodez00_2444;

						BgL_variablez00_bglt BgL_ownerz00_2445;

						BgL_nodez00_2444 = (BgL_nodez00_bglt) (BgL_arg3457z00_2442);
						BgL_ownerz00_2445 = (BgL_variablez00_bglt) (BgL_ownerz00_1410);
						{	/* Effect/cgraph.scm 180 */
							obj_t BgL_method3262z00_2446;

							{	/* Effect/cgraph.scm 180 */
								BgL_objectz00_bglt BgL_objz00_2447;

								BgL_objz00_2447 = (BgL_objectz00_bglt) (BgL_nodez00_2444);
								{	/* Effect/cgraph.scm 180 */
									long BgL_objzd2classzd2numz00_2448;

									BgL_objzd2classzd2numz00_2448 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2447);
									{	/* Effect/cgraph.scm 180 */
										obj_t BgL_arg2334z00_2449;

										BgL_arg2334z00_2449 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 180 */
											obj_t BgL_arrayz00_2451;

											int BgL_offsetz00_2452;

											BgL_arrayz00_2451 = BgL_arg2334z00_2449;
											BgL_offsetz00_2452 =
												(int) (BgL_objzd2classzd2numz00_2448);
											{	/* Effect/cgraph.scm 180 */
												long BgL_offsetz00_2453;

												BgL_offsetz00_2453 =
													((long) (BgL_offsetz00_2452) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 180 */
													long BgL_modz00_2454;

													{	/* Effect/cgraph.scm 180 */
														int BgL_arg2336z00_2455;

														BgL_arg2336z00_2455 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 180 */
															long BgL_auxz00_3581;

															BgL_auxz00_3581 = (long) (BgL_arg2336z00_2455);
															BgL_modz00_2454 =
																(BgL_offsetz00_2453 / BgL_auxz00_3581);
													}}
													{	/* Effect/cgraph.scm 180 */
														long BgL_restz00_2456;

														{	/* Effect/cgraph.scm 180 */
															int BgL_arg2335z00_2457;

															BgL_arg2335z00_2457 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 180 */
																long BgL_auxz00_3585;

																BgL_auxz00_3585 = (long) (BgL_arg2335z00_2457);
																BgL_restz00_2456 =
																	(BgL_offsetz00_2453 % BgL_auxz00_3585);
														}}
														{	/* Effect/cgraph.scm 180 */

															BgL_method3262z00_2446 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2451,
																	(int) (BgL_modz00_2454)),
																(int) (BgL_restz00_2456));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_2446) (BgL_method3262z00_2446,
								(obj_t) (BgL_nodez00_2444), (obj_t) (BgL_ownerz00_2445), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-make-box3292 */
	obj_t BGl_callzd2graphz12zd2makezd2box3292zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2801, obj_t BgL_nodez00_2802, obj_t BgL_ownerz00_2803)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 173 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1402;

				obj_t BgL_ownerz00_1403;

				BgL_nodez00_1402 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2802);
				BgL_ownerz00_1403 = BgL_ownerz00_2803;
				{	/* Effect/cgraph.scm 174 */
					BgL_nodez00_bglt BgL_arg3455z00_2413;

					BgL_arg3455z00_2413 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1402))->BgL_valuez00);
					{	/* Effect/cgraph.scm 174 */
						BgL_variablez00_bglt BgL_ownerz00_2416;

						BgL_ownerz00_2416 = (BgL_variablez00_bglt) (BgL_ownerz00_1403);
						{	/* Effect/cgraph.scm 174 */
							obj_t BgL_method3262z00_2417;

							{	/* Effect/cgraph.scm 174 */
								BgL_objectz00_bglt BgL_objz00_2418;

								BgL_objz00_2418 = (BgL_objectz00_bglt) (BgL_arg3455z00_2413);
								{	/* Effect/cgraph.scm 174 */
									long BgL_objzd2classzd2numz00_2419;

									BgL_objzd2classzd2numz00_2419 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2418);
									{	/* Effect/cgraph.scm 174 */
										obj_t BgL_arg2334z00_2420;

										BgL_arg2334z00_2420 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 174 */
											obj_t BgL_arrayz00_2422;

											int BgL_offsetz00_2423;

											BgL_arrayz00_2422 = BgL_arg2334z00_2420;
											BgL_offsetz00_2423 =
												(int) (BgL_objzd2classzd2numz00_2419);
											{	/* Effect/cgraph.scm 174 */
												long BgL_offsetz00_2424;

												BgL_offsetz00_2424 =
													((long) (BgL_offsetz00_2423) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 174 */
													long BgL_modz00_2425;

													{	/* Effect/cgraph.scm 174 */
														int BgL_arg2336z00_2426;

														BgL_arg2336z00_2426 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 174 */
															long BgL_auxz00_3607;

															BgL_auxz00_3607 = (long) (BgL_arg2336z00_2426);
															BgL_modz00_2425 =
																(BgL_offsetz00_2424 / BgL_auxz00_3607);
													}}
													{	/* Effect/cgraph.scm 174 */
														long BgL_restz00_2427;

														{	/* Effect/cgraph.scm 174 */
															int BgL_arg2335z00_2428;

															BgL_arg2335z00_2428 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 174 */
																long BgL_auxz00_3611;

																BgL_auxz00_3611 = (long) (BgL_arg2335z00_2428);
																BgL_restz00_2427 =
																	(BgL_offsetz00_2424 % BgL_auxz00_3611);
														}}
														{	/* Effect/cgraph.scm 174 */

															BgL_method3262z00_2417 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2422,
																	(int) (BgL_modz00_2425)),
																(int) (BgL_restz00_2427));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_2417) (BgL_method3262z00_2417,
								(obj_t) (BgL_arg3455z00_2413),
								(obj_t) (BgL_ownerz00_2416), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-jump-ex-3290 */
	obj_t BGl_callzd2graphz12zd2jumpzd2exzd23290z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2804, obj_t BgL_nodez00_2805, obj_t BgL_ownerz00_2806)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 164 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1393;

				obj_t BgL_ownerz00_1394;

				BgL_nodez00_1393 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2805);
				BgL_ownerz00_1394 = BgL_ownerz00_2806;
				BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
					(BgL_variablez00_bglt) (BgL_ownerz00_1394));
				{	/* Effect/cgraph.scm 167 */
					BgL_nodez00_bglt BgL_arg3452z00_1398;

					BgL_arg3452z00_1398 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1393))->
						BgL_exitz00);
					{	/* Effect/cgraph.scm 167 */
						BgL_variablez00_bglt BgL_ownerz00_2359;

						BgL_ownerz00_2359 = (BgL_variablez00_bglt) (BgL_ownerz00_1394);
						{	/* Effect/cgraph.scm 167 */
							obj_t BgL_method3262z00_2360;

							{	/* Effect/cgraph.scm 167 */
								BgL_objectz00_bglt BgL_objz00_2361;

								BgL_objz00_2361 = (BgL_objectz00_bglt) (BgL_arg3452z00_1398);
								{	/* Effect/cgraph.scm 167 */
									long BgL_objzd2classzd2numz00_2362;

									BgL_objzd2classzd2numz00_2362 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2361);
									{	/* Effect/cgraph.scm 167 */
										obj_t BgL_arg2334z00_2363;

										BgL_arg2334z00_2363 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 167 */
											obj_t BgL_arrayz00_2365;

											int BgL_offsetz00_2366;

											BgL_arrayz00_2365 = BgL_arg2334z00_2363;
											BgL_offsetz00_2366 =
												(int) (BgL_objzd2classzd2numz00_2362);
											{	/* Effect/cgraph.scm 167 */
												long BgL_offsetz00_2367;

												BgL_offsetz00_2367 =
													((long) (BgL_offsetz00_2366) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 167 */
													long BgL_modz00_2368;

													{	/* Effect/cgraph.scm 167 */
														int BgL_arg2336z00_2369;

														BgL_arg2336z00_2369 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 167 */
															long BgL_auxz00_3635;

															BgL_auxz00_3635 = (long) (BgL_arg2336z00_2369);
															BgL_modz00_2368 =
																(BgL_offsetz00_2367 / BgL_auxz00_3635);
													}}
													{	/* Effect/cgraph.scm 167 */
														long BgL_restz00_2370;

														{	/* Effect/cgraph.scm 167 */
															int BgL_arg2335z00_2371;

															BgL_arg2335z00_2371 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 167 */
																long BgL_auxz00_3639;

																BgL_auxz00_3639 = (long) (BgL_arg2335z00_2371);
																BgL_restz00_2370 =
																	(BgL_offsetz00_2367 % BgL_auxz00_3639);
														}}
														{	/* Effect/cgraph.scm 167 */

															BgL_method3262z00_2360 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2365,
																	(int) (BgL_modz00_2368)),
																(int) (BgL_restz00_2370));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3262z00_2360) (BgL_method3262z00_2360,
								(obj_t) (BgL_arg3452z00_1398),
								(obj_t) (BgL_ownerz00_2359), BEOA);
				}}}
				{	/* Effect/cgraph.scm 168 */
					BgL_nodez00_bglt BgL_arg3453z00_1399;

					BgL_arg3453z00_1399 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1393))->
						BgL_valuez00);
					{	/* Effect/cgraph.scm 168 */
						BgL_variablez00_bglt BgL_ownerz00_2387;

						BgL_ownerz00_2387 = (BgL_variablez00_bglt) (BgL_ownerz00_1394);
						{	/* Effect/cgraph.scm 168 */
							obj_t BgL_method3262z00_2388;

							{	/* Effect/cgraph.scm 168 */
								BgL_objectz00_bglt BgL_objz00_2389;

								BgL_objz00_2389 = (BgL_objectz00_bglt) (BgL_arg3453z00_1399);
								{	/* Effect/cgraph.scm 168 */
									long BgL_objzd2classzd2numz00_2390;

									BgL_objzd2classzd2numz00_2390 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2389);
									{	/* Effect/cgraph.scm 168 */
										obj_t BgL_arg2334z00_2391;

										BgL_arg2334z00_2391 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 168 */
											obj_t BgL_arrayz00_2393;

											int BgL_offsetz00_2394;

											BgL_arrayz00_2393 = BgL_arg2334z00_2391;
											BgL_offsetz00_2394 =
												(int) (BgL_objzd2classzd2numz00_2390);
											{	/* Effect/cgraph.scm 168 */
												long BgL_offsetz00_2395;

												BgL_offsetz00_2395 =
													((long) (BgL_offsetz00_2394) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 168 */
													long BgL_modz00_2396;

													{	/* Effect/cgraph.scm 168 */
														int BgL_arg2336z00_2397;

														BgL_arg2336z00_2397 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 168 */
															long BgL_auxz00_3660;

															BgL_auxz00_3660 = (long) (BgL_arg2336z00_2397);
															BgL_modz00_2396 =
																(BgL_offsetz00_2395 / BgL_auxz00_3660);
													}}
													{	/* Effect/cgraph.scm 168 */
														long BgL_restz00_2398;

														{	/* Effect/cgraph.scm 168 */
															int BgL_arg2335z00_2399;

															BgL_arg2335z00_2399 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 168 */
																long BgL_auxz00_3664;

																BgL_auxz00_3664 = (long) (BgL_arg2335z00_2399);
																BgL_restz00_2398 =
																	(BgL_offsetz00_2395 % BgL_auxz00_3664);
														}}
														{	/* Effect/cgraph.scm 168 */

															BgL_method3262z00_2388 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2393,
																	(int) (BgL_modz00_2396)),
																(int) (BgL_restz00_2398));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_2388) (BgL_method3262z00_2388,
								(obj_t) (BgL_arg3453z00_1399),
								(obj_t) (BgL_ownerz00_2387), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-set-ex-i3288 */
	obj_t BGl_callzd2graphz12zd2setzd2exzd2i3288z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2807, obj_t BgL_nodez00_2808, obj_t BgL_ownerz00_2809)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 156 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1385;

				obj_t BgL_ownerz00_1386;

				BgL_nodez00_1385 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2808);
				BgL_ownerz00_1386 = BgL_ownerz00_2809;
				BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
					(BgL_variablez00_bglt) (BgL_ownerz00_1386));
				{	/* Effect/cgraph.scm 159 */
					BgL_nodez00_bglt BgL_arg3450z00_2328;

					BgL_arg3450z00_2328 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1385))->BgL_bodyz00);
					{	/* Effect/cgraph.scm 159 */
						BgL_variablez00_bglt BgL_ownerz00_2331;

						BgL_ownerz00_2331 = (BgL_variablez00_bglt) (BgL_ownerz00_1386);
						{	/* Effect/cgraph.scm 159 */
							obj_t BgL_method3262z00_2332;

							{	/* Effect/cgraph.scm 159 */
								BgL_objectz00_bglt BgL_objz00_2333;

								BgL_objz00_2333 = (BgL_objectz00_bglt) (BgL_arg3450z00_2328);
								{	/* Effect/cgraph.scm 159 */
									long BgL_objzd2classzd2numz00_2334;

									BgL_objzd2classzd2numz00_2334 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2333);
									{	/* Effect/cgraph.scm 159 */
										obj_t BgL_arg2334z00_2335;

										BgL_arg2334z00_2335 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 159 */
											obj_t BgL_arrayz00_2337;

											int BgL_offsetz00_2338;

											BgL_arrayz00_2337 = BgL_arg2334z00_2335;
											BgL_offsetz00_2338 =
												(int) (BgL_objzd2classzd2numz00_2334);
											{	/* Effect/cgraph.scm 159 */
												long BgL_offsetz00_2339;

												BgL_offsetz00_2339 =
													((long) (BgL_offsetz00_2338) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 159 */
													long BgL_modz00_2340;

													{	/* Effect/cgraph.scm 159 */
														int BgL_arg2336z00_2341;

														BgL_arg2336z00_2341 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 159 */
															long BgL_auxz00_3688;

															BgL_auxz00_3688 = (long) (BgL_arg2336z00_2341);
															BgL_modz00_2340 =
																(BgL_offsetz00_2339 / BgL_auxz00_3688);
													}}
													{	/* Effect/cgraph.scm 159 */
														long BgL_restz00_2342;

														{	/* Effect/cgraph.scm 159 */
															int BgL_arg2335z00_2343;

															BgL_arg2335z00_2343 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 159 */
																long BgL_auxz00_3692;

																BgL_auxz00_3692 = (long) (BgL_arg2335z00_2343);
																BgL_restz00_2342 =
																	(BgL_offsetz00_2339 % BgL_auxz00_3692);
														}}
														{	/* Effect/cgraph.scm 159 */

															BgL_method3262z00_2332 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2337,
																	(int) (BgL_modz00_2340)),
																(int) (BgL_restz00_2342));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_2332) (BgL_method3262z00_2332,
								(obj_t) (BgL_arg3450z00_2328),
								(obj_t) (BgL_ownerz00_2331), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-let-var3286 */
	obj_t BGl_callzd2graphz12zd2letzd2var3286zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2810, obj_t BgL_nodez00_2811, obj_t BgL_ownerz00_2812)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 146 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1370;

				obj_t BgL_ownerz00_1371;

				{	/* Effect/cgraph.scm 147 */
					bool_t BgL_auxz00_3704;

					BgL_nodez00_1370 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2811);
					BgL_ownerz00_1371 = BgL_ownerz00_2812;
					{	/* Effect/cgraph.scm 148 */
						BgL_nodez00_bglt BgL_arg3445z00_1375;

						BgL_arg3445z00_1375 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1370))->BgL_bodyz00);
						{	/* Effect/cgraph.scm 148 */
							BgL_variablez00_bglt BgL_ownerz00_2270;

							BgL_ownerz00_2270 = (BgL_variablez00_bglt) (BgL_ownerz00_1371);
							{	/* Effect/cgraph.scm 148 */
								obj_t BgL_method3262z00_2271;

								{	/* Effect/cgraph.scm 148 */
									BgL_objectz00_bglt BgL_objz00_2272;

									BgL_objz00_2272 = (BgL_objectz00_bglt) (BgL_arg3445z00_1375);
									{	/* Effect/cgraph.scm 148 */
										long BgL_objzd2classzd2numz00_2273;

										BgL_objzd2classzd2numz00_2273 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2272);
										{	/* Effect/cgraph.scm 148 */
											obj_t BgL_arg2334z00_2274;

											BgL_arg2334z00_2274 =
												PROCEDURE_REF
												(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
												(int) (((long) 1)));
											{	/* Effect/cgraph.scm 148 */
												obj_t BgL_arrayz00_2276;

												int BgL_offsetz00_2277;

												BgL_arrayz00_2276 = BgL_arg2334z00_2274;
												BgL_offsetz00_2277 =
													(int) (BgL_objzd2classzd2numz00_2273);
												{	/* Effect/cgraph.scm 148 */
													long BgL_offsetz00_2278;

													BgL_offsetz00_2278 =
														((long) (BgL_offsetz00_2277) - OBJECT_TYPE);
													{	/* Effect/cgraph.scm 148 */
														long BgL_modz00_2279;

														{	/* Effect/cgraph.scm 148 */
															int BgL_arg2336z00_2280;

															BgL_arg2336z00_2280 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 148 */
																long BgL_auxz00_3715;

																BgL_auxz00_3715 = (long) (BgL_arg2336z00_2280);
																BgL_modz00_2279 =
																	(BgL_offsetz00_2278 / BgL_auxz00_3715);
														}}
														{	/* Effect/cgraph.scm 148 */
															long BgL_restz00_2281;

															{	/* Effect/cgraph.scm 148 */
																int BgL_arg2335z00_2282;

																BgL_arg2335z00_2282 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 148 */
																	long BgL_auxz00_3719;

																	BgL_auxz00_3719 =
																		(long) (BgL_arg2335z00_2282);
																	BgL_restz00_2281 =
																		(BgL_offsetz00_2278 % BgL_auxz00_3719);
															}}
															{	/* Effect/cgraph.scm 148 */

																BgL_method3262z00_2271 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2276,
																		(int) (BgL_modz00_2279)),
																	(int) (BgL_restz00_2281));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3262z00_2271) (BgL_method3262z00_2271,
									(obj_t) (BgL_arg3445z00_1375),
									(obj_t) (BgL_ownerz00_2270), BEOA);
					}}}
					{	/* Effect/cgraph.scm 149 */
						obj_t BgL_g3256z00_1376;

						BgL_g3256z00_1376 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1370))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3254z00_1377;

							BgL_l3254z00_1377 = BgL_g3256z00_1376;
						BgL_forzd2each3255zd2_1378:
							if (PAIRP(BgL_l3254z00_1377))
								{	/* Effect/cgraph.scm 149 */
									{	/* Effect/cgraph.scm 150 */
										obj_t BgL_bindingz00_1380;

										BgL_bindingz00_1380 = CAR(BgL_l3254z00_1377);
										{	/* Effect/cgraph.scm 150 */
											obj_t BgL_arg3447z00_1381;

											BgL_arg3447z00_1381 = CDR(BgL_bindingz00_1380);
											{	/* Effect/cgraph.scm 150 */
												BgL_nodez00_bglt BgL_nodez00_2300;

												BgL_variablez00_bglt BgL_ownerz00_2301;

												BgL_nodez00_2300 =
													(BgL_nodez00_bglt) (BgL_arg3447z00_1381);
												BgL_ownerz00_2301 =
													(BgL_variablez00_bglt) (BgL_ownerz00_1371);
												{	/* Effect/cgraph.scm 150 */
													obj_t BgL_method3262z00_2302;

													{	/* Effect/cgraph.scm 150 */
														BgL_objectz00_bglt BgL_objz00_2303;

														BgL_objz00_2303 =
															(BgL_objectz00_bglt) (BgL_nodez00_2300);
														{	/* Effect/cgraph.scm 150 */
															long BgL_objzd2classzd2numz00_2304;

															BgL_objzd2classzd2numz00_2304 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2303);
															{	/* Effect/cgraph.scm 150 */
																obj_t BgL_arg2334z00_2305;

																BgL_arg2334z00_2305 =
																	PROCEDURE_REF
																	(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
																	(int) (((long) 1)));
																{	/* Effect/cgraph.scm 150 */
																	obj_t BgL_arrayz00_2307;

																	int BgL_offsetz00_2308;

																	BgL_arrayz00_2307 = BgL_arg2334z00_2305;
																	BgL_offsetz00_2308 =
																		(int) (BgL_objzd2classzd2numz00_2304);
																	{	/* Effect/cgraph.scm 150 */
																		long BgL_offsetz00_2309;

																		BgL_offsetz00_2309 =
																			(
																			(long) (BgL_offsetz00_2308) -
																			OBJECT_TYPE);
																		{	/* Effect/cgraph.scm 150 */
																			long BgL_modz00_2310;

																			{	/* Effect/cgraph.scm 150 */
																				int BgL_arg2336z00_2311;

																				BgL_arg2336z00_2311 =
																					(int) (((long) 8));
																				{	/* Effect/cgraph.scm 150 */
																					long BgL_auxz00_3745;

																					BgL_auxz00_3745 =
																						(long) (BgL_arg2336z00_2311);
																					BgL_modz00_2310 =
																						(BgL_offsetz00_2309 /
																						BgL_auxz00_3745);
																			}}
																			{	/* Effect/cgraph.scm 150 */
																				long BgL_restz00_2312;

																				{	/* Effect/cgraph.scm 150 */
																					int BgL_arg2335z00_2313;

																					BgL_arg2335z00_2313 =
																						(int) (((long) 8));
																					{	/* Effect/cgraph.scm 150 */
																						long BgL_auxz00_3749;

																						BgL_auxz00_3749 =
																							(long) (BgL_arg2335z00_2313);
																						BgL_restz00_2312 =
																							(BgL_offsetz00_2309 %
																							BgL_auxz00_3749);
																				}}
																				{	/* Effect/cgraph.scm 150 */

																					BgL_method3262z00_2302 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2307,
																							(int) (BgL_modz00_2310)),
																						(int) (BgL_restz00_2312));
													}}}}}}}}
													PROCEDURE_ENTRY(BgL_method3262z00_2302)
														(BgL_method3262z00_2302, (obj_t) (BgL_nodez00_2300),
														(obj_t) (BgL_ownerz00_2301), BEOA);
									}}}}
									{
										obj_t BgL_l3254z00_3760;

										BgL_l3254z00_3760 = CDR(BgL_l3254z00_1377);
										BgL_l3254z00_1377 = BgL_l3254z00_3760;
										goto BgL_forzd2each3255zd2_1378;
									}
								}
							else
								{	/* Effect/cgraph.scm 149 */
									BgL_auxz00_3704 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_3704);
				}
			}
		}
	}



/* call-graph!-let-fun3284 */
	obj_t BGl_callzd2graphz12zd2letzd2fun3284zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2813, obj_t BgL_nodez00_2814, obj_t BgL_ownerz00_2815)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 136 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1356;

				obj_t BgL_ownerz00_1357;

				BgL_nodez00_1356 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2814);
				BgL_ownerz00_1357 = BgL_ownerz00_2815;
				{	/* Effect/cgraph.scm 138 */
					obj_t BgL_g3253z00_1361;

					BgL_g3253z00_1361 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1356))->BgL_localsz00);
					{
						obj_t BgL_l3250z00_1362;

						BgL_l3250z00_1362 = BgL_g3253z00_1361;
					BgL_forzd2each3252zd2_1363:
						if (PAIRP(BgL_l3250z00_1362))
							{	/* Effect/cgraph.scm 138 */
								{	/* Effect/cgraph.scm 139 */
									obj_t BgL_localz00_1365;

									BgL_localz00_1365 = CAR(BgL_l3250z00_1362);
									BGl_funzd2callzd2graphz12z12zzeffect_cgraphz00(
										(BgL_variablez00_bglt) (BgL_localz00_1365));
								}
								{
									obj_t BgL_l3250z00_3770;

									BgL_l3250z00_3770 = CDR(BgL_l3250z00_1362);
									BgL_l3250z00_1362 = BgL_l3250z00_3770;
									goto BgL_forzd2each3252zd2_1363;
								}
							}
						else
							{	/* Effect/cgraph.scm 138 */
								((bool_t) 1);
							}
					}
				}
				{	/* Effect/cgraph.scm 141 */
					BgL_nodez00_bglt BgL_arg3443z00_1367;

					BgL_arg3443z00_1367 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1356))->BgL_bodyz00);
					{	/* Effect/cgraph.scm 141 */
						BgL_variablez00_bglt BgL_ownerz00_2242;

						BgL_ownerz00_2242 = (BgL_variablez00_bglt) (BgL_ownerz00_1357);
						{	/* Effect/cgraph.scm 141 */
							obj_t BgL_method3262z00_2243;

							{	/* Effect/cgraph.scm 141 */
								BgL_objectz00_bglt BgL_objz00_2244;

								BgL_objz00_2244 = (BgL_objectz00_bglt) (BgL_arg3443z00_1367);
								{	/* Effect/cgraph.scm 141 */
									long BgL_objzd2classzd2numz00_2245;

									BgL_objzd2classzd2numz00_2245 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2244);
									{	/* Effect/cgraph.scm 141 */
										obj_t BgL_arg2334z00_2246;

										BgL_arg2334z00_2246 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 141 */
											obj_t BgL_arrayz00_2248;

											int BgL_offsetz00_2249;

											BgL_arrayz00_2248 = BgL_arg2334z00_2246;
											BgL_offsetz00_2249 =
												(int) (BgL_objzd2classzd2numz00_2245);
											{	/* Effect/cgraph.scm 141 */
												long BgL_offsetz00_2250;

												BgL_offsetz00_2250 =
													((long) (BgL_offsetz00_2249) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 141 */
													long BgL_modz00_2251;

													{	/* Effect/cgraph.scm 141 */
														int BgL_arg2336z00_2252;

														BgL_arg2336z00_2252 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 141 */
															long BgL_auxz00_3782;

															BgL_auxz00_3782 = (long) (BgL_arg2336z00_2252);
															BgL_modz00_2251 =
																(BgL_offsetz00_2250 / BgL_auxz00_3782);
													}}
													{	/* Effect/cgraph.scm 141 */
														long BgL_restz00_2253;

														{	/* Effect/cgraph.scm 141 */
															int BgL_arg2335z00_2254;

															BgL_arg2335z00_2254 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 141 */
																long BgL_auxz00_3786;

																BgL_auxz00_3786 = (long) (BgL_arg2335z00_2254);
																BgL_restz00_2253 =
																	(BgL_offsetz00_2250 % BgL_auxz00_3786);
														}}
														{	/* Effect/cgraph.scm 141 */

															BgL_method3262z00_2243 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2248,
																	(int) (BgL_modz00_2251)),
																(int) (BgL_restz00_2253));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_2243) (BgL_method3262z00_2243,
								(obj_t) (BgL_arg3443z00_1367),
								(obj_t) (BgL_ownerz00_2242), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-select3282 */
	obj_t BGl_callzd2graphz12zd2select3282z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2816, obj_t BgL_nodez00_2817, obj_t BgL_ownerz00_2818)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 126 */
			{
				BgL_selectz00_bglt BgL_nodez00_1341;

				obj_t BgL_ownerz00_1342;

				{	/* Effect/cgraph.scm 127 */
					bool_t BgL_auxz00_3798;

					BgL_nodez00_1341 = (BgL_selectz00_bglt) (BgL_nodez00_2817);
					BgL_ownerz00_1342 = BgL_ownerz00_2818;
					{	/* Effect/cgraph.scm 128 */
						BgL_nodez00_bglt BgL_arg3436z00_1346;

						BgL_arg3436z00_1346 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1341))->BgL_testz00);
						{	/* Effect/cgraph.scm 128 */
							BgL_variablez00_bglt BgL_ownerz00_2178;

							BgL_ownerz00_2178 = (BgL_variablez00_bglt) (BgL_ownerz00_1342);
							{	/* Effect/cgraph.scm 128 */
								obj_t BgL_method3262z00_2179;

								{	/* Effect/cgraph.scm 128 */
									BgL_objectz00_bglt BgL_objz00_2180;

									BgL_objz00_2180 = (BgL_objectz00_bglt) (BgL_arg3436z00_1346);
									{	/* Effect/cgraph.scm 128 */
										long BgL_objzd2classzd2numz00_2181;

										BgL_objzd2classzd2numz00_2181 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2180);
										{	/* Effect/cgraph.scm 128 */
											obj_t BgL_arg2334z00_2182;

											BgL_arg2334z00_2182 =
												PROCEDURE_REF
												(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
												(int) (((long) 1)));
											{	/* Effect/cgraph.scm 128 */
												obj_t BgL_arrayz00_2184;

												int BgL_offsetz00_2185;

												BgL_arrayz00_2184 = BgL_arg2334z00_2182;
												BgL_offsetz00_2185 =
													(int) (BgL_objzd2classzd2numz00_2181);
												{	/* Effect/cgraph.scm 128 */
													long BgL_offsetz00_2186;

													BgL_offsetz00_2186 =
														((long) (BgL_offsetz00_2185) - OBJECT_TYPE);
													{	/* Effect/cgraph.scm 128 */
														long BgL_modz00_2187;

														{	/* Effect/cgraph.scm 128 */
															int BgL_arg2336z00_2188;

															BgL_arg2336z00_2188 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 128 */
																long BgL_auxz00_3809;

																BgL_auxz00_3809 = (long) (BgL_arg2336z00_2188);
																BgL_modz00_2187 =
																	(BgL_offsetz00_2186 / BgL_auxz00_3809);
														}}
														{	/* Effect/cgraph.scm 128 */
															long BgL_restz00_2189;

															{	/* Effect/cgraph.scm 128 */
																int BgL_arg2335z00_2190;

																BgL_arg2335z00_2190 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 128 */
																	long BgL_auxz00_3813;

																	BgL_auxz00_3813 =
																		(long) (BgL_arg2335z00_2190);
																	BgL_restz00_2189 =
																		(BgL_offsetz00_2186 % BgL_auxz00_3813);
															}}
															{	/* Effect/cgraph.scm 128 */

																BgL_method3262z00_2179 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2184,
																		(int) (BgL_modz00_2187)),
																	(int) (BgL_restz00_2189));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3262z00_2179) (BgL_method3262z00_2179,
									(obj_t) (BgL_arg3436z00_1346),
									(obj_t) (BgL_ownerz00_2178), BEOA);
					}}}
					{	/* Effect/cgraph.scm 129 */
						obj_t BgL_g3249z00_1347;

						BgL_g3249z00_1347 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1341))->BgL_clausesz00);
						{
							obj_t BgL_l3246z00_1348;

							BgL_l3246z00_1348 = BgL_g3249z00_1347;
						BgL_forzd2each3248zd2_1349:
							if (PAIRP(BgL_l3246z00_1348))
								{	/* Effect/cgraph.scm 129 */
									{	/* Effect/cgraph.scm 130 */
										obj_t BgL_clausez00_1351;

										BgL_clausez00_1351 = CAR(BgL_l3246z00_1348);
										{	/* Effect/cgraph.scm 130 */
											obj_t BgL_arg3438z00_1352;

											BgL_arg3438z00_1352 = CDR(BgL_clausez00_1351);
											{	/* Effect/cgraph.scm 130 */
												BgL_nodez00_bglt BgL_nodez00_2208;

												BgL_variablez00_bglt BgL_ownerz00_2209;

												BgL_nodez00_2208 =
													(BgL_nodez00_bglt) (BgL_arg3438z00_1352);
												BgL_ownerz00_2209 =
													(BgL_variablez00_bglt) (BgL_ownerz00_1342);
												{	/* Effect/cgraph.scm 130 */
													obj_t BgL_method3262z00_2210;

													{	/* Effect/cgraph.scm 130 */
														BgL_objectz00_bglt BgL_objz00_2211;

														BgL_objz00_2211 =
															(BgL_objectz00_bglt) (BgL_nodez00_2208);
														{	/* Effect/cgraph.scm 130 */
															long BgL_objzd2classzd2numz00_2212;

															BgL_objzd2classzd2numz00_2212 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_2211);
															{	/* Effect/cgraph.scm 130 */
																obj_t BgL_arg2334z00_2213;

																BgL_arg2334z00_2213 =
																	PROCEDURE_REF
																	(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
																	(int) (((long) 1)));
																{	/* Effect/cgraph.scm 130 */
																	obj_t BgL_arrayz00_2215;

																	int BgL_offsetz00_2216;

																	BgL_arrayz00_2215 = BgL_arg2334z00_2213;
																	BgL_offsetz00_2216 =
																		(int) (BgL_objzd2classzd2numz00_2212);
																	{	/* Effect/cgraph.scm 130 */
																		long BgL_offsetz00_2217;

																		BgL_offsetz00_2217 =
																			(
																			(long) (BgL_offsetz00_2216) -
																			OBJECT_TYPE);
																		{	/* Effect/cgraph.scm 130 */
																			long BgL_modz00_2218;

																			{	/* Effect/cgraph.scm 130 */
																				int BgL_arg2336z00_2219;

																				BgL_arg2336z00_2219 =
																					(int) (((long) 8));
																				{	/* Effect/cgraph.scm 130 */
																					long BgL_auxz00_3839;

																					BgL_auxz00_3839 =
																						(long) (BgL_arg2336z00_2219);
																					BgL_modz00_2218 =
																						(BgL_offsetz00_2217 /
																						BgL_auxz00_3839);
																			}}
																			{	/* Effect/cgraph.scm 130 */
																				long BgL_restz00_2220;

																				{	/* Effect/cgraph.scm 130 */
																					int BgL_arg2335z00_2221;

																					BgL_arg2335z00_2221 =
																						(int) (((long) 8));
																					{	/* Effect/cgraph.scm 130 */
																						long BgL_auxz00_3843;

																						BgL_auxz00_3843 =
																							(long) (BgL_arg2335z00_2221);
																						BgL_restz00_2220 =
																							(BgL_offsetz00_2217 %
																							BgL_auxz00_3843);
																				}}
																				{	/* Effect/cgraph.scm 130 */

																					BgL_method3262z00_2210 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_2215,
																							(int) (BgL_modz00_2218)),
																						(int) (BgL_restz00_2220));
													}}}}}}}}
													PROCEDURE_ENTRY(BgL_method3262z00_2210)
														(BgL_method3262z00_2210, (obj_t) (BgL_nodez00_2208),
														(obj_t) (BgL_ownerz00_2209), BEOA);
									}}}}
									{
										obj_t BgL_l3246z00_3854;

										BgL_l3246z00_3854 = CDR(BgL_l3246z00_1348);
										BgL_l3246z00_1348 = BgL_l3246z00_3854;
										goto BgL_forzd2each3248zd2_1349;
									}
								}
							else
								{	/* Effect/cgraph.scm 129 */
									BgL_auxz00_3798 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_3798);
				}
			}
		}
	}



/* call-graph!-fail3280 */
	obj_t BGl_callzd2graphz12zd2fail3280z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2819, obj_t BgL_nodez00_2820, obj_t BgL_ownerz00_2821)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 116 */
			{
				BgL_failz00_bglt BgL_nodez00_1331;

				obj_t BgL_ownerz00_1332;

				BgL_nodez00_1331 = (BgL_failz00_bglt) (BgL_nodez00_2820);
				BgL_ownerz00_1332 = BgL_ownerz00_2821;
				BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
					(BgL_variablez00_bglt) (BgL_ownerz00_1332));
				{	/* Effect/cgraph.scm 119 */
					BgL_nodez00_bglt BgL_arg3431z00_1336;

					BgL_arg3431z00_1336 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1331))->BgL_procz00);
					{	/* Effect/cgraph.scm 119 */
						BgL_variablez00_bglt BgL_ownerz00_2094;

						BgL_ownerz00_2094 = (BgL_variablez00_bglt) (BgL_ownerz00_1332);
						{	/* Effect/cgraph.scm 119 */
							obj_t BgL_method3262z00_2095;

							{	/* Effect/cgraph.scm 119 */
								BgL_objectz00_bglt BgL_objz00_2096;

								BgL_objz00_2096 = (BgL_objectz00_bglt) (BgL_arg3431z00_1336);
								{	/* Effect/cgraph.scm 119 */
									long BgL_objzd2classzd2numz00_2097;

									BgL_objzd2classzd2numz00_2097 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2096);
									{	/* Effect/cgraph.scm 119 */
										obj_t BgL_arg2334z00_2098;

										BgL_arg2334z00_2098 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 119 */
											obj_t BgL_arrayz00_2100;

											int BgL_offsetz00_2101;

											BgL_arrayz00_2100 = BgL_arg2334z00_2098;
											BgL_offsetz00_2101 =
												(int) (BgL_objzd2classzd2numz00_2097);
											{	/* Effect/cgraph.scm 119 */
												long BgL_offsetz00_2102;

												BgL_offsetz00_2102 =
													((long) (BgL_offsetz00_2101) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 119 */
													long BgL_modz00_2103;

													{	/* Effect/cgraph.scm 119 */
														int BgL_arg2336z00_2104;

														BgL_arg2336z00_2104 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 119 */
															long BgL_auxz00_3870;

															BgL_auxz00_3870 = (long) (BgL_arg2336z00_2104);
															BgL_modz00_2103 =
																(BgL_offsetz00_2102 / BgL_auxz00_3870);
													}}
													{	/* Effect/cgraph.scm 119 */
														long BgL_restz00_2105;

														{	/* Effect/cgraph.scm 119 */
															int BgL_arg2335z00_2106;

															BgL_arg2335z00_2106 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 119 */
																long BgL_auxz00_3874;

																BgL_auxz00_3874 = (long) (BgL_arg2335z00_2106);
																BgL_restz00_2105 =
																	(BgL_offsetz00_2102 % BgL_auxz00_3874);
														}}
														{	/* Effect/cgraph.scm 119 */

															BgL_method3262z00_2095 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2100,
																	(int) (BgL_modz00_2103)),
																(int) (BgL_restz00_2105));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3262z00_2095) (BgL_method3262z00_2095,
								(obj_t) (BgL_arg3431z00_1336),
								(obj_t) (BgL_ownerz00_2094), BEOA);
				}}}
				{	/* Effect/cgraph.scm 120 */
					BgL_nodez00_bglt BgL_arg3432z00_1337;

					BgL_arg3432z00_1337 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1331))->BgL_msgz00);
					{	/* Effect/cgraph.scm 120 */
						BgL_variablez00_bglt BgL_ownerz00_2122;

						BgL_ownerz00_2122 = (BgL_variablez00_bglt) (BgL_ownerz00_1332);
						{	/* Effect/cgraph.scm 120 */
							obj_t BgL_method3262z00_2123;

							{	/* Effect/cgraph.scm 120 */
								BgL_objectz00_bglt BgL_objz00_2124;

								BgL_objz00_2124 = (BgL_objectz00_bglt) (BgL_arg3432z00_1337);
								{	/* Effect/cgraph.scm 120 */
									long BgL_objzd2classzd2numz00_2125;

									BgL_objzd2classzd2numz00_2125 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2124);
									{	/* Effect/cgraph.scm 120 */
										obj_t BgL_arg2334z00_2126;

										BgL_arg2334z00_2126 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 120 */
											obj_t BgL_arrayz00_2128;

											int BgL_offsetz00_2129;

											BgL_arrayz00_2128 = BgL_arg2334z00_2126;
											BgL_offsetz00_2129 =
												(int) (BgL_objzd2classzd2numz00_2125);
											{	/* Effect/cgraph.scm 120 */
												long BgL_offsetz00_2130;

												BgL_offsetz00_2130 =
													((long) (BgL_offsetz00_2129) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 120 */
													long BgL_modz00_2131;

													{	/* Effect/cgraph.scm 120 */
														int BgL_arg2336z00_2132;

														BgL_arg2336z00_2132 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 120 */
															long BgL_auxz00_3895;

															BgL_auxz00_3895 = (long) (BgL_arg2336z00_2132);
															BgL_modz00_2131 =
																(BgL_offsetz00_2130 / BgL_auxz00_3895);
													}}
													{	/* Effect/cgraph.scm 120 */
														long BgL_restz00_2133;

														{	/* Effect/cgraph.scm 120 */
															int BgL_arg2335z00_2134;

															BgL_arg2335z00_2134 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 120 */
																long BgL_auxz00_3899;

																BgL_auxz00_3899 = (long) (BgL_arg2335z00_2134);
																BgL_restz00_2133 =
																	(BgL_offsetz00_2130 % BgL_auxz00_3899);
														}}
														{	/* Effect/cgraph.scm 120 */

															BgL_method3262z00_2123 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2128,
																	(int) (BgL_modz00_2131)),
																(int) (BgL_restz00_2133));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3262z00_2123) (BgL_method3262z00_2123,
								(obj_t) (BgL_arg3432z00_1337),
								(obj_t) (BgL_ownerz00_2122), BEOA);
				}}}
				{	/* Effect/cgraph.scm 121 */
					BgL_nodez00_bglt BgL_arg3434z00_1338;

					BgL_arg3434z00_1338 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1331))->BgL_objz00);
					{	/* Effect/cgraph.scm 121 */
						BgL_variablez00_bglt BgL_ownerz00_2150;

						BgL_ownerz00_2150 = (BgL_variablez00_bglt) (BgL_ownerz00_1332);
						{	/* Effect/cgraph.scm 121 */
							obj_t BgL_method3262z00_2151;

							{	/* Effect/cgraph.scm 121 */
								BgL_objectz00_bglt BgL_objz00_2152;

								BgL_objz00_2152 = (BgL_objectz00_bglt) (BgL_arg3434z00_1338);
								{	/* Effect/cgraph.scm 121 */
									long BgL_objzd2classzd2numz00_2153;

									BgL_objzd2classzd2numz00_2153 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2152);
									{	/* Effect/cgraph.scm 121 */
										obj_t BgL_arg2334z00_2154;

										BgL_arg2334z00_2154 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 121 */
											obj_t BgL_arrayz00_2156;

											int BgL_offsetz00_2157;

											BgL_arrayz00_2156 = BgL_arg2334z00_2154;
											BgL_offsetz00_2157 =
												(int) (BgL_objzd2classzd2numz00_2153);
											{	/* Effect/cgraph.scm 121 */
												long BgL_offsetz00_2158;

												BgL_offsetz00_2158 =
													((long) (BgL_offsetz00_2157) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 121 */
													long BgL_modz00_2159;

													{	/* Effect/cgraph.scm 121 */
														int BgL_arg2336z00_2160;

														BgL_arg2336z00_2160 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 121 */
															long BgL_auxz00_3920;

															BgL_auxz00_3920 = (long) (BgL_arg2336z00_2160);
															BgL_modz00_2159 =
																(BgL_offsetz00_2158 / BgL_auxz00_3920);
													}}
													{	/* Effect/cgraph.scm 121 */
														long BgL_restz00_2161;

														{	/* Effect/cgraph.scm 121 */
															int BgL_arg2335z00_2162;

															BgL_arg2335z00_2162 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 121 */
																long BgL_auxz00_3924;

																BgL_auxz00_3924 = (long) (BgL_arg2335z00_2162);
																BgL_restz00_2161 =
																	(BgL_offsetz00_2158 % BgL_auxz00_3924);
														}}
														{	/* Effect/cgraph.scm 121 */

															BgL_method3262z00_2151 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2156,
																	(int) (BgL_modz00_2159)),
																(int) (BgL_restz00_2161));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_2151) (BgL_method3262z00_2151,
								(obj_t) (BgL_arg3434z00_1338),
								(obj_t) (BgL_ownerz00_2150), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-conditio3278 */
	obj_t BGl_callzd2graphz12zd2conditio3278z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2822, obj_t BgL_nodez00_2823, obj_t BgL_ownerz00_2824)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 107 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1321;

				obj_t BgL_ownerz00_1322;

				BgL_nodez00_1321 = (BgL_conditionalz00_bglt) (BgL_nodez00_2823);
				BgL_ownerz00_1322 = BgL_ownerz00_2824;
				{	/* Effect/cgraph.scm 109 */
					BgL_nodez00_bglt BgL_arg3427z00_1326;

					BgL_arg3427z00_1326 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1321))->BgL_testz00);
					{	/* Effect/cgraph.scm 109 */
						BgL_variablez00_bglt BgL_ownerz00_2010;

						BgL_ownerz00_2010 = (BgL_variablez00_bglt) (BgL_ownerz00_1322);
						{	/* Effect/cgraph.scm 109 */
							obj_t BgL_method3262z00_2011;

							{	/* Effect/cgraph.scm 109 */
								BgL_objectz00_bglt BgL_objz00_2012;

								BgL_objz00_2012 = (BgL_objectz00_bglt) (BgL_arg3427z00_1326);
								{	/* Effect/cgraph.scm 109 */
									long BgL_objzd2classzd2numz00_2013;

									BgL_objzd2classzd2numz00_2013 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2012);
									{	/* Effect/cgraph.scm 109 */
										obj_t BgL_arg2334z00_2014;

										BgL_arg2334z00_2014 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 109 */
											obj_t BgL_arrayz00_2016;

											int BgL_offsetz00_2017;

											BgL_arrayz00_2016 = BgL_arg2334z00_2014;
											BgL_offsetz00_2017 =
												(int) (BgL_objzd2classzd2numz00_2013);
											{	/* Effect/cgraph.scm 109 */
												long BgL_offsetz00_2018;

												BgL_offsetz00_2018 =
													((long) (BgL_offsetz00_2017) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 109 */
													long BgL_modz00_2019;

													{	/* Effect/cgraph.scm 109 */
														int BgL_arg2336z00_2020;

														BgL_arg2336z00_2020 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 109 */
															long BgL_auxz00_3946;

															BgL_auxz00_3946 = (long) (BgL_arg2336z00_2020);
															BgL_modz00_2019 =
																(BgL_offsetz00_2018 / BgL_auxz00_3946);
													}}
													{	/* Effect/cgraph.scm 109 */
														long BgL_restz00_2021;

														{	/* Effect/cgraph.scm 109 */
															int BgL_arg2335z00_2022;

															BgL_arg2335z00_2022 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 109 */
																long BgL_auxz00_3950;

																BgL_auxz00_3950 = (long) (BgL_arg2335z00_2022);
																BgL_restz00_2021 =
																	(BgL_offsetz00_2018 % BgL_auxz00_3950);
														}}
														{	/* Effect/cgraph.scm 109 */

															BgL_method3262z00_2011 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2016,
																	(int) (BgL_modz00_2019)),
																(int) (BgL_restz00_2021));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3262z00_2011) (BgL_method3262z00_2011,
								(obj_t) (BgL_arg3427z00_1326),
								(obj_t) (BgL_ownerz00_2010), BEOA);
				}}}
				{	/* Effect/cgraph.scm 110 */
					BgL_nodez00_bglt BgL_arg3428z00_1327;

					BgL_arg3428z00_1327 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1321))->BgL_truez00);
					{	/* Effect/cgraph.scm 110 */
						BgL_variablez00_bglt BgL_ownerz00_2038;

						BgL_ownerz00_2038 = (BgL_variablez00_bglt) (BgL_ownerz00_1322);
						{	/* Effect/cgraph.scm 110 */
							obj_t BgL_method3262z00_2039;

							{	/* Effect/cgraph.scm 110 */
								BgL_objectz00_bglt BgL_objz00_2040;

								BgL_objz00_2040 = (BgL_objectz00_bglt) (BgL_arg3428z00_1327);
								{	/* Effect/cgraph.scm 110 */
									long BgL_objzd2classzd2numz00_2041;

									BgL_objzd2classzd2numz00_2041 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2040);
									{	/* Effect/cgraph.scm 110 */
										obj_t BgL_arg2334z00_2042;

										BgL_arg2334z00_2042 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 110 */
											obj_t BgL_arrayz00_2044;

											int BgL_offsetz00_2045;

											BgL_arrayz00_2044 = BgL_arg2334z00_2042;
											BgL_offsetz00_2045 =
												(int) (BgL_objzd2classzd2numz00_2041);
											{	/* Effect/cgraph.scm 110 */
												long BgL_offsetz00_2046;

												BgL_offsetz00_2046 =
													((long) (BgL_offsetz00_2045) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 110 */
													long BgL_modz00_2047;

													{	/* Effect/cgraph.scm 110 */
														int BgL_arg2336z00_2048;

														BgL_arg2336z00_2048 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 110 */
															long BgL_auxz00_3971;

															BgL_auxz00_3971 = (long) (BgL_arg2336z00_2048);
															BgL_modz00_2047 =
																(BgL_offsetz00_2046 / BgL_auxz00_3971);
													}}
													{	/* Effect/cgraph.scm 110 */
														long BgL_restz00_2049;

														{	/* Effect/cgraph.scm 110 */
															int BgL_arg2335z00_2050;

															BgL_arg2335z00_2050 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 110 */
																long BgL_auxz00_3975;

																BgL_auxz00_3975 = (long) (BgL_arg2335z00_2050);
																BgL_restz00_2049 =
																	(BgL_offsetz00_2046 % BgL_auxz00_3975);
														}}
														{	/* Effect/cgraph.scm 110 */

															BgL_method3262z00_2039 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2044,
																	(int) (BgL_modz00_2047)),
																(int) (BgL_restz00_2049));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3262z00_2039) (BgL_method3262z00_2039,
								(obj_t) (BgL_arg3428z00_1327),
								(obj_t) (BgL_ownerz00_2038), BEOA);
				}}}
				{	/* Effect/cgraph.scm 111 */
					BgL_nodez00_bglt BgL_arg3429z00_1328;

					BgL_arg3429z00_1328 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1321))->BgL_falsez00);
					{	/* Effect/cgraph.scm 111 */
						BgL_variablez00_bglt BgL_ownerz00_2066;

						BgL_ownerz00_2066 = (BgL_variablez00_bglt) (BgL_ownerz00_1322);
						{	/* Effect/cgraph.scm 111 */
							obj_t BgL_method3262z00_2067;

							{	/* Effect/cgraph.scm 111 */
								BgL_objectz00_bglt BgL_objz00_2068;

								BgL_objz00_2068 = (BgL_objectz00_bglt) (BgL_arg3429z00_1328);
								{	/* Effect/cgraph.scm 111 */
									long BgL_objzd2classzd2numz00_2069;

									BgL_objzd2classzd2numz00_2069 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_2068);
									{	/* Effect/cgraph.scm 111 */
										obj_t BgL_arg2334z00_2070;

										BgL_arg2334z00_2070 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 111 */
											obj_t BgL_arrayz00_2072;

											int BgL_offsetz00_2073;

											BgL_arrayz00_2072 = BgL_arg2334z00_2070;
											BgL_offsetz00_2073 =
												(int) (BgL_objzd2classzd2numz00_2069);
											{	/* Effect/cgraph.scm 111 */
												long BgL_offsetz00_2074;

												BgL_offsetz00_2074 =
													((long) (BgL_offsetz00_2073) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 111 */
													long BgL_modz00_2075;

													{	/* Effect/cgraph.scm 111 */
														int BgL_arg2336z00_2076;

														BgL_arg2336z00_2076 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 111 */
															long BgL_auxz00_3996;

															BgL_auxz00_3996 = (long) (BgL_arg2336z00_2076);
															BgL_modz00_2075 =
																(BgL_offsetz00_2074 / BgL_auxz00_3996);
													}}
													{	/* Effect/cgraph.scm 111 */
														long BgL_restz00_2077;

														{	/* Effect/cgraph.scm 111 */
															int BgL_arg2335z00_2078;

															BgL_arg2335z00_2078 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 111 */
																long BgL_auxz00_4000;

																BgL_auxz00_4000 = (long) (BgL_arg2335z00_2078);
																BgL_restz00_2077 =
																	(BgL_offsetz00_2074 % BgL_auxz00_4000);
														}}
														{	/* Effect/cgraph.scm 111 */

															BgL_method3262z00_2067 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_2072,
																	(int) (BgL_modz00_2075)),
																(int) (BgL_restz00_2077));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_2067) (BgL_method3262z00_2067,
								(obj_t) (BgL_arg3429z00_1328),
								(obj_t) (BgL_ownerz00_2066), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-setq3276 */
	obj_t BGl_callzd2graphz12zd2setq3276z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2825, obj_t BgL_nodez00_2826, obj_t BgL_ownerz00_2827)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 97 */
			{
				BgL_setqz00_bglt BgL_nodez00_1308;

				obj_t BgL_ownerz00_1309;

				BgL_nodez00_1308 = (BgL_setqz00_bglt) (BgL_nodez00_2826);
				BgL_ownerz00_1309 = BgL_ownerz00_2827;
				{	/* Effect/cgraph.scm 99 */
					bool_t BgL_testz00_4012;

					if (BGl_iszd2azf3z21zz__objectz00(BgL_ownerz00_1309,
							BGl_localz00zzast_varz00))
						{	/* Effect/cgraph.scm 99 */
							BgL_testz00_4012 = ((bool_t) 1);
						}
					else
						{	/* Effect/cgraph.scm 99 */
							BgL_variablez00_bglt BgL_arg3421z00_1315;

							{	/* Effect/cgraph.scm 99 */
								BgL_varz00_bglt BgL_obj1972z00_1950;

								BgL_obj1972z00_1950 =
									(((BgL_setqz00_bglt) CREF(BgL_nodez00_1308))->BgL_varz00);
								BgL_arg3421z00_1315 =
									(((BgL_varz00_bglt) CREF(BgL_obj1972z00_1950))->
									BgL_variablez00);
							}
							{	/* Effect/cgraph.scm 99 */
								obj_t BgL_obj1568z00_1951;

								BgL_obj1568z00_1951 = (obj_t) (BgL_arg3421z00_1315);
								BgL_testz00_4012 =
									BGl_iszd2azf3z21zz__objectz00(BgL_obj1568z00_1951,
									BGl_globalz00zzast_varz00);
							}
						}
					if (BgL_testz00_4012)
						{	/* Effect/cgraph.scm 99 */
							BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
								(BgL_variablez00_bglt) (BgL_ownerz00_1309));
						}
					else
						{	/* Effect/cgraph.scm 99 */
							BFALSE;
						}
				}
				{	/* Effect/cgraph.scm 101 */
					BgL_varz00_bglt BgL_arg3424z00_1317;

					BgL_arg3424z00_1317 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1308))->BgL_varz00);
					{	/* Effect/cgraph.scm 101 */
						BgL_nodez00_bglt BgL_nodez00_1953;

						BgL_variablez00_bglt BgL_ownerz00_1954;

						BgL_nodez00_1953 = (BgL_nodez00_bglt) (BgL_arg3424z00_1317);
						BgL_ownerz00_1954 = (BgL_variablez00_bglt) (BgL_ownerz00_1309);
						{	/* Effect/cgraph.scm 101 */
							obj_t BgL_method3262z00_1955;

							{	/* Effect/cgraph.scm 101 */
								BgL_objectz00_bglt BgL_objz00_1956;

								BgL_objz00_1956 = (BgL_objectz00_bglt) (BgL_nodez00_1953);
								{	/* Effect/cgraph.scm 101 */
									long BgL_objzd2classzd2numz00_1957;

									BgL_objzd2classzd2numz00_1957 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1956);
									{	/* Effect/cgraph.scm 101 */
										obj_t BgL_arg2334z00_1958;

										BgL_arg2334z00_1958 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 101 */
											obj_t BgL_arrayz00_1960;

											int BgL_offsetz00_1961;

											BgL_arrayz00_1960 = BgL_arg2334z00_1958;
											BgL_offsetz00_1961 =
												(int) (BgL_objzd2classzd2numz00_1957);
											{	/* Effect/cgraph.scm 101 */
												long BgL_offsetz00_1962;

												BgL_offsetz00_1962 =
													((long) (BgL_offsetz00_1961) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 101 */
													long BgL_modz00_1963;

													{	/* Effect/cgraph.scm 101 */
														int BgL_arg2336z00_1964;

														BgL_arg2336z00_1964 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 101 */
															long BgL_auxz00_4032;

															BgL_auxz00_4032 = (long) (BgL_arg2336z00_1964);
															BgL_modz00_1963 =
																(BgL_offsetz00_1962 / BgL_auxz00_4032);
													}}
													{	/* Effect/cgraph.scm 101 */
														long BgL_restz00_1965;

														{	/* Effect/cgraph.scm 101 */
															int BgL_arg2335z00_1966;

															BgL_arg2335z00_1966 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 101 */
																long BgL_auxz00_4036;

																BgL_auxz00_4036 = (long) (BgL_arg2335z00_1966);
																BgL_restz00_1965 =
																	(BgL_offsetz00_1962 % BgL_auxz00_4036);
														}}
														{	/* Effect/cgraph.scm 101 */

															BgL_method3262z00_1955 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1960,
																	(int) (BgL_modz00_1963)),
																(int) (BgL_restz00_1965));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3262z00_1955) (BgL_method3262z00_1955,
								(obj_t) (BgL_nodez00_1953), (obj_t) (BgL_ownerz00_1954), BEOA);
				}}}
				{	/* Effect/cgraph.scm 102 */
					BgL_nodez00_bglt BgL_arg3425z00_1318;

					BgL_arg3425z00_1318 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1308))->BgL_valuez00);
					{	/* Effect/cgraph.scm 102 */
						BgL_variablez00_bglt BgL_ownerz00_1982;

						BgL_ownerz00_1982 = (BgL_variablez00_bglt) (BgL_ownerz00_1309);
						{	/* Effect/cgraph.scm 102 */
							obj_t BgL_method3262z00_1983;

							{	/* Effect/cgraph.scm 102 */
								BgL_objectz00_bglt BgL_objz00_1984;

								BgL_objz00_1984 = (BgL_objectz00_bglt) (BgL_arg3425z00_1318);
								{	/* Effect/cgraph.scm 102 */
									long BgL_objzd2classzd2numz00_1985;

									BgL_objzd2classzd2numz00_1985 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1984);
									{	/* Effect/cgraph.scm 102 */
										obj_t BgL_arg2334z00_1986;

										BgL_arg2334z00_1986 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 102 */
											obj_t BgL_arrayz00_1988;

											int BgL_offsetz00_1989;

											BgL_arrayz00_1988 = BgL_arg2334z00_1986;
											BgL_offsetz00_1989 =
												(int) (BgL_objzd2classzd2numz00_1985);
											{	/* Effect/cgraph.scm 102 */
												long BgL_offsetz00_1990;

												BgL_offsetz00_1990 =
													((long) (BgL_offsetz00_1989) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 102 */
													long BgL_modz00_1991;

													{	/* Effect/cgraph.scm 102 */
														int BgL_arg2336z00_1992;

														BgL_arg2336z00_1992 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 102 */
															long BgL_auxz00_4057;

															BgL_auxz00_4057 = (long) (BgL_arg2336z00_1992);
															BgL_modz00_1991 =
																(BgL_offsetz00_1990 / BgL_auxz00_4057);
													}}
													{	/* Effect/cgraph.scm 102 */
														long BgL_restz00_1993;

														{	/* Effect/cgraph.scm 102 */
															int BgL_arg2335z00_1994;

															BgL_arg2335z00_1994 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 102 */
																long BgL_auxz00_4061;

																BgL_auxz00_4061 = (long) (BgL_arg2335z00_1994);
																BgL_restz00_1993 =
																	(BgL_offsetz00_1990 % BgL_auxz00_4061);
														}}
														{	/* Effect/cgraph.scm 102 */

															BgL_method3262z00_1983 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1988,
																	(int) (BgL_modz00_1991)),
																(int) (BgL_restz00_1993));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_1983) (BgL_method3262z00_1983,
								(obj_t) (BgL_arg3425z00_1318),
								(obj_t) (BgL_ownerz00_1982), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-cast3274 */
	obj_t BGl_callzd2graphz12zd2cast3274z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2828, obj_t BgL_nodez00_2829, obj_t BgL_ownerz00_2830)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 86 */
			{
				BgL_castz00_bglt BgL_nodez00_1300;

				obj_t BgL_ownerz00_1301;

				BgL_nodez00_1300 = (BgL_castz00_bglt) (BgL_nodez00_2829);
				BgL_ownerz00_1301 = BgL_ownerz00_2830;
				{	/* Effect/cgraph.scm 87 */
					BgL_nodez00_bglt BgL_arg3417z00_1919;

					BgL_arg3417z00_1919 =
						(((BgL_castz00_bglt) CREF(BgL_nodez00_1300))->BgL_argz00);
					{	/* Effect/cgraph.scm 87 */
						BgL_variablez00_bglt BgL_ownerz00_1922;

						BgL_ownerz00_1922 = (BgL_variablez00_bglt) (BgL_ownerz00_1301);
						{	/* Effect/cgraph.scm 87 */
							obj_t BgL_method3262z00_1923;

							{	/* Effect/cgraph.scm 87 */
								BgL_objectz00_bglt BgL_objz00_1924;

								BgL_objz00_1924 = (BgL_objectz00_bglt) (BgL_arg3417z00_1919);
								{	/* Effect/cgraph.scm 87 */
									long BgL_objzd2classzd2numz00_1925;

									BgL_objzd2classzd2numz00_1925 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1924);
									{	/* Effect/cgraph.scm 87 */
										obj_t BgL_arg2334z00_1926;

										BgL_arg2334z00_1926 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 87 */
											obj_t BgL_arrayz00_1928;

											int BgL_offsetz00_1929;

											BgL_arrayz00_1928 = BgL_arg2334z00_1926;
											BgL_offsetz00_1929 =
												(int) (BgL_objzd2classzd2numz00_1925);
											{	/* Effect/cgraph.scm 87 */
												long BgL_offsetz00_1930;

												BgL_offsetz00_1930 =
													((long) (BgL_offsetz00_1929) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 87 */
													long BgL_modz00_1931;

													{	/* Effect/cgraph.scm 87 */
														int BgL_arg2336z00_1932;

														BgL_arg2336z00_1932 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 87 */
															long BgL_auxz00_4083;

															BgL_auxz00_4083 = (long) (BgL_arg2336z00_1932);
															BgL_modz00_1931 =
																(BgL_offsetz00_1930 / BgL_auxz00_4083);
													}}
													{	/* Effect/cgraph.scm 87 */
														long BgL_restz00_1933;

														{	/* Effect/cgraph.scm 87 */
															int BgL_arg2335z00_1934;

															BgL_arg2335z00_1934 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 87 */
																long BgL_auxz00_4087;

																BgL_auxz00_4087 = (long) (BgL_arg2335z00_1934);
																BgL_restz00_1933 =
																	(BgL_offsetz00_1930 % BgL_auxz00_4087);
														}}
														{	/* Effect/cgraph.scm 87 */

															BgL_method3262z00_1923 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1928,
																	(int) (BgL_modz00_1931)),
																(int) (BgL_restz00_1933));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_1923) (BgL_method3262z00_1923,
								(obj_t) (BgL_arg3417z00_1919),
								(obj_t) (BgL_ownerz00_1922), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-extern3272 */
	obj_t BGl_callzd2graphz12zd2extern3272z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2831, obj_t BgL_nodez00_2832, obj_t BgL_ownerz00_2833)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 77 */
			{
				BgL_externz00_bglt BgL_nodez00_1291;

				obj_t BgL_ownerz00_1292;

				{	/* Effect/cgraph.scm 78 */
					bool_t BgL_auxz00_4099;

					BgL_nodez00_1291 = (BgL_externz00_bglt) (BgL_nodez00_2832);
					BgL_ownerz00_1292 = BgL_ownerz00_2833;
					{	/* Effect/cgraph.scm 79 */
						bool_t BgL_testz00_4100;

						{	/* Effect/cgraph.scm 79 */
							BgL_nodezf2effectzf2_bglt BgL_obj1925z00_1916;

							BgL_obj1925z00_1916 =
								(BgL_nodezf2effectzf2_bglt) (BgL_nodez00_1291);
							BgL_testz00_4100 =
								CBOOL(
								(((BgL_nodezf2effectzf2_bglt) CREF(BgL_obj1925z00_1916))->
									BgL_sidezd2effectzf3z21));
						}
						if (BgL_testz00_4100)
							{	/* Effect/cgraph.scm 79 */
								BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
									(BgL_variablez00_bglt) (BgL_ownerz00_1292));
							}
						else
							{	/* Effect/cgraph.scm 79 */
								BFALSE;
							}
					}
					{	/* Effect/cgraph.scm 81 */
						obj_t BgL_arg3415z00_1297;

						BgL_arg3415z00_1297 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1291))->BgL_exprza2za2);
						BgL_auxz00_4099 =
							BGl_callzd2graphza2z12z62zzeffect_cgraphz00(BgL_arg3415z00_1297,
							BgL_ownerz00_1292);
					}
					return BBOOL(BgL_auxz00_4099);
				}
			}
		}
	}



/* call-graph!-funcall3270 */
	obj_t BGl_callzd2graphz12zd2funcall3270z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2834, obj_t BgL_nodez00_2835, obj_t BgL_ownerz00_2836)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 68 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1282;

				obj_t BgL_ownerz00_1283;

				{	/* Effect/cgraph.scm 69 */
					bool_t BgL_auxz00_4110;

					BgL_nodez00_1282 = (BgL_funcallz00_bglt) (BgL_nodez00_2835);
					BgL_ownerz00_1283 = BgL_ownerz00_2836;
					BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
						(BgL_variablez00_bglt) (BgL_ownerz00_1283));
					{	/* Effect/cgraph.scm 71 */
						BgL_nodez00_bglt BgL_arg3411z00_1287;

						BgL_arg3411z00_1287 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1282))->BgL_funz00);
						{	/* Effect/cgraph.scm 71 */
							BgL_variablez00_bglt BgL_ownerz00_1889;

							BgL_ownerz00_1889 = (BgL_variablez00_bglt) (BgL_ownerz00_1283);
							{	/* Effect/cgraph.scm 71 */
								obj_t BgL_method3262z00_1890;

								{	/* Effect/cgraph.scm 71 */
									BgL_objectz00_bglt BgL_objz00_1891;

									BgL_objz00_1891 = (BgL_objectz00_bglt) (BgL_arg3411z00_1287);
									{	/* Effect/cgraph.scm 71 */
										long BgL_objzd2classzd2numz00_1892;

										BgL_objzd2classzd2numz00_1892 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1891);
										{	/* Effect/cgraph.scm 71 */
											obj_t BgL_arg2334z00_1893;

											BgL_arg2334z00_1893 =
												PROCEDURE_REF
												(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
												(int) (((long) 1)));
											{	/* Effect/cgraph.scm 71 */
												obj_t BgL_arrayz00_1895;

												int BgL_offsetz00_1896;

												BgL_arrayz00_1895 = BgL_arg2334z00_1893;
												BgL_offsetz00_1896 =
													(int) (BgL_objzd2classzd2numz00_1892);
												{	/* Effect/cgraph.scm 71 */
													long BgL_offsetz00_1897;

													BgL_offsetz00_1897 =
														((long) (BgL_offsetz00_1896) - OBJECT_TYPE);
													{	/* Effect/cgraph.scm 71 */
														long BgL_modz00_1898;

														{	/* Effect/cgraph.scm 71 */
															int BgL_arg2336z00_1899;

															BgL_arg2336z00_1899 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 71 */
																long BgL_auxz00_4123;

																BgL_auxz00_4123 = (long) (BgL_arg2336z00_1899);
																BgL_modz00_1898 =
																	(BgL_offsetz00_1897 / BgL_auxz00_4123);
														}}
														{	/* Effect/cgraph.scm 71 */
															long BgL_restz00_1900;

															{	/* Effect/cgraph.scm 71 */
																int BgL_arg2335z00_1901;

																BgL_arg2335z00_1901 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 71 */
																	long BgL_auxz00_4127;

																	BgL_auxz00_4127 =
																		(long) (BgL_arg2335z00_1901);
																	BgL_restz00_1900 =
																		(BgL_offsetz00_1897 % BgL_auxz00_4127);
															}}
															{	/* Effect/cgraph.scm 71 */

																BgL_method3262z00_1890 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1895,
																		(int) (BgL_modz00_1898)),
																	(int) (BgL_restz00_1900));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3262z00_1890) (BgL_method3262z00_1890,
									(obj_t) (BgL_arg3411z00_1287),
									(obj_t) (BgL_ownerz00_1889), BEOA);
					}}}
					{	/* Effect/cgraph.scm 72 */
						obj_t BgL_arg3412z00_1288;

						BgL_arg3412z00_1288 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1282))->BgL_argsz00);
						BgL_auxz00_4110 =
							BGl_callzd2graphza2z12z62zzeffect_cgraphz00(BgL_arg3412z00_1288,
							BgL_ownerz00_1283);
					}
					return BBOOL(BgL_auxz00_4110);
				}
			}
		}
	}



/* call-graph!-app-ly3268 */
	obj_t BGl_callzd2graphz12zd2appzd2ly3268zc0zzeffect_cgraphz00(obj_t
		BgL_envz00_2837, obj_t BgL_nodez00_2838, obj_t BgL_ownerz00_2839)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 59 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1273;

				obj_t BgL_ownerz00_1274;

				BgL_nodez00_1273 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2838);
				BgL_ownerz00_1274 = BgL_ownerz00_2839;
				BGl_markzd2sidezd2effectz12z12zzeffect_cgraphz00(
					(BgL_variablez00_bglt) (BgL_ownerz00_1274));
				{	/* Effect/cgraph.scm 62 */
					BgL_nodez00_bglt BgL_arg3408z00_1278;

					BgL_arg3408z00_1278 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1273))->BgL_funz00);
					{	/* Effect/cgraph.scm 62 */
						BgL_variablez00_bglt BgL_ownerz00_1833;

						BgL_ownerz00_1833 = (BgL_variablez00_bglt) (BgL_ownerz00_1274);
						{	/* Effect/cgraph.scm 62 */
							obj_t BgL_method3262z00_1834;

							{	/* Effect/cgraph.scm 62 */
								BgL_objectz00_bglt BgL_objz00_1835;

								BgL_objz00_1835 = (BgL_objectz00_bglt) (BgL_arg3408z00_1278);
								{	/* Effect/cgraph.scm 62 */
									long BgL_objzd2classzd2numz00_1836;

									BgL_objzd2classzd2numz00_1836 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1835);
									{	/* Effect/cgraph.scm 62 */
										obj_t BgL_arg2334z00_1837;

										BgL_arg2334z00_1837 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 62 */
											obj_t BgL_arrayz00_1839;

											int BgL_offsetz00_1840;

											BgL_arrayz00_1839 = BgL_arg2334z00_1837;
											BgL_offsetz00_1840 =
												(int) (BgL_objzd2classzd2numz00_1836);
											{	/* Effect/cgraph.scm 62 */
												long BgL_offsetz00_1841;

												BgL_offsetz00_1841 =
													((long) (BgL_offsetz00_1840) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 62 */
													long BgL_modz00_1842;

													{	/* Effect/cgraph.scm 62 */
														int BgL_arg2336z00_1843;

														BgL_arg2336z00_1843 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 62 */
															long BgL_auxz00_4154;

															BgL_auxz00_4154 = (long) (BgL_arg2336z00_1843);
															BgL_modz00_1842 =
																(BgL_offsetz00_1841 / BgL_auxz00_4154);
													}}
													{	/* Effect/cgraph.scm 62 */
														long BgL_restz00_1844;

														{	/* Effect/cgraph.scm 62 */
															int BgL_arg2335z00_1845;

															BgL_arg2335z00_1845 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 62 */
																long BgL_auxz00_4158;

																BgL_auxz00_4158 = (long) (BgL_arg2335z00_1845);
																BgL_restz00_1844 =
																	(BgL_offsetz00_1841 % BgL_auxz00_4158);
														}}
														{	/* Effect/cgraph.scm 62 */

															BgL_method3262z00_1834 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1839,
																	(int) (BgL_modz00_1842)),
																(int) (BgL_restz00_1844));
							}}}}}}}}
							PROCEDURE_ENTRY(BgL_method3262z00_1834) (BgL_method3262z00_1834,
								(obj_t) (BgL_arg3408z00_1278),
								(obj_t) (BgL_ownerz00_1833), BEOA);
				}}}
				{	/* Effect/cgraph.scm 63 */
					BgL_nodez00_bglt BgL_arg3409z00_1279;

					BgL_arg3409z00_1279 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1273))->BgL_argz00);
					{	/* Effect/cgraph.scm 63 */
						BgL_variablez00_bglt BgL_ownerz00_1861;

						BgL_ownerz00_1861 = (BgL_variablez00_bglt) (BgL_ownerz00_1274);
						{	/* Effect/cgraph.scm 63 */
							obj_t BgL_method3262z00_1862;

							{	/* Effect/cgraph.scm 63 */
								BgL_objectz00_bglt BgL_objz00_1863;

								BgL_objz00_1863 = (BgL_objectz00_bglt) (BgL_arg3409z00_1279);
								{	/* Effect/cgraph.scm 63 */
									long BgL_objzd2classzd2numz00_1864;

									BgL_objzd2classzd2numz00_1864 =
										BGL_OBJECT_CLASS_NUM(BgL_objz00_1863);
									{	/* Effect/cgraph.scm 63 */
										obj_t BgL_arg2334z00_1865;

										BgL_arg2334z00_1865 =
											PROCEDURE_REF
											(BGl_callzd2graphz12zd2envz12zzeffect_cgraphz00,
											(int) (((long) 1)));
										{	/* Effect/cgraph.scm 63 */
											obj_t BgL_arrayz00_1867;

											int BgL_offsetz00_1868;

											BgL_arrayz00_1867 = BgL_arg2334z00_1865;
											BgL_offsetz00_1868 =
												(int) (BgL_objzd2classzd2numz00_1864);
											{	/* Effect/cgraph.scm 63 */
												long BgL_offsetz00_1869;

												BgL_offsetz00_1869 =
													((long) (BgL_offsetz00_1868) - OBJECT_TYPE);
												{	/* Effect/cgraph.scm 63 */
													long BgL_modz00_1870;

													{	/* Effect/cgraph.scm 63 */
														int BgL_arg2336z00_1871;

														BgL_arg2336z00_1871 = (int) (((long) 8));
														{	/* Effect/cgraph.scm 63 */
															long BgL_auxz00_4179;

															BgL_auxz00_4179 = (long) (BgL_arg2336z00_1871);
															BgL_modz00_1870 =
																(BgL_offsetz00_1869 / BgL_auxz00_4179);
													}}
													{	/* Effect/cgraph.scm 63 */
														long BgL_restz00_1872;

														{	/* Effect/cgraph.scm 63 */
															int BgL_arg2335z00_1873;

															BgL_arg2335z00_1873 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 63 */
																long BgL_auxz00_4183;

																BgL_auxz00_4183 = (long) (BgL_arg2335z00_1873);
																BgL_restz00_1872 =
																	(BgL_offsetz00_1869 % BgL_auxz00_4183);
														}}
														{	/* Effect/cgraph.scm 63 */

															BgL_method3262z00_1862 =
																VECTOR_REF(VECTOR_REF(BgL_arrayz00_1867,
																	(int) (BgL_modz00_1870)),
																(int) (BgL_restz00_1872));
							}}}}}}}}
							return
								PROCEDURE_ENTRY(BgL_method3262z00_1862) (BgL_method3262z00_1862,
								(obj_t) (BgL_arg3409z00_1279),
								(obj_t) (BgL_ownerz00_1861), BEOA);
						}
					}
				}
			}
		}
	}



/* call-graph!-app3266 */
	obj_t BGl_callzd2graphz12zd2app3266z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2840, obj_t BgL_nodez00_2841, obj_t BgL_ownerz00_2842)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 49 */
			{
				BgL_appz00_bglt BgL_nodez00_1263;

				obj_t BgL_ownerz00_1264;

				{	/* Effect/cgraph.scm 50 */
					bool_t BgL_auxz00_4195;

					BgL_nodez00_1263 = (BgL_appz00_bglt) (BgL_nodez00_2841);
					BgL_ownerz00_1264 = BgL_ownerz00_2842;
					{	/* Effect/cgraph.scm 53 */
						BgL_variablez00_bglt BgL_arg3404z00_1268;

						{	/* Effect/cgraph.scm 53 */
							BgL_varz00_bglt BgL_obj1972z00_1802;

							BgL_obj1972z00_1802 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_1263))->BgL_funz00);
							BgL_arg3404z00_1268 =
								(((BgL_varz00_bglt) CREF(BgL_obj1972z00_1802))->
								BgL_variablez00);
						}
						{	/* Effect/cgraph.scm 53 */
							BgL_variablez00_bglt BgL_ownerz00_1804;

							BgL_ownerz00_1804 = (BgL_variablez00_bglt) (BgL_ownerz00_1264);
							{	/* Effect/cgraph.scm 53 */
								obj_t BgL_method3298z00_1805;

								{	/* Effect/cgraph.scm 53 */
									BgL_objectz00_bglt BgL_objz00_1806;

									BgL_objz00_1806 = (BgL_objectz00_bglt) (BgL_arg3404z00_1268);
									{	/* Effect/cgraph.scm 53 */
										long BgL_objzd2classzd2numz00_1807;

										BgL_objzd2classzd2numz00_1807 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_1806);
										{	/* Effect/cgraph.scm 53 */
											obj_t BgL_arg2334z00_1808;

											BgL_arg2334z00_1808 =
												PROCEDURE_REF
												(BGl_savezd2callz12zd2envz12zzeffect_cgraphz00,
												(int) (((long) 1)));
											{	/* Effect/cgraph.scm 53 */
												obj_t BgL_arrayz00_1810;

												int BgL_offsetz00_1811;

												BgL_arrayz00_1810 = BgL_arg2334z00_1808;
												BgL_offsetz00_1811 =
													(int) (BgL_objzd2classzd2numz00_1807);
												{	/* Effect/cgraph.scm 53 */
													long BgL_offsetz00_1812;

													BgL_offsetz00_1812 =
														((long) (BgL_offsetz00_1811) - OBJECT_TYPE);
													{	/* Effect/cgraph.scm 53 */
														long BgL_modz00_1813;

														{	/* Effect/cgraph.scm 53 */
															int BgL_arg2336z00_1814;

															BgL_arg2336z00_1814 = (int) (((long) 8));
															{	/* Effect/cgraph.scm 53 */
																long BgL_auxz00_4207;

																BgL_auxz00_4207 = (long) (BgL_arg2336z00_1814);
																BgL_modz00_1813 =
																	(BgL_offsetz00_1812 / BgL_auxz00_4207);
														}}
														{	/* Effect/cgraph.scm 53 */
															long BgL_restz00_1815;

															{	/* Effect/cgraph.scm 53 */
																int BgL_arg2335z00_1816;

																BgL_arg2335z00_1816 = (int) (((long) 8));
																{	/* Effect/cgraph.scm 53 */
																	long BgL_auxz00_4211;

																	BgL_auxz00_4211 =
																		(long) (BgL_arg2335z00_1816);
																	BgL_restz00_1815 =
																		(BgL_offsetz00_1812 % BgL_auxz00_4211);
															}}
															{	/* Effect/cgraph.scm 53 */

																BgL_method3298z00_1805 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_1810,
																		(int) (BgL_modz00_1813)),
																	(int) (BgL_restz00_1815));
								}}}}}}}}
								PROCEDURE_ENTRY(BgL_method3298z00_1805) (BgL_method3298z00_1805,
									(obj_t) (BgL_arg3404z00_1268),
									(obj_t) (BgL_ownerz00_1804), BEOA);
					}}}
					{	/* Effect/cgraph.scm 54 */
						obj_t BgL_arg3406z00_1270;

						BgL_arg3406z00_1270 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1263))->BgL_argsz00);
						BgL_auxz00_4195 =
							BGl_callzd2graphza2z12z62zzeffect_cgraphz00(BgL_arg3406z00_1270,
							BgL_ownerz00_1264);
					}
					return BBOOL(BgL_auxz00_4195);
				}
			}
		}
	}



/* call-graph!-sequence3264 */
	obj_t BGl_callzd2graphz12zd2sequence3264z12zzeffect_cgraphz00(obj_t
		BgL_envz00_2843, obj_t BgL_nodez00_2844, obj_t BgL_ownerz00_2845)
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 43 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1256;

				obj_t BgL_ownerz00_1257;

				{	/* Effect/cgraph.scm 44 */
					bool_t BgL_auxz00_4226;

					BgL_nodez00_1256 = (BgL_sequencez00_bglt) (BgL_nodez00_2844);
					BgL_ownerz00_1257 = BgL_ownerz00_2845;
					{	/* Effect/cgraph.scm 44 */
						obj_t BgL_arg3402z00_1799;

						BgL_arg3402z00_1799 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1256))->BgL_nodesz00);
						BgL_auxz00_4226 =
							BGl_callzd2graphza2z12z62zzeffect_cgraphz00(BgL_arg3402z00_1799,
							BgL_ownerz00_1257);
					}
					return BBOOL(BgL_auxz00_4226);
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzeffect_cgraphz00()
	{
		AN_OBJECT;
		{	/* Effect/cgraph.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3632z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3632z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3632z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3632z00zzeffect_cgraphz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3632z00zzeffect_cgraphz00));
			return
				BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3632z00zzeffect_cgraphz00));
		}
	}

#ifdef __cplusplus
}
#endif
