/*===========================================================================*/
/*   (Inline/inline.scm)                                                     */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Inline/inline.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_isfunz00_bgl
	{
		struct BgL_nodez00_bgl *BgL_originalzd2bodyzd2;
		obj_t BgL_recursivezd2callszd2;
	}               *BgL_isfunz00_bglt;


	BGL_IMPORT obj_t
		BGl_findzd2superzd2classzd2methodzd2zz__objectz00(BgL_objectz00_bglt, obj_t,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2letzd2var3208zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_isfunz00_bglt
		BGl_makezd2isfunzd2zzinline_inlinez00(long, obj_t, obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, BgL_nodez00_bglt, obj_t);
	static obj_t BGl__makezd2isfun3495zd2zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_objectzd2ze3structz31zz__objectz00(BgL_objectz00_bglt);
	BGL_EXPORTED_DECL BgL_isfunz00_bglt BGl_isfunzd2nilzd2zzinline_inlinez00();
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl__isfunzf3zf3zzinline_inlinez00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, bool_t,
		obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_nodezd2nilzd2zzast_nodez00();
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzinline_inlinez00();
	static obj_t BGl__fillzd2isfunz123496zc0zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_sfunz00_bglt
		BGl_z52allocatezd2isfunz80zzinline_inlinez00();
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_isfunz00_bglt
		BGl_wideningzd2isfunzd2zzinline_inlinez00(BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzinline_inlinez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_alphatiza7eza7(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzinline_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_toplevelzd2initzd2zzinline_inlinez00();
	static obj_t BGl_inlinezd2nodezd2cast3196z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT long bgl_list_length(obj_t);
	BGL_EXPORTED_DECL bool_t BGl_isfunzf3zf3zzinline_inlinez00(obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl__isfunzd2nilzd2zzinline_inlinez00(obj_t);
	static obj_t BGl__inlinezd2nodezd2default3177z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_inlinezd2nodezd2setzd2exzd2i3210z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	static obj_t BGl_inlinezd2nodezd2sequence3186z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_alphatiza7eza7zzast_alphatiza7eza7(obj_t, obj_t,
		obj_t, BgL_nodez00_bglt);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_objectzd2ze3structzd2isfun3220ze3zzinline_inlinez00(obj_t,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2setq3198z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_inlinezd2nodezd2default3177z00zzinline_inlinez00(BgL_nodez00_bglt, long,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2boxzd2setz123218zc0zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2extern3194z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_sfunz00_bglt BGl_makezd2sfunzd2zzast_varz00(long, obj_t, obj_t,
		obj_t, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2appzd2ly3190zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_inlinezd2nodezd2zzinline_inlinez00(BgL_nodez00_bglt, long, obj_t);
	static obj_t BGl_inlinezd2nodezd2conditio3200z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzinline_inlinez00();
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl__inlinezd2sfunz123493zc0zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2app3188z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2funcall3192z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT long BGl_classzd2numzd2zz__objectz00(obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_za2nonzd2inlinedzd2callsza2z00zzinline_walkz00;
	static obj_t BGl__inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzinline_inlinez00 = BUNSPEC;
	static obj_t BGl_inlinezd2nodezd2jumpzd2exzd23212z00zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzinline_inlinez00();
	BGL_EXPORTED_DECL BgL_isfunz00_bglt
		BGl_fillzd2isfunz12zc0zzinline_inlinez00(BgL_isfunz00_bglt,
		BgL_nodez00_bglt, obj_t);
	static obj_t BGl__wideningzd2isfunzd2zzinline_inlinez00(obj_t, obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_inlinezd2nodezd2fail3202z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_importedzd2moduleszd2initz00zzinline_inlinez00();
	static obj_t BGl__inlinezd2node3494zd2zzinline_inlinez00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t make_struct(obj_t, int, obj_t);
	static obj_t BGl_inlinezd2nodezd2makezd2box3214zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_inlinezd2sfunz12zc0zzinline_inlinez00(BgL_variablez00_bglt, long,
		obj_t);
	static obj_t BGl_inlinezd2nodezd2select3204z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2boxzd2ref3216zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	extern BgL_nodez00_bglt BGl_inlinezd2appzd2zzinline_appz00(BgL_appz00_bglt,
		long, obj_t);
	static obj_t BGl__z52allocatezd2isfunz80zzinline_inlinez00(obj_t);
	static obj_t BGl_inlinezd2nodezd2var3182z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	BGL_IMPORT BgL_objectz00_bglt
		BGl_structzb2objectzd2ze3objectz83zz__objectz00(BgL_objectz00_bglt, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl_inlinezd2nodezd2kwote3184z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	extern obj_t BGl_za2kfactorza2z00zzinline_walkz00;
	static obj_t BGl_structzb2objectzd2ze3objec3222z83zzinline_inlinez00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_inlinezd2appzf3z21zzinline_appz00(BgL_variablez00_bglt,
		long, long, obj_t);
	BGL_EXPORTED_DEF obj_t BGl_isfunz00zzinline_inlinez00 = BUNSPEC;
	static obj_t BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 = BUNSPEC;
	static obj_t BGl_objectzd2initzd2zzinline_inlinez00();
	static obj_t BGl__sfunzf3zf3zzinline_inlinez00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzinline_inlinez00();
	static obj_t BGl_inlinezd2nodezd2letzd2fun3206zd2zzinline_inlinez00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_inlinezd2nodezd2atom3180z00zzinline_inlinez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t __cnst[5];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_isfunzf3zd2envz21zzinline_inlinez00,
		BgL_bgl__isfunza7f3za7f3za7za7in3529z00, BGl__isfunzf3zf3zzinline_inlinez00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_sfunzf3zd2envz21zzinline_inlinez00,
		BgL_bgl__sfunza7f3za7f3za7za7inl3530z00, BGl__sfunzf3zf3zzinline_inlinez00,
		0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
		BgL_bgl__inlineza7d2node343531za7,
		BGl__inlinezd2node3494zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_inlinezd2nodeza2z12zd2envzb0zzinline_inlinez00,
		BgL_bgl__inlineza7d2nodeza7a3532z00,
		BGl__inlinezd2nodeza2z12z62zzinline_inlinez00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_inlinezd2sfunz12zd2envz12zzinline_inlinez00,
		BgL_bgl__inlineza7d2sfunza713533z00,
		BGl__inlinezd2sfunz123493zc0zzinline_inlinez00, 0L, BUNSPEC, 3);
	BGL_IMPORT obj_t BGl_objectzd2ze3structzd2envze3zz__objectz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_wideningzd2isfunzd2envz00zzinline_inlinez00,
		BgL_bgl__wideningza7d2isfu3534za7,
		BGl__wideningzd2isfunzd2zzinline_inlinez00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_z52allocatezd2isfunzd2envz52zzinline_inlinez00,
		BgL_bgl__za752allocateza7d2i3535z00,
		BGl__z52allocatezd2isfunz80zzinline_inlinez00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_isfunzd2nilzd2envz00zzinline_inlinez00,
		BgL_bgl__isfunza7d2nilza7d2za73536za7,
		BGl__isfunzd2nilzd2zzinline_inlinez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_fillzd2isfunz12zd2envz12zzinline_inlinez00,
		BgL_bgl__fillza7d2isfunza7123537z00,
		BGl__fillzd2isfunz123496zc0zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_makezd2isfunzd2envz00zzinline_inlinez00,
		BgL_bgl__makeza7d2isfun3493538za7,
		BGl__makezd2isfun3495zd2zzinline_inlinez00, 0L, BUNSPEC, 19);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_inlinezd2nodezd2default3177zd2envzd2zzinline_inlinez00,
		BgL_bgl__inlineza7d2nodeza7d3539z00,
		BGl__inlinezd2nodezd2default3177z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3501z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23540z00,
		BGl_inlinezd2nodezd2atom3180z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3502z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23541z00,
		BGl_inlinezd2nodezd2var3182z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3503z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23542z00,
		BGl_inlinezd2nodezd2kwote3184z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3504z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23543z00,
		BGl_inlinezd2nodezd2sequence3186z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3505z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23544z00,
		BGl_inlinezd2nodezd2app3188z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3506z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23545z00,
		BGl_inlinezd2nodezd2appzd2ly3190zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3507z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23546z00,
		BGl_inlinezd2nodezd2funcall3192z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3508z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23547z00,
		BGl_inlinezd2nodezd2extern3194z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3510z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23548z00,
		BGl_inlinezd2nodezd2setq3198z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3509z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23549z00,
		BGl_inlinezd2nodezd2cast3196z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3511z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23550z00,
		BGl_inlinezd2nodezd2conditio3200z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3512z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23551z00,
		BGl_inlinezd2nodezd2fail3202z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3513z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23552z00,
		BGl_inlinezd2nodezd2select3204z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3514z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23553z00,
		BGl_inlinezd2nodezd2letzd2fun3206zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3515z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23554z00,
		BGl_inlinezd2nodezd2letzd2var3208zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3516z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23555z00,
		BGl_inlinezd2nodezd2setzd2exzd2i3210z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3517z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23556z00,
		BGl_inlinezd2nodezd2jumpzd2exzd23212z00zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3518z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23557z00,
		BGl_inlinezd2nodezd2makezd2box3214zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3520z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23558z00,
		BGl_inlinezd2nodezd2boxzd2setz123218zc0zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3519z00zzinline_inlinez00,
		BgL_bgl_inlineza7d2nodeza7d23559z00,
		BGl_inlinezd2nodezd2boxzd2ref3216zd2zzinline_inlinez00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3521z00zzinline_inlinez00,
		BgL_bgl_objectza7d2za7e3stru3560z00,
		BGl_objectzd2ze3structzd2isfun3220ze3zzinline_inlinez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3522z00zzinline_inlinez00,
		BgL_bgl_structza7b2objectza73561z00,
		BGl_structzb2objectzd2ze3objec3222z83zzinline_inlinez00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3500z00zzinline_inlinez00,
		BgL_bgl_string3500za700za7za7i3562za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string3523z00zzinline_inlinez00,
		BgL_bgl_string3523za700za7za7i3563za7, "inline_inline", 13);
	      DEFINE_STRING(BGl_string3524z00zzinline_inlinez00,
		BgL_bgl_string3524za700za7za7i3564za7,
		"read static inline-node-default3177 isfun done ", 47);
	BGL_IMPORT obj_t BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00;



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzinline_inlinez00(long
		BgL_checksumz00_2718, char *BgL_fromz00_2719)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzinline_inlinez00))
				{
					BGl_requirezd2initializa7ationz75zzinline_inlinez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzinline_inlinez00();
					BGl_cnstzd2initzd2zzinline_inlinez00();
					BGl_importedzd2moduleszd2initz00zzinline_inlinez00();
					BGl_objectzd2initzd2zzinline_inlinez00();
					BGl_genericzd2initzd2zzinline_inlinez00();
					BGl_methodzd2initzd2zzinline_inlinez00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"inline_inline");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"inline_inline");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "inline_inline");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"inline_inline");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			{	/* Inline/inline.scm 15 */
				obj_t BgL_cportz00_2689;

				BgL_cportz00_2689 =
					bgl_open_input_string(BGl_string3524z00zzinline_inlinez00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2690;

					BgL_iz00_2690 = ((long) 4);
				BgL_loopz00_2691:
					if ((BgL_iz00_2690 == ((long) -1)))
						{	/* Inline/inline.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Inline/inline.scm 15 */
							{	/* Inline/inline.scm 15 */
								obj_t BgL_arg3526z00_2693;

								{	/* Inline/inline.scm 15 */

									{	/* Inline/inline.scm 15 */
										obj_t BgL_locationz00_2695;

										BgL_locationz00_2695 = BBOOL(((bool_t) 0));
										{	/* Inline/inline.scm 15 */

											BgL_arg3526z00_2693 =
												BGl_readz00zz__readerz00(BgL_cportz00_2689,
												BgL_locationz00_2695);
										}
									}
								}
								{	/* Inline/inline.scm 15 */
									int BgL_auxz00_2739;

									BgL_auxz00_2739 = (int) (BgL_iz00_2690);
									CNST_TABLE_SET(BgL_auxz00_2739, BgL_arg3526z00_2693);
							}}
							{	/* Inline/inline.scm 15 */
								int BgL_auxz00_2696;

								BgL_auxz00_2696 = (int) ((BgL_iz00_2690 - ((long) 1)));
								{
									long BgL_iz00_2744;

									BgL_iz00_2744 = (long) (BgL_auxz00_2696);
									BgL_iz00_2690 = BgL_iz00_2744;
									goto BgL_loopz00_2691;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return BUNSPEC;
		}
	}



/* inline-sfun! */
	BGL_EXPORTED_DEF obj_t
		BGl_inlinezd2sfunz12zc0zzinline_inlinez00(BgL_variablez00_bglt
		BgL_variablez00_1, long BgL_kfactorz00_2, obj_t BgL_stackz00_3)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 34 */
			{	/* Inline/inline.scm 37 */
				BgL_valuez00_bglt BgL_sfunz00_829;

				BgL_sfunz00_829 =
					(((BgL_variablez00_bglt) CREF(BgL_variablez00_1))->BgL_valuez00);
				{	/* Inline/inline.scm 37 */
					obj_t BgL_isfunz00_830;

					if (BGl_iszd2azf3z21zz__objectz00
						(BGl_sfunzf3zd2envz21zzinline_inlinez00,
							BGl_isfunz00zzinline_inlinez00))
						{	/* Inline/inline.scm 38 */
							BgL_isfunz00_830 = (obj_t) (BgL_sfunz00_829);
						}
					else
						{	/* Inline/inline.scm 40 */
							BgL_sfunz00_bglt BgL_obj3153z00_842;

							BgL_obj3153z00_842 =
								((BgL_sfunz00_bglt) (BgL_sfunz00_bglt) (BgL_sfunz00_829));
							{	/* Inline/inline.scm 40 */
								BgL_isfunz00_bglt BgL_arg3234z00_843;

								{	/* Inline/inline.scm 40 */
									obj_t BgL_arg3235z00_844;

									{
										BgL_sfunz00_bglt BgL_auxz00_2752;

										BgL_auxz00_2752 = (BgL_sfunz00_bglt) (BgL_sfunz00_829);
										BgL_arg3235z00_844 =
											(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2752))->BgL_bodyz00);
									}
									{	/* Inline/inline.scm 40 */
										BgL_isfunz00_bglt BgL_res3405z00_1510;

										{	/* Inline/inline.scm 40 */
											BgL_nodez00_bglt BgL_originalzd2body3060zd2_1501;

											BgL_originalzd2body3060zd2_1501 =
												(BgL_nodez00_bglt) (BgL_arg3235z00_844);
											{	/* Inline/inline.scm 40 */
												BgL_isfunz00_bglt BgL_new3062z00_1503;

												BgL_new3062z00_1503 =
													((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
																BgL_isfunz00_bgl))));
												{	/* Inline/inline.scm 40 */
													BgL_isfunz00_bglt BgL_res3404z00_1509;

													{	/* Inline/inline.scm 40 */
														BgL_isfunz00_bglt BgL_new3087z00_1504;

														BgL_new3087z00_1504 = BgL_new3062z00_1503;
														{	/* Inline/inline.scm 40 */
															BgL_nodez00_bglt BgL_originalzd2body3085zd2_1507;

															obj_t BgL_recursivezd2calls3086zd2_1508;

															BgL_originalzd2body3085zd2_1507 =
																BgL_originalzd2body3060zd2_1501;
															BgL_recursivezd2calls3086zd2_1508 = BUNSPEC;
															((((BgL_isfunz00_bglt)
																		CREF(BgL_new3087z00_1504))->
																	BgL_originalzd2bodyzd2) =
																((BgL_nodez00_bglt)
																	BgL_originalzd2body3085zd2_1507), BUNSPEC);
															((((BgL_isfunz00_bglt)
																		CREF(BgL_new3087z00_1504))->
																	BgL_recursivezd2callszd2) =
																((obj_t) BgL_recursivezd2calls3086zd2_1508),
																BUNSPEC);
															BgL_res3404z00_1509 = BgL_new3087z00_1504;
													}} BgL_res3404z00_1509;
												}
												BgL_res3405z00_1510 = BgL_new3062z00_1503;
										}}
										BgL_arg3234z00_843 = BgL_res3405z00_1510;
								}}
								{	/* Inline/inline.scm 40 */
									obj_t BgL_auxz00_2761;

									BgL_objectz00_bglt BgL_auxz00_2759;

									BgL_auxz00_2761 = (obj_t) (BgL_arg3234z00_843);
									BgL_auxz00_2759 = (BgL_objectz00_bglt) (BgL_obj3153z00_842);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_2759, BgL_auxz00_2761);
							}}
							BGL_OBJECT_CLASS_NUM_SET(
								(BgL_objectz00_bglt) (BgL_obj3153z00_842),
								BGl_classzd2numzd2zz__objectz00
								(BGl_isfunz00zzinline_inlinez00));
							BgL_isfunz00_830 = (obj_t) (BgL_obj3153z00_842);
						}
					{	/* Inline/inline.scm 38 */
						BgL_nodez00_bglt BgL_ozd2bodyzd2_831;

						{	/* Inline/inline.scm 41 */
							BgL_isfunz00_bglt BgL_obj3099z00_1513;

							BgL_obj3099z00_1513 = (BgL_isfunz00_bglt) (BgL_isfunz00_830);
							{
								obj_t BgL_auxz00_2769;

								{	/* Inline/inline.scm 41 */
									BgL_objectz00_bglt BgL_auxz00_2770;

									BgL_auxz00_2770 = (BgL_objectz00_bglt) (BgL_obj3099z00_1513);
									BgL_auxz00_2769 = BGL_OBJECT_WIDENING(BgL_auxz00_2770);
								}
								BgL_ozd2bodyzd2_831 =
									(((BgL_isfunz00_bglt) CREF(BgL_auxz00_2769))->
									BgL_originalzd2bodyzd2);
						}}
						{	/* Inline/inline.scm 41 */
							BgL_nodez00_bglt BgL_inlzd2bodyzd2_832;

							{	/* Inline/inline.scm 42 */
								bool_t BgL_testz00_2774;

								{	/* Inline/inline.scm 44 */
									long BgL_arg3226z00_836;

									{	/* Inline/inline.scm 44 */
										long BgL_auxz00_2775;

										{	/* Inline/inline.scm 44 */
											obj_t BgL_auxz00_2776;

											{
												BgL_sfunz00_bglt BgL_auxz00_2777;

												BgL_auxz00_2777 = (BgL_sfunz00_bglt) (BgL_sfunz00_829);
												BgL_auxz00_2776 =
													(((BgL_sfunz00_bglt) CREF(BgL_auxz00_2777))->
													BgL_argsz00);
											}
											BgL_auxz00_2775 = bgl_list_length(BgL_auxz00_2776);
										}
										BgL_arg3226z00_836 = (((long) 1) + BgL_auxz00_2775);
									}
									BgL_testz00_2774 =
										BGl_inlinezd2appzf3z21zzinline_appz00(BgL_variablez00_1,
										(long) CINT(BGl_za2kfactorza2z00zzinline_walkz00),
										BgL_arg3226z00_836, BNIL);
								}
								if (BgL_testz00_2774)
									{	/* Inline/inline.scm 42 */
										BgL_inlzd2bodyzd2_832 =
											BGl_alphatiza7eza7zzast_alphatiza7eza7(BNIL, BNIL, BFALSE,
											BgL_ozd2bodyzd2_831);
									}
								else
									{	/* Inline/inline.scm 42 */
										BgL_inlzd2bodyzd2_832 = BgL_ozd2bodyzd2_831;
									}
							}
							{	/* Inline/inline.scm 42 */

								{	/* Inline/inline.scm 55 */
									BgL_nodez00_bglt BgL_arg3223z00_833;

									{	/* Inline/inline.scm 55 */
										obj_t BgL_arg3224z00_834;

										BgL_arg3224z00_834 =
											MAKE_PAIR((obj_t) (BgL_variablez00_1), BgL_stackz00_3);
										{	/* Inline/inline.scm 53 */
											BgL_nodez00_bglt BgL_res3408z00_1545;

											{	/* Inline/inline.scm 53 */
												obj_t BgL_method3178z00_1520;

												{	/* Inline/inline.scm 53 */
													BgL_objectz00_bglt BgL_objz00_1521;

													BgL_objz00_1521 =
														(BgL_objectz00_bglt) (BgL_inlzd2bodyzd2_832);
													{	/* Inline/inline.scm 53 */
														long BgL_objzd2classzd2numz00_1522;

														BgL_objzd2classzd2numz00_1522 =
															BGL_OBJECT_CLASS_NUM(BgL_objz00_1521);
														{	/* Inline/inline.scm 53 */
															obj_t BgL_arg2334z00_1523;

															BgL_arg2334z00_1523 =
																PROCEDURE_REF
																(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
																(int) (((long) 1)));
															{	/* Inline/inline.scm 53 */
																obj_t BgL_arrayz00_1525;

																int BgL_offsetz00_1526;

																BgL_arrayz00_1525 = BgL_arg2334z00_1523;
																BgL_offsetz00_1526 =
																	(int) (BgL_objzd2classzd2numz00_1522);
																{	/* Inline/inline.scm 53 */
																	long BgL_offsetz00_1527;

																	BgL_offsetz00_1527 =
																		((long) (BgL_offsetz00_1526) - OBJECT_TYPE);
																	{	/* Inline/inline.scm 53 */
																		long BgL_modz00_1528;

																		{	/* Inline/inline.scm 53 */
																			int BgL_arg2336z00_1529;

																			BgL_arg2336z00_1529 = (int) (((long) 8));
																			{	/* Inline/inline.scm 53 */
																				long BgL_auxz00_2795;

																				BgL_auxz00_2795 =
																					(long) (BgL_arg2336z00_1529);
																				BgL_modz00_1528 =
																					(BgL_offsetz00_1527 /
																					BgL_auxz00_2795);
																		}}
																		{	/* Inline/inline.scm 53 */
																			long BgL_restz00_1530;

																			{	/* Inline/inline.scm 53 */
																				int BgL_arg2335z00_1531;

																				BgL_arg2335z00_1531 =
																					(int) (((long) 8));
																				{	/* Inline/inline.scm 53 */
																					long BgL_auxz00_2799;

																					BgL_auxz00_2799 =
																						(long) (BgL_arg2335z00_1531);
																					BgL_restz00_1530 =
																						(BgL_offsetz00_1527 %
																						BgL_auxz00_2799);
																			}}
																			{	/* Inline/inline.scm 53 */

																				BgL_method3178z00_1520 =
																					VECTOR_REF(VECTOR_REF
																					(BgL_arrayz00_1525,
																						(int) (BgL_modz00_1528)),
																					(int) (BgL_restz00_1530));
												}}}}}}}}
												BgL_res3408z00_1545 =
													(BgL_nodez00_bglt) (PROCEDURE_ENTRY
													(BgL_method3178z00_1520) (BgL_method3178z00_1520,
														(obj_t) (BgL_inlzd2bodyzd2_832),
														BINT(BgL_kfactorz00_2), BgL_arg3224z00_834, BEOA));
											}
											BgL_arg3223z00_833 = BgL_res3408z00_1545;
									}}
									{
										obj_t BgL_auxz00_2813;

										BgL_sfunz00_bglt BgL_auxz00_2811;

										BgL_auxz00_2813 = (obj_t) (BgL_arg3223z00_833);
										BgL_auxz00_2811 = (BgL_sfunz00_bglt) (BgL_sfunz00_829);
										((((BgL_sfunz00_bglt) CREF(BgL_auxz00_2811))->BgL_bodyz00) =
											((obj_t) BgL_auxz00_2813), BUNSPEC);
								}}
								return BNIL;
							}
						}
					}
				}
			}
		}
	}



/* _inline-sfun!3493 */
	obj_t BGl__inlinezd2sfunz123493zc0zzinline_inlinez00(obj_t BgL_envz00_2528,
		obj_t BgL_variablez00_2529, obj_t BgL_kfactorz00_2530,
		obj_t BgL_stackz00_2531)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 34 */
			return
				BGl_inlinezd2sfunz12zc0zzinline_inlinez00(
				(BgL_variablez00_bglt) (BgL_variablez00_2529),
				(long) CINT(BgL_kfactorz00_2530), BgL_stackz00_2531);
		}
	}



/* inline-node*! */
	BGL_EXPORTED_DEF obj_t BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t
		BgL_nodeza2za2_70, obj_t BgL_kfactorz00_71, obj_t BgL_stackz00_72)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 238 */
		BGl_inlinezd2nodeza2z12z62zzinline_inlinez00:
			if (NULLP(BgL_nodeza2za2_70))
				{	/* Inline/inline.scm 239 */
					return CNST_TABLE_REF(((long) 0));
				}
			else
				{	/* Inline/inline.scm 239 */
					{	/* Inline/inline.scm 242 */
						BgL_nodez00_bglt BgL_arg3238z00_847;

						{	/* Inline/inline.scm 242 */
							obj_t BgL_arg3239z00_848;

							BgL_arg3239z00_848 = CAR(BgL_nodeza2za2_70);
							{	/* Inline/inline.scm 242 */
								BgL_nodez00_bglt BgL_res3411z00_1578;

								{	/* Inline/inline.scm 242 */
									BgL_nodez00_bglt BgL_nodez00_1550;

									long BgL_kfactorz00_1551;

									BgL_nodez00_1550 = (BgL_nodez00_bglt) (BgL_arg3239z00_848);
									BgL_kfactorz00_1551 = (long) CINT(BgL_kfactorz00_71);
									{	/* Inline/inline.scm 242 */
										obj_t BgL_method3178z00_1553;

										{	/* Inline/inline.scm 242 */
											BgL_objectz00_bglt BgL_objz00_1554;

											BgL_objz00_1554 = (BgL_objectz00_bglt) (BgL_nodez00_1550);
											{	/* Inline/inline.scm 242 */
												long BgL_objzd2classzd2numz00_1555;

												BgL_objzd2classzd2numz00_1555 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1554);
												{	/* Inline/inline.scm 242 */
													obj_t BgL_arg2334z00_1556;

													BgL_arg2334z00_1556 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 242 */
														obj_t BgL_arrayz00_1558;

														int BgL_offsetz00_1559;

														BgL_arrayz00_1558 = BgL_arg2334z00_1556;
														BgL_offsetz00_1559 =
															(int) (BgL_objzd2classzd2numz00_1555);
														{	/* Inline/inline.scm 242 */
															long BgL_offsetz00_1560;

															BgL_offsetz00_1560 =
																((long) (BgL_offsetz00_1559) - OBJECT_TYPE);
															{	/* Inline/inline.scm 242 */
																long BgL_modz00_1561;

																{	/* Inline/inline.scm 242 */
																	int BgL_arg2336z00_1562;

																	BgL_arg2336z00_1562 = (int) (((long) 8));
																	{	/* Inline/inline.scm 242 */
																		long BgL_auxz00_2833;

																		BgL_auxz00_2833 =
																			(long) (BgL_arg2336z00_1562);
																		BgL_modz00_1561 =
																			(BgL_offsetz00_1560 / BgL_auxz00_2833);
																}}
																{	/* Inline/inline.scm 242 */
																	long BgL_restz00_1563;

																	{	/* Inline/inline.scm 242 */
																		int BgL_arg2335z00_1564;

																		BgL_arg2335z00_1564 = (int) (((long) 8));
																		{	/* Inline/inline.scm 242 */
																			long BgL_auxz00_2837;

																			BgL_auxz00_2837 =
																				(long) (BgL_arg2335z00_1564);
																			BgL_restz00_1563 =
																				(BgL_offsetz00_1560 % BgL_auxz00_2837);
																	}}
																	{	/* Inline/inline.scm 242 */

																		BgL_method3178z00_1553 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1558,
																				(int) (BgL_modz00_1561)),
																			(int) (BgL_restz00_1563));
										}}}}}}}}
										BgL_res3411z00_1578 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_1553) (BgL_method3178z00_1553,
												(obj_t) (BgL_nodez00_1550), BINT(BgL_kfactorz00_1551),
												BgL_stackz00_72, BEOA));
								}}
								BgL_arg3238z00_847 = BgL_res3411z00_1578;
						}}
						{	/* Inline/inline.scm 242 */
							obj_t BgL_auxz00_2849;

							BgL_auxz00_2849 = (obj_t) (BgL_arg3238z00_847);
							SET_CAR(BgL_nodeza2za2_70, BgL_auxz00_2849);
					}}
					{
						obj_t BgL_nodeza2za2_2852;

						BgL_nodeza2za2_2852 = CDR(BgL_nodeza2za2_70);
						BgL_nodeza2za2_70 = BgL_nodeza2za2_2852;
						goto BGl_inlinezd2nodeza2z12z62zzinline_inlinez00;
					}
				}
		}
	}



/* _inline-node*! */
	obj_t BGl__inlinezd2nodeza2z12z62zzinline_inlinez00(obj_t BgL_envz00_2538,
		obj_t BgL_nodeza2za2_2539, obj_t BgL_kfactorz00_2540,
		obj_t BgL_stackz00_2541)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 238 */
			return
				BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_nodeza2za2_2539,
				BgL_kfactorz00_2540, BgL_stackz00_2541);
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			{	/* Inline/inline.scm 25 */
				obj_t BgL_arg3241z00_850;

				obj_t BgL_arg3242z00_851;

				obj_t BgL_arg3245z00_854;

				BgL_arg3241z00_850 = CNST_TABLE_REF(((long) 1));
				BgL_arg3242z00_851 = BGl_sfunz00zzast_varz00;
				{	/* Inline/inline.scm 25 */
					obj_t BgL_v3176z00_855;

					BgL_v3176z00_855 = create_vector((int) (((long) 0)));
					BgL_arg3245z00_854 = BgL_v3176z00_855;
				}
				BGl_isfunz00zzinline_inlinez00 =
					BGl_registerzd2classz12zc0zz__objectz00(BgL_arg3241z00_850,
					BgL_arg3242z00_851, ((bool_t) 0), BFALSE,
					BGl_z52allocatezd2isfunzd2envz52zzinline_inlinez00,
					BGl_isfunzd2nilzd2envz00zzinline_inlinez00,
					BGl_isfunzf3zd2envz21zzinline_inlinez00, ((long) 461696808), BFALSE,
					BFALSE, BgL_arg3245z00_854);
			}
			return (BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 = BUNSPEC, BUNSPEC);
		}
	}



/* isfun? */
	BGL_EXPORTED_DEF bool_t BGl_isfunzf3zf3zzinline_inlinez00(obj_t
		BgL_obj3098z00_73)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				BGl_iszd2azf3z21zz__objectz00(BgL_obj3098z00_73,
				BGl_isfunz00zzinline_inlinez00);
		}
	}



/* _isfun? */
	obj_t BGl__isfunzf3zf3zzinline_inlinez00(obj_t BgL_envz00_2544,
		obj_t BgL_obj3098z00_2545)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj3098z00_2545,
					BGl_isfunz00zzinline_inlinez00));
		}
	}



/* widening-isfun */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt
		BGl_wideningzd2isfunzd2zzinline_inlinez00(BgL_nodez00_bglt
		BgL_originalzd2body3060zd2_77, obj_t BgL_recursivezd2calls3061zd2_78)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_isfunz00_bglt BgL_new3062z00_1582;

				BgL_new3062z00_1582 =
					((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
								BgL_isfunz00_bgl))));
				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_res3412z00_1588;

					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_new3087z00_1583;

						BgL_new3087z00_1583 = BgL_new3062z00_1582;
						{	/* Inline/inline.scm 25 */
							BgL_nodez00_bglt BgL_originalzd2body3085zd2_1586;

							obj_t BgL_recursivezd2calls3086zd2_1587;

							BgL_originalzd2body3085zd2_1586 = BgL_originalzd2body3060zd2_77;
							BgL_recursivezd2calls3086zd2_1587 =
								BgL_recursivezd2calls3061zd2_78;
							((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_1583))->
									BgL_originalzd2bodyzd2) =
								((BgL_nodez00_bglt) BgL_originalzd2body3085zd2_1586), BUNSPEC);
							((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_1583))->
									BgL_recursivezd2callszd2) =
								((obj_t) BgL_recursivezd2calls3086zd2_1587), BUNSPEC);
							BgL_res3412z00_1588 = BgL_new3087z00_1583;
					}} BgL_res3412z00_1588;
				}
				return BgL_new3062z00_1582;
			}
		}
	}



/* _widening-isfun */
	obj_t BGl__wideningzd2isfunzd2zzinline_inlinez00(obj_t BgL_envz00_2546,
		obj_t BgL_originalzd2body3060zd2_2547,
		obj_t BgL_recursivezd2calls3061zd2_2548)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				(obj_t) (BGl_wideningzd2isfunzd2zzinline_inlinez00(
					(BgL_nodez00_bglt) (BgL_originalzd2body3060zd2_2547),
					BgL_recursivezd2calls3061zd2_2548));
		}
	}



/* make-isfun */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt BGl_makezd2isfunzd2zzinline_inlinez00(long
		BgL_arity3066z00_79, obj_t BgL_sidezd2effectzf33067z21_80,
		obj_t BgL_predicatezd2of3068zd2_81, obj_t BgL_stackzd2allocator3069zd2_82,
		bool_t BgL_topzf33070zf3_83, obj_t BgL_thezd2closure3071zd2_84,
		obj_t BgL_effect3072z00_85, obj_t BgL_property3073z00_86,
		obj_t BgL_args3074z00_87, obj_t BgL_argszd2name3075zd2_88,
		obj_t BgL_body3076z00_89, obj_t BgL_class3077z00_90,
		obj_t BgL_dssslzd2keywords3078zd2_91, obj_t BgL_loc3079z00_92,
		obj_t BgL_optionals3080z00_93, obj_t BgL_keys3081z00_94,
		obj_t BgL_thezd2closurezd2global3082z00_95,
		BgL_nodez00_bglt BgL_originalzd2body3064zd2_96,
		obj_t BgL_recursivezd2calls3065zd2_97)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_sfunz00_bglt BgL_aux3083z00_1589;

				BgL_aux3083z00_1589 =
					BGl_makezd2sfunzd2zzast_varz00(BgL_arity3066z00_79,
					BgL_sidezd2effectzf33067z21_80, BgL_predicatezd2of3068zd2_81,
					BgL_stackzd2allocator3069zd2_82, BgL_topzf33070zf3_83,
					BgL_thezd2closure3071zd2_84, BgL_effect3072z00_85,
					BgL_property3073z00_86, BgL_args3074z00_87, BgL_argszd2name3075zd2_88,
					BgL_body3076z00_89, BgL_class3077z00_90,
					BgL_dssslzd2keywords3078zd2_91, BgL_loc3079z00_92,
					BgL_optionals3080z00_93, BgL_keys3081z00_94,
					BgL_thezd2closurezd2global3082z00_95);
				BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_aux3083z00_1589),
					BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00));
				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_arg3247z00_1591;

					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_res3414z00_1604;

						{	/* Inline/inline.scm 25 */
							BgL_isfunz00_bglt BgL_new3062z00_1597;

							BgL_new3062z00_1597 =
								((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_isfunz00_bgl))));
							{	/* Inline/inline.scm 25 */
								BgL_isfunz00_bglt BgL_res3413z00_1603;

								{	/* Inline/inline.scm 25 */
									BgL_isfunz00_bglt BgL_new3087z00_1598;

									BgL_new3087z00_1598 = BgL_new3062z00_1597;
									{	/* Inline/inline.scm 25 */
										BgL_nodez00_bglt BgL_originalzd2body3085zd2_1601;

										obj_t BgL_recursivezd2calls3086zd2_1602;

										BgL_originalzd2body3085zd2_1601 =
											BgL_originalzd2body3064zd2_96;
										BgL_recursivezd2calls3086zd2_1602 =
											BgL_recursivezd2calls3065zd2_97;
										((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_1598))->
												BgL_originalzd2bodyzd2) =
											((BgL_nodez00_bglt) BgL_originalzd2body3085zd2_1601),
											BUNSPEC);
										((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_1598))->
												BgL_recursivezd2callszd2) =
											((obj_t) BgL_recursivezd2calls3086zd2_1602), BUNSPEC);
										BgL_res3413z00_1603 = BgL_new3087z00_1598;
								}} BgL_res3413z00_1603;
							}
							BgL_res3414z00_1604 = BgL_new3062z00_1597;
						}
						BgL_arg3247z00_1591 = BgL_res3414z00_1604;
					}
					{	/* Inline/inline.scm 25 */
						obj_t BgL_auxz00_2877;

						BgL_objectz00_bglt BgL_auxz00_2875;

						BgL_auxz00_2877 = (obj_t) (BgL_arg3247z00_1591);
						BgL_auxz00_2875 = (BgL_objectz00_bglt) (BgL_aux3083z00_1589);
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_2875, BgL_auxz00_2877);
				}}
				return ((BgL_isfunz00_bglt) (BgL_isfunz00_bglt) (BgL_aux3083z00_1589));
			}
		}
	}



/* _make-isfun3495 */
	obj_t BGl__makezd2isfun3495zd2zzinline_inlinez00(obj_t BgL_envz00_2549,
		obj_t BgL_arity3066z00_2550, obj_t BgL_sidezd2effectzf33067z21_2551,
		obj_t BgL_predicatezd2of3068zd2_2552,
		obj_t BgL_stackzd2allocator3069zd2_2553, obj_t BgL_topzf33070zf3_2554,
		obj_t BgL_thezd2closure3071zd2_2555, obj_t BgL_effect3072z00_2556,
		obj_t BgL_property3073z00_2557, obj_t BgL_args3074z00_2558,
		obj_t BgL_argszd2name3075zd2_2559, obj_t BgL_body3076z00_2560,
		obj_t BgL_class3077z00_2561, obj_t BgL_dssslzd2keywords3078zd2_2562,
		obj_t BgL_loc3079z00_2563, obj_t BgL_optionals3080z00_2564,
		obj_t BgL_keys3081z00_2565, obj_t BgL_thezd2closurezd2global3082z00_2566,
		obj_t BgL_originalzd2body3064zd2_2567,
		obj_t BgL_recursivezd2calls3065zd2_2568)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return
				(obj_t) (BGl_makezd2isfunzd2zzinline_inlinez00(
					(long) CINT(BgL_arity3066z00_2550), BgL_sidezd2effectzf33067z21_2551,
					BgL_predicatezd2of3068zd2_2552, BgL_stackzd2allocator3069zd2_2553,
					CBOOL(BgL_topzf33070zf3_2554), BgL_thezd2closure3071zd2_2555,
					BgL_effect3072z00_2556, BgL_property3073z00_2557,
					BgL_args3074z00_2558, BgL_argszd2name3075zd2_2559,
					BgL_body3076z00_2560, BgL_class3077z00_2561,
					BgL_dssslzd2keywords3078zd2_2562, BgL_loc3079z00_2563,
					BgL_optionals3080z00_2564, BgL_keys3081z00_2565,
					BgL_thezd2closurezd2global3082z00_2566,
					(BgL_nodez00_bglt) (BgL_originalzd2body3064zd2_2567),
					BgL_recursivezd2calls3065zd2_2568));
		}
	}



/* fill-isfun! */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt
		BGl_fillzd2isfunz12zc0zzinline_inlinez00(BgL_isfunz00_bglt
		BgL_new3087z00_98, BgL_nodez00_bglt BgL_originalzd2body3085zd2_99,
		obj_t BgL_recursivezd2calls3086zd2_100)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_nodez00_bglt BgL_originalzd2body3085zd2_2698;

				obj_t BgL_recursivezd2calls3086zd2_2699;

				BgL_originalzd2body3085zd2_2698 = BgL_originalzd2body3085zd2_99;
				BgL_recursivezd2calls3086zd2_2699 = BgL_recursivezd2calls3086zd2_100;
				((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_98))->
						BgL_originalzd2bodyzd2) =
					((BgL_nodez00_bglt) BgL_originalzd2body3085zd2_2698), BUNSPEC);
				((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_98))->
						BgL_recursivezd2callszd2) =
					((obj_t) BgL_recursivezd2calls3086zd2_2699), BUNSPEC);
				return BgL_new3087z00_98;
			}
		}
	}



/* _fill-isfun!3496 */
	obj_t BGl__fillzd2isfunz123496zc0zzinline_inlinez00(obj_t BgL_envz00_2569,
		obj_t BgL_new3087z00_2570, obj_t BgL_originalzd2body3085zd2_2571,
		obj_t BgL_recursivezd2calls3086zd2_2572)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_isfunz00_bglt BgL_auxz00_2889;

				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_res3527z00_2705;

					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_new3087z00_2700;

						BgL_nodez00_bglt BgL_originalzd2body3085zd2_2701;

						BgL_new3087z00_2700 = (BgL_isfunz00_bglt) (BgL_new3087z00_2570);
						BgL_originalzd2body3085zd2_2701 =
							(BgL_nodez00_bglt) (BgL_originalzd2body3085zd2_2571);
						{	/* Inline/inline.scm 25 */
							BgL_nodez00_bglt BgL_originalzd2body3085zd2_2703;

							obj_t BgL_recursivezd2calls3086zd2_2704;

							BgL_originalzd2body3085zd2_2703 = BgL_originalzd2body3085zd2_2701;
							BgL_recursivezd2calls3086zd2_2704 =
								BgL_recursivezd2calls3086zd2_2572;
							((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_2700))->
									BgL_originalzd2bodyzd2) =
								((BgL_nodez00_bglt) BgL_originalzd2body3085zd2_2703), BUNSPEC);
							((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_2700))->
									BgL_recursivezd2callszd2) =
								((obj_t) BgL_recursivezd2calls3086zd2_2704), BUNSPEC);
							BgL_res3527z00_2705 = BgL_new3087z00_2700;
						}
					}
					BgL_auxz00_2889 = BgL_res3527z00_2705;
				}
				return (obj_t) (BgL_auxz00_2889);
			}
		}
	}



/* %allocate-isfun */
	BGL_EXPORTED_DEF BgL_sfunz00_bglt
		BGl_z52allocatezd2isfunz80zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_sfunz00_bglt BgL_new3091z00_2706;

				BgL_new3091z00_2706 =
					((BgL_sfunz00_bglt) BREF(GC_MALLOC(sizeof(struct BgL_sfunz00_bgl))));
				BGL_OBJECT_CLASS_NUM_SET(
					(BgL_objectz00_bglt) (BgL_new3091z00_2706),
					BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00));
				{	/* Inline/inline.scm 25 */
					BgL_objectz00_bglt BgL_auxz00_2899;

					BgL_auxz00_2899 = (BgL_objectz00_bglt) (BgL_new3091z00_2706);
					BGL_OBJECT_WIDENING_SET(BgL_auxz00_2899, BFALSE);
				}
				return BgL_new3091z00_2706;
			}
		}
	}



/* _%allocate-isfun */
	obj_t BGl__z52allocatezd2isfunz80zzinline_inlinez00(obj_t BgL_envz00_2542)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{	/* Inline/inline.scm 25 */
				BgL_sfunz00_bglt BgL_auxz00_2902;

				{	/* Inline/inline.scm 25 */
					BgL_sfunz00_bglt BgL_res3528z00_2710;

					{	/* Inline/inline.scm 25 */
						BgL_sfunz00_bglt BgL_new3091z00_2708;

						BgL_new3091z00_2708 =
							((BgL_sfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_sfunz00_bgl))));
						BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt) (BgL_new3091z00_2708),
							BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00));
						{	/* Inline/inline.scm 25 */
							BgL_objectz00_bglt BgL_auxz00_2907;

							BgL_auxz00_2907 = (BgL_objectz00_bglt) (BgL_new3091z00_2708);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2907, BFALSE);
						}
						BgL_res3528z00_2710 = BgL_new3091z00_2708;
					}
					BgL_auxz00_2902 = BgL_res3528z00_2710;
				}
				return (obj_t) (BgL_auxz00_2902);
			}
		}
	}



/* isfun-nil */
	BGL_EXPORTED_DEF BgL_isfunz00_bglt BGl_isfunzd2nilzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			if ((BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 == BUNSPEC))
				{	/* Inline/inline.scm 25 */
					{	/* Inline/inline.scm 25 */
						BgL_sfunz00_bglt BgL_res3415z00_1615;

						{	/* Inline/inline.scm 25 */
							BgL_sfunz00_bglt BgL_new1771z00_1611;

							BgL_new1771z00_1611 =
								((BgL_sfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
											BgL_sfunz00_bgl))));
							BGL_OBJECT_CLASS_NUM_SET((BgL_objectz00_bglt)
								(BgL_new1771z00_1611),
								BGl_classzd2numzd2zz__objectz00(BGl_sfunz00zzast_varz00));
							{	/* Inline/inline.scm 25 */
								BgL_objectz00_bglt BgL_auxz00_2917;

								BgL_auxz00_2917 = (BgL_objectz00_bglt) (BgL_new1771z00_1611);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2917, BFALSE);
							}
							BgL_res3415z00_1615 = BgL_new1771z00_1611;
						}
						BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00 =
							(obj_t) (BgL_res3415z00_1615);
					}
					{	/* Inline/inline.scm 25 */
						BgL_sfunz00_bglt BgL_res3416z00_1651;

						{	/* Inline/inline.scm 25 */
							BgL_sfunz00_bglt BgL_new1752z00_1616;

							BgL_new1752z00_1616 =
								(BgL_sfunz00_bglt)
								(BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00);
							{	/* Inline/inline.scm 25 */
								long BgL_arity1735z00_1634;

								obj_t BgL_sidezd2effectzf31736z21_1635;

								obj_t BgL_predicatezd2of1737zd2_1636;

								obj_t BgL_stackzd2allocator1738zd2_1637;

								bool_t BgL_topzf31739zf3_1638;

								obj_t BgL_thezd2closure1740zd2_1639;

								obj_t BgL_effect1741z00_1640;

								obj_t BgL_property1742z00_1641;

								obj_t BgL_args1743z00_1642;

								obj_t BgL_argszd2name1744zd2_1643;

								obj_t BgL_body1745z00_1644;

								obj_t BgL_class1746z00_1645;

								obj_t BgL_dssslzd2keywords1747zd2_1646;

								obj_t BgL_loc1748z00_1647;

								obj_t BgL_optionals1749z00_1648;

								obj_t BgL_keys1750z00_1649;

								obj_t BgL_thezd2closurezd2global1751z00_1650;

								BgL_arity1735z00_1634 = ((long) 0);
								BgL_sidezd2effectzf31736z21_1635 = BUNSPEC;
								BgL_predicatezd2of1737zd2_1636 = BUNSPEC;
								BgL_stackzd2allocator1738zd2_1637 = BUNSPEC;
								BgL_topzf31739zf3_1638 = ((bool_t) 0);
								BgL_thezd2closure1740zd2_1639 = BUNSPEC;
								BgL_effect1741z00_1640 = BUNSPEC;
								BgL_property1742z00_1641 = BUNSPEC;
								BgL_args1743z00_1642 = BUNSPEC;
								BgL_argszd2name1744zd2_1643 = BUNSPEC;
								BgL_body1745z00_1644 = BUNSPEC;
								BgL_class1746z00_1645 = BUNSPEC;
								BgL_dssslzd2keywords1747zd2_1646 = BUNSPEC;
								BgL_loc1748z00_1647 = BUNSPEC;
								BgL_optionals1749z00_1648 = BUNSPEC;
								BgL_keys1750z00_1649 = BUNSPEC;
								BgL_thezd2closurezd2global1751z00_1650 = BUNSPEC;
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_arityz00) = ((long) BgL_arity1735z00_1634), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_sidezd2effectzf3z21) =
									((obj_t) BgL_sidezd2effectzf31736z21_1635), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_predicatezd2ofzd2) =
									((obj_t) BgL_predicatezd2of1737zd2_1636), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_stackzd2allocatorzd2) =
									((obj_t) BgL_stackzd2allocator1738zd2_1637), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_topzf3zf3) =
									((bool_t) BgL_topzf31739zf3_1638), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_thezd2closurezd2) =
									((obj_t) BgL_thezd2closure1740zd2_1639), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_effectz00) = ((obj_t) BgL_effect1741z00_1640), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_propertyz00) =
									((obj_t) BgL_property1742z00_1641), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->BgL_argsz00) =
									((obj_t) BgL_args1743z00_1642), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_argszd2namezd2) =
									((obj_t) BgL_argszd2name1744zd2_1643), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->BgL_bodyz00) =
									((obj_t) BgL_body1745z00_1644), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_classz00) = ((obj_t) BgL_class1746z00_1645), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_dssslzd2keywordszd2) =
									((obj_t) BgL_dssslzd2keywords1747zd2_1646), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->BgL_locz00) =
									((obj_t) BgL_loc1748z00_1647), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_optionalsz00) =
									((obj_t) BgL_optionals1749z00_1648), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->BgL_keysz00) =
									((obj_t) BgL_keys1750z00_1649), BUNSPEC);
								((((BgL_sfunz00_bglt) CREF(BgL_new1752z00_1616))->
										BgL_thezd2closurezd2globalz00) =
									((obj_t) BgL_thezd2closurezd2global1751z00_1650), BUNSPEC);
								BgL_res3416z00_1651 = BgL_new1752z00_1616;
						}} BgL_res3416z00_1651;
					}
					{	/* Inline/inline.scm 25 */
						long BgL_arg3250z00_866;

						BgL_arg3250z00_866 =
							BGl_classzd2numzd2zz__objectz00(BGl_isfunz00zzinline_inlinez00);
						BGL_OBJECT_CLASS_NUM_SET(
							(BgL_objectz00_bglt)
							(BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00),
							BgL_arg3250z00_866);
					}
					{	/* Inline/inline.scm 25 */
						BgL_isfunz00_bglt BgL_arg3251z00_867;

						{	/* Inline/inline.scm 25 */
							BgL_nodez00_bglt BgL_arg3252z00_868;

							BgL_arg3252z00_868 = BGl_nodezd2nilzd2zzast_nodez00();
							{	/* Inline/inline.scm 25 */
								BgL_isfunz00_bglt BgL_res3418z00_1663;

								{	/* Inline/inline.scm 25 */
									BgL_isfunz00_bglt BgL_new3062z00_1656;

									BgL_new3062z00_1656 =
										((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_isfunz00_bgl))));
									{	/* Inline/inline.scm 25 */
										BgL_isfunz00_bglt BgL_res3417z00_1662;

										{	/* Inline/inline.scm 25 */
											BgL_isfunz00_bglt BgL_new3087z00_1657;

											BgL_new3087z00_1657 = BgL_new3062z00_1656;
											{	/* Inline/inline.scm 25 */
												BgL_nodez00_bglt BgL_originalzd2body3085zd2_1660;

												obj_t BgL_recursivezd2calls3086zd2_1661;

												BgL_originalzd2body3085zd2_1660 = BgL_arg3252z00_868;
												BgL_recursivezd2calls3086zd2_1661 = BUNSPEC;
												((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_1657))->
														BgL_originalzd2bodyzd2) =
													((BgL_nodez00_bglt) BgL_originalzd2body3085zd2_1660),
													BUNSPEC);
												((((BgL_isfunz00_bglt) CREF(BgL_new3087z00_1657))->
														BgL_recursivezd2callszd2) =
													((obj_t) BgL_recursivezd2calls3086zd2_1661), BUNSPEC);
												BgL_res3417z00_1662 = BgL_new3087z00_1657;
										}} BgL_res3417z00_1662;
									}
									BgL_res3418z00_1663 = BgL_new3062z00_1656;
								}
								BgL_arg3251z00_867 = BgL_res3418z00_1663;
						}}
						{	/* Inline/inline.scm 25 */
							obj_t BgL_auxz00_2948;

							BgL_objectz00_bglt BgL_auxz00_2946;

							BgL_auxz00_2948 = (obj_t) (BgL_arg3251z00_867);
							BgL_auxz00_2946 =
								(BgL_objectz00_bglt)
								(BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_2946, BgL_auxz00_2948);
				}}}
			else
				{	/* Inline/inline.scm 25 */
					BFALSE;
				}
			return
				(BgL_isfunz00_bglt) (BGl_z52thezd2isfunzd2nilz52zzinline_inlinez00);
		}
	}



/* _isfun-nil */
	obj_t BGl__isfunzd2nilzd2zzinline_inlinez00(obj_t BgL_envz00_2543)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			return (obj_t) (BGl_isfunzd2nilzd2zzinline_inlinez00());
		}
	}



/* _sfun? */
	obj_t BGl__sfunzf3zf3zzinline_inlinez00(obj_t BgL_envz00_2532,
		obj_t BgL_obj1772z00_2533)
	{
		AN_OBJECT;
		{	/* Ast/var.scm 94 */
			return
				BBOOL(BGl_iszd2azf3z21zz__objectz00(BgL_obj1772z00_2533,
					BGl_sfunz00zzast_varz00));
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_inlinezd2nodezd2default3177zd2envzd2zzinline_inlinez00);
		}
	}



/* inline-node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_inlinezd2nodezd2zzinline_inlinez00(BgL_nodez00_bglt BgL_nodez00_4,
		long BgL_kfactorz00_5, obj_t BgL_stackz00_6)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 62 */
			{	/* Inline/inline.scm 62 */
				obj_t BgL_method3178z00_1685;

				{	/* Inline/inline.scm 62 */
					BgL_objectz00_bglt BgL_objz00_1686;

					BgL_objz00_1686 = (BgL_objectz00_bglt) (BgL_nodez00_4);
					{	/* Inline/inline.scm 62 */
						long BgL_objzd2classzd2numz00_1687;

						BgL_objzd2classzd2numz00_1687 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_1686);
						{	/* Inline/inline.scm 62 */
							obj_t BgL_arg2334z00_1688;

							BgL_arg2334z00_1688 =
								PROCEDURE_REF(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
								(int) (((long) 1)));
							{	/* Inline/inline.scm 62 */
								obj_t BgL_arrayz00_1690;

								int BgL_offsetz00_1691;

								BgL_arrayz00_1690 = BgL_arg2334z00_1688;
								BgL_offsetz00_1691 = (int) (BgL_objzd2classzd2numz00_1687);
								{	/* Inline/inline.scm 62 */
									long BgL_offsetz00_1692;

									BgL_offsetz00_1692 =
										((long) (BgL_offsetz00_1691) - OBJECT_TYPE);
									{	/* Inline/inline.scm 62 */
										long BgL_modz00_1693;

										{	/* Inline/inline.scm 62 */
											int BgL_arg2336z00_1694;

											BgL_arg2336z00_1694 = (int) (((long) 8));
											{	/* Inline/inline.scm 62 */
												long BgL_auxz00_2965;

												BgL_auxz00_2965 = (long) (BgL_arg2336z00_1694);
												BgL_modz00_1693 =
													(BgL_offsetz00_1692 / BgL_auxz00_2965);
										}}
										{	/* Inline/inline.scm 62 */
											long BgL_restz00_1695;

											{	/* Inline/inline.scm 62 */
												int BgL_arg2335z00_1696;

												BgL_arg2335z00_1696 = (int) (((long) 8));
												{	/* Inline/inline.scm 62 */
													long BgL_auxz00_2969;

													BgL_auxz00_2969 = (long) (BgL_arg2335z00_1696);
													BgL_restz00_1695 =
														(BgL_offsetz00_1692 % BgL_auxz00_2969);
											}}
											{	/* Inline/inline.scm 62 */

												BgL_method3178z00_1685 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_1690,
														(int) (BgL_modz00_1693)), (int) (BgL_restz00_1695));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3178z00_1685)
					(BgL_method3178z00_1685, (obj_t) (BgL_nodez00_4),
						BINT(BgL_kfactorz00_5), BgL_stackz00_6, BEOA));
			}
		}
	}



/* _inline-node3494 */
	obj_t BGl__inlinezd2node3494zd2zzinline_inlinez00(obj_t BgL_envz00_2534,
		obj_t BgL_nodez00_2535, obj_t BgL_kfactorz00_2536, obj_t BgL_stackz00_2537)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 62 */
			return
				(obj_t) (BGl_inlinezd2nodezd2zzinline_inlinez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2535),
					(long) CINT(BgL_kfactorz00_2536), BgL_stackz00_2537));
		}
	}



/* inline-node-default3177 */
	BgL_nodez00_bglt
		BGl_inlinezd2nodezd2default3177z00zzinline_inlinez00(BgL_nodez00_bglt
		BgL_nodez00_7, long BgL_kfactorz00_8, obj_t BgL_stackz00_9)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return
				(BgL_nodez00_bglt) (BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 2)),
					BGl_string3500z00zzinline_inlinez00, (obj_t) (BgL_nodez00_7)));
		}
	}



/* _inline-node-default3177 */
	obj_t BGl__inlinezd2nodezd2default3177z00zzinline_inlinez00(obj_t
		BgL_envz00_2573, obj_t BgL_nodez00_2574, obj_t BgL_kfactorz00_2575,
		obj_t BgL_stackz00_2576)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			return
				(obj_t) (BGl_inlinezd2nodezd2default3177z00zzinline_inlinez00(
					(BgL_nodez00_bglt) (BgL_nodez00_2574),
					(long) CINT(BgL_kfactorz00_2575), BgL_stackz00_2576));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_atomz00zzast_nodez00,
				BGl_proc3501z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_varz00zzast_nodez00,
				BGl_proc3502z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_kwotez00zzast_nodez00, BGl_proc3503z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_sequencez00zzast_nodez00, BGl_proc3504z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_appz00zzast_nodez00,
				BGl_proc3505z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3506z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_funcallz00zzast_nodez00, BGl_proc3507z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_externz00zzast_nodez00, BGl_proc3508z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_castz00zzast_nodez00,
				BGl_proc3509z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_setqz00zzast_nodez00,
				BGl_proc3510z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3511z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00, BGl_failz00zzast_nodez00,
				BGl_proc3512z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_selectz00zzast_nodez00, BGl_proc3513z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3514z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3515z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3516z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3517z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3518z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3519z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3520z00zzinline_inlinez00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_objectzd2ze3structzd2envze3zz__objectz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc3521z00zzinline_inlinez00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
				BGl_isfunz00zzinline_inlinez00, BGl_proc3522z00zzinline_inlinez00);
		}
	}



/* struct+object->objec3222 */
	obj_t BGl_structzb2objectzd2ze3objec3222z83zzinline_inlinez00(obj_t
		BgL_envz00_2604, obj_t BgL_oz00_2605, obj_t BgL_sz00_2606)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{
				BgL_isfunz00_bglt BgL_oz00_1486;

				obj_t BgL_sz00_1487;

				{	/* Inline/inline.scm 25 */
					BgL_isfunz00_bglt BgL_auxz00_3015;

					BgL_oz00_1486 = (BgL_isfunz00_bglt) (BgL_oz00_2605);
					BgL_sz00_1487 = BgL_sz00_2606;
					{

						{	/* Inline/inline.scm 25 */
							obj_t BgL_old3095z00_1490;

							obj_t BgL_aux3096z00_1491;

							{	/* Inline/inline.scm 25 */
								obj_t BgL_nextzd2method3221zd2_1497;

								BgL_nextzd2method3221zd2_1497 =
									BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
									(BgL_objectz00_bglt) (BgL_oz00_1486),
									BGl_structzb2objectzd2ze3objectzd2envz51zz__objectz00,
									BGl_isfunz00zzinline_inlinez00);
								if (PROCEDUREP(BgL_nextzd2method3221zd2_1497))
									{	/* Inline/inline.scm 25 */
										BgL_old3095z00_1490 =
											PROCEDURE_ENTRY(BgL_nextzd2method3221zd2_1497)
											(BgL_nextzd2method3221zd2_1497, (obj_t) (BgL_oz00_1486),
											BgL_sz00_1487, BEOA);
									}
								else
									{	/* Inline/inline.scm 25 */
										BgL_old3095z00_1490 =
											(obj_t) (BGl_structzb2objectzd2ze3objectz83zz__objectz00(
												(BgL_objectz00_bglt) (BgL_oz00_1486), BgL_sz00_1487));
									}
							}
							BgL_aux3096z00_1491 =
								STRUCT_REF(BgL_sz00_1487, (int) (((long) 0)));
							{	/* Inline/inline.scm 25 */
								BgL_isfunz00_bglt BgL_new3097z00_1492;

								BgL_new3097z00_1492 =
									((BgL_isfunz00_bglt) (BgL_old3095z00_1490));
								BGL_OBJECT_CLASS_NUM_SET(
									(BgL_objectz00_bglt) (BgL_new3097z00_1492),
									BGl_classzd2numzd2zz__objectz00
									(BGl_isfunz00zzinline_inlinez00));
								{	/* Inline/inline.scm 25 */
									BgL_isfunz00_bglt BgL_arg3400z00_1494;

									{	/* Inline/inline.scm 25 */
										obj_t BgL_arg3401z00_1495;

										obj_t BgL_arg3402z00_1496;

										BgL_arg3401z00_1495 =
											STRUCT_REF(BgL_aux3096z00_1491, (int) (((long) 0)));
										BgL_arg3402z00_1496 =
											STRUCT_REF(BgL_aux3096z00_1491, (int) (((long) 1)));
										{	/* Inline/inline.scm 25 */
											BgL_isfunz00_bglt BgL_res3492z00_2526;

											{	/* Inline/inline.scm 25 */
												BgL_nodez00_bglt BgL_originalzd2body3060zd2_2517;

												BgL_originalzd2body3060zd2_2517 =
													(BgL_nodez00_bglt) (BgL_arg3401z00_1495);
												{	/* Inline/inline.scm 25 */
													BgL_isfunz00_bglt BgL_new3062z00_2519;

													BgL_new3062z00_2519 =
														((BgL_isfunz00_bglt) BREF(GC_MALLOC(sizeof(struct
																	BgL_isfunz00_bgl))));
													{	/* Inline/inline.scm 25 */
														BgL_isfunz00_bglt BgL_res3491z00_2525;

														{	/* Inline/inline.scm 25 */
															BgL_isfunz00_bglt BgL_new3087z00_2520;

															BgL_new3087z00_2520 = BgL_new3062z00_2519;
															{	/* Inline/inline.scm 25 */
																BgL_nodez00_bglt
																	BgL_originalzd2body3085zd2_2523;
																obj_t BgL_recursivezd2calls3086zd2_2524;

																BgL_originalzd2body3085zd2_2523 =
																	BgL_originalzd2body3060zd2_2517;
																BgL_recursivezd2calls3086zd2_2524 =
																	BgL_arg3402z00_1496;
																((((BgL_isfunz00_bglt)
																			CREF(BgL_new3087z00_2520))->
																		BgL_originalzd2bodyzd2) =
																	((BgL_nodez00_bglt)
																		BgL_originalzd2body3085zd2_2523), BUNSPEC);
																((((BgL_isfunz00_bglt)
																			CREF(BgL_new3087z00_2520))->
																		BgL_recursivezd2callszd2) =
																	((obj_t) BgL_recursivezd2calls3086zd2_2524),
																	BUNSPEC);
																BgL_res3491z00_2525 = BgL_new3087z00_2520;
														}} BgL_res3491z00_2525;
													}
													BgL_res3492z00_2526 = BgL_new3062z00_2519;
											}}
											BgL_arg3400z00_1494 = BgL_res3492z00_2526;
									}}
									{	/* Inline/inline.scm 25 */
										obj_t BgL_auxz00_3042;

										BgL_objectz00_bglt BgL_auxz00_3040;

										BgL_auxz00_3042 = (obj_t) (BgL_arg3400z00_1494);
										BgL_auxz00_3040 =
											(BgL_objectz00_bglt) (BgL_new3097z00_1492);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_3040, BgL_auxz00_3042);
								}}
								BgL_auxz00_3015 = BgL_new3097z00_1492;
					}}}
					return (obj_t) (BgL_auxz00_3015);
				}
			}
		}
	}



/* object->struct-isfun3220 */
	obj_t BGl_objectzd2ze3structzd2isfun3220ze3zzinline_inlinez00(obj_t
		BgL_envz00_2607, obj_t BgL_obj3092z00_2608)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 25 */
			{
				BgL_isfunz00_bglt BgL_obj3092z00_1474;

				BgL_obj3092z00_1474 = (BgL_isfunz00_bglt) (BgL_obj3092z00_2608);
				{

					{	/* Inline/inline.scm 25 */
						obj_t BgL_res3093z00_1477;

						{	/* Inline/inline.scm 25 */
							obj_t BgL_nextzd2method3219zd2_1484;

							BgL_nextzd2method3219zd2_1484 =
								BGl_findzd2superzd2classzd2methodzd2zz__objectz00(
								(BgL_objectz00_bglt) (BgL_obj3092z00_1474),
								BGl_objectzd2ze3structzd2envze3zz__objectz00,
								BGl_isfunz00zzinline_inlinez00);
							if (PROCEDUREP(BgL_nextzd2method3219zd2_1484))
								{	/* Inline/inline.scm 25 */
									BgL_res3093z00_1477 =
										PROCEDURE_ENTRY(BgL_nextzd2method3219zd2_1484)
										(BgL_nextzd2method3219zd2_1484,
										(obj_t) (BgL_obj3092z00_1474), BEOA);
								}
							else
								{	/* Inline/inline.scm 25 */
									BgL_res3093z00_1477 =
										BGl_objectzd2ze3structz31zz__objectz00(
										(BgL_objectz00_bglt) (BgL_obj3092z00_1474));
								}
						}
						{	/* Inline/inline.scm 25 */
							obj_t BgL_aux3094z00_1478;

							{	/* Inline/inline.scm 25 */
								obj_t BgL_keyz00_2488;

								BgL_keyz00_2488 = CNST_TABLE_REF(((long) 1));
								BgL_aux3094z00_1478 =
									make_struct(BgL_keyz00_2488, (int) (((long) 2)), BUNSPEC);
							}
							{	/* Inline/inline.scm 25 */
								BgL_nodez00_bglt BgL_arg3394z00_1480;

								{
									obj_t BgL_auxz00_3059;

									{	/* Inline/inline.scm 25 */
										BgL_objectz00_bglt BgL_auxz00_3060;

										BgL_auxz00_3060 =
											(BgL_objectz00_bglt) (BgL_obj3092z00_1474);
										BgL_auxz00_3059 = BGL_OBJECT_WIDENING(BgL_auxz00_3060);
									}
									BgL_arg3394z00_1480 =
										(((BgL_isfunz00_bglt) CREF(BgL_auxz00_3059))->
										BgL_originalzd2bodyzd2);
								}
								{	/* Inline/inline.scm 25 */
									obj_t BgL_auxz00_3066;

									int BgL_auxz00_3064;

									BgL_auxz00_3066 = (obj_t) (BgL_arg3394z00_1480);
									BgL_auxz00_3064 = (int) (((long) 0));
									STRUCT_SET(BgL_aux3094z00_1478, BgL_auxz00_3064,
										BgL_auxz00_3066);
							}}
							{	/* Inline/inline.scm 25 */
								obj_t BgL_arg3396z00_1482;

								{
									obj_t BgL_auxz00_3069;

									{	/* Inline/inline.scm 25 */
										BgL_objectz00_bglt BgL_auxz00_3070;

										BgL_auxz00_3070 =
											(BgL_objectz00_bglt) (BgL_obj3092z00_1474);
										BgL_auxz00_3069 = BGL_OBJECT_WIDENING(BgL_auxz00_3070);
									}
									BgL_arg3396z00_1482 =
										(((BgL_isfunz00_bglt) CREF(BgL_auxz00_3069))->
										BgL_recursivezd2callszd2);
								}
								{	/* Inline/inline.scm 25 */
									int BgL_auxz00_3074;

									BgL_auxz00_3074 = (int) (((long) 1));
									STRUCT_SET(BgL_aux3094z00_1478, BgL_auxz00_3074,
										BgL_arg3396z00_1482);
							}}
							{	/* Inline/inline.scm 25 */
								int BgL_auxz00_3077;

								BgL_auxz00_3077 = (int) (((long) 0));
								STRUCT_SET(BgL_res3093z00_1477, BgL_auxz00_3077,
									BgL_aux3094z00_1478);
							}
							{	/* Inline/inline.scm 25 */
								obj_t BgL_auxz00_3080;

								BgL_auxz00_3080 = STRUCT_KEY(BgL_res3093z00_1477);
								STRUCT_KEY_SET(BgL_aux3094z00_1478, BgL_auxz00_3080);
							}
							{	/* Inline/inline.scm 25 */
								obj_t BgL_kz00_2507;

								BgL_kz00_2507 = CNST_TABLE_REF(((long) 1));
								STRUCT_KEY_SET(BgL_res3093z00_1477, BgL_kz00_2507);
							}
							return BgL_res3093z00_1477;
						}
					}
				}
			}
		}
	}



/* inline-node-box-set!3218 */
	obj_t BGl_inlinezd2nodezd2boxzd2setz123218zc0zzinline_inlinez00(obj_t
		BgL_envz00_2609, obj_t BgL_nodez00_2610, obj_t BgL_kfactorz00_2611,
		obj_t BgL_stackz00_2612)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 229 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1462;

				obj_t BgL_kfactorz00_1463;

				obj_t BgL_stackz00_1464;

				{	/* Inline/inline.scm 230 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_3086;

					BgL_nodez00_1462 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_2610);
					BgL_kfactorz00_1463 = BgL_kfactorz00_2611;
					BgL_stackz00_1464 = BgL_stackz00_2612;
					{	/* Inline/inline.scm 231 */
						BgL_nodez00_bglt BgL_arg3388z00_1468;

						{	/* Inline/inline.scm 231 */
							BgL_varz00_bglt BgL_arg3389z00_1469;

							BgL_arg3389z00_1469 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1462))->
								BgL_varz00);
							{	/* Inline/inline.scm 231 */
								BgL_nodez00_bglt BgL_res3486z00_2453;

								{	/* Inline/inline.scm 231 */
									BgL_nodez00_bglt BgL_nodez00_2425;

									long BgL_kfactorz00_2426;

									BgL_nodez00_2425 = (BgL_nodez00_bglt) (BgL_arg3389z00_1469);
									BgL_kfactorz00_2426 = (long) CINT(BgL_kfactorz00_1463);
									{	/* Inline/inline.scm 231 */
										obj_t BgL_method3178z00_2428;

										{	/* Inline/inline.scm 231 */
											BgL_objectz00_bglt BgL_objz00_2429;

											BgL_objz00_2429 = (BgL_objectz00_bglt) (BgL_nodez00_2425);
											{	/* Inline/inline.scm 231 */
												long BgL_objzd2classzd2numz00_2430;

												BgL_objzd2classzd2numz00_2430 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2429);
												{	/* Inline/inline.scm 231 */
													obj_t BgL_arg2334z00_2431;

													BgL_arg2334z00_2431 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 231 */
														obj_t BgL_arrayz00_2433;

														int BgL_offsetz00_2434;

														BgL_arrayz00_2433 = BgL_arg2334z00_2431;
														BgL_offsetz00_2434 =
															(int) (BgL_objzd2classzd2numz00_2430);
														{	/* Inline/inline.scm 231 */
															long BgL_offsetz00_2435;

															BgL_offsetz00_2435 =
																((long) (BgL_offsetz00_2434) - OBJECT_TYPE);
															{	/* Inline/inline.scm 231 */
																long BgL_modz00_2436;

																{	/* Inline/inline.scm 231 */
																	int BgL_arg2336z00_2437;

																	BgL_arg2336z00_2437 = (int) (((long) 8));
																	{	/* Inline/inline.scm 231 */
																		long BgL_auxz00_3098;

																		BgL_auxz00_3098 =
																			(long) (BgL_arg2336z00_2437);
																		BgL_modz00_2436 =
																			(BgL_offsetz00_2435 / BgL_auxz00_3098);
																}}
																{	/* Inline/inline.scm 231 */
																	long BgL_restz00_2438;

																	{	/* Inline/inline.scm 231 */
																		int BgL_arg2335z00_2439;

																		BgL_arg2335z00_2439 = (int) (((long) 8));
																		{	/* Inline/inline.scm 231 */
																			long BgL_auxz00_3102;

																			BgL_auxz00_3102 =
																				(long) (BgL_arg2335z00_2439);
																			BgL_restz00_2438 =
																				(BgL_offsetz00_2435 % BgL_auxz00_3102);
																	}}
																	{	/* Inline/inline.scm 231 */

																		BgL_method3178z00_2428 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2433,
																				(int) (BgL_modz00_2436)),
																			(int) (BgL_restz00_2438));
										}}}}}}}}
										BgL_res3486z00_2453 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2428) (BgL_method3178z00_2428,
												(obj_t) (BgL_nodez00_2425), BINT(BgL_kfactorz00_2426),
												BgL_stackz00_1464, BEOA));
								}}
								BgL_arg3388z00_1468 = BgL_res3486z00_2453;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3114;

							BgL_auxz00_3114 = (BgL_varz00_bglt) (BgL_arg3388z00_1468);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1462))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_3114), BUNSPEC);
					}}
					{	/* Inline/inline.scm 232 */
						BgL_nodez00_bglt BgL_arg3390z00_1470;

						{	/* Inline/inline.scm 232 */
							BgL_nodez00_bglt BgL_arg3391z00_1471;

							BgL_arg3391z00_1471 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1462))->
								BgL_valuez00);
							{	/* Inline/inline.scm 232 */
								BgL_nodez00_bglt BgL_res3489z00_2485;

								{	/* Inline/inline.scm 232 */
									long BgL_kfactorz00_2458;

									BgL_kfactorz00_2458 = (long) CINT(BgL_kfactorz00_1463);
									{	/* Inline/inline.scm 232 */
										obj_t BgL_method3178z00_2460;

										{	/* Inline/inline.scm 232 */
											BgL_objectz00_bglt BgL_objz00_2461;

											BgL_objz00_2461 =
												(BgL_objectz00_bglt) (BgL_arg3391z00_1471);
											{	/* Inline/inline.scm 232 */
												long BgL_objzd2classzd2numz00_2462;

												BgL_objzd2classzd2numz00_2462 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2461);
												{	/* Inline/inline.scm 232 */
													obj_t BgL_arg2334z00_2463;

													BgL_arg2334z00_2463 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 232 */
														obj_t BgL_arrayz00_2465;

														int BgL_offsetz00_2466;

														BgL_arrayz00_2465 = BgL_arg2334z00_2463;
														BgL_offsetz00_2466 =
															(int) (BgL_objzd2classzd2numz00_2462);
														{	/* Inline/inline.scm 232 */
															long BgL_offsetz00_2467;

															BgL_offsetz00_2467 =
																((long) (BgL_offsetz00_2466) - OBJECT_TYPE);
															{	/* Inline/inline.scm 232 */
																long BgL_modz00_2468;

																{	/* Inline/inline.scm 232 */
																	int BgL_arg2336z00_2469;

																	BgL_arg2336z00_2469 = (int) (((long) 8));
																	{	/* Inline/inline.scm 232 */
																		long BgL_auxz00_3127;

																		BgL_auxz00_3127 =
																			(long) (BgL_arg2336z00_2469);
																		BgL_modz00_2468 =
																			(BgL_offsetz00_2467 / BgL_auxz00_3127);
																}}
																{	/* Inline/inline.scm 232 */
																	long BgL_restz00_2470;

																	{	/* Inline/inline.scm 232 */
																		int BgL_arg2335z00_2471;

																		BgL_arg2335z00_2471 = (int) (((long) 8));
																		{	/* Inline/inline.scm 232 */
																			long BgL_auxz00_3131;

																			BgL_auxz00_3131 =
																				(long) (BgL_arg2335z00_2471);
																			BgL_restz00_2470 =
																				(BgL_offsetz00_2467 % BgL_auxz00_3131);
																	}}
																	{	/* Inline/inline.scm 232 */

																		BgL_method3178z00_2460 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2465,
																				(int) (BgL_modz00_2468)),
																			(int) (BgL_restz00_2470));
										}}}}}}}}
										BgL_res3489z00_2485 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2460) (BgL_method3178z00_2460,
												(obj_t) (BgL_arg3391z00_1471),
												BINT(BgL_kfactorz00_2458), BgL_stackz00_1464, BEOA));
								}}
								BgL_arg3390z00_1470 = BgL_res3489z00_2485;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1462))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3390z00_1470), BUNSPEC);
					}
					BgL_auxz00_3086 = BgL_nodez00_1462;
					return (obj_t) (BgL_auxz00_3086);
				}
			}
		}
	}



/* inline-node-box-ref3216 */
	obj_t BGl_inlinezd2nodezd2boxzd2ref3216zd2zzinline_inlinez00(obj_t
		BgL_envz00_2613, obj_t BgL_nodez00_2614, obj_t BgL_kfactorz00_2615,
		obj_t BgL_stackz00_2616)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 222 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1453;

				obj_t BgL_kfactorz00_1454;

				obj_t BgL_stackz00_1455;

				{	/* Inline/inline.scm 223 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_3146;

					BgL_nodez00_1453 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_2614);
					BgL_kfactorz00_1454 = BgL_kfactorz00_2615;
					BgL_stackz00_1455 = BgL_stackz00_2616;
					{	/* Inline/inline.scm 223 */
						BgL_nodez00_bglt BgL_arg3385z00_2390;

						{	/* Inline/inline.scm 223 */
							BgL_varz00_bglt BgL_arg3386z00_2391;

							BgL_arg3386z00_2391 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1453))->BgL_varz00);
							{	/* Inline/inline.scm 223 */
								BgL_nodez00_bglt BgL_res3483z00_2421;

								{	/* Inline/inline.scm 223 */
									BgL_nodez00_bglt BgL_nodez00_2393;

									long BgL_kfactorz00_2394;

									BgL_nodez00_2393 = (BgL_nodez00_bglt) (BgL_arg3386z00_2391);
									BgL_kfactorz00_2394 = (long) CINT(BgL_kfactorz00_1454);
									{	/* Inline/inline.scm 223 */
										obj_t BgL_method3178z00_2396;

										{	/* Inline/inline.scm 223 */
											BgL_objectz00_bglt BgL_objz00_2397;

											BgL_objz00_2397 = (BgL_objectz00_bglt) (BgL_nodez00_2393);
											{	/* Inline/inline.scm 223 */
												long BgL_objzd2classzd2numz00_2398;

												BgL_objzd2classzd2numz00_2398 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2397);
												{	/* Inline/inline.scm 223 */
													obj_t BgL_arg2334z00_2399;

													BgL_arg2334z00_2399 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 223 */
														obj_t BgL_arrayz00_2401;

														int BgL_offsetz00_2402;

														BgL_arrayz00_2401 = BgL_arg2334z00_2399;
														BgL_offsetz00_2402 =
															(int) (BgL_objzd2classzd2numz00_2398);
														{	/* Inline/inline.scm 223 */
															long BgL_offsetz00_2403;

															BgL_offsetz00_2403 =
																((long) (BgL_offsetz00_2402) - OBJECT_TYPE);
															{	/* Inline/inline.scm 223 */
																long BgL_modz00_2404;

																{	/* Inline/inline.scm 223 */
																	int BgL_arg2336z00_2405;

																	BgL_arg2336z00_2405 = (int) (((long) 8));
																	{	/* Inline/inline.scm 223 */
																		long BgL_auxz00_3158;

																		BgL_auxz00_3158 =
																			(long) (BgL_arg2336z00_2405);
																		BgL_modz00_2404 =
																			(BgL_offsetz00_2403 / BgL_auxz00_3158);
																}}
																{	/* Inline/inline.scm 223 */
																	long BgL_restz00_2406;

																	{	/* Inline/inline.scm 223 */
																		int BgL_arg2335z00_2407;

																		BgL_arg2335z00_2407 = (int) (((long) 8));
																		{	/* Inline/inline.scm 223 */
																			long BgL_auxz00_3162;

																			BgL_auxz00_3162 =
																				(long) (BgL_arg2335z00_2407);
																			BgL_restz00_2406 =
																				(BgL_offsetz00_2403 % BgL_auxz00_3162);
																	}}
																	{	/* Inline/inline.scm 223 */

																		BgL_method3178z00_2396 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2401,
																				(int) (BgL_modz00_2404)),
																			(int) (BgL_restz00_2406));
										}}}}}}}}
										BgL_res3483z00_2421 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2396) (BgL_method3178z00_2396,
												(obj_t) (BgL_nodez00_2393), BINT(BgL_kfactorz00_2394),
												BgL_stackz00_1455, BEOA));
								}}
								BgL_arg3385z00_2390 = BgL_res3483z00_2421;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_3174;

							BgL_auxz00_3174 = (BgL_varz00_bglt) (BgL_arg3385z00_2390);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1453))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_3174), BUNSPEC);
					}}
					BgL_auxz00_3146 = BgL_nodez00_1453;
					return (obj_t) (BgL_auxz00_3146);
				}
			}
		}
	}



/* inline-node-make-box3214 */
	obj_t BGl_inlinezd2nodezd2makezd2box3214zd2zzinline_inlinez00(obj_t
		BgL_envz00_2617, obj_t BgL_nodez00_2618, obj_t BgL_kfactorz00_2619,
		obj_t BgL_stackz00_2620)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 215 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1444;

				obj_t BgL_kfactorz00_1445;

				obj_t BgL_stackz00_1446;

				{	/* Inline/inline.scm 216 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_3179;

					BgL_nodez00_1444 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_2618);
					BgL_kfactorz00_1445 = BgL_kfactorz00_2619;
					BgL_stackz00_1446 = BgL_stackz00_2620;
					{	/* Inline/inline.scm 216 */
						BgL_nodez00_bglt BgL_arg3382z00_2356;

						{	/* Inline/inline.scm 216 */
							BgL_nodez00_bglt BgL_arg3383z00_2357;

							BgL_arg3383z00_2357 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1444))->
								BgL_valuez00);
							{	/* Inline/inline.scm 216 */
								BgL_nodez00_bglt BgL_res3480z00_2387;

								{	/* Inline/inline.scm 216 */
									long BgL_kfactorz00_2360;

									BgL_kfactorz00_2360 = (long) CINT(BgL_kfactorz00_1445);
									{	/* Inline/inline.scm 216 */
										obj_t BgL_method3178z00_2362;

										{	/* Inline/inline.scm 216 */
											BgL_objectz00_bglt BgL_objz00_2363;

											BgL_objz00_2363 =
												(BgL_objectz00_bglt) (BgL_arg3383z00_2357);
											{	/* Inline/inline.scm 216 */
												long BgL_objzd2classzd2numz00_2364;

												BgL_objzd2classzd2numz00_2364 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2363);
												{	/* Inline/inline.scm 216 */
													obj_t BgL_arg2334z00_2365;

													BgL_arg2334z00_2365 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 216 */
														obj_t BgL_arrayz00_2367;

														int BgL_offsetz00_2368;

														BgL_arrayz00_2367 = BgL_arg2334z00_2365;
														BgL_offsetz00_2368 =
															(int) (BgL_objzd2classzd2numz00_2364);
														{	/* Inline/inline.scm 216 */
															long BgL_offsetz00_2369;

															BgL_offsetz00_2369 =
																((long) (BgL_offsetz00_2368) - OBJECT_TYPE);
															{	/* Inline/inline.scm 216 */
																long BgL_modz00_2370;

																{	/* Inline/inline.scm 216 */
																	int BgL_arg2336z00_2371;

																	BgL_arg2336z00_2371 = (int) (((long) 8));
																	{	/* Inline/inline.scm 216 */
																		long BgL_auxz00_3190;

																		BgL_auxz00_3190 =
																			(long) (BgL_arg2336z00_2371);
																		BgL_modz00_2370 =
																			(BgL_offsetz00_2369 / BgL_auxz00_3190);
																}}
																{	/* Inline/inline.scm 216 */
																	long BgL_restz00_2372;

																	{	/* Inline/inline.scm 216 */
																		int BgL_arg2335z00_2373;

																		BgL_arg2335z00_2373 = (int) (((long) 8));
																		{	/* Inline/inline.scm 216 */
																			long BgL_auxz00_3194;

																			BgL_auxz00_3194 =
																				(long) (BgL_arg2335z00_2373);
																			BgL_restz00_2372 =
																				(BgL_offsetz00_2369 % BgL_auxz00_3194);
																	}}
																	{	/* Inline/inline.scm 216 */

																		BgL_method3178z00_2362 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2367,
																				(int) (BgL_modz00_2370)),
																			(int) (BgL_restz00_2372));
										}}}}}}}}
										BgL_res3480z00_2387 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2362) (BgL_method3178z00_2362,
												(obj_t) (BgL_arg3383z00_2357),
												BINT(BgL_kfactorz00_2360), BgL_stackz00_1446, BEOA));
								}}
								BgL_arg3382z00_2356 = BgL_res3480z00_2387;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1444))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3382z00_2356), BUNSPEC);
					}
					BgL_auxz00_3179 = BgL_nodez00_1444;
					return (obj_t) (BgL_auxz00_3179);
				}
			}
		}
	}



/* inline-node-jump-ex-3212 */
	obj_t BGl_inlinezd2nodezd2jumpzd2exzd23212z00zzinline_inlinez00(obj_t
		BgL_envz00_2621, obj_t BgL_nodez00_2622, obj_t BgL_kfactorz00_2623,
		obj_t BgL_stackz00_2624)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 206 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1432;

				obj_t BgL_kfactorz00_1433;

				obj_t BgL_stackz00_1434;

				{	/* Inline/inline.scm 207 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_3209;

					BgL_nodez00_1432 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_2622);
					BgL_kfactorz00_1433 = BgL_kfactorz00_2623;
					BgL_stackz00_1434 = BgL_stackz00_2624;
					{	/* Inline/inline.scm 208 */
						BgL_nodez00_bglt BgL_arg3377z00_1438;

						{	/* Inline/inline.scm 208 */
							BgL_nodez00_bglt BgL_arg3378z00_1439;

							BgL_arg3378z00_1439 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1432))->
								BgL_exitz00);
							{	/* Inline/inline.scm 208 */
								BgL_nodez00_bglt BgL_res3474z00_2321;

								{	/* Inline/inline.scm 208 */
									long BgL_kfactorz00_2294;

									BgL_kfactorz00_2294 = (long) CINT(BgL_kfactorz00_1433);
									{	/* Inline/inline.scm 208 */
										obj_t BgL_method3178z00_2296;

										{	/* Inline/inline.scm 208 */
											BgL_objectz00_bglt BgL_objz00_2297;

											BgL_objz00_2297 =
												(BgL_objectz00_bglt) (BgL_arg3378z00_1439);
											{	/* Inline/inline.scm 208 */
												long BgL_objzd2classzd2numz00_2298;

												BgL_objzd2classzd2numz00_2298 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2297);
												{	/* Inline/inline.scm 208 */
													obj_t BgL_arg2334z00_2299;

													BgL_arg2334z00_2299 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 208 */
														obj_t BgL_arrayz00_2301;

														int BgL_offsetz00_2302;

														BgL_arrayz00_2301 = BgL_arg2334z00_2299;
														BgL_offsetz00_2302 =
															(int) (BgL_objzd2classzd2numz00_2298);
														{	/* Inline/inline.scm 208 */
															long BgL_offsetz00_2303;

															BgL_offsetz00_2303 =
																((long) (BgL_offsetz00_2302) - OBJECT_TYPE);
															{	/* Inline/inline.scm 208 */
																long BgL_modz00_2304;

																{	/* Inline/inline.scm 208 */
																	int BgL_arg2336z00_2305;

																	BgL_arg2336z00_2305 = (int) (((long) 8));
																	{	/* Inline/inline.scm 208 */
																		long BgL_auxz00_3220;

																		BgL_auxz00_3220 =
																			(long) (BgL_arg2336z00_2305);
																		BgL_modz00_2304 =
																			(BgL_offsetz00_2303 / BgL_auxz00_3220);
																}}
																{	/* Inline/inline.scm 208 */
																	long BgL_restz00_2306;

																	{	/* Inline/inline.scm 208 */
																		int BgL_arg2335z00_2307;

																		BgL_arg2335z00_2307 = (int) (((long) 8));
																		{	/* Inline/inline.scm 208 */
																			long BgL_auxz00_3224;

																			BgL_auxz00_3224 =
																				(long) (BgL_arg2335z00_2307);
																			BgL_restz00_2306 =
																				(BgL_offsetz00_2303 % BgL_auxz00_3224);
																	}}
																	{	/* Inline/inline.scm 208 */

																		BgL_method3178z00_2296 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2301,
																				(int) (BgL_modz00_2304)),
																			(int) (BgL_restz00_2306));
										}}}}}}}}
										BgL_res3474z00_2321 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2296) (BgL_method3178z00_2296,
												(obj_t) (BgL_arg3378z00_1439),
												BINT(BgL_kfactorz00_2294), BgL_stackz00_1434, BEOA));
								}}
								BgL_arg3377z00_1438 = BgL_res3474z00_2321;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1432))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3377z00_1438), BUNSPEC);
					}
					{	/* Inline/inline.scm 209 */
						BgL_nodez00_bglt BgL_arg3379z00_1440;

						{	/* Inline/inline.scm 209 */
							BgL_nodez00_bglt BgL_arg3380z00_1441;

							BgL_arg3380z00_1441 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1432))->
								BgL_valuez00);
							{	/* Inline/inline.scm 209 */
								BgL_nodez00_bglt BgL_res3477z00_2353;

								{	/* Inline/inline.scm 209 */
									long BgL_kfactorz00_2326;

									BgL_kfactorz00_2326 = (long) CINT(BgL_kfactorz00_1433);
									{	/* Inline/inline.scm 209 */
										obj_t BgL_method3178z00_2328;

										{	/* Inline/inline.scm 209 */
											BgL_objectz00_bglt BgL_objz00_2329;

											BgL_objz00_2329 =
												(BgL_objectz00_bglt) (BgL_arg3380z00_1441);
											{	/* Inline/inline.scm 209 */
												long BgL_objzd2classzd2numz00_2330;

												BgL_objzd2classzd2numz00_2330 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2329);
												{	/* Inline/inline.scm 209 */
													obj_t BgL_arg2334z00_2331;

													BgL_arg2334z00_2331 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 209 */
														obj_t BgL_arrayz00_2333;

														int BgL_offsetz00_2334;

														BgL_arrayz00_2333 = BgL_arg2334z00_2331;
														BgL_offsetz00_2334 =
															(int) (BgL_objzd2classzd2numz00_2330);
														{	/* Inline/inline.scm 209 */
															long BgL_offsetz00_2335;

															BgL_offsetz00_2335 =
																((long) (BgL_offsetz00_2334) - OBJECT_TYPE);
															{	/* Inline/inline.scm 209 */
																long BgL_modz00_2336;

																{	/* Inline/inline.scm 209 */
																	int BgL_arg2336z00_2337;

																	BgL_arg2336z00_2337 = (int) (((long) 8));
																	{	/* Inline/inline.scm 209 */
																		long BgL_auxz00_3247;

																		BgL_auxz00_3247 =
																			(long) (BgL_arg2336z00_2337);
																		BgL_modz00_2336 =
																			(BgL_offsetz00_2335 / BgL_auxz00_3247);
																}}
																{	/* Inline/inline.scm 209 */
																	long BgL_restz00_2338;

																	{	/* Inline/inline.scm 209 */
																		int BgL_arg2335z00_2339;

																		BgL_arg2335z00_2339 = (int) (((long) 8));
																		{	/* Inline/inline.scm 209 */
																			long BgL_auxz00_3251;

																			BgL_auxz00_3251 =
																				(long) (BgL_arg2335z00_2339);
																			BgL_restz00_2338 =
																				(BgL_offsetz00_2335 % BgL_auxz00_3251);
																	}}
																	{	/* Inline/inline.scm 209 */

																		BgL_method3178z00_2328 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2333,
																				(int) (BgL_modz00_2336)),
																			(int) (BgL_restz00_2338));
										}}}}}}}}
										BgL_res3477z00_2353 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2328) (BgL_method3178z00_2328,
												(obj_t) (BgL_arg3380z00_1441),
												BINT(BgL_kfactorz00_2326), BgL_stackz00_1434, BEOA));
								}}
								BgL_arg3379z00_1440 = BgL_res3477z00_2353;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1432))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3379z00_1440), BUNSPEC);
					}
					BgL_auxz00_3209 = BgL_nodez00_1432;
					return (obj_t) (BgL_auxz00_3209);
				}
			}
		}
	}



/* inline-node-set-ex-i3210 */
	obj_t BGl_inlinezd2nodezd2setzd2exzd2i3210z00zzinline_inlinez00(obj_t
		BgL_envz00_2625, obj_t BgL_nodez00_2626, obj_t BgL_kfactorz00_2627,
		obj_t BgL_stackz00_2628)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 199 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1423;

				obj_t BgL_kfactorz00_1424;

				obj_t BgL_stackz00_1425;

				{	/* Inline/inline.scm 200 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_3266;

					BgL_nodez00_1423 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_2626);
					BgL_kfactorz00_1424 = BgL_kfactorz00_2627;
					BgL_stackz00_1425 = BgL_stackz00_2628;
					{	/* Inline/inline.scm 200 */
						BgL_nodez00_bglt BgL_arg3374z00_2258;

						{	/* Inline/inline.scm 200 */
							BgL_nodez00_bglt BgL_arg3375z00_2259;

							BgL_arg3375z00_2259 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1423))->
								BgL_bodyz00);
							{	/* Inline/inline.scm 200 */
								BgL_nodez00_bglt BgL_res3471z00_2289;

								{	/* Inline/inline.scm 200 */
									long BgL_kfactorz00_2262;

									BgL_kfactorz00_2262 = (long) CINT(BgL_kfactorz00_1424);
									{	/* Inline/inline.scm 200 */
										obj_t BgL_method3178z00_2264;

										{	/* Inline/inline.scm 200 */
											BgL_objectz00_bglt BgL_objz00_2265;

											BgL_objz00_2265 =
												(BgL_objectz00_bglt) (BgL_arg3375z00_2259);
											{	/* Inline/inline.scm 200 */
												long BgL_objzd2classzd2numz00_2266;

												BgL_objzd2classzd2numz00_2266 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2265);
												{	/* Inline/inline.scm 200 */
													obj_t BgL_arg2334z00_2267;

													BgL_arg2334z00_2267 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 200 */
														obj_t BgL_arrayz00_2269;

														int BgL_offsetz00_2270;

														BgL_arrayz00_2269 = BgL_arg2334z00_2267;
														BgL_offsetz00_2270 =
															(int) (BgL_objzd2classzd2numz00_2266);
														{	/* Inline/inline.scm 200 */
															long BgL_offsetz00_2271;

															BgL_offsetz00_2271 =
																((long) (BgL_offsetz00_2270) - OBJECT_TYPE);
															{	/* Inline/inline.scm 200 */
																long BgL_modz00_2272;

																{	/* Inline/inline.scm 200 */
																	int BgL_arg2336z00_2273;

																	BgL_arg2336z00_2273 = (int) (((long) 8));
																	{	/* Inline/inline.scm 200 */
																		long BgL_auxz00_3277;

																		BgL_auxz00_3277 =
																			(long) (BgL_arg2336z00_2273);
																		BgL_modz00_2272 =
																			(BgL_offsetz00_2271 / BgL_auxz00_3277);
																}}
																{	/* Inline/inline.scm 200 */
																	long BgL_restz00_2274;

																	{	/* Inline/inline.scm 200 */
																		int BgL_arg2335z00_2275;

																		BgL_arg2335z00_2275 = (int) (((long) 8));
																		{	/* Inline/inline.scm 200 */
																			long BgL_auxz00_3281;

																			BgL_auxz00_3281 =
																				(long) (BgL_arg2335z00_2275);
																			BgL_restz00_2274 =
																				(BgL_offsetz00_2271 % BgL_auxz00_3281);
																	}}
																	{	/* Inline/inline.scm 200 */

																		BgL_method3178z00_2264 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2269,
																				(int) (BgL_modz00_2272)),
																			(int) (BgL_restz00_2274));
										}}}}}}}}
										BgL_res3471z00_2289 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2264) (BgL_method3178z00_2264,
												(obj_t) (BgL_arg3375z00_2259),
												BINT(BgL_kfactorz00_2262), BgL_stackz00_1425, BEOA));
								}}
								BgL_arg3374z00_2258 = BgL_res3471z00_2289;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1423))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3374z00_2258), BUNSPEC);
					}
					BgL_auxz00_3266 = BgL_nodez00_1423;
					return (obj_t) (BgL_auxz00_3266);
				}
			}
		}
	}



/* inline-node-let-var3208 */
	obj_t BGl_inlinezd2nodezd2letzd2var3208zd2zzinline_inlinez00(obj_t
		BgL_envz00_2629, obj_t BgL_nodez00_2630, obj_t BgL_kfactorz00_2631,
		obj_t BgL_stackz00_2632)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 189 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1406;

				obj_t BgL_kfactorz00_1407;

				obj_t BgL_stackz00_1408;

				{	/* Inline/inline.scm 190 */
					BgL_letzd2varzd2_bglt BgL_auxz00_3296;

					BgL_nodez00_1406 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_2630);
					BgL_kfactorz00_1407 = BgL_kfactorz00_2631;
					BgL_stackz00_1408 = BgL_stackz00_2632;
					{	/* Inline/inline.scm 190 */
						obj_t BgL_g3175z00_1411;

						BgL_g3175z00_1411 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1406))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3173z00_1412;

							BgL_l3173z00_1412 = BgL_g3175z00_1411;
						BgL_forzd2each3174zd2_1413:
							if (PAIRP(BgL_l3173z00_1412))
								{	/* Inline/inline.scm 192 */
									{	/* Inline/inline.scm 191 */
										obj_t BgL_bindingz00_1415;

										BgL_bindingz00_1415 = CAR(BgL_l3173z00_1412);
										{	/* Inline/inline.scm 191 */
											BgL_nodez00_bglt BgL_arg3368z00_1416;

											{	/* Inline/inline.scm 191 */
												obj_t BgL_arg3369z00_1417;

												BgL_arg3369z00_1417 = CDR(BgL_bindingz00_1415);
												{	/* Inline/inline.scm 191 */
													BgL_nodez00_bglt BgL_res3465z00_2222;

													{	/* Inline/inline.scm 191 */
														BgL_nodez00_bglt BgL_nodez00_2194;

														long BgL_kfactorz00_2195;

														BgL_nodez00_2194 =
															(BgL_nodez00_bglt) (BgL_arg3369z00_1417);
														BgL_kfactorz00_2195 =
															(long) CINT(BgL_kfactorz00_1407);
														{	/* Inline/inline.scm 191 */
															obj_t BgL_method3178z00_2197;

															{	/* Inline/inline.scm 191 */
																BgL_objectz00_bglt BgL_objz00_2198;

																BgL_objz00_2198 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2194);
																{	/* Inline/inline.scm 191 */
																	long BgL_objzd2classzd2numz00_2199;

																	BgL_objzd2classzd2numz00_2199 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2198);
																	{	/* Inline/inline.scm 191 */
																		obj_t BgL_arg2334z00_2200;

																		BgL_arg2334z00_2200 =
																			PROCEDURE_REF
																			(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
																			(int) (((long) 1)));
																		{	/* Inline/inline.scm 191 */
																			obj_t BgL_arrayz00_2202;

																			int BgL_offsetz00_2203;

																			BgL_arrayz00_2202 = BgL_arg2334z00_2200;
																			BgL_offsetz00_2203 =
																				(int) (BgL_objzd2classzd2numz00_2199);
																			{	/* Inline/inline.scm 191 */
																				long BgL_offsetz00_2204;

																				BgL_offsetz00_2204 =
																					(
																					(long) (BgL_offsetz00_2203) -
																					OBJECT_TYPE);
																				{	/* Inline/inline.scm 191 */
																					long BgL_modz00_2205;

																					{	/* Inline/inline.scm 191 */
																						int BgL_arg2336z00_2206;

																						BgL_arg2336z00_2206 =
																							(int) (((long) 8));
																						{	/* Inline/inline.scm 191 */
																							long BgL_auxz00_3312;

																							BgL_auxz00_3312 =
																								(long) (BgL_arg2336z00_2206);
																							BgL_modz00_2205 =
																								(BgL_offsetz00_2204 /
																								BgL_auxz00_3312);
																					}}
																					{	/* Inline/inline.scm 191 */
																						long BgL_restz00_2207;

																						{	/* Inline/inline.scm 191 */
																							int BgL_arg2335z00_2208;

																							BgL_arg2335z00_2208 =
																								(int) (((long) 8));
																							{	/* Inline/inline.scm 191 */
																								long BgL_auxz00_3316;

																								BgL_auxz00_3316 =
																									(long) (BgL_arg2335z00_2208);
																								BgL_restz00_2207 =
																									(BgL_offsetz00_2204 %
																									BgL_auxz00_3316);
																						}}
																						{	/* Inline/inline.scm 191 */

																							BgL_method3178z00_2197 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2202,
																									(int) (BgL_modz00_2205)),
																								(int) (BgL_restz00_2207));
															}}}}}}}}
															BgL_res3465z00_2222 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3178z00_2197)
																(BgL_method3178z00_2197,
																	(obj_t) (BgL_nodez00_2194),
																	BINT(BgL_kfactorz00_2195), BgL_stackz00_1408,
																	BEOA));
													}}
													BgL_arg3368z00_1416 = BgL_res3465z00_2222;
											}}
											{	/* Inline/inline.scm 191 */
												obj_t BgL_auxz00_3328;

												BgL_auxz00_3328 = (obj_t) (BgL_arg3368z00_1416);
												SET_CDR(BgL_bindingz00_1415, BgL_auxz00_3328);
									}}}
									{
										obj_t BgL_l3173z00_3331;

										BgL_l3173z00_3331 = CDR(BgL_l3173z00_1412);
										BgL_l3173z00_1412 = BgL_l3173z00_3331;
										goto BgL_forzd2each3174zd2_1413;
									}
								}
							else
								{	/* Inline/inline.scm 192 */
									((bool_t) 1);
								}
						}
					}
					{	/* Inline/inline.scm 193 */
						BgL_nodez00_bglt BgL_arg3371z00_1419;

						{	/* Inline/inline.scm 193 */
							BgL_nodez00_bglt BgL_arg3372z00_1420;

							BgL_arg3372z00_1420 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1406))->BgL_bodyz00);
							{	/* Inline/inline.scm 193 */
								BgL_nodez00_bglt BgL_res3468z00_2255;

								{	/* Inline/inline.scm 193 */
									long BgL_kfactorz00_2228;

									BgL_kfactorz00_2228 = (long) CINT(BgL_kfactorz00_1407);
									{	/* Inline/inline.scm 193 */
										obj_t BgL_method3178z00_2230;

										{	/* Inline/inline.scm 193 */
											BgL_objectz00_bglt BgL_objz00_2231;

											BgL_objz00_2231 =
												(BgL_objectz00_bglt) (BgL_arg3372z00_1420);
											{	/* Inline/inline.scm 193 */
												long BgL_objzd2classzd2numz00_2232;

												BgL_objzd2classzd2numz00_2232 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2231);
												{	/* Inline/inline.scm 193 */
													obj_t BgL_arg2334z00_2233;

													BgL_arg2334z00_2233 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 193 */
														obj_t BgL_arrayz00_2235;

														int BgL_offsetz00_2236;

														BgL_arrayz00_2235 = BgL_arg2334z00_2233;
														BgL_offsetz00_2236 =
															(int) (BgL_objzd2classzd2numz00_2232);
														{	/* Inline/inline.scm 193 */
															long BgL_offsetz00_2237;

															BgL_offsetz00_2237 =
																((long) (BgL_offsetz00_2236) - OBJECT_TYPE);
															{	/* Inline/inline.scm 193 */
																long BgL_modz00_2238;

																{	/* Inline/inline.scm 193 */
																	int BgL_arg2336z00_2239;

																	BgL_arg2336z00_2239 = (int) (((long) 8));
																	{	/* Inline/inline.scm 193 */
																		long BgL_auxz00_3343;

																		BgL_auxz00_3343 =
																			(long) (BgL_arg2336z00_2239);
																		BgL_modz00_2238 =
																			(BgL_offsetz00_2237 / BgL_auxz00_3343);
																}}
																{	/* Inline/inline.scm 193 */
																	long BgL_restz00_2240;

																	{	/* Inline/inline.scm 193 */
																		int BgL_arg2335z00_2241;

																		BgL_arg2335z00_2241 = (int) (((long) 8));
																		{	/* Inline/inline.scm 193 */
																			long BgL_auxz00_3347;

																			BgL_auxz00_3347 =
																				(long) (BgL_arg2335z00_2241);
																			BgL_restz00_2240 =
																				(BgL_offsetz00_2237 % BgL_auxz00_3347);
																	}}
																	{	/* Inline/inline.scm 193 */

																		BgL_method3178z00_2230 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2235,
																				(int) (BgL_modz00_2238)),
																			(int) (BgL_restz00_2240));
										}}}}}}}}
										BgL_res3468z00_2255 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2230) (BgL_method3178z00_2230,
												(obj_t) (BgL_arg3372z00_1420),
												BINT(BgL_kfactorz00_2228), BgL_stackz00_1408, BEOA));
								}}
								BgL_arg3371z00_1419 = BgL_res3468z00_2255;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1406))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3371z00_1419), BUNSPEC);
					}
					BgL_auxz00_3296 = BgL_nodez00_1406;
					return (obj_t) (BgL_auxz00_3296);
				}
			}
		}
	}



/* inline-node-let-fun3206 */
	obj_t BGl_inlinezd2nodezd2letzd2fun3206zd2zzinline_inlinez00(obj_t
		BgL_envz00_2633, obj_t BgL_nodez00_2634, obj_t BgL_kfactorz00_2635,
		obj_t BgL_stackz00_2636)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 179 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1391;

				obj_t BgL_kfactorz00_1392;

				obj_t BgL_stackz00_1393;

				{	/* Inline/inline.scm 180 */
					BgL_letzd2funzd2_bglt BgL_auxz00_3362;

					BgL_nodez00_1391 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_2634);
					BgL_kfactorz00_1392 = BgL_kfactorz00_2635;
					BgL_stackz00_1393 = BgL_stackz00_2636;
					{	/* Inline/inline.scm 180 */
						BgL_nodez00_bglt BgL_arg3362z00_1396;

						{	/* Inline/inline.scm 180 */
							BgL_nodez00_bglt BgL_arg3363z00_1397;

							BgL_arg3363z00_1397 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1391))->BgL_bodyz00);
							{	/* Inline/inline.scm 180 */
								BgL_nodez00_bglt BgL_res3462z00_2183;

								{	/* Inline/inline.scm 180 */
									long BgL_kfactorz00_2156;

									BgL_kfactorz00_2156 = (long) CINT(BgL_kfactorz00_1392);
									{	/* Inline/inline.scm 180 */
										obj_t BgL_method3178z00_2158;

										{	/* Inline/inline.scm 180 */
											BgL_objectz00_bglt BgL_objz00_2159;

											BgL_objz00_2159 =
												(BgL_objectz00_bglt) (BgL_arg3363z00_1397);
											{	/* Inline/inline.scm 180 */
												long BgL_objzd2classzd2numz00_2160;

												BgL_objzd2classzd2numz00_2160 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2159);
												{	/* Inline/inline.scm 180 */
													obj_t BgL_arg2334z00_2161;

													BgL_arg2334z00_2161 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 180 */
														obj_t BgL_arrayz00_2163;

														int BgL_offsetz00_2164;

														BgL_arrayz00_2163 = BgL_arg2334z00_2161;
														BgL_offsetz00_2164 =
															(int) (BgL_objzd2classzd2numz00_2160);
														{	/* Inline/inline.scm 180 */
															long BgL_offsetz00_2165;

															BgL_offsetz00_2165 =
																((long) (BgL_offsetz00_2164) - OBJECT_TYPE);
															{	/* Inline/inline.scm 180 */
																long BgL_modz00_2166;

																{	/* Inline/inline.scm 180 */
																	int BgL_arg2336z00_2167;

																	BgL_arg2336z00_2167 = (int) (((long) 8));
																	{	/* Inline/inline.scm 180 */
																		long BgL_auxz00_3373;

																		BgL_auxz00_3373 =
																			(long) (BgL_arg2336z00_2167);
																		BgL_modz00_2166 =
																			(BgL_offsetz00_2165 / BgL_auxz00_3373);
																}}
																{	/* Inline/inline.scm 180 */
																	long BgL_restz00_2168;

																	{	/* Inline/inline.scm 180 */
																		int BgL_arg2335z00_2169;

																		BgL_arg2335z00_2169 = (int) (((long) 8));
																		{	/* Inline/inline.scm 180 */
																			long BgL_auxz00_3377;

																			BgL_auxz00_3377 =
																				(long) (BgL_arg2335z00_2169);
																			BgL_restz00_2168 =
																				(BgL_offsetz00_2165 % BgL_auxz00_3377);
																	}}
																	{	/* Inline/inline.scm 180 */

																		BgL_method3178z00_2158 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2163,
																				(int) (BgL_modz00_2166)),
																			(int) (BgL_restz00_2168));
										}}}}}}}}
										BgL_res3462z00_2183 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2158) (BgL_method3178z00_2158,
												(obj_t) (BgL_arg3363z00_1397),
												BINT(BgL_kfactorz00_2156), BgL_stackz00_1393, BEOA));
								}}
								BgL_arg3362z00_1396 = BgL_res3462z00_2183;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1391))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3362z00_1396), BUNSPEC);
					}
					{	/* Inline/inline.scm 181 */
						obj_t BgL_g3172z00_1398;

						BgL_g3172z00_1398 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1391))->BgL_localsz00);
						{
							obj_t BgL_l3169z00_1399;

							BgL_l3169z00_1399 = BgL_g3172z00_1398;
						BgL_forzd2each3171zd2_1400:
							if (PAIRP(BgL_l3169z00_1399))
								{	/* Inline/inline.scm 183 */
									{	/* Inline/inline.scm 182 */
										obj_t BgL_localz00_1402;

										BgL_localz00_1402 = CAR(BgL_l3169z00_1399);
										BGl_inlinezd2sfunz12zc0zzinline_inlinez00(
											(BgL_variablez00_bglt) (BgL_localz00_1402),
											(long) CINT(BgL_kfactorz00_1392), BgL_stackz00_1393);
									}
									{
										obj_t BgL_l3169z00_3397;

										BgL_l3169z00_3397 = CDR(BgL_l3169z00_1399);
										BgL_l3169z00_1399 = BgL_l3169z00_3397;
										goto BgL_forzd2each3171zd2_1400;
									}
								}
							else
								{	/* Inline/inline.scm 183 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3362 = BgL_nodez00_1391;
					return (obj_t) (BgL_auxz00_3362);
				}
			}
		}
	}



/* inline-node-select3204 */
	obj_t BGl_inlinezd2nodezd2select3204z00zzinline_inlinez00(obj_t
		BgL_envz00_2637, obj_t BgL_nodez00_2638, obj_t BgL_kfactorz00_2639,
		obj_t BgL_stackz00_2640)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 169 */
			{
				BgL_selectz00_bglt BgL_nodez00_1374;

				obj_t BgL_kfactorz00_1375;

				obj_t BgL_stackz00_1376;

				{	/* Inline/inline.scm 170 */
					BgL_selectz00_bglt BgL_auxz00_3401;

					BgL_nodez00_1374 = (BgL_selectz00_bglt) (BgL_nodez00_2638);
					BgL_kfactorz00_1375 = BgL_kfactorz00_2639;
					BgL_stackz00_1376 = BgL_stackz00_2640;
					{	/* Inline/inline.scm 170 */
						BgL_nodez00_bglt BgL_arg3355z00_1379;

						{	/* Inline/inline.scm 170 */
							BgL_nodez00_bglt BgL_arg3356z00_1380;

							BgL_arg3356z00_1380 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1374))->BgL_testz00);
							{	/* Inline/inline.scm 170 */
								BgL_nodez00_bglt BgL_res3456z00_2115;

								{	/* Inline/inline.scm 170 */
									long BgL_kfactorz00_2088;

									BgL_kfactorz00_2088 = (long) CINT(BgL_kfactorz00_1375);
									{	/* Inline/inline.scm 170 */
										obj_t BgL_method3178z00_2090;

										{	/* Inline/inline.scm 170 */
											BgL_objectz00_bglt BgL_objz00_2091;

											BgL_objz00_2091 =
												(BgL_objectz00_bglt) (BgL_arg3356z00_1380);
											{	/* Inline/inline.scm 170 */
												long BgL_objzd2classzd2numz00_2092;

												BgL_objzd2classzd2numz00_2092 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2091);
												{	/* Inline/inline.scm 170 */
													obj_t BgL_arg2334z00_2093;

													BgL_arg2334z00_2093 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 170 */
														obj_t BgL_arrayz00_2095;

														int BgL_offsetz00_2096;

														BgL_arrayz00_2095 = BgL_arg2334z00_2093;
														BgL_offsetz00_2096 =
															(int) (BgL_objzd2classzd2numz00_2092);
														{	/* Inline/inline.scm 170 */
															long BgL_offsetz00_2097;

															BgL_offsetz00_2097 =
																((long) (BgL_offsetz00_2096) - OBJECT_TYPE);
															{	/* Inline/inline.scm 170 */
																long BgL_modz00_2098;

																{	/* Inline/inline.scm 170 */
																	int BgL_arg2336z00_2099;

																	BgL_arg2336z00_2099 = (int) (((long) 8));
																	{	/* Inline/inline.scm 170 */
																		long BgL_auxz00_3412;

																		BgL_auxz00_3412 =
																			(long) (BgL_arg2336z00_2099);
																		BgL_modz00_2098 =
																			(BgL_offsetz00_2097 / BgL_auxz00_3412);
																}}
																{	/* Inline/inline.scm 170 */
																	long BgL_restz00_2100;

																	{	/* Inline/inline.scm 170 */
																		int BgL_arg2335z00_2101;

																		BgL_arg2335z00_2101 = (int) (((long) 8));
																		{	/* Inline/inline.scm 170 */
																			long BgL_auxz00_3416;

																			BgL_auxz00_3416 =
																				(long) (BgL_arg2335z00_2101);
																			BgL_restz00_2100 =
																				(BgL_offsetz00_2097 % BgL_auxz00_3416);
																	}}
																	{	/* Inline/inline.scm 170 */

																		BgL_method3178z00_2090 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2095,
																				(int) (BgL_modz00_2098)),
																			(int) (BgL_restz00_2100));
										}}}}}}}}
										BgL_res3456z00_2115 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2090) (BgL_method3178z00_2090,
												(obj_t) (BgL_arg3356z00_1380),
												BINT(BgL_kfactorz00_2088), BgL_stackz00_1376, BEOA));
								}}
								BgL_arg3355z00_1379 = BgL_res3456z00_2115;
						}}
						((((BgL_selectz00_bglt) CREF(BgL_nodez00_1374))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3355z00_1379), BUNSPEC);
					}
					{	/* Inline/inline.scm 171 */
						obj_t BgL_g3168z00_1381;

						BgL_g3168z00_1381 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1374))->BgL_clausesz00);
						{
							obj_t BgL_l3166z00_1382;

							BgL_l3166z00_1382 = BgL_g3168z00_1381;
						BgL_forzd2each3167zd2_1383:
							if (PAIRP(BgL_l3166z00_1382))
								{	/* Inline/inline.scm 173 */
									{	/* Inline/inline.scm 172 */
										obj_t BgL_clausez00_1385;

										BgL_clausez00_1385 = CAR(BgL_l3166z00_1382);
										{	/* Inline/inline.scm 172 */
											BgL_nodez00_bglt BgL_arg3358z00_1386;

											{	/* Inline/inline.scm 172 */
												obj_t BgL_arg3359z00_1387;

												BgL_arg3359z00_1387 = CDR(BgL_clausez00_1385);
												{	/* Inline/inline.scm 172 */
													BgL_nodez00_bglt BgL_res3459z00_2150;

													{	/* Inline/inline.scm 172 */
														BgL_nodez00_bglt BgL_nodez00_2122;

														long BgL_kfactorz00_2123;

														BgL_nodez00_2122 =
															(BgL_nodez00_bglt) (BgL_arg3359z00_1387);
														BgL_kfactorz00_2123 =
															(long) CINT(BgL_kfactorz00_1375);
														{	/* Inline/inline.scm 172 */
															obj_t BgL_method3178z00_2125;

															{	/* Inline/inline.scm 172 */
																BgL_objectz00_bglt BgL_objz00_2126;

																BgL_objz00_2126 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2122);
																{	/* Inline/inline.scm 172 */
																	long BgL_objzd2classzd2numz00_2127;

																	BgL_objzd2classzd2numz00_2127 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2126);
																	{	/* Inline/inline.scm 172 */
																		obj_t BgL_arg2334z00_2128;

																		BgL_arg2334z00_2128 =
																			PROCEDURE_REF
																			(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
																			(int) (((long) 1)));
																		{	/* Inline/inline.scm 172 */
																			obj_t BgL_arrayz00_2130;

																			int BgL_offsetz00_2131;

																			BgL_arrayz00_2130 = BgL_arg2334z00_2128;
																			BgL_offsetz00_2131 =
																				(int) (BgL_objzd2classzd2numz00_2127);
																			{	/* Inline/inline.scm 172 */
																				long BgL_offsetz00_2132;

																				BgL_offsetz00_2132 =
																					(
																					(long) (BgL_offsetz00_2131) -
																					OBJECT_TYPE);
																				{	/* Inline/inline.scm 172 */
																					long BgL_modz00_2133;

																					{	/* Inline/inline.scm 172 */
																						int BgL_arg2336z00_2134;

																						BgL_arg2336z00_2134 =
																							(int) (((long) 8));
																						{	/* Inline/inline.scm 172 */
																							long BgL_auxz00_3444;

																							BgL_auxz00_3444 =
																								(long) (BgL_arg2336z00_2134);
																							BgL_modz00_2133 =
																								(BgL_offsetz00_2132 /
																								BgL_auxz00_3444);
																					}}
																					{	/* Inline/inline.scm 172 */
																						long BgL_restz00_2135;

																						{	/* Inline/inline.scm 172 */
																							int BgL_arg2335z00_2136;

																							BgL_arg2335z00_2136 =
																								(int) (((long) 8));
																							{	/* Inline/inline.scm 172 */
																								long BgL_auxz00_3448;

																								BgL_auxz00_3448 =
																									(long) (BgL_arg2335z00_2136);
																								BgL_restz00_2135 =
																									(BgL_offsetz00_2132 %
																									BgL_auxz00_3448);
																						}}
																						{	/* Inline/inline.scm 172 */

																							BgL_method3178z00_2125 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2130,
																									(int) (BgL_modz00_2133)),
																								(int) (BgL_restz00_2135));
															}}}}}}}}
															BgL_res3459z00_2150 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3178z00_2125)
																(BgL_method3178z00_2125,
																	(obj_t) (BgL_nodez00_2122),
																	BINT(BgL_kfactorz00_2123), BgL_stackz00_1376,
																	BEOA));
													}}
													BgL_arg3358z00_1386 = BgL_res3459z00_2150;
											}}
											{	/* Inline/inline.scm 172 */
												obj_t BgL_auxz00_3460;

												BgL_auxz00_3460 = (obj_t) (BgL_arg3358z00_1386);
												SET_CDR(BgL_clausez00_1385, BgL_auxz00_3460);
									}}}
									{
										obj_t BgL_l3166z00_3463;

										BgL_l3166z00_3463 = CDR(BgL_l3166z00_1382);
										BgL_l3166z00_1382 = BgL_l3166z00_3463;
										goto BgL_forzd2each3167zd2_1383;
									}
								}
							else
								{	/* Inline/inline.scm 173 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_3401 = BgL_nodez00_1374;
					return (obj_t) (BgL_auxz00_3401);
				}
			}
		}
	}



/* inline-node-fail3202 */
	obj_t BGl_inlinezd2nodezd2fail3202z00zzinline_inlinez00(obj_t BgL_envz00_2641,
		obj_t BgL_nodez00_2642, obj_t BgL_kfactorz00_2643, obj_t BgL_stackz00_2644)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 159 */
			{
				BgL_failz00_bglt BgL_nodez00_1360;

				obj_t BgL_kfactorz00_1361;

				obj_t BgL_stackz00_1362;

				{	/* Inline/inline.scm 160 */
					BgL_failz00_bglt BgL_auxz00_3467;

					BgL_nodez00_1360 = (BgL_failz00_bglt) (BgL_nodez00_2642);
					BgL_kfactorz00_1361 = BgL_kfactorz00_2643;
					BgL_stackz00_1362 = BgL_stackz00_2644;
					{	/* Inline/inline.scm 161 */
						BgL_nodez00_bglt BgL_arg3348z00_1366;

						{	/* Inline/inline.scm 161 */
							BgL_nodez00_bglt BgL_arg3349z00_1367;

							BgL_arg3349z00_1367 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1360))->BgL_procz00);
							{	/* Inline/inline.scm 161 */
								BgL_nodez00_bglt BgL_res3447z00_2019;

								{	/* Inline/inline.scm 161 */
									long BgL_kfactorz00_1992;

									BgL_kfactorz00_1992 = (long) CINT(BgL_kfactorz00_1361);
									{	/* Inline/inline.scm 161 */
										obj_t BgL_method3178z00_1994;

										{	/* Inline/inline.scm 161 */
											BgL_objectz00_bglt BgL_objz00_1995;

											BgL_objz00_1995 =
												(BgL_objectz00_bglt) (BgL_arg3349z00_1367);
											{	/* Inline/inline.scm 161 */
												long BgL_objzd2classzd2numz00_1996;

												BgL_objzd2classzd2numz00_1996 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1995);
												{	/* Inline/inline.scm 161 */
													obj_t BgL_arg2334z00_1997;

													BgL_arg2334z00_1997 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 161 */
														obj_t BgL_arrayz00_1999;

														int BgL_offsetz00_2000;

														BgL_arrayz00_1999 = BgL_arg2334z00_1997;
														BgL_offsetz00_2000 =
															(int) (BgL_objzd2classzd2numz00_1996);
														{	/* Inline/inline.scm 161 */
															long BgL_offsetz00_2001;

															BgL_offsetz00_2001 =
																((long) (BgL_offsetz00_2000) - OBJECT_TYPE);
															{	/* Inline/inline.scm 161 */
																long BgL_modz00_2002;

																{	/* Inline/inline.scm 161 */
																	int BgL_arg2336z00_2003;

																	BgL_arg2336z00_2003 = (int) (((long) 8));
																	{	/* Inline/inline.scm 161 */
																		long BgL_auxz00_3478;

																		BgL_auxz00_3478 =
																			(long) (BgL_arg2336z00_2003);
																		BgL_modz00_2002 =
																			(BgL_offsetz00_2001 / BgL_auxz00_3478);
																}}
																{	/* Inline/inline.scm 161 */
																	long BgL_restz00_2004;

																	{	/* Inline/inline.scm 161 */
																		int BgL_arg2335z00_2005;

																		BgL_arg2335z00_2005 = (int) (((long) 8));
																		{	/* Inline/inline.scm 161 */
																			long BgL_auxz00_3482;

																			BgL_auxz00_3482 =
																				(long) (BgL_arg2335z00_2005);
																			BgL_restz00_2004 =
																				(BgL_offsetz00_2001 % BgL_auxz00_3482);
																	}}
																	{	/* Inline/inline.scm 161 */

																		BgL_method3178z00_1994 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1999,
																				(int) (BgL_modz00_2002)),
																			(int) (BgL_restz00_2004));
										}}}}}}}}
										BgL_res3447z00_2019 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_1994) (BgL_method3178z00_1994,
												(obj_t) (BgL_arg3349z00_1367),
												BINT(BgL_kfactorz00_1992), BgL_stackz00_1362, BEOA));
								}}
								BgL_arg3348z00_1366 = BgL_res3447z00_2019;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1360))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3348z00_1366), BUNSPEC);
					}
					{	/* Inline/inline.scm 162 */
						BgL_nodez00_bglt BgL_arg3350z00_1368;

						{	/* Inline/inline.scm 162 */
							BgL_nodez00_bglt BgL_arg3351z00_1369;

							BgL_arg3351z00_1369 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1360))->BgL_msgz00);
							{	/* Inline/inline.scm 162 */
								BgL_nodez00_bglt BgL_res3450z00_2051;

								{	/* Inline/inline.scm 162 */
									long BgL_kfactorz00_2024;

									BgL_kfactorz00_2024 = (long) CINT(BgL_kfactorz00_1361);
									{	/* Inline/inline.scm 162 */
										obj_t BgL_method3178z00_2026;

										{	/* Inline/inline.scm 162 */
											BgL_objectz00_bglt BgL_objz00_2027;

											BgL_objz00_2027 =
												(BgL_objectz00_bglt) (BgL_arg3351z00_1369);
											{	/* Inline/inline.scm 162 */
												long BgL_objzd2classzd2numz00_2028;

												BgL_objzd2classzd2numz00_2028 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2027);
												{	/* Inline/inline.scm 162 */
													obj_t BgL_arg2334z00_2029;

													BgL_arg2334z00_2029 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 162 */
														obj_t BgL_arrayz00_2031;

														int BgL_offsetz00_2032;

														BgL_arrayz00_2031 = BgL_arg2334z00_2029;
														BgL_offsetz00_2032 =
															(int) (BgL_objzd2classzd2numz00_2028);
														{	/* Inline/inline.scm 162 */
															long BgL_offsetz00_2033;

															BgL_offsetz00_2033 =
																((long) (BgL_offsetz00_2032) - OBJECT_TYPE);
															{	/* Inline/inline.scm 162 */
																long BgL_modz00_2034;

																{	/* Inline/inline.scm 162 */
																	int BgL_arg2336z00_2035;

																	BgL_arg2336z00_2035 = (int) (((long) 8));
																	{	/* Inline/inline.scm 162 */
																		long BgL_auxz00_3505;

																		BgL_auxz00_3505 =
																			(long) (BgL_arg2336z00_2035);
																		BgL_modz00_2034 =
																			(BgL_offsetz00_2033 / BgL_auxz00_3505);
																}}
																{	/* Inline/inline.scm 162 */
																	long BgL_restz00_2036;

																	{	/* Inline/inline.scm 162 */
																		int BgL_arg2335z00_2037;

																		BgL_arg2335z00_2037 = (int) (((long) 8));
																		{	/* Inline/inline.scm 162 */
																			long BgL_auxz00_3509;

																			BgL_auxz00_3509 =
																				(long) (BgL_arg2335z00_2037);
																			BgL_restz00_2036 =
																				(BgL_offsetz00_2033 % BgL_auxz00_3509);
																	}}
																	{	/* Inline/inline.scm 162 */

																		BgL_method3178z00_2026 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2031,
																				(int) (BgL_modz00_2034)),
																			(int) (BgL_restz00_2036));
										}}}}}}}}
										BgL_res3450z00_2051 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2026) (BgL_method3178z00_2026,
												(obj_t) (BgL_arg3351z00_1369),
												BINT(BgL_kfactorz00_2024), BgL_stackz00_1362, BEOA));
								}}
								BgL_arg3350z00_1368 = BgL_res3450z00_2051;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1360))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3350z00_1368), BUNSPEC);
					}
					{	/* Inline/inline.scm 163 */
						BgL_nodez00_bglt BgL_arg3352z00_1370;

						{	/* Inline/inline.scm 163 */
							BgL_nodez00_bglt BgL_arg3353z00_1371;

							BgL_arg3353z00_1371 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1360))->BgL_objz00);
							{	/* Inline/inline.scm 163 */
								BgL_nodez00_bglt BgL_res3453z00_2083;

								{	/* Inline/inline.scm 163 */
									long BgL_kfactorz00_2056;

									BgL_kfactorz00_2056 = (long) CINT(BgL_kfactorz00_1361);
									{	/* Inline/inline.scm 163 */
										obj_t BgL_method3178z00_2058;

										{	/* Inline/inline.scm 163 */
											BgL_objectz00_bglt BgL_objz00_2059;

											BgL_objz00_2059 =
												(BgL_objectz00_bglt) (BgL_arg3353z00_1371);
											{	/* Inline/inline.scm 163 */
												long BgL_objzd2classzd2numz00_2060;

												BgL_objzd2classzd2numz00_2060 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2059);
												{	/* Inline/inline.scm 163 */
													obj_t BgL_arg2334z00_2061;

													BgL_arg2334z00_2061 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 163 */
														obj_t BgL_arrayz00_2063;

														int BgL_offsetz00_2064;

														BgL_arrayz00_2063 = BgL_arg2334z00_2061;
														BgL_offsetz00_2064 =
															(int) (BgL_objzd2classzd2numz00_2060);
														{	/* Inline/inline.scm 163 */
															long BgL_offsetz00_2065;

															BgL_offsetz00_2065 =
																((long) (BgL_offsetz00_2064) - OBJECT_TYPE);
															{	/* Inline/inline.scm 163 */
																long BgL_modz00_2066;

																{	/* Inline/inline.scm 163 */
																	int BgL_arg2336z00_2067;

																	BgL_arg2336z00_2067 = (int) (((long) 8));
																	{	/* Inline/inline.scm 163 */
																		long BgL_auxz00_3532;

																		BgL_auxz00_3532 =
																			(long) (BgL_arg2336z00_2067);
																		BgL_modz00_2066 =
																			(BgL_offsetz00_2065 / BgL_auxz00_3532);
																}}
																{	/* Inline/inline.scm 163 */
																	long BgL_restz00_2068;

																	{	/* Inline/inline.scm 163 */
																		int BgL_arg2335z00_2069;

																		BgL_arg2335z00_2069 = (int) (((long) 8));
																		{	/* Inline/inline.scm 163 */
																			long BgL_auxz00_3536;

																			BgL_auxz00_3536 =
																				(long) (BgL_arg2335z00_2069);
																			BgL_restz00_2068 =
																				(BgL_offsetz00_2065 % BgL_auxz00_3536);
																	}}
																	{	/* Inline/inline.scm 163 */

																		BgL_method3178z00_2058 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2063,
																				(int) (BgL_modz00_2066)),
																			(int) (BgL_restz00_2068));
										}}}}}}}}
										BgL_res3453z00_2083 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_2058) (BgL_method3178z00_2058,
												(obj_t) (BgL_arg3353z00_1371),
												BINT(BgL_kfactorz00_2056), BgL_stackz00_1362, BEOA));
								}}
								BgL_arg3352z00_1370 = BgL_res3453z00_2083;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1360))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3352z00_1370), BUNSPEC);
					}
					BgL_auxz00_3467 = BgL_nodez00_1360;
					return (obj_t) (BgL_auxz00_3467);
				}
			}
		}
	}



/* inline-node-conditio3200 */
	obj_t BGl_inlinezd2nodezd2conditio3200z00zzinline_inlinez00(obj_t
		BgL_envz00_2645, obj_t BgL_nodez00_2646, obj_t BgL_kfactorz00_2647,
		obj_t BgL_stackz00_2648)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 149 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1346;

				obj_t BgL_kfactorz00_1347;

				obj_t BgL_stackz00_1348;

				{	/* Inline/inline.scm 150 */
					BgL_conditionalz00_bglt BgL_auxz00_3551;

					BgL_nodez00_1346 = (BgL_conditionalz00_bglt) (BgL_nodez00_2646);
					BgL_kfactorz00_1347 = BgL_kfactorz00_2647;
					BgL_stackz00_1348 = BgL_stackz00_2648;
					{	/* Inline/inline.scm 151 */
						BgL_nodez00_bglt BgL_arg3341z00_1352;

						{	/* Inline/inline.scm 151 */
							BgL_nodez00_bglt BgL_arg3342z00_1353;

							BgL_arg3342z00_1353 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1346))->
								BgL_testz00);
							{	/* Inline/inline.scm 151 */
								BgL_nodez00_bglt BgL_res3438z00_1923;

								{	/* Inline/inline.scm 151 */
									long BgL_kfactorz00_1896;

									BgL_kfactorz00_1896 = (long) CINT(BgL_kfactorz00_1347);
									{	/* Inline/inline.scm 151 */
										obj_t BgL_method3178z00_1898;

										{	/* Inline/inline.scm 151 */
											BgL_objectz00_bglt BgL_objz00_1899;

											BgL_objz00_1899 =
												(BgL_objectz00_bglt) (BgL_arg3342z00_1353);
											{	/* Inline/inline.scm 151 */
												long BgL_objzd2classzd2numz00_1900;

												BgL_objzd2classzd2numz00_1900 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1899);
												{	/* Inline/inline.scm 151 */
													obj_t BgL_arg2334z00_1901;

													BgL_arg2334z00_1901 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 151 */
														obj_t BgL_arrayz00_1903;

														int BgL_offsetz00_1904;

														BgL_arrayz00_1903 = BgL_arg2334z00_1901;
														BgL_offsetz00_1904 =
															(int) (BgL_objzd2classzd2numz00_1900);
														{	/* Inline/inline.scm 151 */
															long BgL_offsetz00_1905;

															BgL_offsetz00_1905 =
																((long) (BgL_offsetz00_1904) - OBJECT_TYPE);
															{	/* Inline/inline.scm 151 */
																long BgL_modz00_1906;

																{	/* Inline/inline.scm 151 */
																	int BgL_arg2336z00_1907;

																	BgL_arg2336z00_1907 = (int) (((long) 8));
																	{	/* Inline/inline.scm 151 */
																		long BgL_auxz00_3562;

																		BgL_auxz00_3562 =
																			(long) (BgL_arg2336z00_1907);
																		BgL_modz00_1906 =
																			(BgL_offsetz00_1905 / BgL_auxz00_3562);
																}}
																{	/* Inline/inline.scm 151 */
																	long BgL_restz00_1908;

																	{	/* Inline/inline.scm 151 */
																		int BgL_arg2335z00_1909;

																		BgL_arg2335z00_1909 = (int) (((long) 8));
																		{	/* Inline/inline.scm 151 */
																			long BgL_auxz00_3566;

																			BgL_auxz00_3566 =
																				(long) (BgL_arg2335z00_1909);
																			BgL_restz00_1908 =
																				(BgL_offsetz00_1905 % BgL_auxz00_3566);
																	}}
																	{	/* Inline/inline.scm 151 */

																		BgL_method3178z00_1898 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1903,
																				(int) (BgL_modz00_1906)),
																			(int) (BgL_restz00_1908));
										}}}}}}}}
										BgL_res3438z00_1923 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_1898) (BgL_method3178z00_1898,
												(obj_t) (BgL_arg3342z00_1353),
												BINT(BgL_kfactorz00_1896), BgL_stackz00_1348, BEOA));
								}}
								BgL_arg3341z00_1352 = BgL_res3438z00_1923;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1346))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3341z00_1352), BUNSPEC);
					}
					{	/* Inline/inline.scm 152 */
						BgL_nodez00_bglt BgL_arg3343z00_1354;

						{	/* Inline/inline.scm 152 */
							BgL_nodez00_bglt BgL_arg3344z00_1355;

							BgL_arg3344z00_1355 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1346))->
								BgL_truez00);
							{	/* Inline/inline.scm 152 */
								BgL_nodez00_bglt BgL_res3441z00_1955;

								{	/* Inline/inline.scm 152 */
									long BgL_kfactorz00_1928;

									BgL_kfactorz00_1928 = (long) CINT(BgL_kfactorz00_1347);
									{	/* Inline/inline.scm 152 */
										obj_t BgL_method3178z00_1930;

										{	/* Inline/inline.scm 152 */
											BgL_objectz00_bglt BgL_objz00_1931;

											BgL_objz00_1931 =
												(BgL_objectz00_bglt) (BgL_arg3344z00_1355);
											{	/* Inline/inline.scm 152 */
												long BgL_objzd2classzd2numz00_1932;

												BgL_objzd2classzd2numz00_1932 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1931);
												{	/* Inline/inline.scm 152 */
													obj_t BgL_arg2334z00_1933;

													BgL_arg2334z00_1933 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 152 */
														obj_t BgL_arrayz00_1935;

														int BgL_offsetz00_1936;

														BgL_arrayz00_1935 = BgL_arg2334z00_1933;
														BgL_offsetz00_1936 =
															(int) (BgL_objzd2classzd2numz00_1932);
														{	/* Inline/inline.scm 152 */
															long BgL_offsetz00_1937;

															BgL_offsetz00_1937 =
																((long) (BgL_offsetz00_1936) - OBJECT_TYPE);
															{	/* Inline/inline.scm 152 */
																long BgL_modz00_1938;

																{	/* Inline/inline.scm 152 */
																	int BgL_arg2336z00_1939;

																	BgL_arg2336z00_1939 = (int) (((long) 8));
																	{	/* Inline/inline.scm 152 */
																		long BgL_auxz00_3589;

																		BgL_auxz00_3589 =
																			(long) (BgL_arg2336z00_1939);
																		BgL_modz00_1938 =
																			(BgL_offsetz00_1937 / BgL_auxz00_3589);
																}}
																{	/* Inline/inline.scm 152 */
																	long BgL_restz00_1940;

																	{	/* Inline/inline.scm 152 */
																		int BgL_arg2335z00_1941;

																		BgL_arg2335z00_1941 = (int) (((long) 8));
																		{	/* Inline/inline.scm 152 */
																			long BgL_auxz00_3593;

																			BgL_auxz00_3593 =
																				(long) (BgL_arg2335z00_1941);
																			BgL_restz00_1940 =
																				(BgL_offsetz00_1937 % BgL_auxz00_3593);
																	}}
																	{	/* Inline/inline.scm 152 */

																		BgL_method3178z00_1930 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1935,
																				(int) (BgL_modz00_1938)),
																			(int) (BgL_restz00_1940));
										}}}}}}}}
										BgL_res3441z00_1955 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_1930) (BgL_method3178z00_1930,
												(obj_t) (BgL_arg3344z00_1355),
												BINT(BgL_kfactorz00_1928), BgL_stackz00_1348, BEOA));
								}}
								BgL_arg3343z00_1354 = BgL_res3441z00_1955;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1346))->BgL_truez00) =
							((BgL_nodez00_bglt) BgL_arg3343z00_1354), BUNSPEC);
					}
					{	/* Inline/inline.scm 153 */
						BgL_nodez00_bglt BgL_arg3345z00_1356;

						{	/* Inline/inline.scm 153 */
							BgL_nodez00_bglt BgL_arg3346z00_1357;

							BgL_arg3346z00_1357 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1346))->
								BgL_falsez00);
							{	/* Inline/inline.scm 153 */
								BgL_nodez00_bglt BgL_res3444z00_1987;

								{	/* Inline/inline.scm 153 */
									long BgL_kfactorz00_1960;

									BgL_kfactorz00_1960 = (long) CINT(BgL_kfactorz00_1347);
									{	/* Inline/inline.scm 153 */
										obj_t BgL_method3178z00_1962;

										{	/* Inline/inline.scm 153 */
											BgL_objectz00_bglt BgL_objz00_1963;

											BgL_objz00_1963 =
												(BgL_objectz00_bglt) (BgL_arg3346z00_1357);
											{	/* Inline/inline.scm 153 */
												long BgL_objzd2classzd2numz00_1964;

												BgL_objzd2classzd2numz00_1964 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1963);
												{	/* Inline/inline.scm 153 */
													obj_t BgL_arg2334z00_1965;

													BgL_arg2334z00_1965 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 153 */
														obj_t BgL_arrayz00_1967;

														int BgL_offsetz00_1968;

														BgL_arrayz00_1967 = BgL_arg2334z00_1965;
														BgL_offsetz00_1968 =
															(int) (BgL_objzd2classzd2numz00_1964);
														{	/* Inline/inline.scm 153 */
															long BgL_offsetz00_1969;

															BgL_offsetz00_1969 =
																((long) (BgL_offsetz00_1968) - OBJECT_TYPE);
															{	/* Inline/inline.scm 153 */
																long BgL_modz00_1970;

																{	/* Inline/inline.scm 153 */
																	int BgL_arg2336z00_1971;

																	BgL_arg2336z00_1971 = (int) (((long) 8));
																	{	/* Inline/inline.scm 153 */
																		long BgL_auxz00_3616;

																		BgL_auxz00_3616 =
																			(long) (BgL_arg2336z00_1971);
																		BgL_modz00_1970 =
																			(BgL_offsetz00_1969 / BgL_auxz00_3616);
																}}
																{	/* Inline/inline.scm 153 */
																	long BgL_restz00_1972;

																	{	/* Inline/inline.scm 153 */
																		int BgL_arg2335z00_1973;

																		BgL_arg2335z00_1973 = (int) (((long) 8));
																		{	/* Inline/inline.scm 153 */
																			long BgL_auxz00_3620;

																			BgL_auxz00_3620 =
																				(long) (BgL_arg2335z00_1973);
																			BgL_restz00_1972 =
																				(BgL_offsetz00_1969 % BgL_auxz00_3620);
																	}}
																	{	/* Inline/inline.scm 153 */

																		BgL_method3178z00_1962 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1967,
																				(int) (BgL_modz00_1970)),
																			(int) (BgL_restz00_1972));
										}}}}}}}}
										BgL_res3444z00_1987 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_1962) (BgL_method3178z00_1962,
												(obj_t) (BgL_arg3346z00_1357),
												BINT(BgL_kfactorz00_1960), BgL_stackz00_1348, BEOA));
								}}
								BgL_arg3345z00_1356 = BgL_res3444z00_1987;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1346))->
								BgL_falsez00) =
							((BgL_nodez00_bglt) BgL_arg3345z00_1356), BUNSPEC);
					}
					BgL_auxz00_3551 = BgL_nodez00_1346;
					return (obj_t) (BgL_auxz00_3551);
				}
			}
		}
	}



/* inline-node-setq3198 */
	obj_t BGl_inlinezd2nodezd2setq3198z00zzinline_inlinez00(obj_t BgL_envz00_2649,
		obj_t BgL_nodez00_2650, obj_t BgL_kfactorz00_2651, obj_t BgL_stackz00_2652)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 142 */
			{
				BgL_setqz00_bglt BgL_nodez00_1337;

				obj_t BgL_kfactorz00_1338;

				obj_t BgL_stackz00_1339;

				{	/* Inline/inline.scm 143 */
					BgL_setqz00_bglt BgL_auxz00_3635;

					BgL_nodez00_1337 = (BgL_setqz00_bglt) (BgL_nodez00_2650);
					BgL_kfactorz00_1338 = BgL_kfactorz00_2651;
					BgL_stackz00_1339 = BgL_stackz00_2652;
					{	/* Inline/inline.scm 143 */
						BgL_nodez00_bglt BgL_arg3338z00_1860;

						{	/* Inline/inline.scm 143 */
							BgL_nodez00_bglt BgL_arg3339z00_1861;

							BgL_arg3339z00_1861 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1337))->BgL_valuez00);
							{	/* Inline/inline.scm 143 */
								BgL_nodez00_bglt BgL_res3435z00_1891;

								{	/* Inline/inline.scm 143 */
									long BgL_kfactorz00_1864;

									BgL_kfactorz00_1864 = (long) CINT(BgL_kfactorz00_1338);
									{	/* Inline/inline.scm 143 */
										obj_t BgL_method3178z00_1866;

										{	/* Inline/inline.scm 143 */
											BgL_objectz00_bglt BgL_objz00_1867;

											BgL_objz00_1867 =
												(BgL_objectz00_bglt) (BgL_arg3339z00_1861);
											{	/* Inline/inline.scm 143 */
												long BgL_objzd2classzd2numz00_1868;

												BgL_objzd2classzd2numz00_1868 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1867);
												{	/* Inline/inline.scm 143 */
													obj_t BgL_arg2334z00_1869;

													BgL_arg2334z00_1869 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 143 */
														obj_t BgL_arrayz00_1871;

														int BgL_offsetz00_1872;

														BgL_arrayz00_1871 = BgL_arg2334z00_1869;
														BgL_offsetz00_1872 =
															(int) (BgL_objzd2classzd2numz00_1868);
														{	/* Inline/inline.scm 143 */
															long BgL_offsetz00_1873;

															BgL_offsetz00_1873 =
																((long) (BgL_offsetz00_1872) - OBJECT_TYPE);
															{	/* Inline/inline.scm 143 */
																long BgL_modz00_1874;

																{	/* Inline/inline.scm 143 */
																	int BgL_arg2336z00_1875;

																	BgL_arg2336z00_1875 = (int) (((long) 8));
																	{	/* Inline/inline.scm 143 */
																		long BgL_auxz00_3646;

																		BgL_auxz00_3646 =
																			(long) (BgL_arg2336z00_1875);
																		BgL_modz00_1874 =
																			(BgL_offsetz00_1873 / BgL_auxz00_3646);
																}}
																{	/* Inline/inline.scm 143 */
																	long BgL_restz00_1876;

																	{	/* Inline/inline.scm 143 */
																		int BgL_arg2335z00_1877;

																		BgL_arg2335z00_1877 = (int) (((long) 8));
																		{	/* Inline/inline.scm 143 */
																			long BgL_auxz00_3650;

																			BgL_auxz00_3650 =
																				(long) (BgL_arg2335z00_1877);
																			BgL_restz00_1876 =
																				(BgL_offsetz00_1873 % BgL_auxz00_3650);
																	}}
																	{	/* Inline/inline.scm 143 */

																		BgL_method3178z00_1866 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1871,
																				(int) (BgL_modz00_1874)),
																			(int) (BgL_restz00_1876));
										}}}}}}}}
										BgL_res3435z00_1891 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_1866) (BgL_method3178z00_1866,
												(obj_t) (BgL_arg3339z00_1861),
												BINT(BgL_kfactorz00_1864), BgL_stackz00_1339, BEOA));
								}}
								BgL_arg3338z00_1860 = BgL_res3435z00_1891;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1337))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3338z00_1860), BUNSPEC);
					}
					BgL_auxz00_3635 = BgL_nodez00_1337;
					return (obj_t) (BgL_auxz00_3635);
				}
			}
		}
	}



/* inline-node-cast3196 */
	obj_t BGl_inlinezd2nodezd2cast3196z00zzinline_inlinez00(obj_t BgL_envz00_2653,
		obj_t BgL_nodez00_2654, obj_t BgL_kfactorz00_2655, obj_t BgL_stackz00_2656)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 135 */
			{
				BgL_castz00_bglt BgL_nodez00_1329;

				obj_t BgL_kfactorz00_1330;

				obj_t BgL_stackz00_1331;

				{	/* Inline/inline.scm 136 */
					BgL_castz00_bglt BgL_auxz00_3665;

					BgL_nodez00_1329 = (BgL_castz00_bglt) (BgL_nodez00_2654);
					BgL_kfactorz00_1330 = BgL_kfactorz00_2655;
					BgL_stackz00_1331 = BgL_stackz00_2656;
					{	/* Inline/inline.scm 136 */
						BgL_nodez00_bglt BgL_arg3336z00_1829;

						BgL_arg3336z00_1829 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1329))->BgL_argz00);
						{	/* Inline/inline.scm 136 */
							BgL_nodez00_bglt BgL_res3432z00_1859;

							{	/* Inline/inline.scm 136 */
								long BgL_kfactorz00_1832;

								BgL_kfactorz00_1832 = (long) CINT(BgL_kfactorz00_1330);
								{	/* Inline/inline.scm 136 */
									obj_t BgL_method3178z00_1834;

									{	/* Inline/inline.scm 136 */
										BgL_objectz00_bglt BgL_objz00_1835;

										BgL_objz00_1835 =
											(BgL_objectz00_bglt) (BgL_arg3336z00_1829);
										{	/* Inline/inline.scm 136 */
											long BgL_objzd2classzd2numz00_1836;

											BgL_objzd2classzd2numz00_1836 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_1835);
											{	/* Inline/inline.scm 136 */
												obj_t BgL_arg2334z00_1837;

												BgL_arg2334z00_1837 =
													PROCEDURE_REF
													(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
													(int) (((long) 1)));
												{	/* Inline/inline.scm 136 */
													obj_t BgL_arrayz00_1839;

													int BgL_offsetz00_1840;

													BgL_arrayz00_1839 = BgL_arg2334z00_1837;
													BgL_offsetz00_1840 =
														(int) (BgL_objzd2classzd2numz00_1836);
													{	/* Inline/inline.scm 136 */
														long BgL_offsetz00_1841;

														BgL_offsetz00_1841 =
															((long) (BgL_offsetz00_1840) - OBJECT_TYPE);
														{	/* Inline/inline.scm 136 */
															long BgL_modz00_1842;

															{	/* Inline/inline.scm 136 */
																int BgL_arg2336z00_1843;

																BgL_arg2336z00_1843 = (int) (((long) 8));
																{	/* Inline/inline.scm 136 */
																	long BgL_auxz00_3676;

																	BgL_auxz00_3676 =
																		(long) (BgL_arg2336z00_1843);
																	BgL_modz00_1842 =
																		(BgL_offsetz00_1841 / BgL_auxz00_3676);
															}}
															{	/* Inline/inline.scm 136 */
																long BgL_restz00_1844;

																{	/* Inline/inline.scm 136 */
																	int BgL_arg2335z00_1845;

																	BgL_arg2335z00_1845 = (int) (((long) 8));
																	{	/* Inline/inline.scm 136 */
																		long BgL_auxz00_3680;

																		BgL_auxz00_3680 =
																			(long) (BgL_arg2335z00_1845);
																		BgL_restz00_1844 =
																			(BgL_offsetz00_1841 % BgL_auxz00_3680);
																}}
																{	/* Inline/inline.scm 136 */

																	BgL_method3178z00_1834 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_1839,
																			(int) (BgL_modz00_1842)),
																		(int) (BgL_restz00_1844));
									}}}}}}}}
									BgL_res3432z00_1859 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3178z00_1834)
										(BgL_method3178z00_1834, (obj_t) (BgL_arg3336z00_1829),
											BINT(BgL_kfactorz00_1832), BgL_stackz00_1331, BEOA));
							}} BgL_res3432z00_1859;
					}}
					BgL_auxz00_3665 = BgL_nodez00_1329;
					return (obj_t) (BgL_auxz00_3665);
				}
			}
		}
	}



/* inline-node-extern3194 */
	obj_t BGl_inlinezd2nodezd2extern3194z00zzinline_inlinez00(obj_t
		BgL_envz00_2657, obj_t BgL_nodez00_2658, obj_t BgL_kfactorz00_2659,
		obj_t BgL_stackz00_2660)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 128 */
			{
				BgL_externz00_bglt BgL_nodez00_1321;

				obj_t BgL_kfactorz00_1322;

				obj_t BgL_stackz00_1323;

				{	/* Inline/inline.scm 129 */
					BgL_externz00_bglt BgL_auxz00_3694;

					BgL_nodez00_1321 = (BgL_externz00_bglt) (BgL_nodez00_2658);
					BgL_kfactorz00_1322 = BgL_kfactorz00_2659;
					BgL_stackz00_1323 = BgL_stackz00_2660;
					{	/* Inline/inline.scm 129 */
						obj_t BgL_arg3334z00_1827;

						BgL_arg3334z00_1827 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1321))->BgL_exprza2za2);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3334z00_1827,
							BgL_kfactorz00_1322, BgL_stackz00_1323);
					}
					BgL_auxz00_3694 = BgL_nodez00_1321;
					return (obj_t) (BgL_auxz00_3694);
				}
			}
		}
	}



/* inline-node-funcall3192 */
	obj_t BGl_inlinezd2nodezd2funcall3192z00zzinline_inlinez00(obj_t
		BgL_envz00_2661, obj_t BgL_nodez00_2662, obj_t BgL_kfactorz00_2663,
		obj_t BgL_stackz00_2664)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 118 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1311;

				obj_t BgL_kfactorz00_1312;

				obj_t BgL_stackz00_1313;

				{	/* Inline/inline.scm 120 */
					BgL_funcallz00_bglt BgL_auxz00_3699;

					BgL_nodez00_1311 = (BgL_funcallz00_bglt) (BgL_nodez00_2662);
					BgL_kfactorz00_1312 = BgL_kfactorz00_2663;
					BgL_stackz00_1313 = BgL_stackz00_2664;
					{	/* Inline/inline.scm 120 */
						long BgL_za71za7_1792;

						BgL_za71za7_1792 =
							(long) CINT(BGl_za2nonzd2inlinedzd2callsza2z00zzinline_walkz00);
						BGl_za2nonzd2inlinedzd2callsza2z00zzinline_walkz00 =
							BINT((BgL_za71za7_1792 + ((long) 1)));
					}
					{	/* Inline/inline.scm 121 */
						BgL_nodez00_bglt BgL_arg3330z00_1316;

						{	/* Inline/inline.scm 121 */
							BgL_nodez00_bglt BgL_arg3331z00_1317;

							BgL_arg3331z00_1317 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1311))->BgL_funz00);
							{	/* Inline/inline.scm 121 */
								BgL_nodez00_bglt BgL_res3429z00_1823;

								{	/* Inline/inline.scm 121 */
									long BgL_kfactorz00_1796;

									BgL_kfactorz00_1796 = (long) CINT(BgL_kfactorz00_1312);
									{	/* Inline/inline.scm 121 */
										obj_t BgL_method3178z00_1798;

										{	/* Inline/inline.scm 121 */
											BgL_objectz00_bglt BgL_objz00_1799;

											BgL_objz00_1799 =
												(BgL_objectz00_bglt) (BgL_arg3331z00_1317);
											{	/* Inline/inline.scm 121 */
												long BgL_objzd2classzd2numz00_1800;

												BgL_objzd2classzd2numz00_1800 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1799);
												{	/* Inline/inline.scm 121 */
													obj_t BgL_arg2334z00_1801;

													BgL_arg2334z00_1801 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 121 */
														obj_t BgL_arrayz00_1803;

														int BgL_offsetz00_1804;

														BgL_arrayz00_1803 = BgL_arg2334z00_1801;
														BgL_offsetz00_1804 =
															(int) (BgL_objzd2classzd2numz00_1800);
														{	/* Inline/inline.scm 121 */
															long BgL_offsetz00_1805;

															BgL_offsetz00_1805 =
																((long) (BgL_offsetz00_1804) - OBJECT_TYPE);
															{	/* Inline/inline.scm 121 */
																long BgL_modz00_1806;

																{	/* Inline/inline.scm 121 */
																	int BgL_arg2336z00_1807;

																	BgL_arg2336z00_1807 = (int) (((long) 8));
																	{	/* Inline/inline.scm 121 */
																		long BgL_auxz00_3713;

																		BgL_auxz00_3713 =
																			(long) (BgL_arg2336z00_1807);
																		BgL_modz00_1806 =
																			(BgL_offsetz00_1805 / BgL_auxz00_3713);
																}}
																{	/* Inline/inline.scm 121 */
																	long BgL_restz00_1808;

																	{	/* Inline/inline.scm 121 */
																		int BgL_arg2335z00_1809;

																		BgL_arg2335z00_1809 = (int) (((long) 8));
																		{	/* Inline/inline.scm 121 */
																			long BgL_auxz00_3717;

																			BgL_auxz00_3717 =
																				(long) (BgL_arg2335z00_1809);
																			BgL_restz00_1808 =
																				(BgL_offsetz00_1805 % BgL_auxz00_3717);
																	}}
																	{	/* Inline/inline.scm 121 */

																		BgL_method3178z00_1798 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1803,
																				(int) (BgL_modz00_1806)),
																			(int) (BgL_restz00_1808));
										}}}}}}}}
										BgL_res3429z00_1823 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_1798) (BgL_method3178z00_1798,
												(obj_t) (BgL_arg3331z00_1317),
												BINT(BgL_kfactorz00_1796), BgL_stackz00_1313, BEOA));
								}}
								BgL_arg3330z00_1316 = BgL_res3429z00_1823;
						}}
						((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1311))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3330z00_1316), BUNSPEC);
					}
					{	/* Inline/inline.scm 122 */
						obj_t BgL_arg3332z00_1318;

						BgL_arg3332z00_1318 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1311))->BgL_argsz00);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3332z00_1318,
							BgL_kfactorz00_1312, BgL_stackz00_1313);
					}
					BgL_auxz00_3699 = BgL_nodez00_1311;
					return (obj_t) (BgL_auxz00_3699);
				}
			}
		}
	}



/* inline-node-app-ly3190 */
	obj_t BGl_inlinezd2nodezd2appzd2ly3190zd2zzinline_inlinez00(obj_t
		BgL_envz00_2665, obj_t BgL_nodez00_2666, obj_t BgL_kfactorz00_2667,
		obj_t BgL_stackz00_2668)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 109 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1299;

				obj_t BgL_kfactorz00_1300;

				obj_t BgL_stackz00_1301;

				{	/* Inline/inline.scm 110 */
					BgL_appzd2lyzd2_bglt BgL_auxz00_3734;

					BgL_nodez00_1299 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_2666);
					BgL_kfactorz00_1300 = BgL_kfactorz00_2667;
					BgL_stackz00_1301 = BgL_stackz00_2668;
					{	/* Inline/inline.scm 111 */
						BgL_nodez00_bglt BgL_arg3325z00_1305;

						{	/* Inline/inline.scm 111 */
							BgL_nodez00_bglt BgL_arg3326z00_1306;

							BgL_arg3326z00_1306 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1299))->BgL_funz00);
							{	/* Inline/inline.scm 111 */
								BgL_nodez00_bglt BgL_res3423z00_1757;

								{	/* Inline/inline.scm 111 */
									long BgL_kfactorz00_1730;

									BgL_kfactorz00_1730 = (long) CINT(BgL_kfactorz00_1300);
									{	/* Inline/inline.scm 111 */
										obj_t BgL_method3178z00_1732;

										{	/* Inline/inline.scm 111 */
											BgL_objectz00_bglt BgL_objz00_1733;

											BgL_objz00_1733 =
												(BgL_objectz00_bglt) (BgL_arg3326z00_1306);
											{	/* Inline/inline.scm 111 */
												long BgL_objzd2classzd2numz00_1734;

												BgL_objzd2classzd2numz00_1734 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1733);
												{	/* Inline/inline.scm 111 */
													obj_t BgL_arg2334z00_1735;

													BgL_arg2334z00_1735 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 111 */
														obj_t BgL_arrayz00_1737;

														int BgL_offsetz00_1738;

														BgL_arrayz00_1737 = BgL_arg2334z00_1735;
														BgL_offsetz00_1738 =
															(int) (BgL_objzd2classzd2numz00_1734);
														{	/* Inline/inline.scm 111 */
															long BgL_offsetz00_1739;

															BgL_offsetz00_1739 =
																((long) (BgL_offsetz00_1738) - OBJECT_TYPE);
															{	/* Inline/inline.scm 111 */
																long BgL_modz00_1740;

																{	/* Inline/inline.scm 111 */
																	int BgL_arg2336z00_1741;

																	BgL_arg2336z00_1741 = (int) (((long) 8));
																	{	/* Inline/inline.scm 111 */
																		long BgL_auxz00_3745;

																		BgL_auxz00_3745 =
																			(long) (BgL_arg2336z00_1741);
																		BgL_modz00_1740 =
																			(BgL_offsetz00_1739 / BgL_auxz00_3745);
																}}
																{	/* Inline/inline.scm 111 */
																	long BgL_restz00_1742;

																	{	/* Inline/inline.scm 111 */
																		int BgL_arg2335z00_1743;

																		BgL_arg2335z00_1743 = (int) (((long) 8));
																		{	/* Inline/inline.scm 111 */
																			long BgL_auxz00_3749;

																			BgL_auxz00_3749 =
																				(long) (BgL_arg2335z00_1743);
																			BgL_restz00_1742 =
																				(BgL_offsetz00_1739 % BgL_auxz00_3749);
																	}}
																	{	/* Inline/inline.scm 111 */

																		BgL_method3178z00_1732 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1737,
																				(int) (BgL_modz00_1740)),
																			(int) (BgL_restz00_1742));
										}}}}}}}}
										BgL_res3423z00_1757 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_1732) (BgL_method3178z00_1732,
												(obj_t) (BgL_arg3326z00_1306),
												BINT(BgL_kfactorz00_1730), BgL_stackz00_1301, BEOA));
								}}
								BgL_arg3325z00_1305 = BgL_res3423z00_1757;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1299))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3325z00_1305), BUNSPEC);
					}
					{	/* Inline/inline.scm 112 */
						BgL_nodez00_bglt BgL_arg3327z00_1307;

						{	/* Inline/inline.scm 112 */
							BgL_nodez00_bglt BgL_arg3328z00_1308;

							BgL_arg3328z00_1308 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1299))->BgL_argz00);
							{	/* Inline/inline.scm 112 */
								BgL_nodez00_bglt BgL_res3426z00_1789;

								{	/* Inline/inline.scm 112 */
									long BgL_kfactorz00_1762;

									BgL_kfactorz00_1762 = (long) CINT(BgL_kfactorz00_1300);
									{	/* Inline/inline.scm 112 */
										obj_t BgL_method3178z00_1764;

										{	/* Inline/inline.scm 112 */
											BgL_objectz00_bglt BgL_objz00_1765;

											BgL_objz00_1765 =
												(BgL_objectz00_bglt) (BgL_arg3328z00_1308);
											{	/* Inline/inline.scm 112 */
												long BgL_objzd2classzd2numz00_1766;

												BgL_objzd2classzd2numz00_1766 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1765);
												{	/* Inline/inline.scm 112 */
													obj_t BgL_arg2334z00_1767;

													BgL_arg2334z00_1767 =
														PROCEDURE_REF
														(BGl_inlinezd2nodezd2envz00zzinline_inlinez00,
														(int) (((long) 1)));
													{	/* Inline/inline.scm 112 */
														obj_t BgL_arrayz00_1769;

														int BgL_offsetz00_1770;

														BgL_arrayz00_1769 = BgL_arg2334z00_1767;
														BgL_offsetz00_1770 =
															(int) (BgL_objzd2classzd2numz00_1766);
														{	/* Inline/inline.scm 112 */
															long BgL_offsetz00_1771;

															BgL_offsetz00_1771 =
																((long) (BgL_offsetz00_1770) - OBJECT_TYPE);
															{	/* Inline/inline.scm 112 */
																long BgL_modz00_1772;

																{	/* Inline/inline.scm 112 */
																	int BgL_arg2336z00_1773;

																	BgL_arg2336z00_1773 = (int) (((long) 8));
																	{	/* Inline/inline.scm 112 */
																		long BgL_auxz00_3772;

																		BgL_auxz00_3772 =
																			(long) (BgL_arg2336z00_1773);
																		BgL_modz00_1772 =
																			(BgL_offsetz00_1771 / BgL_auxz00_3772);
																}}
																{	/* Inline/inline.scm 112 */
																	long BgL_restz00_1774;

																	{	/* Inline/inline.scm 112 */
																		int BgL_arg2335z00_1775;

																		BgL_arg2335z00_1775 = (int) (((long) 8));
																		{	/* Inline/inline.scm 112 */
																			long BgL_auxz00_3776;

																			BgL_auxz00_3776 =
																				(long) (BgL_arg2335z00_1775);
																			BgL_restz00_1774 =
																				(BgL_offsetz00_1771 % BgL_auxz00_3776);
																	}}
																	{	/* Inline/inline.scm 112 */

																		BgL_method3178z00_1764 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1769,
																				(int) (BgL_modz00_1772)),
																			(int) (BgL_restz00_1774));
										}}}}}}}}
										BgL_res3426z00_1789 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3178z00_1764) (BgL_method3178z00_1764,
												(obj_t) (BgL_arg3328z00_1308),
												BINT(BgL_kfactorz00_1762), BgL_stackz00_1301, BEOA));
								}}
								BgL_arg3327z00_1307 = BgL_res3426z00_1789;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1299))->BgL_argz00) =
							((BgL_nodez00_bglt) BgL_arg3327z00_1307), BUNSPEC);
					}
					BgL_auxz00_3734 = BgL_nodez00_1299;
					return (obj_t) (BgL_auxz00_3734);
				}
			}
		}
	}



/* inline-node-app3188 */
	obj_t BGl_inlinezd2nodezd2app3188z00zzinline_inlinez00(obj_t BgL_envz00_2669,
		obj_t BgL_nodez00_2670, obj_t BgL_kfactorz00_2671, obj_t BgL_stackz00_2672)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 102 */
			{
				BgL_appz00_bglt BgL_nodez00_1291;

				obj_t BgL_kfactorz00_1292;

				obj_t BgL_stackz00_1293;

				{	/* Inline/inline.scm 103 */
					BgL_nodez00_bglt BgL_auxz00_3791;

					BgL_nodez00_1291 = (BgL_appz00_bglt) (BgL_nodez00_2670);
					BgL_kfactorz00_1292 = BgL_kfactorz00_2671;
					BgL_stackz00_1293 = BgL_stackz00_2672;
					{	/* Inline/inline.scm 103 */
						obj_t BgL_arg3323z00_1726;

						BgL_arg3323z00_1726 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1291))->BgL_argsz00);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3323z00_1726,
							BgL_kfactorz00_1292, BgL_stackz00_1293);
					}
					BgL_auxz00_3791 =
						BGl_inlinezd2appzd2zzinline_appz00(BgL_nodez00_1291,
						(long) CINT(BgL_kfactorz00_1292), BgL_stackz00_1293);
					return (obj_t) (BgL_auxz00_3791);
				}
			}
		}
	}



/* inline-node-sequence3186 */
	obj_t BGl_inlinezd2nodezd2sequence3186z00zzinline_inlinez00(obj_t
		BgL_envz00_2673, obj_t BgL_nodez00_2674, obj_t BgL_kfactorz00_2675,
		obj_t BgL_stackz00_2676)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 95 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1283;

				obj_t BgL_kfactorz00_1284;

				obj_t BgL_stackz00_1285;

				{	/* Inline/inline.scm 96 */
					BgL_sequencez00_bglt BgL_auxz00_3798;

					BgL_nodez00_1283 = (BgL_sequencez00_bglt) (BgL_nodez00_2674);
					BgL_kfactorz00_1284 = BgL_kfactorz00_2675;
					BgL_stackz00_1285 = BgL_stackz00_2676;
					{	/* Inline/inline.scm 96 */
						obj_t BgL_arg3321z00_1724;

						BgL_arg3321z00_1724 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1283))->BgL_nodesz00);
						BGl_inlinezd2nodeza2z12z62zzinline_inlinez00(BgL_arg3321z00_1724,
							BgL_kfactorz00_1284, BgL_stackz00_1285);
					}
					BgL_auxz00_3798 = BgL_nodez00_1283;
					return (obj_t) (BgL_auxz00_3798);
				}
			}
		}
	}



/* inline-node-kwote3184 */
	obj_t BGl_inlinezd2nodezd2kwote3184z00zzinline_inlinez00(obj_t
		BgL_envz00_2677, obj_t BgL_nodez00_2678, obj_t BgL_kfactorz00_2679,
		obj_t BgL_stackz00_2680)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 89 */
			return (obj_t) ((BgL_kwotez00_bglt) (BgL_nodez00_2678));
		}
	}



/* inline-node-var3182 */
	obj_t BGl_inlinezd2nodezd2var3182z00zzinline_inlinez00(obj_t BgL_envz00_2681,
		obj_t BgL_nodez00_2682, obj_t BgL_kfactorz00_2683, obj_t BgL_stackz00_2684)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 73 */
			{
				BgL_varz00_bglt BgL_nodez00_1249;

				obj_t BgL_kfactorz00_1250;

				obj_t BgL_stackz00_1251;

				BgL_nodez00_1249 = (BgL_varz00_bglt) (BgL_nodez00_2682);
				BgL_kfactorz00_1250 = BgL_kfactorz00_2683;
				BgL_stackz00_1251 = BgL_stackz00_2684;
				{	/* Inline/inline.scm 75 */
					bool_t BgL_testz00_3805;

					if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) > ((long) 0)))
						{	/* Inline/inline.scm 76 */
							bool_t BgL_testz00_3809;

							{	/* Inline/inline.scm 76 */
								BgL_variablez00_bglt BgL_arg3318z00_1273;

								BgL_arg3318z00_1273 =
									(((BgL_varz00_bglt) CREF(BgL_nodez00_1249))->BgL_variablez00);
								{	/* Inline/inline.scm 76 */
									obj_t BgL_obj1568z00_1713;

									BgL_obj1568z00_1713 = (obj_t) (BgL_arg3318z00_1273);
									BgL_testz00_3809 =
										BGl_iszd2azf3z21zz__objectz00(BgL_obj1568z00_1713,
										BGl_globalz00zzast_varz00);
							}}
							if (BgL_testz00_3809)
								{	/* Inline/inline.scm 77 */
									bool_t BgL_testz00_3813;

									{	/* Inline/inline.scm 77 */
										obj_t BgL_auxz00_3814;

										{	/* Inline/inline.scm 77 */
											BgL_globalz00_bglt BgL_obj1494z00_1715;

											BgL_obj1494z00_1715 =
												(BgL_globalz00_bglt) (
												(((BgL_varz00_bglt) CREF(BgL_nodez00_1249))->
													BgL_variablez00));
											BgL_auxz00_3814 =
												(((BgL_globalz00_bglt) CREF(BgL_obj1494z00_1715))->
												BgL_importz00);
										}
										BgL_testz00_3813 =
											(BgL_auxz00_3814 == CNST_TABLE_REF(((long) 3)));
									}
									if (BgL_testz00_3813)
										{	/* Inline/inline.scm 78 */
											bool_t BgL_testz00_3820;

											{	/* Inline/inline.scm 78 */
												obj_t BgL_auxz00_3821;

												{	/* Inline/inline.scm 78 */
													BgL_variablez00_bglt BgL_obj1429z00_1717;

													BgL_obj1429z00_1717 =
														(((BgL_varz00_bglt) CREF(BgL_nodez00_1249))->
														BgL_variablez00);
													BgL_auxz00_3821 =
														(((BgL_variablez00_bglt)
															CREF(BgL_obj1429z00_1717))->BgL_accessz00);
												}
												BgL_testz00_3820 =
													(BgL_auxz00_3821 == CNST_TABLE_REF(((long) 4)));
											}
											if (BgL_testz00_3820)
												{	/* Inline/inline.scm 79 */
													obj_t BgL_arg3310z00_1265;

													{	/* Inline/inline.scm 79 */
														BgL_globalz00_bglt BgL_obj1511z00_1719;

														BgL_obj1511z00_1719 =
															(BgL_globalz00_bglt) (
															(((BgL_varz00_bglt) CREF(BgL_nodez00_1249))->
																BgL_variablez00));
														BgL_arg3310z00_1265 =
															(((BgL_globalz00_bglt)
																CREF(BgL_obj1511z00_1719))->BgL_srcz00);
													}
													BgL_testz00_3805 =
														BGl_iszd2azf3z21zz__objectz00(BgL_arg3310z00_1265,
														BGl_atomz00zzast_nodez00);
												}
											else
												{	/* Inline/inline.scm 78 */
													BgL_testz00_3805 = ((bool_t) 0);
												}
										}
									else
										{	/* Inline/inline.scm 77 */
											BgL_testz00_3805 = ((bool_t) 0);
										}
								}
							else
								{	/* Inline/inline.scm 76 */
									BgL_testz00_3805 = ((bool_t) 0);
								}
						}
					else
						{	/* Inline/inline.scm 75 */
							BgL_testz00_3805 = ((bool_t) 0);
						}
					if (BgL_testz00_3805)
						{	/* Inline/inline.scm 75 */
							{	/* Inline/inline.scm 83 */
								obj_t BgL_arg3303z00_1258;

								obj_t BgL_arg3304z00_1259;

								{
									BgL_nodez00_bglt BgL_auxz00_3830;

									BgL_auxz00_3830 = (BgL_nodez00_bglt) (BgL_nodez00_1249);
									BgL_arg3303z00_1258 =
										(((BgL_nodez00_bglt) CREF(BgL_auxz00_3830))->BgL_locz00);
								}
								{	/* Inline/inline.scm 83 */
									BgL_globalz00_bglt BgL_obj1511z00_1723;

									BgL_obj1511z00_1723 =
										(BgL_globalz00_bglt) (
										(((BgL_varz00_bglt) CREF(BgL_nodez00_1249))->
											BgL_variablez00));
									BgL_arg3304z00_1259 =
										(((BgL_globalz00_bglt) CREF(BgL_obj1511z00_1723))->
										BgL_srcz00);
								}
								return
									(obj_t) (BGl_alphatiza7eza7zzast_alphatiza7eza7(BNIL, BNIL,
										BgL_arg3303z00_1258,
										(BgL_nodez00_bglt) (BgL_arg3304z00_1259)));
							}
						}
					else
						{	/* Inline/inline.scm 75 */
							return (obj_t) (BgL_nodez00_1249);
						}
				}
			}
		}
	}



/* inline-node-atom3180 */
	obj_t BGl_inlinezd2nodezd2atom3180z00zzinline_inlinez00(obj_t BgL_envz00_2685,
		obj_t BgL_nodez00_2686, obj_t BgL_kfactorz00_2687, obj_t BgL_stackz00_2688)
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 67 */
			return (obj_t) ((BgL_atomz00_bglt) (BgL_nodez00_2686));
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzinline_inlinez00()
	{
		AN_OBJECT;
		{	/* Inline/inline.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzinline_walkz00(((long) 175384950),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzinline_appz00(((long) 472786230),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzast_alphatiza7eza7(((long) 509694479),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
			return
				BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3523z00zzinline_inlinez00));
		}
	}

#ifdef __cplusplus
}
#endif
