/*===========================================================================*/
/*   (Object/creator.scm)                                                    */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Object/creator.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_tclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		struct BgL_globalz00_bgl *BgL_holderz00;
		obj_t BgL_wideningz00;
		long BgL_depthz00;
		bool_t BgL_finalzf3zf3;
		obj_t BgL_constructorz00;
		obj_t BgL_virtualzd2slotszd2numberz00;
		bool_t BgL_abstractzf3zf3;
		obj_t BgL_widezd2typezd2;
	}                *BgL_tclassz00_bglt;

	typedef struct BgL_jclassz00_bgl
	{
		obj_t BgL_itszd2superzd2;
		obj_t BgL_slotsz00;
		obj_t BgL_packagez00;
	}                *BgL_jclassz00_bglt;

	typedef struct BgL_slotz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_srcz00;
		obj_t BgL_classzd2ownerzd2;
		obj_t BgL_typez00;
		bool_t BgL_readzd2onlyzf3z21;
		obj_t BgL_defaultzd2valuezd2;
		obj_t BgL_virtualzd2numzd2;
		obj_t BgL_getterz00;
		obj_t BgL_setterz00;
		obj_t BgL_indexedz00;
		obj_t BgL_userzd2infozd2;
	}              *BgL_slotz00_bglt;


	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static obj_t
		BGl_makezd2classzd2slotzd2makez12zc0zzobject_creatorz00(BgL_tclassz00_bglt,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	static obj_t
		BGl_importzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t BGl_producezd2modulezd2clausez12z12zzmodule_modulez00(obj_t);
	static obj_t
		BGl_genzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2javazd2classzd2constructorszd2zzobject_creatorz00
		(BgL_jclassz00_bglt, obj_t, obj_t);
	extern obj_t BGl_za2profilezd2modeza2zd2zzengine_paramz00;
	BGL_EXPORTED_DECL obj_t
		BGl_importzd2plainzd2classzd2creatorszd2zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t
		BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00(BgL_typez00_bglt,
		BgL_slotz00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzobject_creatorz00 = BUNSPEC;
	static obj_t
		BGl_importzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t BGl_epairifyza2za2zztools_miscz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzobject_creatorz00();
	static obj_t BGl__genzd2widezd2classzd2creatorszd2zzobject_creatorz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_fastzd2idzd2ofzd2idzd2zzast_identz00(obj_t, obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	static obj_t
		BGl_importzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern bool_t BGl_widezd2classzf3z21zzobject_classz00(obj_t);
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	extern obj_t BGl_importzd2parserzd2zzmodule_impusez00(obj_t, obj_t, obj_t);
	extern obj_t
		BGl_makezd2pragmazd2indexedzd2setz12zf2wideningz32zzobject_toolsz00
		(BgL_typez00_bglt, BgL_slotz00_bglt, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zzobject_creatorz00();
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2widezd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt,
		obj_t, obj_t);
	static obj_t
		BGl_genzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzobject_creatorz00();
	extern obj_t BGl_importzd2classzd2nilz00zzobject_nilz00(BgL_tclassz00_bglt,
		obj_t, obj_t);
	static bool_t BGl_inlinezd2creatorszf3z21zzobject_creatorz00();
	extern obj_t
		BGl_findzd2classzd2constructorsz00zzobject_classz00(BgL_tclassz00_bglt);
	static obj_t
		BGl_genzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzobject_creatorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_impusez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_nilz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_slotsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_structz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_toolsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_sawzd2widezd2classzd2idzd2zzobject_classz00(obj_t);
	static obj_t BGl__importzd2javazd2classzd2creatorzd2zzobject_creatorz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_stringzd2sanszd2z42z42zztype_toolsz00(obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	static obj_t BGl_genzd2classzd2allocatez12z12zzobject_creatorz00(obj_t, obj_t,
		BgL_globalz00_bglt, obj_t, obj_t);
	BGL_IMPORT obj_t string_to_symbol(char *);
	BGL_EXPORTED_DECL obj_t
		BGl_importzd2widezd2classzd2creatorszd2zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t
		BGl_genzd2widezd2classzd2nilzd2zzobject_nilz00(BgL_tclassz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00(obj_t);
	static obj_t BGl__genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t
		BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	BGL_EXPORTED_DECL obj_t
		BGl_importzd2javazd2classzd2creatorzd2zzobject_creatorz00
		(BgL_jclassz00_bglt, obj_t, obj_t);
	static obj_t
		BGl__importzd2widezd2classzd2creatorszd2zzobject_creatorz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_genzd2onezd2constructorz00zzobject_creatorz00(obj_t,
		BgL_jclassz00_bglt, obj_t);
	static obj_t BGl_alloczd2wideningzd2zzobject_creatorz00(obj_t,
		BgL_tclassz00_bglt);
	extern bool_t BGl_slotzd2virtualzf3z21zzobject_slotsz00(BgL_slotz00_bglt);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	static obj_t
		BGl_genzd2javazd2classzd2creatorzd2zzobject_creatorz00(BgL_jclassz00_bglt,
		obj_t);
	extern obj_t BGl_za2sawza2z00zzengine_paramz00;
	extern obj_t BGl_za2passza2z00zzengine_paramz00;
	static obj_t
		BGl__genzd2javazd2classzd2constructorszd2zzobject_creatorz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t
		BGl__importzd2plainzd2classzd2creatorszd2zzobject_creatorz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_typez00_bglt BGl_typezd2ofzd2idz00zzast_identz00(obj_t, obj_t);
	extern obj_t
		BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00
		(BgL_typez00_bglt, BgL_slotz00_bglt, obj_t, obj_t);
	static obj_t
		BGl_genzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	static obj_t BGl_genzd2widezd2classzd2makez12zc0zzobject_creatorz00(obj_t,
		BgL_tclassz00_bglt, obj_t, obj_t);
	extern obj_t
		BGl_genzd2plainzd2classzd2nilzd2zzobject_nilz00(BgL_tclassz00_bglt, obj_t,
		obj_t);
	extern obj_t BGl_makezd2privatezd2sexpz00zzast_privatez00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_appendz00zz__r4_pairs_and_lists_6_3z00(obj_t);
	static obj_t
		BGl_importzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt,
		obj_t, obj_t);
	static obj_t BGl_genzd2classzd2fillz12z12zzobject_creatorz00(obj_t, obj_t,
		BgL_tclassz00_bglt, obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzobject_creatorz00();
	static obj_t BGl_genzd2classzd2makez12z12zzobject_creatorz00(obj_t, obj_t,
		obj_t, BgL_tclassz00_bglt, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzobject_creatorz00();
	static obj_t __cnst[39];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_importzd2javazd2classzd2creatorzd2envz00zzobject_creatorz00,
		BgL_bgl__importza7d2javaza7d3334z00,
		BGl__importzd2javazd2classzd2creatorzd2zzobject_creatorz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2widezd2classzd2creatorszd2envz00zzobject_creatorz00,
		BgL_bgl__genza7d2wideza7d2cl3335z00,
		BGl__genzd2widezd2classzd2creatorszd2zzobject_creatorz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2plainzd2classzd2creatorszd2envz00zzobject_creatorz00,
		BgL_bgl__genza7d2plainza7d2c3336z00,
		BGl__genzd2plainzd2classzd2creatorszd2zzobject_creatorz00, 0L, BUNSPEC, 3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_importzd2widezd2classzd2creatorszd2envz00zzobject_creatorz00,
		BgL_bgl__importza7d2wideza7d3337z00,
		BGl__importzd2widezd2classzd2creatorszd2zzobject_creatorz00, 0L, BUNSPEC,
		3);
	      DEFINE_STRING(BGl_string3325z00zzobject_creatorz00,
		BgL_bgl_string3325za700za7za7o3338za7, "))))", 4);
	      DEFINE_STRING(BGl_string3326z00zzobject_creatorz00,
		BgL_bgl_string3326za700za7za7o3339za7, ")BREF( GC_MALLOC (sizeof(", 25);
	      DEFINE_STRING(BGl_string3327z00zzobject_creatorz00,
		BgL_bgl_string3327za700za7za7o3340za7, "((", 2);
	      DEFINE_STRING(BGl_string3328z00zzobject_creatorz00,
		BgL_bgl_string3328za700za7za7o3341za7, ") )))", 5);
	      DEFINE_STRING(BGl_string3330z00zzobject_creatorz00,
		BgL_bgl_string3330za700za7za7o3342za7, "object_creator", 14);
	      DEFINE_STRING(BGl_string3329z00zzobject_creatorz00,
		BgL_bgl_string3329za700za7za7o3343za7, ")BREF( GC_MALLOC ( sizeof(", 26);
	      DEFINE_STRING(BGl_string3331z00zzobject_creatorz00,
		BgL_bgl_string3331za700za7za7o3344za7,
		"cast aux object-widening-set! class-num __object @ object-class-num-set! +fx done =fx if labels loop free-pragma allocator pragma jvm begin let ::long i export quote define obj widening- o inline static new define-inline %allocate- widening - make make- ! fill- (make-heap make-add-heap) ",
		288);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_genzd2javazd2classzd2constructorszd2envz00zzobject_creatorz00,
		BgL_bgl__genza7d2javaza7d2cl3345z00,
		BGl__genzd2javazd2classzd2constructorszd2zzobject_creatorz00, 0L, BUNSPEC,
		3);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_importzd2plainzd2classzd2creatorszd2envz00zzobject_creatorz00,
		BgL_bgl__importza7d2plainza73346z00,
		BGl__importzd2plainzd2classzd2creatorszd2zzobject_creatorz00, 0L, BUNSPEC,
		3);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzobject_creatorz00(long
		BgL_checksumz00_2081, char *BgL_fromz00_2082)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzobject_creatorz00))
				{
					BGl_requirezd2initializa7ationz75zzobject_creatorz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzobject_creatorz00();
					BGl_cnstzd2initzd2zzobject_creatorz00();
					BGl_importedzd2moduleszd2initz00zzobject_creatorz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"object_creator");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"object_creator");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"object_creator");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"object_creator");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			{	/* Object/creator.scm 21 */
				obj_t BgL_cportz00_2073;

				BgL_cportz00_2073 =
					bgl_open_input_string(BGl_string3331z00zzobject_creatorz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_2074;

					BgL_iz00_2074 = ((long) 38);
				BgL_loopz00_2075:
					if ((BgL_iz00_2074 == ((long) -1)))
						{	/* Object/creator.scm 21 */
							return BUNSPEC;
						}
					else
						{	/* Object/creator.scm 21 */
							{	/* Object/creator.scm 21 */
								obj_t BgL_arg3333z00_2077;

								{	/* Object/creator.scm 21 */

									{	/* Object/creator.scm 21 */
										obj_t BgL_locationz00_2079;

										BgL_locationz00_2079 = BBOOL(((bool_t) 0));
										{	/* Object/creator.scm 21 */

											BgL_arg3333z00_2077 =
												BGl_readz00zz__readerz00(BgL_cportz00_2073,
												BgL_locationz00_2079);
										}
									}
								}
								{	/* Object/creator.scm 21 */
									int BgL_auxz00_2099;

									BgL_auxz00_2099 = (int) (BgL_iz00_2074);
									CNST_TABLE_SET(BgL_auxz00_2099, BgL_arg3333z00_2077);
							}}
							{	/* Object/creator.scm 21 */
								int BgL_auxz00_2080;

								BgL_auxz00_2080 = (int) ((BgL_iz00_2074 - ((long) 1)));
								{
									long BgL_iz00_2104;

									BgL_iz00_2104 = (long) (BgL_auxz00_2080);
									BgL_iz00_2074 = BgL_iz00_2104;
									goto BgL_loopz00_2075;
								}
							}
						}
				}
			}
		}
	}



/* inline-creators? */
	bool_t BGl_inlinezd2creatorszf3z21zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 56 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Object/creator.scm 58 */
					bool_t BgL_testz00_2109;

					{	/* Object/creator.scm 58 */
						bool_t BgL__ortest_2331z00_572;

						{	/* Object/creator.scm 58 */
							bool_t BgL_testz00_2110;

							{	/* Object/creator.scm 58 */
								bool_t BgL_res3319z00_1765;

								{	/* Object/creator.scm 58 */
									obj_t BgL_objz00_1755;

									BgL_objz00_1755 =
										BGl_za2profilezd2modeza2zd2zzengine_paramz00;
									if (INTEGERP(BgL_objz00_1755))
										{	/* Object/creator.scm 58 */
											BgL_res3319z00_1765 = ((bool_t) 1);
										}
									else
										{	/* Object/creator.scm 58 */
											if (REALP(BgL_objz00_1755))
												{	/* Object/creator.scm 58 */
													BgL_res3319z00_1765 = ((bool_t) 1);
												}
											else
												{	/* Object/creator.scm 58 */
													if (ELONGP(BgL_objz00_1755))
														{	/* Object/creator.scm 58 */
															BgL_res3319z00_1765 = ((bool_t) 1);
														}
													else
														{	/* Object/creator.scm 58 */
															if (LLONGP(BgL_objz00_1755))
																{	/* Object/creator.scm 58 */
																	BgL_res3319z00_1765 = ((bool_t) 1);
																}
															else
																{	/* Object/creator.scm 58 */
																	BgL_res3319z00_1765 =
																		BIGNUMP(BgL_objz00_1755);
																}
														}
												}
										}
								}
								BgL_testz00_2110 = BgL_res3319z00_1765;
							}
							if (BgL_testz00_2110)
								{	/* Object/creator.scm 58 */
									BgL__ortest_2331z00_572 = ((bool_t) 0);
								}
							else
								{	/* Object/creator.scm 58 */
									BgL__ortest_2331z00_572 = ((bool_t) 1);
								}
						}
						if (BgL__ortest_2331z00_572)
							{	/* Object/creator.scm 58 */
								BgL_testz00_2109 = BgL__ortest_2331z00_572;
							}
						else
							{	/* Object/creator.scm 58 */
								BgL_testz00_2109 =
									(
									(long) CINT(BGl_za2profilezd2modeza2zd2zzengine_paramz00) <
									((long) 1));
					}}
					if (BgL_testz00_2109)
						{	/* Object/creator.scm 58 */
							if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
									(BGl_za2passza2z00zzengine_paramz00,
										CNST_TABLE_REF(((long) 0)))))
								{	/* Object/creator.scm 60 */
									return ((bool_t) 0);
								}
							else
								{	/* Object/creator.scm 60 */
									return ((bool_t) 1);
								}
						}
					else
						{	/* Object/creator.scm 58 */
							return ((bool_t) 0);
						}
				}
			else
				{	/* Object/creator.scm 57 */
					return ((bool_t) 0);
				}
		}
	}



/* gen-plain-class-creators */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt
		BgL_classz00_1, obj_t BgL_srczd2defzd2_2, obj_t BgL_importz00_3)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 65 */
			{	/* Object/creator.scm 66 */
				obj_t BgL_arg2476z00_574;

				obj_t BgL_arg2478z00_575;

				obj_t BgL_arg2479z00_576;

				BgL_arg2476z00_574 =
					BGl_genzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
					(BgL_classz00_1, BgL_srczd2defzd2_2, BgL_importz00_3);
				BgL_arg2478z00_575 =
					BGl_genzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
					(BgL_classz00_1, BgL_srczd2defzd2_2, BgL_importz00_3);
				BgL_arg2479z00_576 =
					BGl_genzd2plainzd2classzd2nilzd2zzobject_nilz00(BgL_classz00_1,
					BgL_srczd2defzd2_2, BgL_importz00_3);
				{	/* Object/creator.scm 66 */
					obj_t BgL_list2480z00_577;

					{	/* Object/creator.scm 66 */
						obj_t BgL_arg2481z00_578;

						{	/* Object/creator.scm 66 */
							obj_t BgL_arg2482z00_579;

							BgL_arg2482z00_579 = MAKE_PAIR(BgL_arg2479z00_576, BNIL);
							BgL_arg2481z00_578 =
								MAKE_PAIR(BgL_arg2478z00_575, BgL_arg2482z00_579);
						}
						BgL_list2480z00_577 =
							MAKE_PAIR(BgL_arg2476z00_574, BgL_arg2481z00_578);
					}
					return
						BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2480z00_577);
				}
			}
		}
	}



/* _gen-plain-class-creators */
	obj_t BGl__genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2045, obj_t BgL_classz00_2046, obj_t BgL_srczd2defzd2_2047,
		obj_t BgL_importz00_2048)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 65 */
			return
				BGl_genzd2plainzd2classzd2creatorszd2zzobject_creatorz00(
				(BgL_tclassz00_bglt) (BgL_classz00_2046), BgL_srczd2defzd2_2047,
				BgL_importz00_2048);
		}
	}



/* gen-inline-plain-class-creators */
	obj_t
		BGl_genzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_4, obj_t BgL_srczd2defzd2_5,
		obj_t BgL_importz00_6)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 76 */
			{	/* Object/creator.scm 78 */
				obj_t BgL_idz00_581;

				{
					BgL_typez00_bglt BgL_auxz00_2136;

					BgL_auxz00_2136 = (BgL_typez00_bglt) (BgL_classz00_4);
					BgL_idz00_581 =
						(((BgL_typez00_bglt) CREF(BgL_auxz00_2136))->BgL_idz00);
				}
				{	/* Object/creator.scm 78 */
					BgL_globalz00_bglt BgL_holderz00_582;

					{
						obj_t BgL_auxz00_2139;

						{	/* Object/creator.scm 79 */
							BgL_objectz00_bglt BgL_auxz00_2140;

							BgL_auxz00_2140 = (BgL_objectz00_bglt) (BgL_classz00_4);
							BgL_auxz00_2139 = BGL_OBJECT_WIDENING(BgL_auxz00_2140);
						}
						BgL_holderz00_582 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2139))->BgL_holderz00);
					}
					{	/* Object/creator.scm 79 */
						obj_t BgL_fillzd2idzd2_583;

						{	/* Object/creator.scm 80 */
							obj_t BgL_list2487z00_588;

							{	/* Object/creator.scm 80 */
								obj_t BgL_arg2488z00_589;

								obj_t BgL_arg2489z00_590;

								BgL_arg2488z00_589 = CNST_TABLE_REF(((long) 1));
								{	/* Object/creator.scm 80 */
									obj_t BgL_arg2490z00_591;

									BgL_arg2490z00_591 =
										MAKE_PAIR(CNST_TABLE_REF(((long) 2)), BNIL);
									BgL_arg2489z00_590 =
										MAKE_PAIR(BgL_idz00_581, BgL_arg2490z00_591);
								}
								BgL_list2487z00_588 =
									MAKE_PAIR(BgL_arg2488z00_589, BgL_arg2489z00_590);
							}
							BgL_fillzd2idzd2_583 =
								BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
								(BgL_list2487z00_588);
						}
						{	/* Object/creator.scm 80 */

							{	/* Object/creator.scm 81 */
								obj_t BgL_arg2483z00_584;

								obj_t BgL_arg2484z00_585;

								BgL_arg2483z00_584 =
									BGl_genzd2classzd2fillz12z12zzobject_creatorz00
									(BgL_fillzd2idzd2_583, BgL_idz00_581, BgL_classz00_4,
									BgL_srczd2defzd2_5, BgL_importz00_6);
								BgL_arg2484z00_585 =
									BGl_genzd2classzd2allocatez12z12zzobject_creatorz00
									(BgL_idz00_581, (obj_t) (BgL_classz00_4), BgL_holderz00_582,
									BgL_srczd2defzd2_5, BgL_importz00_6);
								{	/* Object/creator.scm 81 */
									obj_t BgL_list2485z00_586;

									{	/* Object/creator.scm 81 */
										obj_t BgL_arg2486z00_587;

										BgL_arg2486z00_587 = MAKE_PAIR(BgL_arg2484z00_585, BNIL);
										BgL_list2485z00_586 =
											MAKE_PAIR(BgL_arg2483z00_584, BgL_arg2486z00_587);
									}
									return BgL_list2485z00_586;
								}
							}
						}
					}
				}
			}
		}
	}



/* gen-noinline-plain-class-creators */
	obj_t
		BGl_genzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_7, obj_t BgL_srczd2defzd2_8,
		obj_t BgL_importz00_9)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 87 */
			{	/* Object/creator.scm 89 */
				bool_t BgL_testz00_2155;

				{
					obj_t BgL_auxz00_2156;

					{	/* Object/creator.scm 89 */
						BgL_objectz00_bglt BgL_auxz00_2157;

						BgL_auxz00_2157 = (BgL_objectz00_bglt) (BgL_classz00_7);
						BgL_auxz00_2156 = BGL_OBJECT_WIDENING(BgL_auxz00_2157);
					}
					BgL_testz00_2155 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2156))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2155)
					{	/* Object/creator.scm 89 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 91 */
						obj_t BgL_idz00_594;

						{
							BgL_typez00_bglt BgL_auxz00_2161;

							BgL_auxz00_2161 = (BgL_typez00_bglt) (BgL_classz00_7);
							BgL_idz00_594 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2161))->BgL_idz00);
						}
						{	/* Object/creator.scm 91 */
							obj_t BgL_mkzd2idzd2_595;

							{	/* Object/creator.scm 92 */
								obj_t BgL_arg2494z00_598;

								{	/* Object/creator.scm 92 */
									obj_t BgL_arg2495z00_599;

									obj_t BgL_arg2496z00_600;

									{	/* Object/creator.scm 92 */
										obj_t BgL_symbolz00_1774;

										BgL_symbolz00_1774 = CNST_TABLE_REF(((long) 3));
										BgL_arg2495z00_599 = SYMBOL_TO_STRING(BgL_symbolz00_1774);
									}
									BgL_arg2496z00_600 = SYMBOL_TO_STRING(BgL_idz00_594);
									{	/* Object/creator.scm 92 */
										obj_t BgL_list2497z00_601;

										{	/* Object/creator.scm 92 */
											obj_t BgL_arg2498z00_602;

											BgL_arg2498z00_602 = MAKE_PAIR(BgL_arg2496z00_600, BNIL);
											BgL_list2497z00_601 =
												MAKE_PAIR(BgL_arg2495z00_599, BgL_arg2498z00_602);
										}
										BgL_arg2494z00_598 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list2497z00_601);
								}}
								BgL_mkzd2idzd2_595 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg2494z00_598));
							}
							{	/* Object/creator.scm 92 */

								{	/* Object/creator.scm 93 */
									obj_t BgL_arg2492z00_596;

									BgL_arg2492z00_596 =
										BGl_genzd2classzd2makez12z12zzobject_creatorz00
										(CNST_TABLE_REF(((long) 4)), BgL_mkzd2idzd2_595,
										BgL_idz00_594, BgL_classz00_7, BgL_srczd2defzd2_8,
										BgL_importz00_9);
									{	/* Object/creator.scm 93 */
										obj_t BgL_list2493z00_597;

										BgL_list2493z00_597 = MAKE_PAIR(BgL_arg2492z00_596, BNIL);
										return BgL_list2493z00_597;
									}
								}
							}
						}
					}
			}
		}
	}



/* gen-wide-class-creators */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2widezd2classzd2creatorszd2zzobject_creatorz00(BgL_tclassz00_bglt
		BgL_classz00_10, obj_t BgL_srczd2defzd2_11, obj_t BgL_importz00_12)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 98 */
			{	/* Object/creator.scm 99 */
				obj_t BgL_arg2499z00_603;

				obj_t BgL_arg2500z00_604;

				obj_t BgL_arg2501z00_605;

				BgL_arg2499z00_603 =
					BGl_genzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
					(BgL_classz00_10, BgL_srczd2defzd2_11, BgL_importz00_12);
				BgL_arg2500z00_604 =
					BGl_genzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
					(BgL_classz00_10, BgL_srczd2defzd2_11, BgL_importz00_12);
				BgL_arg2501z00_605 =
					BGl_genzd2widezd2classzd2nilzd2zzobject_nilz00(BgL_classz00_10,
					BgL_srczd2defzd2_11, BgL_importz00_12);
				{	/* Object/creator.scm 99 */
					obj_t BgL_list2502z00_606;

					{	/* Object/creator.scm 99 */
						obj_t BgL_arg2503z00_607;

						{	/* Object/creator.scm 99 */
							obj_t BgL_arg2504z00_608;

							BgL_arg2504z00_608 = MAKE_PAIR(BgL_arg2501z00_605, BNIL);
							BgL_arg2503z00_607 =
								MAKE_PAIR(BgL_arg2500z00_604, BgL_arg2504z00_608);
						}
						BgL_list2502z00_606 =
							MAKE_PAIR(BgL_arg2499z00_603, BgL_arg2503z00_607);
					}
					return
						BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2502z00_606);
				}
			}
		}
	}



/* _gen-wide-class-creators */
	obj_t BGl__genzd2widezd2classzd2creatorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2049, obj_t BgL_classz00_2050, obj_t BgL_srczd2defzd2_2051,
		obj_t BgL_importz00_2052)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 98 */
			return
				BGl_genzd2widezd2classzd2creatorszd2zzobject_creatorz00(
				(BgL_tclassz00_bglt) (BgL_classz00_2050), BgL_srczd2defzd2_2051,
				BgL_importz00_2052);
		}
	}



/* gen-noinline-wide-class-creators */
	obj_t
		BGl_genzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_13, obj_t BgL_srczd2defzd2_14,
		obj_t BgL_importz00_15)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 106 */
			{	/* Object/creator.scm 108 */
				bool_t BgL_testz00_2184;

				{
					obj_t BgL_auxz00_2185;

					{	/* Object/creator.scm 108 */
						BgL_objectz00_bglt BgL_auxz00_2186;

						BgL_auxz00_2186 = (BgL_objectz00_bglt) (BgL_classz00_13);
						BgL_auxz00_2185 = BGL_OBJECT_WIDENING(BgL_auxz00_2186);
					}
					BgL_testz00_2184 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2185))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2184)
					{	/* Object/creator.scm 108 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 110 */
						obj_t BgL_fillzd2idzd2_611;

						obj_t BgL_wideningz00_612;

						{	/* Object/creator.scm 110 */
							obj_t BgL_arg2513z00_621;

							obj_t BgL_arg2514z00_622;

							obj_t BgL_arg2515z00_623;

							BgL_arg2513z00_621 = CNST_TABLE_REF(((long) 1));
							{
								BgL_typez00_bglt BgL_auxz00_2191;

								BgL_auxz00_2191 = (BgL_typez00_bglt) (BgL_classz00_13);
								BgL_arg2514z00_622 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2191))->BgL_idz00);
							}
							BgL_arg2515z00_623 = CNST_TABLE_REF(((long) 2));
							{	/* Object/creator.scm 110 */
								obj_t BgL_list2516z00_624;

								{	/* Object/creator.scm 110 */
									obj_t BgL_arg2517z00_625;

									{	/* Object/creator.scm 110 */
										obj_t BgL_arg2518z00_626;

										BgL_arg2518z00_626 = MAKE_PAIR(BgL_arg2515z00_623, BNIL);
										BgL_arg2517z00_625 =
											MAKE_PAIR(BgL_arg2514z00_622, BgL_arg2518z00_626);
									}
									BgL_list2516z00_624 =
										MAKE_PAIR(BgL_arg2513z00_621, BgL_arg2517z00_625);
								}
								BgL_fillzd2idzd2_611 =
									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
									(BgL_list2516z00_624);
						}}
						{	/* Object/creator.scm 111 */
							obj_t BgL_arg2519z00_627;

							obj_t BgL_arg2520z00_628;

							obj_t BgL_arg2521z00_629;

							{
								obj_t BgL_auxz00_2199;

								{	/* Object/creator.scm 111 */
									BgL_objectz00_bglt BgL_auxz00_2200;

									BgL_auxz00_2200 = (BgL_objectz00_bglt) (BgL_classz00_13);
									BgL_auxz00_2199 = BGL_OBJECT_WIDENING(BgL_auxz00_2200);
								}
								BgL_arg2519z00_627 =
									(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2199))->
									BgL_wideningz00);
							}
							BgL_arg2520z00_628 = CNST_TABLE_REF(((long) 5));
							{
								BgL_typez00_bglt BgL_auxz00_2205;

								BgL_auxz00_2205 = (BgL_typez00_bglt) (BgL_classz00_13);
								BgL_arg2521z00_629 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2205))->BgL_idz00);
							}
							{	/* Object/creator.scm 111 */
								obj_t BgL_list2522z00_630;

								{	/* Object/creator.scm 111 */
									obj_t BgL_arg2523z00_631;

									{	/* Object/creator.scm 111 */
										obj_t BgL_arg2524z00_632;

										BgL_arg2524z00_632 = MAKE_PAIR(BgL_arg2521z00_629, BNIL);
										BgL_arg2523z00_631 =
											MAKE_PAIR(BgL_arg2520z00_628, BgL_arg2524z00_632);
									}
									BgL_list2522z00_630 =
										MAKE_PAIR(BgL_arg2519z00_627, BgL_arg2523z00_631);
								}
								BgL_wideningz00_612 =
									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
									(BgL_list2522z00_630);
						}}
						{	/* Object/creator.scm 113 */
							obj_t BgL_arg2506z00_614;

							obj_t BgL_arg2507z00_615;

							{	/* Object/creator.scm 113 */
								obj_t BgL_arg2510z00_618;

								obj_t BgL_arg2511z00_619;

								BgL_arg2510z00_618 = CNST_TABLE_REF(((long) 6));
								{
									BgL_typez00_bglt BgL_auxz00_2213;

									BgL_auxz00_2213 = (BgL_typez00_bglt) (BgL_classz00_13);
									BgL_arg2511z00_619 =
										(((BgL_typez00_bglt) CREF(BgL_auxz00_2213))->BgL_idz00);
								}
								BgL_arg2506z00_614 =
									BGl_genzd2classzd2makez12z12zzobject_creatorz00
									(BgL_arg2510z00_618, BgL_wideningz00_612, BgL_arg2511z00_619,
									BgL_classz00_13, BgL_srczd2defzd2_14, BgL_importz00_15);
							}
							{	/* Object/creator.scm 114 */
								obj_t BgL_arg2512z00_620;

								{
									BgL_typez00_bglt BgL_auxz00_2217;

									BgL_auxz00_2217 = (BgL_typez00_bglt) (BgL_classz00_13);
									BgL_arg2512z00_620 =
										(((BgL_typez00_bglt) CREF(BgL_auxz00_2217))->BgL_idz00);
								}
								BgL_arg2507z00_615 =
									BGl_genzd2widezd2classzd2makez12zc0zzobject_creatorz00
									(BgL_arg2512z00_620, BgL_classz00_13, BgL_srczd2defzd2_14,
									BgL_importz00_15);
							}
							{	/* Object/creator.scm 113 */
								obj_t BgL_list2508z00_616;

								{	/* Object/creator.scm 113 */
									obj_t BgL_arg2509z00_617;

									BgL_arg2509z00_617 = MAKE_PAIR(BgL_arg2507z00_615, BNIL);
									BgL_list2508z00_616 =
										MAKE_PAIR(BgL_arg2506z00_614, BgL_arg2509z00_617);
								}
								return BgL_list2508z00_616;
							}
						}
					}
			}
		}
	}



/* gen-inline-wide-class-creators */
	obj_t
		BGl_genzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_16, obj_t BgL_srczd2defzd2_17,
		obj_t BgL_importz00_18)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 119 */
			{	/* Object/creator.scm 121 */
				bool_t BgL_testz00_2223;

				{
					obj_t BgL_auxz00_2224;

					{	/* Object/creator.scm 121 */
						BgL_objectz00_bglt BgL_auxz00_2225;

						BgL_auxz00_2225 = (BgL_objectz00_bglt) (BgL_classz00_16);
						BgL_auxz00_2224 = BGL_OBJECT_WIDENING(BgL_auxz00_2225);
					}
					BgL_testz00_2223 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2224))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2223)
					{	/* Object/creator.scm 121 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 123 */
						obj_t BgL_fillzd2idzd2_635;

						obj_t BgL_wideningz00_636;

						obj_t BgL_superz00_637;

						{	/* Object/creator.scm 123 */
							obj_t BgL_arg2534z00_645;

							obj_t BgL_arg2535z00_646;

							obj_t BgL_arg2537z00_647;

							BgL_arg2534z00_645 = CNST_TABLE_REF(((long) 1));
							{
								BgL_typez00_bglt BgL_auxz00_2230;

								BgL_auxz00_2230 = (BgL_typez00_bglt) (BgL_classz00_16);
								BgL_arg2535z00_646 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2230))->BgL_idz00);
							}
							BgL_arg2537z00_647 = CNST_TABLE_REF(((long) 2));
							{	/* Object/creator.scm 123 */
								obj_t BgL_list2538z00_648;

								{	/* Object/creator.scm 123 */
									obj_t BgL_arg2539z00_649;

									{	/* Object/creator.scm 123 */
										obj_t BgL_arg2540z00_650;

										BgL_arg2540z00_650 = MAKE_PAIR(BgL_arg2537z00_647, BNIL);
										BgL_arg2539z00_649 =
											MAKE_PAIR(BgL_arg2535z00_646, BgL_arg2540z00_650);
									}
									BgL_list2538z00_648 =
										MAKE_PAIR(BgL_arg2534z00_645, BgL_arg2539z00_649);
								}
								BgL_fillzd2idzd2_635 =
									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
									(BgL_list2538z00_648);
						}}
						{	/* Object/creator.scm 124 */
							obj_t BgL_arg2541z00_651;

							obj_t BgL_arg2542z00_652;

							obj_t BgL_arg2543z00_653;

							{
								obj_t BgL_auxz00_2238;

								{	/* Object/creator.scm 124 */
									BgL_objectz00_bglt BgL_auxz00_2239;

									BgL_auxz00_2239 = (BgL_objectz00_bglt) (BgL_classz00_16);
									BgL_auxz00_2238 = BGL_OBJECT_WIDENING(BgL_auxz00_2239);
								}
								BgL_arg2541z00_651 =
									(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2238))->
									BgL_wideningz00);
							}
							BgL_arg2542z00_652 = CNST_TABLE_REF(((long) 5));
							{
								BgL_typez00_bglt BgL_auxz00_2244;

								BgL_auxz00_2244 = (BgL_typez00_bglt) (BgL_classz00_16);
								BgL_arg2543z00_653 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2244))->BgL_idz00);
							}
							{	/* Object/creator.scm 124 */
								obj_t BgL_list2544z00_654;

								{	/* Object/creator.scm 124 */
									obj_t BgL_arg2545z00_655;

									{	/* Object/creator.scm 124 */
										obj_t BgL_arg2546z00_656;

										BgL_arg2546z00_656 = MAKE_PAIR(BgL_arg2543z00_653, BNIL);
										BgL_arg2545z00_655 =
											MAKE_PAIR(BgL_arg2542z00_652, BgL_arg2546z00_656);
									}
									BgL_list2544z00_654 =
										MAKE_PAIR(BgL_arg2541z00_651, BgL_arg2545z00_655);
								}
								BgL_wideningz00_636 =
									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
									(BgL_list2544z00_654);
						}}
						{
							obj_t BgL_auxz00_2251;

							{	/* Object/creator.scm 125 */
								BgL_objectz00_bglt BgL_auxz00_2252;

								BgL_auxz00_2252 = (BgL_objectz00_bglt) (BgL_classz00_16);
								BgL_auxz00_2251 = BGL_OBJECT_WIDENING(BgL_auxz00_2252);
							}
							BgL_superz00_637 =
								(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2251))->
								BgL_itszd2superzd2);
						}
						{	/* Object/creator.scm 126 */
							obj_t BgL_arg2526z00_638;

							obj_t BgL_arg2527z00_639;

							{	/* Object/creator.scm 126 */
								obj_t BgL_arg2530z00_642;

								{
									BgL_typez00_bglt BgL_auxz00_2256;

									BgL_auxz00_2256 = (BgL_typez00_bglt) (BgL_classz00_16);
									BgL_arg2530z00_642 =
										(((BgL_typez00_bglt) CREF(BgL_auxz00_2256))->BgL_idz00);
								}
								BgL_arg2526z00_638 =
									BGl_genzd2classzd2fillz12z12zzobject_creatorz00
									(BgL_fillzd2idzd2_635, BgL_arg2530z00_642, BgL_classz00_16,
									BgL_srczd2defzd2_17, BgL_importz00_18);
							}
							{	/* Object/creator.scm 127 */
								obj_t BgL_arg2531z00_643;

								BgL_globalz00_bglt BgL_arg2533z00_644;

								{
									BgL_typez00_bglt BgL_auxz00_2260;

									BgL_auxz00_2260 = (BgL_typez00_bglt) (BgL_classz00_16);
									BgL_arg2531z00_643 =
										(((BgL_typez00_bglt) CREF(BgL_auxz00_2260))->BgL_idz00);
								}
								{
									obj_t BgL_auxz00_2263;

									{	/* Object/creator.scm 127 */
										BgL_objectz00_bglt BgL_auxz00_2264;

										BgL_auxz00_2264 = (BgL_objectz00_bglt) (BgL_classz00_16);
										BgL_auxz00_2263 = BGL_OBJECT_WIDENING(BgL_auxz00_2264);
									}
									BgL_arg2533z00_644 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2263))->
										BgL_holderz00);
								}
								BgL_arg2527z00_639 =
									BGl_genzd2classzd2allocatez12z12zzobject_creatorz00
									(BgL_arg2531z00_643, BgL_superz00_637, BgL_arg2533z00_644,
									BgL_srczd2defzd2_17, BgL_importz00_18);
							}
							{	/* Object/creator.scm 126 */
								obj_t BgL_list2528z00_640;

								{	/* Object/creator.scm 126 */
									obj_t BgL_arg2529z00_641;

									BgL_arg2529z00_641 = MAKE_PAIR(BgL_arg2527z00_639, BNIL);
									BgL_list2528z00_640 =
										MAKE_PAIR(BgL_arg2526z00_638, BgL_arg2529z00_641);
								}
								return BgL_list2528z00_640;
							}
						}
					}
			}
		}
	}



/* gen-java-class-creator */
	obj_t
		BGl_genzd2javazd2classzd2creatorzd2zzobject_creatorz00(BgL_jclassz00_bglt
		BgL_classz00_19, obj_t BgL_srczd2defzd2_20)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 132 */
			{	/* Object/creator.scm 133 */
				obj_t BgL_idz00_657;

				{
					BgL_typez00_bglt BgL_auxz00_2271;

					BgL_auxz00_2271 = (BgL_typez00_bglt) (BgL_classz00_19);
					BgL_idz00_657 =
						(((BgL_typez00_bglt) CREF(BgL_auxz00_2271))->BgL_idz00);
				}
				{	/* Object/creator.scm 133 */
					obj_t BgL_alloczd2idzd2_658;

					{	/* Object/creator.scm 134 */
						obj_t BgL_arg2570z00_683;

						{	/* Object/creator.scm 134 */
							obj_t BgL_arg2571z00_684;

							obj_t BgL_arg2572z00_685;

							{	/* Object/creator.scm 134 */
								obj_t BgL_symbolz00_1799;

								BgL_symbolz00_1799 = CNST_TABLE_REF(((long) 7));
								BgL_arg2571z00_684 = SYMBOL_TO_STRING(BgL_symbolz00_1799);
							}
							BgL_arg2572z00_685 = SYMBOL_TO_STRING(BgL_idz00_657);
							{	/* Object/creator.scm 134 */
								obj_t BgL_list2573z00_686;

								{	/* Object/creator.scm 134 */
									obj_t BgL_arg2574z00_687;

									BgL_arg2574z00_687 = MAKE_PAIR(BgL_arg2572z00_685, BNIL);
									BgL_list2573z00_686 =
										MAKE_PAIR(BgL_arg2571z00_684, BgL_arg2574z00_687);
								}
								BgL_arg2570z00_683 =
									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
									(BgL_list2573z00_686);
						}}
						BgL_alloczd2idzd2_658 =
							string_to_symbol(BSTRING_TO_STRING(BgL_arg2570z00_683));
					}
					{	/* Object/creator.scm 134 */

						{

							{	/* Object/creator.scm 138 */
								obj_t BgL_arg2547z00_660;

								{	/* Object/creator.scm 138 */
									obj_t BgL_arg2548z00_661;

									obj_t BgL_arg2549z00_662;

									BgL_arg2548z00_661 = CNST_TABLE_REF(((long) 10));
									{	/* Object/creator.scm 138 */
										obj_t BgL_arg2550z00_663;

										{	/* Object/creator.scm 138 */
											obj_t BgL_arg2553z00_666;

											obj_t BgL_arg2554z00_667;

											BgL_arg2553z00_666 = CNST_TABLE_REF(((long) 11));
											{	/* Object/creator.scm 138 */
												obj_t BgL_list2555z00_668;

												BgL_list2555z00_668 = MAKE_PAIR(BNIL, BNIL);
												BgL_arg2554z00_667 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_alloczd2idzd2_658, BgL_list2555z00_668);
											}
											BgL_arg2550z00_663 =
												MAKE_PAIR(BgL_arg2553z00_666, BgL_arg2554z00_667);
										}
										{	/* Object/creator.scm 138 */
											obj_t BgL_list2552z00_665;

											BgL_list2552z00_665 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg2549z00_662 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BgL_arg2550z00_663, BgL_list2552z00_665);
									}}
									BgL_arg2547z00_660 =
										MAKE_PAIR(BgL_arg2548z00_661, BgL_arg2549z00_662);
								}
								BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
									(BgL_arg2547z00_660);
							}
							{	/* Object/creator.scm 139 */
								obj_t BgL_arg2556z00_669;

								{	/* Object/creator.scm 139 */
									obj_t BgL_arg2558z00_671;

									{	/* Object/creator.scm 136 */
										obj_t BgL_arg2561z00_674;

										obj_t BgL_arg2562z00_675;

										BgL_arg2561z00_674 = CNST_TABLE_REF(((long) 8));
										{	/* Object/creator.scm 136 */
											obj_t BgL_arg2564z00_676;

											obj_t BgL_arg2565z00_677;

											BgL_arg2564z00_676 =
												MAKE_PAIR(BgL_alloczd2idzd2_658, BNIL);
											BgL_arg2565z00_677 =
												BGl_makezd2privatezd2sexpz00zzast_privatez00
												(CNST_TABLE_REF(((long) 9)), BgL_idz00_657, BNIL);
											{	/* Object/creator.scm 136 */
												obj_t BgL_list2567z00_679;

												{	/* Object/creator.scm 136 */
													obj_t BgL_arg2568z00_680;

													BgL_arg2568z00_680 = MAKE_PAIR(BNIL, BNIL);
													BgL_list2567z00_679 =
														MAKE_PAIR(BgL_arg2565z00_677, BgL_arg2568z00_680);
												}
												BgL_arg2562z00_675 =
													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
													(BgL_arg2564z00_676, BgL_list2567z00_679);
										}}
										BgL_arg2558z00_671 =
											MAKE_PAIR(BgL_arg2561z00_674, BgL_arg2562z00_675);
									}
									{	/* Object/creator.scm 139 */
										obj_t BgL_list2559z00_672;

										BgL_list2559z00_672 = MAKE_PAIR(BgL_srczd2defzd2_20, BNIL);
										BgL_arg2556z00_669 =
											BGl_epairifyza2za2zztools_miscz00(BgL_arg2558z00_671,
											BgL_list2559z00_672);
								}}
								{	/* Object/creator.scm 139 */
									obj_t BgL_list2557z00_670;

									BgL_list2557z00_670 = MAKE_PAIR(BgL_arg2556z00_669, BNIL);
									return BgL_list2557z00_670;
								}
							}
						}
					}
				}
			}
		}
	}



/* import-plain-class-creators */
	BGL_EXPORTED_DEF obj_t
		BGl_importzd2plainzd2classzd2creatorszd2zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_21, obj_t BgL_srczd2defzd2_22,
		obj_t BgL_modulez00_23)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 144 */
			BGl_importzd2classzd2nilz00zzobject_nilz00(BgL_classz00_21,
				BgL_srczd2defzd2_22, BgL_modulez00_23);
			{	/* Object/creator.scm 146 */
				bool_t BgL_testz00_2303;

				{
					obj_t BgL_auxz00_2304;

					{	/* Object/creator.scm 146 */
						BgL_objectz00_bglt BgL_auxz00_2305;

						BgL_auxz00_2305 = (BgL_objectz00_bglt) (BgL_classz00_21);
						BgL_auxz00_2304 = BGL_OBJECT_WIDENING(BgL_auxz00_2305);
					}
					BgL_testz00_2303 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2304))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2303)
					{	/* Object/creator.scm 146 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 146 */
						if (BGl_inlinezd2creatorszf3z21zzobject_creatorz00())
							{	/* Object/creator.scm 148 */
								BGl_importzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_21, BgL_srczd2defzd2_22, BgL_modulez00_23);
								return
									BGl_genzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_21, BgL_srczd2defzd2_22,
									CNST_TABLE_REF(((long) 10)));
							}
						else
							{	/* Object/creator.scm 148 */
								BGl_importzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_21, BgL_srczd2defzd2_22, BgL_modulez00_23);
								return
									BGl_importzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_21, BgL_srczd2defzd2_22, BgL_modulez00_23);
							}
					}
			}
		}
	}



/* _import-plain-class-creators */
	obj_t BGl__importzd2plainzd2classzd2creatorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2053, obj_t BgL_classz00_2054, obj_t BgL_srczd2defzd2_2055,
		obj_t BgL_modulez00_2056)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 144 */
			return
				BGl_importzd2plainzd2classzd2creatorszd2zzobject_creatorz00(
				(BgL_tclassz00_bglt) (BgL_classz00_2054), BgL_srczd2defzd2_2055,
				BgL_modulez00_2056);
		}
	}



/* import-inline-plain-class-creators */
	obj_t
		BGl_importzd2inlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_24, obj_t BgL_srczd2defzd2_25,
		obj_t BgL_modulez00_26)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 160 */
			{	/* Object/creator.scm 162 */
				obj_t BgL_mkzd2idzd2_691;

				{	/* Object/creator.scm 162 */
					obj_t BgL_arg2605z00_725;

					{	/* Object/creator.scm 162 */
						obj_t BgL_arg2606z00_726;

						obj_t BgL_arg2607z00_727;

						{	/* Object/creator.scm 162 */
							obj_t BgL_symbolz00_1805;

							BgL_symbolz00_1805 = CNST_TABLE_REF(((long) 3));
							BgL_arg2606z00_726 = SYMBOL_TO_STRING(BgL_symbolz00_1805);
						}
						{	/* Object/creator.scm 162 */
							obj_t BgL_arg2610z00_730;

							{
								BgL_typez00_bglt BgL_auxz00_2320;

								BgL_auxz00_2320 = (BgL_typez00_bglt) (BgL_classz00_24);
								BgL_arg2610z00_730 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2320))->BgL_idz00);
							}
							BgL_arg2607z00_727 = SYMBOL_TO_STRING(BgL_arg2610z00_730);
						}
						{	/* Object/creator.scm 162 */
							obj_t BgL_list2608z00_728;

							{	/* Object/creator.scm 162 */
								obj_t BgL_arg2609z00_729;

								BgL_arg2609z00_729 = MAKE_PAIR(BgL_arg2607z00_727, BNIL);
								BgL_list2608z00_728 =
									MAKE_PAIR(BgL_arg2606z00_726, BgL_arg2609z00_729);
							}
							BgL_arg2605z00_725 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list2608z00_728);
					}}
					BgL_mkzd2idzd2_691 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg2605z00_725));
				}
				{	/* Object/creator.scm 162 */
					obj_t BgL_fillzd2idzd2_692;

					{	/* Object/creator.scm 163 */
						obj_t BgL_arg2598z00_719;

						obj_t BgL_arg2600z00_720;

						obj_t BgL_arg2601z00_721;

						BgL_arg2598z00_719 = CNST_TABLE_REF(((long) 1));
						{
							BgL_typez00_bglt BgL_auxz00_2330;

							BgL_auxz00_2330 = (BgL_typez00_bglt) (BgL_classz00_24);
							BgL_arg2600z00_720 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2330))->BgL_idz00);
						}
						BgL_arg2601z00_721 = CNST_TABLE_REF(((long) 2));
						{	/* Object/creator.scm 163 */
							obj_t BgL_list2602z00_722;

							{	/* Object/creator.scm 163 */
								obj_t BgL_arg2603z00_723;

								{	/* Object/creator.scm 163 */
									obj_t BgL_arg2604z00_724;

									BgL_arg2604z00_724 = MAKE_PAIR(BgL_arg2601z00_721, BNIL);
									BgL_arg2603z00_723 =
										MAKE_PAIR(BgL_arg2600z00_720, BgL_arg2604z00_724);
								}
								BgL_list2602z00_722 =
									MAKE_PAIR(BgL_arg2598z00_719, BgL_arg2603z00_723);
							}
							BgL_fillzd2idzd2_692 =
								BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
								(BgL_list2602z00_722);
					}}
					{	/* Object/creator.scm 163 */
						obj_t BgL_mkzd2tidzd2_693;

						{	/* Object/creator.scm 164 */
							obj_t BgL_arg2597z00_718;

							{
								BgL_typez00_bglt BgL_auxz00_2338;

								BgL_auxz00_2338 = (BgL_typez00_bglt) (BgL_classz00_24);
								BgL_arg2597z00_718 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2338))->BgL_idz00);
							}
							BgL_mkzd2tidzd2_693 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_691,
								BgL_arg2597z00_718);
						}
						{	/* Object/creator.scm 164 */
							obj_t BgL_fzd2idszd2_694;

							{	/* Object/creator.scm 165 */
								obj_t BgL_arg2596z00_717;

								{
									obj_t BgL_auxz00_2342;

									{	/* Object/creator.scm 165 */
										BgL_objectz00_bglt BgL_auxz00_2343;

										BgL_auxz00_2343 = (BgL_objectz00_bglt) (BgL_classz00_24);
										BgL_auxz00_2342 = BGL_OBJECT_WIDENING(BgL_auxz00_2343);
									}
									BgL_arg2596z00_717 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2342))->
										BgL_slotsz00);
								}
								BgL_fzd2idszd2_694 =
									BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
									(BgL_arg2596z00_717);
							}
							{	/* Object/creator.scm 165 */
								obj_t BgL_fzd2tidszd2_695;

								{	/* Object/creator.scm 166 */
									obj_t BgL_arg2595z00_716;

									{
										obj_t BgL_auxz00_2348;

										{	/* Object/creator.scm 166 */
											BgL_objectz00_bglt BgL_auxz00_2349;

											BgL_auxz00_2349 = (BgL_objectz00_bglt) (BgL_classz00_24);
											BgL_auxz00_2348 = BGL_OBJECT_WIDENING(BgL_auxz00_2349);
										}
										BgL_arg2595z00_716 =
											(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2348))->
											BgL_slotsz00);
									}
									BgL_fzd2tidszd2_695 =
										BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
										(BgL_fzd2idszd2_694, BgL_arg2595z00_716);
								}
								{	/* Object/creator.scm 166 */
									obj_t BgL_toz00_696;

									{	/* Object/creator.scm 167 */
										obj_t BgL_arg2591z00_713;

										obj_t BgL_arg2592z00_714;

										BgL_arg2591z00_713 =
											BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
											(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
														12))));
										{
											BgL_typez00_bglt BgL_auxz00_2357;

											BgL_auxz00_2357 = (BgL_typez00_bglt) (BgL_classz00_24);
											BgL_arg2592z00_714 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_2357))->BgL_idz00);
										}
										BgL_toz00_696 =
											BGl_makezd2typedzd2identz00zzast_identz00
											(BgL_arg2591z00_713, BgL_arg2592z00_714);
									}
									{	/* Object/creator.scm 167 */
										obj_t BgL_alloczd2idzd2_697;

										{	/* Object/creator.scm 168 */
											obj_t BgL_arg2585z00_707;

											{	/* Object/creator.scm 168 */
												obj_t BgL_arg2586z00_708;

												obj_t BgL_arg2587z00_709;

												{	/* Object/creator.scm 168 */
													obj_t BgL_symbolz00_1814;

													BgL_symbolz00_1814 = CNST_TABLE_REF(((long) 7));
													BgL_arg2586z00_708 =
														SYMBOL_TO_STRING(BgL_symbolz00_1814);
												}
												{	/* Object/creator.scm 168 */
													obj_t BgL_arg2590z00_712;

													{
														BgL_typez00_bglt BgL_auxz00_2363;

														BgL_auxz00_2363 =
															(BgL_typez00_bglt) (BgL_classz00_24);
														BgL_arg2590z00_712 =
															(((BgL_typez00_bglt) CREF(BgL_auxz00_2363))->
															BgL_idz00);
													}
													BgL_arg2587z00_709 =
														SYMBOL_TO_STRING(BgL_arg2590z00_712);
												}
												{	/* Object/creator.scm 168 */
													obj_t BgL_list2588z00_710;

													{	/* Object/creator.scm 168 */
														obj_t BgL_arg2589z00_711;

														BgL_arg2589z00_711 =
															MAKE_PAIR(BgL_arg2587z00_709, BNIL);
														BgL_list2588z00_710 =
															MAKE_PAIR(BgL_arg2586z00_708, BgL_arg2589z00_711);
													}
													BgL_arg2585z00_707 =
														BGl_stringzd2appendzd2zz__r4_strings_6_7z00
														(BgL_list2588z00_710);
											}}
											BgL_alloczd2idzd2_697 =
												string_to_symbol(BSTRING_TO_STRING(BgL_arg2585z00_707));
										}
										{	/* Object/creator.scm 168 */
											obj_t BgL_alloczd2tidzd2_698;

											{	/* Object/creator.scm 169 */
												obj_t BgL_arg2584z00_706;

												{
													BgL_typez00_bglt BgL_auxz00_2372;

													BgL_auxz00_2372 =
														(BgL_typez00_bglt) (BgL_classz00_24);
													BgL_arg2584z00_706 =
														(((BgL_typez00_bglt) CREF(BgL_auxz00_2372))->
														BgL_idz00);
												}
												BgL_alloczd2tidzd2_698 =
													BGl_makezd2typedzd2identz00zzast_identz00
													(BgL_alloczd2idzd2_697, BgL_arg2584z00_706);
											}
											{	/* Object/creator.scm 169 */

												{	/* Object/creator.scm 171 */
													obj_t BgL_arg2577z00_699;

													BgL_arg2577z00_699 =
														MAKE_PAIR(BgL_alloczd2tidzd2_698, BNIL);
													BGl_importzd2parserzd2zzmodule_impusez00
														(BgL_modulez00_26, BgL_arg2577z00_699, BNIL);
												}
												{	/* Object/creator.scm 172 */
													obj_t BgL_arg2579z00_701;

													{	/* Object/creator.scm 172 */
														obj_t BgL_arg2581z00_703;

														{	/* Object/creator.scm 172 */
															obj_t BgL_arg2582z00_704;

															BgL_arg2582z00_704 =
																BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																(BgL_fzd2tidszd2_695, BNIL);
															{	/* Object/creator.scm 172 */
																obj_t BgL_list2583z00_705;

																BgL_list2583z00_705 =
																	MAKE_PAIR(BgL_arg2582z00_704, BNIL);
																BgL_arg2581z00_703 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_toz00_696, BgL_list2583z00_705);
														}}
														BgL_arg2579z00_701 =
															MAKE_PAIR(BgL_fillzd2idzd2_692,
															BgL_arg2581z00_703);
													}
													BGl_importzd2parserzd2zzmodule_impusez00
														(BgL_modulez00_26, BgL_arg2579z00_701, BNIL);
												}
												return BNIL;
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* import-noinline-plain-class-creators */
	obj_t
		BGl_importzd2noinlinezd2plainzd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_27, obj_t BgL_srczd2defzd2_28,
		obj_t BgL_modulez00_29)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 179 */
			{	/* Object/creator.scm 181 */
				obj_t BgL_mkzd2idzd2_732;

				{	/* Object/creator.scm 181 */
					obj_t BgL_arg2618z00_742;

					{	/* Object/creator.scm 181 */
						obj_t BgL_arg2619z00_743;

						obj_t BgL_arg2620z00_744;

						{	/* Object/creator.scm 181 */
							obj_t BgL_symbolz00_1819;

							BgL_symbolz00_1819 = CNST_TABLE_REF(((long) 3));
							BgL_arg2619z00_743 = SYMBOL_TO_STRING(BgL_symbolz00_1819);
						}
						{	/* Object/creator.scm 181 */
							obj_t BgL_arg2623z00_747;

							{
								BgL_typez00_bglt BgL_auxz00_2385;

								BgL_auxz00_2385 = (BgL_typez00_bglt) (BgL_classz00_27);
								BgL_arg2623z00_747 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2385))->BgL_idz00);
							}
							BgL_arg2620z00_744 = SYMBOL_TO_STRING(BgL_arg2623z00_747);
						}
						{	/* Object/creator.scm 181 */
							obj_t BgL_list2621z00_745;

							{	/* Object/creator.scm 181 */
								obj_t BgL_arg2622z00_746;

								BgL_arg2622z00_746 = MAKE_PAIR(BgL_arg2620z00_744, BNIL);
								BgL_list2621z00_745 =
									MAKE_PAIR(BgL_arg2619z00_743, BgL_arg2622z00_746);
							}
							BgL_arg2618z00_742 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list2621z00_745);
					}}
					BgL_mkzd2idzd2_732 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg2618z00_742));
				}
				{	/* Object/creator.scm 181 */
					obj_t BgL_mkzd2tidzd2_733;

					{	/* Object/creator.scm 182 */
						obj_t BgL_arg2617z00_741;

						{
							BgL_typez00_bglt BgL_auxz00_2394;

							BgL_auxz00_2394 = (BgL_typez00_bglt) (BgL_classz00_27);
							BgL_arg2617z00_741 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2394))->BgL_idz00);
						}
						BgL_mkzd2tidzd2_733 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_732,
							BgL_arg2617z00_741);
					}
					{	/* Object/creator.scm 182 */
						obj_t BgL_fzd2idszd2_734;

						{	/* Object/creator.scm 183 */
							obj_t BgL_arg2616z00_740;

							{
								obj_t BgL_auxz00_2398;

								{	/* Object/creator.scm 183 */
									BgL_objectz00_bglt BgL_auxz00_2399;

									BgL_auxz00_2399 = (BgL_objectz00_bglt) (BgL_classz00_27);
									BgL_auxz00_2398 = BGL_OBJECT_WIDENING(BgL_auxz00_2399);
								}
								BgL_arg2616z00_740 =
									(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2398))->BgL_slotsz00);
							}
							BgL_fzd2idszd2_734 =
								BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
								(BgL_arg2616z00_740);
						}
						{	/* Object/creator.scm 183 */
							obj_t BgL_fzd2tidszd2_735;

							{	/* Object/creator.scm 184 */
								obj_t BgL_arg2615z00_739;

								{
									obj_t BgL_auxz00_2404;

									{	/* Object/creator.scm 184 */
										BgL_objectz00_bglt BgL_auxz00_2405;

										BgL_auxz00_2405 = (BgL_objectz00_bglt) (BgL_classz00_27);
										BgL_auxz00_2404 = BGL_OBJECT_WIDENING(BgL_auxz00_2405);
									}
									BgL_arg2615z00_739 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2404))->
										BgL_slotsz00);
								}
								BgL_fzd2tidszd2_735 =
									BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
									(BgL_fzd2idszd2_734, BgL_arg2615z00_739);
							}
							{	/* Object/creator.scm 184 */

								{	/* Object/creator.scm 186 */
									obj_t BgL_arg2611z00_736;

									BgL_arg2611z00_736 =
										MAKE_PAIR(BgL_mkzd2tidzd2_733,
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_fzd2tidszd2_735, BNIL));
									BGl_importzd2parserzd2zzmodule_impusez00(BgL_modulez00_29,
										BgL_arg2611z00_736, BNIL);
								}
								return BNIL;
							}
						}
					}
				}
			}
		}
	}



/* import-wide-class-creators */
	BGL_EXPORTED_DEF obj_t
		BGl_importzd2widezd2classzd2creatorszd2zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_30, obj_t BgL_srczd2defzd2_31,
		obj_t BgL_modulez00_32)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 193 */
			BGl_importzd2classzd2nilz00zzobject_nilz00(BgL_classz00_30,
				BgL_srczd2defzd2_31, BgL_modulez00_32);
			{	/* Object/creator.scm 195 */
				bool_t BgL_testz00_2414;

				{
					obj_t BgL_auxz00_2415;

					{	/* Object/creator.scm 195 */
						BgL_objectz00_bglt BgL_auxz00_2416;

						BgL_auxz00_2416 = (BgL_objectz00_bglt) (BgL_classz00_30);
						BgL_auxz00_2415 = BGL_OBJECT_WIDENING(BgL_auxz00_2416);
					}
					BgL_testz00_2414 =
						(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2415))->BgL_abstractzf3zf3);
				}
				if (BgL_testz00_2414)
					{	/* Object/creator.scm 195 */
						return BNIL;
					}
				else
					{	/* Object/creator.scm 195 */
						if (BGl_inlinezd2creatorszf3z21zzobject_creatorz00())
							{	/* Object/creator.scm 197 */
								BGl_importzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_30, BgL_srczd2defzd2_31, BgL_modulez00_32);
								return
									BGl_genzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_30, BgL_srczd2defzd2_31,
									CNST_TABLE_REF(((long) 10)));
							}
						else
							{	/* Object/creator.scm 197 */
								BGl_importzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_30, BgL_srczd2defzd2_31, BgL_modulez00_32);
								return
									BGl_importzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
									(BgL_classz00_30, BgL_srczd2defzd2_31, BgL_modulez00_32);
							}
					}
			}
		}
	}



/* _import-wide-class-creators */
	obj_t BGl__importzd2widezd2classzd2creatorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2057, obj_t BgL_classz00_2058, obj_t BgL_srczd2defzd2_2059,
		obj_t BgL_modulez00_2060)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 193 */
			return
				BGl_importzd2widezd2classzd2creatorszd2zzobject_creatorz00(
				(BgL_tclassz00_bglt) (BgL_classz00_2058), BgL_srczd2defzd2_2059,
				BgL_modulez00_2060);
		}
	}



/* import-inline-wide-class-creators */
	obj_t
		BGl_importzd2inlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_33, obj_t BgL_srczd2defzd2_34,
		obj_t BgL_modulez00_35)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 209 */
			{	/* Object/creator.scm 211 */
				obj_t BgL_mkzd2idzd2_751;

				{	/* Object/creator.scm 211 */
					obj_t BgL_arg2662z00_794;

					{	/* Object/creator.scm 211 */
						obj_t BgL_arg2663z00_795;

						obj_t BgL_arg2664z00_796;

						{	/* Object/creator.scm 211 */
							obj_t BgL_symbolz00_1827;

							BgL_symbolz00_1827 = CNST_TABLE_REF(((long) 3));
							BgL_arg2663z00_795 = SYMBOL_TO_STRING(BgL_symbolz00_1827);
						}
						{	/* Object/creator.scm 211 */
							obj_t BgL_arg2668z00_799;

							{
								BgL_typez00_bglt BgL_auxz00_2431;

								BgL_auxz00_2431 = (BgL_typez00_bglt) (BgL_classz00_33);
								BgL_arg2668z00_799 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2431))->BgL_idz00);
							}
							BgL_arg2664z00_796 = SYMBOL_TO_STRING(BgL_arg2668z00_799);
						}
						{	/* Object/creator.scm 211 */
							obj_t BgL_list2665z00_797;

							{	/* Object/creator.scm 211 */
								obj_t BgL_arg2666z00_798;

								BgL_arg2666z00_798 = MAKE_PAIR(BgL_arg2664z00_796, BNIL);
								BgL_list2665z00_797 =
									MAKE_PAIR(BgL_arg2663z00_795, BgL_arg2666z00_798);
							}
							BgL_arg2662z00_794 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list2665z00_797);
					}}
					BgL_mkzd2idzd2_751 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg2662z00_794));
				}
				{	/* Object/creator.scm 211 */
					obj_t BgL_fillzd2idzd2_752;

					{	/* Object/creator.scm 212 */
						obj_t BgL_arg2656z00_788;

						obj_t BgL_arg2657z00_789;

						obj_t BgL_arg2658z00_790;

						BgL_arg2656z00_788 = CNST_TABLE_REF(((long) 1));
						{
							BgL_typez00_bglt BgL_auxz00_2441;

							BgL_auxz00_2441 = (BgL_typez00_bglt) (BgL_classz00_33);
							BgL_arg2657z00_789 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2441))->BgL_idz00);
						}
						BgL_arg2658z00_790 = CNST_TABLE_REF(((long) 2));
						{	/* Object/creator.scm 212 */
							obj_t BgL_list2659z00_791;

							{	/* Object/creator.scm 212 */
								obj_t BgL_arg2660z00_792;

								{	/* Object/creator.scm 212 */
									obj_t BgL_arg2661z00_793;

									BgL_arg2661z00_793 = MAKE_PAIR(BgL_arg2658z00_790, BNIL);
									BgL_arg2660z00_792 =
										MAKE_PAIR(BgL_arg2657z00_789, BgL_arg2661z00_793);
								}
								BgL_list2659z00_791 =
									MAKE_PAIR(BgL_arg2656z00_788, BgL_arg2660z00_792);
							}
							BgL_fillzd2idzd2_752 =
								BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
								(BgL_list2659z00_791);
					}}
					{	/* Object/creator.scm 212 */
						obj_t BgL_mkzd2tidzd2_753;

						{	/* Object/creator.scm 213 */
							obj_t BgL_arg2655z00_787;

							{
								BgL_typez00_bglt BgL_auxz00_2449;

								BgL_auxz00_2449 = (BgL_typez00_bglt) (BgL_classz00_33);
								BgL_arg2655z00_787 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2449))->BgL_idz00);
							}
							BgL_mkzd2tidzd2_753 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_751,
								BgL_arg2655z00_787);
						}
						{	/* Object/creator.scm 213 */
							obj_t BgL_alloczd2widezd2_754;

							{	/* Object/creator.scm 214 */
								obj_t BgL_arg2648z00_781;

								{	/* Object/creator.scm 214 */
									obj_t BgL_arg2649z00_782;

									obj_t BgL_arg2650z00_783;

									{	/* Object/creator.scm 214 */
										obj_t BgL_symbolz00_1833;

										BgL_symbolz00_1833 = CNST_TABLE_REF(((long) 13));
										BgL_arg2649z00_782 = SYMBOL_TO_STRING(BgL_symbolz00_1833);
									}
									{	/* Object/creator.scm 214 */
										obj_t BgL_arg2654z00_786;

										{
											BgL_typez00_bglt BgL_auxz00_2455;

											BgL_auxz00_2455 = (BgL_typez00_bglt) (BgL_classz00_33);
											BgL_arg2654z00_786 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_2455))->BgL_idz00);
										}
										BgL_arg2650z00_783 = SYMBOL_TO_STRING(BgL_arg2654z00_786);
									}
									{	/* Object/creator.scm 214 */
										obj_t BgL_list2651z00_784;

										{	/* Object/creator.scm 214 */
											obj_t BgL_arg2653z00_785;

											BgL_arg2653z00_785 = MAKE_PAIR(BgL_arg2650z00_783, BNIL);
											BgL_list2651z00_784 =
												MAKE_PAIR(BgL_arg2649z00_782, BgL_arg2653z00_785);
										}
										BgL_arg2648z00_781 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list2651z00_784);
								}}
								BgL_alloczd2widezd2_754 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg2648z00_781));
							}
							{	/* Object/creator.scm 214 */
								obj_t BgL_talloczd2widezd2_755;

								{	/* Object/creator.scm 215 */
									obj_t BgL_arg2647z00_780;

									{
										BgL_typez00_bglt BgL_auxz00_2464;

										BgL_auxz00_2464 = (BgL_typez00_bglt) (BgL_classz00_33);
										BgL_arg2647z00_780 =
											(((BgL_typez00_bglt) CREF(BgL_auxz00_2464))->BgL_idz00);
									}
									BgL_talloczd2widezd2_755 =
										BGl_makezd2typedzd2identz00zzast_identz00
										(BgL_alloczd2widezd2_754, BgL_arg2647z00_780);
								}
								{	/* Object/creator.scm 215 */
									obj_t BgL_fzd2idszd2_756;

									{	/* Object/creator.scm 216 */
										obj_t BgL_arg2646z00_779;

										{
											obj_t BgL_auxz00_2468;

											{	/* Object/creator.scm 216 */
												BgL_objectz00_bglt BgL_auxz00_2469;

												BgL_auxz00_2469 =
													(BgL_objectz00_bglt) (BgL_classz00_33);
												BgL_auxz00_2468 = BGL_OBJECT_WIDENING(BgL_auxz00_2469);
											}
											BgL_arg2646z00_779 =
												(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2468))->
												BgL_slotsz00);
										}
										BgL_fzd2idszd2_756 =
											BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
											(BgL_arg2646z00_779);
									}
									{	/* Object/creator.scm 216 */
										obj_t BgL_fzd2tidszd2_757;

										{	/* Object/creator.scm 217 */
											obj_t BgL_arg2645z00_778;

											{
												obj_t BgL_auxz00_2474;

												{	/* Object/creator.scm 217 */
													BgL_objectz00_bglt BgL_auxz00_2475;

													BgL_auxz00_2475 =
														(BgL_objectz00_bglt) (BgL_classz00_33);
													BgL_auxz00_2474 =
														BGL_OBJECT_WIDENING(BgL_auxz00_2475);
												}
												BgL_arg2645z00_778 =
													(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2474))->
													BgL_slotsz00);
											}
											BgL_fzd2tidszd2_757 =
												BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
												(BgL_fzd2idszd2_756, BgL_arg2645z00_778);
										}
										{	/* Object/creator.scm 217 */
											obj_t BgL_toz00_758;

											{	/* Object/creator.scm 218 */
												obj_t BgL_arg2642z00_775;

												obj_t BgL_arg2643z00_776;

												BgL_arg2642z00_775 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
																(long) 12))));
												{
													BgL_typez00_bglt BgL_auxz00_2483;

													BgL_auxz00_2483 =
														(BgL_typez00_bglt) (BgL_classz00_33);
													BgL_arg2643z00_776 =
														(((BgL_typez00_bglt) CREF(BgL_auxz00_2483))->
														BgL_idz00);
												}
												BgL_toz00_758 =
													BGl_makezd2typedzd2identz00zzast_identz00
													(BgL_arg2642z00_775, BgL_arg2643z00_776);
											}
											{	/* Object/creator.scm 218 */
												obj_t BgL_alloczd2idzd2_759;

												{	/* Object/creator.scm 219 */
													obj_t BgL_arg2636z00_769;

													{	/* Object/creator.scm 219 */
														obj_t BgL_arg2637z00_770;

														obj_t BgL_arg2638z00_771;

														{	/* Object/creator.scm 219 */
															obj_t BgL_symbolz00_1841;

															BgL_symbolz00_1841 = CNST_TABLE_REF(((long) 7));
															BgL_arg2637z00_770 =
																SYMBOL_TO_STRING(BgL_symbolz00_1841);
														}
														{	/* Object/creator.scm 219 */
															obj_t BgL_arg2641z00_774;

															{
																BgL_typez00_bglt BgL_auxz00_2489;

																BgL_auxz00_2489 =
																	(BgL_typez00_bglt) (BgL_classz00_33);
																BgL_arg2641z00_774 =
																	(((BgL_typez00_bglt) CREF(BgL_auxz00_2489))->
																	BgL_idz00);
															}
															BgL_arg2638z00_771 =
																SYMBOL_TO_STRING(BgL_arg2641z00_774);
														}
														{	/* Object/creator.scm 219 */
															obj_t BgL_list2639z00_772;

															{	/* Object/creator.scm 219 */
																obj_t BgL_arg2640z00_773;

																BgL_arg2640z00_773 =
																	MAKE_PAIR(BgL_arg2638z00_771, BNIL);
																BgL_list2639z00_772 =
																	MAKE_PAIR(BgL_arg2637z00_770,
																	BgL_arg2640z00_773);
															}
															BgL_arg2636z00_769 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list2639z00_772);
													}}
													BgL_alloczd2idzd2_759 =
														string_to_symbol(BSTRING_TO_STRING
														(BgL_arg2636z00_769));
												}
												{	/* Object/creator.scm 219 */
													obj_t BgL_alloczd2tidzd2_760;

													{	/* Object/creator.scm 220 */
														obj_t BgL_arg2635z00_768;

														{
															BgL_typez00_bglt BgL_auxz00_2498;

															BgL_auxz00_2498 =
																(BgL_typez00_bglt) (BgL_classz00_33);
															BgL_arg2635z00_768 =
																(((BgL_typez00_bglt) CREF(BgL_auxz00_2498))->
																BgL_idz00);
														}
														BgL_alloczd2tidzd2_760 =
															BGl_makezd2typedzd2identz00zzast_identz00
															(BgL_alloczd2idzd2_759, BgL_arg2635z00_768);
													}
													{	/* Object/creator.scm 220 */

														{	/* Object/creator.scm 222 */
															obj_t BgL_arg2627z00_761;

															BgL_arg2627z00_761 =
																MAKE_PAIR(BgL_alloczd2tidzd2_760, BNIL);
															BGl_importzd2parserzd2zzmodule_impusez00
																(BgL_modulez00_35, BgL_arg2627z00_761, BNIL);
														}
														{	/* Object/creator.scm 223 */
															obj_t BgL_arg2629z00_763;

															{	/* Object/creator.scm 223 */
																obj_t BgL_arg2631z00_765;

																{	/* Object/creator.scm 223 */
																	obj_t BgL_arg2632z00_766;

																	BgL_arg2632z00_766 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_fzd2tidszd2_757, BNIL);
																	{	/* Object/creator.scm 223 */
																		obj_t BgL_list2633z00_767;

																		BgL_list2633z00_767 =
																			MAKE_PAIR(BgL_arg2632z00_766, BNIL);
																		BgL_arg2631z00_765 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_toz00_758, BgL_list2633z00_767);
																}}
																BgL_arg2629z00_763 =
																	MAKE_PAIR(BgL_fillzd2idzd2_752,
																	BgL_arg2631z00_765);
															}
															BGl_importzd2parserzd2zzmodule_impusez00
																(BgL_modulez00_35, BgL_arg2629z00_763, BNIL);
														}
														return BNIL;
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* import-noinline-wide-class-creators */
	obj_t
		BGl_importzd2noinlinezd2widezd2classzd2creatorsz00zzobject_creatorz00
		(BgL_tclassz00_bglt BgL_classz00_36, obj_t BgL_srczd2defzd2_37,
		obj_t BgL_modulez00_38)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 230 */
			{	/* Object/creator.scm 232 */
				obj_t BgL_mkzd2idzd2_801;

				{	/* Object/creator.scm 232 */
					obj_t BgL_arg2694z00_836;

					{	/* Object/creator.scm 232 */
						obj_t BgL_arg2695z00_837;

						obj_t BgL_arg2696z00_838;

						{	/* Object/creator.scm 232 */
							obj_t BgL_symbolz00_1846;

							BgL_symbolz00_1846 = CNST_TABLE_REF(((long) 3));
							BgL_arg2695z00_837 = SYMBOL_TO_STRING(BgL_symbolz00_1846);
						}
						{	/* Object/creator.scm 232 */
							obj_t BgL_arg2699z00_841;

							{
								BgL_typez00_bglt BgL_auxz00_2511;

								BgL_auxz00_2511 = (BgL_typez00_bglt) (BgL_classz00_36);
								BgL_arg2699z00_841 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2511))->BgL_idz00);
							}
							BgL_arg2696z00_838 = SYMBOL_TO_STRING(BgL_arg2699z00_841);
						}
						{	/* Object/creator.scm 232 */
							obj_t BgL_list2697z00_839;

							{	/* Object/creator.scm 232 */
								obj_t BgL_arg2698z00_840;

								BgL_arg2698z00_840 = MAKE_PAIR(BgL_arg2696z00_838, BNIL);
								BgL_list2697z00_839 =
									MAKE_PAIR(BgL_arg2695z00_837, BgL_arg2698z00_840);
							}
							BgL_arg2694z00_836 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list2697z00_839);
					}}
					BgL_mkzd2idzd2_801 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg2694z00_836));
				}
				{	/* Object/creator.scm 232 */
					obj_t BgL_fillzd2idzd2_802;

					{	/* Object/creator.scm 233 */
						obj_t BgL_arg2688z00_830;

						obj_t BgL_arg2689z00_831;

						obj_t BgL_arg2690z00_832;

						BgL_arg2688z00_830 = CNST_TABLE_REF(((long) 1));
						{
							BgL_typez00_bglt BgL_auxz00_2521;

							BgL_auxz00_2521 = (BgL_typez00_bglt) (BgL_classz00_36);
							BgL_arg2689z00_831 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2521))->BgL_idz00);
						}
						BgL_arg2690z00_832 = CNST_TABLE_REF(((long) 2));
						{	/* Object/creator.scm 233 */
							obj_t BgL_list2691z00_833;

							{	/* Object/creator.scm 233 */
								obj_t BgL_arg2692z00_834;

								{	/* Object/creator.scm 233 */
									obj_t BgL_arg2693z00_835;

									BgL_arg2693z00_835 = MAKE_PAIR(BgL_arg2690z00_832, BNIL);
									BgL_arg2692z00_834 =
										MAKE_PAIR(BgL_arg2689z00_831, BgL_arg2693z00_835);
								}
								BgL_list2691z00_833 =
									MAKE_PAIR(BgL_arg2688z00_830, BgL_arg2692z00_834);
							}
							BgL_fillzd2idzd2_802 =
								BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
								(BgL_list2691z00_833);
					}}
					{	/* Object/creator.scm 233 */
						obj_t BgL_mkzd2tidzd2_803;

						{	/* Object/creator.scm 234 */
							obj_t BgL_arg2687z00_829;

							{
								BgL_typez00_bglt BgL_auxz00_2529;

								BgL_auxz00_2529 = (BgL_typez00_bglt) (BgL_classz00_36);
								BgL_arg2687z00_829 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2529))->BgL_idz00);
							}
							BgL_mkzd2tidzd2_803 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_801,
								BgL_arg2687z00_829);
						}
						{	/* Object/creator.scm 234 */
							obj_t BgL_alloczd2widezd2_804;

							{	/* Object/creator.scm 235 */
								obj_t BgL_arg2681z00_823;

								{	/* Object/creator.scm 235 */
									obj_t BgL_arg2682z00_824;

									obj_t BgL_arg2683z00_825;

									{	/* Object/creator.scm 235 */
										obj_t BgL_symbolz00_1852;

										BgL_symbolz00_1852 = CNST_TABLE_REF(((long) 13));
										BgL_arg2682z00_824 = SYMBOL_TO_STRING(BgL_symbolz00_1852);
									}
									{	/* Object/creator.scm 235 */
										obj_t BgL_arg2686z00_828;

										{
											BgL_typez00_bglt BgL_auxz00_2535;

											BgL_auxz00_2535 = (BgL_typez00_bglt) (BgL_classz00_36);
											BgL_arg2686z00_828 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_2535))->BgL_idz00);
										}
										BgL_arg2683z00_825 = SYMBOL_TO_STRING(BgL_arg2686z00_828);
									}
									{	/* Object/creator.scm 235 */
										obj_t BgL_list2684z00_826;

										{	/* Object/creator.scm 235 */
											obj_t BgL_arg2685z00_827;

											BgL_arg2685z00_827 = MAKE_PAIR(BgL_arg2683z00_825, BNIL);
											BgL_list2684z00_826 =
												MAKE_PAIR(BgL_arg2682z00_824, BgL_arg2685z00_827);
										}
										BgL_arg2681z00_823 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list2684z00_826);
								}}
								BgL_alloczd2widezd2_804 =
									string_to_symbol(BSTRING_TO_STRING(BgL_arg2681z00_823));
							}
							{	/* Object/creator.scm 235 */
								obj_t BgL_tidz00_805;

								if (CBOOL(BGl_za2sawza2z00zzengine_paramz00))
									{	/* Object/creator.scm 240 */
										obj_t BgL_arg2680z00_822;

										{
											BgL_typez00_bglt BgL_auxz00_2546;

											BgL_auxz00_2546 = (BgL_typez00_bglt) (BgL_classz00_36);
											BgL_arg2680z00_822 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_2546))->BgL_idz00);
										}
										BgL_tidz00_805 =
											BGl_sawzd2widezd2classzd2idzd2zzobject_classz00
											(BgL_arg2680z00_822);
									}
								else
									{	/* Object/creator.scm 240 */
										BgL_tidz00_805 = CNST_TABLE_REF(((long) 14));
									}
								{	/* Object/creator.scm 240 */
									obj_t BgL_talloczd2widezd2_806;

									BgL_talloczd2widezd2_806 =
										BGl_makezd2typedzd2identz00zzast_identz00
										(BgL_alloczd2widezd2_804, BgL_tidz00_805);
									{	/* Object/creator.scm 241 */
										obj_t BgL_fzd2idszd2_807;

										{	/* Object/creator.scm 242 */
											obj_t BgL_arg2679z00_821;

											{
												obj_t BgL_auxz00_2552;

												{	/* Object/creator.scm 242 */
													BgL_objectz00_bglt BgL_auxz00_2553;

													BgL_auxz00_2553 =
														(BgL_objectz00_bglt) (BgL_classz00_36);
													BgL_auxz00_2552 =
														BGL_OBJECT_WIDENING(BgL_auxz00_2553);
												}
												BgL_arg2679z00_821 =
													(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2552))->
													BgL_slotsz00);
											}
											BgL_fzd2idszd2_807 =
												BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
												(BgL_arg2679z00_821);
										}
										{	/* Object/creator.scm 242 */
											obj_t BgL_fzd2tidszd2_808;

											{	/* Object/creator.scm 243 */
												obj_t BgL_arg2678z00_820;

												{
													obj_t BgL_auxz00_2558;

													{	/* Object/creator.scm 243 */
														BgL_objectz00_bglt BgL_auxz00_2559;

														BgL_auxz00_2559 =
															(BgL_objectz00_bglt) (BgL_classz00_36);
														BgL_auxz00_2558 =
															BGL_OBJECT_WIDENING(BgL_auxz00_2559);
													}
													BgL_arg2678z00_820 =
														(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2558))->
														BgL_slotsz00);
												}
												BgL_fzd2tidszd2_808 =
													BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
													(BgL_fzd2idszd2_807, BgL_arg2678z00_820);
											}
											{	/* Object/creator.scm 243 */
												obj_t BgL_sslotsz00_809;

												{	/* Object/creator.scm 244 */
													BgL_tclassz00_bglt BgL_obj2040z00_1860;

													{	/* Object/creator.scm 244 */
														obj_t BgL_auxz00_2564;

														{
															obj_t BgL_auxz00_2565;

															{	/* Object/creator.scm 244 */
																BgL_objectz00_bglt BgL_auxz00_2566;

																BgL_auxz00_2566 =
																	(BgL_objectz00_bglt) (BgL_classz00_36);
																BgL_auxz00_2565 =
																	BGL_OBJECT_WIDENING(BgL_auxz00_2566);
															}
															BgL_auxz00_2564 =
																(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2565))->
																BgL_itszd2superzd2);
														}
														BgL_obj2040z00_1860 =
															(BgL_tclassz00_bglt) (BgL_auxz00_2564);
													}
													{
														obj_t BgL_auxz00_2571;

														{	/* Object/creator.scm 244 */
															BgL_objectz00_bglt BgL_auxz00_2572;

															BgL_auxz00_2572 =
																(BgL_objectz00_bglt) (BgL_obj2040z00_1860);
															BgL_auxz00_2571 =
																BGL_OBJECT_WIDENING(BgL_auxz00_2572);
														}
														BgL_sslotsz00_809 =
															(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2571))->
															BgL_slotsz00);
												}}
												{	/* Object/creator.scm 244 */
													obj_t BgL_szd2idszd2_810;

													BgL_szd2idszd2_810 =
														BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
														(BgL_sslotsz00_809);
													{	/* Object/creator.scm 245 */
														obj_t BgL_szd2tidszd2_811;

														BgL_szd2tidszd2_811 =
															BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
															(BgL_szd2idszd2_810, BgL_sslotsz00_809);
														{	/* Object/creator.scm 246 */

															{	/* Object/creator.scm 248 */
																obj_t BgL_arg2669z00_812;

																BgL_arg2669z00_812 =
																	MAKE_PAIR(BgL_mkzd2tidzd2_803,
																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																	(BgL_szd2tidszd2_811,
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_fzd2tidszd2_808, BNIL)));
																BGl_importzd2parserzd2zzmodule_impusez00
																	(BgL_modulez00_38, BgL_arg2669z00_812, BNIL);
															}
															{	/* Object/creator.scm 249 */
																obj_t BgL_arg2674z00_816;

																BgL_arg2674z00_816 =
																	MAKE_PAIR(BgL_talloczd2widezd2_806,
																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																	(BgL_fzd2tidszd2_808, BNIL));
																BGl_importzd2parserzd2zzmodule_impusez00
																	(BgL_modulez00_38, BgL_arg2674z00_816, BNIL);
															}
															return BNIL;
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* import-java-class-creator */
	BGL_EXPORTED_DEF obj_t
		BGl_importzd2javazd2classzd2creatorzd2zzobject_creatorz00(BgL_jclassz00_bglt
		BgL_classz00_39, obj_t BgL_constrsz00_40, obj_t BgL_srczd2defzd2_41)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 256 */
			if (PAIRP(BgL_constrsz00_40))
				{	/* Object/creator.scm 257 */
					return
						BGl_genzd2javazd2classzd2creatorzd2zzobject_creatorz00
						(BgL_classz00_39, BgL_srczd2defzd2_41);
				}
			else
				{	/* Object/creator.scm 257 */
					return BNIL;
				}
		}
	}



/* _import-java-class-creator */
	obj_t BGl__importzd2javazd2classzd2creatorzd2zzobject_creatorz00(obj_t
		BgL_envz00_2061, obj_t BgL_classz00_2062, obj_t BgL_constrsz00_2063,
		obj_t BgL_srczd2defzd2_2064)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 256 */
			return
				BGl_importzd2javazd2classzd2creatorzd2zzobject_creatorz00(
				(BgL_jclassz00_bglt) (BgL_classz00_2062), BgL_constrsz00_2063,
				BgL_srczd2defzd2_2064);
		}
	}



/* gen-java-class-constructors */
	BGL_EXPORTED_DEF obj_t
		BGl_genzd2javazd2classzd2constructorszd2zzobject_creatorz00
		(BgL_jclassz00_bglt BgL_classz00_42, obj_t BgL_constrsz00_43,
		obj_t BgL_srczd2defzd2_44)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 264 */
			if (NULLP(BgL_constrsz00_43))
				{	/* Object/creator.scm 294 */
					return BNIL;
				}
			else
				{	/* Object/creator.scm 294 */
					obj_t BgL_head2448z00_846;

					BgL_head2448z00_846 =
						MAKE_PAIR(BGl_genzd2onezd2constructorz00zzobject_creatorz00
						(BgL_constrsz00_43, BgL_classz00_42, CAR(BgL_constrsz00_43)), BNIL);
					{	/* Object/creator.scm 294 */
						obj_t BgL_g2451z00_847;

						BgL_g2451z00_847 = CDR(BgL_constrsz00_43);
						{
							obj_t BgL_l2446z00_848;

							obj_t BgL_tail2449z00_849;

							BgL_l2446z00_848 = BgL_g2451z00_847;
							BgL_tail2449z00_849 = BgL_head2448z00_846;
						BgL_map2447z00_850:
							if (NULLP(BgL_l2446z00_848))
								{	/* Object/creator.scm 294 */
									return BgL_head2448z00_846;
								}
							else
								{	/* Object/creator.scm 294 */
									obj_t BgL_newtail2450z00_852;

									BgL_newtail2450z00_852 =
										MAKE_PAIR(BGl_genzd2onezd2constructorz00zzobject_creatorz00
										(BgL_constrsz00_43, BgL_classz00_42, CAR(BgL_l2446z00_848)),
										BNIL);
									SET_CDR(BgL_tail2449z00_849, BgL_newtail2450z00_852);
									{
										obj_t BgL_tail2449z00_2604;

										obj_t BgL_l2446z00_2602;

										BgL_l2446z00_2602 = CDR(BgL_l2446z00_848);
										BgL_tail2449z00_2604 = BgL_newtail2450z00_852;
										BgL_tail2449z00_849 = BgL_tail2449z00_2604;
										BgL_l2446z00_848 = BgL_l2446z00_2602;
										goto BgL_map2447z00_850;
									}
								}
						}
					}
				}
		}
	}



/* gen-one-constructor */
	obj_t BGl_genzd2onezd2constructorz00zzobject_creatorz00(obj_t
		BgL_constrsz00_2072, BgL_jclassz00_bglt BgL_classz00_2071,
		obj_t BgL_constrz00_860)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 293 */
			{
				obj_t BgL_identz00_862;

				obj_t BgL_argszd2typezd2_863;

				if (PAIRP(BgL_constrz00_860))
					{	/* Object/creator.scm 293 */
						BgL_identz00_862 = CAR(BgL_constrz00_860);
						BgL_argszd2typezd2_863 = CDR(BgL_constrz00_860);
						{	/* Object/creator.scm 271 */
							obj_t BgL_jidz00_869;

							{
								BgL_typez00_bglt BgL_auxz00_2607;

								BgL_auxz00_2607 = (BgL_typez00_bglt) (BgL_classz00_2071);
								BgL_jidz00_869 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2607))->BgL_idz00);
							}
							{	/* Object/creator.scm 271 */
								obj_t BgL_locz00_870;

								BgL_locz00_870 =
									BGl_findzd2locationzd2zztools_locationz00
									(BgL_constrsz00_2072);
								{	/* Object/creator.scm 272 */
									obj_t BgL_cidz00_871;

									BgL_cidz00_871 =
										BGl_fastzd2idzd2ofzd2idzd2zzast_identz00(BgL_identz00_862,
										BgL_locz00_870);
									{	/* Object/creator.scm 273 */
										obj_t BgL_tidz00_872;

										{	/* Object/creator.scm 274 */
											obj_t BgL_arg2770z00_958;

											{	/* Object/creator.scm 274 */
												obj_t BgL_list2771z00_959;

												{	/* Object/creator.scm 274 */
													obj_t BgL_arg2772z00_960;

													{	/* Object/creator.scm 274 */
														obj_t BgL_arg2773z00_961;

														obj_t BgL_arg2774z00_962;

														BgL_arg2773z00_961 = CNST_TABLE_REF(((long) 5));
														BgL_arg2774z00_962 =
															MAKE_PAIR(BgL_cidz00_871, BNIL);
														BgL_arg2772z00_960 =
															MAKE_PAIR(BgL_arg2773z00_961, BgL_arg2774z00_962);
													}
													BgL_list2771z00_959 =
														MAKE_PAIR(BgL_jidz00_869, BgL_arg2772z00_960);
												}
												BgL_arg2770z00_958 =
													BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
													(BgL_list2771z00_959);
											}
											BgL_tidz00_872 =
												BGl_makezd2typedzd2identz00zzast_identz00
												(BgL_arg2770z00_958, BgL_jidz00_869);
										}
										{	/* Object/creator.scm 274 */
											obj_t BgL_argszd2idzd2_873;

											if (NULLP(BgL_argszd2typezd2_863))
												{	/* Object/creator.scm 275 */
													BgL_argszd2idzd2_873 = BNIL;
												}
											else
												{	/* Object/creator.scm 275 */
													obj_t BgL_head2432z00_946;

													BgL_head2432z00_946 = MAKE_PAIR(BNIL, BNIL);
													{
														obj_t BgL_l2430z00_947;

														obj_t BgL_tail2433z00_948;

														BgL_l2430z00_947 = BgL_argszd2typezd2_863;
														BgL_tail2433z00_948 = BgL_head2432z00_946;
													BgL_map2431z00_949:
														if (NULLP(BgL_l2430z00_947))
															{	/* Object/creator.scm 275 */
																BgL_argszd2idzd2_873 = CDR(BgL_head2432z00_946);
															}
														else
															{	/* Object/creator.scm 275 */
																obj_t BgL_newtail2434z00_951;

																{	/* Object/creator.scm 275 */
																	obj_t BgL_arg2767z00_953;

																	{	/* Object/creator.scm 275 */
																		obj_t BgL_arg2769z00_956;

																		{	/* Object/creator.scm 275 */

																			{	/* Object/creator.scm 275 */

																				BgL_arg2769z00_956 =
																					BGl_gensymz00zz__r4_symbols_6_4z00
																					(BFALSE);
																			}
																		}
																		BgL_arg2767z00_953 =
																			BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																			(BgL_arg2769z00_956);
																	}
																	BgL_newtail2434z00_951 =
																		MAKE_PAIR(BgL_arg2767z00_953, BNIL);
																}
																SET_CDR(BgL_tail2433z00_948,
																	BgL_newtail2434z00_951);
																{
																	obj_t BgL_tail2433z00_2630;

																	obj_t BgL_l2430z00_2628;

																	BgL_l2430z00_2628 = CDR(BgL_l2430z00_947);
																	BgL_tail2433z00_2630 = BgL_newtail2434z00_951;
																	BgL_tail2433z00_948 = BgL_tail2433z00_2630;
																	BgL_l2430z00_947 = BgL_l2430z00_2628;
																	goto BgL_map2431z00_949;
																}
															}
													}
												}
											{	/* Object/creator.scm 275 */
												obj_t BgL_selfz00_874;

												{	/* Object/creator.scm 277 */
													obj_t BgL_arg2763z00_942;

													{	/* Object/creator.scm 277 */

														{	/* Object/creator.scm 277 */

															BgL_arg2763z00_942 =
																BGl_gensymz00zz__r4_symbols_6_4z00(BFALSE);
														}
													}
													BgL_selfz00_874 =
														BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
														(BgL_arg2763z00_942);
												}
												{	/* Object/creator.scm 277 */
													obj_t BgL_tselfz00_875;

													BgL_tselfz00_875 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_selfz00_874, BgL_jidz00_869);
													{	/* Object/creator.scm 278 */
														obj_t BgL_targsz00_876;

														if (NULLP(BgL_argszd2idzd2_873))
															{	/* Object/creator.scm 279 */
																BgL_targsz00_876 = BNIL;
															}
														else
															{	/* Object/creator.scm 279 */
																obj_t BgL_head2437z00_924;

																BgL_head2437z00_924 = MAKE_PAIR(BNIL, BNIL);
																{
																	obj_t BgL_ll2435z00_925;

																	obj_t BgL_ll2436z00_926;

																	obj_t BgL_tail2438z00_927;

																	BgL_ll2435z00_925 = BgL_argszd2idzd2_873;
																	BgL_ll2436z00_926 = BgL_argszd2typezd2_863;
																	BgL_tail2438z00_927 = BgL_head2437z00_924;
																BgL_map2440z00_928:
																	if (NULLP(BgL_ll2435z00_925))
																		{	/* Object/creator.scm 279 */
																			BgL_targsz00_876 =
																				CDR(BgL_head2437z00_924);
																		}
																	else
																		{	/* Object/creator.scm 279 */
																			obj_t BgL_newtail2439z00_930;

																			{	/* Object/creator.scm 279 */
																				obj_t BgL_arg2756z00_933;

																				{	/* Object/creator.scm 279 */
																					obj_t BgL_idz00_935;

																					obj_t BgL_typez00_936;

																					BgL_idz00_935 =
																						CAR(BgL_ll2435z00_925);
																					BgL_typez00_936 =
																						CAR(BgL_ll2436z00_926);
																					{	/* Object/creator.scm 280 */
																						obj_t BgL_arg2758z00_937;

																						{	/* Object/creator.scm 280 */
																							obj_t BgL_arg2759z00_938;

																							obj_t BgL_arg2760z00_939;

																							BgL_arg2759z00_938 =
																								SYMBOL_TO_STRING(BgL_idz00_935);
																							BgL_arg2760z00_939 =
																								SYMBOL_TO_STRING
																								(BgL_typez00_936);
																							{	/* Object/creator.scm 280 */
																								obj_t BgL_list2761z00_940;

																								{	/* Object/creator.scm 280 */
																									obj_t BgL_arg2762z00_941;

																									BgL_arg2762z00_941 =
																										MAKE_PAIR
																										(BgL_arg2760z00_939, BNIL);
																									BgL_list2761z00_940 =
																										MAKE_PAIR
																										(BgL_arg2759z00_938,
																										BgL_arg2762z00_941);
																								}
																								BgL_arg2758z00_937 =
																									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																									(BgL_list2761z00_940);
																							}
																						}
																						BgL_arg2756z00_933 =
																							string_to_symbol(BSTRING_TO_STRING
																							(BgL_arg2758z00_937));
																					}
																				}
																				BgL_newtail2439z00_930 =
																					MAKE_PAIR(BgL_arg2756z00_933, BNIL);
																			}
																			SET_CDR(BgL_tail2438z00_927,
																				BgL_newtail2439z00_930);
																			{
																				obj_t BgL_tail2438z00_2655;

																				obj_t BgL_ll2436z00_2653;

																				obj_t BgL_ll2435z00_2651;

																				BgL_ll2435z00_2651 =
																					CDR(BgL_ll2435z00_925);
																				BgL_ll2436z00_2653 =
																					CDR(BgL_ll2436z00_926);
																				BgL_tail2438z00_2655 =
																					BgL_newtail2439z00_930;
																				BgL_tail2438z00_927 =
																					BgL_tail2438z00_2655;
																				BgL_ll2436z00_926 = BgL_ll2436z00_2653;
																				BgL_ll2435z00_925 = BgL_ll2435z00_2651;
																				goto BgL_map2440z00_928;
																			}
																		}
																}
															}
														{	/* Object/creator.scm 279 */
															obj_t BgL_defz00_877;

															{	/* Object/creator.scm 282 */
																obj_t BgL_arg2723z00_887;

																obj_t BgL_arg2725z00_888;

																BgL_arg2723z00_887 =
																	CNST_TABLE_REF(((long) 15));
																{	/* Object/creator.scm 282 */
																	obj_t BgL_arg2727z00_889;

																	obj_t BgL_arg2728z00_890;

																	BgL_arg2727z00_889 =
																		MAKE_PAIR(BgL_tidz00_872,
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_targsz00_876, BNIL));
																	{	/* Object/creator.scm 284 */
																		obj_t BgL_runner2751z00_920;

																		{	/* Object/creator.scm 284 */
																			obj_t BgL_arg2733z00_895;

																			obj_t BgL_arg2734z00_896;

																			BgL_arg2733z00_895 =
																				CNST_TABLE_REF(((long) 9));
																			{	/* Object/creator.scm 285 */
																				obj_t BgL_arg2738z00_900;

																				obj_t BgL_arg2739z00_901;

																				BgL_arg2738z00_900 =
																					CNST_TABLE_REF(((long) 16));
																				{	/* Object/creator.scm 285 */
																					obj_t BgL_arg2740z00_902;

																					if (NULLP(BgL_argszd2typezd2_863))
																						{	/* Object/creator.scm 285 */
																							BgL_arg2740z00_902 = BNIL;
																						}
																					else
																						{	/* Object/creator.scm 285 */
																							obj_t BgL_head2443z00_907;

																							BgL_head2443z00_907 =
																								MAKE_PAIR(BNIL, BNIL);
																							{
																								obj_t BgL_l2441z00_908;

																								obj_t BgL_tail2444z00_909;

																								BgL_l2441z00_908 =
																									BgL_argszd2typezd2_863;
																								BgL_tail2444z00_909 =
																									BgL_head2443z00_907;
																							BgL_map2442z00_910:
																								if (NULLP(BgL_l2441z00_908))
																									{	/* Object/creator.scm 285 */
																										BgL_arg2740z00_902 =
																											CDR(BgL_head2443z00_907);
																									}
																								else
																									{	/* Object/creator.scm 285 */
																										obj_t
																											BgL_newtail2445z00_912;
																										{	/* Object/creator.scm 285 */
																											obj_t BgL_arg2746z00_914;

																											{	/* Object/creator.scm 285 */
																												obj_t BgL_az00_916;

																												BgL_az00_916 =
																													CAR(BgL_l2441z00_908);
																												{
																													BgL_typez00_bglt
																														BgL_auxz00_2668;
																													BgL_auxz00_2668 =
																														BGl_typezd2ofzd2idz00zzast_identz00
																														(BgL_az00_916,
																														BgL_locz00_870);
																													BgL_arg2746z00_914 =
																														(((BgL_typez00_bglt)
																															CREF
																															(BgL_auxz00_2668))->
																														BgL_idz00);
																												}
																											}
																											BgL_newtail2445z00_912 =
																												MAKE_PAIR
																												(BgL_arg2746z00_914,
																												BNIL);
																										}
																										SET_CDR(BgL_tail2444z00_909,
																											BgL_newtail2445z00_912);
																										{
																											obj_t
																												BgL_tail2444z00_2675;
																											obj_t BgL_l2441z00_2673;

																											BgL_l2441z00_2673 =
																												CDR(BgL_l2441z00_908);
																											BgL_tail2444z00_2675 =
																												BgL_newtail2445z00_912;
																											BgL_tail2444z00_909 =
																												BgL_tail2444z00_2675;
																											BgL_l2441z00_908 =
																												BgL_l2441z00_2673;
																											goto BgL_map2442z00_910;
																										}
																									}
																							}
																						}
																					{	/* Object/creator.scm 285 */
																						obj_t BgL_list2742z00_904;

																						BgL_list2742z00_904 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg2739z00_901 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg2740z00_902,
																							BgL_list2742z00_904);
																					}
																				}
																				BgL_arg2734z00_896 =
																					MAKE_PAIR(BgL_arg2738z00_900,
																					BgL_arg2739z00_901);
																			}
																			{	/* Object/creator.scm 284 */
																				obj_t BgL_list2735z00_897;

																				{	/* Object/creator.scm 284 */
																					obj_t BgL_arg2736z00_898;

																					{	/* Object/creator.scm 284 */
																						obj_t BgL_arg2737z00_899;

																						BgL_arg2737z00_899 =
																							MAKE_PAIR(BgL_argszd2idzd2_873,
																							BNIL);
																						BgL_arg2736z00_898 =
																							MAKE_PAIR(BgL_arg2734z00_896,
																							BgL_arg2737z00_899);
																					}
																					BgL_list2735z00_897 =
																						MAKE_PAIR(BgL_jidz00_869,
																						BgL_arg2736z00_898);
																				}
																				BgL_runner2751z00_920 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2733z00_895,
																					BgL_list2735z00_897);
																			}
																		}
																		{	/* Object/creator.scm 284 */
																			obj_t BgL_aux2749z00_918;

																			BgL_aux2749z00_918 =
																				CAR(BgL_runner2751z00_920);
																			BgL_runner2751z00_920 =
																				CDR(BgL_runner2751z00_920);
																			{	/* Object/creator.scm 284 */
																				obj_t BgL_aux2750z00_919;

																				BgL_aux2750z00_919 =
																					CAR(BgL_runner2751z00_920);
																				BgL_runner2751z00_920 =
																					CDR(BgL_runner2751z00_920);
																				BgL_arg2728z00_890 =
																					BGl_makezd2privatezd2sexpz00zzast_privatez00
																					(BgL_aux2749z00_918,
																					BgL_aux2750z00_919,
																					BgL_runner2751z00_920);
																			}
																		}
																	}
																	{	/* Object/creator.scm 282 */
																		obj_t BgL_list2730z00_892;

																		{	/* Object/creator.scm 282 */
																			obj_t BgL_arg2731z00_893;

																			BgL_arg2731z00_893 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_list2730z00_892 =
																				MAKE_PAIR(BgL_arg2728z00_890,
																				BgL_arg2731z00_893);
																		}
																		BgL_arg2725z00_888 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg2727z00_889, BgL_list2730z00_892);
																	}
																}
																BgL_defz00_877 =
																	MAKE_PAIR(BgL_arg2723z00_887,
																	BgL_arg2725z00_888);
															}
															{	/* Object/creator.scm 282 */
																obj_t BgL_scopez00_878;

																if (BGl_inlinezd2creatorszf3z21zzobject_creatorz00())
																	{	/* Object/creator.scm 290 */
																		BgL_scopez00_878 =
																			CNST_TABLE_REF(((long) 10));
																	}
																else
																	{	/* Object/creator.scm 290 */
																		BgL_scopez00_878 =
																			CNST_TABLE_REF(((long) 17));
																	}
																{	/* Object/creator.scm 290 */
																	obj_t BgL_modz00_879;

																	{	/* Object/creator.scm 291 */
																		obj_t BgL_arg2717z00_881;

																		{	/* Object/creator.scm 291 */
																			obj_t BgL_arg2718z00_882;

																			BgL_arg2718z00_882 =
																				MAKE_PAIR(BgL_tidz00_872,
																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																				(BgL_argszd2typezd2_863, BNIL));
																			{	/* Object/creator.scm 291 */
																				obj_t BgL_list2720z00_884;

																				BgL_list2720z00_884 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_arg2717z00_881 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2718z00_882,
																					BgL_list2720z00_884);
																		}}
																		BgL_modz00_879 =
																			MAKE_PAIR(BgL_scopez00_878,
																			BgL_arg2717z00_881);
																	}
																	{	/* Object/creator.scm 291 */

																		BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																			(BgL_modz00_879);
																		{	/* Object/creator.scm 293 */
																			obj_t BgL_list2716z00_880;

																			BgL_list2716z00_880 =
																				MAKE_PAIR(BgL_constrz00_860, BNIL);
																			return
																				BGl_epairifyza2za2zztools_miscz00
																				(BgL_defz00_877, BgL_list2716z00_880);
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				else
					{	/* Object/creator.scm 293 */
						return BFALSE;
					}
			}
		}
	}



/* _gen-java-class-constructors */
	obj_t BGl__genzd2javazd2classzd2constructorszd2zzobject_creatorz00(obj_t
		BgL_envz00_2065, obj_t BgL_classz00_2066, obj_t BgL_constrsz00_2067,
		obj_t BgL_srczd2defzd2_2068)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 264 */
			return
				BGl_genzd2javazd2classzd2constructorszd2zzobject_creatorz00(
				(BgL_jclassz00_bglt) (BgL_classz00_2066), BgL_constrsz00_2067,
				BgL_srczd2defzd2_2068);
		}
	}



/* gen-class-fill! */
	obj_t BGl_genzd2classzd2fillz12z12zzobject_creatorz00(obj_t
		BgL_fillzd2idzd2_45, obj_t BgL_idz00_46, BgL_tclassz00_bglt BgL_typez00_47,
		obj_t BgL_srczd2defzd2_48, obj_t BgL_importz00_49)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 302 */
			{	/* Object/creator.scm 303 */
				obj_t BgL_tidz00_964;

				{	/* Object/creator.scm 303 */
					bool_t BgL_testz00_2708;

					if (BGl_widezd2classzf3z21zzobject_classz00((obj_t) (BgL_typez00_47)))
						{	/* Object/creator.scm 303 */
							BgL_testz00_2708 = CBOOL(BGl_za2sawza2z00zzengine_paramz00);
						}
					else
						{	/* Object/creator.scm 303 */
							BgL_testz00_2708 = ((bool_t) 0);
						}
					if (BgL_testz00_2708)
						{	/* Object/creator.scm 304 */
							obj_t BgL_arg2823z00_1036;

							{
								BgL_typez00_bglt BgL_auxz00_2713;

								BgL_auxz00_2713 = (BgL_typez00_bglt) (BgL_typez00_47);
								BgL_arg2823z00_1036 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2713))->BgL_idz00);
							}
							BgL_tidz00_964 =
								BGl_sawzd2widezd2classzd2idzd2zzobject_classz00
								(BgL_arg2823z00_1036);
						}
					else
						{
							BgL_typez00_bglt BgL_auxz00_2717;

							BgL_auxz00_2717 = (BgL_typez00_bglt) (BgL_typez00_47);
							BgL_tidz00_964 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2717))->BgL_idz00);
						}
				}
				{	/* Object/creator.scm 303 */
					obj_t BgL_slotsz00_965;

					{
						obj_t BgL_auxz00_2720;

						{	/* Object/creator.scm 306 */
							BgL_objectz00_bglt BgL_auxz00_2721;

							BgL_auxz00_2721 = (BgL_objectz00_bglt) (BgL_typez00_47);
							BgL_auxz00_2720 = BGL_OBJECT_WIDENING(BgL_auxz00_2721);
						}
						BgL_slotsz00_965 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2720))->BgL_slotsz00);
					}
					{	/* Object/creator.scm 306 */
						obj_t BgL_fillzd2tidzd2_966;

						BgL_fillzd2tidzd2_966 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_fillzd2idzd2_45,
							BgL_tidz00_964);
						{	/* Object/creator.scm 307 */
							obj_t BgL_fzd2idszd2_967;

							BgL_fzd2idszd2_967 =
								BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
								(BgL_slotsz00_965);
							{	/* Object/creator.scm 308 */
								obj_t BgL_fzd2tidszd2_968;

								BgL_fzd2tidszd2_968 =
									BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
									(BgL_fzd2idszd2_967, BgL_slotsz00_965);
								{	/* Object/creator.scm 309 */
									obj_t BgL_newz00_969;

									BgL_newz00_969 =
										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
										(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
													9))));
									{	/* Object/creator.scm 310 */
										obj_t BgL_tnewz00_970;

										{	/* Object/creator.scm 311 */
											bool_t BgL_testz00_2731;

											if (BGl_widezd2classzf3z21zzobject_classz00(
													(obj_t) (BgL_typez00_47)))
												{	/* Object/creator.scm 312 */
													obj_t BgL_arg2820z00_1033;

													BgL_arg2820z00_1033 =
														BGl_thezd2backendzd2zzbackend_backendz00();
													{
														BgL_backendz00_bglt BgL_auxz00_2736;

														BgL_auxz00_2736 =
															(BgL_backendz00_bglt) (BgL_arg2820z00_1033);
														BgL_testz00_2731 =
															(((BgL_backendz00_bglt) CREF(BgL_auxz00_2736))->
															BgL_typedz00);
													}
												}
											else
												{	/* Object/creator.scm 311 */
													BgL_testz00_2731 = ((bool_t) 0);
												}
											if (BgL_testz00_2731)
												{	/* Object/creator.scm 311 */
													BgL_tnewz00_970 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_newz00_969, CNST_TABLE_REF(((long) 14)));
												}
											else
												{	/* Object/creator.scm 311 */
													BgL_tnewz00_970 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_newz00_969, BgL_tidz00_964);
												}
										}
										{	/* Object/creator.scm 311 */
											obj_t BgL_ridz00_971;

											BgL_ridz00_971 =
												BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
												(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 18))));
											{	/* Object/creator.scm 315 */
												obj_t BgL_rtidz00_972;

												{	/* Object/creator.scm 316 */
													obj_t BgL_arg2811z00_1025;

													{	/* Object/creator.scm 316 */
														obj_t BgL_arg2812z00_1026;

														obj_t BgL_arg2813z00_1027;

														BgL_arg2812z00_1026 =
															SYMBOL_TO_STRING(BgL_ridz00_971);
														{	/* Object/creator.scm 316 */
															obj_t BgL_symbolz00_1927;

															BgL_symbolz00_1927 = CNST_TABLE_REF(((long) 19));
															BgL_arg2813z00_1027 =
																SYMBOL_TO_STRING(BgL_symbolz00_1927);
														}
														{	/* Object/creator.scm 316 */
															obj_t BgL_list2814z00_1028;

															{	/* Object/creator.scm 316 */
																obj_t BgL_arg2815z00_1029;

																BgL_arg2815z00_1029 =
																	MAKE_PAIR(BgL_arg2813z00_1027, BNIL);
																BgL_list2814z00_1028 =
																	MAKE_PAIR(BgL_arg2812z00_1026,
																	BgL_arg2815z00_1029);
															}
															BgL_arg2811z00_1025 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list2814z00_1028);
													}}
													BgL_rtidz00_972 =
														string_to_symbol(BSTRING_TO_STRING
														(BgL_arg2811z00_1025));
												}
												{	/* Object/creator.scm 316 */

													{

														{	/* Object/creator.scm 326 */
															obj_t BgL_protoz00_974;

															obj_t BgL_bodyz00_975;

															{	/* Object/creator.scm 326 */
																obj_t BgL_arg2788z00_989;

																{	/* Object/creator.scm 326 */
																	obj_t BgL_list2789z00_990;

																	BgL_list2789z00_990 =
																		MAKE_PAIR(BgL_fzd2tidszd2_968, BNIL);
																	BgL_arg2788z00_989 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_tnewz00_970, BgL_list2789z00_990);
																}
																BgL_protoz00_974 =
																	MAKE_PAIR(BgL_fillzd2tidzd2_966,
																	BgL_arg2788z00_989);
															}
															{	/* Object/creator.scm 319 */
																obj_t BgL_alloczd2idzd2_993;

																{	/* Object/creator.scm 320 */
																	obj_t BgL_arg2806z00_1019;

																	{	/* Object/creator.scm 320 */
																		obj_t BgL_arg2807z00_1020;

																		obj_t BgL_arg2808z00_1021;

																		{	/* Object/creator.scm 320 */
																			obj_t BgL_symbolz00_1930;

																			BgL_symbolz00_1930 =
																				CNST_TABLE_REF(((long) 7));
																			BgL_arg2807z00_1020 =
																				SYMBOL_TO_STRING(BgL_symbolz00_1930);
																		}
																		BgL_arg2808z00_1021 =
																			SYMBOL_TO_STRING(BgL_idz00_46);
																		{	/* Object/creator.scm 320 */
																			obj_t BgL_list2809z00_1022;

																			{	/* Object/creator.scm 320 */
																				obj_t BgL_arg2810z00_1023;

																				BgL_arg2810z00_1023 =
																					MAKE_PAIR(BgL_arg2808z00_1021, BNIL);
																				BgL_list2809z00_1022 =
																					MAKE_PAIR(BgL_arg2807z00_1020,
																					BgL_arg2810z00_1023);
																			}
																			BgL_arg2806z00_1019 =
																				BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																				(BgL_list2809z00_1022);
																	}}
																	BgL_alloczd2idzd2_993 =
																		string_to_symbol(BSTRING_TO_STRING
																		(BgL_arg2806z00_1019));
																}
																{	/* Object/creator.scm 320 */

																	{	/* Object/creator.scm 321 */
																		obj_t BgL_arg2791z00_994;

																		obj_t BgL_arg2792z00_995;

																		BgL_arg2791z00_994 =
																			CNST_TABLE_REF(((long) 20));
																		{	/* Object/creator.scm 321 */
																			obj_t BgL_arg2793z00_996;

																			obj_t BgL_arg2794z00_997;

																			if (NULLP(BgL_fzd2tidszd2_968))
																				{	/* Object/creator.scm 321 */
																					BgL_arg2793z00_996 = BNIL;
																				}
																			else
																				{	/* Object/creator.scm 321 */
																					obj_t BgL_head2454z00_1002;

																					BgL_head2454z00_1002 =
																						MAKE_PAIR(BNIL, BNIL);
																					{
																						obj_t BgL_ll2452z00_1003;

																						obj_t BgL_ll2453z00_1004;

																						obj_t BgL_tail2455z00_1005;

																						BgL_ll2452z00_1003 =
																							BgL_fzd2tidszd2_968;
																						BgL_ll2453z00_1004 =
																							BgL_fzd2idszd2_967;
																						BgL_tail2455z00_1005 =
																							BgL_head2454z00_1002;
																					BgL_map2457z00_1006:
																						if (NULLP(BgL_ll2452z00_1003))
																							{	/* Object/creator.scm 321 */
																								BgL_arg2793z00_996 =
																									CDR(BgL_head2454z00_1002);
																							}
																						else
																							{	/* Object/creator.scm 321 */
																								obj_t BgL_newtail2456z00_1008;

																								{	/* Object/creator.scm 321 */
																									obj_t BgL_arg2800z00_1011;

																									{	/* Object/creator.scm 321 */
																										obj_t BgL_ftz00_1013;

																										obj_t BgL_fz00_1014;

																										BgL_ftz00_1013 =
																											CAR(BgL_ll2452z00_1003);
																										BgL_fz00_1014 =
																											CAR(BgL_ll2453z00_1004);
																										{	/* Object/creator.scm 321 */
																											obj_t BgL_arg2802z00_1015;

																											{	/* Object/creator.scm 321 */
																												obj_t
																													BgL_list2803z00_1016;
																												BgL_list2803z00_1016 =
																													MAKE_PAIR(BNIL, BNIL);
																												BgL_arg2802z00_1015 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_fz00_1014,
																													BgL_list2803z00_1016);
																											}
																											BgL_arg2800z00_1011 =
																												MAKE_PAIR
																												(BgL_ftz00_1013,
																												BgL_arg2802z00_1015);
																										}
																									}
																									BgL_newtail2456z00_1008 =
																										MAKE_PAIR
																										(BgL_arg2800z00_1011, BNIL);
																								}
																								SET_CDR(BgL_tail2455z00_1005,
																									BgL_newtail2456z00_1008);
																								{
																									obj_t BgL_tail2455z00_2782;

																									obj_t BgL_ll2453z00_2780;

																									obj_t BgL_ll2452z00_2778;

																									BgL_ll2452z00_2778 =
																										CDR(BgL_ll2452z00_1003);
																									BgL_ll2453z00_2780 =
																										CDR(BgL_ll2453z00_1004);
																									BgL_tail2455z00_2782 =
																										BgL_newtail2456z00_1008;
																									BgL_tail2455z00_1005 =
																										BgL_tail2455z00_2782;
																									BgL_ll2453z00_1004 =
																										BgL_ll2453z00_2780;
																									BgL_ll2452z00_1003 =
																										BgL_ll2452z00_2778;
																									goto BgL_map2457z00_1006;
																								}
																							}
																					}
																				}
																			{	/* Object/creator.scm 322 */
																				obj_t BgL_arg2804z00_1017;

																				obj_t BgL_arg2805z00_1018;

																				BgL_arg2804z00_1017 =
																					BGl_makezd2classzd2slotzd2makez12zc0zzobject_creatorz00
																					(BgL_typez00_47, BgL_newz00_969,
																					BgL_ridz00_971, BgL_rtidz00_972,
																					BgL_slotsz00_965, BgL_fzd2idszd2_967);
																				BgL_arg2805z00_1018 =
																					MAKE_PAIR(BgL_newz00_969, BNIL);
																				BgL_arg2794z00_997 =
																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2804z00_1017,
																					BgL_arg2805z00_1018);
																			}
																			{	/* Object/creator.scm 321 */
																				obj_t BgL_list2795z00_998;

																				BgL_list2795z00_998 =
																					MAKE_PAIR(BgL_arg2794z00_997, BNIL);
																				BgL_arg2792z00_995 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_arg2793z00_996,
																					BgL_list2795z00_998);
																			}
																		}
																		BgL_bodyz00_975 =
																			MAKE_PAIR(BgL_arg2791z00_994,
																			BgL_arg2792z00_995);
																	}
																}
															}
															{	/* Object/creator.scm 329 */
																obj_t BgL_arg2775z00_976;

																{	/* Object/creator.scm 329 */
																	obj_t BgL_arg2776z00_977;

																	{	/* Object/creator.scm 329 */
																		obj_t BgL_arg2777z00_978;

																		{	/* Object/creator.scm 329 */
																			obj_t BgL_arg2780z00_981;

																			obj_t BgL_arg2781z00_982;

																			BgL_arg2780z00_981 =
																				CNST_TABLE_REF(((long) 11));
																			BgL_arg2781z00_982 =
																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																				(BgL_protoz00_974, BNIL);
																			BgL_arg2777z00_978 =
																				MAKE_PAIR(BgL_arg2780z00_981,
																				BgL_arg2781z00_982);
																		}
																		{	/* Object/creator.scm 329 */
																			obj_t BgL_list2779z00_980;

																			BgL_list2779z00_980 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg2776z00_977 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2777z00_978,
																				BgL_list2779z00_980);
																	}}
																	BgL_arg2775z00_976 =
																		MAKE_PAIR(BgL_importz00_49,
																		BgL_arg2776z00_977);
																}
																BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																	(BgL_arg2775z00_976);
															}
															{	/* Object/creator.scm 331 */
																obj_t BgL_arg2782z00_983;

																{	/* Object/creator.scm 331 */
																	obj_t BgL_arg2784z00_985;

																	obj_t BgL_arg2785z00_986;

																	BgL_arg2784z00_985 =
																		CNST_TABLE_REF(((long) 8));
																	{	/* Object/creator.scm 331 */
																		obj_t BgL_list2786z00_987;

																		{	/* Object/creator.scm 331 */
																			obj_t BgL_arg2787z00_988;

																			BgL_arg2787z00_988 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_list2786z00_987 =
																				MAKE_PAIR(BgL_bodyz00_975,
																				BgL_arg2787z00_988);
																		}
																		BgL_arg2785z00_986 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_protoz00_974, BgL_list2786z00_987);
																	}
																	BgL_arg2782z00_983 =
																		MAKE_PAIR(BgL_arg2784z00_985,
																		BgL_arg2785z00_986);
																}
																{	/* Object/creator.scm 331 */
																	obj_t BgL_list2783z00_984;

																	BgL_list2783z00_984 =
																		MAKE_PAIR(BgL_srczd2defzd2_48, BNIL);
																	return
																		BGl_epairifyza2za2zztools_miscz00
																		(BgL_arg2782z00_983, BgL_list2783z00_984);
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* gen-class-make! */
	obj_t BGl_genzd2classzd2makez12z12zzobject_creatorz00(obj_t
		BgL_wideningz00_50, obj_t BgL_mkzd2idzd2_51, obj_t BgL_idz00_52,
		BgL_tclassz00_bglt BgL_typez00_53, obj_t BgL_srczd2defzd2_54,
		obj_t BgL_importz00_55)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 338 */
			{	/* Object/creator.scm 339 */
				obj_t BgL_tidz00_1038;

				{	/* Object/creator.scm 339 */
					bool_t BgL_testz00_2803;

					if ((BgL_wideningz00_50 == CNST_TABLE_REF(((long) 6))))
						{	/* Object/creator.scm 339 */
							if (BGl_widezd2classzf3z21zzobject_classz00(
									(obj_t) (BgL_typez00_53)))
								{	/* Object/creator.scm 340 */
									BgL_testz00_2803 = CBOOL(BGl_za2sawza2z00zzengine_paramz00);
								}
							else
								{	/* Object/creator.scm 340 */
									BgL_testz00_2803 = ((bool_t) 0);
								}
						}
					else
						{	/* Object/creator.scm 339 */
							BgL_testz00_2803 = ((bool_t) 0);
						}
					if (BgL_testz00_2803)
						{	/* Object/creator.scm 342 */
							obj_t BgL_arg2970z00_1221;

							{
								BgL_typez00_bglt BgL_auxz00_2811;

								BgL_auxz00_2811 = (BgL_typez00_bglt) (BgL_typez00_53);
								BgL_arg2970z00_1221 =
									(((BgL_typez00_bglt) CREF(BgL_auxz00_2811))->BgL_idz00);
							}
							BgL_tidz00_1038 =
								BGl_sawzd2widezd2classzd2idzd2zzobject_classz00
								(BgL_arg2970z00_1221);
						}
					else
						{
							BgL_typez00_bglt BgL_auxz00_2815;

							BgL_auxz00_2815 = (BgL_typez00_bglt) (BgL_typez00_53);
							BgL_tidz00_1038 =
								(((BgL_typez00_bglt) CREF(BgL_auxz00_2815))->BgL_idz00);
						}
				}
				{	/* Object/creator.scm 339 */
					obj_t BgL_slotsz00_1039;

					{
						obj_t BgL_auxz00_2818;

						{	/* Object/creator.scm 344 */
							BgL_objectz00_bglt BgL_auxz00_2819;

							BgL_auxz00_2819 = (BgL_objectz00_bglt) (BgL_typez00_53);
							BgL_auxz00_2818 = BGL_OBJECT_WIDENING(BgL_auxz00_2819);
						}
						BgL_slotsz00_1039 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_2818))->BgL_slotsz00);
					}
					{	/* Object/creator.scm 345 */
						obj_t BgL_constrsz00_1041;

						BgL_constrsz00_1041 =
							BGl_findzd2classzd2constructorsz00zzobject_classz00
							(BgL_typez00_53);
						{	/* Object/creator.scm 346 */
							obj_t BgL_mkzd2tidzd2_1042;

							BgL_mkzd2tidzd2_1042 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_mkzd2idzd2_51,
								BgL_tidz00_1038);
							{	/* Object/creator.scm 349 */
								obj_t BgL_fillzd2idzd2_1043;

								{	/* Object/creator.scm 350 */
									obj_t BgL_list2965z00_1216;

									{	/* Object/creator.scm 350 */
										obj_t BgL_arg2966z00_1217;

										obj_t BgL_arg2967z00_1218;

										BgL_arg2966z00_1217 = CNST_TABLE_REF(((long) 1));
										{	/* Object/creator.scm 350 */
											obj_t BgL_arg2968z00_1219;

											BgL_arg2968z00_1219 =
												MAKE_PAIR(CNST_TABLE_REF(((long) 2)), BNIL);
											BgL_arg2967z00_1218 =
												MAKE_PAIR(BgL_idz00_52, BgL_arg2968z00_1219);
										}
										BgL_list2965z00_1216 =
											MAKE_PAIR(BgL_arg2966z00_1217, BgL_arg2967z00_1218);
									}
									BgL_fillzd2idzd2_1043 =
										BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
										(BgL_list2965z00_1216);
								}
								{	/* Object/creator.scm 350 */
									obj_t BgL_fzd2idszd2_1044;

									BgL_fzd2idszd2_1044 =
										BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
										(BgL_slotsz00_1039);
									{	/* Object/creator.scm 351 */
										obj_t BgL_fzd2tidszd2_1045;

										BgL_fzd2tidszd2_1045 =
											BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
											(BgL_fzd2idszd2_1044, BgL_slotsz00_1039);
										{	/* Object/creator.scm 352 */
											obj_t BgL_newz00_1046;

											BgL_newz00_1046 =
												BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
												(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 9))));
											{	/* Object/creator.scm 353 */
												obj_t BgL_ridz00_1047;

												BgL_ridz00_1047 =
													BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
													(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
																(long) 18))));
												{	/* Object/creator.scm 354 */
													obj_t BgL_rtidz00_1048;

													{	/* Object/creator.scm 355 */
														obj_t BgL_arg2958z00_1209;

														{	/* Object/creator.scm 355 */
															obj_t BgL_arg2959z00_1210;

															obj_t BgL_arg2960z00_1211;

															BgL_arg2959z00_1210 =
																SYMBOL_TO_STRING(BgL_ridz00_1047);
															{	/* Object/creator.scm 355 */
																obj_t BgL_symbolz00_1951;

																BgL_symbolz00_1951 =
																	CNST_TABLE_REF(((long) 19));
																BgL_arg2960z00_1211 =
																	SYMBOL_TO_STRING(BgL_symbolz00_1951);
															}
															{	/* Object/creator.scm 355 */
																obj_t BgL_list2961z00_1212;

																{	/* Object/creator.scm 355 */
																	obj_t BgL_arg2962z00_1213;

																	BgL_arg2962z00_1213 =
																		MAKE_PAIR(BgL_arg2960z00_1211, BNIL);
																	BgL_list2961z00_1212 =
																		MAKE_PAIR(BgL_arg2959z00_1210,
																		BgL_arg2962z00_1213);
																}
																BgL_arg2958z00_1209 =
																	BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																	(BgL_list2961z00_1212);
														}}
														BgL_rtidz00_1048 =
															string_to_symbol(BSTRING_TO_STRING
															(BgL_arg2958z00_1209));
													}
													{	/* Object/creator.scm 355 */

														{

															{	/* Object/creator.scm 403 */
																obj_t BgL_arg2825z00_1053;

																{	/* Object/creator.scm 403 */
																	obj_t BgL_arg2826z00_1054;

																	{	/* Object/creator.scm 403 */
																		obj_t BgL_arg2827z00_1055;

																		BgL_arg2827z00_1055 =
																			MAKE_PAIR(BgL_mkzd2tidzd2_1042,
																			BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																			(BgL_fzd2tidszd2_1045, BNIL));
																		{	/* Object/creator.scm 403 */
																			obj_t BgL_list2829z00_1057;

																			BgL_list2829z00_1057 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg2826z00_1054 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2827z00_1055,
																				BgL_list2829z00_1057);
																	}}
																	BgL_arg2825z00_1053 =
																		MAKE_PAIR(BgL_importz00_55,
																		BgL_arg2826z00_1054);
																}
																BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																	(BgL_arg2825z00_1053);
															}
															{	/* Object/creator.scm 404 */
																obj_t BgL_arg2831z00_1059;

																{	/* Object/creator.scm 404 */
																	obj_t BgL_arg2832z00_1060;

																	obj_t BgL_arg2833z00_1061;

																	BgL_arg2832z00_1060 =
																		CNST_TABLE_REF(((long) 23));
																	{	/* Object/creator.scm 404 */
																		obj_t BgL_arg2834z00_1062;

																		{	/* Object/creator.scm 404 */
																			obj_t BgL_arg2838z00_1065;

																			{	/* Object/creator.scm 404 */
																				obj_t BgL_list2839z00_1066;

																				BgL_list2839z00_1066 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_arg2838z00_1065 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(CNST_TABLE_REF(((long) 24)),
																					BgL_list2839z00_1066);
																			}
																			BgL_arg2834z00_1062 =
																				MAKE_PAIR(BgL_mkzd2idzd2_51,
																				BgL_arg2838z00_1065);
																		}
																		{	/* Object/creator.scm 404 */
																			obj_t BgL_list2836z00_1064;

																			BgL_list2836z00_1064 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg2833z00_1061 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg2834z00_1062,
																				BgL_list2836z00_1064);
																	}}
																	BgL_arg2831z00_1059 =
																		MAKE_PAIR(BgL_arg2832z00_1060,
																		BgL_arg2833z00_1061);
																}
																BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																	(BgL_arg2831z00_1059);
															}
															{	/* Object/creator.scm 406 */
																obj_t BgL_protoz00_1067;

																obj_t BgL_bodyz00_1068;

																BgL_protoz00_1067 =
																	MAKE_PAIR(BgL_mkzd2tidzd2_1042,
																	BgL_fzd2tidszd2_1045);
																{	/* Object/creator.scm 399 */
																	bool_t BgL_testz00_2863;

																	{	/* Object/creator.scm 399 */
																		obj_t BgL_arg2848z00_1077;

																		obj_t BgL_arg2849z00_1078;

																		{	/* Object/creator.scm 399 */
																			obj_t BgL_arg2850z00_1079;

																			BgL_arg2850z00_1079 =
																				BGl_thezd2backendzd2zzbackend_backendz00
																				();
																			{
																				BgL_backendz00_bglt BgL_auxz00_2865;

																				BgL_auxz00_2865 =
																					(BgL_backendz00_bglt)
																					(BgL_arg2850z00_1079);
																				BgL_arg2848z00_1077 =
																					(((BgL_backendz00_bglt)
																						CREF(BgL_auxz00_2865))->
																					BgL_languagez00);
																		}}
																		BgL_arg2849z00_1078 =
																			CNST_TABLE_REF(((long) 22));
																		BgL_testz00_2863 =
																			(BgL_arg2848z00_1077 ==
																			BgL_arg2849z00_1078);
																	}
																	if (BgL_testz00_2863)
																		{	/* Object/creator.scm 399 */
																			{	/* Object/creator.scm 371 */
																				obj_t BgL_alloczd2idzd2_1130;

																				{	/* Object/creator.scm 371 */
																					obj_t BgL_arg2931z00_1173;

																					{	/* Object/creator.scm 371 */
																						obj_t BgL_arg2932z00_1174;

																						obj_t BgL_arg2933z00_1175;

																						{	/* Object/creator.scm 371 */
																							obj_t BgL_symbolz00_1969;

																							BgL_symbolz00_1969 =
																								CNST_TABLE_REF(((long) 7));
																							BgL_arg2932z00_1174 =
																								SYMBOL_TO_STRING
																								(BgL_symbolz00_1969);
																						}
																						BgL_arg2933z00_1175 =
																							SYMBOL_TO_STRING(BgL_idz00_52);
																						{	/* Object/creator.scm 371 */
																							obj_t BgL_list2934z00_1176;

																							{	/* Object/creator.scm 371 */
																								obj_t BgL_arg2935z00_1177;

																								BgL_arg2935z00_1177 =
																									MAKE_PAIR(BgL_arg2933z00_1175,
																									BNIL);
																								BgL_list2934z00_1176 =
																									MAKE_PAIR(BgL_arg2932z00_1174,
																									BgL_arg2935z00_1177);
																							}
																							BgL_arg2931z00_1173 =
																								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																								(BgL_list2934z00_1176);
																					}}
																					BgL_alloczd2idzd2_1130 =
																						string_to_symbol(BSTRING_TO_STRING
																						(BgL_arg2931z00_1173));
																				}
																				{	/* Object/creator.scm 371 */

																					{	/* Object/creator.scm 372 */
																						obj_t BgL_arg2893z00_1131;

																						obj_t BgL_arg2894z00_1132;

																						BgL_arg2893z00_1131 =
																							CNST_TABLE_REF(((long) 20));
																						{	/* Object/creator.scm 372 */
																							obj_t BgL_arg2895z00_1133;

																							obj_t BgL_arg2896z00_1134;

																							{	/* Object/creator.scm 372 */
																								obj_t BgL_arg2900z00_1138;

																								{	/* Object/creator.scm 372 */
																									obj_t BgL_arg2905z00_1140;

																									obj_t BgL_arg2906z00_1141;

																									BgL_arg2905z00_1140 =
																										BGl_makezd2typedzd2identz00zzast_identz00
																										(BgL_newz00_1046,
																										BgL_tidz00_1038);
																									{	/* Object/creator.scm 373 */
																										obj_t BgL_arg2907z00_1142;

																										if (
																											(BgL_wideningz00_50 ==
																												CNST_TABLE_REF(((long)
																														6))))
																											{	/* Object/creator.scm 373 */
																												BgL_arg2907z00_1142 =
																													BGl_alloczd2wideningzd2zzobject_creatorz00
																													(BgL_tidz00_1038,
																													BgL_typez00_53);
																											}
																										else
																											{	/* Object/creator.scm 373 */
																												BgL_arg2907z00_1142 =
																													MAKE_PAIR
																													(BgL_alloczd2idzd2_1130,
																													BNIL);
																											}
																										{	/* Object/creator.scm 372 */
																											obj_t
																												BgL_list2909z00_1144;
																											BgL_list2909z00_1144 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_arg2906z00_1141 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg2907z00_1142,
																												BgL_list2909z00_1144);
																										}
																									}
																									BgL_arg2900z00_1138 =
																										MAKE_PAIR
																										(BgL_arg2905z00_1140,
																										BgL_arg2906z00_1141);
																								}
																								BgL_arg2895z00_1133 =
																									MAKE_PAIR(BgL_arg2900z00_1138,
																									BNIL);
																							}
																							{	/* Object/creator.scm 376 */
																								obj_t BgL_arg2911z00_1146;

																								obj_t BgL_arg2912z00_1147;

																								BgL_arg2911z00_1146 =
																									CNST_TABLE_REF(((long) 21));
																								{	/* Object/creator.scm 378 */
																									obj_t BgL_arg2913z00_1148;

																									obj_t BgL_arg2914z00_1149;

																									{	/* Object/creator.scm 378 */
																										obj_t BgL_arg2916z00_1151;

																										{	/* Object/creator.scm 378 */
																											obj_t BgL_arg2917z00_1152;

																											BgL_arg2917z00_1152 =
																												BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																												(BgL_fzd2idszd2_1044,
																												BNIL);
																											{	/* Object/creator.scm 378 */
																												obj_t
																													BgL_list2918z00_1153;
																												BgL_list2918z00_1153 =
																													MAKE_PAIR
																													(BgL_arg2917z00_1152,
																													BNIL);
																												BgL_arg2916z00_1151 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_newz00_1046,
																													BgL_list2918z00_1153);
																										}}
																										BgL_arg2913z00_1148 =
																											MAKE_PAIR
																											(BgL_fillzd2idzd2_1043,
																											BgL_arg2916z00_1151);
																									}
																									{	/* Object/creator.scm 380 */
																										obj_t BgL_arg2919z00_1154;

																										obj_t BgL_arg2920z00_1155;

																										{	/* Object/creator.scm 380 */
																											bool_t BgL_testz00_2894;

																											if (PAIRP
																												(BgL_constrsz00_1041))
																												{	/* Object/creator.scm 380 */
																													if (
																														(BgL_wideningz00_50
																															==
																															CNST_TABLE_REF((
																																	(long) 6))))
																														{	/* Object/creator.scm 380 */
																															BgL_testz00_2894 =
																																((bool_t) 0);
																														}
																													else
																														{	/* Object/creator.scm 380 */
																															BgL_testz00_2894 =
																																((bool_t) 1);
																														}
																												}
																											else
																												{	/* Object/creator.scm 380 */
																													BgL_testz00_2894 =
																														((bool_t) 0);
																												}
																											if (BgL_testz00_2894)
																												{	/* Object/creator.scm 380 */
																													if (NULLP
																														(BgL_constrsz00_1041))
																														{	/* Object/creator.scm 381 */
																															BgL_arg2919z00_1154
																																= BNIL;
																														}
																													else
																														{	/* Object/creator.scm 381 */
																															obj_t
																																BgL_head2466z00_1159;
																															BgL_head2466z00_1159
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															{
																																obj_t
																																	BgL_l2464z00_1160;
																																obj_t
																																	BgL_tail2467z00_1161;
																																BgL_l2464z00_1160
																																	=
																																	BgL_constrsz00_1041;
																																BgL_tail2467z00_1161
																																	=
																																	BgL_head2466z00_1159;
																															BgL_map2465z00_1162:
																																if (NULLP
																																	(BgL_l2464z00_1160))
																																	{	/* Object/creator.scm 381 */
																																		BgL_arg2919z00_1154
																																			=
																																			CDR
																																			(BgL_head2466z00_1159);
																																	}
																																else
																																	{	/* Object/creator.scm 381 */
																																		obj_t
																																			BgL_newtail2468z00_1164;
																																		{	/* Object/creator.scm 381 */
																																			obj_t
																																				BgL_arg2925z00_1166;
																																			{	/* Object/creator.scm 381 */
																																				obj_t
																																					BgL_constrz00_1168;
																																				BgL_constrz00_1168
																																					=
																																					CAR
																																					(BgL_l2464z00_1160);
																																				{	/* Object/creator.scm 381 */
																																					obj_t
																																						BgL_arg2927z00_1169;
																																					{	/* Object/creator.scm 381 */
																																						obj_t
																																							BgL_list2928z00_1170;
																																						BgL_list2928z00_1170
																																							=
																																							MAKE_PAIR
																																							(BNIL,
																																							BNIL);
																																						BgL_arg2927z00_1169
																																							=
																																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																							(BgL_newz00_1046,
																																							BgL_list2928z00_1170);
																																					}
																																					BgL_arg2925z00_1166
																																						=
																																						MAKE_PAIR
																																						(BgL_constrz00_1168,
																																						BgL_arg2927z00_1169);
																																				}
																																			}
																																			BgL_newtail2468z00_1164
																																				=
																																				MAKE_PAIR
																																				(BgL_arg2925z00_1166,
																																				BNIL);
																																		}
																																		SET_CDR
																																			(BgL_tail2467z00_1161,
																																			BgL_newtail2468z00_1164);
																																		{
																																			obj_t
																																				BgL_tail2467z00_2914;
																																			obj_t
																																				BgL_l2464z00_2912;
																																			BgL_l2464z00_2912
																																				=
																																				CDR
																																				(BgL_l2464z00_1160);
																																			BgL_tail2467z00_2914
																																				=
																																				BgL_newtail2468z00_1164;
																																			BgL_tail2467z00_1161
																																				=
																																				BgL_tail2467z00_2914;
																																			BgL_l2464z00_1160
																																				=
																																				BgL_l2464z00_2912;
																																			goto
																																				BgL_map2465z00_1162;
																																		}
																																	}
																															}
																														}
																												}
																											else
																												{	/* Object/creator.scm 380 */
																													BgL_arg2919z00_1154 =
																														BNIL;
																												}
																										}
																										BgL_arg2920z00_1155 =
																											MAKE_PAIR(BgL_newz00_1046,
																											BNIL);
																										BgL_arg2914z00_1149 =
																											BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2919z00_1154,
																											BgL_arg2920z00_1155);
																									}
																									{	/* Object/creator.scm 376 */
																										obj_t BgL_list2915z00_1150;

																										BgL_list2915z00_1150 =
																											MAKE_PAIR
																											(BgL_arg2914z00_1149,
																											BNIL);
																										BgL_arg2912z00_1147 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2913z00_1148,
																											BgL_list2915z00_1150);
																									}
																								}
																								BgL_arg2896z00_1134 =
																									MAKE_PAIR(BgL_arg2911z00_1146,
																									BgL_arg2912z00_1147);
																							}
																							{	/* Object/creator.scm 372 */
																								obj_t BgL_list2898z00_1136;

																								{	/* Object/creator.scm 372 */
																									obj_t BgL_arg2899z00_1137;

																									BgL_arg2899z00_1137 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list2898z00_1136 =
																										MAKE_PAIR
																										(BgL_arg2896z00_1134,
																										BgL_arg2899z00_1137);
																								}
																								BgL_arg2894z00_1132 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg2895z00_1133,
																									BgL_list2898z00_1136);
																							}
																						}
																						BgL_bodyz00_1068 =
																							MAKE_PAIR(BgL_arg2893z00_1131,
																							BgL_arg2894z00_1132);
																					}
																				}
																			}
																		}
																	else
																		{	/* Object/creator.scm 399 */
																			{	/* Object/creator.scm 385 */
																				obj_t BgL_alloczd2idzd2_1081;

																				{	/* Object/creator.scm 385 */
																					obj_t BgL_arg2887z00_1124;

																					{	/* Object/creator.scm 385 */
																						obj_t BgL_arg2888z00_1125;

																						obj_t BgL_arg2889z00_1126;

																						{	/* Object/creator.scm 385 */
																							obj_t BgL_symbolz00_1954;

																							BgL_symbolz00_1954 =
																								CNST_TABLE_REF(((long) 7));
																							BgL_arg2888z00_1125 =
																								SYMBOL_TO_STRING
																								(BgL_symbolz00_1954);
																						}
																						BgL_arg2889z00_1126 =
																							SYMBOL_TO_STRING(BgL_idz00_52);
																						{	/* Object/creator.scm 385 */
																							obj_t BgL_list2890z00_1127;

																							{	/* Object/creator.scm 385 */
																								obj_t BgL_arg2891z00_1128;

																								BgL_arg2891z00_1128 =
																									MAKE_PAIR(BgL_arg2889z00_1126,
																									BNIL);
																								BgL_list2890z00_1127 =
																									MAKE_PAIR(BgL_arg2888z00_1125,
																									BgL_arg2891z00_1128);
																							}
																							BgL_arg2887z00_1124 =
																								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																								(BgL_list2890z00_1127);
																					}}
																					BgL_alloczd2idzd2_1081 =
																						string_to_symbol(BSTRING_TO_STRING
																						(BgL_arg2887z00_1124));
																				}
																				{	/* Object/creator.scm 385 */

																					{	/* Object/creator.scm 386 */
																						obj_t BgL_arg2852z00_1082;

																						obj_t BgL_arg2853z00_1083;

																						BgL_arg2852z00_1082 =
																							CNST_TABLE_REF(((long) 20));
																						{	/* Object/creator.scm 386 */
																							obj_t BgL_arg2854z00_1084;

																							obj_t BgL_arg2855z00_1085;

																							{	/* Object/creator.scm 386 */
																								obj_t BgL_arg2859z00_1089;

																								{	/* Object/creator.scm 386 */
																									obj_t BgL_arg2861z00_1091;

																									obj_t BgL_arg2862z00_1092;

																									BgL_arg2861z00_1091 =
																										BGl_makezd2typedzd2identz00zzast_identz00
																										(BgL_newz00_1046,
																										BgL_tidz00_1038);
																									{	/* Object/creator.scm 387 */
																										obj_t BgL_arg2863z00_1093;

																										if (
																											(BgL_wideningz00_50 ==
																												CNST_TABLE_REF(((long)
																														6))))
																											{	/* Object/creator.scm 387 */
																												BgL_arg2863z00_1093 =
																													BGl_alloczd2wideningzd2zzobject_creatorz00
																													(BgL_tidz00_1038,
																													BgL_typez00_53);
																											}
																										else
																											{	/* Object/creator.scm 387 */
																												BgL_arg2863z00_1093 =
																													MAKE_PAIR
																													(BgL_alloczd2idzd2_1081,
																													BNIL);
																											}
																										{	/* Object/creator.scm 386 */
																											obj_t
																												BgL_list2865z00_1095;
																											BgL_list2865z00_1095 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_arg2862z00_1092 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg2863z00_1093,
																												BgL_list2865z00_1095);
																										}
																									}
																									BgL_arg2859z00_1089 =
																										MAKE_PAIR
																										(BgL_arg2861z00_1091,
																										BgL_arg2862z00_1092);
																								}
																								BgL_arg2854z00_1084 =
																									MAKE_PAIR(BgL_arg2859z00_1089,
																									BNIL);
																							}
																							{	/* Object/creator.scm 390 */
																								obj_t BgL_arg2867z00_1097;

																								obj_t BgL_arg2868z00_1098;

																								BgL_arg2867z00_1097 =
																									CNST_TABLE_REF(((long) 21));
																								{	/* Object/creator.scm 392 */
																									obj_t BgL_arg2869z00_1099;

																									obj_t BgL_arg2870z00_1100;

																									{	/* Object/creator.scm 392 */
																										obj_t BgL_arg2872z00_1102;

																										{	/* Object/creator.scm 392 */
																											obj_t BgL_arg2873z00_1103;

																											BgL_arg2873z00_1103 =
																												BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																												(BgL_fzd2idszd2_1044,
																												BNIL);
																											{	/* Object/creator.scm 392 */
																												obj_t
																													BgL_list2874z00_1104;
																												BgL_list2874z00_1104 =
																													MAKE_PAIR
																													(BgL_arg2873z00_1103,
																													BNIL);
																												BgL_arg2872z00_1102 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_newz00_1046,
																													BgL_list2874z00_1104);
																										}}
																										BgL_arg2869z00_1099 =
																											MAKE_PAIR
																											(BgL_fillzd2idzd2_1043,
																											BgL_arg2872z00_1102);
																									}
																									{	/* Object/creator.scm 394 */
																										obj_t BgL_arg2875z00_1105;

																										obj_t BgL_arg2876z00_1106;

																										{	/* Object/creator.scm 394 */
																											bool_t BgL_testz00_2948;

																											if (PAIRP
																												(BgL_constrsz00_1041))
																												{	/* Object/creator.scm 394 */
																													if (
																														(BgL_wideningz00_50
																															==
																															CNST_TABLE_REF((
																																	(long) 6))))
																														{	/* Object/creator.scm 394 */
																															BgL_testz00_2948 =
																																((bool_t) 0);
																														}
																													else
																														{	/* Object/creator.scm 394 */
																															BgL_testz00_2948 =
																																((bool_t) 1);
																														}
																												}
																											else
																												{	/* Object/creator.scm 394 */
																													BgL_testz00_2948 =
																														((bool_t) 0);
																												}
																											if (BgL_testz00_2948)
																												{	/* Object/creator.scm 394 */
																													if (NULLP
																														(BgL_constrsz00_1041))
																														{	/* Object/creator.scm 395 */
																															BgL_arg2875z00_1105
																																= BNIL;
																														}
																													else
																														{	/* Object/creator.scm 395 */
																															obj_t
																																BgL_head2461z00_1110;
																															BgL_head2461z00_1110
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															{
																																obj_t
																																	BgL_l2458z00_1111;
																																obj_t
																																	BgL_tail2462z00_1112;
																																BgL_l2458z00_1111
																																	=
																																	BgL_constrsz00_1041;
																																BgL_tail2462z00_1112
																																	=
																																	BgL_head2461z00_1110;
																															BgL_map2460z00_1113:
																																if (NULLP
																																	(BgL_l2458z00_1111))
																																	{	/* Object/creator.scm 395 */
																																		BgL_arg2875z00_1105
																																			=
																																			CDR
																																			(BgL_head2461z00_1110);
																																	}
																																else
																																	{	/* Object/creator.scm 395 */
																																		obj_t
																																			BgL_newtail2463z00_1115;
																																		{	/* Object/creator.scm 395 */
																																			obj_t
																																				BgL_arg2881z00_1117;
																																			{	/* Object/creator.scm 395 */
																																				obj_t
																																					BgL_constrz00_1119;
																																				BgL_constrz00_1119
																																					=
																																					CAR
																																					(BgL_l2458z00_1111);
																																				{	/* Object/creator.scm 395 */
																																					obj_t
																																						BgL_arg2883z00_1120;
																																					{	/* Object/creator.scm 395 */
																																						obj_t
																																							BgL_list2884z00_1121;
																																						BgL_list2884z00_1121
																																							=
																																							MAKE_PAIR
																																							(BNIL,
																																							BNIL);
																																						BgL_arg2883z00_1120
																																							=
																																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																							(BgL_newz00_1046,
																																							BgL_list2884z00_1121);
																																					}
																																					BgL_arg2881z00_1117
																																						=
																																						MAKE_PAIR
																																						(BgL_constrz00_1119,
																																						BgL_arg2883z00_1120);
																																				}
																																			}
																																			BgL_newtail2463z00_1115
																																				=
																																				MAKE_PAIR
																																				(BgL_arg2881z00_1117,
																																				BNIL);
																																		}
																																		SET_CDR
																																			(BgL_tail2462z00_1112,
																																			BgL_newtail2463z00_1115);
																																		{
																																			obj_t
																																				BgL_tail2462z00_2968;
																																			obj_t
																																				BgL_l2458z00_2966;
																																			BgL_l2458z00_2966
																																				=
																																				CDR
																																				(BgL_l2458z00_1111);
																																			BgL_tail2462z00_2968
																																				=
																																				BgL_newtail2463z00_1115;
																																			BgL_tail2462z00_1112
																																				=
																																				BgL_tail2462z00_2968;
																																			BgL_l2458z00_1111
																																				=
																																				BgL_l2458z00_2966;
																																			goto
																																				BgL_map2460z00_1113;
																																		}
																																	}
																															}
																														}
																												}
																											else
																												{	/* Object/creator.scm 394 */
																													BgL_arg2875z00_1105 =
																														BNIL;
																												}
																										}
																										BgL_arg2876z00_1106 =
																											MAKE_PAIR(BgL_newz00_1046,
																											BNIL);
																										BgL_arg2870z00_1100 =
																											BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2875z00_1105,
																											BgL_arg2876z00_1106);
																									}
																									{	/* Object/creator.scm 390 */
																										obj_t BgL_list2871z00_1101;

																										BgL_list2871z00_1101 =
																											MAKE_PAIR
																											(BgL_arg2870z00_1100,
																											BNIL);
																										BgL_arg2868z00_1098 =
																											BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																											(BgL_arg2869z00_1099,
																											BgL_list2871z00_1101);
																									}
																								}
																								BgL_arg2855z00_1085 =
																									MAKE_PAIR(BgL_arg2867z00_1097,
																									BgL_arg2868z00_1098);
																							}
																							{	/* Object/creator.scm 386 */
																								obj_t BgL_list2857z00_1087;

																								{	/* Object/creator.scm 386 */
																									obj_t BgL_arg2858z00_1088;

																									BgL_arg2858z00_1088 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list2857z00_1087 =
																										MAKE_PAIR
																										(BgL_arg2855z00_1085,
																										BgL_arg2858z00_1088);
																								}
																								BgL_arg2853z00_1083 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg2854z00_1084,
																									BgL_list2857z00_1087);
																							}
																						}
																						BgL_bodyz00_1068 =
																							MAKE_PAIR(BgL_arg2852z00_1082,
																							BgL_arg2853z00_1083);
																					}
																				}
																			}
																		}
																}
																{	/* Object/creator.scm 408 */
																	obj_t BgL_arg2840z00_1069;

																	{	/* Object/creator.scm 408 */
																		obj_t BgL_arg2842z00_1071;

																		obj_t BgL_arg2843z00_1072;

																		BgL_arg2842z00_1071 =
																			CNST_TABLE_REF(((long) 15));
																		{	/* Object/creator.scm 408 */
																			obj_t BgL_list2844z00_1073;

																			{	/* Object/creator.scm 408 */
																				obj_t BgL_arg2845z00_1074;

																				BgL_arg2845z00_1074 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list2844z00_1073 =
																					MAKE_PAIR(BgL_bodyz00_1068,
																					BgL_arg2845z00_1074);
																			}
																			BgL_arg2843z00_1072 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_protoz00_1067,
																				BgL_list2844z00_1073);
																		}
																		BgL_arg2840z00_1069 =
																			MAKE_PAIR(BgL_arg2842z00_1071,
																			BgL_arg2843z00_1072);
																	}
																	{	/* Object/creator.scm 408 */
																		obj_t BgL_list2841z00_1070;

																		BgL_list2841z00_1070 =
																			MAKE_PAIR(BgL_srczd2defzd2_54, BNIL);
																		return
																			BGl_epairifyza2za2zztools_miscz00
																			(BgL_arg2840z00_1069,
																			BgL_list2841z00_1070);
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* alloc-widening */
	obj_t BGl_alloczd2wideningzd2zzobject_creatorz00(obj_t BgL_tidz00_2070,
		BgL_tclassz00_bglt BgL_typez00_2069)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 364 */
			{

				{	/* Object/creator.scm 367 */
					bool_t BgL_testz00_2985;

					{	/* Object/creator.scm 367 */
						obj_t BgL_arg2938z00_1182;

						BgL_arg2938z00_1182 = BGl_thezd2backendzd2zzbackend_backendz00();
						{
							BgL_backendz00_bglt BgL_auxz00_2987;

							BgL_auxz00_2987 = (BgL_backendz00_bglt) (BgL_arg2938z00_1182);
							BgL_testz00_2985 =
								(((BgL_backendz00_bglt) CREF(BgL_auxz00_2987))->
								BgL_pragmazd2supportzd2);
						}
					}
					if (BgL_testz00_2985)
						{	/* Object/creator.scm 367 */
							{	/* Object/creator.scm 358 */
								obj_t BgL_tnamez00_1186;

								obj_t BgL_siza7eofza7_1187;

								{	/* Object/creator.scm 358 */
									obj_t BgL_arg2955z00_1200;

									{
										BgL_typez00_bglt BgL_auxz00_2990;

										BgL_auxz00_2990 = (BgL_typez00_bglt) (BgL_typez00_2069);
										BgL_arg2955z00_1200 =
											(((BgL_typez00_bglt) CREF(BgL_auxz00_2990))->BgL_namez00);
									}
									BgL_tnamez00_1186 =
										BGl_stringzd2sanszd2z42z42zztype_toolsz00
										(BgL_arg2955z00_1200);
								}
								{	/* Object/creator.scm 359 */
									bool_t BgL_testz00_2994;

									{	/* Object/creator.scm 359 */
										obj_t BgL_auxz00_2995;

										{
											BgL_typez00_bglt BgL_auxz00_2996;

											BgL_auxz00_2996 = (BgL_typez00_bglt) (BgL_typez00_2069);
											BgL_auxz00_2995 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_2996))->
												BgL_siza7eza7);
										}
										BgL_testz00_2994 = STRINGP(BgL_auxz00_2995);
									}
									if (BgL_testz00_2994)
										{
											BgL_typez00_bglt BgL_auxz00_3000;

											BgL_auxz00_3000 = (BgL_typez00_bglt) (BgL_typez00_2069);
											BgL_siza7eofza7_1187 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_3000))->
												BgL_siza7eza7);
										}
									else
										{
											BgL_typez00_bglt BgL_auxz00_3003;

											BgL_auxz00_3003 = (BgL_typez00_bglt) (BgL_typez00_2069);
											BgL_siza7eofza7_1187 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_3003))->
												BgL_namez00);
										}
								}
								{	/* Object/creator.scm 362 */
									obj_t BgL_arg2942z00_1188;

									obj_t BgL_arg2943z00_1189;

									BgL_arg2942z00_1188 =
										BGl_makezd2typedzd2identz00zzast_identz00(CNST_TABLE_REF((
												(long) 25)), BgL_tidz00_2070);
									{	/* Object/creator.scm 363 */
										obj_t BgL_arg2944z00_1190;

										{	/* Object/creator.scm 363 */
											obj_t BgL_list2947z00_1193;

											{	/* Object/creator.scm 363 */
												obj_t BgL_arg2950z00_1195;

												{	/* Object/creator.scm 363 */
													obj_t BgL_arg2951z00_1196;

													{	/* Object/creator.scm 363 */
														obj_t BgL_arg2953z00_1198;

														{	/* Object/creator.scm 363 */
															obj_t BgL_arg2954z00_1199;

															BgL_arg2954z00_1199 =
																MAKE_PAIR(BGl_string3325z00zzobject_creatorz00,
																BNIL);
															BgL_arg2953z00_1198 =
																MAKE_PAIR(BgL_siza7eofza7_1187,
																BgL_arg2954z00_1199);
														}
														BgL_arg2951z00_1196 =
															MAKE_PAIR(BGl_string3326z00zzobject_creatorz00,
															BgL_arg2953z00_1198);
													}
													BgL_arg2950z00_1195 =
														MAKE_PAIR(BgL_tnamez00_1186, BgL_arg2951z00_1196);
												}
												BgL_list2947z00_1193 =
													MAKE_PAIR(BGl_string3327z00zzobject_creatorz00,
													BgL_arg2950z00_1195);
											}
											BgL_arg2944z00_1190 =
												BGl_stringzd2appendzd2zz__r4_strings_6_7z00
												(BgL_list2947z00_1193);
										}
										{	/* Object/creator.scm 362 */
											obj_t BgL_list2946z00_1192;

											BgL_list2946z00_1192 = MAKE_PAIR(BNIL, BNIL);
											BgL_arg2943z00_1189 =
												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
												(BgL_arg2944z00_1190, BgL_list2946z00_1192);
									}}
									return MAKE_PAIR(BgL_arg2942z00_1188, BgL_arg2943z00_1189);
								}
							}
						}
					else
						{	/* Object/creator.scm 367 */
							return
								BGl_makezd2privatezd2sexpz00zzast_privatez00(CNST_TABLE_REF((
										(long) 9)), BgL_tidz00_2070, BNIL);
		}}}}
	}



/* make-class-slot-make! */
	obj_t
		BGl_makezd2classzd2slotzd2makez12zc0zzobject_creatorz00(BgL_tclassz00_bglt
		BgL_typez00_56, obj_t BgL_newz00_57, obj_t BgL_ridz00_58,
		obj_t BgL_rtidz00_59, obj_t BgL_slotsz00_60, obj_t BgL_fzd2idszd2_61)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 413 */
			{
				obj_t BgL_slotz00_1242;

				obj_t BgL_formalz00_1243;

				obj_t BgL_flenz00_1244;

				{
					obj_t BgL_slotsz00_1226;

					obj_t BgL_fzd2idszd2_1227;

					obj_t BgL_resz00_1228;

					obj_t BgL_lenzd2idzd2_1229;

					BgL_slotsz00_1226 = BgL_slotsz00_60;
					BgL_fzd2idszd2_1227 = BgL_fzd2idszd2_61;
					BgL_resz00_1228 = BNIL;
					BgL_lenzd2idzd2_1229 = BUNSPEC;
				BgL_loopz00_1230:
					if (NULLP(BgL_slotsz00_1226))
						{	/* Object/creator.scm 443 */
							return bgl_reverse_bang(BgL_resz00_1228);
						}
					else
						{	/* Object/creator.scm 445 */
							bool_t BgL_testz00_3022;

							{	/* Object/creator.scm 445 */
								obj_t BgL_arg2983z00_1241;

								BgL_arg2983z00_1241 = CAR(BgL_slotsz00_1226);
								BgL_testz00_3022 =
									BGl_slotzd2virtualzf3z21zzobject_slotsz00(
									(BgL_slotz00_bglt) (BgL_arg2983z00_1241));
							}
							if (BgL_testz00_3022)
								{
									obj_t BgL_slotsz00_3026;

									BgL_slotsz00_3026 = CDR(BgL_slotsz00_1226);
									BgL_slotsz00_1226 = BgL_slotsz00_3026;
									goto BgL_loopz00_1230;
								}
							else
								{	/* Object/creator.scm 448 */
									obj_t BgL_arg2976z00_1234;

									obj_t BgL_arg2977z00_1235;

									obj_t BgL_arg2978z00_1236;

									obj_t BgL_arg2979z00_1237;

									BgL_arg2976z00_1234 = CDR(BgL_slotsz00_1226);
									BgL_arg2977z00_1235 = CDR(BgL_fzd2idszd2_1227);
									{	/* Object/creator.scm 450 */
										obj_t BgL_auxz00_3030;

										BgL_slotz00_1242 = CAR(BgL_slotsz00_1226);
										BgL_formalz00_1243 = CAR(BgL_fzd2idszd2_1227);
										BgL_flenz00_1244 = BgL_lenzd2idzd2_1229;
										{	/* Object/creator.scm 415 */
											obj_t BgL_loopz00_1246;

											BgL_loopz00_1246 =
												BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
												(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 26))));
											{	/* Object/creator.scm 417 */
												bool_t BgL_testz00_3034;

												{	/* Object/creator.scm 417 */
													BgL_slotz00_bglt BgL_obj2262z00_1998;

													BgL_obj2262z00_1998 =
														(BgL_slotz00_bglt) (BgL_slotz00_1242);
													BgL_testz00_3034 =
														CBOOL(
														(((BgL_slotz00_bglt) CREF(BgL_obj2262z00_1998))->
															BgL_indexedz00));
												}
												if (BgL_testz00_3034)
													{	/* Object/creator.scm 420 */
														obj_t BgL_arg2986z00_1248;

														obj_t BgL_arg2987z00_1249;

														BgL_arg2986z00_1248 = CNST_TABLE_REF(((long) 21));
														{	/* Object/creator.scm 421 */
															obj_t BgL_arg2988z00_1250;

															obj_t BgL_arg2989z00_1251;

															BgL_arg2988z00_1250 =
																BGl_makezd2pragmazd2indexedzd2initzd2setz12z12zzobject_toolsz00
																((BgL_typez00_bglt) (BgL_typez00_56),
																(BgL_slotz00_bglt) (BgL_slotz00_1242),
																BgL_newz00_57, BgL_flenz00_1244);
															{	/* Object/creator.scm 423 */
																obj_t BgL_arg2993z00_1255;

																obj_t BgL_arg2994z00_1256;

																BgL_arg2993z00_1255 =
																	CNST_TABLE_REF(((long) 27));
																{	/* Object/creator.scm 423 */
																	obj_t BgL_arg2995z00_1257;

																	obj_t BgL_arg2996z00_1258;

																	{	/* Object/creator.scm 423 */
																		obj_t BgL_arg3000z00_1262;

																		{	/* Object/creator.scm 423 */
																			obj_t BgL_arg3002z00_1264;

																			{	/* Object/creator.scm 423 */
																				obj_t BgL_arg3003z00_1265;

																				obj_t BgL_arg3004z00_1266;

																				BgL_arg3003z00_1265 =
																					MAKE_PAIR(BgL_rtidz00_59, BNIL);
																				{	/* Object/creator.scm 424 */
																					obj_t BgL_arg3008z00_1270;

																					obj_t BgL_arg3009z00_1271;

																					BgL_arg3008z00_1270 =
																						CNST_TABLE_REF(((long) 28));
																					{	/* Object/creator.scm 424 */
																						obj_t BgL_arg3010z00_1272;

																						obj_t BgL_arg3011z00_1273;

																						obj_t BgL_arg3012z00_1274;

																						{	/* Object/creator.scm 424 */
																							obj_t BgL_arg3017z00_1279;

																							obj_t BgL_arg3018z00_1280;

																							BgL_arg3017z00_1279 =
																								CNST_TABLE_REF(((long) 29));
																							{	/* Object/creator.scm 424 */
																								obj_t BgL_list3019z00_1281;

																								{	/* Object/creator.scm 424 */
																									obj_t BgL_arg3020z00_1282;

																									BgL_arg3020z00_1282 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list3019z00_1281 =
																										MAKE_PAIR(BgL_flenz00_1244,
																										BgL_arg3020z00_1282);
																								}
																								BgL_arg3018z00_1280 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_ridz00_58,
																									BgL_list3019z00_1281);
																							}
																							BgL_arg3010z00_1272 =
																								MAKE_PAIR(BgL_arg3017z00_1279,
																								BgL_arg3018z00_1280);
																						}
																						{	/* Object/creator.scm 425 */
																							obj_t BgL_arg3021z00_1283;

																							obj_t BgL_arg3022z00_1284;

																							BgL_arg3021z00_1283 =
																								CNST_TABLE_REF(((long) 16));
																							{	/* Object/creator.scm 425 */
																								obj_t BgL_list3023z00_1285;

																								BgL_list3023z00_1285 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg3022z00_1284 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(CNST_TABLE_REF(((long) 30)),
																									BgL_list3023z00_1285);
																							}
																							BgL_arg3011z00_1273 =
																								MAKE_PAIR(BgL_arg3021z00_1283,
																								BgL_arg3022z00_1284);
																						}
																						{	/* Object/creator.scm 426 */
																							obj_t BgL_arg3024z00_1286;

																							obj_t BgL_arg3026z00_1287;

																							BgL_arg3024z00_1286 =
																								CNST_TABLE_REF(((long) 21));
																							{	/* Object/creator.scm 427 */
																								obj_t BgL_arg3027z00_1288;

																								obj_t BgL_arg3028z00_1289;

																								BgL_arg3027z00_1288 =
																									BGl_makezd2pragmazd2indexedzd2setz12zf2wideningz32zzobject_toolsz00
																									((BgL_typez00_bglt)
																									(BgL_typez00_56),
																									(BgL_slotz00_bglt)
																									(BgL_slotz00_1242),
																									BgL_newz00_57,
																									BgL_formalz00_1243,
																									BgL_ridz00_58, BFALSE);
																								{	/* Object/creator.scm 434 */
																									obj_t BgL_arg3033z00_1293;

																									{	/* Object/creator.scm 434 */
																										obj_t BgL_arg3034z00_1294;

																										{	/* Object/creator.scm 434 */
																											obj_t BgL_arg3037z00_1297;

																											obj_t BgL_arg3038z00_1298;

																											BgL_arg3037z00_1297 =
																												CNST_TABLE_REF(((long)
																													31));
																											{	/* Object/creator.scm 434 */
																												obj_t
																													BgL_list3039z00_1299;
																												{	/* Object/creator.scm 434 */
																													obj_t
																														BgL_arg3041z00_1301;
																													BgL_arg3041z00_1301 =
																														MAKE_PAIR(BNIL,
																														BNIL);
																													BgL_list3039z00_1299 =
																														MAKE_PAIR(BINT((
																																(long) 1)),
																														BgL_arg3041z00_1301);
																												}
																												BgL_arg3038z00_1298 =
																													BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																													(BgL_ridz00_58,
																													BgL_list3039z00_1299);
																											}
																											BgL_arg3034z00_1294 =
																												MAKE_PAIR
																												(BgL_arg3037z00_1297,
																												BgL_arg3038z00_1298);
																										}
																										{	/* Object/creator.scm 434 */
																											obj_t
																												BgL_list3036z00_1296;
																											BgL_list3036z00_1296 =
																												MAKE_PAIR(BNIL, BNIL);
																											BgL_arg3033z00_1293 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg3034z00_1294,
																												BgL_list3036z00_1296);
																									}}
																									BgL_arg3028z00_1289 =
																										MAKE_PAIR(BgL_loopz00_1246,
																										BgL_arg3033z00_1293);
																								}
																								{	/* Object/creator.scm 426 */
																									obj_t BgL_list3030z00_1291;

																									{	/* Object/creator.scm 426 */
																										obj_t BgL_arg3032z00_1292;

																										BgL_arg3032z00_1292 =
																											MAKE_PAIR(BNIL, BNIL);
																										BgL_list3030z00_1291 =
																											MAKE_PAIR
																											(BgL_arg3028z00_1289,
																											BgL_arg3032z00_1292);
																									}
																									BgL_arg3026z00_1287 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg3027z00_1288,
																										BgL_list3030z00_1291);
																							}}
																							BgL_arg3012z00_1274 =
																								MAKE_PAIR(BgL_arg3024z00_1286,
																								BgL_arg3026z00_1287);
																						}
																						{	/* Object/creator.scm 424 */
																							obj_t BgL_list3014z00_1276;

																							{	/* Object/creator.scm 424 */
																								obj_t BgL_arg3015z00_1277;

																								{	/* Object/creator.scm 424 */
																									obj_t BgL_arg3016z00_1278;

																									BgL_arg3016z00_1278 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_arg3015z00_1277 =
																										MAKE_PAIR
																										(BgL_arg3012z00_1274,
																										BgL_arg3016z00_1278);
																								}
																								BgL_list3014z00_1276 =
																									MAKE_PAIR(BgL_arg3011z00_1273,
																									BgL_arg3015z00_1277);
																							}
																							BgL_arg3009z00_1271 =
																								BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																								(BgL_arg3010z00_1272,
																								BgL_list3014z00_1276);
																					}}
																					BgL_arg3004z00_1266 =
																						MAKE_PAIR(BgL_arg3008z00_1270,
																						BgL_arg3009z00_1271);
																				}
																				{	/* Object/creator.scm 423 */
																					obj_t BgL_list3006z00_1268;

																					{	/* Object/creator.scm 423 */
																						obj_t BgL_arg3007z00_1269;

																						BgL_arg3007z00_1269 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_list3006z00_1268 =
																							MAKE_PAIR(BgL_arg3004z00_1266,
																							BgL_arg3007z00_1269);
																					}
																					BgL_arg3002z00_1264 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3003z00_1265,
																						BgL_list3006z00_1268);
																			}}
																			BgL_arg3000z00_1262 =
																				MAKE_PAIR(BgL_loopz00_1246,
																				BgL_arg3002z00_1264);
																		}
																		BgL_arg2995z00_1257 =
																			MAKE_PAIR(BgL_arg3000z00_1262, BNIL);
																	}
																	{	/* Object/creator.scm 435 */
																		obj_t BgL_arg3042z00_1302;

																		{	/* Object/creator.scm 435 */
																			obj_t BgL_list3043z00_1303;

																			BgL_list3043z00_1303 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3042z00_1302 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BINT(((long) 0)),
																				BgL_list3043z00_1303);
																		}
																		BgL_arg2996z00_1258 =
																			MAKE_PAIR(BgL_loopz00_1246,
																			BgL_arg3042z00_1302);
																	}
																	{	/* Object/creator.scm 423 */
																		obj_t BgL_list2998z00_1260;

																		{	/* Object/creator.scm 423 */
																			obj_t BgL_arg2999z00_1261;

																			BgL_arg2999z00_1261 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_list2998z00_1260 =
																				MAKE_PAIR(BgL_arg2996z00_1258,
																				BgL_arg2999z00_1261);
																		}
																		BgL_arg2994z00_1256 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg2995z00_1257,
																			BgL_list2998z00_1260);
																}}
																BgL_arg2989z00_1251 =
																	MAKE_PAIR(BgL_arg2993z00_1255,
																	BgL_arg2994z00_1256);
															}
															{	/* Object/creator.scm 420 */
																obj_t BgL_list2991z00_1253;

																{	/* Object/creator.scm 420 */
																	obj_t BgL_arg2992z00_1254;

																	BgL_arg2992z00_1254 = MAKE_PAIR(BNIL, BNIL);
																	BgL_list2991z00_1253 =
																		MAKE_PAIR(BgL_arg2989z00_1251,
																		BgL_arg2992z00_1254);
																}
																BgL_arg2987z00_1249 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg2988z00_1250, BgL_list2991z00_1253);
														}}
														BgL_auxz00_3030 =
															MAKE_PAIR(BgL_arg2986z00_1248,
															BgL_arg2987z00_1249);
													}
												else
													{	/* Object/creator.scm 417 */
														BgL_auxz00_3030 =
															BGl_makezd2pragmazd2directzd2setz12zc0zzobject_toolsz00
															((BgL_typez00_bglt) (BgL_typez00_56),
															(BgL_slotz00_bglt) (BgL_slotz00_1242),
															BgL_newz00_57, BgL_formalz00_1243);
													}
											}
										}
										BgL_arg2978z00_1236 =
											MAKE_PAIR(BgL_auxz00_3030, BgL_resz00_1228);
									}
									BgL_arg2979z00_1237 = CAR(BgL_fzd2idszd2_1227);
									{
										obj_t BgL_lenzd2idzd2_3104;

										obj_t BgL_resz00_3103;

										obj_t BgL_fzd2idszd2_3102;

										obj_t BgL_slotsz00_3101;

										BgL_slotsz00_3101 = BgL_arg2976z00_1234;
										BgL_fzd2idszd2_3102 = BgL_arg2977z00_1235;
										BgL_resz00_3103 = BgL_arg2978z00_1236;
										BgL_lenzd2idzd2_3104 = BgL_arg2979z00_1237;
										BgL_lenzd2idzd2_1229 = BgL_lenzd2idzd2_3104;
										BgL_resz00_1228 = BgL_resz00_3103;
										BgL_fzd2idszd2_1227 = BgL_fzd2idszd2_3102;
										BgL_slotsz00_1226 = BgL_slotsz00_3101;
										goto BgL_loopz00_1230;
									}
								}
						}
				}
			}
		}
	}



/* gen-class-allocate! */
	obj_t BGl_genzd2classzd2allocatez12z12zzobject_creatorz00(obj_t BgL_idz00_62,
		obj_t BgL_typez00_63, BgL_globalz00_bglt BgL_holderz00_64,
		obj_t BgL_srczd2defzd2_65, obj_t BgL_importz00_66)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 456 */
			{	/* Object/creator.scm 457 */
				obj_t BgL_tidz00_1306;

				{
					BgL_typez00_bglt BgL_auxz00_3105;

					BgL_auxz00_3105 = (BgL_typez00_bglt) (BgL_typez00_63);
					BgL_tidz00_1306 =
						(((BgL_typez00_bglt) CREF(BgL_auxz00_3105))->BgL_idz00);
				}
				{	/* Object/creator.scm 457 */
					obj_t BgL_alloczd2idzd2_1307;

					{	/* Object/creator.scm 458 */
						obj_t BgL_arg3181z00_1454;

						{	/* Object/creator.scm 458 */
							obj_t BgL_arg3182z00_1455;

							obj_t BgL_arg3183z00_1456;

							{	/* Object/creator.scm 458 */
								obj_t BgL_symbolz00_2000;

								BgL_symbolz00_2000 = CNST_TABLE_REF(((long) 7));
								BgL_arg3182z00_1455 = SYMBOL_TO_STRING(BgL_symbolz00_2000);
							}
							BgL_arg3183z00_1456 = SYMBOL_TO_STRING(BgL_idz00_62);
							{	/* Object/creator.scm 458 */
								obj_t BgL_list3184z00_1457;

								{	/* Object/creator.scm 458 */
									obj_t BgL_arg3185z00_1458;

									BgL_arg3185z00_1458 = MAKE_PAIR(BgL_arg3183z00_1456, BNIL);
									BgL_list3184z00_1457 =
										MAKE_PAIR(BgL_arg3182z00_1455, BgL_arg3185z00_1458);
								}
								BgL_arg3181z00_1454 =
									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
									(BgL_list3184z00_1457);
						}}
						BgL_alloczd2idzd2_1307 =
							string_to_symbol(BSTRING_TO_STRING(BgL_arg3181z00_1454));
					}
					{	/* Object/creator.scm 458 */
						obj_t BgL_alloczd2tidzd2_1308;

						BgL_alloczd2tidzd2_1308 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_alloczd2idzd2_1307,
							BgL_tidz00_1306);
						{	/* Object/creator.scm 459 */
							obj_t BgL_newz00_1309;

							BgL_newz00_1309 =
								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
								(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											9))));
							{	/* Object/creator.scm 460 */

								{
									obj_t BgL_typez00_1430;

									{	/* Object/creator.scm 490 */
										obj_t BgL_arg3045z00_1313;

										{	/* Object/creator.scm 490 */
											obj_t BgL_arg3046z00_1314;

											{	/* Object/creator.scm 490 */
												obj_t BgL_arg3047z00_1315;

												{	/* Object/creator.scm 490 */
													obj_t BgL_arg3050z00_1318;

													obj_t BgL_arg3051z00_1319;

													BgL_arg3050z00_1318 = CNST_TABLE_REF(((long) 11));
													{	/* Object/creator.scm 490 */
														obj_t BgL_list3052z00_1320;

														BgL_list3052z00_1320 = MAKE_PAIR(BNIL, BNIL);
														BgL_arg3051z00_1319 =
															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
															(BgL_alloczd2tidzd2_1308, BgL_list3052z00_1320);
													}
													BgL_arg3047z00_1315 =
														MAKE_PAIR(BgL_arg3050z00_1318, BgL_arg3051z00_1319);
												}
												{	/* Object/creator.scm 490 */
													obj_t BgL_list3049z00_1317;

													BgL_list3049z00_1317 = MAKE_PAIR(BNIL, BNIL);
													BgL_arg3046z00_1314 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg3047z00_1315, BgL_list3049z00_1317);
											}}
											BgL_arg3045z00_1313 =
												MAKE_PAIR(BgL_importz00_66, BgL_arg3046z00_1314);
										}
										BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
											(BgL_arg3045z00_1313);
									}
									{	/* Object/creator.scm 491 */
										obj_t BgL_arg3053z00_1321;

										{	/* Object/creator.scm 491 */
											bool_t BgL_testz00_3128;

											{	/* Object/creator.scm 491 */
												obj_t BgL_arg3056z00_1324;

												BgL_arg3056z00_1324 =
													BGl_thezd2backendzd2zzbackend_backendz00();
												{
													BgL_backendz00_bglt BgL_auxz00_3130;

													BgL_auxz00_3130 =
														(BgL_backendz00_bglt) (BgL_arg3056z00_1324);
													BgL_testz00_3128 =
														(((BgL_backendz00_bglt) CREF(BgL_auxz00_3130))->
														BgL_pragmazd2supportzd2);
											}}
											if (BgL_testz00_3128)
												{	/* Object/creator.scm 491 */
													{	/* Object/creator.scm 471 */
														obj_t BgL_arg3112z00_1379;

														obj_t BgL_arg3113z00_1380;

														BgL_arg3112z00_1379 = CNST_TABLE_REF(((long) 8));
														{	/* Object/creator.scm 471 */
															obj_t BgL_arg3114z00_1381;

															obj_t BgL_arg3115z00_1382;

															BgL_arg3114z00_1381 =
																MAKE_PAIR(BgL_alloczd2tidzd2_1308, BNIL);
															{	/* Object/creator.scm 472 */
																obj_t BgL_arg3119z00_1386;

																obj_t BgL_arg3120z00_1387;

																BgL_arg3119z00_1386 =
																	CNST_TABLE_REF(((long) 20));
																{	/* Object/creator.scm 472 */
																	obj_t BgL_arg3121z00_1388;

																	obj_t BgL_arg3122z00_1389;

																	obj_t BgL_arg3123z00_1390;

																	{	/* Object/creator.scm 472 */
																		obj_t BgL_arg3129z00_1396;

																		{	/* Object/creator.scm 472 */
																			obj_t BgL_arg3131z00_1398;

																			obj_t BgL_arg3132z00_1399;

																			BgL_arg3131z00_1398 =
																				BGl_makezd2typedzd2identz00zzast_identz00
																				(BgL_newz00_1309, BgL_tidz00_1306);
																			{	/* Object/creator.scm 472 */
																				obj_t BgL_arg3133z00_1400;

																				BgL_typez00_1430 = BgL_typez00_63;
																				{	/* Object/creator.scm 462 */
																					obj_t BgL_tidz00_1432;

																					obj_t BgL_tnamez00_1433;

																					obj_t BgL_siza7eofza7_1434;

																					{
																						BgL_typez00_bglt BgL_auxz00_3137;

																						BgL_auxz00_3137 =
																							(BgL_typez00_bglt)
																							(BgL_typez00_1430);
																						BgL_tidz00_1432 =
																							(((BgL_typez00_bglt)
																								CREF(BgL_auxz00_3137))->
																							BgL_idz00);
																					}
																					{	/* Object/creator.scm 463 */
																						obj_t BgL_arg3177z00_1447;

																						{
																							BgL_typez00_bglt BgL_auxz00_3140;

																							BgL_auxz00_3140 =
																								(BgL_typez00_bglt)
																								(BgL_typez00_1430);
																							BgL_arg3177z00_1447 =
																								(((BgL_typez00_bglt)
																									CREF(BgL_auxz00_3140))->
																								BgL_namez00);
																						}
																						BgL_tnamez00_1433 =
																							BGl_stringzd2sanszd2z42z42zztype_toolsz00
																							(BgL_arg3177z00_1447);
																					}
																					{	/* Object/creator.scm 464 */
																						bool_t BgL_testz00_3144;

																						{	/* Object/creator.scm 464 */
																							obj_t BgL_auxz00_3145;

																							{
																								BgL_typez00_bglt
																									BgL_auxz00_3146;
																								BgL_auxz00_3146 =
																									(BgL_typez00_bglt)
																									(BgL_typez00_1430);
																								BgL_auxz00_3145 =
																									(((BgL_typez00_bglt)
																										CREF(BgL_auxz00_3146))->
																									BgL_siza7eza7);
																							}
																							BgL_testz00_3144 =
																								STRINGP(BgL_auxz00_3145);
																						}
																						if (BgL_testz00_3144)
																							{
																								BgL_typez00_bglt
																									BgL_auxz00_3150;
																								BgL_auxz00_3150 =
																									(BgL_typez00_bglt)
																									(BgL_typez00_1430);
																								BgL_siza7eofza7_1434 =
																									(((BgL_typez00_bglt)
																										CREF(BgL_auxz00_3150))->
																									BgL_siza7eza7);
																							}
																						else
																							{
																								BgL_typez00_bglt
																									BgL_auxz00_3153;
																								BgL_auxz00_3153 =
																									(BgL_typez00_bglt)
																									(BgL_typez00_1430);
																								BgL_siza7eofza7_1434 =
																									(((BgL_typez00_bglt)
																										CREF(BgL_auxz00_3153))->
																									BgL_namez00);
																							}
																					}
																					{	/* Object/creator.scm 467 */
																						obj_t BgL_arg3164z00_1435;

																						obj_t BgL_arg3165z00_1436;

																						BgL_arg3164z00_1435 =
																							BGl_makezd2typedzd2identz00zzast_identz00
																							(CNST_TABLE_REF(((long) 25)),
																							BgL_tidz00_1432);
																						{	/* Object/creator.scm 468 */
																							obj_t BgL_arg3166z00_1437;

																							{	/* Object/creator.scm 468 */
																								obj_t BgL_list3169z00_1440;

																								{	/* Object/creator.scm 468 */
																									obj_t BgL_arg3172z00_1442;

																									{	/* Object/creator.scm 468 */
																										obj_t BgL_arg3173z00_1443;

																										{	/* Object/creator.scm 468 */
																											obj_t BgL_arg3175z00_1445;

																											{	/* Object/creator.scm 468 */
																												obj_t
																													BgL_arg3176z00_1446;
																												BgL_arg3176z00_1446 =
																													MAKE_PAIR
																													(BGl_string3328z00zzobject_creatorz00,
																													BNIL);
																												BgL_arg3175z00_1445 =
																													MAKE_PAIR
																													(BgL_siza7eofza7_1434,
																													BgL_arg3176z00_1446);
																											}
																											BgL_arg3173z00_1443 =
																												MAKE_PAIR
																												(BGl_string3329z00zzobject_creatorz00,
																												BgL_arg3175z00_1445);
																										}
																										BgL_arg3172z00_1442 =
																											MAKE_PAIR
																											(BgL_tnamez00_1433,
																											BgL_arg3173z00_1443);
																									}
																									BgL_list3169z00_1440 =
																										MAKE_PAIR
																										(BGl_string3327z00zzobject_creatorz00,
																										BgL_arg3172z00_1442);
																								}
																								BgL_arg3166z00_1437 =
																									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																									(BgL_list3169z00_1440);
																							}
																							{	/* Object/creator.scm 467 */
																								obj_t BgL_list3168z00_1439;

																								BgL_list3168z00_1439 =
																									MAKE_PAIR(BNIL, BNIL);
																								BgL_arg3165z00_1436 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg3166z00_1437,
																									BgL_list3168z00_1439);
																						}}
																						BgL_arg3133z00_1400 =
																							MAKE_PAIR(BgL_arg3164z00_1435,
																							BgL_arg3165z00_1436);
																				}}
																				{	/* Object/creator.scm 472 */
																					obj_t BgL_list3135z00_1402;

																					BgL_list3135z00_1402 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3132z00_1399 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3133z00_1400,
																						BgL_list3135z00_1402);
																			}}
																			BgL_arg3129z00_1396 =
																				MAKE_PAIR(BgL_arg3131z00_1398,
																				BgL_arg3132z00_1399);
																		}
																		BgL_arg3121z00_1388 =
																			MAKE_PAIR(BgL_arg3129z00_1396, BNIL);
																	}
																	{	/* Object/creator.scm 473 */
																		obj_t BgL_arg3136z00_1403;

																		obj_t BgL_arg3137z00_1404;

																		BgL_arg3136z00_1403 =
																			CNST_TABLE_REF(((long) 32));
																		{	/* Object/creator.scm 474 */
																			obj_t BgL_arg3138z00_1405;

																			{	/* Object/creator.scm 474 */
																				obj_t BgL_arg3142z00_1409;

																				obj_t BgL_arg3143z00_1410;

																				{	/* Object/creator.scm 474 */
																					obj_t BgL_arg3144z00_1411;

																					obj_t BgL_arg3145z00_1412;

																					BgL_arg3144z00_1411 =
																						CNST_TABLE_REF(((long) 33));
																					{	/* Object/creator.scm 474 */
																						obj_t BgL_list3146z00_1413;

																						{	/* Object/creator.scm 474 */
																							obj_t BgL_arg3147z00_1414;

																							obj_t BgL_arg3148z00_1415;

																							BgL_arg3147z00_1414 =
																								CNST_TABLE_REF(((long) 34));
																							BgL_arg3148z00_1415 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list3146z00_1413 =
																								MAKE_PAIR(BgL_arg3147z00_1414,
																								BgL_arg3148z00_1415);
																						}
																						BgL_arg3145z00_1412 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(CNST_TABLE_REF(((long) 35)),
																							BgL_list3146z00_1413);
																					}
																					BgL_arg3142z00_1409 =
																						MAKE_PAIR(BgL_arg3144z00_1411,
																						BgL_arg3145z00_1412);
																				}
																				{	/* Object/creator.scm 475 */
																					obj_t BgL_arg3149z00_1416;

																					{	/* Object/creator.scm 475 */
																						obj_t BgL_arg3152z00_1419;

																						obj_t BgL_arg3153z00_1420;

																						BgL_arg3152z00_1419 =
																							CNST_TABLE_REF(((long) 33));
																						{	/* Object/creator.scm 475 */
																							obj_t BgL_arg3154z00_1421;

																							obj_t BgL_arg3155z00_1422;

																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_3180;
																								BgL_auxz00_3180 =
																									(BgL_variablez00_bglt)
																									(BgL_holderz00_64);
																								BgL_arg3154z00_1421 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_3180))->
																									BgL_idz00);
																							}
																							BgL_arg3155z00_1422 =
																								(((BgL_globalz00_bglt)
																									CREF(BgL_holderz00_64))->
																								BgL_modulez00);
																							{	/* Object/creator.scm 475 */
																								obj_t BgL_list3157z00_1424;

																								{	/* Object/creator.scm 475 */
																									obj_t BgL_arg3158z00_1425;

																									BgL_arg3158z00_1425 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list3157z00_1424 =
																										MAKE_PAIR
																										(BgL_arg3155z00_1422,
																										BgL_arg3158z00_1425);
																								}
																								BgL_arg3153z00_1420 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg3154z00_1421,
																									BgL_list3157z00_1424);
																						}}
																						BgL_arg3149z00_1416 =
																							MAKE_PAIR(BgL_arg3152z00_1419,
																							BgL_arg3153z00_1420);
																					}
																					{	/* Object/creator.scm 474 */
																						obj_t BgL_list3151z00_1418;

																						BgL_list3151z00_1418 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg3143z00_1410 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg3149z00_1416,
																							BgL_list3151z00_1418);
																				}}
																				BgL_arg3138z00_1405 =
																					MAKE_PAIR(BgL_arg3142z00_1409,
																					BgL_arg3143z00_1410);
																			}
																			{	/* Object/creator.scm 473 */
																				obj_t BgL_list3140z00_1407;

																				{	/* Object/creator.scm 473 */
																					obj_t BgL_arg3141z00_1408;

																					BgL_arg3141z00_1408 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_list3140z00_1407 =
																						MAKE_PAIR(BgL_arg3138z00_1405,
																						BgL_arg3141z00_1408);
																				}
																				BgL_arg3137z00_1404 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_newz00_1309,
																					BgL_list3140z00_1407);
																		}}
																		BgL_arg3122z00_1389 =
																			MAKE_PAIR(BgL_arg3136z00_1403,
																			BgL_arg3137z00_1404);
																	}
																	{	/* Object/creator.scm 477 */
																		obj_t BgL_arg3159z00_1426;

																		obj_t BgL_arg3160z00_1427;

																		BgL_arg3159z00_1426 =
																			CNST_TABLE_REF(((long) 36));
																		{	/* Object/creator.scm 477 */
																			obj_t BgL_list3161z00_1428;

																			{	/* Object/creator.scm 477 */
																				obj_t BgL_arg3162z00_1429;

																				BgL_arg3162z00_1429 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list3161z00_1428 =
																					MAKE_PAIR(BFALSE,
																					BgL_arg3162z00_1429);
																			}
																			BgL_arg3160z00_1427 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_newz00_1309, BgL_list3161z00_1428);
																		}
																		BgL_arg3123z00_1390 =
																			MAKE_PAIR(BgL_arg3159z00_1426,
																			BgL_arg3160z00_1427);
																	}
																	{	/* Object/creator.scm 472 */
																		obj_t BgL_list3125z00_1392;

																		{	/* Object/creator.scm 472 */
																			obj_t BgL_arg3126z00_1393;

																			{	/* Object/creator.scm 472 */
																				obj_t BgL_arg3127z00_1394;

																				{	/* Object/creator.scm 472 */
																					obj_t BgL_arg3128z00_1395;

																					BgL_arg3128z00_1395 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3127z00_1394 =
																						MAKE_PAIR(BgL_newz00_1309,
																						BgL_arg3128z00_1395);
																				}
																				BgL_arg3126z00_1393 =
																					MAKE_PAIR(BgL_arg3123z00_1390,
																					BgL_arg3127z00_1394);
																			}
																			BgL_list3125z00_1392 =
																				MAKE_PAIR(BgL_arg3122z00_1389,
																				BgL_arg3126z00_1393);
																		}
																		BgL_arg3120z00_1387 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg3121z00_1388,
																			BgL_list3125z00_1392);
																}}
																BgL_arg3115z00_1382 =
																	MAKE_PAIR(BgL_arg3119z00_1386,
																	BgL_arg3120z00_1387);
															}
															{	/* Object/creator.scm 471 */
																obj_t BgL_list3117z00_1384;

																{	/* Object/creator.scm 471 */
																	obj_t BgL_arg3118z00_1385;

																	BgL_arg3118z00_1385 = MAKE_PAIR(BNIL, BNIL);
																	BgL_list3117z00_1384 =
																		MAKE_PAIR(BgL_arg3115z00_1382,
																		BgL_arg3118z00_1385);
																}
																BgL_arg3113z00_1380 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg3114z00_1381, BgL_list3117z00_1384);
														}}
														BgL_arg3053z00_1321 =
															MAKE_PAIR(BgL_arg3112z00_1379,
															BgL_arg3113z00_1380);
												}}
											else
												{	/* Object/creator.scm 491 */
													{	/* Object/creator.scm 480 */
														obj_t BgL_arg3058z00_1326;

														obj_t BgL_arg3059z00_1327;

														BgL_arg3058z00_1326 = CNST_TABLE_REF(((long) 8));
														{	/* Object/creator.scm 480 */
															obj_t BgL_arg3060z00_1328;

															obj_t BgL_arg3062z00_1329;

															BgL_arg3060z00_1328 =
																MAKE_PAIR(BgL_alloczd2tidzd2_1308, BNIL);
															{	/* Object/creator.scm 481 */
																obj_t BgL_arg3066z00_1333;

																obj_t BgL_arg3067z00_1334;

																BgL_arg3066z00_1333 =
																	CNST_TABLE_REF(((long) 20));
																{	/* Object/creator.scm 481 */
																	obj_t BgL_arg3068z00_1335;

																	obj_t BgL_arg3069z00_1336;

																	obj_t BgL_arg3070z00_1337;

																	{	/* Object/creator.scm 481 */
																		obj_t BgL_arg3076z00_1343;

																		{	/* Object/creator.scm 481 */
																			obj_t BgL_arg3078z00_1345;

																			obj_t BgL_arg3079z00_1346;

																			BgL_arg3078z00_1345 =
																				BGl_makezd2typedzd2identz00zzast_identz00
																				(BgL_newz00_1309, BgL_tidz00_1306);
																			{	/* Object/creator.scm 482 */
																				obj_t BgL_arg3080z00_1347;

																				BgL_arg3080z00_1347 =
																					BGl_makezd2privatezd2sexpz00zzast_privatez00
																					(CNST_TABLE_REF(((long) 9)),
																					BgL_tidz00_1306, BNIL);
																				{	/* Object/creator.scm 481 */
																					obj_t BgL_list3082z00_1349;

																					BgL_list3082z00_1349 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3079z00_1346 =
																						BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																						(BgL_arg3080z00_1347,
																						BgL_list3082z00_1349);
																			}}
																			BgL_arg3076z00_1343 =
																				MAKE_PAIR(BgL_arg3078z00_1345,
																				BgL_arg3079z00_1346);
																		}
																		BgL_arg3068z00_1335 =
																			MAKE_PAIR(BgL_arg3076z00_1343, BNIL);
																	}
																	{	/* Object/creator.scm 483 */
																		obj_t BgL_arg3084z00_1351;

																		obj_t BgL_arg3085z00_1352;

																		BgL_arg3084z00_1351 =
																			CNST_TABLE_REF(((long) 32));
																		{	/* Object/creator.scm 484 */
																			obj_t BgL_arg3086z00_1353;

																			{	/* Object/creator.scm 484 */
																				obj_t BgL_arg3090z00_1357;

																				obj_t BgL_arg3091z00_1358;

																				{	/* Object/creator.scm 484 */
																					obj_t BgL_arg3092z00_1359;

																					obj_t BgL_arg3093z00_1360;

																					BgL_arg3092z00_1359 =
																						CNST_TABLE_REF(((long) 33));
																					{	/* Object/creator.scm 484 */
																						obj_t BgL_list3094z00_1361;

																						{	/* Object/creator.scm 484 */
																							obj_t BgL_arg3095z00_1362;

																							obj_t BgL_arg3096z00_1363;

																							BgL_arg3095z00_1362 =
																								CNST_TABLE_REF(((long) 34));
																							BgL_arg3096z00_1363 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_list3094z00_1361 =
																								MAKE_PAIR(BgL_arg3095z00_1362,
																								BgL_arg3096z00_1363);
																						}
																						BgL_arg3093z00_1360 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(CNST_TABLE_REF(((long) 35)),
																							BgL_list3094z00_1361);
																					}
																					BgL_arg3090z00_1357 =
																						MAKE_PAIR(BgL_arg3092z00_1359,
																						BgL_arg3093z00_1360);
																				}
																				{	/* Object/creator.scm 485 */
																					obj_t BgL_arg3097z00_1364;

																					{	/* Object/creator.scm 485 */
																						obj_t BgL_arg3100z00_1367;

																						obj_t BgL_arg3101z00_1368;

																						BgL_arg3100z00_1367 =
																							CNST_TABLE_REF(((long) 33));
																						{	/* Object/creator.scm 485 */
																							obj_t BgL_arg3102z00_1369;

																							obj_t BgL_arg3103z00_1370;

																							{
																								BgL_variablez00_bglt
																									BgL_auxz00_3229;
																								BgL_auxz00_3229 =
																									(BgL_variablez00_bglt)
																									(BgL_holderz00_64);
																								BgL_arg3102z00_1369 =
																									(((BgL_variablez00_bglt)
																										CREF(BgL_auxz00_3229))->
																									BgL_idz00);
																							}
																							BgL_arg3103z00_1370 =
																								(((BgL_globalz00_bglt)
																									CREF(BgL_holderz00_64))->
																								BgL_modulez00);
																							{	/* Object/creator.scm 485 */
																								obj_t BgL_list3105z00_1372;

																								{	/* Object/creator.scm 485 */
																									obj_t BgL_arg3106z00_1373;

																									BgL_arg3106z00_1373 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_list3105z00_1372 =
																										MAKE_PAIR
																										(BgL_arg3103z00_1370,
																										BgL_arg3106z00_1373);
																								}
																								BgL_arg3101z00_1368 =
																									BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																									(BgL_arg3102z00_1369,
																									BgL_list3105z00_1372);
																						}}
																						BgL_arg3097z00_1364 =
																							MAKE_PAIR(BgL_arg3100z00_1367,
																							BgL_arg3101z00_1368);
																					}
																					{	/* Object/creator.scm 484 */
																						obj_t BgL_list3099z00_1366;

																						BgL_list3099z00_1366 =
																							MAKE_PAIR(BNIL, BNIL);
																						BgL_arg3091z00_1358 =
																							BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																							(BgL_arg3097z00_1364,
																							BgL_list3099z00_1366);
																				}}
																				BgL_arg3086z00_1353 =
																					MAKE_PAIR(BgL_arg3090z00_1357,
																					BgL_arg3091z00_1358);
																			}
																			{	/* Object/creator.scm 483 */
																				obj_t BgL_list3088z00_1355;

																				{	/* Object/creator.scm 483 */
																					obj_t BgL_arg3089z00_1356;

																					BgL_arg3089z00_1356 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_list3088z00_1355 =
																						MAKE_PAIR(BgL_arg3086z00_1353,
																						BgL_arg3089z00_1356);
																				}
																				BgL_arg3085z00_1352 =
																					BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																					(BgL_newz00_1309,
																					BgL_list3088z00_1355);
																		}}
																		BgL_arg3069z00_1336 =
																			MAKE_PAIR(BgL_arg3084z00_1351,
																			BgL_arg3085z00_1352);
																	}
																	{	/* Object/creator.scm 487 */
																		obj_t BgL_arg3107z00_1374;

																		obj_t BgL_arg3108z00_1375;

																		BgL_arg3107z00_1374 =
																			CNST_TABLE_REF(((long) 36));
																		{	/* Object/creator.scm 487 */
																			obj_t BgL_list3109z00_1376;

																			{	/* Object/creator.scm 487 */
																				obj_t BgL_arg3110z00_1377;

																				BgL_arg3110z00_1377 =
																					MAKE_PAIR(BNIL, BNIL);
																				BgL_list3109z00_1376 =
																					MAKE_PAIR(BFALSE,
																					BgL_arg3110z00_1377);
																			}
																			BgL_arg3108z00_1375 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				(BgL_newz00_1309, BgL_list3109z00_1376);
																		}
																		BgL_arg3070z00_1337 =
																			MAKE_PAIR(BgL_arg3107z00_1374,
																			BgL_arg3108z00_1375);
																	}
																	{	/* Object/creator.scm 481 */
																		obj_t BgL_list3072z00_1339;

																		{	/* Object/creator.scm 481 */
																			obj_t BgL_arg3073z00_1340;

																			{	/* Object/creator.scm 481 */
																				obj_t BgL_arg3074z00_1341;

																				{	/* Object/creator.scm 481 */
																					obj_t BgL_arg3075z00_1342;

																					BgL_arg3075z00_1342 =
																						MAKE_PAIR(BNIL, BNIL);
																					BgL_arg3074z00_1341 =
																						MAKE_PAIR(BgL_newz00_1309,
																						BgL_arg3075z00_1342);
																				}
																				BgL_arg3073z00_1340 =
																					MAKE_PAIR(BgL_arg3070z00_1337,
																					BgL_arg3074z00_1341);
																			}
																			BgL_list3072z00_1339 =
																				MAKE_PAIR(BgL_arg3069z00_1336,
																				BgL_arg3073z00_1340);
																		}
																		BgL_arg3067z00_1334 =
																			BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																			(BgL_arg3068z00_1335,
																			BgL_list3072z00_1339);
																}}
																BgL_arg3062z00_1329 =
																	MAKE_PAIR(BgL_arg3066z00_1333,
																	BgL_arg3067z00_1334);
															}
															{	/* Object/creator.scm 480 */
																obj_t BgL_list3064z00_1331;

																{	/* Object/creator.scm 480 */
																	obj_t BgL_arg3065z00_1332;

																	BgL_arg3065z00_1332 = MAKE_PAIR(BNIL, BNIL);
																	BgL_list3064z00_1331 =
																		MAKE_PAIR(BgL_arg3062z00_1329,
																		BgL_arg3065z00_1332);
																}
																BgL_arg3059z00_1327 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg3060z00_1328, BgL_list3064z00_1331);
														}}
														BgL_arg3053z00_1321 =
															MAKE_PAIR(BgL_arg3058z00_1326,
															BgL_arg3059z00_1327);
										}}}
										{	/* Object/creator.scm 491 */
											obj_t BgL_list3054z00_1322;

											BgL_list3054z00_1322 =
												MAKE_PAIR(BgL_srczd2defzd2_65, BNIL);
											return
												BGl_epairifyza2za2zztools_miscz00(BgL_arg3053z00_1321,
												BgL_list3054z00_1322);
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* gen-wide-class-make! */
	obj_t BGl_genzd2widezd2classzd2makez12zc0zzobject_creatorz00(obj_t
		BgL_idz00_67, BgL_tclassz00_bglt BgL_typez00_68, obj_t BgL_srczd2defzd2_69,
		obj_t BgL_importz00_70)
	{
		AN_OBJECT;
		{	/* Object/creator.scm 499 */
			{	/* Object/creator.scm 500 */
				obj_t BgL_mkzd2heapzd2idz00_1459;

				{	/* Object/creator.scm 500 */
					obj_t BgL_arg3296z00_1589;

					{	/* Object/creator.scm 500 */
						obj_t BgL_arg3297z00_1590;

						obj_t BgL_arg3298z00_1591;

						{	/* Object/creator.scm 500 */
							obj_t BgL_symbolz00_2014;

							BgL_symbolz00_2014 = CNST_TABLE_REF(((long) 3));
							BgL_arg3297z00_1590 = SYMBOL_TO_STRING(BgL_symbolz00_2014);
						}
						BgL_arg3298z00_1591 = SYMBOL_TO_STRING(BgL_idz00_67);
						{	/* Object/creator.scm 500 */
							obj_t BgL_list3299z00_1592;

							{	/* Object/creator.scm 500 */
								obj_t BgL_arg3300z00_1593;

								BgL_arg3300z00_1593 = MAKE_PAIR(BgL_arg3298z00_1591, BNIL);
								BgL_list3299z00_1592 =
									MAKE_PAIR(BgL_arg3297z00_1590, BgL_arg3300z00_1593);
							}
							BgL_arg3296z00_1589 =
								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
								(BgL_list3299z00_1592);
					}}
					BgL_mkzd2heapzd2idz00_1459 =
						string_to_symbol(BSTRING_TO_STRING(BgL_arg3296z00_1589));
				}
				{	/* Object/creator.scm 500 */
					obj_t BgL_superz00_1460;

					{
						obj_t BgL_auxz00_3269;

						{	/* Object/creator.scm 501 */
							BgL_objectz00_bglt BgL_auxz00_3270;

							BgL_auxz00_3270 = (BgL_objectz00_bglt) (BgL_typez00_68);
							BgL_auxz00_3269 = BGL_OBJECT_WIDENING(BgL_auxz00_3270);
						}
						BgL_superz00_1460 =
							(((BgL_tclassz00_bglt) CREF(BgL_auxz00_3269))->
							BgL_itszd2superzd2);
					}
					{	/* Object/creator.scm 501 */
						obj_t BgL_slotsz00_1461;

						{
							obj_t BgL_auxz00_3274;

							{	/* Object/creator.scm 502 */
								BgL_objectz00_bglt BgL_auxz00_3275;

								BgL_auxz00_3275 = (BgL_objectz00_bglt) (BgL_typez00_68);
								BgL_auxz00_3274 = BGL_OBJECT_WIDENING(BgL_auxz00_3275);
							}
							BgL_slotsz00_1461 =
								(((BgL_tclassz00_bglt) CREF(BgL_auxz00_3274))->BgL_slotsz00);
						}
						{	/* Object/creator.scm 502 */
							obj_t BgL_sslotsz00_1462;

							{	/* Object/creator.scm 503 */
								BgL_tclassz00_bglt BgL_obj2040z00_2019;

								BgL_obj2040z00_2019 = (BgL_tclassz00_bglt) (BgL_superz00_1460);
								{
									obj_t BgL_auxz00_3280;

									{	/* Object/creator.scm 503 */
										BgL_objectz00_bglt BgL_auxz00_3281;

										BgL_auxz00_3281 =
											(BgL_objectz00_bglt) (BgL_obj2040z00_2019);
										BgL_auxz00_3280 = BGL_OBJECT_WIDENING(BgL_auxz00_3281);
									}
									BgL_sslotsz00_1462 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_3280))->
										BgL_slotsz00);
							}}
							{	/* Object/creator.scm 503 */
								BgL_globalz00_bglt BgL_holderz00_1463;

								{
									obj_t BgL_auxz00_3285;

									{	/* Object/creator.scm 504 */
										BgL_objectz00_bglt BgL_auxz00_3286;

										BgL_auxz00_3286 = (BgL_objectz00_bglt) (BgL_typez00_68);
										BgL_auxz00_3285 = BGL_OBJECT_WIDENING(BgL_auxz00_3286);
									}
									BgL_holderz00_1463 =
										(((BgL_tclassz00_bglt) CREF(BgL_auxz00_3285))->
										BgL_holderz00);
								}
								{	/* Object/creator.scm 504 */
									obj_t BgL_constrsz00_1464;

									BgL_constrsz00_1464 =
										BGl_findzd2classzd2constructorsz00zzobject_classz00
										(BgL_typez00_68);
									{	/* Object/creator.scm 505 */
										obj_t BgL_tidz00_1465;

										{
											BgL_typez00_bglt BgL_auxz00_3291;

											BgL_auxz00_3291 = (BgL_typez00_bglt) (BgL_typez00_68);
											BgL_tidz00_1465 =
												(((BgL_typez00_bglt) CREF(BgL_auxz00_3291))->BgL_idz00);
										}
										{	/* Object/creator.scm 506 */
											obj_t BgL_stidz00_1466;

											{
												BgL_typez00_bglt BgL_auxz00_3294;

												BgL_auxz00_3294 =
													(BgL_typez00_bglt) (BgL_superz00_1460);
												BgL_stidz00_1466 =
													(((BgL_typez00_bglt) CREF(BgL_auxz00_3294))->
													BgL_idz00);
											}
											{	/* Object/creator.scm 507 */
												obj_t BgL_mkzd2tidzd2_1467;

												{	/* Object/creator.scm 508 */
													obj_t BgL_arg3290z00_1583;

													{	/* Object/creator.scm 508 */
														obj_t BgL_arg3291z00_1584;

														{	/* Object/creator.scm 508 */
															obj_t BgL_arg3292z00_1585;

															obj_t BgL_arg3293z00_1586;

															{	/* Object/creator.scm 508 */
																obj_t BgL_symbolz00_2023;

																BgL_symbolz00_2023 = CNST_TABLE_REF(((long) 3));
																BgL_arg3292z00_1585 =
																	SYMBOL_TO_STRING(BgL_symbolz00_2023);
															}
															BgL_arg3293z00_1586 =
																SYMBOL_TO_STRING(BgL_idz00_67);
															{	/* Object/creator.scm 508 */
																obj_t BgL_list3294z00_1587;

																{	/* Object/creator.scm 508 */
																	obj_t BgL_arg3295z00_1588;

																	BgL_arg3295z00_1588 =
																		MAKE_PAIR(BgL_arg3293z00_1586, BNIL);
																	BgL_list3294z00_1587 =
																		MAKE_PAIR(BgL_arg3292z00_1585,
																		BgL_arg3295z00_1588);
																}
																BgL_arg3291z00_1584 =
																	BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																	(BgL_list3294z00_1587);
														}}
														BgL_arg3290z00_1583 =
															string_to_symbol(BSTRING_TO_STRING
															(BgL_arg3291z00_1584));
													}
													BgL_mkzd2tidzd2_1467 =
														BGl_makezd2typedzd2identz00zzast_identz00
														(BgL_arg3290z00_1583, BgL_tidz00_1465);
												}
												{	/* Object/creator.scm 508 */
													obj_t BgL_fzd2idszd2_1468;

													BgL_fzd2idszd2_1468 =
														BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
														(BgL_slotsz00_1461);
													{	/* Object/creator.scm 509 */
														obj_t BgL_sfzd2idszd2_1469;

														BgL_sfzd2idszd2_1469 =
															BGl_makezd2classzd2makezd2formalszd2zzobject_slotsz00
															(BgL_sslotsz00_1462);
														{	/* Object/creator.scm 510 */
															obj_t BgL_fzd2tidszd2_1470;

															BgL_fzd2tidszd2_1470 =
																BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
																(BgL_fzd2idszd2_1468, BgL_slotsz00_1461);
															{	/* Object/creator.scm 511 */
																obj_t BgL_sfzd2tidszd2_1471;

																BgL_sfzd2tidszd2_1471 =
																	BGl_makezd2classzd2makezd2typedzd2formalsz00zzobject_slotsz00
																	(BgL_sfzd2idszd2_1469, BgL_sslotsz00_1462);
																{	/* Object/creator.scm 512 */
																	obj_t BgL_wideningz00_1472;

																	{	/* Object/creator.scm 514 */
																		obj_t BgL_arg3284z00_1577;

																		obj_t BgL_arg3285z00_1578;

																		obj_t BgL_arg3286z00_1579;

																		{
																			obj_t BgL_auxz00_3310;

																			{	/* Object/creator.scm 514 */
																				BgL_objectz00_bglt BgL_auxz00_3311;

																				BgL_auxz00_3311 =
																					(BgL_objectz00_bglt) (BgL_typez00_68);
																				BgL_auxz00_3310 =
																					BGL_OBJECT_WIDENING(BgL_auxz00_3311);
																			}
																			BgL_arg3284z00_1577 =
																				(((BgL_tclassz00_bglt)
																					CREF(BgL_auxz00_3310))->
																				BgL_wideningz00);
																		}
																		BgL_arg3285z00_1578 =
																			CNST_TABLE_REF(((long) 5));
																		{
																			BgL_typez00_bglt BgL_auxz00_3316;

																			BgL_auxz00_3316 =
																				(BgL_typez00_bglt) (BgL_typez00_68);
																			BgL_arg3286z00_1579 =
																				(((BgL_typez00_bglt)
																					CREF(BgL_auxz00_3316))->BgL_idz00);
																		}
																		{	/* Object/creator.scm 513 */
																			obj_t BgL_list3287z00_1580;

																			{	/* Object/creator.scm 513 */
																				obj_t BgL_arg3288z00_1581;

																				{	/* Object/creator.scm 513 */
																					obj_t BgL_arg3289z00_1582;

																					BgL_arg3289z00_1582 =
																						MAKE_PAIR(BgL_arg3286z00_1579,
																						BNIL);
																					BgL_arg3288z00_1581 =
																						MAKE_PAIR(BgL_arg3285z00_1578,
																						BgL_arg3289z00_1582);
																				}
																				BgL_list3287z00_1580 =
																					MAKE_PAIR(BgL_arg3284z00_1577,
																					BgL_arg3288z00_1581);
																			}
																			BgL_wideningz00_1472 =
																				BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																				(BgL_list3287z00_1580);
																	}}
																	{	/* Object/creator.scm 513 */
																		obj_t BgL_auxz00_1473;

																		BgL_auxz00_1473 =
																			BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																			(BGl_gensymz00zz__r4_symbols_6_4z00
																			(CNST_TABLE_REF(((long) 37))));
																		{	/* Object/creator.scm 515 */
																			obj_t BgL_newz00_1474;

																			BgL_newz00_1474 =
																				BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																				(BGl_gensymz00zz__r4_symbols_6_4z00
																				(CNST_TABLE_REF(((long) 9))));
																			{	/* Object/creator.scm 516 */
																				obj_t BgL_mkzd2classzd2idz00_1475;

																				{	/* Object/creator.scm 517 */
																					obj_t BgL_arg3277z00_1570;

																					{	/* Object/creator.scm 517 */
																						obj_t BgL_arg3278z00_1571;

																						obj_t BgL_arg3279z00_1572;

																						{	/* Object/creator.scm 517 */
																							obj_t BgL_symbolz00_2028;

																							BgL_symbolz00_2028 =
																								CNST_TABLE_REF(((long) 3));
																							BgL_arg3278z00_1571 =
																								SYMBOL_TO_STRING
																								(BgL_symbolz00_2028);
																						}
																						BgL_arg3279z00_1572 =
																							SYMBOL_TO_STRING
																							(BgL_stidz00_1466);
																						{	/* Object/creator.scm 517 */
																							obj_t BgL_list3280z00_1573;

																							{	/* Object/creator.scm 517 */
																								obj_t BgL_arg3281z00_1574;

																								BgL_arg3281z00_1574 =
																									MAKE_PAIR(BgL_arg3279z00_1572,
																									BNIL);
																								BgL_list3280z00_1573 =
																									MAKE_PAIR(BgL_arg3278z00_1571,
																									BgL_arg3281z00_1574);
																							}
																							BgL_arg3277z00_1570 =
																								BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																								(BgL_list3280z00_1573);
																					}}
																					BgL_mkzd2classzd2idz00_1475 =
																						string_to_symbol(BSTRING_TO_STRING
																						(BgL_arg3277z00_1570));
																				}
																				{	/* Object/creator.scm 517 */

																					{	/* Object/creator.scm 519 */
																						obj_t BgL_arg3186z00_1476;

																						{	/* Object/creator.scm 519 */
																							obj_t BgL_arg3187z00_1477;

																							{	/* Object/creator.scm 519 */
																								obj_t BgL_arg3188z00_1478;

																								BgL_arg3188z00_1478 =
																									MAKE_PAIR
																									(BgL_mkzd2tidzd2_1467,
																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																									(BgL_sfzd2tidszd2_1471,
																										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																										(BgL_fzd2tidszd2_1470,
																											BNIL)));
																								{	/* Object/creator.scm 519 */
																									obj_t BgL_list3190z00_1480;

																									BgL_list3190z00_1480 =
																										MAKE_PAIR(BNIL, BNIL);
																									BgL_arg3187z00_1477 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg3188z00_1478,
																										BgL_list3190z00_1480);
																							}}
																							BgL_arg3186z00_1476 =
																								MAKE_PAIR(BgL_importz00_70,
																								BgL_arg3187z00_1477);
																						}
																						BGl_producezd2modulezd2clausez12z12zzmodule_modulez00
																							(BgL_arg3186z00_1476);
																					}
																					{	/* Object/creator.scm 521 */
																						obj_t BgL_arg3193z00_1483;

																						{	/* Object/creator.scm 521 */
																							obj_t BgL_arg3195z00_1485;

																							obj_t BgL_arg3196z00_1486;

																							BgL_arg3195z00_1485 =
																								CNST_TABLE_REF(((long) 15));
																							{	/* Object/creator.scm 521 */
																								obj_t BgL_arg3197z00_1487;

																								obj_t BgL_arg3198z00_1488;

																								BgL_arg3197z00_1487 =
																									MAKE_PAIR
																									(BgL_mkzd2tidzd2_1467,
																									BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																									(BgL_sfzd2tidszd2_1471,
																										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																										(BgL_fzd2tidszd2_1470,
																											BNIL)));
																								{	/* Object/creator.scm 524 */
																									obj_t BgL_arg3204z00_1494;

																									obj_t BgL_arg3205z00_1495;

																									BgL_arg3204z00_1494 =
																										CNST_TABLE_REF(((long) 20));
																									{	/* Object/creator.scm 524 */
																										obj_t BgL_arg3207z00_1496;

																										obj_t BgL_arg3208z00_1497;

																										obj_t BgL_arg3209z00_1498;

																										obj_t BgL_arg3212z00_1499;

																										{	/* Object/creator.scm 524 */
																											obj_t BgL_arg3218z00_1505;

																											{	/* Object/creator.scm 524 */
																												obj_t
																													BgL_arg3220z00_1507;
																												obj_t
																													BgL_arg3221z00_1508;
																												BgL_arg3220z00_1507 =
																													BGl_makezd2typedzd2identz00zzast_identz00
																													(BgL_auxz00_1473,
																													BgL_stidz00_1466);
																												{	/* Object/creator.scm 525 */
																													obj_t
																														BgL_arg3222z00_1509;
																													BgL_arg3222z00_1509 =
																														MAKE_PAIR
																														(BgL_mkzd2classzd2idz00_1475,
																														BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																														(BgL_sfzd2idszd2_1469,
																															BNIL));
																													{	/* Object/creator.scm 524 */
																														obj_t
																															BgL_list3224z00_1511;
																														BgL_list3224z00_1511
																															=
																															MAKE_PAIR(BNIL,
																															BNIL);
																														BgL_arg3221z00_1508
																															=
																															BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																															(BgL_arg3222z00_1509,
																															BgL_list3224z00_1511);
																												}}
																												BgL_arg3218z00_1505 =
																													MAKE_PAIR
																													(BgL_arg3220z00_1507,
																													BgL_arg3221z00_1508);
																											}
																											BgL_arg3207z00_1496 =
																												MAKE_PAIR
																												(BgL_arg3218z00_1505,
																												BNIL);
																										}
																										{	/* Object/creator.scm 529 */
																											obj_t BgL_arg3226z00_1513;

																											obj_t BgL_arg3227z00_1514;

																											BgL_arg3226z00_1513 =
																												CNST_TABLE_REF(((long)
																													32));
																											{	/* Object/creator.scm 531 */
																												obj_t
																													BgL_arg3229z00_1515;
																												{	/* Object/creator.scm 531 */
																													obj_t
																														BgL_arg3233z00_1519;
																													obj_t
																														BgL_arg3234z00_1520;
																													BgL_arg3233z00_1519 =
																														CNST_TABLE_REF((
																															(long) 35));
																													{	/* Object/creator.scm 531 */
																														obj_t
																															BgL_arg3235z00_1521;
																														{	/* Object/creator.scm 531 */
																															obj_t
																																BgL_arg3238z00_1524;
																															obj_t
																																BgL_arg3239z00_1525;
																															BgL_arg3238z00_1524
																																=
																																CNST_TABLE_REF((
																																	(long) 33));
																															{	/* Object/creator.scm 531 */
																																obj_t
																																	BgL_arg3240z00_1526;
																																obj_t
																																	BgL_arg3241z00_1527;
																																{
																																	BgL_variablez00_bglt
																																		BgL_auxz00_3359;
																																	BgL_auxz00_3359
																																		=
																																		(BgL_variablez00_bglt)
																																		(BgL_holderz00_1463);
																																	BgL_arg3240z00_1526
																																		=
																																		(((BgL_variablez00_bglt) CREF(BgL_auxz00_3359))->BgL_idz00);
																																}
																																BgL_arg3241z00_1527
																																	=
																																	(((BgL_globalz00_bglt) CREF(BgL_holderz00_1463))->BgL_modulez00);
																																{	/* Object/creator.scm 531 */
																																	obj_t
																																		BgL_list3243z00_1529;
																																	{	/* Object/creator.scm 531 */
																																		obj_t
																																			BgL_arg3244z00_1530;
																																		BgL_arg3244z00_1530
																																			=
																																			MAKE_PAIR
																																			(BNIL,
																																			BNIL);
																																		BgL_list3243z00_1529
																																			=
																																			MAKE_PAIR
																																			(BgL_arg3241z00_1527,
																																			BgL_arg3244z00_1530);
																																	}
																																	BgL_arg3239z00_1525
																																		=
																																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																		(BgL_arg3240z00_1526,
																																		BgL_list3243z00_1529);
																															}}
																															BgL_arg3235z00_1521
																																=
																																MAKE_PAIR
																																(BgL_arg3238z00_1524,
																																BgL_arg3239z00_1525);
																														}
																														{	/* Object/creator.scm 531 */
																															obj_t
																																BgL_list3237z00_1523;
																															BgL_list3237z00_1523
																																=
																																MAKE_PAIR(BNIL,
																																BNIL);
																															BgL_arg3234z00_1520
																																=
																																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																(BgL_arg3235z00_1521,
																																BgL_list3237z00_1523);
																													}}
																													BgL_arg3229z00_1515 =
																														MAKE_PAIR
																														(BgL_arg3233z00_1519,
																														BgL_arg3234z00_1520);
																												}
																												{	/* Object/creator.scm 529 */
																													obj_t
																														BgL_list3231z00_1517;
																													{	/* Object/creator.scm 529 */
																														obj_t
																															BgL_arg3232z00_1518;
																														BgL_arg3232z00_1518
																															=
																															MAKE_PAIR(BNIL,
																															BNIL);
																														BgL_list3231z00_1517
																															=
																															MAKE_PAIR
																															(BgL_arg3229z00_1515,
																															BgL_arg3232z00_1518);
																													}
																													BgL_arg3227z00_1514 =
																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																														(BgL_auxz00_1473,
																														BgL_list3231z00_1517);
																											}}
																											BgL_arg3208z00_1497 =
																												MAKE_PAIR
																												(BgL_arg3226z00_1513,
																												BgL_arg3227z00_1514);
																										}
																										{	/* Object/creator.scm 534 */
																											obj_t BgL_arg3245z00_1531;

																											obj_t BgL_arg3246z00_1532;

																											BgL_arg3245z00_1531 =
																												CNST_TABLE_REF(((long)
																													36));
																											{	/* Object/creator.scm 534 */
																												obj_t
																													BgL_arg3247z00_1533;
																												BgL_arg3247z00_1533 =
																													MAKE_PAIR
																													(BgL_wideningz00_1472,
																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																													(BgL_fzd2idszd2_1468,
																														BNIL));
																												{	/* Object/creator.scm 534 */
																													obj_t
																														BgL_list3249z00_1535;
																													{	/* Object/creator.scm 534 */
																														obj_t
																															BgL_arg3250z00_1536;
																														BgL_arg3250z00_1536
																															=
																															MAKE_PAIR(BNIL,
																															BNIL);
																														BgL_list3249z00_1535
																															=
																															MAKE_PAIR
																															(BgL_arg3247z00_1533,
																															BgL_arg3250z00_1536);
																													}
																													BgL_arg3246z00_1532 =
																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																														(BgL_auxz00_1473,
																														BgL_list3249z00_1535);
																											}}
																											BgL_arg3209z00_1498 =
																												MAKE_PAIR
																												(BgL_arg3245z00_1531,
																												BgL_arg3246z00_1532);
																										}
																										{	/* Object/creator.scm 536 */
																											obj_t BgL_arg3252z00_1538;

																											obj_t BgL_arg3253z00_1539;

																											BgL_arg3252z00_1538 =
																												CNST_TABLE_REF(((long)
																													20));
																											{	/* Object/creator.scm 536 */
																												obj_t
																													BgL_arg3254z00_1540;
																												obj_t
																													BgL_arg3255z00_1541;
																												{	/* Object/creator.scm 536 */
																													obj_t
																														BgL_arg3257z00_1543;
																													{	/* Object/creator.scm 536 */
																														obj_t
																															BgL_arg3259z00_1545;
																														obj_t
																															BgL_arg3260z00_1546;
																														BgL_arg3259z00_1545
																															=
																															BGl_makezd2typedzd2identz00zzast_identz00
																															(BgL_newz00_1474,
																															BgL_tidz00_1465);
																														{	/* Object/creator.scm 537 */
																															obj_t
																																BgL_arg3261z00_1547;
																															{	/* Object/creator.scm 537 */
																																obj_t
																																	BgL_list3264z00_1550;
																																BgL_list3264z00_1550
																																	=
																																	MAKE_PAIR
																																	(BgL_auxz00_1473,
																																	BNIL);
																																BgL_arg3261z00_1547
																																	=
																																	BGl_makezd2privatezd2sexpz00zzast_privatez00
																																	(CNST_TABLE_REF
																																	(((long) 38)),
																																	BgL_tidz00_1465,
																																	BgL_list3264z00_1550);
																															}
																															{	/* Object/creator.scm 536 */
																																obj_t
																																	BgL_list3263z00_1549;
																																BgL_list3263z00_1549
																																	=
																																	MAKE_PAIR
																																	(BNIL, BNIL);
																																BgL_arg3260z00_1546
																																	=
																																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																	(BgL_arg3261z00_1547,
																																	BgL_list3263z00_1549);
																														}}
																														BgL_arg3257z00_1543
																															=
																															MAKE_PAIR
																															(BgL_arg3259z00_1545,
																															BgL_arg3260z00_1546);
																													}
																													BgL_arg3254z00_1540 =
																														MAKE_PAIR
																														(BgL_arg3257z00_1543,
																														BNIL);
																												}
																												{	/* Object/creator.scm 540 */
																													obj_t
																														BgL_arg3265z00_1551;
																													obj_t
																														BgL_arg3266z00_1552;
																													{	/* Object/creator.scm 540 */
																														bool_t
																															BgL_testz00_3390;
																														if (PAIRP
																															(BgL_constrsz00_1464))
																															{	/* Object/creator.scm 540 */
																																if (
																																	(BgL_wideningz00_1472
																																		==
																																		CNST_TABLE_REF
																																		(((long)
																																				6))))
																																	{	/* Object/creator.scm 541 */
																																		BgL_testz00_3390
																																			=
																																			((bool_t)
																																			0);
																																	}
																																else
																																	{	/* Object/creator.scm 541 */
																																		BgL_testz00_3390
																																			=
																																			((bool_t)
																																			1);
																																	}
																															}
																														else
																															{	/* Object/creator.scm 540 */
																																BgL_testz00_3390
																																	=
																																	((bool_t) 0);
																															}
																														if (BgL_testz00_3390)
																															{	/* Object/creator.scm 540 */
																																if (NULLP
																																	(BgL_constrsz00_1464))
																																	{	/* Object/creator.scm 542 */
																																		BgL_arg3265z00_1551
																																			= BNIL;
																																	}
																																else
																																	{	/* Object/creator.scm 542 */
																																		obj_t
																																			BgL_head2471z00_1556;
																																		BgL_head2471z00_1556
																																			=
																																			MAKE_PAIR
																																			(BNIL,
																																			BNIL);
																																		{
																																			obj_t
																																				BgL_l2469z00_1557;
																																			obj_t
																																				BgL_tail2472z00_1558;
																																			BgL_l2469z00_1557
																																				=
																																				BgL_constrsz00_1464;
																																			BgL_tail2472z00_1558
																																				=
																																				BgL_head2471z00_1556;
																																		BgL_map2470z00_1559:
																																			if (NULLP
																																				(BgL_l2469z00_1557))
																																				{	/* Object/creator.scm 542 */
																																					BgL_arg3265z00_1551
																																						=
																																						CDR
																																						(BgL_head2471z00_1556);
																																				}
																																			else
																																				{	/* Object/creator.scm 542 */
																																					obj_t
																																						BgL_newtail2473z00_1561;
																																					{	/* Object/creator.scm 542 */
																																						obj_t
																																							BgL_arg3271z00_1563;
																																						{	/* Object/creator.scm 542 */
																																							obj_t
																																								BgL_constrz00_1565;
																																							BgL_constrz00_1565
																																								=
																																								CAR
																																								(BgL_l2469z00_1557);
																																							{	/* Object/creator.scm 542 */
																																								obj_t
																																									BgL_arg3273z00_1566;
																																								{	/* Object/creator.scm 542 */
																																									obj_t
																																										BgL_list3274z00_1567;
																																									BgL_list3274z00_1567
																																										=
																																										MAKE_PAIR
																																										(BNIL,
																																										BNIL);
																																									BgL_arg3273z00_1566
																																										=
																																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																																										(BgL_newz00_1474,
																																										BgL_list3274z00_1567);
																																								}
																																								BgL_arg3271z00_1563
																																									=
																																									MAKE_PAIR
																																									(BgL_constrz00_1565,
																																									BgL_arg3273z00_1566);
																																							}
																																						}
																																						BgL_newtail2473z00_1561
																																							=
																																							MAKE_PAIR
																																							(BgL_arg3271z00_1563,
																																							BNIL);
																																					}
																																					SET_CDR
																																						(BgL_tail2472z00_1558,
																																						BgL_newtail2473z00_1561);
																																					{
																																						obj_t
																																							BgL_tail2472z00_3410;
																																						obj_t
																																							BgL_l2469z00_3408;
																																						BgL_l2469z00_3408
																																							=
																																							CDR
																																							(BgL_l2469z00_1557);
																																						BgL_tail2472z00_3410
																																							=
																																							BgL_newtail2473z00_1561;
																																						BgL_tail2472z00_1558
																																							=
																																							BgL_tail2472z00_3410;
																																						BgL_l2469z00_1557
																																							=
																																							BgL_l2469z00_3408;
																																						goto
																																							BgL_map2470z00_1559;
																																					}
																																				}
																																		}
																																	}
																															}
																														else
																															{	/* Object/creator.scm 540 */
																																BgL_arg3265z00_1551
																																	= BNIL;
																															}
																													}
																													BgL_arg3266z00_1552 =
																														MAKE_PAIR
																														(BgL_newz00_1474,
																														BNIL);
																													BgL_arg3255z00_1541 =
																														BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																														(BgL_arg3265z00_1551,
																														BgL_arg3266z00_1552);
																												}
																												{	/* Object/creator.scm 536 */
																													obj_t
																														BgL_list3256z00_1542;
																													BgL_list3256z00_1542 =
																														MAKE_PAIR
																														(BgL_arg3255z00_1541,
																														BNIL);
																													BgL_arg3253z00_1539 =
																														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																														(BgL_arg3254z00_1540,
																														BgL_list3256z00_1542);
																												}
																											}
																											BgL_arg3212z00_1499 =
																												MAKE_PAIR
																												(BgL_arg3252z00_1538,
																												BgL_arg3253z00_1539);
																										}
																										{	/* Object/creator.scm 524 */
																											obj_t
																												BgL_list3214z00_1501;
																											{	/* Object/creator.scm 524 */
																												obj_t
																													BgL_arg3215z00_1502;
																												{	/* Object/creator.scm 524 */
																													obj_t
																														BgL_arg3216z00_1503;
																													{	/* Object/creator.scm 524 */
																														obj_t
																															BgL_arg3217z00_1504;
																														BgL_arg3217z00_1504
																															=
																															MAKE_PAIR(BNIL,
																															BNIL);
																														BgL_arg3216z00_1503
																															=
																															MAKE_PAIR
																															(BgL_arg3212z00_1499,
																															BgL_arg3217z00_1504);
																													}
																													BgL_arg3215z00_1502 =
																														MAKE_PAIR
																														(BgL_arg3209z00_1498,
																														BgL_arg3216z00_1503);
																												}
																												BgL_list3214z00_1501 =
																													MAKE_PAIR
																													(BgL_arg3208z00_1497,
																													BgL_arg3215z00_1502);
																											}
																											BgL_arg3205z00_1495 =
																												BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																												(BgL_arg3207z00_1496,
																												BgL_list3214z00_1501);
																										}
																									}
																									BgL_arg3198z00_1488 =
																										MAKE_PAIR
																										(BgL_arg3204z00_1494,
																										BgL_arg3205z00_1495);
																								}
																								{	/* Object/creator.scm 521 */
																									obj_t BgL_list3200z00_1490;

																									{	/* Object/creator.scm 521 */
																										obj_t BgL_arg3201z00_1491;

																										BgL_arg3201z00_1491 =
																											MAKE_PAIR(BNIL, BNIL);
																										BgL_list3200z00_1490 =
																											MAKE_PAIR
																											(BgL_arg3198z00_1488,
																											BgL_arg3201z00_1491);
																									}
																									BgL_arg3196z00_1486 =
																										BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																										(BgL_arg3197z00_1487,
																										BgL_list3200z00_1490);
																								}
																							}
																							BgL_arg3193z00_1483 =
																								MAKE_PAIR(BgL_arg3195z00_1485,
																								BgL_arg3196z00_1486);
																						}
																						{	/* Object/creator.scm 521 */
																							obj_t BgL_list3194z00_1484;

																							BgL_list3194z00_1484 =
																								MAKE_PAIR(BgL_srczd2defzd2_69,
																								BNIL);
																							return
																								BGl_epairifyza2za2zztools_miscz00
																								(BgL_arg3193z00_1483,
																								BgL_list3194z00_1484);
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzobject_creatorz00()
	{
		AN_OBJECT;
		{	/* Object/creator.scm 21 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 12445515),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztype_toolsz00(((long) 195902195),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 328872856),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 453255680),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 71067807),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_structz00(((long) 112894054),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_slotsz00(((long) 17869975),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_toolsz00(((long) 405988581),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzobject_nilz00(((long) 169673641),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
			return
				BGl_modulezd2initializa7ationz75zzmodule_impusez00(((long) 468691571),
				BSTRING_TO_STRING(BGl_string3330z00zzobject_creatorz00));
		}
	}

#ifdef __cplusplus
}
#endif
