/*===========================================================================*/
/*   (Trace/walk.scm)                                                        */
/*   Bigloo (3.2a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 6 18:27:22 CET 2009         */
/*===========================================================================*/
/* COMPILATION: (/users/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /users/serrano/prgm/project/bigloo/lib/3.2a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Trace/walk.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		obj_t BgL_libraryz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzf3z21;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
	}                 *BgL_backendz00_bglt;


	static obj_t BGl_tracezd2nodezd2jumpzd2exzd2i3278z00zztrace_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_tracezd2nodezd2extern3260z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2appzd2l3228z00zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2appzd2ly3256zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t BGl_findzd2lastzd2nodezd2setzd2e3246z00zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zztrace_walkz00();
	static obj_t BGl_tracezd2nodezd2condition3266z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt,
		obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	static obj_t BGl_tracezd2nodezd2letzd2fun3272zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	static obj_t BGl_tracezd2nodezd2sequence3252z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t BGl_tracezd2nodezd2app3254z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2setq3234zd2zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	static obj_t BGl_findzd2lastzd2nodezd2letzd2v3242z00zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zztrace_walkz00();
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2letzd2var3274zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2app3226zd2zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2boxzd2setz123284zc0zztrace_walkz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl_tracezd2nodezd2select3270z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	static obj_t BGl_toplevelzd2tracezd2nodezd23288zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2tracezd2nodezd23290zd2zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_findzd2lastzd2nodezd2selec3240zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2setzd2exzd2it3276z00zztrace_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_addzd2genericz12zc0zz__objectz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2fail3238zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2funca3230zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t);
	static obj_t BGl_methodzd2initzd2zztrace_walkz00();
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static obj_t BGl__findzd2lastzd2nodezd2defau3220zd2zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodezd2makezd2box3280zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zztrace_walkz00 = BUNSPEC;
	extern obj_t BGl_za2bmemzd2profilingza2zd2zzengine_paramz00;
	static obj_t BGl__findzd2lastzd2node3773z00zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zztrace_walkz00();
	extern obj_t BGl_pragmaz00zzast_nodez00;
	static obj_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2seque3224zd2zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl__toplevelzd2tracezd2node3772z00zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2condi3236zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2cast3262z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl__tracezd2nodezd2default3249z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	static BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	extern obj_t BGl_atomz00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	static obj_t BGl__toplevelzd2tracezd2nodezd23285zd2zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00();
	BGL_EXPORTED_DECL obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t bgl_display_string(obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	static obj_t BGl_tracezd2nodezd2funcall3258z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2setq3264z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t string_to_symbol(char *);
	BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
	static obj_t BGl__tracezd2node3774zd2zztrace_walkz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_open_input_string(obj_t, int);
	static obj_t BGl__tracezd2walkz12zc0zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_findzd2lastzd2nodezd2jumpzd23248z00zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	static obj_t BGl_findzd2lastzd2nodezd2exter3232zd2zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2boxzd2ref3282zd2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_tracezd2nodezd2fail3268z00zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
	static obj_t BGl_findzd2lastzd2nodezd2letzd2f3244z00zztrace_walkz00(obj_t,
		obj_t);
	static obj_t __cnst[15];


	   
		 
		DEFINE_STRING(BGl_string3775z00zztrace_walkz00,
		BgL_bgl_string3775za700za7za7t3822za7, "Trace", 5);
	      DEFINE_STRING(BGl_string3776z00zztrace_walkz00,
		BgL_bgl_string3776za700za7za7t3823za7, "   . ", 5);
	      DEFINE_STRING(BGl_string3777z00zztrace_walkz00,
		BgL_bgl_string3777za700za7za7t3824za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string3778z00zztrace_walkz00,
		BgL_bgl_string3778za700za7za7t3825za7, " error", 6);
	      DEFINE_STRING(BGl_string3780z00zztrace_walkz00,
		BgL_bgl_string3780za700za7za7t3826za7, "", 0);
	      DEFINE_STRING(BGl_string3779z00zztrace_walkz00,
		BgL_bgl_string3779za700za7za7t3827za7, "s", 1);
	      DEFINE_STRING(BGl_string3781z00zztrace_walkz00,
		BgL_bgl_string3781za700za7za7t3828za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string3782z00zztrace_walkz00,
		BgL_bgl_string3782za700za7za7t3829za7, "failure during postlude hook", 28);
	      DEFINE_STRING(BGl_string3783z00zztrace_walkz00,
		BgL_bgl_string3783za700za7za7t3830za7, "%toplevel@", 10);
	      DEFINE_STRING(BGl_string3784z00zztrace_walkz00,
		BgL_bgl_string3784za700za7za7t3831za7, "%import@", 8);
	      DEFINE_STRING(BGl_string3785z00zztrace_walkz00,
		BgL_bgl_string3785za700za7za7t3832za7, ", ~a:~a", 7);
	      DEFINE_STRING(BGl_string3818z00zztrace_walkz00,
		BgL_bgl_string3818za700za7za7t3833za7, "trace_walk", 10);
	      DEFINE_STRING(BGl_string3819z00zztrace_walkz00,
		BgL_bgl_string3819za700za7za7t3834za7,
		"done value ($pop-trace) $pop-trace $push-trace quote let location |:| symbol aux no-trace imported-modules-init toplevel-init pass-started ",
		139);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_findzd2lastzd2nodezd2defau3220zd2envz00zztrace_walkz00,
		BgL_bgl__findza7d2lastza7d2n3835z00,
		BGl__findzd2lastzd2nodezd2defau3220zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_GENERIC(BGl_tracezd2nodezd2envz00zztrace_walkz00,
		BgL_bgl__traceza7d2node3773836za7, BGl__tracezd2node3774zd2zztrace_walkz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl__findza7d2lastza7d2n3837z00,
		BGl__findzd2lastzd2node3773z00zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl__toplevelza7d2trac3838za7,
		BGl__toplevelzd2tracezd2node3772z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_tracezd2walkz12zd2envz12zztrace_walkz00,
		BgL_bgl__traceza7d2walkza7123839z00, BGl__tracezd2walkz12zc0zztrace_walkz00,
		0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_toplevelzd2tracezd2nodezd23285zd2envz00zztrace_walkz00,
		BgL_bgl__toplevelza7d2trac3840za7,
		BGl__toplevelzd2tracezd2nodezd23285zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_PROCEDURE
		(BGl_tracezd2nodezd2default3249zd2envzd2zztrace_walkz00,
		BgL_bgl__traceza7d2nodeza7d23841z00,
		BGl__tracezd2nodezd2default3249z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3786z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3842z00,
		BGl_findzd2lastzd2nodezd2seque3224zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3787z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3843z00,
		BGl_findzd2lastzd2nodezd2app3226zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3788z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3844z00,
		BGl_findzd2lastzd2nodezd2appzd2l3228z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3800z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2a3845z00,
		BGl_tracezd2nodezd2app3254z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3790z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3846z00,
		BGl_findzd2lastzd2nodezd2exter3232zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3789z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3847z00,
		BGl_findzd2lastzd2nodezd2funca3230zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3801z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2a3848z00,
		BGl_tracezd2nodezd2appzd2ly3256zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3791z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3849z00,
		BGl_findzd2lastzd2nodezd2setq3234zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3802z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2f3850z00,
		BGl_tracezd2nodezd2funcall3258z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3792z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3851z00,
		BGl_findzd2lastzd2nodezd2condi3236zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3803z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2e3852z00,
		BGl_tracezd2nodezd2extern3260z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3793z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3853z00,
		BGl_findzd2lastzd2nodezd2fail3238zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3804z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2c3854z00,
		BGl_tracezd2nodezd2cast3262z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3794z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3855z00,
		BGl_findzd2lastzd2nodezd2selec3240zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3805z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3856z00,
		BGl_tracezd2nodezd2setq3264z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3795z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3857z00,
		BGl_findzd2lastzd2nodezd2letzd2v3242z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3806z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2c3858z00,
		BGl_tracezd2nodezd2condition3266z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3796z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3859z00,
		BGl_findzd2lastzd2nodezd2letzd2f3244z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3807z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2f3860z00,
		BGl_tracezd2nodezd2fail3268z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3797z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3861z00,
		BGl_findzd2lastzd2nodezd2setzd2e3246z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3808z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3862z00,
		BGl_tracezd2nodezd2select3270z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3798z00zztrace_walkz00,
		BgL_bgl_findza7d2lastza7d2no3863z00,
		BGl_findzd2lastzd2nodezd2jumpzd23248z00zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3810z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2l3864z00,
		BGl_tracezd2nodezd2letzd2var3274zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3809z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2l3865z00,
		BGl_tracezd2nodezd2letzd2fun3272zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3799z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3866z00,
		BGl_tracezd2nodezd2sequence3252z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3811z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2s3867z00,
		BGl_tracezd2nodezd2setzd2exzd2it3276z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3812z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2j3868z00,
		BGl_tracezd2nodezd2jumpzd2exzd2i3278z00zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3813z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2m3869z00,
		BGl_tracezd2nodezd2makezd2box3280zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3814z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2b3870z00,
		BGl_tracezd2nodezd2boxzd2ref3282zd2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3815z00zztrace_walkz00,
		BgL_bgl_traceza7d2nodeza7d2b3871z00,
		BGl_tracezd2nodezd2boxzd2setz123284zc0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3816z00zztrace_walkz00,
		BgL_bgl_toplevelza7d2trace3872za7,
		BGl_toplevelzd2tracezd2nodezd23288zd2zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3817z00zztrace_walkz00,
		BgL_bgl_toplevelza7d2trace3873za7,
		BGl_toplevelzd2tracezd2nodezd23290zd2zztrace_walkz00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long
		BgL_checksumz00_3431, char *BgL_fromz00_3432)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zztrace_walkz00))
				{
					BGl_requirezd2initializa7ationz75zztrace_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
					BGl_cnstzd2initzd2zztrace_walkz00();
					BGl_importedzd2moduleszd2initz00zztrace_walkz00();
					BGl_genericzd2initzd2zztrace_walkz00();
					BGl_methodzd2initzd2zztrace_walkz00();
					return BUNSPEC;
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"trace_walk");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			{	/* Trace/walk.scm 15 */
				obj_t BgL_cportz00_3419;

				BgL_cportz00_3419 =
					bgl_open_input_string(BGl_string3819z00zztrace_walkz00,
					(int) (((long) 0)));
				{
					long BgL_iz00_3420;

					BgL_iz00_3420 = ((long) 14);
				BgL_loopz00_3421:
					if ((BgL_iz00_3420 == ((long) -1)))
						{	/* Trace/walk.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Trace/walk.scm 15 */
							{	/* Trace/walk.scm 15 */
								obj_t BgL_arg3821z00_3423;

								{	/* Trace/walk.scm 15 */

									{	/* Trace/walk.scm 15 */
										obj_t BgL_locationz00_3425;

										BgL_locationz00_3425 = BBOOL(((bool_t) 0));
										{	/* Trace/walk.scm 15 */

											BgL_arg3821z00_3423 =
												BGl_readz00zz__readerz00(BgL_cportz00_3419,
												BgL_locationz00_3425);
										}
									}
								}
								{	/* Trace/walk.scm 15 */
									int BgL_auxz00_3456;

									BgL_auxz00_3456 = (int) (BgL_iz00_3420);
									CNST_TABLE_SET(BgL_auxz00_3456, BgL_arg3821z00_3423);
							}}
							{	/* Trace/walk.scm 15 */
								int BgL_auxz00_3426;

								BgL_auxz00_3426 = (int) ((BgL_iz00_3420 - ((long) 1)));
								{
									long BgL_iz00_3461;

									BgL_iz00_3461 = (long) (BgL_auxz00_3426);
									BgL_iz00_3420 = BgL_iz00_3461;
									goto BgL_loopz00_3421;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}
	}



/* trace-walk! */
	BGL_EXPORTED_DEF obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t
		BgL_globalsz00_15)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 36 */
			{	/* Trace/walk.scm 37 */
				obj_t BgL_list3300z00_908;

				{	/* Trace/walk.scm 37 */
					obj_t BgL_arg3302z00_910;

					{	/* Trace/walk.scm 37 */
						obj_t BgL_arg3304z00_912;

						BgL_arg3304z00_912 = MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
						BgL_arg3302z00_910 =
							MAKE_PAIR(BGl_string3775z00zztrace_walkz00, BgL_arg3304z00_912);
					}
					BgL_list3300z00_908 =
						MAKE_PAIR(BGl_string3776z00zztrace_walkz00, BgL_arg3302z00_910);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list3300z00_908);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 =
				BGl_string3775z00zztrace_walkz00;
			{
				obj_t BgL_hooksz00_915;

				obj_t BgL_hnamesz00_916;

				BgL_hooksz00_915 = BNIL;
				BgL_hnamesz00_916 = BNIL;
			BgL_loopz00_917:
				if (NULLP(BgL_hooksz00_915))
					{	/* Trace/walk.scm 37 */
						CNST_TABLE_REF(((long) 0));
					}
				else
					{	/* Trace/walk.scm 37 */
						bool_t BgL_testz00_3473;

						{	/* Trace/walk.scm 37 */
							obj_t BgL_fun3312z00_925;

							BgL_fun3312z00_925 = CAR(BgL_hooksz00_915);
							BgL_testz00_3473 =
								CBOOL(PROCEDURE_ENTRY(BgL_fun3312z00_925) (BgL_fun3312z00_925,
									BEOA));
						}
						if (BgL_testz00_3473)
							{
								obj_t BgL_hnamesz00_3480;

								obj_t BgL_hooksz00_3478;

								BgL_hooksz00_3478 = CDR(BgL_hooksz00_915);
								BgL_hnamesz00_3480 = CDR(BgL_hnamesz00_916);
								BgL_hnamesz00_916 = BgL_hnamesz00_3480;
								BgL_hooksz00_915 = BgL_hooksz00_3478;
								goto BgL_loopz00_917;
							}
						else
							{	/* Trace/walk.scm 37 */
								BGl_internalzd2errorzd2zztools_errorz00
									(BGl_string3775z00zztrace_walkz00,
									BGl_string3777z00zztrace_walkz00, CAR(BgL_hnamesz00_916));
							}
					}
			}
			{	/* Trace/walk.scm 43 */
				obj_t BgL_idz00_927;

				BgL_idz00_927 = CNST_TABLE_REF(((long) 1));
				{	/* Trace/walk.scm 43 */
					obj_t BgL_gloz00_928;

					{	/* Trace/walk.scm 44 */
						obj_t BgL_list3317z00_933;

						BgL_list3317z00_933 =
							MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL);
						BgL_gloz00_928 =
							BGl_findzd2globalzd2zzast_envz00(BgL_idz00_927,
							BgL_list3317z00_933);
					}
					{	/* Trace/walk.scm 44 */

						if (BGl_iszd2azf3z21zz__objectz00(BgL_gloz00_928,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 46 */
								BgL_valuez00_bglt BgL_instance3170z00_930;

								{
									BgL_variablez00_bglt BgL_auxz00_3489;

									BgL_auxz00_3489 = (BgL_variablez00_bglt) (BgL_gloz00_928);
									BgL_instance3170z00_930 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_3489))->
										BgL_valuez00);
								}
								{	/* Trace/walk.scm 47 */
									BgL_nodez00_bglt BgL_arg3315z00_931;

									{	/* Trace/walk.scm 47 */
										obj_t BgL_arg3316z00_932;

										{
											BgL_sfunz00_bglt BgL_auxz00_3492;

											BgL_auxz00_3492 =
												(BgL_sfunz00_bglt) (BgL_instance3170z00_930);
											BgL_arg3316z00_932 =
												(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3492))->
												BgL_bodyz00);
										}
										{	/* Trace/walk.scm 47 */
											BgL_nodez00_bglt BgL_res3652z00_1840;

											{	/* Trace/walk.scm 47 */
												BgL_nodez00_bglt BgL_nodez00_1814;

												BgL_nodez00_1814 =
													(BgL_nodez00_bglt) (BgL_arg3316z00_932);
												{	/* Trace/walk.scm 47 */
													obj_t BgL_method3286z00_1815;

													{	/* Trace/walk.scm 47 */
														BgL_objectz00_bglt BgL_objz00_1816;

														BgL_objz00_1816 =
															(BgL_objectz00_bglt) (BgL_nodez00_1814);
														{	/* Trace/walk.scm 47 */
															long BgL_objzd2classzd2numz00_1817;

															BgL_objzd2classzd2numz00_1817 =
																BGL_OBJECT_CLASS_NUM(BgL_objz00_1816);
															{	/* Trace/walk.scm 47 */
																obj_t BgL_arg2334z00_1818;

																BgL_arg2334z00_1818 =
																	PROCEDURE_REF
																	(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
																	(int) (((long) 1)));
																{	/* Trace/walk.scm 47 */
																	obj_t BgL_arrayz00_1820;

																	int BgL_offsetz00_1821;

																	BgL_arrayz00_1820 = BgL_arg2334z00_1818;
																	BgL_offsetz00_1821 =
																		(int) (BgL_objzd2classzd2numz00_1817);
																	{	/* Trace/walk.scm 47 */
																		long BgL_offsetz00_1822;

																		BgL_offsetz00_1822 =
																			(
																			(long) (BgL_offsetz00_1821) -
																			OBJECT_TYPE);
																		{	/* Trace/walk.scm 47 */
																			long BgL_modz00_1823;

																			{	/* Trace/walk.scm 47 */
																				int BgL_arg2336z00_1824;

																				BgL_arg2336z00_1824 =
																					(int) (((long) 8));
																				{	/* Trace/walk.scm 47 */
																					long BgL_auxz00_3504;

																					BgL_auxz00_3504 =
																						(long) (BgL_arg2336z00_1824);
																					BgL_modz00_1823 =
																						(BgL_offsetz00_1822 /
																						BgL_auxz00_3504);
																			}}
																			{	/* Trace/walk.scm 47 */
																				long BgL_restz00_1825;

																				{	/* Trace/walk.scm 47 */
																					int BgL_arg2335z00_1826;

																					BgL_arg2335z00_1826 =
																						(int) (((long) 8));
																					{	/* Trace/walk.scm 47 */
																						long BgL_auxz00_3508;

																						BgL_auxz00_3508 =
																							(long) (BgL_arg2335z00_1826);
																						BgL_restz00_1825 =
																							(BgL_offsetz00_1822 %
																							BgL_auxz00_3508);
																				}}
																				{	/* Trace/walk.scm 47 */

																					BgL_method3286z00_1815 =
																						VECTOR_REF(VECTOR_REF
																						(BgL_arrayz00_1820,
																							(int) (BgL_modz00_1823)),
																						(int) (BgL_restz00_1825));
													}}}}}}}}
													BgL_res3652z00_1840 =
														(BgL_nodez00_bglt) (PROCEDURE_ENTRY
														(BgL_method3286z00_1815) (BgL_method3286z00_1815,
															(obj_t) (BgL_nodez00_1814), BEOA));
											}}
											BgL_arg3315z00_931 = BgL_res3652z00_1840;
									}}
									{
										obj_t BgL_auxz00_3521;

										BgL_sfunz00_bglt BgL_auxz00_3519;

										BgL_auxz00_3521 = (obj_t) (BgL_arg3315z00_931);
										BgL_auxz00_3519 =
											(BgL_sfunz00_bglt) (BgL_instance3170z00_930);
										((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3519))->BgL_bodyz00) =
											((obj_t) BgL_auxz00_3521), BUNSPEC);
							}}}
						else
							{	/* Trace/walk.scm 45 */
								BFALSE;
							}
					}
				}
			}
			{
				obj_t BgL_l3207z00_934;

				BgL_l3207z00_934 = BgL_globalsz00_15;
			BgL_forzd2each3209zd2_935:
				if (PAIRP(BgL_l3207z00_934))
					{	/* Trace/walk.scm 49 */
						BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l3207z00_934), BNIL);
						{
							obj_t BgL_l3207z00_3528;

							BgL_l3207z00_3528 = CDR(BgL_l3207z00_934);
							BgL_l3207z00_934 = BgL_l3207z00_3528;
							goto BgL_forzd2each3209zd2_935;
						}
					}
				else
					{	/* Trace/walk.scm 49 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Trace/walk.scm 50 */
					{	/* Trace/walk.scm 50 */
						obj_t BgL_port3210z00_941;

						{	/* Trace/walk.scm 50 */
							obj_t BgL_res3653z00_1849;

							{	/* Trace/walk.scm 50 */
								obj_t BgL_auxz00_3533;

								BgL_auxz00_3533 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3653z00_1849 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_auxz00_3533);
							}
							BgL_port3210z00_941 = BgL_res3653z00_1849;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port3210z00_941);
						bgl_display_string(BGl_string3778z00zztrace_walkz00,
							BgL_port3210z00_941);
						{	/* Trace/walk.scm 50 */
							obj_t BgL_arg3321z00_942;

							{	/* Trace/walk.scm 50 */
								bool_t BgL_testz00_3538;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Trace/walk.scm 50 */
										BgL_testz00_3538 =
											BGl_2ze3ze3zz__r4_numbers_6_5z00
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
											BINT(((long) 1)));
									}
								else
									{	/* Trace/walk.scm 50 */
										BgL_testz00_3538 = ((bool_t) 0);
									}
								if (BgL_testz00_3538)
									{	/* Trace/walk.scm 50 */
										BgL_arg3321z00_942 = BGl_string3779z00zztrace_walkz00;
									}
								else
									{	/* Trace/walk.scm 50 */
										BgL_arg3321z00_942 = BGl_string3780z00zztrace_walkz00;
									}
							}
							bgl_display_obj(BgL_arg3321z00_942, BgL_port3210z00_941);
						}
						bgl_display_string(BGl_string3781z00zztrace_walkz00,
							BgL_port3210z00_941);
						bgl_display_char(((unsigned char) '\n'), BgL_port3210z00_941);
					}
					{	/* Trace/walk.scm 50 */
						obj_t BgL_list3324z00_945;

						BgL_list3324z00_945 = MAKE_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list3324z00_945);
					}
				}
			else
				{
					obj_t BgL_hooksz00_948;

					obj_t BgL_hnamesz00_949;

					BgL_hooksz00_948 = BNIL;
					BgL_hnamesz00_949 = BNIL;
				BgL_loopz00_950:
					if (NULLP(BgL_hooksz00_948))
						{	/* Trace/walk.scm 50 */
							return BgL_globalsz00_15;
						}
					else
						{	/* Trace/walk.scm 50 */
							bool_t BgL_testz00_3551;

							{	/* Trace/walk.scm 50 */
								obj_t BgL_fun3331z00_957;

								BgL_fun3331z00_957 = CAR(BgL_hooksz00_948);
								BgL_testz00_3551 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun3331z00_957) (BgL_fun3331z00_957,
										BEOA));
							}
							if (BgL_testz00_3551)
								{
									obj_t BgL_hnamesz00_3558;

									obj_t BgL_hooksz00_3556;

									BgL_hooksz00_3556 = CDR(BgL_hooksz00_948);
									BgL_hnamesz00_3558 = CDR(BgL_hnamesz00_949);
									BgL_hnamesz00_949 = BgL_hnamesz00_3558;
									BgL_hooksz00_948 = BgL_hooksz00_3556;
									goto BgL_loopz00_950;
								}
							else
								{	/* Trace/walk.scm 50 */
									obj_t BgL_arg3330z00_956;

									BgL_arg3330z00_956 = CAR(BgL_hnamesz00_949);
									return
										BGl_internalzd2errorzd2zztools_errorz00
										(BGl_za2currentzd2passza2zd2zzengine_passz00,
										BGl_string3782z00zztrace_walkz00, BgL_arg3330z00_956);
								}
						}
				}
		}
	}



/* _trace-walk! */
	obj_t BGl__tracezd2walkz12zc0zztrace_walkz00(obj_t BgL_envz00_3289,
		obj_t BgL_globalsz00_3290)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 36 */
			return BGl_tracezd2walkz12zc0zztrace_walkz00(BgL_globalsz00_3290);
		}
	}



/* trace-id */
	obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t BgL_variablez00_16)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 61 */
			{	/* Trace/walk.scm 63 */
				bool_t BgL_testz00_3563;

				if (BGl_iszd2azf3z21zz__objectz00(BgL_variablez00_16,
						BGl_globalz00zzast_varz00))
					{	/* Trace/walk.scm 64 */
						obj_t BgL_auxz00_3566;

						{
							BgL_variablez00_bglt BgL_auxz00_3567;

							BgL_auxz00_3567 = (BgL_variablez00_bglt) (BgL_variablez00_16);
							BgL_auxz00_3566 =
								(((BgL_variablez00_bglt) CREF(BgL_auxz00_3567))->BgL_idz00);
						}
						BgL_testz00_3563 = (BgL_auxz00_3566 == CNST_TABLE_REF(((long) 1)));
					}
				else
					{	/* Trace/walk.scm 63 */
						BgL_testz00_3563 = ((bool_t) 0);
					}
				if (BgL_testz00_3563)
					{	/* Trace/walk.scm 65 */
						obj_t BgL_arg3334z00_960;

						{	/* Trace/walk.scm 65 */
							obj_t BgL_arg3335z00_961;

							obj_t BgL_arg3336z00_962;

							BgL_arg3335z00_961 =
								SYMBOL_TO_STRING(string_to_symbol(BSTRING_TO_STRING
									(BGl_string3783z00zztrace_walkz00)));
							{	/* Trace/walk.scm 65 */
								obj_t BgL_arg3340z00_966;

								{
									BgL_globalz00_bglt BgL_auxz00_3575;

									BgL_auxz00_3575 = (BgL_globalz00_bglt) (BgL_variablez00_16);
									BgL_arg3340z00_966 =
										(((BgL_globalz00_bglt) CREF(BgL_auxz00_3575))->
										BgL_modulez00);
								}
								BgL_arg3336z00_962 = SYMBOL_TO_STRING(BgL_arg3340z00_966);
							}
							{	/* Trace/walk.scm 65 */
								obj_t BgL_list3337z00_963;

								{	/* Trace/walk.scm 65 */
									obj_t BgL_arg3338z00_964;

									BgL_arg3338z00_964 = MAKE_PAIR(BgL_arg3336z00_962, BNIL);
									BgL_list3337z00_963 =
										MAKE_PAIR(BgL_arg3335z00_961, BgL_arg3338z00_964);
								}
								BgL_arg3334z00_960 =
									BGl_stringzd2appendzd2zz__r4_strings_6_7z00
									(BgL_list3337z00_963);
							}
						}
						return string_to_symbol(BSTRING_TO_STRING(BgL_arg3334z00_960));
					}
				else
					{	/* Trace/walk.scm 66 */
						bool_t BgL_testz00_3584;

						if (BGl_iszd2azf3z21zz__objectz00(BgL_variablez00_16,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 67 */
								obj_t BgL_auxz00_3587;

								{
									BgL_variablez00_bglt BgL_auxz00_3588;

									BgL_auxz00_3588 = (BgL_variablez00_bglt) (BgL_variablez00_16);
									BgL_auxz00_3587 =
										(((BgL_variablez00_bglt) CREF(BgL_auxz00_3588))->BgL_idz00);
								}
								BgL_testz00_3584 =
									(BgL_auxz00_3587 == CNST_TABLE_REF(((long) 2)));
							}
						else
							{	/* Trace/walk.scm 66 */
								BgL_testz00_3584 = ((bool_t) 0);
							}
						if (BgL_testz00_3584)
							{	/* Trace/walk.scm 68 */
								obj_t BgL_arg3342z00_968;

								{	/* Trace/walk.scm 68 */
									obj_t BgL_arg3343z00_969;

									obj_t BgL_arg3344z00_970;

									BgL_arg3343z00_969 =
										SYMBOL_TO_STRING(string_to_symbol(BSTRING_TO_STRING
											(BGl_string3784z00zztrace_walkz00)));
									{	/* Trace/walk.scm 68 */
										obj_t BgL_arg3348z00_974;

										{
											BgL_globalz00_bglt BgL_auxz00_3596;

											BgL_auxz00_3596 =
												(BgL_globalz00_bglt) (BgL_variablez00_16);
											BgL_arg3348z00_974 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_3596))->
												BgL_modulez00);
										}
										BgL_arg3344z00_970 = SYMBOL_TO_STRING(BgL_arg3348z00_974);
									}
									{	/* Trace/walk.scm 68 */
										obj_t BgL_list3345z00_971;

										{	/* Trace/walk.scm 68 */
											obj_t BgL_arg3346z00_972;

											BgL_arg3346z00_972 = MAKE_PAIR(BgL_arg3344z00_970, BNIL);
											BgL_list3345z00_971 =
												MAKE_PAIR(BgL_arg3343z00_969, BgL_arg3346z00_972);
										}
										BgL_arg3342z00_968 =
											BGl_stringzd2appendzd2zz__r4_strings_6_7z00
											(BgL_list3345z00_971);
									}
								}
								return string_to_symbol(BSTRING_TO_STRING(BgL_arg3342z00_968));
							}
						else
							{
								BgL_variablez00_bglt BgL_auxz00_3605;

								BgL_auxz00_3605 = (BgL_variablez00_bglt) (BgL_variablez00_16);
								return
									(((BgL_variablez00_bglt) CREF(BgL_auxz00_3605))->BgL_idz00);
							}
					}
			}
		}
	}



/* trace-fun! */
	obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t BgL_varz00_17,
		obj_t BgL_stackz00_18)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 78 */
			{	/* Trace/walk.scm 79 */
				BgL_valuez00_bglt BgL_funz00_981;

				{
					BgL_variablez00_bglt BgL_auxz00_3608;

					BgL_auxz00_3608 = (BgL_variablez00_bglt) (BgL_varz00_17);
					BgL_funz00_981 =
						(((BgL_variablez00_bglt) CREF(BgL_auxz00_3608))->BgL_valuez00);
				}
				{	/* Trace/walk.scm 79 */
					obj_t BgL_bodyz00_982;

					{
						BgL_sfunz00_bglt BgL_auxz00_3611;

						BgL_auxz00_3611 = (BgL_sfunz00_bglt) (BgL_funz00_981);
						BgL_bodyz00_982 =
							(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3611))->BgL_bodyz00);
					}
					{	/* Trace/walk.scm 80 */
						BgL_typez00_bglt BgL_typez00_983;

						{
							BgL_variablez00_bglt BgL_auxz00_3614;

							BgL_auxz00_3614 = (BgL_variablez00_bglt) (BgL_varz00_17);
							BgL_typez00_983 =
								(((BgL_variablez00_bglt) CREF(BgL_auxz00_3614))->BgL_typez00);
						}
						{	/* Trace/walk.scm 81 */
							obj_t BgL_llocz00_984;

							if (BGl_iszd2azf3z21zz__objectz00(BgL_varz00_17,
									BGl_globalz00zzast_varz00))
								{	/* Trace/walk.scm 83 */
									obj_t BgL_arg3368z00_1001;

									{	/* Trace/walk.scm 83 */
										obj_t BgL_auxz00_3619;

										{
											BgL_globalz00_bglt BgL_auxz00_3620;

											BgL_auxz00_3620 = (BgL_globalz00_bglt) (BgL_varz00_17);
											BgL_auxz00_3619 =
												(((BgL_globalz00_bglt) CREF(BgL_auxz00_3620))->
												BgL_srcz00);
										}
										BgL_arg3368z00_1001 =
											BGl_findzd2lastzd2sexpz00zztrace_walkz00(BgL_auxz00_3619);
									}
									BgL_llocz00_984 =
										BGl_findzd2locationzd2zztools_locationz00
										(BgL_arg3368z00_1001);
								}
							else
								{	/* Trace/walk.scm 84 */
									obj_t BgL_arg3370z00_1003;

									{	/* Trace/walk.scm 84 */
										BgL_nodez00_bglt BgL_nodez00_1882;

										BgL_nodez00_1882 = (BgL_nodez00_bglt) (BgL_bodyz00_982);
										{	/* Trace/walk.scm 84 */
											obj_t BgL_method3221z00_1883;

											{	/* Trace/walk.scm 84 */
												BgL_objectz00_bglt BgL_objz00_1884;

												BgL_objz00_1884 =
													(BgL_objectz00_bglt) (BgL_nodez00_1882);
												{	/* Trace/walk.scm 84 */
													long BgL_objzd2classzd2numz00_1885;

													BgL_objzd2classzd2numz00_1885 =
														BGL_OBJECT_CLASS_NUM(BgL_objz00_1884);
													{	/* Trace/walk.scm 84 */
														obj_t BgL_arg2334z00_1886;

														BgL_arg2334z00_1886 =
															PROCEDURE_REF
															(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
															(int) (((long) 1)));
														{	/* Trace/walk.scm 84 */
															obj_t BgL_arrayz00_1888;

															int BgL_offsetz00_1889;

															BgL_arrayz00_1888 = BgL_arg2334z00_1886;
															BgL_offsetz00_1889 =
																(int) (BgL_objzd2classzd2numz00_1885);
															{	/* Trace/walk.scm 84 */
																long BgL_offsetz00_1890;

																BgL_offsetz00_1890 =
																	((long) (BgL_offsetz00_1889) - OBJECT_TYPE);
																{	/* Trace/walk.scm 84 */
																	long BgL_modz00_1891;

																	{	/* Trace/walk.scm 84 */
																		int BgL_arg2336z00_1892;

																		BgL_arg2336z00_1892 = (int) (((long) 8));
																		{	/* Trace/walk.scm 84 */
																			long BgL_auxz00_3634;

																			BgL_auxz00_3634 =
																				(long) (BgL_arg2336z00_1892);
																			BgL_modz00_1891 =
																				(BgL_offsetz00_1890 / BgL_auxz00_3634);
																	}}
																	{	/* Trace/walk.scm 84 */
																		long BgL_restz00_1893;

																		{	/* Trace/walk.scm 84 */
																			int BgL_arg2335z00_1894;

																			BgL_arg2335z00_1894 = (int) (((long) 8));
																			{	/* Trace/walk.scm 84 */
																				long BgL_auxz00_3638;

																				BgL_auxz00_3638 =
																					(long) (BgL_arg2335z00_1894);
																				BgL_restz00_1893 =
																					(BgL_offsetz00_1890 %
																					BgL_auxz00_3638);
																		}}
																		{	/* Trace/walk.scm 84 */

																			BgL_method3221z00_1883 =
																				VECTOR_REF(VECTOR_REF(BgL_arrayz00_1888,
																					(int) (BgL_modz00_1891)),
																				(int) (BgL_restz00_1893));
											}}}}}}}}
											BgL_arg3370z00_1003 =
												PROCEDURE_ENTRY(BgL_method3221z00_1883)
												(BgL_method3221z00_1883, (obj_t) (BgL_nodez00_1882),
												BEOA);
									}}
									{
										BgL_nodez00_bglt BgL_auxz00_3648;

										BgL_auxz00_3648 = (BgL_nodez00_bglt) (BgL_arg3370z00_1003);
										BgL_llocz00_984 =
											(((BgL_nodez00_bglt) CREF(BgL_auxz00_3648))->BgL_locz00);
								}}
							{	/* Trace/walk.scm 82 */

								{	/* Trace/walk.scm 85 */
									bool_t BgL_testz00_3651;

									{	/* Trace/walk.scm 85 */
										bool_t BgL_testz00_3652;

										{	/* Trace/walk.scm 85 */
											BgL_funz00_bglt BgL_obj1634z00_1909;

											BgL_obj1634z00_1909 = (BgL_funz00_bglt) (BgL_funz00_981);
											BgL_testz00_3652 =
												CBOOL(
												(((BgL_funz00_bglt) CREF(BgL_obj1634z00_1909))->
													BgL_predicatezd2ofzd2));
										}
										if (BgL_testz00_3652)
											{	/* Trace/walk.scm 85 */
												BgL_testz00_3651 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 86 */
												bool_t BgL_testz00_3656;

												{	/* Trace/walk.scm 86 */
													obj_t BgL_auxz00_3657;

													{	/* Trace/walk.scm 86 */
														obj_t BgL_auxz00_3658;

														{
															BgL_sfunz00_bglt BgL_auxz00_3660;

															BgL_auxz00_3660 =
																(BgL_sfunz00_bglt) (BgL_funz00_981);
															BgL_auxz00_3658 =
																(((BgL_sfunz00_bglt) CREF(BgL_auxz00_3660))->
																BgL_propertyz00);
														}
														BgL_auxz00_3657 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(CNST_TABLE_REF(((long) 3)), BgL_auxz00_3658);
													}
													BgL_testz00_3656 = CBOOL(BgL_auxz00_3657);
												}
												if (BgL_testz00_3656)
													{	/* Trace/walk.scm 86 */
														BgL_testz00_3651 = ((bool_t) 0);
													}
												else
													{	/* Trace/walk.scm 86 */
														BgL_testz00_3651 = ((bool_t) 1);
													}
											}
									}
									if (BgL_testz00_3651)
										{	/* Trace/walk.scm 85 */
											BGl_enterzd2functionzd2zztools_errorz00
												(BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_17));
											{	/* Trace/walk.scm 89 */
												obj_t BgL_newzd2bodyzd2_987;

												{	/* Trace/walk.scm 89 */
													bool_t BgL_testz00_3667;

													if (
														((long)
															CINT
															(BGl_za2compilerzd2debugza2zd2zzengine_paramz00)
															>= ((long) 3)))
														{	/* Trace/walk.scm 89 */
															BgL_testz00_3667 = ((bool_t) 1);
														}
													else
														{	/* Trace/walk.scm 89 */
															if (BGl_iszd2azf3z21zz__objectz00(BgL_varz00_17,
																	BGl_globalz00zzast_varz00))
																{	/* Trace/walk.scm 91 */
																	obj_t BgL_auxz00_3673;

																	{
																		BgL_variablez00_bglt BgL_auxz00_3674;

																		BgL_auxz00_3674 =
																			(BgL_variablez00_bglt) (BgL_varz00_17);
																		BgL_auxz00_3673 =
																			(((BgL_variablez00_bglt)
																				CREF(BgL_auxz00_3674))->BgL_idz00);
																	}
																	BgL_testz00_3667 =
																		(BgL_auxz00_3673 ==
																		CNST_TABLE_REF(((long) 1)));
																}
															else
																{	/* Trace/walk.scm 90 */
																	BgL_testz00_3667 = ((bool_t) 0);
																}
														}
													if (BgL_testz00_3667)
														{	/* Trace/walk.scm 100 */
															obj_t BgL_arg3359z00_991;

															BgL_arg3359z00_991 =
																MAKE_PAIR(BgL_varz00_17, BgL_stackz00_18);
															{	/* Trace/walk.scm 100 */
																BgL_nodez00_bglt BgL_res3659z00_1942;

																{	/* Trace/walk.scm 100 */
																	BgL_nodez00_bglt BgL_nodez00_1915;

																	BgL_nodez00_1915 =
																		(BgL_nodez00_bglt) (BgL_bodyz00_982);
																	{	/* Trace/walk.scm 100 */
																		obj_t BgL_method3250z00_1917;

																		{	/* Trace/walk.scm 100 */
																			BgL_objectz00_bglt BgL_objz00_1918;

																			BgL_objz00_1918 =
																				(BgL_objectz00_bglt) (BgL_nodez00_1915);
																			{	/* Trace/walk.scm 100 */
																				long BgL_objzd2classzd2numz00_1919;

																				BgL_objzd2classzd2numz00_1919 =
																					BGL_OBJECT_CLASS_NUM(BgL_objz00_1918);
																				{	/* Trace/walk.scm 100 */
																					obj_t BgL_arg2334z00_1920;

																					BgL_arg2334z00_1920 =
																						PROCEDURE_REF
																						(BGl_tracezd2nodezd2envz00zztrace_walkz00,
																						(int) (((long) 1)));
																					{	/* Trace/walk.scm 100 */
																						obj_t BgL_arrayz00_1922;

																						int BgL_offsetz00_1923;

																						BgL_arrayz00_1922 =
																							BgL_arg2334z00_1920;
																						BgL_offsetz00_1923 =
																							(int)
																							(BgL_objzd2classzd2numz00_1919);
																						{	/* Trace/walk.scm 100 */
																							long BgL_offsetz00_1924;

																							BgL_offsetz00_1924 =
																								(
																								(long) (BgL_offsetz00_1923) -
																								OBJECT_TYPE);
																							{	/* Trace/walk.scm 100 */
																								long BgL_modz00_1925;

																								{	/* Trace/walk.scm 100 */
																									int BgL_arg2336z00_1926;

																									BgL_arg2336z00_1926 =
																										(int) (((long) 8));
																									{	/* Trace/walk.scm 100 */
																										long BgL_auxz00_3689;

																										BgL_auxz00_3689 =
																											(long)
																											(BgL_arg2336z00_1926);
																										BgL_modz00_1925 =
																											(BgL_offsetz00_1924 /
																											BgL_auxz00_3689);
																								}}
																								{	/* Trace/walk.scm 100 */
																									long BgL_restz00_1927;

																									{	/* Trace/walk.scm 100 */
																										int BgL_arg2335z00_1928;

																										BgL_arg2335z00_1928 =
																											(int) (((long) 8));
																										{	/* Trace/walk.scm 100 */
																											long BgL_auxz00_3693;

																											BgL_auxz00_3693 =
																												(long)
																												(BgL_arg2335z00_1928);
																											BgL_restz00_1927 =
																												(BgL_offsetz00_1924 %
																												BgL_auxz00_3693);
																									}}
																									{	/* Trace/walk.scm 100 */

																										BgL_method3250z00_1917 =
																											VECTOR_REF(VECTOR_REF
																											(BgL_arrayz00_1922,
																												(int)
																												(BgL_modz00_1925)),
																											(int) (BgL_restz00_1927));
																		}}}}}}}}
																		BgL_res3659z00_1942 =
																			(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																			(BgL_method3250z00_1917)
																			(BgL_method3250z00_1917,
																				(obj_t) (BgL_nodez00_1915),
																				BgL_arg3359z00_991, BEOA));
																}}
																BgL_newzd2bodyzd2_987 =
																	(obj_t) (BgL_res3659z00_1942);
														}}
													else
														{	/* Trace/walk.scm 89 */
															BgL_newzd2bodyzd2_987 = BgL_bodyz00_982;
														}
												}
												{	/* Trace/walk.scm 89 */
													BgL_letzd2varzd2_bglt BgL_new2zd2bodyzd2_988;

													BgL_new2zd2bodyzd2_988 =
														BGl_makezd2tracedzd2nodez00zztrace_walkz00(
														(BgL_nodez00_bglt) (BgL_newzd2bodyzd2_987),
														BgL_typez00_983,
														BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_17),
														BgL_llocz00_984, BgL_stackz00_18);
													{	/* Trace/walk.scm 102 */

														{
															obj_t BgL_auxz00_3710;

															BgL_sfunz00_bglt BgL_auxz00_3708;

															BgL_auxz00_3710 =
																(obj_t) (BgL_new2zd2bodyzd2_988);
															BgL_auxz00_3708 =
																(BgL_sfunz00_bglt) (BgL_funz00_981);
															((((BgL_sfunz00_bglt) CREF(BgL_auxz00_3708))->
																	BgL_bodyz00) =
																((obj_t) BgL_auxz00_3710), BUNSPEC);
														}
														return BGl_leavezd2functionzd2zztools_errorz00();
													}
												}
											}
										}
									else
										{	/* Trace/walk.scm 85 */
											return BFALSE;
										}
								}
							}
						}
					}
				}
			}
		}
	}



/* find-last-sexp */
	obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t BgL_sexpz00_19)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 117 */
			{
				obj_t BgL_sexpz00_1004;

				obj_t BgL_resz00_1005;

				BgL_sexpz00_1004 = BgL_sexpz00_19;
				BgL_resz00_1005 = BgL_sexpz00_19;
			BgL_loopz00_1006:
				if (PAIRP(BgL_sexpz00_1004))
					{	/* Trace/walk.scm 123 */
						bool_t BgL_testz00_3716;

						{	/* Trace/walk.scm 123 */
							obj_t BgL_auxz00_3717;

							BgL_auxz00_3717 = CDR(BgL_sexpz00_1004);
							BgL_testz00_3716 = PAIRP(BgL_auxz00_3717);
						}
						if (BgL_testz00_3716)
							{
								obj_t BgL_resz00_3722;

								obj_t BgL_sexpz00_3720;

								BgL_sexpz00_3720 =
									BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00
									(BgL_sexpz00_1004);
								BgL_resz00_3722 = BgL_sexpz00_1004;
								BgL_resz00_1005 = BgL_resz00_3722;
								BgL_sexpz00_1004 = BgL_sexpz00_3720;
								goto BgL_loopz00_1006;
							}
						else
							{
								obj_t BgL_resz00_3725;

								obj_t BgL_sexpz00_3723;

								BgL_sexpz00_3723 = CAR(BgL_sexpz00_1004);
								BgL_resz00_3725 = BgL_sexpz00_1004;
								BgL_resz00_1005 = BgL_resz00_3725;
								BgL_sexpz00_1004 = BgL_sexpz00_3723;
								goto BgL_loopz00_1006;
							}
					}
				else
					{	/* Trace/walk.scm 121 */
						return BgL_resz00_1005;
					}
			}
		}
	}



/* make-traced-node */
	BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt BgL_nodez00_35,
		BgL_typez00_bglt BgL_typez00_36, obj_t BgL_symbolz00_37,
		obj_t BgL_llocz00_38, obj_t BgL_stackz00_39)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 233 */
			{	/* Trace/walk.scm 234 */
				obj_t BgL_locz00_1012;

				BgL_locz00_1012 =
					(((BgL_nodez00_bglt) CREF(BgL_nodez00_35))->BgL_locz00);
				{	/* Trace/walk.scm 234 */
					obj_t BgL_auxz00_1013;

					BgL_auxz00_1013 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 4))));
					{	/* Trace/walk.scm 235 */
						obj_t BgL_tauxz00_1014;

						{	/* Trace/walk.scm 236 */
							obj_t BgL_arg3444z00_1087;

							BgL_arg3444z00_1087 =
								(((BgL_typez00_bglt) CREF(BgL_typez00_36))->BgL_idz00);
							BgL_tauxz00_1014 =
								BGl_makezd2typedzd2identz00zzast_identz00(BgL_auxz00_1013,
								BgL_arg3444z00_1087);
						}
						{	/* Trace/walk.scm 236 */
							obj_t BgL_symz00_1015;

							BgL_symz00_1015 =
								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
								(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											5))));
							{	/* Trace/walk.scm 237 */
								obj_t BgL_szb2zb2_1016;

								{	/* Trace/walk.scm 238 */
									bool_t BgL_testz00_3735;

									if (PAIRP(BgL_stackz00_39))
										{	/* Trace/walk.scm 238 */
											obj_t BgL_arg3442z00_1085;

											BgL_arg3442z00_1085 = CAR(BgL_stackz00_39);
											BgL_testz00_3735 =
												BGl_iszd2azf3z21zz__objectz00(BgL_arg3442z00_1085,
												BGl_variablez00zzast_varz00);
										}
									else
										{	/* Trace/walk.scm 238 */
											BgL_testz00_3735 = ((bool_t) 0);
										}
									if (BgL_testz00_3735)
										{	/* Trace/walk.scm 239 */
											obj_t BgL_arg3435z00_1078;

											obj_t BgL_arg3436z00_1079;

											BgL_arg3435z00_1078 = CNST_TABLE_REF(((long) 6));
											{	/* Trace/walk.scm 239 */
												BgL_variablez00_bglt BgL_obj1419z00_1955;

												{	/* Trace/walk.scm 239 */
													obj_t BgL_pairz00_1954;

													BgL_pairz00_1954 = BgL_stackz00_39;
													BgL_obj1419z00_1955 =
														(BgL_variablez00_bglt) (CAR(BgL_pairz00_1954));
												}
												BgL_arg3436z00_1079 =
													(((BgL_variablez00_bglt) CREF(BgL_obj1419z00_1955))->
													BgL_idz00);
											}
											{	/* Trace/walk.scm 239 */
												obj_t BgL_list3437z00_1080;

												{	/* Trace/walk.scm 239 */
													obj_t BgL_arg3438z00_1081;

													{	/* Trace/walk.scm 239 */
														obj_t BgL_arg3439z00_1082;

														BgL_arg3439z00_1082 =
															MAKE_PAIR(BgL_arg3436z00_1079, BNIL);
														BgL_arg3438z00_1081 =
															MAKE_PAIR(BgL_arg3435z00_1078,
															BgL_arg3439z00_1082);
													}
													BgL_list3437z00_1080 =
														MAKE_PAIR(BgL_symbolz00_37, BgL_arg3438z00_1081);
												}
												BgL_szb2zb2_1016 =
													BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
													(BgL_list3437z00_1080);
										}}
									else
										{	/* Trace/walk.scm 238 */
											BgL_szb2zb2_1016 = BgL_symbolz00_37;
										}
								}
								{	/* Trace/walk.scm 238 */
									obj_t BgL_szb2zb2z00_1017;

									{	/* Trace/walk.scm 241 */
										bool_t BgL_testz00_3748;

										{	/* Trace/walk.scm 241 */
											bool_t BgL_testz00_3749;

											if (STRUCTP(BgL_locz00_1012))
												{	/* Trace/walk.scm 241 */
													BgL_testz00_3749 =
														(STRUCT_KEY(BgL_locz00_1012) ==
														CNST_TABLE_REF(((long) 7)));
												}
											else
												{	/* Trace/walk.scm 241 */
													BgL_testz00_3749 = ((bool_t) 0);
												}
											if (BgL_testz00_3749)
												{	/* Trace/walk.scm 241 */
													if (CBOOL
														(BGl_za2bmemzd2profilingza2zd2zzengine_paramz00))
														{	/* Trace/walk.scm 241 */
															BgL_testz00_3748 = ((bool_t) 0);
														}
													else
														{	/* Trace/walk.scm 241 */
															BgL_testz00_3748 = ((bool_t) 1);
														}
												}
											else
												{	/* Trace/walk.scm 241 */
													BgL_testz00_3748 = ((bool_t) 0);
												}
										}
										if (BgL_testz00_3748)
											{	/* Trace/walk.scm 245 */
												obj_t BgL_slocz00_1064;

												{	/* Trace/walk.scm 245 */
													obj_t BgL_arg3429z00_1072;

													obj_t BgL_arg3430z00_1073;

													BgL_arg3429z00_1072 =
														STRUCT_REF(BgL_locz00_1012, (int) (((long) 0)));
													BgL_arg3430z00_1073 =
														STRUCT_REF(BgL_locz00_1012, (int) (((long) 2)));
													{	/* Trace/walk.scm 245 */
														obj_t BgL_list3431z00_1074;

														{	/* Trace/walk.scm 245 */
															obj_t BgL_arg3432z00_1075;

															BgL_arg3432z00_1075 =
																MAKE_PAIR(BgL_arg3430z00_1073, BNIL);
															BgL_list3431z00_1074 =
																MAKE_PAIR(BgL_arg3429z00_1072,
																BgL_arg3432z00_1075);
														}
														BgL_slocz00_1064 =
															BGl_formatz00zz__r4_output_6_10_3z00
															(BGl_string3785z00zztrace_walkz00,
															BgL_list3431z00_1074);
												}}
												{	/* Trace/walk.scm 248 */
													obj_t BgL_arg3421z00_1065;

													{	/* Trace/walk.scm 248 */
														obj_t BgL_arg3423z00_1066;

														obj_t BgL_arg3424z00_1067;

														BgL_arg3423z00_1066 =
															SYMBOL_TO_STRING(BgL_szb2zb2_1016);
														{	/* Trace/walk.scm 248 */
															obj_t BgL_arg3427z00_1070;

															{	/* Trace/walk.scm 248 */
																obj_t BgL_stringz00_1970;

																BgL_stringz00_1970 = BgL_slocz00_1064;
																BgL_arg3427z00_1070 =
																	string_to_symbol(BSTRING_TO_STRING
																	(BgL_stringz00_1970));
															}
															BgL_arg3424z00_1067 =
																SYMBOL_TO_STRING(BgL_arg3427z00_1070);
														}
														{	/* Trace/walk.scm 248 */
															obj_t BgL_list3425z00_1068;

															{	/* Trace/walk.scm 248 */
																obj_t BgL_arg3426z00_1069;

																BgL_arg3426z00_1069 =
																	MAKE_PAIR(BgL_arg3424z00_1067, BNIL);
																BgL_list3425z00_1068 =
																	MAKE_PAIR(BgL_arg3423z00_1066,
																	BgL_arg3426z00_1069);
															}
															BgL_arg3421z00_1065 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list3425z00_1068);
													}}
													BgL_szb2zb2z00_1017 =
														string_to_symbol(BSTRING_TO_STRING
														(BgL_arg3421z00_1065));
											}}
										else
											{	/* Trace/walk.scm 241 */
												BgL_szb2zb2z00_1017 = BgL_szb2zb2_1016;
											}
									}
									{	/* Trace/walk.scm 241 */
										obj_t BgL_expz00_1018;

										{	/* Trace/walk.scm 250 */
											obj_t BgL_arg3378z00_1022;

											obj_t BgL_arg3379z00_1023;

											BgL_arg3378z00_1022 = CNST_TABLE_REF(((long) 8));
											{	/* Trace/walk.scm 250 */
												obj_t BgL_arg3380z00_1024;

												obj_t BgL_arg3381z00_1025;

												{	/* Trace/walk.scm 250 */
													obj_t BgL_arg3385z00_1029;

													{	/* Trace/walk.scm 250 */
														obj_t BgL_arg3387z00_1031;

														{	/* Trace/walk.scm 250 */
															obj_t BgL_arg3388z00_1032;

															{	/* Trace/walk.scm 250 */
																obj_t BgL_arg3391z00_1035;

																obj_t BgL_arg3393z00_1036;

																BgL_arg3391z00_1035 =
																	CNST_TABLE_REF(((long) 9));
																{	/* Trace/walk.scm 250 */
																	obj_t BgL_list3394z00_1037;

																	BgL_list3394z00_1037 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg3393z00_1036 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_szb2zb2z00_1017, BgL_list3394z00_1037);
																}
																BgL_arg3388z00_1032 =
																	MAKE_PAIR(BgL_arg3391z00_1035,
																	BgL_arg3393z00_1036);
															}
															{	/* Trace/walk.scm 250 */
																obj_t BgL_list3390z00_1034;

																BgL_list3390z00_1034 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg3387z00_1031 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_arg3388z00_1032, BgL_list3390z00_1034);
														}}
														BgL_arg3385z00_1029 =
															MAKE_PAIR(BgL_symz00_1015, BgL_arg3387z00_1031);
													}
													BgL_arg3380z00_1024 =
														MAKE_PAIR(BgL_arg3385z00_1029, BNIL);
												}
												{	/* Trace/walk.scm 251 */
													obj_t BgL_arg3395z00_1038;

													obj_t BgL_arg3396z00_1039;

													BgL_arg3395z00_1038 = CNST_TABLE_REF(((long) 8));
													{	/* Trace/walk.scm 251 */
														obj_t BgL_arg3398z00_1041;

														obj_t BgL_arg3399z00_1042;

														{	/* Trace/walk.scm 252 */
															obj_t BgL_arg3404z00_1047;

															obj_t BgL_arg3405z00_1048;

															BgL_arg3404z00_1047 = CNST_TABLE_REF(((long) 10));
															{	/* Trace/walk.scm 252 */
																obj_t BgL_list3406z00_1049;

																BgL_list3406z00_1049 = MAKE_PAIR(BNIL, BNIL);
																BgL_arg3405z00_1048 =
																	BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																	(BgL_symz00_1015, BgL_list3406z00_1049);
															}
															BgL_arg3398z00_1041 =
																MAKE_PAIR(BgL_arg3404z00_1047,
																BgL_arg3405z00_1048);
														}
														{	/* Trace/walk.scm 253 */
															obj_t BgL_arg3407z00_1050;

															obj_t BgL_arg3408z00_1051;

															BgL_arg3407z00_1050 = CNST_TABLE_REF(((long) 8));
															{	/* Trace/walk.scm 253 */
																obj_t BgL_arg3409z00_1052;

																obj_t BgL_arg3410z00_1053;

																{	/* Trace/walk.scm 253 */
																	obj_t BgL_arg3415z00_1058;

																	{	/* Trace/walk.scm 253 */
																		obj_t BgL_arg3417z00_1060;

																		{	/* Trace/walk.scm 253 */
																			obj_t BgL_list3418z00_1061;

																			BgL_list3418z00_1061 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3417z00_1060 =
																				BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																				((obj_t) (BgL_nodez00_35),
																				BgL_list3418z00_1061);
																		}
																		BgL_arg3415z00_1058 =
																			MAKE_PAIR(BgL_tauxz00_1014,
																			BgL_arg3417z00_1060);
																	}
																	BgL_arg3409z00_1052 =
																		MAKE_PAIR(BgL_arg3415z00_1058, BNIL);
																}
																{	/* Trace/walk.scm 254 */
																	bool_t BgL_testz00_3793;

																	if (STRUCTP(BgL_llocz00_38))
																		{	/* Trace/walk.scm 254 */
																			BgL_testz00_3793 =
																				(STRUCT_KEY(BgL_llocz00_38) ==
																				CNST_TABLE_REF(((long) 7)));
																		}
																	else
																		{	/* Trace/walk.scm 254 */
																			BgL_testz00_3793 = ((bool_t) 0);
																		}
																	if (BgL_testz00_3793)
																		{	/* Trace/walk.scm 255 */
																			obj_t BgL_res3662z00_1983;

																			{	/* Trace/walk.scm 255 */
																				obj_t BgL_obj1z00_1980;

																				BgL_obj1z00_1980 =
																					CNST_TABLE_REF(((long) 11));
																				BgL_res3662z00_1983 =
																					MAKE_EXTENDED_PAIR(BgL_obj1z00_1980,
																					BNIL, BgL_llocz00_38);
																			}
																			BgL_arg3410z00_1053 = BgL_res3662z00_1983;
																		}
																	else
																		{	/* Trace/walk.scm 254 */
																			BgL_arg3410z00_1053 =
																				CNST_TABLE_REF(((long) 12));
																}}
																{	/* Trace/walk.scm 253 */
																	obj_t BgL_list3412z00_1055;

																	{	/* Trace/walk.scm 253 */
																		obj_t BgL_arg3413z00_1056;

																		{	/* Trace/walk.scm 253 */
																			obj_t BgL_arg3414z00_1057;

																			BgL_arg3414z00_1057 =
																				MAKE_PAIR(BNIL, BNIL);
																			BgL_arg3413z00_1056 =
																				MAKE_PAIR(BgL_auxz00_1013,
																				BgL_arg3414z00_1057);
																		}
																		BgL_list3412z00_1055 =
																			MAKE_PAIR(BgL_arg3410z00_1053,
																			BgL_arg3413z00_1056);
																	}
																	BgL_arg3408z00_1051 =
																		BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																		(BgL_arg3409z00_1052, BgL_list3412z00_1055);
															}}
															BgL_arg3399z00_1042 =
																MAKE_PAIR(BgL_arg3407z00_1050,
																BgL_arg3408z00_1051);
														}
														{	/* Trace/walk.scm 251 */
															obj_t BgL_list3401z00_1044;

															{	/* Trace/walk.scm 251 */
																obj_t BgL_arg3402z00_1045;

																{	/* Trace/walk.scm 251 */
																	obj_t BgL_arg3403z00_1046;

																	BgL_arg3403z00_1046 = MAKE_PAIR(BNIL, BNIL);
																	BgL_arg3402z00_1045 =
																		MAKE_PAIR(BgL_arg3399z00_1042,
																		BgL_arg3403z00_1046);
																}
																BgL_list3401z00_1044 =
																	MAKE_PAIR(BgL_arg3398z00_1041,
																	BgL_arg3402z00_1045);
															}
															BgL_arg3396z00_1039 =
																BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
																(BNIL, BgL_list3401z00_1044);
													}}
													BgL_arg3381z00_1025 =
														MAKE_PAIR(BgL_arg3395z00_1038, BgL_arg3396z00_1039);
												}
												{	/* Trace/walk.scm 250 */
													obj_t BgL_list3383z00_1027;

													{	/* Trace/walk.scm 250 */
														obj_t BgL_arg3384z00_1028;

														BgL_arg3384z00_1028 = MAKE_PAIR(BNIL, BNIL);
														BgL_list3383z00_1027 =
															MAKE_PAIR(BgL_arg3381z00_1025,
															BgL_arg3384z00_1028);
													}
													BgL_arg3379z00_1023 =
														BGl_consza2za2zz__r4_pairs_and_lists_6_3z00
														(BgL_arg3380z00_1024, BgL_list3383z00_1027);
											}}
											BgL_expz00_1018 =
												MAKE_PAIR(BgL_arg3378z00_1022, BgL_arg3379z00_1023);
										}
										{	/* Trace/walk.scm 250 */
											BgL_nodez00_bglt BgL_nodez00_1019;

											BgL_nodez00_1019 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_1018,
												BNIL, BgL_locz00_1012, CNST_TABLE_REF(((long) 13)));
											{	/* Trace/walk.scm 258 */

												{	/* Trace/walk.scm 259 */
													bool_t BgL_arg3376z00_1020;

													{	/* Trace/walk.scm 259 */
														obj_t BgL_arg3377z00_1021;

														BgL_arg3377z00_1021 =
															BGl_thezd2backendzd2zzbackend_backendz00();
														{
															BgL_backendz00_bglt BgL_auxz00_3819;

															BgL_auxz00_3819 =
																(BgL_backendz00_bglt) (BgL_arg3377z00_1021);
															BgL_arg3376z00_1020 =
																(((BgL_backendz00_bglt) CREF(BgL_auxz00_3819))->
																BgL_removezd2emptyzd2letz00);
													}}
													{
														BgL_letzd2varzd2_bglt BgL_auxz00_3822;

														BgL_auxz00_3822 =
															(BgL_letzd2varzd2_bglt) (BgL_nodez00_1019);
														((((BgL_letzd2varzd2_bglt) CREF(BgL_auxz00_3822))->
																BgL_removablezf3zf3) =
															((bool_t) BgL_arg3376z00_1020), BUNSPEC);
												}}
												return (BgL_letzd2varzd2_bglt) (BgL_nodez00_1019);
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* trace-node*! */
	obj_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t BgL_nodeza2za2_78,
		obj_t BgL_stackz00_79)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 414 */
		BGl_tracezd2nodeza2z12z62zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_78))
				{	/* Trace/walk.scm 415 */
					return CNST_TABLE_REF(((long) 14));
				}
			else
				{	/* Trace/walk.scm 415 */
					{	/* Trace/walk.scm 418 */
						BgL_nodez00_bglt BgL_arg3447z00_1090;

						{	/* Trace/walk.scm 418 */
							obj_t BgL_arg3448z00_1091;

							BgL_arg3448z00_1091 = CAR(BgL_nodeza2za2_78);
							{	/* Trace/walk.scm 418 */
								BgL_nodez00_bglt BgL_res3665z00_2016;

								{	/* Trace/walk.scm 418 */
									BgL_nodez00_bglt BgL_nodez00_1989;

									BgL_nodez00_1989 = (BgL_nodez00_bglt) (BgL_arg3448z00_1091);
									{	/* Trace/walk.scm 418 */
										obj_t BgL_method3250z00_1991;

										{	/* Trace/walk.scm 418 */
											BgL_objectz00_bglt BgL_objz00_1992;

											BgL_objz00_1992 = (BgL_objectz00_bglt) (BgL_nodez00_1989);
											{	/* Trace/walk.scm 418 */
												long BgL_objzd2classzd2numz00_1993;

												BgL_objzd2classzd2numz00_1993 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_1992);
												{	/* Trace/walk.scm 418 */
													obj_t BgL_arg2334z00_1994;

													BgL_arg2334z00_1994 =
														PROCEDURE_REF
														(BGl_tracezd2nodezd2envz00zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 418 */
														obj_t BgL_arrayz00_1996;

														int BgL_offsetz00_1997;

														BgL_arrayz00_1996 = BgL_arg2334z00_1994;
														BgL_offsetz00_1997 =
															(int) (BgL_objzd2classzd2numz00_1993);
														{	/* Trace/walk.scm 418 */
															long BgL_offsetz00_1998;

															BgL_offsetz00_1998 =
																((long) (BgL_offsetz00_1997) - OBJECT_TYPE);
															{	/* Trace/walk.scm 418 */
																long BgL_modz00_1999;

																{	/* Trace/walk.scm 418 */
																	int BgL_arg2336z00_2000;

																	BgL_arg2336z00_2000 = (int) (((long) 8));
																	{	/* Trace/walk.scm 418 */
																		long BgL_auxz00_3839;

																		BgL_auxz00_3839 =
																			(long) (BgL_arg2336z00_2000);
																		BgL_modz00_1999 =
																			(BgL_offsetz00_1998 / BgL_auxz00_3839);
																}}
																{	/* Trace/walk.scm 418 */
																	long BgL_restz00_2001;

																	{	/* Trace/walk.scm 418 */
																		int BgL_arg2335z00_2002;

																		BgL_arg2335z00_2002 = (int) (((long) 8));
																		{	/* Trace/walk.scm 418 */
																			long BgL_auxz00_3843;

																			BgL_auxz00_3843 =
																				(long) (BgL_arg2335z00_2002);
																			BgL_restz00_2001 =
																				(BgL_offsetz00_1998 % BgL_auxz00_3843);
																	}}
																	{	/* Trace/walk.scm 418 */

																		BgL_method3250z00_1991 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_1996,
																				(int) (BgL_modz00_1999)),
																			(int) (BgL_restz00_2001));
										}}}}}}}}
										BgL_res3665z00_2016 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3250z00_1991) (BgL_method3250z00_1991,
												(obj_t) (BgL_nodez00_1989), BgL_stackz00_79, BEOA));
								}}
								BgL_arg3447z00_1090 = BgL_res3665z00_2016;
						}}
						{	/* Trace/walk.scm 418 */
							obj_t BgL_auxz00_3854;

							BgL_auxz00_3854 = (obj_t) (BgL_arg3447z00_1090);
							SET_CAR(BgL_nodeza2za2_78, BgL_auxz00_3854);
					}}
					{
						obj_t BgL_nodeza2za2_3857;

						BgL_nodeza2za2_3857 = CDR(BgL_nodeza2za2_78);
						BgL_nodeza2za2_78 = BgL_nodeza2za2_3857;
						goto BGl_tracezd2nodeza2z12z62zztrace_walkz00;
					}
				}
		}
	}



/* toplevel-trace-node*! */
	obj_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t
		BgL_nodeza2za2_84)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 459 */
		BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_84))
				{	/* Trace/walk.scm 460 */
					return CNST_TABLE_REF(((long) 14));
				}
			else
				{	/* Trace/walk.scm 460 */
					{	/* Trace/walk.scm 463 */
						BgL_nodez00_bglt BgL_arg3451z00_1094;

						{	/* Trace/walk.scm 463 */
							obj_t BgL_arg3452z00_1095;

							BgL_arg3452z00_1095 = CAR(BgL_nodeza2za2_84);
							{	/* Trace/walk.scm 463 */
								BgL_nodez00_bglt BgL_res3668z00_2048;

								{	/* Trace/walk.scm 463 */
									BgL_nodez00_bglt BgL_nodez00_2022;

									BgL_nodez00_2022 = (BgL_nodez00_bglt) (BgL_arg3452z00_1095);
									{	/* Trace/walk.scm 463 */
										obj_t BgL_method3286z00_2023;

										{	/* Trace/walk.scm 463 */
											BgL_objectz00_bglt BgL_objz00_2024;

											BgL_objz00_2024 = (BgL_objectz00_bglt) (BgL_nodez00_2022);
											{	/* Trace/walk.scm 463 */
												long BgL_objzd2classzd2numz00_2025;

												BgL_objzd2classzd2numz00_2025 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_2024);
												{	/* Trace/walk.scm 463 */
													obj_t BgL_arg2334z00_2026;

													BgL_arg2334z00_2026 =
														PROCEDURE_REF
														(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 463 */
														obj_t BgL_arrayz00_2028;

														int BgL_offsetz00_2029;

														BgL_arrayz00_2028 = BgL_arg2334z00_2026;
														BgL_offsetz00_2029 =
															(int) (BgL_objzd2classzd2numz00_2025);
														{	/* Trace/walk.scm 463 */
															long BgL_offsetz00_2030;

															BgL_offsetz00_2030 =
																((long) (BgL_offsetz00_2029) - OBJECT_TYPE);
															{	/* Trace/walk.scm 463 */
																long BgL_modz00_2031;

																{	/* Trace/walk.scm 463 */
																	int BgL_arg2336z00_2032;

																	BgL_arg2336z00_2032 = (int) (((long) 8));
																	{	/* Trace/walk.scm 463 */
																		long BgL_auxz00_3872;

																		BgL_auxz00_3872 =
																			(long) (BgL_arg2336z00_2032);
																		BgL_modz00_2031 =
																			(BgL_offsetz00_2030 / BgL_auxz00_3872);
																}}
																{	/* Trace/walk.scm 463 */
																	long BgL_restz00_2033;

																	{	/* Trace/walk.scm 463 */
																		int BgL_arg2335z00_2034;

																		BgL_arg2335z00_2034 = (int) (((long) 8));
																		{	/* Trace/walk.scm 463 */
																			long BgL_auxz00_3876;

																			BgL_auxz00_3876 =
																				(long) (BgL_arg2335z00_2034);
																			BgL_restz00_2033 =
																				(BgL_offsetz00_2030 % BgL_auxz00_3876);
																	}}
																	{	/* Trace/walk.scm 463 */

																		BgL_method3286z00_2023 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_2028,
																				(int) (BgL_modz00_2031)),
																			(int) (BgL_restz00_2033));
										}}}}}}}}
										BgL_res3668z00_2048 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3286z00_2023) (BgL_method3286z00_2023,
												(obj_t) (BgL_nodez00_2022), BEOA));
								}}
								BgL_arg3451z00_1094 = BgL_res3668z00_2048;
						}}
						{	/* Trace/walk.scm 463 */
							obj_t BgL_auxz00_3887;

							BgL_auxz00_3887 = (obj_t) (BgL_arg3451z00_1094);
							SET_CAR(BgL_nodeza2za2_84, BgL_auxz00_3887);
					}}
					{
						obj_t BgL_nodeza2za2_3890;

						BgL_nodeza2za2_3890 = CDR(BgL_nodeza2za2_84);
						BgL_nodeza2za2_84 = BgL_nodeza2za2_3890;
						goto BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00;
					}
				}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_findzd2lastzd2nodezd2defau3220zd2envz00zztrace_walkz00);
			BGl_addzd2genericz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_tracezd2nodezd2default3249zd2envzd2zztrace_walkz00);
			return
				BGl_addzd2genericz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_toplevelzd2tracezd2nodezd23285zd2envz00zztrace_walkz00);
		}
	}



/* find-last-node */
	obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_20)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 134 */
			{	/* Trace/walk.scm 134 */
				obj_t BgL_method3221z00_2052;

				{	/* Trace/walk.scm 134 */
					BgL_objectz00_bglt BgL_objz00_2053;

					BgL_objz00_2053 = (BgL_objectz00_bglt) (BgL_nodez00_20);
					{	/* Trace/walk.scm 134 */
						long BgL_objzd2classzd2numz00_2054;

						BgL_objzd2classzd2numz00_2054 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2053);
						{	/* Trace/walk.scm 134 */
							obj_t BgL_arg2334z00_2055;

							BgL_arg2334z00_2055 =
								PROCEDURE_REF(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 134 */
								obj_t BgL_arrayz00_2057;

								int BgL_offsetz00_2058;

								BgL_arrayz00_2057 = BgL_arg2334z00_2055;
								BgL_offsetz00_2058 = (int) (BgL_objzd2classzd2numz00_2054);
								{	/* Trace/walk.scm 134 */
									long BgL_offsetz00_2059;

									BgL_offsetz00_2059 =
										((long) (BgL_offsetz00_2058) - OBJECT_TYPE);
									{	/* Trace/walk.scm 134 */
										long BgL_modz00_2060;

										{	/* Trace/walk.scm 134 */
											int BgL_arg2336z00_2061;

											BgL_arg2336z00_2061 = (int) (((long) 8));
											{	/* Trace/walk.scm 134 */
												long BgL_auxz00_3903;

												BgL_auxz00_3903 = (long) (BgL_arg2336z00_2061);
												BgL_modz00_2060 =
													(BgL_offsetz00_2059 / BgL_auxz00_3903);
										}}
										{	/* Trace/walk.scm 134 */
											long BgL_restz00_2062;

											{	/* Trace/walk.scm 134 */
												int BgL_arg2335z00_2063;

												BgL_arg2335z00_2063 = (int) (((long) 8));
												{	/* Trace/walk.scm 134 */
													long BgL_auxz00_3907;

													BgL_auxz00_3907 = (long) (BgL_arg2335z00_2063);
													BgL_restz00_2062 =
														(BgL_offsetz00_2059 % BgL_auxz00_3907);
											}}
											{	/* Trace/walk.scm 134 */

												BgL_method3221z00_2052 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2057,
														(int) (BgL_modz00_2060)), (int) (BgL_restz00_2062));
				}}}}}}}}
				return
					PROCEDURE_ENTRY(BgL_method3221z00_2052) (BgL_method3221z00_2052,
					(obj_t) (BgL_nodez00_20), BEOA);
			}
		}
	}



/* _find-last-node3773 */
	obj_t BGl__findzd2lastzd2node3773z00zztrace_walkz00(obj_t BgL_envz00_3293,
		obj_t BgL_nodez00_3294)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 134 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				(BgL_nodez00_bglt) (BgL_nodez00_3294));
		}
	}



/* _find-last-node-defau3220 */
	obj_t BGl__findzd2lastzd2nodezd2defau3220zd2zztrace_walkz00(obj_t
		BgL_envz00_3298, obj_t BgL_nodez00_3299)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_3299));
		}
	}



/* trace-node */
	BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_40, obj_t BgL_stackz00_41)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 265 */
			{	/* Trace/walk.scm 265 */
				obj_t BgL_method3250z00_2077;

				{	/* Trace/walk.scm 265 */
					BgL_objectz00_bglt BgL_objz00_2078;

					BgL_objz00_2078 = (BgL_objectz00_bglt) (BgL_nodez00_40);
					{	/* Trace/walk.scm 265 */
						long BgL_objzd2classzd2numz00_2079;

						BgL_objzd2classzd2numz00_2079 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2078);
						{	/* Trace/walk.scm 265 */
							obj_t BgL_arg2334z00_2080;

							BgL_arg2334z00_2080 =
								PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 265 */
								obj_t BgL_arrayz00_2082;

								int BgL_offsetz00_2083;

								BgL_arrayz00_2082 = BgL_arg2334z00_2080;
								BgL_offsetz00_2083 = (int) (BgL_objzd2classzd2numz00_2079);
								{	/* Trace/walk.scm 265 */
									long BgL_offsetz00_2084;

									BgL_offsetz00_2084 =
										((long) (BgL_offsetz00_2083) - OBJECT_TYPE);
									{	/* Trace/walk.scm 265 */
										long BgL_modz00_2085;

										{	/* Trace/walk.scm 265 */
											int BgL_arg2336z00_2086;

											BgL_arg2336z00_2086 = (int) (((long) 8));
											{	/* Trace/walk.scm 265 */
												long BgL_auxz00_3929;

												BgL_auxz00_3929 = (long) (BgL_arg2336z00_2086);
												BgL_modz00_2085 =
													(BgL_offsetz00_2084 / BgL_auxz00_3929);
										}}
										{	/* Trace/walk.scm 265 */
											long BgL_restz00_2087;

											{	/* Trace/walk.scm 265 */
												int BgL_arg2335z00_2088;

												BgL_arg2335z00_2088 = (int) (((long) 8));
												{	/* Trace/walk.scm 265 */
													long BgL_auxz00_3933;

													BgL_auxz00_3933 = (long) (BgL_arg2335z00_2088);
													BgL_restz00_2087 =
														(BgL_offsetz00_2084 % BgL_auxz00_3933);
											}}
											{	/* Trace/walk.scm 265 */

												BgL_method3250z00_2077 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2082,
														(int) (BgL_modz00_2085)), (int) (BgL_restz00_2087));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2077)
					(BgL_method3250z00_2077, (obj_t) (BgL_nodez00_40), BgL_stackz00_41,
						BEOA));
			}
		}
	}



/* _trace-node3774 */
	obj_t BGl__tracezd2node3774zd2zztrace_walkz00(obj_t BgL_envz00_3295,
		obj_t BgL_nodez00_3296, obj_t BgL_stackz00_3297)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 265 */
			return
				(obj_t) (BGl_tracezd2nodezd2zztrace_walkz00(
					(BgL_nodez00_bglt) (BgL_nodez00_3296), BgL_stackz00_3297));
		}
	}



/* _trace-node-default3249 */
	obj_t BGl__tracezd2nodezd2default3249z00zztrace_walkz00(obj_t BgL_envz00_3300,
		obj_t BgL_nodez00_3301, obj_t BgL_stackz00_3302)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_3301));
		}
	}



/* toplevel-trace-node */
	BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_80)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 424 */
			{	/* Trace/walk.scm 424 */
				obj_t BgL_method3286z00_2102;

				{	/* Trace/walk.scm 424 */
					BgL_objectz00_bglt BgL_objz00_2103;

					BgL_objz00_2103 = (BgL_objectz00_bglt) (BgL_nodez00_80);
					{	/* Trace/walk.scm 424 */
						long BgL_objzd2classzd2numz00_2104;

						BgL_objzd2classzd2numz00_2104 =
							BGL_OBJECT_CLASS_NUM(BgL_objz00_2103);
						{	/* Trace/walk.scm 424 */
							obj_t BgL_arg2334z00_2105;

							BgL_arg2334z00_2105 =
								PROCEDURE_REF
								(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 424 */
								obj_t BgL_arrayz00_2107;

								int BgL_offsetz00_2108;

								BgL_arrayz00_2107 = BgL_arg2334z00_2105;
								BgL_offsetz00_2108 = (int) (BgL_objzd2classzd2numz00_2104);
								{	/* Trace/walk.scm 424 */
									long BgL_offsetz00_2109;

									BgL_offsetz00_2109 =
										((long) (BgL_offsetz00_2108) - OBJECT_TYPE);
									{	/* Trace/walk.scm 424 */
										long BgL_modz00_2110;

										{	/* Trace/walk.scm 424 */
											int BgL_arg2336z00_2111;

											BgL_arg2336z00_2111 = (int) (((long) 8));
											{	/* Trace/walk.scm 424 */
												long BgL_auxz00_3957;

												BgL_auxz00_3957 = (long) (BgL_arg2336z00_2111);
												BgL_modz00_2110 =
													(BgL_offsetz00_2109 / BgL_auxz00_3957);
										}}
										{	/* Trace/walk.scm 424 */
											long BgL_restz00_2112;

											{	/* Trace/walk.scm 424 */
												int BgL_arg2335z00_2113;

												BgL_arg2335z00_2113 = (int) (((long) 8));
												{	/* Trace/walk.scm 424 */
													long BgL_auxz00_3961;

													BgL_auxz00_3961 = (long) (BgL_arg2335z00_2113);
													BgL_restz00_2112 =
														(BgL_offsetz00_2109 % BgL_auxz00_3961);
											}}
											{	/* Trace/walk.scm 424 */

												BgL_method3286z00_2102 =
													VECTOR_REF(VECTOR_REF(BgL_arrayz00_2107,
														(int) (BgL_modz00_2110)), (int) (BgL_restz00_2112));
				}}}}}}}}
				return
					(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3286z00_2102)
					(BgL_method3286z00_2102, (obj_t) (BgL_nodez00_80), BEOA));
			}
		}
	}



/* _toplevel-trace-node3772 */
	obj_t BGl__toplevelzd2tracezd2node3772z00zztrace_walkz00(obj_t
		BgL_envz00_3291, obj_t BgL_nodez00_3292)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 424 */
			return
				(obj_t) (BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
					(BgL_nodez00_bglt) (BgL_nodez00_3292)));
		}
	}



/* _toplevel-trace-node-3285 */
	obj_t BGl__toplevelzd2tracezd2nodezd23285zd2zztrace_walkz00(obj_t
		BgL_envz00_3303, obj_t BgL_nodez00_3304)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return (obj_t) ((BgL_nodez00_bglt) (BgL_nodez00_3304));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3786z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc3787z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc3788z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc3789z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc3790z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc3791z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3792z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc3793z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_selectz00zzast_nodez00, BGl_proc3794z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3795z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3796z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3797z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3798z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3799z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3800z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3801z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3802z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3803z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3804z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3805z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc3806z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3807z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3808z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc3809z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc3810z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc3811z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc3812z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc3813z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc3814z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc3815z00zztrace_walkz00);
			BGl_addzd2methodz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc3816z00zztrace_walkz00);
			return
				BGl_addzd2methodz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc3817z00zztrace_walkz00);
		}
	}



/* toplevel-trace-node-3290 */
	obj_t BGl_toplevelzd2tracezd2nodezd23290zd2zztrace_walkz00(obj_t
		BgL_envz00_3337, obj_t BgL_nodez00_3338)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 442 */
			{
				BgL_setqz00_bglt BgL_nodez00_1767;

				{	/* Trace/walk.scm 443 */
					BgL_setqz00_bglt BgL_auxz00_4009;

					BgL_nodez00_1767 = (BgL_setqz00_bglt) (BgL_nodez00_3338);
					{	/* Trace/walk.scm 444 */
						BgL_varz00_bglt BgL_instance3205z00_1771;

						BgL_instance3205z00_1771 =
							(((BgL_setqz00_bglt) CREF(BgL_nodez00_1767))->BgL_varz00);
						{	/* Trace/walk.scm 445 */
							bool_t BgL_testz00_4011;

							{	/* Trace/walk.scm 445 */
								bool_t BgL_testz00_4012;

								{	/* Trace/walk.scm 445 */
									BgL_variablez00_bglt BgL_arg3645z00_1790;

									BgL_arg3645z00_1790 =
										(((BgL_varz00_bglt) CREF(BgL_instance3205z00_1771))->
										BgL_variablez00);
									{	/* Trace/walk.scm 445 */
										obj_t BgL_obj1568z00_3272;

										BgL_obj1568z00_3272 = (obj_t) (BgL_arg3645z00_1790);
										BgL_testz00_4012 =
											BGl_iszd2azf3z21zz__objectz00(BgL_obj1568z00_3272,
											BGl_globalz00zzast_varz00);
									}
								}
								if (BgL_testz00_4012)
									{	/* Trace/walk.scm 446 */
										bool_t BgL_testz00_4016;

										{	/* Trace/walk.scm 446 */
											bool_t BgL_testz00_4017;

											{	/* Trace/walk.scm 446 */
												BgL_nodez00_bglt BgL_arg3644z00_1789;

												BgL_arg3644z00_1789 =
													(((BgL_setqz00_bglt) CREF(BgL_nodez00_1767))->
													BgL_valuez00);
												{	/* Trace/walk.scm 446 */
													obj_t BgL_obj1966z00_3274;

													BgL_obj1966z00_3274 = (obj_t) (BgL_arg3644z00_1789);
													BgL_testz00_4017 =
														BGl_iszd2azf3z21zz__objectz00(BgL_obj1966z00_3274,
														BGl_atomz00zzast_nodez00);
												}
											}
											if (BgL_testz00_4017)
												{	/* Trace/walk.scm 446 */
													BgL_testz00_4016 = ((bool_t) 1);
												}
											else
												{	/* Trace/walk.scm 447 */
													bool_t BgL_testz00_4021;

													{	/* Trace/walk.scm 447 */
														BgL_nodez00_bglt BgL_arg3643z00_1788;

														BgL_arg3643z00_1788 =
															(((BgL_setqz00_bglt) CREF(BgL_nodez00_1767))->
															BgL_valuez00);
														{	/* Trace/walk.scm 447 */
															obj_t BgL_obj1987z00_3276;

															BgL_obj1987z00_3276 =
																(obj_t) (BgL_arg3643z00_1788);
															BgL_testz00_4021 =
																BGl_iszd2azf3z21zz__objectz00
																(BgL_obj1987z00_3276, BGl_varz00zzast_nodez00);
														}
													}
													if (BgL_testz00_4021)
														{	/* Trace/walk.scm 447 */
															BgL_testz00_4016 = ((bool_t) 1);
														}
													else
														{	/* Trace/walk.scm 448 */
															bool_t BgL_testz00_4025;

															{	/* Trace/walk.scm 448 */
																BgL_nodez00_bglt BgL_arg3642z00_1787;

																BgL_arg3642z00_1787 =
																	(((BgL_setqz00_bglt) CREF(BgL_nodez00_1767))->
																	BgL_valuez00);
																{	/* Trace/walk.scm 448 */
																	obj_t BgL_obj2025z00_3278;

																	BgL_obj2025z00_3278 =
																		(obj_t) (BgL_arg3642z00_1787);
																	BgL_testz00_4025 =
																		BGl_iszd2azf3z21zz__objectz00
																		(BgL_obj2025z00_3278,
																		BGl_kwotez00zzast_nodez00);
																}
															}
															if (BgL_testz00_4025)
																{	/* Trace/walk.scm 448 */
																	BgL_testz00_4016 = ((bool_t) 1);
																}
															else
																{	/* Trace/walk.scm 449 */
																	BgL_nodez00_bglt BgL_arg3641z00_1786;

																	BgL_arg3641z00_1786 =
																		(((BgL_setqz00_bglt)
																			CREF(BgL_nodez00_1767))->BgL_valuez00);
																	{	/* Trace/walk.scm 449 */
																		obj_t BgL_obj2241z00_3280;

																		BgL_obj2241z00_3280 =
																			(obj_t) (BgL_arg3641z00_1786);
																		BgL_testz00_4016 =
																			BGl_iszd2azf3z21zz__objectz00
																			(BgL_obj2241z00_3280,
																			BGl_pragmaz00zzast_nodez00);
																	}
																}
														}
												}
										}
										if (BgL_testz00_4016)
											{	/* Trace/walk.scm 446 */
												BgL_testz00_4011 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 446 */
												BgL_testz00_4011 = ((bool_t) 1);
											}
									}
								else
									{	/* Trace/walk.scm 445 */
										BgL_testz00_4011 = ((bool_t) 0);
									}
							}
							if (BgL_testz00_4011)
								{	/* Trace/walk.scm 450 */
									obj_t BgL_idz00_1773;

									{	/* Trace/walk.scm 450 */
										BgL_variablez00_bglt BgL_obj1419z00_3282;

										BgL_obj1419z00_3282 =
											(((BgL_varz00_bglt) CREF(BgL_instance3205z00_1771))->
											BgL_variablez00);
										BgL_idz00_1773 =
											(((BgL_variablez00_bglt) CREF(BgL_obj1419z00_3282))->
											BgL_idz00);
									}
									{	/* Trace/walk.scm 450 */
										BgL_typez00_bglt BgL_typez00_1774;

										{	/* Trace/walk.scm 451 */
											BgL_variablez00_bglt BgL_obj1423z00_3284;

											BgL_obj1423z00_3284 =
												(((BgL_varz00_bglt) CREF(BgL_instance3205z00_1771))->
												BgL_variablez00);
											BgL_typez00_1774 =
												(((BgL_variablez00_bglt) CREF(BgL_obj1423z00_3284))->
												BgL_typez00);
										}
										{	/* Trace/walk.scm 451 */
											BgL_letzd2varzd2_bglt BgL_tracez00_1775;

											{	/* Trace/walk.scm 452 */
												BgL_nodez00_bglt BgL_arg3630z00_1776;

												obj_t BgL_arg3631z00_1777;

												BgL_arg3630z00_1776 =
													(((BgL_setqz00_bglt) CREF(BgL_nodez00_1767))->
													BgL_valuez00);
												{
													BgL_nodez00_bglt BgL_auxz00_4037;

													BgL_auxz00_4037 =
														(BgL_nodez00_bglt) (BgL_nodez00_1767);
													BgL_arg3631z00_1777 =
														(((BgL_nodez00_bglt) CREF(BgL_auxz00_4037))->
														BgL_locz00);
												}
												BgL_tracez00_1775 =
													BGl_makezd2tracedzd2nodez00zztrace_walkz00
													(BgL_arg3630z00_1776, BgL_typez00_1774,
													BgL_idz00_1773, BgL_arg3631z00_1777, BNIL);
											}
											{	/* Trace/walk.scm 452 */

												{
													BgL_nodez00_bglt BgL_auxz00_4041;

													BgL_auxz00_4041 =
														(BgL_nodez00_bglt) (BgL_tracez00_1775);
													((((BgL_setqz00_bglt) CREF(BgL_nodez00_1767))->
															BgL_valuez00) =
														((BgL_nodez00_bglt) BgL_auxz00_4041), BUNSPEC);
												}
											}
										}
									}
								}
							else
								{	/* Trace/walk.scm 445 */
									BFALSE;
								}
						}
					}
					BgL_auxz00_4009 = BgL_nodez00_1767;
					return (obj_t) (BgL_auxz00_4009);
				}
			}
		}
	}



/* toplevel-trace-node-3288 */
	obj_t BGl_toplevelzd2tracezd2nodezd23288zd2zztrace_walkz00(obj_t
		BgL_envz00_3339, obj_t BgL_nodez00_3340)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 430 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1761;

				{	/* Trace/walk.scm 431 */
					BgL_sequencez00_bglt BgL_auxz00_4046;

					BgL_nodez00_1761 = (BgL_sequencez00_bglt) (BgL_nodez00_3340);
					{	/* Trace/walk.scm 431 */
						obj_t BgL_arg3627z00_3268;

						BgL_arg3627z00_3268 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1761))->BgL_nodesz00);
						BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00
							(BgL_arg3627z00_3268);
					}
					BgL_auxz00_4046 = BgL_nodez00_1761;
					return (obj_t) (BgL_auxz00_4046);
				}
			}
		}
	}



/* trace-node-box-set!3284 */
	obj_t BGl_tracezd2nodezd2boxzd2setz123284zc0zztrace_walkz00(obj_t
		BgL_envz00_3341, obj_t BgL_nodez00_3342, obj_t BgL_stackz00_3343)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 405 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1750;

				obj_t BgL_stackz00_1751;

				{	/* Trace/walk.scm 406 */
					BgL_boxzd2setz12zc0_bglt BgL_auxz00_4051;

					BgL_nodez00_1750 = (BgL_boxzd2setz12zc0_bglt) (BgL_nodez00_3342);
					BgL_stackz00_1751 = BgL_stackz00_3343;
					{	/* Trace/walk.scm 407 */
						BgL_nodez00_bglt BgL_arg3622z00_1755;

						{	/* Trace/walk.scm 407 */
							BgL_varz00_bglt BgL_arg3623z00_1756;

							BgL_arg3623z00_1756 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1750))->
								BgL_varz00);
							{	/* Trace/walk.scm 407 */
								BgL_nodez00_bglt BgL_res3768z00_3234;

								{	/* Trace/walk.scm 407 */
									BgL_nodez00_bglt BgL_nodez00_3207;

									BgL_nodez00_3207 = (BgL_nodez00_bglt) (BgL_arg3623z00_1756);
									{	/* Trace/walk.scm 407 */
										obj_t BgL_method3250z00_3209;

										{	/* Trace/walk.scm 407 */
											BgL_objectz00_bglt BgL_objz00_3210;

											BgL_objz00_3210 = (BgL_objectz00_bglt) (BgL_nodez00_3207);
											{	/* Trace/walk.scm 407 */
												long BgL_objzd2classzd2numz00_3211;

												BgL_objzd2classzd2numz00_3211 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3210);
												{	/* Trace/walk.scm 407 */
													obj_t BgL_arg2334z00_3212;

													BgL_arg2334z00_3212 =
														PROCEDURE_REF
														(BGl_tracezd2nodezd2envz00zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 407 */
														obj_t BgL_arrayz00_3214;

														int BgL_offsetz00_3215;

														BgL_arrayz00_3214 = BgL_arg2334z00_3212;
														BgL_offsetz00_3215 =
															(int) (BgL_objzd2classzd2numz00_3211);
														{	/* Trace/walk.scm 407 */
															long BgL_offsetz00_3216;

															BgL_offsetz00_3216 =
																((long) (BgL_offsetz00_3215) - OBJECT_TYPE);
															{	/* Trace/walk.scm 407 */
																long BgL_modz00_3217;

																{	/* Trace/walk.scm 407 */
																	int BgL_arg2336z00_3218;

																	BgL_arg2336z00_3218 = (int) (((long) 8));
																	{	/* Trace/walk.scm 407 */
																		long BgL_auxz00_4062;

																		BgL_auxz00_4062 =
																			(long) (BgL_arg2336z00_3218);
																		BgL_modz00_3217 =
																			(BgL_offsetz00_3216 / BgL_auxz00_4062);
																}}
																{	/* Trace/walk.scm 407 */
																	long BgL_restz00_3219;

																	{	/* Trace/walk.scm 407 */
																		int BgL_arg2335z00_3220;

																		BgL_arg2335z00_3220 = (int) (((long) 8));
																		{	/* Trace/walk.scm 407 */
																			long BgL_auxz00_4066;

																			BgL_auxz00_4066 =
																				(long) (BgL_arg2335z00_3220);
																			BgL_restz00_3219 =
																				(BgL_offsetz00_3216 % BgL_auxz00_4066);
																	}}
																	{	/* Trace/walk.scm 407 */

																		BgL_method3250z00_3209 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3214,
																				(int) (BgL_modz00_3217)),
																			(int) (BgL_restz00_3219));
										}}}}}}}}
										BgL_res3768z00_3234 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3250z00_3209) (BgL_method3250z00_3209,
												(obj_t) (BgL_nodez00_3207), BgL_stackz00_1751, BEOA));
								}}
								BgL_arg3622z00_1755 = BgL_res3768z00_3234;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_4077;

							BgL_auxz00_4077 = (BgL_varz00_bglt) (BgL_arg3622z00_1755);
							((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1750))->
									BgL_varz00) = ((BgL_varz00_bglt) BgL_auxz00_4077), BUNSPEC);
					}}
					{	/* Trace/walk.scm 408 */
						BgL_nodez00_bglt BgL_arg3624z00_1757;

						{	/* Trace/walk.scm 408 */
							BgL_nodez00_bglt BgL_arg3625z00_1758;

							BgL_arg3625z00_1758 =
								(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1750))->
								BgL_valuez00);
							{	/* Trace/walk.scm 408 */
								BgL_nodez00_bglt BgL_res3771z00_3265;

								{	/* Trace/walk.scm 408 */
									obj_t BgL_method3250z00_3240;

									{	/* Trace/walk.scm 408 */
										BgL_objectz00_bglt BgL_objz00_3241;

										BgL_objz00_3241 =
											(BgL_objectz00_bglt) (BgL_arg3625z00_1758);
										{	/* Trace/walk.scm 408 */
											long BgL_objzd2classzd2numz00_3242;

											BgL_objzd2classzd2numz00_3242 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3241);
											{	/* Trace/walk.scm 408 */
												obj_t BgL_arg2334z00_3243;

												BgL_arg2334z00_3243 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 408 */
													obj_t BgL_arrayz00_3245;

													int BgL_offsetz00_3246;

													BgL_arrayz00_3245 = BgL_arg2334z00_3243;
													BgL_offsetz00_3246 =
														(int) (BgL_objzd2classzd2numz00_3242);
													{	/* Trace/walk.scm 408 */
														long BgL_offsetz00_3247;

														BgL_offsetz00_3247 =
															((long) (BgL_offsetz00_3246) - OBJECT_TYPE);
														{	/* Trace/walk.scm 408 */
															long BgL_modz00_3248;

															{	/* Trace/walk.scm 408 */
																int BgL_arg2336z00_3249;

																BgL_arg2336z00_3249 = (int) (((long) 8));
																{	/* Trace/walk.scm 408 */
																	long BgL_auxz00_4089;

																	BgL_auxz00_4089 =
																		(long) (BgL_arg2336z00_3249);
																	BgL_modz00_3248 =
																		(BgL_offsetz00_3247 / BgL_auxz00_4089);
															}}
															{	/* Trace/walk.scm 408 */
																long BgL_restz00_3250;

																{	/* Trace/walk.scm 408 */
																	int BgL_arg2335z00_3251;

																	BgL_arg2335z00_3251 = (int) (((long) 8));
																	{	/* Trace/walk.scm 408 */
																		long BgL_auxz00_4093;

																		BgL_auxz00_4093 =
																			(long) (BgL_arg2335z00_3251);
																		BgL_restz00_3250 =
																			(BgL_offsetz00_3247 % BgL_auxz00_4093);
																}}
																{	/* Trace/walk.scm 408 */

																	BgL_method3250z00_3240 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3245,
																			(int) (BgL_modz00_3248)),
																		(int) (BgL_restz00_3250));
									}}}}}}}}
									BgL_res3771z00_3265 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_3240)
										(BgL_method3250z00_3240, (obj_t) (BgL_arg3625z00_1758),
											BgL_stackz00_1751, BEOA));
								}
								BgL_arg3624z00_1757 = BgL_res3771z00_3265;
						}}
						((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1750))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3624z00_1757), BUNSPEC);
					}
					BgL_auxz00_4051 = BgL_nodez00_1750;
					return (obj_t) (BgL_auxz00_4051);
				}
			}
		}
	}



/* trace-node-box-ref3282 */
	obj_t BGl_tracezd2nodezd2boxzd2ref3282zd2zztrace_walkz00(obj_t
		BgL_envz00_3344, obj_t BgL_nodez00_3345, obj_t BgL_stackz00_3346)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 398 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1742;

				obj_t BgL_stackz00_1743;

				{	/* Trace/walk.scm 399 */
					BgL_boxzd2refzd2_bglt BgL_auxz00_4107;

					BgL_nodez00_1742 = (BgL_boxzd2refzd2_bglt) (BgL_nodez00_3345);
					BgL_stackz00_1743 = BgL_stackz00_3346;
					{	/* Trace/walk.scm 399 */
						BgL_nodez00_bglt BgL_arg3619z00_3173;

						{	/* Trace/walk.scm 399 */
							BgL_varz00_bglt BgL_arg3620z00_3174;

							BgL_arg3620z00_3174 =
								(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1742))->BgL_varz00);
							{	/* Trace/walk.scm 399 */
								BgL_nodez00_bglt BgL_res3765z00_3203;

								{	/* Trace/walk.scm 399 */
									BgL_nodez00_bglt BgL_nodez00_3176;

									BgL_nodez00_3176 = (BgL_nodez00_bglt) (BgL_arg3620z00_3174);
									{	/* Trace/walk.scm 399 */
										obj_t BgL_method3250z00_3178;

										{	/* Trace/walk.scm 399 */
											BgL_objectz00_bglt BgL_objz00_3179;

											BgL_objz00_3179 = (BgL_objectz00_bglt) (BgL_nodez00_3176);
											{	/* Trace/walk.scm 399 */
												long BgL_objzd2classzd2numz00_3180;

												BgL_objzd2classzd2numz00_3180 =
													BGL_OBJECT_CLASS_NUM(BgL_objz00_3179);
												{	/* Trace/walk.scm 399 */
													obj_t BgL_arg2334z00_3181;

													BgL_arg2334z00_3181 =
														PROCEDURE_REF
														(BGl_tracezd2nodezd2envz00zztrace_walkz00,
														(int) (((long) 1)));
													{	/* Trace/walk.scm 399 */
														obj_t BgL_arrayz00_3183;

														int BgL_offsetz00_3184;

														BgL_arrayz00_3183 = BgL_arg2334z00_3181;
														BgL_offsetz00_3184 =
															(int) (BgL_objzd2classzd2numz00_3180);
														{	/* Trace/walk.scm 399 */
															long BgL_offsetz00_3185;

															BgL_offsetz00_3185 =
																((long) (BgL_offsetz00_3184) - OBJECT_TYPE);
															{	/* Trace/walk.scm 399 */
																long BgL_modz00_3186;

																{	/* Trace/walk.scm 399 */
																	int BgL_arg2336z00_3187;

																	BgL_arg2336z00_3187 = (int) (((long) 8));
																	{	/* Trace/walk.scm 399 */
																		long BgL_auxz00_4118;

																		BgL_auxz00_4118 =
																			(long) (BgL_arg2336z00_3187);
																		BgL_modz00_3186 =
																			(BgL_offsetz00_3185 / BgL_auxz00_4118);
																}}
																{	/* Trace/walk.scm 399 */
																	long BgL_restz00_3188;

																	{	/* Trace/walk.scm 399 */
																		int BgL_arg2335z00_3189;

																		BgL_arg2335z00_3189 = (int) (((long) 8));
																		{	/* Trace/walk.scm 399 */
																			long BgL_auxz00_4122;

																			BgL_auxz00_4122 =
																				(long) (BgL_arg2335z00_3189);
																			BgL_restz00_3188 =
																				(BgL_offsetz00_3185 % BgL_auxz00_4122);
																	}}
																	{	/* Trace/walk.scm 399 */

																		BgL_method3250z00_3178 =
																			VECTOR_REF(VECTOR_REF(BgL_arrayz00_3183,
																				(int) (BgL_modz00_3186)),
																			(int) (BgL_restz00_3188));
										}}}}}}}}
										BgL_res3765z00_3203 =
											(BgL_nodez00_bglt) (PROCEDURE_ENTRY
											(BgL_method3250z00_3178) (BgL_method3250z00_3178,
												(obj_t) (BgL_nodez00_3176), BgL_stackz00_1743, BEOA));
								}}
								BgL_arg3619z00_3173 = BgL_res3765z00_3203;
						}}
						{
							BgL_varz00_bglt BgL_auxz00_4133;

							BgL_auxz00_4133 = (BgL_varz00_bglt) (BgL_arg3619z00_3173);
							((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1742))->BgL_varz00) =
								((BgL_varz00_bglt) BgL_auxz00_4133), BUNSPEC);
					}}
					BgL_auxz00_4107 = BgL_nodez00_1742;
					return (obj_t) (BgL_auxz00_4107);
				}
			}
		}
	}



/* trace-node-make-box3280 */
	obj_t BGl_tracezd2nodezd2makezd2box3280zd2zztrace_walkz00(obj_t
		BgL_envz00_3347, obj_t BgL_nodez00_3348, obj_t BgL_stackz00_3349)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 391 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1734;

				obj_t BgL_stackz00_1735;

				{	/* Trace/walk.scm 392 */
					BgL_makezd2boxzd2_bglt BgL_auxz00_4138;

					BgL_nodez00_1734 = (BgL_makezd2boxzd2_bglt) (BgL_nodez00_3348);
					BgL_stackz00_1735 = BgL_stackz00_3349;
					{	/* Trace/walk.scm 392 */
						BgL_nodez00_bglt BgL_arg3616z00_3140;

						{	/* Trace/walk.scm 392 */
							BgL_nodez00_bglt BgL_arg3617z00_3141;

							BgL_arg3617z00_3141 =
								(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1734))->
								BgL_valuez00);
							{	/* Trace/walk.scm 392 */
								BgL_nodez00_bglt BgL_res3762z00_3170;

								{	/* Trace/walk.scm 392 */
									obj_t BgL_method3250z00_3145;

									{	/* Trace/walk.scm 392 */
										BgL_objectz00_bglt BgL_objz00_3146;

										BgL_objz00_3146 =
											(BgL_objectz00_bglt) (BgL_arg3617z00_3141);
										{	/* Trace/walk.scm 392 */
											long BgL_objzd2classzd2numz00_3147;

											BgL_objzd2classzd2numz00_3147 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3146);
											{	/* Trace/walk.scm 392 */
												obj_t BgL_arg2334z00_3148;

												BgL_arg2334z00_3148 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 392 */
													obj_t BgL_arrayz00_3150;

													int BgL_offsetz00_3151;

													BgL_arrayz00_3150 = BgL_arg2334z00_3148;
													BgL_offsetz00_3151 =
														(int) (BgL_objzd2classzd2numz00_3147);
													{	/* Trace/walk.scm 392 */
														long BgL_offsetz00_3152;

														BgL_offsetz00_3152 =
															((long) (BgL_offsetz00_3151) - OBJECT_TYPE);
														{	/* Trace/walk.scm 392 */
															long BgL_modz00_3153;

															{	/* Trace/walk.scm 392 */
																int BgL_arg2336z00_3154;

																BgL_arg2336z00_3154 = (int) (((long) 8));
																{	/* Trace/walk.scm 392 */
																	long BgL_auxz00_4148;

																	BgL_auxz00_4148 =
																		(long) (BgL_arg2336z00_3154);
																	BgL_modz00_3153 =
																		(BgL_offsetz00_3152 / BgL_auxz00_4148);
															}}
															{	/* Trace/walk.scm 392 */
																long BgL_restz00_3155;

																{	/* Trace/walk.scm 392 */
																	int BgL_arg2335z00_3156;

																	BgL_arg2335z00_3156 = (int) (((long) 8));
																	{	/* Trace/walk.scm 392 */
																		long BgL_auxz00_4152;

																		BgL_auxz00_4152 =
																			(long) (BgL_arg2335z00_3156);
																		BgL_restz00_3155 =
																			(BgL_offsetz00_3152 % BgL_auxz00_4152);
																}}
																{	/* Trace/walk.scm 392 */

																	BgL_method3250z00_3145 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3150,
																			(int) (BgL_modz00_3153)),
																		(int) (BgL_restz00_3155));
									}}}}}}}}
									BgL_res3762z00_3170 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_3145)
										(BgL_method3250z00_3145, (obj_t) (BgL_arg3617z00_3141),
											BgL_stackz00_1735, BEOA));
								}
								BgL_arg3616z00_3140 = BgL_res3762z00_3170;
						}}
						((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1734))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3616z00_3140), BUNSPEC);
					}
					BgL_auxz00_4138 = BgL_nodez00_1734;
					return (obj_t) (BgL_auxz00_4138);
				}
			}
		}
	}



/* trace-node-jump-ex-i3278 */
	obj_t BGl_tracezd2nodezd2jumpzd2exzd2i3278z00zztrace_walkz00(obj_t
		BgL_envz00_3350, obj_t BgL_nodez00_3351, obj_t BgL_stackz00_3352)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 382 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1723;

				obj_t BgL_stackz00_1724;

				{	/* Trace/walk.scm 383 */
					BgL_jumpzd2exzd2itz00_bglt BgL_auxz00_4166;

					BgL_nodez00_1723 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3351);
					BgL_stackz00_1724 = BgL_stackz00_3352;
					{	/* Trace/walk.scm 384 */
						BgL_nodez00_bglt BgL_arg3611z00_1728;

						{	/* Trace/walk.scm 384 */
							BgL_nodez00_bglt BgL_arg3612z00_1729;

							BgL_arg3612z00_1729 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1723))->
								BgL_exitz00);
							{	/* Trace/walk.scm 384 */
								BgL_nodez00_bglt BgL_res3756z00_3106;

								{	/* Trace/walk.scm 384 */
									obj_t BgL_method3250z00_3081;

									{	/* Trace/walk.scm 384 */
										BgL_objectz00_bglt BgL_objz00_3082;

										BgL_objz00_3082 =
											(BgL_objectz00_bglt) (BgL_arg3612z00_1729);
										{	/* Trace/walk.scm 384 */
											long BgL_objzd2classzd2numz00_3083;

											BgL_objzd2classzd2numz00_3083 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3082);
											{	/* Trace/walk.scm 384 */
												obj_t BgL_arg2334z00_3084;

												BgL_arg2334z00_3084 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 384 */
													obj_t BgL_arrayz00_3086;

													int BgL_offsetz00_3087;

													BgL_arrayz00_3086 = BgL_arg2334z00_3084;
													BgL_offsetz00_3087 =
														(int) (BgL_objzd2classzd2numz00_3083);
													{	/* Trace/walk.scm 384 */
														long BgL_offsetz00_3088;

														BgL_offsetz00_3088 =
															((long) (BgL_offsetz00_3087) - OBJECT_TYPE);
														{	/* Trace/walk.scm 384 */
															long BgL_modz00_3089;

															{	/* Trace/walk.scm 384 */
																int BgL_arg2336z00_3090;

																BgL_arg2336z00_3090 = (int) (((long) 8));
																{	/* Trace/walk.scm 384 */
																	long BgL_auxz00_4176;

																	BgL_auxz00_4176 =
																		(long) (BgL_arg2336z00_3090);
																	BgL_modz00_3089 =
																		(BgL_offsetz00_3088 / BgL_auxz00_4176);
															}}
															{	/* Trace/walk.scm 384 */
																long BgL_restz00_3091;

																{	/* Trace/walk.scm 384 */
																	int BgL_arg2335z00_3092;

																	BgL_arg2335z00_3092 = (int) (((long) 8));
																	{	/* Trace/walk.scm 384 */
																		long BgL_auxz00_4180;

																		BgL_auxz00_4180 =
																			(long) (BgL_arg2335z00_3092);
																		BgL_restz00_3091 =
																			(BgL_offsetz00_3088 % BgL_auxz00_4180);
																}}
																{	/* Trace/walk.scm 384 */

																	BgL_method3250z00_3081 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3086,
																			(int) (BgL_modz00_3089)),
																		(int) (BgL_restz00_3091));
									}}}}}}}}
									BgL_res3756z00_3106 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_3081)
										(BgL_method3250z00_3081, (obj_t) (BgL_arg3612z00_1729),
											BgL_stackz00_1724, BEOA));
								}
								BgL_arg3611z00_1728 = BgL_res3756z00_3106;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1723))->
								BgL_exitz00) =
							((BgL_nodez00_bglt) BgL_arg3611z00_1728), BUNSPEC);
					}
					{	/* Trace/walk.scm 385 */
						BgL_nodez00_bglt BgL_arg3613z00_1730;

						{	/* Trace/walk.scm 385 */
							BgL_nodez00_bglt BgL_arg3614z00_1731;

							BgL_arg3614z00_1731 =
								(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1723))->
								BgL_valuez00);
							{	/* Trace/walk.scm 385 */
								BgL_nodez00_bglt BgL_res3759z00_3137;

								{	/* Trace/walk.scm 385 */
									obj_t BgL_method3250z00_3112;

									{	/* Trace/walk.scm 385 */
										BgL_objectz00_bglt BgL_objz00_3113;

										BgL_objz00_3113 =
											(BgL_objectz00_bglt) (BgL_arg3614z00_1731);
										{	/* Trace/walk.scm 385 */
											long BgL_objzd2classzd2numz00_3114;

											BgL_objzd2classzd2numz00_3114 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3113);
											{	/* Trace/walk.scm 385 */
												obj_t BgL_arg2334z00_3115;

												BgL_arg2334z00_3115 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 385 */
													obj_t BgL_arrayz00_3117;

													int BgL_offsetz00_3118;

													BgL_arrayz00_3117 = BgL_arg2334z00_3115;
													BgL_offsetz00_3118 =
														(int) (BgL_objzd2classzd2numz00_3114);
													{	/* Trace/walk.scm 385 */
														long BgL_offsetz00_3119;

														BgL_offsetz00_3119 =
															((long) (BgL_offsetz00_3118) - OBJECT_TYPE);
														{	/* Trace/walk.scm 385 */
															long BgL_modz00_3120;

															{	/* Trace/walk.scm 385 */
																int BgL_arg2336z00_3121;

																BgL_arg2336z00_3121 = (int) (((long) 8));
																{	/* Trace/walk.scm 385 */
																	long BgL_auxz00_4201;

																	BgL_auxz00_4201 =
																		(long) (BgL_arg2336z00_3121);
																	BgL_modz00_3120 =
																		(BgL_offsetz00_3119 / BgL_auxz00_4201);
															}}
															{	/* Trace/walk.scm 385 */
																long BgL_restz00_3122;

																{	/* Trace/walk.scm 385 */
																	int BgL_arg2335z00_3123;

																	BgL_arg2335z00_3123 = (int) (((long) 8));
																	{	/* Trace/walk.scm 385 */
																		long BgL_auxz00_4205;

																		BgL_auxz00_4205 =
																			(long) (BgL_arg2335z00_3123);
																		BgL_restz00_3122 =
																			(BgL_offsetz00_3119 % BgL_auxz00_4205);
																}}
																{	/* Trace/walk.scm 385 */

																	BgL_method3250z00_3112 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3117,
																			(int) (BgL_modz00_3120)),
																		(int) (BgL_restz00_3122));
									}}}}}}}}
									BgL_res3759z00_3137 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_3112)
										(BgL_method3250z00_3112, (obj_t) (BgL_arg3614z00_1731),
											BgL_stackz00_1724, BEOA));
								}
								BgL_arg3613z00_1730 = BgL_res3759z00_3137;
						}}
						((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1723))->
								BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3613z00_1730), BUNSPEC);
					}
					BgL_auxz00_4166 = BgL_nodez00_1723;
					return (obj_t) (BgL_auxz00_4166);
				}
			}
		}
	}



/* trace-node-set-ex-it3276 */
	obj_t BGl_tracezd2nodezd2setzd2exzd2it3276z00zztrace_walkz00(obj_t
		BgL_envz00_3353, obj_t BgL_nodez00_3354, obj_t BgL_stackz00_3355)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 375 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1715;

				obj_t BgL_stackz00_1716;

				{	/* Trace/walk.scm 376 */
					BgL_setzd2exzd2itz00_bglt BgL_auxz00_4219;

					BgL_nodez00_1715 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3354);
					BgL_stackz00_1716 = BgL_stackz00_3355;
					{	/* Trace/walk.scm 376 */
						BgL_nodez00_bglt BgL_arg3608z00_3045;

						{	/* Trace/walk.scm 376 */
							BgL_nodez00_bglt BgL_arg3609z00_3046;

							BgL_arg3609z00_3046 =
								(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1715))->
								BgL_bodyz00);
							{	/* Trace/walk.scm 376 */
								BgL_nodez00_bglt BgL_res3753z00_3075;

								{	/* Trace/walk.scm 376 */
									obj_t BgL_method3250z00_3050;

									{	/* Trace/walk.scm 376 */
										BgL_objectz00_bglt BgL_objz00_3051;

										BgL_objz00_3051 =
											(BgL_objectz00_bglt) (BgL_arg3609z00_3046);
										{	/* Trace/walk.scm 376 */
											long BgL_objzd2classzd2numz00_3052;

											BgL_objzd2classzd2numz00_3052 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3051);
											{	/* Trace/walk.scm 376 */
												obj_t BgL_arg2334z00_3053;

												BgL_arg2334z00_3053 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 376 */
													obj_t BgL_arrayz00_3055;

													int BgL_offsetz00_3056;

													BgL_arrayz00_3055 = BgL_arg2334z00_3053;
													BgL_offsetz00_3056 =
														(int) (BgL_objzd2classzd2numz00_3052);
													{	/* Trace/walk.scm 376 */
														long BgL_offsetz00_3057;

														BgL_offsetz00_3057 =
															((long) (BgL_offsetz00_3056) - OBJECT_TYPE);
														{	/* Trace/walk.scm 376 */
															long BgL_modz00_3058;

															{	/* Trace/walk.scm 376 */
																int BgL_arg2336z00_3059;

																BgL_arg2336z00_3059 = (int) (((long) 8));
																{	/* Trace/walk.scm 376 */
																	long BgL_auxz00_4229;

																	BgL_auxz00_4229 =
																		(long) (BgL_arg2336z00_3059);
																	BgL_modz00_3058 =
																		(BgL_offsetz00_3057 / BgL_auxz00_4229);
															}}
															{	/* Trace/walk.scm 376 */
																long BgL_restz00_3060;

																{	/* Trace/walk.scm 376 */
																	int BgL_arg2335z00_3061;

																	BgL_arg2335z00_3061 = (int) (((long) 8));
																	{	/* Trace/walk.scm 376 */
																		long BgL_auxz00_4233;

																		BgL_auxz00_4233 =
																			(long) (BgL_arg2335z00_3061);
																		BgL_restz00_3060 =
																			(BgL_offsetz00_3057 % BgL_auxz00_4233);
																}}
																{	/* Trace/walk.scm 376 */

																	BgL_method3250z00_3050 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3055,
																			(int) (BgL_modz00_3058)),
																		(int) (BgL_restz00_3060));
									}}}}}}}}
									BgL_res3753z00_3075 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_3050)
										(BgL_method3250z00_3050, (obj_t) (BgL_arg3609z00_3046),
											BgL_stackz00_1716, BEOA));
								}
								BgL_arg3608z00_3045 = BgL_res3753z00_3075;
						}}
						((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1715))->
								BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3608z00_3045), BUNSPEC);
					}
					BgL_auxz00_4219 = BgL_nodez00_1715;
					return (obj_t) (BgL_auxz00_4219);
				}
			}
		}
	}



/* trace-node-let-var3274 */
	obj_t BGl_tracezd2nodezd2letzd2var3274zd2zztrace_walkz00(obj_t
		BgL_envz00_3356, obj_t BgL_nodez00_3357, obj_t BgL_stackz00_3358)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 364 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1698;

				obj_t BgL_stackz00_1699;

				{	/* Trace/walk.scm 365 */
					BgL_letzd2varzd2_bglt BgL_auxz00_4247;

					BgL_nodez00_1698 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3357);
					BgL_stackz00_1699 = BgL_stackz00_3358;
					{	/* Trace/walk.scm 366 */
						obj_t BgL_g3219z00_1703;

						BgL_g3219z00_1703 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1698))->
							BgL_bindingsz00);
						{
							obj_t BgL_l3217z00_1704;

							BgL_l3217z00_1704 = BgL_g3219z00_1703;
						BgL_forzd2each3218zd2_1705:
							if (PAIRP(BgL_l3217z00_1704))
								{	/* Trace/walk.scm 366 */
									{	/* Trace/walk.scm 367 */
										obj_t BgL_bindingz00_1707;

										BgL_bindingz00_1707 = CAR(BgL_l3217z00_1704);
										{	/* Trace/walk.scm 367 */
											BgL_nodez00_bglt BgL_arg3602z00_1708;

											{	/* Trace/walk.scm 367 */
												obj_t BgL_arg3603z00_1709;

												BgL_arg3603z00_1709 = CDR(BgL_bindingz00_1707);
												{	/* Trace/walk.scm 367 */
													BgL_nodez00_bglt BgL_res3747z00_3010;

													{	/* Trace/walk.scm 367 */
														BgL_nodez00_bglt BgL_nodez00_2983;

														BgL_nodez00_2983 =
															(BgL_nodez00_bglt) (BgL_arg3603z00_1709);
														{	/* Trace/walk.scm 367 */
															obj_t BgL_method3250z00_2985;

															{	/* Trace/walk.scm 367 */
																BgL_objectz00_bglt BgL_objz00_2986;

																BgL_objz00_2986 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2983);
																{	/* Trace/walk.scm 367 */
																	long BgL_objzd2classzd2numz00_2987;

																	BgL_objzd2classzd2numz00_2987 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2986);
																	{	/* Trace/walk.scm 367 */
																		obj_t BgL_arg2334z00_2988;

																		BgL_arg2334z00_2988 =
																			PROCEDURE_REF
																			(BGl_tracezd2nodezd2envz00zztrace_walkz00,
																			(int) (((long) 1)));
																		{	/* Trace/walk.scm 367 */
																			obj_t BgL_arrayz00_2990;

																			int BgL_offsetz00_2991;

																			BgL_arrayz00_2990 = BgL_arg2334z00_2988;
																			BgL_offsetz00_2991 =
																				(int) (BgL_objzd2classzd2numz00_2987);
																			{	/* Trace/walk.scm 367 */
																				long BgL_offsetz00_2992;

																				BgL_offsetz00_2992 =
																					(
																					(long) (BgL_offsetz00_2991) -
																					OBJECT_TYPE);
																				{	/* Trace/walk.scm 367 */
																					long BgL_modz00_2993;

																					{	/* Trace/walk.scm 367 */
																						int BgL_arg2336z00_2994;

																						BgL_arg2336z00_2994 =
																							(int) (((long) 8));
																						{	/* Trace/walk.scm 367 */
																							long BgL_auxz00_4262;

																							BgL_auxz00_4262 =
																								(long) (BgL_arg2336z00_2994);
																							BgL_modz00_2993 =
																								(BgL_offsetz00_2992 /
																								BgL_auxz00_4262);
																					}}
																					{	/* Trace/walk.scm 367 */
																						long BgL_restz00_2995;

																						{	/* Trace/walk.scm 367 */
																							int BgL_arg2335z00_2996;

																							BgL_arg2335z00_2996 =
																								(int) (((long) 8));
																							{	/* Trace/walk.scm 367 */
																								long BgL_auxz00_4266;

																								BgL_auxz00_4266 =
																									(long) (BgL_arg2335z00_2996);
																								BgL_restz00_2995 =
																									(BgL_offsetz00_2992 %
																									BgL_auxz00_4266);
																						}}
																						{	/* Trace/walk.scm 367 */

																							BgL_method3250z00_2985 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2990,
																									(int) (BgL_modz00_2993)),
																								(int) (BgL_restz00_2995));
															}}}}}}}}
															BgL_res3747z00_3010 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3250z00_2985)
																(BgL_method3250z00_2985,
																	(obj_t) (BgL_nodez00_2983), BgL_stackz00_1699,
																	BEOA));
													}}
													BgL_arg3602z00_1708 = BgL_res3747z00_3010;
											}}
											{	/* Trace/walk.scm 367 */
												obj_t BgL_auxz00_4277;

												BgL_auxz00_4277 = (obj_t) (BgL_arg3602z00_1708);
												SET_CDR(BgL_bindingz00_1707, BgL_auxz00_4277);
									}}}
									{
										obj_t BgL_l3217z00_4280;

										BgL_l3217z00_4280 = CDR(BgL_l3217z00_1704);
										BgL_l3217z00_1704 = BgL_l3217z00_4280;
										goto BgL_forzd2each3218zd2_1705;
									}
								}
							else
								{	/* Trace/walk.scm 366 */
									((bool_t) 1);
								}
						}
					}
					{	/* Trace/walk.scm 369 */
						BgL_nodez00_bglt BgL_arg3605z00_1711;

						{	/* Trace/walk.scm 369 */
							BgL_nodez00_bglt BgL_arg3606z00_1712;

							BgL_arg3606z00_1712 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1698))->BgL_bodyz00);
							{	/* Trace/walk.scm 369 */
								BgL_nodez00_bglt BgL_res3750z00_3042;

								{	/* Trace/walk.scm 369 */
									obj_t BgL_method3250z00_3017;

									{	/* Trace/walk.scm 369 */
										BgL_objectz00_bglt BgL_objz00_3018;

										BgL_objz00_3018 =
											(BgL_objectz00_bglt) (BgL_arg3606z00_1712);
										{	/* Trace/walk.scm 369 */
											long BgL_objzd2classzd2numz00_3019;

											BgL_objzd2classzd2numz00_3019 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_3018);
											{	/* Trace/walk.scm 369 */
												obj_t BgL_arg2334z00_3020;

												BgL_arg2334z00_3020 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 369 */
													obj_t BgL_arrayz00_3022;

													int BgL_offsetz00_3023;

													BgL_arrayz00_3022 = BgL_arg2334z00_3020;
													BgL_offsetz00_3023 =
														(int) (BgL_objzd2classzd2numz00_3019);
													{	/* Trace/walk.scm 369 */
														long BgL_offsetz00_3024;

														BgL_offsetz00_3024 =
															((long) (BgL_offsetz00_3023) - OBJECT_TYPE);
														{	/* Trace/walk.scm 369 */
															long BgL_modz00_3025;

															{	/* Trace/walk.scm 369 */
																int BgL_arg2336z00_3026;

																BgL_arg2336z00_3026 = (int) (((long) 8));
																{	/* Trace/walk.scm 369 */
																	long BgL_auxz00_4291;

																	BgL_auxz00_4291 =
																		(long) (BgL_arg2336z00_3026);
																	BgL_modz00_3025 =
																		(BgL_offsetz00_3024 / BgL_auxz00_4291);
															}}
															{	/* Trace/walk.scm 369 */
																long BgL_restz00_3027;

																{	/* Trace/walk.scm 369 */
																	int BgL_arg2335z00_3028;

																	BgL_arg2335z00_3028 = (int) (((long) 8));
																	{	/* Trace/walk.scm 369 */
																		long BgL_auxz00_4295;

																		BgL_auxz00_4295 =
																			(long) (BgL_arg2335z00_3028);
																		BgL_restz00_3027 =
																			(BgL_offsetz00_3024 % BgL_auxz00_4295);
																}}
																{	/* Trace/walk.scm 369 */

																	BgL_method3250z00_3017 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_3022,
																			(int) (BgL_modz00_3025)),
																		(int) (BgL_restz00_3027));
									}}}}}}}}
									BgL_res3750z00_3042 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_3017)
										(BgL_method3250z00_3017, (obj_t) (BgL_arg3606z00_1712),
											BgL_stackz00_1699, BEOA));
								}
								BgL_arg3605z00_1711 = BgL_res3750z00_3042;
						}}
						((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1698))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3605z00_1711), BUNSPEC);
					}
					BgL_auxz00_4247 = BgL_nodez00_1698;
					return (obj_t) (BgL_auxz00_4247);
				}
			}
		}
	}



/* trace-node-let-fun3272 */
	obj_t BGl_tracezd2nodezd2letzd2fun3272zd2zztrace_walkz00(obj_t
		BgL_envz00_3359, obj_t BgL_nodez00_3360, obj_t BgL_stackz00_3361)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 355 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1683;

				obj_t BgL_stackz00_1684;

				{	/* Trace/walk.scm 356 */
					BgL_letzd2funzd2_bglt BgL_auxz00_4309;

					BgL_nodez00_1683 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3360);
					BgL_stackz00_1684 = BgL_stackz00_3361;
					{	/* Trace/walk.scm 357 */
						obj_t BgL_g3216z00_1688;

						BgL_g3216z00_1688 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1683))->BgL_localsz00);
						{
							obj_t BgL_l3214z00_1689;

							BgL_l3214z00_1689 = BgL_g3216z00_1688;
						BgL_forzd2each3215zd2_1690:
							if (PAIRP(BgL_l3214z00_1689))
								{	/* Trace/walk.scm 357 */
									BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l3214z00_1689),
										BgL_stackz00_1684);
									{
										obj_t BgL_l3214z00_4315;

										BgL_l3214z00_4315 = CDR(BgL_l3214z00_1689);
										BgL_l3214z00_1689 = BgL_l3214z00_4315;
										goto BgL_forzd2each3215zd2_1690;
									}
								}
							else
								{	/* Trace/walk.scm 357 */
									((bool_t) 1);
								}
						}
					}
					{	/* Trace/walk.scm 358 */
						BgL_nodez00_bglt BgL_arg3598z00_1694;

						{	/* Trace/walk.scm 358 */
							BgL_nodez00_bglt BgL_arg3599z00_1695;

							BgL_arg3599z00_1695 =
								(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1683))->BgL_bodyz00);
							{	/* Trace/walk.scm 358 */
								BgL_nodez00_bglt BgL_res3744z00_2976;

								{	/* Trace/walk.scm 358 */
									obj_t BgL_method3250z00_2951;

									{	/* Trace/walk.scm 358 */
										BgL_objectz00_bglt BgL_objz00_2952;

										BgL_objz00_2952 =
											(BgL_objectz00_bglt) (BgL_arg3599z00_1695);
										{	/* Trace/walk.scm 358 */
											long BgL_objzd2classzd2numz00_2953;

											BgL_objzd2classzd2numz00_2953 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2952);
											{	/* Trace/walk.scm 358 */
												obj_t BgL_arg2334z00_2954;

												BgL_arg2334z00_2954 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 358 */
													obj_t BgL_arrayz00_2956;

													int BgL_offsetz00_2957;

													BgL_arrayz00_2956 = BgL_arg2334z00_2954;
													BgL_offsetz00_2957 =
														(int) (BgL_objzd2classzd2numz00_2953);
													{	/* Trace/walk.scm 358 */
														long BgL_offsetz00_2958;

														BgL_offsetz00_2958 =
															((long) (BgL_offsetz00_2957) - OBJECT_TYPE);
														{	/* Trace/walk.scm 358 */
															long BgL_modz00_2959;

															{	/* Trace/walk.scm 358 */
																int BgL_arg2336z00_2960;

																BgL_arg2336z00_2960 = (int) (((long) 8));
																{	/* Trace/walk.scm 358 */
																	long BgL_auxz00_4326;

																	BgL_auxz00_4326 =
																		(long) (BgL_arg2336z00_2960);
																	BgL_modz00_2959 =
																		(BgL_offsetz00_2958 / BgL_auxz00_4326);
															}}
															{	/* Trace/walk.scm 358 */
																long BgL_restz00_2961;

																{	/* Trace/walk.scm 358 */
																	int BgL_arg2335z00_2962;

																	BgL_arg2335z00_2962 = (int) (((long) 8));
																	{	/* Trace/walk.scm 358 */
																		long BgL_auxz00_4330;

																		BgL_auxz00_4330 =
																			(long) (BgL_arg2335z00_2962);
																		BgL_restz00_2961 =
																			(BgL_offsetz00_2958 % BgL_auxz00_4330);
																}}
																{	/* Trace/walk.scm 358 */

																	BgL_method3250z00_2951 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2956,
																			(int) (BgL_modz00_2959)),
																		(int) (BgL_restz00_2961));
									}}}}}}}}
									BgL_res3744z00_2976 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2951)
										(BgL_method3250z00_2951, (obj_t) (BgL_arg3599z00_1695),
											BgL_stackz00_1684, BEOA));
								}
								BgL_arg3598z00_1694 = BgL_res3744z00_2976;
						}}
						((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1683))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_arg3598z00_1694), BUNSPEC);
					}
					BgL_auxz00_4309 = BgL_nodez00_1683;
					return (obj_t) (BgL_auxz00_4309);
				}
			}
		}
	}



/* trace-node-select3270 */
	obj_t BGl_tracezd2nodezd2select3270z00zztrace_walkz00(obj_t BgL_envz00_3362,
		obj_t BgL_nodez00_3363, obj_t BgL_stackz00_3364)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 344 */
			{
				BgL_selectz00_bglt BgL_nodez00_1666;

				obj_t BgL_stackz00_1667;

				{	/* Trace/walk.scm 345 */
					BgL_selectz00_bglt BgL_auxz00_4344;

					BgL_nodez00_1666 = (BgL_selectz00_bglt) (BgL_nodez00_3363);
					BgL_stackz00_1667 = BgL_stackz00_3364;
					{	/* Trace/walk.scm 346 */
						BgL_nodez00_bglt BgL_arg3589z00_1671;

						{	/* Trace/walk.scm 346 */
							BgL_nodez00_bglt BgL_arg3590z00_1672;

							BgL_arg3590z00_1672 =
								(((BgL_selectz00_bglt) CREF(BgL_nodez00_1666))->BgL_testz00);
							{	/* Trace/walk.scm 346 */
								BgL_nodez00_bglt BgL_res3738z00_2906;

								{	/* Trace/walk.scm 346 */
									obj_t BgL_method3250z00_2881;

									{	/* Trace/walk.scm 346 */
										BgL_objectz00_bglt BgL_objz00_2882;

										BgL_objz00_2882 =
											(BgL_objectz00_bglt) (BgL_arg3590z00_1672);
										{	/* Trace/walk.scm 346 */
											long BgL_objzd2classzd2numz00_2883;

											BgL_objzd2classzd2numz00_2883 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2882);
											{	/* Trace/walk.scm 346 */
												obj_t BgL_arg2334z00_2884;

												BgL_arg2334z00_2884 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 346 */
													obj_t BgL_arrayz00_2886;

													int BgL_offsetz00_2887;

													BgL_arrayz00_2886 = BgL_arg2334z00_2884;
													BgL_offsetz00_2887 =
														(int) (BgL_objzd2classzd2numz00_2883);
													{	/* Trace/walk.scm 346 */
														long BgL_offsetz00_2888;

														BgL_offsetz00_2888 =
															((long) (BgL_offsetz00_2887) - OBJECT_TYPE);
														{	/* Trace/walk.scm 346 */
															long BgL_modz00_2889;

															{	/* Trace/walk.scm 346 */
																int BgL_arg2336z00_2890;

																BgL_arg2336z00_2890 = (int) (((long) 8));
																{	/* Trace/walk.scm 346 */
																	long BgL_auxz00_4354;

																	BgL_auxz00_4354 =
																		(long) (BgL_arg2336z00_2890);
																	BgL_modz00_2889 =
																		(BgL_offsetz00_2888 / BgL_auxz00_4354);
															}}
															{	/* Trace/walk.scm 346 */
																long BgL_restz00_2891;

																{	/* Trace/walk.scm 346 */
																	int BgL_arg2335z00_2892;

																	BgL_arg2335z00_2892 = (int) (((long) 8));
																	{	/* Trace/walk.scm 346 */
																		long BgL_auxz00_4358;

																		BgL_auxz00_4358 =
																			(long) (BgL_arg2335z00_2892);
																		BgL_restz00_2891 =
																			(BgL_offsetz00_2888 % BgL_auxz00_4358);
																}}
																{	/* Trace/walk.scm 346 */

																	BgL_method3250z00_2881 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2886,
																			(int) (BgL_modz00_2889)),
																		(int) (BgL_restz00_2891));
									}}}}}}}}
									BgL_res3738z00_2906 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2881)
										(BgL_method3250z00_2881, (obj_t) (BgL_arg3590z00_1672),
											BgL_stackz00_1667, BEOA));
								}
								BgL_arg3589z00_1671 = BgL_res3738z00_2906;
						}}
						((((BgL_selectz00_bglt) CREF(BgL_nodez00_1666))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3589z00_1671), BUNSPEC);
					}
					{	/* Trace/walk.scm 347 */
						obj_t BgL_g3213z00_1673;

						BgL_g3213z00_1673 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1666))->BgL_clausesz00);
						{
							obj_t BgL_l3211z00_1674;

							BgL_l3211z00_1674 = BgL_g3213z00_1673;
						BgL_forzd2each3212zd2_1675:
							if (PAIRP(BgL_l3211z00_1674))
								{	/* Trace/walk.scm 347 */
									{	/* Trace/walk.scm 348 */
										obj_t BgL_clausez00_1677;

										BgL_clausez00_1677 = CAR(BgL_l3211z00_1674);
										{	/* Trace/walk.scm 348 */
											BgL_nodez00_bglt BgL_arg3592z00_1678;

											{	/* Trace/walk.scm 348 */
												obj_t BgL_arg3593z00_1679;

												BgL_arg3593z00_1679 = CDR(BgL_clausez00_1677);
												{	/* Trace/walk.scm 348 */
													BgL_nodez00_bglt BgL_res3741z00_2940;

													{	/* Trace/walk.scm 348 */
														BgL_nodez00_bglt BgL_nodez00_2913;

														BgL_nodez00_2913 =
															(BgL_nodez00_bglt) (BgL_arg3593z00_1679);
														{	/* Trace/walk.scm 348 */
															obj_t BgL_method3250z00_2915;

															{	/* Trace/walk.scm 348 */
																BgL_objectz00_bglt BgL_objz00_2916;

																BgL_objz00_2916 =
																	(BgL_objectz00_bglt) (BgL_nodez00_2913);
																{	/* Trace/walk.scm 348 */
																	long BgL_objzd2classzd2numz00_2917;

																	BgL_objzd2classzd2numz00_2917 =
																		BGL_OBJECT_CLASS_NUM(BgL_objz00_2916);
																	{	/* Trace/walk.scm 348 */
																		obj_t BgL_arg2334z00_2918;

																		BgL_arg2334z00_2918 =
																			PROCEDURE_REF
																			(BGl_tracezd2nodezd2envz00zztrace_walkz00,
																			(int) (((long) 1)));
																		{	/* Trace/walk.scm 348 */
																			obj_t BgL_arrayz00_2920;

																			int BgL_offsetz00_2921;

																			BgL_arrayz00_2920 = BgL_arg2334z00_2918;
																			BgL_offsetz00_2921 =
																				(int) (BgL_objzd2classzd2numz00_2917);
																			{	/* Trace/walk.scm 348 */
																				long BgL_offsetz00_2922;

																				BgL_offsetz00_2922 =
																					(
																					(long) (BgL_offsetz00_2921) -
																					OBJECT_TYPE);
																				{	/* Trace/walk.scm 348 */
																					long BgL_modz00_2923;

																					{	/* Trace/walk.scm 348 */
																						int BgL_arg2336z00_2924;

																						BgL_arg2336z00_2924 =
																							(int) (((long) 8));
																						{	/* Trace/walk.scm 348 */
																							long BgL_auxz00_4384;

																							BgL_auxz00_4384 =
																								(long) (BgL_arg2336z00_2924);
																							BgL_modz00_2923 =
																								(BgL_offsetz00_2922 /
																								BgL_auxz00_4384);
																					}}
																					{	/* Trace/walk.scm 348 */
																						long BgL_restz00_2925;

																						{	/* Trace/walk.scm 348 */
																							int BgL_arg2335z00_2926;

																							BgL_arg2335z00_2926 =
																								(int) (((long) 8));
																							{	/* Trace/walk.scm 348 */
																								long BgL_auxz00_4388;

																								BgL_auxz00_4388 =
																									(long) (BgL_arg2335z00_2926);
																								BgL_restz00_2925 =
																									(BgL_offsetz00_2922 %
																									BgL_auxz00_4388);
																						}}
																						{	/* Trace/walk.scm 348 */

																							BgL_method3250z00_2915 =
																								VECTOR_REF(VECTOR_REF
																								(BgL_arrayz00_2920,
																									(int) (BgL_modz00_2923)),
																								(int) (BgL_restz00_2925));
															}}}}}}}}
															BgL_res3741z00_2940 =
																(BgL_nodez00_bglt) (PROCEDURE_ENTRY
																(BgL_method3250z00_2915)
																(BgL_method3250z00_2915,
																	(obj_t) (BgL_nodez00_2913), BgL_stackz00_1667,
																	BEOA));
													}}
													BgL_arg3592z00_1678 = BgL_res3741z00_2940;
											}}
											{	/* Trace/walk.scm 348 */
												obj_t BgL_auxz00_4399;

												BgL_auxz00_4399 = (obj_t) (BgL_arg3592z00_1678);
												SET_CDR(BgL_clausez00_1677, BgL_auxz00_4399);
									}}}
									{
										obj_t BgL_l3211z00_4402;

										BgL_l3211z00_4402 = CDR(BgL_l3211z00_1674);
										BgL_l3211z00_1674 = BgL_l3211z00_4402;
										goto BgL_forzd2each3212zd2_1675;
									}
								}
							else
								{	/* Trace/walk.scm 347 */
									((bool_t) 1);
								}
						}
					}
					BgL_auxz00_4344 = BgL_nodez00_1666;
					return (obj_t) (BgL_auxz00_4344);
				}
			}
		}
	}



/* trace-node-fail3268 */
	obj_t BGl_tracezd2nodezd2fail3268z00zztrace_walkz00(obj_t BgL_envz00_3365,
		obj_t BgL_nodez00_3366, obj_t BgL_stackz00_3367)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 334 */
			{
				BgL_failz00_bglt BgL_nodez00_1653;

				obj_t BgL_stackz00_1654;

				{	/* Trace/walk.scm 335 */
					BgL_failz00_bglt BgL_auxz00_4406;

					BgL_nodez00_1653 = (BgL_failz00_bglt) (BgL_nodez00_3366);
					BgL_stackz00_1654 = BgL_stackz00_3367;
					{	/* Trace/walk.scm 336 */
						BgL_nodez00_bglt BgL_arg3582z00_1658;

						{	/* Trace/walk.scm 336 */
							BgL_nodez00_bglt BgL_arg3583z00_1659;

							BgL_arg3583z00_1659 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1653))->BgL_procz00);
							{	/* Trace/walk.scm 336 */
								BgL_nodez00_bglt BgL_res3729z00_2813;

								{	/* Trace/walk.scm 336 */
									obj_t BgL_method3250z00_2788;

									{	/* Trace/walk.scm 336 */
										BgL_objectz00_bglt BgL_objz00_2789;

										BgL_objz00_2789 =
											(BgL_objectz00_bglt) (BgL_arg3583z00_1659);
										{	/* Trace/walk.scm 336 */
											long BgL_objzd2classzd2numz00_2790;

											BgL_objzd2classzd2numz00_2790 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2789);
											{	/* Trace/walk.scm 336 */
												obj_t BgL_arg2334z00_2791;

												BgL_arg2334z00_2791 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 336 */
													obj_t BgL_arrayz00_2793;

													int BgL_offsetz00_2794;

													BgL_arrayz00_2793 = BgL_arg2334z00_2791;
													BgL_offsetz00_2794 =
														(int) (BgL_objzd2classzd2numz00_2790);
													{	/* Trace/walk.scm 336 */
														long BgL_offsetz00_2795;

														BgL_offsetz00_2795 =
															((long) (BgL_offsetz00_2794) - OBJECT_TYPE);
														{	/* Trace/walk.scm 336 */
															long BgL_modz00_2796;

															{	/* Trace/walk.scm 336 */
																int BgL_arg2336z00_2797;

																BgL_arg2336z00_2797 = (int) (((long) 8));
																{	/* Trace/walk.scm 336 */
																	long BgL_auxz00_4416;

																	BgL_auxz00_4416 =
																		(long) (BgL_arg2336z00_2797);
																	BgL_modz00_2796 =
																		(BgL_offsetz00_2795 / BgL_auxz00_4416);
															}}
															{	/* Trace/walk.scm 336 */
																long BgL_restz00_2798;

																{	/* Trace/walk.scm 336 */
																	int BgL_arg2335z00_2799;

																	BgL_arg2335z00_2799 = (int) (((long) 8));
																	{	/* Trace/walk.scm 336 */
																		long BgL_auxz00_4420;

																		BgL_auxz00_4420 =
																			(long) (BgL_arg2335z00_2799);
																		BgL_restz00_2798 =
																			(BgL_offsetz00_2795 % BgL_auxz00_4420);
																}}
																{	/* Trace/walk.scm 336 */

																	BgL_method3250z00_2788 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2793,
																			(int) (BgL_modz00_2796)),
																		(int) (BgL_restz00_2798));
									}}}}}}}}
									BgL_res3729z00_2813 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2788)
										(BgL_method3250z00_2788, (obj_t) (BgL_arg3583z00_1659),
											BgL_stackz00_1654, BEOA));
								}
								BgL_arg3582z00_1658 = BgL_res3729z00_2813;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1653))->BgL_procz00) =
							((BgL_nodez00_bglt) BgL_arg3582z00_1658), BUNSPEC);
					}
					{	/* Trace/walk.scm 337 */
						BgL_nodez00_bglt BgL_arg3584z00_1660;

						{	/* Trace/walk.scm 337 */
							BgL_nodez00_bglt BgL_arg3585z00_1661;

							BgL_arg3585z00_1661 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1653))->BgL_msgz00);
							{	/* Trace/walk.scm 337 */
								BgL_nodez00_bglt BgL_res3732z00_2844;

								{	/* Trace/walk.scm 337 */
									obj_t BgL_method3250z00_2819;

									{	/* Trace/walk.scm 337 */
										BgL_objectz00_bglt BgL_objz00_2820;

										BgL_objz00_2820 =
											(BgL_objectz00_bglt) (BgL_arg3585z00_1661);
										{	/* Trace/walk.scm 337 */
											long BgL_objzd2classzd2numz00_2821;

											BgL_objzd2classzd2numz00_2821 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2820);
											{	/* Trace/walk.scm 337 */
												obj_t BgL_arg2334z00_2822;

												BgL_arg2334z00_2822 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 337 */
													obj_t BgL_arrayz00_2824;

													int BgL_offsetz00_2825;

													BgL_arrayz00_2824 = BgL_arg2334z00_2822;
													BgL_offsetz00_2825 =
														(int) (BgL_objzd2classzd2numz00_2821);
													{	/* Trace/walk.scm 337 */
														long BgL_offsetz00_2826;

														BgL_offsetz00_2826 =
															((long) (BgL_offsetz00_2825) - OBJECT_TYPE);
														{	/* Trace/walk.scm 337 */
															long BgL_modz00_2827;

															{	/* Trace/walk.scm 337 */
																int BgL_arg2336z00_2828;

																BgL_arg2336z00_2828 = (int) (((long) 8));
																{	/* Trace/walk.scm 337 */
																	long BgL_auxz00_4441;

																	BgL_auxz00_4441 =
																		(long) (BgL_arg2336z00_2828);
																	BgL_modz00_2827 =
																		(BgL_offsetz00_2826 / BgL_auxz00_4441);
															}}
															{	/* Trace/walk.scm 337 */
																long BgL_restz00_2829;

																{	/* Trace/walk.scm 337 */
																	int BgL_arg2335z00_2830;

																	BgL_arg2335z00_2830 = (int) (((long) 8));
																	{	/* Trace/walk.scm 337 */
																		long BgL_auxz00_4445;

																		BgL_auxz00_4445 =
																			(long) (BgL_arg2335z00_2830);
																		BgL_restz00_2829 =
																			(BgL_offsetz00_2826 % BgL_auxz00_4445);
																}}
																{	/* Trace/walk.scm 337 */

																	BgL_method3250z00_2819 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2824,
																			(int) (BgL_modz00_2827)),
																		(int) (BgL_restz00_2829));
									}}}}}}}}
									BgL_res3732z00_2844 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2819)
										(BgL_method3250z00_2819, (obj_t) (BgL_arg3585z00_1661),
											BgL_stackz00_1654, BEOA));
								}
								BgL_arg3584z00_1660 = BgL_res3732z00_2844;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1653))->BgL_msgz00) =
							((BgL_nodez00_bglt) BgL_arg3584z00_1660), BUNSPEC);
					}
					{	/* Trace/walk.scm 338 */
						BgL_nodez00_bglt BgL_arg3586z00_1662;

						{	/* Trace/walk.scm 338 */
							BgL_nodez00_bglt BgL_arg3587z00_1663;

							BgL_arg3587z00_1663 =
								(((BgL_failz00_bglt) CREF(BgL_nodez00_1653))->BgL_objz00);
							{	/* Trace/walk.scm 338 */
								BgL_nodez00_bglt BgL_res3735z00_2875;

								{	/* Trace/walk.scm 338 */
									obj_t BgL_method3250z00_2850;

									{	/* Trace/walk.scm 338 */
										BgL_objectz00_bglt BgL_objz00_2851;

										BgL_objz00_2851 =
											(BgL_objectz00_bglt) (BgL_arg3587z00_1663);
										{	/* Trace/walk.scm 338 */
											long BgL_objzd2classzd2numz00_2852;

											BgL_objzd2classzd2numz00_2852 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2851);
											{	/* Trace/walk.scm 338 */
												obj_t BgL_arg2334z00_2853;

												BgL_arg2334z00_2853 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 338 */
													obj_t BgL_arrayz00_2855;

													int BgL_offsetz00_2856;

													BgL_arrayz00_2855 = BgL_arg2334z00_2853;
													BgL_offsetz00_2856 =
														(int) (BgL_objzd2classzd2numz00_2852);
													{	/* Trace/walk.scm 338 */
														long BgL_offsetz00_2857;

														BgL_offsetz00_2857 =
															((long) (BgL_offsetz00_2856) - OBJECT_TYPE);
														{	/* Trace/walk.scm 338 */
															long BgL_modz00_2858;

															{	/* Trace/walk.scm 338 */
																int BgL_arg2336z00_2859;

																BgL_arg2336z00_2859 = (int) (((long) 8));
																{	/* Trace/walk.scm 338 */
																	long BgL_auxz00_4466;

																	BgL_auxz00_4466 =
																		(long) (BgL_arg2336z00_2859);
																	BgL_modz00_2858 =
																		(BgL_offsetz00_2857 / BgL_auxz00_4466);
															}}
															{	/* Trace/walk.scm 338 */
																long BgL_restz00_2860;

																{	/* Trace/walk.scm 338 */
																	int BgL_arg2335z00_2861;

																	BgL_arg2335z00_2861 = (int) (((long) 8));
																	{	/* Trace/walk.scm 338 */
																		long BgL_auxz00_4470;

																		BgL_auxz00_4470 =
																			(long) (BgL_arg2335z00_2861);
																		BgL_restz00_2860 =
																			(BgL_offsetz00_2857 % BgL_auxz00_4470);
																}}
																{	/* Trace/walk.scm 338 */

																	BgL_method3250z00_2850 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2855,
																			(int) (BgL_modz00_2858)),
																		(int) (BgL_restz00_2860));
									}}}}}}}}
									BgL_res3735z00_2875 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2850)
										(BgL_method3250z00_2850, (obj_t) (BgL_arg3587z00_1663),
											BgL_stackz00_1654, BEOA));
								}
								BgL_arg3586z00_1662 = BgL_res3735z00_2875;
						}}
						((((BgL_failz00_bglt) CREF(BgL_nodez00_1653))->BgL_objz00) =
							((BgL_nodez00_bglt) BgL_arg3586z00_1662), BUNSPEC);
					}
					BgL_auxz00_4406 = BgL_nodez00_1653;
					return (obj_t) (BgL_auxz00_4406);
				}
			}
		}
	}



/* trace-node-condition3266 */
	obj_t BGl_tracezd2nodezd2condition3266z00zztrace_walkz00(obj_t
		BgL_envz00_3368, obj_t BgL_nodez00_3369, obj_t BgL_stackz00_3370)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 324 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1640;

				obj_t BgL_stackz00_1641;

				{	/* Trace/walk.scm 325 */
					BgL_conditionalz00_bglt BgL_auxz00_4484;

					BgL_nodez00_1640 = (BgL_conditionalz00_bglt) (BgL_nodez00_3369);
					BgL_stackz00_1641 = BgL_stackz00_3370;
					{	/* Trace/walk.scm 326 */
						BgL_nodez00_bglt BgL_arg3574z00_1645;

						{	/* Trace/walk.scm 326 */
							BgL_nodez00_bglt BgL_arg3575z00_1646;

							BgL_arg3575z00_1646 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1640))->
								BgL_testz00);
							{	/* Trace/walk.scm 326 */
								BgL_nodez00_bglt BgL_res3720z00_2720;

								{	/* Trace/walk.scm 326 */
									obj_t BgL_method3250z00_2695;

									{	/* Trace/walk.scm 326 */
										BgL_objectz00_bglt BgL_objz00_2696;

										BgL_objz00_2696 =
											(BgL_objectz00_bglt) (BgL_arg3575z00_1646);
										{	/* Trace/walk.scm 326 */
											long BgL_objzd2classzd2numz00_2697;

											BgL_objzd2classzd2numz00_2697 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2696);
											{	/* Trace/walk.scm 326 */
												obj_t BgL_arg2334z00_2698;

												BgL_arg2334z00_2698 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 326 */
													obj_t BgL_arrayz00_2700;

													int BgL_offsetz00_2701;

													BgL_arrayz00_2700 = BgL_arg2334z00_2698;
													BgL_offsetz00_2701 =
														(int) (BgL_objzd2classzd2numz00_2697);
													{	/* Trace/walk.scm 326 */
														long BgL_offsetz00_2702;

														BgL_offsetz00_2702 =
															((long) (BgL_offsetz00_2701) - OBJECT_TYPE);
														{	/* Trace/walk.scm 326 */
															long BgL_modz00_2703;

															{	/* Trace/walk.scm 326 */
																int BgL_arg2336z00_2704;

																BgL_arg2336z00_2704 = (int) (((long) 8));
																{	/* Trace/walk.scm 326 */
																	long BgL_auxz00_4494;

																	BgL_auxz00_4494 =
																		(long) (BgL_arg2336z00_2704);
																	BgL_modz00_2703 =
																		(BgL_offsetz00_2702 / BgL_auxz00_4494);
															}}
															{	/* Trace/walk.scm 326 */
																long BgL_restz00_2705;

																{	/* Trace/walk.scm 326 */
																	int BgL_arg2335z00_2706;

																	BgL_arg2335z00_2706 = (int) (((long) 8));
																	{	/* Trace/walk.scm 326 */
																		long BgL_auxz00_4498;

																		BgL_auxz00_4498 =
																			(long) (BgL_arg2335z00_2706);
																		BgL_restz00_2705 =
																			(BgL_offsetz00_2702 % BgL_auxz00_4498);
																}}
																{	/* Trace/walk.scm 326 */

																	BgL_method3250z00_2695 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2700,
																			(int) (BgL_modz00_2703)),
																		(int) (BgL_restz00_2705));
									}}}}}}}}
									BgL_res3720z00_2720 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2695)
										(BgL_method3250z00_2695, (obj_t) (BgL_arg3575z00_1646),
											BgL_stackz00_1641, BEOA));
								}
								BgL_arg3574z00_1645 = BgL_res3720z00_2720;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1640))->BgL_testz00) =
							((BgL_nodez00_bglt) BgL_arg3574z00_1645), BUNSPEC);
					}
					{	/* Trace/walk.scm 327 */
						BgL_nodez00_bglt BgL_arg3577z00_1647;

						{	/* Trace/walk.scm 327 */
							BgL_nodez00_bglt BgL_arg3578z00_1648;

							BgL_arg3578z00_1648 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1640))->
								BgL_truez00);
							{	/* Trace/walk.scm 327 */
								BgL_nodez00_bglt BgL_res3723z00_2751;

								{	/* Trace/walk.scm 327 */
									obj_t BgL_method3250z00_2726;

									{	/* Trace/walk.scm 327 */
										BgL_objectz00_bglt BgL_objz00_2727;

										BgL_objz00_2727 =
											(BgL_objectz00_bglt) (BgL_arg3578z00_1648);
										{	/* Trace/walk.scm 327 */
											long BgL_objzd2classzd2numz00_2728;

											BgL_objzd2classzd2numz00_2728 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2727);
											{	/* Trace/walk.scm 327 */
												obj_t BgL_arg2334z00_2729;

												BgL_arg2334z00_2729 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 327 */
													obj_t BgL_arrayz00_2731;

													int BgL_offsetz00_2732;

													BgL_arrayz00_2731 = BgL_arg2334z00_2729;
													BgL_offsetz00_2732 =
														(int) (BgL_objzd2classzd2numz00_2728);
													{	/* Trace/walk.scm 327 */
														long BgL_offsetz00_2733;

														BgL_offsetz00_2733 =
															((long) (BgL_offsetz00_2732) - OBJECT_TYPE);
														{	/* Trace/walk.scm 327 */
															long BgL_modz00_2734;

															{	/* Trace/walk.scm 327 */
																int BgL_arg2336z00_2735;

																BgL_arg2336z00_2735 = (int) (((long) 8));
																{	/* Trace/walk.scm 327 */
																	long BgL_auxz00_4519;

																	BgL_auxz00_4519 =
																		(long) (BgL_arg2336z00_2735);
																	BgL_modz00_2734 =
																		(BgL_offsetz00_2733 / BgL_auxz00_4519);
															}}
															{	/* Trace/walk.scm 327 */
																long BgL_restz00_2736;

																{	/* Trace/walk.scm 327 */
																	int BgL_arg2335z00_2737;

																	BgL_arg2335z00_2737 = (int) (((long) 8));
																	{	/* Trace/walk.scm 327 */
																		long BgL_auxz00_4523;

																		BgL_auxz00_4523 =
																			(long) (BgL_arg2335z00_2737);
																		BgL_restz00_2736 =
																			(BgL_offsetz00_2733 % BgL_auxz00_4523);
																}}
																{	/* Trace/walk.scm 327 */

																	BgL_method3250z00_2726 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2731,
																			(int) (BgL_modz00_2734)),
																		(int) (BgL_restz00_2736));
									}}}}}}}}
									BgL_res3723z00_2751 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2726)
										(BgL_method3250z00_2726, (obj_t) (BgL_arg3578z00_1648),
											BgL_stackz00_1641, BEOA));
								}
								BgL_arg3577z00_1647 = BgL_res3723z00_2751;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1640))->BgL_truez00) =
							((BgL_nodez00_bglt) BgL_arg3577z00_1647), BUNSPEC);
					}
					{	/* Trace/walk.scm 328 */
						BgL_nodez00_bglt BgL_arg3579z00_1649;

						{	/* Trace/walk.scm 328 */
							BgL_nodez00_bglt BgL_arg3580z00_1650;

							BgL_arg3580z00_1650 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1640))->
								BgL_falsez00);
							{	/* Trace/walk.scm 328 */
								BgL_nodez00_bglt BgL_res3726z00_2782;

								{	/* Trace/walk.scm 328 */
									obj_t BgL_method3250z00_2757;

									{	/* Trace/walk.scm 328 */
										BgL_objectz00_bglt BgL_objz00_2758;

										BgL_objz00_2758 =
											(BgL_objectz00_bglt) (BgL_arg3580z00_1650);
										{	/* Trace/walk.scm 328 */
											long BgL_objzd2classzd2numz00_2759;

											BgL_objzd2classzd2numz00_2759 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2758);
											{	/* Trace/walk.scm 328 */
												obj_t BgL_arg2334z00_2760;

												BgL_arg2334z00_2760 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 328 */
													obj_t BgL_arrayz00_2762;

													int BgL_offsetz00_2763;

													BgL_arrayz00_2762 = BgL_arg2334z00_2760;
													BgL_offsetz00_2763 =
														(int) (BgL_objzd2classzd2numz00_2759);
													{	/* Trace/walk.scm 328 */
														long BgL_offsetz00_2764;

														BgL_offsetz00_2764 =
															((long) (BgL_offsetz00_2763) - OBJECT_TYPE);
														{	/* Trace/walk.scm 328 */
															long BgL_modz00_2765;

															{	/* Trace/walk.scm 328 */
																int BgL_arg2336z00_2766;

																BgL_arg2336z00_2766 = (int) (((long) 8));
																{	/* Trace/walk.scm 328 */
																	long BgL_auxz00_4544;

																	BgL_auxz00_4544 =
																		(long) (BgL_arg2336z00_2766);
																	BgL_modz00_2765 =
																		(BgL_offsetz00_2764 / BgL_auxz00_4544);
															}}
															{	/* Trace/walk.scm 328 */
																long BgL_restz00_2767;

																{	/* Trace/walk.scm 328 */
																	int BgL_arg2335z00_2768;

																	BgL_arg2335z00_2768 = (int) (((long) 8));
																	{	/* Trace/walk.scm 328 */
																		long BgL_auxz00_4548;

																		BgL_auxz00_4548 =
																			(long) (BgL_arg2335z00_2768);
																		BgL_restz00_2767 =
																			(BgL_offsetz00_2764 % BgL_auxz00_4548);
																}}
																{	/* Trace/walk.scm 328 */

																	BgL_method3250z00_2757 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2762,
																			(int) (BgL_modz00_2765)),
																		(int) (BgL_restz00_2767));
									}}}}}}}}
									BgL_res3726z00_2782 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2757)
										(BgL_method3250z00_2757, (obj_t) (BgL_arg3580z00_1650),
											BgL_stackz00_1641, BEOA));
								}
								BgL_arg3579z00_1649 = BgL_res3726z00_2782;
						}}
						((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1640))->
								BgL_falsez00) =
							((BgL_nodez00_bglt) BgL_arg3579z00_1649), BUNSPEC);
					}
					BgL_auxz00_4484 = BgL_nodez00_1640;
					return (obj_t) (BgL_auxz00_4484);
				}
			}
		}
	}



/* trace-node-setq3264 */
	obj_t BGl_tracezd2nodezd2setq3264z00zztrace_walkz00(obj_t BgL_envz00_3371,
		obj_t BgL_nodez00_3372, obj_t BgL_stackz00_3373)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 317 */
			{
				BgL_setqz00_bglt BgL_nodez00_1632;

				obj_t BgL_stackz00_1633;

				{	/* Trace/walk.scm 318 */
					BgL_setqz00_bglt BgL_auxz00_4562;

					BgL_nodez00_1632 = (BgL_setqz00_bglt) (BgL_nodez00_3372);
					BgL_stackz00_1633 = BgL_stackz00_3373;
					{	/* Trace/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3571z00_2659;

						{	/* Trace/walk.scm 318 */
							BgL_nodez00_bglt BgL_arg3572z00_2660;

							BgL_arg3572z00_2660 =
								(((BgL_setqz00_bglt) CREF(BgL_nodez00_1632))->BgL_valuez00);
							{	/* Trace/walk.scm 318 */
								BgL_nodez00_bglt BgL_res3717z00_2689;

								{	/* Trace/walk.scm 318 */
									obj_t BgL_method3250z00_2664;

									{	/* Trace/walk.scm 318 */
										BgL_objectz00_bglt BgL_objz00_2665;

										BgL_objz00_2665 =
											(BgL_objectz00_bglt) (BgL_arg3572z00_2660);
										{	/* Trace/walk.scm 318 */
											long BgL_objzd2classzd2numz00_2666;

											BgL_objzd2classzd2numz00_2666 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2665);
											{	/* Trace/walk.scm 318 */
												obj_t BgL_arg2334z00_2667;

												BgL_arg2334z00_2667 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 318 */
													obj_t BgL_arrayz00_2669;

													int BgL_offsetz00_2670;

													BgL_arrayz00_2669 = BgL_arg2334z00_2667;
													BgL_offsetz00_2670 =
														(int) (BgL_objzd2classzd2numz00_2666);
													{	/* Trace/walk.scm 318 */
														long BgL_offsetz00_2671;

														BgL_offsetz00_2671 =
															((long) (BgL_offsetz00_2670) - OBJECT_TYPE);
														{	/* Trace/walk.scm 318 */
															long BgL_modz00_2672;

															{	/* Trace/walk.scm 318 */
																int BgL_arg2336z00_2673;

																BgL_arg2336z00_2673 = (int) (((long) 8));
																{	/* Trace/walk.scm 318 */
																	long BgL_auxz00_4572;

																	BgL_auxz00_4572 =
																		(long) (BgL_arg2336z00_2673);
																	BgL_modz00_2672 =
																		(BgL_offsetz00_2671 / BgL_auxz00_4572);
															}}
															{	/* Trace/walk.scm 318 */
																long BgL_restz00_2674;

																{	/* Trace/walk.scm 318 */
																	int BgL_arg2335z00_2675;

																	BgL_arg2335z00_2675 = (int) (((long) 8));
																	{	/* Trace/walk.scm 318 */
																		long BgL_auxz00_4576;

																		BgL_auxz00_4576 =
																			(long) (BgL_arg2335z00_2675);
																		BgL_restz00_2674 =
																			(BgL_offsetz00_2671 % BgL_auxz00_4576);
																}}
																{	/* Trace/walk.scm 318 */

																	BgL_method3250z00_2664 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2669,
																			(int) (BgL_modz00_2672)),
																		(int) (BgL_restz00_2674));
									}}}}}}}}
									BgL_res3717z00_2689 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2664)
										(BgL_method3250z00_2664, (obj_t) (BgL_arg3572z00_2660),
											BgL_stackz00_1633, BEOA));
								}
								BgL_arg3571z00_2659 = BgL_res3717z00_2689;
						}}
						((((BgL_setqz00_bglt) CREF(BgL_nodez00_1632))->BgL_valuez00) =
							((BgL_nodez00_bglt) BgL_arg3571z00_2659), BUNSPEC);
					}
					BgL_auxz00_4562 = BgL_nodez00_1632;
					return (obj_t) (BgL_auxz00_4562);
				}
			}
		}
	}



/* trace-node-cast3262 */
	obj_t BGl_tracezd2nodezd2cast3262z00zztrace_walkz00(obj_t BgL_envz00_3374,
		obj_t BgL_nodez00_3375, obj_t BgL_stackz00_3376)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 310 */
			{
				BgL_castz00_bglt BgL_nodez00_1625;

				obj_t BgL_stackz00_1626;

				{	/* Trace/walk.scm 311 */
					BgL_castz00_bglt BgL_auxz00_4590;

					BgL_nodez00_1625 = (BgL_castz00_bglt) (BgL_nodez00_3375);
					BgL_stackz00_1626 = BgL_stackz00_3376;
					{	/* Trace/walk.scm 311 */
						BgL_nodez00_bglt BgL_arg3569z00_2629;

						BgL_arg3569z00_2629 =
							(((BgL_castz00_bglt) CREF(BgL_nodez00_1625))->BgL_argz00);
						{	/* Trace/walk.scm 311 */
							BgL_nodez00_bglt BgL_res3714z00_2658;

							{	/* Trace/walk.scm 311 */
								obj_t BgL_method3250z00_2633;

								{	/* Trace/walk.scm 311 */
									BgL_objectz00_bglt BgL_objz00_2634;

									BgL_objz00_2634 = (BgL_objectz00_bglt) (BgL_arg3569z00_2629);
									{	/* Trace/walk.scm 311 */
										long BgL_objzd2classzd2numz00_2635;

										BgL_objzd2classzd2numz00_2635 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2634);
										{	/* Trace/walk.scm 311 */
											obj_t BgL_arg2334z00_2636;

											BgL_arg2334z00_2636 =
												PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
												(int) (((long) 1)));
											{	/* Trace/walk.scm 311 */
												obj_t BgL_arrayz00_2638;

												int BgL_offsetz00_2639;

												BgL_arrayz00_2638 = BgL_arg2334z00_2636;
												BgL_offsetz00_2639 =
													(int) (BgL_objzd2classzd2numz00_2635);
												{	/* Trace/walk.scm 311 */
													long BgL_offsetz00_2640;

													BgL_offsetz00_2640 =
														((long) (BgL_offsetz00_2639) - OBJECT_TYPE);
													{	/* Trace/walk.scm 311 */
														long BgL_modz00_2641;

														{	/* Trace/walk.scm 311 */
															int BgL_arg2336z00_2642;

															BgL_arg2336z00_2642 = (int) (((long) 8));
															{	/* Trace/walk.scm 311 */
																long BgL_auxz00_4600;

																BgL_auxz00_4600 = (long) (BgL_arg2336z00_2642);
																BgL_modz00_2641 =
																	(BgL_offsetz00_2640 / BgL_auxz00_4600);
														}}
														{	/* Trace/walk.scm 311 */
															long BgL_restz00_2643;

															{	/* Trace/walk.scm 311 */
																int BgL_arg2335z00_2644;

																BgL_arg2335z00_2644 = (int) (((long) 8));
																{	/* Trace/walk.scm 311 */
																	long BgL_auxz00_4604;

																	BgL_auxz00_4604 =
																		(long) (BgL_arg2335z00_2644);
																	BgL_restz00_2643 =
																		(BgL_offsetz00_2640 % BgL_auxz00_4604);
															}}
															{	/* Trace/walk.scm 311 */

																BgL_method3250z00_2633 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2638,
																		(int) (BgL_modz00_2641)),
																	(int) (BgL_restz00_2643));
								}}}}}}}}
								BgL_res3714z00_2658 =
									(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2633)
									(BgL_method3250z00_2633, (obj_t) (BgL_arg3569z00_2629),
										BgL_stackz00_1626, BEOA));
							} BgL_res3714z00_2658;
					}}
					BgL_auxz00_4590 = BgL_nodez00_1625;
					return (obj_t) (BgL_auxz00_4590);
				}
			}
		}
	}



/* trace-node-extern3260 */
	obj_t BGl_tracezd2nodezd2extern3260z00zztrace_walkz00(obj_t BgL_envz00_3377,
		obj_t BgL_nodez00_3378, obj_t BgL_stackz00_3379)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 303 */
			{
				BgL_externz00_bglt BgL_nodez00_1618;

				obj_t BgL_stackz00_1619;

				{	/* Trace/walk.scm 304 */
					BgL_externz00_bglt BgL_auxz00_4617;

					BgL_nodez00_1618 = (BgL_externz00_bglt) (BgL_nodez00_3378);
					BgL_stackz00_1619 = BgL_stackz00_3379;
					{	/* Trace/walk.scm 304 */
						obj_t BgL_arg3567z00_2627;

						BgL_arg3567z00_2627 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1618))->BgL_exprza2za2);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3567z00_2627,
							BgL_stackz00_1619);
					}
					BgL_auxz00_4617 = BgL_nodez00_1618;
					return (obj_t) (BgL_auxz00_4617);
				}
			}
		}
	}



/* trace-node-funcall3258 */
	obj_t BGl_tracezd2nodezd2funcall3258z00zztrace_walkz00(obj_t BgL_envz00_3380,
		obj_t BgL_nodez00_3381, obj_t BgL_stackz00_3382)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 294 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1608;

				obj_t BgL_stackz00_1609;

				{	/* Trace/walk.scm 295 */
					BgL_funcallz00_bglt BgL_auxz00_4622;

					BgL_nodez00_1608 = (BgL_funcallz00_bglt) (BgL_nodez00_3381);
					BgL_stackz00_1609 = BgL_stackz00_3382;
					{	/* Trace/walk.scm 296 */
						BgL_nodez00_bglt BgL_arg3563z00_1613;

						{	/* Trace/walk.scm 296 */
							BgL_nodez00_bglt BgL_arg3564z00_1614;

							BgL_arg3564z00_1614 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1608))->BgL_funz00);
							{	/* Trace/walk.scm 296 */
								BgL_nodez00_bglt BgL_res3711z00_2623;

								{	/* Trace/walk.scm 296 */
									obj_t BgL_method3250z00_2598;

									{	/* Trace/walk.scm 296 */
										BgL_objectz00_bglt BgL_objz00_2599;

										BgL_objz00_2599 =
											(BgL_objectz00_bglt) (BgL_arg3564z00_1614);
										{	/* Trace/walk.scm 296 */
											long BgL_objzd2classzd2numz00_2600;

											BgL_objzd2classzd2numz00_2600 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2599);
											{	/* Trace/walk.scm 296 */
												obj_t BgL_arg2334z00_2601;

												BgL_arg2334z00_2601 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 296 */
													obj_t BgL_arrayz00_2603;

													int BgL_offsetz00_2604;

													BgL_arrayz00_2603 = BgL_arg2334z00_2601;
													BgL_offsetz00_2604 =
														(int) (BgL_objzd2classzd2numz00_2600);
													{	/* Trace/walk.scm 296 */
														long BgL_offsetz00_2605;

														BgL_offsetz00_2605 =
															((long) (BgL_offsetz00_2604) - OBJECT_TYPE);
														{	/* Trace/walk.scm 296 */
															long BgL_modz00_2606;

															{	/* Trace/walk.scm 296 */
																int BgL_arg2336z00_2607;

																BgL_arg2336z00_2607 = (int) (((long) 8));
																{	/* Trace/walk.scm 296 */
																	long BgL_auxz00_4632;

																	BgL_auxz00_4632 =
																		(long) (BgL_arg2336z00_2607);
																	BgL_modz00_2606 =
																		(BgL_offsetz00_2605 / BgL_auxz00_4632);
															}}
															{	/* Trace/walk.scm 296 */
																long BgL_restz00_2608;

																{	/* Trace/walk.scm 296 */
																	int BgL_arg2335z00_2609;

																	BgL_arg2335z00_2609 = (int) (((long) 8));
																	{	/* Trace/walk.scm 296 */
																		long BgL_auxz00_4636;

																		BgL_auxz00_4636 =
																			(long) (BgL_arg2335z00_2609);
																		BgL_restz00_2608 =
																			(BgL_offsetz00_2605 % BgL_auxz00_4636);
																}}
																{	/* Trace/walk.scm 296 */

																	BgL_method3250z00_2598 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2603,
																			(int) (BgL_modz00_2606)),
																		(int) (BgL_restz00_2608));
									}}}}}}}}
									BgL_res3711z00_2623 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2598)
										(BgL_method3250z00_2598, (obj_t) (BgL_arg3564z00_1614),
											BgL_stackz00_1609, BEOA));
								}
								BgL_arg3563z00_1613 = BgL_res3711z00_2623;
						}}
						((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1608))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3563z00_1613), BUNSPEC);
					}
					{	/* Trace/walk.scm 297 */
						obj_t BgL_arg3565z00_1615;

						BgL_arg3565z00_1615 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1608))->BgL_argsz00);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3565z00_1615,
							BgL_stackz00_1609);
					}
					BgL_auxz00_4622 = BgL_nodez00_1608;
					return (obj_t) (BgL_auxz00_4622);
				}
			}
		}
	}



/* trace-node-app-ly3256 */
	obj_t BGl_tracezd2nodezd2appzd2ly3256zd2zztrace_walkz00(obj_t BgL_envz00_3383,
		obj_t BgL_nodez00_3384, obj_t BgL_stackz00_3385)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 285 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1597;

				obj_t BgL_stackz00_1598;

				{	/* Trace/walk.scm 286 */
					BgL_appzd2lyzd2_bglt BgL_auxz00_4652;

					BgL_nodez00_1597 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_3384);
					BgL_stackz00_1598 = BgL_stackz00_3385;
					{	/* Trace/walk.scm 287 */
						BgL_nodez00_bglt BgL_arg3558z00_1602;

						{	/* Trace/walk.scm 287 */
							BgL_nodez00_bglt BgL_arg3559z00_1603;

							BgL_arg3559z00_1603 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1597))->BgL_funz00);
							{	/* Trace/walk.scm 287 */
								BgL_nodez00_bglt BgL_res3705z00_2561;

								{	/* Trace/walk.scm 287 */
									obj_t BgL_method3250z00_2536;

									{	/* Trace/walk.scm 287 */
										BgL_objectz00_bglt BgL_objz00_2537;

										BgL_objz00_2537 =
											(BgL_objectz00_bglt) (BgL_arg3559z00_1603);
										{	/* Trace/walk.scm 287 */
											long BgL_objzd2classzd2numz00_2538;

											BgL_objzd2classzd2numz00_2538 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2537);
											{	/* Trace/walk.scm 287 */
												obj_t BgL_arg2334z00_2539;

												BgL_arg2334z00_2539 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 287 */
													obj_t BgL_arrayz00_2541;

													int BgL_offsetz00_2542;

													BgL_arrayz00_2541 = BgL_arg2334z00_2539;
													BgL_offsetz00_2542 =
														(int) (BgL_objzd2classzd2numz00_2538);
													{	/* Trace/walk.scm 287 */
														long BgL_offsetz00_2543;

														BgL_offsetz00_2543 =
															((long) (BgL_offsetz00_2542) - OBJECT_TYPE);
														{	/* Trace/walk.scm 287 */
															long BgL_modz00_2544;

															{	/* Trace/walk.scm 287 */
																int BgL_arg2336z00_2545;

																BgL_arg2336z00_2545 = (int) (((long) 8));
																{	/* Trace/walk.scm 287 */
																	long BgL_auxz00_4662;

																	BgL_auxz00_4662 =
																		(long) (BgL_arg2336z00_2545);
																	BgL_modz00_2544 =
																		(BgL_offsetz00_2543 / BgL_auxz00_4662);
															}}
															{	/* Trace/walk.scm 287 */
																long BgL_restz00_2546;

																{	/* Trace/walk.scm 287 */
																	int BgL_arg2335z00_2547;

																	BgL_arg2335z00_2547 = (int) (((long) 8));
																	{	/* Trace/walk.scm 287 */
																		long BgL_auxz00_4666;

																		BgL_auxz00_4666 =
																			(long) (BgL_arg2335z00_2547);
																		BgL_restz00_2546 =
																			(BgL_offsetz00_2543 % BgL_auxz00_4666);
																}}
																{	/* Trace/walk.scm 287 */

																	BgL_method3250z00_2536 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2541,
																			(int) (BgL_modz00_2544)),
																		(int) (BgL_restz00_2546));
									}}}}}}}}
									BgL_res3705z00_2561 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2536)
										(BgL_method3250z00_2536, (obj_t) (BgL_arg3559z00_1603),
											BgL_stackz00_1598, BEOA));
								}
								BgL_arg3558z00_1602 = BgL_res3705z00_2561;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1597))->BgL_funz00) =
							((BgL_nodez00_bglt) BgL_arg3558z00_1602), BUNSPEC);
					}
					{	/* Trace/walk.scm 288 */
						BgL_nodez00_bglt BgL_arg3560z00_1604;

						{	/* Trace/walk.scm 288 */
							BgL_nodez00_bglt BgL_arg3561z00_1605;

							BgL_arg3561z00_1605 =
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1597))->BgL_argz00);
							{	/* Trace/walk.scm 288 */
								BgL_nodez00_bglt BgL_res3708z00_2592;

								{	/* Trace/walk.scm 288 */
									obj_t BgL_method3250z00_2567;

									{	/* Trace/walk.scm 288 */
										BgL_objectz00_bglt BgL_objz00_2568;

										BgL_objz00_2568 =
											(BgL_objectz00_bglt) (BgL_arg3561z00_1605);
										{	/* Trace/walk.scm 288 */
											long BgL_objzd2classzd2numz00_2569;

											BgL_objzd2classzd2numz00_2569 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2568);
											{	/* Trace/walk.scm 288 */
												obj_t BgL_arg2334z00_2570;

												BgL_arg2334z00_2570 =
													PROCEDURE_REF
													(BGl_tracezd2nodezd2envz00zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 288 */
													obj_t BgL_arrayz00_2572;

													int BgL_offsetz00_2573;

													BgL_arrayz00_2572 = BgL_arg2334z00_2570;
													BgL_offsetz00_2573 =
														(int) (BgL_objzd2classzd2numz00_2569);
													{	/* Trace/walk.scm 288 */
														long BgL_offsetz00_2574;

														BgL_offsetz00_2574 =
															((long) (BgL_offsetz00_2573) - OBJECT_TYPE);
														{	/* Trace/walk.scm 288 */
															long BgL_modz00_2575;

															{	/* Trace/walk.scm 288 */
																int BgL_arg2336z00_2576;

																BgL_arg2336z00_2576 = (int) (((long) 8));
																{	/* Trace/walk.scm 288 */
																	long BgL_auxz00_4687;

																	BgL_auxz00_4687 =
																		(long) (BgL_arg2336z00_2576);
																	BgL_modz00_2575 =
																		(BgL_offsetz00_2574 / BgL_auxz00_4687);
															}}
															{	/* Trace/walk.scm 288 */
																long BgL_restz00_2577;

																{	/* Trace/walk.scm 288 */
																	int BgL_arg2335z00_2578;

																	BgL_arg2335z00_2578 = (int) (((long) 8));
																	{	/* Trace/walk.scm 288 */
																		long BgL_auxz00_4691;

																		BgL_auxz00_4691 =
																			(long) (BgL_arg2335z00_2578);
																		BgL_restz00_2577 =
																			(BgL_offsetz00_2574 % BgL_auxz00_4691);
																}}
																{	/* Trace/walk.scm 288 */

																	BgL_method3250z00_2567 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2572,
																			(int) (BgL_modz00_2575)),
																		(int) (BgL_restz00_2577));
									}}}}}}}}
									BgL_res3708z00_2592 =
										(BgL_nodez00_bglt) (PROCEDURE_ENTRY(BgL_method3250z00_2567)
										(BgL_method3250z00_2567, (obj_t) (BgL_arg3561z00_1605),
											BgL_stackz00_1598, BEOA));
								}
								BgL_arg3560z00_1604 = BgL_res3708z00_2592;
						}}
						((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1597))->BgL_argz00) =
							((BgL_nodez00_bglt) BgL_arg3560z00_1604), BUNSPEC);
					}
					BgL_auxz00_4652 = BgL_nodez00_1597;
					return (obj_t) (BgL_auxz00_4652);
				}
			}
		}
	}



/* trace-node-app3254 */
	obj_t BGl_tracezd2nodezd2app3254z00zztrace_walkz00(obj_t BgL_envz00_3386,
		obj_t BgL_nodez00_3387, obj_t BgL_stackz00_3388)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 278 */
			{
				BgL_appz00_bglt BgL_nodez00_1590;

				obj_t BgL_stackz00_1591;

				{	/* Trace/walk.scm 279 */
					BgL_appz00_bglt BgL_auxz00_4705;

					BgL_nodez00_1590 = (BgL_appz00_bglt) (BgL_nodez00_3387);
					BgL_stackz00_1591 = BgL_stackz00_3388;
					{	/* Trace/walk.scm 279 */
						obj_t BgL_arg3556z00_2531;

						BgL_arg3556z00_2531 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1590))->BgL_argsz00);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3556z00_2531,
							BgL_stackz00_1591);
					}
					BgL_auxz00_4705 = BgL_nodez00_1590;
					return (obj_t) (BgL_auxz00_4705);
				}
			}
		}
	}



/* trace-node-sequence3252 */
	obj_t BGl_tracezd2nodezd2sequence3252z00zztrace_walkz00(obj_t BgL_envz00_3389,
		obj_t BgL_nodez00_3390, obj_t BgL_stackz00_3391)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 271 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1583;

				obj_t BgL_stackz00_1584;

				{	/* Trace/walk.scm 272 */
					BgL_sequencez00_bglt BgL_auxz00_4710;

					BgL_nodez00_1583 = (BgL_sequencez00_bglt) (BgL_nodez00_3390);
					BgL_stackz00_1584 = BgL_stackz00_3391;
					{	/* Trace/walk.scm 272 */
						obj_t BgL_arg3554z00_2529;

						BgL_arg3554z00_2529 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1583))->BgL_nodesz00);
						BGl_tracezd2nodeza2z12z62zztrace_walkz00(BgL_arg3554z00_2529,
							BgL_stackz00_1584);
					}
					BgL_auxz00_4710 = BgL_nodez00_1583;
					return (obj_t) (BgL_auxz00_4710);
				}
			}
		}
	}



/* find-last-node-jump-3248 */
	obj_t BGl_findzd2lastzd2nodezd2jumpzd23248z00zztrace_walkz00(obj_t
		BgL_envz00_3392, obj_t BgL_nodez00_3393)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 227 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1577;

				BgL_nodez00_1577 = (BgL_jumpzd2exzd2itz00_bglt) (BgL_nodez00_3393);
				{	/* Trace/walk.scm 228 */
					BgL_nodez00_bglt BgL_arg3552z00_2501;

					BgL_arg3552z00_2501 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1577))->
						BgL_valuez00);
					{	/* Trace/walk.scm 228 */
						obj_t BgL_method3221z00_2504;

						{	/* Trace/walk.scm 228 */
							BgL_objectz00_bglt BgL_objz00_2505;

							BgL_objz00_2505 = (BgL_objectz00_bglt) (BgL_arg3552z00_2501);
							{	/* Trace/walk.scm 228 */
								long BgL_objzd2classzd2numz00_2506;

								BgL_objzd2classzd2numz00_2506 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2505);
								{	/* Trace/walk.scm 228 */
									obj_t BgL_arg2334z00_2507;

									BgL_arg2334z00_2507 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 228 */
										obj_t BgL_arrayz00_2509;

										int BgL_offsetz00_2510;

										BgL_arrayz00_2509 = BgL_arg2334z00_2507;
										BgL_offsetz00_2510 = (int) (BgL_objzd2classzd2numz00_2506);
										{	/* Trace/walk.scm 228 */
											long BgL_offsetz00_2511;

											BgL_offsetz00_2511 =
												((long) (BgL_offsetz00_2510) - OBJECT_TYPE);
											{	/* Trace/walk.scm 228 */
												long BgL_modz00_2512;

												{	/* Trace/walk.scm 228 */
													int BgL_arg2336z00_2513;

													BgL_arg2336z00_2513 = (int) (((long) 8));
													{	/* Trace/walk.scm 228 */
														long BgL_auxz00_4724;

														BgL_auxz00_4724 = (long) (BgL_arg2336z00_2513);
														BgL_modz00_2512 =
															(BgL_offsetz00_2511 / BgL_auxz00_4724);
												}}
												{	/* Trace/walk.scm 228 */
													long BgL_restz00_2514;

													{	/* Trace/walk.scm 228 */
														int BgL_arg2335z00_2515;

														BgL_arg2335z00_2515 = (int) (((long) 8));
														{	/* Trace/walk.scm 228 */
															long BgL_auxz00_4728;

															BgL_auxz00_4728 = (long) (BgL_arg2335z00_2515);
															BgL_restz00_2514 =
																(BgL_offsetz00_2511 % BgL_auxz00_4728);
													}}
													{	/* Trace/walk.scm 228 */

														BgL_method3221z00_2504 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2509,
																(int) (BgL_modz00_2512)),
															(int) (BgL_restz00_2514));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3221z00_2504) (BgL_method3221z00_2504,
							(obj_t) (BgL_arg3552z00_2501), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-set-e3246 */
	obj_t BGl_findzd2lastzd2nodezd2setzd2e3246z00zztrace_walkz00(obj_t
		BgL_envz00_3394, obj_t BgL_nodez00_3395)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 221 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1571;

				BgL_nodez00_1571 = (BgL_setzd2exzd2itz00_bglt) (BgL_nodez00_3395);
				{	/* Trace/walk.scm 222 */
					BgL_nodez00_bglt BgL_arg3550z00_2473;

					BgL_arg3550z00_2473 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1571))->BgL_bodyz00);
					{	/* Trace/walk.scm 222 */
						obj_t BgL_method3221z00_2476;

						{	/* Trace/walk.scm 222 */
							BgL_objectz00_bglt BgL_objz00_2477;

							BgL_objz00_2477 = (BgL_objectz00_bglt) (BgL_arg3550z00_2473);
							{	/* Trace/walk.scm 222 */
								long BgL_objzd2classzd2numz00_2478;

								BgL_objzd2classzd2numz00_2478 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2477);
								{	/* Trace/walk.scm 222 */
									obj_t BgL_arg2334z00_2479;

									BgL_arg2334z00_2479 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 222 */
										obj_t BgL_arrayz00_2481;

										int BgL_offsetz00_2482;

										BgL_arrayz00_2481 = BgL_arg2334z00_2479;
										BgL_offsetz00_2482 = (int) (BgL_objzd2classzd2numz00_2478);
										{	/* Trace/walk.scm 222 */
											long BgL_offsetz00_2483;

											BgL_offsetz00_2483 =
												((long) (BgL_offsetz00_2482) - OBJECT_TYPE);
											{	/* Trace/walk.scm 222 */
												long BgL_modz00_2484;

												{	/* Trace/walk.scm 222 */
													int BgL_arg2336z00_2485;

													BgL_arg2336z00_2485 = (int) (((long) 8));
													{	/* Trace/walk.scm 222 */
														long BgL_auxz00_4748;

														BgL_auxz00_4748 = (long) (BgL_arg2336z00_2485);
														BgL_modz00_2484 =
															(BgL_offsetz00_2483 / BgL_auxz00_4748);
												}}
												{	/* Trace/walk.scm 222 */
													long BgL_restz00_2486;

													{	/* Trace/walk.scm 222 */
														int BgL_arg2335z00_2487;

														BgL_arg2335z00_2487 = (int) (((long) 8));
														{	/* Trace/walk.scm 222 */
															long BgL_auxz00_4752;

															BgL_auxz00_4752 = (long) (BgL_arg2335z00_2487);
															BgL_restz00_2486 =
																(BgL_offsetz00_2483 % BgL_auxz00_4752);
													}}
													{	/* Trace/walk.scm 222 */

														BgL_method3221z00_2476 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2481,
																(int) (BgL_modz00_2484)),
															(int) (BgL_restz00_2486));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3221z00_2476) (BgL_method3221z00_2476,
							(obj_t) (BgL_arg3550z00_2473), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-let-f3244 */
	obj_t BGl_findzd2lastzd2nodezd2letzd2f3244z00zztrace_walkz00(obj_t
		BgL_envz00_3396, obj_t BgL_nodez00_3397)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 215 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1565;

				BgL_nodez00_1565 = (BgL_letzd2funzd2_bglt) (BgL_nodez00_3397);
				{	/* Trace/walk.scm 216 */
					BgL_nodez00_bglt BgL_arg3548z00_2445;

					BgL_arg3548z00_2445 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1565))->BgL_bodyz00);
					{	/* Trace/walk.scm 216 */
						obj_t BgL_method3221z00_2448;

						{	/* Trace/walk.scm 216 */
							BgL_objectz00_bglt BgL_objz00_2449;

							BgL_objz00_2449 = (BgL_objectz00_bglt) (BgL_arg3548z00_2445);
							{	/* Trace/walk.scm 216 */
								long BgL_objzd2classzd2numz00_2450;

								BgL_objzd2classzd2numz00_2450 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2449);
								{	/* Trace/walk.scm 216 */
									obj_t BgL_arg2334z00_2451;

									BgL_arg2334z00_2451 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 216 */
										obj_t BgL_arrayz00_2453;

										int BgL_offsetz00_2454;

										BgL_arrayz00_2453 = BgL_arg2334z00_2451;
										BgL_offsetz00_2454 = (int) (BgL_objzd2classzd2numz00_2450);
										{	/* Trace/walk.scm 216 */
											long BgL_offsetz00_2455;

											BgL_offsetz00_2455 =
												((long) (BgL_offsetz00_2454) - OBJECT_TYPE);
											{	/* Trace/walk.scm 216 */
												long BgL_modz00_2456;

												{	/* Trace/walk.scm 216 */
													int BgL_arg2336z00_2457;

													BgL_arg2336z00_2457 = (int) (((long) 8));
													{	/* Trace/walk.scm 216 */
														long BgL_auxz00_4772;

														BgL_auxz00_4772 = (long) (BgL_arg2336z00_2457);
														BgL_modz00_2456 =
															(BgL_offsetz00_2455 / BgL_auxz00_4772);
												}}
												{	/* Trace/walk.scm 216 */
													long BgL_restz00_2458;

													{	/* Trace/walk.scm 216 */
														int BgL_arg2335z00_2459;

														BgL_arg2335z00_2459 = (int) (((long) 8));
														{	/* Trace/walk.scm 216 */
															long BgL_auxz00_4776;

															BgL_auxz00_4776 = (long) (BgL_arg2335z00_2459);
															BgL_restz00_2458 =
																(BgL_offsetz00_2455 % BgL_auxz00_4776);
													}}
													{	/* Trace/walk.scm 216 */

														BgL_method3221z00_2448 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2453,
																(int) (BgL_modz00_2456)),
															(int) (BgL_restz00_2458));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3221z00_2448) (BgL_method3221z00_2448,
							(obj_t) (BgL_arg3548z00_2445), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-let-v3242 */
	obj_t BGl_findzd2lastzd2nodezd2letzd2v3242z00zztrace_walkz00(obj_t
		BgL_envz00_3398, obj_t BgL_nodez00_3399)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 209 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1559;

				BgL_nodez00_1559 = (BgL_letzd2varzd2_bglt) (BgL_nodez00_3399);
				{	/* Trace/walk.scm 210 */
					BgL_nodez00_bglt BgL_arg3546z00_2417;

					BgL_arg3546z00_2417 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1559))->BgL_bodyz00);
					{	/* Trace/walk.scm 210 */
						obj_t BgL_method3221z00_2420;

						{	/* Trace/walk.scm 210 */
							BgL_objectz00_bglt BgL_objz00_2421;

							BgL_objz00_2421 = (BgL_objectz00_bglt) (BgL_arg3546z00_2417);
							{	/* Trace/walk.scm 210 */
								long BgL_objzd2classzd2numz00_2422;

								BgL_objzd2classzd2numz00_2422 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2421);
								{	/* Trace/walk.scm 210 */
									obj_t BgL_arg2334z00_2423;

									BgL_arg2334z00_2423 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 210 */
										obj_t BgL_arrayz00_2425;

										int BgL_offsetz00_2426;

										BgL_arrayz00_2425 = BgL_arg2334z00_2423;
										BgL_offsetz00_2426 = (int) (BgL_objzd2classzd2numz00_2422);
										{	/* Trace/walk.scm 210 */
											long BgL_offsetz00_2427;

											BgL_offsetz00_2427 =
												((long) (BgL_offsetz00_2426) - OBJECT_TYPE);
											{	/* Trace/walk.scm 210 */
												long BgL_modz00_2428;

												{	/* Trace/walk.scm 210 */
													int BgL_arg2336z00_2429;

													BgL_arg2336z00_2429 = (int) (((long) 8));
													{	/* Trace/walk.scm 210 */
														long BgL_auxz00_4796;

														BgL_auxz00_4796 = (long) (BgL_arg2336z00_2429);
														BgL_modz00_2428 =
															(BgL_offsetz00_2427 / BgL_auxz00_4796);
												}}
												{	/* Trace/walk.scm 210 */
													long BgL_restz00_2430;

													{	/* Trace/walk.scm 210 */
														int BgL_arg2335z00_2431;

														BgL_arg2335z00_2431 = (int) (((long) 8));
														{	/* Trace/walk.scm 210 */
															long BgL_auxz00_4800;

															BgL_auxz00_4800 = (long) (BgL_arg2335z00_2431);
															BgL_restz00_2430 =
																(BgL_offsetz00_2427 % BgL_auxz00_4800);
													}}
													{	/* Trace/walk.scm 210 */

														BgL_method3221z00_2420 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2425,
																(int) (BgL_modz00_2428)),
															(int) (BgL_restz00_2430));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3221z00_2420) (BgL_method3221z00_2420,
							(obj_t) (BgL_arg3546z00_2417), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-selec3240 */
	obj_t BGl_findzd2lastzd2nodezd2selec3240zd2zztrace_walkz00(obj_t
		BgL_envz00_3400, obj_t BgL_nodez00_3401)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 200 */
			{
				BgL_selectz00_bglt BgL_nodez00_1547;

				BgL_nodez00_1547 = (BgL_selectz00_bglt) (BgL_nodez00_3401);
				{	/* Trace/walk.scm 202 */
					bool_t BgL_testz00_4811;

					{	/* Trace/walk.scm 202 */
						obj_t BgL_auxz00_4812;

						BgL_auxz00_4812 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1547))->BgL_clausesz00);
						BgL_testz00_4811 = PAIRP(BgL_auxz00_4812);
					}
					if (BgL_testz00_4811)
						{	/* Trace/walk.scm 203 */
							obj_t BgL_arg3540z00_1552;

							BgL_arg3540z00_1552 =
								CDR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1547))->
										BgL_clausesz00)));
							{	/* Trace/walk.scm 203 */
								BgL_nodez00_bglt BgL_nodez00_2390;

								BgL_nodez00_2390 = (BgL_nodez00_bglt) (BgL_arg3540z00_1552);
								{	/* Trace/walk.scm 203 */
									obj_t BgL_method3221z00_2391;

									{	/* Trace/walk.scm 203 */
										BgL_objectz00_bglt BgL_objz00_2392;

										BgL_objz00_2392 = (BgL_objectz00_bglt) (BgL_nodez00_2390);
										{	/* Trace/walk.scm 203 */
											long BgL_objzd2classzd2numz00_2393;

											BgL_objzd2classzd2numz00_2393 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2392);
											{	/* Trace/walk.scm 203 */
												obj_t BgL_arg2334z00_2394;

												BgL_arg2334z00_2394 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 203 */
													obj_t BgL_arrayz00_2396;

													int BgL_offsetz00_2397;

													BgL_arrayz00_2396 = BgL_arg2334z00_2394;
													BgL_offsetz00_2397 =
														(int) (BgL_objzd2classzd2numz00_2393);
													{	/* Trace/walk.scm 203 */
														long BgL_offsetz00_2398;

														BgL_offsetz00_2398 =
															((long) (BgL_offsetz00_2397) - OBJECT_TYPE);
														{	/* Trace/walk.scm 203 */
															long BgL_modz00_2399;

															{	/* Trace/walk.scm 203 */
																int BgL_arg2336z00_2400;

																BgL_arg2336z00_2400 = (int) (((long) 8));
																{	/* Trace/walk.scm 203 */
																	long BgL_auxz00_4827;

																	BgL_auxz00_4827 =
																		(long) (BgL_arg2336z00_2400);
																	BgL_modz00_2399 =
																		(BgL_offsetz00_2398 / BgL_auxz00_4827);
															}}
															{	/* Trace/walk.scm 203 */
																long BgL_restz00_2401;

																{	/* Trace/walk.scm 203 */
																	int BgL_arg2335z00_2402;

																	BgL_arg2335z00_2402 = (int) (((long) 8));
																	{	/* Trace/walk.scm 203 */
																		long BgL_auxz00_4831;

																		BgL_auxz00_4831 =
																			(long) (BgL_arg2335z00_2402);
																		BgL_restz00_2401 =
																			(BgL_offsetz00_2398 % BgL_auxz00_4831);
																}}
																{	/* Trace/walk.scm 203 */

																	BgL_method3221z00_2391 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2396,
																			(int) (BgL_modz00_2399)),
																		(int) (BgL_restz00_2401));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3221z00_2391)
										(BgL_method3221z00_2391, (obj_t) (BgL_nodez00_2390), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 202 */
							return
								BGl_findzd2lastzd2sexpz00zztrace_walkz00(
								(obj_t) (
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1547))->
										BgL_testz00)));
						}
				}
			}
		}
	}



/* find-last-node-fail3238 */
	obj_t BGl_findzd2lastzd2nodezd2fail3238zd2zztrace_walkz00(obj_t
		BgL_envz00_3402, obj_t BgL_nodez00_3403)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 194 */
			{
				BgL_failz00_bglt BgL_nodez00_1541;

				BgL_nodez00_1541 = (BgL_failz00_bglt) (BgL_nodez00_3403);
				{	/* Trace/walk.scm 195 */
					BgL_nodez00_bglt BgL_arg3537z00_2358;

					BgL_arg3537z00_2358 =
						(((BgL_failz00_bglt) CREF(BgL_nodez00_1541))->BgL_objz00);
					{	/* Trace/walk.scm 195 */
						obj_t BgL_method3221z00_2361;

						{	/* Trace/walk.scm 195 */
							BgL_objectz00_bglt BgL_objz00_2362;

							BgL_objz00_2362 = (BgL_objectz00_bglt) (BgL_arg3537z00_2358);
							{	/* Trace/walk.scm 195 */
								long BgL_objzd2classzd2numz00_2363;

								BgL_objzd2classzd2numz00_2363 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2362);
								{	/* Trace/walk.scm 195 */
									obj_t BgL_arg2334z00_2364;

									BgL_arg2334z00_2364 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 195 */
										obj_t BgL_arrayz00_2366;

										int BgL_offsetz00_2367;

										BgL_arrayz00_2366 = BgL_arg2334z00_2364;
										BgL_offsetz00_2367 = (int) (BgL_objzd2classzd2numz00_2363);
										{	/* Trace/walk.scm 195 */
											long BgL_offsetz00_2368;

											BgL_offsetz00_2368 =
												((long) (BgL_offsetz00_2367) - OBJECT_TYPE);
											{	/* Trace/walk.scm 195 */
												long BgL_modz00_2369;

												{	/* Trace/walk.scm 195 */
													int BgL_arg2336z00_2370;

													BgL_arg2336z00_2370 = (int) (((long) 8));
													{	/* Trace/walk.scm 195 */
														long BgL_auxz00_4854;

														BgL_auxz00_4854 = (long) (BgL_arg2336z00_2370);
														BgL_modz00_2369 =
															(BgL_offsetz00_2368 / BgL_auxz00_4854);
												}}
												{	/* Trace/walk.scm 195 */
													long BgL_restz00_2371;

													{	/* Trace/walk.scm 195 */
														int BgL_arg2335z00_2372;

														BgL_arg2335z00_2372 = (int) (((long) 8));
														{	/* Trace/walk.scm 195 */
															long BgL_auxz00_4858;

															BgL_auxz00_4858 = (long) (BgL_arg2335z00_2372);
															BgL_restz00_2371 =
																(BgL_offsetz00_2368 % BgL_auxz00_4858);
													}}
													{	/* Trace/walk.scm 195 */

														BgL_method3221z00_2361 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2366,
																(int) (BgL_modz00_2369)),
															(int) (BgL_restz00_2371));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3221z00_2361) (BgL_method3221z00_2361,
							(obj_t) (BgL_arg3537z00_2358), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-condi3236 */
	obj_t BGl_findzd2lastzd2nodezd2condi3236zd2zztrace_walkz00(obj_t
		BgL_envz00_3404, obj_t BgL_nodez00_3405)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 188 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1535;

				BgL_nodez00_1535 = (BgL_conditionalz00_bglt) (BgL_nodez00_3405);
				{	/* Trace/walk.scm 189 */
					BgL_nodez00_bglt BgL_arg3535z00_2330;

					BgL_arg3535z00_2330 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1535))->BgL_falsez00);
					{	/* Trace/walk.scm 189 */
						obj_t BgL_method3221z00_2333;

						{	/* Trace/walk.scm 189 */
							BgL_objectz00_bglt BgL_objz00_2334;

							BgL_objz00_2334 = (BgL_objectz00_bglt) (BgL_arg3535z00_2330);
							{	/* Trace/walk.scm 189 */
								long BgL_objzd2classzd2numz00_2335;

								BgL_objzd2classzd2numz00_2335 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2334);
								{	/* Trace/walk.scm 189 */
									obj_t BgL_arg2334z00_2336;

									BgL_arg2334z00_2336 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 189 */
										obj_t BgL_arrayz00_2338;

										int BgL_offsetz00_2339;

										BgL_arrayz00_2338 = BgL_arg2334z00_2336;
										BgL_offsetz00_2339 = (int) (BgL_objzd2classzd2numz00_2335);
										{	/* Trace/walk.scm 189 */
											long BgL_offsetz00_2340;

											BgL_offsetz00_2340 =
												((long) (BgL_offsetz00_2339) - OBJECT_TYPE);
											{	/* Trace/walk.scm 189 */
												long BgL_modz00_2341;

												{	/* Trace/walk.scm 189 */
													int BgL_arg2336z00_2342;

													BgL_arg2336z00_2342 = (int) (((long) 8));
													{	/* Trace/walk.scm 189 */
														long BgL_auxz00_4878;

														BgL_auxz00_4878 = (long) (BgL_arg2336z00_2342);
														BgL_modz00_2341 =
															(BgL_offsetz00_2340 / BgL_auxz00_4878);
												}}
												{	/* Trace/walk.scm 189 */
													long BgL_restz00_2343;

													{	/* Trace/walk.scm 189 */
														int BgL_arg2335z00_2344;

														BgL_arg2335z00_2344 = (int) (((long) 8));
														{	/* Trace/walk.scm 189 */
															long BgL_auxz00_4882;

															BgL_auxz00_4882 = (long) (BgL_arg2335z00_2344);
															BgL_restz00_2343 =
																(BgL_offsetz00_2340 % BgL_auxz00_4882);
													}}
													{	/* Trace/walk.scm 189 */

														BgL_method3221z00_2333 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2338,
																(int) (BgL_modz00_2341)),
															(int) (BgL_restz00_2343));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3221z00_2333) (BgL_method3221z00_2333,
							(obj_t) (BgL_arg3535z00_2330), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-setq3234 */
	obj_t BGl_findzd2lastzd2nodezd2setq3234zd2zztrace_walkz00(obj_t
		BgL_envz00_3406, obj_t BgL_nodez00_3407)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 182 */
			{
				BgL_setqz00_bglt BgL_nodez00_1529;

				BgL_nodez00_1529 = (BgL_setqz00_bglt) (BgL_nodez00_3407);
				{	/* Trace/walk.scm 183 */
					BgL_nodez00_bglt BgL_arg3533z00_2302;

					BgL_arg3533z00_2302 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1529))->BgL_valuez00);
					{	/* Trace/walk.scm 183 */
						obj_t BgL_method3221z00_2305;

						{	/* Trace/walk.scm 183 */
							BgL_objectz00_bglt BgL_objz00_2306;

							BgL_objz00_2306 = (BgL_objectz00_bglt) (BgL_arg3533z00_2302);
							{	/* Trace/walk.scm 183 */
								long BgL_objzd2classzd2numz00_2307;

								BgL_objzd2classzd2numz00_2307 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2306);
								{	/* Trace/walk.scm 183 */
									obj_t BgL_arg2334z00_2308;

									BgL_arg2334z00_2308 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 183 */
										obj_t BgL_arrayz00_2310;

										int BgL_offsetz00_2311;

										BgL_arrayz00_2310 = BgL_arg2334z00_2308;
										BgL_offsetz00_2311 = (int) (BgL_objzd2classzd2numz00_2307);
										{	/* Trace/walk.scm 183 */
											long BgL_offsetz00_2312;

											BgL_offsetz00_2312 =
												((long) (BgL_offsetz00_2311) - OBJECT_TYPE);
											{	/* Trace/walk.scm 183 */
												long BgL_modz00_2313;

												{	/* Trace/walk.scm 183 */
													int BgL_arg2336z00_2314;

													BgL_arg2336z00_2314 = (int) (((long) 8));
													{	/* Trace/walk.scm 183 */
														long BgL_auxz00_4902;

														BgL_auxz00_4902 = (long) (BgL_arg2336z00_2314);
														BgL_modz00_2313 =
															(BgL_offsetz00_2312 / BgL_auxz00_4902);
												}}
												{	/* Trace/walk.scm 183 */
													long BgL_restz00_2315;

													{	/* Trace/walk.scm 183 */
														int BgL_arg2335z00_2316;

														BgL_arg2335z00_2316 = (int) (((long) 8));
														{	/* Trace/walk.scm 183 */
															long BgL_auxz00_4906;

															BgL_auxz00_4906 = (long) (BgL_arg2335z00_2316);
															BgL_restz00_2315 =
																(BgL_offsetz00_2312 % BgL_auxz00_4906);
													}}
													{	/* Trace/walk.scm 183 */

														BgL_method3221z00_2305 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2310,
																(int) (BgL_modz00_2313)),
															(int) (BgL_restz00_2315));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3221z00_2305) (BgL_method3221z00_2305,
							(obj_t) (BgL_arg3533z00_2302), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-exter3232 */
	obj_t BGl_findzd2lastzd2nodezd2exter3232zd2zztrace_walkz00(obj_t
		BgL_envz00_3408, obj_t BgL_nodez00_3409)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 173 */
			{
				BgL_externz00_bglt BgL_nodez00_1518;

				BgL_nodez00_1518 = (BgL_externz00_bglt) (BgL_nodez00_3409);
				{	/* Trace/walk.scm 175 */
					bool_t BgL_testz00_4917;

					{	/* Trace/walk.scm 175 */
						obj_t BgL_auxz00_4918;

						BgL_auxz00_4918 =
							(((BgL_externz00_bglt) CREF(BgL_nodez00_1518))->BgL_exprza2za2);
						BgL_testz00_4917 = PAIRP(BgL_auxz00_4918);
					}
					if (BgL_testz00_4917)
						{	/* Trace/walk.scm 176 */
							obj_t BgL_arg3528z00_1523;

							BgL_arg3528z00_1523 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_externz00_bglt) CREF(BgL_nodez00_1518))->
										BgL_exprza2za2)));
							{	/* Trace/walk.scm 176 */
								BgL_nodez00_bglt BgL_nodez00_2276;

								BgL_nodez00_2276 = (BgL_nodez00_bglt) (BgL_arg3528z00_1523);
								{	/* Trace/walk.scm 176 */
									obj_t BgL_method3221z00_2277;

									{	/* Trace/walk.scm 176 */
										BgL_objectz00_bglt BgL_objz00_2278;

										BgL_objz00_2278 = (BgL_objectz00_bglt) (BgL_nodez00_2276);
										{	/* Trace/walk.scm 176 */
											long BgL_objzd2classzd2numz00_2279;

											BgL_objzd2classzd2numz00_2279 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2278);
											{	/* Trace/walk.scm 176 */
												obj_t BgL_arg2334z00_2280;

												BgL_arg2334z00_2280 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 176 */
													obj_t BgL_arrayz00_2282;

													int BgL_offsetz00_2283;

													BgL_arrayz00_2282 = BgL_arg2334z00_2280;
													BgL_offsetz00_2283 =
														(int) (BgL_objzd2classzd2numz00_2279);
													{	/* Trace/walk.scm 176 */
														long BgL_offsetz00_2284;

														BgL_offsetz00_2284 =
															((long) (BgL_offsetz00_2283) - OBJECT_TYPE);
														{	/* Trace/walk.scm 176 */
															long BgL_modz00_2285;

															{	/* Trace/walk.scm 176 */
																int BgL_arg2336z00_2286;

																BgL_arg2336z00_2286 = (int) (((long) 8));
																{	/* Trace/walk.scm 176 */
																	long BgL_auxz00_4933;

																	BgL_auxz00_4933 =
																		(long) (BgL_arg2336z00_2286);
																	BgL_modz00_2285 =
																		(BgL_offsetz00_2284 / BgL_auxz00_4933);
															}}
															{	/* Trace/walk.scm 176 */
																long BgL_restz00_2287;

																{	/* Trace/walk.scm 176 */
																	int BgL_arg2335z00_2288;

																	BgL_arg2335z00_2288 = (int) (((long) 8));
																	{	/* Trace/walk.scm 176 */
																		long BgL_auxz00_4937;

																		BgL_auxz00_4937 =
																			(long) (BgL_arg2335z00_2288);
																		BgL_restz00_2287 =
																			(BgL_offsetz00_2284 % BgL_auxz00_4937);
																}}
																{	/* Trace/walk.scm 176 */

																	BgL_method3221z00_2277 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2282,
																			(int) (BgL_modz00_2285)),
																		(int) (BgL_restz00_2287));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3221z00_2277)
										(BgL_method3221z00_2277, (obj_t) (BgL_nodez00_2276), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 175 */
							return (obj_t) (BgL_nodez00_1518);
						}
				}
			}
		}
	}



/* find-last-node-funca3230 */
	obj_t BGl_findzd2lastzd2nodezd2funca3230zd2zztrace_walkz00(obj_t
		BgL_envz00_3410, obj_t BgL_nodez00_3411)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 164 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1506;

				BgL_nodez00_1506 = (BgL_funcallz00_bglt) (BgL_nodez00_3411);
				{	/* Trace/walk.scm 166 */
					bool_t BgL_testz00_4949;

					{	/* Trace/walk.scm 166 */
						obj_t BgL_auxz00_4950;

						BgL_auxz00_4950 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1506))->BgL_argsz00);
						BgL_testz00_4949 = PAIRP(BgL_auxz00_4950);
					}
					if (BgL_testz00_4949)
						{	/* Trace/walk.scm 167 */
							obj_t BgL_arg3521z00_1511;

							BgL_arg3521z00_1511 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1506))->
										BgL_argsz00)));
							{	/* Trace/walk.scm 167 */
								BgL_nodez00_bglt BgL_nodez00_2219;

								BgL_nodez00_2219 = (BgL_nodez00_bglt) (BgL_arg3521z00_1511);
								{	/* Trace/walk.scm 167 */
									obj_t BgL_method3221z00_2220;

									{	/* Trace/walk.scm 167 */
										BgL_objectz00_bglt BgL_objz00_2221;

										BgL_objz00_2221 = (BgL_objectz00_bglt) (BgL_nodez00_2219);
										{	/* Trace/walk.scm 167 */
											long BgL_objzd2classzd2numz00_2222;

											BgL_objzd2classzd2numz00_2222 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2221);
											{	/* Trace/walk.scm 167 */
												obj_t BgL_arg2334z00_2223;

												BgL_arg2334z00_2223 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 167 */
													obj_t BgL_arrayz00_2225;

													int BgL_offsetz00_2226;

													BgL_arrayz00_2225 = BgL_arg2334z00_2223;
													BgL_offsetz00_2226 =
														(int) (BgL_objzd2classzd2numz00_2222);
													{	/* Trace/walk.scm 167 */
														long BgL_offsetz00_2227;

														BgL_offsetz00_2227 =
															((long) (BgL_offsetz00_2226) - OBJECT_TYPE);
														{	/* Trace/walk.scm 167 */
															long BgL_modz00_2228;

															{	/* Trace/walk.scm 167 */
																int BgL_arg2336z00_2229;

																BgL_arg2336z00_2229 = (int) (((long) 8));
																{	/* Trace/walk.scm 167 */
																	long BgL_auxz00_4965;

																	BgL_auxz00_4965 =
																		(long) (BgL_arg2336z00_2229);
																	BgL_modz00_2228 =
																		(BgL_offsetz00_2227 / BgL_auxz00_4965);
															}}
															{	/* Trace/walk.scm 167 */
																long BgL_restz00_2230;

																{	/* Trace/walk.scm 167 */
																	int BgL_arg2335z00_2231;

																	BgL_arg2335z00_2231 = (int) (((long) 8));
																	{	/* Trace/walk.scm 167 */
																		long BgL_auxz00_4969;

																		BgL_auxz00_4969 =
																			(long) (BgL_arg2335z00_2231);
																		BgL_restz00_2230 =
																			(BgL_offsetz00_2227 % BgL_auxz00_4969);
																}}
																{	/* Trace/walk.scm 167 */

																	BgL_method3221z00_2220 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2225,
																			(int) (BgL_modz00_2228)),
																		(int) (BgL_restz00_2230));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3221z00_2220)
										(BgL_method3221z00_2220, (obj_t) (BgL_nodez00_2219), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 168 */
							BgL_nodez00_bglt BgL_arg3524z00_1514;

							BgL_arg3524z00_1514 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1506))->BgL_funz00);
							{	/* Trace/walk.scm 168 */
								obj_t BgL_method3221z00_2247;

								{	/* Trace/walk.scm 168 */
									BgL_objectz00_bglt BgL_objz00_2248;

									BgL_objz00_2248 = (BgL_objectz00_bglt) (BgL_arg3524z00_1514);
									{	/* Trace/walk.scm 168 */
										long BgL_objzd2classzd2numz00_2249;

										BgL_objzd2classzd2numz00_2249 =
											BGL_OBJECT_CLASS_NUM(BgL_objz00_2248);
										{	/* Trace/walk.scm 168 */
											obj_t BgL_arg2334z00_2250;

											BgL_arg2334z00_2250 =
												PROCEDURE_REF
												(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
												(int) (((long) 1)));
											{	/* Trace/walk.scm 168 */
												obj_t BgL_arrayz00_2252;

												int BgL_offsetz00_2253;

												BgL_arrayz00_2252 = BgL_arg2334z00_2250;
												BgL_offsetz00_2253 =
													(int) (BgL_objzd2classzd2numz00_2249);
												{	/* Trace/walk.scm 168 */
													long BgL_offsetz00_2254;

													BgL_offsetz00_2254 =
														((long) (BgL_offsetz00_2253) - OBJECT_TYPE);
													{	/* Trace/walk.scm 168 */
														long BgL_modz00_2255;

														{	/* Trace/walk.scm 168 */
															int BgL_arg2336z00_2256;

															BgL_arg2336z00_2256 = (int) (((long) 8));
															{	/* Trace/walk.scm 168 */
																long BgL_auxz00_4988;

																BgL_auxz00_4988 = (long) (BgL_arg2336z00_2256);
																BgL_modz00_2255 =
																	(BgL_offsetz00_2254 / BgL_auxz00_4988);
														}}
														{	/* Trace/walk.scm 168 */
															long BgL_restz00_2257;

															{	/* Trace/walk.scm 168 */
																int BgL_arg2335z00_2258;

																BgL_arg2335z00_2258 = (int) (((long) 8));
																{	/* Trace/walk.scm 168 */
																	long BgL_auxz00_4992;

																	BgL_auxz00_4992 =
																		(long) (BgL_arg2335z00_2258);
																	BgL_restz00_2257 =
																		(BgL_offsetz00_2254 % BgL_auxz00_4992);
															}}
															{	/* Trace/walk.scm 168 */

																BgL_method3221z00_2247 =
																	VECTOR_REF(VECTOR_REF(BgL_arrayz00_2252,
																		(int) (BgL_modz00_2255)),
																	(int) (BgL_restz00_2257));
								}}}}}}}}
								return
									PROCEDURE_ENTRY(BgL_method3221z00_2247)
									(BgL_method3221z00_2247, (obj_t) (BgL_arg3524z00_1514), BEOA);
							}
						}
				}
			}
		}
	}



/* find-last-node-app-l3228 */
	obj_t BGl_findzd2lastzd2nodezd2appzd2l3228z00zztrace_walkz00(obj_t
		BgL_envz00_3412, obj_t BgL_nodez00_3413)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 158 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1500;

				BgL_nodez00_1500 = (BgL_appzd2lyzd2_bglt) (BgL_nodez00_3413);
				{	/* Trace/walk.scm 159 */
					BgL_nodez00_bglt BgL_arg3518z00_2187;

					BgL_arg3518z00_2187 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1500))->BgL_argz00);
					{	/* Trace/walk.scm 159 */
						obj_t BgL_method3221z00_2190;

						{	/* Trace/walk.scm 159 */
							BgL_objectz00_bglt BgL_objz00_2191;

							BgL_objz00_2191 = (BgL_objectz00_bglt) (BgL_arg3518z00_2187);
							{	/* Trace/walk.scm 159 */
								long BgL_objzd2classzd2numz00_2192;

								BgL_objzd2classzd2numz00_2192 =
									BGL_OBJECT_CLASS_NUM(BgL_objz00_2191);
								{	/* Trace/walk.scm 159 */
									obj_t BgL_arg2334z00_2193;

									BgL_arg2334z00_2193 =
										PROCEDURE_REF
										(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
										(int) (((long) 1)));
									{	/* Trace/walk.scm 159 */
										obj_t BgL_arrayz00_2195;

										int BgL_offsetz00_2196;

										BgL_arrayz00_2195 = BgL_arg2334z00_2193;
										BgL_offsetz00_2196 = (int) (BgL_objzd2classzd2numz00_2192);
										{	/* Trace/walk.scm 159 */
											long BgL_offsetz00_2197;

											BgL_offsetz00_2197 =
												((long) (BgL_offsetz00_2196) - OBJECT_TYPE);
											{	/* Trace/walk.scm 159 */
												long BgL_modz00_2198;

												{	/* Trace/walk.scm 159 */
													int BgL_arg2336z00_2199;

													BgL_arg2336z00_2199 = (int) (((long) 8));
													{	/* Trace/walk.scm 159 */
														long BgL_auxz00_5012;

														BgL_auxz00_5012 = (long) (BgL_arg2336z00_2199);
														BgL_modz00_2198 =
															(BgL_offsetz00_2197 / BgL_auxz00_5012);
												}}
												{	/* Trace/walk.scm 159 */
													long BgL_restz00_2200;

													{	/* Trace/walk.scm 159 */
														int BgL_arg2335z00_2201;

														BgL_arg2335z00_2201 = (int) (((long) 8));
														{	/* Trace/walk.scm 159 */
															long BgL_auxz00_5016;

															BgL_auxz00_5016 = (long) (BgL_arg2335z00_2201);
															BgL_restz00_2200 =
																(BgL_offsetz00_2197 % BgL_auxz00_5016);
													}}
													{	/* Trace/walk.scm 159 */

														BgL_method3221z00_2190 =
															VECTOR_REF(VECTOR_REF(BgL_arrayz00_2195,
																(int) (BgL_modz00_2198)),
															(int) (BgL_restz00_2200));
						}}}}}}}}
						return
							PROCEDURE_ENTRY(BgL_method3221z00_2190) (BgL_method3221z00_2190,
							(obj_t) (BgL_arg3518z00_2187), BEOA);
					}
				}
			}
		}
	}



/* find-last-node-app3226 */
	obj_t BGl_findzd2lastzd2nodezd2app3226zd2zztrace_walkz00(obj_t
		BgL_envz00_3414, obj_t BgL_nodez00_3415)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 149 */
			{
				BgL_appz00_bglt BgL_nodez00_1489;

				BgL_nodez00_1489 = (BgL_appz00_bglt) (BgL_nodez00_3415);
				{	/* Trace/walk.scm 151 */
					bool_t BgL_testz00_5027;

					{	/* Trace/walk.scm 151 */
						obj_t BgL_auxz00_5028;

						BgL_auxz00_5028 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1489))->BgL_argsz00);
						BgL_testz00_5027 = PAIRP(BgL_auxz00_5028);
					}
					if (BgL_testz00_5027)
						{	/* Trace/walk.scm 152 */
							obj_t BgL_arg3513z00_1494;

							BgL_arg3513z00_1494 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_appz00_bglt) CREF(BgL_nodez00_1489))->BgL_argsz00)));
							{	/* Trace/walk.scm 152 */
								BgL_nodez00_bglt BgL_nodez00_2161;

								BgL_nodez00_2161 = (BgL_nodez00_bglt) (BgL_arg3513z00_1494);
								{	/* Trace/walk.scm 152 */
									obj_t BgL_method3221z00_2162;

									{	/* Trace/walk.scm 152 */
										BgL_objectz00_bglt BgL_objz00_2163;

										BgL_objz00_2163 = (BgL_objectz00_bglt) (BgL_nodez00_2161);
										{	/* Trace/walk.scm 152 */
											long BgL_objzd2classzd2numz00_2164;

											BgL_objzd2classzd2numz00_2164 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2163);
											{	/* Trace/walk.scm 152 */
												obj_t BgL_arg2334z00_2165;

												BgL_arg2334z00_2165 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 152 */
													obj_t BgL_arrayz00_2167;

													int BgL_offsetz00_2168;

													BgL_arrayz00_2167 = BgL_arg2334z00_2165;
													BgL_offsetz00_2168 =
														(int) (BgL_objzd2classzd2numz00_2164);
													{	/* Trace/walk.scm 152 */
														long BgL_offsetz00_2169;

														BgL_offsetz00_2169 =
															((long) (BgL_offsetz00_2168) - OBJECT_TYPE);
														{	/* Trace/walk.scm 152 */
															long BgL_modz00_2170;

															{	/* Trace/walk.scm 152 */
																int BgL_arg2336z00_2171;

																BgL_arg2336z00_2171 = (int) (((long) 8));
																{	/* Trace/walk.scm 152 */
																	long BgL_auxz00_5043;

																	BgL_auxz00_5043 =
																		(long) (BgL_arg2336z00_2171);
																	BgL_modz00_2170 =
																		(BgL_offsetz00_2169 / BgL_auxz00_5043);
															}}
															{	/* Trace/walk.scm 152 */
																long BgL_restz00_2172;

																{	/* Trace/walk.scm 152 */
																	int BgL_arg2335z00_2173;

																	BgL_arg2335z00_2173 = (int) (((long) 8));
																	{	/* Trace/walk.scm 152 */
																		long BgL_auxz00_5047;

																		BgL_auxz00_5047 =
																			(long) (BgL_arg2335z00_2173);
																		BgL_restz00_2172 =
																			(BgL_offsetz00_2169 % BgL_auxz00_5047);
																}}
																{	/* Trace/walk.scm 152 */

																	BgL_method3221z00_2162 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2167,
																			(int) (BgL_modz00_2170)),
																		(int) (BgL_restz00_2172));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3221z00_2162)
										(BgL_method3221z00_2162, (obj_t) (BgL_nodez00_2161), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 151 */
							return (obj_t) (BgL_nodez00_1489);
						}
				}
			}
		}
	}



/* find-last-node-seque3224 */
	obj_t BGl_findzd2lastzd2nodezd2seque3224zd2zztrace_walkz00(obj_t
		BgL_envz00_3416, obj_t BgL_nodez00_3417)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 140 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1478;

				BgL_nodez00_1478 = (BgL_sequencez00_bglt) (BgL_nodez00_3417);
				{	/* Trace/walk.scm 142 */
					bool_t BgL_testz00_5059;

					{	/* Trace/walk.scm 142 */
						obj_t BgL_auxz00_5060;

						BgL_auxz00_5060 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1478))->BgL_nodesz00);
						BgL_testz00_5059 = PAIRP(BgL_auxz00_5060);
					}
					if (BgL_testz00_5059)
						{	/* Trace/walk.scm 143 */
							obj_t BgL_arg3506z00_1483;

							BgL_arg3506z00_1483 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1478))->
										BgL_nodesz00)));
							{	/* Trace/walk.scm 143 */
								BgL_nodez00_bglt BgL_nodez00_2131;

								BgL_nodez00_2131 = (BgL_nodez00_bglt) (BgL_arg3506z00_1483);
								{	/* Trace/walk.scm 143 */
									obj_t BgL_method3221z00_2132;

									{	/* Trace/walk.scm 143 */
										BgL_objectz00_bglt BgL_objz00_2133;

										BgL_objz00_2133 = (BgL_objectz00_bglt) (BgL_nodez00_2131);
										{	/* Trace/walk.scm 143 */
											long BgL_objzd2classzd2numz00_2134;

											BgL_objzd2classzd2numz00_2134 =
												BGL_OBJECT_CLASS_NUM(BgL_objz00_2133);
											{	/* Trace/walk.scm 143 */
												obj_t BgL_arg2334z00_2135;

												BgL_arg2334z00_2135 =
													PROCEDURE_REF
													(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
													(int) (((long) 1)));
												{	/* Trace/walk.scm 143 */
													obj_t BgL_arrayz00_2137;

													int BgL_offsetz00_2138;

													BgL_arrayz00_2137 = BgL_arg2334z00_2135;
													BgL_offsetz00_2138 =
														(int) (BgL_objzd2classzd2numz00_2134);
													{	/* Trace/walk.scm 143 */
														long BgL_offsetz00_2139;

														BgL_offsetz00_2139 =
															((long) (BgL_offsetz00_2138) - OBJECT_TYPE);
														{	/* Trace/walk.scm 143 */
															long BgL_modz00_2140;

															{	/* Trace/walk.scm 143 */
																int BgL_arg2336z00_2141;

																BgL_arg2336z00_2141 = (int) (((long) 8));
																{	/* Trace/walk.scm 143 */
																	long BgL_auxz00_5075;

																	BgL_auxz00_5075 =
																		(long) (BgL_arg2336z00_2141);
																	BgL_modz00_2140 =
																		(BgL_offsetz00_2139 / BgL_auxz00_5075);
															}}
															{	/* Trace/walk.scm 143 */
																long BgL_restz00_2142;

																{	/* Trace/walk.scm 143 */
																	int BgL_arg2335z00_2143;

																	BgL_arg2335z00_2143 = (int) (((long) 8));
																	{	/* Trace/walk.scm 143 */
																		long BgL_auxz00_5079;

																		BgL_auxz00_5079 =
																			(long) (BgL_arg2335z00_2143);
																		BgL_restz00_2142 =
																			(BgL_offsetz00_2139 % BgL_auxz00_5079);
																}}
																{	/* Trace/walk.scm 143 */

																	BgL_method3221z00_2132 =
																		VECTOR_REF(VECTOR_REF(BgL_arrayz00_2137,
																			(int) (BgL_modz00_2140)),
																		(int) (BgL_restz00_2142));
									}}}}}}}}
									return
										PROCEDURE_ENTRY(BgL_method3221z00_2132)
										(BgL_method3221z00_2132, (obj_t) (BgL_nodez00_2131), BEOA);
								}
							}
						}
					else
						{	/* Trace/walk.scm 142 */
							return (obj_t) (BgL_nodez00_1478);
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 182148081),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 139755433),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 216344604),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 445289072),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 43233168),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 11585204),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 399603825),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 315910987),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 171845042),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 466514915),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 77938009),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 498714928),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 358171001),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 489996212),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 531182497),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
			return
				BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 345457731),
				BSTRING_TO_STRING(BGl_string3818z00zztrace_walkz00));
		}
	}

#ifdef __cplusplus
}
#endif
